-- name=int_dialog_task
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_dialog_task", interface.originhub );
  ObjSet( "int_dialog_task", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.DIRECTION = 1;

  public.show = false;
  private.SHOW_ANIM_TIME = 0.5;
  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.FuncEnd = nil;
  private.task = "";

  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () private.StopTypeAnim (); end,
  } );

  private.level_tasks =
  {
    { { 1,2,3 }, { 4,5,6 }, { 7,8,9 }, { 10,11,12 } },
    { { 1,2,3 }, { 4,5,6 }, { 7,8,9 }, { 10 } },
    { { 1,2,3 }, { 4,5,6 }, { 7,8,9 } },
    { { 1,2,3 }, { 4,5,6 }, { 7,8,9 } },
  };

  int.ShowTaskNote = public.ShowTaskNote;
  int.UpdateTask = private.UpdateTask;

  private.WideScreenUpdate();

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function private.WideScreenUpdate ()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_dialog_task" ) then

    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position = 341;

    local posx = position + ( direction * offset );
    ObjSet( "int_dialog_task", { pos_x = posx } );

  end;

end;
--*****************************************************************************************
function public.Show ( data )

  local lvl = string.sub( ng_global.progress[ ng_global.currentprogress ].common.chapter , 6 );

  if ( lvl == "ext" ) then

    lvl = 4;

  end;

  lvl = tonumber( lvl );

  local event_id = "show";

  int.DeployInvHide();

  private.UpdateTask( lvl );

  --ObjSet( "txt_int_dialog_task_description2", { text = "str_dialog_task_"..data.task } );

  private.FuncEnd = data.func_end;
  private.ShowAnim( event_id, data );

end;
--******************************************************************************************
function public.Hide ()

  local event_id = "hide";
  private.HideAnim( event_id );

end;
--******************************************************************************************
function private.ShowAnim ( event_id, data )

  local func_end = function () private.TypeAnim( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  int.Lock( true );

  private.task = data.task;

  ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
  {
    0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
    tme, 3, 402, 36
  } );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_hide_task_list" );
  local func_end = function () private.AnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  int.Lock( true );

  ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
  {
    0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
    tme, 3, 402, 740
  } );

end;
--******************************************************************************************
function private.AnimEnd( event_id )  

  int.Lock( false );

  if ( event_id == "show" ) then

    ObjSet( "obj_int_dialog_task", { input = true } );

    public.show = true;

    ObjSet( "obj_int_dialog_task",
    {
      event_mdown = function ()  

        private.HideAnim( "hide" );

      end
    } );

  elseif ( event_id == "hide" ) then

    public.show = false;

    int_button_task.Update( true, "" );

    ObjSet( "obj_int_dialog_task", { input = false, event_mdown = function () ObjSet( "obj_int_dialog_task",{ event_mdown = function () public.Hide(); end } ); end } );

    if ( private.FuncEnd ) then

      private.FuncEnd();
      private.FuncEnd = nil;

    end;

  end;

end;
--******************************************************************************************
function private.TypeAnim ( event_id )  

  int.Lock( false );

  ObjSet( "obj_int_dialog_task", { input = true } );

  local func_end = function () 

    private.AnimEnd( event_id ); 

    ObjSet( "obj_int_dialog_task",
    {
      event_mdown = function () public.Hide(); end,
    } );

  end;

  -- вывод таска по одной букве
  --common_impl.PrintText(
  --  "txt_int_dialog_task_description", 
  --  "str_dialog_task_"..private.task, 
  --  private.SHOW_ANIM_TIME*3, 
  --  func_end
  --);

  func_end();

  int.Lock( false );

end;
--******************************************************************************************
function private.StopTypeAnim ()

  common_impl.ShowText("txt_int_dialog_task_description");
  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.Hide(); end,
  } );

end;
--******************************************************************************************
function private.Update ( data )

  --[[
  ObjSet( "txt_int_dialog_task_header", { text = "str_dialog_task_header_"..data.state } );
  ObjSet( "txt_int_dialog_task_description", { text = "" } );
  ]]

end;
--******************************************************************************************
--- task nootebook
--******************************************************************************************
function private.GetCurrentPage ( lvl, num )

  for page = 1, #private.level_tasks[ lvl ] do

    local tasks = private.level_tasks[ lvl ][ page ];

    for t = 1, #tasks do

      if ( num == tasks[ t ] ) then

        return page;

      end;

    end;

  end;

  return #private.level_tasks[ lvl ];

end;
--******************************************************************************************
function private.IsChangePage ( lvl, num )

  local page = private.GetCurrentPage( lvl, num );
  local task = #private.level_tasks[ lvl ][ page ];

  if ( num == private.level_tasks[ lvl ][ page ][ task ] ) and
     ( page ~= #private.level_tasks[ lvl ] ) then

    return true;

  end;

  return false;

end;
--******************************************************************************************
function public.ShowTaskNote ( num )

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_get_task_list" );
  local lvl = string.sub( ng_global.progress[ ng_global.currentprogress ].common.chapter , 6 );

  if ( lvl == "ext" ) then

    lvl = 4;

  end;

  lvl = tonumber( lvl );

  if ( num ) then

    local func_end = function () 

      local func_end_1 = function () 

        private.AnimEnd( "show" );

      end;

      local func_anim_end = function () 

        if ( private.IsChangePage( lvl, num ) ) then

          local page = private.GetCurrentPage( lvl, num );

          ObjAnimate( "obj_int_dialog_task_lvl_"..lvl.."_page_"..page, "alp", 0, 0, "",
          {
            0.0, 0, 1,
            1.2, 0, 1,
            1.5, 0, 0,
          } );

          ObjAnimate( "obj_int_dialog_task_lvl_"..lvl.."_page_"..( page + 1 ), "alp", 0, 0, func_end_1,
          {
            0.0, 0, 0,
            1.2, 0, 0,
            1.5, 0, 1,
          } );

        else

          func_end_1();

        end;

      end;

      ObjAnimate( "spr_int_dialog_task_lvl_"..lvl.."_"..num.."_check", "alp", 0, 0, func_anim_end,
      {
        0.0, 0, 0,
        0.3, 0, 1,
      } );

    end;

    int.Lock( true );

    local tme = private.SHOW_ANIM_TIME;

    ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
    {
      0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
      tme, 3, 402, 36
    } );

  else

    local func_end = function () 

      private.AnimEnd( "show" );

    end;

    int.Lock( true );

    local tme = private.SHOW_ANIM_TIME;

    ObjAnimate( "obj_int_dialog_task_handnote", "pos_xy", 0, 0, func_end,
    {
      0.0, 3, ObjGet( "obj_int_dialog_task_handnote" ).pos_x, ObjGet( "obj_int_dialog_task_handnote" ).pos_y,
      tme, 3, 402, 36
    } );

  end;

end;
--******************************************************************************************
function public.TaskDone ( num )

  local lvl = string.sub( ng_global.progress[ ng_global.currentprogress ].common.chapter, 6 );

  if ( lvl == "ext" ) then

    lvl = 4;

  end;

  lvl = tonumber( lvl );

  ng_global.task_array[ lvl ][ num ][ 1 ] = 1;
  ng_global.task_current = num;
  interface.KeyUpdate();

end;
--******************************************************************************************
function private.UpdateTask ( lvl )

  ObjSet( "obj_int_dialog_task_lvl_"..lvl, { alp = 1 } );

  local last_task = 1;

  for num = 1, #ng_global.task_array[ lvl ] do

    if ( ng_global.task_array[ lvl ][ num ][ 1 ] == 1 ) then

      ObjSet( "spr_int_dialog_task_lvl_"..lvl.."_"..num.."_check", { alp = 1 } );

      last_task = num;

    else

      break;

    end;

  end;

  last_task = last_task + 1;

  local page = private.GetCurrentPage( lvl, last_task );

  ObjSet( "obj_int_dialog_task_lvl_"..lvl.."_page_1",      { alp = 0 } );
  ObjSet( "obj_int_dialog_task_lvl_"..lvl.."_page_"..page, { alp = 1 } );

end;
--******************************************************************************************
--******************************************************************************************