-- name=int_achievements
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_achievements", interface.originhub );
  ObjSet( "int_achievements", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.event_anim_end = {};
  private.DIRECTION =  -1;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.MOVE_ANIM_POS_X_BEG = -405;
  private.MOVE_ANIM_POS_X_END =  230;
  private.MOVE_ANIM_TIME      =  0.6;

  private.show  = false; --на экране или нет
  private.timer = 3; --время таймера

  private.IMG_X = 91;
  private.IMG_Y = -14;

  private.TEXT_NAME_X = 55;
  private.TEXT_NAME_Y = -10;

  private.CURRENT_ACHIEV = "";

  ObjSet( "int_achievements", { alp = 0 } );

  ObjSet( "obj_int_achievements_button", 
  {
    event_mdown  = function () private.GoAchievements() end;
    event_menter = function () private.MouseEnter( "int_achievements_button" ) end;
    event_mleave = function () private.MouseLeave( "int_achievements_button" ) end;
  } );

  private.WideScreenUpdate();
  --private.Animation();
  
  private.Icon = {};

  private.Icon[ "not_skip_mg_1" ]      = { -147, -8 };
  private.Icon[ "not_skip_mg_2" ]      = { -151, -13 };
  private.Icon[ "not_skip_mg_3" ]      = { -139, -11 };
  private.Icon[ "not_skip_mg_4" ]      = { -147,  2 };  
  
  private.Icon[ "ho_three_1" ]         = { -146, -9 };
  private.Icon[ "ho_three_2" ]         = { -149, -11 };
  private.Icon[ "ho_three_3" ]         = { -151, -11 };  
  
  private.Icon[ "ho_three_obj_three" ] = { -150, -14 };  
  private.Icon[ "ho_five_obj_five" ]   = { -149,  2 };  
  private.Icon[ "ho_ten_obj_ten" ]     = { -149,  2 };  
  
  private.Icon[ "ho_ten_min" ]         = { -138, -6 }; 
  
  private.Icon[ "ho_one_min" ]         = { -148, -17 };
  
  private.Icon[ "mg_one_min" ]         = { -146, -18 };  
  
  private.Icon[ "get_morph_collect" ]  = { -145, -7 };

  private.Icon[ "ho_not_hint_3" ]      = { -145, -16 };
  private.Icon[ "ho_not_hint_5" ]      = { -134, -8 };
  private.Icon[ "ho_not_hint_10" ]     = { -150, -12 };
  private.Icon[ "ho_not_hint_all" ]    = { -143, -9 };
  
  private.Icon[ "win_secret_4" ]       = { -151, -10 };
  
end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function public.Show ( name )

  ObjSet( "int_achievements", { active = true, visible = true, input = true } );
  private.show = true;
  private.ShowAnim( "show", name );

  if ( ng_global.currentprogress == "std" ) then
  
    cmn.TutorialShow( "tutorial_achievements" );
    cmn.TutorialSetShown( "tutorial_achievements" );
  
  end;
  
end;
--******************************************************************************************
function public.Hide ()

  ObjSet( "int_achievements", { input = false } );
  private.show = false;
  private.HideAnim( "hide" );

end;
--******************************************************************************************
function private.WideScreenUpdate ()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_achievements" ) then

    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;

    local posx = position + ( direction * offset );
    ObjSet( "int_achievements", { pos_x = posx } );
    local pos_obj = ObjGet( "obj_int_achievements_other" ).pos_x;
    ObjSet( "obj_int_achievements_other", { pos_x = pos_obj - posx } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  if ( event_id == "show" ) then

    ObjSet( "obj_int_achievements", { input = 1 } );
    
    ObjSet( "tmr_int_achievements_hide", { endtrig = public.Hide, time = private.timer, playing = true } );

    ObjSet( "pfx_int_achievements_anim", { active = true } );
    PartSysStart( "pfx_int_achievements_anim" );

  elseif ( event_id == "hide" ) then

    ObjSet( "int_achievements", { active = false, visible = false } );
    ObjSet( "obj_int_achievements", { input = false } );
    ObjSet( "pfx_int_achievements_anim", { active = false } );

    private.DeleteObjAchiev();

  end;
  
end;
--******************************************************************************************
function private.GoAchievements ()

  ObjSet( "tmr_common_anm", { active = false } );

  ng_global.achievements.previous_room = GetCurrentRoom();

  if ( int.GetMorphingShow() ) then

     int.HideAnimMorphing();

  end;

  local func_after = function()

    int.Lock(true);
    int.DeployInvHide();
    cmn.CloseSubRoom();
    cmn.GotoRoom( "rm_achievements", 0, true ); 
    ObjSet( "tmr_int_achievements_hide", { endtrig = public.Hide, time = 0.01, playing = true } );
    private.HideAnim( "hide" );

  end;
  
  if common.GetCurrentSubRoom() then

     cmn.CloseSubRoom();
     int.Lock(true);
     ObjSet( "tmr_int_achievements_go_to_rm", { endtrig = func_after, time = 0.7, playing = true } );

  else

    func_after();

  end;

end;
--******************************************************************************************
function private.ShowAnim ( event_id, name )

  local obj       = "obj_int_achievements";
  local func_end  = function () private.EventAnimEnd( event_id ); end;
  local tme       = private.MOVE_ANIM_TIME;

  ObjSet( "int_achievements", { alp = 1 } );
  ObjStopAnimate( obj, "pos_x" ); 
  ObjSet( "tmr_int_achievements_hide", { playing = false } );

  local current_posx = ObjGet( obj ).pos_x; 

  local distance = math.abs( private.MOVE_ANIM_POS_X_BEG - current_posx );

  cmn.PlayAudio( "sfx", "audio/aud_achievement_show", 0, "", 0 );

  if ( distance == 0 ) then

    local overtime = distance * ( tme / ( private.MOVE_ANIM_POS_X_END - private.MOVE_ANIM_POS_X_BEG ) );
    ObjAnimate( obj, "pos_x", 0, 0, func_end,
    {
      0.0,          2, current_posx,
      overtime,     2, private.MOVE_ANIM_POS_X_BEG,
      overtime+tme, 2, private.MOVE_ANIM_POS_X_END
    } );
  
  else
  
    ObjAnimate( obj, "pos_x", 0, 0, func_end,
    {
      0.0, 2, private.MOVE_ANIM_POS_X_BEG,
      tme, 2, private.MOVE_ANIM_POS_X_END
    } );
  
  end;

  private.CURRENT_ACHIEV = name;
  private.CreatObjAchiev( name );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj           = "obj_int_achievements";
  local func_end      = function () private.EventAnimEnd( event_id ); end;
  local tme           = private.MOVE_ANIM_TIME;
  local current_posx  = private.MOVE_ANIM_POS_X_END;

  ObjStopAnimate( obj, "pos_x" ); 
  current_posx = ObjGet( obj ).pos_x; 

  cmn.PlayAudio( "sfx", "audio/aud_achievement_hide", 0, "", 0 );
  
  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, current_posx,
    tme, 1, private.MOVE_ANIM_POS_X_BEG
  } );

  ObjSet( "tmr_int_achievements_hide", { playing = false } );

end;
--******************************************************************************************
function private.CreatObjAchiev ( name )

  local achiev_name = name or private.CURRENT_ACHIEV;

  if ( not ObjGet( "txt_int_achievements_achiev_name" ) ) then

    ObjCreate( "txt_int_achievements_achiev_name", "text" );
    ObjAttach( "txt_int_achievements_achiev_name", "obj_int_achievements" );

    ObjSet( "txt_int_achievements_achiev_name", 
    { 
        pos_x = private.TEXT_NAME_X, 
        pos_y = private.TEXT_NAME_Y,
        pos_z = 1,
        input = false,
        fontcolor_r = 0.996,
        fontcolor_g = 0.71,
        fontcolor_b = 0.51,
        res = "assets/fonts/times",
        fontsize = 24,
        maxwidth = 240,
        align = 1,
        linespacing = 1,
        display_outline = 1,
        outline_size = 1
      } );
    
  end;      
  
  ObjSet( "spr_int_achievements_icon", { 
    --pos_x = private.Icon[ achiev_name ][ 1 ], 
    --pos_y = private.Icon[ achiev_name ][ 2 ], 
    res = "assets/levels/menu/rm_achievements/layers/icon/"..achiev_name 
  } );
  ObjSet( "txt_int_achievements_achiev_name", { text = "str_achievements_name_"..achiev_name } );

end;
--******************************************************************************************
function private.DeleteObjAchiev ()
  
  ObjDelete( "txt_int_achievements_achiev_name" );
  private.CURRENT_ACHIEV = "";

end;
--******************************************************************************************
function private.MouseEnter ( name )

  local prefix = "spr_";

  if GetPerformanceMode() == 0 then

    prefix = "pfx_";

    if ( not ObjGet( prefix..name.."_focus" ) )  then

      prefix = "spr_";

    end;

  end;

  if not ( ObjGet( prefix..name.."_focus" ) ) then

    prefix = "";

  end;  

  SetCursor( CURSOR_HAND );

  local obj = prefix..name.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  ObjSet( "tmr_int_achievements_hide", { active = false } );

end;
--******************************************************************************************
function private.MouseLeave ( name )

  local prefix = "spr_";

  if ( GetPerformanceMode() == 0 ) then

    prefix = "pfx_";

    if not ObjGet( prefix..name.."_focus" ) then

      prefix = "spr_";

    end;

  end;

  if not ( ObjGet( prefix..name.."_focus" ) ) then

    prefix = "";

  end;  

  SetCursor( CURSOR_DEFAULT );

  local obj = prefix..name.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );
  
  ObjSet( "tmr_int_achievements_hide", { active = true } );

end;
--******************************************************************************************
function private.Animation ()

  ObjAnimate( "obj_achievements_obj_add", "alp", 0, 1, "",
  {
    0.0, 1, 1,
    0.1, 1, 0.8,
    0.2, 1, 1
  } );

end;
--******************************************************************************************
