-- name=int_button_ability
--******************************************************************************************
function public.Init ( posz )

  ObjAttach( "int_button_ability", interface.originhub );
  ObjSet( "int_button_ability", { pos_z = posz } );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );    

  public.DIRECTION = 1;
  public.POSITION  = 1024;
 
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.is_showed = false;    
  private.is_active = false;    
  private.is_enabled = false;  
  
  ObjSet("obj_int_button_ability", {
    event_mdown  = private.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });
  
  ObjSet( "obj_int_button_ability", { alp = 0, input = false } );  

end;
--******************************************************************************************
function private.WideScreenUpdate ()

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_ability_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_ability_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.MouseDown ()

  interface.TutorialHide();

  local level = ng_global.progress[ ng_global.currentprogress ].common.chapter;
  local lvl   = string.sub(level,6);
  if ( lvl == "ext" ) then
    lvl = 4
  end;    

  if ( tonumber(lvl) == 1 ) then
    
    local target_room = "rm_mansionhallpast1";
    local current_room = GetCurrentRoom();
    
    if ( GetCurrentRoom() == "rm_mansionhallpast1" ) then
      
      target_room = "rm_mansionhall1";
      
    end;

    if ( private.is_active ) then
      
      int.DeployInvHide();
      cmn.CloseSubRoom();      
      
      local func_end = function ( skip )

        cmn.SetEventDone( "use_charm1" );
        
        ObjSet( current_room, { color_r = 0, color_g = 0, color_b = 0 } );
        
        cmn.GotoRoom( target_room );

        int.Lock( false );
        
        if ( skip ) then
          
          cmn.StopAudio( "mus", "audio/level1/sfx/aud_time_travel_mus" );
          --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_ability_transfer_past_casual" );          
          
        end;

        common_impl.InterfaceSetVisible( true );

      end;         
      
      if ( not cmn.IsEventDone( "use_charm1" ) ) then             
        
        int.Lock( true );
        common_impl.PlayDialogVideo( "vid_ability_transfer_past_epic", func_end );    
        cmn.PlayAudio( "mus", "audio/level1/mus/aud_time_travel_mus" );        
        ObjAnimate( current_room, "color_rgb", 0, 0, "", 
        {
          0.0, 0, 1,1,1,
          0.3, 0, 0,0,0,
          5.0, 0, 0,0,0,          
          5.1, 0, 1,1,1
        } );
                
      else 
        
        int.Lock( true );
        common_impl.PlayDialogVideo( "vid_ability_transfer_past_casual", func_end );   
        cmn.PlayAudio( "mus", "audio/level1/mus/aud_time_travel_mus" );      
        
      end;      
      
    else 
      
      if ( not cmn.IsEventDone( "dlg_mansionhall1_richard_3" ) ) then             
        
        cmn.ShowBbt("bbt_button_ability_talkrichard");        
        
      else
      
        cmn.ShowBbt("bbt_button_ability_disabled");
        
      end;
      
    end;
    
  elseif ( tonumber(lvl) == 2 ) then
    
    local target_room = "rm_mansionhallpast3";
    local current_room = GetCurrentRoom();
    
    if ( GetCurrentRoom() == "rm_mansionhallpast2" ) then
      
      target_room = "rm_mansionhall2";      
      
    elseif ( GetCurrentRoom() == "rm_mansionhall2" ) then
      
      target_room = "rm_mansionhallpast2";
      
    end;    

    if ( private.is_active ) then
      
      int.DeployInvHide();
      cmn.CloseSubRoom();      
      
      local func_end = function ( skip )
      
        ObjSet( current_room, { color_r = 0, color_g = 0, color_b = 0 } );
        
        cmn.GotoRoom( target_room );

        int.Lock( false );
        
        if ( skip ) then
          
          cmn.StopAudio( "mus", "audio/level1/sfx/aud_time_travel_mus" );    
          
        end;

        common_impl.InterfaceSetVisible( true );

      end;         
      
      int.Lock( true );
      common_impl.PlayDialogVideo( "vid_ability_transfer_past_casual", func_end );   
      cmn.PlayAudio( "mus", "audio/level1/mus/aud_time_travel_mus" );                 
      
    else       
      
      cmn.ShowBbt("bbt_button_ability_disabled");
      
    end;      
    
  elseif ( tonumber(lvl) == 3 ) then
    
    if ( cmn.IsEventDone( "get_improvedsphere3" ) and
         not cmn.IsEventDone( "use_improvedsphere3" ) ) then 
      
      cmn.ShowDeployInv( "inv_astrolabe3" )
      
    else      
    
      local target_room = "rm_portaritroompast3";
      local current_room = GetCurrentRoom();
      
      if ( GetCurrentRoom() == "rm_portaritroompast3" ) then
        
        target_room = "rm_portraitroom3";
        
      elseif ( GetCurrentRoom() == "rm_mansionhallpast3" ) then
        
        target_room = "rm_mansionhall3";      
        
      elseif ( GetCurrentRoom() == "rm_mansionhall3" ) then
        
        target_room = "rm_mansionhallpast3";
        
      elseif ( GetCurrentRoom() == "rm_gatespast3" ) then
        
        target_room = "rm_gates3";      
        
      elseif ( GetCurrentRoom() == "rm_gates3" ) then
        
        target_room = "rm_gatespast3";
        
      end;    

      if ( private.is_active ) then
        
        int.DeployInvHide();
        cmn.CloseSubRoom();      
        
        local func_end = function ( skip )
        
          ObjSet( current_room, { color_r = 0, color_g = 0, color_b = 0 } );
          
          cmn.GotoRoom( target_room );

          int.Lock( false );
          
          if ( skip ) then
            
            cmn.StopAudio( "mus", "audio/level1/sfx/aud_time_travel_mus" );    
            
          end;

          common_impl.InterfaceSetVisible( true );

        end;         
        
        int.Lock( true );
        common_impl.PlayDialogVideo( "vid_ability_transfer_past_casual", func_end );   
        cmn.PlayAudio( "mus", "audio/level1/mus/aud_time_travel_mus" );                 
        
      else       
        
        cmn.ShowBbt("bbt_button_ability_disabled");
        
      end;    
      
    end;
    
  end;    

end;
--******************************************************************************************
function public.ShowAnim ( item_game_name, func_after )  
  
  int.Lock( true ); 

  local fly_obj_name = "fly_int_inventory_button_ability";
  ObjCreate( fly_obj_name, "obj" );
  ObjAttach( fly_obj_name, InterfaceWidget_Top_Name );
  local item_game_pos = GetObjPosByObj( item_game_name );
  ObjSet( fly_obj_name,
  {
    input      = 0,
    pos_x      = item_game_pos[ 1 ],
    pos_y      = item_game_pos[ 2 ]
  } );  
  ObjSet( item_game_name, { pos_x = 0, pos_y = 0 } );
  ObjAttach( item_game_name, fly_obj_name );  
  
  local fx_top_res = "assets/levels/common/fx/inv/fx_flash";
  local fx_bot_res = "assets/levels/common/fx/inv/fx_smoke";  
  
  local obj1 = item_game_name;  
  local obj2 = obj1.."_morph";  
  local fx_top = "fx_"..common.GetObjectName( obj1 ).."_top";
  local fx_bot = "fx_"..common.GetObjectName( obj1 ).."_bot"; 
 
  local res_obj2 = ObjGet( "spr_int_button_ability" ).res;--"assets/levels/level1/common_inventory1/inv_charmbasis1/inv/inv_charm1";--ObjGet( "spr_int_button_ability" ).res;
  
  ObjCreate( obj2, "spr" );
  ObjSet( obj2, { pos_z = 1000, scale_x = 0, scale_y = 0, res = res_obj2 } );
  ObjAttach( obj2, fly_obj_name );  
  
  ObjCreate( fx_top, "partsys" );
  ObjSet( fx_top, { pos_z = 1001, res = fx_top_res } );
  ObjAttach( fx_top, fly_obj_name ); 
 
  local trg = function ()
 
    ObjAnimate( "obj_int_button_ability", "alp", 0, 0, "", { 
      0,   0, 0,
      0.3, 0, 1 } );      
    
    ObjAnimate( fx_top, "alp", 0, 0,
    function ()

      ObjDelete( fly_obj_name );
      
      int.Lock( false );     
      private.is_showed = true;

      if ( func_after ) then

        func_after();

      end;

    end,
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );
  
  end;  
  
  local func_end = function()
  
    ObjCreate( fx_bot, "partsys" );
    ObjSet( fx_bot, { res = fx_bot_res } );
    ObjAttach( fx_bot, fly_obj_name );
  
    local target_game_pos = GetObjPosByObj( "obj_int_button_ability" );
    
    ObjAnimate( fly_obj_name, "pos_xy", 0, 0, trg, 
    {
      0.0, 3, ObjGet( fly_obj_name ).pos_x, ObjGet( fly_obj_name ).pos_y,
      1.0, 3, target_game_pos[1], target_game_pos[2]
    } );
    ObjAnimate( fly_obj_name, "scale_xy", 0, 0, "", 
    {
      0.0, 3, ObjGet( fly_obj_name ).scale_x, ObjGet( fly_obj_name ).scale_y,
      0.2, 3, ObjGet( fly_obj_name ).scale_x+0.1, ObjGet( fly_obj_name ).scale_y+0.1, 
      0.8, 3, ObjGet( fly_obj_name ).scale_x+0.1, ObjGet( fly_obj_name ).scale_y+0.1,            
      1.0, 3, ObjGet( fly_obj_name ).scale_x, ObjGet( fly_obj_name ).scale_y,
    } );    
  
  end;
  
  ObjAnimate( obj1, "scale_xy", 0, 0, "", { 
    0,   0, ObjGet( obj1 ).scale_x, ObjGet( obj1 ).scale_y,
    0.3, 0, 0, 0 } );
    
  ObjAnimate( obj2, "scale_xy", 0, 0, func_end, { 
    0,   0, 0, 0,
    0.3, 0, 1, 1 } );  

end;
--******************************************************************************************
function public.Shown ()
  
  ObjSet( "obj_int_button_ability", { alp = 1, input = true } );
  private.is_showed = true;  

end;
--******************************************************************************************
function public.Enable ()
  
  private.is_enabled = true;

end;
--******************************************************************************************
function public.Activate ()
  
  if ( private.is_enabled ) then
  
    private.is_active = true;
    ObjSet( "anm_int_button_ability_active", { alp = 1, active = true, frame = 0 } );
    ObjSet( "spr_int_button_ability", { alp = 0 } );
  
  end;

end;
--******************************************************************************************
function public.Deactivate ()
  
  if ( private.is_enabled ) then  
    
    private.is_active = false;
    ObjSet( "anm_int_button_ability_active", { alp = 0, active = false, frame = 0 } ); 
    ObjSet( "spr_int_button_ability", { alp = 1 } );  
    
  end;

end;
--******************************************************************************************
--******************************************************************************************