-- name=int_button_skull
--******************************************************************************************
function public.Init ( posz )

  ObjAttach( "int_button_skull", interface.originhub );
  ObjSet( "int_button_skull", { pos_z = posz } );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );    

  public.DIRECTION = 1;
  public.POSITION  = 1024;
 
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.is_showed = false;    
  private.is_enabled = false;
  private.is_active = false;  
  
  ObjSet("obj_int_button_skull", {
    event_mdown  = private.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });
  
  ObjSet( "obj_int_button_skull", { alp = 0, input = false } );

end;
--******************************************************************************************
function private.WideScreenUpdate ()

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_skull_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_skull_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.MouseDown ()

  local level = ng_global.progress[ ng_global.currentprogress ].common.chapter;
  local lvl   = string.sub(level,6);
  if ( lvl == "ext" ) then
    lvl = 4
  end;  
  
  if ( not private.is_enabled ) then
    
    cmn.ShowBbt("bbt_button_skull_disabled");
    
  else

    if ( tonumber(lvl) == 1 ) then

      if ( cmn.IsEventDone( "win_trapdoor1" ) and 
           not cmn.IsEventDone( "dlg_mansionhall1_richard_2" ) and   
           private.is_active ) then
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );      
   
        int.Lock( true );
        
        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" );                
        rm_mansionhall1.dlg_mansionhall1_richard_2();
       
      elseif ( cmn.IsEventDone( "get_charm1" )and 
               not cmn.IsEventDone( "dlg_mansionhall1_richard_3" ) and   
               private.is_active ) then  
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );       

        int.Lock( true );        

        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" ); 
        rm_mansionhall1.dlg_mansionhall1_richard_3();          
        
      elseif ( cmn.IsEventDone( "dlg_mansionhall1_stacy_4" )and 
               not cmn.IsEventDone( "dlg_mansionhall1_richard_4" ) and   
               private.is_active ) then 
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );       

        int.Lock( true );        

        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" );  
        rm_mansionhall1.dlg_mansionhall1_richard_4();          
        
      else 
        
        ObjSet( "anm_int_button_skulltalk", { alp = 1, active = true, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );
        ObjSet( "obj_int_button_skull", { input = false } );
        cmn.ShowBbt( "bbt_button_skull_joke_"..math.random(1,7) );                  
        
        local func_end = function ()
          
          ObjSet( "anm_int_button_skulltalk", { alp = 0, active = false, frame = 0 } );
          ObjSet( "spr_int_button_skull", { alp = 1 } );
          ObjSet( "obj_int_button_skull", { input = true } );   
          
        end;
        
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_richard_skull" );
        
        AnimPlay( "anm_int_button_skulltalk", "DoAnim", func_end );
        
      end;
      
    end;

    if ( tonumber(lvl) == 2 ) then

      if ( cmn.IsEventDone( "opn_doriansroom2" )and 
           not cmn.IsEventDone( "dlg_doriansroom2_richard2_1" ) and   
           private.is_active ) then 
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );       

        int.Lock( true );        

        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" );  
        rm_doriansroom2.dlg_doriansroom2_richard2_1();       

      elseif ( cmn.IsEventDone( "clk_oldkey2" )and 
               not cmn.IsEventDone( "dlg_doriansroom2_richard2_2" ) and   
               private.is_active ) then 
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );       

        int.Lock( true );        

        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" );  
        rm_doriansroom2.dlg_doriansroom2_richard2_2();       

      elseif ( cmn.IsEventDone( "opn_boardingschool2" )and 
               not cmn.IsEventDone( "dlg_doriansroom2_richard2_3" ) and   
               private.is_active ) then 
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );       

        int.Lock( true );        

        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" );  
        rm_doriansroom2.dlg_doriansroom2_richard2_3();       

      elseif ( cmn.IsEventDone( "get_oldhypnochip2" )and 
               not cmn.IsEventDone( "dlg_doriansroom2_richard2_4" ) and   
               private.is_active ) then 
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );       

        int.Lock( true );        

        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" );  
        rm_doriansroom2.dlg_doriansroom2_richard2_4();       
        
      else 
        
        ObjSet( "anm_int_button_skulltalk", { alp = 1, active = true, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );
        ObjSet( "obj_int_button_skull", { input = false } );
        cmn.ShowBbt( "bbt_button_skull_joke_"..math.random(1,7) );                 
        
        local func_end = function ()
          
          ObjSet( "anm_int_button_skulltalk", { alp = 0, active = false, frame = 0 } );
          ObjSet( "spr_int_button_skull", { alp = 1 } );
          ObjSet( "obj_int_button_skull", { input = true } );   
          
        end;

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_richard_skull" );
        AnimPlay( "anm_int_button_skulltalk", "DoAnim", func_end );
        
      end;
      
    end;

    if ( tonumber(lvl) == 3 ) then

      if ( cmn.IsEventDone( "use_vase3" )and 
           not cmn.IsEventDone( "dlg_portraitroom3_richard3_1" ) and   
           private.is_active ) then 
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );       

        int.Lock( true );        

        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" );  
        rm_portraitroom3.dlg_portraitroom3_richard3_1 ();       

      elseif ( cmn.IsEventDone( "use_improvedsphere3" )and 
               not cmn.IsEventDone( "dlg_portraitroom3_richard3_2" ) and   
               private.is_active ) then 
        
        int.DeployInvHide( true );
        cmn.CloseSubRoom( true );       

        int.Lock( true );        

        ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );       
        ObjSet( "anm_int_button_skull_richard_appearance", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_skull_rich_appears" );
        AnimPlay( "anm_int_button_skull_richard_appearance", "DoAnim", "" );  
        rm_portraitroom3.dlg_portraitroom3_richard3_2();       
        
      else 
        
        ObjSet( "anm_int_button_skulltalk", { alp = 1, active = true, frame = 0 } );
        ObjSet( "spr_int_button_skull", { alp = 0 } );
        ObjSet( "obj_int_button_skull", { input = false } );
        cmn.ShowBbt( "bbt_button_skull_joke_"..math.random(1,7) );                 
        
        local func_end = function ()
          
          ObjSet( "anm_int_button_skulltalk", { alp = 0, active = false, frame = 0 } );
          ObjSet( "spr_int_button_skull", { alp = 1 } );
          ObjSet( "obj_int_button_skull", { input = true } );   
          
        end;

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_richard_skull" );
        AnimPlay( "anm_int_button_skulltalk", "DoAnim", func_end );
        
      end;
      
    end;

  end;

end;
--******************************************************************************************
function public.ShowAnim ( item_game_name, func_after )  
  
  int.Lock( true ); 

  local fly_obj_name = "fly_int_inventory_button_skull";
  ObjCreate( fly_obj_name, "obj" );
  ObjAttach( fly_obj_name, InterfaceWidget_Top_Name );
  local item_game_pos = GetObjPosByObj( item_game_name );
  ObjSet( fly_obj_name,
  {
    input      = 0,
    pos_x      = item_game_pos[ 1 ],
    pos_y      = item_game_pos[ 2 ]
  } );  
  ObjSet( item_game_name, { pos_x = 0, pos_y = 0 } );
  ObjAttach( item_game_name, fly_obj_name );  
  
  local fx_top_res = "assets/levels/common/fx/inv/fx_flash";
  local fx_bot_res = "assets/levels/common/fx/inv/fx_smoke";  
  
  local obj1 = item_game_name;  
  local obj2 = obj1.."_morph";  
  local fx_top = "fx_"..common.GetObjectName( obj1 ).."_top";
  local fx_bot = "fx_"..common.GetObjectName( obj1 ).."_bot"; 
 
  local res_obj2 = ObjGet( "spr_int_button_skull" ).res;
  
  ObjCreate( obj2, "spr" );
  ObjSet( obj2, { pos_z = 1000, scale_x = 0, scale_y = 0, res = res_obj2 } );
  ObjAttach( obj2, fly_obj_name );  
  
  ObjCreate( fx_top, "partsys" );
  ObjSet( fx_top, { pos_z = 1001, res = fx_top_res } );
  ObjAttach( fx_top, fly_obj_name ); 
 
  local trg = function ()
 
    ObjAnimate( "obj_int_button_skull", "alp", 0, 0, "", { 
      0,   0, 0,
      0.3, 0, 1 } );      
    
    ObjAnimate( fx_top, "alp", 0, 0,
    function ()

      ObjDelete( fly_obj_name );
      
      int.Lock( false );     
      private.is_showed = true;

      if ( func_after ) then

        func_after();

      end;

    end,
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );
  
  end;  
  
  local func_end = function()
  
    ObjCreate( fx_bot, "partsys" );
    ObjSet( fx_bot, { res = fx_bot_res } );
    ObjAttach( fx_bot, fly_obj_name );
  
    local target_game_pos = GetObjPosByObj( "obj_int_button_skull" );
    
    ObjAnimate( fly_obj_name, "pos_xy", 0, 0, trg, 
    {
      0.0, 3, ObjGet( fly_obj_name ).pos_x, ObjGet( fly_obj_name ).pos_y,
      1.0, 3, target_game_pos[1], target_game_pos[2]
    } );
    ObjAnimate( fly_obj_name, "scale_xy", 0, 0, "", 
    {
      0.0, 3, ObjGet( fly_obj_name ).scale_x, ObjGet( fly_obj_name ).scale_y,
      0.2, 3, ObjGet( fly_obj_name ).scale_x+0.1, ObjGet( fly_obj_name ).scale_y+0.1, 
      0.8, 3, ObjGet( fly_obj_name ).scale_x+0.1, ObjGet( fly_obj_name ).scale_y+0.1,            
      1.0, 3, ObjGet( fly_obj_name ).scale_x, ObjGet( fly_obj_name ).scale_y,
    } );    
  
  end;
  
  ObjAnimate( obj1, "scale_xy", 0, 0, "", { 
    0,   0, ObjGet( obj1 ).scale_x, ObjGet( obj1 ).scale_y,
    0.3, 0, 0, 0 } );
    
  ObjAnimate( obj2, "scale_xy", 0, 0, func_end, { 
    0,   0, 0, 0,
    0.3, 0, 1, 1 } );  

end;
--******************************************************************************************
function public.Shown ()
  
  ObjSet( "obj_int_button_skull", { alp = 1, input = true } );
  private.is_showed = true;  

end;
--******************************************************************************************
function public.Enable ()
  
  private.is_enabled = true;

end;
--******************************************************************************************
function public.Activate ()
  
  private.is_active = true;
  ObjSet( "anm_int_button_skull_active", { alp = 1, active = true, frame = 0 } );
  ObjSet( "spr_int_button_skull", { alp = 0 } );

end;
--******************************************************************************************
function public.Deactivate ()
  
  private.is_active = false;
  ObjSet( "anm_int_button_skull_active", { alp = 0, active = false, frame = 0 } );
  ObjSet( "spr_int_button_skull", { alp = 1 } );  

end;
--******************************************************************************************