-- name=int_button_task
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_task", "obj_int_inventory_task" );
  ObjSet( "int_button_task", { pos_z = pos_z } );

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_TIME      =  0.6;

  ObjSet( "obj_int_button_task", 
  {
    event_mdown = private.MouseDown--,
    --event_menter = private.MouseEnterAnim,
    --event_mleave = private.MouseLeaveAnim
    --port. fix
  } );
  
end;
--******************************************************************************************
function public.Destroy ()

  --

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function private.MouseDown ()

  if ( int_dialog_task.show ) then

    interface.DialogTaskHide();

  else

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_get_task_list" );
    interface.DialogTaskShow( private.task_current, "current_task" );

  end;

end;
--******************************************************************************************
function private.MouseEnterAnim ()

  interface.InventoryOpen();

  SetCursor( CURSOR_HAND );

  focus_name = "spr_int_button_task_focus";

  if ( ObjGet( focus_name ) ) then

    local focus_alp = ObjGet( focus_name ).alp;

    ObjAnimate( focus_name, "alp", 0, 0, "", 
    { 
      0, 0, focus_alp, 
      ( private.MOUSE_OVER_ANIM_TIME * ( 1 - focus_alp ) ), 0, 1 
    } );

  end;

end;
--******************************************************************************************
function private.MouseLeaveAnim ()

  interface.InventoryClose();

  SetCursor( CURSOR_DEFAULT );

  focus_name = "spr_int_button_task_focus";

  if ( ObjGet( focus_name ) ) then

    local focus_alp = ObjGet( focus_name ).alp;

    ObjAnimate( focus_name, "alp", 0, 0, "", 
    { 
      0, 0, focus_alp, 
      ( private.MOUSE_OVER_ANIM_TIME * ( 1 - focus_alp ) ), 0, 0 
    } );

  end;

end;
--******************************************************************************************
function public.Update ( state, task )

  private.task_current = task;
  ObjSet( "int_button_task", { active = state, visible = state, input = state } );
  --AnimPlay( "anm_int_button_task_appear", "DoAnim", function () ObjDelete( "anm_int_button_task_appear" );  end );

end;
--******************************************************************************************
function public.SetInput ( state )

  ObjSet( "int_button_task", { input = state } );

end;
--******************************************************************************************
--******************************************************************************************