-- name=int_dialog_task
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_dialog_task", interface.originhub );
  ObjSet( "int_dialog_task", { pos_z = pos_z } );

  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  public.show = false;
  private.SHOW_ANIM_TIME = 0.5;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.pos_x = 492;
  
  private.FuncEnd = nil;
  private.task = "";

  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.StopTypeAnim (); end,
  } );

  private.WideScreenUpdate();

end;
--******************************************************************************************
function public.Destroy()
    MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
end;
--******************************************************************************************
function private.AnimEnd( event_id )  

  int.Lock( false );

  if ( event_id == "show" ) then
  
    public.show = true;
    --ObjSet( "int_dialog_task", { input = true } );

  elseif ( event_id == "hide" ) then
  
    public.show = false;

    --ObjSet( "int_dialog_task", { input = false } );
    
    ObjSet( "obj_int_dialog_task", { input = false, event_mdown = function () public.StopTypeAnim (); end } );


    if ( private.FuncEnd ) then
  
      private.FuncEnd();
      private.FuncEnd = nil;

    end;

  end;

  int_button_task.SetInput( true );

end;
--******************************************************************************************
function private.ShowAnim ( event_id, data )
  
  local func_end = function () private.TypeAnim( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;
  
  int.Lock( true );

  private.task = data.task;

  ObjAnimate( "obj_int_dialog_task", "alp", 0, 0, func_end,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

  int_button_task.SetInput( false );

end;
--******************************************************************************************
function private.TypeAnim ( event_id )  

  int.Lock( false );

  ObjSet( "obj_int_dialog_task", { input = true } );

  local func_end = function () 

    private.AnimEnd( event_id ); 

    ObjSet( "obj_int_dialog_task",
    {
      event_mdown = function () public.Hide(); end,
    } );

  end;

  common_impl.PrintText(
    "txt_int_dialog_task_description", 
    "str_dialog_task_"..private.task, 
    private.SHOW_ANIM_TIME*3, 
    func_end
  );

  int.Lock( false );

end;
--******************************************************************************************
function public.StopTypeAnim ()

  common_impl.ShowText("txt_int_dialog_task_description");
  ObjSet( "obj_int_dialog_task",
  {
    event_mdown = function () public.Hide(); end,
  } );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local func_end = function () private.AnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  int.Lock( true );
  ObjAnimate( "obj_int_dialog_task", "alp", 0, 0, func_end,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--*****************************************************************************************
function public.Show ( data )

  local event_id = "show";  

  --int.DeployInvHide()
  private.Update( data );
  private.FuncEnd = data.func_end;
  private.ShowAnim( event_id, data );

end;
--******************************************************************************************
function public.Hide ()

  local event_id = "hide";
  private.HideAnim( event_id );

end;
--******************************************************************************************
function private.Update ( data )

  ObjSet( "txt_int_dialog_task_header", { text = "str_dialog_task_header_"..data.state } );
  ObjSet( "txt_int_dialog_task_description", { text = "" } );

end;
--******************************************************************************************
function private.WideScreenUpdate()
  
  if ( not GetWideScreen() ) then
    ObjSet( "spr_int_task_show", { pos_x = private.pos_x - 171 } );
  else
    ObjSet( "spr_int_task_show", { pos_x = private.pos_x } );
  end;
end;