-- name=int_loupe
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_loupe", interface.originhub );
  
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  public.loupe_show = false;

  private.obj_list =
  {
    { "mentalmagnifier1_1", "mentalmagnifier1_2", "mentalmagnifier1_3", "mentalmagnifier1_4", "mentalmagnifier1_5", "mentalmagnifier1_6", "mentalmagnifier1_7" }, --[[ lvl1 ]]
    {}, --[[ lvl2 ]]
    {}, --[[ lvl3 ]]
    {}, --[[ lvl4 ]]
  };

  private.WideScreenUpdate();

  ObjSet( "obj_int_loupe",
  {
    drag            = true,
    event_startdrag = function () private.StartDrag(); end,
    event_drag      = function () private.Drag(); end,
    event_dragdrop  = function () private.Hide(); end,
  } );

  int.LoupeShow = private.Show;
  
  private.find = false;

end;
--******************************************************************************************
function public.Destroy()
  
  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
--******************************************************************************************
function private.EventAnimEnd ( event_id )
  
  if not private.find then
    int.Lock( false );
  else 
    private.find = false;
  end;

  if ( event_id == "show" ) then
    
    public.loupe_show = true;

    ObjStartDrag( "obj_int_loupe" );

  elseif ( event_id == "hide" ) then
    
    ObjSet( "obj_int_loupe", { active = false, visible = false, input = false } );

    public.loupe_show = false;

  end;

end;
--******************************************************************************************
function private.ShowAnim ( event_id )

  public.show = true;
  
  local obj = "obj_int_loupe";
  local tme = 0.3;
  
  local func_end = function ()

    private.EventAnimEnd( event_id );

  end;

  ObjAnimate( obj, "alp", 0, 0, func_end,
  {
    0.0, 2, 0.0,
    tme, 2, 1.0
  } );

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj = "obj_int_loupe";
  local tme = 0.3;

  local func_end = function ()

    private.EventAnimEnd( event_id );

  end;
  
  ObjAnimate( obj, "alp", 0, 0, func_end,
  {
    0.0, 2, 1.0,
    tme, 2, 0.0,
  } );
  
end;
--******************************************************************************************
function private.WideScreenUpdate ()

  if ( not GetWideScreen() ) then
    --
  else
    --
  end;

end;
--******************************************************************************************
function private.Show ()

  local room = GetCurrentRoom();

  if ( not string.find( room, "rm_" ) or ( int.GetCurrentInv() ~= "" ) ) then 

    return;

  end;

  int.Lock( true );
  --cmn.CloseSubRoom( true );

  local pos = GetZoomCursorPos()

  ObjSet( "obj_int_loupe", { pos_x = pos[ 1 ], pos_y = pos[ 2 ], active = true, visible = true, input = true } );

  local event_id = "show";

  private.ShowAnim( event_id );

  cmn.SetCursor( CURSOR_NULL );

  interface.TutorialHide();

end;
--******************************************************************************************
function private.Hide ()
 
  int.Lock( true );

  local pos = GetZoomCursorPos()

  ObjSet( "obj_int_loupe", { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );

  local event_id = "hide";
  private.HideAnim( event_id );

  cmn.SetCursor( CURSOR_DEFAULT );

end;
--******************************************************************************************
function private.StartDrag ()

  local level = ng_global.progress[ ng_global.currentprogress ].common.chapter;
  local lvl   = string.sub( level, 6 );

  if ( lvl == "ext" ) then

    lvl = 4;

  end;

  lvl = tonumber( lvl );

  private.list = private.obj_list[ lvl ];
  private.room = common.GetObjectName( GetCurrentRoom() );

  if ( common.IsInSubRoom() ) then

    private.room = common.GetObjectName( common.GetCurrentSubRoom() );

  end;

end;
--******************************************************************************************
function private.Drag ()

  for c = 1, #private.list do

    local obj = private.list[ c ];

    if ( ApplyObj( "obj_int_loupe_apply", "obj_"..private.room.."_use_"..obj ) ) then

      if ( cmn.IsEventDone( "use_"..obj ) ) then

        return;

      end;
      
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_eye_magic_check" );

      --cmn.SetEventDone( "use_"..obj );
      cmn.CallEventHandler( "use_"..obj.."_inv" );
      cmn.CallEventHandler( "use_"..obj.."_beg" );
      cmn.CallEventHandler( "use_"..obj.."_end" );
      
      private.find = true;
      private.Hide();
      ObjStopDrag( "obj_int_loupe" );
     
      local room = common.GetCurrentRoom();
      
      if room == "rm_greywitchgates1" then
        
        if obj == "mentalmagnifier1_1" then
          rm_greywitchgates1.get_auratrace1_1();
        elseif obj == "mentalmagnifier1_2" then
          rm_greywitchgates1.get_auratrace1_2(); 
        elseif obj == "mentalmagnifier1_5" then 
          rm_greywitchgates1.get_auratrace1_5();  
        elseif obj == "mentalmagnifier1_6" then 
          rm_greywitchgates1.get_auratrace1_6();
        end;   
              
      elseif room == "rm_ruinedsquare1" then
        
        if obj == "mentalmagnifier1_7" then
          rm_ruinedsquare1.get_auratrace1_7();
        elseif obj == "mentalmagnifier1_3" then
          rm_ruinedsquare1.get_auratrace1_3(); 
        elseif obj == "mentalmagnifier1_4" then 
          rm_ruinedsquare1.get_auratrace1_4();  
        end;
               
      end;  
     
--      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_find_crystal" );
--      ObjAnimate( "obj_"..private.room.."_"..obj, "alp", 0, 0,
--      function ()
--
--        cmn.CallEventHandler( "use_"..obj.."_end" );
--
--      end,
--      {
--        0.0, 3, 0.0,
--        0.3, 3, 1.0,
--      } );

      --ObjSet( "pfx_"..private.room.."_"..obj, { active = true } );
      --PartSysSetMaskObj( "pfx_"..private.room.."_"..obj, "spr_"..private.room.."_"..obj ); 

    end;

  end;

end;
--******************************************************************************************
--******************************************************************************************