-- name=int_map_impl
--******************************************************************************************
function public.Init()

  public.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.5;
  private.HIDE_ANIM_TIME = 0.5;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  
  private.PopupHidePosX = 0;
  private.PopupHidePosY = 0;

  private.PosBeg = {};
  private.PosEnd = {};

  ObjSet( "btn_map_button_close", {
    event_mdown  = int_map.Close,
    event_menter = function () private.MouseEnter( "btn_map_button_close" ) end,
    event_mleave = function () private.MouseLeave( "btn_map_button_close" ) end
  } );

  ObjSet( "btn_map_button_diary", {
    event_mdown  = function () private.ButtonDiaryClick() end,
    event_menter = function () private.MouseEnter( "btn_map_button_diary" ) end,
    event_mleave = function () private.MouseLeave( "btn_map_button_diary" ) end
  } );

  ObjSet( "btn_map_button_achievements", {
    event_mdown  = function () private.ButtonAchievementsClick() end,
    event_menter = function () private.MouseEnter( "btn_map_button_achievements" ) end,
    event_mleave = function () private.MouseLeave( "btn_map_button_achievements" ) end
  } );

  ObjSet( "btn_map_button_collectibles", {
    event_mdown  = function () private.ButtonCollectiblesClick() end,
    event_menter = function () private.MouseEnter( "btn_map_button_collectibles" ) end,
    event_mleave = function () private.MouseLeave( "btn_map_button_collectibles" ) end
  } );

  ObjSet( "btn_map_button_legends", {
  event_menter = function () private.I_AM_LEGEND( "show" ) end,
  event_mleave = function () private.I_AM_LEGEND( "hide" ) end
  } );

  private.map_show     = false;

  private.map = {};
  private.map.show_payer = 0;

  private.map.map_room = 
  {
    { "greywitchgates1", "ruinedsquare1", "alley1",  "house1",  "secondfloor1", "square1", "cellar1" },
    { "abighalehouse2", "alley2", "neartower2", "prison2", "shore2", "workshop2" },
    { "abigailshouse3", "alley3", "neartower3", "shore3", "workshop3", "lab3", "mortuary3", "park3", "secretroom3", "tower3", "towerroof3" },
    { "alchemiststore", "dungeon", "headphysicianoffice", "hospital", "morgue", "pagantemple", "park", "prison", "sidesteet", "square" }
  };
  
  for i = 1,4 do

      for j = 1,#private.map.map_room[ i ] do

          ObjSet( "spr_map_root_screen_"..i.."_rooms_"..private.map.map_room[i][j].."_focus", {
            event_mdown  = function () private.MouseDown( "spr_map_root_screen_"..i.."_rooms_"..private.map.map_room[i][j].."_focus" ) end,
            event_menter = function () private.MouseEnter( "map_root_screen_"..i.."_rooms_"..private.map.map_room[i][j] ) end,
            event_mleave = function () private.MouseLeave( "map_root_screen_"..i.."_rooms_"..private.map.map_room[i][j] ) end
          } );

      end;

  end;

  private.map.ignore_system_room = 
  {
    "menu", "achievements", "collectibles",
    "extra", "moregames", "diary", "credits",
    "intro", "demo", "monsters", "diary",
  }

  private.map.ignore_game_room = 
  {
    -- 1 лвл 
    --"rm_greywitchgates1", "rm_alley1", "rm_cellar1", "rm_house1", "rm_ruinedsquare1", "rm_secondfloor1", "rm_square1",
    -- 2 лвл 
    --"rm_abighalehouse2", "rm_alley2", "rm_neartower2", "rm_prison2", "rm_shore2", "rm_workshop2",
    -- 3 лвл
    --"rm_abigailshouse3", "rm_alley3", "rm_lab3", "rm_mortuary3", "rm_neartower3", "rm_park3", "rm_secretroom3", "rm_shore3", "rm_tower3", "rm_towerroof3", "rm_workshop3",
    -- 4 лвл    
    --"rm_alchemiststore", "rm_dungeon", "rm_headphysicianoffice", "rm_hospital", "rm_morgue", "rm_pagantemple", "rm_park", "rm_prison", "rm_sidesteet", "rm_square",
    -- допы    
    "rm_achievements", "rm_diary", "rm_collectibles"
  }

  int.VisitMapRoom  = private.VisitMapRoom;
  int.Init          = private.Init;
  int.AddedTaskMap  = private.AddedTaskMap;
  int.DeleteTaskMap = private.DeleteTaskMap;
  int.LockRoomMap   = private.LockRoomMap;

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then
  else
  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local func_end = function () int_map.EventAnimEnd( event_id ); end;
  local tme      = private.SHOW_ANIM_TIME;
  ObjSet( "obj_map_root", { input = true } );

  ObjAnimate( "int_map", "alp", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.1, 3, 0,
    tme, 3, 1
  } );

  ObjAnimate( "int_map", "color_rgb", 0, 0, "",
  {
    0.0, 3, 0, 0, 0,
    0.1, 3, 0, 0, 0,
    tme, 3, 1, 1, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local func_end = function () int_map.EventAnimEnd( event_id ); end;
  local tme      = private.HIDE_ANIM_TIME;

  cmn.PlayAudio( "sfx", "audio/aud_closemap", 0, "", 0 );
  ObjSet( "obj_map_root", { input = false } );

  ObjAnimate( "int_map", "alp", 0, 0, func_end,
  {
    0.0, 3, 1,
    0.1, 3, 1,
    tme, 3, 0
  } );

  ObjAnimate( "int_map", "color_rgb", 0, 0, "",
  {
    0.0, 3, 1, 1, 1,
    0.1, 3, 1, 1, 1,
    tme, 3, 0, 0, 0
  } );

end;
--******************************************************************************************
------------------------------------------------------------------------------------
function private.VisitMapRoom( room )

  for i = 1, #private.map.ignore_system_room do

    if ( room == "rm_"..private.map.ignore_system_room[ i ] ) then

      return nil;

    end;

  end;
--
  local prg = ng_global.currentprogress;
--
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  --принудительный обход проверок карты 4-го уровня
  --if ng_global.progress[ prg ].common.chapter == "levelext" then
  --  return;
  --end;
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  --принудительный обход проверок карты 5-го уровня
  if ng_global.progress[ prg ].common.chapter == "levelscr" or ng_global.progress[ prg ].common.chapter == "levelrpl"  then
    return;
  end;
  --if ng_global.progress[ prg ].common.chapter == "levelscr" or ng_global.progress[ prg ].common.chapter == "levelrpl" then
  --  return;
  --end;
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
--
  local found_room = false;--для определения уже занесенной комнаты в список 
  local cur_pos    = "";--текущее положение игрока
  local bypass_added    = false;
  local PLAYER_OFFSET_X = 0;
  local PLAYER_OFFSET_Y = 0;
--
  if ( not ng_global.progress[ prg ].common.map.room ) then
    
    ng_global.progress[ prg ].common.map.room = {};
    ng_global.progress[ prg ].common.map.task = {};
    
  end;
--
  if ( ng_global.progress[ prg ].common.chapter == "level2" ) then

     for i = 1, #private.map.map_room[ 2 ] do

        if ( cmn.IsEventDone( "opn_"..private.map.map_room[2][i] ) ) then

          local rm_room = common.GetObjectName( room );
          local size_map = #ng_global.progress[ prg ].common.map.room;
          if size_map ~= 0 then

            for i = 1, size_map do

              if ( rm_room == ng_global.progress[ prg ].common.map.room[ i ] ) then

                found_room = true;
                break;

              end;

            end;

            if ( not found_room ) then

               table.insert( ng_global.progress[ prg ].common.map.room, private.map.map_room[2][i] );
               ng_global.progress[ prg ].common.map.task[ private.map.map_room[2][i] ] = {};

            end;

          end;

        end;

     end;
   
  end;

  if ( ng_global.progress[ prg ].common.chapter == "level3" ) then

     for i = 1, 6 do

        if ( cmn.IsEventDone( "opn_"..private.map.map_room[3][i] ) ) then

           table.insert( ng_global.progress[ prg ].common.map.room, private.map.map_room[3][i] );
           ng_global.progress[ prg ].common.map.task[ private.map.map_room[3][i] ] = {};

        end;

     end;

  end;
     
--  if ( ng_global.progress[ prg ].common.chapter == "levelext" ) then
--
--     for i = 1, 6 do
--
--        if ( cmn.IsEventDone( "opn_"..private.map.map_room[4][i] ) ) then
--
--           table.insert( ng_global.progress[ prg ].common.map.room, private.map.map_room[4][i] );
--           ng_global.progress[ prg ].common.map.task[ private.map.map_room[4][i] ] = {};
--
--        end;
--
--     end;
--
--  end;     

  --ObjSet( room, { color_r = 1, color_g = 1, color_b = 1 } );--для восстановления комнаты после перехода по карте

  local ignore = false;

  for i = 1, #private.map.ignore_game_room do

    if ( room == private.map.ignore_game_room[ i ] ) then

      ignore = true;
      break;

    end;

  end;  

  if ( not ignore ) then

      cur_pos = common.GetObjectName( room );
      room = common.GetObjectName( room );

    ---заполнение массива прогресса посещенных комнат--------

      local size_map = #ng_global.progress[ prg ].common.map.room;
      if size_map ~= 0 then

        for i = 1, size_map do

          if ( room == ng_global.progress[ prg ].common.map.room[ i ] ) then

            found_room = true;

            break;

          end;

        end;

        if ( not found_room ) then

          table.insert( ng_global.progress[ prg ].common.map.room, room );

          ng_global.progress[ prg ].common.map.task[ room ] = {};

        end;

      else

         ng_global.progress[ prg ].common.map.room[ 1 ] = room;
         ng_global.progress[ prg ].common.map.task[ room ] = {};

      end;
      
      cur_pos = room;

  end;

  if ( cur_pos ~= "" ) then

    local pos_player = {};

    local prg   = ng_global.currentprogress;
    local level = ng_global.progress[ prg ].common.chapter;
    local lvl   = string.sub(level,6);

    if ( lvl == "ext" ) then

        lvl = 4;

    end;

    pos_player.x = ObjGet( "spr_map_root_screen_"..lvl.."_rooms_"..cur_pos ).pos_x;
    pos_player.y = ObjGet( "spr_map_root_screen_"..lvl.."_rooms_"..cur_pos ).pos_y;
  
    ObjSet( "obj_map_root_player", 
    { 
      alp = 1,
      visible = 1,
      pos_x = pos_player.x + PLAYER_OFFSET_X,
      pos_y = pos_player.y + PLAYER_OFFSET_Y
    } );

  else

    ObjSet( "obj_map_root_player", 
    { 
      alp = 0,
      visible = 0
    } );    

  end;

  private.MapStateRestore();
  
end;
------------------------------------------------------------------------------------
function private.AddedTaskMap( room, event, done_events )

  local prg = ng_global.currentprogress; 

  local is_event_present = false;
  local need = true;

  if ( done_events ~= nil ) then

    for i=1,#done_events do

      for j=1,#game.progress_names do 

        if ( string.find( game.progress_names[ j ],done_events[ i ] ) ) then

          is_event_present = true;

        end;

      end;

      if ( is_event_present ) then

        if ( not cmn.IsEventDone( done_events[i] ) ) then

          need = false;
          break;

        end;

      else

        DbgTrace("Событие "..done_events[ i ].." отсутствует в комнате "..room..", поэтому может быть проблема проблема");

      end;

    end;

  end;

  if ng_global.progress[ prg ].common.map.room ~= nil then

    if ( need ) then

      if not ( cmn.IsEventDone( event ) ) then

        local size_map = #ng_global.progress[ prg ].common.map.room;

        local found_room = false;

        room = common.GetObjectName( room );

        for i = 1, size_map do

          if ( room == ng_global.progress[ prg ].common.map.room[ i ] ) then

            found_room = true;
            break;

          end;

        end;

        local is_get = false;

        if ng_global.progress[ prg ].common.map.task[ room ] ~= nil then

          local size_task = #ng_global.progress[ prg ].common.map.task[ room ];

          if ( size_task > 0 ) then

            for i = 1, size_task do

              if ( ng_global.progress[ prg ].common.map.task[ room ][ i ] == event ) then
                is_get = true;
              end;

            end;

          end;

          if not ( is_get ) then
            --DbgTrace("Событие добавляем - "..tostring(event));
            if not ( found_room ) then

              table.insert( ng_global.progress[ prg ].common.map.room, room );
              ng_global.progress[ prg ].common.map.task[ room ] = {};
              table.insert( ng_global.progress[ prg ].common.map.task[ room ], event );

            else

              table.insert( ng_global.progress[ prg ].common.map.task[ room ], event );

            end;

          end;

        end;

      else 

        room = common.GetObjectName( room );
        local size_map = #ng_global.progress[ prg ].common.map.room;
        local found_room = false;

        for i = 1, size_map do
          if room == ng_global.progress[ prg ].common.map.room[ i ] then
            found_room = true;
            break;
          end;
        end;

        if found_room then  

          local size_task = #ng_global.progress[ prg ].common.map.task[ room ];

          if size_task > 0 then

            for i = 1, size_task do

              if ng_global.progress[ prg ].common.map.task[ room ][ i ] == event then

                table.remove( ng_global.progress[ prg ].common.map.task[ room ], i );
                break;

              end;

            end;

          end;

        end;

      end;

    end;

  end;

end;
------------------------------------------------------------------------------------
function private.DeleteTaskMap( room, event )

  local prg = ng_global.currentprogress; 

  if ( string.find( event, "opn_" ) and cmn.IsEventDone(event) ) or
     ( not string.find( event, "opn_" ) ) then
  
    local size_map = #ng_global.progress[ prg ].common.map.room;
    local found_room = false;

    room = common.GetObjectName( room );

    for i = 1, size_map do
      if room == ng_global.progress[ prg ].common.map.room[ i ] then
        found_room = true;
        break;
      end;
    end;

    if found_room then  

      local size_task = #ng_global.progress[ prg ].common.map.task[ room ];

      if size_task > 0 then

        for i = 1, size_task do

          if ng_global.progress[ prg ].common.map.task[ room ][ i ] == event then

            table.remove( ng_global.progress[ prg ].common.map.task[ room ], i );
            break;

          end;

        end;

      end;

    end;

  end;

end;

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
function private.MapStateRestore()

  local prg      = ng_global.currentprogress; 
  local size_map = #ng_global.progress[ prg ].common.map.room;
  local level    = ng_global.progress[ prg ].common.chapter;
  local lvl      = string.sub(level,6);

  if ( lvl == "ext" ) then

      lvl = 4;

  end;

  for i = 1, size_map do

    local room = ng_global.progress[ prg ].common.map.room[ i ];
    local hub_unlocked = "obj_map_root_screen_"..lvl.."_unlocked_"..room;

    ObjSet( hub_unlocked, { alp = 1 } );

    if not ( private.IsLockRoomMap( room ) ) then

      ObjSet( "spr_map_root_screen_"..lvl.."_rooms_"..room,  { input = 1, alp = 1 } );

      --ObjSet( "txt_map_root_screen_"..lvl.."_rooms_"..room.."_name",  { text = "pop_"..room } );
      --ObjSet( "spr_map_root_screen_"..lvl.."_rooms_"..room.."_line",  { alp = 1 } );
    
    else

      ObjSet( "spr_map_root_screen_"..lvl.."_rooms_"..room,  { input = 0, alp = 1 } );

    end;

  end;
  
end;
------------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function private.MouseEnter( name )

  --if string.find( name, "btn_" ) then

    local prefix = "spr_";

    if GetPerformanceMode() == 0 then

      prefix = "pfx_";

      if not ObjGet( prefix..name.."_focus" ) then

        prefix = "spr_";

      end;

    end;

    if not ObjGet( prefix..name.."_focus" ) then

      prefix = "";

    end;  

    cmn.SetCursor( CURSOR_HAND );
    name = prefix..name.."_focus";
    
    local alp = ObjGet( name ).alp;
    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME ), 0, 1 } );
  
  --else
  if ( not string.find( name, "btn_" ) ) then  

    cmn.SetCursor( CURSOR_LOUPE );
    name = string.sub( name, 29 );

    local not_name = common.GetObjectPrefix( name );
    
    private.PopupShow( not_name );
    
    --name = obj;

  end;
  
  cmn.PlayAudio( "sfx", "audio/aud_menter" );
  
end;
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function private.MouseLeave( name )

  cmn.SetCursor( CURSOR_DEFAULT );

  --local obj = ne_params.sender;
  --local name = "";
  
  --if string.find( name, "btn_" ) then

    local prefix = "spr_";

    if GetPerformanceMode() == 0 then

      prefix = "pfx_";

      if not ObjGet( prefix..name.."_focus" ) then

        prefix = "spr_";

      end;

    end;

    if not ObjGet( prefix..name.."_focus" ) then

      prefix = "";

    end;  
  
    name = prefix..name.."_focus";

  --else
  if ( not string.find( name, "btn_" ) ) then
    
    --name = obj;
    ObjSet( "tmr_map_popup_show", { playing = 0 } );
    private.HidePopupAnim();

  end;

  local alp = ObjGet( name ).alp;
  ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME ), 0, 0 } );
  
end;
--------------------------------------------------------------------------------
function private.PopupShow( name )
  
  --local foc = string.find( name,"_focus");
  --name = string.sub( name, 29,foc-1 );
  
  local level = private.Level();
  private.PosBeg = GetZoomCursorPos();

  local obj_name = "spr_map_root_screen_"..level.."_rooms_"..name;
  
  --local foc = string.find( name,"_focus");
  --name = string.sub( name, 29,foc-1 );
  
  --private.PosBeg[ 1 ] = ObjGet( obj_name ).pos_x;--private.PosBeg[ 1 ] - 512;
  --private.PosBeg[ 2 ] = ObjGet( obj_name ).pos_y;--private.PosBeg[ 2 ] - 384;
  private.PosBeg[ 1 ] = private.PosBeg[ 1 ] - 512;
  private.PosBeg[ 2 ] = private.PosBeg[ 2 ] - 384;  

  private.PopupHidePosX = private.PosBeg[ 1 ];
  private.PopupHidePosY = private.PosBeg[ 2 ];

  ObjSet( "obj_map_root_popup", 
  { 
    active  = 1, 
    visible = 1, 
    pos_x   = private.PosBeg[ 1 ], 
    pos_y   = private.PosBeg[ 2 ],
    scale_x = 0,
    scale_y = 0
  } );

  local task_total_w = 300;
  local task_total_h = 150;

  local pos_off_x = 70;
  local pos_off_y = 0;

  local screen_off = 0.5 * ( GetAppWidth() - 1024 );

  local screen_min_x = -512   - screen_off;
  local screen_max_x =  512   + screen_off;

--  if ( private.PosBeg[ 1 ] < ( screen_min_x + ( task_total_w ) ) ) then
--
--    private.PosEnd[ 1 ] = screen_min_x + ( 0.5 * task_total_w ) + pos_off_x;
--
--  elseif ( private.PosBeg[ 1 ] > ( screen_max_x - ( task_total_w ) ) ) then
--    
--    private.PosEnd[ 1 ] = screen_max_x - ( 0.5 * task_total_w ) - pos_off_x;
--
--  else
--
--    private.PosEnd[ 1 ] = private.PosBeg[ 1 ] + ( 0.5 * task_total_w );
--
--  end;

  private.PosEnd[ 1 ] = private.PosBeg[ 1 ] + pos_off_x;

  if ( private.PosEnd[ 1 ] > ( screen_max_x - ( task_total_w ) ) ) then

    private.PosEnd[ 1 ] = private.PosBeg[ 1 ] - pos_off_x;

  end;

  if ( private.PosBeg[ 2 ] < -384 + ( task_total_h ) ) then

    private.PosEnd[ 2 ] = private.PosBeg[ 2 ] + ( 0.5 * task_total_h ) + pos_off_y;

  elseif ( private.PosBeg[ 2 ] > 384 - ( task_total_h ) ) then

    private.PosEnd[ 2 ] = private.PosBeg[ 2 ] - ( 0.5 * task_total_h ) - pos_off_y;

  else

    private.PosEnd[ 2 ] = private.PosBeg[ 2 ] - ( 0.5 * task_total_h );
    --private.PosEnd[ 2 ] = private.PosBeg[ 2 ] + ( 0.5 * task_total_h );

  end;
  
  private.ShowPopupAnim( name );

end;
--------------------------------------------------------------------------------
function private.ShowPopupAnim( name )

  local current_alp = ObjGet( "obj_map_root_popup" ).alp;
  
  if current_alp ~= 0 then
    
    local func_end = function ()

      private.ShowPopupAnim( name );

    end;
    
    ObjSet( "tmr_map_popup_hide", 
    { 
      playing = 1,
      time = 0.4,
      endtrig = func_end
    } );

  else

    local prg      = ng_global.currentprogress; 
    local level    = ng_global.progress[ prg ].common.chapter;

    local room = "rm_"..name;  

    ObjSet( "spr_map_root_popup_back",      { res  = "assets/levels/"..level.."/"..( room or "" ).."/miniback" } );
    ObjSet( "txt_map_root_name_popup_frame", { text = "pop_"..name } );

    if prg == "ext" then
      
      ObjSet( "txt_map_root_name_popup_frame", { text = "pop_"..name.."_ce" } );
      
    end;

    ObjAnimate( "obj_map_root_popup", "alp", 0, 0, "",
    {
      0.0,  0, 0,
      0.10, 0, 0,
      0.35, 0, 1
    } );

    ObjAnimate( "obj_map_root_popup", "pos_xy", 0, 0, "",
    {
      0.0,  3, private.PosBeg[ 1 ], private.PosBeg[ 2 ],
      0.10, 3, private.PosBeg[ 1 ], private.PosBeg[ 2 ],
      0.35, 3, private.PosEnd[ 1 ], private.PosEnd[ 2 ]
    } );

    ObjAnimate( "obj_map_root_popup", "scale_xy", 0, 0, "",
    {
      0.0,  3, 0, 0,
      0.10, 3, 0, 0,
      0.35, 3, 1, 1
    } );

  end;
  
end;
------------------------------------------------------------------------------------
function private.HidePopupAnim( name )

  ObjSet( "obj_map_root", { input = 0 } );

  local current_alp     = ObjGet( "obj_map_root_popup" ).alp;
  local current_scale_x = ObjGet( "obj_map_root_popup" ).scale_x;
  local current_scale_y = ObjGet( "obj_map_root_popup" ).scale_y;

  local pos_beg = {};

  pos_beg[ 1 ] = ObjGet( "obj_map_root_popup" ).pos_x;
  pos_beg[ 2 ] = ObjGet( "obj_map_root_popup" ).pos_y;
  
  local func_end = function ()

    ObjSet( "obj_map_root", { input = 1 } );
    ObjSet( "obj_map_root_popup", { active = 0, visible = 0 } );

  end;
    
  ObjAnimate( "obj_map_root_popup", "alp", 0, 0, "",
  {
    0.0, 0, current_alp,
    0.1, 0, current_alp,
    0.35, 0, 0
  } );

  ObjAnimate( "obj_map_root_popup", "scale_xy", 0, 0, "",
  {
    0.0, 3, current_scale_x, current_scale_y,
    0.1, 3, current_scale_x, current_scale_y,
    0.35, 3, 0, 0
  } );

  ObjAnimate( "obj_map_root_popup", "pos_xy", 0, 0, func_end,
  {
    0.0,  3, pos_beg[ 1 ],          pos_beg[ 2 ],
    0.10, 3, pos_beg[ 1 ],          pos_beg[ 2 ],
    0.35, 3, private.PopupHidePosX, private.PopupHidePosY
  } );

  if current_alp == 0 then
  
    ObjSet( "obj_map_root", { input = 1 } );
    ObjSet( "obj_map_root_popup", { active = 0, visible = 0 } );

  end;

end;
--------------------------------------------------------------------------------
function private.MouseDown( name )

  local prg  = ng_global.currentprogress;
  local lvl  = ng_global.progress[ prg ].common.chapter;

  local foc = string.find( name,"_focus");
  name = string.sub( name, 29,foc-1 );
  local room = common.GetCurrentRoom();

  if ( "rm_"..name ~= room ) then
    
    --ObjSet( room, { color_r = 0, color_g = 0, color_b = 0 } );
    --ObjAnimate( room, "color_rgb", 0, 0, "",
    --{
    --  0.0, 3, 0, 0, 0,
    --  0.3, 3, 0, 0, 0,
    --  0.4, 3, 1, 1, 1,
    --} );
      cmn.GotoRoom( "rm_"..name );

  end;
  
  ObjSet( "obj_map_root", { input = 0 } );

  int_map.Close();

end;
--------------------------------------------------------------------------------
------------------------------------------------------------------------------
function private.ButtonDiaryClick()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  if not ( private.diary_loaded ) then

    private.diary_loaded = true;

    ModLoad( "assets/levels/menu/rm_diary/mod_diary" );

    rm_diary.Init();

  end;  
  
  if not cmn.IsFromMap then
    cmn.IsFromMap = true;
  end;

  ObjSet( "int_map", { input = false, visible = false } );       

  ng_global.achievements.previous_room = GetCurrentRoom();
  cmn.GotoRoom( "rm_diary", 0, true );  

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function private.ButtonAchievementsClick()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  
  if not cmn.IsFromMap then
    cmn.IsFromMap = true;
  end;

  ObjSet( "int_map", { input = false, visible = false } );      
  int.Lock(true);
  ng_global.achievements.previous_room = GetCurrentRoom();
  cmn.GotoRoom( "rm_achievements", 0, true );  

end;
------------------------------------------------------------------------------
------------------------------------------------------------------------------
function private.ButtonCollectiblesClick()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  
  if not cmn.IsFromMap then
    cmn.IsFromMap = true;
  end;

  ObjSet( "int_map", { input = false, visible = false } );      
  int.Lock(true);
  ng_global.achievements.previous_room = GetCurrentRoom();
  cmn.GotoRoom( "rm_collectibles", 0, true );  

end;
------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function public.InitTask( lvl )

  local prg = ng_global.currentprogress;

  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  --принудительный обход проверок карты 4-го уровня
  --if ng_global.progress[ prg ].common.chapter == "levelext" then
  --  return;
  --end;
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  --принудительный обход проверок карты 5-го уровня
  if ng_global.progress[ prg ].common.chapter == "levelscr" then
    return;
  end;
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  local prg = ng_global.currentprogress;

  if ( ( ng_global.gamemode < 2 ) or ( ng_global.gamemode == 3 and ng_global.gamemode_custom[ "tasks" ] ) ) then

    for index_room = 1, #ng_global.progress[ prg ].common.map.room do

      local room = ng_global.progress[ prg ].common.map.room[ index_room ];

      local hub = "map_root_screen_"..lvl.."_task";

      local size_task = #ng_global.progress[ prg ].common.map.task[ room ];

      if ( size_task > 0 ) and ObjGet( "obj_map_root_screen_"..lvl.."_unlocked_"..( room ) ) then

        local hub_obj = "obj_"..hub.."_"..( room );

        if not( ObjGet( hub_obj ) ) then

          ObjCreate( hub_obj, "obj" );
          
            if ( string.find(room,"past") ) then 
              
              ObjAttach( hub_obj, "obj_map_root_screen_"..lvl.."_task_past" );              
              
            else              
                
              ObjAttach( hub_obj, "obj_map_root_screen_"..lvl.."_task_real" );
            
            end;
            --ObjAttach( hub_obj, "obj_map_root_screen_"..lvl.."_task" );

          local hub_spr = "spr_"..hub.."_"..( room );
          ObjCreate( hub_spr, "spr" );
          ObjAttach( hub_spr, hub_obj );
          ObjSet( hub_spr, 
          { 
            res = "assets/interface/resources/map/layers/icons/task"
          } );      
    
        end;

        local position = {};
        
        position.x = ObjGet( "obj_map_root_screen_"..lvl.."_unlocked_"..( room ) ).pos_x;
        position.y = ObjGet( "obj_map_root_screen_"..lvl.."_unlocked_"..( room ) ).pos_y;
      
        ObjSet( hub_obj, 
        { 
            input = 0,
            alp = 1,
            active = 1,
            pos_x = position.x,
            pos_y = position.y
        } );
      
      else      
        
        local hub_obj = "obj_"..hub.."_"..ng_global.progress[ prg ].common.map.room[ index_room ];

        if ( ObjGet( hub_obj ) ) then

          ObjSet( hub_obj, { alp = 0, active = 0 } );

        end;

      end;

    end;

  else

    for index_room = 1, #ng_global.progress[ prg ].common.map.room do

      local hub = "map_root_screen_"..lvl.."_task";
      local hub_obj = "obj_"..hub.."_"..ng_global.progress[ prg ].common.map.room[ index_room ];

      if ( ObjGet( hub_obj ) ) then

        ObjSet( hub_obj, { alp = 0, active = 0 } );

      end;

    end;

  end;

end;
--------------------------------------------------------------------------------
function public.Screen( lvl )

  local prg = ng_global.currentprogress;

  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  --принудительный обход проверок карты 4-го уровня
  --if ng_global.progress[ prg ].common.chapter == "levelext" then
  --  return;
  --end;
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  --принудительный обход проверок карты 5-го уровня
  if ng_global.progress[ prg ].common.chapter == "levelscr" then
    return;
  end;
  --!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  private.map.show_payer = 0;

  local cur_pos      = "";--текущее положение игрока
  local bypass_added = false;
--  
  local room   = GetCurrentRoom();
  local ignore = false;

    for j = 1,#private.map.map_room[ lvl ] do

        if ( room == "rm_"..private.map.map_room[ lvl ][ j ] ) then

           cur_pos = ( private.map.map_room[ lvl ][ j ] );
           ObjSet( "spr_map_back_block", { alp = 0, input = false} );

           break;
        elseif ( room ~= "rm_"..private.map.map_room[ lvl ][ j ] and
               ( string.find(room,"ho_") or string.find(room,"mg_") ) ) then
           
            ObjSet( "spr_map_back_block", { alp = 0, input = false} );

        else 

            if ( not string.find(room,"ho_") and not string.find(room,"mg_") )  then

                ObjSet( "spr_map_back_block", { alp = 1, input = true} );

            end;

        end;

    end;
          
  --TEMP

  if ( string.find(room,"ho_hopast2") ) then
    
    ObjSet( "spr_map_back_block", { alp = 1, input = true} );
    
  end;

  --TEMP          

  for i = 1,4 do 

    ObjSet( "spr_map_back_"..i,        { alp = 0, visible = 0 } );
    ObjSet( "obj_map_root_screen_"..i, { alp = 0, visible = 0, input = 0 } );

  end;
  
  
  
  
  local is_real = true;

  if (lvl == 1) then
    
    -- проверка телепорта лвл 1    
    if ( string.find(room,"past") ) then is_real = false; end;
    
  elseif (lvl == 2) then
    
    -- проверка телепорта лвл 2    
    --if ( string.find(room,"past") or 
    --     string.find(room,"boardingschool2") or 
    --     string.find(room,"puppetroom2") or 
    --     string.find(room,"mgnotes2") or 
    --     string.find(room,"hopuppets2") ) then is_real = false; end;    

  elseif (lvl == 3) then
    
    -- проверка телепорта лвл 3
    --if ( string.find(room,"past") or 
    --     string.find(room,"hoartistic3") or   
    --     string.find(room,"hocrystal3") or                
    --    string.find(room,"boardingschool3") or 
    --    string.find(room,"puppetroom3") ) then is_real = false; end;     

  elseif (lvl == 4) then
    
    -- проверка телепорта лвл 4    
    if ( string.find(room,"past") ) then is_real = false; end;    

  end;
  
--  if ( not is_real ) then
--    
--    ObjSet( "spr_map_back_"..lvl.."_past",                { alp = 1 } );
--    ObjSet( "obj_map_root_screen_"..lvl.."_past",         { alp = 1, input = true } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_real",         { alp = 0, input = false } );   
--    ObjSet( "obj_map_root_screen_"..lvl.."_unlocked_past", { alp = 1, input = true } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_unlocked_real", { alp = 0, input = false } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_anim_past", { alp = 1 } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_anim_real", { alp = 0 } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_task_past", { alp = 1 } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_task_real", { alp = 0 } );    
--    ObjSet( "obj_map_root_screen_"..lvl.."_locked_past", { alp = 1 } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_locked_real", { alp = 0 } );        
--
--  else  
--    
--    ObjSet( "spr_map_back_"..lvl.."_past",                { alp = 0 } );    
--    ObjSet( "obj_map_root_screen_"..lvl.."_real",         { alp = 1, input = true } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_past",         { alp = 0, input = false } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_unlocked_past", { alp = 0, input = false } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_unlocked_real", { alp = 1, input = true } ); 
--    ObjSet( "obj_map_root_screen_"..lvl.."_anim_past", { alp = 0 } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_anim_real", { alp = 1 } );
--    ObjSet( "obj_map_root_screen_"..lvl.."_task_past", { alp = 0 } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_task_real", { alp = 1 } );    
--    ObjSet( "obj_map_root_screen_"..lvl.."_locked_past", { alp = 0 } );  
--    ObjSet( "obj_map_root_screen_"..lvl.."_locked_real", { alp = 1 } );        
--    
--  end;
    ObjSet( "spr_map_back_"..lvl.."_past",                { alp = 1 } );
    ObjSet( "obj_map_root_screen_"..lvl.."_past",         { alp = 1, input = true } );  
    ObjSet( "obj_map_root_screen_"..lvl.."_real",         { alp = 1, input = true } );   
    ObjSet( "obj_map_root_screen_"..lvl.."_unlocked_past", { alp = 1, input = true } );  
    ObjSet( "obj_map_root_screen_"..lvl.."_unlocked_real", { alp = 1, input = true } );  
    ObjSet( "obj_map_root_screen_"..lvl.."_anim_past", { alp = 1 } );  
    ObjSet( "obj_map_root_screen_"..lvl.."_anim_real", { alp = 1 } );  
    ObjSet( "obj_map_root_screen_"..lvl.."_task_past", { alp = 1 } );  
    ObjSet( "obj_map_root_screen_"..lvl.."_task_real", { alp = 1 } );    
    ObjSet( "obj_map_root_screen_"..lvl.."_locked_past", { alp = 1 } );  
    ObjSet( "obj_map_root_screen_"..lvl.."_locked_real", { alp = 1 } );  
  
  ObjSet( "spr_map_back_"..lvl,                         { alp = 1, visible = true } );
  ObjSet( "obj_map_root_screen_"..lvl,                  { alp = 1, visible = true, input = true } );
  ObjSet( "obj_map_root_player",                        { alp = 1, visible = true } );
    
  private.PlayerAnim();
  private.CloudsAnim();
  --private.I_AM_LEGEND();
  --private.Focus();
 --обновление тасков по открытию карты начало
---------------------------------
  for i = 1,#private.map.map_room[ lvl ] do

    local room_objname = "rm_"..private.map.map_room[ lvl ][ i ];

    if ( _G[ room_objname ].Task ) then

        _G[ room_objname ].Task(); 

    end;

  end;
--- обновление тасков по открытию карты конец

end;
----------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function private.LockRoomMap( room, value )

  local prg = ng_global.currentprogress;
  
  local screen = private.Level();
  local hub = "map_root_screen_"..screen.."_locked";

  local hub_obj = "obj_"..hub.."_"..room;

  if tonumber( value ) == 1 then

    if not ObjGet( hub_obj ) then

      local tmp_obj = "obj_map_root_screen_"..screen.."_locked";

        ObjCreate( hub_obj, "obj" );
        ObjSet( hub_obj, { alp = 1 } );
        
            if ( string.find(room,"past") ) then 
              
              ObjAttach( hub_obj, "obj_map_root_screen_"..screen.."_locked_past" );              
              
            else              
                
              ObjAttach( hub_obj, "obj_map_root_screen_"..screen.."_locked_real" );
            
            end;               

        local hub_spr = "spr_"..hub.."_"..room;
        ObjCreate( hub_spr, "spr" );
        ObjAttach( hub_spr, hub_obj );

        ObjSet( hub_spr, 
        { 
          res = "assets/interface/resources/map/layers/icons/locked"
        } );      
      local hub_spr  = "spr_map_root_screen_"..screen.."_rooms_"..room;
      ObjSet( hub_spr, { input = 0 } );

    else

      ObjSet( hub_obj, { alp = 1, visible = 1 } );

    end;

    local position = {};
    position.x = ObjGet( "obj_map_root_screen_"..screen.."_unlocked_"..room ).pos_x;
    position.y = ObjGet( "obj_map_root_screen_"..screen.."_unlocked_"..room ).pos_y;
   
    ObjSet( hub_obj,
    { 
        alp = 1,
        input = 0,
        pos_x = position.x,
        pos_y = position.y
    } );
            
    local hub_spr  = "spr_map_root_screen_"..screen.."_rooms_"..room;
    local hub_task = "obj_map_root_screen_"..screen.."_task_"..room;
    local hub_unlocked = "obj_map_root_screen_"..screen.."_unlocked_"..room;

    ObjSet( hub_spr,  { input = 0 } );

    if ObjGet( hub_task ) then

      ObjSet( hub_task, { alp = 0 } );

    end;

    if ObjGet( hub_unlocked ) then

      ObjSet( hub_unlocked, { alp = 0 } );

    end;

  else

    if ObjGet( hub_obj ) then

      ObjDelete( hub_obj );

    end;

    local hub_spr  = "spr_map_root_screen_"..screen.."_rooms_"..room;
    local hub_task = "obj_map_root_screen_"..screen.."_task_"..room;
    local hub_unlocked = "obj_map_root_screen_"..screen.."_unlocked_"..room;

    ObjSet( hub_unlocked, { alp = 1 } );
    ObjSet( hub_spr,  { input = 1 } );

    if ObjGet( hub_task ) then

      ObjSet( hub_task, { alp = 1 } );

    end;

  end;

  private.IsLockRoomMap( room );

end;
--------------------------------------------------------------------------------
function private.IsLockRoomMap( room )

  local lvl  = private.Level();

  local hub     = "map_root_screen_"..lvl.."_locked";
  local hub_obj = "obj_"..hub.."_"..room;  

  if ( ObjGet( hub_obj ) ) then 

     ObjSet( "spr_map_root_screen_"..lvl.."_rooms_"..room, { input = 0 } );
     ObjSet( "obj_map_root_screen_"..lvl.."_locked_"..room, { alp = 1 } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------
function private.Level ()

  local prg   = ng_global.currentprogress;
  local size_map = #ng_global.progress[ prg ].common.map.room;
  local level    = ng_global.progress[ prg ].common.chapter;
  local lvl      = string.sub( level, 6 );

  if ( lvl == "ext" ) then

      lvl = 4;

  end;

  return tonumber ( lvl );
  
end;
--------------------------------------------------------------------------------
function private.PlayerAnim()

  ObjAnimate( "spr_map_root_player", "scale_xy", 1, 0, "", 
  { 
    0.0, 0, 1, 1, 
    1.0, 0, 1.1, 1.1, 
    2.0, 0, 1, 1
  });
  ObjAnimate( "spr_map_root_popup_frame_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    0.8, 0, 0.3, 
    1.6, 0, 1
  });
  ObjAnimate( "obj_map_root_popup_focus", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    0.8, 0, 0.6, 
    1.6, 0, 1
  });

end;
--------------------------------------------------------------------------------
function private.CloudsAnim()
  
  if ng_global.map.clouds == nil then

    ng_global.map.clouds = 
    {
        { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false },
        { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false },
        { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false  },
        { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false },
    }

  end;
  
  local lvl = private.Level();
  ObjSet( "obj_map_root_screen_"..lvl.."_anim", { active = 1 } );      
  for i = 1,#private.map.map_room[ lvl ] do
    
    local name = private.map.map_room[ lvl ][ i ];
    --DbgTrace( "0 "..name );   
    if ( ng_global.map.clouds[ lvl ][ i ] == false and
         cmn.IsEventDone( "opn_"..name ) ) then
  
         if ( ObjGet( "anm_map_root_screen_"..lvl.."_"..name ) ) then
           
           local func_end = function ()
           
             private.CloudsAnimEnd( lvl, i )
             
           end;
           --DbgTrace( "1 ".."anm_map_root_screen_"..lvl.."_"..name );            
           AnimPlay( "anm_map_root_screen_"..lvl.."_"..name, "dinamic", func_end );
           int.Lock( true );
         
         end;
       
    elseif ( ng_global.map.clouds[ lvl ][ i ] == false and
             not cmn.IsEventDone( "opn_"..name ) ) then     
             --DbgTrace( "2 ".."anm_map_root_screen_"..lvl.."_"..name );                                
         AnimPlay( "anm_map_root_screen_"..lvl.."_"..name, "static", "" ); 
         
    elseif ( ng_global.map.clouds[ lvl ][ i ] == true ) then   
               
         --DbgTrace( "3 ".."anm_map_root_screen_"..lvl.."_"..name );                     
         ObjDelete( "anm_map_root_screen_"..lvl.."_"..name );
         
    end;
        
  end;

end;
--------------------------------------------------------------------------------
function private.CloudsAnimEnd( lvl, i )
  
  ng_global.map.clouds[ lvl ][ i ] = true;
  int.Lock( false );
  
end;
--------------------------------------------------------------------------------
function private.I_AM_LEGEND( event )

  local prefix = "spr_";

  if GetPerformanceMode() == 0 then

    prefix = "pfx_";

    if ( not ObjGet( prefix.."btn_map_button_legends_focus" ) )  then

      prefix = "spr_";

    end;

  end;

  cmn.SetCursor( CURSOR_LOUPE );
  
  local name = prefix.."btn_map_button_legends_focus";

  cmn.PlayAudio( "sfx", "audio/aud_menter" );
  
  local posy = ObjGet( "spr_map_root_frame" ).pos_y;
  local alp = ObjGet( "spr_map_root_frame" ).alp; 
  
  if ( event == "show" ) then
    

    ObjAnimate( "spr_map_root_frame", "pos_y", 0, 0, "", { 0, 0, posy, ( private.SHOW_ANIM_TIME ), 0, -270 } );
    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME ), 0, 1 } ); 
    
  else 
    
    cmn.SetCursor( CURSOR_DEFAULT ); 
    ObjAnimate( "spr_map_root_frame", "pos_y", 0, 0, "", { 0, 0, posy, ( private.HIDE_ANIM_TIME ), 0, -460 } );
    ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.MOUSE_OVER_ANIM_TIME ), 0, 0 } );   
    
  end;
  

end;
--------------------------------------------------------------------------------
function private.Focus()

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl   = string.sub( level, 6 );
  
  if ( lvl == "ext" ) then

    ObjSet( "obj_map_root_screen_4_rooms_loc_1", { input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5, pos_z = 0 });
    ObjSet( "obj_map_root_screen_4_rooms_loc_2", { input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5, pos_z = 0 });
    ObjSet( "obj_map_root_screen_4_rooms_loc_3", { input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5, pos_z = 0 });
            
      if ( not cmn.IsEventDone( "dlg_nearcar_atropos_2" ) ) then
        
        ObjSet( "obj_map_root_screen_4_rooms_loc_1", { input = true, color_r = 1, color_g = 1, color_b = 1, pos_z = 5 });
        
      elseif ( cmn.IsEventDone( "dlg_nearcar_atropos_2" ) and not cmn.IsEventDone( "dlg_kitchenext_atropos_3" ) ) then

        ObjSet( "obj_map_root_screen_4_rooms_loc_2", { input = true, color_r = 1, color_g = 1, color_b = 1, pos_z = 5 });
        ObjAttach( "obj_map_root_screen_4_locked_nearcar", "obj_map_root_screen_4_rooms_loc_1" );  
        ObjAttach( "obj_map_root_screen_4_locked_farm", "obj_map_root_screen_4_rooms_loc_1" );  
        ObjAttach( "obj_map_root_screen_4_locked_cemetery", "obj_map_root_screen_4_rooms_loc_1" );  
        ObjSet( "obj_map_root_screen_4_locked_nearcar", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_locked_farm", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_locked_cemetery", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_unlocked_loc_1", { alp = 0 });

      elseif ( cmn.IsEventDone( "dlg_kitchenext_atropos_3" ) ) then

        ObjSet( "obj_map_root_screen_4_rooms_loc_3", { input = true, color_r = 1, color_g = 1, color_b = 1, pos_z = 5 });
        ObjAttach( "obj_map_root_screen_4_locked_nearcar", "obj_map_root_screen_4_rooms_loc_1" );  
        ObjAttach( "obj_map_root_screen_4_locked_farm", "obj_map_root_screen_4_rooms_loc_1" );  
        ObjAttach( "obj_map_root_screen_4_locked_cemetery", "obj_map_root_screen_4_rooms_loc_1" );  
        ObjSet( "obj_map_root_screen_4_locked_nearcar", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_locked_farm", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_locked_cemetery", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_unlocked_loc_1", { alp = 0 });
        ObjAttach( "obj_map_root_screen_4_locked_kitchenext", "obj_map_root_screen_4_rooms_loc_2" );  
        ObjAttach( "obj_map_root_screen_4_locked_livingroomext", "obj_map_root_screen_4_rooms_loc_2" );  
        ObjAttach( "obj_map_root_screen_4_locked_basementext", "obj_map_root_screen_4_rooms_loc_2" );  
        ObjSet( "obj_map_root_screen_4_locked_kitchenext", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_locked_livingroomext", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_locked_basementext", { pos_z = 10 });
        ObjSet( "obj_map_root_screen_4_unlocked_loc_2", { alp = 0 });
        
      end;
  
  end;
    
end;
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--*****************************************************************************************
function private.BackAnim()

--  local func_end = function () private.BackAnim(); end;
--  ObjSet( "tmr_map_anim", { endtrig = func_end, time = 1/20, playing = 1 } );
--
--  local res = common.AnimForCur( private.anim_obj, private.x, private.y );
--
--  private.x = res[1];
--  private.y = res[2];

end;
