-- name=int_screensaver
--******************************************************************************************
function public.Init ( posz )

  ObjAttach( "int_screensaver", interface.originhub );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  --private.event_anim_end = {};
  private.DIRECTION =  -1;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  private.MOVE_ANIM_POS_X_BEG  =  -164;
  private.MOVE_ANIM_POS_X_END  =   158;

  private.MOVE_ANIM_TIME       =  0.6;

  private.timer = 3; --время таймера

  private.LEFT_NUMBERS  = 0;
  private.RIGHT_NUMBERS = 0;  
  private.LEFT_NUMBERS_POS = { -147, 2 };
  private.RIGHT_NUMBERS_POS = { -96, 2 };  

  private.screensaver = {};
  private.screensaver.show = false;

  ObjSet( "int_screensaver", { alp = 0, pos_z = posz } );
  ObjAttach( "tmr_int_screensaver_hide", "cmn_timers" );
  ObjSet( "spr_int_screensaver_back", { event_mdown = function () private.HideAnimScreensaver(); end } );
  private.WideScreenUpdate();

  int.AddScreensaver       = private.AddScreensaver;
  int.HideAnimScreensaver     = private.HideAnimScreensaver;
  int.GetScreensaverShow      = private.GetScreensaverShow;

end;
--******************************************************************************************
function private.WideScreenUpdate()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_screensaver" ) then

    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;

    local posx = position + ( direction * offset );
    ObjSet( "int_screensaver", { pos_x = posx } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  if ( event_id == "show" ) then

    ObjSet( "obj_int_screensaver", { input = true } );

    private.ChangeValue( event_id );

  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_screensaver", { input = false } );
    private.DeleteNumbers();

  end;
  
end;
--******************************************************************************************
function private.MouseEnterAnim ()

  ld.PlayAudio( "sfx", "audio/aud_menter" );
  SetCursor( CURSOR_HAND );

  local obj = "pfx_int_screensaver_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
--******************************************************************************************
function private.MouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "pfx_int_screensaver_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.AddScreensaverEnd( prg_event, collect_name, close )

  private.ShowAnimScreensaver();

  int.Lock( false );

  cmn.SetEventDone( prg_event );
  cmn.CallEventHandler( prg_event );

  if ( ng_global[ "screensaver" ][ collect_name ] == nil ) then

     ng_global[ "screensaver" ][ collect_name ] = {};
     ng_global[ "screensaver" ][ collect_name ].done = 1;

  end;

   --private.CheckScreensaver( prg_event );

end;
--******************************************************************************************
function private.AddScreensaver ( name_obj )

  local c_Num     = string.find( name_obj, "screensaver" );
  local name      = string.sub( name_obj, c_Num); --выделяем из имени объекта форму screensaver<num>_<num>_beg
  local prg_event = "get_"..name;

  int.Lock( true );

  cmn.SetEventDone( prg_event );  
  
  local name_timer = "tmr_"..tostring( common.GetObjectName( GetCurrentRoom() ) ).."_morphobject";

  if ( ObjGet( name_timer ) ) then

    ObjDelete( name_timer );

  end;

  if not ( ng_global.screensaver ) then

      ng_global.screensaver = {};

  end;

  if not ( ng_global.screensaver.count ) then

      ng_global.screensaver.count = 0;

  end;

  ng_global.screensaver.count = ng_global.screensaver.count + 1;

  ObjSet( name_obj, { input = false } );

  local pfx_hide_pos       = GetObjPosByObj( name_obj, InterfaceWidget_Top_Name );
  local pfx_hide_drawoff_x = ObjGet( name_obj ).drawoff_x;
  local pfx_hide_drawoff_y = ObjGet( name_obj ).drawoff_y;
  
  ObjAttach( name_obj, InterfaceWidget_Top_Name );
  ObjSet   ( name_obj, { pos_x = pfx_hide_pos[ 1 ], pos_y = pfx_hide_pos[ 2 ] });  
  
  local pfx_frame_name = "pfx_frame_"..name;
  ObjCreate( pfx_frame_name, "partsys" );
  ObjAttach( pfx_frame_name, InterfaceWidget_Top_Name );
  ObjSet( pfx_frame_name, 
  { 
    input = false, 
    pos_x = pfx_hide_pos[ 1 ], pos_y = pfx_hide_pos[ 2 ],
    res = "assets/levels/common/fx/pfx_morphing",
    active = true, visible = true, input = false    
  } );
 
  local pfx_hide_name  = "pfx_hide_"..name_obj;  
  ObjCreate( pfx_hide_name, "partsys" );
  ObjSet( pfx_hide_name,
  {
    res = "assets/interface/resources/effects_ho_hint",
    pos_x = pfx_hide_drawoff_x, pos_y = pfx_hide_drawoff_x,
    active =true, visible = true, input = false
  } );

  ObjAttach( pfx_hide_name, InterfaceWidget_Top_Name );
  ObjSet( pfx_hide_name, { blendmode = 2 } );
  
  PartSysSetMaskObj( pfx_hide_name, name_obj );  

  local func_end     = function () private.AddScreensaverEnd( prg_event, name, param_close ); ObjDelete( pfx_hide_name ) end;  
  ObjAnimate( name_obj, "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0,
    1.4, 0, 0.0
  } );

  local func_end_1 = function () ObjDelete( pfx_hide_name ); ObjDelete( name_obj ) end;
  ObjAnimate( pfx_frame_name, "alp", 0, 0, func_end_1,
  { 
    0.0, 0, 1.0,
    1.2, 0, 1.0,
    1.4, 0, 0.0
  } );

  cmn.PlayAudio( "sfx", "audio/aud_morphing" );

end;
--******************************************************************************************
function private.CheckScreensaver ( name )

  local prg = ng_global.currentprogress; 
--DbgTrace( "1private.CheckScreensaver = "..tostring( name ) );
  --if ( IsCollectorsEdition() or IsSurveyEdition() ) and prg ~= "scr" then
--DbgTrace( "2private.CheckScreensaver = "..tostring( name ) );
      --common_impl.CountGetMorphCollect();

      -- для ачивок
      
    --end;

end;
--******************************************************************************************
function private.ChangeValue ( event_id )

  local func_end         = function () private.ChangeValueEnd();  end;
  local left_name_first  = "spr_int_screensaver_numbers_left_first_"..private.LEFT_NUMBERS;
  local right_name_first = "spr_int_screensaver_numbers_right_first_"..private.RIGHT_NUMBERS;

  local left_name_second  = "spr_int_screensaver_numbers_left_second_"..private.LEFT_NUMBERS;
  local right_name_second = "spr_int_screensaver_numbers_right_second_"..private.RIGHT_NUMBERS;
  
  if ( private.RIGHT_NUMBERS == 0 ) then

      ObjCreate( left_name_second, "spr" );    

      ObjSet( left_name_second, 
      {
        alp = 0,
        pos_x = private.LEFT_NUMBERS_POS[1],
        pos_y = private.LEFT_NUMBERS_POS[2],
        pos_z =  0,
        res   = "assets/interface/resources/morphing/numbers/"..private.LEFT_NUMBERS,
        input =  false,
      } );
      
      ObjSet( left_name_first, 
      {
        alp = 0,
      } );
      
      ObjAttach( left_name_second, "obj_int_screensaver_numbers" ); 
      
      ObjAnimate( "_spr_int_screensaver_anim_roll_morf_left", "alp", 0, 0, "", 
      { 
       0.0, 3, 1,
       0.5, 3, 1 
      } );
      
      ObjAnimate( left_name_first, "pos_y", 0, 0, "", 
      { 
        0.0, 3, private.LEFT_NUMBERS_POS[2],
        0.5, 3, private.LEFT_NUMBERS_POS[2],
      } );

      ObjAnimate( left_name_second, "pos_y", 0, 0, "", 
      { 
        0.0, 3, private.LEFT_NUMBERS_POS[2],
        0.5, 3, private.LEFT_NUMBERS_POS[2],
      } );

  end;

  ObjCreate( right_name_second, "spr" );

  ObjSet( right_name_second, 
  {
    alp = 0,
    pos_x = private.RIGHT_NUMBERS_POS[1],
    pos_y = private.RIGHT_NUMBERS_POS[2],
    pos_z =  0,
    res   = "assets/interface/resources/morphing/numbers/"..private.RIGHT_NUMBERS,
    input = false,
  } );
  
  ObjSet( right_name_first, 
  {
    alp = 0,
  } );
      
  ObjAttach( right_name_second, "obj_int_screensaver_numbers" );
  
  ObjAnimate( "_spr_int_screensaver_anim_roll_morf_right", "alp", 0, 0, "", 
  { 
   0.0, 3, 1,
   0.5, 3, 1 
  } );
      
  ObjAnimate( right_name_first, "pos_y", 0, 0, func_end, 
  { 
    0.0, 3, private.RIGHT_NUMBERS_POS[2],
    0.5, 3, private.RIGHT_NUMBERS_POS[2]
  } );

  ObjAnimate( right_name_second, "pos_y", 0, 0, "", 
  { 
    0.0, 3, private.RIGHT_NUMBERS_POS[2],
    0.5, 3, private.RIGHT_NUMBERS_POS[2]
  } );

  --cmn.PlayAudio( "sfx", "audio/aud_counter" );

end;
--******************************************************************************************
function private.ChangeValueEnd ()
  
  local left_name_second  = "spr_int_screensaver_numbers_left_second_"..private.LEFT_NUMBERS;
  local right_name_second = "spr_int_screensaver_numbers_right_second_"..private.RIGHT_NUMBERS;
  
  ObjSet( "obj_int_screensaver", { input = true } );

  if ( int.GetScreensaverShow() ) then

     ObjSet( "tmr_int_screensaver_hide", { playing = false });
     local func_end   = function () private.HideAnimScreensaver(); end;
     local func_end_1 = function () ObjSet( "tmr_int_screensaver_hide", { endtrig = func_end, time = private.timer, playing = true } );  end;
     func_end_1();

  else 

  end;

  ObjSet( "int_screensaver", { alp = 1, input = true } );
  ObjSet( "obj_int_screensaver", { input = true } );
  ObjSet( "_spr_int_screensaver_anim_roll_morf_left", { alp = 0 } );
  ObjSet( "_spr_int_screensaver_anim_roll_morf_right", { alp = 0 } );
  
  ObjSet( left_name_second, { alp = 1 } );  
  ObjSet( right_name_second, { alp = 1 } ); 
  
end;



--******************************************************************************************
--******************************************************************************************
function private.ShowAnimScreensaver ()

  local obj      = "obj_int_screensaver";
  local event_id = "show";
  local tme      = private.MOVE_ANIM_TIME;
  local func_end = function () private.EventAnimEnd( event_id ) end;

  private.NumbersInit();
  private.screensaver.show = true;

  ObjStopAnimate( obj, "pos_x" ); 
  ObjSet( "int_screensaver", { alp = 1 } );
  ObjSet( "tmr_int_screensaver_hide", { endtrig = func_end, time = private.timer, playing = 0 } );

  local current_posx = private.MOVE_ANIM_POS_X_BEG;

  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 2, private.MOVE_ANIM_POS_X_BEG,
    tme, 2, private.MOVE_ANIM_POS_X_END
  } );

  cmn.PlayAudio( "sfx", "audio/aud_clue_show" );
  cmn.PlayAudio( "sfx", "audio/aud_counter" );

end;
--******************************************************************************************
--******************************************************************************************
function private.HideAnimScreensaver ()

  local obj      = "obj_int_screensaver";
  local event_id = "hide";
  local func_end = function () private.EventAnimEnd( event_id ) end;
  local tme      = private.MOVE_ANIM_TIME;
  local cur_posx = private.MOVE_ANIM_POS_X_END;

  private.screensaver.show = false;

  ObjStopAnimate( obj, "pos_x" ); 
  current_posx = ObjGet( obj ).pos_x; 
  
  ObjSet( "int_screensaver", { input = false } );

  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, cur_posx,
    tme, 1, private.MOVE_ANIM_POS_X_BEG
  } );

  ObjSet( "tmr_int_screensaver_hide", { playing = 0 } );

  cmn.PlayAudio( "sfx", "audio/aud_clue_hide" );

end;
--******************************************************************************************
--******************************************************************************************
function private.NumbersInit ()

    private.DeleteNumbers();  
  
  local value     = 0;
  local tmp_value = value;

  if ( ng_global.screensaver.count > 0 ) then

    value     = ng_global.screensaver.count;
    tmp_value = ng_global.screensaver.count - 1;

  end;

  private.LEFT_NUMBERS  = 0;
  private.RIGHT_NUMBERS = 0;
  
  local tmp_value_left  = 0;
  local tmp_value_right = 0;

  if ( value >= 9 ) then
  
      private.RIGHT_NUMBERS = math.fmod( value, 10 );
      tmp_value_right = math.fmod( tmp_value, 10 );

      private.LEFT_NUMBERS  = math.floor( value / 10 );
      tmp_value_left = math.floor( value / 10 );
    
      if ( tmp_value_right == 9 ) then

          tmp_value_left = tmp_value_left - 1;

      end;

  else

      private.RIGHT_NUMBERS = value;
      tmp_value_right       = tmp_value;

  end;

  local left_name  = "spr_int_screensaver_numbers_left_first_"..private.LEFT_NUMBERS;
  local right_name = "spr_int_screensaver_numbers_right_first_"..private.RIGHT_NUMBERS;
  
  ObjCreate( left_name, "spr" );
  ObjCreate( right_name, "spr" );

  ObjSet( left_name, 
  {
    pos_x = private.LEFT_NUMBERS_POS[1],
    pos_y = private.LEFT_NUMBERS_POS[2],
    pos_z =  2,
    res   = "assets/interface/resources/morphing/numbers/"..tmp_value_left,
    input =  false,
  } );

  ObjSet( right_name, 
  {
    pos_x = private.RIGHT_NUMBERS_POS[1],
    pos_y = private.RIGHT_NUMBERS_POS[2],
    pos_z =  2,
    res   = "assets/interface/resources/morphing/numbers/"..tmp_value_right,
    input = false,
  } );

  ObjAttach( left_name,  "obj_int_screensaver_numbers" );
  ObjAttach( right_name, "obj_int_screensaver_numbers" );

end;
--******************************************************************************************
--******************************************************************************************
function private.DeleteNumbers ()

  local left_name_first  = "spr_int_screensaver_numbers_left_first_"..private.LEFT_NUMBERS;
  local right_name_first = "spr_int_screensaver_numbers_right_first_"..private.RIGHT_NUMBERS;

  local left_name_second  = "spr_int_screensaver_numbers_left_second_"..private.LEFT_NUMBERS;
  local right_name_second = "spr_int_screensaver_numbers_right_second_"..private.RIGHT_NUMBERS;

  ObjDelete( left_name_first   );
  ObjDelete( left_name_second  );
  ObjDelete( right_name_first  );
  ObjDelete( right_name_second );

end;
--******************************************************************************************
function private.GetScreensaverShow()

  return private.screensaver.show;

end;
--******************************************************************************************

