-- name=subroom_impl
--********************************************************************************************************************
function public.Init()

  public.BLACK = "spr_subroom_black_screen";
  public.FRAME = "grd_int_frame_subroom_impl";  
  private.BLACK_ALP = 0.8;

  private.SHOW_TIME = 0.5;
  private.HIDE_TIME = 0.5;

  public.subroom_anim = false;
  
end;
--********************************************************************************************************************
function public.Show( event_id, subroom_name, pos_beg, pos_end, free_zz, ho_zz)

  local back_params = ObjGet( subroom_name );  

  public.subroom_anim = true;
  
  local trg = function() subroom.EventAnimEnd( event_id ); public.subroom_anim = false; end;
  local tme = private.SHOW_TIME;
  
  local alpha_anm_table = {0,0,0, tme,1,1};
  local pos_xy_anm_table = {0,0,pos_beg.x,pos_beg.y, tme,1,pos_end.x,pos_end.y};
  local scale_xy_anm_table = {0,0,0,0, 4*tme/5,3,1.1,1.1, tme,3,1,1 };
  
  int.Lock( true );  

  ObjAnimate( subroom_name, "alp", 0, 0, trg, alpha_anm_table );
  ObjAnimate( subroom_name, "pos_xy", 0, 0, "", pos_xy_anm_table );
  ObjAnimate( subroom_name, "scale_xy", 0, 0, "", scale_xy_anm_table );
  ObjAnimate( public.BLACK, "alp", 0, 0, "", {0,0,0, tme,0,private.BLACK_ALP} );
  
  if not ho_zz then 
    
    ObjSet( "obj_int_frame_subroom_button", { pos_x = -50, pos_y = 30 } );  

    if not free_zz then
  
      ObjSet( "grd_int_frame_subroom", { visible = true } );
      ObjSet( "grd_int_frame_subroom_impl", { visible = false } );

      ObjSet( subroom_name, {  
        inputrect_init = true,
        inputrect_x = ( - 0.5 * back_params.draw_width ),
        inputrect_w = back_params.draw_width, 
        inputrect_y = ( - 0.5 * back_params.draw_height ),
        inputrect_h = back_params.draw_height,
        croprect_init = true, 
        croprect_x = ( - 0.5 * back_params.draw_width ),
        croprect_w = back_params.draw_width, 
        croprect_y = ( - 0.5 * back_params.draw_height ),
        croprect_h = back_params.draw_height 
      } );

    else
      
      ObjSet( "grd_int_frame_subroom_impl", { visible = true } );
      ObjSet( "grd_int_frame_subroom", { visible = false } );

    end; 
    
  else 
    
    ObjSet( "grd_int_frame_subroom_impl", { visible = false } );
    ObjSet( "grd_int_frame_subroom", { visible = false } );  
    ObjSet( "obj_int_frame_subroom_button", { pos_x = ho_zz[ 1 ], pos_y = ho_zz[ 2 ] } );  
    
  end;

  interface.ShowFrameSubroom( alpha_anm_table, pos_xy_anm_table, scale_xy_anm_table );

end;
--********************************************************************************************************************
function public.Hide( event_id, subroom_name, pos_beg, pos_end )

  int.Lock( true );

  public.subroom_anim = true;

  local trg = function() subroom.EventAnimEnd( event_id ); public.subroom_anim = false; end;
  local tme = private.HIDE_TIME;

  local alpha_anm_table = {0,0,1, tme,0,0};
  local pos_xy_anm_table = {0,0,pos_end.x,pos_end.y, tme,0,pos_beg.x,pos_beg.y};
  local scale_xy_anm_table = {0,0,1,1, tme/5,3,1.1,1.1, tme,3,0,0 };

  ObjAnimate( subroom_name, "alp", 0, 0, trg, alpha_anm_table );
  ObjAnimate( subroom_name, "pos_xy", 0, 0, "", pos_xy_anm_table );
  ObjAnimate( subroom_name, "scale_xy", 0, 0, "", scale_xy_anm_table );
  ObjAnimate( public.BLACK, "alp", 0, 0, "", {0,0,private.BLACK_ALP, tme,0,0} );

  interface.HideFrameSubroom( alpha_anm_table, pos_xy_anm_table, scale_xy_anm_table );

  ---- MiniGameHide ----
  local index = string.len(subroom_name);
  local name = string.sub( subroom_name, 4 , index );

  if ( ng_global.progress["std"]["win_"..name] ~= nil ) then

    if  ( cmn.IsEventStart( "win_"..name ) ) and ( not cmn.IsEventDone( "win_"..name )  ) then

      cmn.MiniGameHide( name );

    end;

  end;


end;
--********************************************************************************************************************
