-- name=ho_hotable1
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  
  room.Define( "ho_hotable1" );
  game.relations[ "ho_hotable1" ].exitroom = "rm_house1";
  private.room_objname = "ho_hotable1";
  private.task_name = "win_hotable1";  
  private.win_hotable1 = {};

  private.ANIM_START_POS = 32;
  private.ANIM_END_POS = 150;  
  
  private.win_hotable1.array_symbols = 
  {
    { "spr_hotable1_obj_1",    "spr_hotable1_obj_5",      "spr_hotable1_obj_9" },
    { "spr_hotable1_obj_2",    "spr_hotable1_obj_6",      "spr_hotable1_obj_10" },
    { "spr_hotable1_obj_3",    "spr_hotable1_obj_7",      "spr_hotable1_obj_11" },
    { "spr_hotable1_obj_4",    "spr_hotable1_obj_8",      "spr_hotable1_obj_12" }
  }  
  
  private.rnd = math.random( 4 );
  --------------------------------------------------------------------------------------------
  -- function opn_hotable1 () end;
  --------------------------------------------------------------------------------------------
  local opn_hotable1 = function ()

  end;

  cmn.AddSubscriber( "opn_hotable1", opn_hotable1, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hotable1_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_screwdriver1", "spr_hotable1_win" );
      ObjDelete( "gho_house1_hotable1" );
    
      ObjDelete( "obj_hotable1_taskpanel" );

      ObjSet( "obj_int_taskpanel_task_1", { pos_x = 40, pos_y = 0 } );
      ObjSet( "obj_int_taskpanel_task_5", { pos_x = 40, pos_y = 22 } );
      ObjSet( "obj_int_taskpanel_task_9", { pos_x = 40, pos_y = 44 } );

      ObjSet( "obj_int_taskpanel_task_2", { pos_x = 220, pos_y = 0 } );
      ObjSet( "obj_int_taskpanel_task_6", { pos_x = 220, pos_y = 22 } );
      ObjSet( "obj_int_taskpanel_task_10", { pos_x = 220, pos_y = 4 } );

      ObjSet( "obj_int_taskpanel_task_3", { pos_x = 385, pos_y = 0 } );
      ObjSet( "obj_int_taskpanel_task_7", { pos_x = 385, pos_y = 22 } );
      ObjSet( "obj_int_taskpanel_task_11", { pos_x = 385, pos_y = 44 } );

      ObjSet( "obj_int_taskpanel_task_4", { pos_x = 550, pos_y = 0 } );
      ObjSet( "obj_int_taskpanel_task_8", { pos_x = 550, pos_y = 22 } );
      ObjSet( "obj_int_taskpanel_task_12", { pos_x = 550, pos_y = 44 } );

      ObjSet( "obj_int_taskpanel", { alp = 1 } );   
    
    else 

      for i = 1, 4 do

          if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols_slot[ i ] == 0 ) then

            for j = 1, #private.win_hotable1.array_symbols[ i ] do

              ObjSet( private.win_hotable1.array_symbols[ i ][ j ], { input = false } );

            end;

          else 

            for j = 1, #private.win_hotable1.array_symbols[ i ] do

              ObjSet( private.win_hotable1.array_symbols[ i ][ j ], { input = true } );
              
            end;


          end;

          if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols_slot[ i ] == 1 ) then

              ObjDelete( "obj_hotable1_symbol_"..i );

          end;

          if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols[ i ] == 1 ) then

              ObjDelete( "spr_hotable1_symbol_"..i );
              ObjDelete( "spr_hotable1_symbol_"..i.."_shadow" );
              ObjDelete( "spr_hotable1_symbol_"..i.."_overlap" );
              
          end;
            
      end;

    end;

  end;
  cmn.AddSubscriber( private.task_name, win_hotable1_func );
  --------------------------------------------------------------------------------------------------
  local start_hotable1_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

        common_impl.ProcessHoStart( "hotable1" );

        local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );
            ObjSet( "txt_hotable1_panel_task_"..ho_found[ i ][ "task" ], { alp = 1, fontcolor_r = 0.3, fontcolor_g = 0.3, fontcolor_b = 0.3 } );               

        end;
          
    end;

  end;
  cmn.AddSubscriber( private.task_name, start_hotable1_func, "ho_hotable1" );
  --------------------------------------------------------------------------------------------------
   private.win_hotable1.task = { "obj_1", "obj_2", "obj_3", "obj_4", 
               "obj_5", "obj_6", "obj_7", "obj_8", 
               "obj_9", "obj_10", "obj_11", "obj_12" };

  for i = 1, #private.win_hotable1.task do

    ObjSet( "spr_hotable1_"..private.win_hotable1.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hotable1.task[ i ] ); end, input = false } );

  end;

  for i = 1, 4 do

    ObjSet( "spr_hotable1_symbol_"..i, { event_mdown = function () private.GetSymbol( i ); end, event_dragdrop = function () private.UseSymbol ( i ); end } );

  end;

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hotable1" );

  end;

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hotable1" ) ) then

      cmn.SetEventDone( "opn_hotable1" );
      cmn.CallEventHandler( "opn_hotable1" );

      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols      = { 0, 0, 0, 0 };
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols_slot = { 0, 0, 0, 0 };
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbol_items = { { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 }, { 0, 0, 0 } };

  end;        

  local ho_tasks = {};

  for i = 1, #private.win_hotable1.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hotable1.task[ i ], 1, 0, { { "spr_hotable1_"..private.win_hotable1.task[ i ]  } } );
    
  end;
  
  for i = 1, 4 do

    interface.TaskPanelTaskAdd( ho_tasks, "symbol_"..i,  1, 0, { { "spr_hotable1_symbol_"..i, "obj_hotable1_symbol_"..i } } );
    
  end; 
  
  int.TaskPanelShow( ho_tasks );
  private.PanelShow();
  cmn.StopAllMus();
  cmn.StopAllEnv( "audio/level1/env/aud_ho_hotable1_env" );
  cmn.PlayAudio( "env", "audio/level1/env/aud_ho_hotable1_env", 1, 1 );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_loop_fly_"..private.rnd, 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.StopMusEnv( false );

  cmn.TutorialShow( "tutorial_ho2" );
  cmn.TutorialSetShown( "tutorial_ho2" );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  cmn.StopAudio( "sfx", "audio/level1/sfx/aud_loop_fly_"..private.rnd, 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  common_impl.PlayMusEnv();
  private.PanelHide();  
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )
  
  local postfix = "";
  
  if number then postfix = "_"..number; end;
  
  cmn.HoTaskFind( "spr_hotable1_"..name..postfix, name );
  common_impl.PassingHoCheck();

  local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

  for i = 1, #ho_found, 1 do

    if ( ho_found[ i ][ "object" ] ) then

      for j = 1, 4 do

       for k = 1, 3 do

        if ( private.win_hotable1.array_symbols[ j ][ k ] == ho_found[ i ][ "object" ] ) then

          number = j;
          ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbol_items[ j ][ k ] = 1;
          ObjSet( "txt_hotable1_panel_task_"..ho_found[ i ][ "task" ], { alp = 1, fontcolor_r = 0.3, fontcolor_g = 0.3, fontcolor_b = 0.3 } );   

          break;

        end;

       end;

      end;

    end;

  end;

end;
--*********************************************************************************************************************
function private.PanelShow ( )

  ObjSet( "obj_hotable1_taskpanel", { alp = 1 } );
  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );

  ObjAttach( "obj_hotable1_taskpanel","int_taskpanel_impl" );

  for i = 1, 4 do

      if ( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols_slot[ i ] == 0 ) then

          for j = 1, #private.win_hotable1.array_symbols[ i ] do

              ObjSet( private.win_hotable1.array_symbols[ i ][ j ], { input = false } );

          end;

      end;

  end;

end;
--*********************************************************************************************************************
function private.PanelHide ( )  
  
  ObjSet( "int_inventory_impl", { input = true } );
  ObjSet( "obj_int_taskpanel", { alp = 1 } );  
  ObjAttach( "obj_hotable1_taskpanel","ho_hotable1" );  
  
end;      
--*********************************************************************************************************************
function private.GetSymbol ( num )

  cmn.GetObjectSfx();
  ObjAttach( "spr_hotable1_symbol_"..num, "int_taskpanel_impl" );
  ObjSet( "spr_hotable1_symbol_"..num, { res = "assets/levels/level1/ho_hotable1/layers/amulets/amulet_"..num, pos_z = 5 } );
  ObjSet( "spr_hotable1_symbol_"..num.."_shadow", { alp = 0 } );

end;
--*********************************************************************************************************************
function private.UseSymbol ( num )

  local item = "spr_hotable1_symbol_"..num;
  local bool = true;
  SetCursor( CURSOR_DEFAULT );

  if ( ObjIntersect( item, "obj_hotable1_symbol_"..num ) ) then

      bool = false;
      int.Lock( true );
      parent_obj = "ho_hotable1";

      local func_end = function ()

          private.UseSymbolEnd( num, num );

      end;          

      ObjDelete( item );    
      
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_hotable1_lock"..num );

      ObjAnimate( "spr_hotable1_symbols_"..num.."_amulet", "alp", 0, 0, "", 
      { 
        0.0,  0,  0,
        0.3,  0,  1,
      } );
      ObjAnimate( "obj_hotable1_symbol_"..num, "pos_y", 0, 0, func_end, 
      { 
        0.0,  0,  private.ANIM_START_POS,
        0.3,  0,  private.ANIM_START_POS,
        0.8,  1,  private.ANIM_END_POS
      } );

  end;

  if ( bool ) then

      ObjAttach( item, "obj_hotable1_symbol" );
      ObjSet( item, { res = "assets/levels/level1/ho_hotable1/layers/amulet_"..num, pos_z = 0 } );
      ObjSet( item.."_shadow", { alp = 1 } );      
      cmn.WrongApply();

  end;

end;
--*********************************************************************************************************************
function private.UseSymbolEnd( num1, num2 )

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols[ num1 ] = 1;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols_slot[ num2 ] = 1;

  private.CompleteTask( "symbol_"..num1 );

  for i = 1,#private.win_hotable1.array_symbols[ num2 ] do

      ObjSet( private.win_hotable1.array_symbols[ num2 ][ i ], { input = true } );        
      
  end;
    
    
  int.Lock( false ); 

  ObjDelete( "obj_hotable1_symbol_"..num2 );
  ObjDelete( "spr_hotable1_symbol_"..num1.."_overlap" );  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************