-- name=ho_hovan1
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  
  room.Define( "ho_hovan1" );
  
  game.relations[ "ho_hovan1" ].exitroom = "rm_greywitchgates1";
  private.room_objname = "ho_hovan1";

  private.task_name = "win_hovan1";  
  
  private.win_hovan1 = {};
  
  private.localino = 2;

  private.InitAnim();
  --private.win_hovan1.time = { 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8 };
  private.win_hovan1.time = { 5.5, 4.5, 4.5, 7.5, 7.5, 6.5, 6.5, 8.5, 8.5, 4.5, 6.5, 7.5 };  

  --------------------------------------------------------------------------------------------
  -- function opn_hovan1 () end;
  --------------------------------------------------------------------------------------------
  local opn_hovan1 = function ()

  end;

  cmn.AddSubscriber( "opn_hovan1", opn_hovan1, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hovan1_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_gloves1", "spr_hovan1_win" );
      ObjDelete( "gho_greywitchgates1_hovan1" );
      ObjDelete( "obj_hovan1_taskpanel" );    

    end;

  end;
  cmn.AddSubscriber( "win_hovan1", win_hovan1_func );
  --------------------------------------------------------------------------------------------------
  local start_hovan1_func = function ()

    if ( cmn.IsEventStart( "win_hovan1" ) ) then

        common_impl.ProcessHoStart( "hovan1" );

        local ho_found = ng_global.progress[ "std" ][ "win_hovan1" ].found;

        for i = 1, #ho_found, 1 do

            ObjDelete( ho_found[ i ][ "object" ] );

        end;

    end;

  end;
  cmn.AddSubscriber( "win_hovan1", start_hovan1_func, "ho_hovan1" );
  --------------------------------------------------------------------------------------------------
  private.win_hovan1.task = {  "item_1", "item_2", "item_3", "item_4", 
                                    "item_5", "item_6", "item_7", "item_8", 
                                    "item_9", "item_10", "item_11", "item_12" };                              
  
  for i = 1, #private.win_hovan1.task do

    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ i ], { input = false, event_mdown = function () private.CompleteTask( private.win_hovan1.task[ i ] ); end } );

  end;  

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );  

  if ( not cmn.IsEventDone( "opn_hovan1" ) ) then

    cmn.SetEventDone( "opn_hovan1" );
    cmn.CallEventHandler( "opn_hovan1" );
    
    ng_global.progress["std"]["win_hovan1"].number = 1;
    
  end;        

  private.TaskStart();  
  
  local ho_tasks = {};
  
--  for i = 1, #private.win_hovan1.task do
--
--    interface.TaskPanelTaskAdd( ho_tasks, private.win_hovan1.task[ i ], 1, 0, { { "spr_hovan1_"..private.win_hovan1.task[ i ]  } } );
--    
--  end; 
  interface.TaskPanelTaskAdd( ho_tasks, "item_1", 1, 0, { { "spr_hovan1_item_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_2", 1, 0, { { "spr_hovan1_item_2", "spr_hovan1_item_3" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_3", 1, 0, { { "spr_hovan1_item_3", "spr_hovan1_item_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_4", 1, 0, { { "spr_hovan1_item_4", "spr_hovan1_item_5" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_5", 1, 0, { { "spr_hovan1_item_5", "spr_hovan1_item_4" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_6", 1, 0, { { "spr_hovan1_item_6", "spr_hovan1_item_7" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_7", 1, 0, { { "spr_hovan1_item_7", "spr_hovan1_item_6" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_8", 1, 0, { { "spr_hovan1_item_8", "spr_hovan1_item_9" } } );  
  interface.TaskPanelTaskAdd( ho_tasks, "item_9", 1, 0, { { "spr_hovan1_item_9", "spr_hovan1_item_8" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_10", 1, 0, { { "spr_hovan1_item_10" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_11", 1, 0, { { "spr_hovan1_item_11" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_12", 1, 0, { { "spr_hovan1_item_12" } } );  
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hovan1" );

  end;  
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  cmn.StopAllMus();
  common_impl.StopMusEnv( false );

  cmn.StopAllEnv( "audio/level1/env/aud_ho_hovan1_env" );
  cmn.PlayAudio( "env", "audio/level1/env/aud_ho_hovan1_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  private.TimerStart();

  cmn.TutorialShow( "tutorial_ho1" );
  cmn.TutorialSetShown( "tutorial_ho1" );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  cmn.StopAllVoc();  

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";

  if ( number ) then

     postfix = "_1"

  end;

  cmn.HoTaskFind( "spr_hovan1_"..name..postfix, name..postfix );
  common_impl.PassingHoCheck();
  
  if ( ng_global.progress["std"]["win_hovan1"].number == 1 or 
       ng_global.progress["std"]["win_hovan1"].number == 3 or 
       ng_global.progress["std"]["win_hovan1"].number == 5 or 
       ng_global.progress["std"]["win_hovan1"].number == 7 ) then

    ng_global.progress["std"]["win_hovan1"].number = ng_global.progress["std"]["win_hovan1"].number + 1;         
    private.Task();
    
  elseif ( ng_global.progress["std"]["win_hovan1"].number == 9 or 
           ng_global.progress["std"]["win_hovan1"].number == 10 or 
           ng_global.progress["std"]["win_hovan1"].number == 11 ) then
    
    ng_global.progress["std"]["win_hovan1"].number = ng_global.progress["std"]["win_hovan1"].number + 1;
    private.TaskDouble();

  else
    
    ObjSet( "txt_hovan1_taskpanel", { text = "tsk_hovan1_"..private.win_hovan1.task[ ng_global.progress["std"]["win_hovan1"].number ], param0 = private.localino-1 } );    
    ng_global.progress["std"]["win_hovan1"].number = ng_global.progress["std"]["win_hovan1"].number + 1;      
    
  end;
  


end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hovan1_taskpanel" , "int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.TaskStart()
  
  local number = ng_global.progress["std"]["win_hovan1"].number;
  ObjSet( "txt_hovan1_taskpanel", { alp = 1, text = "tsk_hovan1_"..private.win_hovan1.task[ ng_global.progress["std"]["win_hovan1"].number ], param0 = private.localino } );
  ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number ], { input = true } );
  
  if ( number == 2 or 
       number == 4 or 
       number == 6 or 
       number == 8 ) then

    ObjSet( "txt_hovan1_taskpanel", { text = "tsk_hovan1_"..private.win_hovan1.task[ number ], param0 = private.localino } );
    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number ], { input = true } );
    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number+1 ], { input = true } );           
    
  elseif ( number == 1 or 
           number == 10 or 
           number == 11 or 
           number == 12 ) then
    
    ObjSet( "txt_hovan1_taskpanel", { text = "tsk_hovan1_"..private.win_hovan1.task[ number ] } );
    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number ], { input = true } );

  else
    
    ObjSet( "txt_hovan1_taskpanel", { text = "tsk_hovan1_"..private.win_hovan1.task[ number-1 ], param0 = private.localino-1 } );     
    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number ], { input = true } );
    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number-1 ], { input = true } );     
    
  end;  

end;
--*********************************************************************************************************************
function private.Task ()
  
  local func_end = function ()

    local number = ng_global.progress["std"]["win_hovan1"].number;
    ObjSet( "txt_hovan1_taskpanel", { text = "tsk_hovan1_"..private.win_hovan1.task[ number ], param0 = private.localino } );
    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number ], { input = true } );
    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number+1 ], { input = true } );    

  end;

  local func_end2 = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "txt_hovan1_taskpanel", "alp", 0, 0, func_end2,
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
    0.4, 0, 0,
    0.7, 0, 1

  } );

  ObjAnimate( "ho_hovan1", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 1
  } );

  private.TimerDone();
  private.TimerStart();

end;
--*********************************************************************************************************************
function private.TaskDouble ()
  
  local func_end = function ()

    local number = ng_global.progress["std"]["win_hovan1"].number;
    ObjSet( "txt_hovan1_taskpanel", { text = "tsk_hovan1_"..private.win_hovan1.task[ number ] } );
    ObjSet( "spr_hovan1_"..private.win_hovan1.task[ number ], { input = true } );

  end;

  local func_end2 = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "txt_hovan1_taskpanel", "alp", 0, 0, func_end2,
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
    0.4, 0, 0,
    0.7, 0, 1

  } );

  ObjAnimate( "ho_hovan1", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1, 
    0.3, 0, 1
  } );

  private.TimerDone();
  private.TimerStart();

end;
--*********************************************************************************************************************
function private.TimerStart ()

  local number = ng_global.progress["std"]["win_hovan1"].number;
  
  if ( ng_global.progress["std"]["win_hovan1"].number == 3 or 
     ng_global.progress["std"]["win_hovan1"].number == 5 or 
     ng_global.progress["std"]["win_hovan1"].number == 7 or 
     ng_global.progress["std"]["win_hovan1"].number == 9 ) then
     
     number = ng_global.progress["std"]["win_hovan1"].number - 1;
     
   end;

  ObjSet( "tmr_hovan1_voice", 
    { 
    playing = true, 
    time = private.win_hovan1.time[ number ],
    endtrig = private.TimerDone
    } );

  ObjSet( "tmr_hovan1_button", 
    { 
    playing = true, 
    time = private.win_hovan1.time[ number ],
    endtrig = function()   cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_unclick_volume" ); end
    } );

  cmn.StopAllVoc();
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_hovan1_"..number.."_voc", 0 ); 

  ObjSet( "obj_hovan1_button", { input = false } );
  
  ObjSet( "anm_hovan1_recorder", { alp = 0, active = false, frame = 0 } ); 
  ObjSet( "anm_hovan1_button_add", { alp = 0, active = false, frame = 0 } );
  ObjSet( "anm_hovan1_recorder_start", { alp = 1, active = true, frame = 0 } );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_volume" );
  AnimPlay( "anm_hovan1_recorder_start", "DoAnim", 
    function () 
      ObjSet( "anm_hovan1_recorder_start", { alp = 0, active = false, frame = 0 } );      
      ObjSet( "anm_hovan1_recorder", { alp = 1, active = true } );
     
    end );

end;
--*********************************************************************************************************************
function private.TimerDone ()

  local func_end = function ()

    private.TimerStart();

  end;

  cmn.StopAllVoc();

  ObjSet( "obj_hovan1_button", { input = true, event_mdown = func_end } );
  ObjSet( "anm_hovan1_recorder", { alp = 0, active = false } );
  ObjSet( "anm_hovan1_recorder_start", { alp = 1, active = true, frame = 0 } );
  ObjSet( "anm_hovan1_button_add", { alp = 1, active = true, frame = 0 } );

end;
--*********************************************************************************************************************
function private.InitAnim ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************