-- name=mg_mgtime1
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgtime1";
  game.relations[ "mg_mgtime1" ].exitroom = "rm_house1";

  private.Init();
  private.Animations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgtime1 = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgtime1", update_game_mode_mgtime1, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mgtime1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgtime1" ] =
  {
    type = "click",
    get_obj = "spr_mgtime1_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgtime1 = function ()

    if ( cmn.IsEventDone( "win_mgtime1" ) ) then

      --int.DeleteTaskMap( "rm_", "win_mgtime1" );
      ObjDelete( "obj_mgtime1_buttons" );
      ObjDelete( "obj_mgtime1_way" );

    elseif ( cmn.IsEventStart( "win_mgtime1" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgtime1", win_mgtime1, private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mgtime1" ) ) then

    cmn.ShowBbt( "bbt_house1_mgtime1" );
    private.Start();

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventDone( "win_mgtime1" ) ) then

    cmn.MiniGameShow( "mgtime1" );
    common_impl.PassingMgStart( "mgtime1" );

  end;

  cmn.StopAllEnv( "audio/level1/env/aud_mg_mgtime1_env" );
  cmn.PlayAudio( "env", "audio/level1/env/aud_mg_mgtime1_env", 1 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "mgtime1" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock  = { 3, 1, 2, 5, 4, 6 };
  ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].button = nil;

  for i = 1, private.locks_count do

    ObjSet( "obj_mgtime1_lock_"..ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ i ], { pos_x = private.lock_pos[ i ][ 1 ], pos_y = private.lock_pos[ i ][ 2 ] } );
    ObjSet( "spr_mgtime1_lock_"..i.."_light", { alp = 0 } );

  end;

  private.SetInput();

end;
--*********************************************************************************************************************
function public.Skip ()

  private.WinAnim();

end;
--*********************************************************************************************************************
function public.Load ()

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function private.Init ()

  private.locks_count   = 6;
  private.chains_count  = 4;
  private.buttons_count = 4;

  private.lock_pos = { { 628, 146 }, { 737, 334 }, { 626, 518 }, { 411, 517 }, { 303, 330 }, { 412, 151 } };
  private.chain = { { 1, 4, 3, 2, 1 }, { 3, 6, 1, 2, 3 }, { 4, 1, 6, 5, 4 }, { 6, 3, 4, 5, 6 } };
  private.button = { 1, 3, 4, 6 };
  private.button_input = { 3, 4, 1, 2 };

  for b = 1, private.buttons_count do

    ObjSet( "obj_mgtime1_button_"..b,
    {
      event_mdown  = function () private.ButtonClick( b ) end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock  = { 3, 1, 2, 5, 4, 6 };
  ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].button = nil;

end;
--*********************************************************************************************************************
function private.Load ()

  for i = 1, private.locks_count do

    local lock = ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ i ];

    ObjSet( "obj_mgtime1_lock_"..lock, { pos_x = private.lock_pos[ i ][ 1 ], pos_y = private.lock_pos[ i ][ 2 ] } );

  end;

  local button = ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].button;

  if ( button ) then

    ObjSet( "spr_mgtime1_lock_"..ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ button ].."_light", { alp = 1 } );

    private.SetInput( button );

  end;

end;
--*********************************************************************************************************************
function private.WinAnim()

  int.Lock( true );

  local func_end = function ()

    private.Win();
    int.Lock( false );

  end;

  AnimPlay( "anm_mgtime1_win", "DoAnim", func_end );

  ObjAnimate( "obj_mgtime1_way", "alp", 0, 0, "",
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgtime1_win" );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgtime1" );
  cmn.CallEventHandler( "win_mgtime1" );
  common_impl.PassingMgWin( "mgtime1" );
  cmn.GotoRoom( "rm_house1" );

end;
--*********************************************************************************************************************
function private.IsWin ()

  for i = 1, private.locks_count do

    if ( private.locks[ i ] ~= i ) then

      private.SaveProgress();

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.ButtonClick ( idx )

  local current = ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].button;

  int.Lock( true );

  if ( current ) then

    if ( current == idx ) then

      local func_end = function ()

        int.Lock( false );

        ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].button = nil;

        private.SetInput();

      end;

      ObjAnimate( "spr_mgtime1_lock_"..ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, func_end, 
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

    else

      private.locks = {};

      for i = 1, private.locks_count do

        private.locks[ i ] = ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ i ];

      end;

      local func_end = function ()

        int.Lock( false );
        private.SetInput();

        for c = 1, private.chains_count do

          private.locks[ private.chain[ current ][ c + 1 ] ] = ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ private.chain[ current ][ c ] ];

        end;

        if ( private.IsWin() ) then

          private.WinAnim();

        end;

      end;

      ObjAnimate( "spr_mgtime1_lock_"..ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, "", 
      {
        0.0, 3, 0,
        0.3, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
      } );

      ObjAnimate( "spr_mgtime1_lock_"..ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ private.button[ current ] ].."_light", "alp", 0, 0, func_end,
      {
        0.0, 3, 1,
        0.5, 3, 1,
        0.8, 3, 0,
        1.0, 3, 0,
      } );

      local func_end_aud = function ()

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgtime1_change" );

      end;

      local chain = private.chain[ current ];

      ObjSet( "tmr_mgtime1_anim", { playing = 1, time = 0.5, endtrig = func_end_aud } );

      for c = 1, private.chains_count do

        local pos_1 = private.lock_pos[ chain[ c ] ];
        local pos_2 = private.lock_pos[ chain[ c + 1 ] ];

        ObjAnimate( "obj_mgtime1_lock_"..private.locks[ chain[ c ] ], "pos_xy", 0, 0, "", 
        {
          0.0, 3, pos_1[ 1 ], pos_1[ 2 ],
          0.5, 3, pos_1[ 1 ], pos_1[ 2 ],
          1.0, 3, pos_2[ 1 ], pos_2[ 2 ],
        } );

      end;

    end;

  else

    private.SetInput( idx );

    local func_end = function ()

      int.Lock( false );

      ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].button = idx;

    end;

    ObjAnimate( "spr_mgtime1_lock_"..ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ private.button[ idx ] ].."_light", "alp", 0, 0, func_end, 
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

  end;

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgtime1_click" );

end;
--*********************************************************************************************************************
function private.SaveProgress ()

  for i = 1, private.locks_count do

    ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].lock[ i ] = private.locks[ i ];

  end;

  ng_global.progress[ private.currentprogress ][ "win_mgtime1" ].button = nil;

end;
--*********************************************************************************************************************
function private.SetInput ( idx )

  if ( not idx ) then

    for b = 1, private.buttons_count do

      ObjSet( "obj_mgtime1_button_"..b, { input = true } );

    end;

  else

    for b = 1, private.buttons_count do

      ObjSet( "obj_mgtime1_button_"..b, { input = false } );

    end;

    ObjSet( "obj_mgtime1_button_"..idx,                         { input = true } );
    ObjSet( "obj_mgtime1_button_"..private.button_input[ idx ], { input = true } );

  end;

end;
--*********************************************************************************************************************
function private.Animations ()

  for b = 1, 6 do

    local frame = math.random( 1, 720 );

    ObjSet( "anm_mgtime1_lock_"..b.."_arrows", { frame = frame, animfunc = "DoAnim", playing = true } );

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************