-- name=level1
--*********************************************************************************************************************
function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );
  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );
  int.WidgetAdd( InterfaceWidget_BtnHint, 9 );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );
  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );
  int.WidgetAdd( InterfaceWidget_Effects, 24 );
  int.WidgetAdd( InterfaceWidget_BtnMap, 11 );
  int.WidgetAdd( InterfaceWidget_DialogHo );
  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );
  int.WidgetAdd( InterfaceWidget_Popup, 31 );
  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog, 22 );
  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );
  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );
  int.WidgetAdd( InterfaceWidget_Tutorial, 25 );
  int.WidgetAdd( InterfaceWidget_Map, 24 );

  int.ButtonLockAdd();
  int.PanelNotificationAdd();
  int.DeployInvAdd( 9 );
  int.DialogHintAdd( 10 );
  
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 ); 
  int.InitLoupe( 20 );

  --
  private.Init();
  ModLoad( "assets/levels/level1/mod_level1_inv" );
  level1_inv.Init();
  --

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.AchievementsAdd( 10 );
    int.MorphingAdd( 10 );
    int.CollectiblesAdd( 20 );
    int.Collectibles2Add( 22 );
    int.ScreensaverAdd(11);    

  end;
  if ( IsCollectorsEdition() ) then

    int.WidgetAdd( InterfaceWidget_BtnGuide, 8 );    

  end;  

  common.LevelLoad( "level1", "std", "rm_greywitchgates1", param, private.menu_moduls );
  
  common_impl.PlayMusEnv();

  private.TutorialSetParams();
  interface.KeyUpdate();

  local collectibles = 
  {
     "get_collect_1_1"
    ,"get_collect_1_2"
    ,"get_collect_1_3"
    ,"get_collect_1_4"
  };
  local collect_morph = 
  {
     "get_morphobject_1_1"
    ,"get_morphobject_1_2"
    ,"get_morphobject_1_3"
    ,"get_morphobject_1_4"
    ,"get_morphobject_1_5"
    ,"get_morphobject_1_6"
    ,"get_morphobject_1_7"
  };   
  local screen_s = 
  {
     "screensaver_1_1"
    ,"screensaver_1_2"
    ,"screensaver_1_3"
    ,"screensaver_1_4"
    ,"screensaver_1_5"
    ,"screensaver_1_6"
    ,"screensaver_1_7"
    ,"screensaver_1_8"
    ,"screensaver_1_9"
    ,"screensaver_1_10"
    ,"screensaver_1_11" 
    ,"screensaver_1_12"        
  };   
  
  if ( not IsCollectorsEdition() and not IsSurveyEdition() ) then

    ObjSet( "btn_map_button_diary", { pos_x = 10 } );
    ObjSet( "btn_map_button_collectibles", { visible = 0, active = 0, input = 0  } );
    ObjSet( "btn_map_button_achievements", { visible = 0, active = 0, input = 0  } );        

    for i = 1, #collectibles do

      cmn.SetEventDone( collectibles[ i ] );
      cmn.CallEventHandler( collectibles[ i ] );

    end;
    for i = 1, #collect_morph do

      cmn.SetEventDone( collect_morph[ i ] );
      cmn.CallEventHandler( collect_morph[ i ] );

    end;
    for i = 1, #screen_s do

      cmn.SetEventDone( "get_"..screen_s[ i ] );
      cmn.CallEventHandler( "get_"..screen_s[ i ] );

    end;    

  else
    
    for i = 1, #collectibles do

      if ( ng_global.collect[ collectibles[ i ] ] ~= nil ) then
          if ( ng_global.collect[ collectibles[ i ] ].done == 1 ) then

            cmn.SetEventDone( "get_"..collectibles[ i ] );
            cmn.CallEventHandler( "get_"..collectibles[ i ] );

          end;
      end;

    end;   
    for i = 1, #collect_morph do

      if ( ng_global.morphings[ collect_morph[ i ] ] ~= nil ) then
          if ( ng_global.morphings[ collect_morph[ i ] ].done == 1 ) then

            cmn.SetEventDone( collect_morph[ i ] );
            cmn.CallEventHandler( collect_morph[ i ] );

          end;
      end;

    end;    
    for i = 1, #screen_s do

      if ( ng_global.screensaver[ screen_s[ i ] ] ~= nil ) then
          if ( ng_global.screensaver[ screen_s[ i ] ].done == 1 ) then

            cmn.SetEventDone( "get_"..screen_s[ i ] );
            cmn.CallEventHandler( "get_"..screen_s[ i ] );

          end;
      end;

    end;       
    
  end;

end;
--*********************************************************************************************************************
function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_greywitchgates1"
    ,"ho_hovan1"
    ,"rm_ruinedsquare1"
    ,"mg_mgassault1"
    ,"rm_alley1"
    ,"rm_house1"
    ,"ho_hotable1"
    ,"rm_secondfloor1"
    ,"ho_howardrobe1"
    ,"rm_square1"
    ,"mg_mgtime1"
    ,"rm_cellar1"
    ,"ho_hosafe1"
    ,"mg_mgdocument1"
    ,"rm_demo"    
  };

  game.progress_names =
  {
   "beg_level1"
  ,"opn_greywitchgates1"
  ,"get_bagamulet1_1"
  ,"get_bagamulet1_2"
  ,"get_ladybag1"
  ,"use_bagamulet1"
  ,"get_nuts1"
  ,"clk_note1"
  ,"get_gatesamulet1_1"
  ,"use_nuts1"
  ,"get_keys1"
  ,"use_keys1"
  ,"clk_keys1"
  ,"win_hovan1" --""get_gloves1"
  ,"use_gloves1"
  ,"get_richardskull1"
  ,"dlg_greywitchgates1_richard1_1"
  ,"get_gatesamulet1_2"
  ,"use_gatesamulet1"
  ,"win_gates1"

  ,"opn_ruinedsquare1"
  ,"get_letters1_1"
  ,"get_handle1"
  ,"use_handle1"
  ,"get_sickle1"
  ,"use_sickle1_1"
  ,"get_spade1"
  ,"get_crossamulet1"
  ,"use_sickle1_2"
  ,"use_crossamulet1"
  ,"get_horseamulet1_1"
  ,"get_letters1_2"
  ,"get_ingredients1_1"
  ,"use_spade1"
  ,"get_ingredients1_2"
  ,"get_letters1_3"
  ,"use_letters1"
  ,"win_statue1"
  ,"get_file1"
  ,"use_file1_1"
  ,"get_ingredients1_3"
  ,"use_file1_2"
  ,"get_ingredients1_4"
  ,"use_ingredients1_1"
  ,"use_ingredients1_2"
  ,"use_ingredients1_3"
  ,"use_ingredients1_4"
  ,"dlg_ruinedsquare1_richard1_2"
  ,"get_mentalmagnifier1"
  ,"get_soulphial1"
  ,"use_mentalmagnifier1_1"
  ,"get_auratrace1_1"
  ,"use_mentalmagnifier1_2"
  ,"get_auratrace1_2"
  ,"use_mentalmagnifier1_3"
  ,"get_auratrace1_3"
  ,"use_mentalmagnifier1_4"
  ,"get_auratrace1_4"
  ,"use_mentalmagnifier1_5"
  ,"get_auratrace1_5"
  ,"use_mentalmagnifier1_6"
  ,"get_auratrace1_6"
  ,"use_mentalmagnifier1_7"
  ,"get_auratrace1_7"
  ,"use_auratrace1"
  ,"win_mgassault1"

  ,"opn_alley1"
  ,"get_crowbar1"
  ,"use_crowbar1"
  ,"get_pliers1"
  ,"get_screws1"
  ,"use_cutters1" --"use_pliers1_2"
  ,"get_wire1"
  ,"use_pliers1"
  ,"get_hook1"
  ,"use_hook1_1"
  ,"win_window1"

  ,"opn_house1"
  ,"get_broom1"
  ,"use_broom1"
  ,"win_hotable1" --"get_screwdriver1"
  ,"use_screwdriver1_1"
  ,"get_horseamulet1_2"
  ,"get_horseamulet1_3"
  ,"get_catamulet1_2"
  ,"use_horseamulet1"
  ,"get_sparehandle1"
  ,"use_sparehandle1"
  ,"use_screws1"
  ,"use_screwdriver1_2"

  ,"opn_secondfloor1"
  ,"dlg_secondfloor1_richard1_3"
  ,"get_figurine1_1"
  ,"get_matches1"
  ,"get_glue1"
  ,"get_coin1_1"
  ,"get_rose1_1"
  ,"get_emptyflask1"
  ,"get_rose1_2"
  ,"get_pattern1"
  ,"use_rose1"
  ,"get_powder1"
  ,"use_matches1"
  ,"get_heart1_2"
  ,"get_water1"
  ,"use_water1"
  ,"use_powder1"
  ,"get_plantreviver1"
  ,"use_plantreviver1"
  ,"get_toyclothes1_1"
  ,"use_pattern1"
  ,"get_toyclothes1_2"
  ,"use_glue1"
  ,"clk_leaf1"
  ,"get_figurine1_2"
  ,"use_figurine1"
  ,"get_toyclothes1_3"
  ,"use_toyclothes1"
  ,"win_wardrobe1"
  ,"win_howardrobe1" --"get_clothes1"
  ,"del_clothes1"

  ,"opn_square1"
  ,"dlg_square1_guard1_1"
  ,"get_leaflet1"
  ,"use_leaflet1"
  ,"dlg_square1_abigail1_1"
  ,"get_coin1_2"
  ,"use_coin1"
  ,"get_fish1"
  ,"use_fish1"
  ,"get_kitten1"
  ,"use_kitten1"
  ,"get_catamulet1_1"
  ,"use_catamulet1"
  ,"get_thread1"
  ,"clk_hook1_2"
  ,"use_hook1_2"
  ,"get_threadhook1"
  ,"use_threadhook1"
  ,"get_amulet1"
  ,"use_amulet1"
  ,"dlg_square1_abigail1_2"
  ,"get_windupkey1"
  ,"get_letter1"
  ,"use_windupkey1"
  ,"win_mgtime1"
  ,"see_clock1"

  ,"opn_cellar1"
  ,"dlg_cellar1_richard1_4"
  ,"get_parchmentamulet1_3"
  ,"get_finefile1"
  ,"get_blank1"
  ,"get_emptyoilcan1"
  ,"get_keypicture1"
  ,"use_blank1"
  ,"use_finefile1_1"
  ,"get_key1"
  ,"use_key1"
  ,"get_parchmentamulet1_1"
  ,"use_finefile1_2"
  ,"get_parchmentamulet1_2"
  ,"use_parchmentamulet1"
  ,"get_feather1"
  ,"get_list1"
  ,"use_feather1"
  ,"get_corkscrew1"
  ,"get_heart1_1"
  ,"use_corkscrew1"
  ,"use_emptyoilcan1"
  ,"get_oil1"
  ,"use_heart1"
  ,"get_portrait1_1"
  ,"get_pin1"
  ,"use_oil1"
  ,"use_pin1"
  ,"get_portrait1_2"
  ,"use_portrait1"
  ,"win_safe1"
  ,"clk_safe1_handle"
  ,"win_hosafe1" --"get_money1"
  ,"use_list1"
  ,"use_money1"
  ,"get_reagents1"  
  ,"use_reagents1"
  ,"use_letter1"
  ,"win_mgdocument1"
  ,"get_fakedocument1"
  ,"use_fakedocument1"

  ,"opn_hosafe1"
  ,"opn_hotable1"
  ,"opn_hovan1"
  ,"opn_howardrobe1"

  ,"opn_mgassault1"
  ,"opn_mgdocument1"
  ,"opn_mgtime1"


  ,"get_morphobject_1_1"
  ,"get_morphobject_1_2"
  ,"get_morphobject_1_3"
  ,"get_morphobject_1_4" 
  ,"get_morphobject_1_5" 
  ,"get_morphobject_1_6"
  ,"get_morphobject_1_7"

  ,"get_collect_1_1"
  ,"get_collect_1_2"
  ,"get_collect_1_3"
  ,"get_collect_1_4"
  
  ,"get_screensaver_1_1"
  ,"get_screensaver_1_2"
  ,"get_screensaver_1_3"
  ,"get_screensaver_1_4"
  ,"get_screensaver_1_5"
  ,"get_screensaver_1_6"
  ,"get_screensaver_1_7"
  ,"get_screensaver_1_8"
  ,"get_screensaver_1_9"
  ,"get_screensaver_1_10"
  ,"get_screensaver_1_11" 
  ,"get_screensaver_1_12"    
  };

  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {

      "rm_collectibles",
      "rm_achievements",
    };

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;
--*********************************************************************************************************************
function private.TutorialSetParams()

  if not ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ] then

    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ] = {};
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].start = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state = {};
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.no = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.currentpage = "tutorial_start";
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].func = function() end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );

    end;

    ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_start" ]  = { shown = 0, noskip = true,  posx = 512, posy = 384, input = true,  arrows = {} },       -- Показать туториал?

      [ "tutorial_page_1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 840, pos_y = 500, ang = 3.14 }
                                                                            } },                                        -- Открытие ЗЗ
      [ "tutorial_page_2" ]  = { shown = 0, noskip = false, posx = 512, posy = 170, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "spr_bushes1_ladybag1" }
                                                                            } },                                        -- Подбор предмета
      [ "tutorial_page_3" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "spr_int_inventory" }
                                                                              --{ pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_ladybag" }
                                                                            } },                                        -- Инвентарь, cложный инвентарный
      [ "tutorial_page_4" ]  = { shown = 0, noskip = false, posx = 512, posy = 150, input = false, arrows = {
                                                                              --{ pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_ladybag" }
                                                                            } },                                        -- Сложный инвентарный
      [ "tutorial_page_5" ]  = { shown = 0, noskip = false, posx = 512, posy = 150, input = false, arrows = {
                                                                              { pos_x = 20, pos_y = -80, ang = 3.14, target = "gzz_greywitchgates1_van1" },
                                                                              { pos_x = -80, pos_y = 30, ang = -1.57, target = "gzz_greywitchgates1_gates1" }
                                                                            } },                                        -- Подбор предметов
      [ "tutorial_page_6" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_ladybag1" },
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_bagamulet1" },
                                                                            } },                                        -- применение предмета
      [ "tutorial_page_6_1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_bagamulet1" },
                                                                            } },                                        -- применение предмета                                                                            
      [ "tutorial_page_7" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 60, pos_y = 0, ang = 1.57, target = "gho_greywitchgates1_hovan1" },
                                                                            } },                                        -- переход в ХО
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 400, posy = 200, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = 80, ang = 0.00, target = "grm_greywitchgates1_ruinedsquare1" }
                                                                            } },                                        -- Переход в локацию
      [ "tutorial_ho1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО с войсами
      [ "tutorial_ho2" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО обычное
      [ "tutorial_ho3" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО с силуэтами
      [ "tutorial_ho4" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО парами
      [ "tutorial_minigame" ]  = { shown = 0, noskip = false, posx = 512, posy = 330, input = false, arrows = { 
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_info" },
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_reset" },
                                                                              { pos_x = 100, pos_y = -50, ang = -4,     target = "int_button_skip_impl" }
                                                                            } },                                        -- Кнопка Инфо в МГ
      [ "tutorial_map_1" ] = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = -60, pos_y = -100, ang = 3.925, target = "int_button_map_impl" }
                                                                            } },                                        -- Карта
      [ "tutorial_map_2" ] = { shown = 0, noskip = false, posx = 600, posy = 200, input = false, arrows = {
                                                                              { pos_x = 300, pos_y = 320, ang = 2.355 }
                                                                            } },                                        -- Переход в локацию по карте
      [ "tutorial_achievements" ] = { shown = 0, noskip = false, posx = 512, posy = 280, input = false, arrows = {
                                                                              --{ pos_x = 80, pos_y = 60, ang = 0, target = "obj_int_achievements" },
                                                                            } },                                        -- Ачивки
      [ "tutorial_collectibles" ] = { shown = 0, noskip = false, posx = 512, posy = 280, input = false, arrows = {
                                                                              --{ pos_x = 80, pos_y = 60, ang = 0, target = "obj_int_collectibles" },
                                                                            } },                                        -- Коллектиблз
      [ "tutorial_loupe" ] = { shown = 0, noskip = true,  posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_mentalmagnifier1" },
                                                                            } },                                      -- Поиск линзой
      [ "tutorial_hint" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 100, pos_y = -50, ang = -4, target = "obj_int_button_hint" },
                                                                            } },                                      -- Хинт
      --[ "tutorial_page_20" ] = { shown = 0, noskip = true,  posx = 512, posy = 280, input = false, arrows = {
      --                                                                        { pos_x = 0, pos_y = -80, ang = 3.14, target = "obj_int_button_ability" }
      --                                                                        } },                                    -- Абилка

    };

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************