-- name=rm_alley1
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_alley1";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_animals1", "room_hub" );
  ObjAttach( "zz_boxes1",   "room_hub" );
  ObjAttach( "zz_window1",  "room_hub" );

  ObjMultiSet(
  {
    { "spr_alley1_crowbar1",             { event_mdown = private.get_crowbar1 } },
    { "spr_animals1_catamulet1_1",       { event_mdown = private.get_catamulet1_1 } },
    { "spr_animals1_parchmentamulet1_2", { event_mdown = private.get_parchmentamulet1_2 } },
    { "spr_boxes1_pliers1",              { event_mdown = private.get_pliers1 } },
    { "spr_boxes1_screws1",              { event_mdown = private.get_screws1 } },
    { "spr_boxes1_oil1",                 { event_mdown = private.get_oil1 } },
    { "spr_window1_wire1",               { event_mdown = private.get_wire1 } },
    { "obj_boxes1_use_corkscrew1",       { event_mdown = private.Boxes1CorkClick } },
    { "obj_boxes1_use_crowbar1",         { event_mdown = private.Boxes1BoxClick } },
    { "obj_window1_use_cutters1",        { event_mdown = private.Window1WireClick } },
    { "obj_window1_use_hook1_1",         { event_mdown = private.Window1WindowClick } },
    { "obj_animals1_use_kitten1",        { event_mdown = private.Animals1CatClick } },
    { "spr_animals1_screensaver_1_1",     { event_mdown = private.get_screensaver_1_1 } },  
    { "spr_boxes1_screensaver_1_2",     { event_mdown = private.get_screensaver_1_2 } },      
    
  } );
  local get_screensaver_1_1 = function ()

    ObjDelete( "spr_animals1_screensaver_1_1" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_1", get_screensaver_1_1, private.room_objname );  
  local get_screensaver_1_2 = function ()

    ObjDelete( "spr_boxes1_screensaver_1_2" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_2", get_screensaver_1_2, private.room_objname );  
    ------------------------------------------------------------------------------------------  
  private.Window1Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_alley1 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_alley1", update_game_mode_alley1, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_2 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_2 = function ()

    ObjDelete( "obj_alley1_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_2", get_morphobject_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_crowbar1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crowbar1" ] =
  {
    type = "get",
    get_obj = "spr_alley1_crowbar1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_crowbar1_inv = function ()

    int.InventoryItemAdd( "inv_crowbar1", "spr_alley1_crowbar1" );

  end;

  local get_crowbar1_closezz = function ()

    ObjDelete( "gfx_alley1_crowbar1" );
    ng_global.progress[ ng_global.currentprogress ][ "opn_alley1" ].man = true;    

  end;

  cmn.AddSubscriber( "get_crowbar1", get_crowbar1_inv );
  cmn.AddSubscriber( "get_crowbar1", get_crowbar1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_catamulet1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_catamulet1_1" ] =
  {
    type = "get",
    get_obj = "spr_animals1_catamulet1_1",
    room = private.room_objname,
    zz = "zz_animals1",
    zz_gate = "gzz_alley1_animals1"
  };
  -----------------------------------------------
  local get_catamulet1_1_inv = function ()

    int.InventoryItemAdd( "inv_catamulet1", "spr_animals1_catamulet1_1", "assets/levels/level1/rm_alley1/zz_animals1/inv/inv_catamulet1_1" );
    level1_inv.CheckCatamulet1();

  end;

  local get_catamulet1_1_closezz = function ()

    ObjDelete( "gfx_animals1_catamulet1_1" );

    if cmn.IsEventDone( "get_parchmentamulet1_2" ) then

      ObjDelete( "gzz_alley1_animals1" );

    end;
    
    ObjDelete( "spr_alley1_animals1_amulet" );

  end;

  cmn.AddSubscriber( "get_catamulet1_1", get_catamulet1_1_inv );
  cmn.AddSubscriber( "get_catamulet1_1", get_catamulet1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_parchmentamulet1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_parchmentamulet1_2" ] =
  {
    type = "get",
    get_obj = "spr_animals1_parchmentamulet1_2",
    room = private.room_objname,
    zz = "zz_animals1",
    zz_gate = "gzz_alley1_animals1"
  };
  -----------------------------------------------
  local get_parchmentamulet1_2_inv = function ()

    int.InventoryItemAdd( "inv_parchmentamulet1", "spr_animals1_parchmentamulet1_2", "assets/levels/level1/rm_cellar1/inv/inv_parchmentamulet1_2" );
    level1_inv.CheckParchmentamulet1();

  end;

  local get_parchmentamulet1_2_closezz = function ()

    ObjDelete( "gfx_animals1_parchmentamulet1_2" );
    ObjDelete( "anm_animals1_owl_fly" );

    if cmn.IsEventDone( "get_catamulet1_1" ) then

      ObjDelete( "gzz_alley1_animals1" );

    end;

  end;

  cmn.AddSubscriber( "get_parchmentamulet1_2", get_parchmentamulet1_2_inv );
  cmn.AddSubscriber( "get_parchmentamulet1_2", get_parchmentamulet1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pliers1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pliers1" ] =
  {
    type = "get",
    get_obj = "spr_boxes1_pliers1",
    room = private.room_objname,
    zz = "zz_boxes1",
    zz_gate = "gzz_alley1_boxes1"
  };
  -----------------------------------------------
  local get_pliers1_inv = function ()

    int.InventoryItemAdd( "inv_pliers1", "spr_boxes1_pliers1" );

    if ( cmn.IsEventDone( "get_wire1" ) ) then

      ObjSet( "inv_wire1_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_pliers1_closezz = function ()

    ObjDelete( "gfx_boxes1_pliers1" );

  end;

  cmn.AddSubscriber( "get_pliers1", get_pliers1_inv );
  cmn.AddSubscriber( "get_pliers1", get_pliers1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screws1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screws1" ] =
  {
    type = "get",
    get_obj = "spr_boxes1_screws1",
    room = private.room_objname,
    zz = "zz_boxes1",
    zz_gate = "gzz_alley1_boxes1"
  };
  -----------------------------------------------
  local get_screws1_inv = function ()

    int.InventoryItemAdd( "inv_screws1", "spr_boxes1_screws1" );

  end;

  local get_screws1_closezz = function ()

    ObjDelete( "gfx_boxes1_screws1" );

  end;

  cmn.AddSubscriber( "get_screws1", get_screws1_inv );
  cmn.AddSubscriber( "get_screws1", get_screws1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oil1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oil1" ] =
  {
    type = "get",
    get_obj = "spr_boxes1_oil1",
    room = private.room_objname,
    zz = "zz_boxes1",
    zz_gate = "gzz_alley1_boxes1"
  };
  -----------------------------------------------
  local get_oil1_inv = function ()

    int.InventoryItemAdd( "inv_oil1", "spr_boxes1_oil1" );

  end;

  local get_oil1_closezz = function ()

    ObjDelete( "gfx_boxes1_oil1" );
    ObjDelete( "gzz_alley1_boxes1" );

  end;

  cmn.AddSubscriber( "get_oil1", get_oil1_inv );
  cmn.AddSubscriber( "get_oil1", get_oil1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wire1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wire1" ] =
  {
    type = "get",
    get_obj = "spr_window1_wire1",
    room = private.room_objname,
    zz = "zz_window1",
    zz_gate = "gzz_alley1_window1"
  };
  -----------------------------------------------
  local get_wire1_inv = function ()

    int.InventoryItemAdd( "inv_wire1", "spr_window1_wire1" );
    ObjSet( "inv_wire1", { drag = false } );

    if ( not cmn.IsEventDone( "get_pliers1" ) ) then

      ObjSet( "inv_wire1_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_wire1_closezz = function ()

    ObjDelete( "gfx_window1_wire1" );
    --ObjDelete( "gzz_alley1_window1" );

  end;

  cmn.AddSubscriber( "get_wire1", get_wire1_inv );
  cmn.AddSubscriber( "get_wire1", get_wire1_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_kitten1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_kitten1" ] =
  {
    type = "use",
    use_obj = "inv_kitten1",
    use_place = "obj_animals1_use_kitten1",
    room = private.room_objname,
    zz = "zz_animals1",
    zz_gate = "gzz_alley1_animals1"
  };
  -----------------------------------------------
  local use_kitten1_inv = function ()

    int.InventoryItemRemove( "inv_kitten1" );

  end;
  local use_kitten1_beg = function ()

    ObjDelete( "obj_animals1_use_kitten1" );
    ObjDelete( "anm_animals1_cat_static" );
    ObjDelete( "anm_animals1_cat_static_click" );

  end;
  local use_kitten1_end = function ()

    ObjDelete( "anm_animals1_kitten" );
    ObjSet( "anm_animals1_cat_kitten_static", { alp = 1, playing = true, animfunc = "DoAnim" } );

    ObjSet( "spr_animals1_catamulet1_1", { alp = 1, input = true } );
    ObjSet( "gfx_animals1_catamulet1_1", { active = true } );
    
    ObjSet( "spr_alley1_animals1_amulet", { alp = 1 } );
    ObjSet( "anm_alley1_animals1_cats", { alp = 1, playing = true } );    
    ObjDelete( "anm_alley1_animals1_cats1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_kitten1",     use_kitten1_inv );
  cmn.AddSubscriber( "use_kitten1",     use_kitten1_beg, private.room_objname );
  cmn.AddSubscriber( "use_kitten1",     use_kitten1_end, private.room_objname );
  cmn.AddSubscriber( "use_kitten1_inv", use_kitten1_inv, private.room_objname );
  cmn.AddSubscriber( "use_kitten1_beg", use_kitten1_beg, private.room_objname );
  cmn.AddSubscriber( "use_kitten1_end", use_kitten1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_finefile1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_finefile1_2" ] =
  {
    type = "use",
    use_obj = "inv_finefile1",
    use_place = "obj_animals1_use_finefile1_2",
    room = private.room_objname,
    zz = "zz_animals1",
    zz_gate = "gzz_alley1_animals1"
  };
  -----------------------------------------------
  local use_finefile1_2_inv = function ()

    if ( cmn.IsEventDone( "use_finefile1_1" ) ) then

      int.InventoryItemRemove( "inv_finefile1" );

    end;

  end;
  local use_finefile1_2_beg = function ()

    ObjDelete( "obj_animals1_use_finefile1_2" );

  end;
  local use_finefile1_2_end = function ()

    ObjDelete( "anm_animals1_owl_static" );
    ObjDelete( "anm_animals1_finefile" );
    ObjSet( "anm_animals1_owl_fly", { alp = 1, frame = 148, animfunc = "DoAnim" } );

    ObjSet( "spr_animals1_parchmentamulet1_2", { input = true } );
    ObjSet( "gfx_animals1_parchmentamulet1_2", { active = true } );
    ObjDelete( "spr_alley1_animals1_owl" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_finefile1_2",     use_finefile1_2_inv );
  cmn.AddSubscriber( "use_finefile1_2",     use_finefile1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_finefile1_2",     use_finefile1_2_end, private.room_objname );
  cmn.AddSubscriber( "use_finefile1_2_inv", use_finefile1_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_finefile1_2_beg", use_finefile1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_finefile1_2_end", use_finefile1_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowbar1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crowbar1" ] =
  {
    type = "use",
    use_obj = "inv_crowbar1",
    use_place = "obj_boxes1_use_crowbar1",
    room = private.room_objname,
    zz = "zz_boxes1",
    zz_gate = "gzz_alley1_boxes1"
  };
  -----------------------------------------------
  local use_crowbar1_inv = function ()

    int.InventoryItemRemove( "inv_crowbar1" );

  end;
  local use_crowbar1_beg = function ()

    ObjDelete( "obj_boxes1_use_crowbar1" );
    ObjDelete( "anm_boxes1_crowbar_click" );

  end;
  local use_crowbar1_end = function ()

    ObjAttach( "anm_boxes1_crowbar", "obj_boxes1_box" );
    ObjSet( "spr_boxes1_pliers1", { input = true } );
    ObjSet( "gfx_boxes1_pliers1", { active = true } );
    ObjSet( "spr_boxes1_screws1", { input = true } );
    ObjSet( "gfx_boxes1_screws1", { active = true } );
    ObjSet( "anm_boxes1_crowbar", { alp = 1, frame = 133, animfunc = "DoAnim" } );
    
    ObjSet( "spr_alley1_boxes_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_crowbar1",     use_crowbar1_inv );
  cmn.AddSubscriber( "use_crowbar1",     use_crowbar1_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar1",     use_crowbar1_end, private.room_objname );
  cmn.AddSubscriber( "use_crowbar1_inv", use_crowbar1_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowbar1_beg", use_crowbar1_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar1_end", use_crowbar1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_corkscrew1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_corkscrew1" ] =
  {
    type = "use",
    use_obj = "inv_corkscrew1",
    use_place = "obj_boxes1_use_corkscrew1",
    room = private.room_objname,
    zz = "zz_boxes1",
    zz_gate = "gzz_alley1_boxes1"
  };
  -----------------------------------------------
  local use_corkscrew1_inv = function ()

    int.InventoryItemRemove( "inv_corkscrew1" );

  end;
  local use_corkscrew1_beg = function ()

    ObjDelete( "obj_boxes1_use_corkscrew1" );
    --ObjDelete( "anm_boxes1_cork_click" );

  end;
  local use_corkscrew1_end = function ()

    ObjDelete( "anm_boxes1_corkscrew" );
    ObjSet( "anm_boxes1_corkscrew_end", { alp = 1 } );
    ObjSet( "obj_boxes1_use_emptyoilcan1", { input = true } );
    ObjSet( "anm_boxes1_oil_static", { alp = 1, playing = true } );
    ObjSet( "spr_alley1_boxes_corkscrew", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_corkscrew1",     use_corkscrew1_inv );
  cmn.AddSubscriber( "use_corkscrew1",     use_corkscrew1_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew1",     use_corkscrew1_end, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew1_inv", use_corkscrew1_inv, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew1_beg", use_corkscrew1_beg, private.room_objname );
  cmn.AddSubscriber( "use_corkscrew1_end", use_corkscrew1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emptyoilcan1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emptyoilcan1" ] =
  {
    type = "use",
    use_obj = "inv_emptyoilcan1",
    use_place = "obj_boxes1_use_emptyoilcan1",
    room = private.room_objname,
    zz = "zz_boxes1",
    zz_gate = "gzz_alley1_boxes1"
  };
  -----------------------------------------------
  local use_emptyoilcan1_inv = function ()

    int.InventoryItemRemove( "inv_emptyoilcan1" );

  end;
  local use_emptyoilcan1_beg = function ()

    ObjDelete( "obj_boxes1_use_emptyoilcan1" );

  end;
  local use_emptyoilcan1_end = function ()


  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_emptyoilcan1",     use_emptyoilcan1_inv );
  cmn.AddSubscriber( "use_emptyoilcan1",     use_emptyoilcan1_beg, private.room_objname );
  cmn.AddSubscriber( "use_emptyoilcan1",     use_emptyoilcan1_end, private.room_objname );
  cmn.AddSubscriber( "use_emptyoilcan1_inv", use_emptyoilcan1_inv, private.room_objname );
  cmn.AddSubscriber( "use_emptyoilcan1_beg", use_emptyoilcan1_beg, private.room_objname );
  cmn.AddSubscriber( "use_emptyoilcan1_end", use_emptyoilcan1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cutters1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cutters1" ] =
  {
    type = "use",
    use_obj = "inv_pliers1",
    use_place = "obj_window1_use_cutters1",
    room = private.room_objname,
    zz = "zz_window1",
    zz_gate = "gzz_alley1_window1"
  };
  -----------------------------------------------
  local use_cutters1_inv = function ()

    --int.InventoryItemRemove( "inv_pliers1" );

  end;
  local use_cutters1_beg = function ()

    ObjDelete( "obj_window1_use_cutters1" );
    ObjDelete( "anm_window1_wire_click" );
    ObjSet( "anm_window1_doors_click", { alp = 1 } );

  end;
  local use_cutters1_end = function ()

    ObjDelete( "anm_window1_cutters" );
    ObjSet( "obj_window1_use_hook1_1", { input = true } );
    
    ObjDelete( "spr_alley1_wire_1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_cutters1",     use_cutters1_inv );
  cmn.AddSubscriber( "use_cutters1",     use_cutters1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutters1",     use_cutters1_end, private.room_objname );
  cmn.AddSubscriber( "use_cutters1_inv", use_cutters1_inv, private.room_objname );
  cmn.AddSubscriber( "use_cutters1_beg", use_cutters1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cutters1_end", use_cutters1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hook1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hook1_1" ] =
  {
    type = "use",
    use_obj = "inv_hook1",
    use_place = "obj_window1_use_hook1_1",
    room = private.room_objname,
    zz = "zz_window1",
    zz_gate = "gzz_alley1_window1"
  };
  -----------------------------------------------
  local use_hook1_1_inv = function ()

    --int.InventoryItemRemove( "inv_hook1" );

  end;
  local use_hook1_1_beg = function ()

    ObjDelete( "obj_window1_use_hook1_1" );
    ObjDelete( "anm_window1_doors_click" );

  end;
  local use_hook1_1_end = function ()

    ObjDelete( "anm_window1_hook_use" );
    ObjSet( "anm_window1_hook_static", { alp = 1, playing = true } );
    ObjSet( "obj_window1_mmg",         { alp = 1, input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_hook1_1",     use_hook1_1_inv );
  cmn.AddSubscriber( "use_hook1_1",     use_hook1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook1_1",     use_hook1_1_end, private.room_objname );
  cmn.AddSubscriber( "use_hook1_1_inv", use_hook1_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_hook1_1_beg", use_hook1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_hook1_1_end", use_hook1_1_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_mgassault1 () end;
  --------------------------------------------------------------------------------------------
  local win_mgassault1 = function ()

    if ( cmn.IsEventDone( "win_mgassault1" ) ) then

      ObjDelete( "gmg_alley1_mgassault1" );


      ObjSet( "obj_alley1_az", { alp = 1, input = true } );
      ObjSet( "gfx_alley1_crowbar1", {active = true } );
      ObjSet( "obj_alley1_bbt_no_clothes", {input = true } );

    end;

  end;

  cmn.AddSubscriber( "win_mgassault1", win_mgassault1, private.room_objname );

  --------------------------------------------------------------------------------------
  --function win_window1 () end;
  ------------------------------------------------------------------------------------------
  common_impl.hint[ "win_window1" ] =
  {
    type = "click",
    clk_obj = "spr_window1_mmg_back1",
    room = private.room_objname,
    zz = "zz_window1",
    zz_gate = "gzz_alley1_window1"
  };
  --*********************************************************************************************************************
  local win_window1_inv = function ()

    if ( cmn.IsEventDone( "win_window1" ) ) then


    
    end;

  end;
  --*********************************************************************************************************************
  local win_window1 = function ()

    if ( cmn.IsEventDone( "win_window1" ) ) then

      ObjDelete( "gzz_alley1_window1" );
      ObjSet( "spr_alley1_opn_window", { alp = 1 } );
      ObjSet( "grm_alley1_house1", { alp = 1, input = true, active = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_alley1_house1_focus");
      end;
    end;
    
  end;

  cmn.AddSubscriber( "win_window1", win_window1_inv );
  cmn.AddSubscriber( "win_window1", win_window1, private.room_objname );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------------------------------
------------------------------------------------------------------------------------------
function private.get_screensaver_1_1()

  int.AddScreensaver( "spr_animals1_screensaver_1_1" );

end;
------------------------------------------------------------------------------------------
function private.get_screensaver_1_2()

  int.AddScreensaver( "spr_boxes1_screensaver_1_2" );

end;   
-----------------------------------------------------------------------
function private.get_crowbar1 ()

  cmn.SetEventDone( "get_crowbar1" );
  cmn.CallEventHandler( "get_crowbar1" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_catamulet1_1 ()

  cmn.SetEventDone( "get_catamulet1_1" );
  cmn.CallEventHandler( "get_catamulet1_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_parchmentamulet1_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_parchmentamulet1_2 ()

  ObjSet( "spr_animals1_parchmentamulet1_2", { alp = 1 } );

  cmn.SetEventDone( "get_parchmentamulet1_2" );
  cmn.CallEventHandler( "get_parchmentamulet1_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_catamulet1_1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_pliers1 ()

  cmn.SetEventDone( "get_pliers1" );
  cmn.CallEventHandler( "get_pliers1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_screws1 ()

  cmn.SetEventDone( "get_screws1" );
  cmn.CallEventHandler( "get_screws1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_oil1 ()

  ObjSet( "spr_boxes1_oil1", { alp = 1 } );
  cmn.SetEventDone( "get_oil1" );
  cmn.CallEventHandler( "get_oil1" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();
  
  if port.isPortable()==1 then
    iOS_RateMe();
  end;

end;
-----------------------------------------------------------------------
function private.get_wire1 ()

  cmn.SetEventDone( "get_wire1" );
  cmn.CallEventHandler( "get_wire1" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function public.use_kitten1 ()

  local item = "inv_kitten1";

  if ( cmn.ApplyObj( item, "gzz_alley1_animals1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_animals1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_animals1_use_kitten1", true ) ) then

    cmn.CallEventHandler( "use_kitten1_inv" );
    cmn.CallEventHandler( "use_kitten1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_kitten1" );
      cmn.CallEventHandler( "use_kitten1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_animals1_kitten", { alp = 1 } );
    AnimPlay( "anm_animals1_kitten", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cats_mom" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_finefile1_2 ()

  local item = "inv_finefile1";

  if ( cmn.ApplyObj( item, "gzz_alley1_animals1", false ) ) and
     ( not cmn.IsEventDone( "use_finefile1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_animals1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_animals1_use_finefile1_2", true ) ) and
         ( not cmn.IsEventDone( "use_finefile1_2" ) ) then

    cmn.CallEventHandler( "use_finefile1_2_inv" );
    cmn.CallEventHandler( "use_finefile1_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_finefile1_2" );
      cmn.CallEventHandler( "use_finefile1_2_end" );

    end;

    int.Lock( true );

    AnimPlay( "anm_animals1_finefile", "DoAnim", function ()

      ObjSet( "anm_animals1_owl_static", { alp = 0 } );
      ObjSet( "anm_animals1_owl_fly", { alp = 1 } );

      AnimStop( "anm_animals1_owl_static" );
      AnimPlay( "anm_animals1_owl_fly", "DoAnim", func_end );

    end );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_owl_freedom" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_crowbar1 ()

  local item = "inv_crowbar1";

  if ( cmn.ApplyObj( item, "gzz_alley1_boxes1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes1_use_crowbar1", true ) ) then

    cmn.CallEventHandler( "use_crowbar1_inv" );
    cmn.CallEventHandler( "use_crowbar1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_crowbar1" );
      cmn.CallEventHandler( "use_crowbar1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_boxes1_crowbar", { alp = 1 } );
    AnimPlay( "anm_boxes1_crowbar", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_crash_wood_box" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_corkscrew1 ()

  local item = "inv_corkscrew1";

  if ( cmn.ApplyObj( item, "gzz_alley1_boxes1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes1_use_corkscrew1", true ) ) then

    cmn.CallEventHandler( "use_corkscrew1_inv" );
    cmn.CallEventHandler( "use_corkscrew1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_corkscrew1" );
      cmn.CallEventHandler( "use_corkscrew1_end" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_barrel_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_boxes1_corkscrew", { alp = 1 } );
    AnimPlay( "anm_boxes1_corkscrew", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_barrel_open" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_emptyoilcan1 ()

  local item = "inv_emptyoilcan1";

  if ( cmn.ApplyObj( item, "gzz_alley1_boxes1", false ) ) and
     ( cmn.IsEventDone( "use_corkscrew1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes1_use_emptyoilcan1", true ) ) and
         ( cmn.IsEventDone( "use_corkscrew1" ) ) then

    cmn.CallEventHandler( "use_emptyoilcan1_inv" );
    cmn.CallEventHandler( "use_emptyoilcan1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_emptyoilcan1" );
      cmn.CallEventHandler( "use_emptyoilcan1_end" );
      private.get_oil1();

    end;

    int.Lock( true );

    ObjSet( "anm_boxes1_oil_static",  { alp = 0 } );
    ObjSet( "anm_boxes1_emptyoilcan", { alp = 1 } );
    AnimPlay( "anm_boxes1_emptyoilcan", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_fill_liquid_barrel" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_cutters1 ()

  local item = "inv_pliers1";

  if ( cmn.ApplyObj( item, "gzz_alley1_window1", false ) ) and
     ( not cmn.IsEventDone( "use_cutters1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window1_use_cutters1", true ) ) and
         ( not cmn.IsEventDone( "use_cutters1" ) ) then

    cmn.CallEventHandler( "use_cutters1_inv" );
    cmn.CallEventHandler( "use_cutters1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_cutters1" );
      cmn.CallEventHandler( "use_cutters1_end" );
      private.get_wire1();

    end;

    int.Lock( true );

    ObjSet( "anm_window1_cutters", { alp = 1 } );
    AnimPlay( "anm_window1_cutters", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_metal" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_hook1_1 ()

  local item = "inv_hook1";

  if ( cmn.ApplyObj( item, "gzz_alley1_window1", false ) ) and
     ( not cmn.IsEventDone( "use_hook1_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window1_use_hook1_1", true ) ) and
         ( not cmn.IsEventDone( "use_hook1_1" ) ) then

    cmn.CallEventHandler( "use_hook1_1_inv" );
    cmn.CallEventHandler( "use_hook1_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_hook1_1" );
      cmn.CallEventHandler( "use_hook1_1_end" );
      private.Window1GraduationAnim( 1 );
      private.Window1StartInit();

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_closed_window_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_window1_hook_use", { alp = 1 } );
    AnimPlay( "anm_window1_hook_use", "DoAnim", function ()

      ObjAnimate( "obj_window1_mmg", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0,
        0.3, 0, 1.0,
      } );

    end );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_window_metal" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_alley1 ()

  if not ( cmn.IsEventDone( "opn_alley1" ) ) then

    cmn.SetEventDone( "opn_alley1" );

  end;

  if ( cmn.IsEventDone( "win_mgassault1" ) and 
       not ng_global.progress[ ng_global.currentprogress ][ "opn_alley1" ].man ) then

    local func_end = function ()

      ng_global.progress[ ng_global.currentprogress ][ "opn_alley1" ].man = true;
      ObjDelete( "anm_alley1_stunned_man" );
      int.Lock( false );

      interface.KeyTaskDone( true, "task_1_3" );

    end;

    int.Lock( true );
    ObjSet( "anm_alley1_stunned_man", { alp = 1 } );
    AnimPlay( "anm_alley1_stunned_man", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_assault_win" );

  elseif ng_global.progress[ ng_global.currentprogress ][ "opn_alley1" ].man then

    ObjDelete( "anm_alley1_stunned_man" );

  end;

  cmn.StopAllEnv( "audio/level1/env/aud_rm_alley1_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_rm_alley1_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( cmn.IsEventDone( "win_mgassault1" ) and 
       not ng_global.progress[ ng_global.currentprogress ][ "opn_alley1" ].man ) then

    ObjSet( "anm_alley1_stunned_man", { alp = 1 } );
    
  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_alley1();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_crowbar1",                                      { "win_mgassault1" } );
  int.AddedTaskMap( private.room_objname, "get_catamulet1_1",                                  { "use_kitten1" } );
  int.AddedTaskMap( private.room_objname, "get_parchmentamulet1_2",                            { "use_finefile1_2" } );
  int.AddedTaskMap( private.room_objname, "get_pliers1",                                       { "use_crowbar1" } );
  int.AddedTaskMap( private.room_objname, "get_screws1",                                       { "use_crowbar1" } );
  int.AddedTaskMap( private.room_objname, "get_oil1",                                          { "use_emptyoilcan1" } );
  int.AddedTaskMap( private.room_objname, "get_wire1",                                         { "use_cutters1" } );

  int.AddedTaskMap( private.room_objname, "use_kitten1",                                       { "get_kitten1" } );
  int.AddedTaskMap( private.room_objname, "use_finefile1_2",                                   { "get_finefile1" } );
  int.AddedTaskMap( private.room_objname, "use_crowbar1",                                      { "get_crowbar1" } );
  int.AddedTaskMap( private.room_objname, "use_corkscrew1",                                    { "get_corkscrew1" } );
  int.AddedTaskMap( private.room_objname, "use_emptyoilcan1",                                  { "get_emptyoilcan1", "use_corkscrew1" } );
  int.AddedTaskMap( private.room_objname, "use_cutters1",                                      { "get_pliers1" } );
  int.AddedTaskMap( private.room_objname, "use_hook1_1",                                       { "get_hook1" } );

  int.AddedTaskMap( private.room_objname, "win_mgassault1",                                    { "use_auratrace1" } );
  int.AddedTaskMap( private.room_objname, "win_window1",                                       { "use_hook1_1" } );

  int.AddedTaskMap( private.room_objname, "opn_house1",                                        { "win_window1" } );
  int.AddedTaskMap( private.room_objname, "opn_square1",                                       { "del_clothes1" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_window1" );
  subroom.Define( "zz_boxes1" );
  -------------------------------------------------
  function zz_window1.Open()
    
    if ( cmn.IsEventStart( "win_window1" ) and not cmn.IsEventDone( "win_window1" ) ) then

      cmn.MiniGameShow( "window1" );
      common_impl.PassingMgStart( "window1" );
      private.Window1GraduationAnim( 1 );
      private.stage = 1;

    end;

    if ( cmn.IsEventDone( "use_hook1_1" ) ) then

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_closed_window_loop", 1 );

    end;

  end;
  -------------------------------------------------
  function zz_window1.PreClose()
        
    if ( cmn.IsEventStart( "win_window1" ) and not cmn.IsEventDone( "win_window1" ) ) then

      cmn.MiniGameHide( "window1" );
      common_impl.PassingMgStop( "window1" );
      ObjStopAnimate( "spr_window1_mmg_part1", "pos_x" );
      ObjStopAnimate( "spr_window1_mmg_part2", "pos_x" );
      ObjSet( "spr_window1_mmg_back1", { input = true } );
      ObjSet( "spr_window1_mmg_back2", { input = false } );
      ObjSet( "spr_window1_mmg_part1", { pos_x = -113 } );
      ObjSet( "spr_window1_mmg_part2", { pos_x = -113 } );

    end;

    if ( cmn.IsEventDone( "use_hook1_1" ) ) then

      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mmg_closed_window_loop" );

    end;

  end;
  -------------------------------------------------
  function zz_window1.Skip ()

    if ( cmn.IsEventStart( "win_window1" ) and not cmn.IsEventDone( "win_window1" ) ) then
      private.Window1Skip();
    end;

  end;
  -------------------------------------------------
  function zz_window1.Reset ()

    if ( cmn.IsEventStart( "win_window1" ) and not cmn.IsEventDone( "win_window1" ) ) then
      private.Window1Reset();
    end;

  end;
  -------------------------------------------------
  -------------------------------------------------
  function zz_boxes1.Open()

    if ( cmn.IsEventDone( "use_corkscrew1" ) ) then

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_barrel_loop", 1 );

    end;

  end;
  -------------------------------------------------
  function zz_boxes1.PreClose()

    if ( cmn.IsEventDone( "use_corkscrew1" ) ) then

      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_barrel_loop" );

    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_window1_light_lock", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.6, 0, 0,
    3.2, 0, 1
  } );

end;
--*********************************************************************************************************************
function private.Boxes1CorkClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_boxes1_use_corkscrew1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_boxes1_cork_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_barrel" );

end;
--*********************************************************************************************************************
function private.Boxes1BoxClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_boxes1_use_crowbar1" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_wood_box_zz_boxes1" );
  AnimPlay( "anm_boxes1_crowbar_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Window1WireClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_window1_use_cutters1" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_closed_window_broken" );
  AnimPlay( "anm_window1_wire_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Window1WindowClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_window1_use_hook1_1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_window1_doors_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_closed_window_broken" );

end;
--*********************************************************************************************************************
function private.Animals1CatClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_animals1_use_kitten1" );

    ObjSet( "anm_animals1_cat_static",       { alp = 1 } );
    ObjSet( "anm_animals1_cat_static_click", { alp = 0 } );

    AnimStop( "anm_animals1_cat_static_click" );
    AnimPlay( "anm_animals1_cat_static", "DoAnim", "" );

  end;

  int.Lock( true );

  ObjSet( "anm_animals1_cat_static",       { alp = 0 } );
  ObjSet( "anm_animals1_cat_static_click", { alp = 1 } );

  AnimStop( "anm_animals1_cat_static" );
  AnimPlay( "anm_animals1_cat_static_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_cat_left" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Window1 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Window1StartInit ()

    cmn.MiniGameShow( "window1" );
    common_impl.PassingMgStart( "window1" );

  end;
----*********************************************************************************************************************
-------------------------------------------------
  function private.Window1Skip()

    private.Window1Win();

  end;
---------------------------------------------------
  function private.Window1Reset()

    ObjStopAnimate( "spr_window1_mmg_part1", "pos_x" );
    ObjStopAnimate( "spr_window1_mmg_part2", "pos_x" );
    ObjSet( "spr_window1_mmg_back1", { input = true } );
    ObjSet( "spr_window1_mmg_back2", { input = false } );
    ObjSet( "spr_window1_mmg_part1", { pos_x = -113 } );
    ObjSet( "spr_window1_mmg_part2", { pos_x = -113 } );

    private.Window1GraduationAnim( 1 );
    private.stage = 1;

  end;
--*********************************************************************************************************************
  function private.Window1Init ()

    for i = 1, 2 do

      ObjSet( "spr_window1_mmg_back"..i,
      {
        event_mdown  = function () private.Window1Clk( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );

    end;

    private.stage = 1;

  end;
--*********************************************************************************************************************
  function private.Window1GraduationAnim ( id )

    ObjAnimate( "spr_window1_mmg_part"..id, "pos_x", 1, 0, "", 
    {
      0.0, 0, -113,
      2.5, 3,  29,
      5.0, 3, -113
    } );

  end;
--*********************************************************************************************************************
  function private.Window1Clk ( id )

    ObjStopAnimate( "spr_window1_mmg_part"..id, "pos_x" );
    local x = ObjGet( "spr_window1_mmg_part"..id ).pos_x;

    if ( x > - 32 and x < - 19 ) then

      if private.stage == 1 then

        if id == 1 then

          private.Window1GraduationAnim ( 2 );
          private.stage = 2;
          ObjSet( "spr_window1_mmg_back1", { input = false } );
          ObjSet( "spr_window1_mmg_back2", { input = true } );

          cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_closed_window_right" );

        else

          local func_end_anim = function ()

            private.Window1GraduationAnim ( 1 );
            ObjSet( "spr_window1_mmg_back1", { input = true } );
            ObjSet( "spr_window1_mmg_back2", { input = false } );
            ObjSet( "spr_window1_mmg_part1", { pos_x = -113 } );
            ObjSet( "spr_window1_mmg_part2", { pos_x = -113 } );

            ObjSet( "anm_window1_hook_loose",  { alp = 0 } );
            ObjSet( "anm_window1_hook_static", { alp = 1 } );

            AnimStop( "anm_window1_hook_loose" );
            AnimPlay( "anm_window1_hook_static", "DoAnim", "" );

          end;

          ObjSet( "anm_window1_hook_static", { alp = 0 } );
          ObjSet( "anm_window1_hook_loose",  { alp = 1 } );

          AnimStop( "anm_window1_hook_static" );
          AnimPlay( "anm_window1_hook_loose", "DoAnim", func_end_anim );

          cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_closed_window_wrong" );

        end;

      else
        int.Lock( true );
        ObjSet( "spr_window1_mmg_back2", { input = false } );

        ObjSet( "anm_window1_hook_static", { alp = 0 } );
        ObjSet( "anm_window1_hook_win",    { alp = 1 } );

        AnimStop( "anm_window1_hook_static" );
        AnimPlay( "anm_window1_hook_win", "DoAnim", private.Window1Win );

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_closed_window_win" );

      end;

    else

      if id == 1 then

        private.Window1GraduationAnim ( 2 );
        ObjSet( "spr_window1_mmg_back1", { input = false } );
        ObjSet( "spr_window1_mmg_back2", { input = true } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_closed_window_right" );

      else

        local func_end_anim = function ()

          private.Window1GraduationAnim ( 1 );
          ObjSet( "spr_window1_mmg_back1", { input = true } );
          ObjSet( "spr_window1_mmg_back2", { input = false } );
          ObjSet( "spr_window1_mmg_part1", { pos_x = -113 } );
          ObjSet( "spr_window1_mmg_part2", { pos_x = -113 } );

          if private.stage == 2 then

            private.stage = 1;

          end;

          ObjSet( "anm_window1_hook_loose",  { alp = 0 } );
          ObjSet( "anm_window1_hook_static", { alp = 1 } );

          AnimStop( "anm_window1_hook_loose" );
          AnimPlay( "anm_window1_hook_static", "DoAnim", "" );

        end;

        ObjSet( "anm_window1_hook_static", { alp = 0 } );
        ObjSet( "anm_window1_hook_loose",  { alp = 1 } );

        AnimStop( "anm_window1_hook_static" );
        AnimPlay( "anm_window1_hook_loose", "DoAnim", func_end_anim );

        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_closed_window_wrong" );

      end;

    end; 

  end;
--*********************************************************************************************************************
  function private.Window1Win () 
    
    cmn.MiniGameHide( "window1" );
    cmn.SetEventDone( "win_window1" );
    cmn.CallEventHandler( "win_window1" );
    common_impl.PassingMgWin( "window1" );
    cmn.CloseSubRoom();
     
  end;
--*********************************************************************************************************************