-- name=rm_cellar1
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_cellar1";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_safe1",        "room_hub" );
  ObjAttach( "zz_cellartable1", "room_hub" );

  ObjMultiSet(
  {
    { "spr_cellar1_finefile1",          { event_mdown = private.get_finefile1 } },
    { "spr_cellar1_portrait1_2",        { event_mdown = private.get_portrait1_2 } },
    { "spr_cellar1_parchmentamulet1_1", { event_mdown = private.get_parchmentamulet1_1 } },
    { "spr_safe1_blank1",               { event_mdown = private.get_blank1 } },
    { "spr_cellartable1_emptyoilcan1",  { event_mdown = private.get_emptyoilcan1 } },
    { "spr_cellartable1_list1",         { event_mdown = private.get_list1 } },
    { "spr_cellartable1_feather",       { event_mdown = private.get_feather1 } },
    { "spr_cellartable1_keypicture1",   { event_mdown = private.get_keypicture1 } },
    { "spr_safe1_handle",               { event_mdown = function() private.clk_safe1_handle() end } },
    { "spr_cellar1_collect_1_4",        { event_mdown = private.get_collect_1_4 } },
    { "obj_cellartable1_use_parchmentamulet1", { event_mdown = private.Cellartable1DoorClick } },
    { "obj_safe1_circle_click",         { event_mdown = private.Safe1CircleClick } },
    { "obj_safe1_handle_click",         { event_mdown = private.Safe1HandleClick } },
    { "obj_safe1_use_oil1",             { event_mdown = private.Safe1OilClick } },
    { "obj_safe1_use_portrait1",        { event_mdown = private.Safe1PortraitClick } },
    { "spr_cellartable1_screensaver_1_7",     { event_mdown = private.get_screensaver_1_7 } },          

  } );

  local get_screensaver_1_7 = function ()

    ObjDelete( "spr_cellartable1_screensaver_1_7" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_7", get_screensaver_1_7, private.room_objname );  

  private.Safe1Init();

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.InitMorphRandomState( 1 );

  end;

  --------------------------------------------------------------------------------------------
  -- function get_collect_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_1_4 = function ()

    ObjDelete( "spr_cellar1_collect_1_4" );

  end;

  cmn.AddSubscriber( "get_collect_1_4", get_collect_1_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_6 = function ()

    ObjDelete( "obj_cellar1_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_6", get_morphobject_1_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_cellar1 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_cellar1", update_game_mode_cellar1, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_finefile1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_finefile1" ] =
  {
    type = "get",
    get_obj = "spr_cellar1_finefile1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_finefile1_inv = function ()

    int.InventoryItemAdd( "inv_finefile1", "spr_cellar1_finefile1" );

    if ( cmn.IsEventDone( "use_blank1" ) ) then

      ObjSet( "inv_keypicture1_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_finefile1_closezz = function ()

    ObjDelete( "gfx_cellar1_finefile1" );
    
    ObjDelete( "spr_cellar1_finefile1_shadow" );

  end;

  cmn.AddSubscriber( "get_finefile1", get_finefile1_inv );
  cmn.AddSubscriber( "get_finefile1", get_finefile1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_portrait1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_portrait1_2" ] =
  {
    type = "get",
    get_obj = "spr_cellar1_portrait1_2",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_portrait1_2_inv = function ()

    int.InventoryItemAdd( "inv_portrait1", "spr_cellar1_portrait1_2", "assets/levels/level1/rm_secondfloor1/zz_coffeetable1/inv/inv_portrait1_2" );
    level1_inv.CheckPortrait1();

  end;

  local get_portrait1_2_closezz = function ()

    ObjDelete( "gfx_cellar1_portrait1_2" );

  end;

  cmn.AddSubscriber( "get_portrait1_2", get_portrait1_2_inv );
  cmn.AddSubscriber( "get_portrait1_2", get_portrait1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_parchmentamulet1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_parchmentamulet1_1" ] =
  {
    type = "get",
    get_obj = "spr_cellar1_parchmentamulet1_1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_parchmentamulet1_1_inv = function ()

    int.InventoryItemAdd( "inv_parchmentamulet1", "spr_cellar1_parchmentamulet1_1", "assets/levels/level1/rm_cellar1/inv/inv_parchmentamulet1_1" );
    level1_inv.CheckParchmentamulet1();

  end;

  local get_parchmentamulet1_1_closezz = function ()

    ObjDelete( "gfx_cellar1_parchmentamulet1_1" );

  end;

  cmn.AddSubscriber( "get_parchmentamulet1_1", get_parchmentamulet1_1_inv );
  cmn.AddSubscriber( "get_parchmentamulet1_1", get_parchmentamulet1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_parchmentamulet1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_parchmentamulet1_3" ] =
  {
    type = "get",
    get_obj = "spr_cellar1_parchmentamulet1_3",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_parchmentamulet1_3_inv = function ()

    int.InventoryItemAdd( "inv_parchmentamulet1", "spr_cellar1_parchmentamulet1_3", "assets/levels/level1/rm_cellar1/inv/inv_parchmentamulet1_3" );
    level1_inv.CheckParchmentamulet1();

  end;

  local get_parchmentamulet1_3_closezz = function ()

    ObjDelete( "gfx_cellar1_parchmentamulet1_3" );

  end;

  cmn.AddSubscriber( "get_parchmentamulet1_3", get_parchmentamulet1_3_inv );
  cmn.AddSubscriber( "get_parchmentamulet1_3", get_parchmentamulet1_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_blank1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blank1" ] =
  {
    type = "get",
    get_obj = "spr_safe1_blank1",
    room = private.room_objname,
    zz = "zz_safe1",
    zz_gate = "gzz_cellar1_safe1"
  };
  -----------------------------------------------
  local get_blank1_inv = function ()

    int.InventoryItemAdd( "inv_blank1", "spr_safe1_blank1" );

    if ( cmn.IsEventDone( "get_keypicture1" ) ) then

      ObjSet( "inv_keypicture1_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_blank1_closezz = function ()

    ObjDelete( "gfx_safe1_blank1" );
    
    ObjDelete( "spr_cellar1_safe1_iron" );

  end;

  cmn.AddSubscriber( "get_blank1", get_blank1_inv );
  cmn.AddSubscriber( "get_blank1", get_blank1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emptyoilcan1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emptyoilcan1" ] =
  {
    type = "get",
    get_obj = "spr_cellartable1_emptyoilcan1",
    room = private.room_objname,
    zz = "zz_cellartable1",
    zz_gate = "gzz_cellar1_cellartable1"
  };
  -----------------------------------------------
  local get_emptyoilcan1_inv = function ()

    int.InventoryItemAdd( "inv_emptyoilcan1", "spr_cellartable1_emptyoilcan1" );

  end;

  local get_emptyoilcan1_closezz = function ()

    ObjDelete( "gfx_cellartable1_emptyoilcan1" );
    
    ObjDelete( "spr_cellar1_cellartable1_oil" );    

  end;

  cmn.AddSubscriber( "get_emptyoilcan1", get_emptyoilcan1_inv );
  cmn.AddSubscriber( "get_emptyoilcan1", get_emptyoilcan1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_list1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_list1" ] =
  {
    type = "get",
    get_obj = "spr_cellartable1_list1",
    room = private.room_objname,
    zz = "zz_cellartable1",
    zz_gate = "gzz_cellar1_cellartable1"
  };
  -----------------------------------------------
  local get_list1_inv = function ()

    int.InventoryItemAdd( "inv_list1", "spr_cellartable1_list1" );

  end;

  local get_list1_closezz = function ()

    ObjDelete( "gfx_cellartable1_list1" );
    
    ObjDelete( "spr_cellar1_cellartable1_paper_2" );

  end;

  cmn.AddSubscriber( "get_list1", get_list1_inv );
  cmn.AddSubscriber( "get_list1", get_list1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_keypicture1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_keypicture1" ] =
  {
    type = "get",
    get_obj = "spr_cellartable1_keypicture1",
    room = private.room_objname,
    zz = "zz_cellartable1",
    zz_gate = "gzz_cellar1_cellartable1"
  };
  -----------------------------------------------
  local get_keypicture1_inv = function ()

    int.InventoryItemAdd( "inv_keypicture1", "spr_cellartable1_keypicture1" );
    ObjSet( "inv_keypicture1", { drag = false } );

    if ( not cmn.IsEventDone( "get_blank1" ) ) then

      ObjSet( "inv_keypicture1_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_keypicture1_closezz = function ()

    ObjDelete( "gfx_cellartable1_keypicture1" );
    ObjDelete( "spr_cellartable1_keypicture1_shadow" );
    ObjDelete( "spr_cellartable1_keypicture1_over" );
    ObjDelete( "spr_cellar1_cellartable1_paper" );

  end;

  cmn.AddSubscriber( "get_keypicture1", get_keypicture1_inv );
  cmn.AddSubscriber( "get_keypicture1", get_keypicture1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fakedocument1 () end;
  --------------------------------------------------------------------------------------------
  local get_fakedocument1 = function ()

    ObjDelete( "gmg_cellar1_mgdocument1" );

  end;

  cmn.AddSubscriber( "get_fakedocument1", get_fakedocument1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_feather1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_feather1" ] =
  {
    type = "get",
    get_obj = "spr_cellartable1_feather",
    room = private.room_objname,
    zz = "zz_cellartable1",
    zz_gate = "gzz_cellar1_cellartable1"
  };
  -----------------------------------------------
  local get_feather1_inv = function ()

    int.InventoryItemAdd( "inv_feather1", "spr_cellartable1_feather" );

  end;

  local get_feather1_closezz = function ()

    ObjDelete( "gfx_cellartable1_feather" );

  end;

  cmn.AddSubscriber( "get_feather1", get_feather1_inv );
  cmn.AddSubscriber( "get_feather1", get_feather1_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_pin1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pin1" ] =
  {
    type = "use",
    use_obj = "inv_pin1",
    use_place = "obj_cellar1_use_pin1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_pin1_inv = function ()

    int.InventoryItemRemove( "inv_pin1" );

  end;
  local use_pin1_beg = function ()

    ObjDelete( "obj_cellar1_use_pin1" );

  end;
  local use_pin1_end = function ()

    ObjSet( "spr_cellar1_portrait1_2", { input = true } );
    ObjSet( "gfx_cellar1_portrait1_2", { active = true } );
    
    ObjSet( "anm_cellar1_az_open_chest", { frame = 193 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pin1",     use_pin1_inv );
  cmn.AddSubscriber( "use_pin1",     use_pin1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pin1",     use_pin1_end, private.room_objname );
  cmn.AddSubscriber( "use_pin1_inv", use_pin1_inv, private.room_objname );
  cmn.AddSubscriber( "use_pin1_beg", use_pin1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pin1_end", use_pin1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_key1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_key1" ] =
  {
    type = "use",
    use_obj = "inv_key1",
    use_place = "obj_cellar1_use_key1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_key1_inv = function ()

    int.InventoryItemRemove( "inv_key1" );

  end;
  local use_key1_beg = function ()

    ObjDelete( "obj_cellar1_use_key1" );

  end;
  local use_key1_end = function ()

    ObjSet( "spr_cellar1_parchmentamulet1_1", { input = true } );
    ObjSet( "gfx_cellar1_parchmentamulet1_1", { active = true } );
    ObjSet( "obj_cellar1_use_pin1", { input = true } );
    
    ObjDelete( "anm_cellar1_chest_az_key" );
    ObjSet( "anm_cellar1_az_open_chest", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_key1",     use_key1_inv );
  cmn.AddSubscriber( "use_key1",     use_key1_beg, private.room_objname );
  cmn.AddSubscriber( "use_key1",     use_key1_end, private.room_objname );
  cmn.AddSubscriber( "use_key1_inv", use_key1_inv, private.room_objname );
  cmn.AddSubscriber( "use_key1_beg", use_key1_beg, private.room_objname );
  cmn.AddSubscriber( "use_key1_end", use_key1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oil1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oil1" ] =
  {
    type = "use",
    use_obj = "inv_oil1",
    use_place = "obj_safe1_use_oil1",
    room = private.room_objname,
    zz = "zz_safe1",
    zz_gate = "gzz_cellar1_safe1"
  };
  -----------------------------------------------
  local use_oil1_inv = function ()

    --int.InventoryItemRemove( "inv_oil1" );

  end;
  local use_oil1_beg = function ()

    ObjDelete( "obj_safe1_use_oil1" );
    ObjDelete( "anm_safe1_oil_click" );
    ObjSet( "anm_safe1_portrait_click", { alp = 1 } );

  end;
  local use_oil1_end = function ()

    ObjDelete( "anm_safe1_use_oil" );
    ObjSet( "obj_safe1_use_portrait1", { input = true } );
    
    ObjSet( "spr_cellar1_safe1_cap_1", { alp = 1 } );
    ObjDelete( "spr_cellar1_safe1_rust" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_oil1",     use_oil1_inv );
  cmn.AddSubscriber( "use_oil1",     use_oil1_beg, private.room_objname );
  cmn.AddSubscriber( "use_oil1",     use_oil1_end, private.room_objname );
  cmn.AddSubscriber( "use_oil1_inv", use_oil1_inv, private.room_objname );
  cmn.AddSubscriber( "use_oil1_beg", use_oil1_beg, private.room_objname );
  cmn.AddSubscriber( "use_oil1_end", use_oil1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_portrait1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_portrait1" ] =
  {
    type = "use",
    use_obj = "inv_portrait1",
    use_place = "obj_safe1_use_portrait1",
    room = private.room_objname,
    zz = "zz_safe1",
    zz_gate = "gzz_cellar1_safe1"
  };
  -----------------------------------------------
  local use_portrait1_inv = function ()

    int.InventoryItemRemove( "inv_portrait1" );

  end;
  local use_portrait1_beg = function ()

    ObjDelete( "obj_safe1_use_portrait1" );
    ObjDelete( "obj_safe1_circle_click" );
    ObjDelete( "obj_safe1_handle_click" );
    ObjDelete( "anm_safe1_portrait_click" );

  end;
  local use_portrait1_end = function ()

    ObjSet( "obj_safe1_drag_object", { input = true } );
    ObjSet( "anm_safe1_use_portrait", { alp = 1, frame = 154, animfunc = "DoAnim" } );
    
    ObjSet( "spr_cellar1_safe1_cap_2", { alp = 1 } );
    ObjSet( "obj_safe1_mmg",     { alp = 1 } );
    ObjSet( "obj_safe1_handle1", { alp = 1 } );
    ObjDelete( "spr_cellar1_safe1_cap_1" );
    ObjDelete( "anm_safe1_circle_click" );
    ObjDelete( "anm_safe1_handle_click" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_portrait1",     use_portrait1_inv );
  cmn.AddSubscriber( "use_portrait1",     use_portrait1_beg, private.room_objname );
  cmn.AddSubscriber( "use_portrait1",     use_portrait1_end, private.room_objname );
  cmn.AddSubscriber( "use_portrait1_inv", use_portrait1_inv, private.room_objname );
  cmn.AddSubscriber( "use_portrait1_beg", use_portrait1_beg, private.room_objname );
  cmn.AddSubscriber( "use_portrait1_end", use_portrait1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_parchmentamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_parchmentamulet1" ] =
  {
    type = "use",
    use_obj = "inv_parchmentamulet1",
    use_place = "obj_cellartable1_use_parchmentamulet1",
    room = private.room_objname,
    zz = "zz_cellartable1",
    zz_gate = "gzz_cellar1_cellartable1"
  };
  -----------------------------------------------
  local use_parchmentamulet1_inv = function ()

    int.InventoryItemRemove( "inv_parchmentamulet1" );

  end;
  local use_parchmentamulet1_beg = function ()

    ObjDelete( "obj_cellartable1_use_parchmentamulet1" );
    ObjDelete( "anm_cellartable1_door_click" );

  end;
  local use_parchmentamulet1_end = function ()

    ObjDelete( "obj_cellartable1_box_close" );
    ObjSet( "obj_cellartable1_box_open", { alp = 1 } );
    ObjSet( "spr_cellartable1_list1",    { input = true } );
    ObjSet( "gfx_cellartable1_list1",    { active = true } );
    ObjSet( "spr_cellartable1_feather",  { input = true } );
    ObjSet( "gfx_cellartable1_feather",  { active = true } );
    ObjSet( "obj_cellartable1_use_reagents1", { input = true } );
    ObjSet( "obj_cellartable1_use_letter1",   { input = true } );
    
    ObjSet( "spr_cellar1_cellartable1_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_parchmentamulet1",     use_parchmentamulet1_inv );
  cmn.AddSubscriber( "use_parchmentamulet1",     use_parchmentamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_parchmentamulet1",     use_parchmentamulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_parchmentamulet1_inv", use_parchmentamulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_parchmentamulet1_beg", use_parchmentamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_parchmentamulet1_end", use_parchmentamulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_letter1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_letter1" ] =
  {
    type = "use",
    use_obj = "inv_letter1",
    use_place = "obj_cellartable1_use_letter1",
    room = private.room_objname,
    zz = "zz_cellartable1",
    zz_gate = "gzz_cellar1_cellartable1"
  };
  -----------------------------------------------
  local use_letter1_inv = function ()

    int.InventoryItemRemove( "inv_letter1" );

  end;
  local use_letter1_beg = function ()

    ObjDelete( "obj_cellartable1_use_letter1" );

  end;
  local use_letter1_end = function ()

    ObjSet( "spr_cellartable1_letter1", { alp = 1 } );

    if cmn.IsEventDone( "use_reagents1" ) then

      ObjSet( "gmg_cellar1_mgdocument1", { alp = 1, input = true, active = true } );
      ObjDelete( "gzz_cellar1_cellartable1" );

    end;

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_letter1",     use_letter1_inv );
  cmn.AddSubscriber( "use_letter1",     use_letter1_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter1",     use_letter1_end, private.room_objname );
  cmn.AddSubscriber( "use_letter1_inv", use_letter1_inv, private.room_objname );
  cmn.AddSubscriber( "use_letter1_beg", use_letter1_beg, private.room_objname );
  cmn.AddSubscriber( "use_letter1_end", use_letter1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_reagents1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_reagents1" ] =
  {
    type = "use",
    use_obj = "inv_reagents1",
    use_place = "obj_cellartable1_use_reagents1",
    room = private.room_objname,
    zz = "zz_cellartable1",
    zz_gate = "gzz_cellar1_cellartable1"
  };
  -----------------------------------------------
  local use_reagents1_inv = function ()

    int.InventoryItemRemove( "inv_reagents1" );

  end;
  local use_reagents1_beg = function ()

    ObjDelete( "obj_cellartable1_use_reagents1" );
    ObjDelete( "anm_cellartable1_lamp" );

  end;
  local use_reagents1_end = function ()

    if cmn.IsEventDone( "use_letter1" ) then

      ObjSet( "gmg_cellar1_mgdocument1", { alp = 1, input = true, active = true } );
      ObjDelete( "gzz_cellar1_cellartable1" );

    end;

    ObjDelete( "anm_cellartable1_reagents" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_reagents1",     use_reagents1_inv );
  cmn.AddSubscriber( "use_reagents1",     use_reagents1_beg, private.room_objname );
  cmn.AddSubscriber( "use_reagents1",     use_reagents1_end, private.room_objname );
  cmn.AddSubscriber( "use_reagents1_inv", use_reagents1_inv, private.room_objname );
  cmn.AddSubscriber( "use_reagents1_beg", use_reagents1_beg, private.room_objname );
  cmn.AddSubscriber( "use_reagents1_end", use_reagents1_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_safe1_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_safe1_handle" ] =
  {
    type = "click",
    room = private.room_objname,
    clk_obj = "spr_safe1_handle",
    zz = "zz_safe1",
    zz_gate = "gzz_cellar1_safe1"
  };
  -----------------------------------------------
  local clk_safe1_handle_inv = function ()
        
  end;
  local clk_safe1_handle_beg = function ()


  end;
  local clk_safe1_handle_end = function ()

    ObjDelete( "gzz_cellar1_safe1" );
    ObjSet( "gho_cellar1_hosafe1", { alp = 1, input = true, active = true } );
    
    ObjSet( "spr_cellar1_safe1_open", { alp = 1 } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_safe1_handle",     clk_safe1_handle_inv );
  cmn.AddSubscriber( "clk_safe1_handle",     clk_safe1_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safe1_handle",     clk_safe1_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_safe1_handle_inv", clk_safe1_handle_inv, private.room_objname );
  cmn.AddSubscriber( "clk_safe1_handle_beg", clk_safe1_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safe1_handle_end", clk_safe1_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_hosafe1 () end;
  --------------------------------------------------------------------------------------------
  local win_hosafe1_zz = function ()

    if ( cmn.IsEventDone( "win_hosafe1" ) ) then

      ObjDelete( "spr_cellar1_safe1_ho_1" );
      ObjSet( "spr_cellar1_safe1_ho_2", { alp = 1 } );

    end;

  end;

  cmn.AddSubscriber( "win_hosafe1", win_hosafe1_zz, private.room_objname );  
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------
  --function win_safe1 () end;
  ------------------------------------------------------------------------------------------
  common_impl.hint[ "win_safe1" ] =
  {
    type = "click",
    clk_obj = "spr_safe1_circle",
    room = private.room_objname,
    zz = "zz_safe1",
    zz_gate = "gzz_cellar1_safe1"
  };
  --*********************************************************************************************************************
  local win_safe1_inv = function ()

    if ( cmn.IsEventDone( "win_safe1" ) ) then


    
    end;

  end;
  --*********************************************************************************************************************
  local win_safe1 = function ()

    if ( cmn.IsEventDone( "win_safe1" ) ) then

      ObjSet( "obj_safe1_drag_object", { input = false } );
      for i = 1, 5 do
        ObjSet( "txt_safe1_"..i, { alp = 1 } );
      end;

      ObjSet( "spr_safe1_handle", { input = true } );

    else

      private.Safe1Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_safe1", win_safe1_inv );
  cmn.AddSubscriber( "win_safe1", win_safe1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_cellar1_richard1_4 () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "dlg_cellar1_richard1_4" ] =
  --{
  --  type = "click",
  --  clk_obj = "obj_int_button_skull",
  --  room = "int_button_skull",
  --};
  -----------------------------------------------
  local dlg_cellar1_richard1_4_beg = function ()

  end;
  -----------------------------------------------
  local dlg_cellar1_richard1_4_end = function ()

    ObjDelete( "dlg_cellar1_richard1_4" );

  end;

  cmn.AddSubscriber( "dlg_cellar1_richard1_4",     dlg_cellar1_richard1_4_beg );
  cmn.AddSubscriber( "dlg_cellar1_richard1_4",     dlg_cellar1_richard1_4_end );
  cmn.AddSubscriber( "dlg_cellar1_richard1_4_beg", dlg_cellar1_richard1_4_beg );
  cmn.AddSubscriber( "dlg_cellar1_richard1_4_end", dlg_cellar1_richard1_4_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_1_7()

  int.AddScreensaver( "spr_cellartable1_screensaver_1_7" );

end;    
  
-----------------------------------------------------------------------
function private.get_collect_1_4 ()

  int.AddCollectibles( "spr_cellar1_collect_1_4" );

end;
-----------------------------------------------------------------------
function private.clk_safe1_handle ()

  int.Lock( true );
  cmn.CallEventHandler( "clk_safe1_handle_inv" );
  cmn.CallEventHandler( "clk_safe1_handle_beg" );

  local func_end = function ()

    cmn.SetEventDone( "clk_safe1_handle" );
    cmn.CallEventHandler( "clk_safe1_handle_end" );
    cmn.CloseSubRoom();

  end;

  ObjAnimate( "obj_safe1_handle1", "ang", 0, 0, func_end, 
  { 
    0.0, 3, 0, 
    0.3, 3, 0.5,
    0.9, 3, 0.5
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_safe_win" );

end;
-----------------------------------------------------------------------
function private.get_finefile1 ()

  cmn.SetEventDone( "get_finefile1" );
  cmn.CallEventHandler( "get_finefile1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_portrait1_2 ()

  cmn.SetEventDone( "get_portrait1_2" );
  cmn.CallEventHandler( "get_portrait1_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_parchmentamulet1_1 ()

  cmn.SetEventDone( "get_parchmentamulet1_1" );
  cmn.CallEventHandler( "get_parchmentamulet1_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_blank1 ()

  cmn.SetEventDone( "get_blank1" );
  cmn.CallEventHandler( "get_blank1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_emptyoilcan1 ()

  cmn.SetEventDone( "get_emptyoilcan1" );
  cmn.CallEventHandler( "get_emptyoilcan1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_list1 ()

  cmn.SetEventDone( "get_list1" );
  cmn.CallEventHandler( "get_list1" );
  cmn.GetObjectSfx();

  if ( not cmn.IsEventDone( "get_feather1" ) ) then

    private.get_feather1();

  end;

end;
-----------------------------------------------------------------------
function private.get_keypicture1 ()

  cmn.SetEventDone( "get_keypicture1" );
  cmn.CallEventHandler( "get_keypicture1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_feather1 ()

  cmn.SetEventDone( "get_feather1" );
  cmn.CallEventHandler( "get_feather1" );
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function public.use_pin1 ()

  local item = "inv_pin1";

  if ( cmn.ApplyObj( item, "obj_cellar1_use_pin1", true ) and 
           cmn.IsEventDone( "use_key1" ) ) then

    cmn.CallEventHandler( "use_pin1_inv" );
    cmn.CallEventHandler( "use_pin1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_pin1" );
      cmn.CallEventHandler( "use_pin1_end" );

    end;

    int.Lock( true );

    AnimPlay( "anm_cellar1_az_open_chest", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rm_cellar1_box_small" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_key1 ()

  local item = "inv_key1";

  if ( cmn.ApplyObj( item, "obj_cellar1_use_key1", true ) ) then

    cmn.CallEventHandler( "use_key1_inv" );
    cmn.CallEventHandler( "use_key1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_key1" );
      cmn.CallEventHandler( "use_key1_end" );

    end;

    int.Lock( true );

    AnimPlay( "anm_cellar1_chest_az_key", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rm_cellar1_box_big" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_oil1 ()

  local item = "inv_oil1";

  if ( cmn.ApplyObj( item, "gzz_cellar1_safe1", false ) and 
       cmn.IsEventDone( "get_blank1" ) and
       not cmn.IsEventDone( "use_oil1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_safe1", nil, { 512, 384 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_safe1_use_oil1", true ) and 
           cmn.IsEventDone( "get_blank1" ) and
           not cmn.IsEventDone( "use_oil1" ) ) then

    cmn.CallEventHandler( "use_oil1_inv" );
    cmn.CallEventHandler( "use_oil1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_oil1" );
      cmn.CallEventHandler( "use_oil1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_safe1_use_oil", { alp = 1, pos_z = 35 } );
    AnimPlay( "anm_safe1_use_oil", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_safe_liguid" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_portrait1 ()

  local item = "inv_portrait1";

  if ( cmn.ApplyObj( item, "gzz_cellar1_safe1", false ) and 
       cmn.IsEventDone( "use_oil1" ) and 
       cmn.IsEventDone( "get_portrait1_1" ) and 
       cmn.IsEventDone( "get_portrait1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_safe1", nil, { 512, 384 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_safe1_use_portrait1", true ) and 
           cmn.IsEventDone( "use_oil1" ) and 
           cmn.IsEventDone( "get_portrait1_1" ) and 
           cmn.IsEventDone( "get_portrait1_2" ) ) then

    cmn.CallEventHandler( "use_portrait1_inv" );
    cmn.CallEventHandler( "use_portrait1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_portrait1" );
      cmn.CallEventHandler( "use_portrait1_end" );

      private.Safe1StartInit();

    end;

    int.Lock( true );

    ObjSet( "anm_safe1_use_portrait", { alp = 1 } );
    AnimPlay( "anm_safe1_use_portrait", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_safe_mmg_safe" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
function public.use_parchmentamulet1 ()

  local item = "inv_parchmentamulet1";

  if ( cmn.ApplyObj( item, "gzz_cellar1_cellartable1", false ) ) and
     ( cmn.IsEventDone( "get_parchmentamulet1_1" ) ) and
     ( cmn.IsEventDone( "get_parchmentamulet1_2" ) ) and
     ( cmn.IsEventDone( "get_parchmentamulet1_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cellartable1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cellartable1_use_parchmentamulet1", true ) ) and
         ( cmn.IsEventDone( "get_parchmentamulet1_1" ) ) and
         ( cmn.IsEventDone( "get_parchmentamulet1_2" ) ) and
         ( cmn.IsEventDone( "get_parchmentamulet1_3" ) ) then

    cmn.CallEventHandler( "use_parchmentamulet1_inv" );
    cmn.CallEventHandler( "use_parchmentamulet1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_parchmentamulet1" );
      cmn.CallEventHandler( "use_parchmentamulet1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_cellartable1_door_open", { alp = 1 } );
    AnimPlay( "anm_cellartable1_door_open", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_zz_cellartable1_insert_open" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_letter1 ()

  local item = "inv_letter1";

  if ( cmn.ApplyObj( item, "gzz_cellar1_cellartable1", false ) ) and
     ( cmn.IsEventDone( "use_parchmentamulet1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cellartable1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cellartable1_use_letter1", true ) ) and
         ( cmn.IsEventDone( "use_parchmentamulet1" ) ) then

    cmn.CallEventHandler( "use_letter1_inv" );
    cmn.CallEventHandler( "use_letter1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_letter1" );
      cmn.CallEventHandler( "use_letter1_end" );

      if ( cmn.IsEventDone( "use_reagents1" ) ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mgdocument1" );

      end;

    end;

    int.Lock( true );

    ObjAnimate( "spr_cellartable1_letter1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0,
      0.5, 0, 1.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_put_paper_machine" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_reagents1 ()

  local item = "inv_reagents1";

  if ( cmn.ApplyObj( item, "gzz_cellar1_cellartable1", false ) ) and
     ( cmn.IsEventDone( "use_parchmentamulet1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cellartable1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cellartable1_use_reagents1", true ) ) and
         ( cmn.IsEventDone( "use_parchmentamulet1" ) ) then

    cmn.CallEventHandler( "use_reagents1_inv" );
    cmn.CallEventHandler( "use_reagents1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_reagents1" );
      cmn.CallEventHandler( "use_reagents1_end" );

      if cmn.IsEventDone( "use_letter1" ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mgdocument1" );

      end;

    end;

    int.Lock( true );

    AnimPlay( "anm_cellartable1_reagents", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_fill_perfume_machine" );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.dlg_cellar1_richard1_4 ()

  local func_before_end = function ( func_end )

    cmn.GetObjectSfx();
    cmn.CallEventHandler( "get_parchmentamulet1_3" );
    ObjSet( "txt_inv_parchmentamulet1_count", { text = "1/3" } );

    ObjSet( "anm_cellar1_richard1_4_richard_static_1",      { alp = 0 } );
    ObjSet( "anm_cellar1_richard1_4_richard_static_2",      { alp = 0 } );
    ObjSet( "anm_cellar1_richard1_4_richard_static_3",      { alp = 0 } );
    ObjSet( "anm_cellar1_richard1_4_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_cellar1_richard1_4_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_cellar1_richard1_4_richard_static_1" );
    AnimStop( "anm_cellar1_richard1_4_richard_static_2" );
    AnimStop( "anm_cellar1_richard1_4_richard_static_3" );
    AnimStop( "anm_cellar1_richard1_4_richard_appearance" );

    ObjAnimate( "anm_cellar1_richard1_4_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );
    
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_cellar1_richard1_4_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_parchmentamulet1_3" );
      cmn.SetEventDone( "dlg_cellar1_richard1_4" );
      level1_inv.CheckParchmentamulet1();

      int.InventoryItemAdd( "inv_richardskull1" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_cellar1_richard1_4_richard_appearance" );
    ObjSet( "anm_cellar1_richard1_4_richard_appearance", { alp = 0 } );

    ObjSet( "anm_cellar1_richard1_4_richard_static_1", { alp = 1 } );
    AnimPlay( "anm_cellar1_richard1_4_richard_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard1_4", "cellar1", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_cellar1_richard1_4_beg" );
  ObjAttach( "dlg_cellar1_richard1_4", GetCurrentRoom() );  

  ObjSet( "anm_cellar1_richard1_4_richard_appearance", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );
  AnimPlay( "anm_cellar1_richard1_4_richard_appearance", "DoAnim", func_anim_end );

  ObjAnimate( "anm_cellar1_richard1_4_richard_static_1", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull1" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard1_4" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_cellar1_richard1_4_richard_static_1" );
        AnimPlay( "anm_cellar1_richard1_4_richard_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_cellar1_richard1_4_richard_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_cellar1_richard1_4_richard_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

--    if ( count_txt == 3 ) then
--
--      int.Lock( true );
--
--      local func_end = function ()
--
--        int.Lock( false );
--
--        AnimStop( "anm_cellar1_richard1_4_richard_static_2" );
--        AnimPlay( "anm_cellar1_richard1_4_richard_static_3", "DoAnim", "" );
--
--      end;
--
--      ObjAnimate( "anm_cellar1_richard1_4_richard_static_2", "alp", 0, 0, "",
--      {
--        0.0, 3, 1.0,
--        0.3, 3, 0.0,
--      } );
--
--      ObjAnimate( "anm_cellar1_richard1_4_richard_static_3", "alp", 0, 0, func_end,
--      {
--        0.0, 3, 0.0,
--        0.3, 3, 1.0,
--      } );
--
--    end;

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_cellar1_richard1_4_richard_static_2" );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_creates_cups" );
        AnimPlay( "anm_cellar1_richard1_4_richard_give", "DoAnim", "" );
        AnimPlay( "anm_cellar1_richard1_4_object_appearance", "DoAnim", "" );

        ObjAnimate( "spr_cellar1_parchmentamulet1_3", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_cellar1_richard1_4_richard_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_cellar1_richard1_4_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_cellar1 ()

  if not ( cmn.IsEventDone( "opn_cellar1" ) ) then

    cmn.SetEventDone( "opn_cellar1" );

  end;

  if ( not cmn.IsEventDone( "dlg_cellar1_richard1_4" ) ) then

    private.dlg_cellar1_richard1_4();

  end;

  cmn.StopAllEnv( "audio/level1/env/aud_rm_cellar1_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_rm_cellar1_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_cellar1();

  if ( cmn.IsEventDone( "win_hosafe1" ) ) and
     ( not ng_global.progress[ ng_global.currentprogress ][ "opn_cellar1" ].bbt_ho ) then

    cmn.ShowBbt( "bbt_cellar1_hosafe1" );
    ng_global.progress[ ng_global.currentprogress ][ "opn_cellar1" ].bbt_ho = true;

  end;
  
  if ( cmn.IsEventDone( "get_fakedocument1" ) and iOS_IsBought() == 0 ) then
    iOS_LogEvents(1);
    common.LevelSwitch("menu","unlock");
  end;

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_finefile1",                                      { "dlg_cellar1_richard1_4" }  );
  int.AddedTaskMap( private.room_objname, "get_portrait1_2",                                    { "use_pin1" } );
  int.AddedTaskMap( private.room_objname, "get_parchmentamulet1_1",                             { "use_key1" } );
  int.AddedTaskMap( private.room_objname, "get_parchmentamulet1_3",                             { "dlg_cellar1_richard1_4" }  );
  int.AddedTaskMap( private.room_objname, "get_blank1",                                         { "dlg_cellar1_richard1_4" }  );
  int.AddedTaskMap( private.room_objname, "get_emptyoilcan1",                                   { "dlg_cellar1_richard1_4" }  );
  int.AddedTaskMap( private.room_objname, "get_list1",                                          { "use_parchmentamulet1" } );
  int.AddedTaskMap( private.room_objname, "get_keypicture1",                                    { "dlg_cellar1_richard1_4" }  );
  int.AddedTaskMap( private.room_objname, "get_fakedocument1",                                  { "win_mgdocument1" } );
  int.AddedTaskMap( private.room_objname, "get_feather1",                                       { "use_parchmentamulet1" } );

  int.AddedTaskMap( private.room_objname, "use_pin1",                                           { "get_pin1", "use_key1" } );
  int.AddedTaskMap( private.room_objname, "use_key1",                                           { "get_key1" } );
  int.AddedTaskMap( private.room_objname, "use_oil1",                                           { "get_oil1" } );
  int.AddedTaskMap( private.room_objname, "use_portrait1",                                      { "get_portrait1_1", "get_portrait1_2", "use_oil1" } );
  int.AddedTaskMap( private.room_objname, "use_parchmentamulet1",                               { "get_parchmentamulet1_1", "get_parchmentamulet1_2", "get_parchmentamulet1_3" } );
  int.AddedTaskMap( private.room_objname, "use_letter1",                                        { "get_letter1", "use_parchmentamulet1" } );
  int.AddedTaskMap( private.room_objname, "use_reagents1",                                      { "get_reagents1", "use_parchmentamulet1" } );

  int.AddedTaskMap( private.room_objname, "clk_safe1_handle",                                   { "win_safe1" } );

  int.AddedTaskMap( private.room_objname, "win_hosafe1",                                        { "clk_safe1_handle" } );
  int.AddedTaskMap( private.room_objname, "win_safe1",                                          { "use_portrait1" } );
  int.AddedTaskMap( private.room_objname, "win_mgdocument1",                                    { "use_letter1", "use_reagents1" } );
  
  int.AddedTaskMap( private.room_objname, "dlg_cellar1_richard1_4" );
  
end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_safe1" );
  -------------------------------------------------
  function zz_safe1.Open()
    
    if ( cmn.IsEventStart( "win_safe1" ) and not cmn.IsEventDone( "win_safe1" ) ) then

      cmn.MiniGameShow( "safe1" );
      common_impl.PassingMgStart( "safe1" );

    end;

  end;
  -------------------------------------------------
  function zz_safe1.PreClose()
        
    if ( cmn.IsEventStart( "win_safe1" ) and not cmn.IsEventDone( "win_safe1" ) ) then

      cmn.MiniGameHide( "safe1" );
      common_impl.PassingMgStop( "safe1" );

    end;
    
  end;
  -------------------------------------------------
  function zz_safe1.Skip ()

    if ( cmn.IsEventStart( "win_safe1" ) and not cmn.IsEventDone( "win_safe1" ) ) then
      private.Safe1Skip();
    end;

  end;
  -------------------------------------------------
  function zz_safe1.Reset ()

    if ( cmn.IsEventStart( "win_safe1" ) and not cmn.IsEventDone( "win_safe1" ) ) then
      private.Safe1Reset();
    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_safe1_circle_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.Cellartable1DoorClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_cellartable1_use_parchmentamulet1" );

  end;

  int.Lock( true );
  AnimPlay( "anm_cellartable1_door_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_zz_cellartable1_box" );

end;
--*********************************************************************************************************************
function private.Safe1CircleClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_safe1_clk_roller" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_safe1_nimeral" );
  AnimPlay( "anm_safe1_circle_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Safe1HandleClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_safe1_clk_lever" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_safe1_handle" );
  AnimPlay( "anm_safe1_handle_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Safe1OilClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_safe1_use_oil1" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_safe1_hidden_cell" );
  AnimPlay( "anm_safe1_oil_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Safe1PortraitClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_safe1_use_portrait1" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_safe1_hidden_cell_2" );
  AnimPlay( "anm_safe1_portrait_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Safe1 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Safe1StartInit ()

    cmn.MiniGameShow( "safe1" );
    common_impl.PassingMgStart( "safe1" );
    ng_global.progress[ "std" ][ "win_safe1" ].win = 1;
    ng_global.progress[ "std" ][ "win_safe1" ].ang = 0;

  end;
--*********************************************************************************************************************
  function private.Safe1Init ()

    ObjSet( "obj_safe1_drag_object",
    {
      event_startdrag = function () private.Safe1StartDrag()  end,
      event_drag = function () private.Safe1Drag() end,
      event_dragdrop = function () private.Safe1Drop() end,
    } );

    private.code = { { "L", 1.17 }, { "R", 4.36 }, { "L", 0.65 }, { "R", 0 }, { "L", 5.01 } };

  end;
--*********************************************************************************************************************
  function private.Safe1Skip ()

    private.Safe1Win(); 

  end;
--*********************************************************************************************************************
  function private.Safe1Reset ()

    ng_global.progress[ "std" ][ "win_safe1" ].win = 1;
    ng_global.progress[ "std" ][ "win_safe1" ].ang = 0;

    ObjSet( "obj_safe1_drag_object", { ang = 0 } );
    ObjSet( "obj_safe1_circle", { ang = 0 } );
    ObjSet( "spr_safe1_over_circle_1", { ang = 0 } );

    for i = 1, 5 do
      ObjSet( "txt_safe1_"..i, { alp = 0 } );
    end;

  end;
--*********************************************************************************************************************
  function private.Safe1Load ()

    local stage = ng_global.progress[ "std" ][ "win_safe1" ].win;

    if stage ~= 1 then
      for i = 1, stage - 1 do
        ObjSet( "txt_safe1_"..i, { alp = 1 } );
      end; 
    end; 

    ObjSet( "obj_safe1_drag_object", { ang = ng_global.progress[ "std" ][ "win_safe1" ].ang } );
    ObjSet( "obj_safe1_circle", { ang = ng_global.progress[ "std" ][ "win_safe1" ].ang } );
    ObjSet( "spr_safe1_over_circle_1", { ang = ng_global.progress[ "std" ][ "win_safe1" ].ang } );

  end;
----------------------------------------------------------------------------------------------
    private.switch_sound = false;
--*********************************************************************************************************************
  function private.Safe1StartDrag()
    
    private.coords_begin = GetZoomCursorPos();
    private.coords_begin = { private.coords_begin[ 1 ] - 512, private.coords_begin[ 2 ] - 360 };
    private.dragobj_coords = { ObjGet( "obj_safe1_circle" ).pos_x, ObjGet( "obj_safe1_circle" ).pos_y };

    private.circle_ang = ObjGet( "obj_safe1_circle" ).ang;
    private.old_ang   = math.atan2( private.coords_begin[ 1 ] - private.dragobj_coords[ 1 ], private.coords_begin[ 2 ] - private.dragobj_coords[ 2 ] );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_safe_loop", 1 );
    private.switch_sound = true; 
    
  end;
----------------------------------------------------------------------------------------------
  function private.Safe1Drag()

    local cur_pos = GetZoomCursorPos();
    cur_pos = { cur_pos[ 1 ] - 512, cur_pos[ 2 ] - 360 }; 

    if ( private.coords_begin[ 1 ] ~= cur_pos[ 1 ] ) or ( private.coords_begin[ 2 ] ~= cur_pos[ 2 ] ) then--если мы двигаем мышкой

      if not private.switch_sound then
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_safe_loop", 1 );
        private.switch_sound = true;
      end;  
      local new_ang = math.atan2( cur_pos[1] - private.dragobj_coords[ 1 ], cur_pos[2] - private.dragobj_coords[ 2 ] );
      local k = 1;
      local ang_diff = ( new_ang - private.old_ang ) * k;

      ObjSet( "obj_safe1_circle", { ang = private.circle_ang + ang_diff } );
      ObjSet( "spr_safe1_over_circle_1", { ang = private.circle_ang + ang_diff } );  

      private.old_ang = new_ang;  
      private.coords_begin = { cur_pos[ 1 ], cur_pos[ 2 ] };
      private.circle_ang = private.circle_ang + ang_diff;

      private.Safe1CheckWin( ang_diff );
      
    else 
      
      if private.switch_sound then
        cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mmg_safe_loop", 0.015 );
        private.switch_sound = false;
      end  
      
    end;

  end;
----------------------------------------------------------------------------------------------
  function private.Safe1Drop()
    
    ObjSet( "obj_safe1_drag_object", { ang = ObjGet( "obj_safe1_circle" ).ang } );
    ng_global.progress[ "std" ][ "win_safe1" ].ang = ObjGet( "obj_safe1_circle" ).ang;
    if private.switch_sound then
      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mmg_safe_loop", 0.015 );
      private.switch_sound = false;
    end;
    
  end;
----------------------------------------------------------------------------------------------
  function private.Safe1CheckWin( ang_diff )

    local dir = "L"; 
    
    if ang_diff < 0 then
      dir = "R";
    end; 

    local stage = ng_global.progress[ "std" ][ "win_safe1" ].win;  

    if dir == private.code[ stage ][ 1 ] then
      
      local cur_ang = private.circle_ang;
    
      if cur_ang > 6.28 or cur_ang < - 6.28 then
        
        local whole = math.modf( cur_ang / 6.28 );--выделение целой части
        cur_ang = cur_ang - whole * 6.28;
             
      end;  

      local win_ang = private.code[ stage ][ 2 ];
      local allowed_error = 0.05;--допустимая погрешность
      
      if ( ( cur_ang < ( win_ang + allowed_error ) and cur_ang > ( win_ang - allowed_error ) ) or
           ( cur_ang < ( win_ang - 6.28 ) + allowed_error and cur_ang > ( win_ang - 6.28 ) - allowed_error ) ) then

        ObjSet( "txt_safe1_"..stage, { alp = 1 } );
        cmn.StopAudio( "sfx", "audio/level1/sfx/aud_mmg_safe_loop", 0.015 );  
        ObjStopDrag( "obj_safe1_drag_object" );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_safe_catch" );
        
        if ng_global.progress[ "std" ][ "win_safe1" ].win == 5 then
          private.Safe1Win();
        else 
          ng_global.progress[ "std" ][ "win_safe1" ].win = ng_global.progress[ "std" ][ "win_safe1" ].win + 1;
        end;

      end; 
      
    end;  

  end;
--*********************************************************************************************************************
  function private.Safe1Win () 
    
    cmn.MiniGameHide( "safe1" );
    cmn.SetEventDone( "win_safe1" );
    cmn.CallEventHandler( "win_safe1" );
    common_impl.PassingMgWin( "safe1" );
     
  end;
--*********************************************************************************************************************