-- name=rm_demo
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "rm_demo";
  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet( "btn_demo_buttons", { 
    event_mdown = function () private.ButtonMouseClick(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end 
  });
  
  if IsSurveyEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_survey" } );

  elseif IsDemoEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_demo" } );

  elseif ( cmn.IsFP ) then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_fp" } );

  end; 

  private.Anims();
  
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  
  if not ( IsSurveyEdition() or IsDemoEdition() or cmn.IsFP ) then
    
    cmn.SetCursor(CURSOR_DEFAULT);
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level2";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );

  else
    
    cmn.StopAllEnv( "audio/level1/env/aud_env_end_of_the_game_1_lvl", true );
    cmn.PlayAudio( "env", "audio/level1/env/aud_env_end_of_the_game_1_lvl", 1, 2 );
  
    if ( IsCollectorsEdition() ) then

      ObjSet( "spr_demo_collectors", { visible = 1 } );

    end;

  end;  

end;
--*********************************************************************************************************************
function public.PreOpen()

--  if ( (IsSurveyEdition() == 1 ) or ( IsDemoEdition() == 1) ) then
--
    ObjAnimate( "rm_demo", "color_rgb", 0, 0, "", 
    { 
      0.0, 0, 0, 0, 0,
      0.3, 0, 0, 0, 0,
      0.5, 0, 1, 1, 1
    } );

    common_impl.InterfaceSetVisible( false );
--
--  else
--
--    DbgTrace("enter")
--    ObjSet( "rm_demo", 
--    { 
--      color_r = 0.0,
--      color_g = 0.0,
--      color_b = 0.0
--    } );
--
--
--  end;
  
end;
--*********************************************************************************************************************
function public.Close()
    common_impl.InterfaceSetVisible( true );  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.ButtonMouseEnter()

  cmn.SetCursor( CURSOR_HAND );  
  local but_name = "spr_demo_ok_focus";
  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - but_alp ) ), 0, 1 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseLeave()

  cmn.SetCursor( CURSOR_DEFAULT );  
  local but_name = "spr_demo_ok_focus";
  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * but_alp ), 0, 0 } );
  
end;
--*********************************************************************************************************************
function private.ButtonMouseClick()

  if ( IsSurveyEdition() ) then

    Quit();

  else

    SaveProfiles();
    SaveSettings();

--  common.SaveInterfaceTimers();
    cmn.SetCursor( CURSOR_DEFAULT );
    common.LevelSwitch( "menu", "game" );

  end;  

end;
--*********************************************************************************************************************
function private.Anims ()

end;
--*********************************************************************************************************************