-- name=rm_greywitchgates1
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_greywitchgates1";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_van1",    "room_hub" );
  ObjAttach( "zz_bushes1", "room_hub" );
  ObjAttach( "zz_gates1",  "room_hub" );
  ObjAttach( "zz_tree1",   "room_hub" );

  ObjMultiSet(
  {
    { "spr_van1_bagamulet1_1",       { event_mdown = private.get_bagamulet1_1 } },
    { "spr_bushes1_ladybag1",        { event_mdown = private.get_ladybag1 } },
    { "spr_bushes1_richardskull1",   { event_mdown = private.get_richardskull1 } },
    { "spr_bushes1_ingredients1_2",  { event_mdown = private.get_ingredients1_2 } },
    { "spr_bushes1_letters1_3",      { event_mdown = private.get_letters1_3 } },
    { "spr_gates1_bagamulet1_2",     { event_mdown = private.get_bagamulet1_2 } },
    { "spr_tree1_keys1",             { event_mdown = private.get_keys1 } },
    { "spr_tree1_horseamulet1_1",    { event_mdown = private.get_horseamulet1_1 } },
    { "spr_tree1_letters1_2",        { event_mdown = private.get_letters1_2 } },
    { "spr_tree1_ingredients1_1",    { event_mdown = private.get_ingredients1_1 } },
    { "obj_van1_clk_keys1",          { event_mdown = private.clk_keys1 } },
    { "obj_van1_use_keys1",          { event_mdown = private.Van1HandleClick } },
    { "obj_tree1_use_nuts1",         { event_mdown = private.Tree1SquirrelClick } },
    { "obj_gates1_use_gatesamulet1", { event_mdown = private.Gates1BonesClick } },
    { "obj_bushes1_use_gloves1",     { event_mdown = function() private.Bushes1ThornsClk() end } },
    { "obj_tree1_use_sickle1_2",     { event_mdown = private.Tree1RopeClick } },
    { "obj_tree1_use_crossamulet1",  { event_mdown = private.Tree1ChestClick } },
    { "spr_bushes1_screensaver_1_8",     { event_mdown = private.get_screensaver_1_8 } },      
    { "spr_tree1_screensaver_1_9",     { event_mdown = private.get_screensaver_1_9 } },          
    --
    --
  } );

  local get_screensaver_1_8 = function ()

    ObjDelete( "spr_bushes1_screensaver_1_8" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_8", get_screensaver_1_8, private.room_objname );  
  local get_screensaver_1_9 = function ()

    ObjDelete( "spr_tree1_screensaver_1_9" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_9", get_screensaver_1_9, private.room_objname );    
  
  private.Gates1Init();
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_greywitchgates1 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_greywitchgates1", update_game_mode_greywitchgates1, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_7 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_7 = function ()

    ObjDelete( "obj_greywitchgates1_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_7", get_morphobject_1_7, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_gatesamulet1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gatesamulet1_2" ] =
  {
    type = "get",
    get_obj = "spr_greywitchgates1_gatesamulet1_2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local get_gatesamulet1_2_inv = function ()

    int.InventoryItemAdd( "inv_gatesamulet1", "spr_greywitchgates1_gatesamulet1_2", "assets/levels/level1/common_inventory1/inv_bag1/inv/inv_gatesamulet1_2" );
    level1_inv.CheckGatesamulet1();

  end;

  cmn.AddSubscriber( "get_gatesamulet1_2", get_gatesamulet1_2_inv );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_bagamulet1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bagamulet1_1" ] =
  {
    type = "get",
    get_obj = "spr_van1_bagamulet1_1",
    room = private.room_objname,
    zz = "zz_van1",
    zz_gate = "gzz_greywitchgates1_van1"
  };
  -----------------------------------------------
  local get_bagamulet1_1_inv = function ()

    int.InventoryItemAdd( "inv_bagamulet1", "spr_van1_bagamulet1_1", "assets/levels/level1/rm_greywitchgates1/zz_van1/inv/inv_bagamulet1_1" );
    level1_inv.CheckBagamulet1();

    if cmn.IsEventDone( "get_ladybag1" ) and cmn.IsEventDone( "get_bagamulet1_2" ) then

      ObjSet( "inv_ladybag1_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_bagamulet1_1_closezz = function ()

    ObjDelete( "gfx_van1_bagamulet1_1" );
    ObjDelete( "spr_greywitchgates1_van_bagamulet" );
    ObjDelete( "spr_van1_bagamulet1_1_shadow" );

  end;

  cmn.AddSubscriber( "get_bagamulet1_1", get_bagamulet1_1_inv );
  cmn.AddSubscriber( "get_bagamulet1_1", get_bagamulet1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ladybag1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ladybag1" ] =
  {
    type = "get",
    get_obj = "spr_bushes1_ladybag1",
    room = private.room_objname,
    zz = "zz_bushes1",
    zz_gate = "gzz_greywitchgates1_bushes1"
  };
  -----------------------------------------------
  local get_ladybag1_inv = function ()

    int.InventoryItemAdd( "inv_ladybag1", "spr_bushes1_ladybag1", "assets/levels/level1/rm_greywitchgates1/zz_bushes1/inv/inv_ladybag1" );
    ObjSet( "inv_ladybag1", { drag = false } );

    if ( not cmn.IsEventDone( "get_bagamulet1_1" ) )  or 
       ( not cmn.IsEventDone( "get_bagamulet1_2" ) ) then

      ObjSet( "inv_ladybag1_plus_focus2", { alp = 0 } );

    end;

  end;

  local get_ladybag1_closezz = function ()

    ObjDelete( "gfx_bushes1_ladybag1" );
    ObjDelete( "spr_greywitchgates1_ladybag" );

  end;

  cmn.AddSubscriber( "get_ladybag1", get_ladybag1_inv );
  cmn.AddSubscriber( "get_ladybag1", get_ladybag1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_richardskull1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_richardskull1" ] =
  {
    type = "get",
    get_obj = "spr_bushes1_richardskull1",
    room = private.room_objname,
    zz = "zz_bushes1",
    zz_gate = "gzz_greywitchgates1_bushes1"
  };
  -----------------------------------------------
  local get_richardskull1_inv = function ()

    int.InventoryItemAdd( "inv_richardskull1", "spr_bushes1_richardskull1" );

  end;

  local get_richardskull1_closezz = function ()

    ObjDelete( "gfx_bushes1_richardskull1" );
    ObjDelete( "spr_greywitchgates1_richardskull" );

  end;

  cmn.AddSubscriber( "get_richardskull1", get_richardskull1_inv );
  cmn.AddSubscriber( "get_richardskull1", get_richardskull1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ingredients1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ingredients1_2" ] =
  {
    type = "get",
    get_obj = "spr_bushes1_ingredients1_2",
    room = private.room_objname,
    zz = "zz_bushes1",
    zz_gate = "gzz_greywitchgates1_bushes1"
  };
  -----------------------------------------------
  local get_ingredients1_2_inv = function ()

    int.InventoryItemAdd( "inv_ingredients1_2", "spr_bushes1_ingredients1_2" );

  end;

  local get_ingredients1_2_closezz = function ()

    ObjDelete( "gfx_bushes1_ingredients1_2" );

    ObjDelete( "spr_greywitchgates1_chalk" );
    --ObjDelete( "gzz_greywitchgates1_bushes1" );

  end;

  cmn.AddSubscriber( "get_ingredients1_2", get_ingredients1_2_inv );
  cmn.AddSubscriber( "get_ingredients1_2", get_ingredients1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letters1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_letters1_3" ] =
  {
    type = "get",
    get_obj = "spr_bushes1_letters1_3",
    room = private.room_objname,
    zz = "zz_bushes1",
    zz_gate = "gzz_greywitchgates1_bushes1"
  };
  -----------------------------------------------
  local get_letters1_3_inv = function ()

    int.InventoryItemAdd( "inv_letters1", "spr_bushes1_letters1_3", "assets/levels/level1/rm_ruinedsquare1/zz_ritualplace1/inv/inv_letters1_3" );
    level1_inv.CheckLetters1();

  end;

  local get_letters1_3_closezz = function ()

    ObjDelete( "gfx_bushes1_letters1_3" );
    ObjDelete( "spr_greywitchgates1_bushes_letter" );
    --ObjDelete( "gzz_greywitchgates1_bushes1" );

  end;

  cmn.AddSubscriber( "get_letters1_3", get_letters1_3_inv );
  cmn.AddSubscriber( "get_letters1_3", get_letters1_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_auratrace1_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_auratrace1_5" ] =
  {
    type = "use",
    use_obj = "inv_soulphial1",
    use_place = "obj_bushes1_auratrace_get",
    room = private.room_objname,
    zz = "zz_bushes1",
    zz_gate = "gzz_greywitchgates1_bushes1"
  };
  -----------------------------------------------
  local get_auratrace1_5_inv = function ()

    int.InventoryItemAdd( "inv_soulphial1", "obj_bushes1_auratrace_get", "assets/levels/level1/rm_greywitchgates1/inv/inv_auratrace1_5", function () int.Lock( false ); end );
    level1_inv.CheckAuratrace1();

  end;

  local get_auratrace1_5_closezz = function ()

    ObjDelete( "gfx_bushes1_auratrace1_5" );
    ObjDelete( "anm_bushes1_aura_5_static" );
    ObjDelete( "gzz_greywitchgates1_bushes1" );
    ObjDelete( "spr_greywitchgates1_bushes_auratrace_2" );

  end;

  cmn.AddSubscriber( "get_auratrace1_5", get_auratrace1_5_inv );
  cmn.AddSubscriber( "get_auratrace1_5", get_auratrace1_5_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bagamulet1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bagamulet1_2" ] =
  {
    type = "get",
    get_obj = "spr_gates1_bagamulet1_2",
    room = private.room_objname,
    zz = "zz_gates1",
    zz_gate = "gzz_greywitchgates1_gates1"
  };
  -----------------------------------------------
  local get_bagamulet1_2_inv = function ()

    int.InventoryItemAdd( "inv_bagamulet1", "spr_gates1_bagamulet1_2", "assets/levels/level1/rm_greywitchgates1/zz_van1/inv/inv_bagamulet1_2" );
    level1_inv.CheckBagamulet1();

    if cmn.IsEventDone( "get_ladybag1" ) and cmn.IsEventDone( "get_bagamulet1_1" ) then

      ObjSet( "inv_ladybag1_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_bagamulet1_2_closezz = function ()

    ObjDelete( "gfx_gates1_bagamulet1_2" );
    ObjDelete( "spr_greywitchgates1_gates_bagamulet" );
    --ObjDelete( "gzz_greywitchgates1_gates1" );

  end;

  cmn.AddSubscriber( "get_bagamulet1_2", get_bagamulet1_2_inv );
  cmn.AddSubscriber( "get_bagamulet1_2", get_bagamulet1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_auratrace1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_auratrace1_1" ] =
  {
    type = "use",
    use_obj = "inv_soulphial1",
    use_place = "obj_greywitchgates1_auratrace_get1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_auratrace1_1_inv = function ()

    int.InventoryItemAdd( "inv_soulphial1", "obj_greywitchgates1_auratrace_get1", "assets/levels/level1/rm_greywitchgates1/inv/inv_auratrace1_1", function () int.Lock( false ); end );
    level1_inv.CheckAuratrace1();

  end;

  local get_auratrace1_1_closezz = function ()

    ObjDelete( "gfx_greywitchgates1_auratrace1_1" );
    ObjDelete( "obj_greywitchgates1_auratrace_1" );

    if cmn.IsEventDone( "get_auratrace1_2" ) then
      ObjDelete( "obj_greywitchgates1_auratraces" );
    end;

    --ObjDelete( "gzz_greywitchgates1_gates1" );

  end;

  cmn.AddSubscriber( "get_auratrace1_1", get_auratrace1_1_inv );
  cmn.AddSubscriber( "get_auratrace1_1", get_auratrace1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_auratrace1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_auratrace1_2" ] =
  {
    type = "use",
    use_obj = "inv_soulphial1",
    use_place = "obj_greywitchgates1_auratrace_get2",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_auratrace1_2_inv = function ()

    int.InventoryItemAdd( "inv_soulphial1", "obj_greywitchgates1_auratrace_get2", "assets/levels/level1/rm_greywitchgates1/inv/inv_auratrace1_2", function () int.Lock( false ); end );
    level1_inv.CheckAuratrace1();

  end;

  local get_auratrace1_2_closezz = function ()

    ObjDelete( "gfx_greywitchgates1_auratrace1_2" );
    ObjDelete( "obj_greywitchgates1_auratrace_2" );
  
    if cmn.IsEventDone( "get_auratrace1_1" ) then
      ObjDelete( "obj_greywitchgates1_auratraces" );
    end;

  end;

  cmn.AddSubscriber( "get_auratrace1_2", get_auratrace1_2_inv );
  cmn.AddSubscriber( "get_auratrace1_2", get_auratrace1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_keys1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_keys1" ] =
  {
    type = "get",
    get_obj = "spr_tree1_keys1",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local get_keys1_inv = function ()

    int.InventoryItemAdd( "inv_keys1", "spr_tree1_keys1" );

  end;

  local get_keys1_closezz = function ()

    ObjDelete( "anm_tree1_squirrel_key_end" );

  end;

  cmn.AddSubscriber( "get_keys1", get_keys1_inv );
  cmn.AddSubscriber( "get_keys1", get_keys1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_horseamulet1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_horseamulet1_1" ] =
  {
    type = "get",
    get_obj = "spr_tree1_horseamulet1_1",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local get_horseamulet1_1_inv = function ()

    int.InventoryItemAdd( "inv_horseamulet1", "spr_tree1_horseamulet1_1", "assets/levels/level1/rm_greywitchgates1/zz_tree1/inv/inv_horseamulet1_1" );
    level1_inv.CheckHorseamulet1();

  end;

  local get_horseamulet1_1_closezz = function ()

    ObjDelete( "gfx_tree1_horseamulet1_1" );
    ObjDelete( "spr_greywitchgates1_horseamulet" );

    if ( cmn.IsEventDone( "get_auratrace1_6" ) ) then

      ObjDelete( "gzz_greywitchgates1_tree1" );

    end;

  end;

  cmn.AddSubscriber( "get_horseamulet1_1", get_horseamulet1_1_inv );
  cmn.AddSubscriber( "get_horseamulet1_1", get_horseamulet1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_letters1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_letters1_2" ] =
  {
    type = "get",
    get_obj = "spr_tree1_letters1_2",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local get_letters1_2_inv = function ()

    int.InventoryItemAdd( "inv_letters1", "spr_tree1_letters1_2", "assets/levels/level1/rm_ruinedsquare1/zz_ritualplace1/inv/inv_letters1_2" );
    level1_inv.CheckLetters1();

  end;

  local get_letters1_2_closezz = function ()

    ObjDelete( "gfx_tree1_letters1_2" );
    ObjDelete( "spr_greywitchgates1_tree_letter" );

  end;

  cmn.AddSubscriber( "get_letters1_2", get_letters1_2_inv );
  cmn.AddSubscriber( "get_letters1_2", get_letters1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ingredients1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ingredients1_1" ] =
  {
    type = "get",
    get_obj = "spr_tree1_ingredients1_1",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local get_ingredients1_1_inv = function ()

    int.InventoryItemAdd( "inv_ingredients1_1", "spr_tree1_ingredients1_1" );

  end;

  local get_ingredients1_1_closezz = function ()

    ObjDelete( "gfx_tree1_ingredients1_1" );
    ObjDelete( "spr_greywitchgates1_candles" );

  end;

  cmn.AddSubscriber( "get_ingredients1_1", get_ingredients1_1_inv );
  cmn.AddSubscriber( "get_ingredients1_1", get_ingredients1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_auratrace1_6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_auratrace1_6" ] =
  {
    type = "use",
    use_obj = "inv_soulphial1",
    use_place = "obj_tree1_auratrace_get",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local get_auratrace1_6_inv = function ()

    int.InventoryItemAdd( "inv_soulphial1", "obj_tree1_auratrace_get", "assets/levels/level1/rm_greywitchgates1/inv/inv_auratrace1_6", function () int.Lock( false ); end );
    level1_inv.CheckAuratrace1();

  end;

  local get_auratrace1_6_closezz = function ()

    ObjDelete( "gfx_tree1_auratrace1_6" );

    if ( cmn.IsEventDone( "get_horseamulet1_1" ) ) then

      ObjDelete( "gzz_greywitchgates1_tree1" );

    end;

    ObjDelete( "obj_tree1_auratrace" );
    ObjDelete( "spr_greywitchgates1_tree_auratrace_2" );

  end;

  cmn.AddSubscriber( "get_auratrace1_6", get_auratrace1_6_inv );
  cmn.AddSubscriber( "get_auratrace1_6", get_auratrace1_6_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_keys1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_keys1" ] =
  {
    type = "use",
    use_obj = "inv_keys1",
    use_place = "obj_van1_use_keys1",
    room = private.room_objname,
    zz = "zz_van1",
    zz_gate = "gzz_greywitchgates1_van1"
  };
  -----------------------------------------------
  local use_keys1_inv = function ()

    int.InventoryItemRemove( "inv_keys1" );

  end;
  local use_keys1_beg = function ()

    ObjDelete( "obj_van1_use_keys1" );

  end;
  local use_keys1_end = function ()

    ObjDelete( "anm_van1_key" );
    ObjSet( "anm_van1_key_end", { alp = 1, playing = true } );
    ObjSet( "obj_van1_clk_keys1", { input = true } );

    ObjSet( "spr_greywitchgates1_van_keys", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_keys1",     use_keys1_inv );
  cmn.AddSubscriber( "use_keys1",     use_keys1_beg, private.room_objname );
  cmn.AddSubscriber( "use_keys1",     use_keys1_end, private.room_objname );
  cmn.AddSubscriber( "use_keys1_inv", use_keys1_inv, private.room_objname );
  cmn.AddSubscriber( "use_keys1_beg", use_keys1_beg, private.room_objname );
  cmn.AddSubscriber( "use_keys1_end", use_keys1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gloves1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gloves1" ] =
  {
    type = "use",
    use_obj = "inv_gloves1",
    use_place = "obj_bushes1_use_gloves1",
    room = private.room_objname,
    zz = "zz_bushes1",
    zz_gate = "gzz_greywitchgates1_bushes1"
  };
  -----------------------------------------------
  local use_gloves1_inv = function ()

    int.InventoryItemRemove( "inv_gloves1" );

  end;
  local use_gloves1_beg = function ()

    ObjDelete( "obj_bushes1_use_gloves1" );

  end;
  local use_gloves1_end = function ()

    ObjDelete( "anm_bushes1_crow" );
    ObjDelete( "anm_bushes1_crow_over" );
    ObjDelete( "anm_bushes1_crow_static" );
    ObjDelete( "anm_bushes1_thorns" );
    ObjDelete( "anm_bushes1_thorns_click" );

    ObjSet( "obj_bushes1_use_spade1",           { input = true } );
    ObjSet( "obj_bushes1_use_mentalmagnifier1_5", { input = true } );
    ObjSet( "spr_bushes1_richardskull1",        { input = true } );
    ObjSet( "gfx_bushes1_richardskull1",        { active = true } );

    ObjDelete( "anm_greywitchgates1_bushes1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_gloves1",     use_gloves1_inv );
  cmn.AddSubscriber( "use_gloves1",     use_gloves1_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves1",     use_gloves1_end, private.room_objname );
  cmn.AddSubscriber( "use_gloves1_inv", use_gloves1_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloves1_beg", use_gloves1_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloves1_end", use_gloves1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spade1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spade1" ] =
  {
    type = "use",
    use_obj = "inv_spade1",
    use_place = "obj_bushes1_use_spade1",
    room = private.room_objname,
    zz = "zz_bushes1",
    zz_gate = "gzz_greywitchgates1_bushes1"
  };
  -----------------------------------------------
  local use_spade1_inv = function ()

    int.InventoryItemRemove( "inv_spade1" );

  end;
  local use_spade1_beg = function ()

    ObjDelete( "obj_bushes1_use_spade1" );

  end;
  local use_spade1_end = function ()

    ObjDelete( "spr_bushes1_ground" );
    ObjDelete( "anm_bushes1_use_spade" );
    ObjSet( "spr_bushes1_ingredients1_2", { input = true } );
    ObjSet( "gfx_bushes1_ingredients1_2", { active = true } );
    ObjSet( "spr_bushes1_letters1_3",     { input = true } );
    ObjSet( "gfx_bushes1_letters1_3",     { active = true } );

    ObjDelete( "spr_greywitchgates1_ground" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_spade1",     use_spade1_inv );
  cmn.AddSubscriber( "use_spade1",     use_spade1_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade1",     use_spade1_end, private.room_objname );
  cmn.AddSubscriber( "use_spade1_inv", use_spade1_inv, private.room_objname );
  cmn.AddSubscriber( "use_spade1_beg", use_spade1_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade1_end", use_spade1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mentalmagnifier1_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mentalmagnifier1_5" ] =
  {
    type = "use",
    use_obj = "inv_mentalmagnifier1",
    use_place = "obj_bushes1_use_mentalmagnifier1_5",
    room = private.room_objname,
    zz = "zz_bushes1",
    zz_gate = "gzz_greywitchgates1_bushes1"
  };
  -----------------------------------------------
  local use_mentalmagnifier1_5_inv = function ()

    if cmn.IsEventDone( "use_mentalmagnifier1_2" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_3" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_4" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_1" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_6" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_7" ) then

      int.InventoryItemRemove( "inv_mentalmagnifier1" );

    end;

  end;
  local use_mentalmagnifier1_5_beg = function ()

    ObjDelete( "obj_bushes1_use_mentalmagnifier1_5" );

  end;
  local use_mentalmagnifier1_5_end = function ()

    ObjSet( "anm_bushes1_aura_5_static", { alp = 1, playing = true } );
    ObjDelete( "anm_bushes1_aura_5_hand" );
    ObjDelete( "anm_bushes1_aura_5_lens" );
    ObjSet( "obj_bushes1_auratrace_get", { input = true } );
    ObjSet( "gfx_bushes1_auratrace1_5", { active = true } );

    ObjSet( "spr_greywitchgates1_bushes_auratrace_2", { alp = 1, active = true } );
    ObjDelete( "spr_greywitchgates1_bushes_auratrace_1" );

  end;
  ---------------------------------------------
  cmn.AddSubscriber( "use_mentalmagnifier1_5",     use_mentalmagnifier1_5_inv );
  cmn.AddSubscriber( "use_mentalmagnifier1_5",     use_mentalmagnifier1_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_5",     use_mentalmagnifier1_5_end, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_5_inv", use_mentalmagnifier1_5_inv, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_5_beg", use_mentalmagnifier1_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_5_end", use_mentalmagnifier1_5_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mentalmagnifier1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mentalmagnifier1_1" ] =
  {
    type = "use",
    use_obj = "inv_mentalmagnifier1",
    use_place = "obj_greywitchgates1_use_mentalmagnifier1_1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_mentalmagnifier1_1_inv = function ()

    if cmn.IsEventDone( "use_mentalmagnifier1_2" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_3" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_4" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_5" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_6" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_7" ) then

      int.InventoryItemRemove( "inv_mentalmagnifier1" );

    end;

  end;
  local use_mentalmagnifier1_1_beg = function ()

    ObjDelete( "obj_greywitchgates1_use_mentalmagnifier1_1" );

  end;
  local use_mentalmagnifier1_1_end = function ()

    ObjSet( "obj_greywitchgates1_auratrace_get1", { input = true } );
    ObjSet( "gfx_greywitchgates1_auratrace1_1", { active = true } );

    ObjSet( "anm_greywitchgates1_aura_1_static", { alp = 1, playing = true } );
    ObjDelete( "anm_greywitchgates1_hand1" );
    ObjDelete( "anm_greywitchgates1_open_aura_1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mentalmagnifier1_1",     use_mentalmagnifier1_1_inv );
  cmn.AddSubscriber( "use_mentalmagnifier1_1",     use_mentalmagnifier1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_1",     use_mentalmagnifier1_1_end, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_1_inv", use_mentalmagnifier1_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_1_beg", use_mentalmagnifier1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_1_end", use_mentalmagnifier1_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_mentalmagnifier1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mentalmagnifier1_2" ] =
  {
    type = "use",
    use_obj = "inv_mentalmagnifier1",
    use_place = "obj_greywitchgates1_use_mentalmagnifier1_2",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_mentalmagnifier1_2_inv = function ()

    if cmn.IsEventDone( "use_mentalmagnifier1_1" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_3" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_4" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_5" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_6" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_7" ) then

      int.InventoryItemRemove( "inv_mentalmagnifier1" );

    end;

  end;
  local use_mentalmagnifier1_2_beg = function ()

    ObjDelete( "obj_greywitchgates1_use_mentalmagnifier1_2" );

  end;
  local use_mentalmagnifier1_2_end = function ()

    ObjSet( "obj_greywitchgates1_auratrace_get2", { input = true } );
    ObjSet( "gfx_greywitchgates1_auratrace1_2", { active = true } );

    ObjSet( "anm_greywitchgates1_aura_2_static", { alp = 1, playing = true } );
    ObjDelete( "anm_greywitchgates1_hand2" );
    ObjDelete( "anm_greywitchgates1_open_aura_2" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mentalmagnifier1_2",     use_mentalmagnifier1_2_inv );
  cmn.AddSubscriber( "use_mentalmagnifier1_2",     use_mentalmagnifier1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_2",     use_mentalmagnifier1_2_end, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_2_inv", use_mentalmagnifier1_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_2_beg", use_mentalmagnifier1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_2_end", use_mentalmagnifier1_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gatesamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gatesamulet1" ] =
  {
    type = "use",
    use_obj = "inv_gatesamulet1",
    use_place = "obj_gates1_use_gatesamulet1",
    room = private.room_objname,
    zz = "zz_gates1",
    zz_gate = "gzz_greywitchgates1_gates1"
  };
  -----------------------------------------------
  local use_gatesamulet1_inv = function ()

    int.InventoryItemRemove( "inv_gatesamulet1" );

  end;
  local use_gatesamulet1_beg = function ()

    ObjDelete( "obj_gates1_use_gatesamulet1" );
    ObjDelete( "anm_gates1_bones_click" );
    ObjSet( "obj_gates1_mmg", { alp = 1 } );

  end;
  local use_gatesamulet1_end = function ()

    ObjAttach( "anm_gates1_use_gatesamulet", "obj_gates1_background" );
    ObjSet( "obj_gates1_mmg", { input = true } );
    ObjSet( "anm_gates1_use_gatesamulet", { alp = 1, frame = 48, animfunc = "DoAnim" } );
    ObjSet( "spr_greywitchgates1_gatesamulets", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_gatesamulet1",     use_gatesamulet1_inv );
  cmn.AddSubscriber( "use_gatesamulet1",     use_gatesamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_gatesamulet1",     use_gatesamulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_gatesamulet1_inv", use_gatesamulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_gatesamulet1_beg", use_gatesamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_gatesamulet1_end", use_gatesamulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mentalmagnifier1_6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mentalmagnifier1_6" ] =
  {
    type = "use",
    use_obj = "inv_mentalmagnifier1",
    use_place = "obj_tree1_use_mentalmagnifier1_6",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local use_mentalmagnifier1_6_inv = function ()

    if cmn.IsEventDone( "use_mentalmagnifier1_2" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_3" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_4" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_1" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_5" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_7" ) then

      int.InventoryItemRemove( "inv_mentalmagnifier1" );

    end;

  end;
  local use_mentalmagnifier1_6_beg = function ()

    ObjDelete( "obj_tree1_use_mentalmagnifier1_6" );

  end;
  local use_mentalmagnifier1_6_end = function ()

    ObjSet( "obj_tree1_auratrace_get", { input = true } );
    ObjSet( "gfx_tree1_auratrace1_6", { active = true } );
    ObjSet( "anm_tree1_aura6_static", { alp = 1, playing = true } );
    ObjDelete( "anm_tree1_hand" );
    ObjDelete( "anm_tree1_lens_use" );

    ObjDelete( "spr_greywitchgates1_tree_auratrace_1" );
    ObjSet( "spr_greywitchgates1_tree_auratrace_2", { alp = 1, active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mentalmagnifier1_6",     use_mentalmagnifier1_6_inv );
  cmn.AddSubscriber( "use_mentalmagnifier1_6",     use_mentalmagnifier1_6_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_6",     use_mentalmagnifier1_6_end, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_6_inv", use_mentalmagnifier1_6_inv, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_6_beg", use_mentalmagnifier1_6_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_6_end", use_mentalmagnifier1_6_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nuts1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nuts1" ] =
  {
    type = "use",
    use_obj = "inv_nuts1",
    use_place = "obj_tree1_use_nuts1",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local use_nuts1_inv = function ()

    int.InventoryItemRemove( "inv_nuts1" );

  end;
  local use_nuts1_beg = function ()

    ObjDelete( "obj_tree1_use_nuts1" );
    ObjDelete( "anm_tree1_squirrel_static" );
    ObjDelete( "anm_tree1_squirrel_click" );

  end;
  local use_nuts1_end = function ()

    ObjDelete( "anm_tree1_squirrel_nuts" );
    ObjSet( "anm_tree1_squirrel_key_end",  { alp = 1 } );
    ObjSet( "anm_tree1_squirrel_nuts_end", { alp = 1 } );
    ObjSet( "spr_tree1_keys1", { input = true } );
    ObjSet( "gfx_tree1_keys1", { active = true } );
    ObjDelete( "spr_greywitchgates1_squirrel" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_nuts1",     use_nuts1_inv );
  cmn.AddSubscriber( "use_nuts1",     use_nuts1_beg, private.room_objname );
  cmn.AddSubscriber( "use_nuts1",     use_nuts1_end, private.room_objname );
  cmn.AddSubscriber( "use_nuts1_inv", use_nuts1_inv, private.room_objname );
  cmn.AddSubscriber( "use_nuts1_beg", use_nuts1_beg, private.room_objname );
  cmn.AddSubscriber( "use_nuts1_end", use_nuts1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sickle1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sickle1_2" ] =
  {
    type = "use",
    use_obj = "inv_sickle1",
    use_place = "obj_tree1_use_sickle1_2",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local use_sickle1_2_inv = function ()

    if ( cmn.IsEventDone( "use_sickle1_1" ) ) then

      int.InventoryItemRemove( "inv_sickle1" );

    end;

  end;
  local use_sickle1_2_beg = function ()

    ObjDelete( "obj_tree1_use_sickle1_2" );
    ObjDelete( "anm_tree1_chest_click" );
    ObjSet( "anm_tree1_crossamulet", { alp = 1 } );

  end;
  local use_sickle1_2_end = function ()

    ObjSet( "obj_tree1_use_crossamulet1", { input = true } );
    ObjDelete( "anm_tree1_sickle" );
    ObjDelete( "spr_greywitchgates1_rope" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_sickle1_2",     use_sickle1_2_inv );
  cmn.AddSubscriber( "use_sickle1_2",     use_sickle1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_sickle1_2",     use_sickle1_2_end, private.room_objname );
  cmn.AddSubscriber( "use_sickle1_2_inv", use_sickle1_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_sickle1_2_beg", use_sickle1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_sickle1_2_end", use_sickle1_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crossamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crossamulet1" ] =
  {
    type = "use",
    use_obj = "inv_crossamulet1",
    use_place = "obj_tree1_use_crossamulet1",
    room = private.room_objname,
    zz = "zz_tree1",
    zz_gate = "gzz_greywitchgates1_tree1"
  };
  -----------------------------------------------
  local use_crossamulet1_inv = function ()

    int.InventoryItemRemove( "inv_crossamulet1" );

  end;
  local use_crossamulet1_beg = function ()

    ObjDelete( "obj_tree1_use_crossamulet1" );

  end;
  local use_crossamulet1_end = function ()

    ObjSet( "obj_tree1_chest_open",     { alp = 1 } );
    ObjSet( "spr_tree1_horseamulet1_1", { input = true } );
    ObjSet( "gfx_tree1_horseamulet1_1", { active = true } );
    ObjSet( "spr_tree1_letters1_2",     { input = true } );
    ObjSet( "gfx_tree1_letters1_2",     { active = true } );
    ObjSet( "spr_tree1_ingredients1_1", { input = true } );
    ObjSet( "gfx_tree1_ingredients1_1", { active = true } );
    ObjSet( "anm_tree1_crossamulet",    { frame = 124, animfunc = "DoAnim" } );
    ObjAttach( "anm_tree1_crossamulet", "obj_tree1_chest" );

    ObjSet( "obj_greywitchgates1_open_chest",   { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_crossamulet1",     use_crossamulet1_inv );
  cmn.AddSubscriber( "use_crossamulet1",     use_crossamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_crossamulet1",     use_crossamulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_crossamulet1_inv", use_crossamulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_crossamulet1_beg", use_crossamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_crossamulet1_end", use_crossamulet1_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_keys1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_keys1" ] =
  {
    type = "click",
    clk_obj = "obj_van1_clk_keys1",
    room = private.room_objname,
    zz = "zz_van1",
    zz_gate = "gzz_greywitchgates1_van1"
  };
  -----------------------------------------------
  local clk_keys1_inv = function ()

  end;
  local clk_keys1_beg = function ()

    ObjDelete( "obj_van1_clk_keys1" );
    ObjDelete( "anm_van1_handle_click" );

  end;
  local clk_keys1_end = function ()

    ObjDelete( "gzz_greywitchgates1_van1" );
    ObjSet( "gho_greywitchgates1_hovan1", { alp = 1, input = true, active = true } );

    ObjSet( "anm_greywitchgates1_vandoor", { alp = 1, playing = true  } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_keys1",     clk_keys1_inv );
  cmn.AddSubscriber( "clk_keys1",     clk_keys1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_keys1",     clk_keys1_end, private.room_objname );
  cmn.AddSubscriber( "clk_keys1_inv", clk_keys1_inv, private.room_objname );
  cmn.AddSubscriber( "clk_keys1_beg", clk_keys1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_keys1_end", clk_keys1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_gates1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gates1" ] =
  {
    type = "click",
    clk_obj = "spr_gates1_part1",
    room = private.room_objname,
    zz = "zz_gates1",
    zz_gate = "gzz_greywitchgates1_gates1"
  };
  --*********************************************************************************************************************
  local win_gates1_inv = function ()

    if ( cmn.IsEventDone( "win_gates1" ) ) then


    
    end;

  end;
  --*********************************************************************************************************************
  local win_gates1 = function ()

    if ( cmn.IsEventDone( "win_gates1" ) ) then

      ObjDelete( "gzz_greywitchgates1_gates1" );
      ObjSet( "grm_greywitchgates1_ruinedsquare1", { alp = 1, input = true, active = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_greywitchgates1_ruinedsquare1_focus");
      end;
      ObjSet( "spr_greywitchgates1_open_gates", { alp = 1 } );

    else 

      private.Gates1Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_gates1", win_gates1_inv );
  cmn.AddSubscriber( "win_gates1", win_gates1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_greywitchgates1_richard1_1 () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "dlg_greywitchgates1_richard1_1" ] =
  --{
  --  type = "click",
  --  clk_obj = "obj_int_button_skull",
  --  room = "int_button_skull",
  --};
  -----------------------------------------------
  local dlg_greywitchgates1_richard1_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_greywitchgates1_richard1_1_end = function ()

    ObjDelete( "dlg_greywitchgates1_richard1_1" );

  end;

  cmn.AddSubscriber( "dlg_greywitchgates1_richard1_1",     dlg_greywitchgates1_richard1_1_beg );
  cmn.AddSubscriber( "dlg_greywitchgates1_richard1_1",     dlg_greywitchgates1_richard1_1_end );
  cmn.AddSubscriber( "dlg_greywitchgates1_richard1_1_beg", dlg_greywitchgates1_richard1_1_beg );
  cmn.AddSubscriber( "dlg_greywitchgates1_richard1_1_end", dlg_greywitchgates1_richard1_1_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_1_8()

  int.AddScreensaver( "spr_bushes1_screensaver_1_8" );

end;    
function private.get_screensaver_1_9()

  int.AddScreensaver( "spr_tree1_screensaver_1_9" );

end;  
-----------------------------------------------------------------------
function private.get_bagamulet1_1 ()

  cmn.SetEventDone( "get_bagamulet1_1" );
  cmn.CallEventHandler( "get_bagamulet1_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_ladybag1 ()

  cmn.SetEventDone( "get_ladybag1" );
  cmn.CallEventHandler( "get_ladybag1" );
  cmn.GetObjectSfx();

  local autohide = interface.InventoryAutoHideGet();

  if ( autohide ) then

    cmn.TutorialShow( "tutorial_page_3" );
    cmn.TutorialSetShown( "tutorial_page_3" );

  end;

end;
-----------------------------------------------------------------------
function private.get_richardskull1 ()

  cmn.SetEventDone( "get_richardskull1" );
  cmn.CallEventHandler( "get_richardskull1" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom( true );

  --cmn.WaitAndRun( private.dlg_greywitchgates1_richard1_1, 1.0 );

  private.dlg_greywitchgates1_richard1_1();

end;
-----------------------------------------------------------------------
function private.get_ingredients1_2 ()

  cmn.SetEventDone( "get_ingredients1_2" );
  cmn.CallEventHandler( "get_ingredients1_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_letters1_3 ()

  cmn.SetEventDone( "get_letters1_3" );
  cmn.CallEventHandler( "get_letters1_3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function public.get_auratrace1_5 ()

  int.Lock( true );

  local count = 0;

  for i = 1, 7 do

    if ( cmn.IsEventDone( "get_auratrace1_"..i ) ) then

      count = count + 1;

    end;

  end;

  if count ~= 0 then
    for i = 1, count do
      ObjSet( "spr_bushes1_phial_aura_"..i, { alp = 1 } );
      ObjSet( "spr_bushes1_phial_aura_light_"..i, { alp = 1 } );
    end;
  end;

  local func_end = function ()

    local func_end1 = function ()

      local func_end2 = function ()

        cmn.CloseSubRoom();
        cmn.GetObjectSfx();
        ObjSet( "obj_bushes1_auratrace_get", { pos_x = 335, pos_y = 291 } );
        cmn.SetEventDone( "get_auratrace1_5" );
        cmn.SetEventDone( "use_mentalmagnifier1_5" );
        cmn.CallEventHandler( "get_auratrace1_5" );
        
        if ( cmn.IsEventDone( "get_auratrace1_1" ) and
             cmn.IsEventDone( "get_auratrace1_2" ) and
             cmn.IsEventDone( "get_auratrace1_5" ) and
             cmn.IsEventDone( "get_auratrace1_6" ) ) then
          
             ObjSet( "inv_mentalmagnifier1_add", { active = false, alp = 0 } );  
          
        end;        

      end;

      ObjAnimate( "obj_bushes1_phial", "pos_xy", 0, 0, func_end2, 
      { 
        0.0, 3, 155, 120,
        0.6, 3, 420, 417
      } );

    end;

    ObjAnimate( "spr_bushes1_phial_aura_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );
    ObjAnimate( "spr_bushes1_phial_aura_light_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );

    ObjSet( "anm_bushes1_aura_5_static", { alp = 0 } );
    ObjSet( "gfx_bushes1_auratrace1_5", { alp = 0, active = false } );
    ObjSet( "anm_bushes1_aura_5_get", { alp = 1 } );
    AnimPlay( "anm_bushes1_aura_5_get", "DoAnim", func_end1 ); 

  end;

  int.InventoryItemRemove( "inv_soulphial1" );

  ObjSet( "obj_bushes1_phial", { active = true } );
  ObjAnimate( "obj_bushes1_phial", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, 430, 85,
    0.6, 3, 155, 120
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_magic_absorb" );

end;
-----------------------------------------------------------------------
function private.get_bagamulet1_2 ()

  cmn.SetEventDone( "get_bagamulet1_2" );
  cmn.CallEventHandler( "get_bagamulet1_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function public.get_auratrace1_1 ()

  int.Lock( true );
  ObjSet( "obj_greywitchgates1_phial", { pos_x = -68, pos_x = 993, ang = -0.33, scale_x = - 1, active = true } );

  local count = 0;

  for i = 1, 7 do

    if ( cmn.IsEventDone( "get_auratrace1_"..i ) ) then

      count = count + 1;

    end;

  end;

  if count ~= 0 then
    for i = 1, count do
      ObjSet( "spr_greywitchgates1_phial_aura_"..i, { alp = 1 } );
      ObjSet( "spr_greywitchgates1_phial_aura_light_"..i, { alp = 1 } );
    end;
  end;

  local func_end = function ()

    local func_end1 = function ()

      local func_end2 = function ()
        
        cmn.GetObjectSfx();
        ObjSet( "obj_greywitchgates1_auratrace_get1", { pos_x = 457, pos_y = 847 } );
        cmn.SetEventDone( "get_auratrace1_1" );
        cmn.SetEventDone( "use_mentalmagnifier1_1" );
        cmn.CallEventHandler( "get_auratrace1_1" );
        ObjSet( "obj_greywitchgates1_phial", { active = false } );
        
        if ( cmn.IsEventDone( "get_auratrace1_1" ) and
             cmn.IsEventDone( "get_auratrace1_2" ) and
             cmn.IsEventDone( "get_auratrace1_5" ) and
             cmn.IsEventDone( "get_auratrace1_6" ) ) then
          
             ObjSet( "inv_mentalmagnifier1_add", { active = false, alp = 0 } );  
          
        end;          

      end;

      ObjAnimate( "obj_greywitchgates1_phial", "pos_xy", 0, 0, func_end2, 
      { 
        0.0, 3, 497, 524,
        0.6, 3, 267, 898
      } );

    end;

    ObjAnimate( "spr_greywitchgates1_phial_aura_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );
    ObjAnimate( "spr_greywitchgates1_phial_aura_light_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );

    ObjSet( "anm_greywitchgates1_aura_1_static", { alp = 0 } );
    ObjSet( "gfx_greywitchgates1_auratrace1_1", { alp = 0, active = false } );
    ObjSet( "anm_greywitchgates1_aura_1_get", { alp = 1 } );
    AnimPlay( "anm_greywitchgates1_aura_1_get", "DoAnim", func_end1 ); 

  end;

  int.InventoryItemRemove( "inv_soulphial1" );

  ObjAnimate( "obj_greywitchgates1_phial", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, -68, 893,
    0.9, 3, 497, 524
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_magic_absorb" );

end;
-----------------------------------------------------------------------
function public.get_auratrace1_2 ()

  int.Lock( true );
  ObjSet( "obj_greywitchgates1_phial", { pos_x = 1079, pos_x = 961, ang = 0.52, scale_x = 1, active = true } );

  local count = 0;

  for i = 1, 7 do

    if ( cmn.IsEventDone( "get_auratrace1_"..i ) ) then

      count = count + 1;

    end;

  end;

  if count ~= 0 then
    for i = 1, count do
      ObjSet( "spr_greywitchgates1_phial_aura_"..i, { alp = 1 } );
      ObjSet( "spr_greywitchgates1_phial_aura_light_"..i, { alp = 1 } );
    end;
  end;

  local func_end = function ()

    local func_end1 = function ()

      local func_end2 = function ()

        cmn.GetObjectSfx();
        ObjSet( "obj_greywitchgates1_auratrace_get2", { pos_x = 924, pos_y = 846 } );
        ObjSet( "obj_greywitchgates1_phial", { active = false } );

        cmn.SetEventDone( "get_auratrace1_2" );
        cmn.SetEventDone( "use_mentalmagnifier1_2" );
        cmn.CallEventHandler( "get_auratrace1_2" );
        
        if ( cmn.IsEventDone( "get_auratrace1_1" ) and
             cmn.IsEventDone( "get_auratrace1_2" ) and
             cmn.IsEventDone( "get_auratrace1_5" ) and
             cmn.IsEventDone( "get_auratrace1_6" ) ) then
          
             ObjSet( "inv_mentalmagnifier1_add", { active = false, alp = 0 } );  
          
        end;          
        

      end;

      ObjAnimate( "obj_greywitchgates1_phial", "pos_xy", 0, 0, func_end2, 
      { 
        0.0, 3, 571, 337,
        0.6, 3, 1079, 961
      } );

    end;

    ObjAnimate( "spr_greywitchgates1_phial_aura_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );
    ObjAnimate( "spr_greywitchgates1_phial_aura_light_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );

    ObjSet( "anm_greywitchgates1_aura_2_static", { alp = 0 } );
    ObjSet( "gfx_greywitchgates1_auratrace1_2", { alp = 0, active = false } );
    ObjSet( "anm_greywitchgates1_aura_2_get", { alp = 1 } );
    AnimPlay( "anm_greywitchgates1_aura_2_get", "DoAnim", func_end1 ); 

  end;

  int.InventoryItemRemove( "inv_soulphial1" );

  ObjAnimate( "obj_greywitchgates1_phial", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, 1097, 961,
    0.9, 3, 571, 337
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_magic_absorb" );

end;
-----------------------------------------------------------------------
function private.get_keys1 ()

  ObjSet( "spr_tree1_keys1", { alp = 1 } );
  cmn.SetEventDone( "get_keys1" );
  cmn.CallEventHandler( "get_keys1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_horseamulet1_1 ()

  cmn.SetEventDone( "get_horseamulet1_1" );
  cmn.CallEventHandler( "get_horseamulet1_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_auratrace1_6" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_letters1_2 ()

  cmn.SetEventDone( "get_letters1_2" );
  cmn.CallEventHandler( "get_letters1_2" );
  cmn.GetObjectSfx();

  if ( not cmn.IsEventDone( "get_horseamulet1_1" ) ) then

    private.get_horseamulet1_1();

  end;

end;
-----------------------------------------------------------------------
function private.get_ingredients1_1 ()

  cmn.SetEventDone( "get_ingredients1_1" );
  cmn.CallEventHandler( "get_ingredients1_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function public.get_auratrace1_6 ()

  int.Lock( true );

  local count = 0;

  for i = 1, 7 do

    if ( cmn.IsEventDone( "get_auratrace1_"..i ) ) then

      count = count + 1;

    end;

  end;

  if count ~= 0 then
    for i = 1, count do
      ObjSet( "spr_tree1_phial_aura_"..i, { alp = 1 } );
      ObjSet( "spr_tree1_phial_aura_light_"..i, { alp = 1 } );
    end;
  end;

  local func_end = function ()

    local func_end1 = function ()

      local func_end2 = function ()

        if ( cmn.IsEventDone( "get_horseamulet1_1" ) ) then

          cmn.CloseSubRoom();

        end;
        cmn.GetObjectSfx();
        ObjSet( "obj_tree1_auratrace_get", { pos_x = -283, pos_y = 276 } );
        cmn.SetEventDone( "get_auratrace1_6" );
        cmn.SetEventDone( "use_mentalmagnifier1_6" );
        cmn.CallEventHandler( "get_auratrace1_6" );
        
        if ( cmn.IsEventDone( "get_auratrace1_1" ) and
             cmn.IsEventDone( "get_auratrace1_2" ) and
             cmn.IsEventDone( "get_auratrace1_5" ) and
             cmn.IsEventDone( "get_auratrace1_6" ) ) then
          
             ObjSet( "inv_mentalmagnifier1_add", { active = false, alp = 0 } );  
          
        end;          

      end;

      ObjAnimate( "obj_tree1_phial", "pos_xy", 0, 0, func_end2, 
      { 
        0.0, 3, -78, 180,
        0.6, 3, -534, 448
      } );

    end;

    ObjAnimate( "spr_tree1_phial_aura_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );
    ObjAnimate( "spr_tree1_phial_aura_light_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );

    ObjSet( "anm_tree1_aura6_static", { alp = 0 } );
    ObjSet( "gfx_tree1_auratrace1_6", { alp = 0, active = false } );
    ObjSet( "anm_tree1_aura6_get", { alp = 1 } );
    AnimPlay( "anm_tree1_aura6_get", "DoAnim", func_end1 ); 

  end;

  int.InventoryItemRemove( "inv_soulphial1" );

  ObjSet( "obj_tree1_phial", { active = true } );
  ObjAnimate( "obj_tree1_phial", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, -534, 448,
    0.6, 3, -78, 180
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_magic_absorb" );

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function public.use_keys1 ()

  local item = "inv_keys1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_van1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_van1", nil, { 512, 384 }, true, { -120,58 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_van1_use_keys1", true ) ) then

    cmn.CallEventHandler( "use_keys1_inv" );
    cmn.CallEventHandler( "use_keys1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_keys1" );
      cmn.CallEventHandler( "use_keys1_end" );

    end;

    int.Lock( true );

    AnimPlay( "anm_van1_key", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_door_car_key" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_gloves1 ()

  local item = "inv_gloves1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_bushes1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bushes1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bushes1_use_gloves1", true ) ) then

    cmn.CallEventHandler( "use_gloves1_inv" );
    cmn.CallEventHandler( "use_gloves1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_gloves1" );
      cmn.CallEventHandler( "use_gloves1_end" );
      ObjSet( "anm_bushes1_back", { alp = 1 } );
      AnimPlay( "anm_bushes1_back", "DoAnim", "" );

    end;

    int.Lock( true );
    ObjSet( "anm_bushes1_back", { alp = 0 } );
    AnimStop( "anm_bushes1_back" );
    ObjSet( "anm_bushes1_thorns", { alp = 0 } );
    ObjSet( "anm_bushes1_crow_static", { alp = 0 } );
    ObjSet( "anm_bushes1_crow", { alp = 1 } );
    AnimPlay( "anm_bushes1_crow", "DoAnim", "" );
    AnimPlay( "anm_bushes1_crow_over", "DoAnim", func_end );  
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_crow_leaves" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_spade1 ()

  local item = "inv_spade1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_bushes1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bushes1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bushes1_use_spade1", true ) ) then

    cmn.CallEventHandler( "use_spade1_inv" );
    cmn.CallEventHandler( "use_spade1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_spade1" );
      cmn.CallEventHandler( "use_spade1_end" );

    end;

    int.Lock( true );

    AnimPlay( "anm_bushes1_use_spade", "DoAnim", func_end ); 
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_dig_ground" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_mentalmagnifier1_5 ()

  local item = "inv_mentalmagnifier1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_bushes1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bushes1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bushes1_use_mentalmagnifier1_5", true ) ) then

    cmn.CallEventHandler( "use_mentalmagnifier1_5_inv" );
    cmn.CallEventHandler( "use_mentalmagnifier1_5_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mentalmagnifier1_5" );
      cmn.CallEventHandler( "use_mentalmagnifier1_5_end" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_magic_loc_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_bushes1_aura_5_hand", { alp = 0 } );
    ObjSet( "anm_bushes1_aura_5_lens", { alp = 1 } );
    AnimPlay( "anm_bushes1_aura_5_lens", "DoAnim", func_end ); 
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_eye_magic" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_mentalmagnifier1_1 ()

  local item = "inv_mentalmagnifier1";

  if ( cmn.ApplyObj( item, "obj_greywitchgates1_use_mentalmagnifier1_1", true ) ) then

    cmn.CallEventHandler( "use_mentalmagnifier1_1_inv" );
    cmn.CallEventHandler( "use_mentalmagnifier1_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mentalmagnifier1_1" );
      cmn.CallEventHandler( "use_mentalmagnifier1_1_end" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_magic_loc_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_greywitchgates1_hand1", { alp = 0 } );
    ObjSet( "anm_greywitchgates1_open_aura_1", { alp = 1 } );
    AnimPlay( "anm_greywitchgates1_open_aura_1", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_eye_magic" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_mentalmagnifier1_2 ()

  local item = "inv_mentalmagnifier1";

  if ( cmn.ApplyObj( item, "obj_greywitchgates1_use_mentalmagnifier1_2", true ) ) then

    cmn.CallEventHandler( "use_mentalmagnifier1_2_inv" );
    cmn.CallEventHandler( "use_mentalmagnifier1_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mentalmagnifier1_2" );
      cmn.CallEventHandler( "use_mentalmagnifier1_2_end" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_magic_loc_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_greywitchgates1_hand2", { alp = 0 } );
    ObjSet( "anm_greywitchgates1_open_aura_2", { alp = 1 } );
    AnimPlay( "anm_greywitchgates1_open_aura_2", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_eye_magic" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_gatesamulet1 ()

  local item = "inv_gatesamulet1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_gates1", false ) and 
       cmn.IsEventDone( "get_gatesamulet1_1" ) and 
       cmn.IsEventDone( "get_gatesamulet1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gates1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gates1_use_gatesamulet1", true ) and 
           cmn.IsEventDone( "get_gatesamulet1_1" ) and 
           cmn.IsEventDone( "get_gatesamulet1_2" ) ) then

    cmn.CallEventHandler( "use_gatesamulet1_inv" );
    cmn.CallEventHandler( "use_gatesamulet1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_gatesamulet1" );
      cmn.CallEventHandler( "use_gatesamulet1_end" );
      private.Gates1StartInit();

    end;

    int.Lock( true );
    ObjSet( "anm_gates1_use_gatesamulet", { alp = 1 } );
    AnimPlay( "anm_gates1_use_gatesamulet", "DoAnim", func_end ); 
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_bones_mmg" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
function public.use_mentalmagnifier1_6 ()

  local item = "inv_mentalmagnifier1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_tree1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tree1_use_mentalmagnifier1_6", true ) ) then

    cmn.CallEventHandler( "use_mentalmagnifier1_6_inv" );
    cmn.CallEventHandler( "use_mentalmagnifier1_6_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mentalmagnifier1_6" );
      cmn.CallEventHandler( "use_mentalmagnifier1_6_end" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_magic_loc_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_tree1_hand", { alp = 0 } );
    ObjSet( "anm_tree1_lens_use", { alp = 1 } );
    AnimPlay( "anm_tree1_lens_use", "DoAnim", func_end ); 
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_eye_magic" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_nuts1 ()

  local item = "inv_nuts1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_tree1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tree1_use_nuts1", true ) ) then

    cmn.CallEventHandler( "use_nuts1_inv" );
    cmn.CallEventHandler( "use_nuts1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_nuts1" );
      cmn.CallEventHandler( "use_nuts1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_tree1_squirrel_nuts", { alp = 1 } );
    AnimPlay( "anm_tree1_squirrel_nuts", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_squirel_take" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_sickle1_2 ()

  local item = "inv_sickle1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_tree1", false ) ) and
     ( not cmn.IsEventDone( "use_sickle1_2" ) )then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tree1_use_sickle1_2", true ) ) and
     ( not cmn.IsEventDone( "use_sickle1_2" ) )then

    cmn.CallEventHandler( "use_sickle1_2_inv" );
    cmn.CallEventHandler( "use_sickle1_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_sickle1_2" );
      cmn.CallEventHandler( "use_sickle1_2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_tree1_sickle", { alp = 1 } );
    AnimPlay( "anm_tree1_sickle", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_rope_chest" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_crossamulet1 ()

  local item = "inv_crossamulet1";

  if ( cmn.ApplyObj( item, "gzz_greywitchgates1_tree1", false ) ) and
     ( cmn.IsEventDone( "use_sickle1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tree1_use_crossamulet1", true ) ) and
         ( cmn.IsEventDone( "use_sickle1_2" ) ) then

    cmn.CallEventHandler( "use_crossamulet1_inv" );
    cmn.CallEventHandler( "use_crossamulet1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_crossamulet1" );
      cmn.CallEventHandler( "use_crossamulet1_end" );

    end;

    int.Lock( true );

    AnimPlay( "anm_tree1_crossamulet", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_chest_opens" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function private.clk_keys1 ()

  cmn.CallEventHandler( "clk_keys1_inv" );
  cmn.CallEventHandler( "clk_keys1_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_keys1" );
    cmn.CallEventHandler( "clk_keys1_end" );
    cmn.CloseSubRoom();

  end;

  int.Lock( true );

  ObjSet( "anm_van1_handle", { alp = 1 } );
  AnimPlay( "anm_van1_handle", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_open_door_car" );

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
function private.dlg_greywitchgates1_richard1_1 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_gatesamulet1_2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_greywitchgates1_richard1_1_richard_static_1",      { alp = 0 } );
    ObjSet( "anm_greywitchgates1_richard1_1_richard_static_2",      { alp = 0 } );
    ObjSet( "anm_greywitchgates1_richard1_1_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_greywitchgates1_richard1_1_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_greywitchgates1_richard1_1_richard_static_1" );
    AnimStop( "anm_greywitchgates1_richard1_1_richard_static_2" );
    AnimStop( "anm_greywitchgates1_richard1_1_richard_appearance" );

    ObjAnimate( "anm_greywitchgates1_richard1_1_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_greywitchgates1_richard1_1_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_gatesamulet1_2" );
      cmn.SetEventDone( "dlg_greywitchgates1_richard1_1" );
      level1_inv.CheckGatesamulet1();
      int.InventoryItemAdd( "inv_richardskull1" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_greywitchgates1_richard1_1_richard_appearance" );
    ObjSet( "anm_greywitchgates1_richard1_1_richard_appearance", { alp = 0 } );

    ObjSet( "anm_greywitchgates1_richard1_1_richard_static_1", { alp = 1 } );
    AnimPlay( "anm_greywitchgates1_richard1_1_richard_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard1_1", "greywitchgates1", 3, nil, nil, true, nil, func_before_end );

    int.InventoryItemRemove( "inv_richardskull1" );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_greywitchgates1_richard1_1_beg" );
  ObjAttach( "dlg_greywitchgates1_richard1_1", GetCurrentRoom() );  

  ObjSet( "anm_greywitchgates1_richard1_1_richard_appearance", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );
  AnimPlay( "anm_greywitchgates1_richard1_1_richard_appearance", "DoAnim", func_anim_end );

  ObjAnimate( "anm_greywitchgates1_richard1_1_richard_static_1", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

--  int.InventoryItemRemove( "inv_richardskull1" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard1_1" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_greywitchgates1_richard1_1_richard_static_1" );
        AnimPlay( "anm_greywitchgates1_richard1_1_richard_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_greywitchgates1_richard1_1_richard_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_greywitchgates1_richard1_1_richard_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_greywitchgates1_richard1_1_richard_static_2" );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_creates_cups" );
        AnimPlay( "anm_greywitchgates1_richard1_1_richard_give", "DoAnim", "" );
        AnimPlay( "anm_greywitchgates1_richard1_1_object_appearance", "DoAnim", "" );

        ObjAnimate( "spr_greywitchgates1_gatesamulet1_2", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_greywitchgates1_richard1_1_richard_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_greywitchgates1_richard1_1_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_greywitchgates1 ()

  if not ( cmn.IsEventDone( "opn_greywitchgates1" ) ) then

    cmn.SetEventDone( "opn_greywitchgates1" );

  end;

  if ( not cmn.IsEventDone( "beg_level1" ) ) then

    private.IntroLvl1Open();

  else

    cmn.StopAllEnv( "audio/level1/env/aud_rm_greywitchgates1_env", true );
    cmn.PlayAudio( "env", "audio/level1/env/aud_rm_greywitchgates1_env", 1 );
    
  end;

  if ( cmn.IsEventDone( "get_richardskull1" ) ) and
     ( not cmn.IsEventDone( "dlg_greywitchgates1_richard1_1" ) ) then

    private.dlg_greywitchgates1_richard1_1();

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_greywitchgates1();

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventDone( "beg_level1" ) ) then

    common_impl.InterfaceSetVisible( false );
    ObjSet( "rm_greywitchgates1", { color_r = 0, color_g = 0, color_b = 0 } );    

  end;

  if ( cmn.IsEventDone( "win_hovan1" ) ) and
     ( not ng_global.progress[ ng_global.currentprogress ][ "opn_greywitchgates1" ].bbt_ho ) then

    cmn.ShowBbt( "bbt_house1_hotable1" );
    ng_global.progress[ ng_global.currentprogress ][ "opn_greywitchgates1" ].bbt_ho = true;

  end;
  
  if not ( cmn.IsEventDone( "get_auratrace1_1" ) and
           cmn.IsEventDone( "get_auratrace1_2" ) and
           cmn.IsEventDone( "get_auratrace1_5" ) and
           cmn.IsEventDone( "get_auratrace1_6" ) ) then
    
    ObjSet( "inv_mentalmagnifier1_add", { active = true } );
    ObjAnimate( "inv_mentalmagnifier1_add", "alp", 1, 0, "",
    {
      0.0, 3, 0,
      2.0, 3, 0.3,
      4.0, 3, 0,
    } );      
    
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  ObjSet( "inv_mentalmagnifier1_add", { alp = 0, active = false } );
  
end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_gatesamulet1_2",                                      { "dlg_greywitchgates1_richard1_1" } );
  int.AddedTaskMap( private.room_objname, "get_bagamulet1_1" );
  int.AddedTaskMap( private.room_objname, "get_ladybag1" );
  int.AddedTaskMap( private.room_objname, "get_richardskull1",                                       { "use_gloves1" } );
  int.AddedTaskMap( private.room_objname, "get_ingredients1_2",                                      { "use_spade1" } );
  int.AddedTaskMap( private.room_objname, "get_letters1_3",                                          { "use_spade1" } );
  int.AddedTaskMap( private.room_objname, "get_auratrace1_5",                                        { "use_mentalmagnifier1_5", "get_soulphial1" } );
  int.AddedTaskMap( private.room_objname, "get_bagamulet1_2" );
  int.AddedTaskMap( private.room_objname, "get_auratrace1_1",                                        { "use_mentalmagnifier1_1", "get_soulphial1" } );
  int.AddedTaskMap( private.room_objname, "get_auratrace1_2",                                        { "use_mentalmagnifier1_2", "get_soulphial1" } );
  int.AddedTaskMap( private.room_objname, "get_keys1",                                               { "use_nuts1" } );
  int.AddedTaskMap( private.room_objname, "get_horseamulet1_1",                                      { "use_crossamulet1" } );
  int.AddedTaskMap( private.room_objname, "get_letters1_2",                                          { "use_crossamulet1" } );
  int.AddedTaskMap( private.room_objname, "get_ingredients1_1",                                      { "use_crossamulet1" } );
  int.AddedTaskMap( private.room_objname, "get_auratrace1_6",                                        { "use_mentalmagnifier1_6", "get_soulphial1" } );

  int.AddedTaskMap( private.room_objname, "use_keys1",                                               { "get_keys1" } );
  int.AddedTaskMap( private.room_objname, "use_gloves1",                                             { "win_hovan1" } );
  int.AddedTaskMap( private.room_objname, "use_spade1",                                              { "get_spade1" } );
  int.AddedTaskMap( private.room_objname, "use_mentalmagnifier1_5",                                  { "get_mentalmagnifier1" } );
  int.AddedTaskMap( private.room_objname, "use_mentalmagnifier1_1",                                  { "get_mentalmagnifier1" } );
  int.AddedTaskMap( private.room_objname, "use_mentalmagnifier1_2",                                  { "get_mentalmagnifier1" } );
  int.AddedTaskMap( private.room_objname, "use_gatesamulet1",                                        { "get_gatesamulet1_1", "get_gatesamulet1_2" } );
  int.AddedTaskMap( private.room_objname, "use_mentalmagnifier1_6",                                  { "get_mentalmagnifier1" } );
  int.AddedTaskMap( private.room_objname, "use_nuts1",                                               { "get_nuts1" } );
  int.AddedTaskMap( private.room_objname, "use_sickle1_2",                                           { "get_sickle1" } );
  int.AddedTaskMap( private.room_objname, "use_crossamulet1",                                        { "get_crossamulet1", "use_sickle1_2" } );

  int.AddedTaskMap( private.room_objname, "clk_keys1",                                               { "use_keys1" } );

  int.AddedTaskMap( private.room_objname, "opn_ruinedsquare1",                                       { "win_gates1" } );

  int.AddedTaskMap( private.room_objname, "win_gates1",                                              { "use_gatesamulet1" } );
  int.AddedTaskMap( private.room_objname, "win_hovan1",                                              { "clk_keys1" } );
  int.AddedTaskMap( private.room_objname, "dlg_greywitchgates1_richard1_1",                          { "get_richardskull1" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_gates1" );
  -------------------------------------------------
  function zz_gates1.Open()
    
    if ( cmn.IsEventStart( "win_gates1" ) and not cmn.IsEventDone( "win_gates1" ) ) then

      cmn.MiniGameShow( "gates1" );
      common_impl.PassingMgStart( "gates1" );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_loop_zz_gates1", 1 );

  end;
  -------------------------------------------------
  function zz_gates1.PreClose()
        
    if ( cmn.IsEventStart( "win_gates1" ) and not cmn.IsEventDone( "win_gates1" ) ) then

      cmn.MiniGameHide( "gates1" );
      common_impl.PassingMgStop( "gates1" );

    end;

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_loop_zz_gates1" );
    
  end;
  -------------------------------------------------
  function zz_gates1.Skip ()

    if ( cmn.IsEventStart( "win_gates1" ) and not cmn.IsEventDone( "win_gates1" ) ) then
      private.Gates1Skip();
    end;

  end;
  -------------------------------------------------
  function zz_gates1.Reset ()

    if ( cmn.IsEventStart( "win_gates1" ) and not cmn.IsEventDone( "win_gates1" ) ) then
      private.Gates1Reset();
    end;

  end;
  -------------------------------------------------
  function zz_gates1.Close ()

    if ( cmn.IsEventDone( "get_bagamulet1_1" ) and cmn.IsEventDone( "get_bagamulet1_2" ) and cmn.IsEventDone( "get_ladybag1" ) ) then

      cmn.TutorialShow( "tutorial_page_6" );
      cmn.TutorialSetShown( "tutorial_page_6" );

    end;

  end;
  -------------------------------------------------
  subroom.Define( "zz_bushes1" );
  -------------------------------------------------
  function zz_bushes1.Open()

    cmn.TutorialShow( "tutorial_page_2" );
    cmn.TutorialSetShown( "tutorial_page_2" );

  end;
  -------------------------------------------------
  function zz_bushes1.PreClose()



  end;
  -------------------------------------------------
  function zz_bushes1.Close()

    if ( cmn.IsEventDone( "get_ladybag1" ) ) then

      if ( cmn.IsEventDone( "get_bagamulet1_1" ) ) and 
         ( cmn.IsEventDone( "get_bagamulet1_2" ) )  and 
         not ng_global.progress[ "std" ][ "get_ladybag1" ].tutor then

        cmn.TutorialShow( "tutorial_page_6_1" );
        cmn.TutorialSetShown( "tutorial_page_6_1" );
        ng_global.progress[ "std" ][ "get_ladybag1" ].tutor = 1;

      else

        cmn.TutorialShow( "tutorial_page_4" );
        cmn.TutorialSetShown( "tutorial_page_4" );     
        ng_global.progress[ "std" ][ "get_ladybag1" ].tutor = 1;        

      end;

    end;

  end;
  -------------------------------------------------
  subroom.Define( "zz_tree1" );
  -------------------------------------------------
  function zz_tree1.Open()


  end;
  -------------------------------------------------
  function zz_tree1.PreClose()



  end;
  -------------------------------------------------
  subroom.Define( "zz_van1" );
  -------------------------------------------------
  function zz_van1.Close ()

    if ( cmn.IsEventDone( "get_bagamulet1_1" ) and cmn.IsEventDone( "get_bagamulet1_2" ) and cmn.IsEventDone( "get_ladybag1" ) ) then

      cmn.TutorialShow( "tutorial_page_6" );
      cmn.TutorialSetShown( "tutorial_page_6" );

    end;

    if ( cmn.IsEventDone( "clk_keys1" ) ) then

      cmn.TutorialShow( "tutorial_page_7" );
      cmn.TutorialSetShown( "tutorial_page_7" );

    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.IntroLvl1Open()

  --cmn.StopAllMus();
  --cmn.StopAllEnv();

  local func_end = function ( skip )

    cmn.SetEventDone( "beg_level1" );
    ObjSet( "rm_greywitchgates1", { color_r = 1, color_g = 1, color_b = 1 } );

    int.Lock( false );
    
    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_greywitchgates1_intro" );
      cmn.StopAudio( "voc", "audio/level1/voc/aud_greywitchgates1_intro_voc" );
      cmn.StopAudio( "sfx", "audio/level1/mus/aud_rm_greywitchgates1_vid_mus" );
    end;

    cmn.PlayAudio( "env", "audio/level1/env/aud_rm_greywitchgates1_env", 1 );
    cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );

    local pages = ng_global.progress[ "std" ][ "see_tutorial" ].state.pages;

    if ( ng_global.progress[ "std" ][ "see_tutorial" ].start == 0 ) then

      cmn.TutorialShow( "tutorial_start" );

    end;

    cmn.ShowBbt("bbt_greywitchgates1_intro");

    interface.KeyTaskAdd( "task_1_1", true );

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_greywitchgates1_intro", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_greywitchgates1_intro_voc" );
  cmn.PlayAudio( "sfx", "audio/level1/mus/aud_rm_greywitchgates1_vid_mus", nil, nil, 34 );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_greywitchgates1_tree_auratrace_1", "alp", 1, 0, "",
  {
    0.0, 3, 0.5,
    1.5, 3, 0.0,
    3.0, 3, 0.5,
  } );
  ObjAnimate( "spr_greywitchgates1_tree_auratrace_2", "alp", 1, 0, "",
  {
    0.0, 3, 1,
    3.0, 3, 0.5,
    6.0, 3, 1,
  } );
  ObjAnimate( "spr_greywitchgates1_bushes_auratrace_1", "alp", 1, 0, "",
  {
    0.0, 3, 0.5,
    1.5, 3, 0.0,
    3.0, 3, 0.5,
  } );
  ObjAnimate( "spr_greywitchgates1_bushes_auratrace_2", "alp", 1, 0, "",
  {
    0.0, 3, 1,
    3.0, 3, 0.5,
    6.0, 3, 1,
  } );

end;
--*********************************************************************************************************************
function private.Van1HandleClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_van1_use_keys1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_van1_handle_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_lock_car_1" );

end;
--*********************************************************************************************************************
function private.Bushes1ThornsClk ()

  local func_end = function ()

    ObjSet( "anm_bushes1_thorns_click", { alp = 0 } );
    ObjSet( "anm_bushes1_thorns", { alp = 1 } );
    cmn.ShowBbt( "bbt_bushes1_use_gloves1" );
    AnimPlay( "anm_bushes1_thorns", "DoAnim", "" );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "anm_bushes1_thorns_click", { alp = 1 } );
  AnimStop( "anm_bushes1_thorns" );
  ObjSet( "anm_bushes1_thorns", { alp = 0 } );
  AnimPlay( "anm_bushes1_thorns_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_zz_bushes" );

end;
--*********************************************************************************************************************
function private.Tree1SquirrelClick ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_tree1_use_nuts1" );

    ObjSet( "anm_tree1_squirrel_static", { alp = 0 } );
    ObjSet( "anm_tree1_squirrel_click",  { alp = 1 } );

    AnimPlay( "anm_tree1_squirrel_static", "DoAnim", "" );

  end;

  int.Lock( true );

  ObjSet( "anm_tree1_squirrel_click",  { alp = 1 } );
  ObjSet( "anm_tree1_squirrel_static", { alp = 0 } );

  AnimStop( "anm_tree1_squirrel_static" );
  AnimPlay( "anm_tree1_squirrel_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_squirel" );

end;
--*********************************************************************************************************************
function private.Tree1ChestClick ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_tree1_use_crossamulet1" );

  end;

  int.Lock( true );

  ObjAnimate( "anm_tree1_crossamulet", "pos_y", 0, 0, func_end,
  {
    0.0, 3,  0,
    0.2, 3, -2,
    0.4, 3,  0,
    0.6, 3, -2,
    0.7, 3,  0,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_chest_without_rope" );

end;
--*********************************************************************************************************************
function private.Tree1RopeClick ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_tree1_use_sickle1_2" );

  end;

  int.Lock( true );

  AnimPlay( "anm_tree1_chest_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_chest_zz_tree1" );

end;
--*********************************************************************************************************************
function private.Gates1BonesClick ()

  local func_end = function ()

    int.Lock( false );

    cmn.ShowBbt( "bbt_gates1_use_gatesamulet1" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_skeleton_mmg" );
  AnimPlay( "anm_gates1_bones_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
-- function *** MMG Gates1 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Gates1StartInit ()

    cmn.MiniGameShow( "gates1" );
    common_impl.PassingMgStart( "gates1" );
    ng_global.progress[ "std" ][ "win_gates1" ].part_pos = { 2, 3, 2, 2, 3, 2, 2, 1, 2, 2, 1, 2 };

  end;
  --*********************************************************************************************************************  
  function private.Gates1Load ()

    for i = 1, #ng_global.progress[ "std" ][ "win_gates1" ].part_pos do

      ang = private.pos_ang[ i ][ ng_global.progress[ "std" ][ "win_gates1" ].part_pos[ i ] ];
      ObjSet( "obj_gates1_part"..i, { ang = ang } );

    end;

  end;
  --*********************************************************************************************************************
  function private.Gates1Skip ()

    for i = 1, #ng_global.progress[ "std" ][ "win_gates1" ].part_pos do

      ang = private.pos_ang[ i ][ private.win_part_pos[ i ] ];
      ObjSet( "obj_gates1_part"..i, { ang = ang } );

    end;

    int.Lock( true );
    private.Gates1Win();

  end;
  --*********************************************************************************************************************
  function private.Gates1Reset ()

    for i = 1, #ng_global.progress[ "std" ][ "win_gates1" ].part_pos do

      ng_global.progress[ "std" ][ "win_gates1" ].part_pos[ i ] = private.old_part_pos[ i ];
      ang = private.pos_ang[ i ][ ng_global.progress[ "std" ][ "win_gates1" ].part_pos[ i ] ];
      ObjSet( "obj_gates1_part"..i, { ang = ang } );

    end;

  end;
  --*********************************************************************************************************************
  function private.Gates1Init ()

    for i = 1, 12 do

      ObjSet( "spr_gates1_part"..i,
      {
        event_mdown  = function () private.Gates1ClkPart( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );

    end;

    private.pos_ang = { 
                        { 0.79, 0, -0.79 },
                        { -2.48, -1.24, 0 },
                        { -1.05, 0, 1.05 },
                        { 0.98, 0, -0.98 },
                        { 1.5, 0.83, 0 },
                        { 1.25, 0, -1.25 },
                        { 0.79, 0, -0.79 },
                        { 0, 0.77, 1.55 },
                        { -0.94, 0, 0.85 },
                        { -0.6, 0, 0.6 },
                        { 0, -1.12, -2.17 },
                        { 0.89, 0, -0.89 }
                      };

    private.win_part_pos = { 1, 2, 3, 2, 2, 1, 2, 2, 2, 3, 2, 2 };
    private.old_part_pos = { 2, 3, 2, 2, 3, 2, 2, 1, 2, 2, 1, 2 };
    private.part_dir = { true, true, true, true, true, true, true, true, true, true, true, true };

  end;
  --*********************************************************************************************************************
  function private.Gates1ClkPart ( id )

    local pos = ng_global.progress[ "std" ][ "win_gates1" ].part_pos[ id ];
    local dir = private.part_dir[ id ];

    if dir then

      if pos ~= 3 then

        pos = pos + 1;

      else 

        pos = pos - 1;
        dir = false;

      end;

    else 

      if pos ~= 1 then

        pos = pos - 1;

      else 

        pos = pos + 1;
        dir = true;

      end;

    end;

    local old_ang = private.pos_ang[ id ][ ng_global.progress[ "std" ][ "win_gates1" ].part_pos[ id ] ];
    local new_ang = private.pos_ang[ id ][ pos ];

    local func_end = function ()

      if private.Gates1IsWin( id, pos ) then

        private.Gates1Win();

      else

        ng_global.progress[ "std" ][ "win_gates1" ].part_pos[ id ] = pos;
        private.part_dir[ id ] = dir;
        int.Lock( false );

      end;

    end;

    int.Lock( true );
    ObjAnimate( "obj_gates1_part"..id, "ang", 0, 0, func_end, 
    { 
      0.0, 3, old_ang,
      0.3, 3, new_ang,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_bones_click" );

  end;
  --*********************************************************************************************************************
  function private.Gates1IsWin( id, pos )

    local tmp = {};
    for i = 1, #ng_global.progress[ "std" ][ "win_gates1" ].part_pos do
      tmp[ i ] = ng_global.progress[ "std" ][ "win_gates1" ].part_pos[ i ];
    end;

    tmp[ id ] = pos;

    for i = 1, #ng_global.progress[ "std" ][ "win_gates1" ].part_pos do
      if tmp[ i ] ~= private.win_part_pos[ i ] then
        return false;
      end;
    end;

    return true;

  end;
  --*********************************************************************************************************************
  function private.Gates1Win () 
  
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_bones_win" );
    cmn.MiniGameHide( "gates1" );
    cmn.SetEventDone( "win_gates1" );
    cmn.CallEventHandler( "win_gates1" );
    common_impl.PassingMgWin( "gates1" );
    cmn.CloseSubRoom();
    cmn.TutorialShow( "tutorial_page_8" );
    cmn.TutorialSetShown( "tutorial_page_8" );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************