-- name=rm_house1
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_house1";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_door1",   "room_hub" );
  ObjAttach( "zz_clock1",  "room_hub" );
  ObjAttach( "zz_closet1", "room_hub" );

  ObjMultiSet(
  {
    { "spr_door1_horseamulet1_2",     { event_mdown = private.get_horseamulet1_2 } },
    { "spr_clock1_horseamulet1_3",    { event_mdown = private.get_horseamulet1_3 } },
    { "spr_clock1_catamulet1_2",      { event_mdown = private.get_catamulet1_2 } },
    { "spr_closet1_corkscrew1",       { event_mdown = private.get_corkscrew1 } },
    { "spr_closet1_broom1",           { event_mdown = private.get_broom1 } },
    { "spr_closet1_sparehandle1",     { event_mdown = private.get_sparehandle1 } },
    { "spr_closet1_powder1",          { event_mdown = private.get_powder1 } },
    { "spr_closet1_heart1_1",         { event_mdown = private.get_heart1_1 } },
    { "obj_door1_use_screwdriver1_1", { event_mdown = private.Door1HorseamuletClick } },
    { "obj_closet1_use_horseamulet1", { event_mdown = private.Closet1NicheClick } },
    { "obj_closet1_use_rose1",        { event_mdown = private.Closet1BoxClick } },
    { "obj_closet1_use_feather1",     { event_mdown = private.Closet1CellClick } },
    { "obj_closet1_use_feather1",     { event_mdown = private.Closet1CellClick } },
    { "spr_house1_collect_1_3",       { event_mdown = private.get_collect_1_3 } },
    { "obj_clock1_use_windupkey1",    { event_mdown = private.Clock1ArrowsClick } },
    { "obj_door1_use_sparehandle1",   { event_mdown = private.Door1DoorClick } },
    { "obj_house1_use_broom1",        { event_mdown = private.House1WebClick } },
    { "spr_closet1_screensaver_1_3",     { event_mdown = private.get_screensaver_1_3 } },         

  } );
  local get_screensaver_1_3 = function ()

    ObjDelete( "spr_closet1_screensaver_1_3" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_3", get_screensaver_1_3, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_collect_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_1_3 = function ()

    ObjDelete( "spr_house1_collect_1_3" );

  end;

  cmn.AddSubscriber( "get_collect_1_3", get_collect_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_3 = function ()

    ObjDelete( "obj_house1_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_3", get_morphobject_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_house1 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_house1", update_game_mode_house1, private.room_objname ); 
--********************************************************************************************************************* 
  --------------------------------------------------------------------------------------------
  -- function opn_house1 () end;
  --------------------------------------------------------------------------------------------
  local opn_house1 = function ()

    ObjDelete( "anm_house1_pursuit" );

  end;

  cmn.AddSubscriber( "opn_house1", opn_house1, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_horseamulet1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_horseamulet1_2" ] =
  {
    type = "get",
    get_obj = "spr_door1_horseamulet1_2",
    room = private.room_objname,
    zz = "zz_door1",
    zz_gate = "gzz_house1_door1"
  };
  -----------------------------------------------
  local get_horseamulet1_2_inv = function ()

    int.InventoryItemAdd( "inv_horseamulet1", "spr_door1_horseamulet1_2", "assets/levels/level1/rm_greywitchgates1/zz_tree1/inv/inv_horseamulet1_2" );
    level1_inv.CheckHorseamulet1();

  end;

  local get_horseamulet1_2_closezz = function ()

    ObjDelete( "gfx_door1_horseamulet1_2" );

  end;

  cmn.AddSubscriber( "get_horseamulet1_2", get_horseamulet1_2_inv );
  cmn.AddSubscriber( "get_horseamulet1_2", get_horseamulet1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_horseamulet1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_horseamulet1_3" ] =
  {
    type = "get",
    get_obj = "spr_clock1_horseamulet1_3",
    room = private.room_objname,
    zz = "zz_clock1",
    zz_gate = "gzz_house1_clock1"
  };
  -----------------------------------------------
  local get_horseamulet1_3_inv = function ()

    int.InventoryItemAdd( "inv_horseamulet1", "spr_clock1_horseamulet1_3", "assets/levels/level1/rm_greywitchgates1/zz_tree1/inv/inv_horseamulet1_3" );
    level1_inv.CheckHorseamulet1();

  end;

  local get_horseamulet1_3_closezz = function ()

    ObjDelete( "gfx_clock1_horseamulet1_3" );
    ObjSet( "obj_clock1_use_windupkey1", { input = true } );
    ObjDelete( "spr_house1_clock1_horseamulet" );

  end;

  cmn.AddSubscriber( "get_horseamulet1_3", get_horseamulet1_3_inv );
  cmn.AddSubscriber( "get_horseamulet1_3", get_horseamulet1_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_catamulet1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_catamulet1_2" ] =
  {
    type = "get",
    get_obj = "spr_clock1_catamulet1_2",
    room = private.room_objname,
    zz = "zz_clock1",
    zz_gate = "gzz_house1_clock1"
  };
  -----------------------------------------------
  local get_catamulet1_2_inv = function ()

    int.InventoryItemAdd( "inv_catamulet1", "spr_clock1_catamulet1_2", "assets/levels/level1/rm_alley1/zz_animals1/inv/inv_catamulet1_2" );
    level1_inv.CheckCatamulet1();

  end;

  local get_catamulet1_2_closezz = function ()

    ObjDelete( "gfx_clock1_catamulet1_2" );

  end;

  cmn.AddSubscriber( "get_catamulet1_2", get_catamulet1_2_inv );
  cmn.AddSubscriber( "get_catamulet1_2", get_catamulet1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_corkscrew1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_corkscrew1" ] =
  {
    type = "get",
    get_obj = "spr_closet1_corkscrew1",
    room = private.room_objname,
    zz = "zz_closet1",
    zz_gate = "gzz_house1_closet1"
  };
  -----------------------------------------------
  local get_corkscrew1_inv = function ()

    int.InventoryItemAdd( "inv_corkscrew1", "spr_closet1_corkscrew1" );

  end;

  local get_corkscrew1_closezz = function ()

    ObjDelete( "gfx_closet1_corkscrew1" );

    if ( cmn.IsEventDone( "get_heart1_1" ) ) then

      ObjDelete( "gzz_house1_closet1" );

    end;

  end;

  cmn.AddSubscriber( "get_corkscrew1", get_corkscrew1_inv );
  cmn.AddSubscriber( "get_corkscrew1", get_corkscrew1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_broom1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_broom1" ] =
  {
    type = "get",
    get_obj = "spr_closet1_broom1",
    room = private.room_objname,
    zz = "zz_closet1",
    zz_gate = "gzz_house1_closet1"
  };
  -----------------------------------------------
  local get_broom1_inv = function ()

    int.InventoryItemAdd( "inv_broom1", "spr_closet1_broom1" );

  end;

  local get_broom1_closezz = function ()

    ObjDelete( "gfx_closet1_broom1" );
    ObjDelete( "spr_closet1_broom1_shadow" );
    ObjDelete( "spr_house1_closet1_broom" );

  end;

  cmn.AddSubscriber( "get_broom1", get_broom1_inv );
  cmn.AddSubscriber( "get_broom1", get_broom1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sparehandle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sparehandle1" ] =
  {
    type = "get",
    get_obj = "spr_closet1_sparehandle1",
    room = private.room_objname,
    zz = "zz_closet1",
    zz_gate = "gzz_house1_closet1"
  };
  -----------------------------------------------
  local get_sparehandle1_inv = function ()

    int.InventoryItemAdd( "inv_sparehandle1", "spr_closet1_sparehandle1" );

  end;

  local get_sparehandle1_closezz = function ()

    ObjDelete( "gfx_closet1_sparehandle1" );
    ObjDelete( "spr_house1_closet1_sparehandle" );

  end;

  cmn.AddSubscriber( "get_sparehandle1", get_sparehandle1_inv );
  cmn.AddSubscriber( "get_sparehandle1", get_sparehandle1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_powder1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_powder1" ] =
  {
    type = "get",
    get_obj = "spr_closet1_powder1",
    room = private.room_objname,
    zz = "zz_closet1",
    zz_gate = "gzz_house1_closet1"
  };
  -----------------------------------------------
  local get_powder1_inv = function ()

    int.InventoryItemAdd( "inv_powder1", "spr_closet1_powder1" );

    if ( cmn.IsEventDone( "use_water1" ) ) then

      ObjSet( "inv_emptyflask1_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_powder1_closezz = function ()

    ObjDelete( "gfx_closet1_powder1" );
    ObjDelete( "spr_closet1_powder1_over" );
    ObjDelete( "spr_house1_closet1_powder" );

  end;

  cmn.AddSubscriber( "get_powder1", get_powder1_inv );
  cmn.AddSubscriber( "get_powder1", get_powder1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_heart1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_heart1_1" ] =
  {
    type = "get",
    get_obj = "spr_closet1_heart1_1",
    room = private.room_objname,
    zz = "zz_closet1",
    zz_gate = "gzz_house1_closet1"
  };
  -----------------------------------------------
  local get_heart1_1_inv = function ()

    int.InventoryItemAdd( "inv_heart1", "spr_closet1_heart1_1", "assets/levels/level1/rm_secondfloor1/zz_drawerchest1/inv/inv_heart1_1" );
    level1_inv.CheckHeart1();

  end;

  local get_heart1_1_closezz = function ()

    ObjDelete( "gfx_closet1_heart1_1" );
    ObjDelete( "spr_house1_closet1_heart" );

    if ( cmn.IsEventDone( "get_corkscrew1" ) ) then

      ObjDelete( "gzz_house1_closet1" );

    end;

  end;

  cmn.AddSubscriber( "get_heart1_1", get_heart1_1_inv );
  cmn.AddSubscriber( "get_heart1_1", get_heart1_1_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_screws1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screws1" ] =
  {
    type = "use",
    use_obj = "inv_screws1",
    use_place = "obj_door1_use_screws1",
    room = private.room_objname,
    zz = "zz_door1",
    zz_gate = "gzz_house1_door1"
  };
  -----------------------------------------------
  local use_screws1_inv = function ()

    int.InventoryItemRemove( "inv_screws1" );

  end;
  local use_screws1_beg = function ()

    ObjDelete( "obj_door1_use_screws1" );

  end;
  local use_screws1_end = function ()

    ObjSet( "obj_door1_use_screwdriver1_2", { input = true } );
    ObjSet( "vid_door1_screwdriver", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screws1",     use_screws1_inv );
  cmn.AddSubscriber( "use_screws1",     use_screws1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screws1",     use_screws1_end, private.room_objname );
  cmn.AddSubscriber( "use_screws1_inv", use_screws1_inv, private.room_objname );
  cmn.AddSubscriber( "use_screws1_beg", use_screws1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screws1_end", use_screws1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver1_2" ] =
  {
    type = "use",
    use_obj = "inv_screwdriver1",
    use_place = "obj_door1_use_screwdriver1_2",
    room = private.room_objname,
    zz = "zz_door1",
    zz_gate = "gzz_house1_door1"
  };
  -----------------------------------------------
  local use_screwdriver1_2_inv = function ()

    int.InventoryItemRemove( "inv_screwdriver1" );

  end;
  local use_screwdriver1_2_beg = function ()

    ObjDelete( "obj_door1_use_screwdriver1_2" );

  end;
  local use_screwdriver1_2_end = function ()

    ObjDelete( "gzz_house1_door1" );
    ObjDelete( "spr_house1_door1_sparehandle" );
    ObjSet( "grm_house1_secondfloor1", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_house1_secondfloor1_focus");
    end;
    ObjSet( "spr_house1_door1_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screwdriver1_2",     use_screwdriver1_2_inv );
  cmn.AddSubscriber( "use_screwdriver1_2",     use_screwdriver1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver1_2",     use_screwdriver1_2_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver1_2_inv", use_screwdriver1_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver1_2_beg", use_screwdriver1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver1_2_end", use_screwdriver1_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sparehandle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sparehandle1" ] =
  {
    type = "use",
    use_obj = "inv_sparehandle1",
    use_place = "obj_door1_use_sparehandle1",
    room = private.room_objname,
    zz = "zz_door1",
    zz_gate = "gzz_house1_door1"
  };
  -----------------------------------------------
  local use_sparehandle1_inv = function ()

    int.InventoryItemRemove( "inv_sparehandle1" );

  end;
  local use_sparehandle1_beg = function ()

    ObjDelete( "obj_door1_use_sparehandle1" );

  end;
  local use_sparehandle1_end = function ()

    ObjSet( "anm_door1_sparehandle", { alp = 1, frame = 36, animfunc = "DoAnim" } );
    ObjSet( "obj_door1_use_screws1", { input = true } );
    ObjSet( "spr_house1_door1_sparehandle", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_sparehandle1",     use_sparehandle1_inv );
  cmn.AddSubscriber( "use_sparehandle1",     use_sparehandle1_beg, private.room_objname );
  cmn.AddSubscriber( "use_sparehandle1",     use_sparehandle1_end, private.room_objname );
  cmn.AddSubscriber( "use_sparehandle1_inv", use_sparehandle1_inv, private.room_objname );
  cmn.AddSubscriber( "use_sparehandle1_beg", use_sparehandle1_beg, private.room_objname );
  cmn.AddSubscriber( "use_sparehandle1_end", use_sparehandle1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver1_1" ] =
  {
    type = "use",
    use_obj = "inv_screwdriver1",
    use_place = "obj_door1_use_screwdriver1_1",
    room = private.room_objname,
    zz = "zz_door1",
    zz_gate = "gzz_house1_door1"
  };
  -----------------------------------------------
  local use_screwdriver1_1_inv = function ()

    --int.InventoryItemRemove( "inv_screwdriver1" );

  end;
  local use_screwdriver1_1_beg = function ()

    ObjDelete( "obj_door1_use_screwdriver1_1" );
    ObjDelete( "anm_door1_horseamulet_click" );

  end;
  local use_screwdriver1_1_end = function ()

    ObjDelete( "anm_door1_horseamulet" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_screwdriver1_1",     use_screwdriver1_1_inv );
  cmn.AddSubscriber( "use_screwdriver1_1",     use_screwdriver1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver1_1",     use_screwdriver1_1_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver1_1_inv", use_screwdriver1_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver1_1_beg", use_screwdriver1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver1_1_end", use_screwdriver1_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_broom1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_broom1" ] =
  {
    type = "use",
    use_obj = "inv_broom1",
    use_place = "obj_house1_use_broom1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_broom1_inv = function ()

    int.InventoryItemRemove( "inv_broom1" );

  end;
  local use_broom1_beg = function ()

    ObjDelete( "obj_house1_use_broom1" );
    ObjDelete( "anm_house1_web_click" );

  end;
  local use_broom1_end = function ()

    ObjDelete( "anm_house1_broom" );
    ObjSet( "gho_house1_hotable1", { alp = 1, input = true, active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_broom1",     use_broom1_inv );
  cmn.AddSubscriber( "use_broom1",     use_broom1_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom1",     use_broom1_end, private.room_objname );
  cmn.AddSubscriber( "use_broom1_inv", use_broom1_inv, private.room_objname );
  cmn.AddSubscriber( "use_broom1_beg", use_broom1_beg, private.room_objname );
  cmn.AddSubscriber( "use_broom1_end", use_broom1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_windupkey1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_windupkey1" ] =
  {
    type = "use",
    use_obj = "inv_windupkey1",
    use_place = "obj_clock1_use_windupkey1",
    room = private.room_objname,
    zz = "zz_clock1",
    zz_gate = "gzz_house1_clock1"
  };
  -----------------------------------------------
  local use_windupkey1_inv = function ()

    int.InventoryItemRemove( "inv_windupkey1" );

  end;
  local use_windupkey1_beg = function ()

    ObjDelete( "obj_clock1_use_windupkey1" );
    ObjDelete( "anm_clock1_arrows_click" );

  end;
  local use_windupkey1_end = function ()

    ObjDelete( "gzz_house1_clock1" );
    ObjDelete( "anm_clock1_slot_light" );
    ObjSet( "gmg_house1_mgtime1", { alp = 1, input = true, active = true } );
    ObjSet( "spr_house1_clock1_mg", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_windupkey1",     use_windupkey1_inv );
  cmn.AddSubscriber( "use_windupkey1",     use_windupkey1_beg, private.room_objname );
  cmn.AddSubscriber( "use_windupkey1",     use_windupkey1_end, private.room_objname );
  cmn.AddSubscriber( "use_windupkey1_inv", use_windupkey1_inv, private.room_objname );
  cmn.AddSubscriber( "use_windupkey1_beg", use_windupkey1_beg, private.room_objname );
  cmn.AddSubscriber( "use_windupkey1_end", use_windupkey1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_horseamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_horseamulet1" ] =
  {
    type = "use",
    use_obj = "inv_horseamulet1",
    use_place = "obj_closet1_use_horseamulet1",
    room = private.room_objname,
    zz = "zz_closet1",
    zz_gate = "gzz_house1_closet1"
  };
  -----------------------------------------------
  local use_horseamulet1_inv = function ()

    int.InventoryItemRemove( "inv_horseamulet1" );

  end;
  local use_horseamulet1_beg = function ()

    ObjDelete( "obj_closet1_use_horseamulet1" );

  end;
  local use_horseamulet1_end = function ()

    ObjDelete( "anm_closet1_horseamulet" );
    ObjSet( "spr_closet1_sparehandle1", { input = true } );
    ObjSet( "gfx_closet1_sparehandle1", { active = true } );
    ObjDelete( "spr_house1_closet1_niche" );
    ObjDelete( "spr_house1_closet1_door" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_horseamulet1",     use_horseamulet1_inv );
  cmn.AddSubscriber( "use_horseamulet1",     use_horseamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_horseamulet1",     use_horseamulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_horseamulet1_inv", use_horseamulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_horseamulet1_beg", use_horseamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_horseamulet1_end", use_horseamulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_rose1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_rose1" ] =
  {
    type = "use",
    use_obj = "inv_rose1",
    use_place = "obj_closet1_use_rose1",
    room = private.room_objname,
    zz = "zz_closet1",
    zz_gate = "gzz_house1_closet1"
  };
  -----------------------------------------------
  local use_rose1_inv = function ()

    int.InventoryItemRemove( "inv_rose1" );

  end;
  local use_rose1_beg = function ()

    ObjDelete( "obj_closet1_use_rose1" );

  end;
  local use_rose1_end = function ()

    ObjSet( "spr_closet1_powder1",  { input = true } );
    ObjSet( "gfx_closet1_powder1",  { active = true } );
    ObjSet( "anm_closet1_rose",     { frame = 100, animfunc = "DoAnim" } );
    ObjSet( "spr_house1_closet1_open_box", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_rose1",     use_rose1_inv );
  cmn.AddSubscriber( "use_rose1",     use_rose1_beg, private.room_objname );
  cmn.AddSubscriber( "use_rose1",     use_rose1_end, private.room_objname );
  cmn.AddSubscriber( "use_rose1_inv", use_rose1_inv, private.room_objname );
  cmn.AddSubscriber( "use_rose1_beg", use_rose1_beg, private.room_objname );
  cmn.AddSubscriber( "use_rose1_end", use_rose1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_feather1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_feather1" ] =
  {
    type = "use",
    use_obj = "inv_feather1",
    use_place = "obj_closet1_use_feather1",
    room = private.room_objname,
    zz = "zz_closet1",
    zz_gate = "gzz_house1_closet1"
  };
  -----------------------------------------------
  local use_feather1_inv = function ()

    int.InventoryItemRemove( "inv_feather1" );

  end;
  local use_feather1_beg = function ()

    ObjDelete( "obj_closet1_use_feather1" );
    ObjDelete( "anm_closet1_feather_click" );
    ObjAttach( "obj_closet1_feather", "obj_closet1_foreground" );

  end;
  local use_feather1_end = function ()

    ObjSet( "anm_closet1_feather",    { alp = 1, frame = 96, animfunc = "DoAnim" } );
    ObjSet( "spr_closet1_heart1_1",   { input = true } );
    ObjSet( "gfx_closet1_heart1_1",   { active = true } );
    ObjSet( "spr_closet1_corkscrew1", { input = true } );
    ObjSet( "gfx_closet1_corkscrew1", { active = true } );
    ObjSet( "spr_house1_closet1_feather",  { alp = 1 } );
    ObjSet( "spr_house1_closet1_cap_open", { alp = 1 } );
    ObjDelete( "spr_house1_closet1_cap_close" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_feather1",     use_feather1_inv );
  cmn.AddSubscriber( "use_feather1",     use_feather1_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather1",     use_feather1_end, private.room_objname );
  cmn.AddSubscriber( "use_feather1_inv", use_feather1_inv, private.room_objname );
  cmn.AddSubscriber( "use_feather1_beg", use_feather1_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather1_end", use_feather1_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function see_clock1 () end;
  --------------------------------------------------------------------------------------------
  local see_clock1_inv = function ()

  end;
  local see_clock1_beg = function ()

    ObjDelete( "obj_house1_clock1_1" );

  end;
  local see_clock1_end = function ()

    ObjDelete( "anm_house1_clock1_move" );
    ObjSet( "obj_house1_clock1_2", { alp = 1 } );
    ObjSet( "grm_house1_cellar1",  { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_house1_cellar1_focus");
    end;
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "see_clock1",     see_clock1_inv );
  cmn.AddSubscriber( "see_clock1",     see_clock1_beg, private.room_objname );
  cmn.AddSubscriber( "see_clock1",     see_clock1_end, private.room_objname );
  cmn.AddSubscriber( "see_clock1_inv", see_clock1_inv, private.room_objname );
  cmn.AddSubscriber( "see_clock1_beg", see_clock1_beg, private.room_objname );
  cmn.AddSubscriber( "see_clock1_end", see_clock1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgtime1 () end;
  --------------------------------------------------------------------------------------------
  local win_mgtime1 = function ()

    if ( cmn.IsEventDone( "win_mgtime1" ) ) then

      ObjDelete( "gmg_house1_mgtime1" );
      ObjDelete( "obj_house1_clock1_1" );

    end;

  end;

  cmn.AddSubscriber( "win_mgtime1", win_mgtime1, private.room_objname );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_1_3()

  int.AddScreensaver( "spr_closet1_screensaver_1_3" );

end;
-----------------------------------------------------------------------
function private.get_collect_1_3 ()

  int.AddCollectibles( "spr_house1_collect_1_3" );

end;
-----------------------------------------------------------------------
function private.get_horseamulet1_2 ()

  ObjSet( "spr_door1_horseamulet1_2", { alp = 1 } );
  cmn.SetEventDone( "get_horseamulet1_2" );
  cmn.CallEventHandler( "get_horseamulet1_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_horseamulet1_3 ()

  cmn.SetEventDone( "get_horseamulet1_3" );
  cmn.CallEventHandler( "get_horseamulet1_3" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_catamulet1_2 ()

  cmn.SetEventDone( "get_catamulet1_2" );
  cmn.CallEventHandler( "get_catamulet1_2" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_corkscrew1 ()

  cmn.SetEventDone( "get_corkscrew1" );
  cmn.CallEventHandler( "get_corkscrew1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_heart1_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_broom1 ()

  cmn.SetEventDone( "get_broom1" );
  cmn.CallEventHandler( "get_broom1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_sparehandle1 ()

  cmn.SetEventDone( "get_sparehandle1" );
  cmn.CallEventHandler( "get_sparehandle1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_powder1 ()

  cmn.SetEventDone( "get_powder1" );
  cmn.CallEventHandler( "get_powder1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_heart1_1 ()

  cmn.SetEventDone( "get_heart1_1" );
  cmn.CallEventHandler( "get_heart1_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_corkscrew1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function public.use_screws1 ()

  local item = "inv_screws1";

  if ( cmn.ApplyObj( item, "gzz_house1_door1", false ) ) and
     ( cmn.IsEventDone( "use_sparehandle1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_door1", nil, { 512, 384 }, true, { -109,48 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_door1_use_screws1", true ) ) and
         ( cmn.IsEventDone( "use_sparehandle1" ) ) then

    cmn.CallEventHandler( "use_screws1_inv" );
    cmn.CallEventHandler( "use_screws1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_screws1" );
      cmn.CallEventHandler( "use_screws1_end" );

    end;

    int.Lock( true );

    ObjAnimate( "vid_door1_screwdriver", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_screw_door" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_screwdriver1_2 ()

  local item = "inv_screwdriver1";

  if ( cmn.ApplyObj( item, "gzz_house1_door1", false ) ) and
     ( not cmn.IsEventDone( "use_screwdriver1_2" ) ) and
     ( cmn.IsEventDone( "use_screws1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_door1", nil, { 512, 384 }, true, { -109,48 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_door1_use_screwdriver1_2", true ) ) and
         ( not cmn.IsEventDone( "use_screwdriver1_2" ) ) and
         ( cmn.IsEventDone( "use_screws1" ) ) then

    cmn.CallEventHandler( "use_screwdriver1_2_inv" );
    cmn.CallEventHandler( "use_screwdriver1_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_screwdriver1_2" );
      cmn.CallEventHandler( "use_screwdriver1_2_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );

    VidPlay( "vid_door1_screwdriver",
    function ()

      ObjAnimate( "spr_door1_door_open", "alp", 0, 0, func_end,
      { 
        0.0, 0, 0.0,
        0.3, 0, 1.0,
      } );

    end );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_door_screwdriwer" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_sparehandle1 ()

  local item = "inv_sparehandle1";

  if ( cmn.ApplyObj( item, "gzz_house1_door1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_door1", nil, { 512, 384 }, true, { -109,48 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_door1_use_sparehandle1", true ) ) then

    cmn.CallEventHandler( "use_sparehandle1_inv" );
    cmn.CallEventHandler( "use_sparehandle1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_sparehandle1" );
      cmn.CallEventHandler( "use_sparehandle1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_door1_sparehandle", { alp = 1 } );
    AnimPlay( "anm_door1_sparehandle", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_door_insert_handle" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_screwdriver1_1 ()

  local item = "inv_screwdriver1";

  if ( cmn.ApplyObj( item, "gzz_house1_door1", false ) ) and
     ( not cmn.IsEventDone( "use_screwdriver1_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_door1", nil, { 512, 384 }, true, { -109,48 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_door1_use_screwdriver1_1", true ) ) and
         ( not cmn.IsEventDone( "use_screwdriver1_1" ) ) then

    cmn.CallEventHandler( "use_screwdriver1_1_inv" );
    cmn.CallEventHandler( "use_screwdriver1_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_screwdriver1_1" );
      cmn.CallEventHandler( "use_screwdriver1_1_end" );
      private.get_horseamulet1_2();

    end;

    int.Lock( true );

    ObjSet( "anm_door1_horseamulet", { alp = 1 } );
    AnimPlay( "anm_door1_horseamulet", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_door_stuff" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_broom1 ()

  local item = "inv_broom1";

  if ( cmn.ApplyObj( item, "obj_house1_use_broom1", true ) ) then

    cmn.CallEventHandler( "use_broom1_inv" );
    cmn.CallEventHandler( "use_broom1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_broom1" );
      cmn.CallEventHandler( "use_broom1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_house1_broom", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_spider_web" );
    AnimPlay( "anm_house1_broom", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_windupkey1 ()

  local item = "inv_windupkey1";

  if ( cmn.ApplyObj( item, "gzz_house1_clock1", false ) and 
       cmn.IsEventDone( "get_horseamulet1_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_clock1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_clock1_use_windupkey1", true ) and 
           cmn.IsEventDone( "get_horseamulet1_3" ) ) then

    cmn.CallEventHandler( "use_windupkey1_inv" );
    cmn.CallEventHandler( "use_windupkey1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_windupkey1" );
      cmn.CallEventHandler( "use_windupkey1_end" );
      cmn.CloseSubRoom();
      cmn.GotoRoom( "mg_mgtime1" );

    end;

    int.Lock( true );

    ObjSet( "anm_clock1_windupkey", { alp = 1 } );
    AnimPlay( "anm_clock1_windupkey", "DoAnim", func_end );

    ObjAnimate( "anm_clock1_slot_light", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 1.0,
      0.8, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_work_clocks" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_horseamulet1 ()

  local item = "inv_horseamulet1";

  if ( cmn.ApplyObj( item, "gzz_house1_closet1", false ) ) and
     ( cmn.IsEventDone( "get_horseamulet1_1" ) ) and
     ( cmn.IsEventDone( "get_horseamulet1_2" ) ) and
     ( cmn.IsEventDone( "get_horseamulet1_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closet1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_closet1_use_horseamulet1", true ) ) and
         ( cmn.IsEventDone( "get_horseamulet1_1" ) ) and
         ( cmn.IsEventDone( "get_horseamulet1_2" ) ) and
         ( cmn.IsEventDone( "get_horseamulet1_3" ) ) then

    cmn.CallEventHandler( "use_horseamulet1_inv" );
    cmn.CallEventHandler( "use_horseamulet1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_horseamulet1" );
      cmn.CallEventHandler( "use_horseamulet1_end" );

    end;

    int.Lock( true );

    AnimPlay( "anm_closet1_horseamulet", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_horseshoe_stuff" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_rose1 ()

  local item = "inv_rose1";

  if ( cmn.ApplyObj( item, "gzz_house1_closet1", false ) ) and
     ( cmn.IsEventDone( "get_rose1_1" ) ) and
     ( cmn.IsEventDone( "get_rose1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closet1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_closet1_use_rose1", true ) ) and
         ( cmn.IsEventDone( "get_rose1_1" ) ) and
         ( cmn.IsEventDone( "get_rose1_2" ) ) then

    cmn.CallEventHandler( "use_rose1_inv" );
    cmn.CallEventHandler( "use_rose1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_rose1" );
      cmn.CallEventHandler( "use_rose1_end" );

    end;

    int.Lock( true );

    AnimPlay( "anm_closet1_rose", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_flowers_zz_closet1" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_feather1 ()

  local item = "inv_feather1";

  if ( cmn.ApplyObj( item, "gzz_house1_closet1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_closet1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_closet1_use_feather1", true ) ) then

    cmn.CallEventHandler( "use_feather1_inv" );
    cmn.CallEventHandler( "use_feather1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_feather1" );
      cmn.CallEventHandler( "use_feather1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_closet1_feather", { alp = 1 } );
    AnimPlay( "anm_closet1_feather", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_pen_1" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function private.see_clock1 ()

  cmn.CallEventHandler( "see_clock1_inv" );
  cmn.CallEventHandler( "see_clock1_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "see_clock1" );
    cmn.CallEventHandler( "see_clock1_end" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgtime1_loc_opens" );
  AnimPlay( "anm_house1_clock1_move", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_house1 ()

  if not ( cmn.IsEventDone( "opn_house1" ) ) then

    local func_end = function ()

      int.Lock( false );
      cmn.CallEventHandler( "opn_house1" );
      cmn.SetEventDone( "opn_house1" );
      cmn.ShowBbt( "bbt_house1_clothes" );

    end;

    int.Lock( true );
    AnimPlay( "anm_house1_pursuit", "DoAnim", func_end ); 
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rm_house1_first_appear" );

  end;

  if ( cmn.IsEventDone( "win_mgtime1" ) ) and
     ( not cmn.IsEventDone( "see_clock1" ) ) then

    private.see_clock1();

  end;

  cmn.StopAllEnv( "audio/level1/env/aud_rm_house1_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_rm_house1_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( cmn.IsEventDone( "win_mgtime1" ) ) and
     ( not cmn.IsEventDone( "see_clock1" ) ) then

    ObjSet( "obj_house1_clock1_1",    { alp = 0 } );
    ObjSet( "anm_house1_clock1_move", { alp = 1 } );

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_house1();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_horseamulet1_2",                              { "use_screwdriver1_1" } );
  int.AddedTaskMap( private.room_objname, "get_horseamulet1_3" );
  int.AddedTaskMap( private.room_objname, "get_catamulet1_2" );
  int.AddedTaskMap( private.room_objname, "get_corkscrew1",                                  { "use_feather1" } );
  int.AddedTaskMap( private.room_objname, "get_broom1" );
  int.AddedTaskMap( private.room_objname, "get_sparehandle1",                                { "use_horseamulet1" } );
  int.AddedTaskMap( private.room_objname, "get_powder1",                                     { "use_rose1" } );
  int.AddedTaskMap( private.room_objname, "get_heart1_1",                                    { "use_feather1" } );


  int.AddedTaskMap( private.room_objname, "use_screws1",                                     { "get_screws1", "use_sparehandle1" } );
  int.AddedTaskMap( private.room_objname, "use_screwdriver1_1",                              { "win_hotable1" } );
  int.AddedTaskMap( private.room_objname, "use_screwdriver1_2",                              { "win_hotable1", "use_screws1" } );
  int.AddedTaskMap( private.room_objname, "use_sparehandle1",                                { "get_sparehandle1" } );
  int.AddedTaskMap( private.room_objname, "use_broom1",                                      { "get_broom1" } );
  int.AddedTaskMap( private.room_objname, "use_windupkey1",                                  { "get_windupkey1" } );
  int.AddedTaskMap( private.room_objname, "use_horseamulet1",                                { "get_horseamulet1_1", "get_horseamulet1_2", "get_horseamulet1_3" } );
  int.AddedTaskMap( private.room_objname, "use_rose1",                                       { "get_rose1_1", "get_rose1_2" } );
  int.AddedTaskMap( private.room_objname, "use_feather1",                                    { "get_feather1" } );

  int.AddedTaskMap( private.room_objname, "see_clock1",                                      { "win_mgtime1" } );

  int.AddedTaskMap( private.room_objname, "win_mgtime1",                                     { "use_windupkey1" } );
  int.AddedTaskMap( private.room_objname, "win_hotable1",                                    { "use_broom1" } );

  int.AddedTaskMap( private.room_objname, "opn_secondfloor1",                                { "use_screwdriver1_2" } );
  int.AddedTaskMap( private.room_objname, "opn_cellar1",                                     { "see_clock1" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
--[[
  subroom.Define( "zz_picture" );  
  -------------------------------------------------
  function zz_picture.Open()
  end;
  -------------------------------------------------
  function zz_picture.PreClose()
  end;
  -------------------------------------------------
  function zz_picture.Skip ()
  end;
  -------------------------------------------------
  function zz_picture.Reset ()
  end;
  -------------------------------------------------
]]--
end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_clock1_horseamulet_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0,
    2.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.Door1HorseamuletClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_door1_use_screwdriver1_1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_door1_horseamulet_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_door_stuff" );

end;
--*********************************************************************************************************************
function private.Door1DoorClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_door1_use_sparehandle1" );

  end;

  if ( cmn.IsEventDone( "get_horseamulet1_2" ) ) then

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_door_broken" );
    AnimPlay( "anm_door1_door_click", "DoAnim", func_end );

  else

    func_end();

  end;

end;
--*********************************************************************************************************************
function private.Closet1NicheClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_closet1_use_horseamulet1" );

  end;

  int.Lock( true );

  ObjAnimate( "anm_closet1_horseamulet", "pos_x", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, 2,
    0.4, 3, 0,
    0.6, 3, 2,
    0.8, 3, 0,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_horseshoe" );

end;
--*********************************************************************************************************************
function private.Closet1BoxClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_closet1_use_rose1" );

  end;

  int.Lock( true );

  ObjAnimate( "anm_closet1_rose", "pos_y", 0, 0, func_end,
  {
    0.0, 3,  0,
    0.2, 3, -2,
    0.4, 3,  0,
    0.6, 3, -2,
    0.8, 3,  0,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_rose_box" );

end;
--*********************************************************************************************************************
function private.Closet1CellClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_closet1_use_feather1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_closet1_feather_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_stuff_pen" );

end;
--*********************************************************************************************************************
function private.Clock1ArrowsClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_clock1_use_windupkey1" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_clocks" );
  AnimPlay( "anm_clock1_arrows_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.House1WebClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_house1_use_broom1" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_loc_spider_web" );
  AnimPlay( "anm_house1_web_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************