-- name=rm_ruinedsquare1
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_ruinedsquare1";

  private.InitSubroom();
  private.InitAnimations();
  private.Statue1Init();

  ObjAttach( "zz_ritualplace1", "room_hub" );
  ObjAttach( "zz_ivy1",         "room_hub" );
  ObjAttach( "zz_shop1",        "room_hub" );
  ObjAttach( "zz_statue1",      "room_hub" );

  ObjMultiSet(
  {
    { "spr_ritualplace1_letters1_1",    { event_mdown = private.get_letters1_1 } },
    { "spr_ivy1_spade1",                { event_mdown = private.get_spade1 } },
    { "spr_ivy1_crossamulet1",          { event_mdown = private.get_crossamulet1 } },
    { "spr_ivy1_ingredients1_3",        { event_mdown = private.get_ingredients1_3 } },
    { "obj_shop1_sickle1",              { event_mdown = private.get_sickle1 } },
    { "spr_shop1_ingredients1_4",       { event_mdown = public.get_ingredients1_4 } },
    { "spr_statue1_handle1",            { event_mdown = private.get_handle1 } },
    { "spr_statue1_file1",              { event_mdown = private.get_file1 } },
    { "obj_shop1_use_handle1",          { event_mdown = function() private.Shop1SickleClk() end } },
    { "obj_shop1_use_file1",            { event_mdown = function() private.Shop1DoorClk() end } },
    { "obj_ivy1_use_sickle1_1",         { event_mdown = private.Ivy1IvyClick } },
    { "obj_ivy1_use_file1",             { event_mdown = private.Ivy1LatticeClick } },
    { "obj_statue1_use_letters1",       { event_mdown = private.Statue1PlateClick } },
    { "spr_statue1_screensaver_1_10",     { event_mdown = private.get_screensaver_1_10 } },   
    { "spr_shop1_screensaver_1_11",     { event_mdown = private.get_screensaver_1_11 } },   
    { "spr_ivy1_screensaver_1_12",     { event_mdown = private.get_screensaver_1_12 } },       

  } );
  local get_screensaver_1_10 = function ()

    ObjDelete( "spr_statue1_screensaver_1_10" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_10", get_screensaver_1_10, private.room_objname );  
  local get_screensaver_1_11 = function ()

    ObjDelete( "spr_shop1_screensaver_1_11" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_11", get_screensaver_1_11, private.room_objname );  
  local get_screensaver_1_12 = function ()

    ObjDelete( "spr_ivy1_screensaver_1_12" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_12", get_screensaver_1_12, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_ruinedsquare1 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_ruinedsquare1", update_game_mode_ruinedsquare1, private.room_objname ); 
   --------------------------------------------------------------------------------------------
  -- function opn_ruinedsquare1 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local opn_ruinedsquare1 = function ()

    ObjDelete( "anm_ruinedsquare1_camera" );

  end;
  cmn.AddSubscriber( "opn_ruinedsquare1", opn_ruinedsquare1, private.room_objname );
  -------------------------------------------------------------------------------------------- 
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_1 () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_1 = function ()

    ObjDelete( "obj_ruinedsquare1_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_1", get_morphobject_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_mentalmagnifier1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mentalmagnifier1" ] =
  {
    type = "get",
    get_obj = "spr_ruinedsquare1_mentalmagnifier1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_mentalmagnifier1_inv = function ()

    int.InventoryItemAdd( "inv_mentalmagnifier1", "spr_ruinedsquare1_mentalmagnifier1" );
    ObjSet( "inv_mentalmagnifier1", { drag = false } );

  end;

  local get_mentalmagnifier1_closezz = function ()

    ObjDelete( "gfx_ruinedsquare1_mentalmagnifier1" );

  end;

  cmn.AddSubscriber( "get_mentalmagnifier1", get_mentalmagnifier1_inv );
  cmn.AddSubscriber( "get_mentalmagnifier1", get_mentalmagnifier1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_soulphial1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_soulphial1" ] =
  {
    type = "get",
    get_obj = "spr_ruinedsquare1_soulphial1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_soulphial1_inv = function ()

    int.InventoryItemAdd( "inv_soulphial1", "spr_ruinedsquare1_soulphial1" );

  end;

  cmn.AddSubscriber( "get_soulphial1", get_soulphial1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_letters1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_letters1_1" ] =
  {
    type = "get",
    get_obj = "spr_ritualplace1_letters1_1",
    room = private.room_objname,
    zz = "zz_ritualplace1",
    zz_gate = "gzz_ruinedsquare1_ritualplace1"
  };
  -----------------------------------------------
  local get_letters1_1_inv = function ()

    int.InventoryItemAdd( "inv_letters1", "spr_ritualplace1_letters1_1", "assets/levels/level1/rm_ruinedsquare1/zz_ritualplace1/inv/inv_letters1_1" );
    level1_inv.CheckLetters1();

  end;

  local get_letters1_1_closezz = function ()

    ObjDelete( "gfx_ritualplace1_letters1_1" );
    ObjDelete( "spr_ruinedsquare1_ritualplace_letter" );

  end;

  cmn.AddSubscriber( "get_letters1_1", get_letters1_1_inv );
  cmn.AddSubscriber( "get_letters1_1", get_letters1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spade1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spade1" ] =
  {
    type = "get",
    get_obj = "spr_ivy1_spade1",
    room = private.room_objname,
    zz = "zz_ivy1",
    zz_gate = "gzz_ruinedsquare1_ivy1"
  };
  -----------------------------------------------
  local get_spade1_inv = function ()

    int.InventoryItemAdd( "inv_spade1", "spr_ivy1_spade1" );

  end;

  local get_spade1_closezz = function ()

    ObjDelete( "gfx_ivy1_spade1" );
    ObjDelete( "spr_ruinedsquare1_spade" );

  end;

  cmn.AddSubscriber( "get_spade1", get_spade1_inv );
  cmn.AddSubscriber( "get_spade1", get_spade1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crossamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crossamulet1" ] =
  {
    type = "get",
    get_obj = "spr_ivy1_crossamulet1",
    room = private.room_objname,
    zz = "zz_ivy1",
    zz_gate = "gzz_ruinedsquare1_ivy1"
  };
  -----------------------------------------------
  local get_crossamulet1_inv = function ()

    int.InventoryItemAdd( "inv_crossamulet1", "spr_ivy1_crossamulet1" );

  end;

  local get_crossamulet1_closezz = function ()

    ObjDelete( "gfx_ivy1_crossamulet1" );
    ObjDelete( "spr_ruinedsquare1_crossamulet" );

  end;

  cmn.AddSubscriber( "get_crossamulet1", get_crossamulet1_inv );
  cmn.AddSubscriber( "get_crossamulet1", get_crossamulet1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ingredients1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ingredients1_3" ] =
  {
    type = "get",
    get_obj = "spr_ivy1_ingredients1_3",
    room = private.room_objname,
    zz = "zz_ivy1",
    zz_gate = "gzz_ruinedsquare1_ivy1"
  };
  -----------------------------------------------
  local get_ingredients1_3_inv = function ()

    int.InventoryItemAdd( "inv_ingredients1_3", "spr_ivy1_ingredients1_3" );

  end;

  local get_ingredients1_3_closezz = function ()

    ObjDelete( "gfx_ivy1_ingredients1_3" );
    ObjDelete( "gzz_ruinedsquare1_ivy1" );
    ObjDelete( "spr_ruinedsquare1_ivy_ingredient" );

  end;

  cmn.AddSubscriber( "get_ingredients1_3", get_ingredients1_3_inv );
  cmn.AddSubscriber( "get_ingredients1_3", get_ingredients1_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sickle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sickle1" ] =
  {
    type = "get",
    get_obj = "obj_shop1_sickle1",
    room = private.room_objname,
    zz = "zz_shop1",
    zz_gate = "gzz_ruinedsquare1_shop1"
  };
  -----------------------------------------------
  local get_sickle1_inv = function ()

    int.InventoryItemAdd( "inv_sickle1", "obj_shop1_sickle1" );

  end;

  local get_sickle1_closezz = function ()

    ObjDelete( "gfx_shop1_sickle1" );
    ObjDelete( "anm_shop1_use_handle" );

    if cmn.IsEventDone( "get_ingredients1_4" ) then
      ObjDelete( "gzz_ruinedsquare1_shop1" );
    end;

    ObjDelete( "spr_ruinedsquare1_sickle" );
    ObjDelete( "spr_ruinedsquare1_shop_handle" );

  end;

  cmn.AddSubscriber( "get_sickle1", get_sickle1_inv );
  cmn.AddSubscriber( "get_sickle1", get_sickle1_closezz, private.room_objname );
  ------------------------------------  -- function get_ingredients1_4 () end;--------------------------------------------------------

  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ingredients1_4" ] =
  {
    type = "get",
    get_obj = "spr_shop1_runes_1",
    room = private.room_objname,
    zz = "zz_shop1",
    zz_gate = "gzz_ruinedsquare1_shop1"
  };
  -----------------------------------------------
  local get_ingredients1_4_inv = function ()

    int.InventoryItemAdd( "inv_ingredients1_4", "spr_shop1_win" );

  end;

  local get_ingredients1_4_closezz = function ()


    ObjDelete( "obj_shop1_miniho" );
    if cmn.IsEventDone( "get_sickle1" ) then
      ObjDelete( "gzz_ruinedsquare1_shop1" );
    end;
    
  end;

  cmn.AddSubscriber( "get_ingredients1_4", get_ingredients1_4_inv );
  cmn.AddSubscriber( "get_ingredients1_4", get_ingredients1_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_auratrace1_7 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_auratrace1_7" ] =
  {
    type = "use",
    use_obj = "inv_soulphial1",
    use_place = "obj_statue1_auratrace_get",
    room = private.room_objname,
    zz = "zz_statue1",
    zz_gate = "gzz_ruinedsquare1_statue1"
  };
  -----------------------------------------------
  local get_auratrace1_7_inv = function ()

    int.InventoryItemAdd( "inv_soulphial1", "obj_statue1_auratrace_get", "assets/levels/level1/rm_greywitchgates1/inv/inv_auratrace1_7", function () int.Lock( false ); end );
    level1_inv.CheckAuratrace1();

  end;

  local get_auratrace1_7_closezz = function ()

    ObjDelete( "gfx_statue1_auratrace1_7" );
    ObjDelete( "anm_statue1_statics_aura" );
    ObjDelete( "gzz_ruinedsquare1_statue1" );
    ObjDelete( "spr_ruinedsquare1_statue_auratrace_2" );
    ObjDelete( "anm_statue1_aura7_get" );

  end;

  cmn.AddSubscriber( "get_auratrace1_7", get_auratrace1_7_inv );
  cmn.AddSubscriber( "get_auratrace1_7", get_auratrace1_7_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle1" ] =
  {
    type = "get",
    get_obj = "spr_statue1_handle1",
    room = private.room_objname,
    zz = "zz_statue1",
    zz_gate = "gzz_ruinedsquare1_statue1"
  };
  -----------------------------------------------
  local get_handle1_inv = function ()

    int.InventoryItemAdd( "inv_handle1", "spr_statue1_handle1" );

  end;

  local get_handle1_closezz = function ()

    ObjDelete( "gfx_statue1_handle1" );
    ObjDelete( "spr_ruinedsquare1_statue_handle" );
    ObjSet( "anm_statue1_plate_click", { res = "assets/levels/level1/rm_ruinedsquare1/zz_statue1/anims/anm_plate_click_2", animfunc = "DoAnim" } );

  end;

  cmn.AddSubscriber( "get_handle1", get_handle1_inv );
  cmn.AddSubscriber( "get_handle1", get_handle1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_file1" ] =
  {
    type = "get",
    get_obj = "spr_statue1_file1",
    room = private.room_objname,
    zz = "zz_statue1",
    zz_gate = "gzz_ruinedsquare1_statue1"
  };
  -----------------------------------------------
  local get_file1_inv = function ()

    int.InventoryItemAdd( "inv_file1", "spr_statue1_file1" );

  end;

  local get_file1_closezz = function ()

    ObjDelete( "gfx_statue1_file1" );
    ObjDelete( "spr_statue1_file1_shadow" );
    ObjDelete( "spr_ruinedsquare1_file" );   

  end;

  cmn.AddSubscriber( "get_file1", get_file1_inv );
  cmn.AddSubscriber( "get_file1", get_file1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_auratrace1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_auratrace1_3" ] =
  {
    type = "use",
    use_obj = "inv_soulphial1",
    use_place = "obj_ruinedsquare1_auratrace_get3",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_auratrace1_3_inv = function ()

    int.InventoryItemAdd( "inv_soulphial1", "obj_ruinedsquare1_auratrace_get3", "assets/levels/level1/rm_greywitchgates1/inv/inv_auratrace1_3", function () int.Lock( false ); end );
    level1_inv.CheckAuratrace1();

  end;

  local get_auratrace1_3_closezz = function ()

    ObjDelete( "gfx_ruinedsquare1_auratrace1_3" );
    ObjDelete( "obj_ruinedsquare1_auratrace_3" );

    if cmn.IsEventDone( "get_auratrace1_4" ) then
      ObjDelete( "obj_ruinedsquare1_auratraces" );
    end;

  end;

  cmn.AddSubscriber( "get_auratrace1_3", get_auratrace1_3_inv );
  cmn.AddSubscriber( "get_auratrace1_3", get_auratrace1_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_auratrace1_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_auratrace1_4" ] =
  {
    type = "use",
    use_obj = "inv_soulphial1",
    use_place = "obj_ruinedsquare1_auratrace_get4",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_auratrace1_4_inv = function ()

    int.InventoryItemAdd( "inv_soulphial1", "obj_ruinedsquare1_auratrace_get4", "assets/levels/level1/rm_greywitchgates1/inv/inv_auratrace1_4", function () int.Lock( false ); end );
    level1_inv.CheckAuratrace1();

  end;

  local get_auratrace1_4_closezz = function ()

    ObjDelete( "gfx_ruinedsquare1_auratrace1_4" );
    ObjDelete( "obj_ruinedsquare1_auratrace_4" );

    if cmn.IsEventDone( "get_auratrace1_3" ) then
      ObjDelete( "obj_ruinedsquare1_auratraces" );
    end;

  end;

  cmn.AddSubscriber( "get_auratrace1_4", get_auratrace1_4_inv );
  cmn.AddSubscriber( "get_auratrace1_4", get_auratrace1_4_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_ingredients1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ingredients1_2" ] =
  {
    type = "use",
    use_obj = "inv_ingredients1_2",
    use_place = "obj_ritualplace1_use_ingredients1_2",
    room = private.room_objname,
    zz = "zz_ritualplace1",
    zz_gate = "gzz_ruinedsquare1_ritualplace1"
  };
  -----------------------------------------------
  local use_ingredients1_2_inv = function ()

    int.InventoryItemRemove( "inv_ingredients1_2" );

  end;
  local use_ingredients1_2_beg = function ()

    ObjDelete( "obj_ritualplace1_use_ingredients1_2" );

  end;
  local use_ingredients1_2_end = function ()

    ObjSet( "anm_ritualplace1_symbols", { frame = 354, animfunc = "DoAnim" } );

    if ( cmn.IsEventDone( "use_ingredients1_1" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_2" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_3" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_4" ) ) then

      ObjSet( "obj_ritualplace1_use_auratrace1", { input = true } );
      ObjSet( "spr_ruinedsquare1_mentalmagnifier1", { input = true } );
      ObjSet( "gfx_ruinedsquare1_mentalmagnifier1", { active = true } );
      ObjDelete( "anm_ritualplace1_broken_ritual" );

    end;

    ObjSet( "spr_ruinedsquare1_ritualplace_ingredients_2", { alp = 1 } );
    ObjSet( "spr_ruinedsquare1_symbols", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_ingredients1_2",     use_ingredients1_2_inv );
  cmn.AddSubscriber( "use_ingredients1_2",     use_ingredients1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_2",     use_ingredients1_2_end, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_2_inv", use_ingredients1_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_2_beg", use_ingredients1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_2_end", use_ingredients1_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_auratrace1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_auratrace1" ] =
  {
    type = "use",
    use_obj = "inv_soulphial1",
    use_place = "obj_ritualplace1_use_auratrace1",
    room = private.room_objname,
    zz = "zz_ritualplace1",
    zz_gate = "gzz_ruinedsquare1_ritualplace1"
  };
  -----------------------------------------------
  local use_auratrace1_inv = function ()

    int.InventoryItemRemove( "inv_soulphial1" );
    
    int.LockRoomMap("ruinedsquare1",1);
    int.LockRoomMap("greywitchgates1",1);    
    int.LockRoomMap("alley1",1);        

  end;
  local use_auratrace1_beg = function ()

    ObjDelete( "obj_ritualplace1_use_auratrace1" );

  end;
  local use_auratrace1_end = function ()

    ObjSet( "spr_ruinedsquare1_ritualplace_auratrace_light", { alp = 1, active = true } );
    ObjDelete( "gzz_ruinedsquare1_ritualplace1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_auratrace1",     use_auratrace1_inv );
  cmn.AddSubscriber( "use_auratrace1",     use_auratrace1_beg, private.room_objname );
  cmn.AddSubscriber( "use_auratrace1",     use_auratrace1_end, private.room_objname );
  cmn.AddSubscriber( "use_auratrace1_inv", use_auratrace1_inv, private.room_objname );
  cmn.AddSubscriber( "use_auratrace1_beg", use_auratrace1_beg, private.room_objname );
  cmn.AddSubscriber( "use_auratrace1_end", use_auratrace1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ingredients1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ingredients1_1" ] =
  {
    type = "use",
    use_obj = "inv_ingredients1_1",
    use_place = "obj_ritualplace1_use_ingredients1_1",
    room = private.room_objname,
    zz = "zz_ritualplace1",
    zz_gate = "gzz_ruinedsquare1_ritualplace1"
  };
  -----------------------------------------------
  local use_ingredients1_1_inv = function ()

    int.InventoryItemRemove( "inv_ingredients1_1" );

  end;
  local use_ingredients1_1_beg = function ()

    ObjDelete( "obj_ritualplace1_use_ingredients1_1" );

  end;
  local use_ingredients1_1_end = function ()

    ObjDelete( "anm_ritualplace1_candles" );
    ObjSet( "anm_ritualplace1_candles_fire", { alp = 1, playing = true } );

    if ( cmn.IsEventDone( "use_ingredients1_1" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_2" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_3" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_4" ) ) then

      ObjSet( "obj_ritualplace1_use_auratrace1", { input = true } );
      ObjSet( "spr_ruinedsquare1_mentalmagnifier1", { input = true } );
      ObjSet( "gfx_ruinedsquare1_mentalmagnifier1", { active = true } );
      ObjDelete( "anm_ritualplace1_broken_ritual" );

    end;

    ObjSet( "spr_ruinedsquare1_ritualplace_ingredients_1_1", { alp = 1 } );
    ObjSet( "spr_ruinedsquare1_ritualplace_ingredients_1_2", { alp = 1 } );
    ObjSet( "spr_ruinedsquare1_candle_light_1", { alp = 1, active = true } );
    ObjSet( "spr_ruinedsquare1_candle_light_2", { alp = 1, active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_ingredients1_1",     use_ingredients1_1_inv );
  cmn.AddSubscriber( "use_ingredients1_1",     use_ingredients1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_1",     use_ingredients1_1_end, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_1_inv", use_ingredients1_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_1_beg", use_ingredients1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_1_end", use_ingredients1_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ingredients1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ingredients1_3" ] =
  {
    type = "use",
    use_obj = "inv_ingredients1_3",
    use_place = "obj_ritualplace1_use_ingredients1_3",
    room = private.room_objname,
    zz = "zz_ritualplace1",
    zz_gate = "gzz_ruinedsquare1_ritualplace1"
  };
  -----------------------------------------------
  local use_ingredients1_3_inv = function ()

    int.InventoryItemRemove( "inv_ingredients1_3" );

  end;
  local use_ingredients1_3_beg = function ()

    ObjDelete( "obj_ritualplace1_use_ingredients1_3" );

  end;
  local use_ingredients1_3_end = function ()

    ObjSet( "anm_ritualplace1_stone", { frame = 45, animfunc = "DoAnim" } );

    if ( cmn.IsEventDone( "use_ingredients1_1" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_2" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_3" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_4" ) ) then

      ObjSet( "obj_ritualplace1_use_auratrace1", { input = true } );
      ObjSet( "spr_ruinedsquare1_mentalmagnifier1", { input = true } );
      ObjSet( "gfx_ruinedsquare1_mentalmagnifier1", { active = true } );
      ObjDelete( "anm_ritualplace1_broken_ritual" );

    end;

    ObjSet( "spr_ruinedsquare1_ritualplace_ingredients_3", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_ingredients1_3",     use_ingredients1_3_inv );
  cmn.AddSubscriber( "use_ingredients1_3",     use_ingredients1_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_3",     use_ingredients1_3_end, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_3_inv", use_ingredients1_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_3_beg", use_ingredients1_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_3_end", use_ingredients1_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ingredients1_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ingredients1_4" ] =
  {
    type = "use",
    use_obj = "inv_ingredients1_4",
    use_place = "obj_ritualplace1_use_ingredients1_4",
    room = private.room_objname,
    zz = "zz_ritualplace1",
    zz_gate = "gzz_ruinedsquare1_ritualplace1"
  };
  -----------------------------------------------
  local use_ingredients1_4_inv = function ()

    int.InventoryItemRemove( "inv_ingredients1_4" );

  end;
  local use_ingredients1_4_beg = function ()

    ObjDelete( "obj_ritualplace1_use_ingredients1_4" );

  end;
  local use_ingredients1_4_end = function ()

    ObjSet( "anm_ritualplace1_runes", { frame = 204, animfunc = "DoAnim" } );

    if ( cmn.IsEventDone( "use_ingredients1_1" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_2" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_3" ) ) and
       ( cmn.IsEventDone( "use_ingredients1_4" ) ) then

      ObjSet( "obj_ritualplace1_use_auratrace1", { input = true } );
      ObjSet( "spr_ruinedsquare1_mentalmagnifier1", { input = true } );
      ObjSet( "gfx_ruinedsquare1_mentalmagnifier1", { active = true } );
      ObjDelete( "anm_ritualplace1_broken_ritual" );

    end;

    ObjSet( "obj_ruinedsquare1_runes", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_ingredients1_4",     use_ingredients1_4_inv );
  cmn.AddSubscriber( "use_ingredients1_4",     use_ingredients1_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_4",     use_ingredients1_4_end, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_4_inv", use_ingredients1_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_4_beg", use_ingredients1_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ingredients1_4_end", use_ingredients1_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sickle1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sickle1_1" ] =
  {
    type = "use",
    use_obj = "inv_sickle1",
    use_place = "obj_ivy1_use_sickle1_1",
    room = private.room_objname,
    zz = "zz_ivy1",
    zz_gate = "gzz_ruinedsquare1_ivy1"
  };
  -----------------------------------------------
  local use_sickle1_1_inv = function ()

    if ( cmn.IsEventDone( "use_sickle1_2" ) ) then

      int.InventoryItemRemove( "inv_sickle1" );

    end;

  end;
  local use_sickle1_1_beg = function ()

    ObjDelete( "obj_ivy1_use_sickle1_1" );
    ObjDelete( "anm_ivy1_bush_static" );
    ObjDelete( "anm_ivy1_bush_click" );

  end;
  local use_sickle1_1_end = function ()

    ObjDelete( "anm_ivy1_sickle" );
    ObjSet( "anm_ivy1_bush",         { alp = 1, playing = true } );
    ObjSet( "spr_ivy1_crossamulet1", { input = true } );
    ObjSet( "gfx_ivy1_crossamulet1", { active = true } );
    ObjSet( "spr_ivy1_spade1",       { input = true } );
    ObjSet( "gfx_ivy1_spade1",       { active = true } );
    ObjSet( "obj_ivy1_use_file1",    { input = true } );

    ObjDelete( "spr_ruinedsquare1_bush" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_sickle1_1",     use_sickle1_1_inv );
  cmn.AddSubscriber( "use_sickle1_1",     use_sickle1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_sickle1_1",     use_sickle1_1_end, private.room_objname );
  cmn.AddSubscriber( "use_sickle1_1_inv", use_sickle1_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_sickle1_1_beg", use_sickle1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_sickle1_1_end", use_sickle1_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_file1_1" ] =
  {
    type = "use",
    use_obj = "inv_file1",
    use_place = "obj_ivy1_use_file1",
    room = private.room_objname,
    zz = "zz_ivy1",
    zz_gate = "gzz_ruinedsquare1_ivy1"
  };
  -----------------------------------------------
  local use_file1_1_inv = function ()

    if cmn.IsEventDone( "use_file1_2" ) then

      int.InventoryItemRemove( "inv_file1" );

    end;

  end;
  local use_file1_1_beg = function ()

    ObjDelete( "obj_ivy1_use_file1" );
    ObjDelete( "anm_ivy1_lattice" );

  end;
  local use_file1_1_end = function ()

    ObjSet( "anm_ivy1_file",           { alp = 1, frame = 616, animfunc = "DoAnim" } );
    ObjSet( "spr_ivy1_ingredients1_3", { input = true } );
    ObjSet( "gfx_ivy1_ingredients1_3", { active = true } );
    ObjDelete( "spr_ruinedsquare1_lattice" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_file1_1",     use_file1_1_inv );
  cmn.AddSubscriber( "use_file1_1",     use_file1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_file1_1",     use_file1_1_end, private.room_objname );
  cmn.AddSubscriber( "use_file1_1_inv", use_file1_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_file1_1_beg", use_file1_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_file1_1_end", use_file1_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle1" ] =
  {
    type = "use",
    use_obj = "inv_handle1",
    use_place = "obj_shop1_use_handle1",
    room = private.room_objname,
    zz = "zz_shop1",
    zz_gate = "gzz_ruinedsquare1_shop1"
  };
  -----------------------------------------------
  local use_handle1_inv = function ()

    int.InventoryItemRemove( "inv_handle1" );

  end;
  local use_handle1_beg = function ()

    ObjDelete( "obj_shop1_use_handle1" );

  end;
  local use_handle1_end = function ()

    ObjSet( "obj_shop1_sickle1", { input = true } );
    ObjSet( "gfx_shop1_sickle1", { active = true } );
    ObjSet( "anm_shop1_use_handle", { alp = 1, frame = 499 } );
    ObjDelete( "anm_shop1_click_sickle" );

    ObjSet( "spr_ruinedsquare1_shop_handle", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_handle1",     use_handle1_inv );
  cmn.AddSubscriber( "use_handle1",     use_handle1_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle1",     use_handle1_end, private.room_objname );
  cmn.AddSubscriber( "use_handle1_inv", use_handle1_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle1_beg", use_handle1_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle1_end", use_handle1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_file1_2" ] =
  {
    type = "use",
    use_obj = "inv_file1",
    use_place = "obj_shop1_use_file1",
    room = private.room_objname,
    zz = "zz_shop1",
    zz_gate = "gzz_ruinedsquare1_shop1"
  };
  -----------------------------------------------
  local use_file1_2_inv = function ()

    if cmn.IsEventDone( "use_file1_1" ) then

      int.InventoryItemRemove( "inv_file1" );

    end;

  end;
  local use_file1_2_beg = function ()

    ObjDelete( "obj_shop1_use_file1" );

  end;
  local use_file1_2_end = function ()

    ObjSet( "spr_shop1_door_open1", { alp = 1 } );
    ObjSet( "obj_shop1_open", { input = true } );
    ObjSet( "gfx_shop1_ingredients1_4", { active = true } );

    ObjDelete( "anm_shop1_spider" );
    ObjDelete( "anm_shop1_door_click" );
    ObjDelete( "anm_shop1_use_file" );
    ObjSet( "anm_shop1_door_statics", { playing = true, alp = 1 } );
    ObjSet( "spr_ruinedsquare1_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_file1_2",     use_file1_2_inv );
  cmn.AddSubscriber( "use_file1_2",     use_file1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_file1_2",     use_file1_2_end, private.room_objname );
  cmn.AddSubscriber( "use_file1_2_inv", use_file1_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_file1_2_beg", use_file1_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_file1_2_end", use_file1_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mentalmagnifier1_7 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mentalmagnifier1_7" ] =
  {
    type = "use",
    use_obj = "inv_mentalmagnifier1",
    use_place = "obj_statue1_use_mentalmagnifier1_7",
    room = private.room_objname,
    zz = "zz_statue1",
    zz_gate = "gzz_ruinedsquare1_statue1"
  };
  -----------------------------------------------
  local use_mentalmagnifier1_7_inv = function ()

    if cmn.IsEventDone( "use_mentalmagnifier1_2" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_1" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_4" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_5" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_6" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_3" ) then

      int.InventoryItemRemove( "inv_mentalmagnifier1" );

    end;

  end;
  local use_mentalmagnifier1_7_beg = function ()

    ObjDelete( "obj_statue1_use_mentalmagnifier1_7" );

  end;
  local use_mentalmagnifier1_7_end = function ()

    ObjSet( "anm_statue1_statics_aura", { alp = 1, playing = true } );
    ObjDelete( "anm_statue1_hand" );
    ObjDelete( "anm_statue1_mentalmagnifier" );
    ObjSet( "obj_statue1_auratrace_get", { input = true } );
    ObjSet( "gfx_statue1_auratrace1_7", { active = true } );

    ObjSet( "spr_ruinedsquare1_statue_auratrace_2", { alp = 1, active = true } );
    ObjDelete( "spr_ruinedsquare1_statue_auratrace_1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mentalmagnifier1_7",     use_mentalmagnifier1_7_inv );
  cmn.AddSubscriber( "use_mentalmagnifier1_7",     use_mentalmagnifier1_7_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_7",     use_mentalmagnifier1_7_end, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_7_inv", use_mentalmagnifier1_7_inv, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_7_beg", use_mentalmagnifier1_7_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_7_end", use_mentalmagnifier1_7_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_mentalmagnifier1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mentalmagnifier1_3" ] =
  {
    type = "use",
    use_obj = "inv_mentalmagnifier1",
    use_place = "obj_ruinedsquare1_use_mentalmagnifier1_3",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_mentalmagnifier1_3_inv = function ()

    if cmn.IsEventDone( "use_mentalmagnifier1_2" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_1" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_4" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_5" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_6" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_7" ) then

      int.InventoryItemRemove( "inv_mentalmagnifier1" );

    end;

  end;
  local use_mentalmagnifier1_3_beg = function ()

    ObjDelete( "obj_ruinedsquare1_use_mentalmagnifier1_3" );

  end;
  local use_mentalmagnifier1_3_end = function ()

    ObjSet( "obj_ruinedsquare1_auratrace_get3", { input = true } );
    ObjSet( "gfx_ruinedsquare1_auratrace1_3", { active = true } );

    ObjSet( "anm_ruinedsquare1_statics_aura3", { alp = 1, playing = true } );
    ObjDelete( "anm_ruinedsquare1_hand_3" );
    ObjDelete( "anm_ruinedsquare1_open_aura3" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mentalmagnifier1_3",     use_mentalmagnifier1_3_inv );
  cmn.AddSubscriber( "use_mentalmagnifier1_3",     use_mentalmagnifier1_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_3",     use_mentalmagnifier1_3_end, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_3_inv", use_mentalmagnifier1_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_3_beg", use_mentalmagnifier1_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_3_end", use_mentalmagnifier1_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mentalmagnifier1_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mentalmagnifier1_4" ] =
  {
    type = "use",
    use_obj = "inv_mentalmagnifier1",
    use_place = "obj_ruinedsquare1_use_mentalmagnifier1_4",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_mentalmagnifier1_4_inv = function ()

    if cmn.IsEventDone( "use_mentalmagnifier1_2" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_1" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_3" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_5" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_6" ) and 
       cmn.IsEventDone( "use_mentalmagnifier1_7" ) then

      int.InventoryItemRemove( "inv_mentalmagnifier1" );

    end;

  end;
  local use_mentalmagnifier1_4_beg = function ()

    ObjDelete( "obj_ruinedsquare1_use_mentalmagnifier1_4" );

  end;
  local use_mentalmagnifier1_4_end = function ()

    ObjSet( "obj_ruinedsquare1_auratrace_get4", { input = true } );
    ObjSet( "gfx_ruinedsquare1_auratrace1_4", { active = true } );

    ObjSet( "anm_ruinedsquare1_statics_aura4", { alp = 1, playing = true } );
    ObjDelete( "anm_ruinedsquare1_hand4" );
    ObjDelete( "anm_ruinedsquare1_open_aura4" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_mentalmagnifier1_4",     use_mentalmagnifier1_4_inv );
  cmn.AddSubscriber( "use_mentalmagnifier1_4",     use_mentalmagnifier1_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_4",     use_mentalmagnifier1_4_end, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_4_inv", use_mentalmagnifier1_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_4_beg", use_mentalmagnifier1_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_mentalmagnifier1_4_end", use_mentalmagnifier1_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_letters1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_letters1" ] =
  {
    type = "use",
    use_obj = "inv_letters1",
    use_place = "obj_statue1_use_letters1",
    room = private.room_objname,
    zz = "zz_statue1",
    zz_gate = "gzz_ruinedsquare1_statue1"
  };
  -----------------------------------------------
  local use_letters1_inv = function ()

    int.InventoryItemRemove( "inv_letters1" );

  end;
  local use_letters1_beg = function ()

    ObjDelete( "obj_statue1_use_letters1" );
    ObjDelete( "anm_statue1_plate_click" );
    ObjSet( "obj_statue1_plate", { alp = 1 } );

  end;
  local use_letters1_end = function ()

    ObjDelete( "anm_statue1_buttons" );
    ObjSet( "obj_statue1_button_3",  { alp = 1, input = true } );
    ObjSet( "obj_statue1_button_10", { alp = 1, input = true } );
    ObjSet( "obj_statue1_button_13", { alp = 1, input = true } );

    ObjSet( "spr_ruinedsquare1_letters", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_letters1",     use_letters1_inv );
  cmn.AddSubscriber( "use_letters1",     use_letters1_beg, private.room_objname );
  cmn.AddSubscriber( "use_letters1",     use_letters1_end, private.room_objname );
  cmn.AddSubscriber( "use_letters1_inv", use_letters1_inv, private.room_objname );
  cmn.AddSubscriber( "use_letters1_beg", use_letters1_beg, private.room_objname );
  cmn.AddSubscriber( "use_letters1_end", use_letters1_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_statue1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_statue1" ] =
  {
    type = "click",
    clk_obj = "obj_statue1_buttons",
    room = private.room_objname,
    zz = "zz_statue1",
    zz_gate = "gzz_ruinedsquare1_statue1"    
  };
  -----------------------------------------------
  local win_statue1 = function ()

    if ( cmn.IsEventDone( "win_statue1" ) ) then

      ObjSet( "obj_statue1_plate",   { pos_x = 445 } );
      ObjSet( "obj_statue1_buttons", { input = false } );
      ObjSet( "spr_statue1_file1",   { input = true } );
      ObjSet( "gfx_statue1_file1",   { active = true } );
      ObjSet( "obj_statue1_use_mentalmagnifier1_7", { input = true } );

      ObjSet( "spr_ruinedsquare1_inscription", { alp = 1 } );
      ObjSet( "spr_ruinedsquare1_plate", { pos_x = 684, pos_y = 464 } );
      ObjSet( "spr_ruinedsquare1_file", { alp = 1 } );
      ObjSet( "spr_ruinedsquare1_statue_auratrace_1", { alp = 1 } );

    end;

    if ( cmn.IsEventStart( "win_statue1" ) ) then

      private.Statue1Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_statue1", win_statue1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_ruinedsquare1_richard1_2 () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "dlg_ruinedsquare1_richard1_2" ] =
  --{
  --  type = "click",
  --  clk_obj = "obj_int_button_skull",
  --  room = "int_button_skull",
  --};
  -----------------------------------------------
  local dlg_ruinedsquare1_richard1_2_beg = function ()

  end;
  -----------------------------------------------
  local dlg_ruinedsquare1_richard1_2_end = function ()

    ObjDelete( "dlg_ruinedsquare1_richard1_2" );

  end;

  cmn.AddSubscriber( "dlg_ruinedsquare1_richard1_2",     dlg_ruinedsquare1_richard1_2_beg );
  cmn.AddSubscriber( "dlg_ruinedsquare1_richard1_2",     dlg_ruinedsquare1_richard1_2_end );
  cmn.AddSubscriber( "dlg_ruinedsquare1_richard1_2_beg", dlg_ruinedsquare1_richard1_2_beg );
  cmn.AddSubscriber( "dlg_ruinedsquare1_richard1_2_end", dlg_ruinedsquare1_richard1_2_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_1_10()

  int.AddScreensaver( "spr_statue1_screensaver_1_10" );

end;    
function private.get_screensaver_1_11()

  int.AddScreensaver( "spr_shop1_screensaver_1_11" );

end;    
function private.get_screensaver_1_12()

  int.AddScreensaver( "spr_ivy1_screensaver_1_12" );

end;  
-----------------------------------------------------------------------
function private.get_letters1_1 ()

  cmn.SetEventDone( "get_letters1_1" );
  cmn.CallEventHandler( "get_letters1_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_spade1 ()

  cmn.SetEventDone( "get_spade1" );
  cmn.CallEventHandler( "get_spade1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_crossamulet1 ()

  cmn.SetEventDone( "get_crossamulet1" );
  cmn.CallEventHandler( "get_crossamulet1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_ingredients1_3 ()

  cmn.SetEventDone( "get_ingredients1_3" );
  cmn.CallEventHandler( "get_ingredients1_3" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_sickle1 ()

  cmn.SetEventDone( "get_sickle1" );
  cmn.CallEventHandler( "get_sickle1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_ingredients1_4" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function public.get_ingredients1_4 ()

  if cmn.IsEventDone( "get_sickle1" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function public.get_auratrace1_7 ()

  int.Lock( true );

  local count = 0;

  for i = 1, 7 do

    if ( cmn.IsEventDone( "get_auratrace1_"..i ) ) then

      count = count + 1;

    end;

  end;

  if count ~= 0 then
    for i = 1, count do
      ObjSet( "spr_statue1_phial_aura_"..i, { alp = 1 } );
      ObjSet( "spr_statue1_phial_aura_light_"..i, { alp = 1 } );
    end;
  end;

  local func_end = function ()

    local func_end1 = function ()

      local func_end2 = function ()

        ObjSet( "obj_statue1_phial", { alp = 0 } );
        cmn.CloseSubRoom();
        cmn.GetObjectSfx();
        ObjSet( "obj_statue1_auratrace_get", { pos_x = 329, pos_y = 216 } );
        cmn.SetEventDone( "get_auratrace1_7" );
        cmn.SetEventDone( "use_mentalmagnifier1_7" );
        cmn.CallEventHandler( "get_auratrace1_7" );
        
        if ( cmn.IsEventDone( "get_auratrace1_3" ) and
             cmn.IsEventDone( "get_auratrace1_4" ) and
             cmn.IsEventDone( "get_auratrace1_7" ) ) then
          
             ObjSet( "inv_mentalmagnifier1_add", { active = false, alp = 0 } );  
          
        end;        

      end;

      ObjAnimate( "obj_statue1_phial", "pos_xy", 0, 0, func_end2, 
      { 
        0.0, 3, 182, 129,
        0.6, 3, 520, 294
      } );

    end;

    ObjAnimate( "spr_statue1_phial_aura_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );
    ObjAnimate( "spr_statue1_phial_aura_light_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );

    ObjSet( "anm_statue1_statics_aura", { alp = 0 } );
    ObjSet( "gfx_statue1_auratrace1_7", { alp = 0, active = false } );
    ObjSet( "anm_statue1_aura7_get", { alp = 1 } );
    AnimPlay( "anm_statue1_aura7_get", "DoAnim", func_end1 ); 

  end;

  int.InventoryItemRemove( "inv_soulphial1" );

  ObjSet( "obj_statue1_phial", { active = true } );

  ObjAnimate( "obj_statue1_phial", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

  ObjAnimate( "obj_statue1_phial", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, 520, 294,
    0.2, 3, 520, 294,
    0.8, 3, 182, 129
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_magic_absorb" );

end;
-----------------------------------------------------------------------
function private.get_handle1 ()

  ObjSet( "spr_statue1_handle1", { alp = 1 } );
  cmn.SetEventDone( "get_handle1" );
  cmn.CallEventHandler( "get_handle1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_file1 ()

  cmn.SetEventDone( "get_file1" );
  cmn.CallEventHandler( "get_file1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function public.get_auratrace1_3 ()

  int.Lock( true );
  ObjSet( "obj_ruinedsquare1_phial", { pos_x = -400, pos_x = 775, ang = -0.58, scale_x = - 1, active = true } );

  local count = 0;

  for i = 1, 7 do

    if ( cmn.IsEventDone( "get_auratrace1_"..i ) ) then

      count = count + 1;

    end;

  end;

  if count ~= 0 then
    for i = 1, count do
      ObjSet( "spr_ruinedsquare1_phial_aura_"..i, { alp = 1 } );
      ObjSet( "spr_ruinedsquare1_phial_aura_light_"..i, { alp = 1 } );
    end;
  end;

  local func_end = function ()

    local func_end1 = function ()

      local func_end2 = function ()

        cmn.GetObjectSfx();
        ObjSet( "obj_ruinedsquare1_auratrace_get3", { pos_x = 530, pos_y = 848 } );
        ObjSet( "obj_ruinedsquare1_phial", { active = false } );

        cmn.SetEventDone( "get_auratrace1_3" );
        cmn.SetEventDone( "use_mentalmagnifier1_3" );
        cmn.CallEventHandler( "get_auratrace1_3" );
        
        if ( cmn.IsEventDone( "get_auratrace1_3" ) and
             cmn.IsEventDone( "get_auratrace1_4" ) and
             cmn.IsEventDone( "get_auratrace1_7" ) ) then
          
             ObjSet( "inv_mentalmagnifier1_add", { active = false, alp = 0 } );  
          
        end;            

      end;

      ObjAnimate( "obj_ruinedsquare1_phial", "pos_xy", 0, 0, func_end2, 
      { 
        0.0, 3, 505, 563,
        0.6, 3, 492, 838
      } );

    end;

    ObjAnimate( "spr_ruinedsquare1_phial_aura_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );
    ObjAnimate( "spr_ruinedsquare1_phial_aura_light_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );

    ObjSet( "anm_ruinedsquare1_statics_aura3", { alp = 0 } );
    ObjSet( "gfx_ruinedsquare1_auratrace1_3", { alp = 0, active = false } );
    ObjSet( "anm_ruinedsquare1_aura3_get", { alp = 1 } );
    AnimPlay( "anm_ruinedsquare1_aura3_get", "DoAnim", func_end1 ); 

  end;

  int.InventoryItemRemove( "inv_soulphial1" );

  ObjAnimate( "obj_ruinedsquare1_phial", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, -400, 775,
    0.9, 3, 505, 563
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_magic_absorb" );

end;
-----------------------------------------------------------------------
function public.get_auratrace1_4 ()

  int.Lock( true );
  ObjSet( "obj_ruinedsquare1_phial", { pos_x = 381, pos_x = 476, ang = 0.11, scale_x = - 1, active = true } );

  local count = 0;

  for i = 1, 7 do

    if ( cmn.IsEventDone( "get_auratrace1_"..i ) ) then

      count = count + 1;

    end;

  end;

  if count ~= 0 then
    for i = 1, count do
      ObjSet( "spr_ruinedsquare1_phial_aura_"..i, { alp = 1 } );
      ObjSet( "spr_ruinedsquare1_phial_aura_light_"..i, { alp = 1 } );
    end;
  end;

  local func_end = function ()

    local func_end1 = function ()

      local func_end2 = function ()

        cmn.GetObjectSfx();
        ObjSet( "obj_ruinedsquare1_auratrace_get4", { pos_x = 120, pos_y = 820 } );
        ObjSet( "obj_ruinedsquare1_phial", { active = false } );

        cmn.SetEventDone( "get_auratrace1_4" );
        cmn.SetEventDone( "use_mentalmagnifier1_4" );
        cmn.CallEventHandler( "get_auratrace1_4" );
        
        if ( cmn.IsEventDone( "get_auratrace1_3" ) and
             cmn.IsEventDone( "get_auratrace1_4" ) and
             cmn.IsEventDone( "get_auratrace1_7" ) ) then
          
             ObjSet( "inv_mentalmagnifier1_add", { active = false, alp = 0 } );  
          
        end;            

      end;

      ObjAnimate( "obj_ruinedsquare1_phial", "pos_xy", 0, 0, func_end2, 
      { 
        0.0, 3, 381, 476,
        0.6, 3, 51, 1065
      } );

    end;

    ObjAnimate( "spr_ruinedsquare1_phial_aura_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );
    ObjAnimate( "spr_ruinedsquare1_phial_aura_light_"..( count + 1 ), "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      2.0, 0, 0,
      2.3, 0, 1,
    } );

    ObjSet( "anm_ruinedsquare1_statics_aura4", { alp = 0 } );
    ObjSet( "gfx_ruinedsquare1_auratrace1_4", { alp = 0, active = false } );
    ObjSet( "anm_ruinedsquare1_aura4_get", { alp = 1 } );
    AnimPlay( "anm_ruinedsquare1_aura4_get", "DoAnim", func_end1 ); 

  end;

  int.InventoryItemRemove( "inv_soulphial1" );

  ObjAnimate( "obj_ruinedsquare1_phial", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, 51, 1065,
    0.9, 3, 381, 476
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_click_magic_absorb" );

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function public.use_ingredients1_2 ()

  local item = "inv_ingredients1_2";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_ritualplace1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualplace1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualplace1_use_ingredients1_2", true ) ) then

    cmn.CallEventHandler( "use_ingredients1_2_inv" );
    cmn.CallEventHandler( "use_ingredients1_2_beg" );

    local func_end = function ()

      int.Lock( false );

      if ( cmn.IsEventDone( "use_ingredients1_1" ) ) and
         ( cmn.IsEventDone( "use_ingredients1_3" ) ) and
         ( cmn.IsEventDone( "use_ingredients1_4" ) ) then

        int.Lock( true );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_anim_appear_ritual" );
        AnimPlay( "anm_ritualplace1_broken_ritual", "DoAnim", function ()

          cmn.SetEventDone( "use_ingredients1_2" );
          cmn.CallEventHandler( "use_ingredients1_2_end" );

          cmn.CloseSubRoom( true );
          private.dlg_ruinedsquare1_richard1_2();

        end );

      else

        cmn.SetEventDone( "use_ingredients1_2" );
        cmn.CallEventHandler( "use_ingredients1_2_end" );

      end;

    end;

    int.Lock( true );

    AnimPlay( "anm_ritualplace1_symbols", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_write_chalk" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_auratrace1 ()

  local item = "inv_soulphial1";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_ritualplace1", false ) ) and
     ( cmn.IsEventDone( "get_auratrace1_1" ) ) and
     ( cmn.IsEventDone( "get_auratrace1_2" ) ) and
     ( cmn.IsEventDone( "get_auratrace1_3" ) ) and
     ( cmn.IsEventDone( "get_auratrace1_4" ) ) and
     ( cmn.IsEventDone( "get_auratrace1_5" ) ) and
     ( cmn.IsEventDone( "get_auratrace1_6" ) ) and
     ( cmn.IsEventDone( "get_auratrace1_7" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualplace1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualplace1_use_auratrace1", true ) ) and
         ( cmn.IsEventDone( "get_auratrace1_1" ) ) and
         ( cmn.IsEventDone( "get_auratrace1_2" ) ) and
         ( cmn.IsEventDone( "get_auratrace1_3" ) ) and
         ( cmn.IsEventDone( "get_auratrace1_4" ) ) and
         ( cmn.IsEventDone( "get_auratrace1_5" ) ) and
         ( cmn.IsEventDone( "get_auratrace1_6" ) ) and
         ( cmn.IsEventDone( "get_auratrace1_7" ) ) then

    cmn.CallEventHandler( "use_auratrace1_inv" );
    cmn.CallEventHandler( "use_auratrace1_beg" );

    local func_end = function ()

      local func_end_1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_auratrace1" );
        cmn.CallEventHandler( "use_auratrace1_end" );
        cmn.GotoRoom( "mg_mgassault1" );
      
      end;
      
      cmn.CloseSubRoom();      
      
      public.VidTransfer( func_end_1 );


    end;

    int.Lock( true );

    AnimPlay( "anm_ritualplace1_use_aura", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_syringe" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_ingredients1_1 ()

  local item = "inv_ingredients1_1";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_ritualplace1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualplace1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualplace1_use_ingredients1_1", true ) ) then

    cmn.CallEventHandler( "use_ingredients1_1_inv" );
    cmn.CallEventHandler( "use_ingredients1_1_beg" );

    local func_end = function ()

      int.Lock( false );

      if ( cmn.IsEventDone( "use_ingredients1_2" ) ) and
         ( cmn.IsEventDone( "use_ingredients1_3" ) ) and
         ( cmn.IsEventDone( "use_ingredients1_4" ) ) then

        int.Lock( true );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_anim_appear_ritual" );
        AnimPlay( "anm_ritualplace1_broken_ritual", "DoAnim", function ()

          cmn.SetEventDone( "use_ingredients1_1" );
          cmn.CallEventHandler( "use_ingredients1_1_end" );

          cmn.CloseSubRoom( true );
          private.dlg_ruinedsquare1_richard1_2();

        end );

      else

        cmn.SetEventDone( "use_ingredients1_1" );
        cmn.CallEventHandler( "use_ingredients1_1_end" );

      end;

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_loop_candles_1", 1 );

    end;

    int.Lock( true );

    AnimPlay( "anm_ritualplace1_candles", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_put_candles" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_ingredients1_3 ()

  local item = "inv_ingredients1_3";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_ritualplace1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualplace1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualplace1_use_ingredients1_3", true ) ) then

    cmn.CallEventHandler( "use_ingredients1_3_inv" );
    cmn.CallEventHandler( "use_ingredients1_3_beg" );

    local func_end = function ()

      int.Lock( false );

      if ( cmn.IsEventDone( "use_ingredients1_1" ) ) and
         ( cmn.IsEventDone( "use_ingredients1_2" ) ) and
         ( cmn.IsEventDone( "use_ingredients1_4" ) ) then

        int.Lock( true );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_anim_appear_ritual" );
        AnimPlay( "anm_ritualplace1_broken_ritual", "DoAnim", function ()

          cmn.SetEventDone( "use_ingredients1_3" );
          cmn.CallEventHandler( "use_ingredients1_3_end" );

          cmn.CloseSubRoom( true );
          private.dlg_ruinedsquare1_richard1_2();

        end );

      else

        cmn.SetEventDone( "use_ingredients1_3" );
        cmn.CallEventHandler( "use_ingredients1_3_end" );

      end;

    end;

    int.Lock( true );

    AnimPlay( "anm_ritualplace1_stone", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_crystal_middle" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_ingredients1_4 ()

  local item = "inv_ingredients1_4";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_ritualplace1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualplace1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualplace1_use_ingredients1_4", true ) ) then

    cmn.CallEventHandler( "use_ingredients1_4_inv" );
    cmn.CallEventHandler( "use_ingredients1_4_beg" );

    local func_end = function ()

      int.Lock( false );

      if ( cmn.IsEventDone( "use_ingredients1_1" ) ) and
         ( cmn.IsEventDone( "use_ingredients1_2" ) ) and
         ( cmn.IsEventDone( "use_ingredients1_3" ) ) then

        int.Lock( true );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_anim_appear_ritual" );
        AnimPlay( "anm_ritualplace1_broken_ritual", "DoAnim", function ()

          cmn.SetEventDone( "use_ingredients1_4" );
          cmn.CallEventHandler( "use_ingredients1_4_end" );

          cmn.CloseSubRoom( true );
          private.dlg_ruinedsquare1_richard1_2();

        end );

      else

        cmn.SetEventDone( "use_ingredients1_4" );
        cmn.CallEventHandler( "use_ingredients1_4_end" );

      end;

    end;

    int.Lock( true );

    AnimPlay( "anm_ritualplace1_runes", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_put_stones" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_sickle1_1 ()

  local item = "inv_sickle1";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_ivy1", false ) ) and
     ( not cmn.IsEventDone( "use_sickle1_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ivy1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ivy1_use_sickle1_1", true ) ) and
         ( not cmn.IsEventDone( "use_sickle1_1" ) ) then

    cmn.CallEventHandler( "use_sickle1_1_inv" );
    cmn.CallEventHandler( "use_sickle1_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_sickle1_1" );
      cmn.CallEventHandler( "use_sickle1_1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_ivy1_sickle", { alp = 1 } );
    AnimPlay( "anm_ivy1_sickle", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_ivy_sickle" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_file1_1 ()

  local item = "inv_file1";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_ivy1", false ) )and
     ( cmn.IsEventDone( "use_sickle1_1" ) ) and
     ( not cmn.IsEventDone( "use_file1_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ivy1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ivy1_use_file1", true ) ) and
         ( cmn.IsEventDone( "use_sickle1_1" ) ) and
         ( not cmn.IsEventDone( "use_file1_1" ) ) then

    cmn.CallEventHandler( "use_file1_1_inv" );
    cmn.CallEventHandler( "use_file1_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_file1_1" );
      cmn.CallEventHandler( "use_file1_1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_ivy1_file", { alp = 1 } );
    AnimPlay( "anm_ivy1_file", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_rasp_cage" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_handle1 ()

  local item = "inv_handle1";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_shop1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shop1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shop1_use_handle1", true ) ) then

    cmn.CallEventHandler( "use_handle1_inv" );
    cmn.CallEventHandler( "use_handle1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_handle1" );
      cmn.CallEventHandler( "use_handle1_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_shop1_click_sickle", { alp = 0 } );
    ObjSet( "anm_shop1_use_handle", { alp = 1 } );
    AnimPlay( "anm_shop1_use_handle", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_sickle" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_file1_2 ()

  local item = "inv_file1";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_shop1", false ) ) and
     ( not cmn.IsEventDone( "use_file1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shop1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shop1_use_file1", true ) ) and
         ( not cmn.IsEventDone( "use_file1_2" ) ) then

    cmn.CallEventHandler( "use_file1_2_inv" );
    cmn.CallEventHandler( "use_file1_2_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_file1_2" );
        cmn.CallEventHandler( "use_file1_2_end" );
        int_button_mini_ho.Show( "get_ingredients1_4", "shop1", 4, "spr_shop1_runes_panel", private.mini_ho_array ); 

      end;

      ObjAnimate( "anm_shop1_door_statics", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "spr_shop1_door_open1", "alp", 0, 0, "", 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      ObjAnimate( "anm_shop1_use_file", "alp", 0, 0, func_end1, 
      { 
        0.0, 0, 1,
        0.3, 0, 0,
      } );

    end;

    int.Lock( true );

    ObjSet( "anm_shop1_door_click", { alp = 0 } );
    ObjSet( "anm_shop1_use_file", { alp = 1 } );
    AnimPlay( "anm_shop1_use_file", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_cut_rasp_lock" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_mentalmagnifier1_7 ()

  local item = "inv_mentalmagnifier1";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_statue1", false ) and 
       cmn.IsEventDone( "get_soulphial1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_statue1_use_mentalmagnifier1_7", true ) and 
           cmn.IsEventDone( "get_soulphial1" ) ) then

    cmn.CallEventHandler( "use_mentalmagnifier1_7_inv" );
    cmn.CallEventHandler( "use_mentalmagnifier1_7_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mentalmagnifier1_7" );
      cmn.CallEventHandler( "use_mentalmagnifier1_7_end" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_magic_loc_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_statue1_hand", { alp = 0 } );
    ObjSet( "anm_statue1_mentalmagnifier", { alp = 1 } );
    AnimPlay( "anm_statue1_mentalmagnifier", "DoAnim", func_end ); 
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_eye_magic" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_mentalmagnifier1_3 ()

  local item = "inv_mentalmagnifier1";

  if ( cmn.ApplyObj( item, "obj_ruinedsquare1_use_mentalmagnifier1_3", true ) and 
       cmn.IsEventDone( "get_soulphial1" ) ) then

    cmn.CallEventHandler( "use_mentalmagnifier1_3_inv" );
    cmn.CallEventHandler( "use_mentalmagnifier1_3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mentalmagnifier1_3" );
      cmn.CallEventHandler( "use_mentalmagnifier1_3_end" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_magic_loc_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_ruinedsquare1_hand_3", { alp = 0 } );
    ObjSet( "anm_ruinedsquare1_open_aura3", { alp = 1 } );
    AnimPlay( "anm_ruinedsquare1_open_aura3", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_eye_magic" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_mentalmagnifier1_4 ()

  local item = "inv_mentalmagnifier1";

  if ( cmn.ApplyObj( item, "obj_ruinedsquare1_use_mentalmagnifier1_4", true ) and 
       cmn.IsEventDone( "get_soulphial1" ) ) then

    cmn.CallEventHandler( "use_mentalmagnifier1_4_inv" );
    cmn.CallEventHandler( "use_mentalmagnifier1_4_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mentalmagnifier1_4" );
      cmn.CallEventHandler( "use_mentalmagnifier1_4_end" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_magic_loc_loop", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_ruinedsquare1_hand4", { alp = 0 } );
    ObjSet( "anm_ruinedsquare1_open_aura4", { alp = 1 } );
    AnimPlay( "anm_ruinedsquare1_open_aura4", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_use_eye_magic" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_letters1 ()

  local item = "inv_letters1";

  if ( cmn.ApplyObj( item, "gzz_ruinedsquare1_statue1", false ) ) and
     ( cmn.IsEventDone( "get_letters1_1" ) ) and
     ( cmn.IsEventDone( "get_letters1_2" ) ) and
     ( cmn.IsEventDone( "get_letters1_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_statue1_use_letters1", true ) ) and
         ( cmn.IsEventDone( "get_letters1_1" ) ) and
         ( cmn.IsEventDone( "get_letters1_2" ) ) and
         ( cmn.IsEventDone( "get_letters1_3" ) ) then

    cmn.CallEventHandler( "use_letters1_inv" );
    cmn.CallEventHandler( "use_letters1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_letters1" );
      cmn.CallEventHandler( "use_letters1_end" );
      private.Statue1Start();

    end;

    int.Lock( true );

    AnimPlay( "anm_statue1_buttons", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_missed_parts_willmind" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_ruinedsquare1 ()

  if not ( cmn.IsEventDone( "opn_ruinedsquare1" ) ) then

    local func_end = function ()
      
      local func_end1 = function ()
       
        cmn.SetEventDone( "opn_ruinedsquare1" );
        cmn.CallEventHandler( "opn_ruinedsquare1" );
        int.Lock( false );

        cmn.TutorialShow( "tutorial_map_1" );
        cmn.TutorialSetShown( "tutorial_map_1" );

        interface.KeyTaskDone( true, "task_1_2" );

      end; 
      
      cmn.ShowBbt( "bbt_ruinedsquare1_open" );      
      
      ObjAnimate( "rm_ruinedsquare1", "pos_xy", 0, 0, "", 
      { 
        0.0, 3, 0, 0,
        0.8, 3, -358, -535,
        1.0, 3, -358, -535,
        1.8, 3, 0, 0,
      } );
      ObjAnimate( "rm_ruinedsquare1", "scale_xy", 0, 0, func_end1, 
      { 
        0.0, 3, 1, 1,
        0.8, 3, 1.7, 1.7,
        1.0, 3, 1.7, 1.7,
        1.8, 3, 1, 1,
      } ); 

    end;
    
    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_camera_ends" );
    AnimPlay( "anm_ruinedsquare1_camera", "DoAnim", func_end );

  end;

  cmn.StopAllEnv( "audio/level1/env/aud_rm_ruinedsquare1_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_rm_ruinedsquare1_env", 1 );

  if ( cmn.IsEventDone( "use_ingredients1_1" ) ) and
     ( cmn.IsEventDone( "use_ingredients1_2" ) ) and
     ( cmn.IsEventDone( "use_ingredients1_3" ) ) and
     ( cmn.IsEventDone( "use_ingredients1_4" ) ) and
     ( not cmn.IsEventDone( "dlg_ruinedsquare1_richard1_2" ) ) then

    private.dlg_ruinedsquare1_richard1_2();

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_ruinedsquare1();

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if not ( cmn.IsEventDone( "get_auratrace1_3" ) and
           cmn.IsEventDone( "get_auratrace1_4" ) and
           cmn.IsEventDone( "get_auratrace1_7" ) ) then
    
    ObjSet( "inv_mentalmagnifier1_add", { active = true } );
    ObjAnimate( "inv_mentalmagnifier1_add", "alp", 1, 0, "",
    {
      0.0, 3, 0,
      2.0, 3, 0.3,
      4.0, 3, 0,
    } );      
    
  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  ObjSet( "inv_mentalmagnifier1_add", { alp = 0, active = false } );  
  
end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_letters1_1" );
  int.AddedTaskMap( private.room_objname, "get_spade1",                                  { "use_sickle1_1" } );
  int.AddedTaskMap( private.room_objname, "get_crossamulet1",                            { "use_sickle1_1" } );
  int.AddedTaskMap( private.room_objname, "get_ingredients1_3",                          { "use_file1_1" } );
  int.AddedTaskMap( private.room_objname, "get_sickle1",                                 { "use_handle1" } );
  int.AddedTaskMap( private.room_objname, "get_ingredients1_4",                          { "use_file1_2" } );
  int.AddedTaskMap( private.room_objname, "get_auratrace1_7",                            { "use_mentalmagnifier1_7", "get_soulphial1" } );
  int.AddedTaskMap( private.room_objname, "get_handle1" );
  int.AddedTaskMap( private.room_objname, "get_file1",                                   { "win_statue1" } );
  int.AddedTaskMap( private.room_objname, "get_auratrace1_3",                            { "use_mentalmagnifier1_3", "get_soulphial1" } );
  int.AddedTaskMap( private.room_objname, "get_auratrace1_4",                            { "use_mentalmagnifier1_4", "get_soulphial1" } );
  int.AddedTaskMap( private.room_objname, "get_soulphial1",                              { "dlg_ruinedsquare1_richard1_2" } );
  int.AddedTaskMap( private.room_objname, "get_mentalmagnifier1",                        { "dlg_ruinedsquare1_richard1_2" } );

  int.AddedTaskMap( private.room_objname, "use_ingredients1_2",                          { "get_ingredients1_2" } );
  int.AddedTaskMap( private.room_objname, "use_auratrace1",                              { "get_auratrace1_1", "get_auratrace1_2", "get_auratrace1_3", "get_auratrace1_4", "get_auratrace1_5", "get_auratrace1_6", "get_auratrace1_7" } );
  int.AddedTaskMap( private.room_objname, "use_ingredients1_1",                          { "get_ingredients1_1" } );
  int.AddedTaskMap( private.room_objname, "use_ingredients1_3",                          { "get_ingredients1_3" } );
  int.AddedTaskMap( private.room_objname, "use_ingredients1_4",                          { "get_ingredients1_4" } );
  int.AddedTaskMap( private.room_objname, "use_sickle1_1",                               { "get_sickle1" } );
  int.AddedTaskMap( private.room_objname, "use_file1_1",                                 { "get_file1", "use_sickle1_1" } );
  int.AddedTaskMap( private.room_objname, "use_handle1",                                 { "get_handle1" } );
  int.AddedTaskMap( private.room_objname, "use_file1_2",                                 { "get_file1" } );
  int.AddedTaskMap( private.room_objname, "use_mentalmagnifier1_7",                      { "get_mentalmagnifier1" } );
  int.AddedTaskMap( private.room_objname, "use_mentalmagnifier1_3",                      { "get_mentalmagnifier1" } );
  int.AddedTaskMap( private.room_objname, "use_mentalmagnifier1_4",                      { "get_mentalmagnifier1" } );
  int.AddedTaskMap( private.room_objname, "use_letters1",                                { "get_letters1_1","get_letters1_2", "get_letters1_3" } );

  int.AddedTaskMap( private.room_objname, "win_statue1",                                 { "use_letters1" } );

  int.AddedTaskMap( private.room_objname, "dlg_ruinedsquare1_richard1_2",                { "use_ingredients1_1", "use_ingredients1_2", "use_ingredients1_3", "use_ingredients1_4" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  private.mini_ho_array = { 
                            "spr_shop1_runes_1", 
                            "spr_shop1_runes_2", 
                            "spr_shop1_runes_3", 
                            "spr_shop1_runes_4", 
                          };

  for i = 1, #private.mini_ho_array do

    ObjSet( private.mini_ho_array[ i ], { 
      event_mdown = function() 
                      int_button_mini_ho.MiniHoTaskFind( "get_ingredients1_4", "shop1", private.mini_ho_array[ i ], 4, "" );
                    end,
      event_menter = function () cmn.SetCursor( CURSOR_GET );  end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end  } );

  end;


  subroom.Define( "zz_statue1" ); 
  subroom.Define( "zz_shop1" );   
  -------------------------------------------------
  function zz_statue1.Open()

    if ( cmn.IsEventStart( "win_statue1" ) and not cmn.IsEventDone( "win_statue1" ) ) then
      
      cmn.MiniGameShow( "statue1" );
      common_impl.PassingMgStart( "statue1" );
      
    end;

  end;
  -------------------------------------------------
  function zz_statue1.PreClose()

    if ( cmn.IsEventStart( "win_statue1" ) and not cmn.IsEventDone( "win_statue1" ) ) then
      
      cmn.MiniGameHide( "statue1" );
      common_impl.PassingMgStop( "statue1" );    
  
    end;  

  end;
  -------------------------------------------------
  function zz_statue1.Skip ()

    private.Statue1Skip();

  end;
  -------------------------------------------------
  function zz_statue1.Reset ()

    private.Statue1Reset();

  end;
  -------------------------------------------------
  subroom.Define( "zz_ritualplace1" );  
  -------------------------------------------------
  function zz_ritualplace1.Open ()

    if ( cmn.IsEventDone( "use_ingredients1_1" ) ) then

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_loop_candles_1", 1 );

    end;

  end;
  -------------------------------------------------
  function zz_ritualplace1.PreClose ()

    if ( cmn.IsEventDone( "use_ingredients1_1" ) ) then

      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_loop_candles_1" );

    end;

  end;
  -------------------------------------------------
  function zz_ritualplace1.Close ()

    cmn.NoteScaleEnd( { "spr_ritualplace1_note" }, true );

  end;
  -------------------------------------------------
  -------------------------------------------------
  function zz_shop1.PreOpen ()

     if cmn.IsEventDone( "use_file1_2" ) and not
        cmn.IsEventDone( "get_ingredients1_4" ) then
       int_button_mini_ho.Show( "get_ingredients1_4", "shop1", 4, "spr_shop1_runes_panel", private.mini_ho_array ); 
     end;       
       
  end;  
  -------------------------------------------------
  function zz_shop1.PreClose()

    if cmn.IsEventDone( "use_file1_2" ) and not
        cmn.IsEventDone( "get_ingredients1_4" ) then
      int_button_mini_ho.Hide(); 
    end;        
       
  end;

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_ruinedsquare1_candle_light_1", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  ObjAnimate( "spr_ruinedsquare1_candle_light_2", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  ObjAnimate( "spr_ruinedsquare1_ritualplace_auratrace_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  ObjAnimate( "spr_ruinedsquare1_statue_auratrace_1", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  ObjAnimate( "spr_ruinedsquare1_statue_auratrace_2", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

end;
--*********************************************************************************************************************
function public.VidTransfer ( func_end1 )

  local func_end = function ( skip )

    func_end1();
    int.Lock( false );
    
    if ( skip ) then

      cmn.StopAudio( "sfx", "audio/level1/mus/aud_transfer_past_vid_mus" );
      cmn.StopAudio( "voc", "audio/level1/voc/aud_ruinedsquare1_transfer_voc" );
      
    end;

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_ruinedsquare1_transfer_past_1", func_end, nil, 0 );  
  cmn.PlayAudio( "voc", "audio/level1/voc/aud_ruinedsquare1_transfer_voc" );
  cmn.PlayAudio( "sfx", "audio/level1/mus/aud_transfer_past_vid_mus", nil, nil, 13 );

end;
--*********************************************************************************************************************
function private.dlg_ruinedsquare1_richard1_2 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_mentalmagnifier1" );
    cmn.CallEventHandler( "get_soulphial1" );
    
    cmn.GetObjectSfx();

    ObjSet( "anm_ruinedsquare1_richard1_2_richard_static_1",      { alp = 0 } );
    ObjSet( "anm_ruinedsquare1_richard1_2_richard_static_2",      { alp = 0 } );
    ObjSet( "anm_ruinedsquare1_richard1_2_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_ruinedsquare1_richard1_2_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_ruinedsquare1_richard1_2_richard_static_1" );
    AnimStop( "anm_ruinedsquare1_richard1_2_richard_static_2" );
    AnimStop( "anm_ruinedsquare1_richard1_2_richard_appearance" );

    ObjAnimate( "anm_ruinedsquare1_richard1_2_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_ruinedsquare1_richard1_2_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_mentalmagnifier1" );
      cmn.SetEventDone( "get_soulphial1" );
      cmn.SetEventDone( "dlg_ruinedsquare1_richard1_2" );

      ObjSet( "inv_mentalmagnifier1_add", { active = true } );
      ObjAnimate( "inv_mentalmagnifier1_add", "alp", 1, 0, "",
      {
        0.0, 3, 0,
        2.0, 3, 0.3,
        4.0, 3, 0,
      } );        
      
      cmn.TutorialShow( "tutorial_loupe" );
      cmn.TutorialSetShown( "tutorial_loupe" );

      int.InventoryItemAdd( "inv_richardskull1" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_ruinedsquare1_richard1_2_richard_appearance" );
    ObjSet( "anm_ruinedsquare1_richard1_2_richard_appearance", { alp = 0 } );

    ObjSet( "anm_ruinedsquare1_richard1_2_richard_static_1", { alp = 1 } );
    AnimPlay( "anm_ruinedsquare1_richard1_2_richard_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard1_2", "ruinedsquare1", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_ruinedsquare1_richard1_2_beg" );
  ObjAttach( "dlg_ruinedsquare1_richard1_2", GetCurrentRoom() );  

  ObjSet( "anm_ruinedsquare1_richard1_2_richard_appearance", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );
  AnimPlay( "anm_ruinedsquare1_richard1_2_richard_appearance", "DoAnim", func_anim_end );

  ObjAnimate( "anm_ruinedsquare1_richard1_2_richard_static_1", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull1" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard1_2" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_ruinedsquare1_richard1_2_richard_static_1" );
        AnimPlay( "anm_ruinedsquare1_richard1_2_richard_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_ruinedsquare1_richard1_2_richard_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_ruinedsquare1_richard1_2_richard_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_ruinedsquare1_richard1_2_richard_static_2" );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_creates_cups" );
        AnimPlay( "anm_ruinedsquare1_richard1_2_richard_give", "DoAnim", "" );
        AnimPlay( "anm_ruinedsquare1_richard1_2_object_appearance_1", "DoAnim", "" );
        AnimPlay( "anm_ruinedsquare1_richard1_2_object_appearance_2", "DoAnim", "" );

        ObjAnimate( "spr_ruinedsquare1_mentalmagnifier1", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

        ObjAnimate( "spr_ruinedsquare1_soulphial1", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_ruinedsquare1_richard1_2_richard_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_ruinedsquare1_richard1_2_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
--**** function *** MMG Statue1 *** () end; ****
--*********************************************************************************************************************
  function private.Statue1Init ()

    private.word_buttons = 17;
    private.word_count   = 8;
    private.word_letters = {};
    private.word_pos   = { { {   0,   0 },{   0,-120 } },
                           { {   0,-120 },{   9,-156 },{  24,-165 },{  39,-156 },{  49,-120 } },
                           { {  49,-120 },{  94,-120 } },
                           { {  94,-120 },{  99, -76 },{ 116, -64 },{ 131, -76 },{ 139,-120 } },
                           { { 139,-120 },{ 185,-120 } },
                           { { 185,-120 },{ 203,-157 },{ 230,-163 },{ 254,-157 },{ 275,-120 } },
                           { { 275,-120 },{ 229,-120 } },
                           { { 229,-120 },{ 246, -72 },{ 276, -64 },{ 301, -72 },{ 318,-120 } } };

    for w = 1, private.word_buttons do

      ObjSet( "obj_statue1_button_"..w,
      {
        event_mdown  = function () private.Statue1Click( w ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );

    end;

  end;
--*********************************************************************************************************************
  function private.Statue1Start ()

    cmn.MiniGameShow( "statue1" );
    common_impl.PassingMgStart( "statue1" );

    ng_global.progress[ "std" ][ "win_statue1" ].letters = {};

  end;
--*********************************************************************************************************************
  function private.Statue1Click ( idx )

    ObjAnimate( "spr_statue1_button_"..idx.."_press", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.2, 3, 1.0,
      0.4, 3, 0.0,
    } );

    if ( not cmn.IsEventStart( "win_statue1" ) ) then
      
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_click_willmind" );
      cmn.ShowBbt( "bbt_statue1_use_letters1" );
      return;
      
    else 
      
      local rnd = math.random( 3 );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_willmind_click_"..rnd );
      
    end;

    int.Lock( true );

    local func_end = function ()

      int.Lock( false );

      table.insert( private.word_letters, idx );

      if ( private.Statue1IsWin( idx ) ) then

        int.Lock( true );

        ObjSet( "tmr_statue1_word",
        {
          playing = 1,
          time = 0.3,
          endtrig = private.Statue1WinAnim;
        } );

      end;

    end;

    local count = ( #private.word_letters or 0 ) + 1;
    ObjSet( "txt_statue1_letter_"..count, { text = "txt_statue1_letter_"..idx } );

    for i = 1, count do

      local letter = count - i + 1;

      if ( letter == 1 ) or ( letter == 3 ) or ( letter == 5 ) or ( letter == 7 ) then

        ObjAnimate( "obj_statue1_letter_"..i, "pos_xy", 0, 0, "",
        {
          0.0, 0, private.word_pos[ letter ][ 1 ][ 1 ], private.word_pos[ letter ][ 1 ][ 2 ],
          0.5, 0, private.word_pos[ letter ][ 2 ][ 1 ], private.word_pos[ letter ][ 2 ][ 2 ],
        } );

      else

        ObjAnimate( "obj_statue1_letter_"..i, "pos_xy", 0, 0, "",
        {
          0.000, 0, private.word_pos[ letter ][ 1 ][ 1 ], private.word_pos[ letter ][ 1 ][ 2 ],
          0.125, 0, private.word_pos[ letter ][ 2 ][ 1 ], private.word_pos[ letter ][ 2 ][ 2 ],
          0.250, 0, private.word_pos[ letter ][ 3 ][ 1 ], private.word_pos[ letter ][ 3 ][ 2 ],
          0.375, 0, private.word_pos[ letter ][ 4 ][ 1 ], private.word_pos[ letter ][ 4 ][ 2 ],
          0.500, 0, private.word_pos[ letter ][ 5 ][ 1 ], private.word_pos[ letter ][ 5 ][ 2 ],
        } );

      end;

    end;

    ObjSet( "tmr_statue1_word",
    {
      playing = 1,
      time = 0.5,
      endtrig = func_end;
    } );

  end;
--*********************************************************************************************************************
  function private.Statue1Skip ()

    local word_win = { 7,3,13,13,1,16,3,10 };

    for w = 1, private.word_count do

      ObjSet( "obj_statue1_letter_"..w, { pos_x = private.word_pos[ w ][ #private.word_pos[ w ] ][ 1 ], pos_y = private.word_pos[ w ][ #private.word_pos[ w ] ][ 2 ] } );
      ObjSet( "txt_statue1_letter_"..w, { text = "txt_statue1_letter_"..word_win[ w ] } );

    end;

    cmn.WaitAndRun( private.Statue1WinAnim );

  end;
--*********************************************************************************************************************
  function private.Statue1ResetAnim ( count )    

    for c = 1, count do

      local letter = count - c + 1;

      if ( letter == 1 ) or ( letter == 3 ) or ( letter == 5 ) or ( letter == 7 ) then

        ObjAnimate( "obj_statue1_letter_"..c, "pos_xy", 0, 0, "",
        {
          0.0, 0, private.word_pos[ letter ][ 2 ][ 1 ], private.word_pos[ letter ][ 2 ][ 2 ],
          0.5, 0, private.word_pos[ letter ][ 1 ][ 1 ], private.word_pos[ letter ][ 1 ][ 2 ],
        } );

      else

        ObjAnimate( "obj_statue1_letter_"..c, "pos_xy", 0, 0, "",
        {
          0.000, 0, private.word_pos[ letter ][ 5 ][ 1 ], private.word_pos[ letter ][ 5 ][ 2 ],
          0.125, 0, private.word_pos[ letter ][ 4 ][ 1 ], private.word_pos[ letter ][ 4 ][ 2 ],
          0.250, 0, private.word_pos[ letter ][ 3 ][ 1 ], private.word_pos[ letter ][ 3 ][ 2 ],
          0.375, 0, private.word_pos[ letter ][ 2 ][ 1 ], private.word_pos[ letter ][ 2 ][ 2 ],
          0.500, 0, private.word_pos[ letter ][ 1 ][ 1 ], private.word_pos[ letter ][ 1 ][ 2 ],
        } );

      end;

    end;

    ObjSet( "tmr_statue1_word",
    {
      playing = 1,
      time = 0.5,
      endtrig = function ()

        private.Statue1ResetAnimEnd( count );

      end,
    } );

    local rnd = math.random( 3 );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_willmind_wrong_"..rnd );
    
  end;
--*********************************************************************************************************************
  function private.Statue1ResetAnimEnd ( count )

    count = count - 1;

    if ( count == 0 ) then

      int.Lock( false );
      private.word_letters = {};
      ng_global.progress[ "std" ][ "win_statue1" ].letters = {};

      return;

    end;

    private.Statue1ResetAnim( count );

  end;
--*********************************************************************************************************************
  function private.Statue1Reset ()

    local count = #private.word_letters or 0;

    if ( count == 0 ) then

      return;

    end;

    int.Lock( true );

    private.Statue1ResetAnim( count );

  end;
--*********************************************************************************************************************
  function private.Statue1Load ()

    private.word_letters = {};

    local count = #ng_global.progress[ "std" ][ "win_statue1" ].letters;

    for c = 1, count do

      private.word_letters[ c ] = ng_global.progress[ "std" ][ "win_statue1" ].letters[ c ];

      local letter = count - c + 1;

      if ( letter == 1 ) or ( letter == 3 ) or ( letter == 5 )  or ( letter == 7 ) then

        ObjSet( "obj_statue1_letter_"..c, { pos_x = private.word_pos[ letter ][ 2 ][ 1 ], pos_y = private.word_pos[ letter ][ 2 ][ 2 ] } );
        ObjSet( "txt_statue1_letter_"..c, { text = "txt_statue1_letter_"..private.word_letters[ c ] } );

      else

        ObjSet( "obj_statue1_letter_"..c, { pos_x = private.word_pos[ letter ][ 5 ][ 1 ], pos_y = private.word_pos[ letter ][ 5 ][ 2 ] } );
        ObjSet( "txt_statue1_letter_"..c, { text = "txt_statue1_letter_"..private.word_letters[ c ] } );

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.Statue1IsWin ( idx )

    local word_win = { 10,3,16,1,13,13,3,7 };

    local count = #private.word_letters or 0;

    if ( count < private.word_count ) then

      table.insert( ng_global.progress[ "std" ][ "win_statue1" ].letters, idx );

      return false;

    end;

    for i = 1, private.word_count do

      if ( private.word_letters[ i ] ~= word_win[ i ] ) then

        int.Lock( true );

        ObjSet( "tmr_statue1_word",
        {
          playing = 1,
          time = 0.3,
          endtrig = private.Statue1Reset;
        } );

        return false;

      end;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.Statue1WinAnim ()

    int.Lock( true );

    local func_end = function ()

      int.Lock( false );

      ng_global.progress[ "std" ][ "win_statue1" ].letters = { 10,3,16,1,13,13,3,7 };
      private.Statue1Win();

    end;
    
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_willmind_win" );
    ObjAnimate( "obj_statue1_plate", "pos_x", 0, 0, func_end,
    {
      0.0, 3,  35,
      3.0, 3, 445,
    } );
    
    local rnd = math.random( 3 );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_willmind_wrong_"..rnd );

  end;
--*********************************************************************************************************************
  function private.Statue1Win ()

    common_impl.PassingMgWin( "statue1" );
    cmn.MiniGameHide( "statue1" );
    cmn.SetEventDone( "win_statue1" );
    cmn.CallEventHandler( "win_statue1" );

  end;
--*********************************************************************************************************************
function private.Shop1SickleClk ()

  local func_end = function ()
    cmn.ShowBbt( "bbt_shop1_use_handle1" );
    int.Lock( false );
  end;

  int.Lock( true );
  AnimPlay( "anm_shop1_click_sickle", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_sickle" );

end;
--*********************************************************************************************************************
function private.Shop1DoorClk ()

  local func_end = function ()
    cmn.ShowBbt( "bbt_shop1_use_file1" );
    int.Lock( false );
  end;

  int.Lock( true );
  AnimPlay( "anm_shop1_door_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_lock_doors" );

end;
--*********************************************************************************************************************
function private.Ivy1IvyClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_ivy1_use_sickle1_1" );
    int.Lock( false );

    ObjSet( "anm_ivy1_bush_click",  { alp = 0 } );
    ObjSet( "anm_ivy1_bush_static", { alp = 1 } );

    AnimStop( "anm_ivy1_bush_click" );
    AnimPlay( "anm_ivy1_bush_static", "DoAnim", "" );

  end;

  int.Lock( true );

  ObjSet( "anm_ivy1_bush_static", { alp = 0 } );
  ObjSet( "anm_ivy1_bush_click",  { alp = 1 } );

  AnimStop( "anm_ivy1_bush_static" );
  AnimPlay( "anm_ivy1_bush_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_ivy_zz_ivy1" );

end;
--*********************************************************************************************************************
function private.Ivy1LatticeClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_ivy1_use_file1" );
    int.Lock( false );

  end;

  int.Lock( true );

  AnimPlay( "anm_ivy1_lattice", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_cage_zz_ivy1" );

end;
--*********************************************************************************************************************
function private.Statue1PlateClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_statue1_use_letters1" );
    int.Lock( false );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_willmind_tab" );
  AnimPlay( "anm_statue1_plate_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************