-- name=rm_secondfloor1
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_secondfloor1";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_coffeetable1", "room_hub" );
  ObjAttach( "zz_wardrobe1",    "room_hub" );
  ObjAttach( "zz_roomwindow1",  "room_hub" );
  ObjAttach( "zz_drawerchest1", "room_hub" );

  ObjMultiSet(
  {
    { "spr_coffeetable1_matches1",      { event_mdown = private.get_matches1 } },
    { "spr_coffeetable1_glue1",         { event_mdown = private.get_glue1 } },
    { "spr_coffeetable1_coin1",         { event_mdown = private.get_coin1_1 } },
    { "spr_coffeetable1_toyclothes1_3", { event_mdown = private.get_toyclothes1_3 } },
    { "spr_coffeetable1_portrait1_1",   { event_mdown = private.get_portrait1_1 } },
    { "spr_coffeetable1_pin1",          { event_mdown = private.get_pin1 } },
    { "spr_secondfloor1_kitten1",       { event_mdown = private.get_kitten1 } },
    { "spr_wardrobe1_rose1_2",          { event_mdown = private.get_rose1_2 } },
    { "spr_wardrobe1_pattern1",         { event_mdown = private.get_pattern1 } },
    { "spr_roomwindow1_rose1_1",        { event_mdown = private.get_rose1_1 } },
    { "spr_roomwindow1_figurine1_2",    { event_mdown = private.get_figurine1_2 } },
    { "spr_roomwindow1_emptyflask1",    { event_mdown = private.get_emptyflask1 } },
    { "spr_roomwindow1_toyclothes1_1",  { event_mdown = private.get_toyclothes1_1 } },
    { "spr_roomwindow1_amulet1",        { event_mdown = private.get_amulet1 } },
    { "spr_drawerchest1_heart1_2",      { event_mdown = private.get_heart1_2 } },
    { "spr_drawerchest1_toyclothes1_2", { event_mdown = private.get_toyclothes1_2 } },
    { "spr_drawerchest1_water1",        { event_mdown = private.get_water1 } },
    { "spr_drawerchest1_thread1",       { event_mdown = private.get_thread1 } },
    { "spr_secondfloor1_collect_1_2",   { event_mdown = private.get_collect_1_2 } },
    { "obj_roomwindow1_clk_leaf1",      { event_mdown = private.clk_leaf1 } },
    { "obj_roomwindow1_use_plantreviver1", { event_mdown = private.Roomwindow1FlowerClick } },
    { "obj_roomwindow1_use_glue1",         { event_mdown = private.Roomwindow1FigurineClick } },
    { "obj_coffeetable1_use_heart1",       { event_mdown = private.Coffeetable1BoxClick } },
    { "obj_coffeetable1_use_figurine1",    { event_mdown = private.Coffeetable1HeartboxClick } },
    { "obj_drawerchest1_use_pattern1",     { event_mdown = private.Drawerchest1BoxClick } },
    { "obj_drawerchest1_use_catamulet1",   { event_mdown = private.Drawerchest1CasketClick } },
    { "spr_coffeetable1_screensaver_1_4",     { event_mdown = private.get_screensaver_1_4 } },      
    { "spr_roomwindow1_screensaver_1_5",     { event_mdown = private.get_screensaver_1_5 } },          
  } );

  local get_screensaver_1_4 = function ()

    ObjDelete( "spr_coffeetable1_screensaver_1_4" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_4", get_screensaver_1_4, private.room_objname );  
  local get_screensaver_1_5 = function ()

    ObjDelete( "spr_roomwindow1_screensaver_1_5" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_5", get_screensaver_1_5, private.room_objname );   
  
  private.Wardrobe1Init();

  --------------------------------------------------------------------------------------------
  -- function get_collect_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_1_2 = function ()

    ObjDelete( "spr_secondfloor1_collect_1_2" );

  end;

  cmn.AddSubscriber( "get_collect_1_2", get_collect_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_4 = function ()

    ObjDelete( "obj_secondfloor1_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_4", get_morphobject_1_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_secondfloor1 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_secondfloor1", update_game_mode_secondfloor1, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function opn_secondfloor1 () end;
  --------------------------------------------------------------------------------------------
  local opn_secondfloor1 = function ()

    ObjDelete( "anm_secondfloor1_monster" );
    
    if ng_global.progress[ ng_global.currentprogress ][ "opn_secondfloor1" ].bbt_ho then
      
      ObjDelete( "anm_secondfloor1_dressing" );

    end;    

  end;

  cmn.AddSubscriber( "opn_secondfloor1", opn_secondfloor1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function del_clothes1 () end;
  --------------------------------------------------------------------------------------------
  local del_clothes1 = function ()

      int.InventoryItemRemove( "inv_clothes1" );
      ObjSet( "grm_alley1_square1", { alp = 1, input = true, active = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_alley1_square1_focus");
      end;
      ObjDelete( "obj_alley1_bbt_no_clothes" );
  
  end;

    cmn.AddSubscriber( "del_clothes1", del_clothes1 );  
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_figurine1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurine1_1" ] =
  {
    type = "get",
    get_obj = "spr_secondfloor1_figurine1_1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_figurine1_1_inv = function ()

    int.InventoryItemAdd( "inv_figurine1", "spr_secondfloor1_figurine1_1", "assets/levels/level1/rm_secondfloor1/inv/inv_figurine1_1" );
    level1_inv.CheckFigurine1();

  end;

  cmn.AddSubscriber( "get_figurine1_1", get_figurine1_1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_heart1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_heart1_2" ] =
  {
    type = "get",
    get_obj = "spr_drawerchest1_heart1_2",
    room = private.room_objname,
    zz = "zz_drawerchest1",
    zz_gate = "gzz_secondfloor1_drawerchest1"
  };
  -----------------------------------------------
  local get_heart1_2_inv = function ()

    int.InventoryItemAdd( "inv_heart1", "spr_drawerchest1_heart1_2","assets/levels/level1/rm_secondfloor1/zz_drawerchest1/inv/inv_heart1_1" );
    level1_inv.CheckHeart1();

  end;

  local get_heart1_2_closezz = function ()

    ObjDelete( "gfx_drawerchest1_heart1_2" );

    if cmn.IsEventDone( "get_toyclothes1_2" ) and 
       cmn.IsEventDone( "get_water1" ) and 
       cmn.IsEventDone( "get_thread1" ) then

      ObjDelete( "gzz_secondfloor1_drawerchest1" );

    end;
    
    ObjDelete( "spr_secondfloor1_drawerchest1_heart" );

  end;

  cmn.AddSubscriber( "get_heart1_2", get_heart1_2_inv );
  cmn.AddSubscriber( "get_heart1_2", get_heart1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_matches1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_matches1" ] =
  {
    type = "get",
    get_obj = "spr_coffeetable1_matches1",
    room = private.room_objname,
    zz = "zz_coffeetable1",
    zz_gate = "gzz_secondfloor1_coffeetable1"
  };
  -----------------------------------------------
  local get_matches1_inv = function ()

    int.InventoryItemAdd( "inv_matches1", "spr_coffeetable1_matches1" );

  end;

  local get_matches1_closezz = function ()

    ObjDelete( "gfx_coffeetable1_matches1" );
    ObjDelete( "spr_coffeetable1_matches_shadow" );

    if cmn.IsEventDone( "get_glue1" ) and 
       cmn.IsEventDone( "get_coin1_1" ) and 
       cmn.IsEventDone( "get_toyclothes1_3" ) and 
       cmn.IsEventDone( "get_portrait1_1" ) and 
       cmn.IsEventDone( "get_pin1" ) then

      ObjDelete( "gzz_secondfloor1_coffeetable1" );

    end;
    
    ObjDelete( "spr_secondfloor1_coffeetable1_maches" );

  end;

  cmn.AddSubscriber( "get_matches1", get_matches1_inv );
  cmn.AddSubscriber( "get_matches1", get_matches1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glue1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glue1" ] =
  {
    type = "get",
    get_obj = "spr_coffeetable1_glue1",
    room = private.room_objname,
    zz = "zz_coffeetable1",
    zz_gate = "gzz_secondfloor1_coffeetable1"
  };
  -----------------------------------------------
  local get_glue1_inv = function ()

    int.InventoryItemAdd( "inv_glue1", "spr_coffeetable1_glue1" );

  end;

  local get_glue1_closezz = function ()

    ObjDelete( "gfx_coffeetable1_glue1" );

    if cmn.IsEventDone( "get_matches1" ) and 
       cmn.IsEventDone( "get_coin1_1" ) and 
       cmn.IsEventDone( "get_toyclothes1_3" ) and 
       cmn.IsEventDone( "get_portrait1_1" ) and 
       cmn.IsEventDone( "get_pin1" ) then

      ObjDelete( "gzz_secondfloor1_coffeetable1" );

    end;
    
    ObjDelete( "spr_secondfloor1_coffeetable1_glue" );

  end;

  cmn.AddSubscriber( "get_glue1", get_glue1_inv );
  cmn.AddSubscriber( "get_glue1", get_glue1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin1_1" ] =
  {
    type = "get",
    get_obj = "spr_coffeetable1_coin1",
    room = private.room_objname,
    zz = "zz_coffeetable1",
    zz_gate = "gzz_secondfloor1_coffeetable1"
  };
  -----------------------------------------------
  local get_coin1_1_inv = function ()

    int.InventoryItemAdd( "inv_coin1", "spr_coffeetable1_coin1", "assets/levels/level1/rm_secondfloor1/zz_coffeetable1/inv/inv_coin1_1" );
    level1_inv.CheckCoin1();

  end;

  local get_coin1_1_closezz = function ()

    ObjDelete( "gfx_coffeetable1_coin1" );

    if cmn.IsEventDone( "get_matches1" ) and 
       cmn.IsEventDone( "get_glue1" ) and 
       cmn.IsEventDone( "get_toyclothes1_3" ) and 
       cmn.IsEventDone( "get_portrait1_1" ) and 
       cmn.IsEventDone( "get_pin1" ) then

      ObjDelete( "gzz_secondfloor1_coffeetable1" );

    end;
    
    ObjDelete( "spr_secondfloor1_coffeetable1_coin" );

  end;

  cmn.AddSubscriber( "get_coin1_1", get_coin1_1_inv );
  cmn.AddSubscriber( "get_coin1_1", get_coin1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toyclothes1_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toyclothes1_3" ] =
  {
    type = "get",
    get_obj = "spr_coffeetable1_toyclothes1_3",
    room = private.room_objname,
    zz = "zz_coffeetable1",
    zz_gate = "gzz_secondfloor1_coffeetable1"
  };
  -----------------------------------------------
  local get_toyclothes1_3_inv = function ()

    int.InventoryItemAdd( "inv_toyclothes1", "spr_coffeetable1_toyclothes1_3", "assets/levels/level1/rm_secondfloor1/zz_roomwindow1/inv/inv_toyclothes1_3_flying" );
    level1_inv.CheckToyclothes1();

  end;

  local get_toyclothes1_3_closezz = function ()

    ObjDelete( "gfx_coffeetable1_toyclothes1_3" );

    if cmn.IsEventDone( "get_matches1" ) and 
       cmn.IsEventDone( "get_glue1" ) and 
       cmn.IsEventDone( "get_coin1_1" ) and 
       cmn.IsEventDone( "get_portrait1_1" ) and 
       cmn.IsEventDone( "get_pin1" ) then

      ObjDelete( "gzz_secondfloor1_coffeetable1" );

    end;

  end;

  cmn.AddSubscriber( "get_toyclothes1_3", get_toyclothes1_3_inv );
  cmn.AddSubscriber( "get_toyclothes1_3", get_toyclothes1_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_portrait1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_portrait1_1" ] =
  {
    type = "get",
    get_obj = "spr_coffeetable1_portrait1_1",
    room = private.room_objname,
    zz = "zz_coffeetable1",
    zz_gate = "gzz_secondfloor1_coffeetable1"
  };
  -----------------------------------------------
  local get_portrait1_1_inv = function ()

    int.InventoryItemAdd( "inv_portrait1", "spr_coffeetable1_portrait1_1", "assets/levels/level1/rm_secondfloor1/zz_coffeetable1/inv/inv_portrait1_1" );
    level1_inv.CheckPortrait1();

  end;

  local get_portrait1_1_closezz = function ()

    ObjDelete( "gfx_coffeetable1_portrait1_1" );

    if cmn.IsEventDone( "get_matches1" ) and 
       cmn.IsEventDone( "get_glue1" ) and 
       cmn.IsEventDone( "get_coin1_1" ) and 
       cmn.IsEventDone( "get_toyclothes1_3" ) and 
       cmn.IsEventDone( "get_pin1" ) then

      ObjDelete( "gzz_secondfloor1_coffeetable1" );

    end;
    
    ObjDelete( "spr_secondfloor1_coffeetable1_portrait" );

  end;

  cmn.AddSubscriber( "get_portrait1_1", get_portrait1_1_inv );
  cmn.AddSubscriber( "get_portrait1_1", get_portrait1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pin1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pin1" ] =
  {
    type = "get",
    get_obj = "spr_coffeetable1_pin1",
    room = private.room_objname,
    zz = "zz_coffeetable1",
    zz_gate = "gzz_secondfloor1_coffeetable1"
  };
  -----------------------------------------------
  local get_pin1_inv = function ()

    int.InventoryItemAdd( "inv_pin1", "spr_coffeetable1_pin1" );

  end;

  local get_pin1_closezz = function ()

    ObjDelete( "gfx_coffeetable1_pin1" );
    ObjDelete( "spr_coffeetable1_pin_shadow" );

    if cmn.IsEventDone( "get_matches1" ) and 
       cmn.IsEventDone( "get_glue1" ) and 
       cmn.IsEventDone( "get_coin1_1" ) and 
       cmn.IsEventDone( "get_toyclothes1_3" ) and 
       cmn.IsEventDone( "get_portrait1_1" ) then

      ObjDelete( "gzz_secondfloor1_coffeetable1" );

    end;

  end;

  cmn.AddSubscriber( "get_pin1", get_pin1_inv );
  cmn.AddSubscriber( "get_pin1", get_pin1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_kitten1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_kitten1" ] =
  {
    type = "get",
    get_obj = "spr_secondfloor1_kitten1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_kitten1_inv = function ()

    int.InventoryItemAdd( "inv_kitten1", "spr_secondfloor1_kitten1", "assets/levels/level1/rm_secondfloor1/inv/inv_kitten1" );

  end;

  local get_kitten1_closezz = function ()

    ObjDelete( "gfx_secondfloor1_kitten1" );
    ObjDelete( "anm_secondfloor1_az_cat_1" );
    ObjSet( "anm_secondfloor1_az_cat", { alp = 1, playing = false, frame = 0 } );    

  end;

  cmn.AddSubscriber( "get_kitten1", get_kitten1_inv );
  cmn.AddSubscriber( "get_kitten1", get_kitten1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rose1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rose1_2" ] =
  {
    type = "get",
    get_obj = "spr_wardrobe1_rose1_2",
    room = private.room_objname,
    zz = "zz_wardrobe1",
    zz_gate = "gzz_secondfloor1_wardrobe1"
  };
  -----------------------------------------------
  local get_rose1_2_inv = function ()

    int.InventoryItemAdd( "inv_rose1", "spr_wardrobe1_rose1_2", "assets/levels/level1/rm_secondfloor1/zz_roomwindow1/inv/inv_rose1_2" );
    level1_inv.CheckRose1();

  end;

  local get_rose1_2_closezz = function ()

    ObjDelete( "gfx_wardrobe1_rose1_2" );
    
    ObjDelete( "spr_secondfloor1_wardrobe1_rose" );

  end;

  cmn.AddSubscriber( "get_rose1_2", get_rose1_2_inv );
  cmn.AddSubscriber( "get_rose1_2", get_rose1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pattern1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pattern1" ] =
  {
    type = "get",
    get_obj = "spr_wardrobe1_pattern1",
    room = private.room_objname,
    zz = "zz_wardrobe1",
    zz_gate = "gzz_secondfloor1_wardrobe1"
  };
  -----------------------------------------------
  local get_pattern1_inv = function ()

    int.InventoryItemAdd( "inv_pattern1", "spr_wardrobe1_pattern1" );

  end;

  local get_pattern1_closezz = function ()

    ObjDelete( "gfx_wardrobe1_pattern1" );
    
    ObjDelete( "spr_secondfloor1_wardrobe1_pattern" );

  end;

  cmn.AddSubscriber( "get_pattern1", get_pattern1_inv );
  cmn.AddSubscriber( "get_pattern1", get_pattern1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rose1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rose1_1" ] =
  {
    type = "get",
    get_obj = "spr_roomwindow1_rose1_1",
    room = private.room_objname,
    zz = "zz_roomwindow1",
    zz_gate = "gzz_secondfloor1_roomwindow1"
  };
  -----------------------------------------------
  local get_rose1_1_inv = function ()

    int.InventoryItemAdd( "inv_rose1", "spr_roomwindow1_rose1_1", "assets/levels/level1/rm_secondfloor1/zz_roomwindow1/inv/inv_rose1_1" );
    level1_inv.CheckRose1();

  end;

  local get_rose1_1_closezz = function ()

    ObjDelete( "gfx_roomwindow1_rose1_1" );
    
    ObjDelete( "spr_secondfloor1_roomwindow1_rose" );

  end;

  cmn.AddSubscriber( "get_rose1_1", get_rose1_1_inv );
  cmn.AddSubscriber( "get_rose1_1", get_rose1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurine1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurine1_2" ] =
  {
    type = "get",
    get_obj = "spr_roomwindow1_figurine1_2",
    room = private.room_objname,
    zz = "zz_roomwindow1",
    zz_gate = "gzz_secondfloor1_roomwindow1"
  };
  -----------------------------------------------
  local get_figurine1_2_inv = function ()

    int.InventoryItemAdd( "inv_figurine1", "spr_roomwindow1_figurine1_2", "assets/levels/level1/rm_secondfloor1/inv/inv_figurine1_2" );
    level1_inv.CheckFigurine1();

  end;

  local get_figurine1_2_closezz = function ()

    ObjDelete( "anm_roomwindow1_glue" );
    
    ObjDelete( "spr_secondfloor1_roomwindow1_doll" );

  end;

  cmn.AddSubscriber( "get_figurine1_2", get_figurine1_2_inv );
  cmn.AddSubscriber( "get_figurine1_2", get_figurine1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emptyflask1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emptyflask1" ] =
  {
    type = "get",
    get_obj = "spr_roomwindow1_emptyflask1",
    room = private.room_objname,
    zz = "zz_roomwindow1",
    zz_gate = "gzz_secondfloor1_roomwindow1"
  };
  -----------------------------------------------
  local get_emptyflask1_inv = function ()

    int.InventoryItemAdd( "inv_emptyflask1", "spr_roomwindow1_emptyflask1" );
    ObjSet( "inv_emptyflask1", { drag = false } );

    if ( not cmn.IsEventDone( "get_water1" ) ) then

      ObjSet( "inv_emptyflask1_plus_focus2", { alp = 0 } );

    end;
    
    ObjDelete( "spr_secondfloor1_roomwindow1_bottle" );

  end;

  local get_emptyflask1_closezz = function ()

    ObjDelete( "gfx_roomwindow1_emptyflask1" );
    ObjDelete( "obj_roomwindow1_emptyflask" );
    --ObjDelete( "gzz_secondfloor1_roomwindow1" );

  end;

  cmn.AddSubscriber( "get_emptyflask1", get_emptyflask1_inv );
  cmn.AddSubscriber( "get_emptyflask1", get_emptyflask1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toyclothes1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toyclothes1_1" ] =
  {
    type = "get",
    get_obj = "spr_roomwindow1_toyclothes1_1",
    room = private.room_objname,
    zz = "zz_roomwindow1",
    zz_gate = "gzz_secondfloor1_roomwindow1"
  };
  -----------------------------------------------
  local get_toyclothes1_1_inv = function ()

    int.InventoryItemAdd( "inv_toyclothes1", "spr_roomwindow1_toyclothes1_1", "assets/levels/level1/rm_secondfloor1/zz_roomwindow1/inv/inv_toyclothes1_1_flying" );
    level1_inv.CheckToyclothes1();

  end;

  local get_toyclothes1_1_closezz = function ()

    ObjDelete( "spr_roomwindow1_toyclothes1_1_shadow" );
    ObjDelete( "gfx_roomwindow1_toyclothes1_1" );

    ObjDelete( "spr_secondfloor1_roomwindow1_clothes" );
    
  end;

  cmn.AddSubscriber( "get_toyclothes1_1", get_toyclothes1_1_inv );
  cmn.AddSubscriber( "get_toyclothes1_1", get_toyclothes1_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulet1" ] =
  {
    type = "get",
    get_obj = "spr_roomwindow1_amulet1",
    room = private.room_objname,
    zz = "zz_roomwindow1",
    zz_gate = "gzz_secondfloor1_roomwindow1"
  };
  -----------------------------------------------
  local get_amulet1_inv = function ()

    int.InventoryItemAdd( "inv_amulet1", "spr_roomwindow1_amulet1" );

  end;

  local get_amulet1_closezz = function ()

    ObjDelete( "gfx_roomwindow1_amulet1" );
    ObjDelete( "gzz_secondfloor1_roomwindow1" );
    ObjSet( "spr_secondfloor1_ho_knife", { alp = 1 } );

  end;

  cmn.AddSubscriber( "get_amulet1",         get_amulet1_inv );
  cmn.AddSubscriber( "get_amulet1",         get_amulet1_closezz, private.room_objname );
  cmn.AddSubscriber( "get_amulet1_inv",     get_amulet1_inv,     private.room_objname );
  cmn.AddSubscriber( "get_amulet1_closezz", get_amulet1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toyclothes1_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toyclothes1_2" ] =
  {
    type = "get",
    get_obj = "spr_drawerchest1_toyclothes1_2",
    room = private.room_objname,
    zz = "zz_drawerchest1",
    zz_gate = "gzz_secondfloor1_drawerchest1"
  };
  -----------------------------------------------
  local get_toyclothes1_2_inv = function ()

    int.InventoryItemAdd( "inv_toyclothes1", "spr_drawerchest1_toyclothes1_2", "assets/levels/level1/rm_secondfloor1/zz_roomwindow1/inv/inv_toyclothes1_2_flying"  );
    level1_inv.CheckToyclothes1();

  end;

  local get_toyclothes1_2_closezz = function ()

    ObjDelete( "anm_drawerchest1_box_open" );
    ObjSet( "obj_drawerchest1_open_box", { alp = 1 } );

    if cmn.IsEventDone( "get_water1" ) and 
       cmn.IsEventDone( "get_thread1" ) and 
       cmn.IsEventDone( "get_heart1_2" ) then

      ObjDelete( "gzz_secondfloor1_drawerchest1" );

    end;
    
    ObjDelete( "spr_secondfloor1_drawerchest1_clother" );

  end;

  cmn.AddSubscriber( "get_toyclothes1_2", get_toyclothes1_2_inv );
  cmn.AddSubscriber( "get_toyclothes1_2", get_toyclothes1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_water1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_water1" ] =
  {
    type = "get",
    get_obj = "spr_drawerchest1_water1",
    room = private.room_objname,
    zz = "zz_drawerchest1",
    zz_gate = "gzz_secondfloor1_drawerchest1"
  };
  -----------------------------------------------
  local get_water1_inv = function ()

    int.InventoryItemAdd( "inv_water1", "spr_drawerchest1_water1" );

    if ( cmn.IsEventDone( "get_emptyflask1" ) ) then

      ObjSet( "inv_emptyflask1_plus_focus2", { alp = 1 } );

    end;

  end;

  local get_water1_closezz = function ()

    ObjDelete( "gfx_drawerchest1_water1" );

    if cmn.IsEventDone( "get_toyclothes1_2" ) and 
       cmn.IsEventDone( "get_thread1" ) and 
       cmn.IsEventDone( "get_heart1_2" ) then

      ObjDelete( "gzz_secondfloor1_drawerchest1" );

    end;
    
    ObjDelete( "spr_secondfloor1_drawerchest1_glass" );

  end;

  cmn.AddSubscriber( "get_water1", get_water1_inv );
  cmn.AddSubscriber( "get_water1", get_water1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_thread1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_thread1" ] =
  {
    type = "get",
    get_obj = "spr_drawerchest1_thread1",
    room = private.room_objname,
    zz = "zz_drawerchest1",
    zz_gate = "gzz_secondfloor1_drawerchest1"
  };
  -----------------------------------------------
  local get_thread1_inv = function ()

    int.InventoryItemAdd( "inv_thread1", "spr_drawerchest1_thread1" );
    ObjSet( "inv_thread1", { drag = false } );

  end;

  local get_thread1_closezz = function ()

    ObjDelete( "gfx_drawerchest1_thread1" );

    if cmn.IsEventDone( "get_toyclothes1_2" ) and 
       cmn.IsEventDone( "get_water1" ) and 
       cmn.IsEventDone( "get_heart1_2" ) then

      ObjDelete( "gzz_secondfloor1_drawerchest1" );

    end;
    
    ObjDelete( "spr_secondfloor1_drawerchest1_thread" );

  end;

  cmn.AddSubscriber( "get_thread1", get_thread1_inv );
  cmn.AddSubscriber( "get_thread1", get_thread1_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_heart1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_heart1" ] =
  {
    type = "use",
    use_obj = "inv_heart1",
    use_place = "obj_coffeetable1_use_heart1",
    room = private.room_objname,
    zz = "zz_coffeetable1",
    zz_gate = "gzz_secondfloor1_coffeetable1"
  };
  -----------------------------------------------
  local use_heart1_inv = function ()

    int.InventoryItemRemove( "inv_heart1" );

  end;
  local use_heart1_beg = function ()

    ObjDelete( "obj_coffeetable1_use_heart1" );
    ObjDelete( "anm_coffeetable1_box_click" );

  end;
  local use_heart1_end = function ()

    ObjSet( "obj_coffeetable1_open_box", { alp = 1, input = true } );
    ObjSet( "gfx_coffeetable1_pin1", { active = true } );
    ObjSet( "gfx_coffeetable1_portrait1_1", { active = true } );
    ObjSet( "spr_coffeetable1_mirror_open_box", { alp = 1 } );
    ObjDelete( "anm_coffeetable1_heart" );
    
    ObjSet( "spr_secondfloor1_coffeetable1_open_box", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_heart1",     use_heart1_inv );
  cmn.AddSubscriber( "use_heart1",     use_heart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_heart1",     use_heart1_end, private.room_objname );
  cmn.AddSubscriber( "use_heart1_inv", use_heart1_inv, private.room_objname );
  cmn.AddSubscriber( "use_heart1_beg", use_heart1_beg, private.room_objname );
  cmn.AddSubscriber( "use_heart1_end", use_heart1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurine1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurine1" ] =
  {
    type = "use",
    use_obj = "inv_figurine1",
    use_place = "obj_coffeetable1_use_figurine1",
    room = private.room_objname,
    zz = "zz_coffeetable1",
    zz_gate = "gzz_secondfloor1_coffeetable1"
  };
  -----------------------------------------------
  local use_figurine1_inv = function ()

    int.InventoryItemRemove( "inv_figurine1" );

  end;
  local use_figurine1_beg = function ()

    ObjDelete( "obj_coffeetable1_use_figurine1" );
    ObjDelete( "anm_coffeetable1_heartbox_click" );

  end;
  local use_figurine1_end = function ()

    ObjSet( "obj_coffeetable1_open_heart_box", { alp = 1, input = true } );
    ObjSet( "gfx_coffeetable1_toyclothes1_3",  { active = true } );
    ObjDelete( "obj_coffeetable1_close_heart_box" );
    
    ObjSet( "spr_secondfloor1_coffeetable1_open_heart", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_figurine1",     use_figurine1_inv );
  cmn.AddSubscriber( "use_figurine1",     use_figurine1_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurine1",     use_figurine1_end, private.room_objname );
  cmn.AddSubscriber( "use_figurine1_inv", use_figurine1_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurine1_beg", use_figurine1_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurine1_end", use_figurine1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fish1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fish1" ] =
  {
    type = "use",
    use_obj = "inv_fish1",
    use_place = "obj_secondfloor1_use_fish1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_fish1_inv = function ()

    int.InventoryItemRemove( "inv_fish1" );

  end;
  local use_fish1_beg = function ()

    ObjDelete( "obj_secondfloor1_use_fish1" );
    ObjSet( "anm_secondfloor1_az_cat", { playing = false, frame = 0 } );    

  end;
  local use_fish1_end = function ()

    ObjSet( "spr_secondfloor1_kitten1", { input = true } );
    ObjSet( "gfx_secondfloor1_kitten1", { active = true } );
    
    ObjDelete( "anm_secondfloor1_az_use_fish" );
    ObjSet( "anm_secondfloor1_az_cat_1", { alp = 1, playing = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_fish1",     use_fish1_inv );
  cmn.AddSubscriber( "use_fish1",     use_fish1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fish1",     use_fish1_end, private.room_objname );
  cmn.AddSubscriber( "use_fish1_inv", use_fish1_inv, private.room_objname );
  cmn.AddSubscriber( "use_fish1_beg", use_fish1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fish1_end", use_fish1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toyclothes1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toyclothes1" ] =
  {
    type = "use",
    use_obj = "inv_toyclothes1",
    use_place = "obj_wardrobe1_use_toyclothes1",
    room = private.room_objname,
    zz = "zz_wardrobe1",
    zz_gate = "gzz_secondfloor1_wardrobe1"
  };
  -----------------------------------------------
  local use_toyclothes1_inv = function ()

    int.InventoryItemRemove( "inv_toyclothes1" );

  end;
  local use_toyclothes1_beg = function ()

    ObjDelete( "obj_wardrobe1_use_toyclothes1" );

  end;
  local use_toyclothes1_end = function ()

    ObjSet( "obj_wardrobe1_clother_1_3", { alp = 1 } );
    ObjSet( "obj_wardrobe1_clother_2_3", { alp = 1 } );
    ObjSet( "obj_wardrobe1_clother_3_3", { alp = 1 } );
    ObjDelete( "obj_wardrobe1_slots" );

    ObjSet( "obj_wardrobe1_buttons", { input = true } );
    ObjSet( "spr_secondfloor1_wardrobe1_clothes_1", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_toyclothes1",     use_toyclothes1_inv );
  cmn.AddSubscriber( "use_toyclothes1",     use_toyclothes1_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyclothes1",     use_toyclothes1_end, private.room_objname );
  cmn.AddSubscriber( "use_toyclothes1_inv", use_toyclothes1_inv, private.room_objname );
  cmn.AddSubscriber( "use_toyclothes1_beg", use_toyclothes1_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyclothes1_end", use_toyclothes1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_glue1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glue1" ] =
  {
    type = "use",
    use_obj = "inv_glue1",
    use_place = "obj_roomwindow1_use_glue1",
    room = private.room_objname,
    zz = "zz_roomwindow1",
    zz_gate = "gzz_secondfloor1_roomwindow1"
  };
  -----------------------------------------------
  local use_glue1_inv = function ()

    int.InventoryItemRemove( "inv_glue1" );

  end;
  local use_glue1_beg = function ()

    ObjDelete( "obj_roomwindow1_use_glue1" );
    ObjDelete( "anm_roomwindow1_figurine_click" );

  end;
  local use_glue1_end = function ()

    ObjSet( "anm_roomwindow1_glue",        { alp = 1, frame = 211, animfunc = "DoAnim" } );
    ObjSet( "spr_roomwindow1_figurine1_2", { input = true } );
    ObjSet( "gfx_roomwindow1_figurine1_2", { active = true } );
    ObjSet( "obj_roomwindow1_clk_leaf1",   { input = true } );

    ObjDelete( "spr_secondfloor1_roomwindow1_doll_part" );
    ObjDelete( "spr_secondfloor1_roomwindow1_brocken_bride" );
    ObjSet( "spr_secondfloor1_roomwindow1_doll", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_glue1",     use_glue1_inv );
  cmn.AddSubscriber( "use_glue1",     use_glue1_beg, private.room_objname );
  cmn.AddSubscriber( "use_glue1",     use_glue1_end, private.room_objname );
  cmn.AddSubscriber( "use_glue1_inv", use_glue1_inv, private.room_objname );
  cmn.AddSubscriber( "use_glue1_beg", use_glue1_beg, private.room_objname );
  cmn.AddSubscriber( "use_glue1_end", use_glue1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_plantreviver1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plantreviver1" ] =
  {
    type = "use",
    use_obj = "inv_plantreviver1",
    use_place = "obj_roomwindow1_use_plantreviver1",
    room = private.room_objname,
    zz = "zz_roomwindow1",
    zz_gate = "gzz_secondfloor1_roomwindow1"
  };
  -----------------------------------------------
  local use_plantreviver1_inv = function ()

    int.InventoryItemRemove( "inv_plantreviver1" );

  end;
  local use_plantreviver1_beg = function ()

    ObjDelete( "obj_roomwindow1_use_plantreviver1" );
    ObjDelete( "anm_roomwindow1_flower" );
    ObjDelete( "anm_roomwindow1_flower_click" );

  end;
  local use_plantreviver1_end = function ()

    ObjDelete( "anm_roomwindow1_flower_plantreviver" );
    ObjSet( "spr_roomwindow1_toyclothes1_1_shadow", { alp = 1 } );
    ObjSet( "spr_roomwindow1_toyclothes1_1", { alp = 1, input = true } );
    ObjSet( "gfx_roomwindow1_toyclothes1_1", { active = true } );
    ObjSet( "anm_roomwindow1_flower_plantreviver_end", { alp = 1, animfunc = "DoAnim", playing = true } );
    
    ObjDelete( "spr_secondfloor1_roomwindow1_stone_flower" );
    ObjSet( "spr_secondfloor1_roomwindow1_clothes", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_plantreviver1",     use_plantreviver1_inv );
  cmn.AddSubscriber( "use_plantreviver1",     use_plantreviver1_beg, private.room_objname );
  cmn.AddSubscriber( "use_plantreviver1",     use_plantreviver1_end, private.room_objname );
  cmn.AddSubscriber( "use_plantreviver1_inv", use_plantreviver1_inv, private.room_objname );
  cmn.AddSubscriber( "use_plantreviver1_beg", use_plantreviver1_beg, private.room_objname );
  cmn.AddSubscriber( "use_plantreviver1_end", use_plantreviver1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_threadhook1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_threadhook1" ] =
  {
    type = "use",
    use_obj = "inv_threadhook1",
    use_place = "obj_roomwindow1_use_threadhook1",
    room = private.room_objname,
    zz = "zz_roomwindow1",
    zz_gate = "gzz_secondfloor1_roomwindow1"
  };
  -----------------------------------------------
  local use_threadhook1_inv = function ()

    int.InventoryItemRemove( "inv_threadhook1" );

  end;
  local use_threadhook1_beg = function ()

    ObjDelete( "obj_roomwindow1_use_threadhook1" );
    ObjDelete( "anm_roomwindow1_amulet" );

  end;
  local use_threadhook1_end = function ()

    ObjDelete( "anm_roomwindow1_threadhook" );
    
    ObjDelete( "spr_secondfloor1_roomwindow1_amulet" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_threadhook1",     use_threadhook1_inv );
  cmn.AddSubscriber( "use_threadhook1",     use_threadhook1_beg, private.room_objname );
  cmn.AddSubscriber( "use_threadhook1",     use_threadhook1_end, private.room_objname );
  cmn.AddSubscriber( "use_threadhook1_inv", use_threadhook1_inv, private.room_objname );
  cmn.AddSubscriber( "use_threadhook1_beg", use_threadhook1_beg, private.room_objname );
  cmn.AddSubscriber( "use_threadhook1_end", use_threadhook1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_catamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_catamulet1" ] =
  {
    type = "use",
    use_obj = "inv_catamulet1",
    use_place = "obj_drawerchest1_use_catamulet1",
    room = private.room_objname,
    zz = "zz_drawerchest1",
    zz_gate = "gzz_secondfloor1_drawerchest1"
  };
  -----------------------------------------------
  local use_catamulet1_inv = function ()

    int.InventoryItemRemove( "inv_catamulet1" );

  end;
  local use_catamulet1_beg = function ()

    ObjDelete( "obj_drawerchest1_use_catamulet1" );
    ObjDelete( "anm_drawerchest1_casket_click" );

  end;
  local use_catamulet1_end = function ()

    ObjSet( "obj_drawerchest1_open_casket", { alp = 1, input = true } );
    ObjSet( "gfx_drawerchest1_thread1", { active = true } );
    ObjDelete( "obj_drawerchest1_close_casket" );
    
    ObjSet( "spr_secondfloor1_drawerchest1_open_box", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_catamulet1",     use_catamulet1_inv );
  cmn.AddSubscriber( "use_catamulet1",     use_catamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_catamulet1",     use_catamulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_catamulet1_inv", use_catamulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_catamulet1_beg", use_catamulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_catamulet1_end", use_catamulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_matches1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_matches1" ] =
  {
    type = "use",
    use_obj = "inv_matches1",
    use_place = "obj_drawerchest1_use_matches1",
    room = private.room_objname,
    zz = "zz_drawerchest1",
    zz_gate = "gzz_secondfloor1_drawerchest1"
  };
  -----------------------------------------------
  local use_matches1_inv = function ()

    int.InventoryItemRemove( "inv_matches1" );

  end;
  local use_matches1_beg = function ()

    ObjDelete( "obj_drawerchest1_use_matches1" );
    ObjDelete( "anm_drawerchest1_back_dark" );

  end;
  local use_matches1_end = function ()

    ObjDelete( "obj_drawerchest1_dark" );
    ObjDelete( "anm_drawerchest1_matches" );

    ObjSet( "obj_drawerchest1_lighted", { alp = 1, input = true } );
    ObjSet( "obj_drawerchest1_use_catamulet1", { input = true } );
    ObjSet( "obj_drawerchest1_use_pattern1",   { input = true } );

    ObjSet( "spr_drawerchest1_water1",   { alp = 1, input = true } );
    ObjSet( "gfx_drawerchest1_heart1_2", { active = true } );
    ObjSet( "gfx_drawerchest1_water1",   { active = true } );
    ObjSet( "obj_drawerchest1_light",    { alp = 1 } );
    ObjSet( "anm_drawerchest1_candle_light", { alp = 1, playing = true } );
    ObjSet( "anm_drawerchest1_back",         { alp = 1, playing = true } );
    
    ObjSet( "spr_secondfloor1_drawerchest1_1", { alp = 1 } );
    ObjSet( "spr_secondfloor1_drawerchest1_light_add_05", { visible = true } );
    ObjSet( "spr_secondfloor1_drawerchest1_flower_light", { alp = 1 } );
    ObjDelete( "spr_secondfloor1_drawerchest1_flower" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_matches1",     use_matches1_inv );
  cmn.AddSubscriber( "use_matches1",     use_matches1_beg, private.room_objname );
  cmn.AddSubscriber( "use_matches1",     use_matches1_end, private.room_objname );
  cmn.AddSubscriber( "use_matches1_inv", use_matches1_inv, private.room_objname );
  cmn.AddSubscriber( "use_matches1_beg", use_matches1_beg, private.room_objname );
  cmn.AddSubscriber( "use_matches1_end", use_matches1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pattern1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pattern1" ] =
  {
    type = "use",
    use_obj = "inv_pattern1",
    use_place = "obj_drawerchest1_use_pattern1",
    room = private.room_objname,
    zz = "zz_drawerchest1",
    zz_gate = "gzz_secondfloor1_drawerchest1"
  };
  -----------------------------------------------
  local use_pattern1_inv = function ()

    int.InventoryItemRemove( "inv_pattern1" );

  end;
  local use_pattern1_beg = function ()

    ObjDelete( "obj_drawerchest1_use_pattern1" );
    ObjDelete( "anm_drawerchest1_box_click" );

  end;
  local use_pattern1_end = function ()

    ObjSet( "obj_drawerchest1_open_box", { input = true } );
    ObjSet( "gfx_drawerchest1_toyclothes1_2", { active = true } );
    ObjSet( "anm_drawerchest1_box_open", { alp = 1, frame = 61, animfunc = "DoAnim" } );
    
    ObjSet( "spr_secondfloor1_drawerchest1_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_pattern1",     use_pattern1_inv );
  cmn.AddSubscriber( "use_pattern1",     use_pattern1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern1",     use_pattern1_end, private.room_objname );
  cmn.AddSubscriber( "use_pattern1_inv", use_pattern1_inv, private.room_objname );
  cmn.AddSubscriber( "use_pattern1_beg", use_pattern1_beg, private.room_objname );
  cmn.AddSubscriber( "use_pattern1_end", use_pattern1_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_leaf1 () end;
  --------------------------------------------------------------------------------------------
  local clk_leaf1_inv = function ()

  end;
  local clk_leaf1_beg = function ()

    ObjDelete( "obj_roomwindow1_clk_leaf1" );
    ObjDelete( "anm_roomwindow1_leaf_static" );

  end;
  local clk_leaf1_end = function ()

    ObjDelete( "anm_roomwindow1_leaf" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_leaf1",     clk_leaf1_inv );
  cmn.AddSubscriber( "clk_leaf1",     clk_leaf1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_leaf1",     clk_leaf1_end, private.room_objname );
  cmn.AddSubscriber( "clk_leaf1_inv", clk_leaf1_inv, private.room_objname );
  cmn.AddSubscriber( "clk_leaf1_beg", clk_leaf1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_leaf1_end", clk_leaf1_end, private.room_objname );
  --------------------------------------------------------------------------------------
  --function win_wardrobe1 () end;
  ------------------------------------------------------------------------------------------
  common_impl.hint[ "win_wardrobe1" ] =
  {
    type = "click",
    clk_obj = "obj_wardrobe1_button_1_1",
    room = private.room_objname,
    zz = "zz_wardrobe1",
    zz_gate = "gzz_secondfloor1_wardrobe1"
  };
  --*********************************************************************************************************************
  local win_wardrobe1_inv = function ()

    if ( cmn.IsEventDone( "win_wardrobe1" ) ) then
    
    end;

  end;
  --*********************************************************************************************************************
  local win_wardrobe1 = function ()

    if ( cmn.IsEventDone( "win_wardrobe1" ) ) then

      ObjDelete( "gzz_secondfloor1_wardrobe1" );
      ObjSet( "gho_secondfloor1_howardrobe1", { alp = 1, input = true, active = true } );

      ObjDelete( "spr_secondfloor1_wardrobe1_cl_door" );
      ObjSet( "spr_secondfloor1_wardrobe1_open_door_r", { alp = 1 } );
      ObjSet( "spr_secondfloor1_wardrobe1_open_door_l", { alp = 1 } );      

    elseif ( cmn.IsEventStart( "win_wardrobe1" ) ) then

      private.Wardrobe1Load();

    end;

  end;

  cmn.AddSubscriber( "win_wardrobe1", win_wardrobe1_inv );
  cmn.AddSubscriber( "win_wardrobe1", win_wardrobe1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_secondfloor1_richard1_3 () end;
  --------------------------------------------------------------------------------------------
  local dlg_secondfloor1_richard1_3_beg = function ()

  end;
  -----------------------------------------------
  local dlg_secondfloor1_richard1_3_end = function ()

    ObjDelete( "dlg_secondfloor1_richard1_3" );

  end;

  cmn.AddSubscriber( "dlg_secondfloor1_richard1_3",     dlg_secondfloor1_richard1_3_beg );
  cmn.AddSubscriber( "dlg_secondfloor1_richard1_3",     dlg_secondfloor1_richard1_3_end );
  cmn.AddSubscriber( "dlg_secondfloor1_richard1_3_beg", dlg_secondfloor1_richard1_3_beg );
  cmn.AddSubscriber( "dlg_secondfloor1_richard1_3_end", dlg_secondfloor1_richard1_3_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
  
function private.get_screensaver_1_4()

  int.AddScreensaver( "spr_coffeetable1_screensaver_1_4" );

end;    
function private.get_screensaver_1_5()

  int.AddScreensaver( "spr_roomwindow1_screensaver_1_5" );

end;   
-----------------------------------------------------------------------
function private.get_collect_1_2 ()

  int.AddCollectibles( "spr_secondfloor1_collect_1_2" );

end;
-----------------------------------------------------------------------
function private.get_matches1 ()

  cmn.SetEventDone( "get_matches1" );
  cmn.CallEventHandler( "get_matches1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_glue1" ) and 
     cmn.IsEventDone( "get_coin1_1" ) and 
     cmn.IsEventDone( "get_toyclothes1_3" ) and 
     cmn.IsEventDone( "get_portrait1_1" ) and 
     cmn.IsEventDone( "get_pin1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_glue1 ()

  cmn.SetEventDone( "get_glue1" );
  cmn.CallEventHandler( "get_glue1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_matches1" ) and 
     cmn.IsEventDone( "get_coin1_1" ) and 
     cmn.IsEventDone( "get_toyclothes1_3" ) and 
     cmn.IsEventDone( "get_portrait1_1" ) and 
     cmn.IsEventDone( "get_pin1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_coin1_1 ()

  cmn.SetEventDone( "get_coin1_1" );
  cmn.CallEventHandler( "get_coin1_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_matches1" ) and 
     cmn.IsEventDone( "get_glue1" ) and 
     cmn.IsEventDone( "get_toyclothes1_3" ) and 
     cmn.IsEventDone( "get_portrait1_1" ) and 
     cmn.IsEventDone( "get_pin1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_toyclothes1_3 ()

  cmn.SetEventDone( "get_toyclothes1_3" );
  cmn.CallEventHandler( "get_toyclothes1_3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_matches1" ) and 
     cmn.IsEventDone( "get_glue1" ) and 
     cmn.IsEventDone( "get_coin1_1" ) and 
     cmn.IsEventDone( "get_portrait1_1" ) and 
     cmn.IsEventDone( "get_pin1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_portrait1_1 ()

  cmn.SetEventDone( "get_portrait1_1" );
  cmn.CallEventHandler( "get_portrait1_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_matches1" ) and 
     cmn.IsEventDone( "get_glue1" ) and 
     cmn.IsEventDone( "get_coin1_1" ) and 
     cmn.IsEventDone( "get_toyclothes1_3" ) and 
     cmn.IsEventDone( "get_pin1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_pin1 ()

  cmn.SetEventDone( "get_pin1" );
  cmn.CallEventHandler( "get_pin1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_matches1" ) and 
     cmn.IsEventDone( "get_glue1" ) and 
     cmn.IsEventDone( "get_coin1_1" ) and 
     cmn.IsEventDone( "get_toyclothes1_3" ) and 
     cmn.IsEventDone( "get_portrait1_1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_kitten1 ()

  cmn.SetEventDone( "get_kitten1" );
  cmn.CallEventHandler( "get_kitten1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_rose1_2 ()

  cmn.SetEventDone( "get_rose1_2" );
  cmn.CallEventHandler( "get_rose1_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_pattern1 ()

  cmn.SetEventDone( "get_pattern1" );
  cmn.CallEventHandler( "get_pattern1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_rose1_1 ()

  cmn.SetEventDone( "get_rose1_1" );
  cmn.CallEventHandler( "get_rose1_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_figurine1_2 ()

  ObjSet( "spr_roomwindow1_figurine1_2", { alp = 1 } );
  cmn.SetEventDone( "get_figurine1_2" );
  cmn.CallEventHandler( "get_figurine1_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_emptyflask1 ()

  cmn.SetEventDone( "get_emptyflask1" );
  cmn.CallEventHandler( "get_emptyflask1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_toyclothes1_1 ()

  ObjSet( "spr_roomwindow1_toyclothes1_1", { alp = 1 } );
  cmn.SetEventDone( "get_toyclothes1_1" );
  cmn.CallEventHandler( "get_toyclothes1_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amulet1 ()

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "use_threadhook1" );
    cmn.SetEventDone( "get_amulet1" );
    cmn.CallEventHandler( "get_amulet1_closezz" );
    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_anim_knife_appears" );    

  end;

  cmn.CallEventHandler( "get_amulet1_inv" );
  cmn.GetObjectSfx();

  cmn.CloseSubRoom( true );
  common_impl.PlayDialogVideo( "vid_secondfloor1_street_knife", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_anim_knife_appears" );  
 
end;
-----------------------------------------------------------------------
function private.get_heart1_2 ()

  cmn.SetEventDone( "get_heart1_2" );
  cmn.CallEventHandler( "get_heart1_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toyclothes1_2" ) and 
     cmn.IsEventDone( "get_water1" ) and 
     cmn.IsEventDone( "get_thread1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_toyclothes1_2 ()

  cmn.SetEventDone( "get_toyclothes1_2" );
  cmn.CallEventHandler( "get_toyclothes1_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_water1" ) and 
     cmn.IsEventDone( "get_thread1" ) and 
     cmn.IsEventDone( "get_heart1_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_water1 ()

  cmn.SetEventDone( "get_water1" );
  cmn.CallEventHandler( "get_water1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toyclothes1_2" ) and 
     cmn.IsEventDone( "get_thread1" ) and 
     cmn.IsEventDone( "get_heart1_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_thread1 ()

  cmn.SetEventDone( "get_thread1" );
  cmn.CallEventHandler( "get_thread1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toyclothes1_2" ) and 
     cmn.IsEventDone( "get_water1" ) and 
     cmn.IsEventDone( "get_heart1_2" ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function public.use_heart1 ()

  local item = "inv_heart1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_coffeetable1", false ) and 
       cmn.IsEventDone( "get_heart1_1" ) and 
       cmn.IsEventDone( "get_heart1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffeetable1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffeetable1_use_heart1", true ) and 
           cmn.IsEventDone( "get_heart1_1" ) and 
           cmn.IsEventDone( "get_heart1_2" ) ) then

    cmn.CallEventHandler( "use_heart1_inv" );
    cmn.CallEventHandler( "use_heart1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_heart1" );
      cmn.CallEventHandler( "use_heart1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_coffeetable1_heart", { alp = 1 } );
    AnimPlay( "anm_coffeetable1_heart", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_box_obgects" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_figurine1 ()

  local item = "inv_figurine1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_coffeetable1", false ) ) and
     ( cmn.IsEventDone( "get_figurine1_1" ) ) and
     ( cmn.IsEventDone( "get_figurine1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_coffeetable1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_coffeetable1_use_figurine1", true ) ) and
         ( cmn.IsEventDone( "get_figurine1_1" ) ) and
         ( cmn.IsEventDone( "get_figurine1_2" ) ) then

    cmn.CallEventHandler( "use_figurine1_inv" );
    cmn.CallEventHandler( "use_figurine1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_figurine1" );
      cmn.CallEventHandler( "use_figurine1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_coffeetable1_figurine", { alp = 1 } );
    AnimPlay( "anm_coffeetable1_figurine", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_two_peoples" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
function public.use_fish1 ()

  local item = "inv_fish1";

  if ( cmn.ApplyObj( item, "obj_secondfloor1_use_fish1", true ) ) then

    cmn.CallEventHandler( "use_fish1_inv" );
    cmn.CallEventHandler( "use_fish1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_fish1" );
      cmn.CallEventHandler( "use_fish1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_secondfloor1_az_use_fish", { alp = 1 } );
    cmn.StopAudio( "env", "audio/level1/env/aud_rm_secondfloor1_cat_env", 0.5 );
    AnimPlay( "anm_secondfloor1_az_use_fish", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_give_cat_fish" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
function public.use_toyclothes1 ()

  local item = "inv_toyclothes1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_wardrobe1", false ) and 
       cmn.IsEventDone( "get_toyclothes1_1" ) and 
       cmn.IsEventDone( "get_toyclothes1_2" ) and 
       cmn.IsEventDone( "get_toyclothes1_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wardrobe1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_wardrobe1_use_toyclothes1", true ) and 
           cmn.IsEventDone( "get_toyclothes1_1" ) and 
           cmn.IsEventDone( "get_toyclothes1_2" ) and 
           cmn.IsEventDone( "get_toyclothes1_3" ) ) then

    cmn.CallEventHandler( "use_toyclothes1_inv" );
    cmn.CallEventHandler( "use_toyclothes1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_toyclothes1" );
      cmn.CallEventHandler( "use_toyclothes1_end" );
      private.Wardrobe1Start();

    end;

    int.Lock( true );

    ObjAnimate( "obj_wardrobe1_clother_3_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0,
    } );

    ObjAnimate( "obj_wardrobe1_clother_2_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0,
    } );

    ObjAnimate( "obj_wardrobe1_clother_1_3", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_cloth_mmg" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
function public.use_glue1 ()

  local item = "inv_glue1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_roomwindow1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roomwindow1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roomwindow1_use_glue1", true ) ) then

    cmn.CallEventHandler( "use_glue1_inv" );
    cmn.CallEventHandler( "use_glue1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_glue1" );
      cmn.CallEventHandler( "use_glue1_end" );

      ObjSet( "obj_roomwindow1_figurine", { pos_z = 20 } );

    end;

    int.Lock( true );

    ObjSet( "obj_roomwindow1_figurine", { pos_z = 35 } );
    ObjSet( "anm_roomwindow1_glue", { alp = 1 } );
    AnimPlay( "anm_roomwindow1_glue", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_glue_broken_statue" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_plantreviver1 ()

  local item = "inv_plantreviver1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_roomwindow1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roomwindow1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roomwindow1_use_plantreviver1", true ) ) then

    cmn.CallEventHandler( "use_plantreviver1_inv" );
    cmn.CallEventHandler( "use_plantreviver1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_plantreviver1" );
      cmn.CallEventHandler( "use_plantreviver1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_roomwindow1_flower_plantreviver", { alp = 1 } );
    AnimPlay( "anm_roomwindow1_flower_plantreviver", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_spray_flacon" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_threadhook1 ()

  local item = "inv_threadhook1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_roomwindow1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roomwindow1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roomwindow1_use_threadhook1", true ) ) then

    cmn.CallEventHandler( "use_threadhook1_inv" );
    cmn.CallEventHandler( "use_threadhook1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.CallEventHandler( "use_threadhook1_end" );
      private.get_amulet1();

    end;

    int.Lock( true );

    ObjSet( "anm_roomwindow1_threadhook", { alp = 1 } );
    AnimPlay( "anm_roomwindow1_threadhook", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_zz_roomwindow1_clew" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_catamulet1 ()

  local item = "inv_catamulet1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_drawerchest1", false ) and 
       cmn.IsEventDone( "use_matches1" ) and 
       cmn.IsEventDone( "get_catamulet1_1" ) and 
       cmn.IsEventDone( "get_catamulet1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drawerchest1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_drawerchest1_use_catamulet1", true ) and 
           cmn.IsEventDone( "use_matches1" ) and 
           cmn.IsEventDone( "get_catamulet1_1" ) and 
           cmn.IsEventDone( "get_catamulet1_2" ) ) then

    cmn.CallEventHandler( "use_catamulet1_inv" );
    cmn.CallEventHandler( "use_catamulet1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_catamulet1" );
      cmn.CallEventHandler( "use_catamulet1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_drawerchest1_catamulet", { alp = 1 } );
    AnimPlay( "anm_drawerchest1_catamulet", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_zz_drawerchest1_left_candle" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
function public.use_matches1 ()

  local item = "inv_matches1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_drawerchest1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drawerchest1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_drawerchest1_use_matches1", true ) ) then

    cmn.CallEventHandler( "use_matches1_inv" );
    cmn.CallEventHandler( "use_matches1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_matches1" );
      cmn.CallEventHandler( "use_matches1_end" );
      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_candle_zz_drawerchest1_loop" );

    end;

    int.Lock( true );

    AnimPlay( "anm_drawerchest1_matches", "DoAnim", func_end );
    AnimPlay( "anm_drawerchest1_matches_over", "DoAnim", "" );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_fire_matches_candle" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_pattern1 ()

  local item = "inv_pattern1";

  if ( cmn.ApplyObj( item, "gzz_secondfloor1_drawerchest1", false ) and 
       cmn.IsEventDone( "use_matches1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drawerchest1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_drawerchest1_use_pattern1", true ) and 
           cmn.IsEventDone( "use_matches1" ) ) then

    cmn.CallEventHandler( "use_pattern1_inv" );
    cmn.CallEventHandler( "use_pattern1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_pattern1" );
      cmn.CallEventHandler( "use_pattern1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_drawerchest1_box_open",  { alp = 1 } );
    AnimPlay( "anm_drawerchest1_box_open", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_insert_stuff_zz_drawerchest1" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
function private.clk_leaf1 ()

  cmn.CallEventHandler( "clk_leaf1_inv" );
  cmn.CallEventHandler( "clk_leaf1_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_leaf1" );
    cmn.CallEventHandler( "clk_leaf1_end" );

  end;

  int.Lock( true );
  
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_list_window" );
  ObjSet( "anm_roomwindow1_leaf", { alp = 1 } );
  AnimPlay( "anm_roomwindow1_leaf", "DoAnim", func_end );

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_secondfloor1 ()

  if not ( cmn.IsEventDone( "opn_secondfloor1" ) ) then

    local func_end = function ()

      cmn.SetEventDone( "opn_secondfloor1" );
      cmn.CallEventHandler( "opn_secondfloor1" );
      int.Lock( false );
      private.dlg_secondfloor1_richard1_3();
      
      cmn.StopAllEnv();
      cmn.PlayAudio( "env", "audio/level1/env/aud_rm_secondfloor1_env", 1 );
      if not cmn.IsEventDone( "use_fish1" ) then
        cmn.PlayAudio( "env", "audio/level1/env/aud_rm_secondfloor1_cat_env", 1 );
       end;

    end;

    int.Lock( true );
    AnimPlay( "anm_secondfloor1_monster", "DoAnim", func_end );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rm_secondfloor1_first_appear" );

  else
    
    if ( not cmn.IsEventDone( "dlg_secondfloor1_richard1_3" ) ) then

      private.dlg_secondfloor1_richard1_3();
    
    end;
    
    cmn.StopAllEnv();
    cmn.PlayAudio( "env", "audio/level1/env/aud_rm_secondfloor1_env", 1 );
    if not cmn.IsEventDone( "use_fish1" ) then
      cmn.PlayAudio( "env", "audio/level1/env/aud_rm_secondfloor1_cat_env", 1 );
    end;

  end;
 
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_secondfloor1();

  if ( cmn.IsEventDone( "win_howardrobe1" ) ) and
     ( not ng_global.progress[ ng_global.currentprogress ][ "opn_secondfloor1" ].bbt_ho ) then

    local func_end = function ()

      cmn.ShowBbt( "bbt_secondfloor1_howardrobe1" );
      ng_global.progress[ ng_global.currentprogress ][ "opn_secondfloor1" ].bbt_ho = true;
      ObjDelete( "anm_secondfloor1_dressing" );
      --int.InventoryItemRemove( "inv_clothes1" );     
      --ObjSet( "grm_alley1_square1", { alp = 1, input = true, active = true } );   
      cmn.SetEventDone( "del_clothes1" );
      cmn.CallEventHandler( "del_clothes1" );  
      int.Lock( false );

      interface.KeyTaskDone( true, "task_1_4" );

    end;

    int.Lock( true );
    ObjSet( "anm_secondfloor1_dressing", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_wear_gloves_1" );
    AnimPlay( "anm_secondfloor1_dressing", "DoAnim", func_end );    

  end;

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "del_clothes1",                              { "win_howardrobe1" } );
  
  int.AddedTaskMap( private.room_objname, "get_figurine1_1",                           { "dlg_secondfloor1_richard1_3" }  );
  int.AddedTaskMap( private.room_objname, "get_heart1_2",                              { "use_matches1" } );
  int.AddedTaskMap( private.room_objname, "get_matches1",                              { "dlg_secondfloor1_richard1_3" } );
  int.AddedTaskMap( private.room_objname, "get_glue1",                                 { "dlg_secondfloor1_richard1_3" } );
  int.AddedTaskMap( private.room_objname, "get_coin1_1",                               { "dlg_secondfloor1_richard1_3" } );
  int.AddedTaskMap( private.room_objname, "get_toyclothes1_3",                         { "use_figurine1" } );
  int.AddedTaskMap( private.room_objname, "get_portrait1_1",                           { "use_heart1" } );
  int.AddedTaskMap( private.room_objname, "get_pin1",                                  { "use_heart1" } );
  int.AddedTaskMap( private.room_objname, "get_kitten1",                               { "use_fish1" } );
  int.AddedTaskMap( private.room_objname, "get_rose1_2",                               { "dlg_secondfloor1_richard1_3" } );
  int.AddedTaskMap( private.room_objname, "get_pattern1",                              { "dlg_secondfloor1_richard1_3" } );
  int.AddedTaskMap( private.room_objname, "get_rose1_1",                               { "dlg_secondfloor1_richard1_3" } );
  int.AddedTaskMap( private.room_objname, "get_figurine1_2",                           { "use_glue1" } );
  int.AddedTaskMap( private.room_objname, "get_emptyflask1",                           { "dlg_secondfloor1_richard1_3" } );
  int.AddedTaskMap( private.room_objname, "get_toyclothes1_1",                         { "use_plantreviver1" } );
  int.AddedTaskMap( private.room_objname, "get_amulet1",                               { "use_threadhook1" } );
  int.AddedTaskMap( private.room_objname, "get_toyclothes1_2",                         { "use_pattern1" } );
  int.AddedTaskMap( private.room_objname, "get_water1",                                { "use_matches1" } );
  int.AddedTaskMap( private.room_objname, "get_thread1",                               { "use_catamulet1" } );

  int.AddedTaskMap( private.room_objname, "use_heart1",                                { "get_heart1_1", "get_heart1_2" } );
  int.AddedTaskMap( private.room_objname, "use_figurine1",                             { "get_figurine1_1", "get_figurine1_2" } );
  int.AddedTaskMap( private.room_objname, "use_fish1",                                 { "get_fish1"  } );
  int.AddedTaskMap( private.room_objname, "use_toyclothes1",                           { "get_toyclothes1_1", "get_toyclothes1_2", "get_toyclothes1_3" } );
  int.AddedTaskMap( private.room_objname, "use_glue1",                                 { "get_glue1" } );
  int.AddedTaskMap( private.room_objname, "use_plantreviver1",                         { "get_plantreviver1" } );
  int.AddedTaskMap( private.room_objname, "use_threadhook1",                           { "get_threadhook1" } );
  int.AddedTaskMap( private.room_objname, "use_catamulet1",                            { "get_catamulet1_1", "get_catamulet1_2", "use_matches1" } );
  int.AddedTaskMap( private.room_objname, "use_matches1",                              { "get_matches1" } );
  int.AddedTaskMap( private.room_objname, "use_pattern1",                              { "get_pattern1", "use_matches1" } );

  int.AddedTaskMap( private.room_objname, "win_wardrobe1",                             { "use_toyclothes1" } );
  int.AddedTaskMap( private.room_objname, "win_howardrobe1",                           { "win_wardrobe1" } );
  
  int.AddedTaskMap( private.room_objname, "dlg_secondfloor1_richard1_3" );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_wardrobe1" );
  subroom.Define( "zz_roomwindow1" );
  subroom.Define( "zz_coffeetable1" );
  subroom.Define( "zz_drawerchest1" );
  -------------------------------------------------
  function zz_coffeetable1.Close()

    cmn.NoteScaleEnd( { "spr_coffeetable1_note" }, true );

  end;
  -----------------------------------------------
  function zz_roomwindow1.Open ()

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_loop_zz_roomwindow1", 1 );

  end;
  -----------------------------------------------
  function zz_roomwindow1.PreClose ()

    cmn.StopAudio( "sfx", "audio/level1/sfx/aud_loop_zz_roomwindow1" );

  end;
  -----------------------------------------------
  function zz_roomwindow1.Close ()

    cmn.NoteScaleEnd( { "spr_roomwindow1_note" }, true );

  end;
  -------------------------------------------------
  function zz_wardrobe1.Open()
    
    if ( cmn.IsEventStart( "win_wardrobe1" ) and not cmn.IsEventDone( "win_wardrobe1" ) ) then

      cmn.MiniGameShow( "wardrobe1" );
      common_impl.PassingMgStart( "wardrobe1" );

    end;

  end;
  -------------------------------------------------
  function zz_wardrobe1.PreClose()
        
    if ( cmn.IsEventStart( "win_wardrobe1" ) and not cmn.IsEventDone( "win_wardrobe1" ) ) then

      cmn.MiniGameHide( "wardrobe1" );
      common_impl.PassingMgStop( "wardrobe1" );

    end;
    
  end;
  -------------------------------------------------
  function zz_wardrobe1.Skip ()

    if ( cmn.IsEventStart( "win_wardrobe1" ) and not cmn.IsEventDone( "win_wardrobe1" ) ) then
      private.Wardrobe1Skip();
    end;

  end;
  -------------------------------------------------
  function zz_wardrobe1.Reset ()

    if ( cmn.IsEventStart( "win_wardrobe1" ) and not cmn.IsEventDone( "win_wardrobe1" ) ) then
      private.Wardrobe1Reset();
    end;

  end;
  -------------------------------------------------
  function zz_drawerchest1.Open()

    if ( cmn.IsEventDone( "use_matches1" ) ) then

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_candle_zz_drawerchest1_loop", 1 );

    end;

  end;
  -------------------------------------------------
  function zz_drawerchest1.PreClose()

    if ( cmn.IsEventDone( "use_matches1" ) ) then

      cmn.StopAudio( "sfx", "audio/level1/sfx/aud_candle_zz_drawerchest1_loop" );

    end;
    
  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_wardrobe1_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

  ObjAnimate( "spr_roomwindow1_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

  ObjAnimate( "spr_roomwindow1_emptyflask_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    1.5, 3, 0,
    3.0, 3, 1,
  } );

end;
--*********************************************************************************************************************
function private.dlg_secondfloor1_richard1_3 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_figurine1_1" );
    cmn.GetObjectSfx();

    ObjSet( "anm_secondfloor1_richard1_3_richard_static_1",      { alp = 0 } );
    ObjSet( "anm_secondfloor1_richard1_3_richard_static_2",      { alp = 0 } );
    ObjSet( "anm_secondfloor1_richard1_3_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_secondfloor1_richard1_3_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_secondfloor1_richard1_3_richard_static_1" );
    AnimStop( "anm_secondfloor1_richard1_3_richard_static_2" );
    AnimStop( "anm_secondfloor1_richard1_3_richard_appearance" );

    ObjAnimate( "anm_secondfloor1_richard1_3_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );
    
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_secondfloor1_richard1_3_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_figurine1_1" );
      cmn.SetEventDone( "dlg_secondfloor1_richard1_3" );
      cmn.ShowBbt( "bbt_secondfloor1_monster" );

      int.InventoryItemAdd( "inv_richardskull1" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_secondfloor1_richard1_3_richard_appearance" );
    ObjSet( "anm_secondfloor1_richard1_3_richard_appearance", { alp = 0 } );

    ObjSet( "anm_secondfloor1_richard1_3_richard_static_1", { alp = 1 } );
    AnimPlay( "anm_secondfloor1_richard1_3_richard_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard1_3", "secondfloor1", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_secondfloor1_richard1_3_beg" );
  ObjAttach( "dlg_secondfloor1_richard1_3", GetCurrentRoom() );  

  ObjSet( "anm_secondfloor1_richard1_3_richard_appearance", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );
  AnimPlay( "anm_secondfloor1_richard1_3_richard_appearance", "DoAnim", func_anim_end );

  ObjAnimate( "anm_secondfloor1_richard1_3_richard_static_1", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull1" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard1_3" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_secondfloor1_richard1_3_richard_static_1" );
        AnimPlay( "anm_secondfloor1_richard1_3_richard_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_secondfloor1_richard1_3_richard_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_secondfloor1_richard1_3_richard_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_secondfloor1_richard1_3_richard_static_2" );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_creates_cups" );
        AnimPlay( "anm_secondfloor1_richard1_3_richard_give", "DoAnim", "" );
        AnimPlay( "anm_secondfloor1_richard1_3_object_appearance", "DoAnim", "" );

        ObjAnimate( "spr_secondfloor1_figurine1_1", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_secondfloor1_richard1_3_richard_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_secondfloor1_richard1_3_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.Roomwindow1FlowerClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_roomwindow1_use_plantreviver1" );

    ObjSet( "anm_roomwindow1_flower_click",{ alp = 0 } );
    ObjSet( "anm_roomwindow1_flower",      { alp = 1 } );

    AnimPlay( "anm_roomwindow1_flower", "DoAnim", "" );

  end;

  int.Lock( true );

  ObjSet( "anm_roomwindow1_flower_click", { alp = 1 } );
  ObjSet( "anm_roomwindow1_flower",       { alp = 0 } );

  AnimStop( "anm_roomwindow1_flower" );
  AnimPlay( "anm_roomwindow1_flower_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_zz_roomwindow1_right" );

end;
--*********************************************************************************************************************
function private.Roomwindow1FigurineClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_roomwindow1_use_glue1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_roomwindow1_figurine_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_broken_statue" );

end;
--*********************************************************************************************************************
function private.Coffeetable1HeartboxClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_coffeetable1_use_figurine1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_coffeetable1_heartbox_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_heart_left" );

end;
--*********************************************************************************************************************
function private.Coffeetable1BoxClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_coffeetable1_use_heart1" );

  end;

  int.Lock( true );

  AnimPlay( "anm_coffeetable1_box_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_heart_right" );

end;
--*********************************************************************************************************************
function private.Drawerchest1BoxClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_drawerchest1_use_pattern1" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_zz_drawerchest1_cupboard" );
  AnimPlay( "anm_drawerchest1_box_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Drawerchest1CasketClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_drawerchest1_use_catamulet1" );

  end;

  int.Lock( true );

  if ( cmn.IsEventDone( "get_water1" ) ) then
    
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_xx_zz_drawerchest1_box" );
    AnimPlay( "anm_drawerchest1_casket_click", "DoAnim", func_end );

  else

    func_end();

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Wardrobe1 *** () end;
--*********************************************************************************************************************
  function private.Wardrobe1Start ()

    cmn.MiniGameShow( "wardrobe1" );
    common_impl.PassingMgStart( "wardrobe1" );
    ng_global.progress[ "std" ][ "win_wardrobe1" ].position = {
                                                                { 1, 2, 3, 4, 1 },
                                                                { 1, 2, 3, 4, 1 },
                                                                { 1, 2, 3, 4, 1 },
                                                              };
  end;
--*********************************************************************************************************************
  function private.Wardrobe1Init ()

    private.line_count = 3;
    private.item_count = 5;
    private.res_count  = 4;

    for b = 1, private.line_count do

      ObjSet( "obj_wardrobe1_button_"..b.."_1",
      {
        event_mdown  = function () private.Wardrobe1Click( b, "left" ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );

      ObjSet( "obj_wardrobe1_button_"..b.."_2",
      {
        event_mdown  = function () private.Wardrobe1Click( b, "right" ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );

    end;

    private.shift = { 90,100,100 };
    private.win_position = { 1,1,1 };
    private.position = {
                         { 1, 2, 3, 4, 1 },
                         { 1, 2, 3, 4, 1 },
                         { 1, 2, 3, 4, 1 },
                       };

    --private.Wardrobe1Debug( "Init" );

  end;
--*********************************************************************************************************************
  function private.Wardrobe1Skip ()

    private.position = {
                         { 3, 4, 1, 2, 3 },
                         { 3, 4, 1, 2, 3 },
                         { 3, 4, 1, 2, 3 },
                       };

    for i = 1, private.line_count do

      for j = 1, private.item_count do

        ObjSet( "spr_wardrobe1_clother_"..i.."_"..j, { res = "assets/levels/level1/rm_secondfloor1/zz_wardrobe1/layers/clother_"..i.."_"..private.position[ i ][ j ] } );

      end;

    end;

    cmn.WaitAndRun( private.Wardrobe1WinAnim );

  end;
--*********************************************************************************************************************
  function private.Wardrobe1Reset ()

    ng_global.progress[ "std" ][ "win_wardrobe1" ].position = {
                                                                { 1, 2, 3, 4, 1 },
                                                                { 1, 2, 3, 4, 1 },
                                                                { 1, 2, 3, 4, 1 },
                                                              };

    private.Wardrobe1Load();

    --private.Wardrobe1Debug( "Reset" );

  end;
--*********************************************************************************************************************
  function private.Wardrobe1Load ()

    for i = 1, private.line_count do

      for j = 1, private.item_count do

        private.position[ i ][ j ] = ng_global.progress[ "std" ][ "win_wardrobe1" ].position[ i ][ j ];
        ObjSet( "spr_wardrobe1_clother_"..i.."_"..j, { res = "assets/levels/level1/rm_secondfloor1/zz_wardrobe1/layers/clother_"..i.."_"..private.position[ i ][ j ] } );

      end;

    end;

    --private.Wardrobe1Debug( "Load" );

  end;
--*********************************************************************************************************************
  function private.Wardrobe1Click ( idx, dir )

    int.Lock( true );

    local func_end = function ()

      int.Lock( false );
      private.Wardrobe1SetResources( idx, dir );

    end;

    if ( dir == "right" ) then

      ObjAnimate( "obj_wardrobe1_line_"..idx, "pos_x", 0, 0, func_end,
      {
        0.0, 3, 0,
        1.0, 3, private.shift[ idx ],
      } );

    else

      ObjAnimate( "obj_wardrobe1_line_"..idx, "pos_x", 0, 0, func_end,
      {
        0.0, 3, 0,
        1.0, 3, -private.shift[ idx ],
      } );

    end;

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mmg_cloth_change" );

  end;
--*********************************************************************************************************************
  function private.Wardrobe1GetResource ( idx, dir )

    local item = 0;

    if ( dir == "right" ) then

      item = private.position[ idx ][ 1 ];
      item = item - 1;

      if ( item <= 0 ) then

        item = private.res_count;

      end;

    else

      item = private.position[ idx ][ 5 ];
      item = item + 1;

      if ( item > private.res_count ) then

        item = 1;

      end;

    end;

    return item;

  end;
--*********************************************************************************************************************
  function private.Wardrobe1SetResources ( idx, dir )

    if ( dir == "right" ) then

      private.position[ idx ][ 5 ] = private.position[ idx ][ 4 ];
      private.position[ idx ][ 4 ] = private.position[ idx ][ 3 ];
      private.position[ idx ][ 3 ] = private.position[ idx ][ 2 ];
      private.position[ idx ][ 2 ] = private.position[ idx ][ 1 ];
      private.position[ idx ][ 1 ] = private.Wardrobe1GetResource( idx, dir );

    else

      private.position[ idx ][ 1 ] = private.position[ idx ][ 2 ];
      private.position[ idx ][ 2 ] = private.position[ idx ][ 3 ];
      private.position[ idx ][ 3 ] = private.position[ idx ][ 4 ];
      private.position[ idx ][ 4 ] = private.position[ idx ][ 5 ];
      private.position[ idx ][ 5 ] = private.Wardrobe1GetResource( idx, dir );

    end;

    for j = 1, private.item_count do

      ObjSet( "spr_wardrobe1_clother_"..idx.."_"..j, { res = "assets/levels/level1/rm_secondfloor1/zz_wardrobe1/layers/clother_"..idx.."_"..private.position[ idx ][ j ] } );

    end;

    ObjSet( "obj_wardrobe1_line_"..idx, { pos_x = 0 } );

    if ( private.Wardrobe1IsWin() ) then

      private.Wardrobe1WinAnim();

    else

      private.Wardrobe1Save();

    end;

    --private.Wardrobe1Debug( "Wardrobe1SetResources" );

  end;
--*********************************************************************************************************************
  function private.Wardrobe1WinAnim ()

    int.Lock( true );

    local func_exec = function ()

      int.Lock( false );
      private.Wardrobe1Save();
      private.Wardrobe1Win();

    end;
    
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_win_mmg_cloth" );
    cmn.WaitAndRun( func_exec );

  end;
--*********************************************************************************************************************
  function private.Wardrobe1Save ()

    for i = 1, private.line_count do

      for j = 1, private.item_count do

        ng_global.progress[ "std" ][ "win_wardrobe1" ].position[ i ][ j ] = private.position[ i ][ j ];

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.Wardrobe1IsWin ()

    for i = 1, private.line_count do

      if ( private.position[ i ][ 3 ] ~= private.win_position[ i ] ) then

        return false;

      end;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.Wardrobe1Win ()

    cmn.MiniGameHide( "wardrobe1" );
    cmn.SetEventDone( "win_wardrobe1" );
    cmn.CallEventHandler( "win_wardrobe1" );
    common_impl.PassingMgWin( "wardrobe1" );
    cmn.CloseSubRoom();

  end;
--*********************************************************************************************************************
  function private.Wardrobe1Debug ( txt )

    DbgTrace( "***** "..tostring( txt ).." *****" );

    DbgTrace( private.position[ 1 ][ 1 ]..", "..
              private.position[ 1 ][ 2 ]..", "..
              private.position[ 1 ][ 3 ]..", "..
              private.position[ 1 ][ 4 ]..", "..
              private.position[ 1 ][ 5 ] );
    DbgTrace( private.position[ 2 ][ 1 ]..", "..
              private.position[ 2 ][ 2 ]..", "..
              private.position[ 2 ][ 3 ]..", "..
              private.position[ 2 ][ 4 ]..", "..
              private.position[ 2 ][ 5 ] );
    DbgTrace( private.position[ 3 ][ 1 ]..", "..
              private.position[ 3 ][ 2 ]..", "..
              private.position[ 3 ][ 3 ]..", "..
              private.position[ 3 ][ 4 ]..", "..
              private.position[ 3 ][ 5 ] );

  end;
--*********************************************************************************************************************