-- name=rm_square1
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_square1";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_abighale1", "room_hub" );
  ObjAttach( "zz_shoppast1", "room_hub" );

  ObjMultiSet(
  {
    { "spr_shoppast1_fish1",      { event_mdown = private.get_fish1 } },
    { "spr_shoppast1_reagents1",  { event_mdown = private.get_reagents1 } },
    { "spr_square1_leaflet1",     { event_mdown = private.get_leaflet1 } },
    { "obj_square1_dlg_guard1_1",       { event_mdown = private.dlg_square1_guard1_1 } },
    { "obj_square1_dlg_guard1_1_focus", { event_mdown = private.dlg_square1_guard1_1 } },
    { "spr_square1_collect_1_1",  { event_mdown = private.get_collect_1_1 } },
    { "spr_square1_big_note",  { event_mdown = function() private.NoteClk() end; } },
    { "spr_shoppast1_screensaver_1_6",     { event_mdown = private.get_screensaver_1_6 } },            

  } );
   local get_screensaver_1_6 = function ()

    ObjDelete( "spr_shoppast1_screensaver_1_6" );

  end;
  cmn.AddSubscriber( "get_screensaver_1_6", get_screensaver_1_6, private.room_objname );  
 
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_square1 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_square1", update_game_mode_square1, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_collect_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_1_1 = function ()

    ObjDelete( "spr_square1_collect_1_1" );

  end;

  cmn.AddSubscriber( "get_collect_1_1", get_collect_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_1_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_1_5 = function ()

    ObjDelete( "obj_square1_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_1_5", get_morphobject_1_5, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  -----------------------------------------------
  local get_windupkey1_inv = function ()

    int.InventoryItemAdd( "inv_windupkey1", "spr_square1_windupkey1" );

  end;
  cmn.AddSubscriber( "get_windupkey1", get_windupkey1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_coin1_2 () end;
  --------------------------------------------------------------------------------------------
  -----------------------------------------------
  local get_coin1_2_inv = function ()

    int.InventoryItemAdd( "inv_coin1", "spr_square1_coin1", "assets/levels/level1/rm_secondfloor1/zz_coffeetable1/inv/inv_coin1_1" );
    level1_inv.CheckCoin1();

  end;

  cmn.AddSubscriber( "get_coin1_2", get_coin1_2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_letter1 () end;
  --------------------------------------------------------------------------------------------
  local get_letter1_inv = function ()

    int.InventoryItemAdd( "inv_letter1", "spr_square1_letter1" );

  end;

  cmn.AddSubscriber( "get_letter1", get_letter1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_fish1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fish1" ] =
  {
    type = "get",
    get_obj = "spr_shoppast1_fish1",
    room = private.room_objname,
    zz = "zz_shoppast1",
    zz_gate = "gzz_square1_shoppast1"
  };
  -----------------------------------------------
  local get_fish1_inv = function ()

    int.InventoryItemAdd( "inv_fish1", "spr_shoppast1_fish1" );

  end;

  local get_fish1_closezz = function ()

    ObjDelete( "gfx_shoppast1_fish1" );
    ObjDelete( "spr_shoppast1_fish_over" );
    ObjDelete( "spr_square1_shoppast1_fish_2" );

  end;

  cmn.AddSubscriber( "get_fish1", get_fish1_inv );
  cmn.AddSubscriber( "get_fish1", get_fish1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_reagents1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_reagents1" ] =
  {
    type = "get",
    get_obj = "spr_shoppast1_reagents1",
    room = private.room_objname,
    zz = "zz_shoppast1",
    zz_gate = "gzz_square1_shoppast1"
  };
  -----------------------------------------------
  local get_reagents1_inv = function ()

    int.InventoryItemAdd( "inv_reagents1", "spr_shoppast1_reagents1" );

  end;

  local get_reagents1_closezz = function ()

    ObjDelete( "gfx_shoppast1_reagents1" );
    if not ObjGet("spr_shoppast1_screensaver_1_6") then
      ObjDelete( "gzz_square1_shoppast1" );
    end;
    ObjDelete( "spr_shoppast1_reagents1_shadow" );
    ObjDelete( "spr_square1_shoppast1_reagent" );

  end;

  cmn.AddSubscriber( "get_reagents1", get_reagents1_inv );
  cmn.AddSubscriber( "get_reagents1", get_reagents1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_leaflet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_leaflet1" ] =
  {
    type = "get",
    get_obj = "spr_square1_big_note",
    room = private.room_objname,
  };
  -----------------------------------------------
  local get_leaflet1_inv = function ()

    int.InventoryItemAdd( "inv_leaflet1", "spr_square1_big_note" );

  end;

  local get_leaflet1_closezz = function ()
    

  end;

  cmn.AddSubscriber( "get_leaflet1", get_leaflet1_inv );
  cmn.AddSubscriber( "get_leaflet1", get_leaflet1_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_amulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amulet1" ] =
  {
    type = "use",
    use_obj = "inv_amulet1",
    use_place = "obj_abighale1_use_amulet1",
    room = private.room_objname,
    zz = "zz_abighale1",
    zz_gate = "gzz_square1_abighale1"
  };
  -----------------------------------------------
  local use_amulet1_inv = function ()

    int.InventoryItemRemove( "inv_amulet1" );

  end;
  local use_amulet1_beg = function ()

    ObjDelete( "obj_abighale1_use_amulet1" );

  end;
  local use_amulet1_end = function ()

    ObjDelete( "anm_abighale1_abighale_amulet" );
    ObjDelete( "gzz_square1_abighale1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_amulet1",     use_amulet1_inv );
  cmn.AddSubscriber( "use_amulet1",     use_amulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulet1",     use_amulet1_end, private.room_objname );
  cmn.AddSubscriber( "use_amulet1_inv", use_amulet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_amulet1_beg", use_amulet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulet1_end", use_amulet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_leaflet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_leaflet1" ] =
  {
    type = "use",
    use_obj = "inv_leaflet1",
    use_place = "obj_abighale1_use_leaflet1",
    room = private.room_objname,
    zz = "zz_abighale1",
    zz_gate = "gzz_square1_abighale1"
  };
  -----------------------------------------------
  local use_leaflet1_inv = function ()

    int.InventoryItemRemove( "inv_leaflet1" );

  end;
  local use_leaflet1_beg = function ()

    ObjDelete( "obj_abighale1_use_leaflet1" );

  end;
  local use_leaflet1_end = function ()

    ObjDelete( "anm_abighale1_abighale_leaflet" );
    ObjSet( "obj_abighale1_use_amulet1", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_leaflet1",     use_leaflet1_inv );
  cmn.AddSubscriber( "use_leaflet1",     use_leaflet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_leaflet1",     use_leaflet1_end, private.room_objname );
  cmn.AddSubscriber( "use_leaflet1_inv", use_leaflet1_inv, private.room_objname );
  cmn.AddSubscriber( "use_leaflet1_beg", use_leaflet1_beg, private.room_objname );
  cmn.AddSubscriber( "use_leaflet1_end", use_leaflet1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coin1" ] =
  {
    type = "use",
    use_obj = "inv_coin1",
    use_place = "obj_shoppast1_use_coin1",
    room = private.room_objname,
    zz = "zz_shoppast1",
    zz_gate = "gzz_square1_shoppast1"
  };
  -----------------------------------------------
  local use_coin1_inv = function ()

    int.InventoryItemRemove( "inv_coin1" );

  end;
  local use_coin1_beg = function ()

    ObjDelete( "obj_shoppast1_use_coin1" );
    ObjDelete( "anm_shoppast1_fish" );

  end;
  local use_coin1_end = function ()

    ObjSet( "spr_shoppast1_fish1",     { alp = 1, input = true } );
    ObjSet( "gfx_shoppast1_fish1",     { active = true } );
    ObjSet( "obj_shoppast1_use_list1", { input = true } );
    ObjSet( "spr_square1_shoppast1_fish_2", { alp = 1 } );
    ObjDelete( "anm_shoppast1_coin" );
    ObjDelete( "spr_square1_shoppast1_fish_1" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_coin1",     use_coin1_inv );
  cmn.AddSubscriber( "use_coin1",     use_coin1_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin1",     use_coin1_end, private.room_objname );
  cmn.AddSubscriber( "use_coin1_inv", use_coin1_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin1_beg", use_coin1_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin1_end", use_coin1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_list1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_list1" ] =
  {
    type = "use",
    use_obj = "inv_list1",
    use_place = "obj_shoppast1_use_list1",
    room = private.room_objname,
    zz = "zz_shoppast1",
    zz_gate = "gzz_square1_shoppast1"
  };
  -----------------------------------------------
  local use_list1_inv = function ()

    int.InventoryItemRemove( "inv_list1" );

  end;
  local use_list1_beg = function ()

    ObjDelete( "obj_shoppast1_use_list1" );

  end;
  local use_list1_end = function ()

    ObjDelete( "anm_shoppast1_list" );
    ObjSet( "obj_shoppast1_use_money1", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_list1",     use_list1_inv );
  cmn.AddSubscriber( "use_list1",     use_list1_beg, private.room_objname );
  cmn.AddSubscriber( "use_list1",     use_list1_end, private.room_objname );
  cmn.AddSubscriber( "use_list1_inv", use_list1_inv, private.room_objname );
  cmn.AddSubscriber( "use_list1_beg", use_list1_beg, private.room_objname );
  cmn.AddSubscriber( "use_list1_end", use_list1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_money1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_money1" ] =
  {
    type = "use",
    use_obj = "inv_money1",
    use_place = "obj_shoppast1_use_money1",
    room = private.room_objname,
    zz = "zz_shoppast1",
    zz_gate = "gzz_square1_shoppast1"
  };
  -----------------------------------------------
  local use_money1_inv = function ()

    int.InventoryItemRemove( "inv_money1" );

  end;
  local use_money1_beg = function ()

    ObjDelete( "obj_shoppast1_use_money1" );

  end;
  local use_money1_end = function ()

    ObjDelete( "anm_shoppast1_money" );
    ObjSet( "spr_shoppast1_reagents1_shadow", { alp = 1 } );
    ObjSet( "spr_shoppast1_reagents1", { alp = 1, input = true } );
    ObjSet( "gfx_shoppast1_reagents1", { active = true } );
    ObjSet( "spr_square1_shoppast1_reagent", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_money1",     use_money1_inv );
  cmn.AddSubscriber( "use_money1",     use_money1_beg, private.room_objname );
  cmn.AddSubscriber( "use_money1",     use_money1_end, private.room_objname );
  cmn.AddSubscriber( "use_money1_inv", use_money1_inv, private.room_objname );
  cmn.AddSubscriber( "use_money1_beg", use_money1_beg, private.room_objname );
  cmn.AddSubscriber( "use_money1_end", use_money1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fakedocument1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fakedocument1" ] =
  {
    type = "use",
    use_obj = "inv_fakedocument1",
    use_place = "obj_square1_use_fakedocument1",
    room = private.room_objname,
  };
  -----------------------------------------------
  local use_fakedocument1_inv = function ()

    int.InventoryItemRemove( "inv_fakedocument1" );

  end;
  local use_fakedocument1_beg = function ()

    ObjDelete( "obj_square1_use_fakedocument1" );

  end;
  local use_fakedocument1_end = function ()


  end;
  -----------------------------------------------
  cmn.AddSubscriber( "use_fakedocument1",     use_fakedocument1_inv );
  cmn.AddSubscriber( "use_fakedocument1",     use_fakedocument1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fakedocument1",     use_fakedocument1_end, private.room_objname );
  cmn.AddSubscriber( "use_fakedocument1_inv", use_fakedocument1_inv, private.room_objname );
  cmn.AddSubscriber( "use_fakedocument1_beg", use_fakedocument1_beg, private.room_objname );
  cmn.AddSubscriber( "use_fakedocument1_end", use_fakedocument1_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function dlg_square1_abigail1_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_square1_abigail1_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_square1_abigail1_1_end = function ()

    ObjDelete( "dlg_square1_abigail1_1" );

  end;

  cmn.AddSubscriber( "dlg_square1_abigail1_1",     dlg_square1_abigail1_1_beg );
  cmn.AddSubscriber( "dlg_square1_abigail1_1",     dlg_square1_abigail1_1_end );
  cmn.AddSubscriber( "dlg_square1_abigail1_1_beg", dlg_square1_abigail1_1_beg );
  cmn.AddSubscriber( "dlg_square1_abigail1_1_end", dlg_square1_abigail1_1_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_square1_abigail1_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_square1_abigail1_2_beg = function ()

  end;
  -----------------------------------------------
  local dlg_square1_abigail1_2_end = function ()
    
    ObjDelete( "dlg_square1_abigail1_2" );

  end;

  cmn.AddSubscriber( "dlg_square1_abigail1_2",     dlg_square1_abigail1_2_beg );
  cmn.AddSubscriber( "dlg_square1_abigail1_2",     dlg_square1_abigail1_2_end );
  cmn.AddSubscriber( "dlg_square1_abigail1_2_beg", dlg_square1_abigail1_2_beg );
  cmn.AddSubscriber( "dlg_square1_abigail1_2_end", dlg_square1_abigail1_2_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_square1_guard1_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_square1_guard1_1" ] =
  {
    type = "click",
    clk_obj = "obj_square1_dlg_guard1_1_focus",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_square1_guard1_1_beg = function ()

    ObjDelete( "obj_square1_dlg_guard1_1" );

  end;
  -----------------------------------------------
  local dlg_square1_guard1_1_end = function ()

    ObjDelete( "dlg_square1_guard1_1" );

  end;

  cmn.AddSubscriber( "dlg_square1_guard1_1",     dlg_square1_guard1_1_beg );
  cmn.AddSubscriber( "dlg_square1_guard1_1",     dlg_square1_guard1_1_end );
  cmn.AddSubscriber( "dlg_square1_guard1_1_beg", dlg_square1_guard1_1_beg );
  cmn.AddSubscriber( "dlg_square1_guard1_1_end", dlg_square1_guard1_1_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_1_6()

  int.AddScreensaver( "spr_shoppast1_screensaver_1_6" );
  if cmn.IsEventDone("get_reagents1") then
    ObjDelete( "gzz_square1_shoppast1" );
    cmn.CloseSubRoom();
  end;
  
end; 
-----------------------------------------------------------------------
function private.get_collect_1_1 ()

  int.AddCollectibles( "spr_square1_collect_1_1" );

end;
-----------------------------------------------------------------------
function private.get_fish1 ()

  cmn.SetEventDone( "get_fish1" );
  cmn.CallEventHandler( "get_fish1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_reagents1 ()

  cmn.SetEventDone( "get_reagents1" );
  cmn.CallEventHandler( "get_reagents1" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_leaflet1 ()

  cmn.SetEventDone( "get_leaflet1" );
  cmn.CallEventHandler( "get_leaflet1" );
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function public.use_amulet1 ()

  local item = "inv_amulet1";

  if ( cmn.ApplyObj( item, "gzz_square1_abighale1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_abighale1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_abighale1_use_amulet1", true ) ) then

    cmn.CallEventHandler( "use_amulet1_inv" );
    cmn.CallEventHandler( "use_amulet1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.CloseSubRoom( true );

      private.dlg_square1_abigail1_2();

    end;

    int.Lock( true );

    ObjSet( "anm_abighale1_abighale_static", { alp = 0 } );
    ObjSet( "anm_abighale1_abighale_amulet", { alp = 1 } );

    AnimStop( "anm_abighale1_abighale_static" );
    AnimPlay( "anm_abighale1_abighale_amulet", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_abigail_meadllion" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_leaflet1 ()

  local item = "inv_leaflet1";

  if ( cmn.ApplyObj( item, "gzz_square1_abighale1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_abighale1", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_abighale1_use_leaflet1", true ) ) then

    cmn.CallEventHandler( "use_leaflet1_inv" );
    cmn.CallEventHandler( "use_leaflet1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.CloseSubRoom( true );

      private.dlg_square1_abigail1_1();

    end;

    int.Lock( true );

    ObjSet( "anm_abighale1_abighale_static",  { alp = 0 } );
    ObjSet( "anm_abighale1_abighale_leaflet", { alp = 1 } );

    AnimStop( "anm_abighale1_abighale_static" );
    AnimPlay( "anm_abighale1_abighale_leaflet", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_abigale_take_wanted" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_coin1 ()

  local item = "inv_coin1";

  if ( cmn.ApplyObj( item, "gzz_square1_shoppast1", false ) and 
       cmn.IsEventDone( "get_coin1_1" ) and
       cmn.IsEventDone( "get_coin1_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shoppast1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shoppast1_use_coin1", true ) and 
           cmn.IsEventDone( "get_coin1_1" ) and
           cmn.IsEventDone( "get_coin1_2" ) ) then

    cmn.CallEventHandler( "use_coin1_inv" );
    cmn.CallEventHandler( "use_coin1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_coin1" );
      cmn.CallEventHandler( "use_coin1_end" );

      ObjSet( "anm_shoppast1_seller_hands", { alp = 1 } );

    end;

    int.Lock( true );

    ObjSet( "anm_shoppast1_seller_hands", { alp = 0 } );
    ObjSet( "anm_shoppast1_coin",         { alp = 1 } );

    AnimPlay( "anm_shoppast1_coin", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_celler_take_coin" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_list1 ()

  local item = "inv_list1";

  if ( cmn.ApplyObj( item, "gzz_square1_shoppast1", false ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shoppast1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shoppast1_use_list1", true ) ) then

    cmn.CallEventHandler( "use_list1_inv" );
    cmn.CallEventHandler( "use_list1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_list1" );
      cmn.CallEventHandler( "use_list1_end" );

      ObjSet( "anm_shoppast1_seller_hands", { alp = 1 } );

    end;

    int.Lock( true );

    ObjSet( "anm_shoppast1_seller_hands", { alp = 0 } );
    ObjSet( "anm_shoppast1_list",         { alp = 1 } );
    AnimPlay( "anm_shoppast1_list", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_take_celler_envelope" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_money1 ()

  local item = "inv_money1";

  if ( cmn.ApplyObj( item, "gzz_square1_shoppast1", false ) ) and
     ( cmn.IsEventDone( "use_list1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shoppast1" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shoppast1_use_money1", true ) ) and
         ( cmn.IsEventDone( "use_list1" ) ) then

    cmn.CallEventHandler( "use_money1_inv" );
    cmn.CallEventHandler( "use_money1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_money1" );
      cmn.CallEventHandler( "use_money1_end" );

      ObjSet( "anm_shoppast1_seller_hands", { alp = 1 } );

    end;

    int.Lock( true );

    ObjSet( "anm_shoppast1_seller_hands", { alp = 0 } );
    ObjSet( "anm_shoppast1_money",        { croprect_init = false } );
    AnimPlay( "anm_shoppast1_money", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_take_celler_bag" );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function public.use_fakedocument1 ()

  local item = "inv_fakedocument1";

  if ( cmn.ApplyObj( item, "obj_square1_use_fakedocument1", true ) ) then

    cmn.CallEventHandler( "use_fakedocument1_inv" );
    cmn.CallEventHandler( "use_fakedocument1_beg" );

    local func_end = function ()

      local func_end_1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_fakedocument1" );
        cmn.CallEventHandler( "use_fakedocument1_end" );
        
      end;

      cmn.CloseSubRoom();            
      public.OutroLvl1( func_end_1 );
      
    end;

    int.Lock( true );

    --ObjAnimate( "spr", "alp", 0, 0, func_end,
    --{ 
    --  0.0, 0, 0.0,
    --  0.3, 0, 1.0,
    --} );

    func_end();
    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_square1 ()

  if not ( cmn.IsEventDone( "opn_square1" ) ) then

    cmn.SetEventDone( "opn_square1" );
    cmn.PlayAudio( "mus", "audio/level1/mus/aud_old_music_strings_mus", nil, nil, 35 );

  end;
  
  if ( cmn.IsEventDone( "dlg_square1_abigail1_2" ) ) then

    if ( ng_global.progress[ ng_global.currentprogress ][ "opn_square1" ].see_abigail == 1 ) then

      cmn.GotoSubRoom( "zz_abighale1", nil, { 512, 384 }, true );
      
    end;

  end;
  
  cmn.StopAllEnv( "audio/level1/env/aud_rm_square1_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_rm_square1_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  if ( cmn.IsEventDone( "dlg_square1_abigail1_2" ) ) then
    
    if ng_global.progress[ ng_global.currentprogress ][ "opn_square1" ].see_abigail == 2 then
    
      ObjDelete( "obj_square1_abighale1" );
    
    end;
      
  end;
  
end;  
--*********************************************************************************************************************
function public.Open ()

  private.opn_square1();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_windupkey1",                              { "dlg_square1_abigail1_2" } );
  int.AddedTaskMap( private.room_objname, "get_coin1_2",                                 { "dlg_square1_abigail1_1" } );
  int.AddedTaskMap( private.room_objname, "get_letter1",                                 { "dlg_square1_abigail1_2" } );
  int.AddedTaskMap( private.room_objname, "get_fish1",                                   { "use_coin1" } );
  int.AddedTaskMap( private.room_objname, "get_reagents1",                               { "use_money1" } );
  int.AddedTaskMap( private.room_objname, "get_leaflet1",                                { "dlg_square1_guard1_1" });

  int.AddedTaskMap( private.room_objname, "use_amulet1",                                 { "get_amulet1" } );
  int.AddedTaskMap( private.room_objname, "use_leaflet1",                                { "get_leaflet1" } );
  int.AddedTaskMap( private.room_objname, "use_coin1",                                   { "get_coin1_1", "get_coin1_2" } );
  int.AddedTaskMap( private.room_objname, "use_list1",                                   { "win_hosafe1" } );
  int.AddedTaskMap( private.room_objname, "use_money1",                                  { "use_list1", "win_hosafe1" } );
  int.AddedTaskMap( private.room_objname, "use_fakedocument1",                           { "get_fakedocument1" } );
  
  int.AddedTaskMap( private.room_objname, "dlg_square1_abigail1_1",                      { "use_leaflet1" } );
  int.AddedTaskMap( private.room_objname, "dlg_square1_abigail1_2",                      { "use_amulet1" } );
  int.AddedTaskMap( private.room_objname, "dlg_square1_guard1_1" );

end;
--*********************************************************************************************************************
function private.dlg_square1_abigail1_1 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_coin1_2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_square1_abigail1_1_abigail_static_1", { alp = 0 } );
    ObjSet( "anm_square1_abigail1_1_abigail_object",   { alp = 1 } );
    ObjSet( "spr_square1_coin1",                       { alp = 1 } );

    AnimStop( "anm_square1_abigail1_1_abigail_static_1" );

    cmn.SetEventDone( "get_coin1_2" );
    cmn.SetEventDone( "dlg_square1_abigail1_1" );
    cmn.SetEventDone( "use_leaflet1" );
    cmn.CallEventHandler( "use_leaflet1_end" );

    level1_inv.CheckCoin1();

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_square1_abigail1_1_abigail_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "spr_square1_abighale1_abighale";
    common_impl.DialogCharacterStart( "abigail1_1", "square1", 3, nil, nil, true, func_end );

    ObjSet( "anm_abighale1_abighale_static",  { alp = 1 } );
    AnimPlay( "anm_abighale1_abighale_static", "DoAnim", "" );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_square1_abigail1_1_beg" );
  ObjAttach( "dlg_square1_abigail1_1", GetCurrentRoom() );  

  func_anim_end();

end;
--*********************************************************************************************************************
function private.dlg_square1_abigail1_2 ()

  local func_end = function ()

    cmn.CallEventHandler( "get_letter1" );
    cmn.CallEventHandler( "get_windupkey1" );
    cmn.GetObjectSfx();

    ObjSet( "anm_square1_abigail1_2_abigail_static_1", { alp = 0 } );
    ObjSet( "anm_square1_abigail1_2_abigail_object",   { alp = 1 } );
    ObjSet( "spr_square1_letter1",                     { alp = 1 } );
    ObjSet( "spr_square1_windupkey1",                  { alp = 1 } );

    AnimStop( "anm_square1_abigail1_2_abigail_static_1" );
    ng_global.progress[ ng_global.currentprogress ][ "opn_square1" ].see_abigail = 1;
    cmn.GotoSubRoom( "zz_abighale1", nil, { 512, 384 }, true );
    
    cmn.SetEventDone( "get_letter1" );
    cmn.SetEventDone( "get_windupkey1" );
    cmn.SetEventDone( "dlg_square1_abigail1_2" );
    cmn.SetEventDone( "use_amulet1" );
    cmn.CallEventHandler( "use_amulet1_end" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_square1_abigail1_2_abigail_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "spr_square1_abighale1_abighale";
    common_impl.DialogCharacterStart( "abigail1_2", "square1", 3, nil, nil, true, func_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_square1_abigail1_2_beg" );
  ObjAttach( "dlg_square1_abigail1_2", GetCurrentRoom() );  

  func_anim_end();

end;
--*********************************************************************************************************************
function private.dlg_square1_guard1_1 ()

  local func_end = function ()
    
    local func_end1 = function ()
      
      ObjSet( "spr_square1_big_note", { input = true } );
      int.Lock( false );

      interface.KeyTaskDone( true, "task_1_5" );

    end;   

    ObjSet( "anm_square1_guard1_1_guard_static_1", { alp = 0 } );
    ObjSet( "anm_square1_guard1_1_guard_give",     { alp = 1 } );
    ObjSet( "spr_square1_leaflet1",                { alp = 1 } );

    AnimStop( "anm_square1_guard1_1_guard_static_1" );

    cmn.SetEventDone( "get_leaflet1" );
    cmn.SetEventDone( "dlg_square1_guard1_1" );
    
    int.Lock( true );
    cmn.ShowBbt( "bbt_square1_leaflet" );
    ObjAnimate( "spr_square1_big_note", "scale_xy", 0, 0, func_end1, 
    { 
      0.0, 0, 0, 0,
      0.3, 0, 1, 1
    } );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_square1_guard1_1_guard_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "anm_rm_square1_guard";
    common_impl.DialogCharacterStart( "guard1_1", "square1", 2, nil, nil, true, func_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_square1_guard1_1_beg" );
  ObjAttach( "dlg_square1_guard1_1", GetCurrentRoom() );  

  func_anim_end();

end;
--*********************************************************************************************************************
function private.NoteClk ()
  
  cmn.CallEventHandler( "get_leaflet1" );
  cmn.GetObjectSfx();
  
end;  
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "abigail1_1" ) then

    if ( count_txt == 3 ) then

      AnimStop( "anm_square1_abigail1_1_abigail_static_1" );
      AnimPlay( "anm_square1_abigail1_1_abigail_object", "DoAnim", "" );
      ObjSet( "anm_square1_abigail1_1_abigail_object", { alp = 1 } );
      ObjSet( "anm_square1_abigail1_1_abigail_static_1", { alp = 0 } );

    end;

  end;

  if ( dlg_name == "abigail1_2" ) then

    if ( count_txt == 3 ) then

      AnimStop( "anm_square1_abigail1_2_abigail_static_1" );
      AnimPlay( "anm_square1_abigail1_2_abigail_object", "DoAnim", "" );
      ObjSet( "anm_square1_abigail1_2_abigail_object", { alp = 1 } );
      ObjSet( "anm_square1_abigail1_2_abigail_static_1", { alp = 0 } );

    end;

  end;

  if ( dlg_name == "guard1_1" ) then

    if ( count_txt == 2 ) then
      
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_guard_takes_you_paper" );
      AnimStop( "anm_square1_guard1_1_guard_static_1" );
      AnimPlay( "anm_square1_guard1_1_guard_give", "DoAnim", "" );
      ObjSet( "anm_square1_guard1_1_guard_give", { alp = 1 } );
      ObjSet( "anm_square1_guard1_1_guard_static_1", { alp = 0 } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_abighale1" );
  -----------------------------------------------
  function zz_abighale1.PreOpen()
    if ng_global.progress[ ng_global.currentprogress ][ "opn_square1" ].see_abigail == 1 then
      ObjSet( "anm_abighale1_abighale_static", { alp = 0 } );
      ObjSet( "anm_abighale1_abighale_amulet", { alp = 0 } );
      ObjSet( "anm_abighale1_mask", { alp = 1 } );
    end;  
  end;
  -----------------------------------------------
  function zz_abighale1.Open()
    
    if ng_global.progress[ ng_global.currentprogress ][ "opn_square1" ].see_abigail == 1 then
      
      local func_end = function ()
        
        cmn.CloseSubRoom( true );
        
        local func_end1 = function ()
          ng_global.progress[ ng_global.currentprogress ][ "opn_square1" ].see_abigail = 2;
          int.Lock( false );
        end;  
        
        ObjDelete( "spr_square1_abighale1_abighale" );
        ObjSet( "anm_square1_abigail", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_abigail_goes_loc" );
        AnimPlay( "anm_square1_abigail", "DoAnim", func_end1 );
        
      end;
      
      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_abigail_take_off_mask" );
      AnimPlay( "anm_abighale1_mask", "DoAnim", func_end ); 
      
    end;  
    
  end;
  -----------------------------------------------
  function zz_abighale1.PreClose()
  end;
  -----------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_shoppast1_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1.0,
    1.6, 0, 0.5,
    3.2, 0, 1.0,
  } );

end;
--*********************************************************************************************************************
function public.OutroLvl1 ( func_end1 )

  local func_end = function ( skip )

    func_end1();    
    int.Lock( false );
    
    if ( skip ) then
      
      cmn.StopAudio( "sfx", "audio/level1/mus/aud_outro_vid_mus" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_square1_outro_voc" );
      
    end;

    common_impl.InterfaceSetVisible( true );
    
    if ( IsDemoEdition() or IsSurveyEdition() or cmn.IsFP ) then

      cmn.GotoRoom( "rm_demo" );

    else 

      local prg = ng_global.currentprogress;
      ng_global.progress[ prg ].common.chapter = "level2";
      ng_global.progress[ prg ].common.currentroom = nil;
      local level = ng_global.progress[ prg ].common.chapter;
      ng_global.task_current = nil;

      common.LevelSwitch( level );    

    end;    

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_square1_outro", func_end );  

  cmn.PlayAudio( "sfx", "audio/level1/mus/aud_outro_vid_mus", nil, nil, 26 );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_square1_outro_voc" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************