-- name=ho_hosecretsection2
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hosecretsection2" );
  game.relations[ "ho_hosecretsection2" ].exitroom = "rm_abighalehouse2";
  private.room_objname = "ho_hosecretsection2";
  private.task_name = "win_hosecretsection2";  
  private.win_hosecretsection2 = {};    
  
  private.COLLECT_ANIM_TIME = 0.8;
  private.COLLECT_VISIBLE_TIME = 4.0;
  private.REPLACE_VISIBLE_TIME = 2.0;      
  
  --------------------------------------------------------------------------------------------
  -- function opn_hosecretsection2 () end;
  --------------------------------------------------------------------------------------------
  local opn_hosecretsection2 = function ()

  end;

  cmn.AddSubscriber( "opn_hosecretsection2", opn_hosecretsection2, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hosecretsection2_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_envelope2", "spr_hosecretsection2_win" );
      ObjDelete( "gho_abighalehouse2_hosecretsection2" );

      ObjSet( "inv_envelope2", { drag = false } );

      if ( not cmn.IsEventDone( "get_paperknife2" ) ) then

        ObjSet( "inv_envelope2_plus_focus2", { alp = 0 } );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_hosecretsection2", win_hosecretsection2_func );
  --------------------------------------------------------------------------------------------------
  local start_hosecretsection2_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

      common_impl.ProcessHoStart( "hosecretsection2" );
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hosecretsection2", start_hosecretsection2_func, "ho_hosecretsection2" );
  --------------------------------------------------------------------------------------------------
  private.win_hosecretsection2.task = { "item_1", "item_2", "item_3", "item_4", 
               "item_5", "item_6", "item_7", "item_8", 
             "item_9", "item_12", "item_11", "item_10" };
  for i = 1, #private.win_hosecretsection2.task do

    ObjSet( "spr_hosecretsection2_"..private.win_hosecretsection2.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hosecretsection2.task[ i ] ); end } );

  end;

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hosecretsection2" );

  end;

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hosecretsection2" ) ) then

      cmn.SetEventDone( "opn_hosecretsection2" );
      cmn.CallEventHandler( "opn_hosecretsection2" );

  end;        

  local ho_tasks = {};
  
  for i = 1, #private.win_hosecretsection2.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hosecretsection2.task[ i ], 1, 0, { { "spr_hosecretsection2_"..private.win_hosecretsection2.task[ i ]  } } );
    
  end; 
  
  
  for i=1, #private.win_hosecretsection2.task do  

    local rand = math.random( 1, 2 );
    
    if rand == 1 then
    
      private.MorphItemMorphing( private.win_hosecretsection2.task[ i ] );
      
    else
      
      private.MorphItemActive( private.win_hosecretsection2.task[ i ] );
      
    end;
    
  end;    
  
  int.TaskPanelShow( ho_tasks );
  private.PanelShow();
  
  private.ClearTasks();  
  
  cmn.StopAllMus();
  cmn.StopAllEnv( "audio/level2/env/aud_rm_abighalehouse2_env" );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_abighalehouse2_env", 1, 1 );
  --cmn.PlayAudio( "mus", "audio/aud_ho_game1_mus", 1, 1 );     

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.StopMusEnv( false );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "mus", "audio/aud_ho_game1_mus", 0.5 );
  common_impl.PlayMusEnv();  

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  private.PanelHide();
  
end;

--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  if (ObjGet("spr_hosecretsection2_"..name).alp > 0.8) then  
  
    local postfix = "";
    if ( number ) then postfix = "_"..number; end;
    cmn.HoTaskFind( "spr_hosecretsection2_"..name..postfix, name );
    common_impl.PassingHoCheck();  
    
  end;

end;
--*********************************************************************************************************************
function private.ClearTasks ()

  local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

  for i = 1, #ho_found, 1 do
      ObjDelete( ho_found[ i ][ "object" ] );
      ObjDelete( ho_found[ i ][ "object" ].."_morph" );
  end;

end;
--*********************************************************************************************************************
function private.PanelShow ( )

  ObjSet( "int_inventory_impl", { input = false } );
  ObjSet( "obj_int_taskpanel", { alp = 1 } );

end;
--*********************************************************************************************************************
function private.PanelHide ( )  
  
  ObjSet( "int_inventory_impl", { input = true } );
  ObjSet( "obj_int_taskpanel", { alp = 1 } );  
  
end;   
--*********************************************************************************************************************
function private.MorphItemMorphing ( name )
 
  local collect_item = "spr_hosecretsection2_"..name;
  local replace_item = "spr_hosecretsection2_"..name.."_morph"; 
  local random_time = math.random( 0, 2 );

  --ObjSet( collect_item, { input = false } ); 

  ObjAnimate( collect_item, "alp", 0, 0, function() private.MorphItemActive( name ) end, { 
    0, 0, 1,
    random_time + private.COLLECT_ANIM_TIME, 0, 0,
    random_time + private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 0, 0,
    random_time + 2*private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 3, 1 } );

  ObjAnimate( replace_item, "alp", 0, 0, "", { 
    0, 0, 0,
    random_time + private.COLLECT_ANIM_TIME, 0, 1,
    random_time + private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 0, 1,
    random_time + 2*private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 3, 0 } );
 
end;
--*********************************************************************************************************************
function private.MorphItemActive ( name )
  
   local collect_item = "spr_hosecretsection2_"..name;
   local replace_item = "spr_hosecretsection2_"..name.."_morph"; 
  
   --ObjSet( collect_item, { input = true } ); 

   ObjAnimate( collect_item, "alp", 0, 0, function() private.MorphItemMorphing( name ) end, { 
    0, 3, 1, 
    private.COLLECT_VISIBLE_TIME, 3, 1 } );

  ObjAnimate( replace_item, "alp", 0, 0, "", { 
    0, 3, 0, 
    private.COLLECT_VISIBLE_TIME, 3, 0 } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************