-- name=ho_hoskeleton2
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hoskeleton2" );
  game.relations[ "ho_hoskeleton2" ].exitroom = "rm_prison2";
  private.room_objname = "ho_hoskeleton2";
  private.task_name = "win_hoskeleton2";  
  private.win_hoskeleton2 = {};      

  --------------------------------------------------------------------------------------------
  -- function opn_hoskeleton2 () end;
  --------------------------------------------------------------------------------------------
  local opn_hoskeleton2 = function ()

  end;

  cmn.AddSubscriber( "opn_hoskeleton2", opn_hoskeleton2, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hoskeleton2_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_hook2", "spr_hoskeleton2_win" );
      ObjDelete( "gho_prison2_hoskeleton2" );
      ObjDelete( "spr_hoskeleton2_panel" );     

      if ( cmn.IsEventDone( "get_rope2" ) ) then

        ObjSet( "inv_rope2_plus_focus2", { alp = 1 } );

      end;

    end;

  end;
  cmn.AddSubscriber( "win_hoskeleton2", win_hoskeleton2_func );
  --------------------------------------------------------------------------------------------------
  local start_hoskeleton2_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

      common_impl.ProcessHoStart( "hoskeleton2" );
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hoskeleton2", start_hoskeleton2_func, "ho_hoskeleton2" );
  --------------------------------------------------------------------------------------------------
  private.win_hoskeleton2.task = { "item_1", "item_2", "item_3", "item_4", 
               "item_5", "item_6", "item_7", "item_8", 
               "item_9", "item_10", "item_11", "item_12" };
  for i = 1, #private.win_hoskeleton2.task do

    ObjSet( "spr_hoskeleton2_"..private.win_hoskeleton2.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hoskeleton2.task[ i ] ); end } );

  end;
  
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hoskeleton2" );

  end;

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hoskeleton2" ) ) then

      cmn.SetEventDone( "opn_hoskeleton2" );
      cmn.CallEventHandler( "opn_hoskeleton2" );
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count = 12;

  end;        

  local ho_tasks = {};
  
  for i = 1, #private.win_hoskeleton2.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hoskeleton2.task[ i ], 1, 0, { { "spr_hoskeleton2_"..private.win_hoskeleton2.task[ i ]  } } );
    
  end;
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  
  cmn.StopAllMus();
  --cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1 );  
  cmn.StopAllEnv( "audio/level2/env/aud_ho_hoskeleton2_env" );
  cmn.PlayAudio( "env", "audio/level2/env/aud_ho_hoskeleton2_env", 1, 1 );  

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.StopMusEnv( false );

  cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 0.5 );
  common_impl.PlayMusEnv();  

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "obj_int_taskpanel", { alp = 1, input = true } );  
  ObjSet( "txt_int_taskpanel", { alp = 1 } );  
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hoskeleton2_panel", "ho_hoskeleton2" );
  --cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 0.5 );
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  local postfix = "";
  if ( number ) then postfix = "_"..number; end;
  cmn.HoTaskFind( "spr_hoskeleton2_"..name..postfix, name );
  common_impl.PassingHoCheck();  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count - 1;
  ObjSet( "txt_hoskeleton2_task_num", { text = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count } );

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0, input = false } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hoskeleton2_panel", "int_taskpanel_impl" );
  ObjSet( "txt_hoskeleton2_task_num", { text = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************