-- name=mg_mgcatacomb2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgcatacomb2";
  game.relations[ "mg_mgcatacomb2" ].exitroom = "rm_abighalehouse2";

  private.Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgcatacomb2 = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgcatacomb2", update_game_mode_mgcatacomb2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mgcatacomb2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgcatacomb2" ] =
  {
    type = "click",
    get_obj = "spr_mgcatacomb2_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgcatacomb2 = function ()

    if ( cmn.IsEventDone( "win_mgcatacomb2" ) ) then

      --int.DeleteTaskMap( "rm_abighalehouse2", "win_mgcatacomb2" );
      ObjSet( "obj_mgcatacomb2_arrows", { alp = 0, input = false } );
      
      int.LockRoomMap("abighalehouse2",1);      
      int.LockRoomMap("alley2",1);                               

    end;

    if ( cmn.IsEventStart( "win_mgcatacomb2" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgcatacomb2", win_mgcatacomb2 );
  -----------------------------------------------

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mgcatacomb2" ) ) then

    private.Start();

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventDone( "win_mgcatacomb2" ) ) then

    cmn.MiniGameShow( "mgcatacomb2" );
    common_impl.PassingMgStart( "mgcatacomb2" );

  end;

  common_impl.StopMusEnv( false );  
  cmn.StopAllMus();
  cmn.StopAllEnv( "audio/level2/env/aud_mg_catacomb2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_mg_catacomb2_env", 1, 1 );  
  cmn.PlayAudio( "mus", "audio/aud_action_theme_1_loop_mus", 1, 1 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "mgcatacomb2" );

  cmn.StopAudio( "mus", "audio/aud_action_theme_1_loop_mus", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PlayMusEnv();
  
end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].point =  1;
  ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].moves = 23;

  private.Load();

end;
--*********************************************************************************************************************
function public.Skip ()

  int.Lock( true );

  private.SetInput();

  local func_end = function ()

    private.WinAnim();

  end;

  ObjAnimate( "obj_mgcatacomb2_point", "alp", 0, 0, func_end,
  {
    0.0, 0, 1.0,
    0.3, 0, 0.0,
    0.6, 0, 1.0,
  } );

  ObjAnimate( "obj_mgcatacomb2_point", "pos_xy", 0, 0, "",
  {
    0.0, 0, private.point_pos[ private.point ][ 1 ],     private.point_pos[ private.point ][ 2 ],
    0.3, 0, private.point_pos[ private.point ][ 1 ],     private.point_pos[ private.point ][ 2 ],
    0.3, 0, private.point_pos[ private.win_point ][ 1 ], private.point_pos[ private.win_point ][ 2 ],
  } );

  --ObjAnimate( "obj_mgcatacomb2_dark", "alp", 0, 0, "",
  --{
  --  0.0, 0, 1.0,
  --  0.3, 0, 0.0,
  --  0.6, 0, 1.0,
  --} );

  ObjAnimate( "obj_mgcatacomb2_dark", "pos_xy", 0, 0, "",
  {
    0.0, 0, private.point_pos[ private.point ][ 1 ],     private.point_pos[ private.point ][ 2 ],
    0.3, 0, private.point_pos[ private.point ][ 1 ],     private.point_pos[ private.point ][ 2 ],
    0.3, 0, private.point_pos[ private.win_point ][ 1 ], private.point_pos[ private.win_point ][ 2 ],
  } );

end;
--*********************************************************************************************************************
function private.Init ()

  private.arrow_count =  4;
  private.point       =  1;
  private.moves       = 23;
  private.win_point   = 55;

  private.point_pos =
  {
  --[[   1            2            3            4            5   ]]
    {  60,110 }, {  60,190 }, { 135,190 }, { 135,115 }, { 212,115 }, --[[  1 ]]
    { 212,342 }, { 136,342 }, { 136,264 }, {  60,264 }, {  60,340 }, --[[  2 ]]
    { 212,520 }, { 515,115 }, { 515,265 }, { 590,265 }, { 590,340 }, --[[  3 ]]
    { 516,340 }, { 516,415 }, { 290,415 }, { 290,340 }, { 364,340 }, --[[  4 ]]
    { 364,190 }, { 290,190 }, { 290,264 }, { 440,190 }, { 440,340 }, --[[  5 ]]
    { 290,490 }, { 442,490 }, { 442,520 }, { 590,490 }, { 590,416 }, --[[  6 ]]
    { 665,416 }, { 665,190 }, { 742,190 }, { 742,115 }, { 592,115 }, --[[  7 ]]
    { 592,185 }, { 895,115 }, { 970,115 }, { 970,190 }, { 970,340 }, --[[  8 ]]
    { 895,340 }, { 895,190 }, { 590,525 }, { 665,525 }, { 665,490 }, --[[  9 ]]
    { 744,490 }, { 744,265 }, { 820,265 }, { 820,190 }, { 820,415 }, --[[ 10 ]]
    { 820,490 }, { 820,522 }, { 970,490 }, { 970,415 }, {1060,415 }, --[[ 10 ]]
  };

  private.links =
  {
  --[[     1                2                3                4                5     ]]
    {  0, 0, 2, 0 }, {  1, 3, 0, 0 }, {  4, 0, 0, 2 }, {  0, 5, 3, 0 }, {  0,12, 6, 4 }, --[[  1 ]]
    {  5, 0,11, 7 }, {  8, 6, 0, 0 }, {  0, 0, 7, 9 }, {  0, 8,10, 0 }, {  9, 0, 0, 0 }, --[[  2 ]]
    {  6, 0, 0, 0 }, {  0, 0,13, 5 }, { 12,14, 0, 0 }, {  0, 0,15,13 }, { 14, 0, 0,16 }, --[[  3 ]]
    {  0,15,17, 0 }, { 16, 0, 0,18 }, { 19,17,26, 0 }, {  0,20,18, 0 }, { 21, 0, 0,19 }, --[[  4 ]]
    {  0,24,20,22 }, {  0,21,23, 0 }, { 22, 0, 0, 0 }, {  0, 0,25,21 }, { 24, 0, 0, 0 }, --[[  5 ]]
    { 18,27, 0, 0 }, {  0,29,28,26 }, { 27, 0, 0, 0 }, { 30, 0,43,27 }, {  0,31,29, 0 }, --[[  6 ]]
    { 32, 0, 0,30 }, {  0,33,31, 0 }, { 34, 0, 0,32 }, {  0,37,33,35 }, {  0,34,36, 0 }, --[[  7 ]]
    { 35, 0, 0, 0 }, {  0, 0,42,34 }, {  0, 0,39,37 }, {  0, 0,40,42 }, { 39, 0, 0,41 }, --[[  8 ]]
    { 42,40, 0, 0 }, { 37,39,41, 0 }, { 29,44, 0, 0 }, { 45, 0, 0,43 }, {  0,46,44, 0 }, --[[  9 ]]
    { 47, 0, 0,45 }, {  0,48,46, 0 }, { 49, 0,50,47 }, {  0, 0,48, 0 }, { 48,54,51, 0 }, --[[ 10 ]]
    { 50,53,52, 0 }, { 51, 0, 0, 0 }, { 54, 0, 0,51 }, {  0,55,53,50 }, {  0, 0, 0, 0 }, --[[ 11 ]]
  };

  for r = 1, private.arrow_count do

    ObjSet( "obj_mgcatacomb2_arrow_"..r,
    {
      event_mdown  = function () private.ArrowClick( r ); end,
      event_menter = function () private.MouseEnter( r ); end,
      event_mleave = function () private.MouseLeave( r ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].point =  1;
  ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].moves = 23;

end;
--*********************************************************************************************************************
function private.Load ()

  private.point = ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].point;
  private.moves = ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].moves;

  ObjSet( "obj_mgcatacomb2_point", { pos_x = private.point_pos[ private.point ][ 1 ], pos_y = private.point_pos[ private.point ][ 2 ] } );
  ObjSet( "obj_mgcatacomb2_dark",  { pos_x = private.point_pos[ private.point ][ 1 ], pos_y = private.point_pos[ private.point ][ 2 ] } );

  private.SetInput( true );
  private.UpdateMoves();

end;
--*********************************************************************************************************************
function private.WinAnim()

  int.Lock( true );

  local func_end = function ()

    ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].point = 55;
    ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].moves = 0;

    private.Win();
    int.Lock( false );

  end;

  --cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_win_mmg_lab" );
  
  func_end();

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgcatacomb2" );
  cmn.CallEventHandler( "win_mgcatacomb2" );
  common_impl.PassingMgWin( "mgcatacomb2" );
  cmn.GotoRoom( "rm_neartower2" );

end;
--*********************************************************************************************************************
function private.SetInput ( show )

  for r = 1, private.arrow_count do

    ObjSet( "obj_mgcatacomb2_arrow_"..r, { alp = 0, input = false } );

  end;

  if ( not show ) then

    return;

  end;

  for r = 1, private.arrow_count do

    if ( private.links[ private.point ][ r ] ~= 0 ) then

      ObjSet( "obj_mgcatacomb2_arrow_"..r, { alp = 1, input = true } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.ArrowClick ( idx )

  int.Lock( true );

  private.SetInput();

  local new_point = private.links[ private.point ][ idx ];
  local delta_x = math.abs( private.point_pos[ private.point ][ 1 ] - private.point_pos[ new_point ][ 1 ] );
  local delta_y = math.abs( private.point_pos[ private.point ][ 2 ] - private.point_pos[ new_point ][ 2 ] );
  local delta   = delta_x;

  if ( delta_x < delta_y ) then

    delta = delta_y;

  end

  local tme = delta * 0.006;

  local func_end = function ()

    private.is_move = false;

    int.Lock( false );

    private.point = new_point;
    private.moves = private.moves - 1;

    private.UpdateMoves();

    if ( private.point == private.win_point ) then

      private.WinAnim();

      return;

    end;

    if ( private.moves == 0 ) then

      int.Lock( true );

      ObjAnimate( "obj_mgcatacomb2_point", "scale_x", 0, 0,
      function ()

        public.Reset();

      end,
      {
        0.0, 0, 1.0,
        0.2, 0, 1.0,
      } );

      ObjAnimate( "obj_mgcatacomb2_point", "alp", 0, 0,
      function ()

        int.Lock( false );

      end,
      {
        0.0, 0, 1.0,
        0.2, 0, 0.0,
        0.4, 0, 1.0,
      } );

    else

      ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].point = private.point;
      ng_global.progress[ ng_global.currentprogress ][ "win_mgcatacomb2" ].moves = private.moves;

    end;

    private.SetInput( true );

  end;

  private.is_move = true;

  ObjAnimate( "obj_mgcatacomb2_point", "pos_xy", 0, 0, func_end,
  {
    0.0, 0, private.point_pos[ private.point ][ 1 ], private.point_pos[ private.point ][ 2 ],
    tme, 0, private.point_pos[ new_point ][ 1 ],     private.point_pos[ new_point ][ 2 ],
  } );

  ObjAnimate( "obj_mgcatacomb2_dark", "pos_xy", 0, 0, "",
  {
    0.0, 0, private.point_pos[ private.point ][ 1 ], private.point_pos[ private.point ][ 2 ],
    tme, 0, private.point_pos[ new_point ][ 1 ],     private.point_pos[ new_point ][ 2 ],
  } );

  private.StepsSFX();

end;
--*********************************************************************************************************************
function private.UpdateMoves ()

  local alp = 1 / 23 * private.moves;

  ObjSet( "txt_mgcatacomb2_counter_count", { text = private.moves } );
  ObjSet( "spr_mgcatacomb2_counter_light", { alp = alp } );

end;
--*********************************************************************************************************************
function private.MouseEnter ( idx )

  ObjSet( "spr_mgcatacomb2_arrow_"..idx.."_light", { alp = 1 } );
  cmn.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.MouseLeave ( idx )

  ObjSet( "spr_mgcatacomb2_arrow_"..idx.."_light", { alp = 0 } );
  cmn.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.StepsSFX ()

  if ( not private.is_move ) then

    return;

  end;

  local sfx = math.random( 1,8 );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcatacomb2_step_"..sfx );

  local func_end = function ()

    private.StepsSFX();

  end;

  ObjSet( "tmr_mgcatacomb2_steps", { time = 0.35, playing = true, endtrig = func_end } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************