-- name=mg_mgcreatingacid2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgcreatingacid2";
  game.relations[ "mg_mgcreatingacid2" ].exitroom = "rm_workshop2";

  private.Init();

  ObjSet( "spr_mgcreatingacid2_acid2", { event_mdown = private.get_acid2 } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgcreatingacid2 = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgcreatingacid2", update_game_mode_mgcreatingacid2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mgcreatingacid2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgcreatingacid2" ] =
  {
    type = "click",
    get_obj = "spr_mgcreatingacid2_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgcreatingacid2 = function ()

    if ( cmn.IsEventDone( "win_mgcreatingacid2" ) ) then

      --int.DeleteTaskMap( "rm_", "win_mgcreatingacid2" );
      ObjSet( "spr_mgcreatingacid2_acid2", { input = true } );
      ObjSet( "gfx_mgcreatingacid2_acid2", { active = true } );
      ObjSet( "obj_mgcreatingacid2_buttons", { input = false } );
      ObjSet( "anm_mgcreatingacid2_acid",  { alp = 1, frame = 339, animfunc = "DoAnim" } );

    end;
    if ( cmn.IsEventStart( "win_mgcreatingacid2" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgcreatingacid2", win_mgcreatingacid2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_acid2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_acid2" ] =
  {
    type = "get",
    get_obj = "spr_mgcreatingacid2_acid2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local get_acid2_inv = function ()

    int.InventoryItemAdd( "inv_acid2", "spr_mgcreatingacid2_acid2" );

  end;
  local get_acid2_closezz = function ()

    ObjDelete( "spr_mgcreatingacid2_acid_refl" );
    ObjDelete( "spr_mgcreatingacid2_acid2_shadow" );
    ObjDelete( "gfx_mgcreatingacid2_acid2" );
    ObjDelete( "anm_mgcreatingacid2_acid" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_acid2", get_acid2_inv );
  cmn.AddSubscriber( "get_acid2", get_acid2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_mgcreatingacid2 () end;
  --------------------------------------------------------------------------------------------
  local opn_mgcreatingacid2 = function ()

    ObjSet( "anm_mgcreatingacid2_vitriol_start", { alp = 1, frame = 151, animfunc = "DoAnim" } );
    ObjSet( "anm_mgcreatingacid2_water_start",   { alp = 1, frame = 153, animfunc = "DoAnim" } );
    ObjSet( "anm_mgcreatingacid2_static",        { playing = true, animfunc = "DoAnim" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_mgcreatingacid2", opn_mgcreatingacid2, private.room_objname );

end;
-----------------------------------------------------------------------
function private.get_acid2 ()

  ObjSet( "spr_mgcreatingacid2_acid", { alp = 1 } );
  cmn.SetEventDone( "get_acid2" );
  cmn.CallEventHandler( "get_acid2" );
  cmn.GetObjectSfx();
  cmn.GotoRoom( "rm_workshop2" );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mgcreatingacid2" ) ) then

    private.Start();

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventDone( "opn_mgcreatingacid2" ) ) then

    local func_end = function ()

      int.Lock( false );

      cmn.SetEventDone( "opn_mgcreatingacid2" );
      cmn.CallEventHandler( "opn_mgcreatingacid2" );

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_loop_bubles", 1 );

    end;

    int.Lock( true );

    AnimPlay( "anm_mgcreatingacid2_vitriol_start", "DoAnim", function ()

      AnimPlay( "anm_mgcreatingacid2_water_start", "DoAnim", func_end );

    end );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_green_dust" );

  else

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_loop_bubles", 1 );

  end;

  if ( not cmn.IsEventDone( "win_mgcreatingacid2" ) ) then

    cmn.MiniGameShow( "mgcreatingacid2" );
    common_impl.PassingMgStart( "mgcreatingacid2" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "mgcreatingacid2" );

  cmn.StopAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_loop_bubles" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ ng_global.currentprogress ][ "win_mgcreatingacid2" ].angs = { 3,-4 };

  private.Load();

end;
--*********************************************************************************************************************
function public.Skip ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    private.WinAnim();

  end;

  for c = 1, private.count do

    local ang_1 = ( private.angs[ c ] ) * private.delta;
    local ang_2 = 0;

    ObjAnimate( "spr_mgcreatingacid2_arrow_"..c, "ang", 0, 0, func_end,
    {
      0.0, 3, ang_1,
      1.5, 3, ang_2,
    } );

    func_end = "";

  end;

end;
--*********************************************************************************************************************
function private.Init ()

  private.count = 2;
  private.delta = 0.523;
  private.angs  = { 3,-4 };
  private.array_pos = { { 2,-1 }, { -1,1 } };

  for c = 1, private.count do

    ObjSet( "obj_mgcreatingacid2_button_"..c,
    {
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      event_mdown  = function () private.ButtonClick( c ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgcreatingacid2" ].angs = { 3,-4 };

end;
--*********************************************************************************************************************
function private.Load ()

  for c = 1, private.count do

    private.angs[ c ] = ng_global.progress[ ng_global.currentprogress ][ "win_mgcreatingacid2" ].angs[ c ];

    local ang = private.angs[ c ] * private.delta;

    ObjSet( "spr_mgcreatingacid2_arrow_"..c, { ang = ang } );

  end;

end;
--*********************************************************************************************************************
function private.WinAnim()

  local func_end = function ()

    ng_global.progress[ ng_global.currentprogress ][ "win_mgcreatingacid2" ].angs = { 0,0 };
    int.Lock( false );
    private.Win();

  end;

  int.Lock( true );

  ObjSet( "anm_mgcreatingacid2_acid", { alp = 1 } );
  AnimPlay( "anm_mgcreatingacid2_acid", "DoAnim", func_end );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_win" );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgcreatingacid2" );
  cmn.CallEventHandler( "win_mgcreatingacid2" );
  common_impl.PassingMgWin( "mgcreatingacid2" );
  cmn.ShowBbt( "bbt_mgcreatingacid2_after_win" );

end;
--*********************************************************************************************************************
function private.IsWin ()

  for c = 1, private.count do

    if ( private.angs[ c ] ~= 0 ) then

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.ButtonClick ( idx )

  local func_end = function ()

    int.Lock( false );

    for c = 1, private.count do

      private.angs[ c ] = private.angs[ c ] + private.array_pos[ idx ][ c ];

      if ( private.angs[ c ] >= 13.9 ) then

        private.angs[ c ] = 2;

      elseif ( private.angs[ c ] >= 12.9 ) then

        private.angs[ c ] = 1;

      elseif ( private.angs[ c ] >= 11.9 ) then

        private.angs[ c ] = 0;

      elseif ( private.angs[ c ] <= -13.9 ) then

        private.angs[ c ] = -2;

      elseif ( private.angs[ c ] <= -12.9 ) then

        private.angs[ c ] = -1;

      elseif ( private.angs[ c ] <= -11.9 ) then

        private.angs[ c ] = 0;

      end;

      ObjSet( "spr_mgcreatingacid2_arrow_"..c, { ang = private.angs[ c ] * private.delta } );

    end;

    if ( private.IsWin() ) then

      private.WinAnim();

    else

      private.SaveProgress();

    end;

  end;

  int.Lock( true );

  for c = 1, private.count do

    local ang_1 = ( private.angs[ c ] ) * private.delta;
    local ang_2 = ( private.angs[ c ] + private.array_pos[ idx ][ c ] ) * private.delta;

    ObjAnimate( "spr_mgcreatingacid2_arrow_"..c, "ang", 0, 0, func_end,
    {
      0.0, 3, ang_1,
      0.5, 3, ang_2,
    } );

    func_end = "";

  end;

  AnimPlay( "anm_mgcreatingacid2_button_"..idx.."_click", "DoAnim", "" );

  if ( idx == 1 ) then

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_click_right" );

  else

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_click_left" );

  end;

end;
--*********************************************************************************************************************
function private.SaveProgress ()

  for c = 1, private.count do

    ng_global.progress[ ng_global.currentprogress ][ "win_mgcreatingacid2" ].angs[ c ] = private.angs[ c ];

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************