-- name=mg_mglock2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mglock2";
  game.relations[ "mg_mglock2" ].exitroom = "rm_neartower2";

  private.Init();
  private.Animations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mglock2 = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mglock2", update_game_mode_mglock2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mglock2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mglock2" ] =
  {
    type = "click",
    get_obj = "spr_mglock2_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mglock2 = function ()

    if ( cmn.IsEventDone( "win_mglock2" ) ) then

      --int.DeleteTaskMap( "rm_", "win_mglock2" );

    elseif ( cmn.IsEventStart( "win_mglock2" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mglock2", win_mglock2, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mglock2" ) ) then

    private.Start();

  end;
  
  if ( cmn.IsEventDone( "win_mglock2" ) ) then
    
    ObjSet( "mg_mglock2", { color_r = 0, color_g = 0, color_b = 0 } );
    
  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventDone( "win_mglock2" ) ) then

    cmn.MiniGameShow( "mglock2" );
    common_impl.PassingMgStart( "mglock2" );
    common_impl.StopMusEnv( false );
    cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 1 );

  else
        
    local func_end = function ()
      
      cmn.GotoRoom( "rm_neartower2" );  
      
    end;    
    private.VidOutro2Lvl( func_end );            

  end;

end;
--*********************************************************************************************************************
function private.VidOutro2Lvl ( func_end )

  local func_end = function ( skip )
   
    int.Lock( false );
    ObjSet("mg_mglock2",{ color_r = 0, color_g = 0, color_b = 0 });
    
    
    if ( skip ) then
      
      cmn.StopAudio( "sfx", "audio/level2/mus/aud_vid_mglock2_outro_mus" );
      cmn.StopAudio( "voc", "audio/level2/voc/aud_lvl2_outro_voc" );
      
    end;
    func_end();
    common_impl.InterfaceSetVisible( true );
    
   end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_mglock2_outro", func_end );  
  
  
  cmn.PlayAudio( "sfx", "audio/level2/mus/aud_vid_mglock2_outro_mus", nil, nil, 24 );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_lvl2_outro_voc" );
  cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()
  
  if ( not cmn.IsEventDone( "win_mglock2" ) ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop( "mglock2" );    
    cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 0.5 );

  end;

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PlayMusEnv();
  
end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items = { 4,1,2,6,5,3 };

  private.Load();

end;
--*********************************************************************************************************************
function public.Skip ()

  private.WinAnim();

end;
--*********************************************************************************************************************
function private.Init ()

  private.ang_delta = 2.093;
  private.items_count = 6;
  private.items_links = { { 1,2,4 }, { 2,3,5 }, { 4,5,6 } };
  private.items = { 4,1,2,6,5,3 };
  private.res_pos = { { 6,6 },{ 4,4 },{ 4,4 },{ 0,8 },{ 30,0 },{ 10,6 } };
  private.items_pos =
  {
    {
      { { 306,510 }, { 350,550 }, { 408,565 }, { 465,554 }, { 513,517 } },
      { { 513,517 }, { 542,445 }, { 526,373 }, { 474,321 }, { 391,307 } },
      { { 391,307 }, { 328,336 }, { 291,389 }, { 283,451 }, { 306,510 } },
    },
    {
      { { 513,517 }, { 562,554 }, { 621,564 }, { 667,548 }, { 720,510 } },
      { { 720,510 }, { 743,450 }, { 736,390 }, { 698,337 }, { 634,307 } },
      { { 634,307 }, { 554,319 }, { 502,370 }, { 484,442 }, { 513,517 } },
    },
    {
      { { 391,307 }, { 440,369 }, { 514,390 }, { 585,367 }, { 634,307 } },
      { { 634,307 }, { 640,242 }, { 618,185 }, { 573,146 }, { 510,130 } },
      { { 510,130 }, { 448,148 }, { 405,188 }, { 383,246 }, { 391,307 } },
    },
  };

  for c = 1, 3 do

    ObjSet( "obj_mglock2_button_"..c,
    {
      event_mdown  = function () private.ItemClick( c ) end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items = { 4,1,2,6,5,3 };
  ng_global.progress[ private.currentprogress ][ "win_mglock2" ].ang = { 0,0,0 };

end;
--*********************************************************************************************************************
function private.Load ()

  for c = 1, private.items_count do

    local item = ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items[ c ];

    ObjSet( "spr_mglock2_item_"..c,
    {
      pos_x = private.res_pos[ item ][ 1 ],
      pos_y = private.res_pos[ item ][ 2 ],
      res = "assets/levels/level2/mg_mglock2/layers/item_"..item
    } );

    private.items[ c ] = item;

  end;

  for b = 1, 3 do

    local ang = ng_global.progress[ private.currentprogress ][ "win_mglock2" ].ang[ b ];
    ObjSet( "spr_mglock2_button_"..b, { ang = ang * private.ang_delta } );

  end;

  private.ItemSetLight();

end;
--*********************************************************************************************************************
function private.WinAnim()

  int.Lock( true );

  local func_end = function ()

    private.Win();
    int.Lock( false );

  end;

  func_end();

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mglock2_win" );

end;
--*********************************************************************************************************************
function private.Win ()
    
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mglock2" );
  cmn.CallEventHandler( "win_mglock2" );
  common_impl.PassingMgWin( "mglock2" );
  
  local func_end = function ()
    
    cmn.GotoRoom( "rm_neartower2" );  
    
  end;  
  
  private.VidOutro2Lvl( func_end );        

end;
--*********************************************************************************************************************
function private.ItemSetLight ()    

  local win_items = { 1,2,3,4,5,6 };

  for c = 1, private.items_count do

    local item = private.items[ c ];

    ObjSet( "spr_mglock2_item_light_"..c, { alp = 0 } );

    if ( item == win_items[ c ] ) then        

      ObjSet( "spr_mglock2_item_light_"..c, { alp = 1 } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.ItemClick ( btn )

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mglock2_click" );

  AnimPlay( "anm_mglock2_gears", "DoAnim", "" );

  int.Lock( true );

  local ang_1 = ng_global.progress[ private.currentprogress ][ "win_mglock2" ].ang[ btn ];
  local ang_2 = ang_1 + 1;

  ObjAnimate( "spr_mglock2_button_"..btn, "ang", 0, 0, "",
  {
    0.00, 0, ang_1 * private.ang_delta,
    0.60, 0, ang_2 * private.ang_delta,
  } );

  local links = private.items_links[ btn ];
  local pos = private.items_pos[ btn ];

  local func_end = function ()

    int.Lock( false );

    private.items[ links[ 1 ] ] = ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items[ links[ 3 ] ];
    private.items[ links[ 2 ] ] = ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items[ links[ 1 ] ];
    private.items[ links[ 3 ] ] = ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items[ links[ 2 ] ];

    ObjSet( "obj_mglock2_item_"..links[ 1 ], { pos_x = pos[ 1 ][ 1 ][ 1 ], pos_y = pos[ 1 ][ 1 ][ 2 ] } );
    ObjSet( "obj_mglock2_item_"..links[ 2 ], { pos_x = pos[ 2 ][ 1 ][ 1 ], pos_y = pos[ 2 ][ 1 ][ 2 ] } );
    ObjSet( "obj_mglock2_item_"..links[ 3 ], { pos_x = pos[ 3 ][ 1 ][ 1 ], pos_y = pos[ 3 ][ 1 ][ 2 ] } );

    ObjSet( "spr_mglock2_item_"..links[ 1 ], { res = "assets/levels/level2/mg_mglock2/layers/item_"..private.items[ links[ 1 ] ] } );
    ObjSet( "spr_mglock2_item_"..links[ 2 ], { res = "assets/levels/level2/mg_mglock2/layers/item_"..private.items[ links[ 2 ] ] } );
    ObjSet( "spr_mglock2_item_"..links[ 3 ], { res = "assets/levels/level2/mg_mglock2/layers/item_"..private.items[ links[ 3 ] ] } );

    ObjSet( "spr_mglock2_item_"..links[ 1 ], { pos_x = private.res_pos[ private.items[ links[ 1 ] ] ][ 1 ], pos_y = private.res_pos[ private.items[ links[ 1 ] ] ][ 2 ] } );
    ObjSet( "spr_mglock2_item_"..links[ 2 ], { pos_x = private.res_pos[ private.items[ links[ 2 ] ] ][ 1 ], pos_y = private.res_pos[ private.items[ links[ 2 ] ] ][ 2 ] } );
    ObjSet( "spr_mglock2_item_"..links[ 3 ], { pos_x = private.res_pos[ private.items[ links[ 3 ] ] ][ 1 ], pos_y = private.res_pos[ private.items[ links[ 3 ] ] ][ 2 ] } );

    private.ItemSetLight();

    if ( private.IsWin( btn ) ) then

      private.WinAnim();

    else

      if ( ang_2 == 3 ) then ang_2 = 0; end;
      ng_global.progress[ private.currentprogress ][ "win_mglock2" ].ang[ btn ] = ang_2;

    end;

  end;

  ObjAnimate( "obj_mglock2_item_"..links[ 1 ], "pos_xy", 0, 0, "",
  {
    0.00, 0, pos[ 1 ][ 1 ][ 1 ], pos[ 1 ][ 1 ][ 2 ],
    0.15, 0, pos[ 1 ][ 2 ][ 1 ], pos[ 1 ][ 2 ][ 2 ],
    0.30, 0, pos[ 1 ][ 3 ][ 1 ], pos[ 1 ][ 3 ][ 2 ],
    0.45, 0, pos[ 1 ][ 4 ][ 1 ], pos[ 1 ][ 4 ][ 2 ],
    0.60, 0, pos[ 1 ][ 5 ][ 1 ], pos[ 1 ][ 5 ][ 2 ],
  } );

  ObjAnimate( "obj_mglock2_item_"..links[ 2 ], "pos_xy", 0, 0, "",
  {
    0.00, 0, pos[ 2 ][ 1 ][ 1 ], pos[ 2 ][ 1 ][ 2 ],
    0.15, 0, pos[ 2 ][ 2 ][ 1 ], pos[ 2 ][ 2 ][ 2 ],
    0.30, 0, pos[ 2 ][ 3 ][ 1 ], pos[ 2 ][ 3 ][ 2 ],
    0.45, 0, pos[ 2 ][ 4 ][ 1 ], pos[ 2 ][ 4 ][ 2 ],
    0.60, 0, pos[ 2 ][ 5 ][ 1 ], pos[ 2 ][ 5 ][ 2 ],
  } );

  ObjAnimate( "obj_mglock2_item_"..links[ 3 ], "pos_xy", 0, 0, func_end,
  {
    0.00, 0, pos[ 3 ][ 1 ][ 1 ], pos[ 3 ][ 1 ][ 2 ],
    0.15, 0, pos[ 3 ][ 2 ][ 1 ], pos[ 3 ][ 2 ][ 2 ],
    0.30, 0, pos[ 3 ][ 3 ][ 1 ], pos[ 3 ][ 3 ][ 2 ],
    0.45, 0, pos[ 3 ][ 4 ][ 1 ], pos[ 3 ][ 4 ][ 2 ],
    0.60, 0, pos[ 3 ][ 5 ][ 1 ], pos[ 3 ][ 5 ][ 2 ],
  } );

end;
--*********************************************************************************************************************
function private.IsWin ( btn )

  local win_items = { 1,2,3,4,5,6 };

  for c = 1, private.items_count do

    local item = private.items[ c ];

    if ( item ~= win_items[ c ] ) then

      local links = private.items_links[ btn ];

      ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items[ links[ 1 ] ] = private.items[ links[ 1 ] ];
      ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items[ links[ 2 ] ] = private.items[ links[ 2 ] ];
      ng_global.progress[ private.currentprogress ][ "win_mglock2" ].items[ links[ 3 ] ] = private.items[ links[ 3 ] ];

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.Animations ()

  ObjAnimate( "spr_mglock2_button_1_light", "alp", 1, 0, "",
  {
    0.0, 3, 0.2,
    2.3, 3, 1.0,
    4.6, 3, 0.2,
  } );

  ObjAnimate( "spr_mglock2_button_2_light", "alp", 1, 0, "",
  {
    0.0, 3, 0.9,
    3.5, 3, 0.5,
    7.0, 3, 0.9,
  } );

  ObjAnimate( "spr_mglock2_button_3_light", "alp", 1, 0, "",
  {
    0.0, 3, 0.4,
    2.8, 3, 1.0,
    5.6, 3, 0.4,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************