-- name=level2
--*********************************************************************************************************************
function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );
  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );
  int.WidgetAdd( InterfaceWidget_BtnHint, 9 );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );
  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );
  int.WidgetAdd( InterfaceWidget_Effects, 24 );
  int.WidgetAdd( InterfaceWidget_BtnMap, 11 );
  int.WidgetAdd( InterfaceWidget_DialogHo );
  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );
  int.WidgetAdd( InterfaceWidget_Popup, 31 );
  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog, 22 );
  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );
  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );
  int.WidgetAdd( InterfaceWidget_Tutorial, 20 );
  int.WidgetAdd( InterfaceWidget_Map, 24 );

  int.ButtonLockAdd();
  int.PanelNotificationAdd();
  int.DeployInvAdd( 9 );
  int.DialogHintAdd( 10 );
  
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 ); 
  int.InitLoupe( 20 );

  --
  private.Init();
  ModLoad( "assets/levels/level2/mod_level2_inv" );
  level2_inv.Init();
  --

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.WidgetAdd( InterfaceWidget_BtnGuide, 8 );  
    interface.AchievementsAdd( 10 );
    int.MorphingAdd( 10 );
    int.CollectiblesAdd( 20 );
    int.Collectibles2Add( 22 );
    int.ScreensaverAdd(11);        

  end;

  common.LevelLoad( "level2", "std", "rm_prison2", param, private.menu_moduls );

  private.TutorialSetParams();
  interface.KeyUpdate();

  local collectibles = 
  {
     "get_collect_2_1"
    ,"get_collect_2_2"
    ,"get_collect_2_3"
  };
  local collect_morph = 
  {
     "get_morphobject_2_1"
    ,"get_morphobject_2_2"
    ,"get_morphobject_2_3"
    ,"get_morphobject_2_4"
    ,"get_morphobject_2_5"
    ,"get_morphobject_2_6"
  };   
  local screen_s = 
  {
     "screensaver_2_1"
     ,"screensaver_2_2"
     ,"screensaver_2_3"
     ,"screensaver_2_4"
     ,"screensaver_2_5"
     ,"screensaver_2_6"
     ,"screensaver_2_7"
     ,"screensaver_2_8"
     ,"screensaver_2_9"
     ,"screensaver_2_10"
     ,"screensaver_2_11" 
     ,"screensaver_2_12"       
  };  
  
  if ( not IsCollectorsEdition() and not IsSurveyEdition() ) then

    ObjSet( "btn_map_button_diary", { pos_x = 10 } );
    ObjSet( "btn_map_button_collectibles", { visible = 0, active = 0, input = 0  } );
    ObjSet( "btn_map_button_achievements", { visible = 0, active = 0, input = 0  } );        

    for i = 1, #collectibles do

      cmn.SetEventDone( collectibles[ i ] );
      cmn.CallEventHandler( collectibles[ i ] );

    end;
    for i = 1, #collect_morph do

      cmn.SetEventDone( collect_morph[ i ] );
      cmn.CallEventHandler( collect_morph[ i ] );

    end;
    for i = 1, #screen_s do

      cmn.SetEventDone( "get_"..screen_s[ i ] );
      cmn.CallEventHandler( "get_"..screen_s[ i ] );

    end; 
    
  else
    
    for i = 1, #collectibles do

      if ( ng_global.collect[ collectibles[ i ] ] ~= nil ) then
          if ( ng_global.collect[ collectibles[ i ] ].done == 1 ) then

            cmn.SetEventDone( "get_"..collectibles[ i ] );
            cmn.CallEventHandler( "get_"..collectibles[ i ] );

          end;
      end;

    end; 
    for i = 1, #collect_morph do

      if ( ng_global.morphings[ collect_morph[ i ] ] ~= nil ) then
          if ( ng_global.morphings[ collect_morph[ i ] ].done == 1 ) then

            cmn.SetEventDone( collect_morph[ i ] );
            cmn.CallEventHandler( collect_morph[ i ] );

          end;
      end;

    end;       
    for i = 1, #screen_s do

      if ( ng_global.screensaver[ screen_s[ i ] ] ~= nil ) then
          if ( ng_global.screensaver[ screen_s[ i ] ].done == 1 ) then

            cmn.SetEventDone( "get_"..screen_s[ i ] );
            cmn.CallEventHandler( "get_"..screen_s[ i ] );

          end;
      end;

    end;       
    
  end;

end;
--*********************************************************************************************************************
function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_prison2"
    ,"rm_alley2"
    ,"rm_abighalehouse2"
    ,"rm_neartower2"
    ,"mg_mgdescent2"
    ,"ho_hoskeleton2"
    ,"mg_mgcatacomb2"
    ,"rm_shore2"
    ,"rm_workshop2"
    ,"ho_hosecretsection2"
    ,"mg_mglock2"
    ,"mg_mgcreatingacid2"
    ,"ho_hocupboard2"
    ,"ho_hopast2"
  };

  game.progress_names =
  {
   "get_oil2"
  ,"beg_level2"
  ,"opn_prison2"  
  ,"dlg_prison2_richard2_1"
  ,"get_ravenamulet2"
  ,"get_flint2_2"  
  ,"get_shard2"  
  ,"get_bread2"
  ,"get_stump2"  
  ,"use_shard2"
  ,"get_duster2"
  ,"use_oil2"
  ,"clk_torturechamber2_handle"
  ,"get_file2"
  ,"use_duster2"
  ,"get_wetduster2"
  ,"use_file2_2"
  ,"get_flint2_1"  
  ,"use_flint2"
  ,"get_lamp2"
  ,"use_lamp2"
  ,"win_hoskeleton2"--,"get_hook2"   
  ,"use_file2_1"
  ,"get_bonehandamulet2"
  ,"use_ravenamulet2"
  ,"use_bonehandamulet2"
  ,"get_staff2"
  ,"use_wetduster2"
  ,"use_staff2"
  ,"use_bread2"
  ,"get_batamulet2"
  ,"use_batamulet2"
  ,"get_rope2"
  ,"use_hook2"
  ,"get_selfmadecat2"
  ,"use_selfmadecat2"
  ,"win_mgdescent2"
  
  ,"opn_alley2"  
  ,"dlg_alley2_beggar2_1"
  ,"get_brick2"
  ,"get_crowbar2"  
  ,"get_pole2"
  ,"get_pipe2"
  ,"get_milk2"
  ,"use_milk2"
  ,"dlg_alley2_beggar2_2"
  ,"get_lighter2"
  ,"get_saw2"
  ,"use_crowbar2"
  ,"get_emptysmoker2"
  ,"use_saw2"
  ,"get_rottenwood2"
  ,"use_pipe2"
  ,"clk_emptysmoker2_door_1"
  ,"use_rottenwood2"
  ,"use_lighter2"
  ,"clk_emptysmoker2_door_2"
  ,"get_smoker2"
  ,"use_pole2"
  ,"get_pikepole2"
  ,"use_smoker2"
  ,"use_pikepole2"
  ,"get_homekey2"
  ,"get_streetlamp2"
  ,"use_homekey2"
  
  ,"opn_abighalehouse2"
  ,"dlg_abighalehouse2_richard2_2"
  ,"get_featheramulet2"
  ,"get_scrollamulet2"
  ,"get_paperknife2"
  ,"use_scrollamulet2"
  ,"use_featheramulet2"
  ,"get_key2_1"
  ,"get_keypiece2_1"  
  ,"get_owlamulet2_1"
  ,"get_cleaningagent2"
  ,"get_key2_2"
  ,"get_decanter2"
  ,"use_paperknife2_1"
  ,"get_owlamulet2_2"
  ,"use_brick2"
  ,"get_eyeamulet2"  
  ,"use_decanter2"
  ,"clk_parkentrance2_handle"
  ,"get_decanterwater2"
  ,"use_decanterwater2"
  ,"get_owlamulet2_3"
  ,"use_owlamulet2"
  ,"get_musicnotes2"
  ,"use_key2"
  ,"use_musicnotes2"
  ,"win_piano2"
  ,"get_signet2"
  ,"use_signet2"
  ,"win_hosecretsection2"--,"get_envelope2"
  ,"use_paperknife2_2"
  ,"get_lockpicks2"
  ,"use_lockpicks2"
  ,"get_pyramidamulet2"
  ,"use_pyramidamulet2"
  ,"use_eyeamulet2"
  ,"use_streetlamp2"
  ,"win_mgcatacomb2"
  
  ,"opn_neartower2"
  ,"dlg_neartower2_richard2_3"
  ,"get_spiralamulet2"

  ,"use_spiralamulet2_1"
  ,"get_temporaryecho2_1"
  
  ,"get_mosaicpart2"
  ,"get_figurine2"
  ,"use_figurine2"
  ,"get_handle2"
  ,"get_boltcutter2"
  ,"use_handle2"
  ,"get_axe2"
  ,"use_axe2"
  ,"opn_workshop2"
  
  ,"get_tweezers2"  
  ,"get_mitts2"
  ,"get_bucket2"
  ,"use_mosaicpart2"
  ,"win_foundry2"
  ,"get_blacksmithamulet2_1"
  ,"get_crucible2"  
  ,"use_boltcutter2"
  ,"get_chain2"
  ,"get_cometamulet2"
  ,"get_scissors2"
  ,"use_chain2"
  ,"use_bucket2"
  ,"get_talisman2"  
  ,"use_cleaningagent2"
  ,"get_recipe2"
  ,"use_mitts2"
  ,"win_hocupboard2" --,"get_vessel2"  
  ,"use_scissors2"
  
  ,"opn_shore2"
  ,"use_spiralamulet2_2"
  ,"get_temporaryecho2_2" 
  ,"get_dipnet2"  
  ,"get_brokenlamp2"  
  ,"get_snakesamulet2_1"  
  ,"use_spiralamulet2_3"
  ,"get_temporaryecho2_3"
  ,"use_dipnet2"
  ,"get_snakesamulet2_2"  
  ,"use_snakesamulet2"
  ,"get_phial2"
  ,"get_tongs2"
  ,"use_phial2"
  ,"get_copperas2"
  ,"use_tongs2"
  ,"get_pigeonamulet2"
  ,"use_pigeonamulet2"
  ,"get_ring2_1"
  ,"use_tweezers2"
  ,"get_keypiece2_2"
  ,"use_keypiece2"
  ,"clk_foundry2_handle_1"
  ,"get_wholekey2"
  ,"use_wholekey2"
  ,"get_brokenamulet2"

  ,"use_recipe2"
  ,"use_copperas2"
  ,"clk_vessel2"
  ,"use_vessel2"
  ,"opn_mgcreatingacid2"
  ,"win_mgcreatingacid2"
  ,"get_acid2"
  ,"use_acid2"
  ,"clk_worktable2_note2"
  ,"get_ring2_2"
  ,"get_blacksmithamulet2_2"

  ,"dlg_workshop2_richard2_4"
  ,"get_magicprism2"
  ,"use_blacksmithamulet2"
  ,"get_dagger2"  
  ,"use_dagger2"
  ,"get_staramulet2"  
  ,"get_astronomycircle2"  
  ,"use_astronomycircle2"
  ,"win_precipice2"
  ,"get_sunamulet2"  
  ,"clk_brokenlamp2"
  ,"use_magicprism2"
  ,"get_magiclamp2"
  ,"use_magiclamp2"
  ,"get_medallion2"
  ,"use_spiralamulet2_4"
  ,"get_temporaryecho2_4"
  ,"use_ring2"
  ,"use_medallion2"
  ,"get_lock2"

  ,"use_lock2"
  ,"use_talisman2"
  ,"use_temporaryecho2"
  ,"win_altar2"
  ,"win_hopast2" --,"get_tinamulet2"
  ,"dlg_shore2_richard2_5"
  ,"get_halfmoonamulet2"

  ,"use_crucible2"
  ,"use_tinamulet2"
  ,"clk_foundry2_handle_2"
  ,"get_meltedtin2"
  ,"use_brokenamulet2"
  ,"use_meltedtin2"
  ,"get_planetamulet2"



  ,"use_planetamulet2"
  ,"use_cometamulet2"
  ,"use_staramulet2"
  ,"use_sunamulet2"
  ,"use_halfmoonamulet2"
  ,"win_mglock2" 

  ,"opn_hocupboard2"
  ,"opn_hopast2"
  ,"opn_hosecretsection2"
  ,"opn_hoskeleton2"
  ,"opn_mgcatacomb2"
  ,"opn_mgdescent2"
  ,"opn_mglock2"

  
  ,"get_morphobject_2_1"
  ,"get_morphobject_2_2"
  ,"get_morphobject_2_3"
  ,"get_morphobject_2_4"
  ,"get_morphobject_2_5"
  ,"get_morphobject_2_6"

  ,"get_collect_2_1"
  ,"get_collect_2_2"
  ,"get_collect_2_3"

  ,"get_screensaver_2_1"
  ,"get_screensaver_2_2"
  ,"get_screensaver_2_3"
  ,"get_screensaver_2_4"
  ,"get_screensaver_2_5"
  ,"get_screensaver_2_6"
  ,"get_screensaver_2_7"
  ,"get_screensaver_2_8"
  ,"get_screensaver_2_9"
  ,"get_screensaver_2_10"
  ,"get_screensaver_2_11" 
  ,"get_screensaver_2_12"      
  
  };

  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {

      "rm_collectibles",
      "rm_achievements",
    };

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;
--*********************************************************************************************************************
function private.TutorialSetParams()

  if not ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ] then

    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ] = {};
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].start = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state = {};
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.no = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.currentpage = "tutorial_start";
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].func = function() end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );

    end;

    ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_start" ]  = { shown = 0, noskip = true,  posx = 512, posy = 384, input = true,  arrows = {} },       -- Показать туториал?

      [ "tutorial_page_1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 840, pos_y = 500, ang = 3.14 }
                                                                            } },                                        -- Открытие ЗЗ
      [ "tutorial_page_2" ]  = { shown = 0, noskip = false, posx = 512, posy = 170, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "spr_bushes1_ladybag1" }
                                                                            } },                                        -- Подбор предмета
      [ "tutorial_page_3" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "spr_int_inventory" }
                                                                              --{ pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_ladybag" }
                                                                            } },                                        -- Инвентарь, cложный инвентарный
      [ "tutorial_page_4" ]  = { shown = 0, noskip = false, posx = 512, posy = 150, input = false, arrows = {
                                                                              --{ pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_ladybag" }
                                                                            } },                                        -- Сложный инвентарный
      [ "tutorial_page_5" ]  = { shown = 0, noskip = false, posx = 512, posy = 150, input = false, arrows = {
                                                                              { pos_x = 20, pos_y = -80, ang = 3.14, target = "gzz_greywitchgates1_van1" },
                                                                              { pos_x = -80, pos_y = 30, ang = -1.57, target = "gzz_greywitchgates1_gates1" }
                                                                            } },                                        -- Подбор предметов
      [ "tutorial_page_6" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_ladybag1" },
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_bagamulet1" },
                                                                            } },                                        -- применение предмета
      [ "tutorial_page_7" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 60, pos_y = 0, ang = 1.57, target = "gho_greywitchgates1_hovan1" },
                                                                            } },                                        -- переход в ХО
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 400, posy = 200, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = 80, ang = 0.00, target = "grm_greywitchgates1_ruinedsquare1" }
                                                                            } },                                        -- Переход в локацию
      [ "tutorial_ho1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО с войсами
      [ "tutorial_ho2" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО обычное
      [ "tutorial_ho3" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО с силуэтами
      [ "tutorial_ho4" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО парами
      [ "tutorial_minigame" ]  = { shown = 0, noskip = false, posx = 512, posy = 330, input = false, arrows = { 
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_info" },
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_reset" },
                                                                              { pos_x = 100, pos_y = -50, ang = -4,     target = "int_button_skip_impl" }
                                                                            } },                                        -- Кнопка Инфо в МГ
      [ "tutorial_map_1" ] = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = -60, pos_y = -100, ang = 3.925, target = "int_button_map_impl" }
                                                                            } },                                        -- Карта
      [ "tutorial_map_2" ] = { shown = 0, noskip = false, posx = 600, posy = 200, input = false, arrows = {
                                                                              { pos_x = 300, pos_y = 320, ang = 2.355 }
                                                                            } },                                        -- Переход в локацию по карте
      [ "tutorial_achievements" ] = { shown = 0, noskip = false, posx = 512, posy = 280, input = false, arrows = {
                                                                              --{ pos_x = 80, pos_y = 60, ang = 0, target = "obj_int_achievements" },
                                                                            } },                                        -- Ачивки
      [ "tutorial_collectibles" ] = { shown = 0, noskip = false, posx = 512, posy = 280, input = false, arrows = {
                                                                              --{ pos_x = 80, pos_y = 60, ang = 0, target = "obj_int_collectibles" },
                                                                            } },                                        -- Коллектиблз
      [ "tutorial_loupe" ] = { shown = 0, noskip = true,  posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_mentalmagnifier1" },
                                                                            } },                                      -- Поиск линзой
      [ "tutorial_hint" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 100, pos_y = -50, ang = -4, target = "obj_int_button_hint" },
                                                                            } },                                      -- Хинт
      --[ "tutorial_page_20" ] = { shown = 0, noskip = true,  posx = 512, posy = 280, input = false, arrows = {
      --                                                                        { pos_x = 0, pos_y = -80, ang = 3.14, target = "obj_int_button_ability" }
      --                                                                        } },                                    -- Абилка

    };

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************