-- name=level2_inv
--*********************************************************************************************************************
function public.Init ()

  int.CreateDeployPlus( 2 );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level2_inv_deploy = function ()

    local visible_sparkle_ho = true;

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then

      visible_sparkle_ho = false;

    end;

    common_impl.TurnChildGfx( { "level2_inv_deploy" } , "level2_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level2_inv_deploy", update_game_mode_level2_inv_deploy, nil );

  private.init_rope2();
  private.init_stump2();
  private.init_emptysmoker2();
  private.init_envelope2();
  private.init_brokenlamp2();

  int.InventoryItemAdd( "inv_richardskull2" );

  --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level2_inv_hub");
    port.VideoResizeInRoom("level2_inv");
  end;
end;
--*********************************************************************************************************************
-- function *** rope2 *** () end;
--*********************************************************************************************************************
  function private.init_rope2 ()

    ObjSet( "spr_deploy_inv_rope2_hook2",  { event_mdown = private.get_selfmadecat2 } );
    ObjSet( "spr_deploy_inv_rope2_rope_1", { event_mdown = private.get_selfmadecat2 } );
    --------------------------------------------------------------------------------------------
    -- function get_selfmadecat2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_selfmadecat2" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_rope2_selfmadecat2_hint",
      room = "int_deploy_inv",
      zz = "deploy_inv_rope2",
      zz_gate = "inv_rope2"
    };
    --------------------------------------------------------------------------------------------
    local get_selfmadecat2_inv = function ()
    
      int.InventoryItemAdd( "inv_selfmadecat2", "obj_deploy_inv_rope2" );
      int.InventoryItemRemove( "inv_rope2" );
    
      ObjDelete( "anm_deploy_inv_rope2_hook" );
      ObjDelete( "obj_deploy_inv_rope2_selfmadecat2_hint" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_selfmadecat2", get_selfmadecat2_inv );
    --------------------------------------------------------------------------------------------
    -- function use_hook2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_hook2" ] =
    {
      type = "use",
      use_obj = "inv_hook2",
      use_place = "obj_deploy_inv_rope2_use_hook2",
      room = "int_deploy_inv",
      zz = "deploy_inv_rope2",
      zz_gate = "inv_rope2"
    };
    --------------------------------------------------------------------------------------------
    local use_hook2_inv = function ()
    
      int.InventoryItemRemove( "inv_hook2" );
      ObjSet( "inv_rope2", { res = "assets/levels/level2/common_inventory2/inv_rope2/inv/inv_selfmadecat2" } );

    end;
    local use_hook2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_rope2_use_hook2" );
    
    end;
    local use_hook2_end = function ()

      ObjSet( "anm_deploy_inv_rope2_hook",  { res = "assets/levels/level2/common_inventory2/inv_rope2/anims/anm_hook_use_end", animfunc = "DoAnim" } );
      ObjSet( "spr_deploy_inv_rope2_hook2", { input = true } );
      ObjSet( "gfx_deploy_inv_rope2_hook2", { active = true } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_hook2",     use_hook2_beg, "inv_rope2" );
    cmn.AddSubscriber( "use_hook2",     use_hook2_inv );
    cmn.AddSubscriber( "use_hook2",     use_hook2_end, "inv_rope2" );
    cmn.AddSubscriber( "use_hook2_inv", use_hook2_inv, "inv_rope2" );
    cmn.AddSubscriber( "use_hook2_beg", use_hook2_beg, "inv_rope2" );
    cmn.AddSubscriber( "use_hook2_end", use_hook2_end, "inv_rope2" );

  end;
  --------------------------------------------------------------------------------------------
  function public.use_hook2 ()
  
    local item = "inv_hook2";
  
    if ( cmn.ShowByInv( item, "inv_rope2" ) ) and
       ( not cmn.IsEventDone( "use_hook2" ) ) then
  
      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_rope2" );
  
      return true;
  
    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_rope2_use_hook2", "deploy_inv_rope2" ) ) and
           ( not cmn.IsEventDone( "use_hook2" ) ) then
  
      cmn.CallEventHandler( "use_hook2_inv" );
      cmn.CallEventHandler( "use_hook2_beg", "inv_rope2" );
  
      local func_end = function ()
  
        int.Lock( false );
        cmn.SetEventDone( "use_hook2" );
        cmn.CallEventHandler( "use_hook2_end", "inv_rope2" );
  
      end;
  
      int.Lock( true );
  
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_hook_rope" );
      AnimPlay( "anm_deploy_inv_rope2_hook", "DoAnim", func_end );
  
      return true;
  
    end;
  
    return false;
  
  end;
  --------------------------------------------------------------------------------------------
  function private.get_selfmadecat2 ()
  
    ObjSet( "spr_deploy_inv_rope2_hook2", { alp = 1 } );
    cmn.SetEventDone( "get_selfmadecat2" );
    cmn.CallEventHandler( "get_selfmadecat2" );
    int.DeployInvHide();
  
  end;
--*********************************************************************************************************************
-- function *** stump2 *** () end;
--*********************************************************************************************************************
  function private.init_stump2 ()

    ObjSet( "spr_deploy_inv_stump2_candle", { event_mdown = private.get_lamp2 } );
    --------------------------------------------------------------------------------------------
    -- function get_lamp2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_lamp2" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_stump2_lamp2_hint",
      room = "int_deploy_inv",
      zz = "deploy_inv_stump2",
      zz_gate = "inv_stump2"
    };
    --------------------------------------------------------------------------------------------
    local get_lamp2_inv = function ()
    
      int.InventoryItemAdd( "inv_lamp2", "obj_deploy_inv_stump2", "assets/levels/level2/common_inventory2/inv_stump2/inv/inv_lamp2" );
      int.InventoryItemRemove( "inv_stump2" );
    
      ObjDelete( "gfx_deploy_inv_stump2_lamp2" );
      ObjDelete( "obj_deploy_inv_stump2_lamp2_hint" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_lamp2", get_lamp2_inv );
    --------------------------------------------------------------------------------------------
    -- function use_flint2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_flint2" ] =
    {
      type = "use",
      use_obj = "inv_flint2",
      use_place = "obj_deploy_inv_stump2_use_flint2",
      room = "int_deploy_inv",
      zz = "deploy_inv_stump2",
      zz_gate = "inv_stump2"
    };
    --------------------------------------------------------------------------------------------
    local use_flint2_inv = function ()
    
      int.InventoryItemRemove( "inv_flint2" );
      ObjSet( "anm_inv_stump2", { alp = 1, playing = true } );

    end;
    local use_flint2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_stump2_use_flint2" );
    
    end;
    local use_flint2_end = function ()
    
      ObjDelete( "anm_deploy_inv_stump2_flint" );
      ObjSet( "anm_deploy_inv_stump2_static", { alp = 1, playing = true, animfunc = "DoAnim" } );
      ObjSet( "spr_deploy_inv_stump2_candle", { input = true } );
      ObjSet( "gfx_deploy_inv_stump2_lamp2",  { active = true } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_flint2",     use_flint2_beg, "inv_stump2" );
    cmn.AddSubscriber( "use_flint2",     use_flint2_inv );
    cmn.AddSubscriber( "use_flint2",     use_flint2_end, "inv_stump2" );
    cmn.AddSubscriber( "use_flint2_inv", use_flint2_inv, "inv_stump2" );
    cmn.AddSubscriber( "use_flint2_beg", use_flint2_beg, "inv_stump2" );
    cmn.AddSubscriber( "use_flint2_end", use_flint2_end, "inv_stump2" );

  end;
  --------------------------------------------------------------------------------------------
  function public.use_flint2 ()
  
    local item = "inv_flint2";
  
    if ( cmn.ShowByInv( item, "inv_stump2" ) ) and
       ( not cmn.IsEventDone( "use_flint2" ) ) and
       ( cmn.IsEventDone( "get_flint2_1" ) ) and
       ( cmn.IsEventDone( "get_flint2_2" ) ) then
  
      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_stump2" );
  
      return true;
  
    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_stump2_use_flint2", "deploy_inv_stump2" ) ) and
           ( not cmn.IsEventDone( "use_flint2" ) ) and
           ( cmn.IsEventDone( "get_flint2_1" ) ) and
           ( cmn.IsEventDone( "get_flint2_2" ) ) then
  
      cmn.CallEventHandler( "use_flint2_inv" );
      cmn.CallEventHandler( "use_flint2_beg", "inv_stump2" );
  
      local func_end = function ()
  
        int.Lock( false );
        cmn.SetEventDone( "use_flint2" );
        cmn.CallEventHandler( "use_flint2_end", "inv_stump2" );
  
      end;
  
      int.Lock( true );
  
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_inv_candle_fire" );
      AnimPlay( "anm_deploy_inv_stump2_flint", "DoAnim", func_end );
  
      return true;
  
    end;
  
    return false;
  
  end;
  --------------------------------------------------------------------------------------------
  function private.get_lamp2 ()
  
    cmn.SetEventDone( "get_lamp2" );
    cmn.CallEventHandler( "get_lamp2" );
    int.DeployInvHide();
  
  end;
--*********************************************************************************************************************
-- function *** emptysmoker2 *** () end;
--*********************************************************************************************************************
  function private.init_emptysmoker2 ()

    ObjSet( "obj_deploy_inv_emptysmoker2_get", { event_mdown = private.get_smoker2 } );
    ObjSet( "obj_deploy_inv_emptysmoker2_clk_door_1", { event_mdown = function() private.clk_emptysmoker2_door_1() end } );
    ObjSet( "obj_deploy_inv_emptysmoker2_clk_door_2", { event_mdown = function() private.clk_emptysmoker2_door_2() end } );
    --------------------------------------------------------------------------------------------
    -- function get_smoker2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_smoker2" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_emptysmoker2_get",
      room = "int_deploy_inv",
      zz = "deploy_inv_emptysmoker2",
      zz_gate = "inv_emptysmoker2"
    };
    --------------------------------------------------------------------------------------------
    local get_smoker2_inv = function ()
    
      int.InventoryItemAdd( "inv_smoker2", "deploy_inv_emptysmoker2" );
      int.InventoryItemRemove( "inv_emptysmoker2" );
    
      ObjDelete( "gfx_deploy_inv_emptysmoker2_smoker2" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_smoker2", get_smoker2_inv );
    --------------------------------------------------------------------------------------------
    -- function use_lighter2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_lighter2" ] =
    {
      type = "use",
      use_obj = "inv_lighter2",
      use_place = "obj_deploy_inv_emptysmoker2_use_lighter2",
      room = "int_deploy_inv",
      zz = "deploy_inv_emptysmoker2",
      zz_gate = "inv_emptysmoker2"
    };
    --------------------------------------------------------------------------------------------
    local use_lighter2_inv = function ()
    
      int.InventoryItemRemove( "inv_lighter2" );
      ObjSet( "inv_emptysmoker2_touchwood_smoke", { alp = 1 } );
      ObjSet( "inv_emptysmoker2_tube_touchwood_smoke", { alp = 1 } );
      ObjDelete( "inv_emptysmoker2_touchwood" );
      ObjDelete( "inv_emptysmoker2_tube_touchwood" );
     
    end;
    local use_lighter2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_emptysmoker2_use_lighter2" );
    
    end;
    local use_lighter2_end = function ()
    
      ObjSet( "obj_deploy_inv_emptysmoker2_clk_door_2", { input = true } );
      ObjSet( "anm_deploy_inv_emptysmoker2_use_lighter", { frame = 316 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_lighter2",     use_lighter2_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_lighter2",     use_lighter2_inv );
    cmn.AddSubscriber( "use_lighter2",     use_lighter2_end, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_lighter2_inv", use_lighter2_inv, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_lighter2_beg", use_lighter2_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_lighter2_end", use_lighter2_end, "inv_emptysmoker2" );
    --------------------------------------------------------------------------------------------
    -- function use_pipe2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_pipe2" ] =
    {
      type = "use",
      use_obj = "inv_pipe2",
      use_place = "obj_deploy_inv_emptysmoker2_use_pipe2",
      room = "int_deploy_inv",
      zz = "deploy_inv_emptysmoker2",
      zz_gate = "inv_emptysmoker2"
    };
    --------------------------------------------------------------------------------------------
    local use_pipe2_inv = function ()
    
      int.InventoryItemRemove( "inv_pipe2" );
      
      if cmn.IsEventDone( "clk_emptysmoker2_door_1" ) then
        
        if not cmn.IsEventDone( "get_rottenwood2" ) then
          ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 0 } );
        else 
          if ( cmn.IsEventDone( "use_rottenwood2" ) and not cmn.IsEventDone( "get_lighter2" ) ) then
            ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 0 } );
          end; 
        end;
        
      end; 

      ObjSet( "inv_emptysmoker2", { res = "assets/levels/level2/common_inventory2/inv_emptysmoker2/inv/inv_emptysmoker2_tube" } );
      ObjSet( "obj_before_tube", { alp = 0 } );
      ObjSet( "obj_after_tube", { alp = 1 } );

      if cmn.IsEventDone( "clk_emptysmoker2_door_2" ) then
        ObjSet( "inv_emptysmoker2_smoke", { alp = 1 } );
      end;
    
    end;
    local use_pipe2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_emptysmoker2_use_pipe2" );
    
    end;
    local use_pipe2_end = function ()
    
      ObjSet( "anm_deploy_inv_emptysmoker2_use_pipe", { frame = 500 } );
      if cmn.IsEventDone( "clk_emptysmoker2_door_2" ) then
        ObjSet( "gfx_deploy_inv_emptysmoker2_smoker2", { active = true } );
        ObjDelete( "anm_deploy_inv_emptysmoker2_use_pipe" );
        ObjDelete( "anm_deploy_inv_emptysmoker2_smoker_ready" );
        ObjSet( "anm_deploy_inv_emptysmoker2_smoker_ready_static", { alp = 1, playing = true } );
        ObjSet( "obj_deploy_inv_emptysmoker2_get", { input = true } );
      end;
          
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_pipe2",     use_pipe2_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_pipe2",     use_pipe2_inv );
    cmn.AddSubscriber( "use_pipe2",     use_pipe2_end, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_pipe2_inv", use_pipe2_inv, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_pipe2_beg", use_pipe2_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_pipe2_end", use_pipe2_end, "inv_emptysmoker2" );
    --------------------------------------------------------------------------------------------
    -- function use_rottenwood2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_rottenwood2" ] =
    {
      type = "use",
      use_obj = "inv_rottenwood2",
      use_place = "obj_deploy_inv_emptysmoker2_use_rottenwood2",
      room = "int_deploy_inv",
      zz = "deploy_inv_emptysmoker2",
      zz_gate = "inv_emptysmoker2"
    };
    --------------------------------------------------------------------------------------------
    local use_rottenwood2_inv = function ()
    
      int.InventoryItemRemove( "inv_rottenwood2" );
      
      if ( ( not cmn.IsEventDone( "get_lighter2" ) ) and ( not cmn.IsEventDone( "get_pipe2" ) ) or 
             cmn.IsEventDone( "use_lighter2" ) and ( not cmn.IsEventDone( "get_pipe2" ) ) or 
             cmn.IsEventDone( "use_pipe2" ) and ( not cmn.IsEventDone( "get_lighter2" ) ) ) then
        ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 0 } );        
      end;
      
      ObjSet( "inv_emptysmoker2_touchwood", { alp = 1 } );
      ObjSet( "inv_emptysmoker2_tube_touchwood", { alp = 1 } );

    end;  
    local use_rottenwood2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_emptysmoker2_use_rottenwood2" );
    
    end;
    local use_rottenwood2_end = function ()
     
      ObjDelete( "anm_deploy_inv_emptysmoker2_use_rottenwood" );
      ObjSet( "anm_deploy_inv_emptysmoker2_use_lighter", { alp = 1 } ); 
      ObjSet( "obj_deploy_inv_emptysmoker2_use_lighter2", { input = true } );
      ObjDelete( "spr_deploy_inv_emptysmoker2_over_hook" );      
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_rottenwood2",     use_rottenwood2_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_rottenwood2",     use_rottenwood2_inv );
    cmn.AddSubscriber( "use_rottenwood2",     use_rottenwood2_end, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_rottenwood2_inv", use_rottenwood2_inv, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_rottenwood2_beg", use_rottenwood2_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "use_rottenwood2_end", use_rottenwood2_end, "inv_emptysmoker2" );
    --------------------------------------------------------------------------------------------
    -- function clk_emptysmoker2_door_1 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_emptysmoker2_door_1" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_emptysmoker2_clk_door_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_emptysmoker2",
      zz_gate = "inv_emptysmoker2"
    };
    --------------------------------------------------------------------------------------------
    local clk_emptysmoker2_door_1_inv = function () 
      
      if not cmn.IsEventDone( "get_rottenwood2" ) then
        if ( not cmn.IsEventDone( "get_pipe2" ) ) or cmn.IsEventDone( "use_pipe2" ) then
          ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 0 } );
        end;
      elseif not cmn.IsEventDone( "get_pipe2" ) then
        if ( not cmn.IsEventDone( "get_rottenwood2" ) ) or cmn.IsEventDone( "use_rottenwood2" ) then
          ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 0 } );
        end;       
      end;

      ObjSet( "inv_emptysmoker2_open", { alp = 1 } );
      ObjSet( "inv_emptysmoker2_tube_open", { alp = 1 } );
    
    end;
    local clk_emptysmoker2_door_1_beg = function ()
    
      ObjDelete( "obj_deploy_inv_emptysmoker2_clk_door_1" );
    
    end;
    local clk_emptysmoker2_door_1_end = function ()
      
      ObjSet( "obj_deploy_inv_emptysmoker2_use_rottenwood2", { input = true } );
      ObjSet( "anm_deploy_inv_emptysmoker2_door_open_static", { alp = 1, playing = true } );
      ObjDelete( "anm_deploy_inv_emptysmoker2_door_open" );
      ObjSet( "spr_deploy_inv_emptysmoker2_over_hook", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_emptysmoker2_door_1", clk_emptysmoker2_door_1_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "clk_emptysmoker2_door_1", clk_emptysmoker2_door_1_inv );
    cmn.AddSubscriber( "clk_emptysmoker2_door_1", clk_emptysmoker2_door_1_end, "inv_emptysmoker2" );
    cmn.AddSubscriber( "clk_emptysmoker2_door_1_inv", clk_emptysmoker2_door_1_inv, "inv_emptysmoker2" );
    cmn.AddSubscriber( "clk_emptysmoker2_door_1_beg", clk_emptysmoker2_door_1_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "clk_emptysmoker2_door_1_end", clk_emptysmoker2_door_1_end, "inv_emptysmoker2" );
    --------------------------------------------------------------------------------------------
    -- function clk_emptysmoker2_door_2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_emptysmoker2_door_2" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_emptysmoker2_clk_door_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_emptysmoker2",
      zz_gate = "inv_emptysmoker2"
    };
    --------------------------------------------------------------------------------------------
    local clk_emptysmoker2_door_2_inv = function () 
      
      if ( not cmn.IsEventDone( "get_pipe2" ) ) then
        ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 0 } );
      end; 

      ObjDelete( "obj_before_tube" );
      ObjDelete( "inv_emptysmoker2_tube_open" );
      ObjDelete( "inv_emptysmoker2_tube_touchwood_smoke" );

      if ( cmn.IsEventDone( "use_pipe2" ) ) then
        ObjSet( "inv_emptysmoker2_smoke", { alp = 1 } );
      end;
     
    end;
    local clk_emptysmoker2_door_2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_emptysmoker2_clk_door_2" );
    
    end;
    local clk_emptysmoker2_door_2_end = function ()
      
      ObjSet( "anm_deploy_inv_emptysmoker2_door_close", { frame = 500 } );
      ObjDelete( "anm_deploy_inv_emptysmoker2_door_open_static" );
      if cmn.IsEventDone( "use_pipe2" ) then
        ObjSet( "gfx_deploy_inv_emptysmoker2_smoker2", { active = true } );
        ObjDelete( "anm_deploy_inv_emptysmoker2_use_pipe" );
        ObjDelete( "anm_deploy_inv_emptysmoker2_smoker_ready" );
        ObjSet( "anm_deploy_inv_emptysmoker2_smoker_ready_static", { alp = 1, playing = true } );
        ObjSet( "obj_deploy_inv_emptysmoker2_get", { input = true } );
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_emptysmoker2_door_2", clk_emptysmoker2_door_2_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "clk_emptysmoker2_door_2", clk_emptysmoker2_door_2_inv );
    cmn.AddSubscriber( "clk_emptysmoker2_door_2", clk_emptysmoker2_door_2_end, "inv_emptysmoker2" );
    cmn.AddSubscriber( "clk_emptysmoker2_door_2_inv", clk_emptysmoker2_door_2_inv, "inv_emptysmoker2" );
    cmn.AddSubscriber( "clk_emptysmoker2_door_2_beg", clk_emptysmoker2_door_2_beg, "inv_emptysmoker2" );
    cmn.AddSubscriber( "clk_emptysmoker2_door_2_end", clk_emptysmoker2_door_2_end, "inv_emptysmoker2" );
    
  end;
  --------------------------------------------------------------------------------------------
  function public.use_lighter2 ()

    local item = "inv_lighter2";

    if ( cmn.ShowByInv( item, "inv_emptysmoker2" ) ) and
       ( cmn.IsEventDone( "use_rottenwood2" ) ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_emptysmoker2" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_emptysmoker2_use_lighter2", "deploy_inv_emptysmoker2" ) ) and
           ( cmn.IsEventDone( "use_rottenwood2" ) ) then

      cmn.CallEventHandler( "use_lighter2_inv" );
      cmn.CallEventHandler( "use_lighter2_beg", "inv_emptysmoker2" );

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_lighter2" );
        cmn.CallEventHandler( "use_lighter2_end", "inv_emptysmoker2" );

      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_pumper_match" );
      AnimPlay( "anm_deploy_inv_emptysmoker2_use_lighter", "DoAnim", func_end ); 

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function public.use_pipe2 ()

    local item = "inv_pipe2";

    if ( cmn.ShowByInv( item, "inv_emptysmoker2" ) ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_emptysmoker2" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_emptysmoker2_use_pipe2", "deploy_inv_emptysmoker2" ) ) then

      cmn.CallEventHandler( "use_pipe2_inv" );
      cmn.CallEventHandler( "use_pipe2_beg", "inv_emptysmoker2" );

      local func_end = function ()
        
        local func_end1 = function ()
          int.Lock( false );
          cmn.SetEventDone( "use_pipe2" );
          cmn.CallEventHandler( "use_pipe2_end", "inv_emptysmoker2" );
        end;
        
        if cmn.IsEventDone( "clk_emptysmoker2_door_2" ) then
          private.emptysmoker2_anim_end( func_end1 );
        else
          func_end1();  
        end;  

      end;

      int.Lock( true );

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_pumper_nose" );
      AnimPlay( "anm_deploy_inv_emptysmoker2_use_pipe", "DoAnim", func_end ); 

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function public.use_rottenwood2 ()

    local item = "inv_rottenwood2";

    if ( cmn.ShowByInv( item, "inv_emptysmoker2" ) ) and
       ( cmn.IsEventDone( "clk_emptysmoker2_door_1" ) ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_emptysmoker2" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_emptysmoker2_use_rottenwood2", "deploy_inv_emptysmoker2" ) ) and
           ( cmn.IsEventDone( "clk_emptysmoker2_door_1" ) ) then

      cmn.CallEventHandler( "use_rottenwood2_inv" );
      cmn.CallEventHandler( "use_rottenwood2_beg", "inv_emptysmoker2" );

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_rottenwood2" );
        cmn.CallEventHandler( "use_rottenwood2_end", "inv_emptysmoker2" );

      end;

      int.Lock( true );
      
      ObjSet( "anm_deploy_inv_emptysmoker2_use_rottenwood", { alp = 1 } );
      ObjSet( "spr_deploy_inv_emptysmoker2_over_hook", { alp = 0 } );

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_pumper_coil" );
      AnimPlay( "anm_deploy_inv_emptysmoker2_use_rottenwood", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function private.get_smoker2 ()

    cmn.SetEventDone( "get_smoker2" );
    cmn.CallEventHandler( "get_smoker2" );
    int.DeployInvHide();

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_emptysmoker2_door_1 ()

    cmn.CallEventHandler( "clk_emptysmoker2_door_1_inv" );
    cmn.CallEventHandler( "clk_emptysmoker2_door_1_beg", "inv_emptysmoker2" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "clk_emptysmoker2_door_1" );
      cmn.CallEventHandler( "clk_emptysmoker2_door_1_end", "inv_emptysmoker2" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_inv_open_pumper" );
    AnimPlay( "anm_deploy_inv_emptysmoker2_door_open", "DoAnim", func_end ); 

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_emptysmoker2_door_2 ()

    cmn.CallEventHandler( "clk_emptysmoker2_door_2_inv" );
    cmn.CallEventHandler( "clk_emptysmoker2_door_2_beg", "inv_emptysmoker2" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "clk_emptysmoker2_door_2" );
        cmn.CallEventHandler( "clk_emptysmoker2_door_2_end", "inv_emptysmoker2" );
        
      end;
      
      if cmn.IsEventDone( "use_pipe2" ) then
        private.emptysmoker2_anim_end( func_end1 );
      else
        func_end1();  
      end;

    end;

    int.Lock( true );
    
    ObjSet( "anm_deploy_inv_emptysmoker2_door_open_static", { alp = 0 } );
    ObjSet( "anm_deploy_inv_emptysmoker2_door_close", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_pumper_close" );
    AnimPlay( "anm_deploy_inv_emptysmoker2_door_close", "DoAnim", func_end );

  end;
--------------------------------------------------------------------------------------------
  function private.emptysmoker2_anim_end ( func_end )
    
    ObjSet( "anm_deploy_inv_emptysmoker2_use_pipe", { alp = 0 } );
    ObjSet( "anm_deploy_inv_emptysmoker2_smoker_ready", { alp = 1 } );
    AnimPlay( "anm_deploy_inv_emptysmoker2_smoker_ready", "DoAnim", func_end );
    
  end;  
--*********************************************************************************************************************
-- function *** envelope2 *** () end;
--*********************************************************************************************************************
  function private.init_envelope2 ()

    ObjSet( "spr_deploy_inv_envelope2_lockpicks2", { event_mdown = private.get_lockpicks2 } );
    ObjSet( "obj_deploy_inv_envelope2_use_paperknife2_2", { event_mdown = function() private.EnvelopeClk() end  } );

    --------------------------------------------------------------------------------------------
    -- function get_lockpicks2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_lockpicks2" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_envelope2_lockpicks2",
      room = "int_deploy_inv",
      zz = "deploy_inv_envelope2",
      zz_gate = "inv_envelope2"
    };
    --------------------------------------------------------------------------------------------
    local get_lockpicks2_inv = function ()
    
      int.InventoryItemAdd( "inv_lockpicks2", "spr_deploy_inv_envelope2_lockpicks2" );
      int.InventoryItemRemove( "inv_envelope2" );
    
      ObjDelete( "gfx_envelope2_lockpicks2" );
      ObjDelete( "inv_envelope_open2_lockpicks2" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_lockpicks2", get_lockpicks2_inv );
    --------------------------------------------------------------------------------------------
    -- function use_paperknife2_2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_paperknife2_2" ] =
    {
      type = "use",
      use_obj = "inv_paperknife2",
      use_place = "obj_deploy_inv_envelope2_use_paperknife2_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_envelope2",
      zz_gate = "inv_envelope2"
    };
    --------------------------------------------------------------------------------------------
    local use_paperknife2_2_inv = function ()
    
      if cmn.IsEventDone( "use_paperknife2_1" ) then
        int.InventoryItemRemove( "inv_paperknife2" );
      end;
      
      ObjSet( "inv_envelope2", { res = "assets/levels/level2/common_inventory2/inv_envelope2/inv/inv_envelope_open2" } );

      ObjSet( "inv_envelope_open2_note", { alp = 1 } );
      ObjSet( "inv_envelope_open2_lockpicks2", { alp = 1 } );

    end;
    local use_paperknife2_2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_envelope2_use_paperknife2_2" );
    
    end;
    local use_paperknife2_2_end = function ()

      ObjSet( "anm_deploy_inv_envelope2_knife", { res = "assets/levels/level2/common_inventory2/inv_envelope2/anims/anm_knife_end", animfunc = "DoAnim" } );
      ObjSet( "spr_deploy_inv_envelope2_lockpicks2", { alp = 1, input = true } );
      ObjSet( "gfx_deploy_inv_envelope2_lockpicks2", { active = true } );
      ObjDelete( "anm_deploy_inv_envelope2_click" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_paperknife2_2",     use_paperknife2_2_beg, "inv_envelope2" );
    cmn.AddSubscriber( "use_paperknife2_2",     use_paperknife2_2_inv );
    cmn.AddSubscriber( "use_paperknife2_2",     use_paperknife2_2_end, "inv_envelope2" );
    cmn.AddSubscriber( "use_paperknife2_2_inv", use_paperknife2_2_inv, "inv_envelope2" );
    cmn.AddSubscriber( "use_paperknife2_2_beg", use_paperknife2_2_beg, "inv_envelope2" );
    cmn.AddSubscriber( "use_paperknife2_2_end", use_paperknife2_2_end, "inv_envelope2" );

  end;
  --------------------------------------------------------------------------------------------
  function public.use_paperknife2_2 ()
  
    local item = "inv_paperknife2";
  
    if ( cmn.ShowByInv( item, "inv_envelope2" ) ) and
       ( not cmn.IsEventDone( "use_paperknife2_2" ) ) then
  
      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_envelope2" );
  
      return true;
  
    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_envelope2_use_paperknife2_2", "deploy_inv_envelope2" ) ) and
           ( not cmn.IsEventDone( "use_paperknife2_2" ) ) then
  
      cmn.CallEventHandler( "use_paperknife2_2_inv" );
      cmn.CallEventHandler( "use_paperknife2_2_beg", "inv_envelope2" );
  
      local func_end = function ()
  
        int.Lock( false );
        cmn.SetEventDone( "use_paperknife2_2" );
        cmn.CallEventHandler( "use_paperknife2_2_end", "inv_envelope2" );
        interface.KeyTaskDone( true, "task_2_4" );

      end;
  
      int.Lock( true );
  
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_inv_cut_letter" );
      ObjSet( "anm_deploy_inv_envelope2_knife", { alp = 1 } );
      ObjSet( "anm_deploy_inv_envelope2_click", { alp = 0 } );
      AnimPlay( "anm_deploy_inv_envelope2_knife", "DoAnim", func_end );

      return true;
  
    end;
  
    return false;
  
  end;
  --------------------------------------------------------------------------------------------
  function private.get_lockpicks2 ()
  
    cmn.SetEventDone( "get_lockpicks2" );
    cmn.CallEventHandler( "get_lockpicks2" );
    --int.DeployInvHide();
  
  end;
--*********************************************************************************************************************
-- function *** brokenlamp2 *** () end;
--*********************************************************************************************************************
  function private.init_brokenlamp2 ()

    ObjSet( "obj_deploy_inv_brokenlamp2_clk_brokenlamp2", { event_mdown = private.clk_brokenlamp2 } );
    ObjSet( "spr_deploy_inv_brokenlamp2_brokenlamp", { event_mdown = private.get_magiclamp2 } );
    ObjSet( "spr_deploy_inv_brokenlamp2_magicprism", { event_mdown = private.get_magiclamp2 } );
    --------------------------------------------------------------------------------------------
    -- function get_magiclamp2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_magiclamp2" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_brokenlamp2",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenlamp2",
      zz_gate = "inv_brokenlamp2"
    };
    --------------------------------------------------------------------------------------------
    local get_magiclamp2_inv = function ()
    
      int.InventoryItemAdd( "inv_magiclamp2", "obj_deploy_inv_brokenlamp2" );
      int.InventoryItemRemove( "inv_brokenlamp2" );
    
      ObjDelete( "gfx_deploy_inv_brokenlamp2_brokenlamp" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_magiclamp2", get_magiclamp2_inv );
    --------------------------------------------------------------------------------------------
    -- function clk_brokenlamp2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_brokenlamp2" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_brokenlamp2_clk_brokenlamp2",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenlamp2",
      zz_gate = "inv_brokenlamp2"
    };
    --------------------------------------------------------------------------------------------
    local clk_brokenlamp2_inv = function ()

      ObjSet( "inv_brokenlamp2", { res = "assets/levels/level2/common_inventory2/inv_brokenlamp2/inv/inv_brokenlamp2_2" } );
      if ( not cmn.IsEventDone( "get_magicprism2" ) ) then

        ObjSet( "inv_brokenlamp2_plus_focus2", { alp = 0 } );

      end;

    end;
    local clk_brokenlamp2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_brokenlamp2_clk_brokenlamp2" );
    
    end;
    local clk_brokenlamp2_end = function ()
    
      ObjDelete( "anm_deploy_inv_brokenlamp2_glass" );
      ObjSet( "anm_deploy_inv_brokenlamp2_magicprism", { alp = 1 } );
      ObjSet( "obj_deploy_inv_brokenlamp2_use_magicprism2", { input = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_brokenlamp2",     clk_brokenlamp2_beg, "inv_brokenlamp2" );
    cmn.AddSubscriber( "clk_brokenlamp2",     clk_brokenlamp2_inv );
    cmn.AddSubscriber( "clk_brokenlamp2",     clk_brokenlamp2_end, "inv_brokenlamp2" );
    cmn.AddSubscriber( "clk_brokenlamp2_inv", clk_brokenlamp2_inv, "inv_brokenlamp2" );
    cmn.AddSubscriber( "clk_brokenlamp2_beg", clk_brokenlamp2_beg, "inv_brokenlamp2" );
    cmn.AddSubscriber( "clk_brokenlamp2_end", clk_brokenlamp2_end, "inv_brokenlamp2" );
    --------------------------------------------------------------------------------------------
    -- function use_magicprism2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_magicprism2" ] =
    {
      type = "use",
      use_obj = "inv_magicprism2",
      use_place = "obj_deploy_inv_brokenlamp2_use_magicprism2",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenlamp2",
      zz_gate = "inv_brokenlamp2"
    };
    --------------------------------------------------------------------------------------------
    local use_magicprism2_inv = function ()
    
      int.InventoryItemRemove( "inv_magicprism2" );
      ObjSet( "inv_brokenlamp2", { res = "assets/levels/level2/common_inventory2/inv_brokenlamp2/inv/inv_magiclamp2" } );

    end;
    local use_magicprism2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_brokenlamp2_use_magicprism2" );
    
    end;
    local use_magicprism2_end = function ()

      ObjDelete( "anm_deploy_inv_brokenlamp2_magicprism" );
      ObjSet( "spr_deploy_inv_brokenlamp2_brokenlamp", { input = true } );
      ObjSet( "gfx_deploy_inv_brokenlamp2_brokenlamp", { active = true } );
      ObjSet( "anm_deploy_inv_brokenlamp2_magicprism_static", { alp = 1, playing = true } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_magicprism2",     use_magicprism2_beg, "inv_brokenlamp2" );
    cmn.AddSubscriber( "use_magicprism2",     use_magicprism2_inv );
    cmn.AddSubscriber( "use_magicprism2",     use_magicprism2_end, "inv_brokenlamp2" );
    cmn.AddSubscriber( "use_magicprism2_inv", use_magicprism2_inv, "inv_brokenlamp2" );
    cmn.AddSubscriber( "use_magicprism2_beg", use_magicprism2_beg, "inv_brokenlamp2" );
    cmn.AddSubscriber( "use_magicprism2_end", use_magicprism2_end, "inv_brokenlamp2" );

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_brokenlamp2 ()
  
    cmn.CallEventHandler( "clk_brokenlamp2_inv" );
    cmn.CallEventHandler( "clk_brokenlamp2_beg", "inv_brokenlamp2" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "clk_brokenlamp2" );
      cmn.CallEventHandler( "clk_brokenlamp2_end", "inv_brokenlamp2" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_throw_broken_lamp" );
    AnimPlay( "anm_deploy_inv_brokenlamp2_glass", "DoAnim", func_end );
  
  end;
  --------------------------------------------------------------------------------------------
  function public.use_magicprism2 ()

    local item = "inv_magicprism2";
  
    if ( cmn.ShowByInv( item, "inv_brokenlamp2" ) ) and
       ( not cmn.IsEventDone( "use_magicprism2" ) ) and
       ( cmn.IsEventDone( "clk_brokenlamp2" ) ) then
  
      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_brokenlamp2" );
  
      return true;
  
    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenlamp2_use_magicprism2", "deploy_inv_brokenlamp2" ) ) and
           ( not cmn.IsEventDone( "use_magicprism2" ) ) and
           ( cmn.IsEventDone( "clk_brokenlamp2" ) ) then
  
      cmn.CallEventHandler( "use_magicprism2_inv" );
      cmn.CallEventHandler( "use_magicprism2_beg", "inv_brokenlamp2" );
  
      local func_end = function ()
  
        int.Lock( false );
        cmn.SetEventDone( "use_magicprism2" );
        cmn.CallEventHandler( "use_magicprism2_end", "inv_brokenlamp2" );
  
      end;
  
      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_new_lamp_crystal" );
      AnimPlay( "anm_deploy_inv_brokenlamp2_magicprism", "DoAnim", func_end );

      return true;
  
    end;
  
    return false;
  
  end;
  --------------------------------------------------------------------------------------------
  function private.get_magiclamp2 ()
  
    cmn.SetEventDone( "get_magiclamp2" );
    cmn.CallEventHandler( "get_magiclamp2" );
    int.DeployInvHide();
  
  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** CHECK FUNCTIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.CheckFlint2 ()

    if ( cmn.IsEventDone( "get_flint2_1" ) ) and
       ( cmn.IsEventDone( "get_flint2_2" ) ) then

      ObjSet( "inv_flint2", { res = "assets/levels/level2/rm_prison2/zz_stash2/inv/inv_flint2_all" } );
      ObjDelete( "txt_inv_flint2_count" );

    elseif ( cmn.IsEventDone( "get_flint2_2" ) ) then

      ObjSet( "inv_flint2", { res = "assets/levels/level2/rm_prison2/zz_stash2/inv/inv_flint2_2" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckBlacksmithamulet2 ( id )

    if ( cmn.IsEventDone( "get_blacksmithamulet2_1" ) ) and
       ( cmn.IsEventDone( "get_blacksmithamulet2_2" ) ) then

      ObjSet( "inv_blacksmithamulet2", { res = "assets/levels/level2/rm_workshop2/zz_foundry2/inv/inv_blacksmithamulet2_all" } );
      ObjDelete( "txt_inv_blacksmithamulet2_count" );

    else 

      ObjSet( "inv_blacksmithamulet2", { res = "assets/levels/level2/rm_workshop2/zz_foundry2/inv/inv_blacksmithamulet2_"..id } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckSnakesamulet2 ()

    if ( cmn.IsEventDone( "get_snakesamulet2_1" ) ) then

      ObjSet( "spr_inv_snakesamulet2_1", { alp = 1 } );

    end;

    if ( cmn.IsEventDone( "get_snakesamulet2_2" ) ) then

      ObjSet( "spr_inv_snakesamulet2_2", { alp = 1 } );

    end;

    if ( cmn.IsEventDone( "get_snakesamulet2_1" ) ) and
       ( cmn.IsEventDone( "get_snakesamulet2_2" ) ) then

      ObjDelete( "txt_inv_snakesamulet2_count" );
      ObjDelete( "spr_inv_snakesamulet2_1" );
      ObjDelete( "spr_inv_snakesamulet2_2" );
      ObjSet( "spr_inv_snakesamulet2_all", { alp = 1 } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckOwlamulet2 ()

    local count = 0;

    for i = 1, 3 do

      if ( cmn.IsEventDone( "get_owlamulet2_"..i ) ) then

        ObjSet( "spr_owlamulet2_"..i, { alp = 1 } );
        count = count + 1;

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_owlamulet2_count" );

    else

      ObjSet( "txt_inv_owlamulet2_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckKeypiece2 ( id )

    if ( cmn.IsEventDone( "get_keypiece2_1" ) ) and
       ( cmn.IsEventDone( "get_keypiece2_2" ) ) then

      ObjSet( "inv_keypiece2_all", { alp = 1 } );
      ObjDelete( "inv_keypiece2_1" );
      ObjDelete( "inv_keypiece2_2" );
      ObjDelete( "txt_inv_keypiece2_count" );

    else 

      ObjSet( "inv_keypiece2_"..id, { alp = 1 } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckRing2 ( id )

    if ( cmn.IsEventDone( "get_ring2_1" ) ) and
       ( cmn.IsEventDone( "get_ring2_2" ) ) then

      ObjSet( "inv_ring2_all", { alp = 1 } );
      ObjDelete( "inv_ring2_1" );
      ObjDelete( "inv_ring2_2" );
      ObjDelete( "txt_inv_ring2_count" );

    else 

      ObjSet( "inv_ring2_"..id, { alp = 1 } );

    end;

  end;
  --*********************************************************************************************************************
  function public.CheckSpiralamulet2 ()

    local count = 0;

    for i = 1, 4 do

      if ( cmn.IsEventDone( "get_temporaryecho2_"..i ) ) then

        ObjSet( "inv_spiralamulet2_"..i, { alp = 1 } );
        count = count + 1;

      end;

    end;

    if ( count == 4 ) then

      ObjDelete( "txt_inv_spiralamulet2_count" );

    else

      ObjSet( "txt_inv_spiralamulet2_count", { text = count.."/4" } );

    end;

  end;
  --*********************************************************************************************************************
  function public.CheckKey2 ( id )

    if ( cmn.IsEventDone( "get_key2_1" ) ) and
       ( cmn.IsEventDone( "get_key2_2" ) ) then

       ObjSet( "inv_key2", { res = "assets/levels/level2/rm_abighalehouse2/zz_writingdesk2/inv/inv_key2_all" } );
      ObjDelete( "txt_inv_key2_count" );

    else 

      ObjSet( "inv_key2", { res = "assets/levels/level2/rm_abighalehouse2/zz_writingdesk2/inv/inv_key2_"..id } );

    end;

  end;
--*********************************************************************************************************************
function private.EnvelopeClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_deploy_inv_envelope2_use_paperknife2_2" );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_inv_letter_click" );
  AnimPlay( "anm_deploy_inv_envelope2_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************