-- name=rm_abighalehouse2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_abighalehouse2";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_fireplace2", "room_hub" );
  ObjAttach( "zz_bookcase2", "room_hub" );
  ObjAttach( "zz_piano2", "room_hub" );
  ObjAttach( "zz_writingdesk2", "room_hub" );

  ObjMultiSet(
  {
    { "spr_fireplace2_scrollamulet2",        { event_mdown = private.get_scrollamulet2 } },
    { "spr_fireplace2_paperknife2",          { event_mdown = private.get_paperknife2 } },
    { "spr_fireplace2_owlamulet2_3",         { event_mdown = private.get_owlamulet2_3 } },
    { "spr_writingdesk2_key2_1",             { event_mdown = private.get_key2_1 } },
    { "spr_bookcase2_owlamulet2_1",          { event_mdown = private.get_owlamulet2_1 } },
    { "spr_bookcase2_eyeamulet2",            { event_mdown = private.get_eyeamulet2 } },
    { "spr_piano2_decanter2",                { event_mdown = private.get_decanter2 } },
    { "spr_piano2_owlamulet2_2",             { event_mdown = private.get_owlamulet2_2 } },
    { "spr_piano2_signet2",                  { event_mdown = private.get_signet2 } },
    { "spr_writingdesk2_keypiece2_1",        { event_mdown = private.get_keypiece2_1 } },
    { "spr_writingdesk2_cleaningagent2",     { event_mdown = private.get_cleaningagent2 } },
    { "spr_writingdesk2_key2_2",             { event_mdown = private.get_key2_2 } },
    { "spr_writingdesk2_musicnotes2",        { event_mdown = private.get_musicnotes2 } },
    { "obj_writingdesk2_use_scrollamulet2",  { event_mdown = private.Writingdesk2CacheClick } },
    { "obj_writingdesk2_use_featheramulet2", { event_mdown = private.Writingdesk2CacheClick } },
    { "obj_writingdesk2_use_owlamulet2",     { event_mdown = private.Writingdesk2CascetClick } },
    { "obj_writingdesk2_use_signet2",        { event_mdown = private.Writingdesk2BoxClick } },
    { "obj_bookcase2_use_brick2",            { event_mdown = private.Bookcase2DoorClick } },
    { "obj_piano2_use_paperknife2_1",        { event_mdown = function() private.Piano2ClkCap() end; } },
    { "spr_abighalehouse2_collect_2_2",      { event_mdown = private.get_collect_2_2 } },
  } );
  
  private.Piano2Init();
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_abighalehouse2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_abighalehouse2", update_game_mode_abighalehouse2, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2 = function ()

    ObjDelete( "spr_abighalehouse2_collect_2_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_2_2", get_collect_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_1 = function ()

    ObjDelete( "obj_abighalehouse2_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_1", get_morphobject_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_featheramulet2 () end;
  --------------------------------------------------------------------------------------------
  local get_featheramulet2_inv = function ()

    int.InventoryItemAdd( "inv_featheramulet2", "spr_abighalehouse2_featheramulet2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_featheramulet2", get_featheramulet2_inv );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_scrollamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scrollamulet2" ] =
  {
    type = "get",
    get_obj = "spr_fireplace2_scrollamulet2",
    room = private.room_objname,
    zz = "zz_fireplace2",
    zz_gate = "gzz_abighalehouse2_fireplace2"
  };
  --------------------------------------------------------------------------------------------
  local get_scrollamulet2_inv = function ()

    int.InventoryItemAdd( "inv_scrollamulet2", "spr_fireplace2_scrollamulet2" );

  end;
  local get_scrollamulet2_closezz = function ()

    ObjDelete( "gfx_fireplace2_scrollamulet2" );
    ObjDelete( "spr_abighalehouse2_scrollamulet" );
    --ObjDelete( "gzz_abighalehouse2_fireplace2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_scrollamulet2", get_scrollamulet2_inv );
  cmn.AddSubscriber( "get_scrollamulet2", get_scrollamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_paperknife2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_paperknife2" ] =
  {
    type = "get",
    get_obj = "spr_fireplace2_paperknife2",
    room = private.room_objname,
    zz = "zz_fireplace2",
    zz_gate = "gzz_abighalehouse2_fireplace2"
  };
  --------------------------------------------------------------------------------------------
  local get_paperknife2_inv = function ()

    int.InventoryItemAdd( "inv_paperknife2", "spr_fireplace2_paperknife2" );

    if ( cmn.IsEventDone( "win_hosecretsection2" ) ) then

      ObjSet( "inv_envelope2_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_paperknife2_closezz = function ()

    ObjDelete( "gfx_fireplace2_paperknife2" );
    ObjDelete( "spr_abighalehouse2_paperknife" );
    ObjDelete( "spr_fireplace2_paperknife2_shadow" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_paperknife2", get_paperknife2_inv );
  cmn.AddSubscriber( "get_paperknife2", get_paperknife2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_owlamulet2_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_owlamulet2_3" ] =
  {
    type = "get",
    get_obj = "spr_fireplace2_owlamulet2_3",
    room = private.room_objname,
    zz = "zz_fireplace2",
    zz_gate = "gzz_abighalehouse2_fireplace2"
  };
  --------------------------------------------------------------------------------------------
  local get_owlamulet2_3_inv = function ()

    int.InventoryItemAdd( "inv_owlamulet2", "spr_fireplace2_owlamulet2_3", "assets/levels/level2/rm_abighalehouse2/zz_bookcase2/inv/inv_owlamulet2_3" );
    level2_inv.CheckOwlamulet2();

  end;
  local get_owlamulet2_3_closezz = function ()

    ObjDelete( "gfx_fireplace2_owlamulet2_3" );
    ObjDelete( "spr_abighalehouse2_fireplace_owlamulet" );
    --ObjDelete( "gzz_abighalehouse2_fireplace2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_owlamulet2_3", get_owlamulet2_3_inv );
  cmn.AddSubscriber( "get_owlamulet2_3", get_owlamulet2_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_key2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_key2_1" ] =
  {
    type = "get",
    get_obj = "spr_writingdesk2_key2_1",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local get_key2_1_inv = function ()

    int.InventoryItemAdd( "inv_key2", "spr_writingdesk2_key2_1", "assets/levels/level2/rm_abighalehouse2/zz_writingdesk2/inv/inv_key2_1" );
    level2_inv.CheckKey2( 1 );

  end;
  local get_key2_1_closezz = function ()

    ObjDelete( "gfx_writingdesk2_key2_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_key2_1", get_key2_1_inv );
  cmn.AddSubscriber( "get_key2_1", get_key2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_owlamulet2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_owlamulet2_1" ] =
  {
    type = "get",
    get_obj = "spr_bookcase2_owlamulet2_1",
    room = private.room_objname,
    zz = "zz_bookcase2",
    zz_gate = "gzz_abighalehouse2_bookcase2"
  };
  --------------------------------------------------------------------------------------------
  local get_owlamulet2_1_inv = function ()

    int.InventoryItemAdd( "inv_owlamulet2", "spr_bookcase2_owlamulet2_1", "assets/levels/level2/rm_abighalehouse2/zz_bookcase2/inv/inv_owlamulet2_1" );
    level2_inv.CheckOwlamulet2();

  end;
  local get_owlamulet2_1_closezz = function ()

    ObjDelete( "gfx_bookcase2_owlamulet2_1" );
    ObjDelete( "spr_abighalehouse2_bookcase_owlamulet" );

    if ( cmn.IsEventDone( "get_eyeamulet2" ) ) then

      ObjDelete( "gzz_abighalehouse2_bookcase2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_owlamulet2_1", get_owlamulet2_1_inv );
  cmn.AddSubscriber( "get_owlamulet2_1", get_owlamulet2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_eyeamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_eyeamulet2" ] =
  {
    type = "get",
    get_obj = "spr_bookcase2_eyeamulet2",
    room = private.room_objname,
    zz = "zz_bookcase2",
    zz_gate = "gzz_abighalehouse2_bookcase2"
  };
  --------------------------------------------------------------------------------------------
  local get_eyeamulet2_inv = function ()

    int.InventoryItemAdd( "inv_eyeamulet2", "spr_bookcase2_eyeamulet2" );

  end;
  local get_eyeamulet2_closezz = function ()

    ObjDelete( "gfx_bookcase2_eyeamulet2" );
    ObjDelete( "spr_bookcase2_eyeamulet_shadow" );
    
    ObjDelete( "spr_abighalehouse2_bookcase_eyeamulet" );

    if ( cmn.IsEventDone( "get_owlamulet2_1" ) ) then

      ObjDelete( "gzz_abighalehouse2_bookcase2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_eyeamulet2", get_eyeamulet2_inv );
  cmn.AddSubscriber( "get_eyeamulet2", get_eyeamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_decanter2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_decanter2" ] =
  {
    type = "get",
    get_obj = "spr_piano2_decanter2",
    room = private.room_objname,
    zz = "zz_piano2",
    zz_gate = "gzz_abighalehouse2_piano2"
  };
  --------------------------------------------------------------------------------------------
  local get_decanter2_inv = function ()

    int.InventoryItemAdd( "inv_decanter2", "spr_piano2_decanter2" );

  end;
  local get_decanter2_closezz = function ()

    ObjDelete( "gfx_piano2_decanter2" );
    
    ObjDelete( "spr_abighalehouse2_decanter" );
    ObjDelete( "spr_abighalehouse2_overlapping_2" );
    --ObjDelete( "gzz_abighalehouse2_piano2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_decanter2", get_decanter2_inv );
  cmn.AddSubscriber( "get_decanter2", get_decanter2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_owlamulet2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_owlamulet2_2" ] =
  {
    type = "get",
    get_obj = "spr_piano2_owlamulet2_2",
    room = private.room_objname,
    zz = "zz_piano2",
    zz_gate = "gzz_abighalehouse2_piano2"
  };
  --------------------------------------------------------------------------------------------
  local get_owlamulet2_2_inv = function ()

    int.InventoryItemAdd( "inv_owlamulet2", "spr_piano2_owlamulet2_2", "assets/levels/level2/rm_abighalehouse2/zz_bookcase2/inv/inv_owlamulet2_2" );
    level2_inv.CheckOwlamulet2();

  end;
  local get_owlamulet2_2_closezz = function ()

    ObjDelete( "gfx_piano2_owlamulet2_2" );
    
    if cmn.IsEventDone( "get_signet2" ) then
      
      ObjDelete( "gzz_abighalehouse2_piano2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_owlamulet2_2", get_owlamulet2_2_inv );
  cmn.AddSubscriber( "get_owlamulet2_2", get_owlamulet2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_signet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_signet2" ] =
  {
    type = "get",
    get_obj = "spr_piano2_signet2",
    room = private.room_objname,
    zz = "zz_piano2",
    zz_gate = "gzz_abighalehouse2_piano2"
  };
  --------------------------------------------------------------------------------------------
  local get_signet2_inv = function ()

    int.InventoryItemAdd( "inv_signet2", "spr_piano2_signet2" );

  end;
  local get_signet2_closezz = function ()

    ObjDelete( "gfx_piano2_signet2" );
    
    if cmn.IsEventDone( "get_signet2" ) then
      
      ObjDelete( "gzz_abighalehouse2_piano2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_signet2", get_signet2_inv );
  cmn.AddSubscriber( "get_signet2", get_signet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_keypiece2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_keypiece2_1" ] =
  {
    type = "get",
    get_obj = "spr_writingdesk2_keypiece2_1",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local get_keypiece2_1_inv = function ()

    int.InventoryItemAdd( "inv_keypiece2", "spr_writingdesk2_keypiece2_1", "assets/levels/level2/rm_abighalehouse2/zz_writingdesk2/inv/inv_keypiece2_1" );
    level2_inv.CheckKeypiece2( 1 );

  end;
  local get_keypiece2_1_closezz = function ()

    ObjDelete( "gfx_writingdesk2_keypiece2_1" );
    --ObjDelete( "gzz_abighalehouse2_piano2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_keypiece2_1", get_keypiece2_1_inv );
  cmn.AddSubscriber( "get_keypiece2_1", get_keypiece2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cleaningagent2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cleaningagent2" ] =
  {
    type = "get",
    get_obj = "spr_writingdesk2_cleaningagent2",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local get_cleaningagent2_inv = function ()

    int.InventoryItemAdd( "inv_cleaningagent2", "spr_writingdesk2_cleaningagent2" );

  end;
  local get_cleaningagent2_closezz = function ()

    ObjDelete( "gfx_writingdesk2_cleaningagent2" );
    ObjDelete( "spr_abighalehouse2_cleaner" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cleaningagent2", get_cleaningagent2_inv );
  cmn.AddSubscriber( "get_cleaningagent2", get_cleaningagent2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_key2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_key2_2" ] =
  {
    type = "get",
    get_obj = "spr_writingdesk2_key2_2",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local get_key2_2_inv = function ()

    int.InventoryItemAdd( "inv_key2", "spr_writingdesk2_key2_2", "assets/levels/level2/rm_abighalehouse2/zz_writingdesk2/inv/inv_key2_2" );
    level2_inv.CheckKey2( 2 );

  end;
  local get_key2_2_closezz = function ()

    ObjDelete( "gfx_writingdesk2_key2_2" );
    ObjDelete( "spr_abighalehouse2_key" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_key2_2", get_key2_2_inv );
  cmn.AddSubscriber( "get_key2_2", get_key2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_musicnotes2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_musicnotes2" ] =
  {
    type = "get",
    get_obj = "spr_writingdesk2_musicnotes2",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local get_musicnotes2_inv = function ()

    int.InventoryItemAdd( "inv_musicnotes2", "spr_writingdesk2_musicnotes2" );

  end;
  local get_musicnotes2_closezz = function ()

    ObjDelete( "gfx_writingdesk2_musicnotes2" );
    ObjDelete( "spr_abighalehouse2_note" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_musicnotes2", get_musicnotes2_inv );
  cmn.AddSubscriber( "get_musicnotes2", get_musicnotes2_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_decanterwater2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_decanterwater2" ] =
  {
    type = "use",
    use_obj = "inv_decanterwater2",
    use_place = "obj_fireplace2_use_decanterwater2",
    room = private.room_objname,
    zz = "zz_fireplace2",
    zz_gate = "gzz_abighalehouse2_fireplace2"
  };
  --------------------------------------------------------------------------------------------
  local use_decanterwater2_inv = function ()

    int.InventoryItemRemove( "inv_decanterwater2" );

  end;
  local use_decanterwater2_beg = function ()

    ObjDelete( "obj_fireplace2_use_decanterwater2" );
    ObjDelete( "anm_fireplace2_fire" );

  end;
  local use_decanterwater2_end = function ()

    ObjSet( "spr_fireplace2_owlamulet2_3", { alp = 1, input = true } );
    ObjSet( "gfx_fireplace2_owlamulet2_3", { active = true } );
    ObjDelete( "anm_fireplace2_water" );
    ObjDelete( "anm_fireplace2_water_backchange" );
    ObjDelete( "anm_abighalehouse2_fire" );
    ObjDelete( "spr_abighalehouse2_fire" );
    ObjDelete( "spr_abighalehouse2_light3" );
    ObjDelete( "spr_abighalehouse2_paperknife_fire" );
    ObjDelete( "spr_abighalehouse2_fireplace_owlamulet_fire" );
    ObjDelete( "spr_abighalehouse2_scrollamulet_fire" );

    ObjDelete( "spr_fireplace2_paperknife2_over_fire" );
    ObjDelete( "spr_fireplace2_part_2_fire" );
    ObjDelete( "spr_fireplace2_scrollamulet2_fire" );
    ObjDelete( "spr_fireplace2_paperknife2_fire" );
    ObjSet( "anm_fireplace2_steam", { playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_decanterwater2",     use_decanterwater2_inv );
  cmn.AddSubscriber( "use_decanterwater2",     use_decanterwater2_beg, private.room_objname );
  cmn.AddSubscriber( "use_decanterwater2",     use_decanterwater2_end, private.room_objname );
  cmn.AddSubscriber( "use_decanterwater2_inv", use_decanterwater2_inv, private.room_objname );
  cmn.AddSubscriber( "use_decanterwater2_beg", use_decanterwater2_beg, private.room_objname );
  cmn.AddSubscriber( "use_decanterwater2_end", use_decanterwater2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pyramidamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pyramidamulet2" ] =
  {
    type = "use",
    use_obj = "inv_pyramidamulet2",
    use_place = "obj_fireplace2_use_pyramidamulet2",
    room = private.room_objname,
    zz = "zz_fireplace2",
    zz_gate = "gzz_abighalehouse2_fireplace2"
  };
  --------------------------------------------------------------------------------------------
  local use_pyramidamulet2_inv = function ()

    int.InventoryItemRemove( "inv_pyramidamulet2" );

  end;
  local use_pyramidamulet2_beg = function ()

    ObjDelete( "obj_fireplace2_use_pyramidamulet2" );

  end;
  local use_pyramidamulet2_end = function ()
    
    if cmn.IsEventDone( "use_eyeamulet2" ) then

      ObjDelete( "gzz_abighalehouse2_fireplace2" );
      ObjDelete( "anm_abighalehouse2_passage" );
      ObjDelete( "obj_abighalehouse2_bookcase" );
      ObjSet( "obj_abighalehouse2_use_streetlamp2", { input = true } );

    else 
      ObjSet( "spr_fireplace2_pyramidamulet", { alp = 1 } ); 
    end;
    
    ObjSet( "spr_abighalehouse2_pyramidamulet", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pyramidamulet2",     use_pyramidamulet2_inv );
  cmn.AddSubscriber( "use_pyramidamulet2",     use_pyramidamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pyramidamulet2",     use_pyramidamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_pyramidamulet2_inv", use_pyramidamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_pyramidamulet2_beg", use_pyramidamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pyramidamulet2_end", use_pyramidamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_eyeamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_eyeamulet2" ] =
  {
    type = "use",
    use_obj = "inv_eyeamulet2",
    use_place = "obj_fireplace2_use_eyeamulet2",
    room = private.room_objname,
    zz = "zz_fireplace2",
    zz_gate = "gzz_abighalehouse2_fireplace2"
  };
  --------------------------------------------------------------------------------------------
  local use_eyeamulet2_inv = function ()

    int.InventoryItemRemove( "inv_eyeamulet2" );

  end;
  local use_eyeamulet2_beg = function ()

    ObjDelete( "obj_fireplace2_use_eyeamulet2" );

  end;
  local use_eyeamulet2_end = function ()

    if cmn.IsEventDone( "use_pyramidamulet2" ) then
      
      ObjDelete( "gzz_abighalehouse2_fireplace2" );
      ObjDelete( "anm_abighalehouse2_passage" );
      ObjDelete( "obj_abighalehouse2_bookcase" );
      ObjSet( "obj_abighalehouse2_use_streetlamp2", { input = true } );

    else 
      ObjSet( "spr_fireplace2_eyeamulet", { alp = 1 } );
    end;
    
    ObjSet( "spr_abighalehouse2_eyeamulet", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_eyeamulet2",     use_eyeamulet2_inv );
  cmn.AddSubscriber( "use_eyeamulet2",     use_eyeamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_eyeamulet2",     use_eyeamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_eyeamulet2_inv", use_eyeamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_eyeamulet2_beg", use_eyeamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_eyeamulet2_end", use_eyeamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_streetlamp2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_streetlamp2" ] =
  {
    type = "use",
    use_obj = "inv_streetlamp2",
    use_place = "obj_abighalehouse2_use_streetlamp2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local use_streetlamp2_inv = function ()

    int.InventoryItemRemove( "inv_streetlamp2" );

  end;
  local use_streetlamp2_beg = function ()

    ObjDelete( "obj_abighalehouse2_use_streetlamp2" );

  end;
  local use_streetlamp2_end = function ()

    ObjDelete( "anm_abighalehouse2_streetlamp" );
    ObjSet( "gmg_abighalehouse2_mgcatacomb2", { alp = 1, input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_streetlamp2",     use_streetlamp2_inv );
  cmn.AddSubscriber( "use_streetlamp2",     use_streetlamp2_beg, private.room_objname );
  cmn.AddSubscriber( "use_streetlamp2",     use_streetlamp2_end, private.room_objname );
  cmn.AddSubscriber( "use_streetlamp2_inv", use_streetlamp2_inv, private.room_objname );
  cmn.AddSubscriber( "use_streetlamp2_beg", use_streetlamp2_beg, private.room_objname );
  cmn.AddSubscriber( "use_streetlamp2_end", use_streetlamp2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_brick2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_brick2" ] =
  {
    type = "use",
    use_obj = "inv_brick2",
    use_place = "obj_bookcase2_use_brick2",
    room = private.room_objname,
    zz = "zz_bookcase2",
    zz_gate = "gzz_abighalehouse2_bookcase2"
  };
  --------------------------------------------------------------------------------------------
  local use_brick2_inv = function ()

    int.InventoryItemRemove( "inv_brick2" );

  end;
  local use_brick2_beg = function ()

    ObjDelete( "obj_bookcase2_use_brick2" );
    ObjDelete( "anm_bookcase2_door_click" );

  end;
  local use_brick2_end = function ()
    
    ObjSet( "anm_bookcase2_brick",      { frame = 41, animfunc = "DoAnim" } );
    ObjSet( "spr_bookcase2_eyeamulet2", { input = true } );
    ObjSet( "gfx_bookcase2_eyeamulet2", { active = true } );
    ObjSet( "obj_bookcase2_broken",     { alp = 1 } );
    ObjSet( "spr_abighalehouse2_broken_glass", { alp = 1 } );
    ObjSet( "spr_abighalehouse2_bookcase_eyeamulet", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_brick2",     use_brick2_inv );
  cmn.AddSubscriber( "use_brick2",     use_brick2_beg, private.room_objname );
  cmn.AddSubscriber( "use_brick2",     use_brick2_end, private.room_objname );
  cmn.AddSubscriber( "use_brick2_inv", use_brick2_inv, private.room_objname );
  cmn.AddSubscriber( "use_brick2_beg", use_brick2_beg, private.room_objname );
  cmn.AddSubscriber( "use_brick2_end", use_brick2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_key2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_key2" ] =
  {
    type = "use",
    use_obj = "inv_key2",
    use_place = "obj_piano2_use_key2",
    room = private.room_objname,
    zz = "zz_piano2",
    zz_gate = "gzz_abighalehouse2_piano2"
  };
  --------------------------------------------------------------------------------------------
  local use_key2_inv = function ()

    int.InventoryItemRemove( "inv_key2" );

  end;
  local use_key2_beg = function ()

    ObjDelete( "obj_piano2_use_key2" );

  end;
  local use_key2_end = function ()
    
    ObjSet( "spr_piano2_button2", { input = true } );
    ObjSet( "spr_piano2_button6", { input = true } );
    
    ObjSet( "spr_piano2_button2_2", { alp = 1 } );
    ObjSet( "spr_piano2_button6_6", { alp = 1 } );
    
    if cmn.IsEventDone( "use_musicnotes2" ) then
      
      for i = 1, 10 do
        
        ObjSet( "spr_piano2_button"..i,
        {
          event_mdown  = function () private.Piano2Clk( i ) end,
        } );
          
      end;
      
    end;
      
    ObjDelete( "spr_abighalehouse2_slot" );
    ObjDelete( "spr_abighalehouse2_slot2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_key2",     use_key2_inv );
  cmn.AddSubscriber( "use_key2",     use_key2_beg, private.room_objname );
  cmn.AddSubscriber( "use_key2",     use_key2_end, private.room_objname );
  cmn.AddSubscriber( "use_key2_inv", use_key2_inv, private.room_objname );
  cmn.AddSubscriber( "use_key2_beg", use_key2_beg, private.room_objname );
  cmn.AddSubscriber( "use_key2_end", use_key2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_paperknife2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_paperknife2_1" ] =
  {
    type = "use",
    use_obj = "inv_paperknife2",
    use_place = "obj_piano2_use_paperknife2_1",
    room = private.room_objname,
    zz = "zz_piano2",
    zz_gate = "gzz_abighalehouse2_piano2"
  };
  --------------------------------------------------------------------------------------------
  local use_paperknife2_1_inv = function ()
    
    if cmn.IsEventDone( "use_paperknife2_2" ) then
      int.InventoryItemRemove( "inv_paperknife2" );
    end;

  end;
  local use_paperknife2_1_beg = function ()

    ObjDelete( "obj_piano2_use_paperknife2_1" );

  end;
  local use_paperknife2_1_end = function ()

    ObjDelete( "obj_piano2_close" );
    ObjSet( "obj_piano2_open", { alp = 1, input = true } );
    ObjSet( "gfx_piano2_owlamulet2_2", { active = true } );
    ObjSet( "obj_piano2_use_key2", { input = true } );
    ObjSet( "obj_piano2_use_musicnotes2", { input = true } );
    
    ObjSet( "obj_piano2_stash", { alp = 1 } );
    ObjSet( "spr_piano2_over_musicnotes", { alp = 1 } );
    
    ObjDelete( "spr_abighalehouse2_cap" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_paperknife2_1",     use_paperknife2_1_inv );
  cmn.AddSubscriber( "use_paperknife2_1",     use_paperknife2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_paperknife2_1",     use_paperknife2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_paperknife2_1_inv", use_paperknife2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_paperknife2_1_beg", use_paperknife2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_paperknife2_1_end", use_paperknife2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_musicnotes2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_musicnotes2" ] =
  {
    type = "use",
    use_obj = "inv_musicnotes2",
    use_place = "obj_piano2_use_musicnotes2",
    room = private.room_objname,
    zz = "zz_piano2",
    zz_gate = "gzz_abighalehouse2_piano2"
  };
  --------------------------------------------------------------------------------------------
  local use_musicnotes2_inv = function ()

    int.InventoryItemRemove( "inv_musicnotes2" );

  end;
  local use_musicnotes2_beg = function ()

    ObjDelete( "obj_piano2_use_musicnotes2" );

  end;
  local use_musicnotes2_end = function ()

    ObjSet( "obj_piano2_musicnotes", { alp = 1 } );
    
    if cmn.IsEventDone( "use_key2" ) then
      
      for i = 1, 10 do
        
        ObjSet( "spr_piano2_button"..i,
        {
          event_mdown  = function () private.Piano2Clk( i ) end,
        } );
          
      end;
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_musicnotes2",     use_musicnotes2_inv );
  cmn.AddSubscriber( "use_musicnotes2",     use_musicnotes2_beg, private.room_objname );
  cmn.AddSubscriber( "use_musicnotes2",     use_musicnotes2_end, private.room_objname );
  cmn.AddSubscriber( "use_musicnotes2_inv", use_musicnotes2_inv, private.room_objname );
  cmn.AddSubscriber( "use_musicnotes2_beg", use_musicnotes2_beg, private.room_objname );
  cmn.AddSubscriber( "use_musicnotes2_end", use_musicnotes2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_owlamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_owlamulet2" ] =
  {
    type = "use",
    use_obj = "inv_owlamulet2",
    use_place = "obj_writingdesk2_use_owlamulet2",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local use_owlamulet2_inv = function ()

    int.InventoryItemRemove( "inv_owlamulet2" );

  end;
  local use_owlamulet2_beg = function ()

    ObjDelete( "obj_writingdesk2_use_owlamulet2" );

  end;
  local use_owlamulet2_end = function ()

    ObjSet( "obj_writingdesk2_casket_open", { input = true } );
    ObjSet( "gfx_writingdesk2_musicnotes2", { active = true } );
    ObjSet( "anm_writingdesk2_casket_open", { alp = 1, frame = 60, animfunc = "DoAnim" } );
    ObjSet( "spr_abighalehouse2_open_box",  { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_owlamulet2",     use_owlamulet2_inv );
  cmn.AddSubscriber( "use_owlamulet2",     use_owlamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_owlamulet2",     use_owlamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_owlamulet2_inv", use_owlamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_owlamulet2_beg", use_owlamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_owlamulet2_end", use_owlamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scrollamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scrollamulet2" ] =
  {
    type = "use",
    use_obj = "inv_scrollamulet2",
    use_place = "obj_writingdesk2_use_scrollamulet2",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local use_scrollamulet2_inv = function ()

    int.InventoryItemRemove( "inv_scrollamulet2" );

  end;
  local use_scrollamulet2_beg = function ()

    ObjDelete( "obj_writingdesk2_use_scrollamulet2" );

  end;
  local use_scrollamulet2_end = function ()

    if cmn.IsEventDone( "use_featheramulet2" ) then

      ObjSet( "obj_writingdesk2_cache_open", { input = true } );
      ObjSet( "gfx_writingdesk2_keypiece2_1", { active = true } );
      ObjSet( "gfx_writingdesk2_key2_1", { active = true } );
      ObjDelete( "obj_writingdesk2_cache_close" );
      ObjSet( "anm_writingdesk2_cache_open", { alp = 1, frame = 25, animfunc = "DoAnim" } );
      ObjSet( "spr_abighalehouse2_open_panel", { alp = 1 } );
      ObjDelete( "spr_abighalehouse2_panel" );

    else 

      ObjSet( "spr_writingdesk2_scrollamulet", { alp = 1 } ); 

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scrollamulet2",     use_scrollamulet2_inv );
  cmn.AddSubscriber( "use_scrollamulet2",     use_scrollamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_scrollamulet2",     use_scrollamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_scrollamulet2_inv", use_scrollamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_scrollamulet2_beg", use_scrollamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_scrollamulet2_end", use_scrollamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_featheramulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_featheramulet2" ] =
  {
    type = "use",
    use_obj = "inv_featheramulet2",
    use_place = "obj_writingdesk2_use_featheramulet2",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local use_featheramulet2_inv = function ()

    int.InventoryItemRemove( "inv_featheramulet2" );

  end;
  local use_featheramulet2_beg = function ()

    ObjDelete( "obj_writingdesk2_use_featheramulet2" );

  end;
  local use_featheramulet2_end = function ()

    if cmn.IsEventDone( "use_scrollamulet2" ) then

      ObjSet( "obj_writingdesk2_cache_open", { input = true } );
      ObjSet( "gfx_writingdesk2_keypiece2_1", { active = true } );
      ObjSet( "gfx_writingdesk2_key2_1", { active = true } );
      ObjDelete( "obj_writingdesk2_cache_close" );
      ObjSet( "anm_writingdesk2_cache_open", { alp = 1, frame = 25, animfunc = "DoAnim" } );
      ObjSet( "spr_abighalehouse2_open_panel", { alp = 1 } );
      ObjDelete( "spr_abighalehouse2_panel" );

    else 

      ObjSet( "spr_writingdesk2_featheramulet", { alp = 1 } ); 

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_featheramulet2",     use_featheramulet2_inv );
  cmn.AddSubscriber( "use_featheramulet2",     use_featheramulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_featheramulet2",     use_featheramulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_featheramulet2_inv", use_featheramulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_featheramulet2_beg", use_featheramulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_featheramulet2_end", use_featheramulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_signet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_signet2" ] =
  {
    type = "use",
    use_obj = "inv_signet2",
    use_place = "obj_writingdesk2_use_signet2",
    room = private.room_objname,
    zz = "zz_writingdesk2",
    zz_gate = "gzz_abighalehouse2_writingdesk2"
  };
  --------------------------------------------------------------------------------------------
  local use_signet2_inv = function ()

    int.InventoryItemRemove( "inv_signet2" );

  end;
  local use_signet2_beg = function ()

    ObjDelete( "obj_writingdesk2_use_signet2" );
    ObjDelete( "obj_writingdesk2_box_close" );

  end;
  local use_signet2_end = function ()

    ObjSet( "gho_abighalehouse2_hosecretsection2", { alp = 1, input = true, active = true } );
    ObjDelete( "gzz_abighalehouse2_writingdesk2" );
    ObjSet( "spr_abighalehouse2_open_ho", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_signet2",     use_signet2_inv );
  cmn.AddSubscriber( "use_signet2",     use_signet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_signet2",     use_signet2_end, private.room_objname );
  cmn.AddSubscriber( "use_signet2_inv", use_signet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_signet2_beg", use_signet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_signet2_end", use_signet2_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_mgcatacomb2 () end;
  --------------------------------------------------------------------------------------------
  local win_mgcatacomb2 = function ()

    if ( cmn.IsEventDone( "win_mgcatacomb2" ) ) then

      ObjDelete( "gmg_abighalehouse2_mgcatacomb2" );
      ObjSet( "grm_abighalehouse2_neartower2", { alp = 1, input = true, active = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_abighalehouse2_neartower2_focus");
      end;
    
    end;

  end;

  cmn.AddSubscriber( "win_mgcatacomb2", win_mgcatacomb2, private.room_objname );

  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_piano2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_piano2" ] =
  {
    type = "click",
    clk_obj = "spr_piano2_button1",
    room = private.room_objname,
    zz = "zz_piano2",
    zz_gate = "gzz_abighalehouse2_piano2"
  };
  --*********************************************************************************************************************
  local win_piano2_inv = function ()

    if ( cmn.IsEventDone( "win_piano2" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_piano2 = function ()

    if ( cmn.IsEventDone( "win_piano2" ) ) then
            
      ObjSet( "spr_piano2_signet2", { input = true } );
      ObjSet( "gfx_piano2_signet2", { active = true } );
      ObjSet( "obj_piano2_open_stash", { alp = 1, input = true } );
      ObjSet( "gfx_piano2_keypiece2_1", { active = true } );
      ObjDelete( "spr_piano2_cap_stash" );
      ObjSet( "obj_piano2_mmg", { input = false } );

      ObjDelete( "obj_piano2_green_numbers_lights" );
      ObjDelete( "obj_piano2_red_numbers_lights" );
      
    else 

      private.Piano2Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_piano2", win_piano2_inv );
  cmn.AddSubscriber( "win_piano2", win_piano2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_hosecretsection2 () end;
  --------------------------------------------------------------------------------------------
  local win_hosecretsection2 = function ()

    if ( cmn.IsEventDone( "win_hosecretsection2" ) ) then

      ObjSet( "obj_abighalehouse2_ho_bbt", { input = true } );
      
    end;

  end;

  cmn.AddSubscriber( "win_hosecretsection2", win_hosecretsection2, private.room_objname );

  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function dlg_abighalehouse2_richard2_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_abighalehouse2_richard2_2_beg = function ()

  end;
  -----------------------------------------------
  local dlg_abighalehouse2_richard2_2_end = function ()

    ObjDelete( "dlg_abighalehouse2_richard2_2" );

  end;

  cmn.AddSubscriber( "dlg_abighalehouse2_richard2_2",     dlg_abighalehouse2_richard2_2_beg );
  cmn.AddSubscriber( "dlg_abighalehouse2_richard2_2",     dlg_abighalehouse2_richard2_2_end );
  cmn.AddSubscriber( "dlg_abighalehouse2_richard2_2_beg", dlg_abighalehouse2_richard2_2_beg );
  cmn.AddSubscriber( "dlg_abighalehouse2_richard2_2_end", dlg_abighalehouse2_richard2_2_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------------------------------
function private.get_collect_2_2 ()

  int.AddCollectibles( "spr_abighalehouse2_collect_2_2" );

end;
-----------------------------------------------------------------------
function private.get_scrollamulet2 ()

  cmn.SetEventDone( "get_scrollamulet2" );
  cmn.CallEventHandler( "get_scrollamulet2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_paperknife2 ()

  cmn.SetEventDone( "get_paperknife2" );
  cmn.CallEventHandler( "get_paperknife2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_owlamulet2_3 ()

  cmn.SetEventDone( "get_owlamulet2_3" );
  cmn.CallEventHandler( "get_owlamulet2_3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_key2_1 ()

  cmn.SetEventDone( "get_key2_1" );
  cmn.CallEventHandler( "get_key2_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_owlamulet2_1 ()

  cmn.SetEventDone( "get_owlamulet2_1" );
  cmn.CallEventHandler( "get_owlamulet2_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_eyeamulet2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_eyeamulet2 ()

  cmn.SetEventDone( "get_eyeamulet2" );
  cmn.CallEventHandler( "get_eyeamulet2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_owlamulet2_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_decanter2 ()

  cmn.SetEventDone( "get_decanter2" );
  cmn.CallEventHandler( "get_decanter2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_owlamulet2_2 ()

  cmn.SetEventDone( "get_owlamulet2_2" );
  cmn.CallEventHandler( "get_owlamulet2_2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_signet2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_signet2 ()

  cmn.SetEventDone( "get_signet2" );
  cmn.CallEventHandler( "get_signet2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_owlamulet2_2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_keypiece2_1 ()

  cmn.SetEventDone( "get_keypiece2_1" );
  cmn.CallEventHandler( "get_keypiece2_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_cleaningagent2 ()

  cmn.SetEventDone( "get_cleaningagent2" );
  cmn.CallEventHandler( "get_cleaningagent2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_key2_2 ()

  cmn.SetEventDone( "get_key2_2" );
  cmn.CallEventHandler( "get_key2_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_musicnotes2 ()

  cmn.SetEventDone( "get_musicnotes2" );
  cmn.CallEventHandler( "get_musicnotes2" );
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_decanterwater2 ()

  local item = "inv_decanterwater2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_fireplace2", false ) ) and
     ( not cmn.IsEventDone( "use_decanterwater2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireplace2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fireplace2_use_decanterwater2", true ) ) and
         ( not cmn.IsEventDone( "use_decanterwater2" ) ) then

    cmn.CallEventHandler( "use_decanterwater2_inv" );
    cmn.CallEventHandler( "use_decanterwater2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_decanterwater2" );
      cmn.CallEventHandler( "use_decanterwater2_end" );
      cmn.StopAudio( "sfx", "audio/level2/sfx/aud_zz_fireplace2_loop_env", 0.5 );

    end;

    int.Lock( true );

    ObjSet( "anm_fireplace2_water", { alp = 1 } );
    AnimPlay( "anm_fireplace2_water", "DoAnim", func_end );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_snuff_out_fire" );
    AnimPlay( "anm_fireplace2_water_backchange", "DoAnim", "" );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_pyramidamulet2 ()

  local item = "inv_pyramidamulet2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_fireplace2", false ) ) and
     ( not cmn.IsEventDone( "use_pyramidamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireplace2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fireplace2_use_pyramidamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_pyramidamulet2" ) ) then

    cmn.CallEventHandler( "use_pyramidamulet2_inv" );
    cmn.CallEventHandler( "use_pyramidamulet2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_pyramidamulet2" );
        cmn.CallEventHandler( "use_pyramidamulet2_end" );
        
      end;
      
      if cmn.IsEventDone( "use_eyeamulet2" ) then
        
        ObjSet( "spr_abighalehouse2_pyramidamulet", { alp = 1 } );
        ObjSet( "obj_abighalehouse2_bookcase", { alp = 0 } );
        ObjSet( "anm_abighalehouse2_passage", { alp = 1 } );
        cmn.CloseSubRoom( true );
        ObjSet( "obj_abighalehouse2_bookcase", { alp = 0 } );
        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_hidden_door_opens" );
        AnimPlay( "anm_abighalehouse2_passage", "DoAnim", function() cmn.ShowBbt( "bbt_abighalehouse2_passage" ); func_end1(); end  ); 
        
      else 
        
        func_end1();   
        
      end;

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_pyramide_right" );
    ObjAnimate( "spr_fireplace2_pyramidamulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_eyeamulet2 ()

  local item = "inv_eyeamulet2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_fireplace2", false ) ) and
     ( not cmn.IsEventDone( "use_eyeamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireplace2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fireplace2_use_eyeamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_eyeamulet2" ) ) then

    cmn.CallEventHandler( "use_eyeamulet2_inv" );
    cmn.CallEventHandler( "use_eyeamulet2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_eyeamulet2" );
        cmn.CallEventHandler( "use_eyeamulet2_end" );
        
      end;
      
      if cmn.IsEventDone( "use_pyramidamulet2" ) then
        ObjSet( "obj_abighalehouse2_bookcase", { alp = 0 } );
        ObjSet( "anm_abighalehouse2_passage", { alp = 1 } );
        cmn.CloseSubRoom( true );
        ObjSet( "spr_abighalehouse2_eyeamulet", { alp = 1 } );
        ObjSet( "obj_abighalehouse2_bookcase", { alp = 0 } );
        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_hidden_door_opens" );
        AnimPlay( "anm_abighalehouse2_passage", "DoAnim", function() cmn.ShowBbt( "bbt_abighalehouse2_passage" ); func_end1(); end  );
      else
        func_end1();  
      end;
      
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_eye_left" );
    ObjAnimate( "spr_fireplace2_eyeamulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_streetlamp2 ()

  local item = "inv_streetlamp2";

  if ( cmn.ApplyObj( item, "obj_abighalehouse2_use_streetlamp2", true ) ) and
     ( not cmn.IsEventDone( "use_streetlamp2" ) ) and 
     ( cmn.IsEventDone( "use_pyramidamulet2" ) ) and 
     ( cmn.IsEventDone( "use_eyeamulet2" ) ) then

    cmn.CallEventHandler( "use_streetlamp2_inv" );
    cmn.CallEventHandler( "use_streetlamp2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_streetlamp2" );
      cmn.CallEventHandler( "use_streetlamp2_end" );
      cmn.GotoRoom( "mg_mgcatacomb2" );

    end;

    int.Lock( true );

    ObjSet( "anm_abighalehouse2_streetlamp", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_light_lamp" );
    AnimPlay( "anm_abighalehouse2_streetlamp", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_brick2 ()

  local item = "inv_brick2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_bookcase2", false ) ) and
     ( not cmn.IsEventDone( "use_brick2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bookcase2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bookcase2_use_brick2", true ) ) and
         ( not cmn.IsEventDone( "use_brick2" ) ) then

    cmn.CallEventHandler( "use_brick2_inv" );
    cmn.CallEventHandler( "use_brick2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_brick2" );
      cmn.CallEventHandler( "use_brick2_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_broke_glass_zz_bookcase2" );
    AnimPlay( "anm_bookcase2_brick", "DoAnim", func_end );

    ObjAnimate( "obj_bookcase2_broken", "alp", 0, 0, "",
    {
      0.00, 3, 0.0,
      0.59, 3, 0.0,
      0.59, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_key2 ()

  local item = "inv_key2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_piano2", false ) ) and
     ( not cmn.IsEventDone( "use_key2" ) ) and 
       cmn.IsEventDone( "get_key2_1" ) and  
       cmn.IsEventDone( "get_key2_2" ) and  
       cmn.IsEventDone( "use_paperknife2_1" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_piano2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_piano2_use_key2", true ) ) and
         ( not cmn.IsEventDone( "use_key2" ) ) and 
           cmn.IsEventDone( "get_key2_1" ) and 
           cmn.IsEventDone( "get_key2_2" ) and 
           cmn.IsEventDone( "use_paperknife2_1" ) then

    cmn.CallEventHandler( "use_key2_inv" );
    cmn.CallEventHandler( "use_key2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_key2" );
      cmn.CallEventHandler( "use_key2_end" );
      
      if cmn.IsEventDone( "use_musicnotes2" ) then
        
        private.Piano2StartInit();
        
      end;

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_missed_keys_piano" );
    ObjAnimate( "spr_piano2_button2_2", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    ObjAnimate( "spr_piano2_button6_6", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_paperknife2_1 ()

  local item = "inv_paperknife2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_piano2", false ) ) and
     ( not cmn.IsEventDone( "use_paperknife2_1" ) ) and 
       cmn.IsEventDone( "get_decanter2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_piano2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_piano2_use_paperknife2_1", true ) ) and
         ( not cmn.IsEventDone( "use_paperknife2_1" ) ) and 
           cmn.IsEventDone( "get_decanter2" ) then

    cmn.CallEventHandler( "use_paperknife2_1_inv" );
    cmn.CallEventHandler( "use_paperknife2_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_paperknife2_1" );
      cmn.CallEventHandler( "use_paperknife2_1_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_piano2_click_cap", { alp = 0 } );
    ObjSet( "anm_piano2_use_paperknife", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ipen_piano_zz_piano2" );
    AnimPlay( "anm_piano2_use_paperknife", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_musicnotes2 ()

  local item = "inv_musicnotes2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_piano2", false ) ) and
     ( not cmn.IsEventDone( "use_musicnotes2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_piano2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_piano2_use_musicnotes2", true ) ) and
         ( not cmn.IsEventDone( "use_musicnotes2" ) ) then

    cmn.CallEventHandler( "use_musicnotes2_inv" );
    cmn.CallEventHandler( "use_musicnotes2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_musicnotes2" );
      cmn.CallEventHandler( "use_musicnotes2_end" );
      
      if cmn.IsEventDone( "use_key2" ) then
        
        private.Piano2StartInit();
        
      end;

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_put_paper_piano" );
    ObjAnimate( "obj_piano2_musicnotes", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_owlamulet2 ()

  local item = "inv_owlamulet2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_writingdesk2", false ) ) and
     ( not cmn.IsEventDone( "use_owlamulet2" ) ) and 
       cmn.IsEventDone( "get_owlamulet2_1" ) and 
       cmn.IsEventDone( "get_owlamulet2_2" ) and 
       cmn.IsEventDone( "get_owlamulet2_3" ) and
       cmn.IsEventDone( "get_key2_2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_writingdesk2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_writingdesk2_use_owlamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_owlamulet2" ) ) and 
           cmn.IsEventDone( "get_owlamulet2_1" ) and 
           cmn.IsEventDone( "get_owlamulet2_2" ) and 
           cmn.IsEventDone( "get_owlamulet2_3" ) and
           cmn.IsEventDone( "get_key2_2" ) then

    cmn.CallEventHandler( "use_owlamulet2_inv" );
    cmn.CallEventHandler( "use_owlamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_owlamulet2" );
      cmn.CallEventHandler( "use_owlamulet2_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_3_pieces_box_opens" );
    AnimPlay( "anm_writingdesk2_casket_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_scrollamulet2 ()

  local item = "inv_scrollamulet2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_writingdesk2", false ) ) and
     ( not cmn.IsEventDone( "use_scrollamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_writingdesk2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_writingdesk2_use_scrollamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_scrollamulet2" ) ) then

    cmn.CallEventHandler( "use_scrollamulet2_inv" );
    cmn.CallEventHandler( "use_scrollamulet2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_scrollamulet2" );
        cmn.CallEventHandler( "use_scrollamulet2_end" );
        
      end;
      
      if cmn.IsEventDone( "use_featheramulet2" ) then
        private.use_scrollamulet_featheramulet_end( func_end1 );
      else 
        func_end1(); 
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_left_zz_writingdesk2" );
    ObjAnimate( "spr_writingdesk2_scrollamulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.use_scrollamulet_featheramulet_end ( func_end )
  
  ObjSet( "obj_writingdesk2_cache_close", { alp = 0 } );
  ObjSet( "anm_writingdesk2_cache_open",  { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_writingdesk2_opens" );
  AnimPlay( "anm_writingdesk2_cache_open", "DoAnim", func_end );
  
end;  
--------------------------------------------------------------------------------------------
function public.use_featheramulet2 ()

  local item = "inv_featheramulet2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_writingdesk2", false ) ) and
     ( not cmn.IsEventDone( "use_featheramulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_writingdesk2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_writingdesk2_use_featheramulet2", true ) ) and
         ( not cmn.IsEventDone( "use_featheramulet2" ) ) then

    cmn.CallEventHandler( "use_featheramulet2_inv" );
    cmn.CallEventHandler( "use_featheramulet2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_featheramulet2" );
        cmn.CallEventHandler( "use_featheramulet2_end" );
        
      end;  
      
      if cmn.IsEventDone( "use_scrollamulet2" ) then
        private.use_scrollamulet_featheramulet_end( func_end1 );
      else 
        func_end1(); 
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_right_zz_writingdesk2" );
    ObjAnimate( "spr_writingdesk2_featheramulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_signet2 ()

  local item = "inv_signet2";

  if ( cmn.ApplyObj( item, "gzz_abighalehouse2_writingdesk2", false ) ) and
     ( not cmn.IsEventDone( "use_signet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_writingdesk2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_writingdesk2_use_signet2", true ) ) and
         ( not cmn.IsEventDone( "use_signet2" ) ) then

    cmn.CallEventHandler( "use_signet2_inv" );
    cmn.CallEventHandler( "use_signet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_signet2" );
      cmn.CallEventHandler( "use_signet2_end" );
      cmn.CloseSubRoom();
      
    end;

    int.Lock( true );

    ObjSet( "obj_writingdesk2_box_open", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_down_zz_writingdesk2_opens" );
    AnimPlay( "anm_writingdesk2_box_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.dlg_abighalehouse2_richard2_2 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_featheramulet2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_abighalehouse2_richard2_2_richard_static_1",      { alp = 0 } );
    ObjSet( "anm_abighalehouse2_richard2_2_richard_static_2",      { alp = 0 } );
    ObjSet( "anm_abighalehouse2_richard2_2_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_abighalehouse2_richard2_2_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_abighalehouse2_richard2_2_richard_static_1" );
    AnimStop( "anm_abighalehouse2_richard2_2_richard_static_2" );
    AnimStop( "anm_abighalehouse2_richard2_2_richard_disappearance" );

    ObjAnimate( "anm_abighalehouse2_richard2_2_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_abighalehouse2_richard2_2_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_featheramulet2" );
      cmn.SetEventDone( "dlg_abighalehouse2_richard2_2" );
      int.InventoryItemAdd( "inv_richardskull2" );
      cmn.ShowBbt( "bbt_abighalehouse2_after_dlg_richard" );

      interface.KeyTaskDone( true, "task_2_3" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_abighalehouse2_richard2_2_richard_appearance" );
    ObjSet( "anm_abighalehouse2_richard2_2_richard_appearance", { alp = 0 } );

    ObjSet( "anm_abighalehouse2_richard2_2_richard_static_1", { alp = 1 } );
    AnimPlay( "anm_abighalehouse2_richard2_2_richard_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard2_2", "abighalehouse2", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_abighalehouse2_richard2_2_beg" );
  ObjAttach( "dlg_abighalehouse2_richard2_2", GetCurrentRoom() );  

  ObjSet( "anm_abighalehouse2_richard2_2_richard_appearance", { alp = 1 } );
  AnimPlay( "anm_abighalehouse2_richard2_2_richard_appearance", "DoAnim", func_anim_end );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_abighalehouse2_richard2_2_richard_static_1", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull2" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard2_2" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_abighalehouse2_richard2_2_richard_static_1" );
        AnimPlay( "anm_abighalehouse2_richard2_2_richard_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_abighalehouse2_richard2_2_richard_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_abighalehouse2_richard2_2_richard_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_abighalehouse2_richard2_2_richard_static_2" );
        AnimPlay( "anm_abighalehouse2_richard2_2_richard_give", "DoAnim", "" );
        AnimPlay( "anm_abighalehouse2_richard2_2_object_appearance", "DoAnim", "" );

        ObjAnimate( "spr_abighalehouse2_featheramulet2", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_abighalehouse2_richard2_2_richard_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_abighalehouse2_richard2_2_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      cmn.PlayAudio( "sfx", "audio/aud_richard_creates_thing" );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_abighalehouse2 ()

  if not ( cmn.IsEventDone( "opn_abighalehouse2" ) ) then

    cmn.SetEventDone( "opn_abighalehouse2" );

  end;

  if not ( cmn.IsEventDone( "dlg_abighalehouse2_richard2_2" ) ) then

    private.dlg_abighalehouse2_richard2_2();

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_abighalehouse2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_abighalehouse2_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_abighalehouse2();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_featheramulet2",                            { "dlg_abighalehouse2_richard2_2" } );
  int.AddedTaskMap( private.room_objname, "get_scrollamulet2" );
  int.AddedTaskMap( private.room_objname, "get_paperknife2" );
  int.AddedTaskMap( private.room_objname, "get_owlamulet2_3",                              { "use_decanterwater2" } );
  int.AddedTaskMap( private.room_objname, "get_key2_1",                                    { "use_featheramulet2", "use_scrollamulet2" } );
  int.AddedTaskMap( private.room_objname, "get_owlamulet2_1" );
  int.AddedTaskMap( private.room_objname, "get_eyeamulet2",                                { "use_brick2" } );
  int.AddedTaskMap( private.room_objname, "get_decanter2" );
  int.AddedTaskMap( private.room_objname, "get_owlamulet2_2",                              { "use_paperknife2_1" } );
  int.AddedTaskMap( private.room_objname, "get_signet2",                                   { "win_piano2" } );
  int.AddedTaskMap( private.room_objname, "get_keypiece2_1",                               { "use_featheramulet2" } );
  int.AddedTaskMap( private.room_objname, "get_cleaningagent2" );
  int.AddedTaskMap( private.room_objname, "get_key2_2" );
  int.AddedTaskMap( private.room_objname, "get_musicnotes2",                               { "use_owlamulet2" } );

  int.AddedTaskMap( private.room_objname, "use_decanterwater2",                            { "get_decanterwater2" } );
  int.AddedTaskMap( private.room_objname, "use_pyramidamulet2",                            { "get_pyramidamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_eyeamulet2",                                { "get_eyeamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_streetlamp2",                               { "get_streetlamp2", "use_eyeamulet2", "use_pyramidamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_brick2",                                    { "get_brick2" } );
  int.AddedTaskMap( private.room_objname, "use_key2",                                      { "get_key2_1", "get_key2_2", "use_paperknife2_1" } );
  int.AddedTaskMap( private.room_objname, "use_paperknife2_1",                             { "get_paperknife2", "get_decanter2" } );
  int.AddedTaskMap( private.room_objname, "use_musicnotes2",                               { "get_musicnotes2", "use_paperknife2_1" } );
  int.AddedTaskMap( private.room_objname, "use_owlamulet2",                                { "get_owlamulet2_1", "get_owlamulet2_2", "get_owlamulet2_3" } );
  int.AddedTaskMap( private.room_objname, "use_scrollamulet2",                             { "get_scrollamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_featheramulet2",                            { "get_featheramulet2" } );
  int.AddedTaskMap( private.room_objname, "use_signet2",                                   { "get_signet2" } );

  int.AddedTaskMap( private.room_objname, "win_mgcatacomb2",                               { "use_streetlamp2" } );
  int.AddedTaskMap( private.room_objname, "win_piano2",                                    { "use_musicnotes2", "use_key2" } );
  int.AddedTaskMap( private.room_objname, "win_hosecretsection2",                          { "use_signet2" } );

  int.AddedTaskMap( private.room_objname, "dlg_abighalehouse2_richard2_2" );

  int.AddedTaskMap( private.room_objname, "opn_neartower2",                                { "win_mgcatacomb2" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_piano2" );
  subroom.Define( "zz_fireplace2" );
  -------------------------------------------------
  function zz_fireplace2.Open()

    if not cmn.IsEventDone( "use_decanterwater2" ) then
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_fireplace2_loop_env", 1 );
    end;

  end;
  -------------------------------------------------
  function zz_fireplace2.Close()

    if not cmn.IsEventDone( "use_decanterwater2" ) then
      cmn.StopAudio( "sfx", "audio/level2/sfx/aud_zz_fireplace2_loop_env", 0.5 );
    end;

  end;
  -------------------------------------------------
  function zz_piano2.Open()
    
    if ( cmn.IsEventStart( "win_piano2" ) and not cmn.IsEventDone( "win_piano2" ) ) then

      cmn.MiniGameShow( "piano2" );
      common_impl.PassingMgStart( "piano2" );

    end;

  end;
  -------------------------------------------------
  function zz_piano2.PreClose()
        
    if ( cmn.IsEventStart( "win_piano2" ) and not cmn.IsEventDone( "win_piano2" ) ) then

      cmn.MiniGameHide( "piano2" );
      common_impl.PassingMgStop( "piano2" );

    end;
    
  end;
  -------------------------------------------------
  function zz_piano2.Skip ()

    if ( cmn.IsEventStart( "win_piano2" ) and not cmn.IsEventDone( "win_piano2" ) ) then
      
      private.Piano2Skip();
      
    end;

  end;
  -------------------------------------------------
  function zz_piano2.Reset ()

    if ( cmn.IsEventStart( "win_piano2" ) and not cmn.IsEventDone( "win_piano2" ) ) then
      
      private.Piano2Reset();
      
    end;

  end;
  -------------------------------------------------
  subroom.Define( "zz_bookcase2" );  
  -------------------------------------------------
  function zz_bookcase2.Close()

      cmn.NoteScaleEnd( { "spr_bookcase2_note" }, true );

  end;
  -------------------------------------------------
  subroom.Define( "zz_writingdesk2" );  
  -------------------------------------------------
  function zz_writingdesk2.Close()

      cmn.NoteScaleEnd( { "spr_writingdesk2_note" }, true );

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
  ObjAnimate( "spr_abighalehouse2_light3", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

  ObjAnimate( "spr_abighalehouse2_paperknife_fire", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

  ObjAnimate( "spr_abighalehouse2_mascot", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.15,
    3.0, 3, 0.15,
    6.0, 3, -0.15,
  } );
  
end;
--*********************************************************************************************************************
function private.Writingdesk2CacheClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    if ( cmn.IsEventDone( "use_featheramulet2" ) ) then

      cmn.ShowBbt( "bbt_writingdesk2_use_scrollamulet2" );

    else

      cmn.ShowBbt( "bbt_writingdesk2_use_featheramulet2" );

    end;

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_right_cell_zz_writingdesk2" );
  ObjAnimate( "obj_writingdesk2_cache_close", "pos_x", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, 2,
    0.4, 3, 0,
    0.6, 3, 2,
    0.8, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.Writingdesk2CascetClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_writingdesk2_use_owlamulet2" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_left_box_zz_writingdesk2" );
  ObjAnimate( "obj_writingdesk2_casket_close", "pos_y", 0, 0, func_end,
  {
    0.0, 3,  0,
    0.2, 3, -2,
    0.4, 3,  0,
    0.6, 3, -2,
    0.8, 3,  0,
  } );

end;
--*********************************************************************************************************************
function private.Writingdesk2BoxClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_writingdesk2_use_signet2" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_drawer_desk" );
  AnimPlay( "anm_writingdesk2_box_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Bookcase2DoorClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_bookcase2_use_brick2" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_glass_cupboard" );
  AnimPlay( "anm_bookcase2_door_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Piano2 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Piano2StartInit ()

    cmn.MiniGameShow( "piano2" );
    common_impl.PassingMgStart( "piano2" );
    ng_global.progress[ "std" ][ "win_piano2" ].stage = 1;
   
  end;
--*********************************************************************************************************************
  function private.Piano2Load ()
    
    if ng_global.progress[ "std" ][ "win_piano2" ].stage ~= 1 then
      for i = 1, ng_global.progress[ "std" ][ "win_piano2" ].stage - 1 do
        ObjSet( "spr_piano2_green_light_"..i, { alp = 1 } );
      end;
    end;
    
  end;
--*********************************************************************************************************************
  function private.Piano2Skip ()

    int.Lock( true );
    private.Piano2SkipClkKey( ng_global.progress[ "std" ][ "win_piano2" ].stage );
    
  end
--*********************************************************************************************************************
  function private.Piano2SkipClkKey ( stage )

    if stage <= #private.win then

      local func_end = function ()
        private.Piano2SkipClkKey ( stage + 1 )
      end;
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_"..private.win[ stage ].."_key_piano" );
      ObjAnimate( "spr_piano2_button"..private.win[ stage ], "alp", 0, 0, func_end, 
      { 
       0.0, 3, 0.0,
       0.2, 3, 1.0,
       0.4, 3, 0.0,
       } );
      ObjAnimate( "spr_piano2_green_light_"..stage, "alp", 0, 0, "", 
      { 
       0.0, 3, 0.0,
       0.2, 3, 1.0,
       } );

    else

      private.Piano2Win();

    end;

  end;
--*********************************************************************************************************************
  function private.Piano2Reset ()

    if ng_global.progress[ "std" ][ "win_piano2" ].stage ~= 1 then
      for i = 1, ng_global.progress[ "std" ][ "win_piano2" ].stage - 1 do
        ObjSet( "spr_piano2_green_light_"..i, { alp = 0 } );
      end;
    end;

    ng_global.progress[ "std" ][ "win_piano2" ].stage = 1;
    
  end  
--*********************************************************************************************************************
  function private.Piano2Init ()
      
    for i = 1, 10 do
      
      ObjSet( "spr_piano2_button"..i,
      {
        event_mdown  = function () private.Piano2NoKeys( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );
        
    end;
      
    private.win = { 2, 4, 7, 6, 4 };
      
  end;    
--*********************************************************************************************************************
  function private.Piano2Clk ( id ) 
    
    local func_end = function ()
          
      if ( id == private.win[ ng_global.progress[ "std" ][ "win_piano2" ].stage ] ) then
        
        local func_end1 = function ()
          
          if ng_global.progress[ "std" ][ "win_piano2" ].stage == 5 then
            private.Piano2Win();
          else
            ng_global.progress[ "std" ][ "win_piano2" ].stage = ng_global.progress[ "std" ][ "win_piano2" ].stage + 1;
            int.Lock( false );
          end;
          
        end; 
 
        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mmg_piano_right" );
        ObjAnimate( "obj_piano2_right_light"..id, "alp", 0, 0, func_end1, 
        { 
          0.0, 3, 0.0,
          0.2, 3, 1.0,
          0.4, 3, 0.0,
        } );
        ObjAnimate( "spr_piano2_green_light_"..ng_global.progress[ "std" ][ "win_piano2" ].stage, "alp", 0, 0, "", 
        { 
          0.0, 3, 0.0,
          0.2, 3, 1.0,
        } );   

      else 
        
        local func_end1 = function ()
          
          ng_global.progress[ "std" ][ "win_piano2" ].stage = 1;
          int.Lock( false );
          
        end; 
 
        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mmg_piano_wrong" );
        ObjAnimate( "obj_piano2_wrong_light"..id, "alp", 0, 0, func_end1, 
        { 
          0.0, 3, 0.0,
          0.2, 3, 1.0,
          0.4, 3, 0.0,
        } );
        ObjAnimate( "spr_piano2_red_light_"..ng_global.progress[ "std" ][ "win_piano2" ].stage, "alp", 0, 0, "", 
        { 
          0.0, 3, 0.0,
          0.2, 3, 1.0,
          0.4, 3, 0.0,
        } );  

        if ng_global.progress[ "std" ][ "win_piano2" ].stage ~= 1 then

          for i = 1, ng_global.progress[ "std" ][ "win_piano2" ].stage - 1 do

            ObjAnimate( "spr_piano2_green_light_"..i, "alp", 0, 0, "", 
            { 
              0.0, 3, 1.0,
              0.2, 3, 1.0,
              0.4, 3, 0.0,
            } );  

          end;

        end;
        
      end;  
      
    end;
    
    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_"..id.."_key_piano" );
    ObjAnimate( "spr_piano2_button"..id, "alp", 0, 0, func_end, 
    { 
      0.0, 3, 0.0,
      0.2, 3, 1.0,
      0.4, 3, 0.0,
    } );
    
  end;
--*********************************************************************************************************************
  function private.Piano2Win ()
    
    local func_end = function ()
      
      cmn.MiniGameHide( "piano2" );
      cmn.SetEventDone( "win_piano2" );
      cmn.CallEventHandler( "win_piano2" );
      common_impl.PassingMgWin( "piano2" );
      int.Lock( false );
    
    end;

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mmg_piano_open_cell" );
    ObjAnimate( "spr_piano2_cap_stash", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );
    ObjAnimate( "obj_piano2_open_stash", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );
           
  end;
--*********************************************************************************************************************
function private.Piano2NoKeys ( id ) 
  
  local func_end = function ()
    
    int.Lock( false );
    
    if cmn.IsEventDone( "use_key2" ) then
      cmn.ShowBbt( "bbt_piano2_use_musicnotes2" );
    else  
      cmn.ShowBbt( "bbt_piano2_use_key2" );
    end;
   
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_"..id.."_key_piano" );
  ObjAnimate( "spr_piano2_button"..id, "alp", 0, 0, func_end, 
  { 
    0.0, 3, 0.0,
    0.2, 3, 1.0,
    0.4, 3, 0.0,
  } );
  
end;
--*********************************************************************************************************************
function private.Piano2ClkCap () 

  local func_end = function ()
    
    int.Lock( false );
    cmn.ShowBbt( "bbt_piano2_use_paperknife2_1" );
   
  end;
  
  int.Lock( true );
  
  if cmn.IsEventDone( "get_decanter2" ) then

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_piano_zz_piano2" );
    AnimPlay( "anm_piano2_click_cap", "DoAnim", func_end );
    
  else  
    
    func_end();
    
  end;
  
end;
--*********************************************************************************************************************  