-- name=rm_alley2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_alley2";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_parkentrance2", "room_hub" );
  ObjAttach( "zz_houseextension2", "room_hub" );
  ObjAttach( "zz_veranda2", "room_hub" );
  ObjAttach( "zz_hedge2", "room_hub" );

  ObjMultiSet(
  {
    { "obj_alley2_dlg_beggar2_1",           { event_mdown = private.dlg_alley2_beggar2_1 } },
    { "obj_alley2_dlg_beggar2_1_focus",     { event_mdown = private.dlg_alley2_beggar2_1 } },
    { "spr_hedge2_milk2",                   { event_mdown = private.get_milk2 } },
    { "spr_parkentrance2_crowbar2",         { event_mdown = private.get_crowbar2 } },
    { "spr_parkentrance2_brick2",           { event_mdown = private.get_brick2 } },
    { "spr_parkentrance2_pole",             { event_mdown = private.get_pikepole2 } },
    { "spr_parkentrance2_decanter",         { event_mdown = private.get_decanterwater2 } },
    { "spr_houseextension2_saw2",           { event_mdown = private.get_saw2 } },
    { "spr_houseextension2_emptysmoker2",   { event_mdown = private.get_emptysmoker2 } },
    { "spr_houseextension2_pyramidamulet2", { event_mdown = private.get_pyramidamulet2 } },
    { "spr_veranda2_pole2",                 { event_mdown = private.get_pole2 } },
    { "spr_veranda2_pipe2",                 { event_mdown = private.get_pipe2 } },
    { "spr_veranda2_rottenwood2",           { event_mdown = private.get_rottenwood2 } },
    { "spr_hedge2_homekey2",                { event_mdown = private.get_homekey2 } },
    { "spr_hedge2_streetlamp2",             { event_mdown = private.get_streetlamp2 } },
    { "obj_houseextension2_use_crowbar2",   { event_mdown = function() private.Houseextension2LockClk() end } },
    { "obj_houseextension2_use_lockpicks2", { event_mdown = function() private.Houseextension2BoxClk() end } },
    { "obj_parkentrance2_use_pole2",        { event_mdown = function() private.Parkentrance2GaffClk() end } },
    { "obj_parkentrance2_clk_handle",       { event_mdown = function() private.clk_parkentrance2_handle() end } },
    { "obj_parkentrance2_use_decanter2",    { event_mdown = function() private.Parkentrance2HandleClk() end } },
    { "obj_veranda2_use_homekey2",          { event_mdown = function() private.Veranda2DoorClick() end } },
    { "spr_alley2_collect_2_1",             { event_mdown = private.get_collect_2_1 } },
    { "spr_veranda2_screensaver_2_4",     { event_mdown = private.get_screensaver_2_4 } },      
    { "spr_houseextension2_screensaver_2_5",     { event_mdown = private.get_screensaver_2_5 } },  
    { "spr_hedge2_screensaver_2_6",     { event_mdown = private.get_screensaver_2_6 } },      

  } );
  local get_screensaver_2_4 = function ()

    ObjDelete( "spr_veranda2_screensaver_2_4" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_4", get_screensaver_2_4, private.room_objname );  
  local get_screensaver_2_5 = function ()

    ObjDelete( "spr_houseextension2_screensaver_2_5" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_5", get_screensaver_2_5, private.room_objname );  
  local get_screensaver_2_6 = function ()

    ObjDelete( "spr_hedge2_screensaver_2_6" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_6", get_screensaver_2_6, private.room_objname );  
   
  private.InitMiniHO();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_alley2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_alley2", update_game_mode_alley2, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function opn_alley2 () end;
  --------------------------------------------------------------------------------------------
  local opn_alley2 = function ()

    ObjDelete( "anm_alley2_abigail" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_alley2", opn_alley2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_1 = function ()

    ObjDelete( "spr_alley2_collect_2_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_2_1", get_collect_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_2 = function ()

    ObjDelete( "obj_alley2_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_2", get_morphobject_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crowbar2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crowbar2" ] =
  {
    type = "get",
    get_obj = "spr_parkentrance2_crowbar2",
    room = private.room_objname,
    zz = "zz_parkentrance2",
    zz_gate = "gzz_alley2_parkentrance2"
  };
  --------------------------------------------------------------------------------------------
  local get_crowbar2_inv = function ()

    int.InventoryItemAdd( "inv_crowbar2", "spr_parkentrance2_crowbar2" );

  end;
  local get_crowbar2_closezz = function ()

    ObjDelete( "gfx_parkentrance2_crowbar2" );

    if cmn.IsEventDone( "get_brick2") and 
       cmn.IsEventDone( "get_crowbar2") and 
       cmn.IsEventDone( "get_pikepole2") and
       cmn.IsEventDone( "get_decanterwater2") then
       
       ObjDelete( "gzz_alley2_parkentrance2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crowbar2", get_crowbar2_inv );
  cmn.AddSubscriber( "get_crowbar2", get_crowbar2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lighter2 () end;
  --------------------------------------------------------------------------------------------
  local get_lighter2_inv = function ()

    int.InventoryItemAdd( "inv_lighter2", "spr_alley2_lighter2" );
    
    if cmn.IsEventDone( "use_rottenwood2" ) then
      ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 1 } );
    end;    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lighter2", get_lighter2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_brick2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brick2" ] =
  {
    type = "get",
    get_obj = "spr_parkentrance2_brick2",
    room = private.room_objname,
    zz = "zz_parkentrance2",
    zz_gate = "gzz_alley2_parkentrance2"
  };
  --------------------------------------------------------------------------------------------
  local get_brick2_inv = function ()

    int.InventoryItemAdd( "inv_brick2", "spr_parkentrance2_brick2" );

  end;
  local get_brick2_closezz = function ()

    ObjDelete( "gfx_parkentrance2_brick2" );
    
    if cmn.IsEventDone( "get_brick2") and 
       cmn.IsEventDone( "get_crowbar2") and 
       cmn.IsEventDone( "get_pikepole2") and
       cmn.IsEventDone( "get_decanterwater2") then
       
       ObjDelete( "gzz_alley2_parkentrance2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_brick2", get_brick2_inv );
  cmn.AddSubscriber( "get_brick2", get_brick2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pikepole2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pikepole2" ] =
  {
    type = "get",
    get_obj = "obj_parkentrance2_gaff",
    room = private.room_objname,
    zz = "zz_parkentrance2",
    zz_gate = "gzz_alley2_parkentrance2"
  };
  --------------------------------------------------------------------------------------------
  local get_pikepole2_inv = function ()

    int.InventoryItemAdd( "inv_pikepole2", "obj_parkentrance_gaff_get" );

  end;
  local get_pikepole2_closezz = function ()
    
    if cmn.IsEventDone( "get_brick2") and 
       cmn.IsEventDone( "get_crowbar2") and 
       cmn.IsEventDone( "get_pikepole2") and
       cmn.IsEventDone( "get_decanterwater2") then
       
       ObjDelete( "gzz_alley2_parkentrance2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pikepole2", get_pikepole2_inv );
  cmn.AddSubscriber( "get_pikepole2", get_pikepole2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_decanterwater2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_decanterwater2" ] =
  {
    type = "get",
    get_obj = "obj_parkentrance2_decanterwater",
    room = private.room_objname,
    zz = "zz_parkentrance2",
    zz_gate = "gzz_alley2_parkentrance2"
  };
  --------------------------------------------------------------------------------------------
  local get_decanterwater2_inv = function ()

    int.InventoryItemAdd( "inv_decanterwater2", "obj_parkentrance2_decanterwater" );

  end;
  local get_decanterwater2_closezz = function ()

    ObjDelete( "gfx_parkentrance2_decanterwater2" );
    ObjDelete( "spr_alley2_decanter" );
    
    if cmn.IsEventDone( "get_brick2") and 
       cmn.IsEventDone( "get_crowbar2") and 
       cmn.IsEventDone( "get_pikepole2") and
       cmn.IsEventDone( "get_decanterwater2") then
       
       ObjDelete( "gzz_alley2_parkentrance2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_decanterwater2", get_decanterwater2_inv );
  cmn.AddSubscriber( "get_decanterwater2", get_decanterwater2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_saw2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_saw2" ] =
  {
    type = "get",
    get_obj = "spr_houseextension2_saw2",
    room = private.room_objname,
    zz = "zz_houseextension2",
    zz_gate = "gzz_alley2_houseextension2"
  };
  --------------------------------------------------------------------------------------------
  local get_saw2_inv = function ()

    int.InventoryItemAdd( "inv_saw2", "spr_houseextension2_saw2" );

  end;
  local get_saw2_closezz = function ()

    ObjDelete( "gfx_houseextension2_saw2" );
    ObjDelete( "spr_alley2_saw" );
    --ObjDelete( "gzz_alley2_houseextension2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_saw2", get_saw2_inv );
  cmn.AddSubscriber( "get_saw2", get_saw2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emptysmoker2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emptysmoker2" ] =
  {
    type = "get",
    get_obj = "spr_houseextension2_ho_1",
    room = private.room_objname,
    zz = "zz_houseextension2",
    zz_gate = "gzz_alley2_houseextension2"
  };
  --------------------------------------------------------------------------------------------
  local get_emptysmoker2_inv = function ()

    int.InventoryItemAdd( "inv_emptysmoker2", "spr_houseextension2_win" );
    ObjSet( "inv_emptysmoker2", { drag = false } );

  end;
  local get_emptysmoker2_closezz = function ()

    ObjDelete( "gfx_houseextension2_emptysmoker2" );
    ObjDelete( "obj_houseextension2_miniho" );
    
    if cmn.IsEventDone( "get_pyramidamulet2" ) then
      ObjDelete( "gzz_alley2_houseextension2" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_emptysmoker2", get_emptysmoker2_inv );
  cmn.AddSubscriber( "get_emptysmoker2", get_emptysmoker2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pyramidamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pyramidamulet2" ] =
  {
    type = "get",
    get_obj = "spr_houseextension2_pyramidamulet2",
    room = private.room_objname,
    zz = "zz_houseextension2",
    zz_gate = "gzz_alley2_houseextension2"
  };
  --------------------------------------------------------------------------------------------
  local get_pyramidamulet2_inv = function ()

    int.InventoryItemAdd( "inv_pyramidamulet2", "spr_houseextension2_pyramidamulet2" );

  end;
  local get_pyramidamulet2_closezz = function ()

    ObjDelete( "gfx_houseextension2_pyramidamulet2" );
    ObjDelete( "anm_alley2_guards" );

    if cmn.IsEventDone( "get_emptysmoker2" ) then
      ObjDelete( "gzz_alley2_houseextension2" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pyramidamulet2", get_pyramidamulet2_inv );
  cmn.AddSubscriber( "get_pyramidamulet2", get_pyramidamulet2_closezz, private.room_objname );
  cmn.AddSubscriber( "get_pyramidamulet2_inv", get_pyramidamulet2_inv );
  cmn.AddSubscriber( "get_pyramidamulet2_closezz", get_pyramidamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pole2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pole2" ] =
  {
    type = "get",
    get_obj = "spr_veranda2_pole2",
    room = private.room_objname,
    zz = "zz_veranda2",
    zz_gate = "gzz_alley2_veranda2"
  };
  --------------------------------------------------------------------------------------------
  local get_pole2_inv = function ()

    int.InventoryItemAdd( "inv_pole2", "spr_veranda2_pole2" );

  end;
  local get_pole2_closezz = function ()

    ObjDelete( "gfx_veranda2_pole2" );
    ObjDelete( "spr_alley2_pole" );
    ObjDelete( "spr_veranda2_pole2_shadow" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pole2", get_pole2_inv );
  cmn.AddSubscriber( "get_pole2", get_pole2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pipe2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pipe2" ] =
  {
    type = "get",
    get_obj = "spr_veranda2_pipe2",
    room = private.room_objname,
    zz = "zz_veranda2",
    zz_gate = "gzz_alley2_veranda2"
  };
  --------------------------------------------------------------------------------------------
  local get_pipe2_inv = function ()

    int.InventoryItemAdd( "inv_pipe2", "spr_veranda2_pipe2" );
    if cmn.IsEventDone( "get_emptysmoker2" ) then
      ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 1 } );
    end;

  end;
  local get_pipe2_closezz = function ()

    ObjDelete( "gfx_veranda2_pipe2" );
    ObjDelete( "spr_veranda2_over_pipe" );
    --ObjDelete( "gzz_alley2_veranda2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pipe2", get_pipe2_inv );
  cmn.AddSubscriber( "get_pipe2", get_pipe2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rottenwood2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rottenwood2" ] =
  {
    type = "get",
    get_obj = "spr_veranda2_rottenwood2",
    room = private.room_objname,
    zz = "zz_veranda2",
    zz_gate = "gzz_alley2_veranda2"
  };
  --------------------------------------------------------------------------------------------
  local get_rottenwood2_inv = function ()

    int.InventoryItemAdd( "inv_rottenwood2", "spr_veranda2_rottenwood2" );
    
    if cmn.IsEventDone( "clk_emptysmoker2_door_1" ) then
      ObjSet( "inv_emptysmoker2_plus_focus2", { alp = 1 } );
    end; 

  end;
  local get_rottenwood2_closezz = function ()

    ObjDelete( "gfx_veranda2_rottenwood2" );
    --ObjDelete( "gzz_alley2_veranda2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_rottenwood2", get_rottenwood2_inv );
  cmn.AddSubscriber( "get_rottenwood2", get_rottenwood2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_homekey2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_homekey2" ] =
  {
    type = "get",
    get_obj = "spr_hedge2_homekey2",
    room = private.room_objname,
    zz = "zz_hedge2",
    zz_gate = "gzz_alley2_hedge2"
  };
  --------------------------------------------------------------------------------------------
  local get_homekey2_inv = function ()

    int.InventoryItemAdd( "inv_homekey2", "spr_hedge2_homekey2" );

  end;
  local get_homekey2_closezz = function ()

    ObjDelete( "gfx_hedge2_homekey2" );
    ObjDelete( "spr_alley2_homekey" );
    
    if cmn.IsEventDone( "get_milk2" ) and
       cmn.IsEventDone( "get_homekey2" ) and
       cmn.IsEventDone( "get_streetlamp2" ) then

      ObjDelete( "gzz_alley2_hedge2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_homekey2", get_homekey2_inv );
  cmn.AddSubscriber( "get_homekey2", get_homekey2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_streetlamp2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_streetlamp2" ] =
  {
    type = "get",
    get_obj = "spr_hedge2_streetlamp2",
    room = private.room_objname,
    zz = "zz_hedge2",
    zz_gate = "gzz_alley2_hedge2"
  };
  --------------------------------------------------------------------------------------------
  local get_streetlamp2_inv = function ()

    int.InventoryItemAdd( "inv_streetlamp2", "spr_hedge2_streetlamp2" );

  end;
  local get_streetlamp2_closezz = function ()

    ObjDelete( "gfx_hedge2_streetlamp2" );
    ObjDelete( "anm_alley2_lantern" );

    if cmn.IsEventDone( "get_milk2" ) and
       cmn.IsEventDone( "get_homekey2" ) and
       cmn.IsEventDone( "get_streetlamp2" ) then

      ObjDelete( "gzz_alley2_hedge2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_streetlamp2", get_streetlamp2_inv );
  cmn.AddSubscriber( "get_streetlamp2", get_streetlamp2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_milk2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_milk2" ] =
  {
    type = "get",
    get_obj = "spr_hedge2_milk2",
    room = private.room_objname,
    zz = "zz_hedge2",
    zz_gate = "gzz_alley2_hedge2"
  };
  --------------------------------------------------------------------------------------------
  local get_milk2_inv = function ()

    int.InventoryItemAdd( "inv_milk2", "spr_hedge2_milk2" );

  end;
  local get_milk2_closezz = function ()

    ObjDelete( "gfx_hedge2_milk2" );

    if cmn.IsEventDone( "get_milk2" ) and
       cmn.IsEventDone( "get_homekey2" ) and
       cmn.IsEventDone( "get_streetlamp2" ) then

      ObjDelete( "gzz_alley2_hedge2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_milk2", get_milk2_inv );
  cmn.AddSubscriber( "get_milk2", get_milk2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_milk2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_milk2" ] =
  {
    type = "use",
    use_obj = "inv_milk2",
    use_place = "obj_alley2_use_milk2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local use_milk2_inv = function ()

    int.InventoryItemRemove( "inv_milk2" );

  end;
  local use_milk2_beg = function ()

    ObjDelete( "obj_alley2_use_milk2" );

  end;
  local use_milk2_end = function ()

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_milk2",     use_milk2_inv );
  cmn.AddSubscriber( "use_milk2",     use_milk2_beg, private.room_objname );
  cmn.AddSubscriber( "use_milk2",     use_milk2_end, private.room_objname );
  cmn.AddSubscriber( "use_milk2_inv", use_milk2_inv, private.room_objname );
  cmn.AddSubscriber( "use_milk2_beg", use_milk2_beg, private.room_objname );
  cmn.AddSubscriber( "use_milk2_end", use_milk2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pole2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pole2" ] =
  {
    type = "use",
    use_obj = "inv_pole2",
    use_place = "obj_parkentrance2_use_pole2",
    room = private.room_objname,
    zz = "zz_parkentrance2",
    zz_gate = "gzz_alley2_parkentrance2"
  };
  --------------------------------------------------------------------------------------------
  local use_pole2_inv = function ()

    int.InventoryItemRemove( "inv_pole2" );

  end;
  local use_pole2_beg = function ()

    ObjDelete( "obj_parkentrance2_use_pole2" );

  end;
  local use_pole2_end = function ()

    ObjDelete( "anm_parkentrance2_gaff_click" );
    ObjDelete( "anm_parkentrance2_use_pole" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pole2",     use_pole2_inv );
  cmn.AddSubscriber( "use_pole2",     use_pole2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pole2",     use_pole2_end, private.room_objname );
  cmn.AddSubscriber( "use_pole2_inv", use_pole2_inv, private.room_objname );
  cmn.AddSubscriber( "use_pole2_beg", use_pole2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pole2_end", use_pole2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_decanter2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_decanter2" ] =
  {
    type = "use",
    use_obj = "inv_decanter2",
    use_place = "obj_parkentrance2_use_decanter2",
    room = private.room_objname,
    zz = "zz_parkentrance2",
    zz_gate = "gzz_alley2_parkentrance2"
  };
  --------------------------------------------------------------------------------------------
  local use_decanter2_inv = function ()

    int.InventoryItemRemove( "inv_decanter2" );

  end;
  local use_decanter2_beg = function ()

    ObjDelete( "obj_parkentrance2_use_decanter2" );

  end;
  local use_decanter2_end = function ()

    ObjSet( "anm_parkentrance2_pump_use", { alp = 1 } );
    ObjSet( "anm_parkentrance2_pump_click", { alp = 0 } );
    ObjSet( "obj_parkentrance2_clk_handle", { input = true } );

    ObjSet( "spr_alley2_decanter", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_decanter2",     use_decanter2_inv );
  cmn.AddSubscriber( "use_decanter2",     use_decanter2_beg, private.room_objname );
  cmn.AddSubscriber( "use_decanter2",     use_decanter2_end, private.room_objname );
  cmn.AddSubscriber( "use_decanter2_inv", use_decanter2_inv, private.room_objname );
  cmn.AddSubscriber( "use_decanter2_beg", use_decanter2_beg, private.room_objname );
  cmn.AddSubscriber( "use_decanter2_end", use_decanter2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowbar2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crowbar2" ] =
  {
    type = "use",
    use_obj = "inv_crowbar2",
    use_place = "obj_houseextension2_use_crowbar2",
    room = private.room_objname,
    zz = "zz_houseextension2",
    zz_gate = "gzz_alley2_houseextension2"
  };
  --------------------------------------------------------------------------------------------
  local use_crowbar2_inv = function ()

    int.InventoryItemRemove( "inv_crowbar2" );

  end;
  local use_crowbar2_beg = function ()

    ObjDelete( "obj_houseextension2_use_crowbar2" );

  end;
  local use_crowbar2_end = function ()

    ObjDelete( "obj_houseextension2_close" );
    ObjSet( "obj_houseextension2_open", { input = true } );
    ObjSet( "obj_houseextension2_use_lockpicks2", { input = true } );
    ObjSet( "obj_houseextension2_open1", { alp = 1 } );
    
    ObjDelete( "anm_houseextension2_doors_open" );
    ObjDelete( "anm_houseextension2_lock_break" );
    ObjDelete( "anm_houseextension2_lock_click" );
    
    ObjDelete( "spr_alley2_lock" );
    ObjSet( "spr_alley2_houseextension_open_door", { alp = 1 } );
    ObjSet( "anm_houseextension2_doors_static", { playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowbar2",     use_crowbar2_inv );
  cmn.AddSubscriber( "use_crowbar2",     use_crowbar2_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar2",     use_crowbar2_end, private.room_objname );
  cmn.AddSubscriber( "use_crowbar2_inv", use_crowbar2_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowbar2_beg", use_crowbar2_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar2_end", use_crowbar2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockpicks2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockpicks2" ] =
  {
    type = "use",
    use_obj = "inv_lockpicks2",
    use_place = "obj_houseextension2_use_lockpicks2",
    room = private.room_objname,
    zz = "zz_houseextension2",
    zz_gate = "gzz_alley2_houseextension2"
  };
  --------------------------------------------------------------------------------------------
  local use_lockpicks2_inv = function ()

    int.InventoryItemRemove( "inv_lockpicks2" );

  end;
  local use_lockpicks2_beg = function ()

    ObjDelete( "obj_houseextension2_use_lockpicks2" );

  end;
  local use_lockpicks2_end = function ()

    ObjSet( "obj_houseextension2_box_open", { input = true } );
    ObjSet( "gfx_houseextension2_pyramidamulet2", { active = true } );
    ObjDelete( "obj_houseextension2_use_lockpicks2" );
    ObjDelete( "obj_houseextension2_box_close" );
    
    ObjDelete( "anm_houseextension2_casket_click" );
    ObjDelete( "anm_houseextension2_use_lockpicks" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockpicks2",     use_lockpicks2_inv );
  cmn.AddSubscriber( "use_lockpicks2",     use_lockpicks2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpicks2",     use_lockpicks2_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpicks2_inv", use_lockpicks2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpicks2_beg", use_lockpicks2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpicks2_end", use_lockpicks2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_saw2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_saw2" ] =
  {
    type = "use",
    use_obj = "inv_saw2",
    use_place = "obj_veranda2_use_saw2",
    room = private.room_objname,
    zz = "zz_veranda2",
    zz_gate = "gzz_alley2_veranda2"
  };
  --------------------------------------------------------------------------------------------
  local use_saw2_inv = function ()

    int.InventoryItemRemove( "inv_saw2" );

  end;
  local use_saw2_beg = function ()

    ObjDelete( "obj_veranda2_use_saw2" );

  end;
  local use_saw2_end = function ()

    ObjDelete( "anm_veranda2_saw" );
    ObjSet( "anm_veranda2_branch",
    {
      res = "assets/levels/level2/rm_alley2/zz_veranda2/anims/anm_branch_static_2",
      animfunc = "DoAnim",
      playing = true
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_saw2",     use_saw2_inv );
  cmn.AddSubscriber( "use_saw2",     use_saw2_beg, private.room_objname );
  cmn.AddSubscriber( "use_saw2",     use_saw2_end, private.room_objname );
  cmn.AddSubscriber( "use_saw2_inv", use_saw2_inv, private.room_objname );
  cmn.AddSubscriber( "use_saw2_beg", use_saw2_beg, private.room_objname );
  cmn.AddSubscriber( "use_saw2_end", use_saw2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_homekey2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_homekey2" ] =
  {
    type = "use",
    use_obj = "inv_homekey2",
    use_place = "obj_veranda2_use_homekey2",
    room = private.room_objname,
    zz = "zz_veranda2",
    zz_gate = "gzz_alley2_veranda2"
  };
  --------------------------------------------------------------------------------------------
  local use_homekey2_inv = function ()

    int.InventoryItemRemove( "inv_homekey2" );

  end;
  local use_homekey2_beg = function ()

    ObjDelete( "obj_veranda2_use_homekey2" );
    ObjDelete( "anm_veranda2_door" );

  end;
  local use_homekey2_end = function ()
    
    ObjSet( "grm_alley2_abighalehouse2", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_alley2_abighalehouse2_focus");
    end;
    ObjDelete( "gzz_alley2_veranda2" );
    
    ObjSet( "spr_alley2_veranda_open_door", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_homekey2",     use_homekey2_inv );
  cmn.AddSubscriber( "use_homekey2",     use_homekey2_beg, private.room_objname );
  cmn.AddSubscriber( "use_homekey2",     use_homekey2_end, private.room_objname );
  cmn.AddSubscriber( "use_homekey2_inv", use_homekey2_inv, private.room_objname );
  cmn.AddSubscriber( "use_homekey2_beg", use_homekey2_beg, private.room_objname );
  cmn.AddSubscriber( "use_homekey2_end", use_homekey2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pikepole2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pikepole2" ] =
  {
    type = "use",
    use_obj = "inv_pikepole2",
    use_place = "obj_hedge2_use_pikepole2",
    room = private.room_objname,
    zz = "zz_hedge2",
    zz_gate = "gzz_alley2_hedge2"
  };
  --------------------------------------------------------------------------------------------
  local use_pikepole2_inv = function ()

    int.InventoryItemRemove( "inv_pikepole2" );

  end;
  local use_pikepole2_beg = function ()

    ObjDelete( "obj_hedge2_use_pikepole2" );
    ObjDelete( "anm_hedge2_streetlamp" );

  end;
  local use_pikepole2_end = function ()

    ObjDelete( "anm_hedge2_pikepole" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pikepole2",     use_pikepole2_inv );
  cmn.AddSubscriber( "use_pikepole2",     use_pikepole2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pikepole2",     use_pikepole2_end, private.room_objname );
  cmn.AddSubscriber( "use_pikepole2_inv", use_pikepole2_inv, private.room_objname );
  cmn.AddSubscriber( "use_pikepole2_beg", use_pikepole2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pikepole2_end", use_pikepole2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_smoker2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_smoker2" ] =
  {
    type = "use",
    use_obj = "inv_smoker2",
    use_place = "obj_hedge2_use_smoker2",
    room = private.room_objname,
    zz = "zz_hedge2",
    zz_gate = "gzz_alley2_hedge2"
  };
  --------------------------------------------------------------------------------------------
  local use_smoker2_inv = function ()

    int.InventoryItemRemove( "inv_smoker2" );

  end;
  local use_smoker2_beg = function ()

    ObjDelete( "obj_hedge2_use_smoker2" );
    ObjDelete( "anm_hedge2_wasps" );

  end;
  local use_smoker2_end = function ()

    ObjSet( "obj_hedge2_use_pikepole2", { input = true } );
    ObjDelete( "anm_hedge2_smoker" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_smoker2",     use_smoker2_inv );
  cmn.AddSubscriber( "use_smoker2",     use_smoker2_beg, private.room_objname );
  cmn.AddSubscriber( "use_smoker2",     use_smoker2_end, private.room_objname );
  cmn.AddSubscriber( "use_smoker2_inv", use_smoker2_inv, private.room_objname );
  cmn.AddSubscriber( "use_smoker2_beg", use_smoker2_beg, private.room_objname );
  cmn.AddSubscriber( "use_smoker2_end", use_smoker2_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_parkentrance2_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_parkentrance2_handle" ] =
  {
    type = "click",
    clk_obj = "obj_parkentrance2_clk_handle",
    room = private.room_objname,
    zz = "zz_parkentrance2",
    zz_gate = "gzz_alley2_parkentrance2"
  };
  -----------------------------------------------
  local clk_parkentrance2_handle_inv = function ()

  end;
  local clk_parkentrance2_handle_beg = function ()
    
    ObjDelete( "obj_parkentrance2_clk_handle" );
    
  end;
  local clk_parkentrance2_handle_end = function ()

    ObjSet( "spr_parkentrance2_decanter", { input = true } );
    ObjSet( "gfx_parkentrance2_decanterwater2", { active = true } );
    
    ObjDelete( "anm_parkentrance2_pump_use" );
    
    ObjSet( "anm_parkentrance2_pump_click", { alp = 1 } );
    ObjSet( "obj_parkentrance2_decanterwater", { alp = 1 } );
    
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_parkentrance2_handle",     clk_parkentrance2_handle_inv );
  cmn.AddSubscriber( "clk_parkentrance2_handle",     clk_parkentrance2_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_parkentrance2_handle",     clk_parkentrance2_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_parkentrance2_handle_inv", clk_parkentrance2_handle_inv, private.room_objname );
  cmn.AddSubscriber( "clk_parkentrance2_handle_beg", clk_parkentrance2_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_parkentrance2_handle_end", clk_parkentrance2_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_alley2_beggar2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_alley2_beggar2_1" ] =
  {
    type = "click",
    clk_obj = "obj_alley2_dlg_beggar2_1_focus",
    room = private.room_objname,
  };
  -----------------------------------------------
  local dlg_alley2_beggar2_1_beg = function ()

    ObjDelete( "obj_alley2_dlg_beggar2_1" );

  end;
  -----------------------------------------------
  local dlg_alley2_beggar2_1_end = function ()

    ObjDelete( "dlg_alley2_beggar2_1" );
    ObjSet( "obj_alley2_use_milk2", { input = true } );

  end;

  cmn.AddSubscriber( "dlg_alley2_beggar2_1",     dlg_alley2_beggar2_1_beg );
  cmn.AddSubscriber( "dlg_alley2_beggar2_1",     dlg_alley2_beggar2_1_end );
  cmn.AddSubscriber( "dlg_alley2_beggar2_1_beg", dlg_alley2_beggar2_1_beg );
  cmn.AddSubscriber( "dlg_alley2_beggar2_1_end", dlg_alley2_beggar2_1_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_alley2_beggar2_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_alley2_beggar2_2_beg = function ()

  end;
  -----------------------------------------------
  local dlg_alley2_beggar2_2_end = function ()

    ObjDelete( "dlg_alley2_beggar2_2" );

  end;

  cmn.AddSubscriber( "dlg_alley2_beggar2_2",     dlg_alley2_beggar2_2_beg );
  cmn.AddSubscriber( "dlg_alley2_beggar2_2",     dlg_alley2_beggar2_2_end );
  cmn.AddSubscriber( "dlg_alley2_beggar2_2_beg", dlg_alley2_beggar2_2_beg );
  cmn.AddSubscriber( "dlg_alley2_beggar2_2_end", dlg_alley2_beggar2_2_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--********************************************************************************************************************* 
function private.get_screensaver_2_4()

  int.AddScreensaver( "spr_veranda2_screensaver_2_4" );

end;    
function private.get_screensaver_2_5()

  int.AddScreensaver( "spr_houseextension2_screensaver_2_5" );

end;    
function private.get_screensaver_2_6()

  int.AddScreensaver( "spr_hedge2_screensaver_2_6" );

end; 
-----------------------------------------------------------------------
function private.get_collect_2_1 ()

  int.AddCollectibles( "spr_alley2_collect_2_1" );

end;
-----------------------------------------------------------------------
function private.clk_parkentrance2_handle ()

  cmn.CallEventHandler( "clk_parkentrance2_handle_inv" );
  cmn.CallEventHandler( "clk_parkentrance2_handle_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_parkentrance2_handle" );
    cmn.CallEventHandler( "clk_parkentrance2_handle_end" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_fill_jug_column" );
  AnimPlay( "anm_parkentrance2_pump_use", "DoAnim", func_end ); 

end;
-----------------------------------------------------------------------
function private.get_crowbar2 ()

  cmn.SetEventDone( "get_crowbar2" );
  cmn.CallEventHandler( "get_crowbar2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_brick2") and 
     cmn.IsEventDone( "get_crowbar2") and 
     cmn.IsEventDone( "get_pikepole2") and
     cmn.IsEventDone( "get_decanterwater2") then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_lighter2 ()

  ObjSet( "spr_alley2_lighter2", { alp = 1 } );

  cmn.SetEventDone( "get_lighter2" );
  cmn.CallEventHandler( "get_lighter2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_brick2 ()

  cmn.SetEventDone( "get_brick2" );
  cmn.CallEventHandler( "get_brick2" );
  cmn.GetObjectSfx();
 
  if cmn.IsEventDone( "get_brick2") and 
     cmn.IsEventDone( "get_crowbar2") and 
     cmn.IsEventDone( "get_pikepole2") and
     cmn.IsEventDone( "get_decanterwater2") then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_pikepole2 ()

  cmn.SetEventDone( "get_pikepole2" );
  cmn.CallEventHandler( "get_pikepole2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_brick2") and 
     cmn.IsEventDone( "get_crowbar2") and 
     cmn.IsEventDone( "get_pikepole2") and
     cmn.IsEventDone( "get_decanterwater2") then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_decanterwater2 ()

  cmn.SetEventDone( "get_decanterwater2" );
  cmn.CallEventHandler( "get_decanterwater2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_brick2") and 
     cmn.IsEventDone( "get_crowbar2") and 
     cmn.IsEventDone( "get_pikepole2") and
     cmn.IsEventDone( "get_decanterwater2") then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_saw2 ()

  cmn.SetEventDone( "get_saw2" );
  cmn.CallEventHandler( "get_saw2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function public.get_emptysmoker2 ()
  
  if cmn.IsEventDone( "get_pyramidamulet2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_pyramidamulet2 ()

  cmn.CallEventHandler( "get_pyramidamulet2_inv" );
  cmn.GetObjectSfx();

  int.Lock( true );

  cmn.CloseSubRoom( true );

  private.GetPyramidamulet2Anim();

end;
-----------------------------------------------------------------------
function private.get_pole2 ()

  cmn.SetEventDone( "get_pole2" );
  cmn.CallEventHandler( "get_pole2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_pipe2 ()

  cmn.SetEventDone( "get_pipe2" );
  cmn.CallEventHandler( "get_pipe2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_rottenwood2 ()

  ObjSet( "spr_veranda2_rottenwood2", { alp = 1 } );

  cmn.SetEventDone( "get_rottenwood2" );
  cmn.CallEventHandler( "get_rottenwood2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_homekey2 ()

  ObjSet( "spr_hedge2_homekey2", { alp = 1 } );

  cmn.SetEventDone( "get_homekey2" );
  cmn.CallEventHandler( "get_homekey2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_milk2" ) and
     cmn.IsEventDone( "get_homekey2" ) and
     cmn.IsEventDone( "get_streetlamp2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_streetlamp2 ()

  ObjSet( "spr_hedge2_streetlamp2", { alp = 1 } );

  cmn.SetEventDone( "get_streetlamp2" );
  cmn.CallEventHandler( "get_streetlamp2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_milk2" ) and
     cmn.IsEventDone( "get_homekey2" ) and
     cmn.IsEventDone( "get_streetlamp2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_milk2 ()

  cmn.SetEventDone( "get_milk2" );
  cmn.CallEventHandler( "get_milk2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_milk2" ) and
     cmn.IsEventDone( "get_homekey2" ) and
     cmn.IsEventDone( "get_streetlamp2" ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_milk2 ()

  local item = "inv_milk2";

  if ( cmn.ApplyObj( item, "obj_alley2_use_milk2", true ) ) and
     ( cmn.IsEventDone( "dlg_alley2_beggar2_1" ) ) then

    cmn.CallEventHandler( "use_milk2_inv" );
    cmn.CallEventHandler( "use_milk2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_milk2" );
      cmn.CallEventHandler( "use_milk2_end" );
      private.dlg_alley2_beggar2_2();

    end;

    int.Lock( true );

    func_end();

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_pole2 ()

  local item = "inv_pole2";

  if ( cmn.ApplyObj( item, "gzz_alley2_parkentrance2", false ) ) and
     ( not cmn.IsEventDone( "use_pole2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_parkentrance2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_parkentrance2_use_pole2", true ) ) and
         ( not cmn.IsEventDone( "use_pole2" ) ) then

    cmn.CallEventHandler( "use_pole2_inv" );
    cmn.CallEventHandler( "use_pole2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_pole2" );
      cmn.CallEventHandler( "use_pole2_end" );
      private.get_pikepole2();

    end;

    int.Lock( true );
    ObjSet( "anm_parkentrance2_gaff_click", { alp = 0 } );
    ObjSet( "anm_parkentrance2_use_pole", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_part_pike_gates" );
    AnimPlay( "anm_parkentrance2_use_pole", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_decanter2 ()

  local item = "inv_decanter2";

  if ( cmn.ApplyObj( item, "gzz_alley2_parkentrance2", false ) ) and
     ( not cmn.IsEventDone( "use_decanter2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_parkentrance2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_parkentrance2_use_decanter2", true ) ) and
         ( not cmn.IsEventDone( "use_decanter2" ) ) then

    cmn.CallEventHandler( "use_decanter2_inv" );
    cmn.CallEventHandler( "use_decanter2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_decanter2" );
      cmn.CallEventHandler( "use_decanter2_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_put_jug_column" );
    ObjAnimate( "anm_parkentrance2_pump_use", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0
    } );
    ObjAnimate( "anm_parkentrance2_pump_click", "alp", 0, 0, func_end,
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_crowbar2 ()

  local item = "inv_crowbar2";

  if ( cmn.ApplyObj( item, "gzz_alley2_houseextension2", false ) ) and
     ( not cmn.IsEventDone( "use_crowbar2" ) ) and 
       cmn.IsEventDone( "get_saw2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_houseextension2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_houseextension2_use_crowbar2", true ) ) and
         ( not cmn.IsEventDone( "use_crowbar2" ) ) and 
           cmn.IsEventDone( "get_saw2" ) then

    cmn.CallEventHandler( "use_crowbar2_inv" );
    cmn.CallEventHandler( "use_crowbar2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_crowbar2" );
        cmn.CallEventHandler( "use_crowbar2_end" );
        int_button_mini_ho.Show( "get_emptysmoker2", "houseextension2", 4, "spr_houseextension2_emptysmoker_panel", private.mini_ho_array );
        
      end;
      
      AnimPlay( "anm_houseextension2_doors_open", "DoAnim", func_end1 );

    end;

    int.Lock( true );
    
    ObjSet( "anm_houseextension2_lock_break", { alp = 1 } );
    ObjSet( "anm_houseextension2_lock_click", { alp = 0 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_nailpuller" );
    AnimPlay( "anm_houseextension2_lock_break", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_lockpicks2 ()

  local item = "inv_lockpicks2";

  if ( cmn.ApplyObj( item, "gzz_alley2_houseextension2", false ) ) and
     ( not cmn.IsEventDone( "use_lockpicks2" ) ) and 
       cmn.IsEventDone( "use_crowbar2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_houseextension2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_houseextension2_use_lockpicks2", true ) ) and
         ( not cmn.IsEventDone( "use_lockpicks2" ) ) and 
           cmn.IsEventDone( "use_crowbar2" ) then

    cmn.CallEventHandler( "use_lockpicks2_inv" );
    cmn.CallEventHandler( "use_lockpicks2_beg" );

    local func_end = function ()
      
      int.Lock( false );
      cmn.SetEventDone( "use_lockpicks2" );
      cmn.CallEventHandler( "use_lockpicks2_end" );
        
    end;

    int.Lock( true );
    ObjSet( "anm_houseextension2_use_lockpicks", { alp = 1 } );
    ObjSet( "anm_houseextension2_casket_click", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_chest_lockpick" );
    AnimPlay( "anm_houseextension2_use_lockpicks", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_saw2 ()

  local item = "inv_saw2";

  if ( cmn.ApplyObj( item, "gzz_alley2_veranda2", false ) ) and
     ( not cmn.IsEventDone( "use_saw2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_veranda2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_veranda2_use_saw2", true ) ) and
         ( not cmn.IsEventDone( "use_saw2" ) ) then

    cmn.CallEventHandler( "use_saw2_inv" );
    cmn.CallEventHandler( "use_saw2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_saw2" );
      cmn.CallEventHandler( "use_saw2_end" );
      private.get_rottenwood2();

      ObjSet( "anm_veranda2_branch", { alp = 1 } );

    end;

    int.Lock( true );

    ObjSet( "anm_veranda2_branch", { alp = 0 } );
    ObjSet( "anm_veranda2_saw",    { alp = 1 } );

    AnimStop( "anm_veranda2_branch" );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_saw_branch" );
    AnimPlay( "anm_veranda2_saw", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_homekey2 ()

  local item = "inv_homekey2";

  if ( cmn.ApplyObj( item, "gzz_alley2_veranda2", false ) ) and
     ( not cmn.IsEventDone( "use_homekey2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_veranda2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_veranda2_use_homekey2", true ) ) and
         ( not cmn.IsEventDone( "use_homekey2" ) ) then

    cmn.CallEventHandler( "use_homekey2_inv" );
    cmn.CallEventHandler( "use_homekey2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_homekey2" );
      cmn.CallEventHandler( "use_homekey2_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );

    ObjSet( "anm_veranda2_homekey", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_door_zz_veranda2" );
    AnimPlay( "anm_veranda2_homekey", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_pikepole2 ()

  local item = "inv_pikepole2";

  if ( cmn.ApplyObj( item, "gzz_alley2_hedge2", false ) ) and
     ( not cmn.IsEventDone( "use_pikepole2" ) ) and 
       cmn.IsEventDone( "use_smoker2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hedge2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hedge2_use_pikepole2", true ) ) and
         ( not cmn.IsEventDone( "use_pikepole2" ) ) and 
           cmn.IsEventDone( "use_smoker2" ) then

    cmn.CallEventHandler( "use_pikepole2_inv" );
    cmn.CallEventHandler( "use_pikepole2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_pikepole2" );
      cmn.CallEventHandler( "use_pikepole2_end" );
      private.get_homekey2();
      private.get_streetlamp2();

    end;

    int.Lock( true );

    ObjSet( "anm_hedge2_pikepole", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_lamp_pike" );
    AnimPlay( "anm_hedge2_pikepole", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_smoker2 ()

  local item = "inv_smoker2";

  if ( cmn.ApplyObj( item, "gzz_alley2_hedge2", false ) ) and
     ( not cmn.IsEventDone( "use_smoker2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hedge2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hedge2_use_smoker2", true ) ) and
         ( not cmn.IsEventDone( "use_smoker2" ) ) then

    cmn.CallEventHandler( "use_smoker2_inv" );
    cmn.CallEventHandler( "use_smoker2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_smoker2" );
      cmn.CallEventHandler( "use_smoker2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_hedge2_smoker", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_pumper" );
    AnimPlay( "anm_hedge2_smoker", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.dlg_alley2_beggar2_1 ()

  local func_end = function ()

    cmn.SetEventDone( "dlg_alley2_beggar2_1" );
    cmn.CallEventHandler( "dlg_alley2_beggar2_1_end" );
    cmn.ShowBbt( "bbt_alley2_after_dlg_beggar_1" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_alley2_beggar2_1_beggar_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "anm_alley2_beggar";
    common_impl.DialogCharacterStart( "beggar2_1", "alley2", 3, nil, nil, true, func_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_alley2_beggar2_1_beg" );
  ObjAttach( "dlg_alley2_beggar2_1", GetCurrentRoom() );  

  ObjAnimate( "anm_alley2_beggar2_1_beggar_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.dlg_alley2_beggar2_2 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_lighter2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_alley2_beggar2_2_beggar_static", { alp = 0 } );
    AnimStop( "anm_alley2_beggar2_2_beggar_static" );

    ObjAnimate( "anm_alley2_beggar2_2_beggar_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    if ( func_end ) then

      func_end();

    end;

    cmn.SetEventDone( "get_lighter2" );
    cmn.SetEventDone( "dlg_alley2_beggar2_2" );
    cmn.ShowBbt( "bbt_alley2_after_dlg_beggar_2" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_alley2_beggar2_2_beggar_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "anm_alley2_beggar";
    common_impl.DialogCharacterStart( "beggar2_2", "alley2", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_alley2_beggar2_2_beg" );
  ObjAttach( "dlg_alley2_beggar2_2", GetCurrentRoom() );  

  ObjAnimate( "anm_alley2_beggar2_2_beggar_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
----*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "beggar2_2" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_alley2_beggar2_2_beggar_static" );
        AnimPlay( "anm_alley2_beggar2_2_beggar_give", "DoAnim", "" );

      end;

      ObjAnimate( "anm_alley2_beggar2_2_beggar_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.0, 3, 0.0,
      } );

      ObjAnimate( "anm_alley2_beggar2_2_beggar_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.0, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.Alley2AbigailAnim ()
  
  int.Lock( true );

  local mas_widgets = {
     InterfaceWidget_BtnHint
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_BtnMap   
  };

  if ( IsCollectorsEdition() ) then

    mas_widgets = {
       InterfaceWidget_BtnHint
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_BtnGuide    
    };

  end;

  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[ i ], false, true, 0.3 ); 

  end;

  cmn.StopAllMus();
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgdescent2_down_win", 0, 0 );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_lvl2_abigail_1_voc", 0, 0 );


  ObjSet( "obj_alley2_gates", { visible = false } );
  interface.DialogVideoShow( "", 1, function() private.Alley2AbigailAnim_End( "skip" ); end, 0 );
  AnimPlay( "anm_alley2_abigail", "DoAnim", private.Alley2AbigailAnim_End );

  local func_subtitle_1 = function ()

    interface.DialogVideoSubtitleShow( "str_alley2_abigail_1" );  

  end;

  local func_subtitle_2 = function ()

    interface.DialogVideoSubtitleShow( "str_alley2_abigail_2" );  

  end;

  local func_subtitle_end = function ()

    interface.DialogVideoSubtitleHide();  

  end;

  cmn.WaitAndRun( func_subtitle_1, 4.0 );
  cmn.WaitAndRun( func_subtitle_end, 7.8 );
  cmn.WaitAndRun( func_subtitle_2, 8.1 );
  cmn.WaitAndRun( func_subtitle_end, 15.5 );
  
end;
--*********************************************************************************************************************
function private.Alley2AbigailAnim_End ( skip ) 
 
  local mas_widgets = {
     InterfaceWidget_BtnHint
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_BtnMap   
  };

  if ( IsCollectorsEdition() ) then

    mas_widgets = {
       InterfaceWidget_BtnHint
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_BtnGuide    
    };

  end;
  
  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[ i ], true, true, 0.3 ); 

  end;
  
  interface.DialogVideoHide();
  --interface.DialogVideoSubtitleHide();
  ObjSet( "obj_alley2_gates", { visible = true } );
  
  cmn.SetEventDone( "opn_alley2" );
  cmn.CallEventHandler( "opn_alley2" );

  cmn.ShowBbt( "bbt_alley2_abigail" );
  interface.KeyTaskDone( true, "task_2_2" );

  int.Lock( false );
  
  if skip then

    cmn.StopAudio( "sfx", "audio/level2/sfx/aud_mg_mgdescent2_down_win", 0.2 );
    cmn.StopAudio( "voc", "audio/level2/voc/aud_lvl2_abigail_1_voc", 0.2 );
    
  end; 

  --cmn.PlayMusEnv( "common/audio/aud_danger2_mus" );  
  
end; 
--*********************************************************************************************************************
function private.GetPyramidamulet2Anim ()
  
  int.Lock( true );

  local mas_widgets = {
     InterfaceWidget_BtnHint
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_BtnMap   
  };

  if ( IsCollectorsEdition() ) then

    mas_widgets = {
       InterfaceWidget_BtnHint
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_BtnGuide    
    };

  end;

  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[ i ], false, true, 0.3 ); 

  end;

  cmn.StopAllMus();
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_guards_attention_anim", 0, 0 );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_lvl_2_guard_2_voc", 0, 0 );


  ObjSet( "obj_alley2_gates", { visible = false } );
  interface.DialogVideoShow( "", 1, function() private.GetPyramidamulet2Anim_End( "skip" ); end, 0 );
  ObjSet( "anm_alley2_guards", { alp = 1 } );
  AnimPlay( "anm_alley2_guards", "DoAnim", private.GetPyramidamulet2Anim_End );

  local func_subtitle = function ()

    interface.DialogVideoSubtitleShow( "str_alley2_guards" );  

  end;

  cmn.WaitAndRun( func_subtitle, 0.3 );

end;
----*********************************************************************************************************************
function private.GetPyramidamulet2Anim_End ( skip ) 
 
  local mas_widgets = {
     InterfaceWidget_BtnHint
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_BtnMap   
  };

  if ( IsCollectorsEdition() ) then

    mas_widgets = {
       InterfaceWidget_BtnHint
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_BtnGuide    
    };

  end;
  
  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[ i ], true, true, 0.3 ); 

  end;
  
  interface.DialogVideoHide();
  interface.DialogVideoSubtitleHide();
  ObjSet( "obj_alley2_gates", { visible = true } );
  
  cmn.SetEventDone( "get_pyramidamulet2" );
  cmn.CallEventHandler( "get_pyramidamulet2_closezz" );
  cmn.ShowBbt( "bbt_alley2_guards" );

  int.Lock( false );
  
  if skip then

    cmn.StopAudio( "sfx", "audio/level2/sfx/aud_loc_guards_attention_anim", 0.2 );
    cmn.StopAudio( "voc", "audio/level2/voc/aud_lvl_2_guard_2_voc", 0.2 );
    
  end; 

  common_impl.StopMusEnv( false );
  cmn.PlayAudio( "mus", "audio/aud_action_crowd_1", nil, nil, 94 );
  
end; 
--*********************************************************************************************************************
function private.opn_alley2 ()

  if not ( cmn.IsEventDone( "opn_alley2" ) ) then

    private.Alley2AbigailAnim();

  end;

  if ( cmn.IsEventDone( "use_milk2" ) ) and
     ( not cmn.IsEventDone( "dlg_alley2_beggar2_2" ) ) then

    private.dlg_alley2_beggar2_2();

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_alley2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_alley2_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_alley2();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_crowbar2" );
  int.AddedTaskMap( private.room_objname, "get_lighter2",                            { "dlg_alley2_beggar2_2" } );
  int.AddedTaskMap( private.room_objname, "get_brick2" );
  int.AddedTaskMap( private.room_objname, "get_pikepole2",                           { "use_pole2" } );
  int.AddedTaskMap( private.room_objname, "get_decanterwater2",                      { "clk_parkentrance2_handle" } );
  int.AddedTaskMap( private.room_objname, "get_saw2" );
  int.AddedTaskMap( private.room_objname, "get_emptysmoker2",                        { "use_crowbar2" } );
  int.AddedTaskMap( private.room_objname, "get_pyramidamulet2",                      { "use_lockpicks2" } );
  int.AddedTaskMap( private.room_objname, "get_pole2" );
  int.AddedTaskMap( private.room_objname, "get_pipe2" );
  int.AddedTaskMap( private.room_objname, "get_rottenwood2",                         { "use_saw2" } );
  int.AddedTaskMap( private.room_objname, "get_homekey2",                            { "use_pikepole2" } );
  int.AddedTaskMap( private.room_objname, "get_streetlamp2",                         { "use_pikepole2" } );
  int.AddedTaskMap( private.room_objname, "get_milk2" );

  int.AddedTaskMap( private.room_objname, "use_milk2",                               { "get_milk2" } );
  int.AddedTaskMap( private.room_objname, "use_pole2",                               { "get_pole2" } );
  int.AddedTaskMap( private.room_objname, "use_decanter2",                           { "get_decanter2" } );
  int.AddedTaskMap( private.room_objname, "use_crowbar2",                            { "get_saw2", "get_crowbar2" } );
  int.AddedTaskMap( private.room_objname, "use_lockpicks2",                          { "get_lockpicks2", "use_crowbar2" } );
  int.AddedTaskMap( private.room_objname, "use_saw2",                                { "get_saw2" } );
  int.AddedTaskMap( private.room_objname, "use_homekey2",                            { "get_homekey2" } );
  int.AddedTaskMap( private.room_objname, "use_pikepole2",                           { "use_smoker2", "get_pikepole2" } );
  int.AddedTaskMap( private.room_objname, "use_smoker2",                             { "get_smoker2" } );

  int.AddedTaskMap( private.room_objname, "dlg_alley2_beggar2_1" );
  int.AddedTaskMap( private.room_objname, "dlg_alley2_beggar2_2",                    { "use_milk2" } );

  int.AddedTaskMap( private.room_objname, "clk_parkentrance2_handle",                { "use_decanter2" } );

  int.AddedTaskMap( private.room_objname, "opn_abighalehouse2",                      { "use_homekey2" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_houseextension2" );
  -------------------------------------------------
  function zz_houseextension2.PreOpen ()

   if cmn.IsEventDone( "use_crowbar2" ) and not
      cmn.IsEventDone( "get_emptysmoker2" ) then
     int_button_mini_ho.Show( "get_emptysmoker2", "houseextension2", 4, "spr_houseextension2_emptysmoker_panel", private.mini_ho_array ); 
   end;       
       
  end;  
  -------------------------------------------------
  function zz_houseextension2.PreClose()

    if cmn.IsEventDone( "use_crowbar2" ) and not
       cmn.IsEventDone( "get_emptysmoker2" ) then
      int_button_mini_ho.Hide(); 
    end;        
       
  end; 
 -------------------------------------------------
 
end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitMiniHO ()
  
  private.mini_ho_array = { 
                            "spr_houseextension2_ho_1", 
                            "spr_houseextension2_ho_2", 
                            "spr_houseextension2_ho_3", 
                            "spr_houseextension2_ho_4", 
                          };

  for i = 1, #private.mini_ho_array do

    ObjSet( private.mini_ho_array[ i ], { 
                    event_mdown = function() 
                                    int_button_mini_ho.MiniHoTaskFind( "get_emptysmoker2", "houseextension2", private.mini_ho_array[ i ], 4, "" );
                                  end,
                    event_menter = function () cmn.SetCursor( CURSOR_GET );  end,
                    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end  } );

  end;
      
end;
--*********************************************************************************************************************
function private.Houseextension2LockClk ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_houseextension2_use_crowbar2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_lock_gate" );
  AnimPlay( "anm_houseextension2_lock_click", "DoAnim", func_end ); 
    
end;
--*********************************************************************************************************************
function private.Houseextension2BoxClk ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_houseextension2_use_lockpicks2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_box_inside_gate" );
  AnimPlay( "anm_houseextension2_casket_click", "DoAnim", func_end ); 
    
end;
--*********************************************************************************************************************
function private.Parkentrance2GaffClk ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_parkentrance2_use_pole2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_stick_pike" );
  AnimPlay( "anm_parkentrance2_gaff_click", "DoAnim", func_end ); 
    
end;
--*********************************************************************************************************************
function private.Parkentrance2HandleClk ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_parkentrance2_use_decanter2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_column" );
  AnimPlay( "anm_parkentrance2_pump_click", "DoAnim", func_end ); 
    
end;
--*********************************************************************************************************************
function private.Veranda2DoorClick ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_veranda2_use_homekey2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_door_house" );
  AnimPlay( "anm_veranda2_door", "DoAnim", func_end ); 
    
end;
--*********************************************************************************************************************