-- name=rm_neartower2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_neartower2";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_well2", "room_hub" );
  ObjAttach( "zz_workshopdoor2", "room_hub" );
  ObjAttach( "zz_towerdoor2", "room_hub" );
  ObjAttach( "zz_precipice2", "room_hub" );
  ObjAttach( "zz_travelingbag2", "room_hub" );
  ObjAttach( "zz_tunnelentrance2", "room_hub" );  

  ObjMultiSet(
  {
    { "spr_travelingbag2_staramulet2",      { event_mdown = private.get_staramulet2 } },
    { "spr_workshopdoor2_figurine2",        { event_mdown = private.get_figurine2 } },
    { "spr_well2_mosaicpart2",              { event_mdown = private.get_mosaicpart2 } },
    { "spr_well2_ring2_1",                  { event_mdown = private.get_ring2_1 } },
    { "obj_well2_talisman2",                { event_mdown = private.get_talisman2 } },
    { "spr_well2_temporaryecho2_1",         { event_mdown = private.get_temporaryecho2_1 } },
    { "spr_travelingbag2_handle2",          { event_mdown = private.get_handle2 } },
    { "spr_towerdoor2_keypiece2_2",         { event_mdown = private.get_keypiece2_2 } },
    { "spr_towerdoor2_brokenamulet2",       { event_mdown = private.get_brokenamulet2 } },
    { "spr_precipice2_wingsamulet2",        { event_mdown = private.get_snakesamulet2_2 } },
    { "spr_precipice2_temporaryecho2_3",    { event_mdown = private.get_temporaryecho2_3 } },
    { "spr_precipice2_sunamulet2",          { event_mdown = private.get_sunamulet2 } },
    { "spr_travelingbag2_astronomycircle2", { event_mdown = private.get_astronomycircle2 } },
    { "obj_travelingbag2_boltcutter_get",   { event_mdown = private.get_boltcutter2 } },
    { "obj_neartower2_use_scissors2",       { event_mdown = private.NeartowerBushesClick } },
    { "obj_towerdoor2_use_tweezers2",       { event_mdown = function() private.TowerdoorKeypieceClk() end } },
    { "obj_travelingbag2_use_dagger2",      { event_mdown = function() private.TravelingbagCaseClk() end } },
    { "obj_workshopdoor2_use_axe2",         { event_mdown = function() private.WorkshopdoorBoardsClk() end } },
    { "obj_well2_use_pigeonamulet2",        { event_mdown = function() private.WellCashClk() end } },
    { "obj_precipice2_use_astronomycircle2",{ event_mdown = function() private.Precipice2CircleClick() end } },
    { "obj_travelingbag2_use_figurine2",    { event_mdown = function() private.Travelingbag2Clk() end } },
    { "obj_towerdoor2_use_handle2",         { event_mdown = function() private.TowerdoorAxebladeClk() end } },
    { "spr_well2_screensaver_2_7",     { event_mdown = private.get_screensaver_2_7 } },                      
  } );
  local get_screensaver_2_7 = function ()

    ObjDelete( "spr_well2_screensaver_2_7" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_7", get_screensaver_2_7, private.room_objname );  
      
  private.Precipice2Init();
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_neartower2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_neartower2", update_game_mode_neartower2, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_3 = function ()

    ObjDelete( "obj_neartower2_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_3", get_morphobject_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurine2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurine2" ] =
  {
    type = "get",
    get_obj = "spr_workshopdoor2_figurine2",
    room = private.room_objname,
    zz = "zz_workshopdoor2",
    zz_gate = "gzz_neartower2_workshopdoor2"
  };
  --------------------------------------------------------------------------------------------
  local get_figurine2_inv = function ()

    int.InventoryItemAdd( "inv_figurine2", "spr_workshopdoor2_figurine2" );

  end;
  local get_figurine2_closezz = function ()

    ObjDelete( "gfx_workshopdoor2_figurine2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_figurine2", get_figurine2_inv );
  cmn.AddSubscriber( "get_figurine2", get_figurine2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spiralamulet2 () end;
  --------------------------------------------------------------------------------------------
  local get_spiralamulet2_inv = function ()

    int.InventoryItemAdd( "inv_spiralamulet2", "spr_neartower2_spiralamulet2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_spiralamulet2", get_spiralamulet2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_mosaicpart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mosaicpart2" ] =
  {
    type = "get",
    get_obj = "spr_well2_mosaicpart2",
    room = private.room_objname,
    zz = "zz_well2",
    zz_gate = "gzz_neartower2_well2"
  };
  --------------------------------------------------------------------------------------------
  local get_mosaicpart2_inv = function ()

    int.InventoryItemAdd( "inv_mosaicpart2", "spr_well2_mosaicpart2" );

  end;
  local get_mosaicpart2_closezz = function ()

    ObjDelete( "gfx_well2_mosaicpart2" );
    ObjDelete( "spr_neartower2_mosaicpart" );
    
    if cmn.IsEventDone( "get_ring2_1" ) and 
       cmn.IsEventDone( "get_talisman2" ) and 
       cmn.IsEventDone( "get_temporaryecho2_1" ) then
       
      ObjDelete( "gzz_neartower2_well2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mosaicpart2", get_mosaicpart2_inv );
  cmn.AddSubscriber( "get_mosaicpart2", get_mosaicpart2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ring2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ring2_1" ] =
  {
    type = "get",
    get_obj = "spr_well2_ring2_1",
    room = private.room_objname,
    zz = "zz_well2",
    zz_gate = "gzz_neartower2_well2"
  };
  --------------------------------------------------------------------------------------------
  local get_ring2_1_inv = function ()

    int.InventoryItemAdd( "inv_ring2", "spr_well2_ring2_1", "assets/levels/level2/rm_neartower2/zz_well2/inv/inv_ring2_1" );
    level2_inv.CheckRing2( 1 );

  end;
  local get_ring2_1_closezz = function ()

    ObjDelete( "gfx_well2_ring2_1" );
    ObjDelete( "spr_neartower2_ring" );
    
    if cmn.IsEventDone( "get_mosaicpart2" ) and 
       cmn.IsEventDone( "get_talisman2" ) and 
       cmn.IsEventDone( "get_temporaryecho2_1" ) then
       
      ObjDelete( "gzz_neartower2_well2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_ring2_1", get_ring2_1_inv );
  cmn.AddSubscriber( "get_ring2_1", get_ring2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_talisman2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_talisman2" ] =
  {
    type = "get",
    get_obj = "obj_well2_talisman2",
    room = private.room_objname,
    zz = "zz_well2",
    zz_gate = "gzz_neartower2_well2"
  };
  --------------------------------------------------------------------------------------------
  local get_talisman2_inv = function ()

    int.InventoryItemAdd( "inv_talisman2", "obj_well2_talisman2" );

  end;
  local get_talisman2_closezz = function ()

    ObjDelete( "gfx_well2_talisman2" );
    ObjDelete( "vid_well2_talisman_anim" );

    if cmn.IsEventDone( "get_mosaicpart2" ) and 
       cmn.IsEventDone( "get_ring2_1" ) and 
       cmn.IsEventDone( "get_temporaryecho2_1" ) then
       
      ObjDelete( "gzz_neartower2_well2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_talisman2", get_talisman2_inv );
  cmn.AddSubscriber( "get_talisman2", get_talisman2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_temporaryecho2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_temporaryecho2_1" ] =
  {
    type = "get",
    get_obj = "spr_well2_temporaryecho2_1",
    room = private.room_objname,
    zz = "zz_well2",
    zz_gate = "gzz_neartower2_well2"
  };
  --------------------------------------------------------------------------------------------
  local get_temporaryecho2_1_inv = function ()

    int.InventoryItemAdd( "inv_spiralamulet2", "spr_well2_temporaryecho2_1" );
    level2_inv.CheckSpiralamulet2();
    
    ObjSet( "obj_willow2_spiralamulet", { alp = 1 } );
    ObjSet( "obj_willow2_use_spiralamulet2_2", { input = true } );    

  end;
  local get_temporaryecho2_1_closezz = function ()

    ObjDelete( "gfx_well2_temporaryecho2_1" );
    
    if cmn.IsEventDone( "get_mosaicpart2" ) and 
       cmn.IsEventDone( "get_ring2_1" ) and 
       cmn.IsEventDone( "get_talisman2" ) then
       
      ObjDelete( "gzz_neartower2_well2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_temporaryecho2_1", get_temporaryecho2_1_inv );
  cmn.AddSubscriber( "get_temporaryecho2_1", get_temporaryecho2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_temporaryecho2_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_temporaryecho2_3" ] =
  {
    type = "get",
    get_obj = "spr_precipice2_temporaryecho2_3",
    room = private.room_objname,
    zz = "zz_precipice2",
    zz_gate = "gzz_neartower2_precipice2"
  };
  --------------------------------------------------------------------------------------------
  local get_temporaryecho2_3_inv = function ()

    int.InventoryItemAdd( "inv_spiralamulet2", "spr_precipice2_temporaryecho2_3" );
    level2_inv.CheckSpiralamulet2();
    
    ObjSet( "anm_memorial2_hand", { alp = 1 } );
    ObjSet( "obj_memorial2_use_spiralamulet2_4", { input = true } );

  end;
  local get_temporaryecho2_3_closezz = function ()

    ObjDelete( "gfx_precipice2_temporaryecho2_3" );
    
    if cmn.IsEventDone( "get_snakesamulet2_2" ) and
       cmn.IsEventDone( "get_sunamulet2" ) then
      ObjDelete( "gzz_neartower2_precipice2" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_temporaryecho2_3", get_temporaryecho2_3_inv );
  cmn.AddSubscriber( "get_temporaryecho2_3", get_temporaryecho2_3_closezz, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_handle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle2" ] =
  {
    type = "get",
    get_obj = "spr_travelingbag2_handle2",
    room = private.room_objname,
    zz = "zz_travelingbag2",
    zz_gate = "gzz_neartower2_travelingbag2"
  };
  --------------------------------------------------------------------------------------------
  local get_handle2_inv = function ()

    int.InventoryItemAdd( "inv_handle2", "spr_travelingbag2_handle2" );

  end;
  local get_handle2_closezz = function ()

    ObjDelete( "gfx_travelingbag2_handle2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_handle2", get_handle2_inv );
  cmn.AddSubscriber( "get_handle2", get_handle2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_keypiece2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_keypiece2_2" ] =
  {
    type = "get",
    get_obj = "spr_towerdoor2_keypiece2_2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local get_keypiece2_2_inv = function ()

    int.InventoryItemAdd( "inv_keypiece2", "obj_towerdoor2_keypiece", "assets/levels/level2/rm_abighalehouse2/zz_writingdesk2/inv/inv_keypiece2_2" );
    level2_inv.CheckKeypiece2( 2 );

  end;
  local get_keypiece2_2_closezz = function ()

    ObjDelete( "gfx_towerdoor2_keypiece2_2" );

    --ObjDelete( "gzz_neartower2_towerdoor2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_keypiece2_2", get_keypiece2_2_inv );
  cmn.AddSubscriber( "get_keypiece2_2", get_keypiece2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenamulet2" ] =
  {
    type = "get",
    get_obj = "spr_towerdoor2_brokenamulet2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local get_brokenamulet2_inv = function ()

    int.InventoryItemAdd( "inv_brokenamulet2", "spr_towerdoor2_brokenamulet2" );

  end;
  local get_brokenamulet2_closezz = function ()

    ObjDelete( "gfx_towerdoor2_brokenamulet2" );
    --ObjDelete( "gzz_neartower2_towerdoor2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_brokenamulet2", get_brokenamulet2_inv );
  cmn.AddSubscriber( "get_brokenamulet2", get_brokenamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_axe2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_axe2" ] =
  {
    type = "get",
    get_obj = "spr_towerdoor2_axe2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local get_axe2_inv = function ()

    int.InventoryItemAdd( "inv_axe2", "spr_towerdoor2_axe2" );

  end;
  local get_axe2_closezz = function ()

    ObjDelete( "gfx_towerdoor2_axe2" );
    ObjDelete( "spr_neartower2_axeblade" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_axe2", get_axe2_inv );
  cmn.AddSubscriber( "get_axe2", get_axe2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_snakesamulet2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_snakesamulet2_2" ] =
  {
    type = "get",
    get_obj = "spr_precipice2_wingsamulet2",
    room = private.room_objname,
    zz = "zz_precipice2",
    zz_gate = "gzz_neartower2_precipice2"
  };
  --------------------------------------------------------------------------------------------
  local get_snakesamulet2_2_inv = function ()

    int.InventoryItemAdd( "inv_snakesamulet2", "obj_precipice2_wingsamulet", "assets/levels/level2/rm_shore2/zz_altar2/inv/inv_amuletsnake2_2" );
    level2_inv.CheckSnakesamulet2();

  end;
  local get_snakesamulet2_2_closezz = function ()

    ObjDelete( "gfx_precipice2_wingsamulet2" );
    ObjDelete( "spr_neartower2_wingsamulet" );
    
    if cmn.IsEventDone( "get_temporaryecho2_3" ) and
       cmn.IsEventDone( "get_sunamulet2" ) then
      ObjDelete( "gzz_neartower2_precipice2" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_snakesamulet2_2", get_snakesamulet2_2_inv );
  cmn.AddSubscriber( "get_snakesamulet2_2", get_snakesamulet2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sunamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sunamulet2" ] =
  {
    type = "get",
    get_obj = "spr_precipice2_sunamulet2",
    room = private.room_objname,
    zz = "zz_precipice2",
    zz_gate = "gzz_neartower2_precipice2"
  };
  --------------------------------------------------------------------------------------------
  local get_sunamulet2_inv = function ()

    int.InventoryItemAdd( "inv_sunamulet2", "spr_precipice2_sunamulet2" );

  end;
  local get_sunamulet2_closezz = function ()

    ObjDelete( "gfx_precipice2_sunamulet2" );
    ObjDelete( "spr_neartower2_sunamulet" );
    
    if cmn.IsEventDone( "get_snakesamulet2_2" ) and
       cmn.IsEventDone( "get_temporaryecho2_3" ) then
      ObjDelete( "gzz_neartower2_precipice2" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sunamulet2", get_sunamulet2_inv );
  cmn.AddSubscriber( "get_sunamulet2", get_sunamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_astronomycircle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_astronomycircle2" ] =
  {
    type = "get",
    get_obj = "spr_travelingbag2_astronomycircle2",
    room = private.room_objname,
    zz = "zz_travelingbag2",
    zz_gate = "gzz_neartower2_travelingbag2"
  };
  --------------------------------------------------------------------------------------------
  local get_astronomycircle2_inv = function ()

    int.InventoryItemAdd( "inv_astronomycircle2", "spr_travelingbag2_astronomycircle2" );

  end;
  local get_astronomycircle2_closezz = function ()

    ObjDelete( "gfx_travelingbag2_astronomycircle2" );
    ObjDelete( "spr_neartower2_travelingbag_astronomycircle" );
    
    if cmn.IsEventDone( "get_boltcutter2" ) and
       cmn.IsEventDone( "get_staramulet2" ) and
       cmn.IsEventDone( "get_astronomycircle2" ) then
      ObjDelete( "gzz_neartower2_travelingbag2" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_astronomycircle2", get_astronomycircle2_inv );
  cmn.AddSubscriber( "get_astronomycircle2", get_astronomycircle2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boltcutter2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boltcutter2" ] =
  {
    type = "get",
    get_obj = "obj_travelingbag2_boltcutter_get",
    room = private.room_objname,
    zz = "zz_travelingbag2",
    zz_gate = "gzz_neartower2_travelingbag2"
  };
  --------------------------------------------------------------------------------------------
  local get_boltcutter2_inv = function ()

    int.InventoryItemAdd( "inv_boltcutter2", "obj_travelingbag2_boltcutter_get" );

  end;
  local get_boltcutter2_closezz = function ()

    ObjDelete( "anm_travelingbag2_boltcutter" );
    ObjDelete( "gfx_travelingbag2_boltcutter2" );
    
    if cmn.IsEventDone( "get_boltcutter2" ) and
       cmn.IsEventDone( "get_staramulet2" ) and
       cmn.IsEventDone( "get_astronomycircle2" ) then
      ObjDelete( "gzz_neartower2_travelingbag2" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_boltcutter2", get_boltcutter2_inv );
  cmn.AddSubscriber( "get_boltcutter2", get_boltcutter2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_staramulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_staramulet2" ] =
  {
    type = "get",
    get_obj = "spr_travelingbag2_staramulet2",
    room = private.room_objname,
    zz = "zz_travelingbag2",
    zz_gate = "gzz_neartower2_travelingbag2"
  };
  --------------------------------------------------------------------------------------------
  local get_staramulet2_inv = function ()

    int.InventoryItemAdd( "inv_staramulet2", "spr_travelingbag2_staramulet2" );

  end;
  local get_staramulet2_closezz = function ()

    ObjDelete( "gfx_travelingbag2_staramulet2" );
    ObjDelete( "spr_neartower2_travelingbag_staramulet" );

    if cmn.IsEventDone( "get_boltcutter2" ) and
       cmn.IsEventDone( "get_staramulet2" ) and
       cmn.IsEventDone( "get_astronomycircle2" ) then
      ObjDelete( "gzz_neartower2_travelingbag2" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_staramulet2", get_staramulet2_inv );
  cmn.AddSubscriber( "get_staramulet2", get_staramulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_pigeonamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pigeonamulet2" ] =
  {
    type = "use",
    use_obj = "inv_pigeonamulet2",
    use_place = "obj_well2_use_pigeonamulet2",
    room = private.room_objname,
    zz = "zz_well2",
    zz_gate = "gzz_neartower2_well2"
  };
  --------------------------------------------------------------------------------------------
  local use_pigeonamulet2_inv = function ()

    int.InventoryItemRemove( "inv_pigeonamulet2" );

  end;
  local use_pigeonamulet2_beg = function ()

    ObjDelete( "obj_well2_use_pigeonamulet2" );

  end;
  local use_pigeonamulet2_end = function ()

    ObjSet( "obj_well2_cash_open", { input = true } );
    ObjSet( "gfx_well2_ring2_1", { active = true } );
    ObjDelete( "obj_well2_cash_close" );
    
    ObjSet( "spr_neartower2_ring", { alp = 1 } );
    ObjDelete( "spr_neartower2_cashedoor" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pigeonamulet2",     use_pigeonamulet2_inv );
  cmn.AddSubscriber( "use_pigeonamulet2",     use_pigeonamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pigeonamulet2",     use_pigeonamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_pigeonamulet2_inv", use_pigeonamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_pigeonamulet2_beg", use_pigeonamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_pigeonamulet2_end", use_pigeonamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chain2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chain2" ] =
  {
    type = "use",
    use_obj = "inv_chain2",
    use_place = "obj_well2_use_chain2",
    room = private.room_objname,
    zz = "zz_well2",
    zz_gate = "gzz_neartower2_well2"
  };
  --------------------------------------------------------------------------------------------
  local use_chain2_inv = function ()

    int.InventoryItemRemove( "inv_chain2" );

  end;
  local use_chain2_beg = function ()

    ObjDelete( "obj_well2_use_chain2" );

  end;
  local use_chain2_end = function ()

    ObjSet( "spr_neartower2_chain", { alp = 1 } );
    
    if cmn.IsEventDone( "use_bucket2" ) then
      ObjSet( "obj_well2_well_1", { alp = 1 } );
      ObjSet( "obj_well2_talisman2", { input = true } );
      ObjSet( "gfx_well2_talisman2", { active = true } );
      ObjSet( "vid_well2_talisman_anim", { alp = 1, playing = true } );
      ObjSet( "vid_well2_water_anim", { alp = 1, playing = true } );
      ObjDelete( "vid_well2_well_anim" );
      ObjSet( "spr_well2_chain_2", { alp = 1 } );
      ObjDelete( "spr_well2_chain_1" );
      ObjDelete( "spr_well2_talisman1" );
    else
      ObjSet( "spr_well2_chain_1", { alp = 1 } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chain2",     use_chain2_inv );
  cmn.AddSubscriber( "use_chain2",     use_chain2_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain2",     use_chain2_end, private.room_objname );
  cmn.AddSubscriber( "use_chain2_inv", use_chain2_inv, private.room_objname );
  cmn.AddSubscriber( "use_chain2_beg", use_chain2_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain2_end", use_chain2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bucket2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bucket2" ] =
  {
    type = "use",
    use_obj = "inv_bucket2",
    use_place = "obj_well2_use_bucket2",
    room = private.room_objname,
    zz = "zz_well2",
    zz_gate = "gzz_neartower2_well2"
  };
  --------------------------------------------------------------------------------------------
  local use_bucket2_inv = function ()

    int.InventoryItemRemove( "inv_bucket2" );

  end;
  local use_bucket2_beg = function ()

    ObjDelete( "obj_well2_use_bucket2" );

  end;
  local use_bucket2_end = function ()

    ObjSet( "spr_well2_bucket", { alp = 1 } );
    ObjSet( "spr_neartower2_bucket", { alp = 1 } );
    
    if cmn.IsEventDone( "use_chain2" ) then
      ObjSet( "obj_well2_well_1", { alp = 1 } );
      ObjSet( "obj_well2_talisman2", { input = true } );
      ObjSet( "gfx_well2_talisman2", { active = true } );
      ObjSet( "vid_well2_talisman_anim", { alp = 1, playing = true } );
      ObjSet( "vid_well2_water_anim", { alp = 1, playing = true } );
      ObjDelete( "vid_well2_well_anim" );
      ObjSet( "spr_well2_chain_2", { alp = 1 } );
      ObjDelete( "spr_well2_chain_1" );
      ObjDelete( "spr_well2_talisman1" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bucket2",     use_bucket2_inv );
  cmn.AddSubscriber( "use_bucket2",     use_bucket2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket2",     use_bucket2_end, private.room_objname );
  cmn.AddSubscriber( "use_bucket2_inv", use_bucket2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bucket2_beg", use_bucket2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket2_end", use_bucket2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spiralamulet2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spiralamulet2_1" ] =
  {
    type = "use",
    use_obj = "inv_spiralamulet2",
    use_place = "obj_well2_use_spiralamulet2_1",
    room = private.room_objname,
    zz = "zz_well2",
    zz_gate = "gzz_neartower2_well2"
  };
  --------------------------------------------------------------------------------------------
  local use_spiralamulet2_1_inv = function ()

  end;
  local use_spiralamulet2_1_beg = function ()

    ObjDelete( "obj_well2_use_spiralamulet2_1" );

  end;
  local use_spiralamulet2_1_end = function ()

    ObjDelete( "anm_well2_spiral_blue" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spiralamulet2_1",     use_spiralamulet2_1_inv );
  cmn.AddSubscriber( "use_spiralamulet2_1",     use_spiralamulet2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_1",     use_spiralamulet2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_1_inv", use_spiralamulet2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_1_beg", use_spiralamulet2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_1_end", use_spiralamulet2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spiralamulet2_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spiralamulet2_3" ] =
  {
    type = "use",
    use_obj = "inv_spiralamulet2",
    use_place = "obj_precipice2_use_spiralamulet2_3",
    room = private.room_objname,
    zz = "zz_precipice2",
    zz_gate = "gzz_neartower2_precipice2"
  };
  --------------------------------------------------------------------------------------------
  local use_spiralamulet2_3_inv = function ()


  end;
  local use_spiralamulet2_3_beg = function ()

    ObjDelete( "obj_precipice2_use_spiralamulet2_3" );

  end;
  local use_spiralamulet2_3_end = function ()

    ObjSet( "spr_precipice2_temporaryecho2_3", { alp = 1, input = true } );
    ObjSet( "gfx_precipice2_temporaryecho2_3", { active = true } );
    ObjDelete( "anm_precipice2_use_spiral" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spiralamulet2_3",     use_spiralamulet2_3_inv );
  cmn.AddSubscriber( "use_spiralamulet2_3",     use_spiralamulet2_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_3",     use_spiralamulet2_3_end, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_3_inv", use_spiralamulet2_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_3_beg", use_spiralamulet2_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_3_end", use_spiralamulet2_3_end, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function use_axe2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_axe2" ] =
  {
    type = "use",
    use_obj = "inv_axe2",
    use_place = "obj_workshopdoor2_use_axe2",
    room = private.room_objname,
    zz = "zz_workshopdoor2",
    zz_gate = "gzz_neartower2_workshopdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_axe2_inv = function ()

    int.InventoryItemRemove( "inv_axe2" );

  end;
  local use_axe2_beg = function ()

    ObjDelete( "obj_workshopdoor2_use_axe2" );

  end;
  local use_axe2_end = function ()

    ObjDelete( "gzz_neartower2_workshopdoor2" );
    ObjSet( "grm_neartower2_workshop2", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_neartower2_workshop2_focus");
    end;
    ObjSet( "anm_neartower2_workshop_open", { alp = 0 } );--ObjSet( "anm_neartower2_workshop_open", { frame = 500 } );
    ObjSet( "spr_neartower2_workshop_open", { alp = 1 } );
    ObjDelete( "spr_neartower2_workshopdoor_close" );
    
    ObjDelete( "obj_workshopdoor2_boards" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_axe2",     use_axe2_inv );
  cmn.AddSubscriber( "use_axe2",     use_axe2_beg, private.room_objname );
  cmn.AddSubscriber( "use_axe2",     use_axe2_end, private.room_objname );
  cmn.AddSubscriber( "use_axe2_inv", use_axe2_inv, private.room_objname );
  cmn.AddSubscriber( "use_axe2_beg", use_axe2_beg, private.room_objname );
  cmn.AddSubscriber( "use_axe2_end", use_axe2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_halfmoonamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_halfmoonamulet2" ] =
  {
    type = "use",
    use_obj = "inv_halfmoonamulet2",
    use_place = "obj_towerdoor2_use_halfmoonamulet2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_halfmoonamulet2_inv = function ()

    int.InventoryItemRemove( "inv_halfmoonamulet2" );

  end;
  local use_halfmoonamulet2_beg = function ()

    ObjDelete( "obj_towerdoor2_use_halfmoonamulet2" );

  end;
  local use_halfmoonamulet2_end = function ()

    if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
       cmn.IsEventDone( "use_sunamulet2" ) and 
       cmn.IsEventDone( "use_planetamulet2" ) and 
       cmn.IsEventDone( "use_cometamulet2" ) and 
       cmn.IsEventDone( "use_staramulet2" ) then
       
      ObjDelete( "gzz_neartower2_towerdoor2" );
      ObjDelete( "obj_towerdoor2_use_amulets" );
      ObjSet( "gmg_neartower2_mglock2", { alp = 1, input = true, active = true } );
      
    else 
      
      ObjSet( "spr_towerdoor2_halfmoonamulet", { alp = 1 } ); 
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_halfmoonamulet2",     use_halfmoonamulet2_inv );
  cmn.AddSubscriber( "use_halfmoonamulet2",     use_halfmoonamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_halfmoonamulet2",     use_halfmoonamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_halfmoonamulet2_inv", use_halfmoonamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_halfmoonamulet2_beg", use_halfmoonamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_halfmoonamulet2_end", use_halfmoonamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sunamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sunamulet2" ] =
  {
    type = "use",
    use_obj = "inv_sunamulet2",
    use_place = "obj_towerdoor2_use_sunamulet2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_sunamulet2_inv = function ()

    int.InventoryItemRemove( "inv_sunamulet2" );

  end;
  local use_sunamulet2_beg = function ()

    ObjDelete( "obj_towerdoor2_use_sunamulet2" );

  end;
  local use_sunamulet2_end = function ()

    if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
       cmn.IsEventDone( "use_sunamulet2" ) and 
       cmn.IsEventDone( "use_planetamulet2" ) and 
       cmn.IsEventDone( "use_cometamulet2" ) and 
       cmn.IsEventDone( "use_staramulet2" ) then
       
      ObjDelete( "gzz_neartower2_towerdoor2" );
      ObjDelete( "obj_towerdoor2_use_amulets" );
      ObjSet( "gmg_neartower2_mglock2", { alp = 1, input = true, active = true } );
      
    else 
      
      ObjSet( "spr_towerdoor2_sunamulet", { alp = 1 } ); 
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sunamulet2",     use_sunamulet2_inv );
  cmn.AddSubscriber( "use_sunamulet2",     use_sunamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_sunamulet2",     use_sunamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_sunamulet2_inv", use_sunamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_sunamulet2_beg", use_sunamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_sunamulet2_end", use_sunamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers2" ] =
  {
    type = "use",
    use_obj = "inv_tweezers2",
    use_place = "obj_towerdoor2_use_tweezers2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_tweezers2_inv = function ()

    int.InventoryItemRemove( "inv_tweezers2" );

  end;
  local use_tweezers2_beg = function ()

    ObjDelete( "obj_towerdoor2_use_tweezers2" );

  end;
  local use_tweezers2_end = function ()

    ObjSet( "obj_towerdoor2_use_wholekey2", { input = true } );
    ObjDelete( "anm_towerdoor2_keypiece_click" );
    ObjDelete( "anm_towerdoor2_keypiece_static" );
    ObjDelete( "anm_towerdoor2_use_tweezers" );
    ObjSet( "anm_towerdoor2_use_wholekey", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers2",     use_tweezers2_inv );
  cmn.AddSubscriber( "use_tweezers2",     use_tweezers2_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers2",     use_tweezers2_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers2_inv", use_tweezers2_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers2_beg", use_tweezers2_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers2_end", use_tweezers2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle2" ] =
  {
    type = "use",
    use_obj = "inv_handle2",
    use_place = "obj_towerdoor2_use_handle2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_handle2_inv = function ()

    int.InventoryItemRemove( "inv_handle2" );

  end;
  local use_handle2_beg = function ()

    ObjDelete( "obj_towerdoor2_use_handle2" );
    ObjDelete( "anm_towerdoor2_axeblade_click" );

  end;
  local use_handle2_end = function ()

    ObjDelete( "anm_towerdoor2_use_handle" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handle2",     use_handle2_inv );
  cmn.AddSubscriber( "use_handle2",     use_handle2_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle2",     use_handle2_end, private.room_objname );
  cmn.AddSubscriber( "use_handle2_inv", use_handle2_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle2_beg", use_handle2_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle2_end", use_handle2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wholekey2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wholekey2" ] =
  {
    type = "use",
    use_obj = "inv_wholekey2",
    use_place = "obj_towerdoor2_use_wholekey2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_wholekey2_inv = function ()

    int.InventoryItemRemove( "inv_wholekey2" );

  end;
  local use_wholekey2_beg = function ()

    ObjDelete( "obj_towerdoor2_use_wholekey2" );

  end;
  local use_wholekey2_end = function ()

    ObjSet( "obj_towerdoor2_open_lock", { alp = 1, input = true } );
    ObjSet( "gfx_towerdoor2_brokenamulet2", { active = true } );
    ObjDelete( "obj_towerdoor2_close_lock" );
    
    ObjSet( "obj_towerdoor2_use_halfmoonamulet2", { input = true } );
    ObjSet( "obj_towerdoor2_use_sunamulet2", { input = true } );
    ObjSet( "obj_towerdoor2_use_planetamulet2", { input = true } );
    ObjSet( "obj_towerdoor2_use_cometamulet2", { input = true } );
    ObjSet( "obj_towerdoor2_use_staramulet2", { input = true } );
    
    ObjDelete( "anm_towerdoor2_use_wholekey" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wholekey2",     use_wholekey2_inv );
  cmn.AddSubscriber( "use_wholekey2",     use_wholekey2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wholekey2",     use_wholekey2_end, private.room_objname );
  cmn.AddSubscriber( "use_wholekey2_inv", use_wholekey2_inv, private.room_objname );
  cmn.AddSubscriber( "use_wholekey2_beg", use_wholekey2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wholekey2_end", use_wholekey2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_planetamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_planetamulet2" ] =
  {
    type = "use",
    use_obj = "inv_planetamulet2",
    use_place = "obj_towerdoor2_use_planetamulet2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_planetamulet2_inv = function ()

    int.InventoryItemRemove( "inv_planetamulet2" );

  end;
  local use_planetamulet2_beg = function ()

    ObjDelete( "obj_towerdoor2_use_planetamulet2" );

  end;
  local use_planetamulet2_end = function ()

    if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
       cmn.IsEventDone( "use_sunamulet2" ) and 
       cmn.IsEventDone( "use_planetamulet2" ) and 
       cmn.IsEventDone( "use_cometamulet2" ) and 
       cmn.IsEventDone( "use_staramulet2" ) then
       
      ObjDelete( "gzz_neartower2_towerdoor2" );
      ObjDelete( "obj_towerdoor2_use_amulets" );
      ObjSet( "gmg_neartower2_mglock2", { alp = 1, input = true, active = true } );
      
    else 
      
      ObjSet( "spr_towerdoor2_cometamulet", { alp = 1 } ); 
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_planetamulet2",     use_planetamulet2_inv );
  cmn.AddSubscriber( "use_planetamulet2",     use_planetamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_planetamulet2",     use_planetamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_planetamulet2_inv", use_planetamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_planetamulet2_beg", use_planetamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_planetamulet2_end", use_planetamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cometamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cometamulet2" ] =
  {
    type = "use",
    use_obj = "inv_cometamulet2",
    use_place = "obj_towerdoor2_use_cometamulet2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_cometamulet2_inv = function ()

    int.InventoryItemRemove( "inv_cometamulet2" );

  end;
  local use_cometamulet2_beg = function ()

    ObjDelete( "obj_towerdoor2_use_cometamulet2" );

  end;
  local use_cometamulet2_end = function ()

    if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
       cmn.IsEventDone( "use_sunamulet2" ) and 
       cmn.IsEventDone( "use_planetamulet2" ) and 
       cmn.IsEventDone( "use_cometamulet2" ) and 
       cmn.IsEventDone( "use_staramulet2" ) then
       
      ObjDelete( "gzz_neartower2_towerdoor2" );
      ObjDelete( "obj_towerdoor2_use_amulets" );
      ObjSet( "gmg_neartower2_mglock2", { alp = 1, input = true, active = true } );
      
    else 
      
      ObjSet( "spr_towerdoor2_planetamulet", { alp = 1 } ); 
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cometamulet2",     use_cometamulet2_inv );
  cmn.AddSubscriber( "use_cometamulet2",     use_cometamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cometamulet2",     use_cometamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_cometamulet2_inv", use_cometamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_cometamulet2_beg", use_cometamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cometamulet2_end", use_cometamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_staramulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_staramulet2" ] =
  {
    type = "use",
    use_obj = "inv_staramulet2",
    use_place = "obj_towerdoor2_use_staramulet2",
    room = private.room_objname,
    zz = "zz_towerdoor2",
    zz_gate = "gzz_neartower2_towerdoor2"
  };
  --------------------------------------------------------------------------------------------
  local use_staramulet2_inv = function ()

    int.InventoryItemRemove( "inv_staramulet2" );

  end;
  local use_staramulet2_beg = function ()

    ObjDelete( "obj_towerdoor2_use_staramulet2" );

  end;
  local use_staramulet2_end = function ()

    if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
       cmn.IsEventDone( "use_sunamulet2" ) and 
       cmn.IsEventDone( "use_planetamulet2" ) and 
       cmn.IsEventDone( "use_cometamulet2" ) and 
       cmn.IsEventDone( "use_staramulet2" ) then
       
      ObjDelete( "gzz_neartower2_towerdoor2" );
      ObjDelete( "obj_towerdoor2_use_amulets" );
      ObjSet( "gmg_neartower2_mglock2", { alp = 1, input = true, active = true } );
      
    else 
      
      ObjSet( "spr_towerdoor2_staramulet", { alp = 1 } ); 
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_staramulet2",     use_staramulet2_inv );
  cmn.AddSubscriber( "use_staramulet2",     use_staramulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_staramulet2",     use_staramulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_staramulet2_inv", use_staramulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_staramulet2_beg", use_staramulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_staramulet2_end", use_staramulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dipnet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dipnet2" ] =
  {
    type = "use",
    use_obj = "inv_dipnet2",
    use_place = "obj_precipice2_use_dipnet2",
    room = private.room_objname,
    zz = "zz_precipice2",
    zz_gate = "gzz_neartower2_precipice2"
  };
  --------------------------------------------------------------------------------------------
  local use_dipnet2_inv = function ()

    int.InventoryItemRemove( "inv_dipnet2" );

  end;
  local use_dipnet2_beg = function ()

    ObjDelete( "obj_precipice2_use_dipnet2" );

  end;
  local use_dipnet2_end = function ()

    ObjDelete( "anm_precipice2_wingsamulet" );
    ObjDelete( "anm_precipice2_use_dipnet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dipnet2",     use_dipnet2_inv );
  cmn.AddSubscriber( "use_dipnet2",     use_dipnet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_dipnet2",     use_dipnet2_end, private.room_objname );
  cmn.AddSubscriber( "use_dipnet2_inv", use_dipnet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_dipnet2_beg", use_dipnet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_dipnet2_end", use_dipnet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_astronomycircle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_astronomycircle2" ] =
  {
    type = "use",
    use_obj = "inv_astronomycircle2",
    use_place = "obj_precipice2_use_astronomycircle2",
    room = private.room_objname,
    zz = "zz_precipice2",
    zz_gate = "gzz_neartower2_precipice2"
  };
  --------------------------------------------------------------------------------------------
  local use_astronomycircle2_inv = function ()

    int.InventoryItemRemove( "inv_astronomycircle2" );

  end;
  local use_astronomycircle2_beg = function ()

    ObjDelete( "obj_precipice2_use_astronomycircle2" );

  end;
  local use_astronomycircle2_end = function ()

    ObjSet( "spr_precipice2_circle_3_shadow", { alp = 1 } );
    ObjSet( "spr_precipice2_circle_3", { alp = 1 } );
    ObjSet( "obj_precipice2_circles", { input = true } );
    
    ObjSet( "spr_neartower2_precipice_astronomycircle", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_astronomycircle2",     use_astronomycircle2_inv );
  cmn.AddSubscriber( "use_astronomycircle2",     use_astronomycircle2_beg, private.room_objname );
  cmn.AddSubscriber( "use_astronomycircle2",     use_astronomycircle2_end, private.room_objname );
  cmn.AddSubscriber( "use_astronomycircle2_inv", use_astronomycircle2_inv, private.room_objname );
  cmn.AddSubscriber( "use_astronomycircle2_beg", use_astronomycircle2_beg, private.room_objname );
  cmn.AddSubscriber( "use_astronomycircle2_end", use_astronomycircle2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dagger2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dagger2" ] =
  {
    type = "use",
    use_obj = "inv_dagger2",
    use_place = "obj_travelingbag2_use_dagger2",
    room = private.room_objname,
    zz = "zz_travelingbag2",
    zz_gate = "gzz_neartower2_travelingbag2"
  };
  --------------------------------------------------------------------------------------------
  local use_dagger2_inv = function ()

    int.InventoryItemRemove( "inv_dagger2" );

  end;
  local use_dagger2_beg = function ()

    ObjDelete( "obj_travelingbag2_use_dagger2" );

  end;
  local use_dagger2_end = function ()

    ObjSet( "obj_travelingbag2_open_case", { alp = 1, input = true } );
    ObjSet( "gfx_travelingbag2_astronomycircle2", { active = true } );
    ObjSet( "gfx_travelingbag2_staramulet2", { active = true } );
    ObjSet( "anm_travelingbag2_astronomycircle_over", { playing = true } );
    ObjDelete( "obj_travelingbag2_close_case" );
    
    ObjSet( "spr_neartower2_travelingbag_opencase", { alp = 1 } );
    ObjSet( "spr_neartower2_travelingbag_astronomycircle", { alp = 1 } );
    ObjSet( "spr_neartower2_travelingbag_staramulet", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dagger2",     use_dagger2_inv );
  cmn.AddSubscriber( "use_dagger2",     use_dagger2_beg, private.room_objname );
  cmn.AddSubscriber( "use_dagger2",     use_dagger2_end, private.room_objname );
  cmn.AddSubscriber( "use_dagger2_inv", use_dagger2_inv, private.room_objname );
  cmn.AddSubscriber( "use_dagger2_beg", use_dagger2_beg, private.room_objname );
  cmn.AddSubscriber( "use_dagger2_end", use_dagger2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurine2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurine2" ] =
  {
    type = "use",
    use_obj = "inv_figurine2",
    use_place = "obj_travelingbag2_use_figurine2",
    room = private.room_objname,
    zz = "zz_travelingbag2",
    zz_gate = "gzz_neartower2_travelingbag2"
  };
  --------------------------------------------------------------------------------------------
  local use_figurine2_inv = function ()

    int.InventoryItemRemove( "inv_figurine2" );

  end;
  local use_figurine2_beg = function ()

    ObjDelete( "obj_travelingbag2_use_figurine2" );

  end;
  local use_figurine2_end = function ()

    ObjSet( "obj_travelingbag2_open_bag", { alp = 1, input = true } );
    ObjSet( "gfx_travelingbag2_boltcutter2", { active = true } );
    ObjSet( "gfx_travelingbag2_handle2", { active = true } );
    ObjDelete( "obj_travelingbag2_close_bag" );
   
    ObjSet( "spr_neartower2_travelingbag_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_figurine2",     use_figurine2_inv );
  cmn.AddSubscriber( "use_figurine2",     use_figurine2_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurine2",     use_figurine2_end, private.room_objname );
  cmn.AddSubscriber( "use_figurine2_inv", use_figurine2_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurine2_beg", use_figurine2_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurine2_end", use_figurine2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scissors2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scissors2" ] =
  {
    type = "use",
    use_obj = "inv_scissors2",
    use_place = "obj_neartower2_use_scissors2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local use_scissors2_inv = function ()

    int.InventoryItemRemove( "inv_scissors2" );

  end;
  local use_scissors2_beg = function ()

    ObjDelete( "obj_neartower2_use_scissors2" );
    ObjDelete( "anm_neartower2_bushes_static" );
    ObjDelete( "anm_neartower2_bushes_click" );

  end;
  local use_scissors2_end = function ()

    ObjDelete( "anm_neartower2_scissors" );
    ObjSet( "grm_neartower2_shore2", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_neartower2_shore2_focus");
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scissors2",     use_scissors2_inv );
  cmn.AddSubscriber( "use_scissors2",     use_scissors2_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors2",     use_scissors2_end, private.room_objname );
  cmn.AddSubscriber( "use_scissors2_inv", use_scissors2_inv, private.room_objname );
  cmn.AddSubscriber( "use_scissors2_beg", use_scissors2_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors2_end", use_scissors2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_precipice2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_precipice2" ] =
  {
    type = "click",
    clk_obj = "spr_precipice2_circle_1",
    room = private.room_objname,
    zz = "zz_precipice2",
    zz_gate = "gzz_neartower2_precipice2"
  };
  --*********************************************************************************************************************
  local win_precipice2_inv = function ()

    if ( cmn.IsEventDone( "win_precipice2" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_precipice2 = function ()

    if ( cmn.IsEventDone( "win_precipice2" ) ) then

      for i = 1, 2 do
        ObjSet( "spr_precipice2_circle_"..i, { ang = 0 } );
      end;
      
      ObjSet( "obj_precipice2_circles", { input = false } );
      ObjSet( "spr_precipice2_sunamulet2", { input = true } );
      ObjSet( "gfx_precipice2_sunamulet2", { active = true } );
      ObjSet( "anm_precipice2_door_open", { frame = 500 } );

      ObjSet( "spr_neartower2_precipice_door", { pos_x = 111, pos_y = 271 } );

    else 

      private.Precipice2Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_precipice2", win_precipice2_inv );
  cmn.AddSubscriber( "win_precipice2", win_precipice2, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_mglock2 () end;
  --------------------------------------------------------------------------------------------
  --*********************************************************************************************************************
  local win_mglock2 = function ()

    if ( cmn.IsEventDone( "win_mglock2" ) ) then
      
      ObjSet( "anm_neartower2_workshop_open", { alp = 0 } );--ObjSet( "anm_neartower2_workshop_open", { frame = 500 } );
      ObjSet( "spr_neartower2_workshop_open", { alp = 1 } );
      ObjDelete( "gmg_neartower2_mglock2" );

    end;
    
  end;


  cmn.AddSubscriber( "win_mglock2", win_mglock2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_neartower2_richard2_3 () end;
  --------------------------------------------------------------------------------------------
  local dlg_neartower2_richard2_3_beg = function ()

  end;
  -----------------------------------------------
  local dlg_neartower2_richard2_3_end = function ()

    ObjDelete( "dlg_neartower2_richard2_3" );

  end;

  cmn.AddSubscriber( "dlg_neartower2_richard2_3",     dlg_neartower2_richard2_3_beg );
  cmn.AddSubscriber( "dlg_neartower2_richard2_3",     dlg_neartower2_richard2_3_end );
  cmn.AddSubscriber( "dlg_neartower2_richard2_3_beg", dlg_neartower2_richard2_3_beg );
  cmn.AddSubscriber( "dlg_neartower2_richard2_3_end", dlg_neartower2_richard2_3_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_2_7()

  int.AddScreensaver( "spr_well2_screensaver_2_7" );

end;
-----------------------------------------------------------------------
function private.get_staramulet2 ()

  cmn.SetEventDone( "get_staramulet2" );
  cmn.CallEventHandler( "get_staramulet2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_boltcutter2" ) and
     cmn.IsEventDone( "get_staramulet2" ) and
     cmn.IsEventDone( "get_astronomycircle2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_figurine2 ()

  cmn.SetEventDone( "get_figurine2" );
  cmn.CallEventHandler( "get_figurine2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_mosaicpart2 ()

  cmn.SetEventDone( "get_mosaicpart2" );
  cmn.CallEventHandler( "get_mosaicpart2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_ring2_1" ) and 
     cmn.IsEventDone( "get_talisman2" ) and 
     cmn.IsEventDone( "get_temporaryecho2_1" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_ring2_1 ()

  cmn.SetEventDone( "get_ring2_1" );
  cmn.CallEventHandler( "get_ring2_1" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_mosaicpart2" ) and 
     cmn.IsEventDone( "get_talisman2" ) and 
     cmn.IsEventDone( "get_temporaryecho2_1" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_talisman2 ()

  cmn.SetEventDone( "get_talisman2" );
  cmn.CallEventHandler( "get_talisman2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_mosaicpart2" ) and 
     cmn.IsEventDone( "get_ring2_1" ) and 
     cmn.IsEventDone( "get_temporaryecho2_1" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_temporaryecho2_1 ()

  cmn.SetEventDone( "get_temporaryecho2_1" );
  cmn.CallEventHandler( "get_temporaryecho2_1" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_mosaicpart2" ) and 
     cmn.IsEventDone( "get_ring2_1" ) and 
     cmn.IsEventDone( "get_talisman2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_temporaryecho2_3 ()

  cmn.SetEventDone( "get_temporaryecho2_3" );
  cmn.CallEventHandler( "get_temporaryecho2_3" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_snakesamulet2_2" ) and
     cmn.IsEventDone( "get_sunamulet2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_handle2 ()

  cmn.SetEventDone( "get_handle2" );
  cmn.CallEventHandler( "get_handle2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_keypiece2_2 ()

  cmn.SetEventDone( "get_keypiece2_2" );
  cmn.CallEventHandler( "get_keypiece2_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_brokenamulet2 ()

  cmn.SetEventDone( "get_brokenamulet2" );
  cmn.CallEventHandler( "get_brokenamulet2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_axe2 ()

  ObjSet( "spr_towerdoor2_axe2", { alp = 1 } );

  cmn.SetEventDone( "get_axe2" );
  cmn.CallEventHandler( "get_axe2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_snakesamulet2_2 ()

  cmn.SetEventDone( "get_snakesamulet2_2" );
  cmn.CallEventHandler( "get_snakesamulet2_2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_temporaryecho2_3" ) and
     cmn.IsEventDone( "get_sunamulet2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_sunamulet2 ()

  cmn.SetEventDone( "get_sunamulet2" );
  cmn.CallEventHandler( "get_sunamulet2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_snakesamulet2_2" ) and
     cmn.IsEventDone( "get_temporaryecho2_3" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_astronomycircle2 ()

  cmn.SetEventDone( "get_astronomycircle2" );
  cmn.CallEventHandler( "get_astronomycircle2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_boltcutter2" ) and
     cmn.IsEventDone( "get_staramulet2" ) and
     cmn.IsEventDone( "get_astronomycircle2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_boltcutter2 ()

  cmn.SetEventDone( "get_boltcutter2" );
  cmn.CallEventHandler( "get_boltcutter2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_boltcutter2" ) and
     cmn.IsEventDone( "get_staramulet2" ) and
     cmn.IsEventDone( "get_astronomycircle2" ) then
    cmn.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_pigeonamulet2 ()

  local item = "inv_pigeonamulet2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_well2", false ) ) and
     ( not cmn.IsEventDone( "use_pigeonamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_well2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_well2_use_pigeonamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_pigeonamulet2" ) ) then

    cmn.CallEventHandler( "use_pigeonamulet2_inv" );
    cmn.CallEventHandler( "use_pigeonamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_pigeonamulet2" );
      cmn.CallEventHandler( "use_pigeonamulet2_end" );

    end;

    int.Lock( true );
    
    ObjSet( "anm_well2_cashe_click", { alp = 0 } );
    ObjSet( "anm_well2_use_pigeonamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_bird_cell_opens" );
    AnimPlay( "anm_well2_use_pigeonamulet", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_chain2 ()

  local item = "inv_chain2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_well2", false ) ) and
     ( not cmn.IsEventDone( "use_chain2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_well2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_well2_use_chain2", true ) ) and
         ( not cmn.IsEventDone( "use_chain2" ) ) then

    cmn.CallEventHandler( "use_chain2_inv" );
    cmn.CallEventHandler( "use_chain2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_chain2" );
        cmn.CallEventHandler( "use_chain2_end" );
        
      end;
      
      if cmn.IsEventDone( "use_bucket2" ) then
        private.use_chain_bucket( func_end1 );
      else  
        func_end1();
      end;  

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_chain_well" );

    if not cmn.IsEventDone( "use_bucket2" ) then

      ObjAnimate( "spr_well2_chain_1", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    else

      ObjAnimate( "spr_well2_chain_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.use_chain_bucket ( func_end )

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_well_take_water" );
  ObjSet( "obj_well2_well_1", { alp = 0 } );
  ObjSet( "vid_well2_well_anim", { alp = 1 } );
  VidPlay( "vid_well2_well_anim", func_end );

end;  
--------------------------------------------------------------------------------------------
function public.use_bucket2 ()

  local item = "inv_bucket2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_well2", false ) ) and
     ( not cmn.IsEventDone( "use_bucket2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_well2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_well2_use_bucket2", true ) ) and
         ( not cmn.IsEventDone( "use_bucket2" ) ) then

    cmn.CallEventHandler( "use_bucket2_inv" );
    cmn.CallEventHandler( "use_bucket2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        int.Lock( false );
        cmn.SetEventDone( "use_bucket2" );
        cmn.CallEventHandler( "use_bucket2_end" );
      end;
      
      if cmn.IsEventDone( "use_chain2" ) then
        private.use_chain_bucket( func_end1 );
      else
        func_end1();  
      end;  

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_bucket_well" );

    ObjAnimate( "spr_well2_bucket", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    if cmn.IsEventDone( "use_chain2" ) then

      ObjAnimate( "spr_well2_chain_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );
      ObjAnimate( "spr_well2_chain_2", "alp", 0, 0, "",
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_spiralamulet2_1 ()

  local item = "inv_spiralamulet2";

  if ( not cmn.IsEventDone( "use_spiralamulet2_1" ) ) then

    cmn.CallEventHandler( "use_spiralamulet2_1_inv" );
    cmn.CallEventHandler( "use_spiralamulet2_1_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_spiralamulet2_1" );
        cmn.CallEventHandler( "use_spiralamulet2_1" );
        private.get_temporaryecho2_1();
        
      end;
      
      --cmn.CloseSubRoom();
      private.VidEmily1( func_end1 );

    end;

    int.Lock( true );

    --ObjAnimate( "spr_well2_spiralamulet2_1", "alp", 0, 0, func_end,
    --{
    --  0.0, 3, 0.0,
    --  0.3, 3, 1.0,
    --} );
  
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_well_auto_use_talisman" );

    AnimPlay( "anm_well2_spiral_blue", "DoAnim", func_end );

    --func_end();

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spiralamulet2_3 ()

  if ( not cmn.IsEventDone( "use_spiralamulet2_3" ) and
    cmn.IsEventDone( "use_spiralamulet2_2" )) then

    cmn.CallEventHandler( "use_spiralamulet2_3_inv" );
    cmn.CallEventHandler( "use_spiralamulet2_3_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        int.Lock( false );
        cmn.SetEventDone( "use_spiralamulet2_3" );
        cmn.CallEventHandler( "use_spiralamulet2_3_end" );
        private.get_temporaryecho2_3();
      end;
      
      --cmn.CloseSubRoom();
      private.VidEmily3( func_end1 );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_amulet_zz_precipice2" );
    AnimPlay( "anm_precipice2_use_spiral", "DoAnim", func_end );

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_axe2 ()

  local item = "inv_axe2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_workshopdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_axe2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_workshopdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_workshopdoor2_use_axe2", true ) ) and
         ( not cmn.IsEventDone( "use_axe2" ) ) then

    cmn.CallEventHandler( "use_axe2_inv" );
    cmn.CallEventHandler( "use_axe2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_axe2" );
        cmn.CallEventHandler( "use_axe2_end" );
        
      end;
      
      cmn.CloseSubRoom( true );
      ObjSet( "spr_neartower2_workshopdoor_close", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_lov_open_door_neartower2" );
      AnimPlay( "anm_neartower2_workshop_open", "DoAnim", func_end1 );

    end;

    int.Lock( true );

    ObjSet( "anm_workshopdoor2_boards_click", { alp = 0 } );
    ObjSet( "anm_workshopdoor2_use_axe", { alp = 1 } );
    ObjSet( "anm_workshopdoor2_use_axe_over", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_broke_wood_axe" );
    AnimPlay( "anm_workshopdoor2_use_axe", "DoAnim", func_end ); 
    AnimPlay( "anm_workshopdoor2_use_axe_over", "DoAnim", "" );     

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_halfmoonamulet2 ()

  local item = "inv_halfmoonamulet2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_towerdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_halfmoonamulet2" ) ) and 
       cmn.IsEventDone( "use_wholekey2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_towerdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_towerdoor2_use_halfmoonamulet2", true ) or cmn.ApplyObj( item, "obj_towerdoor2_use_amulets", true ) ) and
         ( not cmn.IsEventDone( "use_halfmoonamulet2" ) ) and 
           cmn.IsEventDone( "use_wholekey2" ) then

    cmn.CallEventHandler( "use_halfmoonamulet2_inv" );
    cmn.CallEventHandler( "use_halfmoonamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_halfmoonamulet2" );
      cmn.CallEventHandler( "use_halfmoonamulet2_end" );
      
      if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
         cmn.IsEventDone( "use_sunamulet2" ) and 
         cmn.IsEventDone( "use_planetamulet2" ) and 
         cmn.IsEventDone( "use_cometamulet2" ) and 
         cmn.IsEventDone( "use_staramulet2" ) then
        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mglock2" );
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_towerdoor2_insert_moon" );
    ObjAnimate( "spr_towerdoor2_halfmoonamulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_sunamulet2 ()

  local item = "inv_sunamulet2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_towerdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_sunamulet2" ) ) and 
       cmn.IsEventDone( "use_wholekey2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_towerdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_towerdoor2_use_sunamulet2", true ) or cmn.ApplyObj( item, "obj_towerdoor2_use_amulets", true ) ) and
         ( not cmn.IsEventDone( "use_sunamulet2" ) ) and 
           cmn.IsEventDone( "use_wholekey2" ) then

    cmn.CallEventHandler( "use_sunamulet2_inv" );
    cmn.CallEventHandler( "use_sunamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_sunamulet2" );
      cmn.CallEventHandler( "use_sunamulet2_end" );
      
      if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
         cmn.IsEventDone( "use_sunamulet2" ) and 
         cmn.IsEventDone( "use_planetamulet2" ) and 
         cmn.IsEventDone( "use_cometamulet2" ) and 
         cmn.IsEventDone( "use_staramulet2" ) then
        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mglock2" );
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_towerdoor2_insert_sun" );
    ObjAnimate( "spr_towerdoor2_sunamulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_tweezers2 ()

  local item = "inv_tweezers2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_towerdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_tweezers2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_towerdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_towerdoor2_use_tweezers2", true ) ) and
         ( not cmn.IsEventDone( "use_tweezers2" ) ) then

    cmn.CallEventHandler( "use_tweezers2_inv" );
    cmn.CallEventHandler( "use_tweezers2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_tweezers2" );
      cmn.CallEventHandler( "use_tweezers2_end" );
      private.get_keypiece2_2();

    end;

    int.Lock( true );
    ObjSet( "anm_towerdoor2_keypiece_static", { alp = 0 } );
    ObjSet( "anm_towerdoor2_use_tweezers", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_stuff_key_zz_towerdoor2" );
    AnimPlay( "anm_towerdoor2_use_tweezers", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_handle2 ()

  local item = "inv_handle2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_towerdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_handle2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_towerdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_towerdoor2_use_handle2", true ) ) and
         ( not cmn.IsEventDone( "use_handle2" ) ) then

    cmn.CallEventHandler( "use_handle2_inv" );
    cmn.CallEventHandler( "use_handle2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_handle2" );
      cmn.CallEventHandler( "use_handle2_end" );
      private.get_axe2();

    end;

    int.Lock( true );
    ObjSet( "anm_towerdoor2_use_handle", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_towerdoor2_blade_axe_take" );
    AnimPlay( "anm_towerdoor2_use_handle", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_wholekey2 ()

  local item = "inv_wholekey2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_towerdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_wholekey2" ) ) and 
       cmn.IsEventDone( "use_tweezers2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_towerdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_towerdoor2_use_wholekey2", true ) ) and
         ( not cmn.IsEventDone( "use_wholekey2" ) ) and 
           cmn.IsEventDone( "use_tweezers2" ) then

    cmn.CallEventHandler( "use_wholekey2_inv" );
    cmn.CallEventHandler( "use_wholekey2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_wholekey2" );
      cmn.CallEventHandler( "use_wholekey2_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_key_zz_towerdoor2" );
    AnimPlay( "anm_towerdoor2_use_wholekey", "DoAnim", func_end ); 
      
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_planetamulet2 ()

  local item = "inv_planetamulet2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_towerdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_planetamulet2" ) ) and 
       cmn.IsEventDone( "use_wholekey2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_towerdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_towerdoor2_use_planetamulet2", true ) or cmn.ApplyObj( item, "obj_towerdoor2_use_amulets", true ) ) and
         ( not cmn.IsEventDone( "use_planetamulet2" ) ) and 
           cmn.IsEventDone( "use_wholekey2" ) then

    cmn.CallEventHandler( "use_planetamulet2_inv" );
    cmn.CallEventHandler( "use_planetamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_planetamulet2" );
      cmn.CallEventHandler( "use_planetamulet2_end" );
      
      if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
         cmn.IsEventDone( "use_sunamulet2" ) and 
         cmn.IsEventDone( "use_planetamulet2" ) and 
         cmn.IsEventDone( "use_cometamulet2" ) and 
         cmn.IsEventDone( "use_staramulet2" ) then
        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mglock2" );
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_towerdoor2_insert_planet" );
    ObjAnimate( "spr_towerdoor2_cometamulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_cometamulet2 ()

  local item = "inv_cometamulet2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_towerdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_cometamulet2" ) ) and 
       cmn.IsEventDone( "use_wholekey2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_towerdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_towerdoor2_use_cometamulet2", true ) or cmn.ApplyObj( item, "obj_towerdoor2_use_amulets", true ) ) and
         ( not cmn.IsEventDone( "use_cometamulet2" ) ) and 
           cmn.IsEventDone( "use_wholekey2" ) then

    cmn.CallEventHandler( "use_cometamulet2_inv" );
    cmn.CallEventHandler( "use_cometamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_cometamulet2" );
      cmn.CallEventHandler( "use_cometamulet2_end" );
      
      if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
         cmn.IsEventDone( "use_sunamulet2" ) and 
         cmn.IsEventDone( "use_planetamulet2" ) and 
         cmn.IsEventDone( "use_cometamulet2" ) and 
         cmn.IsEventDone( "use_staramulet2" ) then
        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mglock2" );
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_towerdoor2_insert_wing" );
    ObjAnimate( "spr_towerdoor2_planetamulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_staramulet2 ()

  local item = "inv_staramulet2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_towerdoor2", false ) ) and
     ( not cmn.IsEventDone( "use_staramulet2" ) ) and 
       cmn.IsEventDone( "use_wholekey2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_towerdoor2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_towerdoor2_use_staramulet2", true ) or cmn.ApplyObj( item, "obj_towerdoor2_use_amulets", true ) ) and
         ( not cmn.IsEventDone( "use_staramulet2" ) ) and 
           cmn.IsEventDone( "use_wholekey2" ) then

    cmn.CallEventHandler( "use_staramulet2_inv" );
    cmn.CallEventHandler( "use_staramulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_staramulet2" );
      cmn.CallEventHandler( "use_staramulet2_end" );
      
      if cmn.IsEventDone( "use_halfmoonamulet2" ) and 
         cmn.IsEventDone( "use_sunamulet2" ) and 
         cmn.IsEventDone( "use_planetamulet2" ) and 
         cmn.IsEventDone( "use_cometamulet2" ) and 
         cmn.IsEventDone( "use_staramulet2" ) then
        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mglock2" );

      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_towerdoor2_insert_star" );
    ObjAnimate( "spr_towerdoor2_staramulet", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_dipnet2 ()

  local item = "inv_dipnet2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_precipice2", false ) ) and
     ( not cmn.IsEventDone( "use_dipnet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_precipice2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_precipice2_use_dipnet2", true ) ) and
         ( not cmn.IsEventDone( "use_dipnet2" ) ) then

    cmn.CallEventHandler( "use_dipnet2_inv" );
    cmn.CallEventHandler( "use_dipnet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_dipnet2" );
      cmn.CallEventHandler( "use_dipnet2_end" );
      private.get_snakesamulet2_2();

    end;

    int.Lock( true );
    
    ObjSet( "anm_precipice2_use_dipnet", { alp = 1 } );
    ObjSet( "anm_precipice2_wingsamulet", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_stuff_net" );
    AnimPlay( "anm_precipice2_use_dipnet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_astronomycircle2 ()

  local item = "inv_astronomycircle2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_precipice2", false ) ) and
     ( not cmn.IsEventDone( "use_astronomycircle2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_precipice2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_precipice2_use_astronomycircle2", true ) ) and
         ( not cmn.IsEventDone( "use_astronomycircle2" ) ) then

    cmn.CallEventHandler( "use_astronomycircle2_inv" );
    cmn.CallEventHandler( "use_astronomycircle2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_astronomycircle2" );
      cmn.CallEventHandler( "use_astronomycircle2_end" );
      private.Precipice2StartInit();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_circles_for_mmg" );
    ObjAnimate( "spr_precipice2_circle_3_shadow", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    ObjAnimate( "spr_precipice2_circle_3", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_dagger2 ()

  local item = "inv_dagger2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_travelingbag2", false ) ) and
     ( not cmn.IsEventDone( "use_dagger2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_travelingbag2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_travelingbag2_use_dagger2", true ) ) and
         ( not cmn.IsEventDone( "use_dagger2" ) ) then

    cmn.CallEventHandler( "use_dagger2_inv" );
    cmn.CallEventHandler( "use_dagger2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_dagger2" );
      cmn.CallEventHandler( "use_dagger2_end" );

    end;

    int.Lock( true );
    
    ObjSet( "anm_travelingbag2_case_click", { alp = 0 } );
    ObjSet( "anm_travelingbag2_use_dagger", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_cut_leather_jucket" );
    AnimPlay( "anm_travelingbag2_use_dagger", "DoAnim", func_end );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_figurine2 ()

  local item = "inv_figurine2";

  if ( cmn.ApplyObj( item, "gzz_neartower2_travelingbag2", false ) ) and
     ( not cmn.IsEventDone( "use_figurine2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_travelingbag2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_travelingbag2_use_figurine2", true ) ) and
         ( not cmn.IsEventDone( "use_figurine2" ) ) then

    cmn.CallEventHandler( "use_figurine2_inv" );
    cmn.CallEventHandler( "use_figurine2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_figurine2" );
      cmn.CallEventHandler( "use_figurine2_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_horse_bag" );
    ObjSet( "anm_travelingbag2_use_figurine", { alp = 1 } );
    ObjSet( "anm_travelingbag2_bag_click", { alp = 0 } );
    AnimPlay( "anm_travelingbag2_use_figurine", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_scissors2 ()

  local item = "inv_scissors2";

  if ( cmn.ApplyObj( item, "obj_neartower2_use_scissors2", true ) ) and
     ( not cmn.IsEventDone( "use_scissors2" ) ) then

    cmn.CallEventHandler( "use_scissors2_inv" );
    cmn.CallEventHandler( "use_scissors2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_scissors2" );
      cmn.CallEventHandler( "use_scissors2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_neartower2_scissors", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_rm_neartower2_cut" );
    AnimPlay( "anm_neartower2_scissors", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.dlg_neartower2_richard2_3 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_spiralamulet2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_neartower2_richard2_3_richard_static_1",      { alp = 0 } );
    ObjSet( "anm_neartower2_richard2_3_richard_static_2",      { alp = 0 } );
    ObjSet( "anm_neartower2_richard2_3_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_neartower2_richard2_3_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_neartower2_richard2_3_richard_static_1" );
    AnimStop( "anm_neartower2_richard2_3_richard_static_2" );
    AnimStop( "anm_neartower2_richard2_3_richard_disappearance" );

    ObjAnimate( "anm_neartower2_richard2_3_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_neartower2_richard2_3_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_spiralamulet2" );
      cmn.SetEventDone( "dlg_neartower2_richard2_3" );
      int.InventoryItemAdd( "inv_richardskull2" );
      cmn.ShowBbt( "bbt_neartower2_after_dlg_richard" );

      interface.KeyTaskDone( true, "task_2_5" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_neartower2_richard2_3_richard_appearance" );
    ObjSet( "anm_neartower2_richard2_3_richard_appearance", { alp = 0 } );

    ObjSet( "anm_neartower2_richard2_3_richard_static_1", { alp = 1 } );
    AnimPlay( "anm_neartower2_richard2_3_richard_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard2_3", "neartower2", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_neartower2_richard2_3_beg" );
  ObjAttach( "dlg_neartower2_richard2_3", GetCurrentRoom() );  

  ObjSet( "anm_neartower2_richard2_3_richard_appearance", { alp = 1 } );
  AnimPlay( "anm_neartower2_richard2_3_richard_appearance", "DoAnim", func_anim_end );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_neartower2_richard2_3_richard_static_1", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull2" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard2_3" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_neartower2_richard2_3_richard_static_1" );
        AnimPlay( "anm_neartower2_richard2_3_richard_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_neartower2_richard2_3_richard_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_neartower2_richard2_3_richard_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_neartower2_richard2_3_richard_static_2" );
        AnimPlay( "anm_neartower2_richard2_3_richard_give", "DoAnim", "" );
        AnimPlay( "anm_neartower2_richard2_3_object_appearance", "DoAnim", "" );

        ObjAnimate( "spr_neartower2_spiralamulet2", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_neartower2_richard2_3_richard_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_neartower2_richard2_3_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      cmn.PlayAudio( "sfx", "audio/aud_richard_creates_thing" );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_neartower2 ()

  if not ( cmn.IsEventDone( "opn_neartower2" ) ) then

    cmn.SetEventDone( "opn_neartower2" );

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_neartower2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_neartower2_env", 1 );

  if not ( cmn.IsEventDone( "dlg_neartower2_richard2_3" ) ) then

    private.dlg_neartower2_richard2_3();

  end;
  
  private.Neartower2CheckPrecipiceFX();
  private.Neartower2CheckWellFX();
  private.Neartower2CheckLocationFX();  
  
end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  if ( cmn.IsEventDone( "win_mglock2" ) ) then
    
    --if not ng_global.progress[ "std" ][ "opn_neartower2" ].lock then
    
      int.Lock( true );
      
      local func_end = function ()
        
        int.Lock( false );
        --ng_global.progress[ "std" ][ "opn_neartower2" ].lock = true;

        local prg = ng_global.currentprogress;
        ng_global.progress[ prg ].common.chapter = "level3";
        ng_global.progress[ prg ].common.currentroom = nil;
        local level = ng_global.progress[ prg ].common.chapter;
        ng_global.task_current = nil;

        common.LevelSwitch( level );

      end;

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_anim_open_door_castle" );
      AnimPlay( "anm_neartower2_towerdoor_open", "DoAnim", func_end );
    --  
    --else
    --  
    --  ObjSet( "anm_neartower2_towerdoor_open", { frame = 500 } );
      
    --end;

  end;
  
end;  
--*********************************************************************************************************************
function public.Open ()

  private.opn_neartower2();

end;
--*********************************************************************************************************************
function private.VidEmily1 ( func_end1 )

  local func_end = function ( skip )
   
    int.Lock( false );
    
    if ( skip ) then
      
      cmn.StopAudio( "mus", "audio/level2/mus/aud_neartower2_emily_1_mus" );
      cmn.StopAudio( "voc", "audio/level2/voc/aud_lvl2_neartower2_emily_1_voc" );
      
    end;

    common_impl.InterfaceSetVisible( true );
    func_end1();
    
   end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_neartower2_emily_1", func_end );  

  cmn.PlayAudio( "mus", "audio/level2/mus/aud_neartower2_emily_1_mus", nil, nil, 13 );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_lvl2_neartower2_emily_1_voc" );

end;
--*********************************************************************************************************************
function private.VidEmily3 ( func_end1 )

  local func_end = function ( skip )
   
    int.Lock( false );
    
    if ( skip ) then
      
      cmn.StopAudio( "mus", "audio/level2/mus/aud_neartower2_emily_3_mus" );
      cmn.StopAudio( "voc", "audio/level2/voc/aud_lvl2_neartower2_emily_3_voc" );
      
    end;

    common_impl.InterfaceSetVisible( true );
    func_end1();
    
   end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_neartower2_emily_3", func_end );  

  cmn.PlayAudio( "mus", "audio/level2/mus/aud_neartower2_emily_3_mus", nil, nil, 27 );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_lvl2_neartower2_emily_3_voc" );

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_figurine2",                                     { "dlg_neartower2_richard2_3" } );
  int.AddedTaskMap( private.room_objname, "get_spiralamulet2",                                 { "dlg_neartower2_richard2_3" } );
  int.AddedTaskMap( private.room_objname, "get_mosaicpart2" );
  int.AddedTaskMap( private.room_objname, "get_ring2_1",                                       { "use_pigeonamulet2" } );
  int.AddedTaskMap( private.room_objname, "get_talisman2",                                     { "use_bucket2", "use_chain2" } );
  int.AddedTaskMap( private.room_objname, "get_temporaryecho2_1",                              { "use_spiralamulet2_1" } );
  int.AddedTaskMap( private.room_objname, "get_handle2",                                       { "use_figurine2" } );
  int.AddedTaskMap( private.room_objname, "get_keypiece2_2",                                   { "use_tweezers2" } );
  int.AddedTaskMap( private.room_objname, "get_brokenamulet2",                                 { "use_wholekey2" } );
  int.AddedTaskMap( private.room_objname, "get_axe2",                                          { "use_handle2" } );
  int.AddedTaskMap( private.room_objname, "get_snakesamulet2_2",                               { "use_dipnet2" } );
  int.AddedTaskMap( private.room_objname, "get_temporaryecho2_3",                              { "use_spiralamulet2_3" } );
  int.AddedTaskMap( private.room_objname, "get_sunamulet2",                                    { "win_precipice2" } );
  int.AddedTaskMap( private.room_objname, "get_astronomycircle2",                              { "use_dagger2" } );
  int.AddedTaskMap( private.room_objname, "get_boltcutter2",                                   { "use_figurine2" } );
  int.AddedTaskMap( private.room_objname, "get_staramulet2",                                   { "use_dagger2" } );

  int.AddedTaskMap( private.room_objname, "use_pigeonamulet2",                                 { "get_pigeonamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_chain2",                                        { "get_chain2" } );
  int.AddedTaskMap( private.room_objname, "use_bucket2",                                       { "get_bucket2" } );
  int.AddedTaskMap( private.room_objname, "use_spiralamulet2_1",                               { "get_spiralamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_axe2",                                          { "get_axe2" } );
  int.AddedTaskMap( private.room_objname, "use_halfmoonamulet2",                               { "get_halfmoonamulet2", "use_wholekey2" } );
  int.AddedTaskMap( private.room_objname, "use_sunamulet2",                                    { "get_sunamulet2", "use_wholekey2" } );
  int.AddedTaskMap( private.room_objname, "use_tweezers2",                                     { "get_tweezers2" } );
  int.AddedTaskMap( private.room_objname, "use_handle2",                                       { "get_handle2" } );
  int.AddedTaskMap( private.room_objname, "use_wholekey2",                                     { "get_wholekey2" } );
  int.AddedTaskMap( private.room_objname, "use_planetamulet2",                                 { "get_planetamulet2", "use_wholekey2" } );
  int.AddedTaskMap( private.room_objname, "use_cometamulet2",                                  { "get_cometamulet2", "use_wholekey2" } );
  int.AddedTaskMap( private.room_objname, "use_staramulet2",                                   { "get_staramulet2", "use_wholekey2" } );
  int.AddedTaskMap( private.room_objname, "use_spiralamulet2_3",                               { "get_spiralamulet2", "use_spiralamulet2_2" } );
  int.AddedTaskMap( private.room_objname, "use_dipnet2",                                       { "get_dipnet2" } );
  int.AddedTaskMap( private.room_objname, "use_astronomycircle2",                              { "get_astronomycircle2" } );
  int.AddedTaskMap( private.room_objname, "use_dagger2",                                       { "get_dagger2" } );
  int.AddedTaskMap( private.room_objname, "use_figurine2",                                     { "get_figurine2" } );
  int.AddedTaskMap( private.room_objname, "use_scissors2",                                     { "get_scissors2" } );

  int.AddedTaskMap( private.room_objname, "win_precipice2",                                    { "use_astronomycircle2" } );
  int.AddedTaskMap( private.room_objname, "win_mglock2",                                       { "use_planetamulet2", "use_cometamulet2", "use_staramulet2", "use_sunamulet2", "use_halfmoonamulet2" } );
  int.AddedTaskMap( private.room_objname, "dlg_neartower2_richard2_3" );

  int.AddedTaskMap( private.room_objname, "opn_workshop2",                                     { "use_axe2" } );
  int.AddedTaskMap( private.room_objname, "opn_shore2",                                        { "use_scissors2" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_precipice2" );   
  subroom.Define("zz_well2");
  subroom.Define("zz_towerdoor2");  
  -------------------------------------------------
  function zz_precipice2.Open()
    
    if ( cmn.IsEventStart( "win_precipice2" ) and not cmn.IsEventDone( "win_precipice2" ) ) then

      cmn.MiniGameShow( "precipice2" );
      common_impl.PassingMgStart( "precipice2" );

    end;
    
    public.use_spiralamulet2_3(); 

  end;
  -------------------------------------------------
  function zz_precipice2.PreClose()
        
    if ( cmn.IsEventStart( "win_precipice2" ) and not cmn.IsEventDone( "win_precipice2" ) ) then

      cmn.MiniGameHide( "precipice2" );
      common_impl.PassingMgStop( "precipice2" );

    end;
    
  end;
  -------------------------------------------------
  function zz_precipice2.Close()
    
    private.Neartower2CheckPrecipiceFX();

  end;    
  -------------------------------------------------
  function zz_precipice2.Skip ()

    if ( cmn.IsEventStart( "win_precipice2" ) and not cmn.IsEventDone( "win_precipice2" ) ) then
      private.Precipice2Skip();
    end;

  end;
  -------------------------------------------------
  function zz_precipice2.Reset ()

    if ( cmn.IsEventStart( "win_precipice2" ) and not cmn.IsEventDone( "win_precipice2" ) ) then
      private.Precipice2Reset();
    end;

  end;
  -------------------------------------------------
  function zz_well2.Open()
    
    public.use_spiralamulet2_1();

  end;     
  -------------------------------------------------
  function zz_well2.Close()
    
    private.Neartower2CheckWellFX();

  end;       
  
  
  -------------------------------------------------
  
end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
  ObjAnimate( "spr_towerdoor2_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1,
  } );
  ObjAnimate( "obj_neartower2_clouds", "pos_x", 1, 0, "", 
  { 
    0.0, 0, 0,
    120.0, 0, -1486,
  } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Precipice2 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Precipice2StartInit ()

    cmn.MiniGameShow( "precipice2" );
    common_impl.PassingMgStart( "precipice2" );
    ng_global.progress[ "std" ][ "win_precipice2" ].pos = { 3, 4 };

  end;
--*********************************************************************************************************************  
  function private.Precipice2Load ()
    
    for i = 1, 2 do
      local pos = ng_global.progress[ "std" ][ "win_precipice2" ].pos[ i ];
      local ang = private.pos_ang[ i ][ pos ];
      ObjSet( "spr_precipice2_circle_"..i, { ang = ang } );
    end;   
    
  end;
--*********************************************************************************************************************
  function private.Precipice2Skip ()
    
    for i = 1, 2 do
      ng_global.progress[ "std" ][ "win_precipice2" ].pos[ i ] = 1;
      local pos = ng_global.progress[ "std" ][ "win_precipice2" ].pos[ i ];
      local ang = private.pos_ang[ i ][ pos ];
      ObjSet( "spr_precipice2_circle_"..i, { ang = ang } );
    end; 
    int.Lock( true );
    private.Precipice2Win();

  end;
--*********************************************************************************************************************
  function private.Precipice2Reset ()
    
    for i = 1, 2 do
      ng_global.progress[ "std" ][ "win_precipice2" ].pos[ i ] = private.old_pos[ i ];
      local pos = ng_global.progress[ "std" ][ "win_precipice2" ].pos[ i ];
      local ang = private.pos_ang[ i ][ pos ];
      ObjSet( "spr_precipice2_circle_"..i, { ang = ang } );
    end; 

  end;
--*********************************************************************************************************************
  function private.Precipice2Init ()

    for i = 1, 2 do

      ObjSet( "spr_precipice2_circle_"..i,
      {
        event_mdown  = function () private.Precipice2ClkCircle( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );

    end;

    private.pos_ang = { 
                       { 0, - 1.01, - 2.09, - 3.19, - 4.29, - 5.29, - 6.28 },
                       { 0, - 1.01, - 2.12, - 3.21, - 4.32, - 5.37, - 6.28 } 
                      };
                     
    private.old_pos = { 3, 4 };
    
    for i = 1, 2 do
      local pos = private.old_pos[ i ];
      local ang = private.pos_ang[ i ][ pos ];
      ObjSet( "spr_precipice2_circle_"..i, { ang = ang } );
    end;
                     
  end;
--*********************************************************************************************************************
  function private.Precipice2ClkCircle ( id )

    local old_pos = ng_global.progress[ "std" ][ "win_precipice2" ].pos[ id ];
    local new_pos = old_pos + 1;
    
    local old_ang = private.pos_ang[ id ][ old_pos ];
    local new_ang = private.pos_ang[ id ][ new_pos ]; 
    
    local func_end = function ()
      
      local tmp = {};
      
      tmp[ 1 ] = ng_global.progress[ "std" ][ "win_precipice2" ].pos[ 1 ];
      tmp[ 2 ] = ng_global.progress[ "std" ][ "win_precipice2" ].pos[ 2 ];
      tmp[ id ] = new_pos;
      
      if ( tmp[ 1 ] == 1 or tmp[ 1 ] == 7 ) and 
         ( tmp[ 2 ] == 1 or tmp[ 2 ] == 7 ) then
         
        private.Precipice2Win();
        
      else
         
        if ng_global.progress[ "std" ][ "win_precipice2" ].pos[ id ] ~= 6 then
          ng_global.progress[ "std" ][ "win_precipice2" ].pos[ id ] = new_pos;
        else  
          ng_global.progress[ "std" ][ "win_precipice2" ].pos[ id ] = 1;
          ObjSet( "spr_precipice2_circle_"..id, { ang = 0 } );
        end;
        
        int.Lock( false );
        
      end;
      
    end;
    
    int.Lock( true );

    if id == 1 then
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mmg_sign_click_small" );
    else
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mmg_sign_click_big" );
    end;

    ObjAnimate( "spr_precipice2_circle_"..id, "ang", 0, 0, func_end, 
    { 
      0.0, 0, old_ang,
      0.3, 0, new_ang,
    } );
    
  end;
--*********************************************************************************************************************
  function private.Precipice2Win () 
    
    local func_end = function ()
      
      cmn.MiniGameHide( "precipice2" );
      cmn.SetEventDone( "win_precipice2" );
      cmn.CallEventHandler( "win_precipice2" );
      common_impl.PassingMgWin( "precipice2" );
      int.Lock( false );
      
    end;
    
    AnimPlay( "anm_precipice2_door_open", "DoAnim", func_end ); 

  end;
--*********************************************************************************************************************
function private.TowerdoorKeypieceClk ()
  
  local func_end = function ()
    ObjSet( "anm_towerdoor2_keypiece_static", { alp = 1 } );
    ObjSet( "anm_towerdoor2_keypiece_click", { alp = 0 } );
    AnimPlay( "anm_towerdoor2_keypiece_static", "DoAnim", "" ); 
    cmn.ShowBbt( "bbt_towerdoor2_use_tweezers2" );
    int.Lock( false );
  end;
  
  int.Lock( true );
  ObjSet( "anm_towerdoor2_keypiece_static", { alp = 0 } );
  ObjSet( "anm_towerdoor2_keypiece_click", { alp = 1 } );
  AnimStop( "anm_towerdoor2_keypiece_static" );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_stuff_hole_key" );
  AnimPlay( "anm_towerdoor2_keypiece_click", "DoAnim", func_end ); 
  
end; 
--*********************************************************************************************************************
function private.TowerdoorAxebladeClk ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_towerdoor2_use_handle2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_zz_towerdoor2_blade_axe" );
  AnimPlay( "anm_towerdoor2_axeblade_click", "DoAnim", func_end ); 
  
end;
--*********************************************************************************************************************
function private.TravelingbagCaseClk ()
  
  local func_end = function ()
    cmn.ShowBbt( "bbt_travelingbag2_use_dagger2" );
    int.Lock( false );
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_broken_jacket" );
  AnimPlay( "anm_travelingbag2_case_click", "DoAnim", func_end ); 
  
end;
--*********************************************************************************************************************
function private.Travelingbag2Clk ()

  local func_end = function ()
    cmn.ShowBbt( "bbt_travelingbag2_use_figurine2" );
    int.Lock( false );
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_bag_zz_travelingbag2" );
  AnimPlay( "anm_travelingbag2_bag_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.WorkshopdoorBoardsClk ()
  
  local func_end = function ()
    cmn.ShowBbt( "bbt_workshopdoor2_use_axe2" );
    int.Lock( false );
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_zz_zz_workshopdoor2_woods" );
  AnimPlay( "anm_workshopdoor2_boards_click", "DoAnim", func_end ); 
  
end;
--*********************************************************************************************************************
function private.WellCashClk ()
  
  local func_end = function ()
    cmn.ShowBbt( "bbt_well2_use_pigeonamulet2" );
    int.Lock( false );
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_zz_well2_stone_near" );
  AnimPlay( "anm_well2_cashe_click", "DoAnim", func_end ); 
  
end;
--*********************************************************************************************************************
function private.Precipice2CircleClick ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_precipice2_use_astronomycircle2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_future_mmg_zz_precipice2" );

  ObjAnimate( "spr_precipice2_circle_2", "ang", 0, 0, "",
  {
    0.0, 3, -3.21,
    0.2, 3, -3.51,
    0.4, 3, -3.21,
  } );

  ObjAnimate( "spr_precipice2_circle_1", "ang", 0, 0, func_end,
  {
    0.0, 3, -2.09,
    0.2, 3, -1.79,
    0.4, 3, -2.09,
  } );

end;
--*********************************************************************************************************************
function private.NeartowerBushesClick ()
  
  local func_end = function ()

    cmn.ShowBbt( "bbt_neartower2_use_scissors2" );
    int.Lock( false );

    ObjSet( "anm_neartower2_bushes_static", { alp = 1 } );
    ObjSet( "anm_neartower2_bushes_click",  { alp = 0 } );
    AnimStop( "anm_neartower2_bushes_click" );
    AnimPlay( "anm_neartower2_bushes_static", "DoAnim", "" ); 

  end;
  
  int.Lock( true );

  ObjSet( "anm_neartower2_bushes_click",  { alp = 1 } );
  ObjSet( "anm_neartower2_bushes_static", { alp = 0 } );
  AnimStop( "anm_neartower2_bushes_static" );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_leaver_left" );
  AnimPlay( "anm_neartower2_bushes_click", "DoAnim", func_end ); 
  
end;
--*********************************************************************************************************************
function private.Neartower2CheckWellFX ()
  
  if ( cmn.IsEventDone( "use_spiralamulet2_1" ) and
     not ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_1" ].fx_showed ) then

    int.Lock( true );
       
    local func_end = function ()
      
      int.Lock( false );        
      ObjSet( "anm_neartower2_fx_well_shore", { alp = 0 } );              
      
    end;             
       
    ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_1" ].fx_showed  = true;  
    ObjSet( "anm_neartower2_fx_well_shore", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_magic_follows_us_leaves" );      
    AnimPlay( "anm_neartower2_fx_well_shore", "DoAnim", func_end );

  end;
  
end;
--*********************************************************************************************************************
function private.Neartower2CheckPrecipiceFX ()
  
  if ( cmn.IsEventDone( "use_spiralamulet2_3" ) and
       not ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_3" ].fx_showed ) then

    int.Lock( true );
       
    local func_end = function ()
      
      int.Lock( false );        
      ObjSet( "anm_neartower2_fx_precipice_shore", { alp = 0 } );              
      
    end;             
       
    ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_3" ].fx_showed  = true;    
    ObjSet( "anm_neartower2_fx_precipice_shore", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_rm_neartower2_magic_follows_rm_shore2" );          
    AnimPlay( "anm_neartower2_fx_precipice_shore", "DoAnim", func_end );
    
  end;

end;
--*********************************************************************************************************************
function private.Neartower2CheckLocationFX ()
  
  if ( cmn.IsEventDone( "use_spiralamulet2_2" ) and
       not ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_2" ].fx_neartower2_showed ) then

    int.Lock( true );
       
    local func_end = function ()
      
      int.Lock( false );        
      ObjSet( "anm_neartower2_fx_shore_precipice", { alp = 0 } );              
      
    end;             
       
    ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_2" ].fx_neartower2_showed  = true;    
    ObjSet( "anm_neartower2_fx_shore_precipice", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_rm_neartower2_magic_follows_door" );          
    AnimPlay( "anm_neartower2_fx_shore_precipice", "DoAnim", func_end );
    
  end;

end;

--*********************************************************************************************************************