-- name=rm_prison2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_prison2";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_window2", "room_hub" );
  ObjAttach( "zz_bed2", "room_hub" );
  ObjAttach( "zz_torturechamber2", "room_hub" );
  ObjAttach( "zz_stash2", "room_hub" );

  ObjMultiSet(
  {
    --{ "spr_window2_handkerchief2",             { event_mdown = private.get_handkerchief2 } },
    { "spr_window2_batamulet2",                { event_mdown = private.get_batamulet2 } },
    { "spr_window2_flint2_2",                  { event_mdown = private.get_flint2_2 } },
    { "spr_bed2_bread2",                       { event_mdown = private.get_bread2 } },
    { "spr_bed2_stump2",                       { event_mdown = private.get_stump2 } },
    { "spr_bed2_bonehandamulet2",              { event_mdown = private.get_bonehandamulet2 } },
    { "obj_bed2_duster2",                      { event_mdown = private.get_duster2 } },
    { "spr_torturechamber2_file2",             { event_mdown = private.get_file2 } },
    { "spr_torturechamber2_shard2",            { event_mdown = private.get_shard2 } },
    { "spr_torturechamber2_staff2",            { event_mdown = private.get_staff2 } },
    { "obj_torturechamber2_wetduster2",        { event_mdown = private.get_wetduster2 } },
    { "obj_stash2_flint2",                     { event_mdown = private.get_flint2 } },
    { "spr_stash2_rope2",                      { event_mdown = private.get_rope2 } },
    { "obj_torturechamber2_ironmaiden_handle_clk", { event_mdown = function() private.clk_torturechamber2_handle() end } },
    { "obj_torturechamber2_use_ravenamulet2",      { event_mdown = function() private.TorturechamberRackDoorClk( "ravenamulet2" ) end } },
    { "obj_torturechamber2_use_bonehandamulet2",   { event_mdown = function() private.TorturechamberRackDoorClk( "bonehandamulet2" ) end } },
    { "obj_torturechamber2_use_oil2",          { event_mdown = function() private.TorturechamberRustdoorClk() end } },
    { "obj_stash2_use_file2",                  { event_mdown = function() private.StashFlintClk() end } },
    { "obj_stash2_use_batamulet2",             { event_mdown = function() private.StashCapClk() end } },

    { "obj_window2_use_bread2",                { event_mdown = function() private.Window2GullClk() end } },
    { "obj_window2_use_wetduster2",            { event_mdown = function() private.Window2GullClk() end } },
    { "obj_window2_use_staff2",                { event_mdown = function() private.Window2GullClk() end } },

    { "obj_bed2_use_shard2",                   { event_mdown = function() private.Bed2PillowClk() end } },
    { "obj_bed2_use_file2_1",                  { event_mdown = function() private.Bed2BonehandamuletClk() end } },
    { "spr_stash2_screensaver_2_1",     { event_mdown = private.get_screensaver_2_1 } },      
    { "spr_bed2_screensaver_2_2",     { event_mdown = private.get_screensaver_2_2 } },  
    { "spr_torturechamber2_screensaver_2_3",     { event_mdown = private.get_screensaver_2_3 } },      
    { "spr_window2_screensaver_2_8",     { event_mdown = private.get_screensaver_2_8 } },      
  } );
  local get_screensaver_2_1 = function ()

    ObjDelete( "spr_stash2_screensaver_2_1" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_1", get_screensaver_2_1, private.room_objname );  
  local get_screensaver_2_2 = function ()

    ObjDelete( "spr_bed2_screensaver_2_2" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_2", get_screensaver_2_2, private.room_objname );  
  local get_screensaver_2_3 = function ()

    ObjDelete( "spr_torturechamber2_screensaver_2_3" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_3", get_screensaver_2_3, private.room_objname );  
  local get_screensaver_2_8 = function ()

    ObjDelete( "spr_window2_screensaver_2_8" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_8", get_screensaver_2_8, private.room_objname );   
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_prison2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_prison2", update_game_mode_prison2, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_4 = function ()

    ObjDelete( "obj_prison2_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_2_4", get_morphobject_2_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ravenamulet2 () end;
  --------------------------------------------------------------------------------------------
  local get_ravenamulet2_inv = function ()

    int.InventoryItemAdd( "inv_ravenamulet2", "spr_prison2_ravenamulet2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_ravenamulet2", get_ravenamulet2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_oil2 () end;
  --------------------------------------------------------------------------------------------
  local get_oil2_inv = function ()

    int.InventoryItemAdd( "inv_oil2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_oil2", get_oil2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_handkerchief2 () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "get_handkerchief2" ] =
  --{
  --  type = "get",
  --  get_obj = "spr_window2_handkerchief2",
  --  room = private.room_objname,
  --  zz = "zz_window2",
  --  zz_gate = "gzz_prison2_window2"
  --};
  --------------------------------------------------------------------------------------------
--  local get_handkerchief2_inv = function ()
--
--    int.InventoryItemAdd( "inv_handkerchief2", "spr_window2_handkerchief2" );
--
--  end;
--  local get_handkerchief2_closezz = function ()
--
--    ObjDelete( "gfx_window2_handkerchief2" );
--    ObjDelete( "spr_prison2_handkerchief" );
--    ObjDelete( "spr_window2_handkerchief2_shadow" );
--
--  end;
  --------------------------------------------------------------------------------------------
  --cmn.AddSubscriber( "get_handkerchief2", get_handkerchief2_inv );
  --cmn.AddSubscriber( "get_handkerchief2", get_handkerchief2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_batamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_batamulet2" ] =
  {
    type = "get",
    get_obj = "spr_window2_batamulet2",
    room = private.room_objname,
    zz = "zz_window2",
    zz_gate = "gzz_prison2_window2"
  };
  --------------------------------------------------------------------------------------------
  local get_batamulet2_inv = function ()

    int.InventoryItemAdd( "inv_batamulet2", "spr_window2_batamulet2" );

  end;
  local get_batamulet2_closezz = function ()

    ObjDelete( "gfx_window2_batamulet2" );
    ObjSet( "obj_window2_use_selfmadecat2", { input = true } );
    ObjDelete( "spr_prison2_batamulet" );
    --ObjDelete( "gzz_prison2_window2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_batamulet2", get_batamulet2_inv );
  cmn.AddSubscriber( "get_batamulet2", get_batamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flint2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flint2_2" ] =
  {
    type = "get",
    get_obj = "spr_window2_flint2_2",
    room = private.room_objname,
    zz = "zz_window2",
    zz_gate = "gzz_prison2_window2"
  };
  --------------------------------------------------------------------------------------------
  local get_flint2_2_inv = function ()

    int.InventoryItemAdd( "inv_flint2", "spr_window2_flint2_2", "assets/levels/level2/rm_prison2/zz_stash2/inv/inv_flint2_2" );
    level2_inv.CheckFlint2();

    if ( cmn.IsEventDone( "get_stump2" ) ) and
       ( cmn.IsEventDone( "get_flint2_1" ) ) then

      ObjSet( "inv_stump2_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_flint2_2_closezz = function ()

    ObjDelete( "gfx_window2_flint2_2" );
    ObjDelete( "spr_prison2_window_flint" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_flint2_2", get_flint2_2_inv );
  cmn.AddSubscriber( "get_flint2_2", get_flint2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bread2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bread2" ] =
  {
    type = "get",
    get_obj = "spr_bed2_bread2",
    room = private.room_objname,
    zz = "zz_bed2",
    zz_gate = "gzz_prison2_bed2"
  };
  --------------------------------------------------------------------------------------------
  local get_bread2_inv = function ()

    int.InventoryItemAdd( "inv_bread2", "spr_bed2_bread2" );

  end;
  local get_bread2_closezz = function ()

    ObjDelete( "gfx_bed2_bread2" );
    ObjDelete( "spr_prison2_bread" );
    ObjDelete( "spr_bed2_bread2_shadow" );

    --if cmn.IsEventDone( "get_stump2" ) and 
    --   cmn.IsEventDone( "get_bonehandamulet2" ) and 
    --   cmn.IsEventDone( "get_duster2" ) then
    --   ObjDelete( "gzz_prison2_bed2" );
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bread2", get_bread2_inv );
  cmn.AddSubscriber( "get_bread2", get_bread2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stump2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stump2" ] =
  {
    type = "get",
    get_obj = "spr_bed2_stump2",
    room = private.room_objname,
    zz = "zz_bed2",
    zz_gate = "gzz_prison2_bed2"
  };
  --------------------------------------------------------------------------------------------
  local get_stump2_inv = function ()

    int.InventoryItemAdd( "inv_stump2", "spr_bed2_stump2" );
    ObjSet( "inv_stump2", { drag = false } );

    if ( not cmn.IsEventDone( "get_flint2_1" ) ) or
       ( not cmn.IsEventDone( "get_flint2_2" ) ) then

      ObjSet( "inv_stump2_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_stump2_closezz = function ()

    ObjDelete( "gfx_bed2_stump2" );
    ObjDelete( "spr_prison2_stump" );
    
    --if cmn.IsEventDone( "get_bread2" ) and 
    --   cmn.IsEventDone( "get_bonehandamulet2" ) and 
    --   cmn.IsEventDone( "get_duster2" ) then
    --   ObjDelete( "gzz_prison2_bed2" );
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stump2", get_stump2_inv );
  cmn.AddSubscriber( "get_stump2", get_stump2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bonehandamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bonehandamulet2" ] =
  {
    type = "get",
    get_obj = "spr_bed2_bonehandamulet2",
    room = private.room_objname,
    zz = "zz_bed2",
    zz_gate = "gzz_prison2_bed2"
  };
  --------------------------------------------------------------------------------------------
  local get_bonehandamulet2_inv = function ()

    int.InventoryItemAdd( "inv_bonehandamulet2", "spr_bed2_bonehandamulet2" );

  end;
  local get_bonehandamulet2_closezz = function ()

    ObjDelete( "anm_bed2_use_file" );
    ObjDelete( "spr_prison2_bonehandamulet" );
    
    --if cmn.IsEventDone( "get_bread2" ) and 
    --   cmn.IsEventDone( "get_stump2" ) and 
    --   cmn.IsEventDone( "get_duster2" ) then
    --   ObjDelete( "gzz_prison2_bed2" );
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bonehandamulet2", get_bonehandamulet2_inv );
  cmn.AddSubscriber( "get_bonehandamulet2", get_bonehandamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_duster2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_duster2" ] =
  {
    type = "get",
    get_obj = "obj_bed2_duster2",
    room = private.room_objname,
    zz = "zz_bed2",
    zz_gate = "gzz_prison2_bed2"
  };
  --------------------------------------------------------------------------------------------
  local get_duster2_inv = function ()

    int.InventoryItemAdd( "inv_duster2", "obj_bed2_duster2" );

  end;
  local get_duster2_closezz = function ()

    ObjDelete( "gfx_bed2_duster2" );
    ObjSet( "spr_prison2_bed_pillow_open_2", { alp = 1 } );
    
    --if cmn.IsEventDone( "get_bread2" ) and 
    --   cmn.IsEventDone( "get_stump2" ) and 
    --   cmn.IsEventDone( "get_bonehandamulet2" ) then
    --   ObjDelete( "gzz_prison2_bed2" );
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_duster2", get_duster2_inv );
  cmn.AddSubscriber( "get_duster2", get_duster2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_file2" ] =
  {
    type = "get",
    get_obj = "spr_torturechamber2_file2",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  --------------------------------------------------------------------------------------------
  local get_file2_inv = function ()

    int.InventoryItemAdd( "inv_file2", "spr_torturechamber2_file2" );

  end;
  local get_file2_closezz = function ()

    ObjDelete( "gfx_torturechamber2_file2" );
    ObjDelete( "spr_prison2_file" );
    
    if cmn.IsEventDone( "get_shard2" ) and 
       cmn.IsEventDone( "get_staff2" ) and 
       cmn.IsEventDone( "get_wetduster2" ) then
       
      ObjDelete( "gzz_prison2_torturechamber2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_file2", get_file2_inv );
  cmn.AddSubscriber( "get_file2", get_file2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shard2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shard2" ] =
  {
    type = "get",
    get_obj = "spr_torturechamber2_shard2",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  --------------------------------------------------------------------------------------------
  local get_shard2_inv = function ()

    int.InventoryItemAdd( "inv_shard2", "spr_torturechamber2_shard2" );

  end;
  local get_shard2_closezz = function ()

    ObjDelete( "anm_torturechamber2_lattern" );
    ObjSet( "anm_torturechamber2_lattern_noglass", { alp = 1, playing = true } );

    ObjDelete( "gfx_torturechamber2_shard2" );
    ObjDelete( "spr_prison2_shard" );
    
    if cmn.IsEventDone( "get_file2" ) and 
       cmn.IsEventDone( "get_staff2" ) and 
       cmn.IsEventDone( "get_wetduster2" ) then
       
      ObjDelete( "gzz_prison2_torturechamber2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_shard2", get_shard2_inv );
  cmn.AddSubscriber( "get_shard2", get_shard2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_staff2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_staff2" ] =
  {
    type = "get",
    get_obj = "spr_torturechamber2_staff2",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  --------------------------------------------------------------------------------------------
  local get_staff2_inv = function ()

    int.InventoryItemAdd( "inv_staff2", "spr_torturechamber2_staff2" );

  end;
  local get_staff2_closezz = function ()

    ObjDelete( "gfx_torturechamber2_staff2" );
    ObjDelete( "spr_torturechamber2_staff_shadow" );
    ObjDelete( "spr_prison2_staff" );
    
    if cmn.IsEventDone( "get_file2" ) and 
       cmn.IsEventDone( "get_shard2" ) and 
       cmn.IsEventDone( "get_wetduster2" ) then
       
      ObjDelete( "gzz_prison2_torturechamber2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_staff2", get_staff2_inv );
  cmn.AddSubscriber( "get_staff2", get_staff2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wetduster2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wetduster2" ] =
  {
    type = "get",
    get_obj = "obj_torturechamber2_wetduster2",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  --------------------------------------------------------------------------------------------
  local get_wetduster2_inv = function ()

    int.InventoryItemAdd( "inv_wetduster2", "obj_torturechamber2_wetduster2" );

  end;
  local get_wetduster2_closezz = function ()

    ObjDelete( "gfx_torturechamber2_wetduster2" );
    
    if cmn.IsEventDone( "get_file2" ) and 
       cmn.IsEventDone( "get_shard2" ) and 
       cmn.IsEventDone( "get_staff2" ) then
       
      ObjDelete( "gzz_prison2_torturechamber2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_wetduster2", get_wetduster2_inv );
  cmn.AddSubscriber( "get_wetduster2", get_wetduster2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flint2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flint2_1" ] =
  {
    type = "get",
    get_obj = "obj_stash2_flint2",
    room = private.room_objname,
    zz = "zz_stash2",
    zz_gate = "gzz_prison2_stash2"
  };
  --------------------------------------------------------------------------------------------
  local get_flint2_1_inv = function ()

    int.InventoryItemAdd( "inv_flint2", "obj_stash2_flint2", "assets/levels/level2/rm_prison2/zz_stash2/inv/inv_flint2_1" );
    level2_inv.CheckFlint2();

    if ( cmn.IsEventDone( "get_stump2" ) ) and
       ( cmn.IsEventDone( "get_flint2_2" ) ) then

      ObjSet( "inv_stump2_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_flint2_1_closezz = function ()

    ObjDelete( "spr_prison2_stash_flint" );

    if ( cmn.IsEventDone( "get_rope2" ) ) then

      ObjDelete( "gzz_prison2_stash2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_flint2_1", get_flint2_1_inv );
  cmn.AddSubscriber( "get_flint2_1", get_flint2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_rope2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_rope2" ] =
  {
    type = "get",
    get_obj = "spr_stash2_rope2",
    room = private.room_objname,
    zz = "zz_stash2",
    zz_gate = "gzz_prison2_stash2"
  };
  --------------------------------------------------------------------------------------------
  local get_rope2_inv = function ()

    int.InventoryItemAdd( "inv_rope2", "spr_stash2_rope2" );
    ObjSet( "inv_rope2", { drag = false } );

    if ( not cmn.IsEventDone( "win_hoskeleton2" ) ) then

      ObjSet( "inv_rope2_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_rope2_closezz = function ()

    ObjDelete( "gfx_stash2_rope2" );
    ObjDelete( "spr_stash2_rope_shadow" );
    ObjDelete( "spr_prison2_rope" );
    ObjSet( "spr_stash2_note", { input = true } );

    if ( cmn.IsEventDone( "get_flint2_1" ) ) then

      ObjDelete( "gzz_prison2_stash2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_rope2", get_rope2_inv );
  cmn.AddSubscriber( "get_rope2", get_rope2_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_bread2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bread2" ] =
  {
    type = "use",
    use_obj = "inv_bread2",
    use_place = "obj_window2_use_bread2",
    room = private.room_objname,
    zz = "zz_window2",
    zz_gate = "gzz_prison2_window2"
  };
  --------------------------------------------------------------------------------------------
  local use_bread2_inv = function ()

    int.InventoryItemRemove( "inv_bread2" );

  end;
  local use_bread2_beg = function ()

    ObjDelete( "obj_window2_use_bread2" );

  end;
  local use_bread2_end = function ()

    ObjSet( "spr_window2_batamulet2", { input = true } );
    ObjSet( "gfx_window2_batamulet2", { active = true } );
    ObjDelete( "anm_window2_gull_static" );
    ObjDelete( "anm_window2_gull_click" );
    ObjDelete( "anm_window2_use_bread" );

    ObjDelete( "spr_prison2_gull" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bread2",     use_bread2_inv );
  cmn.AddSubscriber( "use_bread2",     use_bread2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bread2",     use_bread2_end, private.room_objname );
  cmn.AddSubscriber( "use_bread2_inv", use_bread2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bread2_beg", use_bread2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bread2_end", use_bread2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_staff2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_staff2" ] =
  {
    type = "use",
    use_obj = "inv_staff2",
    use_place = "obj_window2_use_staff2",
    room = private.room_objname,
    zz = "zz_window2",
    zz_gate = "gzz_prison2_window2"
  };
  --------------------------------------------------------------------------------------------
  local use_staff2_inv = function ()

    int.InventoryItemRemove( "inv_staff2" );

  end;
  local use_staff2_beg = function ()

    ObjDelete( "obj_window2_use_staff2" );

  end;
  local use_staff2_end = function ()
    
    ObjDelete( "spr_window2_lattice" );
    ObjDelete( "spr_window2_wetduster_big" );
    ObjSet( "anm_window2_use_staff", { alp = 1, frame = 500 } );

    ObjSet( "obj_window2_use_bread2", { input = true } );
    
    ObjSet( "spr_prison2_window_open", { alp = 1 } );
    ObjDelete( "spr_prison2_window_close" );
    ObjDelete( "spr_prison2_window_wetduster" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_staff2",     use_staff2_inv );
  cmn.AddSubscriber( "use_staff2",     use_staff2_beg, private.room_objname );
  cmn.AddSubscriber( "use_staff2",     use_staff2_end, private.room_objname );
  cmn.AddSubscriber( "use_staff2_inv", use_staff2_inv, private.room_objname );
  cmn.AddSubscriber( "use_staff2_beg", use_staff2_beg, private.room_objname );
  cmn.AddSubscriber( "use_staff2_end", use_staff2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wetduster2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wetduster2" ] =
  {
    type = "use",
    use_obj = "inv_wetduster2",
    use_place = "obj_window2_use_wetduster2",
    room = private.room_objname,
    zz = "zz_window2",
    zz_gate = "gzz_prison2_window2"
  };
  --------------------------------------------------------------------------------------------
  local use_wetduster2_inv = function ()

    int.InventoryItemRemove( "inv_wetduster2" );

  end;
  local use_wetduster2_beg = function ()

    ObjDelete( "obj_window2_use_wetduster2" );

  end;
  local use_wetduster2_end = function ()

    ObjSet( "spr_window2_wetduster_big", { alp = 1 } );
    ObjSet( "obj_window2_use_staff2", { input = true } );
    
    ObjSet( "spr_prison2_window_wetduster", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wetduster2",     use_wetduster2_inv );
  cmn.AddSubscriber( "use_wetduster2",     use_wetduster2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wetduster2",     use_wetduster2_end, private.room_objname );
  cmn.AddSubscriber( "use_wetduster2_inv", use_wetduster2_inv, private.room_objname );
  cmn.AddSubscriber( "use_wetduster2_beg", use_wetduster2_beg, private.room_objname );
  cmn.AddSubscriber( "use_wetduster2_end", use_wetduster2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_selfmadecat2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_selfmadecat2" ] =
  {
    type = "use",
    use_obj = "inv_selfmadecat2",
    use_place = "obj_window2_use_selfmadecat2",
    room = private.room_objname,
    zz = "zz_window2",
    zz_gate = "gzz_prison2_window2"
  };
  --------------------------------------------------------------------------------------------
  local use_selfmadecat2_inv = function ()

    int.InventoryItemRemove( "inv_selfmadecat2" );

  end;
  local use_selfmadecat2_beg = function ()

    ObjDelete( "obj_window2_use_selfmadecat2" );

  end;
  local use_selfmadecat2_end = function ()

    ObjSet( "gmg_prison2_mgdescent2", { alp = 1, input = true, active = true } );
    ObjDelete( "gzz_prison2_window2" );
    
    ObjSet( "spr_prison2_selfmadecat", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_selfmadecat2",     use_selfmadecat2_inv );
  cmn.AddSubscriber( "use_selfmadecat2",     use_selfmadecat2_beg, private.room_objname );
  cmn.AddSubscriber( "use_selfmadecat2",     use_selfmadecat2_end, private.room_objname );
  cmn.AddSubscriber( "use_selfmadecat2_inv", use_selfmadecat2_inv, private.room_objname );
  cmn.AddSubscriber( "use_selfmadecat2_beg", use_selfmadecat2_beg, private.room_objname );
  cmn.AddSubscriber( "use_selfmadecat2_end", use_selfmadecat2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_file2_1" ] =
  {
    type = "use",
    use_obj = "inv_file2",
    use_place = "obj_bed2_use_file2_1",
    room = private.room_objname,
    zz = "zz_bed2",
    zz_gate = "gzz_prison2_bed2"
  };
  --------------------------------------------------------------------------------------------
  local use_file2_1_inv = function ()
    
    if cmn.IsEventDone( "use_file2_2" ) then
      int.InventoryItemRemove( "inv_file2" );
    end;

  end;
  local use_file2_1_beg = function ()

    ObjDelete( "obj_bed2_use_file2_1" );

  end;
  local use_file2_1_end = function ()

    ObjDelete( "anm_bed2_click_bonehandamulet" );
    ObjSet( "anm_bed2_use_file", { alp = 1, frame = 500, croprect_init = true, croprect_x = -256, croprect_y = -208, croprect_w = 530, croprect_w = 416 } );
    ObjSet( "spr_bed2_bonehandamulet2", { input = true } );
    ObjSet( "gfx_bed2_bonehandamulet2", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_file2_1",     use_file2_1_inv );
  cmn.AddSubscriber( "use_file2_1",     use_file2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_file2_1",     use_file2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_file2_1_inv", use_file2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_file2_1_beg", use_file2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_file2_1_end", use_file2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shard2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shard2" ] =
  {
    type = "use",
    use_obj = "inv_shard2",
    use_place = "obj_bed2_use_shard2",
    room = private.room_objname,
    zz = "zz_bed2",
    zz_gate = "gzz_prison2_bed2"
  };
  --------------------------------------------------------------------------------------------
  local use_shard2_inv = function ()

    int.InventoryItemRemove( "inv_shard2" );

  end;
  local use_shard2_beg = function ()

    ObjDelete( "obj_bed2_use_shard2" );
    ObjDelete( "anm_bed2_click_pillow" );

  end;
  local use_shard2_end = function ()

    ObjSet( "spr_bed2_torn_pillow", { alp = 1 } );
    ObjSet( "anm_bed2_use_shard", { alp = 1, frame = 500, croprect_init = true, croprect_x = - 256, croprect_y = - 208, croprect_w = 530, croprect_w = 416 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shard2",     use_shard2_inv );
  cmn.AddSubscriber( "use_shard2",     use_shard2_beg, private.room_objname );
  cmn.AddSubscriber( "use_shard2",     use_shard2_end, private.room_objname );
  cmn.AddSubscriber( "use_shard2_inv", use_shard2_inv, private.room_objname );
  cmn.AddSubscriber( "use_shard2_beg", use_shard2_beg, private.room_objname );
  cmn.AddSubscriber( "use_shard2_end", use_shard2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bonehandamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bonehandamulet2" ] =
  {
    type = "use",
    use_obj = "inv_bonehandamulet2",
    use_place = "obj_torturechamber2_use_bonehandamulet2",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  --------------------------------------------------------------------------------------------
  local use_bonehandamulet2_inv = function ()

    int.InventoryItemRemove( "inv_bonehandamulet2" );

  end;
  local use_bonehandamulet2_beg = function ()

    ObjDelete( "obj_torturechamber2_use_bonehandamulet2" );

  end;
  local use_bonehandamulet2_end = function ()

    if cmn.IsEventDone( "use_ravenamulet2" ) then
      
      ObjSet( "obj_torturechamber2_rack_open", { input = true } );
      ObjSet( "anm_torturechamber2_slots_open", { alp = 1, frame = 500 } );
      ObjDelete( "obj_torturechamber2_rack_close" );
      ObjSet( "gfx_torturechamber2_staff2", { active = true } );
      
      ObjSet( "spr_prison2_open_rack", { alp = 1 } );
      ObjSet( "spr_prison2_staff", { alp = 1 } );
      
      ObjDelete( "spr_prison2_torturechamber_ravenamulet" );
      
    else
      ObjSet( "anm_torturechamber2_slots_bonehandamulet2", { alp = 1 } );
      ObjDelete( "anm_torturechamber2_slots_bonehandamulet1" );  
      ObjSet( "spr_prison2_torturechamber_bonehandamulet", { alp = 1 } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bonehandamulet2",     use_bonehandamulet2_inv );
  cmn.AddSubscriber( "use_bonehandamulet2",     use_bonehandamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bonehandamulet2",     use_bonehandamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_bonehandamulet2_inv", use_bonehandamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bonehandamulet2_beg", use_bonehandamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bonehandamulet2_end", use_bonehandamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_duster2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_duster2" ] =
  {
    type = "use",
    use_obj = "inv_duster2",
    use_place = "obj_torturechamber2_use_duster2",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  --------------------------------------------------------------------------------------------
  local use_duster2_inv = function ()

    int.InventoryItemRemove( "inv_duster2" );

  end;
  local use_duster2_beg = function ()

    ObjDelete( "obj_torturechamber2_use_duster2" );

  end;
  local use_duster2_end = function ()

    ObjDelete( "anm_torturechamber2_use_duster" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_duster2",     use_duster2_inv );
  cmn.AddSubscriber( "use_duster2",     use_duster2_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster2",     use_duster2_end, private.room_objname );
  cmn.AddSubscriber( "use_duster2_inv", use_duster2_inv, private.room_objname );
  cmn.AddSubscriber( "use_duster2_beg", use_duster2_beg, private.room_objname );
  cmn.AddSubscriber( "use_duster2_end", use_duster2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oil2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oil2" ] =
  {
    type = "use",
    use_obj = "inv_oil2",
    use_place = "obj_torturechamber2_use_oil2",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  --------------------------------------------------------------------------------------------
  local use_oil2_inv = function ()

    int.InventoryItemRemove( "inv_oil2" );

  end;
  local use_oil2_beg = function ()

    ObjDelete( "obj_torturechamber2_use_oil2" );

  end;
  local use_oil2_end = function ()

    ObjSet( "obj_torturechamber2_ironmaiden_handle_clk", { input = true } );
    ObjDelete( "anm_torturechamber2_rustdoor_clk" );
    ObjSet( "anm_torturechamber2_use_oil", { frame = 500, alp = 1 } );
    
    ObjDelete( "spr_prison2_rust_maiden" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oil2",     use_oil2_inv );
  cmn.AddSubscriber( "use_oil2",     use_oil2_beg, private.room_objname );
  cmn.AddSubscriber( "use_oil2",     use_oil2_end, private.room_objname );
  cmn.AddSubscriber( "use_oil2_inv", use_oil2_inv, private.room_objname );
  cmn.AddSubscriber( "use_oil2_beg", use_oil2_beg, private.room_objname );
  cmn.AddSubscriber( "use_oil2_end", use_oil2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ravenamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ravenamulet2" ] =
  {
    type = "use",
    use_obj = "inv_ravenamulet2",
    use_place = "obj_torturechamber2_use_ravenamulet2",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  --------------------------------------------------------------------------------------------
  local use_ravenamulet2_inv = function ()

    int.InventoryItemRemove( "inv_ravenamulet2" );

  end;
  local use_ravenamulet2_beg = function ()

    ObjDelete( "obj_torturechamber2_use_ravenamulet2" );

  end;
  local use_ravenamulet2_end = function ()

    if cmn.IsEventDone( "use_bonehandamulet2" ) then
      
      ObjSet( "obj_torturechamber2_rack_open", { input = true } );
      ObjSet( "anm_torturechamber2_slots_open", { alp = 1, frame = 500 } );
      ObjDelete( "obj_torturechamber2_rack_close" );
      ObjSet( "gfx_torturechamber2_staff2", { active = true } );
      
      ObjSet( "spr_prison2_open_rack", { alp = 1 } );
      ObjSet( "spr_prison2_staff", { alp = 1 } );
      
      ObjDelete( "spr_prison2_torturechamber_bonehandamulet" );
      
    else
      
      ObjSet( "anm_torturechamber2_slots_ravenamulet2", { alp = 1 } ); 
      ObjDelete( "anm_torturechamber2_slots_ravenamulet1" );
      ObjSet( "spr_prison2_torturechamber_ravenamulet", { alp = 1 } ); 
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ravenamulet2",     use_ravenamulet2_inv );
  cmn.AddSubscriber( "use_ravenamulet2",     use_ravenamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ravenamulet2",     use_ravenamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_ravenamulet2_inv", use_ravenamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_ravenamulet2_beg", use_ravenamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ravenamulet2_end", use_ravenamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handkerchief2 () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "use_handkerchief2" ] =
  --{
  --  type = "use",
  --  use_obj = "inv_handkerchief2",
  --  use_place = "obj_torturechamber2_use_handkerchief2",
  --  room = private.room_objname,
  --  zz = "zz_torturechamber2",
  --  zz_gate = "gzz_prison2_torturechamber2"
  --};
  --------------------------------------------------------------------------------------------
--  local use_handkerchief2_inv = function ()
--
--    int.InventoryItemRemove( "inv_handkerchief2" );
--
--  end;
--  local use_handkerchief2_beg = function ()
--
--    ObjDelete( "obj_torturechamber2_use_handkerchief2" );
--
--  end;
--  local use_handkerchief2_end = function ()
--
--    ObjDelete( "anm_torturechamber2_lattern" );
--    ObjDelete( "anm_torturechamber2_use_handkerchief" );
--    ObjSet( "anm_torturechamber2_lattern_noglass", { alp = 1, playing = true } );
--    
--  end;
  --------------------------------------------------------------------------------------------
  --cmn.AddSubscriber( "use_handkerchief2",     use_handkerchief2_inv );
  --cmn.AddSubscriber( "use_handkerchief2",     use_handkerchief2_beg, private.room_objname );
  --cmn.AddSubscriber( "use_handkerchief2",     use_handkerchief2_end, private.room_objname );
  --cmn.AddSubscriber( "use_handkerchief2_inv", use_handkerchief2_inv, private.room_objname );
  --cmn.AddSubscriber( "use_handkerchief2_beg", use_handkerchief2_beg, private.room_objname );
  --cmn.AddSubscriber( "use_handkerchief2_end", use_handkerchief2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_file2_2" ] =
  {
    type = "use",
    use_obj = "inv_file2",
    use_place = "obj_stash2_use_file2",
    room = private.room_objname,
    zz = "zz_stash2",
    zz_gate = "gzz_prison2_stash2"
  };
  --------------------------------------------------------------------------------------------
  local use_file2_2_inv = function ()

    if cmn.IsEventDone( "use_file2_1" ) then
      int.InventoryItemRemove( "inv_file2" );
    end;

  end;
  local use_file2_2_beg = function ()

    ObjDelete( "obj_stash2_use_file2" );

  end;
  local use_file2_2_end = function ()

    ObjDelete( "anm_stash2_click_flint" );
    ObjDelete( "anm_stash2_use_file" );
    ObjSet( "spr_stash2_flint_1", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_file2_2",     use_file2_2_inv );
  cmn.AddSubscriber( "use_file2_2",     use_file2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_file2_2",     use_file2_2_end, private.room_objname );
  cmn.AddSubscriber( "use_file2_2_inv", use_file2_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_file2_2_beg", use_file2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_file2_2_end", use_file2_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_batamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_batamulet2" ] =
  {
    type = "use",
    use_obj = "inv_batamulet2",
    use_place = "obj_stash2_use_batamulet2",
    room = private.room_objname,
    zz = "zz_stash2",
    zz_gate = "gzz_prison2_stash2"
  };
  --------------------------------------------------------------------------------------------
  local use_batamulet2_inv = function ()

    int.InventoryItemRemove( "inv_batamulet2" );

  end;
  local use_batamulet2_beg = function ()

    ObjDelete( "obj_stash2_use_batamulet2" );

  end;
  local use_batamulet2_end = function ()

    ObjSet( "obj_stash2_open", { input = true } );
    ObjSet( "gfx_stash2_rope2", { active = true } );
    ObjDelete( "obj_stash2_close" );
    
    ObjDelete( "spr_prison2_stash_door" );
    ObjSet( "spr_prison2_stones", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_batamulet2",     use_batamulet2_inv );
  cmn.AddSubscriber( "use_batamulet2",     use_batamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_batamulet2",     use_batamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_batamulet2_inv", use_batamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_batamulet2_beg", use_batamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_batamulet2_end", use_batamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lamp2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lamp2" ] =
  {
    type = "use",
    use_obj = "inv_lamp2",
    use_place = "obj_prison2_use_lamp2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local use_lamp2_inv = function ()

    int.InventoryItemRemove( "inv_lamp2" );

  end;
  local use_lamp2_beg = function ()

    ObjDelete( "obj_prison2_use_lamp2" );

  end;
  local use_lamp2_end = function ()

    ObjSet( "gho_prison2_hoskeleton2", { alp = 1, input = true, active = true } );
    ObjSet( "obj_prison2_ho", { alp = 1 } );
    ObjSet( "spr_prison2_fire_ho", { active = true } );
    ObjSet( "anm_prison2_candle_static", { alp = 1, animfunc = "DoAnim", playing = true } );
    ObjSet( "anm_prison2_candle_2",      { alp = 1, animfunc = "DoAnim", frame = 385 } );
    ObjDelete( "anm_prison2_candle" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lamp2",     use_lamp2_inv );
  cmn.AddSubscriber( "use_lamp2",     use_lamp2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lamp2",     use_lamp2_end, private.room_objname );
  cmn.AddSubscriber( "use_lamp2_inv", use_lamp2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lamp2_beg", use_lamp2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lamp2_end", use_lamp2_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_torturechamber2_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_torturechamber2_handle" ] =
  {
    type = "click",
    clk_obj = "obj_torturechamber2_ironmaiden_handle_clk",
    room = private.room_objname,
    zz = "zz_torturechamber2",
    zz_gate = "gzz_prison2_torturechamber2"
  };
  -----------------------------------------------
  local clk_torturechamber2_handle_inv = function ()

  end;
  local clk_torturechamber2_handle_beg = function ()

    ObjDelete( "anm_torturechamber2_use_oil" );

  end;
  local clk_torturechamber2_handle_end = function ()

    ObjDelete( "obj_torturechamber2_ironmaiden_close" );
    ObjSet( "obj_torturechamber2_ironmaiden_open", { input = true } );
    ObjSet( "anm_torturechamber2_open_ironmaiden", { alp = 1, frame = 500 } );
    ObjSet( "gfx_torturechamber2_file2", { active = true } );
    
    ObjSet( "spr_prison2_open_ironmaiden", { alp = 1 } );
    ObjSet( "spr_prison2_file", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_torturechamber2_handle",     clk_torturechamber2_handle_inv );
  cmn.AddSubscriber( "clk_torturechamber2_handle",     clk_torturechamber2_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_torturechamber2_handle",     clk_torturechamber2_handle_end, private.room_objname );
  cmn.AddSubscriber( "clk_torturechamber2_handle_inv", clk_torturechamber2_handle_inv, private.room_objname );
  cmn.AddSubscriber( "clk_torturechamber2_handle_beg", clk_torturechamber2_handle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_torturechamber2_handle_end", clk_torturechamber2_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgdescent2 () end;
  --------------------------------------------------------------------------------------------
  local win_mgdescent2 = function ()

    if ( cmn.IsEventDone( "win_mgdescent2" ) ) then

      ObjDelete( "gmg_prison2_mgdescent2" );
      ObjSet( "grm_prison2_alley2", { alp = 1, input = true, active = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_prison2_alley2_focus");
      end;
    end;

  end;

  cmn.AddSubscriber( "win_mgdescent2", win_mgdescent2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_prison2_richard2_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_prison2_richard2_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_prison2_richard2_1_end = function ()

    ObjDelete( "dlg_prison2_richard2_1" );

  end;

  cmn.AddSubscriber( "dlg_prison2_richard2_1",     dlg_prison2_richard2_1_beg );
  cmn.AddSubscriber( "dlg_prison2_richard2_1",     dlg_prison2_richard2_1_end );
  cmn.AddSubscriber( "dlg_prison2_richard2_1_beg", dlg_prison2_richard2_1_beg );
  cmn.AddSubscriber( "dlg_prison2_richard2_1_end", dlg_prison2_richard2_1_end );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_hoskeleton2 () end;
  --------------------------------------------------------------------------------------------
  local win_hoskeleton2 = function ()

    if ( cmn.IsEventDone( "win_hoskeleton2" ) ) then

      ObjSet( "obj_prison2_skeleton_bbt", { input = true } );

    end;

  end;

  cmn.AddSubscriber( "win_hoskeleton2", win_hoskeleton2, private.room_objname );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------------------------------
--function private.get_handkerchief2 ()
--
--  cmn.SetEventDone( "get_handkerchief2" );
--  cmn.CallEventHandler( "get_handkerchief2" );
--  cmn.GetObjectSfx();
--
--end;
-----------------------------------------------------------------------  
function private.get_screensaver_2_1()

  int.AddScreensaver( "spr_stash2_screensaver_2_1" );

end;    
function private.get_screensaver_2_2()

  int.AddScreensaver( "spr_bed2_screensaver_2_2" );

end;    
function private.get_screensaver_2_3()

  int.AddScreensaver( "spr_torturechamber2_screensaver_2_3" );

end;    
function private.get_screensaver_2_8()

  int.AddScreensaver( "spr_window2_screensaver_2_8" );

end; 
-----------------------------------------------------------------------
function private.get_batamulet2 ()

  cmn.SetEventDone( "get_batamulet2" );
  cmn.CallEventHandler( "get_batamulet2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_flint2_2 ()

  cmn.SetEventDone( "get_flint2_2" );
  cmn.CallEventHandler( "get_flint2_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_bread2 ()

  cmn.SetEventDone( "get_bread2" );
  cmn.CallEventHandler( "get_bread2" );
  cmn.GetObjectSfx();
  
  --if cmn.IsEventDone( "get_stump2" ) and 
  --   cmn.IsEventDone( "get_bonehandamulet2" ) and 
  --   cmn.IsEventDone( "get_duster2" ) then
  --  cmn.CloseSubRoom();
  --end;

end;
-----------------------------------------------------------------------
function private.get_stump2 ()

  cmn.SetEventDone( "get_stump2" );
  cmn.CallEventHandler( "get_stump2" );
  cmn.GetObjectSfx();
  
  --if cmn.IsEventDone( "get_bread2" ) and 
  --   cmn.IsEventDone( "get_bonehandamulet2" ) and 
  --   cmn.IsEventDone( "get_duster2" ) then
  --  cmn.CloseSubRoom();
  --end;

end;
-----------------------------------------------------------------------
function private.get_bonehandamulet2 ()

  ObjSet( "spr_bed2_bonehandamulet2", { alp = 1 } );

  cmn.SetEventDone( "get_bonehandamulet2" );
  cmn.CallEventHandler( "get_bonehandamulet2" );
  cmn.GetObjectSfx();
  
  --if cmn.IsEventDone( "get_bread2" ) and 
  --   cmn.IsEventDone( "get_stump2" ) and 
  --   cmn.IsEventDone( "get_duster2" ) then
  --  cmn.CloseSubRoom();
  --end;

end;
-----------------------------------------------------------------------
function private.get_duster2 ()

  cmn.SetEventDone( "get_duster2" );
  cmn.CallEventHandler( "get_duster2" );
  cmn.GetObjectSfx();
  
  --if cmn.IsEventDone( "get_bread2" ) and 
  --   cmn.IsEventDone( "get_stump2" ) and 
  --   cmn.IsEventDone( "get_bonehandamulet2" ) then
  --  cmn.CloseSubRoom();
  --end;

end;
-----------------------------------------------------------------------
function private.get_file2 ()

  cmn.SetEventDone( "get_file2" );
  cmn.CallEventHandler( "get_file2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_shard2" ) and 
     cmn.IsEventDone( "get_staff2" ) and 
     cmn.IsEventDone( "get_wetduster2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_shard2 ()

  ObjSet( "spr_torturechamber2_shard2", { alp = 1 } );

  cmn.SetEventDone( "get_shard2" );
  cmn.CallEventHandler( "get_shard2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_file2" ) and 
     cmn.IsEventDone( "get_staff2" ) and 
     cmn.IsEventDone( "get_wetduster2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_staff2 ()

  cmn.SetEventDone( "get_staff2" );
  cmn.CallEventHandler( "get_staff2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_file2" ) and 
     cmn.IsEventDone( "get_shard2" ) and 
     cmn.IsEventDone( "get_wetduster2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_wetduster2 ()

  cmn.SetEventDone( "get_wetduster2" );
  cmn.CallEventHandler( "get_wetduster2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_file2" ) and 
     cmn.IsEventDone( "get_shard2" ) and 
     cmn.IsEventDone( "get_staff2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_flint2_1 ()

  cmn.SetEventDone( "get_flint2_1" );
  cmn.CallEventHandler( "get_flint2_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_rope2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_rope2 ()

  cmn.SetEventDone( "get_rope2" );
  cmn.CallEventHandler( "get_rope2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_flint2_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_bread2 ()

  local item = "inv_bread2";

  if ( cmn.ApplyObj( item, "gzz_prison2_window2", false ) ) and
     ( not cmn.IsEventDone( "use_bread2" ) ) and 
       cmn.IsEventDone( "use_staff2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window2_use_bread2", true ) ) and
         ( not cmn.IsEventDone( "use_bread2" ) ) and 
           cmn.IsEventDone( "use_staff2" ) then

    cmn.CallEventHandler( "use_bread2_inv" );
    cmn.CallEventHandler( "use_bread2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_bread2" );
      cmn.CallEventHandler( "use_bread2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_window2_gull_static", { alp = 0 } );
    ObjSet( "anm_window2_use_bread", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_gull_bread" );
    AnimPlay( "anm_window2_use_bread", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_staff2 ()

  local item = "inv_staff2";

  if ( cmn.ApplyObj( item, "gzz_prison2_window2", false ) ) and
     ( not cmn.IsEventDone( "use_staff2" ) ) and  
       cmn.IsEventDone( "use_wetduster2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window2_use_staff2", true ) ) and
         ( not cmn.IsEventDone( "use_staff2" ) ) and 
           cmn.IsEventDone( "use_wetduster2" ) then

    cmn.CallEventHandler( "use_staff2_inv" );
    cmn.CallEventHandler( "use_staff2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_staff2" );
      cmn.CallEventHandler( "use_staff2_end" );

    end;

    int.Lock( true );

    ObjSet( "spr_window2_lattice", { alp = 0 } );
    ObjSet( "spr_window2_wetduster_big", { alp = 0 } );
    ObjSet( "anm_window2_use_staff", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_creak_cage" );
    AnimPlay( "anm_window2_use_staff", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_wetduster2 ()

  local item = "inv_wetduster2";

  if ( cmn.ApplyObj( item, "gzz_prison2_window2", false ) ) and
     ( not cmn.IsEventDone( "use_wetduster2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window2_use_wetduster2", true ) ) and
         ( not cmn.IsEventDone( "use_wetduster2" ) ) then

    cmn.CallEventHandler( "use_wetduster2_inv" );
    cmn.CallEventHandler( "use_wetduster2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_wetduster2" );
      cmn.CallEventHandler( "use_wetduster2_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_cloth_round_cage" );
    ObjAnimate( "spr_window2_wetduster_big", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_selfmadecat2 ()

  local item = "inv_selfmadecat2";

  if ( cmn.ApplyObj( item, "gzz_prison2_window2", false ) ) and
     ( not cmn.IsEventDone( "use_selfmadecat2" ) and 
       cmn.IsEventDone( "get_batamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_window2_use_selfmadecat2", true ) ) and
         ( not cmn.IsEventDone( "use_selfmadecat2" ) ) and  
           cmn.IsEventDone( "get_batamulet2" ) then

    cmn.CallEventHandler( "use_selfmadecat2_inv" );
    cmn.CallEventHandler( "use_selfmadecat2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_selfmadecat2" );
      cmn.CallEventHandler( "use_selfmadecat2_end" );
      cmn.CloseSubRoom();
      cmn.GotoRoom( "mg_mgdescent2" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_rope_window" );
    ObjAnimate( "spr_window2_selfmadecat", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_file2_1 ()

  local item = "inv_file2";

  if ( cmn.ApplyObj( item, "gzz_prison2_bed2", false ) ) and
     ( not cmn.IsEventDone( "use_file2_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bed2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bed2_use_file2_1", true ) ) and
         ( not cmn.IsEventDone( "use_file2_1" ) ) then

    cmn.CallEventHandler( "use_file2_1_inv" );
    cmn.CallEventHandler( "use_file2_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_file2_1" );
      cmn.CallEventHandler( "use_file2_1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_bed2_click_bonehandamulet", { alp = 0 } );
    ObjSet( "anm_bed2_use_file", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_free_hand_skeleton" );
    AnimPlay( "anm_bed2_use_file", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_shard2 ()

  local item = "inv_shard2";

  if ( cmn.ApplyObj( item, "gzz_prison2_bed2", false ) ) and
     ( not cmn.IsEventDone( "use_shard2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bed2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_bed2_use_shard2", true ) ) and
         ( not cmn.IsEventDone( "use_shard2" ) ) then

    cmn.CallEventHandler( "use_shard2_inv" );
    cmn.CallEventHandler( "use_shard2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_shard2" );
      cmn.CallEventHandler( "use_shard2_end" );
      if not cmn.IsEventDone( "use_file2_1" ) then
        ObjSet( "anm_bed2_click_bonehandamulet", { alp = 1 } );
      end;
      private.get_duster2();

    end;

    int.Lock( true );

    ObjSet( "anm_bed2_click_pillow", { alp = 0 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_cut_pillow" );

    ObjSet( "anm_bed2_use_shard", { alp = 1 } );
    AnimPlay( "anm_bed2_use_shard", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_bonehandamulet2 ()

  local item = "inv_bonehandamulet2";

  if ( cmn.ApplyObj( item, "gzz_prison2_torturechamber2", false ) ) and
     ( not cmn.IsEventDone( "use_bonehandamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_torturechamber2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_torturechamber2_use_bonehandamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_bonehandamulet2" ) ) then

    cmn.CallEventHandler( "use_bonehandamulet2_inv" );
    cmn.CallEventHandler( "use_bonehandamulet2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_bonehandamulet2" );
        cmn.CallEventHandler( "use_bonehandamulet2_end" );
        
      end;
      
      if cmn.IsEventDone( "use_ravenamulet2" ) then
        private.use_ravenamulet_bonehandamulet_end( func_end1 );
      else
        func_end1();  
      end;
      
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_2_zz_torturechamber2" );
    ObjAnimate( "anm_torturechamber2_slots_bonehandamulet2", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_duster2 ()

  local item = "inv_duster2";

  if ( cmn.ApplyObj( item, "gzz_prison2_torturechamber2", false ) ) and
     ( not cmn.IsEventDone( "use_duster2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_torturechamber2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_torturechamber2_use_duster2", true ) ) and
         ( not cmn.IsEventDone( "use_duster2" ) ) then

    cmn.CallEventHandler( "use_duster2_inv" );
    cmn.CallEventHandler( "use_duster2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_duster2" );
      cmn.CallEventHandler( "use_duster2_end" );
      ObjSet( "anm_torturechamber2_water", { alp = 1 } );
      AnimPlay( "anm_torturechamber2_water", "DoAnim", "" );
      private.get_wetduster2();

    end;

    int.Lock( true );
    
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_down_cloth_water" );
    ObjSet( "anm_torturechamber2_water", { alp = 0 } );
    ObjSet( "anm_torturechamber2_use_duster", { alp = 1 } );
    AnimStop( "anm_torturechamber2_water" ); 
    AnimPlay( "anm_torturechamber2_use_duster", "DoAnim", func_end );
      
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_oil2 ()

  local item = "inv_oil2";

  if ( cmn.ApplyObj( item, "gzz_prison2_torturechamber2", false ) ) and
     ( not cmn.IsEventDone( "use_oil2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_torturechamber2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_torturechamber2_use_oil2", true ) ) and
         ( not cmn.IsEventDone( "use_oil2" ) ) then

    cmn.CallEventHandler( "use_oil2_inv" );
    cmn.CallEventHandler( "use_oil2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_oil2" );
      cmn.CallEventHandler( "use_oil2_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_torturechamber2_rustdoor_clk", { alp = 0 } );
    ObjSet( "anm_torturechamber2_use_oil", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_spill_oil" );
    AnimPlay( "anm_torturechamber2_use_oil", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_ravenamulet2 ()

  local item = "inv_ravenamulet2";

  if ( cmn.ApplyObj( item, "gzz_prison2_torturechamber2", false ) ) and
     ( not cmn.IsEventDone( "use_ravenamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_torturechamber2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_torturechamber2_use_ravenamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_ravenamulet2" ) ) then

    cmn.CallEventHandler( "use_ravenamulet2_inv" );
    cmn.CallEventHandler( "use_ravenamulet2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_ravenamulet2" );
        cmn.CallEventHandler( "use_ravenamulet2_end" );
        
      end;
      
      if cmn.IsEventDone( "use_bonehandamulet2" ) then
        private.use_ravenamulet_bonehandamulet_end( func_end1 );
      else
        func_end1();  
      end;
      
    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_1_zz_torturechamber2" );
    ObjAnimate( "anm_torturechamber2_slots_ravenamulet2", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.use_ravenamulet_bonehandamulet_end ( func_end )
    
  ObjSet( "anm_torturechamber2_slots_open", { alp = 1 } );
  ObjSet( "obj_torturechamber2_rack_close", { alp = 0 } );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_aud_zz_torturechamber2_opens" );
  AnimPlay( "anm_torturechamber2_slots_open", "DoAnim", func_end );

end;  
--------------------------------------------------------------------------------------------
--function public.use_handkerchief2 ()
--
--  local item = "inv_handkerchief2";
--
--  if ( cmn.ApplyObj( item, "gzz_prison2_torturechamber2", false ) ) and
--     ( not cmn.IsEventDone( "use_handkerchief2" ) ) then
--
--    --interface.ObjDoNotDrop( item );
--    cmn.GotoSubRoom( "zz_torturechamber2", nil, { 512, 384 }, true );
--
--    return true;
--
--  elseif ( cmn.ApplyObj( item, "obj_torturechamber2_use_handkerchief2", true ) ) and
--         ( not cmn.IsEventDone( "use_handkerchief2" ) ) then
--
--    cmn.CallEventHandler( "use_handkerchief2_inv" );
--    cmn.CallEventHandler( "use_handkerchief2_beg" );
--
--    local func_end = function ()
--
--      int.Lock( false );
--      cmn.SetEventDone( "use_handkerchief2" );
--      cmn.CallEventHandler( "use_handkerchief2_end" );
--      private.get_shard2();
--
--    end;
--
--    int.Lock( true );
--    
--    ObjSet( "anm_torturechamber2_lattern", { alp = 0 } );
--    ObjSet( "anm_torturechamber2_use_handkerchief", { alp = 1 } );
--
--    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_glass_cloth_1" );
--    AnimPlay( "anm_torturechamber2_use_handkerchief", "DoAnim", func_end ); 
--
--    return true;
--
--  end;
--
--  return false;
--
--end;
--------------------------------------------------------------------------------------------
function public.use_file2_2 ()

  local item = "inv_file2";

  if ( cmn.ApplyObj( item, "gzz_prison2_stash2", false ) ) and
     ( not cmn.IsEventDone( "use_file2_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stash2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stash2_use_file2", true ) ) and
         ( not cmn.IsEventDone( "use_file2_2" ) ) then

    cmn.CallEventHandler( "use_file2_2_inv" );
    cmn.CallEventHandler( "use_file2_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_file2_2" );
      cmn.CallEventHandler( "use_file2_2_end" );
      private.get_flint2_1();

    end;

    int.Lock( true );
    ObjSet( "anm_stash2_click_flint", { alp = 0 } );
    ObjSet( "anm_stash2_use_file", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_saw_stone" );
    AnimPlay( "anm_stash2_use_file", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_batamulet2 ()

  local item = "inv_batamulet2";

  if ( cmn.ApplyObj( item, "gzz_prison2_stash2", false ) ) and
     ( not cmn.IsEventDone( "use_batamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stash2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stash2_use_batamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_batamulet2" ) ) then

    cmn.CallEventHandler( "use_batamulet2_inv" );
    cmn.CallEventHandler( "use_batamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_batamulet2" );
      cmn.CallEventHandler( "use_batamulet2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_stash2_click_cap", { alp = 0 } );
    ObjSet( "anm_stash2_use_batamulet", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_bat_cell" );
    AnimPlay( "anm_stash2_use_batamulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_lamp2 ()

  local item = "inv_lamp2";

  if ( cmn.ApplyObj( item, "obj_prison2_use_lamp2", true ) ) and
         ( not cmn.IsEventDone( "use_lamp2" ) ) then

    cmn.CallEventHandler( "use_lamp2_inv" );
    cmn.CallEventHandler( "use_lamp2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_lamp2" );
      cmn.CallEventHandler( "use_lamp2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_prison2_candle", { alp = 1 } );
    ObjSet( "anm_prison2_candle_2", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_loc_candle_darkness" );
    AnimPlay( "anm_prison2_candle", "DoAnim", "" );
    AnimPlay( "anm_prison2_candle_2", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
-----------------------------------------------------------------------
function private.clk_torturechamber2_handle ()

  cmn.CallEventHandler( "clk_torturechamber2_handle_inv" );
  cmn.CallEventHandler( "clk_torturechamber2_handle_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_torturechamber2_handle" );
    cmn.CallEventHandler( "clk_torturechamber2_handle_end" );

  end;

  int.Lock( true );
  
  ObjSet( "anm_torturechamber2_open_ironmaiden", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_open_zz_stash2" );
  AnimPlay( "anm_torturechamber2_open_ironmaiden", "DoAnim", func_end );

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
function private.dlg_prison2_richard2_1 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_ravenamulet2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_prison2_richard2_1_richard_static",        { alp = 0 } );
    ObjSet( "anm_prison2_richard2_1_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_prison2_richard2_1_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_prison2_richard2_1_richard_static" );
    AnimStop( "anm_prison2_richard2_1_richard_disappearance" );

    ObjAnimate( "anm_prison2_richard2_1_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_prison2_richard2_1_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_ravenamulet2" );
      cmn.SetEventDone( "dlg_prison2_richard2_1" );
      int.InventoryItemAdd( "inv_richardskull2" );
      cmn.ShowBbt( "bbt_prison2_after_dlg_richard" );

      interface.KeyTaskAdd( "task_2_1", true );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_prison2_richard2_1_richard_appearance" );
    ObjSet( "anm_prison2_richard2_1_richard_appearance", { alp = 0 } );

    ObjSet( "anm_prison2_richard2_1_richard_static", { alp = 1 } );
    AnimPlay( "anm_prison2_richard2_1_richard_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard2_1", "prison2", 3, nil, nil, true, nil, func_before_end );

    common_impl.StopMusEnv( false );
    cmn.PlayAudio( "mus", "audio/aud_first_appear_richard_mus", nil, nil, 48 );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_prison2_richard2_1_beg" );
  ObjAttach( "dlg_prison2_richard2_1", GetCurrentRoom() );  

  ObjSet( "anm_prison2_richard2_1_richard_appearance", { alp = 1 } );
  AnimPlay( "anm_prison2_richard2_1_richard_appearance", "DoAnim", func_anim_end );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_prison2_richard2_1_richard_static", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull2" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard2_1" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_prison2_richard2_1_richard_static" );
        AnimPlay( "anm_prison2_richard2_1_richard_give", "DoAnim", "" );
        AnimPlay( "anm_prison2_richard2_1_object_appearance", "DoAnim", "" );

        ObjAnimate( "spr_prison2_ravenamulet2", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_prison2_richard2_1_richard_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_prison2_richard2_1_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      cmn.PlayAudio( "sfx", "audio/aud_richard_creates_thing" );

    end;

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventDone( "beg_level2" ) ) then

    common_impl.InterfaceSetVisible( false );
    ObjSet( "rm_prison2", { color_r = 0, color_g = 0, color_b = 0 } );    

  end;
  
end;  
--*********************************************************************************************************************
function private.opn_prison2 ()

  if not ( cmn.IsEventDone( "opn_prison2" ) ) then

    cmn.SetEventDone( "opn_prison2" );

  end;
  
  if ( not cmn.IsEventDone( "beg_level2" ) ) then

    private.IntroLvl2Open();

  else

    cmn.StopAllEnv( "audio/level2/env/aud_rm_prison2_env", true );
    cmn.PlayAudio( "env", "audio/level2/env/aud_rm_prison2_env", 1 );

    if ( not cmn.IsEventDone( "dlg_prison2_richard2_1" ) ) then

      private.dlg_prison2_richard2_1();

    end;

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_prison2();

end;
--*********************************************************************************************************************
function private.IntroLvl2Open()

  local func_end = function ( skip )

    cmn.SetEventDone( "beg_level2" );
    cmn.SetEventDone( "get_oil2" );
    cmn.CallEventHandler( "get_oil2" );
    ObjSet( "rm_prison2", { color_r = 1, color_g = 1, color_b = 1 } );

    int.Lock( false );
    
    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      cmn.StopAudio( "voc", "audio/level2/voc/aud_lvl2_intro_voc" );
      cmn.StopAudio( "mus", "audio/level2/mus/aud_vid_intro_2_lvl_mus" );
    end;

    cmn.PlayAudio( "env", "audio/level2/env/aud_rm_prison2_env", 1 );
    --cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );

    private.dlg_prison2_richard2_1();

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_prison2_intro", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_lvl2_intro_voc" );
  cmn.PlayAudio( "mus", "audio/level2/mus/aud_vid_intro_2_lvl_mus", nil, nil, 28 );

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_ravenamulet2",                            { "dlg_prison2_richard2_1" } );
  int.AddedTaskMap( private.room_objname, "get_batamulet2",                              { "use_bread2" } );
  int.AddedTaskMap( private.room_objname, "get_flint2_2" );
  int.AddedTaskMap( private.room_objname, "get_bread2" );
  int.AddedTaskMap( private.room_objname, "get_stump2" );
  int.AddedTaskMap( private.room_objname, "get_bonehandamulet2",                         { "use_file2_1" } );
  int.AddedTaskMap( private.room_objname, "get_duster2",                                 { "use_shard2" } );
  int.AddedTaskMap( private.room_objname, "get_file2",                                   { "clk_torturechamber2_handle" } );
  int.AddedTaskMap( private.room_objname, "get_shard2" );
  int.AddedTaskMap( private.room_objname, "get_staff2",                                  { "use_bonehandamulet2", "use_ravenamulet2" } );
  int.AddedTaskMap( private.room_objname, "get_wetduster2",                              { "use_duster2" } );
  int.AddedTaskMap( private.room_objname, "get_flint2_1",                                { "use_file2_2" } );
  int.AddedTaskMap( private.room_objname, "get_rope2",                                   { "use_batamulet2" } );

  int.AddedTaskMap( private.room_objname, "use_bread2",                                  { "use_staff2", "get_bread2" } );
  int.AddedTaskMap( private.room_objname, "use_staff2",                                  { "get_staff2", "use_wetduster2" } );
  int.AddedTaskMap( private.room_objname, "use_wetduster2",                              { "get_wetduster2" } );
  int.AddedTaskMap( private.room_objname, "use_selfmadecat2",                            { "get_selfmadecat2" } );
  int.AddedTaskMap( private.room_objname, "use_file2_1",                                 { "get_file2" } );
  int.AddedTaskMap( private.room_objname, "use_shard2",                                  { "get_shard2" } );
  int.AddedTaskMap( private.room_objname, "use_bonehandamulet2",                         { "get_bonehandamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_duster2",                                 { "get_duster2" } );
  int.AddedTaskMap( private.room_objname, "use_oil2" );
  int.AddedTaskMap( private.room_objname, "use_ravenamulet2",                            { "get_ravenamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_file2_2",                                 { "get_file2" } );
  int.AddedTaskMap( private.room_objname, "use_batamulet2",                              { "get_batamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_lamp2",                                   { "get_lamp2" } );

  int.AddedTaskMap( private.room_objname, "clk_torturechamber2_handle",                  { "use_oil2" } );

  int.AddedTaskMap( private.room_objname, "win_mgdescent2",                              { "use_selfmadecat2" } );
  int.AddedTaskMap( private.room_objname, "win_hoskeleton2",                             { "use_lamp2" } );

  int.AddedTaskMap( private.room_objname, "dlg_prison2_richard2_1" );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_bed2" );  
  -----------------------------------------------
  function zz_bed2.Close()

      cmn.NoteScaleEnd( { "spr_bed2_note" }, true );

  end;
  -----------------------------------------------
  subroom.Define( "zz_window2" );  
  -----------------------------------------------
  function zz_window2.Close()

      cmn.NoteScaleEnd( { "spr_window2_note" }, true );

  end;
  -----------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_stash2_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  ObjAnimate( "spr_torturechamber2_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  ObjAnimate( "spr_prison2_fire_ho", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

  ObjAnimate( "obj_stash2_flint2_1_hotspot", "alp", 1, 0, "", 
  { 
    0.0, 3, 0.3,
    2.0, 3, 1.0,
    4.0, 3, 0.3,
  } );
  ObjAnimate( "spr_window2_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

end;
--*********************************************************************************************************************
function private.TorturechamberRackDoorClk ( item )
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_torturechamber2_use_"..item );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_sloder_cell_zz_torturechamber2" );

  if cmn.IsEventDone( "use_bonehandamulet2" ) then
    AnimPlay( "anm_torturechamber2_slots_bonehandamulet2", "DoAnim", "" ); 
  else 
    AnimPlay( "anm_torturechamber2_slots_bonehandamulet1", "DoAnim", "" );  
  end;
  
  if cmn.IsEventDone( "use_ravenamulet2" ) then
    AnimPlay( "anm_torturechamber2_slots_ravenamulet2", "DoAnim", func_end ); 
  else
    AnimPlay( "anm_torturechamber2_slots_ravenamulet1", "DoAnim", func_end );  
  end;
    
end;
--*********************************************************************************************************************
function private.TorturechamberRustdoorClk ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_torturechamber2_use_oil2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_metal_zz_torturechamber2" );
  AnimPlay( "anm_torturechamber2_rustdoor_clk", "DoAnim", func_end ); 
    
end;
--*********************************************************************************************************************
function private.StashFlintClk ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_stash2_use_file2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_left_for_saw" );
  AnimPlay( "anm_stash2_click_flint", "DoAnim", func_end ); 
    
end;
--*********************************************************************************************************************
function private.StashCapClk ()
  
  local func_end = function ()
    
    cmn.ShowBbt( "bbt_stash2_use_batamulet2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_stone_bat" );
  AnimPlay( "anm_stash2_click_cap", "DoAnim", func_end ); 
    
end;
--*********************************************************************************************************************
function private.Window2GullClk ()

  local func_end = function ()

    AnimPlay( "anm_window2_gull_static", "DoAnim", "" );
    ObjSet( "anm_window2_gull_static", { alp = 1 } );
    ObjSet( "anm_window2_gull_click", { alp = 0 } );

    if cmn.IsEventDone( "use_wetduster2" ) and 
       cmn.IsEventDone( "use_staff2" ) then

      cmn.ShowBbt( "bbt_window2_use_bread2" );

    elseif cmn.IsEventDone( "use_wetduster2" ) then

      cmn.ShowBbt( "bbt_window2_use_staff2" );

    else

      cmn.ShowBbt( "bbt_window2_use_wetduster2" );

    end;

    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_gull" );
  ObjSet( "anm_window2_gull_static", { alp = 0 } );
  AnimStop( "anm_window2_gull_static" ); 
  ObjSet( "anm_window2_gull_click", { alp = 1 } );
  AnimPlay( "anm_window2_gull_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.Bed2PillowClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_bed2_use_shard2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_pillow" );
  AnimPlay( "anm_bed2_click_pillow", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.Bed2BonehandamuletClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_bed2_use_file2_1" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_hand_skeleton" );
  AnimPlay( "anm_bed2_click_bonehandamulet", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************