-- name=rm_shore2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_shore2";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_altar2",    "room_hub" );
  ObjAttach( "zz_memorial2", "room_hub" );
  ObjAttach( "zz_willow2",   "room_hub" );

  ObjMultiSet(
  {
    { "spr_altar2_snakesamulet2_1",     { event_mdown = private.get_snakesamulet2_1 } },
    { "spr_memorial2_planetamulet2",    { event_mdown = private.get_planetamulet2 } },
    { "spr_memorial2_lock2",            { event_mdown = private.get_lock2 } },
    { "spr_memorial2_temporaryecho2_4", { event_mdown = private.get_temporaryecho2_4 } },
    { "obj_willow2_pigeonamulet2",      { event_mdown = private.get_pigeonamulet2 } },
    { "spr_willow2_dipnet2",            { event_mdown = private.get_dipnet2 } },
    { "spr_willow2_brokenlamp2",        { event_mdown = private.get_brokenlamp2 } },
    { "obj_willow2_temporaryecho2_2",   { event_mdown = private.get_temporaryecho2_2 } },
    { "obj_memorial2_use_medallion2",   { event_mdown = function() private.MemorialCapClk ( "medallion" ) end } },
    { "obj_memorial2_use_ring2",        { event_mdown = function() private.MemorialCapClk ( "ring" ) end } },
    { "obj_memorial2_clk_cap",          { event_mdown = function() private.MemorialCapClk ( "cap" ) end } },
    { "obj_willow2_use_tongs2",         { event_mdown = function() private.WillowPigeonamuletClk () end } },
    { "spr_altar2_medallion2",          { event_mdown = private.get_medallion2 } },
    { "spr_memorial2_screensaver_2_11", { event_mdown = private.get_screensaver_2_11 } },      
    { "spr_willow2_screensaver_2_12",   { event_mdown = private.get_screensaver_2_12 } },       
    --
    --
  } );
  
  local get_screensaver_2_11 = function ()

    ObjDelete( "spr_memorial2_screensaver_2_11" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_11", get_screensaver_2_11, private.room_objname );  
  local get_screensaver_2_12 = function ()

    ObjDelete( "spr_willow2_screensaver_2_12" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_12", get_screensaver_2_12, private.room_objname );  
  
  private.Altar2Init();
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_shore2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_shore2", update_game_mode_shore2, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_5 = function ()

    ObjDelete( "obj_shore2_morphobject" );

  end;
  cmn.AddSubscriber( "get_morphobject_2_5", get_morphobject_2_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_halfmoonamulet2 () end;
  --------------------------------------------------------------------------------------------
  local get_halfmoonamulet2_inv = function ()

    int.InventoryItemAdd( "inv_halfmoonamulet2", "spr_shore2_halfmoonamulet2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_halfmoonamulet2", get_halfmoonamulet2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_snakesamulet2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_snakesamulet2_1" ] =
  {
    type = "get",
    get_obj = "spr_altar2_snakesamulet2_1",
    room = private.room_objname,
    zz = "zz_altar2",
    zz_gate = "gzz_shore2_altar2"
  };
  --------------------------------------------------------------------------------------------
  local get_snakesamulet2_1_inv = function ()

    int.InventoryItemAdd( "inv_snakesamulet2", "spr_altar2_snakesamulet2_1", "assets/levels/level2/rm_shore2/zz_altar2/inv/inv_amuletsnake2_1" );
    level2_inv.CheckSnakesamulet2();

  end;
  local get_snakesamulet2_1_closezz = function ()

    ObjDelete( "gfx_altar2_snakesamulet2_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_snakesamulet2_1", get_snakesamulet2_1_inv );
  cmn.AddSubscriber( "get_snakesamulet2_1", get_snakesamulet2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_planetamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_planetamulet2" ] =
  {
    type = "get",
    get_obj = "spr_memorial2_planetamulet2",
    room = private.room_objname,
    zz = "zz_memorial2",
    zz_gate = "gzz_shore2_memorial2"
  };
  --------------------------------------------------------------------------------------------
  local get_planetamulet2_inv = function ()

    int.InventoryItemAdd( "inv_planetamulet2", "spr_memorial2_planetamulet2" );

  end;
  local get_planetamulet2_closezz = function ()

    ObjDelete( "gfx_memorial2_planetamulet2" );
    
    if cmn.IsEventDone( "get_lock2" ) and 
       cmn.IsEventDone( "get_temporaryecho2_4" ) then

       ObjDelete( "gzz_shore2_memorial2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_planetamulet2", get_planetamulet2_inv );
  cmn.AddSubscriber( "get_planetamulet2", get_planetamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lock2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lock2" ] =
  {
    type = "get",
    get_obj = "spr_memorial2_lock2",
    room = private.room_objname,
    zz = "zz_memorial2",
    zz_gate = "gzz_shore2_memorial2"
  };
  --------------------------------------------------------------------------------------------
  local get_lock2_inv = function ()

    int.InventoryItemAdd( "inv_lock2", "spr_memorial2_lock2" );

  end;
  local get_lock2_closezz = function ()

    ObjDelete( "gfx_memorial2_lock2" );
    
    ObjDelete( "spr_shore2_memorial_lock" );
    
    if cmn.IsEventDone( "get_planetamulet2" ) and 
       cmn.IsEventDone( "get_temporaryecho2_4" ) then

       ObjDelete( "gzz_shore2_memorial2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lock2", get_lock2_inv );
  cmn.AddSubscriber( "get_lock2", get_lock2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_temporaryecho2_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_temporaryecho2_4" ] =
  {
    type = "get",
    get_obj = "spr_memorial2_temporaryecho2_4",
    room = private.room_objname,
    zz = "zz_memorial2",
    zz_gate = "gzz_shore2_memorial2"
  };
  --------------------------------------------------------------------------------------------
  local get_temporaryecho2_4_inv = function ()

    int.InventoryItemAdd( "inv_spiralamulet2", "spr_memorial2_temporaryecho2_4" );
    level2_inv.CheckSpiralamulet2();

  end;
  local get_temporaryecho2_4_closezz = function ()

    ObjDelete( "gfx_memorial2_temporaryecho2_4" );
    
    if cmn.IsEventDone( "get_planetamulet2" ) and 
       cmn.IsEventDone( "get_lock2" ) then

       ObjDelete( "gzz_shore2_memorial2" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_temporaryecho2_4", get_temporaryecho2_4_inv );
  cmn.AddSubscriber( "get_temporaryecho2_4", get_temporaryecho2_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pigeonamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pigeonamulet2" ] =
  {
    type = "get",
    get_obj = "obj_willow2_pigeonamulet2",
    room = private.room_objname,
    zz = "zz_willow2",
    zz_gate = "gzz_shore2_willow2"
  };
  --------------------------------------------------------------------------------------------
  local get_pigeonamulet2_inv = function ()

    int.InventoryItemAdd( "inv_pigeonamulet2", "obj_willow2_pigeonamulet2" );

  end;
  local get_pigeonamulet2_closezz = function ()

    ObjDelete( "gfx_willow2_pigeonamulet2" );
    ObjDelete( "spr_willow2_pigeonamulet_shadow" );
    ObjDelete( "spr_willow2_pigeonamulet_over" );
    
    if cmn.IsEventDone( "get_brokenlamp2" ) and 
       cmn.IsEventDone( "get_temporaryecho2_2" ) and 
       cmn.IsEventDone( "get_dipnet2" ) then
       
      ObjDelete( "gzz_shore2_willow2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pigeonamulet2", get_pigeonamulet2_inv );
  cmn.AddSubscriber( "get_pigeonamulet2", get_pigeonamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dipnet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dipnet2" ] =
  {
    type = "get",
    get_obj = "spr_willow2_dipnet2",
    room = private.room_objname,
    zz = "zz_willow2",
    zz_gate = "gzz_shore2_willow2"
  };
  --------------------------------------------------------------------------------------------
  local get_dipnet2_inv = function ()

    int.InventoryItemAdd( "inv_dipnet2", "spr_willow2_dipnet2" );

  end;
  local get_dipnet2_closezz = function ()

    ObjDelete( "gfx_willow2_dipnet2" );
    ObjDelete( "spr_willow2_dipnet_shadow" );
    ObjDelete( "spr_willow2_dipnet_over" );
    
    ObjDelete( "spr_shore2_willow_dipnet" );
   
    if cmn.IsEventDone( "get_brokenlamp2" ) and 
       cmn.IsEventDone( "get_temporaryecho2_2" ) and 
       cmn.IsEventDone( "get_pigeonamulet2" ) then
       
      ObjDelete( "gzz_shore2_willow2" );
      
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_dipnet2", get_dipnet2_inv );
  cmn.AddSubscriber( "get_dipnet2", get_dipnet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenlamp2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenlamp2" ] =
  {
    type = "get",
    get_obj = "spr_willow2_brokenlamp2",
    room = private.room_objname,
    zz = "zz_willow2",
    zz_gate = "gzz_shore2_willow2"
  };
  --------------------------------------------------------------------------------------------
  local get_brokenlamp2_inv = function ()

    int.InventoryItemAdd( "inv_brokenlamp2", "spr_willow2_brokenlamp2" );
    ObjSet( "inv_brokenlamp2", { drag = false } );

  end;
  local get_brokenlamp2_closezz = function ()

    ObjDelete( "gfx_willow2_brokenlamp2" );
    ObjDelete( "spr_shore2_willow_brokenlamp" );
    ObjDelete( "spr_willow2_brokenlamp_shadow" );
    ObjDelete( "spr_willow2_brokenlamp_over" );

    if cmn.IsEventDone( "get_dipnet2" ) and 
       cmn.IsEventDone( "get_temporaryecho2_2" ) and 
       cmn.IsEventDone( "get_pigeonamulet2" ) then
       
      ObjDelete( "gzz_shore2_willow2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_brokenlamp2", get_brokenlamp2_inv );
  cmn.AddSubscriber( "get_brokenlamp2", get_brokenlamp2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_temporaryecho2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_temporaryecho2_2" ] =
  {
    type = "get",
    get_obj = "obj_willow2_temporaryecho2_2",
    room = private.room_objname,
    zz = "zz_willow2",
    zz_gate = "gzz_shore2_willow2"
  };
  --------------------------------------------------------------------------------------------
  local get_temporaryecho2_2_inv = function ()

    int.InventoryItemAdd( "inv_spiralamulet2", "obj_willow2_temporaryecho2_2" );
    level2_inv.CheckSpiralamulet2();
    
    ObjSet( "anm_precipice2_use_spiral", { alp = 1 } );
    ObjSet( "obj_precipice2_use_spiralamulet2_3", { input = true } );

  end;
  local get_temporaryecho2_2_closezz = function ()

    ObjDelete( "gfx_willow2_temporaryecho2_2" );
    
    if cmn.IsEventDone( "get_dipnet2" ) and 
       cmn.IsEventDone( "get_brokenlamp2" ) and 
       cmn.IsEventDone( "get_pigeonamulet2" ) then
       
      ObjDelete( "gzz_shore2_willow2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_temporaryecho2_2", get_temporaryecho2_2_inv );
  cmn.AddSubscriber( "get_temporaryecho2_2", get_temporaryecho2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_medallion2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_medallion2" ] =
  {
    type = "get",
    get_obj = "spr_altar2_medallion2",
    room = private.room_objname,
    zz = "zz_altar2",
    zz_gate = "gzz_shore2_altar2"
  };
  --------------------------------------------------------------------------------------------
  local get_medallion2_inv = function ()

    int.InventoryItemAdd( "inv_medallion2", "spr_altar2_medallion2" );

  end;
  local get_medallion2_closezz = function ()

    ObjDelete( "anm_altar2_use_magiclamp" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_medallion2", get_medallion2_inv );
  cmn.AddSubscriber( "get_medallion2", get_medallion2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_talisman2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_talisman2" ] =
  {
    type = "use",
    use_obj = "inv_talisman2",
    use_place = "obj_altar2_use_talisman2",
    room = private.room_objname,
    zz = "zz_altar2",
    zz_gate = "gzz_shore2_altar2"
  };
  --------------------------------------------------------------------------------------------
  local use_talisman2_inv = function ()

    int.InventoryItemRemove( "inv_talisman2" );

  end;
  local use_talisman2_beg = function ()

    ObjDelete( "obj_altar2_use_talisman2" );

  end;
  local use_talisman2_end = function ()

    ObjSet( "anm_altar2_use_talisman", { frame = 500 } );
    
    if cmn.IsEventDone( "use_temporaryecho2" ) and 
       cmn.IsEventDone( "use_lock2" ) then
       
       ObjSet( "obj_altar2_mmg", { input = true } );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_talisman2",     use_talisman2_inv );
  cmn.AddSubscriber( "use_talisman2",     use_talisman2_beg, private.room_objname );
  cmn.AddSubscriber( "use_talisman2",     use_talisman2_end, private.room_objname );
  cmn.AddSubscriber( "use_talisman2_inv", use_talisman2_inv, private.room_objname );
  cmn.AddSubscriber( "use_talisman2_beg", use_talisman2_beg, private.room_objname );
  cmn.AddSubscriber( "use_talisman2_end", use_talisman2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_temporaryecho2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_temporaryecho2" ] =
  {
    type = "use",
    use_obj = "inv_spiralamulet2",
    use_place = "obj_altar2_use_temporaryecho2",
    room = private.room_objname,
    zz = "zz_altar2",
    zz_gate = "gzz_shore2_altar2"
  };
  --------------------------------------------------------------------------------------------
  local use_temporaryecho2_inv = function ()

    int.InventoryItemRemove( "inv_spiralamulet2" );

  end;
  local use_temporaryecho2_beg = function ()

    ObjDelete( "obj_altar2_use_temporaryecho2" );

  end;
  local use_temporaryecho2_end = function ()
    
    ObjSet( "anm_altar2_use_temporaryecho", { frame = 500 } );
    
    for i = 1, 4 do
      ObjSet( "spr_altar2_light_"..i, { alp = 1, active = true } );
    end;
    
    if cmn.IsEventDone( "use_talisman2" ) and 
       cmn.IsEventDone( "use_lock2" ) then
       
       ObjSet( "obj_altar2_mmg", { input = true } );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_temporaryecho2",     use_temporaryecho2_inv );
  cmn.AddSubscriber( "use_temporaryecho2",     use_temporaryecho2_beg, private.room_objname );
  cmn.AddSubscriber( "use_temporaryecho2",     use_temporaryecho2_end, private.room_objname );
  cmn.AddSubscriber( "use_temporaryecho2_inv", use_temporaryecho2_inv, private.room_objname );
  cmn.AddSubscriber( "use_temporaryecho2_beg", use_temporaryecho2_beg, private.room_objname );
  cmn.AddSubscriber( "use_temporaryecho2_end", use_temporaryecho2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magiclamp2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magiclamp2" ] =
  {
    type = "use",
    use_obj = "inv_magiclamp2",
    use_place = "obj_altar2_use_magiclamp2",
    room = private.room_objname,
    zz = "zz_altar2",
    zz_gate = "gzz_shore2_altar2"
  };
  --------------------------------------------------------------------------------------------
  local use_magiclamp2_inv = function ()

    int.InventoryItemRemove( "inv_magiclamp2" );

  end;
  local use_magiclamp2_beg = function ()

    ObjDelete( "obj_altar2_use_magiclamp2" );
    ObjDelete( "anm_altar2_medallion" );

  end;
  local use_magiclamp2_end = function ()

    ObjSet( "spr_altar2_medallion2", { input = true } );
    ObjSet( "gfx_altar2_medallion2", { active = true } );
    ObjSet( "anm_altar2_use_magiclamp", { alp = 1, frame = 329, animfunc = "DoAnim" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magiclamp2",     use_magiclamp2_inv );
  cmn.AddSubscriber( "use_magiclamp2",     use_magiclamp2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magiclamp2",     use_magiclamp2_end, private.room_objname );
  cmn.AddSubscriber( "use_magiclamp2_inv", use_magiclamp2_inv, private.room_objname );
  cmn.AddSubscriber( "use_magiclamp2_beg", use_magiclamp2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magiclamp2_end", use_magiclamp2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lock2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lock2" ] =
  {
    type = "use",
    use_obj = "inv_lock2",
    use_place = "obj_altar2_use_lock2",
    room = private.room_objname,
    zz = "zz_altar2",
    zz_gate = "gzz_shore2_altar2"
  };
  --------------------------------------------------------------------------------------------
  local use_lock2_inv = function ()

    int.InventoryItemRemove( "inv_lock2" );

  end;
  local use_lock2_beg = function ()

    ObjDelete( "obj_altar2_use_lock2" );

  end;
  local use_lock2_end = function ()
    
    ObjSet( "anm_altar2_use_lock", { frame = 500 } );
    
    if cmn.IsEventDone( "use_talisman2" ) and 
       cmn.IsEventDone( "use_temporaryecho2" ) then
       
       ObjSet( "obj_altar2_mmg", { input = true } );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lock2",     use_lock2_inv );
  cmn.AddSubscriber( "use_lock2",     use_lock2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lock2",     use_lock2_end, private.room_objname );
  cmn.AddSubscriber( "use_lock2_inv", use_lock2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lock2_beg", use_lock2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lock2_end", use_lock2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_medallion2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_medallion2" ] =
  {
    type = "use",
    use_obj = "inv_medallion2",
    use_place = "obj_memorial2_use_medallion2",
    room = private.room_objname,
    zz = "zz_memorial2",
    zz_gate = "gzz_shore2_memorial2"
  };
  --------------------------------------------------------------------------------------------
  local use_medallion2_inv = function ()

    int.InventoryItemRemove( "inv_medallion2" );

  end;
  local use_medallion2_beg = function ()

    ObjDelete( "obj_memorial2_use_medallion2" );

  end;
  local use_medallion2_end = function ()

    ObjSet( "spr_memorial2_medallion_shadow", { alp = 1 } );
    ObjSet( "spr_memorial2_medallion", { alp = 1 } );
    ObjSet( "spr_memorial2_medallion_light", { active = true } );
    
    ObjSet( "spr_shore2_memorial_medallion", { alp = 1 } );
    
    ObjDelete( "anm_memorial2_use_medallion" );
    
    if cmn.IsEventDone( "use_ring2" ) then

      ObjDelete( "spr_memorial2_cap" );
      ObjSet( "obj_memorial2_open", { alp = 1, input = true } );
      ObjSet( "gfx_memorial2_lock2", { active = true } );
      
      ObjSet( "spr_shore2_memorial_cap_open", { alp = 1 } );
      ObjSet( "spr_shore2_memorial_lock", { alp = 1 } );
      
      ObjDelete( "anm_memorial2_cap_click" );
      ObjSet( "anm_memorial2_open_cap", { alp = 1, frame = 500 } );
      
      ObjDelete( "obj_memorial2_clk_cap" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_medallion2",     use_medallion2_inv );
  cmn.AddSubscriber( "use_medallion2",     use_medallion2_beg, private.room_objname );
  cmn.AddSubscriber( "use_medallion2",     use_medallion2_end, private.room_objname );
  cmn.AddSubscriber( "use_medallion2_inv", use_medallion2_inv, private.room_objname );
  cmn.AddSubscriber( "use_medallion2_beg", use_medallion2_beg, private.room_objname );
  cmn.AddSubscriber( "use_medallion2_end", use_medallion2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ring2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ring2" ] =
  {
    type = "use",
    use_obj = "inv_ring2",
    use_place = "obj_memorial2_use_ring2",
    room = private.room_objname,
    zz = "zz_memorial2",
    zz_gate = "gzz_shore2_memorial2"
  };
  --------------------------------------------------------------------------------------------
  local use_ring2_inv = function ()

    int.InventoryItemRemove( "inv_ring2" );

  end;
  local use_ring2_beg = function ()

    ObjDelete( "obj_memorial2_use_ring2" );

  end;
  local use_ring2_end = function ()

    ObjSet( "obj_memorial2_rings", { alp = 1 } );
    ObjSet( "spr_memorial2_ring_1_light", { active = true } );
    ObjSet( "spr_memorial2_ring_2_light", { active = true } );
    ObjDelete( "anm_memorial2_use_ring" );
    
    if cmn.IsEventDone( "use_medallion2" ) then
      
      ObjDelete( "spr_memorial2_cap" );
      ObjSet( "obj_memorial2_open", { alp = 1, input = true } );
      ObjSet( "gfx_memorial2_lock2", { active = true } );
      
      ObjSet( "spr_shore2_memorial_cap_open", { alp = 1 } );
      ObjSet( "spr_shore2_memorial_lock", { alp = 1 } );
      
      ObjDelete( "anm_memorial2_cap_click" );
      ObjSet( "anm_memorial2_open_cap", { alp = 1, frame = 500 } );
      
      ObjDelete( "obj_memorial2_clk_cap" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ring2",     use_ring2_inv );
  cmn.AddSubscriber( "use_ring2",     use_ring2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring2",     use_ring2_end, private.room_objname );
  cmn.AddSubscriber( "use_ring2_inv", use_ring2_inv, private.room_objname );
  cmn.AddSubscriber( "use_ring2_beg", use_ring2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring2_end", use_ring2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spiralamulet2_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spiralamulet2_4" ] =
  {
    type = "use",
    use_obj = "inv_spiralamulet2",
    use_place = "obj_memorial2_use_spiralamulet2_4",
    room = private.room_objname,
    zz = "zz_memorial2",
    zz_gate = "gzz_shore2_memorial2"
  };
  --------------------------------------------------------------------------------------------
  local use_spiralamulet2_4_inv = function ()
    
  end;
  local use_spiralamulet2_4_beg = function ()

    ObjDelete( "obj_memorial2_use_spiralamulet2_4" );

  end;
  local use_spiralamulet2_4_end = function ()

    ObjDelete( "anm_memorial2_hand" );
    ObjSet( "spr_memorial2_temporaryecho2_4", { alp = 1, input = true } );
    ObjSet( "gfx_memorial2_temporaryecho2_4", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spiralamulet2_4",     use_spiralamulet2_4_inv );
  cmn.AddSubscriber( "use_spiralamulet2_4",     use_spiralamulet2_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_4",     use_spiralamulet2_4_end, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_4_inv", use_spiralamulet2_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_4_beg", use_spiralamulet2_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_4_end", use_spiralamulet2_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_brokenamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_brokenamulet2" ] =
  {
    type = "use",
    use_obj = "inv_brokenamulet2",
    use_place = "obj_memorial2_use_brokenamulet2",
    room = private.room_objname,
    zz = "zz_memorial2",
    zz_gate = "gzz_shore2_memorial2"
  };
  --------------------------------------------------------------------------------------------
  local use_brokenamulet2_inv = function ()

    int.InventoryItemRemove( "inv_brokenamulet2" );

  end;
  local use_brokenamulet2_beg = function ()

    ObjDelete( "obj_memorial2_use_brokenamulet2" );

  end;
  local use_brokenamulet2_end = function ()
    
    ObjDelete( "anm_memorial2_use_brokenamulet" );
    ObjSet( "anm_memorial2_use_meltedtin", { alp = 1 } );
    ObjSet( "obj_memorial2_use_meltedtin2", { input = true } );
    
    ObjDelete( "spr_memorial2_brokenamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_brokenamulet2",     use_brokenamulet2_inv );
  cmn.AddSubscriber( "use_brokenamulet2",     use_brokenamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_brokenamulet2",     use_brokenamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_brokenamulet2_inv", use_brokenamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_brokenamulet2_beg", use_brokenamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_brokenamulet2_end", use_brokenamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_meltedtin2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_meltedtin2" ] =
  {
    type = "use",
    use_obj = "inv_meltedtin2",
    use_place = "obj_memorial2_use_meltedtin2",
    room = private.room_objname,
    zz = "zz_memorial2",
    zz_gate = "gzz_shore2_memorial2"
  };
  --------------------------------------------------------------------------------------------
  local use_meltedtin2_inv = function ()

    int.InventoryItemRemove( "inv_meltedtin2" );

  end;
  local use_meltedtin2_beg = function ()

    ObjDelete( "obj_memorial2_use_meltedtin2" );

  end;
  local use_meltedtin2_end = function ()

    ObjSet( "spr_memorial2_planetamulet2", { alp = 1, input = true } );
    ObjSet( "gfx_memorial2_planetamulet2", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_meltedtin2",     use_meltedtin2_inv );
  cmn.AddSubscriber( "use_meltedtin2",     use_meltedtin2_beg, private.room_objname );
  cmn.AddSubscriber( "use_meltedtin2",     use_meltedtin2_end, private.room_objname );
  cmn.AddSubscriber( "use_meltedtin2_inv", use_meltedtin2_inv, private.room_objname );
  cmn.AddSubscriber( "use_meltedtin2_beg", use_meltedtin2_beg, private.room_objname );
  cmn.AddSubscriber( "use_meltedtin2_end", use_meltedtin2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spiralamulet2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spiralamulet2_2" ] =
  {
    type = "use",
    use_obj = "inv_spiralamulet2",
    use_place = "obj_willow2_use_spiralamulet2_2",
    room = private.room_objname,
    zz = "zz_willow2",
    zz_gate = "gzz_shore2_willow2"
  };
  --------------------------------------------------------------------------------------------
  local use_spiralamulet2_2_inv = function ()

  end;
  local use_spiralamulet2_2_beg = function ()

    ObjDelete( "obj_willow2_use_spiralamulet2_2" );

  end;
  local use_spiralamulet2_2_end = function ()

    ObjDelete( "anm_willow2_use_spiralamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spiralamulet2_2",     use_spiralamulet2_2_inv );
  cmn.AddSubscriber( "use_spiralamulet2_2",     use_spiralamulet2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_2",     use_spiralamulet2_2_end, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_2_inv", use_spiralamulet2_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_2_beg", use_spiralamulet2_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_spiralamulet2_2_end", use_spiralamulet2_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tongs2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tongs2" ] =
  {
    type = "use",
    use_obj = "inv_tongs2",
    use_place = "obj_willow2_use_tongs2",
    room = private.room_objname,
    zz = "zz_willow2",
    zz_gate = "gzz_shore2_willow2"
  };
  --------------------------------------------------------------------------------------------
  local use_tongs2_inv = function ()

    int.InventoryItemRemove( "inv_tongs2" );

  end;
  local use_tongs2_beg = function ()

    ObjDelete( "obj_willow2_use_tongs2" );

  end;
  local use_tongs2_end = function ()

    ObjDelete( "anm_willow2_pigeonamulet_clk" );
    ObjDelete( "anm_willow2_use_tongs" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tongs2",     use_tongs2_inv );
  cmn.AddSubscriber( "use_tongs2",     use_tongs2_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs2",     use_tongs2_end, private.room_objname );
  cmn.AddSubscriber( "use_tongs2_inv", use_tongs2_inv, private.room_objname );
  cmn.AddSubscriber( "use_tongs2_beg", use_tongs2_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs2_end", use_tongs2_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_altar2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_altar2" ] =
  {
    type = "click",
    clk_obj = "spr_altar2_mmg_1",
    room = private.room_objname,
    zz = "zz_altar2",
    zz_gate = "gzz_shore2_altar2"
  };
  --*********************************************************************************************************************
  local win_altar2_inv = function ()

    if ( cmn.IsEventDone( "win_altar2" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_altar2 = function ()

    if ( cmn.IsEventDone( "win_altar2" ) ) then
            
      ObjDelete( "gzz_shore2_altar2" );

    else 

      private.Altar2Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_altar2", win_altar2_inv );
  cmn.AddSubscriber( "win_altar2", win_altar2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_shore2_richard2_5 () end;
  --------------------------------------------------------------------------------------------
  local dlg_shore2_richard2_5_beg = function ()

  end;
  -----------------------------------------------
  local dlg_shore2_richard2_5_end = function ()

    ObjDelete( "dlg_shore2_richard2_5" );

  end;

  cmn.AddSubscriber( "dlg_shore2_richard2_5",     dlg_shore2_richard2_5_beg );
  cmn.AddSubscriber( "dlg_shore2_richard2_5",     dlg_shore2_richard2_5_end );
  cmn.AddSubscriber( "dlg_shore2_richard2_5_beg", dlg_shore2_richard2_5_beg );
  cmn.AddSubscriber( "dlg_shore2_richard2_5_end", dlg_shore2_richard2_5_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************  
function private.get_screensaver_2_11()

  int.AddScreensaver( "spr_memorial2_screensaver_2_11" );

end;    
function private.get_screensaver_2_12()

  int.AddScreensaver( "spr_willow2_screensaver_2_12" );

end;    
-----------------------------------------------------------------------
function private.get_snakesamulet2_1 ()

  cmn.SetEventDone( "get_snakesamulet2_1" );
  cmn.CallEventHandler( "get_snakesamulet2_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_planetamulet2 ()

  cmn.SetEventDone( "get_planetamulet2" );
  cmn.CallEventHandler( "get_planetamulet2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_lock2" ) and 
     cmn.IsEventDone( "get_temporaryecho2_4" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_lock2 ()

  cmn.SetEventDone( "get_lock2" );
  cmn.CallEventHandler( "get_lock2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_planetamulet2" ) and 
     cmn.IsEventDone( "get_temporaryecho2_4" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_temporaryecho2_4 ()

  cmn.SetEventDone( "get_temporaryecho2_4" );
  cmn.CallEventHandler( "get_temporaryecho2_4" );
  cmn.GetObjectSfx();
  
  if port.isPortable()==1 then
    iOS_RateMe();
  end;

end;
-----------------------------------------------------------------------
function private.get_pigeonamulet2 ()

  cmn.SetEventDone( "get_pigeonamulet2" );
  cmn.CallEventHandler( "get_pigeonamulet2" );
  cmn.GetObjectSfx();
 
  if cmn.IsEventDone( "get_dipnet2" ) and 
     cmn.IsEventDone( "get_brokenlamp2" ) and 
     cmn.IsEventDone( "get_temporaryecho2_2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_dipnet2 ()

  cmn.SetEventDone( "get_dipnet2" );
  cmn.CallEventHandler( "get_dipnet2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_pigeonamulet2" ) and 
     cmn.IsEventDone( "get_brokenlamp2" ) and 
     cmn.IsEventDone( "get_temporaryecho2_2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_brokenlamp2 ()

  cmn.SetEventDone( "get_brokenlamp2" );
  cmn.CallEventHandler( "get_brokenlamp2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_pigeonamulet2" ) and 
     cmn.IsEventDone( "get_dipnet2" ) and 
     cmn.IsEventDone( "get_temporaryecho2_2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_temporaryecho2_2 ()

  cmn.SetEventDone( "get_temporaryecho2_2" );
  cmn.CallEventHandler( "get_temporaryecho2_2" );
  cmn.GetObjectSfx();
  
  --if cmn.IsEventDone( "get_pigeonamulet2" ) and 
  --   cmn.IsEventDone( "get_dipnet2" ) and 
  --   cmn.IsEventDone( "get_brokenlamp2" ) then
  --   
  --  cmn.CloseSubRoom();
  --  
  --end;

end;
-----------------------------------------------------------------------
function private.get_medallion2 ()

  ObjSet( "spr_altar2_medallion2", { alp = 1 } );

  cmn.SetEventDone( "get_medallion2" );
  cmn.CallEventHandler( "get_medallion2" );
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_talisman2 ()

  local item = "inv_talisman2";

  if ( cmn.ApplyObj( item, "gzz_shore2_altar2", false ) ) and
     ( not cmn.IsEventDone( "use_talisman2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar2_use_talisman2", true ) ) and
         ( not cmn.IsEventDone( "use_talisman2" ) ) then

    cmn.CallEventHandler( "use_talisman2_inv" );
    cmn.CallEventHandler( "use_talisman2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_talisman2" );
      cmn.CallEventHandler( "use_talisman2_end" );
      
      if cmn.IsEventDone( "use_temporaryecho2" ) and 
         cmn.IsEventDone( "use_lock2" ) then
         
        private.Altar2StartInit();
        
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_put_amulet" );
    AnimPlay( "anm_altar2_use_talisman", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_temporaryecho2 ()

  local item = "inv_spiralamulet2";

  if ( cmn.ApplyObj( item, "gzz_shore2_altar2", false ) ) and
     ( not cmn.IsEventDone( "use_temporaryecho2" ) ) and 
       cmn.IsEventDone( "get_temporaryecho2_1" ) and 
       cmn.IsEventDone( "get_temporaryecho2_2" ) and 
       cmn.IsEventDone( "get_temporaryecho2_3" ) and 
       cmn.IsEventDone( "get_temporaryecho2_4" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar2_use_temporaryecho2", true ) ) and
         ( not cmn.IsEventDone( "use_temporaryecho2" ) ) and 
           cmn.IsEventDone( "get_temporaryecho2_1" ) and 
           cmn.IsEventDone( "get_temporaryecho2_2" ) and 
           cmn.IsEventDone( "get_temporaryecho2_3" ) and            
           cmn.IsEventDone( "get_temporaryecho2_4" ) then

    cmn.CallEventHandler( "use_temporaryecho2_inv" );
    cmn.CallEventHandler( "use_temporaryecho2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_temporaryecho2" );
      cmn.CallEventHandler( "use_temporaryecho2_end" );
      
      if cmn.IsEventDone( "use_talisman2" ) and 
         cmn.IsEventDone( "use_lock2" ) then
         
        private.Altar2StartInit();
        
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_amulet_left_cup" );
    AnimPlay( "anm_altar2_use_temporaryecho", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_magiclamp2 ()

  local item = "inv_magiclamp2";

  if ( cmn.ApplyObj( item, "gzz_shore2_altar2", false ) ) and
     ( not cmn.IsEventDone( "use_magiclamp2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar2_use_magiclamp2", true ) ) and
         ( not cmn.IsEventDone( "use_magiclamp2" ) ) then

    cmn.CallEventHandler( "use_magiclamp2_inv" );
    cmn.CallEventHandler( "use_magiclamp2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_magiclamp2" );
      cmn.CallEventHandler( "use_magiclamp2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_altar2_use_magiclamp", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_amulet_zz_altar2" );
    AnimPlay( "anm_altar2_use_magiclamp", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_lock2 ()

  local item = "inv_lock2";

  if ( cmn.ApplyObj( item, "gzz_shore2_altar2", false ) ) and
     ( not cmn.IsEventDone( "use_lock2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar2_use_lock2", true ) ) and
         ( not cmn.IsEventDone( "use_lock2" ) ) then

    cmn.CallEventHandler( "use_lock2_inv" );
    cmn.CallEventHandler( "use_lock2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_lock2" );
      cmn.CallEventHandler( "use_lock2_end" );
      
      if cmn.IsEventDone( "use_talisman2" ) and  
         cmn.IsEventDone( "use_temporaryecho2" ) then
         
        private.Altar2StartInit();
        
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_put_bundle" );
    AnimPlay( "anm_altar2_use_lock", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_medallion2 ()

  local item = "inv_medallion2";

  if ( cmn.ApplyObj( item, "gzz_shore2_memorial2", false ) ) and
     ( not cmn.IsEventDone( "use_medallion2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_memorial2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_memorial2_use_medallion2", true ) ) and
         ( not cmn.IsEventDone( "use_medallion2" ) ) then

    cmn.CallEventHandler( "use_medallion2_inv" );
    cmn.CallEventHandler( "use_medallion2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_medallion2" );
        cmn.CallEventHandler( "use_medallion2_end" );
        
      end;
      
      if cmn.IsEventDone( "use_ring2" ) then
        private.use_ring_medallion( func_end1 );
      else
        func_end1();  
      end;

    end;

    int.Lock( true );
    ObjSet( "anm_memorial2_use_medallion", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_neck_statue_stones" );
    AnimPlay( "anm_memorial2_use_medallion", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_ring2 ()

  local item = "inv_ring2";

  if ( cmn.ApplyObj( item, "gzz_shore2_memorial2", false ) ) and
     ( not cmn.IsEventDone( "use_ring2" ) ) and 
       cmn.IsEventDone( "get_ring2_1" ) and 
       cmn.IsEventDone( "get_ring2_2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_memorial2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_memorial2_use_ring2", true ) ) and
         ( not cmn.IsEventDone( "use_ring2" ) ) and 
           cmn.IsEventDone( "get_ring2_1" ) and 
           cmn.IsEventDone( "get_ring2_2" ) then

    cmn.CallEventHandler( "use_ring2_inv" );
    cmn.CallEventHandler( "use_ring2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_ring2" );
        cmn.CallEventHandler( "use_ring2_end" );
        
      end;
      
      if cmn.IsEventDone( "use_medallion2" ) then
        private.use_ring_medallion( func_end1 );
      else
        func_end1();  
      end;

    end;

    int.Lock( true );
    ObjSet( "anm_memorial2_use_ring", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_hands_statue_stones" );
    AnimPlay( "anm_memorial2_use_ring", "DoAnim", func_end );
  
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.use_ring_medallion ( func_end )
  
  ObjSet( "anm_memorial2_cap_click", { alp = 0 } );
  ObjSet( "anm_memorial2_open_cap", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_statue_box_right_opens" );
  AnimPlay( "anm_memorial2_open_cap", "DoAnim", func_end );
  
end;  
--------------------------------------------------------------------------------------------
function public.use_spiralamulet2_4 ()

  local item = "inv_spiralamulet2";

  if ( not cmn.IsEventDone( "use_spiralamulet2_4" )and
    cmn.IsEventDone( "use_spiralamulet2_3" ) ) then

    cmn.CallEventHandler( "use_spiralamulet2_4_inv" );
    cmn.CallEventHandler( "use_spiralamulet2_4_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        cmn.SetEventDone( "use_spiralamulet2_4" );
        cmn.CallEventHandler( "use_spiralamulet2_4_end" );
        private.get_temporaryecho2_4();
        int.Lock( false );
        
      end;
      
      --cmn.CloseSubRoom();
      private.VidEmily4( func_end1 );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_amulet_zz_memorial2" );
    AnimPlay( "anm_memorial2_hand", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_brokenamulet2 ()

  local item = "inv_brokenamulet2";

  if ( cmn.ApplyObj( item, "gzz_shore2_memorial2", false ) ) and
     ( not cmn.IsEventDone( "use_brokenamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_memorial2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_memorial2_use_brokenamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_brokenamulet2" ) ) then

    cmn.CallEventHandler( "use_brokenamulet2_inv" );
    cmn.CallEventHandler( "use_brokenamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_brokenamulet2" );
      cmn.CallEventHandler( "use_brokenamulet2_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_make_convex" );
    AnimPlay( "anm_memorial2_use_brokenamulet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_meltedtin2 ()

  local item = "inv_meltedtin2";

  if ( cmn.ApplyObj( item, "gzz_shore2_memorial2", false ) ) and
     ( not cmn.IsEventDone( "use_meltedtin2" ) ) and 
       cmn.IsEventDone( "use_brokenamulet2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_memorial2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_memorial2_use_meltedtin2", true ) ) and
         ( not cmn.IsEventDone( "use_meltedtin2" ) ) and 
           cmn.IsEventDone( "use_brokenamulet2" ) then

    cmn.CallEventHandler( "use_meltedtin2_inv" );
    cmn.CallEventHandler( "use_meltedtin2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_meltedtin2" );
      cmn.CallEventHandler( "use_meltedtin2_end" );
      ObjSet( "anm_memorial2_use_meltedtin", { frame = 0 } );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_fill_metal_convex" );
    AnimPlay( "anm_memorial2_use_meltedtin", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_spiralamulet2_2 ()

  local item = "inv_spiralamulet2";

  if ( not cmn.IsEventDone( "use_spiralamulet2_2" )and
    cmn.IsEventDone( "use_spiralamulet2_1" ) ) then

    cmn.CallEventHandler( "use_spiralamulet2_2_inv" );
    cmn.CallEventHandler( "use_spiralamulet2_2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_spiralamulet2_2" );
        cmn.CallEventHandler( "use_spiralamulet2_2_end" );
        private.get_temporaryecho2_2();
        
      end;
      
      --cmn.CloseSubRoom();
      private.VidEmily2( func_end1 );

    end;

    int.Lock( true );
    ObjSet( "obj_willow2_spiralamulet", { pos_z = 30 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_use_amulet_zz_willow2" );
    AnimPlay( "anm_willow2_use_spiralamulet", "DoAnim", func_end ); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tongs2 ()

  local item = "inv_tongs2";

  if ( cmn.ApplyObj( item, "gzz_shore2_willow2", false ) ) and
     ( not cmn.IsEventDone( "use_tongs2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_willow2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_willow2_use_tongs2", true ) ) and
         ( not cmn.IsEventDone( "use_tongs2" ) ) then

    cmn.CallEventHandler( "use_tongs2_inv" );
    cmn.CallEventHandler( "use_tongs2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_tongs2" );
      cmn.CallEventHandler( "use_tongs2_end" );
      private.get_pigeonamulet2();

    end;

    int.Lock( true );

    ObjSet( "anm_willow2_pigeonamulet_clk", { alp = 0 } );
    ObjSet( "anm_willow2_use_tongs", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_take_tree_stuff" );
    AnimPlay( "anm_willow2_use_tongs", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.dlg_shore2_richard2_5 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_halfmoonamulet2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_shore2_richard2_5_richard_static",        { alp = 0 } );
    ObjSet( "anm_shore2_richard2_5_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_shore2_richard2_5_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_shore2_richard2_5_richard_static" );
    AnimStop( "anm_shore2_richard2_5_richard_disappearance" );

    ObjAnimate( "anm_shore2_richard2_5_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_shore2_richard2_5_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_halfmoonamulet2" );
      cmn.SetEventDone( "dlg_shore2_richard2_5" );
      int.InventoryItemAdd( "inv_richardskull2" );
      cmn.ShowBbt( "bbt_shore2_after_dlg_richard" );

      interface.KeyTaskDone( true, "task_2_7" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_shore2_richard2_5_richard_appearance" );
    ObjSet( "anm_shore2_richard2_5_richard_appearance", { alp = 0 } );

    ObjSet( "anm_shore2_richard2_5_richard_static", { alp = 1 } );
    AnimPlay( "anm_shore2_richard2_5_richard_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard2_5", "shore2", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_shore2_richard2_5_beg" );
  ObjAttach( "dlg_shore2_richard2_5", GetCurrentRoom() );  

  ObjSet( "anm_shore2_richard2_5_richard_appearance", { alp = 1 } );
  AnimPlay( "anm_shore2_richard2_5_richard_appearance", "DoAnim", func_anim_end );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_shore2_richard2_5_richard_static", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull2" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard2_5" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_shore2_richard2_5_richard_static" );
        AnimPlay( "anm_shore2_richard2_5_richard_give", "DoAnim", "" );
        AnimPlay( "anm_shore2_richard2_5_object_appearance", "DoAnim", "" );

        ObjAnimate( "spr_shore2_halfmoonamulet2", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_shore2_richard2_5_richard_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_shore2_richard2_5_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      cmn.PlayAudio( "sfx", "audio/aud_richard_creates_thing" );

    end;

  end;

end;
--*********************************************************************************************************************
function private.opn_shore2 ()

  if not ( cmn.IsEventDone( "opn_shore2" ) ) then

    cmn.SetEventDone( "opn_shore2" );
    cmn.ShowBbt( "bbt_shore2_first_entrance" );

  end;
  
  if ( cmn.IsEventDone( "win_hopast2" ) ) then

--    if ( not ng_global.progress[ ng_global.currentprogress ][ "opn_shore2" ].see_return ) then
--
--      private.VidShore2Return();
--
--    else
    if ( ( not cmn.IsEventDone( "dlg_shore2_richard2_5" ) ) and ( not private.shore2_return ) ) then

      cmn.StopAllEnv( "audio/level2/env/aud_rm_shore2_env", true );
      cmn.PlayAudio( "env", "audio/level2/env/aud_rm_shore2_env", 1 );
      private.dlg_shore2_richard2_5();

    else

      cmn.StopAllEnv( "audio/level2/env/aud_rm_shore2_env", true );
      cmn.PlayAudio( "env", "audio/level2/env/aud_rm_shore2_env", 1 );

    end;

  else

    cmn.StopAllEnv( "audio/level2/env/aud_rm_shore2_env", true );
    cmn.PlayAudio( "env", "audio/level2/env/aud_rm_shore2_env", 1 );

  end;
  
  private.Shore2CheckToMemorialFX();
  private.Shore2CheckToWillowFX();
  private.Shore2CheckToNeartowerFX();

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_shore2();

end;
--*********************************************************************************************************************
function public.PreClose ()

end;
--*********************************************************************************************************************
function private.VidEmily2 ( func_end1 )

  local func_end = function ( skip )
   
    int.Lock( false );
    
    if ( skip ) then
      
      cmn.StopAudio( "mus", "audio/level2/mus/aud_shore2_emily_2_mus" );
      cmn.StopAudio( "voc", "audio/level2/voc/aud_lvl2_shore2_emily_2_voc" );
      
    end;

    common_impl.InterfaceSetVisible( true );
    func_end1();

   end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_shore2_emily_2", func_end );  

  cmn.PlayAudio( "mus", "audio/level2/mus/aud_shore2_emily_2_mus", nil, nil, 26 );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_lvl2_shore2_emily_2_voc" );

end;
--*********************************************************************************************************************
function private.VidEmily4 ( func_end1 )

  local func_end = function ( skip )
   
    int.Lock( false );
    
    if ( skip ) then
      
      cmn.StopAudio( "mus", "audio/level2/mus/aud_shore2_emily_4_mus" );
      cmn.StopAudio( "voc", "audio/level2/voc/aud_lvl2_shore2_emily_4_voc" );
      
    end;

    common_impl.InterfaceSetVisible( true );
    
    cmn.SetEventDone( "use_spiralamulet2_4" );
    cmn.CallEventHandler( "use_spiralamulet2_4_end" );
    func_end1();
    
   end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_shore2_emily_4", func_end );  

  cmn.PlayAudio( "mus", "audio/level2/mus/aud_shore2_emily_4_mus", nil, nil, 18 );
  cmn.PlayAudio( "voc", "audio/level2/voc/aud_lvl2_shore2_emily_4_voc" );

end;
--*********************************************************************************************************************
function private.VidShore2Transfer ( func_end1 )


  
  local func_end = function ( skip )
   
    int.Lock( false );
    cmn.GotoRoom( "ho_hopast2" ); 
    if ( skip ) then
      
      cmn.StopAudio( "mus", "audio/level2/mus/aud_vid_shore2_transfer_mus" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_square1_outro_voc" );
      
    end;

    common_impl.InterfaceSetVisible( true );
    
    if (  func_end1) then func_end1(); end;    
    
   end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_shore2_transfer", func_end );  

  cmn.PlayAudio( "mus", "audio/level2/mus/aud_vid_shore2_transfer_mus", nil, nil, 5 );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_square1_outro_voc" );

end;
--*********************************************************************************************************************
function public.VidShore2Return ()

  local func_end = function ( skip )
   
    --int.Lock( false );
    
    if ( skip ) then
      
      cmn.StopAudio( "mus", "audio/level2/mus/aud_vid_shore2_transfer_mus" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_square1_outro_voc" );
      
    end;

    cmn.PlayAudio( "env", "audio/level2/env/aud_rm_shore2_env", 1 );
    ng_global.progress[ ng_global.currentprogress ][ "opn_shore2" ].see_return = true;
    common_impl.InterfaceSetVisible( true );   

    private.shore2_return = false;
    private.dlg_shore2_richard2_5();

   end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_shore2_return", func_end );  

  cmn.PlayAudio( "mus", "audio/level2/mus/aud_vid_shore2_transfer_mus", nil, nil, 5 );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_square1_outro_voc" );

  private.shore2_return = true;

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_halfmoonamulet2",                                { "dlg_shore2_richard2_5" } );
  int.AddedTaskMap( private.room_objname, "get_snakesamulet2_1" );
  int.AddedTaskMap( private.room_objname, "get_planetamulet2",                                  { "use_meltedtin2" } );
  int.AddedTaskMap( private.room_objname, "get_lock2",                                          { "use_medallion2", "use_ring2" } );
  int.AddedTaskMap( private.room_objname, "get_temporaryecho2_4",                               { "use_spiralamulet2_4" } );
  int.AddedTaskMap( private.room_objname, "get_pigeonamulet2",                                  { "use_tongs2" } );
  int.AddedTaskMap( private.room_objname, "get_dipnet2" );
  int.AddedTaskMap( private.room_objname, "get_brokenlamp2" );
  int.AddedTaskMap( private.room_objname, "get_temporaryecho2_2",                               { "use_spiralamulet2_2" } );
  int.AddedTaskMap( private.room_objname, "get_medallion2",                                     { "use_magiclamp2" } );

  int.AddedTaskMap( private.room_objname, "use_talisman2",                                      { "get_talisman2" } );
  int.AddedTaskMap( private.room_objname, "use_temporaryecho2",                                 { "get_temporaryecho2_1", "get_temporaryecho2_2", "get_temporaryecho2_3", "get_temporaryecho2_4" } );
  int.AddedTaskMap( private.room_objname, "use_magiclamp2",                                     { "get_magiclamp2" } );
  int.AddedTaskMap( private.room_objname, "use_lock2",                                          { "get_lock2" } );
  int.AddedTaskMap( private.room_objname, "use_medallion2",                                     { "get_medallion2" } );
  int.AddedTaskMap( private.room_objname, "use_ring2",                                          { "get_ring2_1", "get_ring2_2" } );
  int.AddedTaskMap( private.room_objname, "use_spiralamulet2_4",                                { "get_spiralamulet2", "use_spiralamulet2_3" } );
  int.AddedTaskMap( private.room_objname, "use_brokenamulet2",                                  { "get_brokenamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_meltedtin2",                                     { "get_meltedtin2", "use_brokenamulet2" } );
  int.AddedTaskMap( private.room_objname, "use_spiralamulet2_2",                                { "get_spiralamulet2", "use_spiralamulet2_1" } );
  int.AddedTaskMap( private.room_objname, "use_tongs2",                                         { "get_tongs2" } );

  int.AddedTaskMap( private.room_objname, "win_altar2",                                         { "use_temporaryecho2", "use_lock2", "use_talisman2" } );

  int.AddedTaskMap( private.room_objname, "dlg_shore2_richard2_5",                              { "win_hopast2" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_altar2" );
  subroom.Define( "zz_willow2" );  
  subroom.Define( "zz_memorial2" );      
    -------------------------------------------------
  function zz_memorial2.Open()
    
    public.use_spiralamulet2_4();

  end;  
  -------------------------------------------------
  function zz_willow2.Open()
    
    public.use_spiralamulet2_2();

  end;  
  -------------------------------------------------
  function zz_willow2.Close()
    
    private.Shore2CheckToNeartowerFX();

  end;    
  
  -------------------------------------------------
  function zz_altar2.Open()
    
    if ( cmn.IsEventStart( "win_altar2" ) and not cmn.IsEventDone( "win_altar2" ) ) then

      cmn.MiniGameShow( "altar2" );
      common_impl.PassingMgStart( "altar2" );

    end;

  end;
  -------------------------------------------------
  function zz_altar2.Close()
    
    cmn.NoteScaleEnd( { "spr_altar2_note" }, true );
    
  end;  
  -------------------------------------------------
  function zz_altar2.PreClose()
        
    if ( cmn.IsEventStart( "win_altar2" ) and not cmn.IsEventDone( "win_altar2" ) ) then

      cmn.MiniGameHide( "altar2" );
      common_impl.PassingMgStop( "altar2" );

    end;
    
  end;
  -------------------------------------------------
  function zz_altar2.Skip ()

    if ( cmn.IsEventStart( "win_altar2" ) and not cmn.IsEventDone( "win_altar2" ) ) then
      private.Altar2Skip();
    end;

  end;
  -------------------------------------------------
  function zz_altar2.Reset ()

    if ( cmn.IsEventStart( "win_altar2" ) and not cmn.IsEventDone( "win_altar2" ) ) then
      private.Altar2Reset();
    end;

  end;
  -------------------------------------------------
  
end;
--*********************************************************************************************************************
function private.InitAnimations ()
  
  ObjAnimate( "spr_altar2_light", "alp", 1, 0, "",
  {
    0.0, 3, 1,
    3.0, 3, 0.5,
    6.0, 3, 1,
  } );
  
  for i = 1, 4 do
    
     ObjAnimate( "spr_altar2_light_"..i, "alp", 1, 0, "",
    {
      0.0, 3, 1,
      1.5, 3, 0.5,
      3.0, 3, 1,
    } );
    
  end;  
  
  ObjAnimate( "spr_memorial2_ring_1_light", "alp", 1, 0, "",
  {
    0.0, 3, 1,
    1.5, 3, 0,
    3.0, 3, 1,
  } );
  ObjAnimate( "spr_memorial2_ring_2_light", "alp", 1, 0, "",
  {
    0.0, 3, 1,
    1.4, 3, 0,
    2.8, 3, 1,
  } );
  ObjAnimate( "spr_memorial2_medallion_light", "alp", 1, 0, "",
  {
    0.0, 3, 1,
    1.6, 3, 0,
    3.2, 3, 1,
  } );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Altar2 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Altar2StartInit ()

    cmn.MiniGameShow( "altar2" );
    common_impl.PassingMgStart( "altar2" );

    ng_global.progress[ "std" ][ "win_altar2" ].pos = {};
    
    for i = 1, 6 do
      ng_global.progress[ "std" ][ "win_altar2" ].pos[ i ] = private.old_pos[ i ];
    end;
    
  end;
--*********************************************************************************************************************
  function private.Altar2Load ()
    
    for i = 1, 6 do
      
      local pos = ng_global.progress[ "std" ][ "win_altar2" ].pos[ i ];
      local ang = private.ang[ pos ];
      ObjSet( "spr_altar2_mmg_"..i, { ang = ang } );
      
    end;
        
  end;
--*********************************************************************************************************************
  function private.Altar2Skip ()
    
    for i = 1, 6 do
      
      local pos = private.win_pos[ i ];
      local ang = private.ang[ pos ];
      ObjSet( "spr_altar2_mmg_"..i, { ang = ang } );
      
    end;
    
    private.Altar2Win();
    
  end;
--*********************************************************************************************************************
  function private.Altar2Reset ()
    
    for i = 1, 6 do
      
      local pos = private.old_pos[ i ];
      local ang = private.ang[ pos ];
      ObjSet( "spr_altar2_mmg_"..i, { ang = ang } );
      ng_global.progress[ "std" ][ "win_altar2" ].pos[ i ] = private.old_pos[ i ];
      
    end;
    
  end 
--*********************************************************************************************************************
  function private.Altar2Init ()
      
    for i = 1, 6 do
      
      local number = i;
      if i == 1 then
        number = i.."_1"  
      end;  
      ObjSet( "spr_altar2_mmg_"..number,
      {
        event_mdown  = function () private.Altar2Clk( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );
        
    end; 
                                     
    private.ang = { 0, - 1.03, - 2.1, - 3.16, - 4.2, - 5.26, - 6.28 };
    private.win_pos = { 1, 1, 1, 1, 1, 1 };
    private.old_pos = { 1, 1, 1, 1, 1, 1 };
    
    private.Altar2PrimarySet( 1 );
    private.Altar2PrimarySet( 2 );
    private.Altar2PrimarySet( 3 );
    private.Altar2PrimarySet( 4 );
    private.Altar2PrimarySet( 5 );
    private.Altar2PrimarySet( 6 );
    private.Altar2PrimarySet( 3 );
                
  end;
--*********************************************************************************************************************
  function private.Altar2PrimarySet ( id )
    
    local old_pos = private.old_pos[ id ];
    local new_pos = old_pos + 1;
    
    local new_ang = private.ang[ new_pos ];
    
    if new_pos == 7 then
      new_pos = 1;
    end;  
    
    ObjSet( "spr_altar2_mmg_"..id, { ang = new_ang } );
      
    private.old_pos[ id ] = new_pos;
    
  end;  
--*********************************************************************************************************************
  function private.Altar2Clk ( id )
    
    local old_pos = ng_global.progress[ "std" ][ "win_altar2" ].pos[ id ];
    local new_pos = old_pos + 1;
    
    local old_ang = private.ang[ old_pos ];
    local new_ang = private.ang[ new_pos ];
   
    local func_end = function ()

      if new_pos == 7 then
        new_pos = 1;
      end;  
      
      -----------------проверка на выигрыш
      local flag = true;
      local tmp = {};
      
      for i = 1, 6 do
        tmp[ i ] = ng_global.progress[ "std" ][ "win_altar2" ].pos[ i ];
      end;
      tmp[ id ] = new_pos;
      
      for i = 1, 6 do
        if tmp[ i ] ~= 1 then
          flag = false;
          break;
        end;  
      end;
      -----------------
      
      if flag then
        private.Altar2Win();
      else 
       ng_global.progress[ "std" ][ "win_altar2" ].pos[ id ] = new_pos;
       int.Lock( false ); 
      end;  
      
    end;
    
    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mmg_altar2_click" );
    ObjAnimate( "spr_altar2_mmg_"..id, "ang", 0, 0, func_end, 
    { 
      0.0, 0, old_ang,
      0.3, 0, new_ang,
    } );
    
  end;  
--*********************************************************************************************************************
  function private.Altar2Win () 
    
    local func_end = function ()
     
      cmn.SetEventDone( "win_altar2" );
      common_impl.PassingMgWin( "altar2" );
      
    end;
    
    ObjDelete( "gzz_shore2_altar2" );
    cmn.CloseSubRoom();
    cmn.MiniGameHide( "altar2" );
    cmn.CallEventHandler( "win_altar2" );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mmg_altar2_win" );
    private.VidShore2Transfer( func_end );
       
  end;
--*********************************************************************************************************************
function private.MemorialCapClk ( item )
  
  local func_end = function ()
    
    if item == "ring" then
      cmn.ShowBbt( "bbt_memorial2_use_ring2" );
    elseif item == "medallion" then
      cmn.ShowBbt( "bbt_memorial2_use_medallion2" ); 
    else
      cmn.ShowBbt( "bbt_memorial2_clk_stash" ); 
    end;

    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_stone_right_statue" );
  AnimPlay( "anm_memorial2_cap_click", "DoAnim", func_end ); 
  
end;
--*********************************************************************************************************************
function private.WillowPigeonamuletClk ()
  
  local func_end = function ()

    cmn.ShowBbt( "bbt_willow2_use_tongs2" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_stick_stuff_tree" );
  AnimPlay( "anm_willow2_pigeonamulet_clk", "DoAnim", func_end ); 
  
end;
--*********************************************************************************************************************
function private.Shore2CheckToMemorialFX ()
  
  if ( cmn.IsEventDone( "use_spiralamulet2_3" ) and
       not ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_3" ].fx_shore_showed ) then

    int.Lock( true );
       
    local func_end = function ()
      
      int.Lock( false );        
      ObjSet( "anm_shore2_fx_to_memorial", { alp = 0 } );              
      
    end;             
       
    ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_3" ].fx_shore_showed  = true;  
    ObjSet( "anm_shore2_fx_to_memorial", { alp = 1 } );  
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_rm_shore2_magic_follows" );    
    AnimPlay( "anm_shore2_fx_to_memorial", "DoAnim", func_end );

  end;
  
end;
--*********************************************************************************************************************
function private.Shore2CheckToWillowFX ()
  
  if ( cmn.IsEventDone( "use_spiralamulet2_1" ) and
       not ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_1" ].fx_shore_showed ) then

    int.Lock( true );
       
    local func_end = function ()
      
      int.Lock( false );        
      ObjSet( "anm_shore2_fx_to_willow", { alp = 0 } );              
      
    end;             
       
    ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_1" ].fx_shore_showed  = true;    
    ObjSet( "anm_shore2_fx_to_willow", { alp = 1 } ); 
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_rm_shore2_magic_follows" );         
    AnimPlay( "anm_shore2_fx_to_willow", "DoAnim", func_end );
    
  end;

end;
--*********************************************************************************************************************
function private.Shore2CheckToNeartowerFX ()
  
  if ( cmn.IsEventDone( "use_spiralamulet2_2" ) and
       not ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_2" ].fx_showed ) then

    int.Lock( true );
       
    local func_end = function ()
      
      int.Lock( false );        
      ObjSet( "anm_shore2_fx_to_neartower", { alp = 0 } );              
      
    end;             
       
    ng_global.progress[ ng_global.currentprogress ][ "use_spiralamulet2_2" ].fx_showed  = true;    
    ObjSet( "anm_shore2_fx_to_neartower", { alp = 1 } );  
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_rm_shore2_magic_follows_back" );        
    AnimPlay( "anm_shore2_fx_to_neartower", "DoAnim", func_end );
    
  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************