-- name=rm_workshop2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_workshop2";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_chest2",       "room_hub" );
  ObjAttach( "zz_worktable2",   "room_hub" );
  ObjAttach( "zz_foundry2",     "room_hub" );
  ObjAttach( "zz_chemicallab2", "room_hub" );

  ObjMultiSet(
  {
    { "spr_chest2_chain2",                  { event_mdown = private.get_chain2 } },
    { "spr_chest2_scissors2",               { event_mdown = private.get_scissors2 } },
    { "spr_chest2_cometamulet2",            { event_mdown = private.get_cometamulet2 } },
    { "spr_chest2_crucible2",               { event_mdown = private.get_crucible2 } },
    { "spr_worktable2_recipe2",             { event_mdown = private.get_recipe2 } },
    { "spr_worktable2_copperas2",           { event_mdown = private.get_copperas2 } },
    { "spr_worktable2_ring2_2",             { event_mdown = private.get_ring2_2 } },
    { "spr_worktable2_blacksmithamulet2_2", { event_mdown = private.get_blacksmithamulet2_2 } },
    { "spr_foundry2_mitts2",                { event_mdown = private.get_mitts2 } },
    { "spr_foundry2_bucket2",               { event_mdown = private.get_bucket2 } },
    { "obj_foundry2_wholekey2",             { event_mdown = private.get_wholekey2 } },
    { "spr_foundry2_blacksmithamulet2_1",   { event_mdown = private.get_blacksmithamulet2_1 } },
    { "spr_foundry2_crucible",              { event_mdown = private.get_meltedtin2 } },
    { "spr_chemicallab2_tweezers2",         { event_mdown = private.get_tweezers2 } },
    { "spr_chemicallab2_phial2",            { event_mdown = private.get_phial2 } },
    { "spr_chemicallab2_tongs2",            { event_mdown = private.get_tongs2 } },
    { "obj_chest2_use_boltcutter2",         { event_mdown = private.Chest2ChainClick } },
    { "obj_chest2_use_blacksmithamulet2",   { event_mdown = private.Chest2CapClick } },
    { "obj_chemicallab2_clk_vessel2",       { event_mdown = function() private.clk_vessel2() end } },
    { "obj_foundry2_clk_handle",            { event_mdown = function() private.clk_foundry2_handle() end } },
    { "obj_worktable2_use_acid2",           { event_mdown = function() private.Worktable2CapClk() end } },
    { "spr_workshop2_collect_2_3",          { event_mdown = private.get_collect_2_3 } },
    { "obj_worktable2_diary_click",         { event_mdown = function() private.Worktable2DiaryClick() end } },
    { "spr_foundry2_screensaver_2_9",       { event_mdown = private.get_screensaver_2_9 } },
    { "spr_chest2_screensaver_2_10",        { event_mdown = private.get_screensaver_2_10 } },          
    { "obj_worktable2_clk_note2",           { event_mdown = private.clk_worktable2_note2 } },          
  } );
  local get_screensaver_2_9 = function ()

    ObjDelete( "spr_foundry2_screensaver_2_9" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_9", get_screensaver_2_9, private.room_objname );  
  local get_screensaver_2_10 = function ()

    ObjDelete( "spr_chest2_screensaver_2_10" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_10", get_screensaver_2_10, private.room_objname );  

  private.InitMiniHO();
  
  private.Foundry2Init();
  
  private.worktable2_page_diary = 1;
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_workshop2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_workshop2", update_game_mode_workshop2, private.room_objname );  

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.InitMorphRandomState( 2 );

  end;

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3 = function ()

    ObjDelete( "spr_workshop2_collect_2_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_2_3", get_collect_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_6 = function ()

    ObjDelete( "obj_workshop2_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_6", get_morphobject_2_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicprism2 () end;
  --------------------------------------------------------------------------------------------
  local get_magicprism2_inv = function ()

    int.InventoryItemAdd( "inv_magicprism2", "spr_workshop2_magicprism2" );

    if ( cmn.IsEventDone( "get_brokenlamp2" ) ) then

      ObjSet( "inv_brokenlamp2_plus_focus2", { alp = 1 } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicprism2", get_magicprism2_inv );
  --------------------------------------------------------------------------------------------
  -- function get_chain2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chain2" ] =
  {
    type = "get",
    get_obj = "spr_chest2_chain2",
    room = private.room_objname,
    zz = "zz_chest2",
    zz_gate = "gzz_workshop2_chest2"
  };
  --------------------------------------------------------------------------------------------
  local get_chain2_inv = function ()

    int.InventoryItemAdd( "inv_chain2", "spr_chest2_chain2" );

  end;
  local get_chain2_closezz = function ()

    ObjDelete( "gfx_chest2_chain2" );
    
    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
       
      ObjDelete( "gzz_workshop2_chest2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_chain2", get_chain2_inv );
  cmn.AddSubscriber( "get_chain2", get_chain2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cometamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cometamulet2" ] =
  {
    type = "get",
    get_obj = "spr_chest2_cometamulet2",
    room = private.room_objname,
    zz = "zz_chest2",
    zz_gate = "gzz_workshop2_chest2"
  };
  --------------------------------------------------------------------------------------------
  local get_cometamulet2_inv = function ()

    int.InventoryItemAdd( "inv_cometamulet2", "spr_chest2_cometamulet2" );

  end;
  local get_cometamulet2_closezz = function ()

    ObjDelete( "gfx_chest2_cometamulet2" );
    ObjDelete( "spr_workshop2_cometamulet" );
    ObjSet( "anm_chest2_cap_click", { res = "assets/levels/level2/rm_workshop2/zz_chest2/anims/anm_cap_click", animfunc = "DoAnim" } );

    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
       
      ObjDelete( "gzz_workshop2_chest2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cometamulet2", get_cometamulet2_inv );
  cmn.AddSubscriber( "get_cometamulet2", get_cometamulet2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scissors2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scissors2" ] =
  {
    type = "get",
    get_obj = "spr_chest2_scissors2",
    room = private.room_objname,
    zz = "zz_chest2",
    zz_gate = "gzz_workshop2_chest2"
  };
  --------------------------------------------------------------------------------------------
  local get_scissors2_inv = function ()

    int.InventoryItemAdd( "inv_scissors2", "spr_chest2_scissors2" );

  end;
  local get_scissors2_closezz = function ()

    ObjDelete( "gfx_chest2_scissors2" );
    ObjDelete( "spr_workshop2_scissors" );

    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
       
      ObjDelete( "gzz_workshop2_chest2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_scissors2", get_scissors2_inv );
  cmn.AddSubscriber( "get_scissors2", get_scissors2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crucible2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crucible2" ] =
  {
    type = "get",
    get_obj = "spr_chest2_crucible2",
    room = private.room_objname,
    zz = "zz_chest2",
    zz_gate = "gzz_workshop2_chest2"
  };
  --------------------------------------------------------------------------------------------
  local get_crucible2_inv = function ()

    int.InventoryItemAdd( "inv_crucible2", "spr_chest2_crucible2" );

  end;
  local get_crucible2_closezz = function ()

    ObjDelete( "gfx_chest2_crucible2" );
    ObjDelete( "spr_chest2_crucible2_shadow" );
    
    ObjDelete( "spr_workshop2_chest_crucible" );

    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
       
      ObjDelete( "gzz_workshop2_chest2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crucible2", get_crucible2_inv );
  cmn.AddSubscriber( "get_crucible2", get_crucible2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dagger2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dagger2" ] =
  {
    type = "get",
    get_obj = "spr_chest2_ho_1",
    room = private.room_objname,
    zz = "zz_chest2",
    zz_gate = "gzz_workshop2_chest2"
  };
  --------------------------------------------------------------------------------------------
  local get_dagger2_inv = function ()

    int.InventoryItemAdd( "inv_dagger2", "spr_chest2_win" );

  end;
  local get_dagger2_closezz = function ()

    ObjDelete( "obj_chest2_miniho" );
    
    ObjDelete( "spr_workshop2_chest_ho" );
    
    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
       
      ObjDelete( "gzz_workshop2_chest2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_dagger2", get_dagger2_inv );
  cmn.AddSubscriber( "get_dagger2", get_dagger2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_recipe2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_recipe2" ] =
  {
    type = "get",
    get_obj = "spr_worktable2_recipe2",
    room = private.room_objname,
    zz = "zz_worktable2",
    zz_gate = "gzz_workshop2_worktable2"
  };
  --------------------------------------------------------------------------------------------
  local get_recipe2_inv = function ()

    int.InventoryItemAdd( "inv_recipe2", "spr_worktable2_recipe2" );

  end;
  local get_recipe2_closezz = function ()

    ObjDelete( "spr_worktable2_recipe_shadow" );
    ObjDelete( "anm_worktable2_use_cleaningagent" );
    
    ObjDelete( "spr_workshop2_worktable_recipe_2" );

    --if cmn.IsEventDone( "get_copperas2" ) and 
    --   cmn.IsEventDone( "get_ring2_2" ) then
    --   
    --   ObjDelete( "gzz_workshop2_worktable2" );
    --  
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_recipe2", get_recipe2_inv );
  cmn.AddSubscriber( "get_recipe2", get_recipe2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_copperas2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_copperas2" ] =
  {
    type = "get",
    get_obj = "obj_worktable2_copperas2",
    room = private.room_objname,
    zz = "zz_worktable2",
    zz_gate = "gzz_workshop2_worktable2"
  };
  --------------------------------------------------------------------------------------------
  local get_copperas2_inv = function ()

    int.InventoryItemAdd( "inv_copperas2", "obj_worktable2_copperas2" );

  end;
  local get_copperas2_closezz = function ()

    ObjDelete( "gfx_worktable2_copperas2" );
    ObjDelete( "spr_worktable2_copperas_1_shadow" );
    ObjDelete( "spr_workshop2_worktable_copperas" );
    
    --if cmn.IsEventDone( "get_recipe2" ) and 
    --   cmn.IsEventDone( "get_ring2_2" ) then
    --   
    --   ObjDelete( "gzz_workshop2_worktable2" );
    --  
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_copperas2", get_copperas2_inv );
  cmn.AddSubscriber( "get_copperas2", get_copperas2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ring2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ring2_2" ] =
  {
    type = "get",
    get_obj = "spr_worktable2_ring2_2",
    room = private.room_objname,
    zz = "zz_worktable2",
    zz_gate = "gzz_workshop2_worktable2"
  };
  --------------------------------------------------------------------------------------------
  local get_ring2_2_inv = function ()

    int.InventoryItemAdd( "inv_ring2", "spr_worktable2_ring2_2", "assets/levels/level2/rm_neartower2/zz_well2/inv/inv_ring2_2" );
    level2_inv.CheckRing2( 2 );

  end;
  local get_ring2_2_closezz = function ()

    ObjDelete( "gfx_worktable2_ring2_2" );
    ObjDelete( "spr_workshop2_worktable_ring" );
    
    --if cmn.IsEventDone( "get_recipe2" ) and 
    --   cmn.IsEventDone( "get_copperas2" ) then
    --   
    --   ObjDelete( "gzz_workshop2_worktable2" );
    --  
    --end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_ring2_2", get_ring2_2_inv );
  cmn.AddSubscriber( "get_ring2_2", get_ring2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_blacksmithamulet2_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blacksmithamulet2_2" ] =
  {
    type = "get",
    get_obj = "spr_worktable2_blacksmithamulet2_2",
    room = private.room_objname,
    zz = "zz_worktable2",
    zz_gate = "gzz_workshop2_worktable2"
  };
  --------------------------------------------------------------------------------------------
  local get_blacksmithamulet2_2_inv = function ()

    int.InventoryItemAdd( "inv_blacksmithamulet2", "spr_worktable2_blacksmithamulet2_2", "assets/levels/level2/rm_workshop2/zz_foundry2/inv/inv_blacksmithamulet2_2" );
    level2_inv.CheckBlacksmithamulet2( 2 );

  end;
  local get_blacksmithamulet2_2_closezz = function ()

    ObjDelete( "gfx_worktable2_blacksmithamulet2_2" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_blacksmithamulet2_2", get_blacksmithamulet2_2_inv );
  cmn.AddSubscriber( "get_blacksmithamulet2_2", get_blacksmithamulet2_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mitts2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mitts2" ] =
  {
    type = "get",
    get_obj = "spr_foundry2_mitts2",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local get_mitts2_inv = function ()

    int.InventoryItemAdd( "inv_mitts2", "spr_foundry2_mitts2" );

  end;
  local get_mitts2_closezz = function ()

    ObjDelete( "gfx_foundry2_mitts2" );
    
    ObjDelete( "spr_workshop2_foundry_mitts" );
    
    if cmn.IsEventDone( "get_bucket2" ) and 
       cmn.IsEventDone( "get_wholekey2" ) and 
       cmn.IsEventDone( "get_blacksmithamulet2_1" ) and 
       cmn.IsEventDone( "get_meltedtin2" ) then
       
      ObjDelete( "gzz_workshop2_foundry2" );
      
    end; 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mitts2", get_mitts2_inv );
  cmn.AddSubscriber( "get_mitts2", get_mitts2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bucket2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bucket2" ] =
  {
    type = "get",
    get_obj = "spr_foundry2_bucket2",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local get_bucket2_inv = function ()

    int.InventoryItemAdd( "inv_bucket2", "spr_foundry2_bucket2" );

  end;
  local get_bucket2_closezz = function ()

    ObjDelete( "gfx_foundry2_bucket2" );
    ObjDelete( "spr_workshop2_foundry_bucket" );
    
    if cmn.IsEventDone( "get_mitts2" ) and 
       cmn.IsEventDone( "get_wholekey2" ) and 
       cmn.IsEventDone( "get_blacksmithamulet2_1" ) and 
       cmn.IsEventDone( "get_meltedtin2" ) then
       
      ObjDelete( "gzz_workshop2_foundry2" );
      
    end; 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bucket2", get_bucket2_inv );
  cmn.AddSubscriber( "get_bucket2", get_bucket2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wholekey2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wholekey2" ] =
  {
    type = "get",
    get_obj = "obj_foundry2_wholekey2",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local get_wholekey2_inv = function ()

    int.InventoryItemAdd( "inv_wholekey2", "obj_foundry2_wholekey2" );

  end;
  local get_wholekey2_closezz = function ()

    ObjDelete( "gfx_foundry2_wholekey2" );
    ObjDelete( "obj_foundry2_key" );
    ObjDelete( "spr_workshop2_foundry_wholekey" );
    
    if cmn.IsEventDone( "get_mitts2" ) and 
       cmn.IsEventDone( "get_bucket2" ) and 
       cmn.IsEventDone( "get_blacksmithamulet2_1" ) and 
       cmn.IsEventDone( "get_meltedtin2" ) then
       
      ObjDelete( "gzz_workshop2_foundry2" );
      
    end; 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_wholekey2", get_wholekey2_inv );
  cmn.AddSubscriber( "get_wholekey2", get_wholekey2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_blacksmithamulet2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blacksmithamulet2_1" ] =
  {
    type = "get",
    get_obj = "spr_foundry2_blacksmithamulet2_1",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local get_blacksmithamulet2_1_inv = function ()

    int.InventoryItemAdd( "inv_blacksmithamulet2", "spr_foundry2_blacksmithamulet2_1", "assets/levels/level2/rm_workshop2/zz_foundry2/inv/inv_blacksmithamulet2_1" );
    level2_inv.CheckBlacksmithamulet2 ( 1 );

  end;
  local get_blacksmithamulet2_1_closezz = function ()

    ObjDelete( "gfx_foundry2_blacksmithamulet2_1" );
    
    ObjDelete( "spr_workshop2_foundry_blacksmithamulet" );
    
    if cmn.IsEventDone( "get_mitts2" ) and 
       cmn.IsEventDone( "get_bucket2" ) and 
       cmn.IsEventDone( "get_wholekey2" ) and 
       cmn.IsEventDone( "get_meltedtin2" ) then
       
      ObjDelete( "gzz_workshop2_foundry2" );
      
    end; 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_blacksmithamulet2_1", get_blacksmithamulet2_1_inv );
  cmn.AddSubscriber( "get_blacksmithamulet2_1", get_blacksmithamulet2_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_meltedtin2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_meltedtin2" ] =
  {
    type = "get",
    get_obj = "spr_foundry2_crucible",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local get_meltedtin2_inv = function ()

    int.InventoryItemAdd( "inv_meltedtin2", "spr_foundry2_crucible" );

  end;
  local get_meltedtin2_closezz = function ()

    ObjDelete( "gfx_foundry2_meltedtin2" );
    ObjDelete( "spr_foundry2_crucible_shadow" );
    
    ObjDelete( "spr_workshop2_foundry_crucible" );
    ObjDelete( "spr_workshop2_foundry_meltedtin" );
    
    if cmn.IsEventDone( "get_mitts2" ) and 
       cmn.IsEventDone( "get_bucket2" ) and 
       cmn.IsEventDone( "get_wholekey2" ) and 
       cmn.IsEventDone( "get_blacksmithamulet2_1" ) then
       
      ObjDelete( "gzz_workshop2_foundry2" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_meltedtin2", get_meltedtin2_inv );
  cmn.AddSubscriber( "get_meltedtin2", get_meltedtin2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezers2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezers2" ] =
  {
    type = "get",
    get_obj = "spr_chemicallab2_tweezers2",
    room = private.room_objname,
    zz = "zz_chemicallab2",
    zz_gate = "gzz_workshop2_chemicallab2"
  };
  --------------------------------------------------------------------------------------------
  local get_tweezers2_inv = function ()

    int.InventoryItemAdd( "inv_tweezers2", "spr_chemicallab2_tweezers2" );

  end;
  local get_tweezers2_closezz = function ()

    ObjDelete( "gfx_chemicallab2_tweezers2" );
    ObjDelete( "spr_workshop2_tweezers" );

    if cmn.IsEventDone( "use_copperas2" ) and 
       cmn.IsEventDone( "get_tweezers2" ) and  
       cmn.IsEventDone( "use_recipe2" ) and                  
       cmn.IsEventDone( "use_vessel2" ) then

      ObjDelete( "gzz_workshop2_chemicallab2" );
      ObjSet( "gmg_workshop2_mgcreatingacid2", { alp = 1, input = true, active = true } );

    end;      

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_tweezers2", get_tweezers2_inv );
  cmn.AddSubscriber( "get_tweezers2", get_tweezers2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_phial2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_phial2" ] =
  {
    type = "get",
    get_obj = "spr_chemicallab2_phial2",
    room = private.room_objname,
    zz = "zz_chemicallab2",
    zz_gate = "gzz_workshop2_chemicallab2"
  };
  --------------------------------------------------------------------------------------------
  local get_phial2_inv = function ()

    int.InventoryItemAdd( "inv_phial2", "spr_chemicallab2_phial2" );

  end;
  local get_phial2_closezz = function ()

    ObjDelete( "gfx_chemicallab2_phial2" );
    ObjDelete( "spr_workshop2_phial" );
    --ObjDelete( "gzz_workshop2_chemicallab2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_phial2", get_phial2_inv );
  cmn.AddSubscriber( "get_phial2", get_phial2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tongs2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tongs2" ] =
  {
    type = "get",
    get_obj = "spr_chemicallab2_tongs2",
    room = private.room_objname,
    zz = "zz_chemicallab2",
    zz_gate = "gzz_workshop2_chemicallab2"
  };
  --------------------------------------------------------------------------------------------
  local get_tongs2_inv = function ()

    int.InventoryItemAdd( "inv_tongs2", "spr_chemicallab2_tongs2" );

  end;
  local get_tongs2_closezz = function ()

    ObjDelete( "gfx_chemicallab2_tongs2" );
    ObjDelete( "spr_workshop2_tongs" );
    --ObjDelete( "gzz_workshop2_chemicallab2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_tongs2", get_tongs2_inv );
  cmn.AddSubscriber( "get_tongs2", get_tongs2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_acid2 () end;
  --------------------------------------------------------------------------------------------
  local get_acid2_closezz = function ()

    ObjDelete( "gmg_workshop2_mgcreatingacid2" );
    ObjDelete( "spr_workshop2_mg_acid_bottle" );
    ObjDelete( "spr_workshop2_mg_acid" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_acid2", get_acid2_closezz, private.room_objname );

--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_blacksmithamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_blacksmithamulet2" ] =
  {
    type = "use",
    use_obj = "inv_blacksmithamulet2",
    use_place = "obj_chest2_use_blacksmithamulet2",
    room = private.room_objname,
    zz = "zz_chest2",
    zz_gate = "gzz_workshop2_chest2"
  };
  --------------------------------------------------------------------------------------------
  local use_blacksmithamulet2_inv = function ()

    int.InventoryItemRemove( "inv_blacksmithamulet2" );

  end;
  local use_blacksmithamulet2_beg = function ()

    ObjDelete( "obj_chest2_use_blacksmithamulet2" );
    ObjDelete( "anm_chest2_cap_click" );

  end;
  local use_blacksmithamulet2_end = function ()

    ObjSet( "anm_chest2_cap_open", { alp = 1, frame = 94, animfunc = "DoAnim" } );
    ObjSet( "obj_chest2_miniho", { input = true } );
    ObjSet( "obj_chest2_open", { alp = 1 } );
    
    ObjSet( "obj_workshop2_open_2", { alp = 1 } );
    ObjDelete( "spr_workshop2_chest_cap_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_blacksmithamulet2",     use_blacksmithamulet2_inv );
  cmn.AddSubscriber( "use_blacksmithamulet2",     use_blacksmithamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_blacksmithamulet2",     use_blacksmithamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_blacksmithamulet2_inv", use_blacksmithamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_blacksmithamulet2_beg", use_blacksmithamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_blacksmithamulet2_end", use_blacksmithamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boltcutter2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boltcutter2" ] =
  {
    type = "use",
    use_obj = "inv_boltcutter2",
    use_place = "obj_chest2_use_boltcutter2",
    room = private.room_objname,
    zz = "zz_chest2",
    zz_gate = "gzz_workshop2_chest2"
  };
  --------------------------------------------------------------------------------------------
  local use_boltcutter2_inv = function ()

    int.InventoryItemRemove( "inv_boltcutter2" );

  end;
  local use_boltcutter2_beg = function ()

    ObjDelete( "obj_chest2_use_boltcutter2" );
    ObjDelete( "anm_chest2_chain_click" );

  end;
  local use_boltcutter2_end = function ()

    ObjDelete( "obj_chest2_close" );
    ObjSet( "spr_chest2_box_open", { alp = 1 } );
    ObjSet( "obj_chest2_open", { input = true } );
    ObjSet( "gfx_chest2_cometamulet2", { active = true } );
    ObjSet( "obj_chest2_use_blacksmithamulet2", { input = true } );

    ObjDelete( "spr_workshop2_chine_1" );
    ObjSet( "spr_workshop2_chine_2", { alp = 1 } );
    ObjDelete( "spr_workshop2_chest_cap" );
    ObjSet( "obj_workshop2_open_1", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boltcutter2",     use_boltcutter2_inv );
  cmn.AddSubscriber( "use_boltcutter2",     use_boltcutter2_beg, private.room_objname );
  cmn.AddSubscriber( "use_boltcutter2",     use_boltcutter2_end, private.room_objname );
  cmn.AddSubscriber( "use_boltcutter2_inv", use_boltcutter2_inv, private.room_objname );
  cmn.AddSubscriber( "use_boltcutter2_beg", use_boltcutter2_beg, private.room_objname );
  cmn.AddSubscriber( "use_boltcutter2_end", use_boltcutter2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cleaningagent2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cleaningagent2" ] =
  {
    type = "use",
    use_obj = "inv_cleaningagent2",
    use_place = "obj_worktable2_use_cleaningagent2",
    room = private.room_objname,
    zz = "zz_worktable2",
    zz_gate = "gzz_workshop2_worktable2"
  };
  --------------------------------------------------------------------------------------------
  local use_cleaningagent2_inv = function ()

    int.InventoryItemRemove( "inv_cleaningagent2" );

  end;
  local use_cleaningagent2_beg = function ()

    ObjDelete( "obj_worktable2_use_cleaningagent2" );

  end;
  local use_cleaningagent2_end = function ()

    ObjSet( "anm_worktable2_use_cleaningagent", { frame = 208, animfunc = "DoAnim" } );

    ObjSet( "spr_worktable2_recipe2", { input = true } );
    --ObjSet( "spr_worktable2_recipe_shadow", { alp = 1 } );
    ObjSet( "gfx_worktable2_recipe2", { active = true } );

    ObjDelete( "spr_workshop2_worktable_recipe_1" );
    ObjSet( "spr_workshop2_worktable_recipe_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cleaningagent2",     use_cleaningagent2_inv );
  cmn.AddSubscriber( "use_cleaningagent2",     use_cleaningagent2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagent2",     use_cleaningagent2_end, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagent2_inv", use_cleaningagent2_inv, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagent2_beg", use_cleaningagent2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cleaningagent2_end", use_cleaningagent2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_phial2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_phial2" ] =
  {
    type = "use",
    use_obj = "inv_phial2",
    use_place = "obj_worktable2_use_phial2",
    room = private.room_objname,
    zz = "zz_worktable2",
    zz_gate = "gzz_workshop2_worktable2"
  };
  --------------------------------------------------------------------------------------------
  local use_phial2_inv = function ()

    int.InventoryItemRemove( "inv_phial2" );

  end;
  local use_phial2_beg = function ()

    ObjDelete( "obj_worktable2_use_phial2" );

  end;
  local use_phial2_end = function ()

    ObjDelete( "anm_worktable2_use_phial" );
    ObjDelete( "spr_workshop2_worktable_copperas" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_phial2",     use_phial2_inv );
  cmn.AddSubscriber( "use_phial2",     use_phial2_beg, private.room_objname );
  cmn.AddSubscriber( "use_phial2",     use_phial2_end, private.room_objname );
  cmn.AddSubscriber( "use_phial2_inv", use_phial2_inv, private.room_objname );
  cmn.AddSubscriber( "use_phial2_beg", use_phial2_beg, private.room_objname );
  cmn.AddSubscriber( "use_phial2_end", use_phial2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_acid2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_acid2" ] =
  {
    type = "use",
    use_obj = "inv_acid2",
    use_place = "obj_worktable2_use_acid2",
    room = private.room_objname,
    zz = "zz_worktable2",
    zz_gate = "gzz_workshop2_worktable2"
  };
  --------------------------------------------------------------------------------------------
  local use_acid2_inv = function ()

    int.InventoryItemRemove( "inv_acid2" );

  end;
  local use_acid2_beg = function ()

    ObjDelete( "obj_worktable2_use_acid2" );

  end;
  local use_acid2_end = function ()

    ObjDelete( "obj_worktable2_cash_close" );
    ObjSet( "obj_worktable2_cash_open", { input = true } );
    ObjSet( "obj_worktable2_clk_note2", { input = true } );
    ObjSet( "anm_worktable2_use_acid", { frame = 500, alp = 1 } );
    ObjSet( "gfx_worktable2_ring2_2", { active = true } );
    ObjSet( "gfx_worktable2_blacksmithamulet2_2", { active = true } );
    
    ObjSet( "spr_worktable2_light_ring", { active = true } );

    ObjDelete( "spr_workshop2_worktable_close" );
    ObjSet( "obj_workshop2_open_worktable", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_acid2",     use_acid2_inv );
  cmn.AddSubscriber( "use_acid2",     use_acid2_beg, private.room_objname );
  cmn.AddSubscriber( "use_acid2",     use_acid2_end, private.room_objname );
  cmn.AddSubscriber( "use_acid2_inv", use_acid2_inv, private.room_objname );
  cmn.AddSubscriber( "use_acid2_beg", use_acid2_beg, private.room_objname );
  cmn.AddSubscriber( "use_acid2_end", use_acid2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_keypiece2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_keypiece2" ] =
  {
    type = "use",
    use_obj = "inv_keypiece2",
    use_place = "obj_foundry2_use_keypiece2",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local use_keypiece2_inv = function ()

    int.InventoryItemRemove( "inv_keypiece2" );

  end;
  local use_keypiece2_beg = function ()

    ObjDelete( "obj_foundry2_use_keypiece2" );

  end;
  local use_keypiece2_end = function ()

    --ObjSet( "spr_foundry2_keypiece_2", { alp = 1 } );
    --ObjSet( "spr_foundry2_keypiece_1", { alp = 1 } );
    --ObjSet( "spr_foundry2_wholekey2", { input = true } );
    --ObjSet( "gfx_foundry2_wholekey2", { active = true } );
    
    ObjDelete( "anm_foundry2_use_keypiece" );
    ObjSet( "obj_foundry2_clk_handle", { input = true } );
    ObjSet( "anm_foundry2_key_repair", { alp = 1 } );

    ObjSet( "spr_workshop2_foundry_wholekey", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_keypiece2",     use_keypiece2_inv );
  cmn.AddSubscriber( "use_keypiece2",     use_keypiece2_beg, private.room_objname );
  cmn.AddSubscriber( "use_keypiece2",     use_keypiece2_end, private.room_objname );
  cmn.AddSubscriber( "use_keypiece2_inv", use_keypiece2_inv, private.room_objname );
  cmn.AddSubscriber( "use_keypiece2_beg", use_keypiece2_beg, private.room_objname );
  cmn.AddSubscriber( "use_keypiece2_end", use_keypiece2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mosaicpart2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mosaicpart2" ] =
  {
    type = "use",
    use_obj = "inv_mosaicpart2",
    use_place = "obj_foundry2_use_mosaicpart2",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local use_mosaicpart2_inv = function ()

    int.InventoryItemRemove( "inv_mosaicpart2" );

  end;
  local use_mosaicpart2_beg = function ()

    ObjDelete( "obj_foundry2_use_mosaicpart2" );

  end;
  local use_mosaicpart2_end = function ()

    ObjSet( "obj_foundry2_mmg", { input = true, scale_x = 1, scale_y = 1, pos_x = -64, pos_y = 13 } );
    ObjSet( "anm_foundry2_use_mosaicpart", { frame = 500 } );

    ObjDelete( "spr_workshop2_foundry_box_hole" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mosaicpart2",     use_mosaicpart2_inv );
  cmn.AddSubscriber( "use_mosaicpart2",     use_mosaicpart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mosaicpart2",     use_mosaicpart2_end, private.room_objname );
  cmn.AddSubscriber( "use_mosaicpart2_inv", use_mosaicpart2_inv, private.room_objname );
  cmn.AddSubscriber( "use_mosaicpart2_beg", use_mosaicpart2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mosaicpart2_end", use_mosaicpart2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crucible2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crucible2" ] =
  {
    type = "use",
    use_obj = "inv_crucible2",
    use_place = "obj_foundry2_use_crucible2",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local use_crucible2_inv = function ()

    int.InventoryItemRemove( "inv_crucible2" );

  end;
  local use_crucible2_beg = function ()

    ObjDelete( "obj_foundry2_use_crucible2" );

  end;
  local use_crucible2_end = function ()

    ObjSet( "spr_foundry2_crucible_shadow", { alp = 1 } );
    ObjSet( "spr_foundry2_crucible", { alp = 1 } );
    ObjDelete( "anm_foundry2_use_crucible" );
    ObjSet( "obj_foundry2_use_tinamulet2", { input = true } );

    ObjSet( "spr_workshop2_foundry_crucible", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crucible2",     use_crucible2_inv );
  cmn.AddSubscriber( "use_crucible2",     use_crucible2_beg, private.room_objname );
  cmn.AddSubscriber( "use_crucible2",     use_crucible2_end, private.room_objname );
  cmn.AddSubscriber( "use_crucible2_inv", use_crucible2_inv, private.room_objname );
  cmn.AddSubscriber( "use_crucible2_beg", use_crucible2_beg, private.room_objname );
  cmn.AddSubscriber( "use_crucible2_end", use_crucible2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tinamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tinamulet2" ] =
  {
    type = "use",
    use_obj = "inv_tinamulet2",
    use_place = "obj_foundry2_use_tinamulet2",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --------------------------------------------------------------------------------------------
  local use_tinamulet2_inv = function ()

    int.InventoryItemRemove( "inv_tinamulet2" );

  end;
  local use_tinamulet2_beg = function ()

    ObjDelete( "obj_foundry2_use_tinamulet2" );

  end;
  local use_tinamulet2_end = function ()

    ObjDelete( "anm_foundry2_use_tinamulet" );
    ObjSet( "anm_foundry2_melting", { alp = 1 } );
    ObjSet( "obj_foundry2_clk_handle", { input = true } );
    ObjSet( "spr_foundry2_crucible_shadow", { alp = 0 } );
    ObjSet( "spr_foundry2_crucible", { alp = 0 } );

    ObjSet( "spr_workshop2_foundry_tinamulet", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tinamulet2",     use_tinamulet2_inv );
  cmn.AddSubscriber( "use_tinamulet2",     use_tinamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_tinamulet2",     use_tinamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_tinamulet2_inv", use_tinamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_tinamulet2_beg", use_tinamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_tinamulet2_end", use_tinamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_recipe2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_recipe2" ] =
  {
    type = "use",
    use_obj = "inv_recipe2",
    use_place = "obj_chemicallab2_use_recipe2",
    room = private.room_objname,
    zz = "zz_chemicallab2",
    zz_gate = "gzz_workshop2_chemicallab2"
  };
  --------------------------------------------------------------------------------------------
  local use_recipe2_inv = function ()

    int.InventoryItemRemove( "inv_recipe2" );

  end;
  local use_recipe2_beg = function ()

    ObjDelete( "obj_chemicallab2_use_recipe2" );

  end;
  local use_recipe2_end = function ()

    ObjSet( "spr_chemicallab2_recipe_shadow", { alp = 1 } );
    ObjSet( "spr_chemicallab2_recipe", { alp = 1, input = true } );

    ObjSet( "spr_workshop2_chemicallab_recipe", { alp = 1 } );
    
    if cmn.IsEventDone( "use_copperas2" ) and 
       cmn.IsEventDone( "get_tweezers2" ) and  
       cmn.IsEventDone( "use_recipe2" ) and                  
       cmn.IsEventDone( "use_vessel2" ) then

      ObjDelete( "gzz_workshop2_chemicallab2" );
      ObjSet( "gmg_workshop2_mgcreatingacid2", { alp = 1, input = true, active = true } );

    end;      

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_recipe2",     use_recipe2_inv );
  cmn.AddSubscriber( "use_recipe2",     use_recipe2_beg, private.room_objname );
  cmn.AddSubscriber( "use_recipe2",     use_recipe2_end, private.room_objname );
  cmn.AddSubscriber( "use_recipe2_inv", use_recipe2_inv, private.room_objname );
  cmn.AddSubscriber( "use_recipe2_beg", use_recipe2_beg, private.room_objname );
  cmn.AddSubscriber( "use_recipe2_end", use_recipe2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_copperas2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_copperas2" ] =
  {
    type = "use",
    use_obj = "inv_copperas2",
    use_place = "obj_chemicallab2_use_copperas2",
    room = private.room_objname,
    zz = "zz_chemicallab2",
    zz_gate = "gzz_workshop2_chemicallab2"
  };
  --------------------------------------------------------------------------------------------
  local use_copperas2_inv = function ()

    int.InventoryItemRemove( "inv_copperas2" );

  end;
  local use_copperas2_beg = function ()

    ObjDelete( "obj_chemicallab2_use_copperas2" );

  end;
  local use_copperas2_end = function ()

    ObjSet( "anm_chemicallab2_use_copperas", { alp = 1, frame = 123, animfunc = "DoAnim" } );
    ObjSet( "spr_workshop2_chemicallab_copperas", { alp = 1 } );
    
    if cmn.IsEventDone( "use_copperas2" ) and 
       cmn.IsEventDone( "get_tweezers2" ) and  
       cmn.IsEventDone( "use_recipe2" ) and                  
       cmn.IsEventDone( "use_vessel2" ) then

      ObjDelete( "gzz_workshop2_chemicallab2" );
      ObjSet( "gmg_workshop2_mgcreatingacid2", { alp = 1, input = true, active = true } );

    end;  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_copperas2",     use_copperas2_inv );
  cmn.AddSubscriber( "use_copperas2",     use_copperas2_beg, private.room_objname );
  cmn.AddSubscriber( "use_copperas2",     use_copperas2_end, private.room_objname );
  cmn.AddSubscriber( "use_copperas2_inv", use_copperas2_inv, private.room_objname );
  cmn.AddSubscriber( "use_copperas2_beg", use_copperas2_beg, private.room_objname );
  cmn.AddSubscriber( "use_copperas2_end", use_copperas2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_snakesamulet2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_snakesamulet2" ] =
  {
    type = "use",
    use_obj = "inv_snakesamulet2",
    use_place = "obj_chemicallab2_use_snakesamulet2",
    room = private.room_objname,
    zz = "zz_chemicallab2",
    zz_gate = "gzz_workshop2_chemicallab2"
  };
  --------------------------------------------------------------------------------------------
  local use_snakesamulet2_inv = function ()

    int.InventoryItemRemove( "inv_snakesamulet2" );

  end;
  local use_snakesamulet2_beg = function ()

    ObjDelete( "obj_chemicallab2_use_snakesamulet2" );

  end;
  local use_snakesamulet2_end = function ()

    ObjDelete( "anm_chemicallab2_snakeamulet2_1" );
    ObjDelete( "anm_chemicallab2_snakeamulet2_2" );

    ObjSet( "obj_chemicallab2_open_box", { alp = 1, input = true } );
    ObjSet( "gfx_chemicallab2_tongs2", { active = true } );
    ObjSet( "gfx_chemicallab2_phial2", { active = true } );

    ObjSet( "obj_workshop2_chemicallab_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_snakesamulet2",     use_snakesamulet2_inv );
  cmn.AddSubscriber( "use_snakesamulet2",     use_snakesamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_snakesamulet2",     use_snakesamulet2_end, private.room_objname );
  cmn.AddSubscriber( "use_snakesamulet2_inv", use_snakesamulet2_inv, private.room_objname );
  cmn.AddSubscriber( "use_snakesamulet2_beg", use_snakesamulet2_beg, private.room_objname );
  cmn.AddSubscriber( "use_snakesamulet2_end", use_snakesamulet2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_vessel2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_vessel2" ] =
  {
    type = "use",
    use_obj = "inv_vessel2",
    use_place = "obj_chemicallab2_use_vessel2",
    room = private.room_objname,
    zz = "zz_chemicallab2",
    zz_gate = "gzz_workshop2_chemicallab2"
  };
  --------------------------------------------------------------------------------------------
  local use_vessel2_inv = function ()

    int.InventoryItemRemove( "inv_vessel2" );

  end;
  local use_vessel2_beg = function ()

    ObjDelete( "obj_chemicallab2_use_vessel2" );

  end;
  local use_vessel2_end = function ()

    ObjSet( "anm_chemicallab2_use_vessel", { alp = 1, frame = 88, animfunc = "DoAnim" } );
    ObjSet( "spr_workshop2_chemicallab_vessel", { alp = 1 } );
    
    if cmn.IsEventDone( "use_copperas2" ) and 
       cmn.IsEventDone( "get_tweezers2" ) and  
       cmn.IsEventDone( "use_recipe2" ) and                  
       cmn.IsEventDone( "use_vessel2" ) then

      ObjDelete( "gzz_workshop2_chemicallab2" );
      ObjSet( "gmg_workshop2_mgcreatingacid2", { alp = 1, input = true, active = true } );

    end;  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_vessel2",     use_vessel2_inv );
  cmn.AddSubscriber( "use_vessel2",     use_vessel2_beg, private.room_objname );
  cmn.AddSubscriber( "use_vessel2",     use_vessel2_end, private.room_objname );
  cmn.AddSubscriber( "use_vessel2_inv", use_vessel2_inv, private.room_objname );
  cmn.AddSubscriber( "use_vessel2_beg", use_vessel2_beg, private.room_objname );
  cmn.AddSubscriber( "use_vessel2_end", use_vessel2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mitts2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mitts2" ] =
  {
    type = "use",
    use_obj = "inv_mitts2",
    use_place = "obj_workshop2_use_mitts2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local use_mitts2_inv = function ()

    int.InventoryItemRemove( "inv_mitts2" );

  end;
  local use_mitts2_beg = function ()

    ObjDelete( "obj_workshop2_use_mitts2" );

  end;
  local use_mitts2_end = function ()

    ObjDelete( "anm_workshop2_mitts2" );
    ObjSet( "gho_workshop2_hocupboard2", { alp = 1, input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mitts2",     use_mitts2_inv );
  cmn.AddSubscriber( "use_mitts2",     use_mitts2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mitts2",     use_mitts2_end, private.room_objname );
  cmn.AddSubscriber( "use_mitts2_inv", use_mitts2_inv, private.room_objname );
  cmn.AddSubscriber( "use_mitts2_beg", use_mitts2_beg, private.room_objname );
  cmn.AddSubscriber( "use_mitts2_end", use_mitts2_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_vessel2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_vessel2" ] =
  {
    type = "click",
    clk_obj = "obj_chemicallab2_clk_vessel2",
    room = private.room_objname,
    zz = "zz_chemicallab2",
    zz_gate = "gzz_workshop2_chemicallab2"
  };
  -----------------------------------------------
  local clk_vessel2_inv = function ()

  end;
  local clk_vessel2_beg = function ()

    ObjDelete( "obj_chemicallab2_clk_vessel2" );

  end;
  local clk_vessel2_end = function ()

    ObjSet( "obj_chemicallab2_use_vessel2", { input = true } );
    ObjDelete( "anm_chemicallab2_click_vessel" );

    ObjDelete( "spr_workshop2_chemicallab_vessel_broken" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_vessel2",     clk_vessel2_inv );
  cmn.AddSubscriber( "clk_vessel2",     clk_vessel2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vessel2",     clk_vessel2_end, private.room_objname );
  cmn.AddSubscriber( "clk_vessel2_inv", clk_vessel2_inv, private.room_objname );
  cmn.AddSubscriber( "clk_vessel2_beg", clk_vessel2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vessel2_end", clk_vessel2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_foundry2_handle_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_foundry2_handle_1" ] =
  {
    type = "click",
    clk_obj = "obj_foundry2_clk_handle",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  -----------------------------------------------
  local clk_foundry2_handle_1_inv = function ()

  end;
  local clk_foundry2_handle_1_beg = function ()

    ObjSet( "obj_foundry2_gun", { alp = 0 } );

  end;
  local clk_foundry2_handle_1_end = function ()
    
    if ( not cmn.IsEventDone( "use_tinamulet2" ) or
         cmn.IsEventDone( "clk_foundry2_handle_2" )) then
    
      ObjSet( "obj_foundry2_clk_handle", { input = false } );
      
    end;
    
    ObjSet( "spr_foundry2_keypiece_2", { alp = 1 } );
    ObjSet( "spr_foundry2_keypiece_1", { alp = 1 } );
    ObjSet( "spr_foundry2_key_22", { alp = 1 } );
    ObjDelete( "anm_foundry2_key_repair" );
    ObjSet( "obj_foundry2_gun", { alp = 1 } );
    
    ObjSet( "obj_foundry2_wholekey2", { input = true } );
    ObjSet( "gfx_foundry2_wholekey2", { active = true } );

    ObjSet( "spr_workshop2_foundry_handle_1", { alp = 0 } );
    ObjSet( "spr_workshop2_foundry_handle_2", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_foundry2_handle_1",     clk_foundry2_handle_1_inv );
  cmn.AddSubscriber( "clk_foundry2_handle_1",     clk_foundry2_handle_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_foundry2_handle_1",     clk_foundry2_handle_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_foundry2_handle_1_inv", clk_foundry2_handle_1_inv, private.room_objname );
  cmn.AddSubscriber( "clk_foundry2_handle_1_beg", clk_foundry2_handle_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_foundry2_handle_1_end", clk_foundry2_handle_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_foundry2_handle_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_foundry2_handle_2" ] =
  {
    type = "click",
    clk_obj = "obj_foundry2_clk_handle",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  -----------------------------------------------
  local clk_foundry2_handle_2_inv = function ()

  end;
  local clk_foundry2_handle_2_beg = function ()
    
    ObjSet( "obj_foundry2_gun", { alp = 0 } );    

  end;
  local clk_foundry2_handle_2_end = function ()
    
    if ( not cmn.IsEventDone( "use_keypiece2" ) or
         cmn.IsEventDone( "clk_foundry2_handle_1" )) then
    
      ObjSet( "obj_foundry2_clk_handle", { input = false } );
      
    end;    
    
    ObjDelete( "anm_foundry2_melting" );
    ObjSet( "spr_foundry2_crucible_shadow", { alp = 1 } );
    ObjSet( "spr_foundry2_crucible", { alp = 1, input = true } );
    ObjSet( "obj_foundry2_gun", { alp = 1 } );
    ObjSet( "spr_foundry2_meltedtin2", { alp = 1 } );
    ObjSet( "gfx_foundry2_meltedtin2", { active = true } );

    ObjDelete( "spr_workshop2_foundry_tinamulet" );
    ObjSet( "spr_workshop2_foundry_meltedtin", { alp = 1 } );
    
    ObjSet( "spr_workshop2_foundry_handle_1", { alp = 0 } );
    ObjSet( "spr_workshop2_foundry_handle_2", { alp = 1 } );    

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_foundry2_handle_2",     clk_foundry2_handle_2_inv );
  cmn.AddSubscriber( "clk_foundry2_handle_2",     clk_foundry2_handle_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_foundry2_handle_2",     clk_foundry2_handle_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_foundry2_handle_2_inv", clk_foundry2_handle_2_inv, private.room_objname );
  cmn.AddSubscriber( "clk_foundry2_handle_2_beg", clk_foundry2_handle_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_foundry2_handle_2_end", clk_foundry2_handle_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_worktable2_note2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_worktable2_note2" ] =
  {
    type = "click",
    clk_obj = "obj_worktable2_clk_note2",
    room = private.room_objname,
    zz = "zz_worktable2",
    zz_gate = "gzz_workshop2_worktable2"
  };
  -----------------------------------------------
  local clk_worktable2_note2_inv = function ()

  end;
  local clk_worktable2_note2_beg = function ()

    ObjDelete( "obj_worktable2_clk_note2" );

  end;
  local clk_worktable2_note2_end = function ()

    ObjSet( "spr_worktable2_note2", { input = true } );
    ObjSet( "spr_worktable2_ring2_2", { input = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_worktable2_note2",     clk_worktable2_note2_inv );
  cmn.AddSubscriber( "clk_worktable2_note2",     clk_worktable2_note2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_worktable2_note2",     clk_worktable2_note2_end, private.room_objname );
  cmn.AddSubscriber( "clk_worktable2_note2_inv", clk_worktable2_note2_inv, private.room_objname );
  cmn.AddSubscriber( "clk_worktable2_note2_beg", clk_worktable2_note2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_worktable2_note2_end", clk_worktable2_note2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_foundry2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_foundry2" ] =
  {
    type = "click",
    clk_obj = "spr_foundry2_button1",
    room = private.room_objname,
    zz = "zz_foundry2",
    zz_gate = "gzz_workshop2_foundry2"
  };
  --*********************************************************************************************************************
  local win_foundry2_inv = function ()

    if ( cmn.IsEventDone( "win_foundry2" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_foundry2 = function ()

    if ( cmn.IsEventDone( "win_foundry2" ) ) then
            
      ObjDelete( "obj_foundry2_mmg" );
      ObjSet( "anm_foundry2_open_box", { frame = 500 } );
      ObjSet( "obj_foundry2_box_open", { input = true } );
      ObjSet( "gfx_foundry2_blacksmithamulet2_1", { active = true } );
      ObjDelete( "obj_foundry2_box_close" );

      ObjSet( "spr_workshop2_foundry_open", { alp = 1 } );

    else 

      private.Foundry2Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_foundry2", win_foundry2_inv );
  cmn.AddSubscriber( "win_foundry2", win_foundry2, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function opn_mgcreatingacid2 () end;
  --------------------------------------------------------------------------------------------
  local opn_mgcreatingacid2 = function ()

    if ( cmn.IsEventDone( "opn_mgcreatingacid2" ) ) then

      ObjSet( "spr_workshop2_mg_recipe", { alp = 1 } );
      ObjDelete( "spr_workshop2_chemicallab_recipe" );
      ObjSet( "spr_workshop2_mg_copperas", { alp = 1 } );
      ObjSet( "spr_workshop2_mg_water", { alp = 1 } );

    end;

  end;

  cmn.AddSubscriber( "opn_mgcreatingacid2", opn_mgcreatingacid2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgcreatingacid2 () end;
  --------------------------------------------------------------------------------------------
  local win_mgcreatingacid2 = function ()

    if ( cmn.IsEventDone( "win_mgcreatingacid2" ) ) then

      ObjSet( "spr_workshop2_mg_acid", { alp = 1 } );

    end;

  end;

  cmn.AddSubscriber( "win_mgcreatingacid2", win_mgcreatingacid2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_hocupboard2 () end;
  --------------------------------------------------------------------------------------------
  local win_hocupboard2 = function ()

    if ( cmn.IsEventDone( "win_hocupboard2" ) ) then

      ObjDelete( "spr_workshop2_ho_vessel" );

    end;

  end;

  cmn.AddSubscriber( "win_hocupboard2", win_hocupboard2, private.room_objname );
  --------------------------------------------------------------------------------------
  -- function dlg_workshop2_richard2_4 () end;
  --------------------------------------------------------------------------------------------
  local dlg_workshop2_richard2_4_beg = function ()

  end;
  -----------------------------------------------
  local dlg_workshop2_richard2_4_end = function ()

    ObjDelete( "dlg_workshop2_richard2_4" );

  end;

  cmn.AddSubscriber( "dlg_workshop2_richard2_4",     dlg_workshop2_richard2_4_beg );
  cmn.AddSubscriber( "dlg_workshop2_richard2_4",     dlg_workshop2_richard2_4_end );
  cmn.AddSubscriber( "dlg_workshop2_richard2_4_beg", dlg_workshop2_richard2_4_beg );
  cmn.AddSubscriber( "dlg_workshop2_richard2_4_end", dlg_workshop2_richard2_4_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************  
function private.get_screensaver_2_9()

  int.AddScreensaver( "spr_foundry2_screensaver_2_9" );

end;    
function private.get_screensaver_2_10()

  int.AddScreensaver( "spr_chest2_screensaver_2_10" );

end;  
-----------------------------------------------------------------------
function private.get_collect_2_3 ()

  int.AddCollectibles( "spr_workshop2_collect_2_3" );

end;
-----------------------------------------------------------------------
function private.get_chain2 ()

  cmn.SetEventDone( "get_chain2" );
  cmn.CallEventHandler( "get_chain2" );
  cmn.GetObjectSfx();
  
    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_cometamulet2 ()

  ObjSet( "spr_chest2_cometamulet2", { alp = 1 } );

  cmn.SetEventDone( "get_cometamulet2" );
  cmn.CallEventHandler( "get_cometamulet2" );
  cmn.GetObjectSfx();
  
    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_crucible2 ()

  cmn.SetEventDone( "get_crucible2" );
  cmn.CallEventHandler( "get_crucible2" );
  cmn.GetObjectSfx();
  
    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function public.get_dagger2 ()

    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_scissors2 ()

    cmn.SetEventDone( "get_scissors2" );
    cmn.CallEventHandler( "get_scissors2" );
    cmn.GetObjectSfx();

    if cmn.IsEventDone( "get_chain2" ) and 
       cmn.IsEventDone( "get_crucible2" ) and 
       cmn.IsEventDone( "get_scissors2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) and 
       cmn.IsEventDone( "get_dagger2" ) then
     
    cmn.CloseSubRoom();
    
  end;

end;
-----------------------------------------------------------------------
function private.get_recipe2 ()

  ObjSet( "spr_worktable2_recipe2", { alp = 1 } );

  cmn.SetEventDone( "get_recipe2" );
  cmn.CallEventHandler( "get_recipe2" );
  cmn.GetObjectSfx();
  
--  if cmn.IsEventDone( "get_recipe2" ) and 
--     cmn.IsEventDone( "get_ring2_2" ) and 
--     cmn.IsEventDone( "get_blacksmithamulet2_2" ) and 
--     cmn.IsEventDone( "get_copperas2" ) then
--     
--    cmn.CloseSubRoom( true );
--    private.dlg_workshop2_richard2_4();
--
--  end;

end;
-----------------------------------------------------------------------
function private.get_copperas2 ()

  cmn.SetEventDone( "get_copperas2" );
  cmn.CallEventHandler( "get_copperas2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_recipe2" ) and 
     cmn.IsEventDone( "get_ring2_2" ) and 
     cmn.IsEventDone( "get_blacksmithamulet2_2" ) and 
     cmn.IsEventDone( "get_copperas2" ) then
     
    cmn.CloseSubRoom( true );
    private.dlg_workshop2_richard2_4();

  end;

end;
-----------------------------------------------------------------------
function private.get_ring2_2 ()

  cmn.SetEventDone( "get_ring2_2" );
  cmn.CallEventHandler( "get_ring2_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_recipe2" ) and 
     cmn.IsEventDone( "get_ring2_2" ) and 
     cmn.IsEventDone( "get_blacksmithamulet2_2" ) and 
     cmn.IsEventDone( "get_copperas2" ) then
     
    cmn.CloseSubRoom( true );
    private.dlg_workshop2_richard2_4();

  end;

end;
-----------------------------------------------------------------------
function private.get_blacksmithamulet2_2 ()

  cmn.SetEventDone( "get_blacksmithamulet2_2" );
  cmn.CallEventHandler( "get_blacksmithamulet2_2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_recipe2" ) and 
     cmn.IsEventDone( "get_ring2_2" ) and 
     cmn.IsEventDone( "get_blacksmithamulet2_2" ) and 
     cmn.IsEventDone( "get_copperas2" ) then
     
    cmn.CloseSubRoom( true );
    private.dlg_workshop2_richard2_4();

  end;

end;
-----------------------------------------------------------------------
function private.get_mitts2 ()

  cmn.SetEventDone( "get_mitts2" );
  cmn.CallEventHandler( "get_mitts2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_bucket2" ) and 
     cmn.IsEventDone( "get_wholekey2" ) and 
     cmn.IsEventDone( "get_blacksmithamulet2_1" ) and 
     cmn.IsEventDone( "get_meltedtin2" ) then
    cmn.CloseSubRoom();
  end;  
    
end;
-----------------------------------------------------------------------
function private.get_bucket2 ()

  cmn.SetEventDone( "get_bucket2" );
  cmn.CallEventHandler( "get_bucket2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_mitts2" ) and 
     cmn.IsEventDone( "get_wholekey2" ) and 
     cmn.IsEventDone( "get_blacksmithamulet2_1" ) and 
     cmn.IsEventDone( "get_meltedtin2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_wholekey2 ()

  cmn.SetEventDone( "get_wholekey2" );
  cmn.CallEventHandler( "get_wholekey2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_mitts2" ) and 
     cmn.IsEventDone( "get_bucket2" ) and 
     cmn.IsEventDone( "get_blacksmithamulet2_1" ) and 
     cmn.IsEventDone( "get_meltedtin2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_blacksmithamulet2_1 ()

  cmn.SetEventDone( "get_blacksmithamulet2_1" );
  cmn.CallEventHandler( "get_blacksmithamulet2_1" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_mitts2" ) and 
     cmn.IsEventDone( "get_bucket2" ) and 
     cmn.IsEventDone( "get_wholekey2" ) and 
     cmn.IsEventDone( "get_meltedtin2" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_meltedtin2 ()

  cmn.SetEventDone( "get_meltedtin2" );
  cmn.CallEventHandler( "get_meltedtin2" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_mitts2" ) and 
     cmn.IsEventDone( "get_bucket2" ) and 
     cmn.IsEventDone( "get_wholekey2" ) and 
     cmn.IsEventDone( "get_blacksmithamulet2_1" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_tweezers2 ()

  cmn.SetEventDone( "get_tweezers2" );
  cmn.CallEventHandler( "get_tweezers2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "use_copperas2" ) and 
     cmn.IsEventDone( "get_tweezers2" ) and  
     cmn.IsEventDone( "use_recipe2" ) and                  
     cmn.IsEventDone( "use_vessel2" ) then

    cmn.CloseSubRoom();
    
    if (not cmn.IsEventStart( "win_mgcreatingacid2" ) ) then
      
      cmn.GotoRoom( "mg_mgcreatingacid2" );
      
    end;

  end;  

end;
-----------------------------------------------------------------------
function private.get_phial2 ()

  cmn.SetEventDone( "get_phial2" );
  cmn.CallEventHandler( "get_phial2" );
  cmn.GetObjectSfx();

  if ( not cmn.IsEventDone( "get_tongs2" ) ) then

    private.get_tongs2();

  end;

end;
-----------------------------------------------------------------------
function private.get_tongs2 ()

  cmn.SetEventDone( "get_tongs2" );
  cmn.CallEventHandler( "get_tongs2" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_blacksmithamulet2 ()

  local item = "inv_blacksmithamulet2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_chest2", false ) and  
       cmn.IsEventDone( "get_blacksmithamulet2_1" ) and 
       cmn.IsEventDone( "get_blacksmithamulet2_2" ) and 
       cmn.IsEventDone( "get_cometamulet2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chest2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_chest2_use_blacksmithamulet2", true ) and
           cmn.IsEventDone( "get_blacksmithamulet2_1" ) and 
           cmn.IsEventDone( "get_blacksmithamulet2_2" ) and 
           cmn.IsEventDone( "get_cometamulet2" ) ) then

    cmn.CallEventHandler( "use_blacksmithamulet2_inv" );
    cmn.CallEventHandler( "use_blacksmithamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_blacksmithamulet2" );
      cmn.CallEventHandler( "use_blacksmithamulet2_end" );
      int_button_mini_ho.Show( "get_dagger2", "chest2", 4, "spr_chest2_dagger_panel", private.mini_ho_array ); 

    end;

    int.Lock( true );

    ObjSet( "anm_chest2_cap_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_horseshoe" );
    AnimPlay( "anm_chest2_cap_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_boltcutter2 ()

  local item = "inv_boltcutter2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_chest2", false ) ) and
     ( not cmn.IsEventDone( "use_boltcutter2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chest2" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_chest2_use_boltcutter2", true ) ) and
         ( not cmn.IsEventDone( "use_boltcutter2" ) ) then

    cmn.CallEventHandler( "use_boltcutter2_inv" );
    cmn.CallEventHandler( "use_boltcutter2_beg" );

    local func_end = function ()

      int.Lock( false );
      private.get_chain2();
      cmn.SetEventDone( "use_boltcutter2" );
      cmn.CallEventHandler( "use_boltcutter2_end" );

    end;

    int.Lock( true );
    
    ObjSet( "anm_chest2_chain_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_cut_chains_chest" );
    AnimPlay( "anm_chest2_chain_open", "DoAnim", function ()

      ObjAnimate( "spr_chest2_box_open", "alp", 0, 0, "",
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      ObjAnimate( "obj_chest2_close", "alp", 0, 0, func_end,
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

    end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_cleaningagent2 ()

  local item = "inv_cleaningagent2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_worktable2", false ) ) and
     ( not cmn.IsEventDone( "use_cleaningagent2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_worktable2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_worktable2_use_cleaningagent2", true ) ) and
         ( not cmn.IsEventDone( "use_cleaningagent2" ) ) then

    cmn.CallEventHandler( "use_cleaningagent2_inv" );
    cmn.CallEventHandler( "use_cleaningagent2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_cleaningagent2" );
      cmn.CallEventHandler( "use_cleaningagent2_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_fill_liquid_picture" );
    AnimPlay( "anm_worktable2_use_cleaningagent", "DoAnim", func_end );  
  
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_phial2 ()

  local item = "inv_phial2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_worktable2", false ) ) and
     ( not cmn.IsEventDone( "use_phial2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_worktable2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_worktable2_use_phial2", true ) ) and
         ( not cmn.IsEventDone( "use_phial2" ) ) then

    cmn.CallEventHandler( "use_phial2_inv" );
    cmn.CallEventHandler( "use_phial2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_phial2" );
      cmn.CallEventHandler( "use_phial2_end" );
      private.get_copperas2();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_fill_green_dust" );
    AnimPlay( "anm_worktable2_use_phial", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_acid2 ()

  local item = "inv_acid2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_worktable2", false ) ) and
     ( not cmn.IsEventDone( "use_acid2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_worktable2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_worktable2_use_acid2", true ) ) and
         ( not cmn.IsEventDone( "use_acid2" ) ) then

    cmn.CallEventHandler( "use_acid2_inv" );
    cmn.CallEventHandler( "use_acid2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_acid2" );
      cmn.CallEventHandler( "use_acid2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_worktable2_clk_cap", { alp = 0 } );
    ObjSet( "anm_worktable2_use_acid", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_worktable2_fill_acid" );
    AnimPlay( "anm_worktable2_use_acid", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_keypiece2 ()

  local item = "inv_keypiece2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_foundry2", false ) ) and
     ( not cmn.IsEventDone( "use_keypiece2" ) ) and 
       cmn.IsEventDone( "get_keypiece2_1" ) and 
       cmn.IsEventDone( "get_keypiece2_2" ) and 
       cmn.IsEventDone( "get_mitts2" ) and 
       cmn.IsEventDone( "get_bucket2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foundry2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_foundry2_use_keypiece2", true ) ) and
         ( not cmn.IsEventDone( "use_keypiece2" ) ) and 
           cmn.IsEventDone( "get_keypiece2_1" ) and 
           cmn.IsEventDone( "get_keypiece2_2" ) and 
           cmn.IsEventDone( "get_mitts2" ) and 
           cmn.IsEventDone( "get_bucket2" ) then

    cmn.CallEventHandler( "use_keypiece2_inv" );
    cmn.CallEventHandler( "use_keypiece2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_keypiece2" );
      cmn.CallEventHandler( "use_keypiece2_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_foundry2_use_keypiece", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_put_together_key" );
    AnimPlay( "anm_foundry2_use_keypiece", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_mosaicpart2 ()

  local item = "inv_mosaicpart2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_foundry2", false ) ) and
     ( not cmn.IsEventDone( "use_mosaicpart2" ) ) and 
       cmn.IsEventDone( "get_mitts2" ) and  
       cmn.IsEventDone( "get_bucket2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foundry2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_foundry2_use_mosaicpart2", true ) ) and
         ( not cmn.IsEventDone( "use_mosaicpart2" ) ) and 
           cmn.IsEventDone( "get_mitts2" ) and 
           cmn.IsEventDone( "get_bucket2" ) then

    cmn.CallEventHandler( "use_mosaicpart2_inv" );
    cmn.CallEventHandler( "use_mosaicpart2_beg" );

    local func_end = function ()
      
      local func_end1 = function ()
        
        int.Lock( false );
        cmn.SetEventDone( "use_mosaicpart2" );
        cmn.CallEventHandler( "use_mosaicpart2_end" );
        private.Foundry2StartInit();
        
      end;
      
      ObjAnimate( "obj_foundry2_mmg", "scale_xy", 0, 0, "",
      {
        0.0, 3, 0, 0,
        0.3, 3, 0, 0,
        0.8, 3, 1, 1
      } );
      ObjAnimate( "obj_foundry2_mmg", "pos_xy", 0, 0, func_end1,
      {
        0.0, 3, 150, 35,
        0.3, 3, 150, 35,
        0.8, 3, -64, 13
      } );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_cube_stuff" );
    AnimPlay( "anm_foundry2_use_mosaicpart", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_crucible2 ()

  local item = "inv_crucible2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_foundry2", false ) ) and
     ( not cmn.IsEventDone( "use_crucible2" ) ) and 
       cmn.IsEventDone( "get_mitts2" ) and 
       cmn.IsEventDone( "get_bucket2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foundry2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_foundry2_use_crucible2", true ) ) and
         ( not cmn.IsEventDone( "use_crucible2" ) ) and 
           cmn.IsEventDone( "get_mitts2" ) and 
           cmn.IsEventDone( "get_bucket2" ) then

    cmn.CallEventHandler( "use_crucible2_inv" );
    cmn.CallEventHandler( "use_crucible2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_crucible2" );
      cmn.CallEventHandler( "use_crucible2_end" );

    end;

    int.Lock( true );
    
    ObjSet( "anm_foundry2_use_crucible", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_metal_for_melt" );
    AnimPlay( "anm_foundry2_use_crucible", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_tinamulet2 ()

  local item = "inv_tinamulet2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_foundry2", false ) ) and
     ( not cmn.IsEventDone( "use_tinamulet2" ) ) and 
       cmn.IsEventDone( "use_crucible2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_foundry2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_foundry2_use_tinamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_tinamulet2" ) ) and 
           cmn.IsEventDone( "use_crucible2" ) then

    cmn.CallEventHandler( "use_tinamulet2_inv" );
    cmn.CallEventHandler( "use_tinamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_tinamulet2" );
      cmn.CallEventHandler( "use_tinamulet2_end" );

    end;

    int.Lock( true );

    ObjSet( "spr_foundry2_crucible_shadow", { alp = 0 } );
    ObjSet( "spr_foundry2_crucible", { alp = 0 } );
    ObjSet( "anm_foundry2_use_tinamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_put_stuff_for_melt" );
    AnimPlay( "anm_foundry2_use_tinamulet", "DoAnim", func_end );
      
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_recipe2 ()

  local item = "inv_recipe2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_chemicallab2", false ) ) and
     ( not cmn.IsEventDone( "use_recipe2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chemicallab2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_chemicallab2_use_recipe2", true ) ) and
         ( not cmn.IsEventDone( "use_recipe2" ) ) then

    cmn.CallEventHandler( "use_recipe2_inv" );
    cmn.CallEventHandler( "use_recipe2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_recipe2" );
      cmn.CallEventHandler( "use_recipe2_end" );
      
      if cmn.IsEventDone( "use_copperas2" ) and 
         cmn.IsEventDone( "get_tweezers2" ) and  
         cmn.IsEventDone( "use_recipe2" ) and                  
         cmn.IsEventDone( "use_vessel2" ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mgcreatingacid2" );

      end;

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_chemicallab2_put_paper" );
    ObjAnimate( "spr_chemicallab2_recipe_shadow", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    ObjAnimate( "spr_chemicallab2_recipe", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_copperas2 ()

  local item = "inv_copperas2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_chemicallab2", false ) ) and
     ( not cmn.IsEventDone( "use_copperas2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chemicallab2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_chemicallab2_use_copperas2", true ) ) and
         ( not cmn.IsEventDone( "use_copperas2" ) ) then

    cmn.CallEventHandler( "use_copperas2_inv" );
    cmn.CallEventHandler( "use_copperas2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_copperas2" );
      cmn.CallEventHandler( "use_copperas2_end" );
      
      if cmn.IsEventDone( "use_copperas2" ) and 
         cmn.IsEventDone( "get_tweezers2" ) and  
         cmn.IsEventDone( "use_recipe2" ) and                  
         cmn.IsEventDone( "use_vessel2" ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mgcreatingacid2" );

      end;

    end;

    int.Lock( true );

    ObjSet( "anm_chemicallab2_use_copperas", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_fill_green_dust_2" );
    AnimPlay( "anm_chemicallab2_use_copperas", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_snakesamulet2 ()

  local item = "inv_snakesamulet2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_chemicallab2", false ) ) and
     ( not cmn.IsEventDone( "use_snakesamulet2" ) ) and
     ( cmn.IsEventDone( "get_snakesamulet2_1" ) ) and
     ( cmn.IsEventDone( "get_snakesamulet2_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chemicallab2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_chemicallab2_use_snakesamulet2", true ) ) and
         ( not cmn.IsEventDone( "use_snakesamulet2" ) ) and
         ( cmn.IsEventDone( "get_snakesamulet2_1" ) ) and
         ( cmn.IsEventDone( "get_snakesamulet2_2" ) ) then

    cmn.CallEventHandler( "use_snakesamulet2_inv" );
    cmn.CallEventHandler( "use_snakesamulet2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_snakesamulet2" );
      cmn.CallEventHandler( "use_snakesamulet2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_chemicallab2_snakeamulet2_1", { alp = 1 } );
    ObjSet( "anm_chemicallab2_snakeamulet2_2", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_insert_symbol_table_opens" );
    AnimPlay( "anm_chemicallab2_snakeamulet2_1", "DoAnim", "" );
    AnimPlay( "anm_chemicallab2_snakeamulet2_2", "DoAnim", function ()

      ObjAnimate( "obj_chemicallab2_open_box", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 0,
        0.6, 0, 1,
      } );

    end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_vessel2 ()

  local item = "inv_vessel2";

  if ( cmn.ApplyObj( item, "gzz_workshop2_chemicallab2", false ) ) and
     ( not cmn.IsEventDone( "use_vessel2" ) ) and 
       cmn.IsEventDone( "clk_vessel2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chemicallab2", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_chemicallab2_use_vessel2", true ) ) and
         ( not cmn.IsEventDone( "use_vessel2" ) ) and 
           cmn.IsEventDone( "clk_vessel2" ) then

    cmn.CallEventHandler( "use_vessel2_inv" );
    cmn.CallEventHandler( "use_vessel2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_vessel2" );
      cmn.CallEventHandler( "use_vessel2_end" );
      
      if cmn.IsEventDone( "use_copperas2" ) and 
         cmn.IsEventDone( "get_tweezers2" ) and  
         cmn.IsEventDone( "use_recipe2" ) and                  
         cmn.IsEventDone( "use_vessel2" ) then

        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mgcreatingacid2" );

      end;

    end;

    int.Lock( true );

    ObjSet( "anm_chemicallab2_use_vessel", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_put_colb" );
    AnimPlay( "anm_chemicallab2_use_vessel", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_mitts2 ()

  local item = "inv_mitts2";

  if ( cmn.ApplyObj( item, "obj_workshop2_use_mitts2", true ) ) and
         ( not cmn.IsEventDone( "use_mitts2" ) ) then

    cmn.CallEventHandler( "use_mitts2_inv" );
    cmn.CallEventHandler( "use_mitts2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mitts2" );
      cmn.CallEventHandler( "use_mitts2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_workshop2_mitts2", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_pc_wear_mask" );
    AnimPlay( "anm_workshop2_mitts2", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function private.clk_vessel2 ()

  cmn.CallEventHandler( "clk_vessel2_inv" );
  cmn.CallEventHandler( "clk_vessel2_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_vessel2" );
    cmn.CallEventHandler( "clk_vessel2_end" );

  end;

  int.Lock( true );
  AnimPlay( "anm_chemicallab2_click_vessel", "DoAnim", func_end );

end;
-----------------------------------------------------------------------
-----------------------------------------------------------------------
function private.clk_foundry2_handle ()

  if (cmn.IsEventDone( "use_keypiece2" ) and 
      not cmn.IsEventDone( "clk_foundry2_handle_1" ) ) then
    
    private.clk_foundry2_handle_1();
    
  elseif ( cmn.IsEventDone( "use_tinamulet2" ) and 
           not cmn.IsEventDone( "clk_foundry2_handle_2" ) ) then

    private.clk_foundry2_handle_2();    
    
  end;

end;
-----------------------------------------------------------------------
function private.clk_foundry2_handle_1 ()

  cmn.CallEventHandler( "clk_foundry2_handle_1_inv" );
  cmn.CallEventHandler( "clk_foundry2_handle_1_beg" );

  local func_end = function ()
    
    local func_end1 = function ()
      int.Lock( false );
      cmn.SetEventDone( "clk_foundry2_handle_1" );
      cmn.CallEventHandler( "clk_foundry2_handle_1_end" );
      
      ObjSet( "anm_foundry2_handle", { frame = 0 } );         
      if ( cmn.IsEventDone( "use_tinamulet2" ) ) then
        
        ObjSet( "anm_foundry2_melting", { alp = 1 } );
        
      end;      
      
    end;
   
    if ( cmn.IsEventDone( "use_tinamulet2" ) ) then
      
      --ObjSet( "anm_foundry2_melting", { alp = 0 } );
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_sold_key" );
    ObjSet( "anm_foundry2_key_repair", { alp = 1 } );
    AnimPlay( "anm_foundry2_key_repair", "DoAnim", func_end1 );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_push_handle_for_key" );
  AnimPlay( "anm_foundry2_handle", "DoAnim", func_end );

end;
-----------------------------------------------------------------------
function private.clk_foundry2_handle_2 ()

  cmn.CallEventHandler( "clk_foundry2_handle_2_inv" );
  cmn.CallEventHandler( "clk_foundry2_handle_2_beg" );

  local func_end = function ()
    
    local func_end1 = function ()
      
      int.Lock( false );
      cmn.SetEventDone( "clk_foundry2_handle_2" );
      cmn.CallEventHandler( "clk_foundry2_handle_2_end" );
  
      ObjSet( "anm_foundry2_handle", { frame = 0 } );
      if ( cmn.IsEventDone( "use_keypiece2" ) ) then
        
        ObjSet( "anm_foundry2_key_repair", { alp = 1 } );
        
      end;          
      
    end;

    if ( cmn.IsEventDone( "use_keypiece2" ) ) then
      
      ObjSet( "anm_foundry2_key_repair", { alp = 0 } );
      
    end;
    
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_melt_stuff" );
    ObjSet( "anm_foundry2_melting", { alp = 1 } );
    AnimPlay( "anm_foundry2_melting", "DoAnim", func_end1 );
    
  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_push_handle_for_key" );
  AnimPlay( "anm_foundry2_handle", "DoAnim", func_end ); 

end;
-----------------------------------------------------------------------
function private.clk_worktable2_note2 ()

  cmn.CallEventHandler( "clk_worktable2_note2_inv" );
  cmn.CallEventHandler( "clk_worktable2_note2_beg" );

  cmn.NoteScale( { "spr_worktable2_note2" } );

  cmn.SetEventDone( "clk_worktable2_note2" );
  cmn.CallEventHandler( "clk_worktable2_note2_end" );

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
function private.dlg_workshop2_richard2_4 ()

  local func_before_end = function ( func_end )

    ObjSet( "anm_workshop2_magicprism2", { alp = 0 } );
    ObjSet( "spr_workshop2_magicprism2", { alp = 1 } );
    AnimStop( "anm_workshop2_magicprism2" );

    cmn.CallEventHandler( "get_magicprism2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_workshop2_richard2_4_richard_static",        { alp = 0 } );
    ObjSet( "anm_workshop2_richard2_4_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_workshop2_richard2_4_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_workshop2_richard2_4_richard_static" );
    AnimStop( "anm_workshop2_richard2_4_richard_disappearance" );

    ObjAnimate( "anm_workshop2_richard2_4_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_workshop2_richard2_4_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_magicprism2" );
      cmn.SetEventDone( "dlg_workshop2_richard2_4" );
      int.InventoryItemAdd( "inv_richardskull2" );
      cmn.ShowBbt( "bbt_workshop2_after_dlg_richard" );

      interface.KeyTaskDone( true, "task_2_6" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_workshop2_richard2_4_richard_appearance" );
    ObjSet( "anm_workshop2_richard2_4_richard_appearance", { alp = 0 } );

    ObjSet( "anm_workshop2_richard2_4_richard_static", { alp = 1 } );
    AnimPlay( "anm_workshop2_richard2_4_richard_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard2_4", "workshop2", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_workshop2_richard2_4_beg" );
  ObjAttach( "dlg_workshop2_richard2_4", GetCurrentRoom() );  

  ObjSet( "anm_workshop2_richard2_4_richard_appearance", { alp = 1 } );
  AnimPlay( "anm_workshop2_richard2_4_richard_appearance", "DoAnim", func_anim_end );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_workshop2_richard2_4_richard_static", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull2" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard2_4" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_workshop2_richard2_4_richard_static" );
        AnimPlay( "anm_workshop2_richard2_4_richard_give", "DoAnim", "" );
        AnimPlay( "anm_workshop2_richard2_4_object_appearance", "DoAnim", "" );

        ObjAnimate( "anm_workshop2_magicprism2", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_workshop2_richard2_4_richard_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_workshop2_richard2_4_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      cmn.PlayAudio( "sfx", "audio/aud_richard_creates_thing" );

    end;

  end;

end;
--*********************************************************************************************************************
function private.opn_workshop2 ()

  if not ( cmn.IsEventDone( "opn_workshop2" ) ) then

    cmn.SetEventDone( "opn_workshop2" );

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_workshop2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_workshop2_env", 1 );

  if ( cmn.IsEventDone( "get_recipe2" ) ) and 
     ( cmn.IsEventDone( "get_copperas2" ) ) and 
     ( cmn.IsEventDone( "get_blacksmithamulet2_2" ) ) and 
     ( cmn.IsEventDone( "get_ring2_2" ) ) and
     not ( cmn.IsEventDone( "dlg_workshop2_richard2_4" ) ) then

    private.dlg_workshop2_richard2_4();

  end;
  
  if ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2" ].stage then
    
    if ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2" ].stage == 3 then
      
      ObjSet( "spr_workshop2_open_door_ho", { alp = 1 } );
      ObjDelete( "spr_workshop2_ho_item" );
      ObjDelete( "spr_workshop2_close_door_ho" );
      
    end;  

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_workshop2();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_scissors2",                              { "use_boltcutter2" } );
  int.AddedTaskMap( private.room_objname, "get_cometamulet2",                           { "use_boltcutter2" }  );
  int.AddedTaskMap( private.room_objname, "get_cometamulet2",                           { "use_boltcutter2" }  );
  int.AddedTaskMap( private.room_objname, "get_crucible2" );
  int.AddedTaskMap( private.room_objname, "get_dagger2",                                { "use_blacksmithamulet2" } );
  int.AddedTaskMap( private.room_objname, "get_recipe2",                                { "use_cleaningagent2" } );
  int.AddedTaskMap( private.room_objname, "get_copperas2",                              { "use_phial2" } );
  int.AddedTaskMap( private.room_objname, "get_ring2_2",                                { "use_acid2" } );
  int.AddedTaskMap( private.room_objname, "get_mitts2" );
  int.AddedTaskMap( private.room_objname, "get_bucket2" );
  int.AddedTaskMap( private.room_objname, "get_wholekey2",                              { "clk_foundry2_handle_1" } );
  int.AddedTaskMap( private.room_objname, "get_blacksmithamulet2_1",                    { "win_foundry2" } );
  int.AddedTaskMap( private.room_objname, "get_meltedtin2",                             { "clk_foundry2_handle_2" } );
  int.AddedTaskMap( private.room_objname, "get_tweezers2" );
  int.AddedTaskMap( private.room_objname, "get_phial2",                                 { "use_snakesamulet2" } );
  int.AddedTaskMap( private.room_objname, "get_tongs2",                                 { "use_snakesamulet2" } );
  int.AddedTaskMap( private.room_objname, "get_acid2",                                  { "win_mgcreatingacid2" } );
  int.AddedTaskMap( private.room_objname, "get_blacksmithamulet2_2",                    { "use_acid2" } );

  int.AddedTaskMap( private.room_objname, "use_blacksmithamulet2",                      { "get_blacksmithamulet2_1", "get_blacksmithamulet2_2", "use_boltcutter2" } );
  int.AddedTaskMap( private.room_objname, "use_boltcutter2",                            { "get_boltcutter2" } );
  int.AddedTaskMap( private.room_objname, "use_cleaningagent2",                         { "get_cleaningagent2" } );
  int.AddedTaskMap( private.room_objname, "use_phial2",                                 { "get_phial2" } );
  int.AddedTaskMap( private.room_objname, "use_acid2",                                  { "get_acid2" } );
  int.AddedTaskMap( private.room_objname, "use_keypiece2",                              { "get_keypiece2_1", "get_keypiece2_2" } );
  int.AddedTaskMap( private.room_objname, "use_mosaicpart2",                            { "get_mosaicpart2", "get_mitts2", "get_bucket2" } );
  int.AddedTaskMap( private.room_objname, "use_crucible2",                              { "get_crucible2" } );
  int.AddedTaskMap( private.room_objname, "use_tinamulet2",                             { "win_hopast2", "use_crucible2" } );
  int.AddedTaskMap( private.room_objname, "use_recipe2",                                { "get_recipe2" } );
  int.AddedTaskMap( private.room_objname, "use_copperas2",                              { "get_copperas2" } );
  int.AddedTaskMap( private.room_objname, "use_snakesamulet2",                          { "get_snakesamulet2_1", "get_snakesamulet2_2" } );
  int.AddedTaskMap( private.room_objname, "use_vessel2",                                { "clk_vessel2", "win_hocupboard2" } );
  int.AddedTaskMap( private.room_objname, "use_mitts2",                                 { "get_mitts2" } );

  int.AddedTaskMap( private.room_objname, "clk_vessel2" );
  int.AddedTaskMap( private.room_objname, "clk_foundry2_handle_1",                      { "use_keypiece2" } );
  int.AddedTaskMap( private.room_objname, "clk_foundry2_handle_2",                      { "use_tinamulet2" } );

  int.AddedTaskMap( private.room_objname, "win_foundry2",                               { "use_mosaicpart2" } );
  int.AddedTaskMap( private.room_objname, "win_mgcreatingacid2",                        { "use_recipe2", "use_copperas2", "use_vessel2" } );
  int.AddedTaskMap( private.room_objname, "win_hocupboard2",                            { "use_mitts2" } );

  int.AddedTaskMap( private.room_objname, "dlg_workshop2_richard2_4",                   { "get_ring2_2" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
  
  subroom.Define( "zz_chest2" );
  subroom.Define( "zz_worktable2" );
  subroom.Define( "zz_foundry2" );
  subroom.Define( "zz_chemicallab2" );
  -------------------------------------------------
  function zz_chemicallab2.Close()

    if ( cmn.IsEventDone( "use_recipe2" ) ) then

      cmn.NoteScaleEnd( { "spr_chemicallab2_recipe" }, true );

    end;

  end;
  -----------------------------------------------
  function zz_worktable2.Close ()

    cmn.NoteScaleEnd( { "spr_worktable2_note2", "spr_worktable2_diary" }, true );

  end;
  -------------------------------------------------
  -------------------------------------------------
  function zz_chest2.PreOpen ()

     if cmn.IsEventDone( "use_blacksmithamulet2" ) and not
       cmn.IsEventDone( "get_dagger2" ) then
       int_button_mini_ho.Show( "get_dagger2", "chest2", 4, "spr_chest2_dagger_panel", private.mini_ho_array ); 
     end;       
       
  end;  
  -------------------------------------------------
  function zz_chest2.PreClose()

    if cmn.IsEventDone( "use_blacksmithamulet2" ) and not
        cmn.IsEventDone( "get_dagger2" ) then
      int_button_mini_ho.Hide(); 
    end;        
       
  end; 
 -------------------------------------------------
  -------------------------------------------------
  function zz_foundry2.Open()
    
    if ( cmn.IsEventStart( "win_foundry2" ) and not cmn.IsEventDone( "win_foundry2" ) ) then

      cmn.MiniGameShow( "foundry2" );
      common_impl.PassingMgStart( "foundry2" );

    end;

  end;
  -------------------------------------------------
  function zz_foundry2.PreClose()
        
    if ( cmn.IsEventStart( "win_foundry2" ) and not cmn.IsEventDone( "win_foundry2" ) ) then

      cmn.MiniGameHide( "foundry2" );
      common_impl.PassingMgStop( "foundry2" );

    end;
    
  end;
  -------------------------------------------------
  function zz_foundry2.Skip ()

    if ( cmn.IsEventStart( "win_foundry2" ) and not cmn.IsEventDone( "win_foundry2" ) ) then
      private.Foundry2Skip();
    end;

  end;
  -------------------------------------------------
  function zz_foundry2.Reset ()

    if ( cmn.IsEventStart( "win_foundry2" ) and not cmn.IsEventDone( "win_foundry2" ) ) then
      private.Foundry2Reset();
    end;

  end;
  -------------------------------------------------


end;
--*********************************************************************************************************************
function private.InitMiniHO ()
  
  private.mini_ho_array = { 
                            "spr_chest2_ho_1", 
                            "spr_chest2_ho_2", 
                            "spr_chest2_ho_3", 
                            "spr_chest2_ho_4", 
                          };

  for i = 1, #private.mini_ho_array do

    ObjSet( private.mini_ho_array[ i ], { 
                    event_mdown = function() 
                                    int_button_mini_ho.MiniHoTaskFind( "get_dagger2", "chest2", private.mini_ho_array[ i ], 4, "", nil, true );
                                  end,
                    event_menter = function () cmn.SetCursor( CURSOR_GET );  end,
                    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end  } );

  end;
      
end;  
--*********************************************************************************************************************
function private.InitAnimations ()
  
  ObjAnimate( "spr_worktable2_light_ring", "alp", 1, 0, "", 
  { 
    0.0, 3, 1.0,
    1.5, 3, 0,
    3.0, 3, 1,
  } );
  
end;
--*********************************************************************************************************************
function private.Chest2ChainClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_chest2_use_boltcutter2" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_chest_chain" );
  AnimPlay( "anm_chest2_chain_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Chest2CapClick ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_chest2_use_blacksmithamulet2" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_xx_box_inside_chest" );
  AnimPlay( "anm_chest2_cap_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Worktable2CapClk ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_worktable2_use_acid2" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_locked_cell_inside_table" );
  AnimPlay( "anm_worktable2_clk_cap", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Worktable2DiaryClick ()

--  int.Lock( true );
--
--  local func_end = function ()
--
--    int.Lock( false );
--    --cmn.ShowBbt( "bbt_worktable2_use_acid2" );
--
--  end;

  ObjSet( "obj_worktable2_diary_page_"..private.worktable2_page_diary, { alp = 0 } );
  private.worktable2_page_diary = private.worktable2_page_diary + 1;
  
  if (private.worktable2_page_diary > 8) then
    private.worktable2_page_diary = 1;
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_worktable2_close_book" );
  else
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_zz_worktable2_click_book" );
  end;
  
  ObjSet( "obj_worktable2_diary_page_"..private.worktable2_page_diary, { alp = 1 } );  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Foundry2 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Foundry2StartInit ()

    cmn.MiniGameShow( "foundry2" );
    common_impl.PassingMgStart( "foundry2" );
    
    ng_global.progress[ "std" ][ "win_foundry2" ].part = { {}, {}, {}, {}, {}, {} };
    
    for i = 1, 6 do
      for j = 1, 2 do
        ng_global.progress[ "std" ][ "win_foundry2" ].part[ i ][ j ] = private.part[ i ][ j ];
      end; 
    end; 

  end;
--*********************************************************************************************************************
  function private.Foundry2Load ()
    
    for return_rhombus = 1, 6 do
     
      for i = 1, 2 do
        
        local part = ng_global.progress[ "std" ][ "win_foundry2" ].part[ return_rhombus ][ i ];
        
        if part ~= 0 then
          ObjAttach( "spr_foundry2_"..part, "obj_foundry2_"..return_rhombus.."_"..i );
        end;
        
      end;  
      
    end;
    
  end;
--*********************************************************************************************************************
  function private.Foundry2Skip ()

    int.Lock( true );
    for return_rhombus = 1, 6 do
     
      for i = 1, 2 do
        
        local part = private.win1[ return_rhombus ][ i ];
        
        if part ~= 0 then
          ObjAttach( "spr_foundry2_"..part, "obj_foundry2_"..return_rhombus.."_"..i );
        end;
        
      end;  
      
    end;
    
    private.Foundry2Win();
    
  end
--*********************************************************************************************************************
  function private.Foundry2Reset ()
    
    for i = 1, 6 do
      for j = 1, 2 do
        ng_global.progress[ "std" ][ "win_foundry2" ].part[ i ][ j ] = private.part[ i ][ j ];
      end; 
    end;  

    for return_rhombus = 1, 6 do
     
      for i = 1, 2 do
        
        local part = ng_global.progress[ "std" ][ "win_foundry2" ].part[ return_rhombus ][ i ];
        
        if part ~= 0 then
          ObjAttach( "spr_foundry2_"..part, "obj_foundry2_"..return_rhombus.."_"..i );
        end;
        
      end;  
      
    end;
    
  end;  
--*********************************************************************************************************************
  function private.Foundry2Init ()
      
    for i = 1, 6 do
      
      ObjSet( "spr_foundry2_button"..i,
      {
        event_mdown  = function () private.Foundry2Clk( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );
        
    end; 
                     
    private.link = {
                     { { 2, 2 } },--какой куб связан с каким кубом и какой связью
                     { { 1, 1 }, { 3, 2 } },
                     { { 2, 1 }, { 4, 2 } }, 
                     { { 3, 1 } }
                   };
                   
    private.link = {
                     { { 6, 1 }, { 2, 2 } },--какой куб связан с каким кубом и какой связью
                     { { 1, 1 }, { 3, 2 } },
                     { { 2, 1 }, { 4, 2 } }, 
                     { { 3, 1 }, { 5, 2 } },
                     { { 4, 1 }, { 6, 2 } },
                     { { 5, 1 }, { 1, 2 } }, 
                   };
                   
                    
    private.win = {
                    { 3, 2 }, { 2, 7 }, { 7, 8 }, { 8, 9 }, { 9, 4 }, { 4, 3 }
                  };
                  
    private.part = { { 3, 2 }, { 0, 7 }, { 0, 8 }, { 0, 9 }, { 0, 0 }, { 4, 0 } };
    
    private.win1 = { { 3, 2 }, { 0, 7 }, { 0, 8 }, { 0, 9 }, { 0, 0 }, { 4, 0 } };
     
    private.Foundry2PrimarySet( 1 );
    private.Foundry2PrimarySet( 2 );
    private.Foundry2PrimarySet( 3 );
    private.Foundry2PrimarySet( 4 );
    private.Foundry2PrimarySet( 5 );
    private.Foundry2PrimarySet( 6 );
                
  end;
--*********************************************************************************************************************
  function private.Foundry2PrimarySet ( return_rhombus )
    
    ------------------------------------создание временных массивов
    tmp_part = { {}, {}, {}, {}, {}, {} };
    for i = 1, 6 do
      for j = 1, 2 do
        tmp_part[ i ][ j ] = private.part[ i ][ j ];
      end; 
    end;  
    ------------------------------------
    local part1 = tmp_part[ return_rhombus ][ 1 ];
    local part2 = tmp_part[ return_rhombus ][ 2 ]; 
    
    for i = 1, 2 do
      if tmp_part[ return_rhombus ][ i ] == 0 then
        for j = 1, #private.link[ return_rhombus ] do
          if private.link[ return_rhombus ][ j ][ 2 ] == i then--какой связью текущий ромб связан с другим ромбом
            local link_rhombus = private.link[ return_rhombus ][ j ][ 1 ];--номер связанного ромба
            local cur_link = i;--номер нулевой связи текущего ромба 
              
            for k = 1, #private.link[ link_rhombus ] do
              if private.link[ link_rhombus ][ k ][ 1 ] == return_rhombus then--если связанный ромб соединен с текущим
                local link = private.link[ link_rhombus ][ k ][ 2 ];--какой связью связанный ромб соединен с текущим ромбом
                local part_number = tmp_part[ link_rhombus ][ link ];--номер детали, которую отсоединяем от связанного ромба
                tmp_part[ link_rhombus ][ link ] = 0;--помечаем, что эта связь стала нулевой 
                if tmp_part[ return_rhombus ][ 1 ] == 0 then
                  part1 = part_number;
                  tmp_part[ return_rhombus ][ 1 ] = part_number;--помечаем, что к текущему ромбу присоединяем деталь
                else
                  part2 = part_number;
                  tmp_part[ return_rhombus ][ 2 ] = part_number;  
                end;
              end;  
            end;
            
          end;  
        end;  
      end;
    end;  
        
    ObjAttach( "spr_foundry2_"..part1, "obj_foundry2_"..return_rhombus.."_2" );
    ObjAttach( "spr_foundry2_"..part2, "obj_foundry2_"..return_rhombus.."_1" );

    tmp_part[ return_rhombus ][ 1 ] = part2;
    tmp_part[ return_rhombus ][ 2 ] = part1;

    ------------------------------------запись значений
    for i = 1, 6 do
      for j = 1, 2 do
        private.part[ i ][ j ] = tmp_part[ i ][ j ];
      end; 
    end;  
    ------------------------------------
    
  end;  
--*********************************************************************************************************************
  function private.Foundry2Clk ( return_rhombus )
    
    ------------------------------------создание временных массивов
    tmp_part = { {}, {}, {}, {}, {}, {} };
    for i = 1, 6 do
      for j = 1, 2 do
        tmp_part[ i ][ j ] = ng_global.progress[ "std" ][ "win_foundry2" ].part[ i ][ j ];
      end; 
    end;  
    ------------------------------------
    local part1 = tmp_part[ return_rhombus ][ 1 ];
    local part2 = tmp_part[ return_rhombus ][ 2 ]; 
    
    for i = 1, 2 do
      if tmp_part[ return_rhombus ][ i ] == 0 then
        for j = 1, #private.link[ return_rhombus ] do
          if private.link[ return_rhombus ][ j ][ 2 ] == i then--какой связью текущий ромб связан с другим ромбом
            local link_rhombus = private.link[ return_rhombus ][ j ][ 1 ];--номер связанного ромба
            local cur_link = i;--номер нулевой связи текущего ромба 
              
            for k = 1, #private.link[ link_rhombus ] do
              if private.link[ link_rhombus ][ k ][ 1 ] == return_rhombus then--если связанный ромб соединен с текущим
                local link = private.link[ link_rhombus ][ k ][ 2 ];--какой связью связанный ромб соединен с текущим ромбом
                local part_number = tmp_part[ link_rhombus ][ link ];--номер детали, которую отсоединяем от связанного ромба
                tmp_part[ link_rhombus ][ link ] = 0;--помечаем, что эта связь стала нулевой 
                if tmp_part[ return_rhombus ][ 1 ] == 0 then
                  part1 = part_number;
                  tmp_part[ return_rhombus ][ 1 ] = part_number;--помечаем, что к текущему ромбу присоединяем деталь
                else
                  part2 = part_number;
                  tmp_part[ return_rhombus ][ 2 ] = part_number;  
                end;
              end;  
            end;
            
          end;  
        end;  
      end;
    end;  
    
    ObjAttach( "spr_foundry2_"..part1, "obj_foundry2_"..return_rhombus.."_1" );
    ObjAttach( "spr_foundry2_"..part2, "obj_foundry2_"..return_rhombus.."_2" );
    ObjAttach( "obj_foundry2_rhombus"..return_rhombus, "obj_foundry2_up" );
    
    local func_end = function ()
    
      ObjSet( "obj_foundry2_rhombus"..return_rhombus, { ang = 0 } );
      ObjAttach( "spr_foundry2_"..part1, "obj_foundry2_"..return_rhombus.."_2" );
      ObjAttach( "spr_foundry2_"..part2, "obj_foundry2_"..return_rhombus.."_1" );
      ObjAttach( "obj_foundry2_rhombus"..return_rhombus, "obj_foundry2_rhombuses" );
      tmp_part[ return_rhombus ][ 1 ] = part2;
      tmp_part[ return_rhombus ][ 2 ] = part1;
      
      flag = true;
      ---------------------------------------------------------------------------проверка на выигрыш    
      for i = 1, 6 do
        for j = 1, 2 do
          if tmp_part[ i ][ j ] ~= private.win[ i ][ j ] then

            if j == 1 then
              if i == 1 then
                if ( tmp_part[ 1 ][ 1 ] ~= private.win[ 1 ][ 1 ] ) and tmp_part[ 6 ][ 2 ] == 0 then
                  flag = false;
                end; 
              else 
                if ( tmp_part[ i - 1 ][ 2 ] ~= private.win[ i - 1 ][ 2 ] ) and tmp_part[ i ][ 1 ] == 0 then
                  flag = false;
                end;  
              end;
            else 
              if i == 6 then
                if ( tmp_part[ 6 ][ 2 ] ~= private.win[ 6 ][ 2 ] ) and tmp_part[ 1 ][ 1 ] == 0 then
                  flag = false;
                end; 
              else
                if ( tmp_part[ i + 1 ][ 1 ] ~= private.win[ i + 1 ][ 1 ] ) and tmp_part[ i ][ 2 ] == 0 then
                  flag = false;      
                end;  
              end; 
            end; 
            
          end;  
        end; 
      end; 
      ---------------------------------------------------------------------------
      if flag then
        private.Foundry2Win();
      else
        ------------------------------------запись значений
        for i = 1, 6 do
          for j = 1, 2 do
            ng_global.progress[ "std" ][ "win_foundry2" ].part[ i ][ j ] = tmp_part[ i ][ j ];
          end; 
        end;  
        ------------------------------------
        int.Lock( false );  
      end;

    end;
    
    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_cube_click" );
    ObjAnimate( "obj_foundry2_rhombus"..return_rhombus, "ang", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.8, 0, -3.14,
    } );
    
  end;
--*********************************************************************************************************************
  function private.Foundry2Win () 
    
    local func_end = function ()
      
      local func_end1 = function ()
        
        cmn.MiniGameHide( "foundry2" );
        cmn.SetEventDone( "win_foundry2" );
        cmn.CallEventHandler( "win_foundry2" );
        common_impl.PassingMgWin( "foundry2" );
        int.Lock( false );
        
      end;

      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_cube_win" );
      AnimPlay( "anm_foundry2_open_box", "DoAnim", func_end1 );
      
    end;
    
    ObjSet( "anm_foundry2_use_mosaicpart", { alp = 0 } );
    ObjSet( "anm_foundry2_open_box", { alp = 1 } );
    
    ObjAnimate( "obj_foundry2_mmg", "scale_xy", 0, 0, "",
    {
      0.0, 3, 1, 1,
      0.9, 3, 1, 1,
      1.4, 3, 0, 0
    } );
    ObjAnimate( "obj_foundry2_mmg", "pos_xy", 0, 0, func_end,
    {
      0.0, 3, -64, 13,
      0.9, 3, -64, 13,
      1.4, 3, 150, 35,
      1.7, 3, 150, 35
    } );

  end;
 --*********************************************************************************************************************