-- name=mg_mgcrowd3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgcrowd3";
  game.relations[ "mg_mgcrowd3" ].exitroom = "rm_lab3";

  private.Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgcrowd3 = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgcrowd3", update_game_mode_mgcrowd3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_mgcrowd3 () end;
  --------------------------------------------------------------------------------------------
  local opn_mgcrowd3 = function ()

  end;

  cmn.AddSubscriber( "opn_mgcrowd3", opn_mgcrowd3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgcrowd3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgcrowd3" ] =
  {
    type = "click",
    get_obj = "spr_mgcrowd3_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgcrowd3 = function ()

    if ( cmn.IsEventDone( "win_mgcrowd3" ) ) then

      --int.DeleteTaskMap( "rm_", "win_mgcrowd3" );
      ObjDelete( "obj_mgcrowd3_buttons" );

    elseif ( cmn.IsEventStart( "win_mgcrowd3" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgcrowd3", win_mgcrowd3, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mgcrowd3" ) ) then

    private.Start();

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if not ( cmn.IsEventDone( "opn_mgcrowd3" ) ) then

    cmn.SetEventDone( "opn_mgcrowd3" );
    cmn.CallEventHandler( "opn_mgcrowd3" );

  end;

  if ( not cmn.IsEventDone( "win_mgcrowd3" ) ) then

    cmn.MiniGameShow( "mgcrowd3" );
    common_impl.PassingMgStart( "mgcrowd3" );

  end;

  if ( not private.is_start_timers ) then

    private.StartTimer();
    private.is_start_timers = true;

  end;

  cmn.StopAllMus();
  common_impl.StopMusEnv( false );
  cmn.StopAllEnv( "audio/level3/env/aud_rm_lab3_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_lab3_env", 1, 1 );  

  cmn.PlayAudio( "mus", "audio/level1/mus/aud_action_fight_1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "mgcrowd3" );

  cmn.StopAudio( "mus", "audio/level1/mus/aud_action_fight_1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()
  
  common_impl.PlayMusEnv();    
  
end;
--*********************************************************************************************************************
function public.Reset ()

  private.is_win = false;
  private.enemy = 10;
  private.health = 5;
  ng_global.progress[ private.currentprogress ][ "win_mgcrowd3" ].enemy  = 10;
  ng_global.progress[ private.currentprogress ][ "win_mgcrowd3" ].health = 5;

  private.UpdateHealth( private.health );
  private.UpdateEnemy( private.enemy );

  for t = 1, private.enemy_count do

    ObjSet( "obj_mgcrowd3_button_"..t,            { input = false } );
    ObjSet( "anm_mgcrowd3_enemy_"..t.."_static",  { alp = 0, frame = 0 } );
    ObjSet( "anm_mgcrowd3_enemy_"..t.."_attack",  { alp = 0, frame = 0 } );
    ObjSet( "anm_mgcrowd3_hero_attack_"..t,       { alp = 0, frame = 0 } );
    ObjSet( "tmr_mgcrowd3_enemy_"..t,             { playing = false } );
    ObjDelete( "tmr_mgcrowd3_enemy_"..t );
    AnimStop( "anm_mgcrowd3_enemy_"..t.."_static" );
    AnimStop( "anm_mgcrowd3_enemy_"..t.."_attack" );
    AnimStop( "anm_mgcrowd3_hero_attack_"..t );

  end;

  ObjSet( "anm_mgcrowd3_loose", { alp = 0, frame = 0 } );
  AnimStop( "anm_mgcrowd3_loose" );

  private.StartTimer();

end;
--*********************************************************************************************************************
function public.Skip ()

  private.WinAnim();

end;
--*********************************************************************************************************************
function private.Init ()

  private.enemy = 10;
  private.health = 5;
  private.enemy_count = 7;
  private.tme_attack = 3.0;
  private.tme_min = 200;
  private.tme_max = 1500;
  private.is_start_timers = false;
  private.is_win = false;

  for c = 1, private.enemy_count do

    ObjSet( "obj_mgcrowd3_button_"..c,
    {
      event_mdown  = function () private.EnemyClick( c ) end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgcrowd3" ].enemy  = 10;
  ng_global.progress[ private.currentprogress ][ "win_mgcrowd3" ].health = 5;

end;
--*********************************************************************************************************************
function private.Load ()

  private.enemy = ng_global.progress[ private.currentprogress ][ "win_mgcrowd3" ].enemy;
  private.health = ng_global.progress[ private.currentprogress ][ "win_mgcrowd3" ].health;

  private.UpdateHealth( private.health );
  private.UpdateEnemy( private.enemy );

end;
--*********************************************************************************************************************
function private.WinAnim()

  private.is_win = true;

  for t = 1, private.enemy_count do

    ObjSet( "tmr_mgcrowd3_enemy_"..t,  { playing = false } );
    ObjDelete( "tmr_mgcrowd3_enemy_"..t );
    ObjSet( "obj_mgcrowd3_enemy_"..t, { alp = 0, active = false } );

  end;

  int.Lock( true );

  local func_end = function ()

    private.Win();
    int.Lock( false );

  end;

  ObjSet( "anm_mgcrowd3_win", { alp = 1 } );
  AnimPlay( "anm_mgcrowd3_win", "DoAnim", func_end );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgcroud3_win" );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgcrowd3" );
  cmn.CallEventHandler( "win_mgcrowd3" );
  common_impl.PassingMgWin( "mgcrowd3" );
  cmn.GotoRoom( "rm_lab3" );

end;
--*********************************************************************************************************************
function private.EnemyAttack ( idx, rnd )

  if ( private.is_win ) then

    return;

  end;

  ObjSet( "obj_mgcrowd3_button_"..idx, { input = false } );
  ObjSet( "anm_mgcrowd3_enemy_"..idx.."_static", { alp = 0, frame = 0 } );

  local name = "anm_mgcrowd3_enemy_"..idx.."_attack";
  local func = idx..rnd.."_enemy_attack";

  local func_end = function ()

    if ( private.is_win ) then

      return;

    end;

    ObjSet( name, { alp = 0, frame = 0 } );

    private.health = private.health - 1;
    private.UpdateHealth( private.health );

    if ( private.health <= 0 ) then

      for t = 1, private.enemy_count do

        ObjSet( "tmr_mgcrowd3_enemy_"..t,  { playing = false } );

      end;

      int.Lock( true );

      ObjSet( "anm_mgcrowd3_loose", { alp = 1 } );
      AnimPlay( "anm_mgcrowd3_loose", "DoAnim",
      function ()

        int.Lock( false );
        public.Reset();

      end );

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgcroud3_we_die" );

    else

      ng_global.progress[ private.currentprogress ][ "win_mgcrowd3" ].health = private.health;
      --private.EnemyHide( idx );
      private.StartTimer( idx );

    end;

  end;

  ObjSet( name, { alp = 1 } );
  AnimPlay( name, func, "" );

  ObjSet( "tmr_mgcrowd3_enemy_"..idx,
  {
    time = 1.6,
    playing = true,
    endtrig = func_end
  } );

  local rnd = math.random( 1,3 );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgcroud3_enemy_throws_us_"..rnd );

end;
--*********************************************************************************************************************
function private.EnemyShow ( idx )

  local rnd  = math.random( 1,2 );
  local name = "anm_mgcrowd3_enemy_"..idx.."_static";
  local func = idx..rnd.."_enemy_static";

  local func_end = function ()

    --ObjSet( name, { alp = 0, frame = 0 } );
    --ObjSet( "obj_mgcrowd3_button_"..idx, { input = true } );
    --private.EnemyAttack( idx, rnd );

  end;

  ObjSet( "obj_mgcrowd3_button_"..idx, { input = true } );

  ObjSet( name, { alp = 1 } );
  AnimPlay( name, func, func_end );

  ObjSet( "tmr_mgcrowd3_enemy_"..idx,
  {
    time = private.tme_attack,
    playing = true,
    endtrig = function ()

      private.EnemyAttack( idx, rnd );

    end
  } );

  local rnd = math.random( 1,3 );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgcroud3_enemy_appears_"..rnd );

end;
--*********************************************************************************************************************
--function private.EnemyHide ( idx )
--
--  local func_end = function ()
--
--    private.StartTimer( idx );
--
--  end;
--
--  local name = "spr_mgcrowd3_enemy_"..idx;
--
--  ObjAnimate( name, "alp", 0, 0, func_end,
--  {
--    0.0, 3, 1.0,
--    0.2, 3, 0.0,
--  } );
--
--end;
--*********************************************************************************************************************
function private.EnemyClick ( idx )

  local name = "anm_mgcrowd3_hero_attack_"..idx;

  local func_anim_end = function ()

    ObjSet( name, { alp = 0, frame = 0 } );

  end;

  local func_end = function ()

    if ( private.is_win ) then

      return;

    end;

    private.enemy = private.enemy - 1;
    private.UpdateEnemy( private.enemy );

    if ( private.enemy <= 0 ) then

      private.WinAnim();

    else

      ng_global.progress[ private.currentprogress ][ "win_mgcrowd3" ].enemy = private.enemy;
      --private.EnemyHide( idx );
      private.StartTimer( idx );

    end;

  end;

  ObjSet( "obj_mgcrowd3_button_"..idx, { input = false } );
  ObjSet( "tmr_mgcrowd3_enemy_"..idx, { playing = false } );

  --AnimStop( "anm_mgcrowd3_enemy_"..idx.."_static" );
  --ObjSet( "anm_mgcrowd3_enemy_"..idx.."_static", { playing = false } );

  local func = "Shoot"..idx.."_hit";

  ObjSet( name, { alp = 1 } );
  AnimPlay( name, func, func_anim_end );

  ObjAnimate( "anm_mgcrowd3_enemy_"..idx.."_static", "alp", 0, 0, func_end,
  {
    0.0, 3, 1.0,
    1.0, 3, 1.0,
    1.0, 3, 0.0,
    1.5, 3, 0.0,
  } );

  local rnd = math.random( 1,3 );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgcroud3_we_throw_enemy_"..rnd );

end;
--*********************************************************************************************************************
function private.StartTimer ( idx )

  if ( idx ) then

    local tme = math.random( private.tme_min, private.tme_max ) / 100;

    ObjSet( "tmr_mgcrowd3_enemy_"..idx,
    {
      time = tme,
      playing = true,
      endtrig = function ()

        private.EnemyShow( idx );

      end
    } );

    return;

  end;

  for t = 1, private.enemy_count do

    ObjCreate( "tmr_mgcrowd3_enemy_"..t, "timer" );
    ObjAttach( "tmr_mgcrowd3_enemy_"..t, "obj_mgcrowd3_timers" );

    local tme = math.random( private.tme_min, private.tme_max ) / 100;

    ObjSet( "tmr_mgcrowd3_enemy_"..t,
    {
      time = tme,
      playing = true,
      endtrig = function ()

        private.EnemyShow( t );

      end
    } );

  end;

end;
--*********************************************************************************************************************
function private.UpdateHealth ( count )

  if ( count < 0 ) then

    count = 0;

  end;

  ObjSet( "txt_mgcrowd3_icon_health", { text = tostring( count ) } );

end;
--*********************************************************************************************************************
function private.UpdateEnemy ( count )

  if ( count < 0 ) then

    count = 0;

  end;

  ObjSet( "txt_mgcrowd3_icon_enemy", { text = tostring( count ) } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************