-- name=level3
--*********************************************************************************************************************
function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );
  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );
  int.WidgetAdd( InterfaceWidget_BtnHint, 9 );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );
  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );
  int.WidgetAdd( InterfaceWidget_Effects, 24 );
  int.WidgetAdd( InterfaceWidget_BtnMap, 11 );
  int.WidgetAdd( InterfaceWidget_DialogHo );
  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );
  int.WidgetAdd( InterfaceWidget_Popup, 31 );
  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog, 22 );
  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );
  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );
  int.WidgetAdd( InterfaceWidget_Tutorial, 25 );
  int.WidgetAdd( InterfaceWidget_Map, 24 );

  int.ButtonLockAdd();
  int.PanelNotificationAdd();
  int.DeployInvAdd( 9 );
  int.DialogHintAdd( 10 );

  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 );
  --int.InitLoupe( 20 );

  --
  private.Init();
  ModLoad( "assets/levels/level3/mod_level3_inv" );
  level3_inv.Init();
  --

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.WidgetAdd( InterfaceWidget_BtnGuide, 8 );
    interface.AchievementsAdd( 10 );
    int.MorphingAdd( 10 );
    int.CollectiblesAdd( 20 );
    int.Collectibles2Add( 22 );
    int.ScreensaverAdd( 11 ); 

  end;

  common.LevelLoad( "level3", "std", "rm_tower3", param, private.menu_moduls );

  private.TutorialSetParams();
  interface.KeyUpdate();

  local collectibles = 
  {
     "get_collect_2_1"
    ,"get_collect_2_2"
    ,"get_collect_2_3"
    ,"get_collect_3_1"
    ,"get_collect_3_2"
    ,"get_collect_3_3"
  };
  local collect_morph = 
  {
     "get_morphobject_2_1"
    ,"get_morphobject_2_2"
    ,"get_morphobject_2_3"
    ,"get_morphobject_2_5"
    ,"get_morphobject_2_6"
    ,"get_morphobject_3_1"
    ,"get_morphobject_3_2"
    ,"get_morphobject_3_3"
    ,"get_morphobject_3_4"
    ,"get_morphobject_3_5"
    ,"get_morphobject_3_6"
  };   
  local screen_s = 
  {
     "screensaver_2_13"
    ,"screensaver_2_14"
    ,"screensaver_2_15"
    ,"screensaver_2_16"
    ,"screensaver_2_17"
    ,"screensaver_2_18"
    ,"screensaver_2_19"
    ,"screensaver_2_20"
    ,"screensaver_2_21"
    ,"screensaver_2_22"
    ,"screensaver_2_23"
    ,"screensaver_2_24"      
  };   

  if ( not IsCollectorsEdition() and not IsSurveyEdition() ) then

    ObjSet( "btn_map_button_diary", { pos_x = 10 } );
    ObjSet( "btn_map_button_collectibles", { visible = 0, active = 0, input = 0  } );
    ObjSet( "btn_map_button_achievements", { visible = 0, active = 0, input = 0  } );        

    for i = 1, #collectibles do

      cmn.SetEventDone( collectibles[ i ] );
      cmn.CallEventHandler( collectibles[ i ] );

    end;
    for i = 1, #collect_morph do

      cmn.SetEventDone( collect_morph[ i ] );
      cmn.CallEventHandler( collect_morph[ i ] );

    end;
    for i = 1, #screen_s do

      cmn.SetEventDone( "get_"..screen_s[ i ] );
      cmn.CallEventHandler( "get_"..screen_s[ i ] );

    end;    

  else

    for i = 1, #collectibles do

      if ( ng_global.collect[ collectibles[ i ] ] ~= nil ) then

        if ( ng_global.collect[ collectibles[ i ] ].done == 1 ) then

          cmn.SetEventDone( "get_"..collectibles[ i ] );
          cmn.CallEventHandler( "get_"..collectibles[ i ] );

        end;

      end;

    end;
    for i = 1, #collect_morph do

      if ( ng_global.morphings[ collect_morph[ i ] ] ~= nil ) then
          if ( ng_global.morphings[ collect_morph[ i ] ].done == 1 ) then

            cmn.SetEventDone( collect_morph[ i ] );
            cmn.CallEventHandler( collect_morph[ i ] );

          end;
      end;

    end;         
    for i = 1, #screen_s do

      if ( ng_global.screensaver[ screen_s[ i ] ] ~= nil ) then
          if ( ng_global.screensaver[ screen_s[ i ] ].done == 1 ) then

            cmn.SetEventDone( "get_"..screen_s[ i ] );
            cmn.CallEventHandler( "get_"..screen_s[ i ] );

          end;
      end;

    end;     

  end;

end;
--*********************************************************************************************************************
function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_tower3"
    ,"rm_lab3"
    ,"rm_towerroof3"
    ,"rm_abigailshouse3"
    ,"rm_alley3"
    ,"rm_park3"
    ,"rm_mortuary3"
    ,"rm_neartower3"
    ,"rm_shore3"
    ,"rm_secretroom3"
    ,"rm_workshop3"
    ,"ho_hocardindex3"
    ,"mg_mgkeys3"
    ,"mg_mgfight3"
    ,"ho_horepair3"
    ,"ho_hoalchemybox3"
    ,"ho_hotreasury3"
    ,"mg_mgcrowd3"
  };

  game.progress_names =
  {
   "beg_level3"
  ,"get_jimmy3"
  ,"get_richardskull3"
  
  ,"opn_tower3"
  ,"dlg_tower3_emily_stacy3_1"
  ,"get_blacksmithfigurine3_1"
  ,"get_blacksmithfigurine3_2"
  ,"get_blacksmithfigurine3_3"
  ,"use_jimmy3_2"
  ,"get_mallet3"
  ,"get_amuletmolecule3_1"
  ,"use_blacksmithfigurine3"
  ,"get_amuletomega3_1"
  ,"get_switchhandle3"  
  ,"use_switchhandle3"
  ,"clk_switchhandle3"
  ,"get_amuletmolecule3_2"
  ,"get_torch3"  
  ,"use_amuletmolecule3"
  ,"win_labdoor3"  
  
  ,"opn_lab3"
  ,"get_coals3"  
  ,"get_amuletomega3_2"
  ,"use_amuletomega3"
  ,"get_roundnosepliers3"
  ,"get_chisel3"
  ,"use_chisel3"
  ,"use_mallet3"
  ,"get_hexagram3_2"
  
  ,"opn_neartower3"
  ,"use_jimmy3_1"
  ,"get_hexagram3_1"
  ,"use_hexagram3"
  ,"get_glasscutter3"
  ,"get_bellows3"
  ,"use_coals3"
  ,"use_bellows3"
  ,"use_torch3"
  ,"get_burningtorch3"
  ,"use_burningtorch3"

  ,"opn_abigailshouse3"
  ,"get_amuletgriffin3_1"
  ,"get_amuletcrown3"
  ,"use_jimmy3_3"
  ,"get_amuletflower3"
  ,"get_smallbox3"
  ,"use_amuletflower3"
  ,"get_pin3"--маленький ключик
  ,"get_razor3"
  ,"use_pin3"
  ,"get_codenote3"
  ,"use_amuletcrown3"
  ,"use_codenote3"
  ,"clk_portrait3_mmg"
  ,"win_portrait3"

  ,"opn_secretroom3"
  ,"get_soldierfigurine3"
  ,"use_razor3"
  ,"get_crest3_1"
  ,"use_roundnosepliers3_1"
  ,"get_crest3_2"
  ,"use_crest3"
  ,"get_feather3"--спрей
  ,"use_feather3"
  ,"get_amuletgriffin3_2"
  ,"use_amuletgriffin3"
  ,"get_opener3"
  ,"use_opener3"
  ,"get_toyboat3"
  ,"use_toyboat3"
  ,"win_irondoor3"
  ,"win_hotreasury3" --,"get_victorpapers3"
  ,"use_victorpapers3"
  ,"clk_carriage3_door" -- ????
  ,"get_mermaidstatue3"   
  
  ,"opn_park3"  
  ,"dlg_park3_richard3_1"
  ,"get_spellabsorbent3"  
  ,"get_gear3_1"
  ,"get_amuletshamrock3"
  ,"use_spellabsorbent3_1"
  ,"get_statuehead3"
  ,"get_amuletchimera3_1"--амулет лев_1  
  ,"use_mermaidstatue3"
  ,"get_amulettree3"
  ,"use_amulettree3"
  ,"get_cane3"
  ,"use_cane3"
  ,"get_abovedoorsign3"
  ,"use_glasscutter3"
  ,"get_amuletsnake3"
  ,"use_amuletsnake3"
  ,"get_statuehand3"
  ,"use_statuehand3"
  ,"use_statuehead3"
  ,"get_amuletchimera3_2"--амулет лев_2
  ,"use_amuletchimera3"--амулеты льва
  ,"get_bunchofkeys3"
  ,"use_bunchofkeys3"
  ,"opn_mgkeys3"
  ,"win_mgkeys3"
  
  ,"opn_mortuary3"  
  ,"get_lever3"
  ,"use_spellabsorbent3_2"
  ,"get_spirit3"
  ,"use_amuletshamrock3"
  ,"get_gear3_2"
  ,"use_lever3"
  ,"get_scalpel3"
  ,"use_spirit3"
  ,"get_amulethydra3_1"
  ,"use_scalpel3_1"
  ,"get_amuletlapwing3"
  ,"get_amulethydra3_2"
  ,"use_amuletlapwing3"
  ,"get_gear3_3"
  ,"get_probe3"
  ,"use_probe3"
  ,"get_amulethydra3_3"
  ,"use_amulethydra3"
  ,"win_hocardindex3" --,"get_card3"
  ,"use_gear3"
  ,"use_card3" -- vid_carriage after that 
  ,"dlg_tower3_emily3_1"
  ,"get_amuletrainbow3"
  
  ,"opn_towerroof3"  
  ,"get_amuletangel3_1"  
  ,"use_soldierfigurine3"
  ,"get_bullet3"
  ,"use_scalpel3_2"
  ,"get_lace3"
  ,"get_propellentcharge3"
  ,"use_propellentcharge3"
  ,"get_bluecylinder3"
  ,"get_amuletgorgon3"
  ,"use_amuletgorgon3"
  ,"get_crystal3"
  ,"use_roundnosepliers3_2"
  ,"get_amulethypercube3"
  ,"use_amulethypercube3"
  ,"get_disassembledlamp3"
  ,"get_magnetizedhorseshoe3"
  ,"use_lace3"
  ,"get_magnetonlace3"
  ,"use_magnetonlace3"
  ,"win_windowopening3"
  ,"use_butterflypart3_1"
  ,"use_butterflypart3_2"
  ,"use_butterflypart3_3"
  ,"get_amuletbutterfly3"
  ,"use_amuletbutterfly3"
  ,"get_reagents3"
  ,"get_icarusfigurine3"
  ,"use_icarusfigurine3"  
  ,"get_battery3"  
  ,"get_disassembledgun3"
  ,"use_battery3"
  ,"get_capsule3"
  ,"use_amuletrainbow3"
  ,"get_gasoline3"  
  ,"use_gasoline3"
  ,"get_blowtorch3"  
  ,"use_blowtorch3"
  ,"win_horepair3" --,"get_fuses3"
  ,"use_fuses3"
  ,"win_generator3"
  ,"clk_generator3_lever" -- vid_crowd after that
  ,"dlg_towerroof3_emily3_2"
  ,"get_vitruvianamulet3"  
  ,"use_vitruvianamulet3"
  ,"get_flintlock3"
  ,"get_amuletaxes3"    
  ,"use_amuletaxes3"
  ,"get_gunpowder3"
  ,"get_wrench3"
  ,"use_wrench3"
  ,"get_chemicals3"
  ,"use_bluecylinder3"
  ,"use_chemicals3"
  ,"use_reagents3"
  ,"clk_autoclave3_button"
  ,"get_gasbombs3"
  ,"use_gasbombs3"
  ,"win_mgcrowd3"
  --,"dlg_lab3_emily3_3"
  ,"see_amuletangel3_2"
  ,"get_amuletangel3_2"
  ,"use_amuletangel3"
  ,"win_hoalchemybox3" --,"get_essence3"  
  
  ,"clk_disassembledgun3"
  ,"use_gunpowder3"
  ,"use_bullet3"
  ,"use_flintlock3"
  ,"get_chargedgun3"
  ,"use_chargedgun3"
  ,"get_facetedglass3"

  ,"use_facetedglass3"
  ,"use_essence3"
  ,"use_crystal3"
  ,"win_revitalizer3"
  ,"win_mgfight3"
  

  ,"opn_hoalchemybox3"
  ,"opn_hocardindex3"
  ,"opn_horepair3"
  ,"opn_hotreasury3"
  ,"opn_mgcrowd3"
  ,"opn_mgfight3"
  ,"opn_alley3"

  ,"opn_shore3"
  ,"opn_workshop3"

  ,"get_morphobject_2_1"
  ,"get_morphobject_2_2"
  ,"get_morphobject_2_3"
  ,"get_morphobject_2_5"
  ,"get_morphobject_2_6"
  ,"get_morphobject_3_1"
  ,"get_morphobject_3_2"
  ,"get_morphobject_3_3"
  ,"get_morphobject_3_4"
  ,"get_morphobject_3_5"
  ,"get_morphobject_3_6"

  ,"get_collect_2_1"
  ,"get_collect_2_2"
  ,"get_collect_2_3"
  ,"get_collect_3_1"
  ,"get_collect_3_2"
  ,"get_collect_3_3"
  
  ,"get_screensaver_2_13"    
  ,"get_screensaver_2_14"
  ,"get_screensaver_2_15"
  ,"get_screensaver_2_16"
  ,"get_screensaver_2_17"
  ,"get_screensaver_2_18"
  ,"get_screensaver_2_19"
  ,"get_screensaver_2_20"
  ,"get_screensaver_2_21"
  ,"get_screensaver_2_22"
  ,"get_screensaver_2_23"
  ,"get_screensaver_2_24"   
  };

  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {

      "rm_collectibles",
      "rm_achievements",
    };

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TutorialSetParams()

  if not ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ] then

    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ] = {};
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].start = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state = {};
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.no = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.currentpage = "tutorial_start";
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].func = function() end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );

    end;

    ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_start" ]  = { shown = 0, noskip = true,  posx = 512, posy = 384, input = true,  arrows = {} },       -- Показать туториал?

      [ "tutorial_page_1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 840, pos_y = 500, ang = 3.14 }
                                                                            } },                                        -- Открытие ЗЗ
      [ "tutorial_page_2" ]  = { shown = 0, noskip = false, posx = 512, posy = 170, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "spr_bushes1_ladybag1" }
                                                                            } },                                        -- Подбор предмета
      [ "tutorial_page_3" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "spr_int_inventory" }
                                                                              --{ pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_ladybag" }
                                                                            } },                                        -- Инвентарь, cложный инвентарный
      [ "tutorial_page_4" ]  = { shown = 0, noskip = false, posx = 512, posy = 150, input = false, arrows = {
                                                                              --{ pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_ladybag" }
                                                                            } },                                        -- Сложный инвентарный
      [ "tutorial_page_5" ]  = { shown = 0, noskip = false, posx = 512, posy = 150, input = false, arrows = {
                                                                              { pos_x = 20, pos_y = -80, ang = 3.14, target = "gzz_greywitchgates1_van1" },
                                                                              { pos_x = -80, pos_y = 30, ang = -1.57, target = "gzz_greywitchgates1_gates1" }
                                                                            } },                                        -- Подбор предметов
      [ "tutorial_page_6" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_ladybag1" },
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_bagamulet1" },
                                                                            } },                                        -- применение предмета
      [ "tutorial_page_6_1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_bagamulet1" },
                                                                            } },                                        -- применение предмета                                                                            
      [ "tutorial_page_7" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 60, pos_y = 0, ang = 1.57, target = "gho_greywitchgates1_hovan1" },
                                                                            } },                                        -- переход в ХО
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 400, posy = 200, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = 80, ang = 0.00, target = "grm_greywitchgates1_ruinedsquare1" }
                                                                            } },                                        -- Переход в локацию
      [ "tutorial_ho1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО с войсами
      [ "tutorial_ho2" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО обычное
      [ "tutorial_ho3" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО с силуэтами
      [ "tutorial_ho4" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО парами
      [ "tutorial_minigame" ]  = { shown = 0, noskip = false, posx = 512, posy = 330, input = false, arrows = { 
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_info" },
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_reset" },
                                                                              { pos_x = 100, pos_y = -50, ang = -4,     target = "int_button_skip_impl" }
                                                                            } },                                        -- Кнопка Инфо в МГ
      [ "tutorial_map_1" ] = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = -60, pos_y = -100, ang = 3.925, target = "int_button_map_impl" }
                                                                            } },                                        -- Карта
      [ "tutorial_map_2" ] = { shown = 0, noskip = false, posx = 600, posy = 200, input = false, arrows = {
                                                                              { pos_x = 300, pos_y = 320, ang = 2.355 }
                                                                            } },                                        -- Переход в локацию по карте
      [ "tutorial_achievements" ] = { shown = 0, noskip = false, posx = 512, posy = 280, input = false, arrows = {
                                                                              --{ pos_x = 80, pos_y = 60, ang = 0, target = "obj_int_achievements" },
                                                                            } },                                        -- Ачивки
      [ "tutorial_collectibles" ] = { shown = 0, noskip = false, posx = 512, posy = 280, input = false, arrows = {
                                                                              --{ pos_x = 80, pos_y = 60, ang = 0, target = "obj_int_collectibles" },
                                                                            } },                                        -- Коллектиблз
      [ "tutorial_loupe" ] = { shown = 0, noskip = true,  posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_mentalmagnifier1" },
                                                                            } },                                      -- Поиск линзой
      [ "tutorial_hint" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 100, pos_y = -50, ang = -4, target = "obj_int_button_hint" },
                                                                            } },                                      -- Хинт
      --[ "tutorial_page_20" ] = { shown = 0, noskip = true,  posx = 512, posy = 280, input = false, arrows = {
      --                                                                        { pos_x = 0, pos_y = -80, ang = 3.14, target = "obj_int_button_ability" }
      --                                                                        } },                                    -- Абилка

    };

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************