-- name=level3_inv
--*********************************************************************************************************************
function public.Init ()

  int.CreateDeployPlus( 3 );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level3_inv_deploy = function ()

    local visible_sparkle_ho = true;

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then

      visible_sparkle_ho = false;

    end;

    common_impl.TurnChildGfx( { "level3_inv_deploy" } , "level3_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level3_inv_deploy", update_game_mode_level3_inv_deploy, nil );

  private.init_inv_smallbox3();
  private.init_inv_abovedoorsign3();
  private.init_inv_disassembledlamp3();
  private.init_inv_magnetizedhorseshoe3();
  private.init_inv_disassembledgun3();
  private.init_inv_capsule3();
  
  --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("level3_inv_hub");
    port.VideoResizeInRoom("level3_inv");
  end;
end;
--*********************************************************************************************************************
-- function *** inv_smallbox3 *** () end;
--*********************************************************************************************************************
function private.init_inv_smallbox3 ()

  ObjSet( "spr_deploy_inv_smallbox3_codenote3", { event_mdown = private.get_codenote3 } );
  ObjSet( "obj_deploy_inv_smallbox3_use_pin3",  { event_mdown = private.Smallbox3Click } );
  --------------------------------------------------------------------------------------------
  -- function get_codenote3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_codenote3" ] =
  {
    type = "get",
    get_obj = "spr_deploy_inv_smallbox3_codenote3",
    room = "int_deploy_inv",
    zz = "deploy_inv_smallbox3",
    zz_gate = "inv_smallbox3"
  };
  --------------------------------------------------------------------------------------------
  local get_codenote3_inv = function ()

    int.InventoryItemAdd( "inv_codenote3", "spr_deploy_inv_smallbox3_codenote3" );
    int.InventoryItemRemove( "inv_smallbox3" );

    ObjDelete( "gfx_deploy_inv_smallbox3_codenote3" );

    ObjDelete( "inv_smallbox3_codenote3" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_codenote3", get_codenote3_inv );
  --------------------------------------------------------------------------------------------
  -- function use_pin3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pin3" ] =
  {
    type = "use",
    use_obj = "inv_pin3",
    use_place = "obj_deploy_inv_smallbox3_use_pin3",
    room = "int_deploy_inv",
    zz = "deploy_inv_smallbox3",
    zz_gate = "inv_smallbox3"
  };
  --------------------------------------------------------------------------------------------
  local use_pin3_inv = function ()
  
    int.InventoryItemRemove( "inv_pin3" );
    ObjSet( "inv_smallbox3_open", { alp = 1 } );
    ObjSet( "inv_smallbox3_codenote3", { alp = 1 } );
  
  end;
  local use_pin3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_smallbox3_use_pin3" );
    ObjDelete( "anm_deploy_inv_smallbox3_click" );

  end;
  local use_pin3_end = function ()
  
    ObjSet( "anm_deploy_inv_smallbox3_pin",       { alp = 1, frame = 162, animfunc = "DoAnim" } );    
    ObjSet( "spr_deploy_inv_smallbox3_codenote3", { input = true } );
    ObjSet( "gfx_deploy_inv_smallbox3_codenote3", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pin3",     use_pin3_beg, "inv_smallbox3" );
  cmn.AddSubscriber( "use_pin3",     use_pin3_inv );
  cmn.AddSubscriber( "use_pin3",     use_pin3_end, "inv_smallbox3" );
  cmn.AddSubscriber( "use_pin3_inv", use_pin3_inv, "inv_smallbox3" );
  cmn.AddSubscriber( "use_pin3_beg", use_pin3_beg, "inv_smallbox3" );
  cmn.AddSubscriber( "use_pin3_end", use_pin3_end, "inv_smallbox3" );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.get_codenote3 ()

  cmn.SetEventDone( "get_codenote3" );
  cmn.CallEventHandler( "get_codenote3" );
  int.DeployInvHide();

end;
--*********************************************************************************************************************
function public.use_pin3 ()

  local item = "inv_pin3";

  if ( cmn.ShowByInv( item, "inv_smallbox3" ) ) and
     ( not cmn.IsEventDone( "use_pin3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_smallbox3" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_smallbox3_use_pin3", "deploy_inv_smallbox3" ) ) and
         ( not cmn.IsEventDone( "use_pin3" ) ) then

    cmn.CallEventHandler( "use_pin3_inv" );
    cmn.CallEventHandler( "use_pin3_beg", "inv_smallbox3" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_pin3" );
      cmn.CallEventHandler( "use_pin3_end", "inv_smallbox3" );

    end;

    int.Lock( true );

    ObjSet( "anm_deploy_inv_smallbox3_pin", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_insert_key_blue_box" );
    AnimPlay( "anm_deploy_inv_smallbox3_pin", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** inv_abovedoorsign3 *** () end;
--*********************************************************************************************************************
function private.init_inv_abovedoorsign3 ()

  ObjSet( "spr_deploy_inv_abovedoorsign3_amuletsnake3",     { event_mdown = private.get_amuletsnake3 } );
  ObjSet( "obj_deploy_inv_abovedoorsign3_use_glasscutter3", { event_mdown = private.Abovedoorsign3Click } );
  --------------------------------------------------------------------------------------------
  -- function get_amuletsnake3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletsnake3" ] =
  {
    type = "get",
    get_obj = "spr_deploy_inv_abovedoorsign3_amuletsnake3",
    room = "int_deploy_inv",
    zz = "deploy_inv_abovedoorsign3",
    zz_gate = "inv_abovedoorsign3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletsnake3_inv = function ()
  
    int.InventoryItemAdd( "inv_amuletsnake3", "spr_deploy_inv_abovedoorsign3_amuletsnake3" );
    int.InventoryItemRemove( "inv_abovedoorsign3" );
  
    ObjDelete( "gfx_deploy_inv_abovedoorsign3_amuletsnake3" );

    ObjDelete( "inv_abovedoorsign3_open_amuletsnake3" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletsnake3", get_amuletsnake3_inv );
  --------------------------------------------------------------------------------------------
  -- function use_glasscutter3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glasscutter3" ] =
  {
    type = "use",
    use_obj = "inv_glasscutter3",
    use_place = "obj_deploy_inv_abovedoorsign3_use_glasscutter3",
    room = "int_deploy_inv",
    zz = "deploy_inv_abovedoorsign3",
    zz_gate = "inv_abovedoorsign3"
  };
  --------------------------------------------------------------------------------------------
  local use_glasscutter3_inv = function ()
  
    int.InventoryItemRemove( "inv_glasscutter3" );

    ObjSet( "inv_abovedoorsign3_open", { alp = 1 } );
    ObjSet( "inv_abovedoorsign3_open_amuletsnake3", { alp = 1 } );
  
  end;
  local use_glasscutter3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_abovedoorsign3_use_glasscutter3" );
    ObjDelete( "anm_deploy_inv_abovedoorsign3_click" );

  end;
  local use_glasscutter3_end = function ()
  
    ObjDelete( "anm_deploy_inv_abovedoorsign3_open" );
    ObjSet( "spr_deploy_inv_abovedoorsign3_abovedoorsign", { alp = 1 } );
    ObjSet( "spr_deploy_inv_abovedoorsign3_amuletsnake3",  { alp = 1, input = true } );
    ObjSet( "gfx_deploy_inv_abovedoorsign3_amuletsnake3",  { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glasscutter3",     use_glasscutter3_beg, "inv_abovedoorsign3" );
  cmn.AddSubscriber( "use_glasscutter3",     use_glasscutter3_inv );
  cmn.AddSubscriber( "use_glasscutter3",     use_glasscutter3_end, "inv_abovedoorsign3" );
  cmn.AddSubscriber( "use_glasscutter3_inv", use_glasscutter3_inv, "inv_abovedoorsign3" );
  cmn.AddSubscriber( "use_glasscutter3_beg", use_glasscutter3_beg, "inv_abovedoorsign3" );
  cmn.AddSubscriber( "use_glasscutter3_end", use_glasscutter3_end, "inv_abovedoorsign3" );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.get_amuletsnake3 ()

  cmn.SetEventDone( "get_amuletsnake3" );
  cmn.CallEventHandler( "get_amuletsnake3" );
  int.DeployInvHide();

end;
--*********************************************************************************************************************
function public.use_glasscutter3 ()

  local item = "inv_glasscutter3";

  if ( cmn.ShowByInv( item, "inv_abovedoorsign3" ) ) and
     ( not cmn.IsEventDone( "use_glasscutter3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_abovedoorsign3" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_abovedoorsign3_use_glasscutter3", "deploy_inv_abovedoorsign3" ) ) and
         ( not cmn.IsEventDone( "use_glasscutter3" ) ) then

    cmn.CallEventHandler( "use_glasscutter3_inv" );
    cmn.CallEventHandler( "use_glasscutter3_beg", "inv_abovedoorsign3" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_glasscutter3" );
      cmn.CallEventHandler( "use_glasscutter3_end", "inv_abovedoorsign3" );

    end;

    int.Lock( true );

    ObjSet( "anm_deploy_inv_abovedoorsign3_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_cut_cross" );
    AnimPlay( "anm_deploy_inv_abovedoorsign3_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** inv_disassembledlamp3 *** () end;
--*********************************************************************************************************************
function private.init_inv_disassembledlamp3 ()

  ObjSet( "spr_deploy_inv_disassembledlamp3_blowtorch3", { event_mdown = private.get_blowtorch3 } );
  --------------------------------------------------------------------------------------------
  -- function get_blowtorch3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blowtorch3" ] =
  {
    type = "get",
    get_obj = "obj_deploy_inv_disassembledlamp3_blowtorch3_hint",
    room = "int_deploy_inv",
    zz = "deploy_inv_disassembledlamp3",
    zz_gate = "inv_disassembledlamp3"
  };
  --------------------------------------------------------------------------------------------
  local get_blowtorch3_inv = function ()
  
    int.InventoryItemAdd( "inv_blowtorch3", "obj_deploy_inv_disassembledlamp3_blowtorch3" );
    int.InventoryItemRemove( "inv_disassembledlamp3" );
  
    ObjDelete( "gfx_deploy_inv_disassembledlamp3_blowtorch3" );
    ObjDelete( "obj_deploy_inv_disassembledlamp3_blowtorch3_hint" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_blowtorch3", get_blowtorch3_inv );
  --------------------------------------------------------------------------------------------
  -- function use_gasoline3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gasoline3" ] =
  {
    type = "use",
    use_obj = "inv_gasoline3",
    use_place = "obj_deploy_inv_disassembledlamp3_use_gasoline3",
    room = "int_deploy_inv",
    zz = "deploy_inv_disassembledlamp3",
    zz_gate = "inv_disassembledlamp3"
  };
  --------------------------------------------------------------------------------------------
  local use_gasoline3_inv = function ()
  
    int.InventoryItemRemove( "inv_gasoline3" );
    ObjSet( "inv_disassembledlamp3", { res = "assets/levels/level3/common_inventory3/inv_disassembledlamp3/inv/inv_blowtorch3" } );
  
  end;
  local use_gasoline3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_disassembledlamp3_use_gasoline3" );
  
  end;
  local use_gasoline3_end = function ()

    ObjSet( "anm_deploy_inv_disassembledlamp3_gasoline",   { frame = 0, animfunc = "DoAnim" } );
    ObjSet( "spr_deploy_inv_disassembledlamp3_blowtorch3", { input = true } );
    ObjSet( "gfx_deploy_inv_disassembledlamp3_blowtorch3", { active = true } );
    ObjSet( "anm_deploy_inv_disassembledlamp3_gasoline_fire", { playing = true } );
    ObjSet( "obj_deploy_inv_disassembledlamp3_blowtorch3",
    {
      croprect_init = true,
      croprect_x = -250,
      croprect_y = -250,
      croprect_w =  600,
      croprect_h =  450,
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gasoline3",     use_gasoline3_beg, "inv_disassembledlamp3" );
  cmn.AddSubscriber( "use_gasoline3",     use_gasoline3_inv );
  cmn.AddSubscriber( "use_gasoline3",     use_gasoline3_end, "inv_disassembledlamp3" );
  cmn.AddSubscriber( "use_gasoline3_inv", use_gasoline3_inv, "inv_disassembledlamp3" );
  cmn.AddSubscriber( "use_gasoline3_beg", use_gasoline3_beg, "inv_disassembledlamp3" );
  cmn.AddSubscriber( "use_gasoline3_end", use_gasoline3_end, "inv_disassembledlamp3" );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.get_blowtorch3 ()

  cmn.SetEventDone( "get_blowtorch3" );
  cmn.CallEventHandler( "get_blowtorch3" );
  int.DeployInvHide();

end;
--*********************************************************************************************************************
function public.use_gasoline3 ()

  local item = "inv_gasoline3";

  if ( cmn.ShowByInv( item, "inv_disassembledlamp3" ) ) and
     ( not cmn.IsEventDone( "use_gasoline3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_disassembledlamp3" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_disassembledlamp3_use_gasoline3", "deploy_inv_disassembledlamp3" ) ) and
         ( not cmn.IsEventDone( "use_gasoline3" ) ) then

    cmn.CallEventHandler( "use_gasoline3_inv" );
    cmn.CallEventHandler( "use_gasoline3_beg", "inv_disassembledlamp3" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_gasoline3" );
      cmn.CallEventHandler( "use_gasoline3_end", "inv_disassembledlamp3" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_fill_burner" );
    AnimPlay( "anm_deploy_inv_disassembledlamp3_gasoline", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** inv_magnetizedhorseshoe3 *** () end;
--*********************************************************************************************************************
function private.init_inv_magnetizedhorseshoe3 ()

  ObjSet( "spr_deploy_inv_magnetizedhorseshoe3_magnetonlace3", { event_mdown = private.get_magnetonlace3 } );
  --------------------------------------------------------------------------------------------
  -- function get_magnetonlace3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnetonlace3" ] =
  {
    type = "get",
    get_obj = "obj_deploy_inv_magnetizedhorseshoe3_hint",
    room = "int_deploy_inv",
    zz = "deploy_inv_magnetizedhorseshoe3",
    zz_gate = "inv_magnetizedhorseshoe3"
  };
  --------------------------------------------------------------------------------------------
  local get_magnetonlace3_inv = function ()
  
    int.InventoryItemAdd( "inv_magnetonlace3", "obj_deploy_inv_magnetizedhorseshoe3_magnetonlace3" );
    int.InventoryItemRemove( "inv_magnetizedhorseshoe3" );
  
    ObjDelete( "gfx_deploy_inv_magnetizedhorseshoe3_magnetonlace3" );
    ObjDelete( "obj_deploy_inv_magnetizedhorseshoe3_hint" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magnetonlace3", get_magnetonlace3_inv );
  --------------------------------------------------------------------------------------------
  -- function use_lace3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lace3" ] =
  {
    type = "use",
    use_obj = "inv_lace3",
    use_place = "obj_deploy_inv_magnetizedhorseshoe3_use_lace3",
    room = "int_deploy_inv",
    zz = "deploy_inv_magnetizedhorseshoe3",
    zz_gate = "inv_magnetizedhorseshoe3"
  };
  --------------------------------------------------------------------------------------------
  local use_lace3_inv = function ()
  
    int.InventoryItemRemove( "inv_lace3" );
    ObjSet( "inv_magnetizedhorseshoe3", { res = "assets/levels/level3/common_inventory3/inv_magnetizedhorseshoe3/inv/inv_magnetonlace3" } );
  
  end;
  local use_lace3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_magnetizedhorseshoe3_use_lace3" );
    ObjSet( "anm_deploy_inv_magnetizedhorseshoe3_lace", { alp = 1 } );
    ObjSet( "spr_deploy_inv_magnetizedhorseshoe3_magnetonlace3", { alp = 0 } );

  end;
  local use_lace3_end = function ()

    ObjSet( "anm_deploy_inv_magnetizedhorseshoe3_lace", { alp = 1, frame = 62, animfunc = "DoAnim" } );
    ObjSet( "spr_deploy_inv_magnetizedhorseshoe3_magnetonlace3", { input = true } );
    ObjSet( "gfx_deploy_inv_magnetizedhorseshoe3_magnetonlace3", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lace3",     use_lace3_beg, "inv_magnetizedhorseshoe3" );
  cmn.AddSubscriber( "use_lace3",     use_lace3_inv );
  cmn.AddSubscriber( "use_lace3",     use_lace3_end, "inv_magnetizedhorseshoe3" );
  cmn.AddSubscriber( "use_lace3_inv", use_lace3_inv, "inv_magnetizedhorseshoe3" );
  cmn.AddSubscriber( "use_lace3_beg", use_lace3_beg, "inv_magnetizedhorseshoe3" );
  cmn.AddSubscriber( "use_lace3_end", use_lace3_end, "inv_magnetizedhorseshoe3" );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.get_magnetonlace3 ()

  cmn.SetEventDone( "get_magnetonlace3" );
  cmn.CallEventHandler( "get_magnetonlace3" );
  int.DeployInvHide();

end;
--*********************************************************************************************************************
function public.use_lace3 ()

  local item = "inv_lace3";

  if ( cmn.ShowByInv( item, "inv_magnetizedhorseshoe3" ) ) and
     ( not cmn.IsEventDone( "use_lace3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_magnetizedhorseshoe3" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_magnetizedhorseshoe3_use_lace3", "deploy_inv_magnetizedhorseshoe3" ) ) and
         ( not cmn.IsEventDone( "use_lace3" ) ) then

    cmn.CallEventHandler( "use_lace3_inv" );
    cmn.CallEventHandler( "use_lace3_beg", "inv_magnetizedhorseshoe3" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_lace3" );
      cmn.CallEventHandler( "use_lace3_end", "inv_magnetizedhorseshoe3" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_rope_magnet" );
    AnimPlay( "anm_deploy_inv_magnetizedhorseshoe3_lace", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** inv_disassembledgun3 *** () end;
--*********************************************************************************************************************
function private.init_inv_disassembledgun3 ()

  ObjSet( "spr_deploy_inv_disassembledgun3_chargedgun3", { event_mdown = private.get_chargedgun3 } );
  ObjSet( "obj_deploy_inv_disassembledgun3_clk_disassembledgun3", { event_mdown = private.clk_disassembledgun3 } );
  --------------------------------------------------------------------------------------------
  -- function get_chargedgun3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chargedgun3" ] =
  {
    type = "get",
    get_obj = "spr_deploy_inv_disassembledgun3_chargedgun3",
    room = "int_deploy_inv",
    zz = "deploy_inv_disassembledgun3",
    zz_gate = "inv_disassembledgun3"
  };
  --------------------------------------------------------------------------------------------
  local get_chargedgun3_inv = function ()
  
    int.InventoryItemRemove( "inv_disassembledgun3" );
    int.InventoryItemAdd( "inv_chargedgun3", "obj_deploy_inv_disassembledgun3_chargedgun3" );
  
    ObjDelete( "gfx_deploy_inv_disassembledgun3_chargedgun3" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_chargedgun3", get_chargedgun3_inv );
  --------------------------------------------------------------------------------------------
  -- function clk_disassembledgun3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_disassembledgun3" ] =
  {
    type = "click",
    clk_obj = "obj_deploy_inv_disassembledgun3_clk_disassembledgun3",
    room = "int_deploy_inv",
    zz = "deploy_inv_disassembledgun3",
    zz_gate = "inv_disassembledgun3"
  };
  --------------------------------------------------------------------------------------------
  local clk_disassembledgun3_inv = function ()

    ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 0 } );

    if ( cmn.IsEventDone( "get_gunpowder3" ) ) or
       ( ( cmn.IsEventDone( "get_flintlock3" ) ) and ( not cmn.IsEventDone( "use_flintlock3" ) ) ) then

      ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 1 } );

    end;

  end;
  local clk_disassembledgun3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_disassembledgun3_clk_disassembledgun3" );
  
  end;
  local clk_disassembledgun3_end = function ()
  
    ObjSet( "anm_deploy_inv_disassembledgun3_cap",            { alp = 1, frame = 0, animfunc = "DoAnim", res = "assets/levels/level3/common_inventory3/inv_disassembledgun3/anims/anm_close_cap" } );
    ObjSet( "obj_deploy_inv_disassembledgun3_use_gunpowder3", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_disassembledgun3",     clk_disassembledgun3_beg, "inv_disassembledgun3" );
  cmn.AddSubscriber( "clk_disassembledgun3",     clk_disassembledgun3_inv );
  cmn.AddSubscriber( "clk_disassembledgun3",     clk_disassembledgun3_end, "inv_disassembledgun3" );
  cmn.AddSubscriber( "clk_disassembledgun3_inv", clk_disassembledgun3_inv, "inv_disassembledgun3" );
  cmn.AddSubscriber( "clk_disassembledgun3_beg", clk_disassembledgun3_beg, "inv_disassembledgun3" );
  cmn.AddSubscriber( "clk_disassembledgun3_end", clk_disassembledgun3_end, "inv_disassembledgun3" );
  --------------------------------------------------------------------------------------------
  -- function use_bullet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bullet3" ] =
  {
    type = "use",
    use_obj = "inv_bullet3",
    use_place = "obj_deploy_inv_disassembledgun3_use_bullet3",
    room = "int_deploy_inv",
    zz = "deploy_inv_disassembledgun3",
    zz_gate = "inv_disassembledgun3"
  };
  --------------------------------------------------------------------------------------------
  local use_bullet3_inv = function ()
  
    int.InventoryItemRemove( "inv_bullet3" );

    if ( not cmn.IsEventDone( "get_flintlock3" ) ) then

      ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 0 } );

    end;

  end;
  local use_bullet3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_disassembledgun3_use_bullet3" );
  
  end;
  local use_bullet3_end = function ()
  
    ObjSet( "anm_deploy_inv_disassembledgun3_bullet", { alp = 1, pos_z = 3, frame = 0, animfunc = "DoAnim", res = "assets/levels/level3/common_inventory3/inv_disassembledgun3/anims/anm_bullet_end" } );
    ObjSet( "anm_deploy_inv_disassembledgun3_cap",    { alp = 1, frame = 18, animfunc = "DoAnim" } );

    if ( cmn.IsEventDone( "use_flintlock3" ) ) then

      ObjSet( "spr_deploy_inv_disassembledgun3_chargedgun3", { input = true } );
      ObjSet( "gfx_deploy_inv_disassembledgun3_chargedgun3", { active = true } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bullet3",     use_bullet3_beg, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_bullet3",     use_bullet3_inv );
  cmn.AddSubscriber( "use_bullet3",     use_bullet3_end, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_bullet3_inv", use_bullet3_inv, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_bullet3_beg", use_bullet3_beg, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_bullet3_end", use_bullet3_end, "inv_disassembledgun3" );
  --------------------------------------------------------------------------------------------
  -- function use_gunpowder3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gunpowder3" ] =
  {
    type = "use",
    use_obj = "inv_gunpowder3",
    use_place = "obj_deploy_inv_disassembledgun3_use_gunpowder3",
    room = "int_deploy_inv",
    zz = "deploy_inv_disassembledgun3",
    zz_gate = "inv_disassembledgun3"
  };
  --------------------------------------------------------------------------------------------
  local use_gunpowder3_inv = function ()
  
    int.InventoryItemRemove( "inv_gunpowder3" );

    ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 0 } );

    if ( cmn.IsEventDone( "get_bullet3" ) ) or
       ( cmn.IsEventDone( "get_flintlock3" ) and not cmn.IsEventDone( "get_flintlock3" ) ) then

      ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 1 } );

    end;

  end;
  local use_gunpowder3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_disassembledgun3_use_gunpowder3" );
  
  end;
  local use_gunpowder3_end = function ()
  
    ObjSet( "anm_deploy_inv_disassembledgun3_powder", { alp = 1, pos_z = 2, frame = 0, animfunc = "DoAnim", res = "assets/levels/level3/common_inventory3/inv_disassembledgun3/anims/anm_powder_end" } );
    ObjSet( "obj_deploy_inv_disassembledgun3_use_bullet3", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gunpowder3",     use_gunpowder3_beg, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_gunpowder3",     use_gunpowder3_inv );
  cmn.AddSubscriber( "use_gunpowder3",     use_gunpowder3_end, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_gunpowder3_inv", use_gunpowder3_inv, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_gunpowder3_beg", use_gunpowder3_beg, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_gunpowder3_end", use_gunpowder3_end, "inv_disassembledgun3" );
  --------------------------------------------------------------------------------------------
  -- function use_flintlock3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flintlock3" ] =
  {
    type = "use",
    use_obj = "inv_flintlock3",
    use_place = "obj_deploy_inv_disassembledgun3_use_flintlock3",
    room = "int_deploy_inv",
    zz = "deploy_inv_disassembledgun3",
    zz_gate = "inv_disassembledgun3"
  };
  --------------------------------------------------------------------------------------------
  local use_flintlock3_inv = function ()
  
    int.InventoryItemRemove( "inv_flintlock3" );

    if ( not cmn.IsEventDone( "get_gunpowder3" ) ) or
       ( cmn.IsEventDone( "use_gunpowder3" ) and not cmn.IsEventDone( "get_bullet3" ) ) then

      ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 0 } );

    end;

    ObjSet( "inv_disassembledgun_flintlock3", { alp = 1 } );

  end;
  local use_flintlock3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_disassembledgun3_use_flintlock3" );
  
  end;
  local use_flintlock3_end = function ()
  
    ObjSet( "anm_deploy_inv_disassembledgun3_flintlock", { alp = 1, frame = 0, animfunc = "DoAnim", res = "assets/levels/level3/common_inventory3/inv_disassembledgun3/anims/anm_flintlock_end" } );

    if ( cmn.IsEventDone( "use_bullet3" ) ) then

      ObjSet( "spr_deploy_inv_disassembledgun3_chargedgun3", { input = true } );
      ObjSet( "gfx_deploy_inv_disassembledgun3_chargedgun3", { active = true } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flintlock3",     use_flintlock3_beg, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_flintlock3",     use_flintlock3_inv );
  cmn.AddSubscriber( "use_flintlock3",     use_flintlock3_end, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_flintlock3_inv", use_flintlock3_inv, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_flintlock3_beg", use_flintlock3_beg, "inv_disassembledgun3" );
  cmn.AddSubscriber( "use_flintlock3_end", use_flintlock3_end, "inv_disassembledgun3" );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.get_chargedgun3 ()

  cmn.SetEventDone( "get_chargedgun3" );
  cmn.CallEventHandler( "get_chargedgun3" );
  int.DeployInvHide();

end;
--*********************************************************************************************************************
function private.clk_disassembledgun3 ()

  cmn.CallEventHandler( "clk_disassembledgun3_inv" );
  cmn.CallEventHandler( "clk_disassembledgun3_beg", "inv_disassembledgun3" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_disassembledgun3" );
    cmn.CallEventHandler( "clk_disassembledgun3_end", "inv_disassembledgun3" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_gun_click_open" );
  AnimPlay( "anm_deploy_inv_disassembledgun3_cap", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function public.use_bullet3 ()

  local item = "inv_bullet3";

  if ( cmn.ShowByInv( item, "inv_disassembledgun3" ) ) and
     ( not cmn.IsEventDone( "use_bullet3" ) ) and
     ( cmn.IsEventDone( "use_gunpowder3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_disassembledgun3" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_disassembledgun3_use_bullet3", "deploy_inv_disassembledgun3" ) ) and
         ( not cmn.IsEventDone( "use_bullet3" ) ) and
         ( cmn.IsEventDone( "use_gunpowder3" ) ) then

    cmn.CallEventHandler( "use_bullet3_inv" );
    cmn.CallEventHandler( "use_bullet3_beg", "inv_disassembledgun3" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_bullet3" );
      cmn.CallEventHandler( "use_bullet3_end", "inv_disassembledgun3" );

    end;

    int.Lock( true );

    ObjSet( "anm_deploy_inv_disassembledgun3_bullet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_gun_insert_bullet" );
    AnimPlay( "anm_deploy_inv_disassembledgun3_bullet", "DoAnim",
    function ()

      ObjSet( "anm_deploy_inv_disassembledgun3_bullet", { pos_z = 3 } );
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_gun_close" );
      AnimPlay( "anm_deploy_inv_disassembledgun3_cap", "DoAnim", func_end );

    end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_gunpowder3 ()

  local item = "inv_gunpowder3";

  if ( cmn.ShowByInv( item, "inv_disassembledgun3" ) ) and
     ( not cmn.IsEventDone( "use_gunpowder3" ) ) and
     ( cmn.IsEventDone( "clk_disassembledgun3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_disassembledgun3" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_disassembledgun3_use_gunpowder3", "deploy_inv_disassembledgun3" ) ) and
         ( not cmn.IsEventDone( "use_gunpowder3" ) ) and
         ( cmn.IsEventDone( "clk_disassembledgun3" ) ) then

    cmn.CallEventHandler( "use_gunpowder3_inv" );
    cmn.CallEventHandler( "use_gunpowder3_beg", "inv_disassembledgun3" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_gunpowder3" );
      cmn.CallEventHandler( "use_gunpowder3_end", "inv_disassembledgun3" );

    end;

    int.Lock( true );

    ObjSet( "anm_deploy_inv_disassembledgun3_powder", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_gun_fill_powder" );
    AnimPlay( "anm_deploy_inv_disassembledgun3_powder", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_flintlock3 ()

  local item = "inv_flintlock3";

  if ( cmn.ShowByInv( item, "inv_disassembledgun3" ) ) and
     ( not cmn.IsEventDone( "use_flintlock3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_disassembledgun3" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_disassembledgun3_use_flintlock3", "deploy_inv_disassembledgun3" ) ) and
         ( not cmn.IsEventDone( "use_flintlock3" ) ) then

    cmn.CallEventHandler( "use_flintlock3_inv" );
    cmn.CallEventHandler( "use_flintlock3_beg", "inv_disassembledgun3" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_flintlock3" );
      cmn.CallEventHandler( "use_flintlock3_end", "inv_disassembledgun3" );

    end;

    int.Lock( true );

    ObjSet( "anm_deploy_inv_disassembledgun3_flintlock", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_gun_insert_gate" );
    AnimPlay( "anm_deploy_inv_disassembledgun3_flintlock", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-- function *** inv_capsule3 *** () end;
--*********************************************************************************************************************
function private.init_inv_capsule3 ()

  ObjSet( "spr_deploy_inv_capsule3_chemicals3", { event_mdown = private.get_chemicals3 } );
  --------------------------------------------------------------------------------------------
  -- function get_chemicals3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chemicals3" ] =
  {
    type = "get",
    get_obj = "obj_deploy_inv_capsule3_chemicals3_hint",
    room = "int_deploy_inv",
    zz = "deploy_inv_capsule3",
    zz_gate = "inv_capsule3"
  };
  --------------------------------------------------------------------------------------------
  local get_chemicals3_inv = function ()
  
    int.InventoryItemAdd( "inv_chemicals3", "spr_deploy_inv_capsule3_chemicals3" );
    int.InventoryItemRemove( "inv_capsule3" );    

    ObjDelete( "gfx_deploy_inv_capsule3_chemicals3" );
    ObjDelete( "obj_deploy_inv_capsule3_chemicals3_hint" );
    ObjDelete( "inv_capsule3_open_chemicals" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_chemicals3", get_chemicals3_inv );
  --------------------------------------------------------------------------------------------
  -- function use_wrench3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench3" ] =
  {
    type = "use",
    use_obj = "inv_wrench3",
    use_place = "obj_deploy_inv_capsule3_use_wrench3",
    room = "int_deploy_inv",
    zz = "deploy_inv_capsule3",
    zz_gate = "inv_capsule3"
  };
  --------------------------------------------------------------------------------------------
  local use_wrench3_inv = function ()
  
    int.InventoryItemRemove( "inv_wrench3" );
    ObjSet( "inv_capsule3", { res = "assets/levels/level3/common_inventory3/inv_capsule3/inv/inv_capsule3_open" } );
    ObjSet( "inv_capsule3_open_chemicals", { alp = 1 } );
  
  end;
  local use_wrench3_beg = function ()
  
    ObjDelete( "obj_deploy_inv_capsule3_use_wrench3" );
  
  end;
  local use_wrench3_end = function ()
  
    ObjSet( "spr_deploy_inv_capsule3_chemicals3", { input = true } );
    ObjSet( "gfx_deploy_inv_capsule3_chemicals3", { active = true } );
    ObjSet( "vid_deploy_inv_capsule3_open", { frame = 157 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench3",     use_wrench3_beg, "inv_capsule3" );
  cmn.AddSubscriber( "use_wrench3",     use_wrench3_inv );
  cmn.AddSubscriber( "use_wrench3",     use_wrench3_end, "inv_capsule3" );
  cmn.AddSubscriber( "use_wrench3_inv", use_wrench3_inv, "inv_capsule3" );
  cmn.AddSubscriber( "use_wrench3_beg", use_wrench3_beg, "inv_capsule3" );
  cmn.AddSubscriber( "use_wrench3_end", use_wrench3_end, "inv_capsule3" );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.get_chemicals3 ()

  cmn.SetEventDone( "get_chemicals3" );
  cmn.CallEventHandler( "get_chemicals3" );

  int.DeployInvHide();

  if port.isPortable()==1 then
    iOS_RateMe();
  end;
end;
--*********************************************************************************************************************
function public.use_wrench3 ()

  local item = "inv_wrench3";

  if ( cmn.ShowByInv( item, "inv_capsule3" ) ) and
     ( not cmn.IsEventDone( "use_wrench3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.ShowDeployInv( "inv_capsule3" );

    return true;

  elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_capsule3_use_wrench3", "deploy_inv_capsule3" ) ) and
         ( not cmn.IsEventDone( "use_wrench3" ) ) then

    cmn.CallEventHandler( "use_wrench3_inv" );
    cmn.CallEventHandler( "use_wrench3_beg", "inv_capsule3" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_wrench3" );
      cmn.CallEventHandler( "use_wrench3_end", "inv_capsule3" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_unscrew_tube" );
    VidPlay( "vid_deploy_inv_capsule3_open", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** CHECK FUNCTIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.CheckBlacksmithfigurine3 ()

    local count = 0;

    for a = 1, 3 do

      if ( cmn.IsEventDone( "get_blacksmithfigurine3_"..a ) ) then

        count = count + 1;
        ObjSet( "spr_inv_blacksmithfigurine3_"..a, { alp = 1 } );

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_blacksmithfigurine3_count" );

    else

      ObjSet( "txt_inv_blacksmithfigurine3_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckGear3 ()

    local count = 0;

    for a = 1, 3 do

      if ( cmn.IsEventDone( "get_gear3_"..a ) ) then

        count = count + 1;
        ObjSet( "spr_inv_gear3_"..a, { alp = 1 } );

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_gear3_count" );

    else

      ObjSet( "txt_inv_gear3_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckAmulethydra3 ()

    local count = 0;

    for a = 1, 3 do

      if ( cmn.IsEventDone( "get_amulethydra3_"..a ) ) then

        count = count + 1;
        ObjSet( "spr_inv_amulethydra3_"..a, { alp = 1 } );

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_amulethydra3_count" );

    else

      ObjSet( "txt_inv_amulethydra3_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckCrest3 ( id )

    if ( cmn.IsEventDone( "get_crest3_1" ) ) and
       ( cmn.IsEventDone( "get_crest3_2" ) ) then

      ObjSet( "inv_crest3", { res = "assets/levels/level3/rm_secretroom3/zz_armchair3/inv/inv_crest3_all" } );
      ObjDelete( "txt_inv_crest3_count" );

    else 

      ObjSet( "inv_crest3", { res = "assets/levels/level3/rm_secretroom3/zz_armchair3/inv/inv_crest3_"..id } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckAmuletmolecule3 ( id )

    if ( cmn.IsEventDone( "get_amuletmolecule3_1" ) ) and
       ( cmn.IsEventDone( "get_amuletmolecule3_2" ) ) then

      ObjSet( "inv_amuletmolecule3", { res = "assets/levels/level3/rm_tower3/zz_boxes3/inv/inv_amuletmolecule3_all" } );
      ObjDelete( "txt_inv_amuletmolecule3_count" );

    else 

      ObjSet( "inv_amuletmolecule3", { res = "assets/levels/level3/rm_tower3/zz_boxes3/inv/inv_amuletmolecule3_"..id } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckAmuletchimera3 ( id )

    if ( cmn.IsEventDone( "get_amuletchimera3_1" ) ) and
       ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) then

      ObjSet( "inv_amuletchimera3", { res = "assets/levels/level3/rm_park3/zz_fountain3/inv/inv_amuletchimera3_all" } );
      ObjDelete( "txt_inv_amuletchimera3_count" );

    else 

      ObjSet( "inv_amuletchimera3", { res = "assets/levels/level3/rm_park3/zz_fountain3/inv/inv_amuletchimera3_"..id } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckAmuletomega3 ( id )

    if ( cmn.IsEventDone( "get_amuletomega3_1" ) ) and
       ( cmn.IsEventDone( "get_amuletomega3_2" ) ) then

      ObjSet( "inv_amuletomega3", { res = "assets/levels/level3/rm_tower3/zz_labdoor3/inv/inv_amuletomega3_all" } );
      ObjDelete( "txt_inv_amuletomega3_count" );

    else 

      ObjSet( "inv_amuletomega3", { res = "assets/levels/level3/rm_tower3/zz_labdoor3/inv/inv_amuletomega3_"..id } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckAmuletgriffin3 ( id )

    if ( cmn.IsEventDone( "get_amuletgriffin3_1" ) ) and
       ( cmn.IsEventDone( "get_amuletgriffin3_2" ) ) then

      ObjSet( "inv_amuletgriffin3", { res = "assets/levels/level3/rm_abigailshouse3/zz_windowsill3/inv/inv_amuletgriffin3_all" } );
      ObjDelete( "txt_inv_amuletgriffin3_count" );

    else 

      ObjSet( "inv_amuletgriffin3", { res = "assets/levels/level3/rm_abigailshouse3/zz_windowsill3/inv/inv_amuletgriffin3_"..id } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckAmuletAngel3 ( id )

    if ( cmn.IsEventDone( "get_amuletangel3_1" ) ) and
       ( cmn.IsEventDone( "get_amuletangel3_2" ) ) then

      ObjSet( "inv_amuletangel3", { res = "assets/levels/level3/rm_towerroof3/zz_revitalizer3/inv/inv_amuletangel3_all" } );
      ObjDelete( "txt_inv_amuletangel3_count" );

    else 

      ObjSet( "inv_amuletangel3", { res = "assets/levels/level3/rm_towerroof3/zz_revitalizer3/inv/inv_amuletangel3_"..id } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckHexagram3 ( id )

    if ( cmn.IsEventDone( "get_hexagram3_1" ) ) and
       ( cmn.IsEventDone( "get_hexagram3_2" ) ) then

      ObjSet( "inv_hexagram3", { res = "assets/levels/level3/rm_neartower3/zz_tunnelentrance3/inv/inv_hexagram3_all" } );
      ObjDelete( "txt_inv_hexagram3_count" );

    else 

      ObjSet( "inv_hexagram3", { res = "assets/levels/level3/rm_neartower3/zz_tunnelentrance3/inv/inv_hexagram3_"..id } );

    end;

  end;
--*********************************************************************************************************************
function private.Smallbox3Click ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_deploy_inv_smallbox3_use_pin3" );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_inv_blue_box" );
  AnimPlay( "anm_deploy_inv_smallbox3_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Abovedoorsign3Click ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_deploy_inv_abovedoorsign3_use_glasscutter3" );

  end;

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_inv_cross" );
  AnimPlay( "anm_deploy_inv_abovedoorsign3_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************