-- name=rm_abigailshouse3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_abigailshouse3";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_windowsill3", "room_hub" );
  ObjAttach( "zz_portrait3",   "room_hub" );

  ObjMultiSet(
  {
    { "spr_windowsill3_amuletgriffin3_1", { event_mdown = private.get_amuletgriffin3_1 } },
    { "spr_windowsill3_amuletcrown3",     { event_mdown = private.get_amuletcrown3 } },
    { "spr_windowsill3_pin3",             { event_mdown = private.get_pin3 } },
    { "spr_windowsill3_razor3",           { event_mdown = private.get_razor3 } },
    { "spr_windowsill3_feather3",         { event_mdown = private.get_feather3 } },
    { "spr_portrait3_amuletflower3",      { event_mdown = private.get_amuletflower3 } },
    { "spr_portrait3_smallbox3",          { event_mdown = private.get_smallbox3 } },
    { "spr_abigailshouse3_collect_2_2",   { event_mdown = private.get_collect_2_2 } },
    { "obj_portrait3_clk_mmg",            { event_mdown = function() private.clk_portrait3_mmg() end } },
    { "obj_portrait3_use_jimmy3",         { event_mdown = function() private.Portrait3Clk() end } },
    { "obj_portrait3_use_amuletcrown3",   { event_mdown = function() private.Portrait3AmuletcrownClk() end } },
    { "obj_portrait3_use_codenote3",      { event_mdown = function() private.Portrait3CodenoteClk() end } },
    { "obj_windowsill3_use_crest3",       { event_mdown = function() private.Windowsill3CrestClk() end } },
    { "obj_windowsill3_use_amuletflower3",       { event_mdown = function() private.Windowsill3AmuletflowerClk() end } },
  } );

  private.Portrait3Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_abigailshouse3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_abigailshouse3", update_game_mode_abigailshouse3, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function opn_abigailshouse3 () end;
  --------------------------------------------------------------------------------------------
  local opn_abigailshouse3 = function ()

    if ( cmn.IsEventDone( "opn_alley3" ) ) then
      
      ObjDelete( "obj_abigailshouse3_stasy" );      
      ObjDelete( "obj_abigailshouse3_stasy_bbt" );      
      
    end;        

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_abigailshouse3", opn_abigailshouse3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_2 = function ()

    ObjDelete( "spr_abigailshouse3_collect_2_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_2_2", get_collect_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_1 = function ()

    ObjDelete( "obj_abigailshouse3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_1", get_morphobject_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletgriffin3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletgriffin3_1" ] =
  {
    type = "get",
    get_obj = "spr_windowsill3_amuletgriffin3_1",
    room = private.room_objname,
    zz = "zz_windowsill3",
    zz_gate = "gzz_abigailshouse3_windowsill3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletgriffin3_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletgriffin3", "spr_windowsill3_amuletgriffin3_1", "assets/levels/level3/rm_abigailshouse3/zz_windowsill3/inv/inv_amuletgriffin3_1" );
    level3_inv.CheckAmuletgriffin3( 1 );

  end;
  local get_amuletgriffin3_1_closezz = function ()

    ObjDelete( "gfx_windowsill3_amuletgriffin3_1" );

    if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
       cmn.IsEventDone( "get_amuletcrown3" ) and 
       cmn.IsEventDone( "get_pin3" ) and 
       cmn.IsEventDone( "get_razor3" ) and 
       cmn.IsEventDone( "get_feather3" ) then

      ObjDelete( "gzz_abigailshouse3_windowsill3" );

    end;

    ObjDelete( "spr_abigailshouse3_windowsill_amuletgriffin" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletgriffin3_1", get_amuletgriffin3_1_inv );
  cmn.AddSubscriber( "get_amuletgriffin3_1", get_amuletgriffin3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletcrown3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletcrown3" ] =
  {
    type = "get",
    get_obj = "spr_windowsill3_amuletcrown3",
    room = private.room_objname,
    zz = "zz_windowsill3",
    zz_gate = "gzz_abigailshouse3_windowsill3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletcrown3_inv = function ()

    int.InventoryItemAdd( "inv_amuletcrown3", "spr_windowsill3_amuletcrown3" );

  end;
  local get_amuletcrown3_closezz = function ()

    ObjDelete( "gfx_windowsill3_amuletcrown3" );

    if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
       cmn.IsEventDone( "get_amuletcrown3" ) and 
       cmn.IsEventDone( "get_pin3" ) and 
       cmn.IsEventDone( "get_razor3" ) and 
       cmn.IsEventDone( "get_feather3" ) then

      ObjDelete( "gzz_abigailshouse3_windowsill3" );

    end;

    ObjDelete( "spr_abigailshouse3_windowsill_amuletcrown" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletcrown3", get_amuletcrown3_inv );
  cmn.AddSubscriber( "get_amuletcrown3", get_amuletcrown3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pin3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pin3" ] =
  {
    type = "get",
    get_obj = "spr_windowsill3_pin3",
    room = private.room_objname,
    zz = "zz_windowsill3",
    zz_gate = "gzz_abigailshouse3_windowsill3"
  };
  --------------------------------------------------------------------------------------------
  local get_pin3_inv = function ()

    int.InventoryItemAdd( "inv_pin3", "spr_windowsill3_pin3" );

    if ( cmn.IsEventDone( "get_smallbox3" ) ) then

      ObjSet( "inv_smallbox3_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_pin3_closezz = function ()

    ObjDelete( "gfx_windowsill3_pin3" );

    if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
       cmn.IsEventDone( "get_amuletcrown3" ) and 
       cmn.IsEventDone( "get_pin3" ) and 
       cmn.IsEventDone( "get_razor3" ) and 
       cmn.IsEventDone( "get_feather3" ) then

      ObjDelete( "gzz_abigailshouse3_windowsill3" );

    end;

    ObjDelete( "spr_abigailshouse3_open_box_2_pin" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pin3", get_pin3_inv );
  cmn.AddSubscriber( "get_pin3", get_pin3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_razor3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_razor3" ] =
  {
    type = "get",
    get_obj = "spr_windowsill3_razor3",
    room = private.room_objname,
    zz = "zz_windowsill3",
    zz_gate = "gzz_abigailshouse3_windowsill3"
  };
  --------------------------------------------------------------------------------------------
  local get_razor3_inv = function ()

    int.InventoryItemAdd( "inv_razor3", "spr_windowsill3_razor3" );

  end;
  local get_razor3_closezz = function ()

    ObjDelete( "gfx_windowsill3_razor3" );

    if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
       cmn.IsEventDone( "get_amuletcrown3" ) and 
       cmn.IsEventDone( "get_pin3" ) and 
       cmn.IsEventDone( "get_razor3" ) and 
       cmn.IsEventDone( "get_feather3" ) then

      ObjDelete( "gzz_abigailshouse3_windowsill3" );

    end;

    ObjDelete( "spr_abigailshouse3_windowsill_razor" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_razor3", get_razor3_inv );
  cmn.AddSubscriber( "get_razor3", get_razor3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_feather3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_feather3" ] =
  {
    type = "get",
    get_obj = "spr_windowsill3_feather3",
    room = private.room_objname,
    zz = "zz_windowsill3",
    zz_gate = "gzz_abigailshouse3_windowsill3"
  };
  --------------------------------------------------------------------------------------------
  local get_feather3_inv = function ()

    int.InventoryItemAdd( "inv_feather3", "spr_windowsill3_feather3" );

  end;
  local get_feather3_closezz = function ()

    ObjDelete( "gfx_windowsill3_feather3" );
    ObjDelete( "spr_abigailshouse3_open_box_1_spray" );

    if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
       cmn.IsEventDone( "get_amuletcrown3" ) and 
       cmn.IsEventDone( "get_pin3" ) and 
       cmn.IsEventDone( "get_razor3" ) and 
       cmn.IsEventDone( "get_feather3" ) then

      ObjDelete( "gzz_abigailshouse3_windowsill3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_feather3", get_feather3_inv );
  cmn.AddSubscriber( "get_feather3", get_feather3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletflower3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletflower3" ] =
  {
    type = "get",
    get_obj = "spr_portrait3_amuletflower3",
    room = private.room_objname,
    zz = "zz_portrait3",
    zz_gate = "gzz_abigailshouse3_portrait3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletflower3_inv = function ()

    int.InventoryItemAdd( "inv_amuletflower3", "spr_portrait3_amuletflower3" );

  end;
  local get_amuletflower3_closezz = function ()

    ObjDelete( "gfx_portrait3_amuletflower3" );
    ObjDelete( "spr_abigailshouse3_portrait_amuletflower" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletflower3", get_amuletflower3_inv );
  cmn.AddSubscriber( "get_amuletflower3", get_amuletflower3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_smallbox3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_smallbox3" ] =
  {
    type = "get",
    get_obj = "spr_portrait3_smallbox3",
    room = private.room_objname,
    zz = "zz_portrait3",
    zz_gate = "gzz_abigailshouse3_portrait3"
  };
  --------------------------------------------------------------------------------------------
  local get_smallbox3_inv = function ()

    int.InventoryItemAdd( "inv_smallbox3", "spr_portrait3_smallbox3" );
    ObjSet( "inv_smallbox3", { drag = false } );

    if ( not cmn.IsEventDone( "get_pin3" ) ) then

      ObjSet( "inv_smallbox3_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_smallbox3_closezz = function ()

    ObjDelete( "gfx_portrait3_smallbox3" );
    ObjDelete( "spr_abigailshouse3_box" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_smallbox3", get_smallbox3_inv );
  cmn.AddSubscriber( "get_smallbox3", get_smallbox3_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_amuletflower3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletflower3" ] =
  {
    type = "use",
    use_obj = "inv_amuletflower3",
    use_place = "obj_windowsill3_use_amuletflower3",
    room = private.room_objname,
    zz = "zz_windowsill3",
    zz_gate = "gzz_abigailshouse3_windowsill3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletflower3_inv = function ()

    int.InventoryItemRemove( "inv_amuletflower3" );

  end;
  local use_amuletflower3_beg = function ()

    ObjDelete( "obj_windowsill3_use_amuletflower3" );

  end;
  local use_amuletflower3_end = function ()

    ObjDelete( "anm_windowsill3_amuletflower" );
    ObjSet( "spr_windowsill3_amuletflower", { alp = 1 } );
    ObjSet( "obj_windowsill3_niche_small_open", { alp = 1, input = true } );
    ObjSet( "gfx_windowsill3_pin3", { active = true } );
    ObjSet( "gfx_windowsill3_razor3", { active = true } );
    ObjDelete( "anm_windowsill3_click_stash" );

    ObjSet( "spr_abigailshouse3_windowsill_amuletflower", { alp = 1 } );
    ObjSet( "obj_abigailshouse3_windowsill_box_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletflower3",     use_amuletflower3_inv );
  cmn.AddSubscriber( "use_amuletflower3",     use_amuletflower3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletflower3",     use_amuletflower3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletflower3_inv", use_amuletflower3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletflower3_beg", use_amuletflower3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletflower3_end", use_amuletflower3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crest3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crest3" ] =
  {
    type = "use",
    use_obj = "inv_crest3",
    use_place = "obj_windowsill3_use_crest3",
    room = private.room_objname,
    zz = "zz_windowsill3",
    zz_gate = "gzz_abigailshouse3_windowsill3"
  };
  --------------------------------------------------------------------------------------------
  local use_crest3_inv = function ()

    int.InventoryItemRemove( "inv_crest3" );

  end;
  local use_crest3_beg = function ()

    ObjDelete( "obj_windowsill3_use_crest3" );

  end;
  local use_crest3_end = function ()

    ObjSet( "anm_windowsill3_crest", { frame = 97, animfunc = "DoAnim" } );
    ObjSet( "obj_windowsill3_niche_big_open", { input = true } );
    ObjSet( "gfx_windowsill3_feather3", { active = true } );
    ObjDelete( "anm_windowsill3_click_cap" );

    ObjSet( "spr_abigailshouse3_open_box_1", { alp = 1 } );
    ObjSet( "spr_abigailshouse3_open_box_1_spray", { alp = 1 } );
    ObjDelete( "spr_abigailshouse3_box_cap" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crest3",     use_crest3_inv );
  cmn.AddSubscriber( "use_crest3",     use_crest3_beg, private.room_objname );
  cmn.AddSubscriber( "use_crest3",     use_crest3_end, private.room_objname );
  cmn.AddSubscriber( "use_crest3_inv", use_crest3_inv, private.room_objname );
  cmn.AddSubscriber( "use_crest3_beg", use_crest3_beg, private.room_objname );
  cmn.AddSubscriber( "use_crest3_end", use_crest3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_jimmy3_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jimmy3_3" ] =
  {
    type = "use",
    use_obj = "inv_jimmy3",
    use_place = "obj_portrait3_use_jimmy3",
    room = private.room_objname,
    zz = "zz_portrait3",
    zz_gate = "gzz_abigailshouse3_portrait3"
  };
  --------------------------------------------------------------------------------------------
  local use_jimmy3_3_inv = function ()

    if cmn.IsEventDone( "use_jimmy3_2" ) and 
       cmn.IsEventDone( "use_jimmy3_1" ) then
      int.InventoryItemRemove( "inv_jimmy3" );
    end;

  end;
  local use_jimmy3_3_beg = function ()

    ObjDelete( "obj_portrait3_use_jimmy3" );

  end;
  local use_jimmy3_3_end = function ()

    ObjDelete( "obj_portrait3_close" );
    ObjSet( "obj_portrait3_open", { input = true } );

    ObjSet( "obj_portrait3_use_amuletcrown3", { input = true } );

    ObjSet( "gfx_portrait3_smallbox3", { active = true } );
    ObjSet( "gfx_portrait3_amuletflower3", { active = true } );
    
    ObjDelete( "spr_abigailshouse3_close_picture" );
    ObjSet( "spr_abigailshouse3_open_picture", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jimmy3_3",     use_jimmy3_3_inv );
  cmn.AddSubscriber( "use_jimmy3_3",     use_jimmy3_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_3",     use_jimmy3_3_end, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_3_inv", use_jimmy3_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_3_beg", use_jimmy3_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_3_end", use_jimmy3_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletcrown3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletcrown3" ] =
  {
    type = "use",
    use_obj = "inv_amuletcrown3",
    use_place = "obj_portrait3_use_amuletcrown3",
    room = private.room_objname,
    zz = "zz_portrait3",
    zz_gate = "gzz_abigailshouse3_portrait3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletcrown3_inv = function ()

    int.InventoryItemRemove( "inv_amuletcrown3" );

  end;
  local use_amuletcrown3_beg = function ()

    ObjDelete( "obj_portrait3_use_amuletcrown3" );

  end;
  local use_amuletcrown3_end = function ()

    ObjDelete( "obj_portrait3_mmg_doors" );
    ObjSet( "obj_portrait3_use_codenote3", { input = true } );  
    ObjSet( "anm_portrait3_click_handle", { alp = 1 } );    
    
    ObjDelete( "spr_abigailshouse3_mmg_2_cl" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletcrown3",     use_amuletcrown3_inv );
  cmn.AddSubscriber( "use_amuletcrown3",     use_amuletcrown3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrown3",     use_amuletcrown3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrown3_inv", use_amuletcrown3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrown3_beg", use_amuletcrown3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletcrown3_end", use_amuletcrown3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_codenote3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_codenote3" ] =
  {
    type = "use",
    use_obj = "inv_codenote3",
    use_place = "obj_portrait3_use_codenote3",
    room = private.room_objname,
    zz = "zz_portrait3",
    zz_gate = "gzz_abigailshouse3_portrait3"
  };
  --------------------------------------------------------------------------------------------
  local use_codenote3_inv = function ()

    int.InventoryItemRemove( "inv_codenote3" );

  end;
  local use_codenote3_beg = function ()

    ObjDelete( "obj_portrait3_use_codenote3" );

  end;
  local use_codenote3_end = function ()

    ObjSet( "spr_portrait3_codenote", { alp = 1 } );
    ObjSet( "obj_portrait3_clk_mmg", { input = true } );
    
    ObjSet( "spr_abigailshouse3_note", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_codenote3",     use_codenote3_inv );
  cmn.AddSubscriber( "use_codenote3",     use_codenote3_beg, private.room_objname );
  cmn.AddSubscriber( "use_codenote3",     use_codenote3_end, private.room_objname );
  cmn.AddSubscriber( "use_codenote3_inv", use_codenote3_inv, private.room_objname );
  cmn.AddSubscriber( "use_codenote3_beg", use_codenote3_beg, private.room_objname );
  cmn.AddSubscriber( "use_codenote3_end", use_codenote3_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_portrait3_mmg () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_portrait3_mmg" ] =
  {
    type = "click",
    clk_obj = "obj_portrait3_clk_mmg",
    room = private.room_objname,
    zz = "zz_portrait3",
    zz_gate = "gzz_abigailshouse3_portrait3"
  };
  --------------------------------------------------------------------------------------------
  local clk_portrait3_mmg_inv = function ()


  end;
  local clk_portrait3_mmg_beg = function ()

    ObjDelete( "obj_portrait3_clk_mmg" );

  end;
  local clk_portrait3_mmg_end = function ()

    ObjSet( "obj_portrait3_mmg", { scale_x = 1, scale_y = 1 } );
    ObjSet( "obj_portrait3_buttons", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_portrait3_mmg",     clk_portrait3_mmg_inv );
  cmn.AddSubscriber( "clk_portrait3_mmg",     clk_portrait3_mmg_beg, private.room_objname );
  cmn.AddSubscriber( "clk_portrait3_mmg",     clk_portrait3_mmg_end, private.room_objname );
  cmn.AddSubscriber( "clk_portrait3_mmg_inv", clk_portrait3_mmg_inv, private.room_objname );
  cmn.AddSubscriber( "clk_portrait3_mmg_beg", clk_portrait3_mmg_beg, private.room_objname );
  cmn.AddSubscriber( "clk_portrait3_mmg_end", clk_portrait3_mmg_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_portrait3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_portrait3" ] =
  {
    type = "click",
    clk_obj = "spr_portrait3_light_1_1",
    room = private.room_objname,
    zz = "zz_portrait3",
    zz_gate = "gzz_abigailshouse3_portrait3"
  };
  --*********************************************************************************************************************
  local win_portrait3_inv = function ()

    if ( cmn.IsEventDone( "win_portrait3" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_portrait3 = function ()

    if ( cmn.IsEventDone( "win_portrait3" ) ) then
            
      ObjDelete( "gzz_abigailshouse3_portrait3" );
      ObjSet( "grm_abigailshouse3_secretroom3", { alp = 1, input = true, active = true } );     
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_abigailshouse3_secretroom3_focus");
      end;
    
      ObjSet( "spr_abigailshouse3_open_mmg", { alp = 1 } );
      ObjDelete( "spr_abigailshouse3_mmg_2" );
      ObjDelete( "spr_abigailshouse3_note" );
      
    else 

      private.Portrait3Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_portrait3", win_portrait3_inv );
  cmn.AddSubscriber( "win_portrait3", win_portrait3, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_portrait3_mmg ()

  cmn.CallEventHandler( "clk_portrait3_mmg_inv" );
  cmn.CallEventHandler( "clk_portrait3_mmg_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_portrait3_mmg" );
    cmn.CallEventHandler( "clk_portrait3_mmg_end" );
    private.Portrait3Start();

  end;

  int.Lock( true );

  ObjAnimate( "obj_portrait3_mmg", "scale_xy", 0, 0, func_end,
  {
    0.0, 3, 0, 0,
    0.3, 3, 1, 1
  } );

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function private.get_collect_2_2 ()

  int.AddCollectibles( "spr_abigailshouse3_collect_2_2" );

end;
-----------------------------------------------------------------------
function private.get_amuletgriffin3_1 ()

  cmn.SetEventDone( "get_amuletgriffin3_1" );
  cmn.CallEventHandler( "get_amuletgriffin3_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
     cmn.IsEventDone( "get_amuletcrown3" ) and 
     cmn.IsEventDone( "get_pin3" ) and 
     cmn.IsEventDone( "get_razor3" ) and 
     cmn.IsEventDone( "get_feather3" ) then


    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amuletcrown3 ()

  cmn.SetEventDone( "get_amuletcrown3" );
  cmn.CallEventHandler( "get_amuletcrown3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
     cmn.IsEventDone( "get_amuletcrown3" ) and 
     cmn.IsEventDone( "get_pin3" ) and 
     cmn.IsEventDone( "get_razor3" ) and 
     cmn.IsEventDone( "get_feather3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_pin3 ()

  cmn.SetEventDone( "get_pin3" );
  cmn.CallEventHandler( "get_pin3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
     cmn.IsEventDone( "get_amuletcrown3" ) and 
     cmn.IsEventDone( "get_pin3" ) and 
     cmn.IsEventDone( "get_razor3" ) and 
     cmn.IsEventDone( "get_feather3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_razor3 ()

  cmn.SetEventDone( "get_razor3" );
  cmn.CallEventHandler( "get_razor3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
     cmn.IsEventDone( "get_amuletcrown3" ) and 
     cmn.IsEventDone( "get_pin3" ) and 
     cmn.IsEventDone( "get_razor3" ) and 
     cmn.IsEventDone( "get_feather3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_feather3 ()

  cmn.SetEventDone( "get_feather3" );
  cmn.CallEventHandler( "get_feather3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
     cmn.IsEventDone( "get_amuletcrown3" ) and 
     cmn.IsEventDone( "get_pin3" ) and 
     cmn.IsEventDone( "get_razor3" ) and 
     cmn.IsEventDone( "get_feather3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amuletflower3 ()

  cmn.SetEventDone( "get_amuletflower3" );
  cmn.CallEventHandler( "get_amuletflower3" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_smallbox3 ()

  cmn.SetEventDone( "get_smallbox3" );
  cmn.CallEventHandler( "get_smallbox3" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_amuletflower3 ()

  local item = "inv_amuletflower3";

  if ( cmn.ApplyObj( item, "gzz_abigailshouse3_windowsill3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletflower3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowsill3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowsill3_use_amuletflower3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletflower3" ) ) then

    cmn.CallEventHandler( "use_amuletflower3_inv" );
    cmn.CallEventHandler( "use_amuletflower3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletflower3" );
      cmn.CallEventHandler( "use_amuletflower3_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_windowsill3_insert_flower" );
    ObjSet( "anm_windowsill3_click_stash", { alp = 0 } );
    ObjSet( "anm_windowsill3_amuletflower", { alp = 1 } );
    AnimPlay( "anm_windowsill3_amuletflower", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_crest3 ()

  local item = "inv_crest3";

  if ( cmn.ApplyObj( item, "gzz_abigailshouse3_windowsill3", false ) ) and
     ( not cmn.IsEventDone( "use_crest3" ) ) and  
       cmn.IsEventDone( "get_crest3_1" ) and 
       cmn.IsEventDone( "get_crest3_2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowsill3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowsill3_use_crest3", true ) ) and
         ( not cmn.IsEventDone( "use_crest3" ) ) and  
           cmn.IsEventDone( "get_crest3_1" ) and 
           cmn.IsEventDone( "get_crest3_2" ) then

    cmn.CallEventHandler( "use_crest3_inv" );
    cmn.CallEventHandler( "use_crest3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_crest3" );
      cmn.CallEventHandler( "use_crest3_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_windowsill3_insert_2_stuffs" );
    ObjSet( "anm_windowsill3_click_cap", { alp = 0 } );
    ObjSet( "anm_windowsill3_crest", { alp = 1 } );
    AnimPlay( "anm_windowsill3_crest", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_jimmy3_3 ()

  local item = "inv_jimmy3";

  if ( cmn.ApplyObj( item, "gzz_abigailshouse3_portrait3", false ) ) and
     ( not cmn.IsEventDone( "use_jimmy3_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_portrait3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_portrait3_use_jimmy3", true ) ) and
         ( not cmn.IsEventDone( "use_jimmy3_3" ) ) then

    cmn.CallEventHandler( "use_jimmy3_3_inv" );
    cmn.CallEventHandler( "use_jimmy3_3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_jimmy3_3" );
      cmn.CallEventHandler( "use_jimmy3_3_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_portrait3_broke_picture" );
    AnimPlay( "anm_portrait3_use_jimmy", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletcrown3 ()

  local item = "inv_amuletcrown3";

  if ( cmn.ApplyObj( item, "gzz_abigailshouse3_portrait3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletcrown3" ) ) and 
       cmn.IsEventDone( "get_amuletflower3" )  and      
       cmn.IsEventDone( "use_jimmy3_3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_portrait3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_portrait3_use_amuletcrown3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletcrown3" ) ) and 
           cmn.IsEventDone( "get_amuletflower3" )  and               
           cmn.IsEventDone( "use_jimmy3_3" ) then

    cmn.CallEventHandler( "use_amuletcrown3_inv" );
    cmn.CallEventHandler( "use_amuletcrown3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletcrown3" );
      cmn.CallEventHandler( "use_amuletcrown3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_portrait3_click_mmg", { alp = 0 } );
    ObjSet( "anm_portrait3_use_amuletcrown", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_portrait3_insert_wolf" );
    AnimPlay( "anm_portrait3_use_amuletcrown", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_codenote3 ()

  local item = "inv_codenote3";

  if ( cmn.ApplyObj( item, "gzz_abigailshouse3_portrait3", false ) ) and
     ( not cmn.IsEventDone( "use_codenote3" ) ) and 
       cmn.IsEventDone( "use_jimmy3_3" ) and
       cmn.IsEventDone( "use_amuletcrown3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_portrait3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_portrait3_use_codenote3", true ) ) and
         ( not cmn.IsEventDone( "use_codenote3" ) ) and 
           cmn.IsEventDone( "use_jimmy3_3" ) and 
           cmn.IsEventDone( "use_amuletcrown3" ) then

    cmn.CallEventHandler( "use_codenote3_inv" );
    cmn.CallEventHandler( "use_codenote3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_codenote3" );
      cmn.CallEventHandler( "use_codenote3_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_portrait3_put_paper" );
    ObjAnimate( "spr_portrait3_codenote", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_abigailshouse3 ()

  if not ( cmn.IsEventDone( "opn_abigailshouse3" ) ) then

    cmn.SetEventDone( "opn_abigailshouse3" );

    cmn.SetEventDone( "opn_alley3" );         
    int.VisitMapRoom( "rm_alley3" );    
    int.VisitMapRoom( "rm_abigailshouse3" );     

    interface.KeyTaskDone( true, "task_3_2" );

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_abighalehouse2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_abighalehouse2_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()
   
  private.opn_abigailshouse3();  

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( cmn.IsEventDone( "opn_alley3" ) ) then
    
    ObjDelete( "obj_abigailshouse3_stasy" );      
    ObjDelete( "obj_abigailshouse3_stasy_bbt" );          
    
  end;   

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_amuletgriffin3_1" );
  int.AddedTaskMap( private.room_objname, "get_amuletcrown3" );
  int.AddedTaskMap( private.room_objname, "get_pin3",                                               { "use_amuletflower3" } );
  int.AddedTaskMap( private.room_objname, "get_razor3",                                             { "use_amuletflower3" } );
  int.AddedTaskMap( private.room_objname, "get_feather3",                                           { "use_crest3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletflower3",                                      { "use_jimmy3_3" } );
  int.AddedTaskMap( private.room_objname, "get_smallbox3",                                          { "use_jimmy3_3" } );

  int.AddedTaskMap( private.room_objname, "use_amuletflower3",                                      { "get_amuletflower3" } );
  int.AddedTaskMap( private.room_objname, "use_crest3",                                             { "get_crest3_1", "get_crest3_2" } );
  int.AddedTaskMap( private.room_objname, "use_jimmy3_3" );
  int.AddedTaskMap( private.room_objname, "use_amuletcrown3",                                       { "get_amuletcrown3", "use_jimmy3_3", "get_amuletflower3" } );
  int.AddedTaskMap( private.room_objname, "use_codenote3",                                          { "get_codenote3", "use_amuletcrown3" } );

  int.AddedTaskMap( private.room_objname, "clk_portrait3_mmg",                                      { "use_codenote3" } );

  int.AddedTaskMap( private.room_objname, "win_portrait3",                                          { "clk_portrait3_mmg" } );

  int.AddedTaskMap( private.room_objname, "opn_secretroom3",                                        { "win_portrait3" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_portrait3" );
  -------------------------------------------------
  function zz_portrait3.Open()
    
    if ( cmn.IsEventStart( "win_portrait3" ) and not cmn.IsEventDone( "win_portrait3" ) ) then

      cmn.MiniGameShow( "portrait3" );
      common_impl.PassingMgStart( "portrait3" );

    end;

  end;
  -------------------------------------------------
  function zz_portrait3.PreClose()
        
    if ( cmn.IsEventStart( "win_portrait3" ) and not cmn.IsEventDone( "win_portrait3" ) ) then

      cmn.MiniGameHide( "portrait3" );
      common_impl.PassingMgStop( "portrait3" );

    end;
    
  end;
  -------------------------------------------------
  function zz_portrait3.Skip ()

    if ( cmn.IsEventStart( "win_portrait3" ) and not cmn.IsEventDone( "win_portrait3" ) ) then
      private.Portrait3Skip();
    end;

  end;
  -------------------------------------------------
  function zz_portrait3.Reset ()

    if ( cmn.IsEventStart( "win_portrait3" ) and not cmn.IsEventDone( "win_portrait3" ) ) then
      private.Portrait3Reset();
    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_abigailshouse3_box_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.5,
    2.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Portrait3 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Portrait3Start ()

    cmn.MiniGameShow( "portrait3" );
    common_impl.PassingMgStart( "portrait3" );
   
    ng_global.progress[ "std" ][ "win_portrait3" ].fullness = { 15, 1, 0 };--заполненность отсеков
   
  end;
  --*********************************************************************************************************************
  function private.Portrait3Load ()

    for i = 1, 3 do
      for j = 1, private.places[ i ] do
        ObjSet( "spr_portrait3_button_"..i.."_"..j, { alp = 0 } );
      end;
    end; 

    for i = 1, 3 do
      if ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ i ] ~= 0 then
        for j = 1, ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ i ] do
          ObjSet( "spr_portrait3_button_"..i.."_"..j, { alp = 1 } );
        end;
      end;
    end; 

    private.Portrait3InputSet();

  end;
  --*********************************************************************************************************************
  function private.Portrait3Skip ()

    int.Lock( true );

    for i = 1, 3 do
      for j = 1, private.places[ i ] do
        ObjSet( "spr_portrait3_button_"..i.."_"..j, { alp = 0 } );
      end;
    end; 

    for i = 1, 3 do
      if private.win[ i ] ~= 0 then
        for j = 1, private.win[ i ] do
          ObjSet( "spr_portrait3_button_"..i.."_"..j, { alp = 1 } );
        end;
      end;
    end; 

    private.Portrait3Win();
    
  end
  --*********************************************************************************************************************
  function private.Portrait3Reset ()

    ng_global.progress[ "std" ][ "win_portrait3" ].fullness = { 15, 1, 0 };

    for i = 1, 3 do
      for j = 1, private.places[ i ] do
        ObjSet( "spr_portrait3_button_"..i.."_"..j, { alp = 0 } );
      end;
    end; 

    for i = 1, 3 do
      if ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ i ] ~= 0 then
        for j = 1, ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ i ] do
          ObjSet( "spr_portrait3_button_"..i.."_"..j, { alp = 1 } );
        end;
      end;
    end; 

    private.Portrait3InputSet();

  end;
  --*********************************************************************************************************************
  function private.Portrait3Init ()
      
    for i = 1, 3 do

      for j = 1, 2 do

        ObjSet( "spr_portrait3_light_"..i.."_"..j,
        {
          event_mdown  = function () private.Portrait3ButtonClk( i, j ) end,
          event_menter = function () cmn.SetCursor( CURSOR_HAND ); ObjSet( "spr_portrait3_light_"..i.."_"..j, { alp = 1 } ) end,
          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); ObjSet( "spr_portrait3_light_"..i.."_"..j, { alp = 0 } ) end,
        } );

      end;

    end;
     
    private.places = { 16, 9, 7 };--сколько мест в отсеках
    private.win = { 8, 8, 0 };
      
  end; 
  --*********************************************************************************************************************
  function private.Portrait3ButtonClk ( id1, id2 ) 

    local rnd = math.random( 3 );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_portrait_click"..rnd );

    local compartment1 = id1;
    local compartment2 = compartment1 + 1;

    if compartment1 == 3 then
      compartment2 = 1;
    end;

    if id2 == 2 then--если обратное направление
      local tmp = compartment1;
      compartment1 = compartment2;
      compartment2 = tmp;
    end; 

    local taken;

    local free_places = private.places[ compartment2 ] - ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment2 ];--сколько свободных ячеек в отсеке, куда переносим алмазы 

    if free_places >= ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment1 ] then
      taken = ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment1 ];--сколько алмазов берем из забираемого отсека
    else
      taken = free_places;
    end;

    if taken ~= 0 then

      int.Lock( true );

      for i = ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment1 ], ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment1 ] - taken + 1, - 1 do 

        ObjAnimate( "spr_portrait3_button_"..compartment1.."_"..i, "alp", 0, 0, "", 
        { 
          0.0, 0, 1,
          0.3, 0, 0,
        } );

      end;

      for i = ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment2 ] + 1, ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment2 ] + taken do 

        local func_end = function ()

          if i == ( ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment2 ] + taken ) then

            local tmp = { 0, 0, 0 };
            for i = 1, 3 do
              tmp[ i ] = ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ i ]; 
            end;

            tmp[ compartment1 ] = ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment1 ] - taken;
            tmp[ compartment2 ] = ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment2 ] + taken;

            local win = true;
            for i = 1, 3 do
              if tmp[ i ] ~= private.win[ i ] then
                win = false;
                break;
              end;
            end;
            
            if win then

              private.Portrait3Win();

            else

              int.Lock( false );
              ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment1 ] = tmp[ compartment1 ];
              ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment2 ] = tmp[ compartment2 ];
              private.Portrait3InputSet();

            end;

          end;

        end;

        ObjAnimate( "spr_portrait3_button_"..compartment2.."_"..i, "alp", 0, 0, func_end, 
        { 
          0.0, 0, 0,
          0.3, 0, 1,
        } );

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.Portrait3InputSet ()

    for i = 1, 3 do

      for j = 1, 2 do

        ObjSet( "spr_portrait3_light_"..i.."_"..j, { input = true } );

      end;

    end;

    for i = 1, 3 do

      for j = 1, 2 do

        local compartment1 = i;
        local compartment2 = compartment1 + 1;

        if compartment1 == 3 then
          compartment2 = 1;
        end;

        if j == 2 then--если обратное направление
          local tmp = compartment1;
          compartment1 = compartment2;
          compartment2 = tmp;
        end; 

        local taken;

        local free_places = private.places[ compartment2 ] - ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment2 ];--сколько свободных ячеек в отсеке, куда переносим алмазы 

        if free_places >= ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment1 ] then
          taken = ng_global.progress[ "std" ][ "win_portrait3" ].fullness[ compartment1 ];--сколько алмазов берем из забираемого отсека
        else
          taken = free_places;
        end;

        if taken == 0 then
          ObjSet( "spr_portrait3_light_"..i.."_"..j, { input = false } );
        end;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.Portrait3Win () 

    local func_end = function ()

      cmn.MiniGameHide( "portrait3" );
      cmn.SetEventDone( "win_portrait3" );
      cmn.CallEventHandler( "win_portrait3" );
      common_impl.PassingMgWin( "portrait3" );
      cmn.CloseSubRoom();

    end;      

    ObjAnimate( "obj_portrait3_mmg", "scale_xy", 0, 0, func_end,
    {
      0.0, 3, 1, 1,
      0.7, 3, 1, 1,
      1.0, 3, 0, 0,
      1.7, 3, 0, 0
    } );
       
  end;
--*********************************************************************************************************************
function private.Portrait3Clk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_portrait3_use_jimmy3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_picture_zz_portrait3" );
  ObjAnimate( "obj_portrait3_close", "pos_x", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, 1,
    0.4, 3, 0,
    0.6, 3, 1,
    0.8, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.Portrait3AmuletcrownClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_portrait3_use_amuletcrown3" );

    if not cmn.IsEventDone( "get_amuletflower3" ) then
      ObjSet( "anm_portrait3_click_mmg_amuletflower", { alp = 0 } );
      ObjSet( "anm_portrait3_click_mmg", { alp = 1 } );
      ObjSet( "spr_portrait3_amuletflower3", { alp = 1 } );
    end;

    int.Lock( false );
    
  end;
  
  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_portrait3_future_mmg" );
  if not cmn.IsEventDone( "get_amuletflower3" ) then
    ObjSet( "anm_portrait3_click_mmg_amuletflower", { alp = 1 } );
    ObjSet( "anm_portrait3_click_mmg", { alp = 0 } );
    ObjSet( "spr_portrait3_amuletflower3", { alp = 0 } );
    AnimPlay( "anm_portrait3_click_mmg_amuletflower", "DoAnim", func_end ); 
  else
    AnimPlay( "anm_portrait3_click_mmg", "DoAnim", func_end );
  end;

end;
--*********************************************************************************************************************
function private.Portrait3CodenoteClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_portrait3_use_codenote3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_portrait3_future_mmg" );
  AnimPlay( "anm_portrait3_click_handle", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.Windowsill3CrestClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_windowsill3_use_crest3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_windowsill3_cell" );
  AnimPlay( "anm_windowsill3_click_cap", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.Windowsill3AmuletflowerClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_windowsill3_use_amuletflower3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_windowsill3_down_cell" );
  AnimPlay( "anm_windowsill3_click_stash", "DoAnim", func_end ); 

end;
 --*********************************************************************************************************************    