-- name=rm_alley3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_alley3";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_carriage3", "room_hub" );

  ObjMultiSet(
  {
    { "spr_carriage3_mermaidstatue3", { event_mdown = private.get_mermaidstatue3 } },
    { "spr_carriage3_cane3",          { event_mdown = private.get_cane3 } },
    { "spr_carriage3_bunchofkeys3",   { event_mdown = private.get_bunchofkeys3 } },
    { "spr_carriage3_amuletlapwing3", { event_mdown = private.get_amuletlapwing3 } },
    { "spr_carriage3_amulethydra3_2", { event_mdown = private.get_amulethydra3_2 } },
    { "obj_carriage3_door_clk",       { event_mdown = function() private.clk_carriage3_door() end } },
    { "spr_alley3_collect_2_1",       { event_mdown = private.get_collect_2_1 } },
    { "obj_carriage3_use_amulettree3",{ event_mdown = function() private.Carriage3AmulettreeClk() end } },
    { "obj_carriage3_use_amuletchimera3",  { event_mdown = function() private.Carriage3DoorCapClk() end } },
    { "obj_carriage3_use_scalpel3_1",      { event_mdown = function() private.Carriage3BagClk() end } },
  } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_alley3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_alley3", update_game_mode_alley3, private.room_objname );  

 
  
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function opn_alley3 () end;
  --------------------------------------------------------------------------------------------
  local opn_alley3 = function ()

    if ( cmn.IsEventDone( "use_gear3" ) ) and
       ( cmn.IsEventDone( "use_card3" ) ) then
      
       ObjSet( "spr_alley3_carriage", { alp = 0 } );      
      
    end;

  end;

  cmn.AddSubscriber( "opn_alley3", opn_alley3, private.room_objname );   
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_1 = function ()

    ObjDelete( "spr_alley3_collect_2_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_2_1", get_collect_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_2 = function ()

    ObjDelete( "obj_alley3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_2", get_morphobject_2_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mermaidstatue3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mermaidstatue3" ] =
  {
    type = "get",
    get_obj = "spr_carriage3_mermaidstatue3",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  --------------------------------------------------------------------------------------------
  local get_mermaidstatue3_inv = function ()

    int.InventoryItemAdd( "inv_mermaidstatue3", "spr_carriage3_mermaidstatue3" );

  end;
  local get_mermaidstatue3_closezz = function ()

    ObjDelete( "gfx_carriage3_mermaidstatue3" );

    ObjDelete( "spr_alley3_carriage_mermaidstatue" );
    --ObjDelete( "gzz_alley3_carriage3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mermaidstatue3", get_mermaidstatue3_inv );
  cmn.AddSubscriber( "get_mermaidstatue3", get_mermaidstatue3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cane3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cane3" ] =
  {
    type = "get",
    get_obj = "spr_carriage3_cane3",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  --------------------------------------------------------------------------------------------
  local get_cane3_inv = function ()

    int.InventoryItemAdd( "inv_cane3", "spr_carriage3_cane3" );

  end;
  local get_cane3_closezz = function ()

    ObjDelete( "gfx_carriage3_cane3" );

    if cmn.IsEventDone( "get_mermaidstatue3" ) and 
       cmn.IsEventDone( "get_bunchofkeys3" ) and 
       cmn.IsEventDone( "get_amuletlapwing3" ) and  
       cmn.IsEventDone( "get_amulethydra3_2" ) then

      ObjDelete( "gzz_alley3_carriage3" );

    end;

    ObjDelete( "spr_alley3_carriage_cane" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_cane3", get_cane3_inv );
  cmn.AddSubscriber( "get_cane3", get_cane3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bunchofkeys3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bunchofkeys3" ] =
  {
    type = "get",
    get_obj = "spr_carriage3_bunchofkeys3",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  --------------------------------------------------------------------------------------------
  local get_bunchofkeys3_inv = function ()

    int.InventoryItemAdd( "inv_bunchofkeys3", "spr_carriage3_bunchofkeys3" );

  end;
  local get_bunchofkeys3_closezz = function ()

    ObjDelete( "gfx_carriage3_bunchofkeys3" );

    if cmn.IsEventDone( "get_mermaidstatue3" ) and 
       cmn.IsEventDone( "get_cane3" ) and 
       cmn.IsEventDone( "get_amuletlapwing3" ) and  
       cmn.IsEventDone( "get_amulethydra3_2" ) then

      ObjDelete( "gzz_alley3_carriage3" );

    end;

    ObjDelete( "spr_alley3_carriage_bunchofkeys" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bunchofkeys3", get_bunchofkeys3_inv );
  cmn.AddSubscriber( "get_bunchofkeys3", get_bunchofkeys3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletlapwing3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletlapwing3" ] =
  {
    type = "get",
    get_obj = "spr_carriage3_amuletlapwing3",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletlapwing3_inv = function ()

    int.InventoryItemAdd( "inv_amuletlapwing3", "spr_carriage3_amuletlapwing3" );

  end;
  local get_amuletlapwing3_closezz = function ()

    ObjDelete( "gfx_carriage3_amuletlapwing3" );

    if cmn.IsEventDone( "get_mermaidstatue3" ) and 
       cmn.IsEventDone( "get_cane3" ) and 
       cmn.IsEventDone( "get_bunchofkeys3" ) and  
       cmn.IsEventDone( "get_amulethydra3_2" ) then

      ObjDelete( "gzz_alley3_carriage3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletlapwing3", get_amuletlapwing3_inv );
  cmn.AddSubscriber( "get_amuletlapwing3", get_amuletlapwing3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulethydra3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulethydra3_2" ] =
  {
    type = "get",
    get_obj = "spr_carriage3_amulethydra3_2",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  --------------------------------------------------------------------------------------------
  local get_amulethydra3_2_inv = function ()

    int.InventoryItemAdd( "inv_amulethydra3", "spr_carriage3_amulethydra3_2", "assets/levels/level3/rm_park3/zz_fountain3/inv/inv_amulethydra3_2" );
    level3_inv.CheckAmulethydra3();

  end;
  local get_amulethydra3_2_closezz = function ()

    ObjDelete( "gfx_carriage3_amulethydra3_2" );

    if cmn.IsEventDone( "get_mermaidstatue3" ) and 
       cmn.IsEventDone( "get_cane3" ) and 
       cmn.IsEventDone( "get_bunchofkeys3" ) and  
       cmn.IsEventDone( "get_amuletlapwing3" ) then

      ObjDelete( "gzz_alley3_carriage3" );

    end;

    ObjDelete( "spr_alley3_carriage_amulethydra" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amulethydra3_2", get_amulethydra3_2_inv );
  cmn.AddSubscriber( "get_amulethydra3_2", get_amulethydra3_2_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_amulettree3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amulettree3" ] =
  {
    type = "use",
    use_obj = "inv_amulettree3",
    use_place = "obj_carriage3_use_amulettree3",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  --------------------------------------------------------------------------------------------
  local use_amulettree3_inv = function ()

    int.InventoryItemRemove( "inv_amulettree3" );

  end;
  local use_amulettree3_beg = function ()

    ObjDelete( "obj_carriage3_use_amulettree3" );

  end;
  local use_amulettree3_end = function ()

    ObjSet( "anm_carriage3_use_amulettree", { frame = 500 } );
    ObjSet( "spr_carriage3_cane3", { input = true } );
    ObjSet( "gfx_carriage3_cane3", { active = true } );

    ObjSet( "spr_alley3_carriage_opncashe", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amulettree3",     use_amulettree3_inv );
  cmn.AddSubscriber( "use_amulettree3",     use_amulettree3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulettree3",     use_amulettree3_end, private.room_objname );
  cmn.AddSubscriber( "use_amulettree3_inv", use_amulettree3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amulettree3_beg", use_amulettree3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulettree3_end", use_amulettree3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletchimera3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletchimera3" ] =
  {
    type = "use",
    use_obj = "inv_amuletchimera3",
    use_place = "obj_carriage3_use_amuletchimera3",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletchimera3_inv = function ()

    int.InventoryItemRemove( "inv_amuletchimera3" );

  end;
  local use_amuletchimera3_beg = function ()

    ObjDelete( "obj_carriage3_use_amuletchimera3" );

  end;
  local use_amuletchimera3_end = function ()

    ObjDelete( "obj_carriage3_door_cap" );

    ObjSet( "spr_carriage3_bunchofkeys3", { input = true } );
    ObjSet( "gfx_carriage3_bunchofkeys3", { active = true } );
    ObjSet( "anm_carriage3_doorcashe_open", { alp = 1, frame = 500 } );

    ObjSet( "spr_alley3_carriage_amuletlion2", { alp = 1 } );
    ObjSet( "spr_alley3_carriage_amuletlion1", { alp = 1 } );
    ObjSet( "spr_alley3_carriage_cashedoor", { pos_x = 4, pos_y = 17 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletchimera3",     use_amuletchimera3_inv );
  cmn.AddSubscriber( "use_amuletchimera3",     use_amuletchimera3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletchimera3",     use_amuletchimera3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletchimera3_inv", use_amuletchimera3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletchimera3_beg", use_amuletchimera3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletchimera3_end", use_amuletchimera3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scalpel3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scalpel3_1" ] =
  {
    type = "use",
    use_obj = "inv_scalpel3",
    use_place = "obj_carriage3_use_scalpel3_1",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  --------------------------------------------------------------------------------------------
  local use_scalpel3_1_inv = function ()

    if ( cmn.IsEventDone( "use_scalpel3_2" ) ) then

      int.InventoryItemRemove( "inv_scalpel3" );

    end;

  end;
  local use_scalpel3_1_beg = function ()

    ObjDelete( "obj_carriage3_use_scalpel3_1" );

  end;
  local use_scalpel3_1_end = function ()

    ObjSet( "obj_carriage3_bag_open", { alp = 1, input = true } );
    ObjSet( "gfx_carriage3_amuletlapwing3", { active = true } );
    ObjSet( "gfx_carriage3_amulethydra3_2", { active = true } );
    ObjDelete( "obj_carriage3_bag_close" );

    ObjSet( "spr_alley3_carriage_bagopn", { alp = 1 } );
    ObjSet( "spr_alley3_carriage_amulethydra", { alp = 1 } );
    ObjDelete( "spr_alley3_carriage_bag" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scalpel3_1",     use_scalpel3_1_inv );
  cmn.AddSubscriber( "use_scalpel3_1",     use_scalpel3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalpel3_1",     use_scalpel3_1_end, private.room_objname );
  cmn.AddSubscriber( "use_scalpel3_1_inv", use_scalpel3_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_scalpel3_1_beg", use_scalpel3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalpel3_1_end", use_scalpel3_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_victorpapers3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_victorpapers3" ] =
  {
    type = "use",
    use_obj = "inv_victorpapers3",
    use_place = "obj_alley3_use_victorpapers3",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local use_victorpapers3_inv = function ()

    int.InventoryItemRemove( "inv_victorpapers3" );

  end;
  local use_victorpapers3_beg = function ()

    ObjDelete( "obj_alley3_use_victorpapers3" );

  end;
  local use_victorpapers3_end = function ()

    ObjSet( "obj_alley3_carriage3", { alp = 1 } );
    ObjSet( "grm_alley3_park3", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_alley3_park3_focus");
    end;
    ObjSet( "gzz_alley3_carriage3", { alp = 1, input = true, active = true } );
    ObjSet( "obj_alley3_stacy_bbt", { input = true } );

    ObjSet( "spr_alley3_carriage_light", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_victorpapers3",     use_victorpapers3_inv );
  cmn.AddSubscriber( "use_victorpapers3",     use_victorpapers3_beg, private.room_objname );
  cmn.AddSubscriber( "use_victorpapers3",     use_victorpapers3_end, private.room_objname );
  cmn.AddSubscriber( "use_victorpapers3_inv", use_victorpapers3_inv, private.room_objname );
  cmn.AddSubscriber( "use_victorpapers3_beg", use_victorpapers3_beg, private.room_objname );
  cmn.AddSubscriber( "use_victorpapers3_end", use_victorpapers3_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_carriage3_door () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_carriage3_door" ] =
  {
    type = "click",
    clk_obj = "obj_carriage3_door_clk",
    room = private.room_objname,
    zz = "zz_carriage3",
    zz_gate = "gzz_alley3_carriage3"
  };
  -----------------------------------------------
  local clk_carriage3_door_inv = function ()

  end;
  local clk_carriage3_door_beg = function ()

    ObjDelete( "obj_carriage3_door_clk" );

  end;
  local clk_carriage3_door_end = function ()

    ObjDelete( "obj_carriage3_close" );
    ObjSet( "obj_carriage3_open", { alp = 1, input = true } );

    ObjSet( "obj_carriage3_use_amulettree3", { input = true } );
    ObjSet( "obj_carriage3_use_amuletchimera3", { input = true } );
    ObjSet( "obj_carriage3_use_scalpel3_1", { input = true } );

    ObjSet( "anm_carriage3_rag", { playing = true } );

    ObjSet( "obj_alley3_carriage3_open", { alp = 1 } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_carriage3_door",     clk_carriage3_door_inv );
  cmn.AddSubscriber( "clk_carriage3_door",     clk_carriage3_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carriage3_door",     clk_carriage3_door_end, private.room_objname );
  cmn.AddSubscriber( "clk_carriage3_door_inv", clk_carriage3_door_inv, private.room_objname );
  cmn.AddSubscriber( "clk_carriage3_door_beg", clk_carriage3_door_beg, private.room_objname );
  cmn.AddSubscriber( "clk_carriage3_door_end", clk_carriage3_door_end, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------------------------------
function private.get_collect_2_1 ()

  int.AddCollectibles( "spr_alley3_collect_2_1" );

end;
-----------------------------------------------------------------------
function private.get_mermaidstatue3 ()

  cmn.SetEventDone( "get_mermaidstatue3" );
  cmn.CallEventHandler( "get_mermaidstatue3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_cane3" ) and 
     cmn.IsEventDone( "get_bunchofkeys3" ) and 
     cmn.IsEventDone( "get_amuletlapwing3" ) and  
     cmn.IsEventDone( "get_amulethydra3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_cane3 ()

  cmn.SetEventDone( "get_cane3" );
  cmn.CallEventHandler( "get_cane3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_mermaidstatue3" ) and 
     cmn.IsEventDone( "get_bunchofkeys3" ) and 
     cmn.IsEventDone( "get_amuletlapwing3" ) and  
     cmn.IsEventDone( "get_amulethydra3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_bunchofkeys3 ()

  cmn.SetEventDone( "get_bunchofkeys3" );
  cmn.CallEventHandler( "get_bunchofkeys3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_mermaidstatue3" ) and 
     cmn.IsEventDone( "get_cane3" ) and 
     cmn.IsEventDone( "get_amuletlapwing3" ) and  
     cmn.IsEventDone( "get_amulethydra3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amuletlapwing3 ()

  cmn.SetEventDone( "get_amuletlapwing3" );
  cmn.CallEventHandler( "get_amuletlapwing3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_mermaidstatue3" ) and 
     cmn.IsEventDone( "get_cane3" ) and 
     cmn.IsEventDone( "get_bunchofkeys3" ) and  
     cmn.IsEventDone( "get_amulethydra3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amulethydra3_2 ()

  cmn.SetEventDone( "get_amulethydra3_2" );
  cmn.CallEventHandler( "get_amulethydra3_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_mermaidstatue3" ) and 
     cmn.IsEventDone( "get_cane3" ) and 
     cmn.IsEventDone( "get_bunchofkeys3" ) and  
     cmn.IsEventDone( "get_amuletlapwing3" ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_amulettree3 ()

  local item = "inv_amulettree3";

  if ( cmn.ApplyObj( item, "gzz_alley3_carriage3", false ) ) and
     ( not cmn.IsEventDone( "use_amulettree3" ) ) and 
       cmn.IsEventDone( "clk_carriage3_door" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_carriage3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carriage3_use_amulettree3", true ) ) and
         ( not cmn.IsEventDone( "use_amulettree3" ) ) and 
           cmn.IsEventDone( "clk_carriage3_door" ) then

    cmn.CallEventHandler( "use_amulettree3_inv" );
    cmn.CallEventHandler( "use_amulettree3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amulettree3" );
      cmn.CallEventHandler( "use_amulettree3_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_carriage3_insert_tree" );
    AnimPlay( "anm_carriage3_use_amulettree", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletchimera3 ()

  local item = "inv_amuletchimera3";

  if ( cmn.ApplyObj( item, "gzz_alley3_carriage3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletchimera3" ) ) and 
       cmn.IsEventDone( "get_amuletchimera3_1" ) and 
       cmn.IsEventDone( "get_amuletchimera3_2" ) and 
       cmn.IsEventDone( "clk_carriage3_door" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_carriage3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carriage3_use_amuletchimera3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletchimera3" ) ) and 
           cmn.IsEventDone( "get_amuletchimera3_1" ) and 
           cmn.IsEventDone( "get_amuletchimera3_2" ) and 
           cmn.IsEventDone( "clk_carriage3_door" ) then

    cmn.CallEventHandler( "use_amuletchimera3_inv" );
    cmn.CallEventHandler( "use_amuletchimera3_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_amuletchimera3" );
        cmn.CallEventHandler( "use_amuletchimera3_end" );

      end;

      ObjSet( "anm_carriage3_doorcashe_open", { alp = 1 } );
      ObjSet( "obj_carriage3_door_cap", { alp = 0 } );
      AnimPlay( "anm_carriage3_doorcashe_open", "DoAnim", func_end1 ); 

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_carriage3_insert_hidden_cell_door" );
    ObjAnimate( "spr_carriage3_amuletchimera_1", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    ObjAnimate( "spr_carriage3_amuletchimera_2", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
      0.6, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_scalpel3_1 ()

  local item = "inv_scalpel3";

  if ( cmn.ApplyObj( item, "gzz_alley3_carriage3", false ) ) and
     ( not cmn.IsEventDone( "use_scalpel3_1" ) ) and 
       cmn.IsEventDone( "clk_carriage3_door" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_carriage3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_carriage3_use_scalpel3_1", true ) ) and
         ( not cmn.IsEventDone( "use_scalpel3_1" ) ) and 
           cmn.IsEventDone( "clk_carriage3_door" ) then

    cmn.CallEventHandler( "use_scalpel3_1_inv" );
    cmn.CallEventHandler( "use_scalpel3_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_scalpel3_1" );
      cmn.CallEventHandler( "use_scalpel3_1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_carriage3_bag_click", { alp = 0 } );
    ObjSet( "anm_carriage3_use_scalpel", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_carriage3_cut" );
    AnimPlay( "anm_carriage3_use_scalpel", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_victorpapers3 ()

  local item = "inv_victorpapers3";

  if ( cmn.ApplyObj( item, "obj_alley3_use_victorpapers3", true ) ) and
         ( not cmn.IsEventDone( "use_victorpapers3" ) ) then

    cmn.CallEventHandler( "use_victorpapers3_inv" );
    cmn.CallEventHandler( "use_victorpapers3_beg" );

    local func_end = function ()

      private.VidGate();

    end;

    int.Lock( true );

    --ObjAnimate( "spr_alley3_victorpapers3", "alp", 0, 0, func_end,
    --{
    --  0.0, 3, 0.0,
    --  0.3, 3, 1.0,
    --} );

    func_end();
    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
-----------------------------------------------------------------------
function private.clk_carriage3_door ()

  cmn.CallEventHandler( "clk_carriage3_door_inv" );
  cmn.CallEventHandler( "clk_carriage3_door_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_carriage3_door" );
    cmn.CallEventHandler( "clk_carriage3_door_end" );

  end;

  int.Lock( true );

  ObjAnimate( "obj_carriage3_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.3, 0, 1,
  } );
  ObjAnimate( "obj_carriage3_close", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 1,
    0.3, 0, 0,
  } );
  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_carriage3_iopen_door" );

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
function private.opn_alley3 ()

  if not ( cmn.IsEventDone( "opn_alley3" ) ) then

    cmn.SetEventDone( "opn_alley3" );
    cmn.CallEventHandler( "opn_alley3" );

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_alley2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_alley2_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_alley3();

end;
--*********************************************************************************************************************
function private.VidGate()

  local func_end = function ( skip )

    int.Lock( false );
    cmn.SetEventDone( "use_victorpapers3" );
    cmn.CallEventHandler( "use_victorpapers3_end" );
    
    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      cmn.StopAudio( "voc", "audio/level3/voc/aud_lvl3_vid_gates_voc" );
      cmn.StopAudio( "mus", "audio/level3/mus/aud_vid_alley3_gate_mus" );
    end;

    --cmn.PlayAudio( "env", "audio/level1/env/aud_rm_prison2_env", 1 );
    --cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );

    interface.KeyTaskDone( true, "task_3_3" );

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_alley3_gate", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  cmn.PlayAudio( "voc", "audio/level3/voc/aud_lvl3_vid_gates_voc" );
  cmn.PlayAudio( "mus", "audio/level3/mus/aud_vid_alley3_gate_mus" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_mermaidstatue3",                              { "clk_carriage3_door" } );
  int.AddedTaskMap( private.room_objname, "get_cane3",                                       { "use_amulettree3" } );
  int.AddedTaskMap( private.room_objname, "get_bunchofkeys3",                                { "use_amuletchimera3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletlapwing3",                              { "use_scalpel3_1" } );
  int.AddedTaskMap( private.room_objname, "get_amulethydra3_2",                              { "use_scalpel3_1" } );

  int.AddedTaskMap( private.room_objname, "use_amulettree3",                                 { "get_amulettree3", "clk_carriage3_door" } );
  int.AddedTaskMap( private.room_objname, "use_amuletchimera3",                              { "get_amuletchimera3_1", "get_amuletchimera3_2", "clk_carriage3_door" } );
  int.AddedTaskMap( private.room_objname, "use_scalpel3_1",                                  { "get_scalpel3", "clk_carriage3_door" } );
  int.AddedTaskMap( private.room_objname, "use_victorpapers3",                               { "win_hotreasury3" } );

  int.AddedTaskMap( private.room_objname, "clk_carriage3_door",                              { "use_victorpapers3" } );

  int.AddedTaskMap( private.room_objname, "opn_park3",                                       { "use_victorpapers3" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_carriage3" );
  -----------------------------------------------
  function zz_carriage3.Close ()

    if cmn.IsEventDone( "clk_carriage3_door" ) then
      cmn.NoteScaleEnd( { "spr_carriage3_note" }, true );
    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_carriage3_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  ObjAnimate( "spr_alley3_carriage_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.Carriage3DoorCapClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_carriage3_use_amuletchimera3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_carriage3_hidden_cell" );
  ObjAnimate( "obj_carriage3_door_box", "pos_x", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, -1,
    0.4, 3, 0,
    0.6, 3, -1,
    0.8, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.Carriage3AmulettreeClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_carriage3_use_amulettree3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_carriage3_box_down" );
  ObjAnimate( "anm_carriage3_use_amulettree", "pos_y", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, 2,
    0.4, 3, 0,
    0.6, 3, 2,
    0.8, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.Carriage3BagClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_carriage3_use_scalpel3_1" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_carriage3_pouch" );
  AnimPlay( "anm_carriage3_bag_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************