-- name=rm_lab3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_lab3";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_storage3",       "room_hub" );
  ObjAttach( "zz_windowopening3", "room_hub" );
  ObjAttach( "zz_autoclave3",     "room_hub" );
  ObjAttach( "zz_shelvings3",     "room_hub" );
  ObjAttach( "zz_device3",        "room_hub" );

  ObjMultiSet(
  {
    { "spr_lab3_amuletangel3_2",           { event_mdown = private.get_amuletangel3_2 } },
    { "spr_windowopening3_wrench3",        { event_mdown = private.get_wrench3 } },
    { "spr_storage3_glasscutter3",         { event_mdown = private.get_glasscutter3 } },
    { "spr_storage3_bellows3",             { event_mdown = private.get_bellows3 } },
    { "spr_windowopening3_gunpowder3",     { event_mdown = private.get_gunpowder3 } },
    { "spr_windowopening3_amuletomega3_2", { event_mdown = private.get_amuletomega3_2 } },
    { "spr_autoclave3_coals3",             { event_mdown = private.get_coals3 } },
    { "spr_autoclave3_lace3",              { event_mdown = private.get_lace3 } },
    { "spr_autoclave3_gasbombs3",          { event_mdown = private.get_gasbombs3 } },
    { "spr_shelvings3_crystal3",           { event_mdown = private.get_crystal3 } },
    { "spr_shelvings3_chisel3",            { event_mdown = private.get_chisel3 } },
    { "spr_shelvings3_roundnosepliers3",   { event_mdown = private.get_roundnosepliers3 } },
    { "spr_device3_amulethypercube3",      { event_mdown = private.get_amulethypercube3 } },
    { "spr_device3_capsule3",              { event_mdown = private.get_capsule3 } },
    { "obj_autoclave3_use_scalpel3_2",     { event_mdown = private.Autoclave3BombClick } },
    { "spr_windowopening3_ho_1",           { event_dragdrop = function() private.use_butterflypart3_1() end } },
    { "spr_windowopening3_ho_2",           { event_dragdrop = function() private.use_butterflypart3_2() end } },
    { "spr_windowopening3_ho_3",           { event_dragdrop = function() private.use_butterflypart3_3() end } },
    { "spr_windowopening3_ho_1",           { event_mdown = function() private.Windowopening3ButterflyPartClk( 1 ) end } },
    { "spr_windowopening3_ho_2",           { event_mdown = function() private.Windowopening3ButterflyPartClk( 2 ) end } },
    { "spr_windowopening3_ho_3",           { event_mdown = function() private.Windowopening3ButterflyPartClk( 3 ) end } },
    { "obj_windowopening3_get_amuletbutterfly",      { event_mdown = function() private.get_amuletbutterfly3() end } },
    { "obj_storage3_use_amuletbutterfly3",           { event_mdown = function() private.Storage3AmuletbutterflyClk() end } },
    { "obj_storage3_use_hexagram3",                  { event_mdown = function() private.Storage3HexagramClk() end } },
    { "obj_shelvings3_use_amuletomega3",             { event_mdown = function() private.Shelvings3AmuletomegaClk() end } },
    { "obj_shelvings3_use_amuletgorgon3",            { event_mdown = function() private.Shelvings3AmuletgorgonClk() end } },
    { "obj_autoclave3_clk_button",                   { event_mdown = function() private.clk_autoclave3_button() end } },
    { "spr_storage3_icarusfigurine3",                { event_mdown = function() private.get_icarusfigurine3() end } },
    { "spr_storage3_reagents3",                      { event_mdown = function() private.get_reagents3() end } },
    { "obj_windowopening3_use_amuletaxes3",          { event_mdown = function() private.Windowopening3CapClk() end } },
    { "obj_autoclave3_diary_click_right",         { event_mdown = function() private.Autoclave3DiaryClick(1) end } }, 
    { "obj_autoclave3_diary_click_left",                { event_mdown = function() private.Autoclave3DiaryClick(-1) end } }, 
    { "spr_autoclave3_diary",                { event_mdown = function() cmn.NoteScale( { "spr_autoclave3_diary" } );private.Autoclave3DiaryClick(0); end } },       
    { "spr_shelvings3_screensaver_2_15",     { event_mdown = private.get_screensaver_2_15 } },      
    { "spr_autoclave3_screensaver_2_16",     { event_mdown = private.get_screensaver_2_16 } },          
  } );
  local get_screensaver_2_15 = function ()

    ObjDelete( "spr_shelvings3_screensaver_2_15" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_15", get_screensaver_2_15, private.room_objname );  
  local get_screensaver_2_16 = function ()

    ObjDelete( "spr_autoclave3_screensaver_2_16" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_16", get_screensaver_2_16, private.room_objname );  

  private.Windowopening3Init();
  
  private.autoclave3_page_diary = 1;  

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_lab3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_lab3", update_game_mode_lab3, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function opn_lab3 () end;
  --------------------------------------------------------------------------------------------
  local opn_lab3 = function ()

    ObjDelete( "anm_lab3_bomb_plant" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_lab3", opn_lab3, private.room_objname );    
  --------------------------------------------------------------------------------------------  
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_1 = function ()

    ObjDelete( "obj_lab3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_3_1", get_morphobject_3_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletangel3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletangel3_2" ] =
  {
    type = "get",
    get_obj = "spr_lab3_amuletangel3_2",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local get_amuletangel3_2_inv = function ()

    int.InventoryItemAdd( "inv_amuletangel3", "spr_lab3_amuletangel3_2", "assets/levels/level3/rm_towerroof3/zz_revitalizer3/inv/inv_amuletangel3_2" );
    level3_inv.CheckAmuletAngel3( 2 );

  end;
  local get_amuletangel3_2_closezz = function ()

    ObjDelete( "spr_lab3_amuletangel3_2_shadow" );
    ObjDelete( "gfx_lab3_amuletangel3_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletangel3_2", get_amuletangel3_2_inv );
  cmn.AddSubscriber( "get_amuletangel3_2", get_amuletangel3_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wrench3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wrench3" ] =
  {
    type = "get",
    get_obj = "spr_windowopening3_wrench3",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --------------------------------------------------------------------------------------------
  local get_wrench3_inv = function ()

    int.InventoryItemAdd( "inv_wrench3", "spr_windowopening3_wrench3" );

    if ( cmn.IsEventDone( "get_capsule3" ) ) then

      ObjSet( "inv_capsule3_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_wrench3_closezz = function ()

    ObjDelete( "gfx_windowopening3_wrench3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_wrench3", get_wrench3_inv );
  cmn.AddSubscriber( "get_wrench3", get_wrench3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glasscutter3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glasscutter3" ] =
  {
    type = "get",
    get_obj = "spr_storage3_glasscutter3",
    room = private.room_objname,
    zz = "zz_storage3",
    zz_gate = "gzz_lab3_storage3"
  };
  --------------------------------------------------------------------------------------------
  local get_glasscutter3_inv = function ()

    int.InventoryItemAdd( "inv_glasscutter3", "spr_storage3_glasscutter3" );

    if ( cmn.IsEventDone( "get_abovedoorsign3" ) ) then

      ObjSet( "inv_abovedoorsign3_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_glasscutter3_closezz = function ()

    ObjDelete( "gfx_storage3_glasscutter3" );
    ObjDelete( "spr_lab3_glasscutter" );
    --ObjDelete( "gzz_lab3_storage3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_glasscutter3", get_glasscutter3_inv );
  cmn.AddSubscriber( "get_glasscutter3", get_glasscutter3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bellows3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bellows3" ] =
  {
    type = "get",
    get_obj = "spr_storage3_bellows3",
    room = private.room_objname,
    zz = "zz_storage3",
    zz_gate = "gzz_lab3_storage3"
  };
  --------------------------------------------------------------------------------------------
  local get_bellows3_inv = function ()

    int.InventoryItemAdd( "inv_bellows3", "spr_storage3_bellows3" );

  end;
  local get_bellows3_closezz = function ()

    ObjDelete( "gfx_storage3_bellows3" );
    ObjDelete( "spr_lab3_bellows" );
    --ObjDelete( "gzz_lab3_storage3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bellows3", get_bellows3_inv );
  cmn.AddSubscriber( "get_bellows3", get_bellows3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_icarusfigurine3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_icarusfigurine3" ] =
  {
    type = "get",
    get_obj = "spr_storage3_icarusfigurine3",
    room = private.room_objname,
    zz = "zz_storage3",
    zz_gate = "gzz_lab3_storage3"
  };
  --------------------------------------------------------------------------------------------
  local get_icarusfigurine3_inv = function ()

    int.InventoryItemAdd( "inv_icarusfigurine3", "spr_storage3_icarusfigurine3" );

  end;
  local get_icarusfigurine3_closezz = function ()

    ObjDelete( "gfx_storage3_icarusfigurine3" );
    ObjDelete( "spr_lab3_icarusfigurine" );
    ObjDelete( "spr_lab3_icarusfigurine" );
    --ObjDelete( "gzz_lab3_storage3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_icarusfigurine3", get_icarusfigurine3_inv );
  cmn.AddSubscriber( "get_icarusfigurine3", get_icarusfigurine3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_reagents3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_reagents3" ] =
  {
    type = "get",
    get_obj = "spr_storage3_reagents3",
    room = private.room_objname,
    zz = "zz_storage3",
    zz_gate = "gzz_lab3_storage3"
  };
  --------------------------------------------------------------------------------------------
  local get_reagents3_inv = function ()

    int.InventoryItemAdd( "inv_reagents3", "spr_storage3_reagents3" );

  end;
  local get_reagents3_closezz = function ()

    ObjDelete( "gfx_storage3_reagents3" );
    ObjDelete( "spr_lab3_reagents" );
    ObjDelete( "spr_lab3_reagents" );
    --ObjDelete( "gzz_lab3_storage3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_reagents3", get_reagents3_inv );
  cmn.AddSubscriber( "get_reagents3", get_reagents3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletomega3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletomega3_2" ] =
  {
    type = "get",
    get_obj = "spr_windowopening3_amuletomega3_2",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletomega3_2_inv = function ()

    int.InventoryItemAdd( "inv_amuletomega3", "spr_windowopening3_amuletomega3_2", "assets/levels/level3/rm_tower3/zz_labdoor3/inv/inv_amuletomega3_2" );
    level3_inv.CheckAmuletomega3( 2 );

  end;
  local get_amuletomega3_2_closezz = function ()

    ObjDelete( "gfx_windowopening3_amuletomega3_2" );
    ObjDelete( "spr_lab3_amuletomega" );
    --ObjDelete( "gzz_lab3_windowopening3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletomega3_2", get_amuletomega3_2_inv );
  cmn.AddSubscriber( "get_amuletomega3_2", get_amuletomega3_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gunpowder3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gunpowder3" ] =
  {
    type = "get",
    get_obj = "spr_windowopening3_gunpowder3",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local get_gunpowder3_inv = function ()

    int.InventoryItemAdd( "inv_gunpowder3", "spr_windowopening3_gunpowder3" );

    if ( cmn.IsEventDone( "clk_disassembledgun3" ) ) then

      ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_gunpowder3_closezz = function ()

    ObjDelete( "gfx_windowopening3_gunpowder3" );
    ObjDelete( "spr_lab3_gunpowder" );
    --ObjDelete( "gzz_lab3_windowopening3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gunpowder3", get_gunpowder3_inv );
  cmn.AddSubscriber( "get_gunpowder3", get_gunpowder3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_amuletbutterfly3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletbutterfly3" ] =
  {
    type = "get",
    get_obj = "obj_windowopening3_get_amuletbutterfly",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletbutterfly3_inv = function ()

    int.InventoryItemAdd( "inv_amuletbutterfly3", "obj_windowopening3_get_amuletbutterfly" );

  end;
  local get_amuletbutterfly3_closezz = function ()

    ObjDelete( "gfx_windowopening3_amuletbutterfly3" );
    ObjDelete( "obj_windowopening3_mmg1" );
    --ObjDelete( "gzz_lab3_windowopening3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletbutterfly3", get_amuletbutterfly3_inv );
  cmn.AddSubscriber( "get_amuletbutterfly3", get_amuletbutterfly3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coals3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coals3" ] =
  {
    type = "get",
    get_obj = "spr_autoclave3_coals3",
    room = private.room_objname,
    zz = "zz_autoclave3",
    zz_gate = "gzz_lab3_autoclave3"
  };
  --------------------------------------------------------------------------------------------
  local get_coals3_inv = function ()

    int.InventoryItemAdd( "inv_coals3", "spr_autoclave3_coals3" );

  end;
  local get_coals3_closezz = function ()

    ObjDelete( "anm_autoclave3_coals_light" );
    ObjDelete( "spr_lab3_coal" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_coals3", get_coals3_inv );
  cmn.AddSubscriber( "get_coals3", get_coals3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_propellentcharge3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_propellentcharge3" ] =
  {
    type = "get",
    get_obj = "obj_autoclave3_propellentcharge3",
    room = private.room_objname,
    zz = "zz_autoclave3",
    zz_gate = "gzz_lab3_autoclave3"
  };
  --------------------------------------------------------------------------------------------
  local get_propellentcharge3_inv = function ()

    int.InventoryItemAdd( "inv_propellentcharge3", "obj_autoclave3_propellentcharge3" );

  end;
  local get_propellentcharge3_closezz = function ()

    ObjDelete( "gfx_autoclave3_propellentcharge3" );
    ObjDelete( "anm_autoclave3_use_scalpel" );
    ObjDelete( "spr_lab3_propellentcharge" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_propellentcharge3", get_propellentcharge3_inv );
  cmn.AddSubscriber( "get_propellentcharge3", get_propellentcharge3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lace3 () end;
  --------------------------------------------------------------------------------------------
  local get_lace3_inv = function ()

    int.InventoryItemAdd( "inv_lace3", "obj_autoclave3_lace3" );

    if ( cmn.IsEventDone( "get_magnetizedhorseshoe3" ) ) then

      ObjSet( "inv_magnetizedhorseshoe3_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_lace3_closezz = function ()

    ObjDelete( "gfx_autoclave3_lace3" );
    ObjDelete( "spr_autoclave3_lace_shadow" );

    ObjDelete( "spr_lab3_lace" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lace3", get_lace3_inv );
  cmn.AddSubscriber( "get_lace3", get_lace3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gasbombs3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gasbombs3" ] =
  {
    type = "get",
    get_obj = "spr_autoclave3_gasbombs3",
    room = private.room_objname,
    zz = "zz_autoclave3",
    zz_gate = "gzz_lab3_autoclave3"
  };
  --------------------------------------------------------------------------------------------
  local get_gasbombs3_inv = function ()

    int.InventoryItemAdd( "inv_gasbombs3", "spr_autoclave3_gasbombs3" );

  end;
  local get_gasbombs3_closezz = function ()

    ObjDelete( "gfx_autoclave3_gasbombs3" );
    ObjDelete( "spr_autoclave3_gasbombs_shadow" );
    ObjDelete( "spr_autoclave3_gasbombs_reflection" );
    ObjDelete( "anm_autoclave3_bottle_smoke" );

    ObjDelete( "spr_lab3_bottles_shadow" );
    ObjDelete( "spr_lab3_gasbombs" );
    ObjDelete( "spr_lab3_autuclave_bottle_light" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gasbombs3", get_gasbombs3_inv );
  cmn.AddSubscriber( "get_gasbombs3", get_gasbombs3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystal3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crystal3" ] =
  {
    type = "get",
    get_obj = "spr_shelvings3_crystal3",
    room = private.room_objname,
    zz = "zz_shelvings3",
    zz_gate = "gzz_lab3_shelvings3"
  };
  --------------------------------------------------------------------------------------------
  local get_crystal3_inv = function ()

    int.InventoryItemAdd( "inv_crystal3", "spr_shelvings3_crystal3" );

  end;
  local get_crystal3_closezz = function ()

    ObjDelete( "gfx_shelvings3_crystal3" );

    if cmn.IsEventDone( "get_chisel3" ) and  
       cmn.IsEventDone( "get_roundnosepliers3" ) then

      ObjDelete( "gzz_lab3_shelvings3" );

    end;

    ObjDelete( "spr_lab3_crystal" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystal3", get_crystal3_inv );
  cmn.AddSubscriber( "get_crystal3", get_crystal3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chisel3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chisel3" ] =
  {
    type = "get",
    get_obj = "spr_shelvings3_chisel3",
    room = private.room_objname,
    zz = "zz_shelvings3",
    zz_gate = "gzz_lab3_shelvings3"
  };
  --------------------------------------------------------------------------------------------
  local get_chisel3_inv = function ()

    int.InventoryItemAdd( "inv_chisel3", "spr_shelvings3_chisel3" );

  end;
  local get_chisel3_closezz = function ()

    ObjDelete( "gfx_shelvings3_chisel3" );

    if cmn.IsEventDone( "get_crystal3" ) and 
       cmn.IsEventDone( "get_roundnosepliers3" ) then

      ObjDelete( "gzz_lab3_shelvings3" );

    end;

    ObjDelete( "spr_lab3_chisel" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_chisel3", get_chisel3_inv );
  cmn.AddSubscriber( "get_chisel3", get_chisel3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_roundnosepliers3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_roundnosepliers3" ] =
  {
    type = "get",
    get_obj = "spr_shelvings3_roundnosepliers3",
    room = private.room_objname,
    zz = "zz_shelvings3",
    zz_gate = "gzz_lab3_shelvings3"
  };
  --------------------------------------------------------------------------------------------
  local get_roundnosepliers3_inv = function ()

    int.InventoryItemAdd( "inv_roundnosepliers3", "spr_shelvings3_roundnosepliers3" );

  end;
  local get_roundnosepliers3_closezz = function ()

    ObjDelete( "gfx_shelvings3_roundnosepliers3" );

    if cmn.IsEventDone( "get_crystal3" ) and 
       cmn.IsEventDone( "get_chisel3" ) then

      ObjDelete( "gzz_lab3_shelvings3" );

    end;

    ObjDelete( "spr_lab3_roundnosepliers" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_roundnosepliers3", get_roundnosepliers3_inv );
  cmn.AddSubscriber( "get_roundnosepliers3", get_roundnosepliers3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulethypercube3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulethypercube3" ] =
  {
    type = "get",
    get_obj = "spr_device3_amulethypercube3",
    room = private.room_objname,
    zz = "zz_device3",
    zz_gate = "gzz_lab3_device3"
  };
  --------------------------------------------------------------------------------------------
  local get_amulethypercube3_inv = function ()

    int.InventoryItemAdd( "inv_amulethypercube3", "spr_device3_amulethypercube3" );

  end;
  local get_amulethypercube3_closezz = function ()

    ObjDelete( "gfx_device3_amulethypercube3" );

    if ( cmn.IsEventDone( "get_capsule3" ) ) and
       ( cmn.IsEventDone( "get_amulethypercube3" ) ) then

      ObjDelete( "gzz_lab3_device3" );

    end;

    ObjDelete( "spr_lab3_device_amulethypercube" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amulethypercube3", get_amulethypercube3_inv );
  cmn.AddSubscriber( "get_amulethypercube3", get_amulethypercube3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_capsule3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_capsule3" ] =
  {
    type = "get",
    get_obj = "spr_device3_capsule3",
    room = private.room_objname,
    zz = "zz_device3",
    zz_gate = "gzz_lab3_device3"
  };
  --------------------------------------------------------------------------------------------
  local get_capsule3_inv = function ()

    int.InventoryItemAdd( "inv_capsule3", "spr_device3_capsule3" );
    ObjSet( "inv_capsule3", { drag = false } );

    if ( not cmn.IsEventDone( "get_wrench3" ) ) then

      ObjSet( "inv_capsule3_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_capsule3_closezz = function ()

    ObjDelete( "gfx_device3_capsule3" );

    if ( cmn.IsEventDone( "get_capsule3" ) ) and
       ( cmn.IsEventDone( "get_amulethypercube3" ) ) then

      ObjDelete( "gzz_lab3_device3" );

    end;

    ObjDelete( "spr_lab3_capsule" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_capsule3", get_capsule3_inv );
  cmn.AddSubscriber( "get_capsule3", get_capsule3_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_hexagram3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hexagram3" ] =
  {
    type = "use",
    use_obj = "inv_hexagram3",
    use_place = "obj_storage3_use_hexagram3",
    room = private.room_objname,
    zz = "zz_storage3",
    zz_gate = "gzz_lab3_storage3"
  };
  --------------------------------------------------------------------------------------------
  local use_hexagram3_inv = function ()

    int.InventoryItemRemove( "inv_hexagram3" );

  end;
  local use_hexagram3_beg = function ()

    ObjDelete( "obj_storage3_use_hexagram3" );

  end;
  local use_hexagram3_end = function ()

    ObjSet( "obj_storage3_hexagram_open", { input = true } );
    ObjSet( "anm_storage3_use_hexagram", { alp = 1, frame = 500 } );
    ObjDelete( "obj_storage3_hexagram_close" );

    ObjSet( "gfx_storage3_glasscutter3", { active = true } );
    ObjSet( "spr_storage3_glasscutter_light", { active = true } );
    ObjSet( "gfx_storage3_bellows3", { active = true } );

    ObjSet( "spr_lab3_hexagram_cap_2", { alp = 1 } );
    ObjDelete( "spr_lab3_hexagram_cap_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hexagram3",     use_hexagram3_inv );
  cmn.AddSubscriber( "use_hexagram3",     use_hexagram3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexagram3",     use_hexagram3_end, private.room_objname );
  cmn.AddSubscriber( "use_hexagram3_inv", use_hexagram3_inv, private.room_objname );
  cmn.AddSubscriber( "use_hexagram3_beg", use_hexagram3_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexagram3_end", use_hexagram3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_amuletbutterfly3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletbutterfly3" ] =
  {
    type = "use",
    use_obj = "inv_amuletbutterfly3",
    use_place = "obj_storage3_use_amuletbutterfly3",
    room = private.room_objname,
    zz = "zz_storage3",
    zz_gate = "gzz_lab3_storage3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletbutterfly3_inv = function ()

    int.InventoryItemRemove( "inv_amuletbutterfly3" );

  end;
  local use_amuletbutterfly3_beg = function ()

    ObjDelete( "obj_storage3_use_amuletbutterfly3" );

  end;
  local use_amuletbutterfly3_end = function ()

    ObjSet( "obj_storage3_amuletbutterfly_open", { input = true } );
    ObjSet( "anm_storage3_use_amuletbutterfly", { alp = 1, frame = 500 } );
    ObjDelete( "obj_storage3_amuletbutterfly_close" );

    ObjSet( "gfx_storage3_icarusfigurine3", { active = true } );
    ObjSet( "gfx_storage3_reagents3", { active = true } );

    ObjSet( "spr_lab3_amuletbutterfly_cap_2", { alp = 1 } );
    ObjDelete( "spr_lab3_amuletbutterfly_cap_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletbutterfly3",     use_amuletbutterfly3_inv );
  cmn.AddSubscriber( "use_amuletbutterfly3",     use_amuletbutterfly3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletbutterfly3",     use_amuletbutterfly3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletbutterfly3_inv", use_amuletbutterfly3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletbutterfly3_beg", use_amuletbutterfly3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletbutterfly3_end", use_amuletbutterfly3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletangel3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletangel3" ] =
  {
    type = "use",
    use_obj = "inv_amuletangel3",
    use_place = "obj_storage3_use_amuletangel3",
    room = private.room_objname,
    zz = "zz_storage3",
    zz_gate = "gzz_lab3_storage3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletangel3_inv = function ()

    int.InventoryItemRemove( "inv_amuletangel3" );

  end;
  local use_amuletangel3_beg = function ()

    ObjDelete( "obj_storage3_use_amuletangel3" );

  end;
  local use_amuletangel3_end = function ()

    ObjSet( "gho_lab3_hoalchemybox3", { alp = 1, input = true, active = true } );
    ObjDelete( "gzz_lab3_storage3" );

    ObjSet( "spr_lab3_amuletangel", { alp = 1 } );
    ObjSet( "spr_lab3_ho", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletangel3",     use_amuletangel3_inv );
  cmn.AddSubscriber( "use_amuletangel3",     use_amuletangel3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletangel3",     use_amuletangel3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletangel3_inv", use_amuletangel3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletangel3_beg", use_amuletangel3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletangel3_end", use_amuletangel3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletaxes3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletaxes3" ] =
  {
    type = "use",
    use_obj = "inv_amuletaxes3",
    use_place = "obj_windowopening3_use_amuletaxes3",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletaxes3_inv = function ()

    int.InventoryItemRemove( "inv_amuletaxes3" );

  end;
  local use_amuletaxes3_beg = function ()

    ObjDelete( "obj_windowopening3_use_amuletaxes3" );

  end;
  local use_amuletaxes3_end = function ()

    ObjSet( "obj_windowopening3_box_open", { input = true } );
    ObjSet( "gfx_windowopening3_gunpowder3", { active = true } );
    ObjSet( "gfx_windowopening3_wrench3", { active = true } );
    ObjDelete( "obj_windowopening3_box_close" );

    ObjDelete( "spr_lab3_window_cap" );
    ObjDelete( "spr_lab3_over" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletaxes3",     use_amuletaxes3_inv );
  cmn.AddSubscriber( "use_amuletaxes3",     use_amuletaxes3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletaxes3",     use_amuletaxes3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletaxes3_inv", use_amuletaxes3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletaxes3_beg", use_amuletaxes3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletaxes3_end", use_amuletaxes3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gasbombs3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gasbombs3" ] =
  {
    type = "use",
    use_obj = "inv_gasbombs3",
    use_place = "obj_windowopening3_use_gasbombs3",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local use_gasbombs3_inv = function ()

    int.InventoryItemRemove( "inv_gasbombs3" );

  end;
  local use_gasbombs3_beg = function ()

    ObjDelete( "obj_windowopening3_use_gasbombs3" );

  end;
  local use_gasbombs3_end = function ()

    ObjDelete( "gzz_lab3_windowopening3" );
    ObjSet( "gmg_lab3_mgcrowd3", { alp = 1, input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gasbombs3",     use_gasbombs3_inv );
  cmn.AddSubscriber( "use_gasbombs3",     use_gasbombs3_beg, private.room_objname );
  cmn.AddSubscriber( "use_gasbombs3",     use_gasbombs3_end, private.room_objname );
  cmn.AddSubscriber( "use_gasbombs3_inv", use_gasbombs3_inv, private.room_objname );
  cmn.AddSubscriber( "use_gasbombs3_beg", use_gasbombs3_beg, private.room_objname );
  cmn.AddSubscriber( "use_gasbombs3_end", use_gasbombs3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnetonlace3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnetonlace3" ] =
  {
    type = "use",
    use_obj = "inv_magnetonlace3",
    use_place = "obj_windowopening3_use_magnetonlace3",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local use_magnetonlace3_inv = function ()

    int.InventoryItemRemove( "inv_magnetonlace3" );

  end;
  local use_magnetonlace3_beg = function ()

    ObjDelete( "obj_windowopening3_use_magnetonlace3" );

  end;
  local use_magnetonlace3_end = function ()

    ObjSet( "obj_windowopening3_horseshoe1", { alp = 1, input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnetonlace3",     use_magnetonlace3_inv );
  cmn.AddSubscriber( "use_magnetonlace3",     use_magnetonlace3_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnetonlace3",     use_magnetonlace3_end, private.room_objname );
  cmn.AddSubscriber( "use_magnetonlace3_inv", use_magnetonlace3_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnetonlace3_beg", use_magnetonlace3_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnetonlace3_end", use_magnetonlace3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scalpel3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scalpel3_2" ] =
  {
    type = "use",
    use_obj = "inv_scalpel3",
    use_place = "obj_autoclave3_use_scalpel3_2",
    room = private.room_objname,
    zz = "zz_autoclave3",
    zz_gate = "gzz_lab3_autoclave3"
  };
  --------------------------------------------------------------------------------------------
  local use_scalpel3_2_inv = function ()

    if ( cmn.IsEventDone( "use_scalpel3_1" ) ) then

      int.InventoryItemRemove( "inv_scalpel3" );

    end;

  end;
  local use_scalpel3_2_beg = function ()

    ObjDelete( "obj_autoclave3_use_scalpel3_2" );
    ObjDelete( "anm_autoclave3_bomb_click" );

  end;
  local use_scalpel3_2_end = function ()

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scalpel3_2",     use_scalpel3_2_inv );
  cmn.AddSubscriber( "use_scalpel3_2",     use_scalpel3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalpel3_2",     use_scalpel3_2_end, private.room_objname );
  cmn.AddSubscriber( "use_scalpel3_2_inv", use_scalpel3_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_scalpel3_2_beg", use_scalpel3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_scalpel3_2_end", use_scalpel3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bluecylinder3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bluecylinder3" ] =
  {
    type = "use",
    use_obj = "inv_bluecylinder3",
    use_place = "obj_autoclave3_use_bluecylinder3",
    room = private.room_objname,
    zz = "zz_autoclave3",
    zz_gate = "gzz_lab3_autoclave3"
  };
  --------------------------------------------------------------------------------------------
  local use_bluecylinder3_inv = function ()

    int.InventoryItemRemove( "inv_bluecylinder3" );

  end;
  local use_bluecylinder3_beg = function ()

    ObjDelete( "obj_autoclave3_use_bluecylinder3" );

  end;
  local use_bluecylinder3_end = function ()

    ObjSet( "anm_autoclave3_use_bluecylinder", { frame = 500 } );
    ObjSet( "spr_lab3_bluecylinder", { alp = 1 } );

    if ( cmn.IsEventDone( "use_chemicals3" ) ) and
       ( cmn.IsEventDone( "use_reagents3" ) ) then

      ObjSet( "obj_autoclave3_clk_button", { input = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bluecylinder3",     use_bluecylinder3_inv );
  cmn.AddSubscriber( "use_bluecylinder3",     use_bluecylinder3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluecylinder3",     use_bluecylinder3_end, private.room_objname );
  cmn.AddSubscriber( "use_bluecylinder3_inv", use_bluecylinder3_inv, private.room_objname );
  cmn.AddSubscriber( "use_bluecylinder3_beg", use_bluecylinder3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bluecylinder3_end", use_bluecylinder3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chemicals3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chemicals3" ] =
  {
    type = "use",
    use_obj = "inv_chemicals3",
    use_place = "obj_autoclave3_use_chemicals3",
    room = private.room_objname,
    zz = "zz_autoclave3",
    zz_gate = "gzz_lab3_autoclave3"
  };
  --------------------------------------------------------------------------------------------
  local use_chemicals3_inv = function ()

    int.InventoryItemRemove( "inv_chemicals3" );

  end;
  local use_chemicals3_beg = function ()

    ObjDelete( "obj_autoclave3_use_chemicals3" );

  end;
  local use_chemicals3_end = function ()

    if ( cmn.IsEventDone( "use_reagents3" ) ) and
       ( cmn.IsEventDone( "use_bluecylinder3" ) ) then

      ObjSet( "obj_autoclave3_clk_button", { input = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chemicals3",     use_chemicals3_inv );
  cmn.AddSubscriber( "use_chemicals3",     use_chemicals3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chemicals3",     use_chemicals3_end, private.room_objname );
  cmn.AddSubscriber( "use_chemicals3_inv", use_chemicals3_inv, private.room_objname );
  cmn.AddSubscriber( "use_chemicals3_beg", use_chemicals3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chemicals3_end", use_chemicals3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_reagents3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_reagents3" ] =
  {
    type = "use",
    use_obj = "inv_reagents3",
    use_place = "obj_autoclave3_use_reagents3",
    room = private.room_objname,
    zz = "zz_autoclave3",
    zz_gate = "gzz_lab3_autoclave3"
  };
  --------------------------------------------------------------------------------------------
  local use_reagents3_inv = function ()

    int.InventoryItemRemove( "inv_reagents3" );

  end;
  local use_reagents3_beg = function ()

    ObjDelete( "obj_autoclave3_use_reagents3" );

  end;
  local use_reagents3_end = function ()

    if ( cmn.IsEventDone( "use_chemicals3" ) ) and
       ( cmn.IsEventDone( "use_bluecylinder3" ) ) then

      ObjSet( "obj_autoclave3_clk_button", { input = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_reagents3",     use_reagents3_inv );
  cmn.AddSubscriber( "use_reagents3",     use_reagents3_beg, private.room_objname );
  cmn.AddSubscriber( "use_reagents3",     use_reagents3_end, private.room_objname );
  cmn.AddSubscriber( "use_reagents3_inv", use_reagents3_inv, private.room_objname );
  cmn.AddSubscriber( "use_reagents3_beg", use_reagents3_beg, private.room_objname );
  cmn.AddSubscriber( "use_reagents3_end", use_reagents3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletomega3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletomega3" ] =
  {
    type = "use",
    use_obj = "inv_amuletomega3",
    use_place = "obj_shelvings3_use_amuletomega3",
    room = private.room_objname,
    zz = "zz_shelvings3",
    zz_gate = "gzz_lab3_shelvings3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletomega3_inv = function ()

    int.InventoryItemRemove( "inv_amuletomega3" );

  end;
  local use_amuletomega3_beg = function ()

    ObjDelete( "obj_shelvings3_use_amuletomega3" );

  end;
  local use_amuletomega3_end = function ()

    ObjDelete( "obj_shelvings3_box_omega_close" );
    ObjSet( "anm_shelvings3_use_amuletomega", { alp = 1, frame = 500 } );

    ObjSet( "obj_shelvings3_box_omega_open", { input = true } );
    ObjSet( "gfx_shelvings3_roundnosepliers3", { active = true } );
    ObjSet( "gfx_shelvings3_chisel3", { active = true } );

    ObjDelete( "spr_lab3_amuletomega_door_1" );
    ObjSet( "spr_lab3_amuletomega_door_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletomega3",     use_amuletomega3_inv );
  cmn.AddSubscriber( "use_amuletomega3",     use_amuletomega3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletomega3",     use_amuletomega3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletomega3_inv", use_amuletomega3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletomega3_beg", use_amuletomega3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletomega3_end", use_amuletomega3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletgorgon3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletgorgon3" ] =
  {
    type = "use",
    use_obj = "inv_amuletgorgon3",
    use_place = "obj_shelvings3_use_amuletgorgon3",
    room = private.room_objname,
    zz = "zz_shelvings3",
    zz_gate = "gzz_lab3_shelvings3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletgorgon3_inv = function ()

    int.InventoryItemRemove( "inv_amuletgorgon3" );

  end;
  local use_amuletgorgon3_beg = function ()

    ObjDelete( "obj_shelvings3_use_amuletgorgon3" );

  end;
  local use_amuletgorgon3_end = function ()

    ObjDelete( "obj_shelvings3_box_gorgon_close" );
    ObjSet( "anm_shelvings3_use_amuletgorgon", { alp = 1, frame = 500 } );
    ObjSet( "obj_shelvings3_box_gorgon_open", { input = true } );
    ObjSet( "spr_shelvings3_crystal3", { input = true } );
    ObjSet( "gfx_shelvings3_crystal3", { active = true } );

    ObjDelete( "spr_lab3_amuletgorgon_cap_1" );
    ObjSet( "spr_lab3_amuletgorgon_cap_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletgorgon3",     use_amuletgorgon3_inv );
  cmn.AddSubscriber( "use_amuletgorgon3",     use_amuletgorgon3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgorgon3",     use_amuletgorgon3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletgorgon3_inv", use_amuletgorgon3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletgorgon3_beg", use_amuletgorgon3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgorgon3_end", use_amuletgorgon3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_battery3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_battery3" ] =
  {
    type = "use",
    use_obj = "inv_battery3",
    use_place = "obj_device3_use_battery3",
    room = private.room_objname,
    zz = "zz_device3",
    zz_gate = "gzz_lab3_device3"
  };
  --------------------------------------------------------------------------------------------
  local use_battery3_inv = function ()

    int.InventoryItemRemove( "inv_battery3" );

  end;
  local use_battery3_beg = function ()

    ObjDelete( "obj_device3_use_battery3" );

  end;
  local use_battery3_end = function ()
   
    ObjSet( "anm_device3_battery",  { frame = 78, animfunc = "DoAnim" } );
    ObjSet( "spr_device3_capsule3", { input = true } );
    ObjSet( "gfx_device3_capsule3", { active = true } );
    ObjDelete( "anm_device3_sparkles" );
    
    ObjSet( "spr_lab3_device_over_2", { alp = 1 } );
    ObjSet( "spr_lab3_battery", { alp = 1 } );
    ObjDelete( "spr_lab3_device_over_1" );

    ObjSet( "anm_lab3_light_lamps", { alp = 1, playing = true } );
    ObjDelete( "anm_lab3_dark_lamps" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_battery3",     use_battery3_inv );
  cmn.AddSubscriber( "use_battery3",     use_battery3_beg, private.room_objname );
  cmn.AddSubscriber( "use_battery3",     use_battery3_end, private.room_objname );
  cmn.AddSubscriber( "use_battery3_inv", use_battery3_inv, private.room_objname );
  cmn.AddSubscriber( "use_battery3_beg", use_battery3_beg, private.room_objname );
  cmn.AddSubscriber( "use_battery3_end", use_battery3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_roundnosepliers3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_roundnosepliers3_2" ] =
  {
    type = "use",
    use_obj = "inv_roundnosepliers3",
    use_place = "obj_device3_use_roundnosepliers3_2",
    room = private.room_objname,
    zz = "zz_device3",
    zz_gate = "gzz_lab3_device3"
  };
  --------------------------------------------------------------------------------------------
  local use_roundnosepliers3_2_inv = function ()

    if ( cmn.IsEventDone( "use_roundnosepliers3_1" ) ) then

      int.InventoryItemRemove( "inv_roundnosepliers3" );

    end;

  end;
  local use_roundnosepliers3_2_beg = function ()

    ObjDelete( "obj_device3_use_roundnosepliers3_2" );
    ObjDelete( "anm_device3_wire_static" );

  end;
  local use_roundnosepliers3_2_end = function ()

    ObjDelete( "anm_device3_roundnosepliers" );
    ObjSet( "obj_device3_use_battery3",     { input = true } );
    ObjSet( "spr_device3_amulethypercube3", { input = true } );
    ObjSet( "gfx_device3_amulethypercube3", { active = true } );

    ObjDelete( "spr_lab3_device_wire" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_roundnosepliers3_2",     use_roundnosepliers3_2_inv );
  cmn.AddSubscriber( "use_roundnosepliers3_2",     use_roundnosepliers3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_roundnosepliers3_2",     use_roundnosepliers3_2_end, private.room_objname );
  cmn.AddSubscriber( "use_roundnosepliers3_2_inv", use_roundnosepliers3_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_roundnosepliers3_2_beg", use_roundnosepliers3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_roundnosepliers3_2_end", use_roundnosepliers3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_butterflypart3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_butterflypart3_1" ] =
  {
    type = "use",
    use_obj = "spr_windowopening3_ho_1",
    use_place = "spr_windowopening3_base",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local use_butterflypart3_1_end = function ()

    ObjSet( "spr_windowopening3_ho_1", { pos_x = - 1, pos_y = - 47, pos_z = 0, input = false } );

    if cmn.IsEventDone( "use_butterflypart3_2" ) and 
       cmn.IsEventDone( "use_butterflypart3_3" ) then

      ObjSet( "obj_windowopening3_get_amuletbutterfly", { input = true } );
      ObjSet( "gfx_windowopening3_amuletbutterfly3", { active = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_butterflypart3_1",     use_butterflypart3_1_end, private.room_objname );
  cmn.AddSubscriber( "use_butterflypart3_1_end", use_butterflypart3_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_butterflypart3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_butterflypart3_2" ] =
  {
    type = "use",
    use_obj = "spr_windowopening3_ho_2",
    use_place = "spr_windowopening3_base",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local use_butterflypart3_2_end = function ()

    ObjSet( "spr_windowopening3_ho_2", { pos_x = 65, pos_y = 23, pos_z = 0, input = false } );

    if cmn.IsEventDone( "use_butterflypart3_1" ) and 
       cmn.IsEventDone( "use_butterflypart3_3" ) then

      ObjSet( "obj_windowopening3_get_amuletbutterfly", { input = true } );
      ObjSet( "gfx_windowopening3_amuletbutterfly3", { active = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_butterflypart3_2",     use_butterflypart3_2_end, private.room_objname );
  cmn.AddSubscriber( "use_butterflypart3_2_end", use_butterflypart3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_butterflypart3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_butterflypart3_3" ] =
  {
    type = "use",
    use_obj = "spr_windowopening3_ho_3",
    use_place = "spr_windowopening3_base",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --------------------------------------------------------------------------------------------
  local use_butterflypart3_3_end = function ()

    ObjSet( "spr_windowopening3_ho_3", { pos_x = - 64, pos_y = 22, pos_z = 0, input = false } );

    if cmn.IsEventDone( "use_butterflypart3_2" ) and 
       cmn.IsEventDone( "use_butterflypart3_1" ) then

      ObjSet( "obj_windowopening3_get_amuletbutterfly", { input = true } );
      ObjSet( "gfx_windowopening3_amuletbutterfly3", { active = true } );

    end;


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_butterflypart3_3",     use_butterflypart3_3_end, private.room_objname );
  cmn.AddSubscriber( "use_butterflypart3_3_end", use_butterflypart3_3_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_autoclave3_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_autoclave3_button" ] =
  {
    type = "click",
    clk_obj = "obj_autoclave3_clk_button",
    room = private.room_objname,
    zz = "zz_autoclave3",
    zz_gate = "gzz_lab3_autoclave3"
  };
  -----------------------------------------------
  local clk_autoclave3_button_inv = function ()

  end;
  local clk_autoclave3_button_beg = function ()

    ObjDelete( "obj_autoclave3_clk_button" );

  end;
  local clk_autoclave3_button_end = function ()

    ObjDelete( "anm_autoclave3_bottle" );
    ObjSet( "anm_autoclave3_bottle_smoke", { alp = 1, playing = true } );
    ObjSet( "spr_autoclave3_gasbombs_reflection_2", { alp = 1 } );

    ObjSet( "spr_autoclave3_gasbombs_reflection_2", { alp = 1 } );
    ObjSet( "spr_autoclave3_gasbombs3", { input = true } );
    ObjSet( "gfx_autoclave3_gasbombs3", { active = true } );

    ObjSet( "spr_lab3_gasbombs", { alp = 1 } );
    ObjDelete( "spr_lab3_bottles" );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_autoclave3_button",     clk_autoclave3_button_inv );
  cmn.AddSubscriber( "clk_autoclave3_button",     clk_autoclave3_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_autoclave3_button",     clk_autoclave3_button_end, private.room_objname );
  cmn.AddSubscriber( "clk_autoclave3_button_inv", clk_autoclave3_button_inv, private.room_objname );
  cmn.AddSubscriber( "clk_autoclave3_button_beg", clk_autoclave3_button_beg, private.room_objname );
  cmn.AddSubscriber( "clk_autoclave3_button_end", clk_autoclave3_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_amuletangel3_2 () end;
  --------------------------------------------------------------------------------------------
  local see_amuletangel3_2_inv = function ()

  end;
  local see_amuletangel3_2_beg = function ()

  end;
  local see_amuletangel3_2_end = function ()

    ObjDelete( "anm_lab3_angel" );
    ObjSet( "spr_lab3_amuletangel3_2_shadow", { alp = 1 } );
    ObjSet( "spr_lab3_amuletangel3_2", { alp = 1, input = true } );
    ObjSet( "gfx_lab3_amuletangel3_2", { active = true } );

  end;
  -----------------------------------------------
  cmn.AddSubscriber( "see_amuletangel3_2",     see_amuletangel3_2_inv );
  cmn.AddSubscriber( "see_amuletangel3_2",     see_amuletangel3_2_beg, private.room_objname );
  cmn.AddSubscriber( "see_amuletangel3_2",     see_amuletangel3_2_end, private.room_objname );
  cmn.AddSubscriber( "see_amuletangel3_2_inv", see_amuletangel3_2_inv, private.room_objname );
  cmn.AddSubscriber( "see_amuletangel3_2_beg", see_amuletangel3_2_beg, private.room_objname );
  cmn.AddSubscriber( "see_amuletangel3_2_end", see_amuletangel3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_mgcrowd3 () end;
  --------------------------------------------------------------------------------------------
  local win_mgcrowd3 = function ()

    if ( cmn.IsEventDone( "win_mgcrowd3" ) ) then

      ObjDelete( "gmg_lab3_mgcrowd3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_mgcrowd3", win_mgcrowd3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_windowopening3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_windowopening3" ] =
  {
    type = "click",
    clk_obj = "obj_windowopening3_drag",
    room = private.room_objname,
    zz = "zz_windowopening3",
    zz_gate = "gzz_lab3_windowopening3"
  };
  --*********************************************************************************************************************
  local win_windowopening3_inv = function ()

    if ( cmn.IsEventDone( "win_windowopening3" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_windowopening3 = function ()

    if ( cmn.IsEventDone( "win_windowopening3" ) ) then
            
      ObjDelete( "obj_windowopening3_mmg" );
      ObjSet( "obj_windowopening3_mmg1", { alp = 1, input = true } );

    else 

      private.Windowopening3Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_windowopening3", win_windowopening3_inv );
  cmn.AddSubscriber( "win_windowopening3", win_windowopening3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_lab3_emily3_3 () end;
  --------------------------------------------------------------------------------------------
  local dlg_lab3_emily3_3_beg = function ()

  end;
  -----------------------------------------------
  local dlg_lab3_emily3_3_end = function ()

    ObjDelete( "dlg_lab3_emily3_3" );

  end;

  cmn.AddSubscriber( "dlg_lab3_emily3_3",     dlg_lab3_emily3_3_beg );
  cmn.AddSubscriber( "dlg_lab3_emily3_3",     dlg_lab3_emily3_3_end );
  cmn.AddSubscriber( "dlg_lab3_emily3_3_beg", dlg_lab3_emily3_3_beg );
  cmn.AddSubscriber( "dlg_lab3_emily3_3_end", dlg_lab3_emily3_3_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_towerroof3_emily3_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_towerroof3_emily3_2 = function ()

    ObjSet( "anm_windowopening3_people", { alp = 1, playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_towerroof3_emily3_2",     dlg_towerroof3_emily3_2, private.room_objname );
  cmn.AddSubscriber( "dlg_towerroof3_emily3_2_end", dlg_towerroof3_emily3_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_hoalchemybox3 () end;
  --------------------------------------------------------------------------------------------
  --*********************************************************************************************************************
  local win_hoalchemybox3 = function ()

    if ( cmn.IsEventDone( "win_hoalchemybox3" ) ) then
            
      ObjSet( "spr_lab3_ho_open_cap", { alp = 1 } );
      ObjDelete( "spr_lab3_ho_win" );

    else 

      if ( cmn.IsEventDone( "opn_hoalchemybox3" ) ) then

        if ( ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3" ].set == 10 ) then

          ObjSet( "spr_lab3_ho_open_cap", { alp = 1 } );
          ObjSet( "spr_lab3_ho_win", { alp = 1 } );

        end; 

      end; 

    end;
    
  end;

  cmn.AddSubscriber( "win_hoalchemybox3", win_hoalchemybox3, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_2_15()

  int.AddScreensaver( "spr_shelvings3_screensaver_2_15" );

end;    
function private.get_screensaver_2_16()

  int.AddScreensaver( "spr_autoclave3_screensaver_2_16" );

end; 
-----------------------------------------------------------------------
function private.get_amuletangel3_2 ()

  cmn.SetEventDone( "get_amuletangel3_2" );
  cmn.CallEventHandler( "get_amuletangel3_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_wrench3 ()

  cmn.SetEventDone( "get_wrench3" );
  cmn.CallEventHandler( "get_wrench3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_glasscutter3 ()

  cmn.SetEventDone( "get_glasscutter3" );
  cmn.CallEventHandler( "get_glasscutter3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amuletbutterfly3 ()

  cmn.SetEventDone( "get_amuletbutterfly3" );
  cmn.CallEventHandler( "get_amuletbutterfly3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_bellows3 ()

  cmn.SetEventDone( "get_bellows3" );
  cmn.CallEventHandler( "get_bellows3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_icarusfigurine3 ()

  cmn.SetEventDone( "get_icarusfigurine3" );
  cmn.CallEventHandler( "get_icarusfigurine3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_reagents3 ()

  cmn.SetEventDone( "get_reagents3" );
  cmn.CallEventHandler( "get_reagents3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_gunpowder3 ()

  cmn.SetEventDone( "get_gunpowder3" );
  cmn.CallEventHandler( "get_gunpowder3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amuletomega3_2 ()

  cmn.SetEventDone( "get_amuletomega3_2" );
  cmn.CallEventHandler( "get_amuletomega3_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------
function private.get_coals3 ()

  ObjSet( "spr_autoclave3_coals3", { alp = 1 } );

  cmn.SetEventDone( "get_coals3" );
  cmn.CallEventHandler( "get_coals3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_propellentcharge3 ()

  cmn.SetEventDone( "get_propellentcharge3" );
  cmn.CallEventHandler( "get_propellentcharge3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_lace3 ()

  cmn.SetEventDone( "get_lace3" );
  cmn.CallEventHandler( "get_lace3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_gasbombs3 ()

  cmn.SetEventDone( "get_gasbombs3" );
  cmn.CallEventHandler( "get_gasbombs3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_crystal3 ()

  cmn.SetEventDone( "get_crystal3" );
  cmn.CallEventHandler( "get_crystal3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_chisel3" ) and  
     cmn.IsEventDone( "get_roundnosepliers3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_chisel3 ()

  cmn.SetEventDone( "get_chisel3" );
  cmn.CallEventHandler( "get_chisel3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_crystal3" ) and 
     cmn.IsEventDone( "get_roundnosepliers3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_roundnosepliers3 ()

  cmn.SetEventDone( "get_roundnosepliers3" );
  cmn.CallEventHandler( "get_roundnosepliers3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_crystal3" ) and 
     cmn.IsEventDone( "get_chisel3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amulethypercube3 ()

  cmn.SetEventDone( "get_amulethypercube3" );
  cmn.CallEventHandler( "get_amulethypercube3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_capsule3" ) ) and
     ( cmn.IsEventDone( "get_amulethypercube3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_capsule3 ()

  cmn.SetEventDone( "get_capsule3" );
  cmn.CallEventHandler( "get_capsule3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_capsule3" ) ) and
     ( cmn.IsEventDone( "get_amulethypercube3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hexagram3 ()

  local item = "inv_hexagram3";

  if ( cmn.ApplyObj( item, "gzz_lab3_storage3", false ) ) and
     ( not cmn.IsEventDone( "use_hexagram3" ) ) and 
       cmn.IsEventDone( "get_hexagram3_1" ) and 
       cmn.IsEventDone( "get_hexagram3_2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storage3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_storage3_use_hexagram3", true ) ) and
         ( not cmn.IsEventDone( "use_hexagram3" ) ) and 
           cmn.IsEventDone( "get_hexagram3_1" ) and 
           cmn.IsEventDone( "get_hexagram3_2" ) then

    cmn.CallEventHandler( "use_hexagram3_inv" );
    cmn.CallEventHandler( "use_hexagram3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_hexagram3" );
      cmn.CallEventHandler( "use_hexagram3_end" );

    end;

    int.Lock( true );

    ObjSet( "obj_storage3_hexagram_close", { alp = 0 } );
    ObjSet( "anm_storage3_use_hexagram", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_storage3_insert_left" );
    AnimPlay( "anm_storage3_use_hexagram", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletbutterfly3 ()

  local item = "inv_amuletbutterfly3";

  if ( cmn.ApplyObj( item, "gzz_lab3_storage3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletbutterfly3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storage3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_storage3_use_amuletbutterfly3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletbutterfly3" ) ) then

    cmn.CallEventHandler( "use_amuletbutterfly3_inv" );
    cmn.CallEventHandler( "use_amuletbutterfly3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletbutterfly3" );
      cmn.CallEventHandler( "use_amuletbutterfly3_end" );

    end;

    int.Lock( true );

    ObjSet( "obj_storage3_amuletbutterfly_close", { alp = 0 } );
    ObjSet( "anm_storage3_use_amuletbutterfly", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_storage3_insert_butterfly" );
    AnimPlay( "anm_storage3_use_amuletbutterfly", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletangel3 ()

  local item = "inv_amuletangel3";

  if ( cmn.ApplyObj( item, "gzz_lab3_storage3", false ) ) and
     ( cmn.IsEventDone( "get_amuletangel3_1" ) ) and
     ( cmn.IsEventDone( "get_amuletangel3_2" ) ) and    
     ( not cmn.IsEventDone( "use_amuletangel3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storage3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_storage3_use_amuletangel3", true ) ) and
         ( cmn.IsEventDone( "get_amuletangel3_1" ) ) and
         ( cmn.IsEventDone( "get_amuletangel3_2" ) ) and        
         ( not cmn.IsEventDone( "use_amuletangel3" ) ) then

    cmn.CallEventHandler( "use_amuletangel3_inv" );
    cmn.CallEventHandler( "use_amuletangel3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletangel3" );
      cmn.CallEventHandler( "use_amuletangel3_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_storage3_insert_2_angels" );
    AnimPlay( "anm_storage3_use_amuletangel", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletaxes3 ()

  local item = "inv_amuletaxes3";

  if ( cmn.ApplyObj( item, "gzz_lab3_windowopening3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletaxes3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowopening3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowopening3_use_amuletaxes3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletaxes3" ) ) then

    cmn.CallEventHandler( "use_amuletaxes3_inv" );
    cmn.CallEventHandler( "use_amuletaxes3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletaxes3" );
      cmn.CallEventHandler( "use_amuletaxes3_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_windowopening3_click_cap", { alp = 0 } );
    ObjSet( "anm_windowopening3_use_amuletaxes", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_windowopening3_insert_figure_2_axes" );
    AnimPlay( "anm_windowopening3_use_amuletaxes", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_gasbombs3 ()

  local item = "inv_gasbombs3";

  if ( cmn.ApplyObj( item, "gzz_lab3_windowopening3", false ) ) and
     ( not cmn.IsEventDone( "use_gasbombs3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowopening3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowopening3_use_gasbombs3", true ) ) and
         ( not cmn.IsEventDone( "use_gasbombs3" ) ) then

    cmn.CallEventHandler( "use_gasbombs3_inv" );
    cmn.CallEventHandler( "use_gasbombs3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_gasbombs3" );
      cmn.CallEventHandler( "use_gasbombs3_end" );
      cmn.CloseSubRoom();
      cmn.GotoRoom( "mg_mgcrowd3" );

    end;

    int.Lock( true );
    func_end();

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_magnetonlace3 ()

  local item = "inv_magnetonlace3";

  if ( cmn.ApplyObj( item, "gzz_lab3_windowopening3", false ) ) and
     ( not cmn.IsEventDone( "use_magnetonlace3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_windowopening3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_windowopening3_use_magnetonlace3", true ) ) and
         ( not cmn.IsEventDone( "use_magnetonlace3" ) ) then

    cmn.CallEventHandler( "use_magnetonlace3_inv" );
    cmn.CallEventHandler( "use_magnetonlace3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_magnetonlace3" );
      cmn.CallEventHandler( "use_magnetonlace3_end" );
      private.Windowopening3Start();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_use_magnet" );
    ObjAnimate( "obj_windowopening3_horseshoe1", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_scalpel3_2 ()

  local item = "inv_scalpel3";

  if ( cmn.ApplyObj( item, "gzz_lab3_autoclave3", false ) ) and
     ( not cmn.IsEventDone( "use_scalpel3_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_autoclave3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_autoclave3_use_scalpel3_2", true ) ) and
         ( not cmn.IsEventDone( "use_scalpel3_2" ) ) then

    cmn.CallEventHandler( "use_scalpel3_2_inv" );
    cmn.CallEventHandler( "use_scalpel3_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_scalpel3_2" );
      cmn.CallEventHandler( "use_scalpel3_2_end" );

      private.get_propellentcharge3();
      private.get_lace3();

    end;

    int.Lock( true );

    ObjSet( "anm_autoclave3_use_scalpel", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_cut_dynamite" );
    AnimPlay( "anm_autoclave3_use_scalpel", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_bluecylinder3 ()

  local item = "inv_bluecylinder3";

  if ( cmn.ApplyObj( item, "gzz_lab3_autoclave3", false ) ) and
     ( not cmn.IsEventDone( "use_bluecylinder3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_autoclave3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_autoclave3_use_bluecylinder3", true ) ) and
         ( not cmn.IsEventDone( "use_bluecylinder3" ) ) then

    cmn.CallEventHandler( "use_bluecylinder3_inv" );
    cmn.CallEventHandler( "use_bluecylinder3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_bluecylinder3" );
      cmn.CallEventHandler( "use_bluecylinder3_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_autoclave_insert_colb_right" );
    AnimPlay( "anm_autoclave3_use_bluecylinder", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_chemicals3 ()

  local item = "inv_chemicals3";

  if ( cmn.ApplyObj( item, "gzz_lab3_autoclave3", false ) ) and
     ( not cmn.IsEventDone( "use_chemicals3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_autoclave3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_autoclave3_use_chemicals3", true ) ) and
         ( not cmn.IsEventDone( "use_chemicals3" ) ) then

    cmn.CallEventHandler( "use_chemicals3_inv" );
    cmn.CallEventHandler( "use_chemicals3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_chemicals3" );
      cmn.CallEventHandler( "use_chemicals3_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_autoclave_fill_red_colb" );
    AnimPlay( "anm_autoclave3_use_chemicals", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_reagents3 ()

  local item = "inv_reagents3";

  if ( cmn.ApplyObj( item, "gzz_lab3_autoclave3", false ) ) and
     ( not cmn.IsEventDone( "use_reagents3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_autoclave3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_autoclave3_use_reagents3", true ) ) and
         ( not cmn.IsEventDone( "use_reagents3" ) ) then

    cmn.CallEventHandler( "use_reagents3_inv" );
    cmn.CallEventHandler( "use_reagents3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_reagents3" );
      cmn.CallEventHandler( "use_reagents3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_autoclave3_use_reagents", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_autoclave_fill_pink_colb" );
    AnimPlay( "anm_autoclave3_use_reagents", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletomega3 ()

  local item = "inv_amuletomega3";

  if ( cmn.ApplyObj( item, "gzz_lab3_shelvings3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletomega3" ) ) and 
       cmn.IsEventDone( "get_amuletomega3_1" ) and 
       cmn.IsEventDone( "get_amuletomega3_2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelvings3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shelvings3_use_amuletomega3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletomega3" ) ) and 
           cmn.IsEventDone( "get_amuletomega3_1" ) and 
           cmn.IsEventDone( "get_amuletomega3_2" ) then

    cmn.CallEventHandler( "use_amuletomega3_inv" );
    cmn.CallEventHandler( "use_amuletomega3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletomega3" );
      cmn.CallEventHandler( "use_amuletomega3_end" );

    end;

    int.Lock( true );

    ObjSet( "obj_shelvings3_box_omega_close", { alp = 0 } );
    ObjSet( "anm_shelvings3_use_amuletomega", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_sheliving3_left_cell_insert" );
    AnimPlay( "anm_shelvings3_use_amuletomega", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletgorgon3 ()

  local item = "inv_amuletgorgon3";

  if ( cmn.ApplyObj( item, "gzz_lab3_shelvings3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletgorgon3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shelvings3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_shelvings3_use_amuletgorgon3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletgorgon3" ) ) then

    cmn.CallEventHandler( "use_amuletgorgon3_inv" );
    cmn.CallEventHandler( "use_amuletgorgon3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletgorgon3" );
      cmn.CallEventHandler( "use_amuletgorgon3_end" );

    end;

    int.Lock( true );

    ObjSet( "obj_shelvings3_box_gorgon_close", { alp = 0 } );
    ObjSet( "anm_shelvings3_use_amuletgorgon", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_sheliving3_insert_stuff_right_cell" );
    AnimPlay( "anm_shelvings3_use_amuletgorgon", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_battery3 ()

  local item = "inv_battery3";

  if ( cmn.ApplyObj( item, "gzz_lab3_device3", false ) ) and
     ( not cmn.IsEventDone( "use_battery3" ) ) and
     ( cmn.IsEventDone( "use_roundnosepliers3_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_device3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_device3_use_battery3", true ) ) and
         ( not cmn.IsEventDone( "use_battery3" ) ) and
         ( cmn.IsEventDone( "use_roundnosepliers3_2" ) ) then

    cmn.CallEventHandler( "use_battery3_inv" );
    cmn.CallEventHandler( "use_battery3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_battery3" );
      cmn.CallEventHandler( "use_battery3_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_device3_insert_battery" );
    AnimPlay( "anm_device3_battery", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_roundnosepliers3_2 ()

  local item = "inv_roundnosepliers3";

  if ( cmn.ApplyObj( item, "gzz_lab3_device3", false ) ) and
     ( not cmn.IsEventDone( "use_roundnosepliers3_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_device3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_device3_use_roundnosepliers3_2", true ) ) and
         ( not cmn.IsEventDone( "use_roundnosepliers3_2" ) ) then

    cmn.CallEventHandler( "use_roundnosepliers3_2_inv" );
    cmn.CallEventHandler( "use_roundnosepliers3_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_roundnosepliers3_2" );
      cmn.CallEventHandler( "use_roundnosepliers3_2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_device3_roundnosepliers", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_device3_cut_wires" );
    AnimPlay( "anm_device3_roundnosepliers", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.use_butterflypart3_1 ()

  if ( cmn.ApplyObj( "spr_windowopening3_ho_1", "spr_windowopening3_base", true ) ) then

    int.Lock( false );
    cmn.SetEventDone( "use_butterflypart3_1" );
    cmn.CallEventHandler( "use_butterflypart3_1_end" );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_butterfly_insert_right" );

  else

    ObjSet( "spr_windowopening3_ho_1", { pos_z = 0 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_butterflypart3_2 ()

  if ( cmn.ApplyObj( "spr_windowopening3_ho_2", "spr_windowopening3_base", true ) ) then

    int.Lock( false );
    cmn.SetEventDone( "use_butterflypart3_2" );
    cmn.CallEventHandler( "use_butterflypart3_2_end" );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_butterfly_insert_right" );

  else

    ObjSet( "spr_windowopening3_ho_2", { pos_z = 0 } );

  end;

end;
--------------------------------------------------------------------------------------------
function private.use_butterflypart3_3 ()

  if ( cmn.ApplyObj( "spr_windowopening3_ho_3", "spr_windowopening3_base", true ) ) then

    int.Lock( false );
    cmn.SetEventDone( "use_butterflypart3_3" );
    cmn.CallEventHandler( "use_butterflypart3_3_end" );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_inv_butterfly_insert_right" );

  else

    ObjSet( "spr_windowopening3_ho_3", { pos_z = 0 } );

  end; 

end;
--------------------------------------------------------------------------------------------
function private.clk_autoclave3_button ()

  cmn.CallEventHandler( "clk_autoclave3_button_inv" );
  cmn.CallEventHandler( "clk_autoclave3_button_beg" );

  local func_end = function ()

    local func_end1 = function ()

      int.Lock( false );
      cmn.SetEventDone( "clk_autoclave3_button" );
      cmn.CallEventHandler( "clk_autoclave3_button_end" );
      ObjSet( "spr_autoclave3_back_over", { alp = 1 } );
      ObjSet( "spr_autoclave3_web_all", { alp = 1 } );

    end; 

    ObjSet( "spr_autoclave3_back_over", { alp = 0 } );
    ObjSet( "anm_autoclave3_bottle", { alp = 1 } );
    ObjSet( "spr_autoclave3_web_all", { alp = 0 } );
    AnimPlay( "anm_autoclave3_bottle", "DoAnim", func_end1 ); 

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_autoclave_click_button" );
  AnimPlay( "anm_autoclave3_button", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function private.see_amuletangel3_2 ()

  cmn.CallEventHandler( "see_amuletangel3_2_inv" );
  cmn.CallEventHandler( "see_amuletangel3_2_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "see_amuletangel3_2" );
    cmn.CallEventHandler( "see_amuletangel3_2_end" );

    ObjSet( "anm_lab3_light_lamps", { alp = 1 } );
    AnimPlay( "anm_lab3_light_lamps", "DoAnim", "" );

    interface.KeyTaskDone( true, "task_3_8" );

  end;

  int.Lock( true );
  --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_autoclave_click_button" );

  ObjSet( "anm_lab3_angel", { alp = 1 } );
  ObjSet( "anm_lab3_light_lamps", { alp = 0 } );

  AnimStop( "anm_lab3_light_lamps" );
  AnimPlay( "anm_lab3_angel", "DoAnim", func_end );

end;
-----------------------------------------------------------------------
--*********************************************************************************************************************
function private.dlg_lab3_emily3_3 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_amuletangel3_2" );
    cmn.GetObjectSfx();

    ObjSet( "anm_lab3_emily3_3_emily_static_1", { alp = 0 } );
    ObjSet( "anm_lab3_emily3_3_emily_static_2", { alp = 0 } );

    AnimStop( "anm_lab3_emily3_3_emily_static_1" );
    AnimStop( "anm_lab3_emily3_3_emily_static_2" );

    ObjAnimate( "anm_lab3_emily3_3_emily_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );

    if ( func_end ) then

      func_end();

    end;

    cmn.SetEventDone( "get_amuletangel3_2" );
    cmn.SetEventDone( "dlg_lab3_emily3_3" );
    level3_inv.CheckAmuletAngel3( 2 );

    --cmn.ShowBbt( "bbt_lab3_after_dlg_emily" );

    interface.KeyTaskDone( true, "task_3_8" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_lab3_emily3_3_emily_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "emily3_3", "lab3", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_lab3_emily3_3_beg" );
  ObjAttach( "dlg_lab3_emily3_3", GetCurrentRoom() );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_lab3_emily3_3_emily_static_1", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "emily3_3" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_lab3_emily3_3_emily_static_1" );
        AnimPlay( "anm_lab3_emily3_3_emily_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_lab3_emily3_3_emily_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_lab3_emily3_3_emily_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    elseif ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_lab3_emily3_3_emily_static_2" );
        AnimPlay( "anm_lab3_emily3_3_emily_give", "DoAnim", "" );

      end;

      ObjAnimate( "anm_lab3_emily3_3_emily_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_lab3_emily3_3_emily_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.Lab3BombPlantAnim ()
  
  int.Lock( true );

  local mas_widgets = {
     InterfaceWidget_BtnHint
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_BtnMap   
  };

  if ( IsCollectorsEdition() ) then

    mas_widgets = {
       InterfaceWidget_BtnHint
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_BtnGuide    
    };

  end;

  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[ i ], false, true, 0.3 ); 

  end;

  cmn.StopAllMus();
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_loc_anim_maradeur", 0, 0 );
  cmn.PlayAudio( "voc", "audio/level3/voc/aud_lvl3_marauder1_voc", 0, 0 );


  ObjSet( "obj_lab3_gates", { visible = false } );
  interface.DialogVideoShow( "", 1, function() private.Lab3BombPlantAnim_End( "skip" ); end, 0 );
  AnimPlay( "anm_lab3_bomb_plant", "DoAnim", private.Lab3BombPlantAnim_End );

  local func_subtitle_1 = function ()

    interface.DialogVideoSubtitleShow( "sub_lab3_marauder_1" );  

  end;

  local func_subtitle_2 = function ()

    interface.DialogVideoSubtitleShow( "sub_lab3_marauder_2" );  

  end;

  local func_subtitle_end = function ()

    interface.DialogVideoSubtitleHide();  

  end;

  cmn.WaitAndRun( func_subtitle_1, 1.0 );
  cmn.WaitAndRun( func_subtitle_end, 6.8 );
  cmn.WaitAndRun( func_subtitle_2, 7.2 );
  cmn.WaitAndRun( func_subtitle_end, 13.3 );
  
end;
--*********************************************************************************************************************
function private.Lab3BombPlantAnim_End ( skip ) 
 
  local mas_widgets = {
     InterfaceWidget_BtnHint
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_BtnMap   
  };

  if ( IsCollectorsEdition() ) then

    mas_widgets = {
       InterfaceWidget_BtnHint
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_BtnGuide    
    };

  end;
  
  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[ i ], true, true, 0.3 ); 

  end;
  
  interface.DialogVideoHide();
  --interface.DialogVideoSubtitleHide();
  ObjSet( "obj_lab3_gates", { visible = true } );
  
  cmn.SetEventDone( "opn_lab3" );
  cmn.CallEventHandler( "opn_lab3" );
  int.Lock( false );
  
  if skip then

    cmn.StopAudio( "sfx", "audio/level3/sfx/aud_loc_anim_maradeur", 0.2 );
    cmn.StopAudio( "voc", "audio/level3/voc/aud_lvl3_marauder1_voc", 0.2 );
    
  end; 

  --cmn.PlayMusEnv( "common/audio/aud_danger2_mus" );  
  
end; 
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_lab3 ()

  if not ( cmn.IsEventDone( "opn_lab3" ) ) then

    private.Lab3BombPlantAnim();

  end;

  cmn.StopAllEnv( "audio/level3/env/aud_rm_lab3_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_lab3_env", 1 );

  if ( cmn.IsEventDone( "win_mgcrowd3" ) ) and
     ( not cmn.IsEventDone( "see_amuletangel3_2" ) ) then

    private.see_amuletangel3_2();

  end;

  if ( cmn.IsEventDone( "win_generator3" ) ) and
     not ( cmn.IsEventDone( "win_mgcrowd3" ) ) and
     ( ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window < 3 ) then

    int.Lock( true );

    if ( ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window == 0 ) then

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_rm_lab3_throw_stone_1" );
      AnimPlay( "anm_lab3_window", "1_item",
      function ()

        ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window = 1;

        int.Lock( false );
        ObjSet( "anm_lab3_window", { frame = 0, animfunc = "2_items" } );

      end );

    elseif ( ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window == 1 ) then

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_rm_lab3_throw_stone_2" );
      AnimPlay( "anm_lab3_window", "2_items",
      function ()

        ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window = 2;

        int.Lock( false );
        ObjSet( "anm_lab3_window", { frame = 0, animfunc = "last_item" } );

      end );

    elseif ( ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window == 2 ) then

      AnimPlay( "anm_lab3_window", "last_item",
      function ()

        ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window = 3;

        int.Lock( false );
        ObjSet( "anm_lab3_window", { frame = 0, animfunc = "end_anim" } );

      end );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window ) then

    ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window = 0;

  else

    if ( ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window == 0 ) then

      ObjSet( "anm_lab3_window", { frame = 0, animfunc = "1_item" } );

    elseif ( ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window == 1 ) then

      ObjSet( "anm_lab3_window", { frame = 0, animfunc = "2_items" } );

    elseif ( ng_global.progress[ ng_global.currentprogress ][ "opn_lab3" ].window == 2 ) then

      ObjSet( "anm_lab3_window", { frame = 0, animfunc = "last_item" } );

    else

      ObjSet( "anm_lab3_window", { frame = 0, animfunc = "end_anim" } );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_lab3();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_amuletangel3_2",                              { "see_amuletangel3_2" } );
  int.AddedTaskMap( private.room_objname, "get_wrench3",                                     { "use_amuletaxes3" } );
  int.AddedTaskMap( private.room_objname, "get_glasscutter3",                                { "use_hexagram3" } );
  int.AddedTaskMap( private.room_objname, "get_bellows3",                                    { "use_hexagram3" } );
  int.AddedTaskMap( private.room_objname, "get_icarusfigurine3",                             { "use_amuletbutterfly3" } );
  int.AddedTaskMap( private.room_objname, "get_reagents3",                                   { "use_amuletbutterfly3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletomega3_2" );
  int.AddedTaskMap( private.room_objname, "get_gunpowder3",                                  { "use_amuletaxes3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletbutterfly3",                            { "use_butterflypart3_1", "use_butterflypart3_2", "use_butterflypart3_3" } );
  int.AddedTaskMap( private.room_objname, "get_coals3" );
  int.AddedTaskMap( private.room_objname, "get_propellentcharge3",                           { "use_scalpel3_2" } );
  int.AddedTaskMap( private.room_objname, "get_lace3",                                       { "use_scalpel3_2" } );
  int.AddedTaskMap( private.room_objname, "get_gasbombs3",                                   { "clk_autoclave3_button" } );
  int.AddedTaskMap( private.room_objname, "get_crystal3",                                    { "use_amuletgorgon3" } );
  int.AddedTaskMap( private.room_objname, "get_chisel3",                                     { "use_amuletomega3" } );
  int.AddedTaskMap( private.room_objname, "get_roundnosepliers3",                            { "use_amuletomega3" } );
  int.AddedTaskMap( private.room_objname, "get_amulethypercube3",                            { "use_roundnosepliers3_2" } );
  int.AddedTaskMap( private.room_objname, "get_capsule3",                                    { "use_battery3" } );

  int.AddedTaskMap( private.room_objname, "use_hexagram3",                                   { "get_hexagram3_1", "get_hexagram3_2" } );
  int.AddedTaskMap( private.room_objname, "use_amuletbutterfly3",                            { "get_amuletbutterfly3" } );
  int.AddedTaskMap( private.room_objname, "use_amuletangel3",                                { "get_amuletangel3_1", "get_amuletangel3_2" } );
  int.AddedTaskMap( private.room_objname, "use_amuletaxes3",                                 { "get_amuletaxes3" } );
  int.AddedTaskMap( private.room_objname, "use_gasbombs3",                                   { "get_gasbombs3" } );
  int.AddedTaskMap( private.room_objname, "use_magnetonlace3",                               { "get_magnetonlace3" } );
  int.AddedTaskMap( private.room_objname, "use_scalpel3_2",                                  { "get_scalpel3" } );
  int.AddedTaskMap( private.room_objname, "use_bluecylinder3",                               { "get_bluecylinder3" } );
  int.AddedTaskMap( private.room_objname, "use_chemicals3",                                  { "get_chemicals3" } );
  int.AddedTaskMap( private.room_objname, "use_reagents3",                                   { "get_reagents3" } );
  int.AddedTaskMap( private.room_objname, "use_amuletomega3",                                { "get_amuletomega3_1", "get_amuletomega3_2" } );
  int.AddedTaskMap( private.room_objname, "use_amuletgorgon3",                               { "get_amuletgorgon3" } );
  int.AddedTaskMap( private.room_objname, "use_battery3",                                    { "get_battery3", "use_roundnosepliers3_2" } );
  int.AddedTaskMap( private.room_objname, "use_roundnosepliers3_2",                          { "get_roundnosepliers3" } );
  int.AddedTaskMap( private.room_objname, "use_butterflypart3_1",                            { "win_windowopening3" } );
  int.AddedTaskMap( private.room_objname, "use_butterflypart3_2",                            { "win_windowopening3" } );
  int.AddedTaskMap( private.room_objname, "use_butterflypart3_3",                            { "win_windowopening3" } );

  int.AddedTaskMap( private.room_objname, "clk_autoclave3_button",                           { "use_bluecylinder3", "use_chemicals3", "use_reagents3" } );

  int.AddedTaskMap( private.room_objname, "see_amuletangel3_2",                              { "win_mgcrowd3" } );

  int.AddedTaskMap( private.room_objname, "win_mgcrowd3",                                    { "use_gasbombs3" } );
  int.AddedTaskMap( private.room_objname, "win_windowopening3",                              { "use_magnetonlace3" } );
  int.AddedTaskMap( private.room_objname, "win_hoalchemybox3",                               { "use_amuletangel3" } );

  int.AddedTaskMap( private.room_objname, "dlg_towerroof3_emily3_2",                         { "clk_generator3_lever" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_storage3" );
  subroom.Define( "zz_windowopening3" );
  -------------------------------------------------
  function zz_storage3.PreOpen ()

   --if cmn.IsEventDone( "get_swordhandle3" ) then
   --  int_button_mini_ho.Show( "get_swordhandle3", "storage3", 5, "spr_storage3_swordhandle_panel", private.mini_ho_array ); 
   --end;       
       
  end;  
  -------------------------------------------------
  function zz_storage3.PreClose()

    --if cmn.IsEventDone( "get_swordhandle3" ) then
    --  int_button_mini_ho.Hide(); 
    --end;        
       
  end; 
  -------------------------------------------------
  function zz_windowopening3.Open()
    
    if ( cmn.IsEventStart( "win_windowopening3" ) and not cmn.IsEventDone( "win_windowopening3" ) ) then

      cmn.MiniGameShow( "windowopening3" );
      common_impl.PassingMgStart( "windowopening3" );

    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_windowopening3_loop_env", 1 );

  end;
  -------------------------------------------------
  function zz_windowopening3.PreClose()
        
    if ( cmn.IsEventStart( "win_windowopening3" ) and not cmn.IsEventDone( "win_windowopening3" ) ) then

      cmn.MiniGameHide( "windowopening3" );
      common_impl.PassingMgStop( "windowopening3" );

    end;
    
  end;
  -------------------------------------------------
  function zz_windowopening3.Close()

    cmn.NoteScaleEnd( { "spr_windowopening3_note" }, true );
    cmn.StopAudio( "sfx", "audio/level3/sfx/aud_zz_windowopening3_loop_env", 0.5 );

  end;
  -------------------------------------------------
  function zz_windowopening3.Skip ()

    if ( cmn.IsEventStart( "win_windowopening3" ) and not cmn.IsEventDone( "win_windowopening3" ) ) then
      private.Windowopening3Skip();
    end;

  end;
  -------------------------------------------------
  function zz_windowopening3.Reset ()

    if ( cmn.IsEventStart( "win_windowopening3" ) and not cmn.IsEventDone( "win_windowopening3" ) ) then
      private.Windowopening3Reset();
    end;

  end;
  -------------------------------------------------
  subroom.Define( "zz_autoclave3" );
  -----------------------------------------------
  function zz_autoclave3.Close ()

    cmn.NoteScaleEnd( { "spr_autoclave3_note", "spr_autoclave3_diary" }, true );

  end;
  -------------------------------------------------
  subroom.Define( "zz_device3" );
  -------------------------------------------------
  function zz_device3.Close()

    cmn.NoteScaleEnd( { "spr_device3_note" }, true );

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_shelvings3_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1
  } );
  ObjAnimate( "spr_storage3_glasscutter_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0,
    4.0, 3, 1
  } );
  ObjAnimate( "spr_lab3_autuclave_bottle_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0,
    4.0, 3, 1
  } );
  ObjAnimate( "spr_autoclave3_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Windowopening3 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Windowopening3Start ()

    cmn.MiniGameShow( "windowopening3" );
    common_impl.PassingMgStart( "windowopening3" );

    ng_global.progress[ "std" ][ "win_windowopening3" ].butterfly = { 0, 0, 0, 0 };

  end;
  --*********************************************************************************************************************
  function private.Windowopening3Load ()
    
    for i = 1, 4 do
      if ng_global.progress[ "std" ][ "win_windowopening3" ].butterfly[ i ] == 1 then
        ObjAttach( "spr_windowopening3_butterfly_"..i, "obj_windowopening3_butterflys_deleted" );
        ObjSet( "spr_windowopening3_green_butterfly"..i, { alp = 0 } );
      end; 
    end;
    
  end;
  --*********************************************************************************************************************
  function private.Windowopening3Skip ()

    int.Lock( true );
    ObjAnimate( "obj_windowopening3_horseshoe", "pos_y", 0, 0, function() private.Windowopening3Win(); end, 
    { 
      0.0, 3, 0,
      1.2, 3, -600,
    } );
    
  end
  --*********************************************************************************************************************
  function private.Windowopening3Reset ()
    
    for i = 1, 4 do
      if ng_global.progress[ "std" ][ "win_windowopening3" ].butterfly[ i ] == 1 then
        ObjAttach( "spr_windowopening3_butterfly_"..i, "obj_windowopening3_butterflys_cur" );
        ObjSet( "spr_windowopening3_green_butterfly"..i, { alp = 1 } );
        ObjSet( "spr_windowopening3_butterfly_"..i, { alp = 0 } );
      end; 
    end;
    
    ng_global.progress[ "std" ][ "win_windowopening3" ].butterfly = { 0, 0, 0, 0 };
    ObjSet( "obj_windowopening3_horseshoe1", { pos_x = 17, pos_y = 148 } );

  end;  
  --*********************************************************************************************************************
  function private.Windowopening3Init ()

    ObjSet( "obj_windowopening3_drag",
    {
      event_drag  = function () private.Windowopening3Drag() end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

    private.flag = false;

  end;
  --*********************************************************************************************************************
  function private.Windowopening3Drag ()

    local pos = GetZoomCursorPos();
    local x = pos[ 1 ] - 512;
    local y = pos[ 2 ] - 384;

    if x > - 350 and x < 350 and y > - 275 and y < 275 then
      ObjSet( "obj_windowopening3_horseshoe1", { pos_x = x, pos_y = y } );
    else
      ObjStopDrag( "obj_windowopening3_drag" );
    end;

    for i = 1, 2 do
      for j = 1, 4 do
        if ( cmn.ApplyObj( "obj_windowopening3_point_"..i, "spr_windowopening3_butterfly_"..j, true ) ) then

          if not private.flag then

            private.flag = true;
            int.Lock( true );

            local func_end = function ()

              ObjAttach( "spr_windowopening3_butterfly_"..j, "obj_windowopening3_butterflys_deleted" );
              ng_global.progress[ "std" ][ "win_windowopening3" ].butterfly[ j ] = 1; 

              private.flag = false;
              int.Lock( false );

            end;

            local func_end_win = function ()
              private.Windowopening3Win();
            end;

            local count = 0;
            for k = 1 , 4 do
              if ng_global.progress[ "std" ][ "win_windowopening3" ].butterfly[ k ] == 1 then
                count = count + 1;
              end;
            end; 

            cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_take_stuffs_magnet_catch" );

            if count == 3 then

              ObjAnimate( "obj_windowopening3_horseshoe", "pos_y", 0, 0, func_end_win, 
              { 
                0.0, 3, 0,
                1.2, 3, -600,
                1.4, 3, -600
              } );

            else 

              ObjAnimate( "obj_windowopening3_horseshoe", "pos_y", 0, 0, func_end, 
              { 
                0.0, 3, 0,
                1.2, 3, -600,
                1.4, 3, -600,
                2.6, 3, 0,
              } );

            end;

            ObjStopDrag( "obj_windowopening3_drag" );
            ObjAttach( "spr_windowopening3_butterfly_"..j, "obj_windowopening3_horseshoe");
            ObjSet( "spr_windowopening3_butterfly_"..j, { alp = 1 } );
            ObjSet( "spr_windowopening3_green_butterfly"..j, { alp = 0 } );

            AnimPlay( "anm_windowopening3_ring"..j, "DoAnim", "" );

            ObjAnimate( "spr_windowopening3_butterfly_"..j, "alp", 0, 0, "", 
            { 
              0.0, 3, 1,
              1.2, 3, 1,
              1.4, 3, 0,
            } );

          end;

        end;
      end;
    end;

  end;
  --*********************************************************************************************************************
  function private.Windowopening3Win ()
       
    cmn.MiniGameHide( "windowopening3" );
    cmn.SetEventDone( "win_windowopening3" );
    cmn.CallEventHandler( "win_windowopening3" );
    common_impl.PassingMgWin( "windowopening3" );
    int.Lock( false );
        
  end;
--*********************************************************************************************************************
function private.Windowopening3ButterflyPartClk ( id )

  ObjSet( "spr_windowopening3_ho_"..id, { pos_z = 10 } );

end;
--*********************************************************************************************************************
function private.Storage3AmuletbutterflyClk () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_storage3_use_amuletbutterfly3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_storage3_right_hidden_cell" );
  AnimPlay( "anm_storage3_clk_amuletbutterfly", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Storage3HexagramClk () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_storage3_use_hexagram3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_storage3_left_hidden_cell" );
  AnimPlay( "anm_storage3_clk_hexagram", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Shelvings3AmuletomegaClk () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_shelvings3_use_amuletomega3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_sheliving3_left_cell" );
  AnimPlay( "anm_shelvings3_clk_amuletomega", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Shelvings3AmuletgorgonClk () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_shelvings3_use_amuletgorgon3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_sheliving3_right_cell" );
  AnimPlay( "anm_shelvings3_clk_amuletgorgon", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Windowopening3CapClk () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_windowopening3_use_amuletaxes3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_windowopening3_right" );
  AnimPlay( "anm_windowopening3_click_cap", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Autoclave3BombClick () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_autoclave3_use_scalpel3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_bomb_1" );
  AnimPlay( "anm_autoclave3_bomb_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Autoclave3DiaryClick ( number )

  ObjSet( "obj_autoclave3_diary_click_right", { input = true, color_r = 1, color_g = 1, color_b = 1 } );  
  ObjSet( "obj_autoclave3_diary_click_left", { input = true, color_r = 1, color_g = 1, color_b = 1 } );    
  
  ObjSet( "obj_autoclave3_diary_page_"..private.autoclave3_page_diary, { alp = 0 } );
  
  private.autoclave3_page_diary = private.autoclave3_page_diary + number;

  if (private.autoclave3_page_diary >= 4) then
    private.autoclave3_page_diary = 4;    
    ObjSet( "obj_autoclave3_diary_click_right", { input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5 } );     
    
  elseif(private.autoclave3_page_diary <= 1) then
    private.autoclave3_page_diary = 1;      
    ObjSet( "obj_autoclave3_diary_click_left", { input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5 } );     
  end;
  
  ObjSet( "obj_autoclave3_diary_page_"..private.autoclave3_page_diary, { alp = 1 } );  

end;
--*********************************************************************************************************************