-- name=rm_mortuary3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_mortuary3";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_stand3",     "room_hub" );
  ObjAttach( "zz_fridges3",   "room_hub" );
  ObjAttach( "zz_cardindex3", "room_hub" );

  ObjMultiSet(
  {
    { "spr_stand3_scalpel3",                  { event_mdown = private.get_scalpel3 } },
    { "spr_cardindex3_spirit3",               { event_mdown = private.get_spirit3 } },
    { "spr_stand3_gear3_3",                   { event_mdown = private.get_gear3_3 } },
    { "spr_stand3_probe3",                    { event_mdown = private.get_probe3 } },
    { "spr_fridges3_lever3",                  { event_mdown = private.get_lever3 } },
    { "spr_fridges3_amulethydra3_3",          { event_mdown = private.get_amulethydra3_3 } },
    { "spr_stand3_gear3_2",                   { event_mdown = private.get_gear3_2 } },
    { "obj_cardindex3_use_amulethydra3",      { event_mdown = private.Cardindex3BoxClick } },
    { "obj_fridges3_use_probe3",              { event_mdown = private.Fridges3amulethydraClick } },
    { "obj_cardindex3_use_spellabsorbent3_2", { event_mdown = private.Cardindex3SpiritClick } },
    { "obj_stand3_lever_clk",                 { event_mdown = function() private.clk_stand3_lever() end } },
    { "obj_stand3_use_amuletlapwing3",        { event_mdown = function() private.Stand3AmuletlapwingClk() end } },
    { "obj_stand3_use_amuletshamrock3",       { event_mdown = function() private.Stand3AmuletshamrockClk() end } },
    { "obj_stand3_use_lever3",                { event_mdown = function() private.Stand3LeverClk() end } },
    { "spr_stand3_screensaver_2_23",          { event_mdown = private.get_screensaver_2_23 } },      
    { "spr_fridges3_screensaver_2_24",        { event_mdown = private.get_screensaver_2_24 } },          
  } );
  local get_screensaver_2_23 = function ()

    ObjDelete( "spr_stand3_screensaver_2_23" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_23", get_screensaver_2_23, private.room_objname );  
  local get_screensaver_2_24 = function ()

    ObjDelete( "spr_fridges3_screensaver_2_24" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_24", get_screensaver_2_24, private.room_objname );  
   
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mortuary3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_mortuary3", update_game_mode_mortuary3, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function opn_mortuary3 () end;
  --------------------------------------------------------------------------------------------
  local opn_mortuary3 = function ()


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_mortuary3", opn_mortuary3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_2 = function ()

    ObjDelete( "obj_mortuary3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_3_2", get_morphobject_3_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_scalpel3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scalpel3" ] =
  {
    type = "get",
    get_obj = "spr_stand3_scalpel3",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_mortuary3_stand3"
  };
  --------------------------------------------------------------------------------------------
  local get_scalpel3_inv = function ()

    int.InventoryItemAdd( "inv_scalpel3", "spr_stand3_scalpel3" );

  end;
  local get_scalpel3_closezz = function ()

    ObjDelete( "gfx_stand3_scalpel3" );
    ObjDelete( "spr_mortuary3_stand_scalpel" );

    if cmn.IsEventDone( "get_scalpel3" ) and 
       cmn.IsEventDone( "get_gear3_3" ) and 
       cmn.IsEventDone( "get_gear3_2" ) and 
       cmn.IsEventDone( "get_probe3" ) then

      ObjDelete( "gzz_mortuary3_stand3" );

    end;


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_scalpel3", get_scalpel3_inv );
  cmn.AddSubscriber( "get_scalpel3", get_scalpel3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spirit3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spirit3" ] =
  {
    type = "get",
    get_obj = "spr_cardindex3_spirit3",
    room = private.room_objname,
    zz = "zz_cardindex3",
    zz_gate = "gzz_mortuary3_cardindex3"
  };
  --------------------------------------------------------------------------------------------
  local get_spirit3_inv = function ()

    int.InventoryItemAdd( "inv_spirit3", "spr_cardindex3_spirit3" );

  end;
  local get_spirit3_closezz = function ()

    ObjDelete( "gfx_cardindex3_spirit3" );
    ObjDelete( "spr_mortuary3_cardindex_spirit" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_spirit3", get_spirit3_inv );
  cmn.AddSubscriber( "get_spirit3", get_spirit3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gear3_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gear3_3" ] =
  {
    type = "get",
    get_obj = "spr_stand3_gear3_3",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_mortuary3_stand3"
  };
  --------------------------------------------------------------------------------------------
  local get_gear3_3_inv = function ()

    int.InventoryItemAdd( "inv_gear3", "spr_stand3_gear3_3", "assets/levels/level3/rm_park3/zz_highrelief3/inv/inv_gear3_3" );
    level3_inv.CheckGear3();

  end;
  local get_gear3_3_closezz = function ()

    ObjDelete( "gfx_stand3_gear3_3" );
    ObjDelete( "spr_mortuary3_stand_gear" );

    if cmn.IsEventDone( "get_scalpel3" ) and 
       cmn.IsEventDone( "get_gear3_3" ) and 
       cmn.IsEventDone( "get_gear3_2" ) and 
       cmn.IsEventDone( "get_probe3" ) then

      ObjDelete( "gzz_mortuary3_stand3" );

    end;


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gear3_3", get_gear3_3_inv );
  cmn.AddSubscriber( "get_gear3_3", get_gear3_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_probe3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_probe3" ] =
  {
    type = "get",
    get_obj = "spr_stand3_probe3",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_mortuary3_stand3"
  };
  --------------------------------------------------------------------------------------------
  local get_probe3_inv = function ()

    int.InventoryItemAdd( "inv_probe3", "spr_stand3_probe3" );

  end;
  local get_probe3_closezz = function ()

    ObjDelete( "gfx_stand3_probe3" );
    ObjDelete( "spr_stand3_probe_shadow" );

    ObjDelete( "spr_mortuary3_stand_probe" );

    if cmn.IsEventDone( "get_scalpel3" ) and 
       cmn.IsEventDone( "get_gear3_3" ) and 
       cmn.IsEventDone( "get_gear3_2" ) and 
       cmn.IsEventDone( "get_probe3" ) then

      ObjDelete( "gzz_mortuary3_stand3" );

    end;


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_probe3", get_probe3_inv );
  cmn.AddSubscriber( "get_probe3", get_probe3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lever3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lever3" ] =
  {
    type = "get",
    get_obj = "spr_fridges3_lever3",
    room = private.room_objname,
    zz = "zz_fridges3",
    zz_gate = "gzz_mortuary3_fridges3"
  };
  --------------------------------------------------------------------------------------------
  local get_lever3_inv = function ()

    int.InventoryItemAdd( "inv_lever3", "spr_fridges3_lever3" );

  end;
  local get_lever3_closezz = function ()

    ObjDelete( "gfx_fridges3_lever3" );
    ObjDelete( "spr_fridges3_lever3_shadow" );

    ObjDelete( "spr_mortuary3_fridge_lever" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lever3", get_lever3_inv );
  cmn.AddSubscriber( "get_lever3", get_lever3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulethydra3_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulethydra3_3" ] =
  {
    type = "get",
    get_obj = "spr_fridges3_amulethydra3_3",
    room = private.room_objname,
    zz = "zz_fridges3",
    zz_gate = "gzz_mortuary3_fridges3"
  };
  --------------------------------------------------------------------------------------------
  local get_amulethydra3_3_inv = function ()

    int.InventoryItemAdd( "inv_amulethydra3", "spr_fridges3_amulethydra3_3", "assets/levels/level3/rm_park3/zz_fountain3/inv/inv_amulethydra3_3" );
    level3_inv.CheckAmulethydra3();

  end;
  local get_amulethydra3_3_closezz = function ()

    ObjDelete( "gfx_fridges3_amulethydra3_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amulethydra3_3", get_amulethydra3_3_inv );
  cmn.AddSubscriber( "get_amulethydra3_3", get_amulethydra3_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gear3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gear3_2" ] =
  {
    type = "get",
    get_obj = "spr_stand3_gear3_2",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_mortuary3_stand3"
  };
  --------------------------------------------------------------------------------------------
  local get_gear3_2_inv = function ()

    int.InventoryItemAdd( "inv_gear3", "spr_stand3_gear3_2", "assets/levels/level3/rm_park3/zz_highrelief3/inv/inv_gear3_2" );
    level3_inv.CheckGear3();

  end;
  local get_gear3_2_closezz = function ()

    ObjDelete( "gfx_stand3_gear3_2" );
    ObjDelete( "spr_mortuary3_stand_gear2" );

    if cmn.IsEventDone( "get_scalpel3" ) and 
       cmn.IsEventDone( "get_gear3_3" ) and 
       cmn.IsEventDone( "get_gear3_2" ) and 
       cmn.IsEventDone( "get_probe3" ) then

      ObjDelete( "gzz_mortuary3_stand3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gear3_2", get_gear3_2_inv );
  cmn.AddSubscriber( "get_gear3_2", get_gear3_2_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_amuletlapwing3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletlapwing3" ] =
  {
    type = "use",
    use_obj = "inv_amuletlapwing3",
    use_place = "obj_stand3_use_amuletlapwing3",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_mortuary3_stand3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletlapwing3_inv = function ()

    int.InventoryItemRemove( "inv_amuletlapwing3" );

  end;
  local use_amuletlapwing3_beg = function ()

    ObjDelete( "obj_stand3_use_amuletlapwing3" );

  end;
  local use_amuletlapwing3_end = function ()

    ObjSet( "obj_stand3_open_box", { input = true } );
    ObjSet( "gfx_stand3_probe3", { active = true } );
    ObjSet( "gfx_stand3_gear3_3", { active = true } );
    ObjDelete( "obj_stand3_close_box" );

    ObjSet( "spr_mortuary3_stand_open_box", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletlapwing3",     use_amuletlapwing3_inv );
  cmn.AddSubscriber( "use_amuletlapwing3",     use_amuletlapwing3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletlapwing3",     use_amuletlapwing3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletlapwing3_inv", use_amuletlapwing3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletlapwing3_beg", use_amuletlapwing3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletlapwing3_end", use_amuletlapwing3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletshamrock3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletshamrock3" ] =
  {
    type = "use",
    use_obj = "inv_amuletshamrock3",
    use_place = "obj_stand3_use_amuletshamrock3",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_mortuary3_stand3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletshamrock3_inv = function ()

    int.InventoryItemRemove( "inv_amuletshamrock3" );

  end;
  local use_amuletshamrock3_beg = function ()

    ObjDelete( "obj_stand3_use_amuletshamrock3" );

  end;
  local use_amuletshamrock3_end = function ()

    ObjSet( "obj_stand3_medicine_open", { input = true } );
    ObjSet( "anm_stand3_use_amuletshamrock", { alp = 1, frame = 500 } );
    ObjDelete( "obj_stand3_medicine_close" );

    ObjSet( "spr_mortuary3_stand_open_medicine", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletshamrock3",     use_amuletshamrock3_inv );
  cmn.AddSubscriber( "use_amuletshamrock3",     use_amuletshamrock3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletshamrock3",     use_amuletshamrock3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletshamrock3_inv", use_amuletshamrock3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletshamrock3_beg", use_amuletshamrock3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletshamrock3_end", use_amuletshamrock3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lever3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lever3" ] =
  {
    type = "use",
    use_obj = "inv_lever3",
    use_place = "obj_stand3_use_lever3",
    room = private.room_objname,
    zz = "zz_stand3",
    zz_gate = "gzz_mortuary3_stand3"
  };
  --------------------------------------------------------------------------------------------
  local use_lever3_inv = function ()

    int.InventoryItemRemove( "inv_lever3" );

  end;
  local use_lever3_beg = function ()

    ObjDelete( "obj_stand3_use_lever3" );

  end;
  local use_lever3_end = function ()

    ObjSet( "spr_mortuary3_lever", { alp = 1 } );

    ObjSet( "obj_stand3_open_cash", { input = true } );
    ObjSet( "anm_stand3_use_lever", { alp = 1, frame = 500 } );
    ObjDelete( "obj_stand3_close_cash" );

    ObjSet( "gfx_stand3_scalpel3", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lever3",     use_lever3_inv );
  cmn.AddSubscriber( "use_lever3",     use_lever3_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever3",     use_lever3_end, private.room_objname );
  cmn.AddSubscriber( "use_lever3_inv", use_lever3_inv, private.room_objname );
  cmn.AddSubscriber( "use_lever3_beg", use_lever3_beg, private.room_objname );
  cmn.AddSubscriber( "use_lever3_end", use_lever3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gear3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gear3" ] =
  {
    type = "use",
    use_obj = "inv_gear3",
    use_place = "obj_fridges3_use_gear3",
    room = private.room_objname,
    zz = "zz_fridges3",
    zz_gate = "gzz_mortuary3_fridges3"
  };
  --------------------------------------------------------------------------------------------
  local use_gear3_inv = function ()

    int.InventoryItemRemove( "inv_gear3" );
    if ( cmn.IsEventDone( "use_card3" ) ) then

      ObjDelete( "anm_alley3_stacy" );
      ObjDelete( "obj_alley3_stacy_bbt" );

    end;
    
  end;
  local use_gear3_beg = function ()

    ObjDelete( "obj_fridges3_use_gear3" );

  end;
  local use_gear3_end = function ()

    ObjSet( "anm_fridges3_gear", { alp = 1, frame = 60, animfunc = "DoAnim" } );
    ObjSet( "spr_mortuary3_fridge_gears", { alp = 1 } );

    if ( cmn.IsEventDone( "use_card3" ) ) then

      ObjSet( "anm_fridges3_on_frize", { frame = 106, animfunc = "DoAnim" } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gear3",     use_gear3_inv );
  cmn.AddSubscriber( "use_gear3",     use_gear3_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear3",     use_gear3_end, private.room_objname );
  cmn.AddSubscriber( "use_gear3_inv", use_gear3_inv, private.room_objname );
  cmn.AddSubscriber( "use_gear3_beg", use_gear3_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear3_end", use_gear3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_probe3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_probe3" ] =
  {
    type = "use",
    use_obj = "inv_probe3",
    use_place = "obj_fridges3_use_probe3",
    room = private.room_objname,
    zz = "zz_fridges3",
    zz_gate = "gzz_mortuary3_fridges3"
  };
  --------------------------------------------------------------------------------------------
  local use_probe3_inv = function ()

    int.InventoryItemRemove( "inv_probe3" );

  end;
  local use_probe3_beg = function ()

    ObjDelete( "obj_fridges3_use_probe3" );
    ObjDelete( "anm_fridges3_amulethydra3_3_click" );

  end;
  local use_probe3_end = function ()

    ObjDelete( "anm_fridges3_probe" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_probe3",     use_probe3_inv );
  cmn.AddSubscriber( "use_probe3",     use_probe3_beg, private.room_objname );
  cmn.AddSubscriber( "use_probe3",     use_probe3_end, private.room_objname );
  cmn.AddSubscriber( "use_probe3_inv", use_probe3_inv, private.room_objname );
  cmn.AddSubscriber( "use_probe3_beg", use_probe3_beg, private.room_objname );
  cmn.AddSubscriber( "use_probe3_end", use_probe3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_card3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_card3" ] =
  {
    type = "use",
    use_obj = "inv_card3",
    use_place = "obj_fridges3_use_card3",
    room = private.room_objname,
    zz = "zz_fridges3",
    zz_gate = "gzz_mortuary3_fridges3"
  };
  --------------------------------------------------------------------------------------------
  local use_card3_inv = function ()

    int.InventoryItemRemove( "inv_card3" );
    if ( cmn.IsEventDone( "use_gear3" ) ) then

      ObjDelete( "anm_alley3_stacy" );
      ObjDelete( "obj_alley3_stacy_bbt" );      

    end;    

  end;
  local use_card3_beg = function ()

    ObjDelete( "obj_fridges3_use_card3" );

  end;
  local use_card3_end = function ()

    ObjSet( "anm_fridges3_card", { alp = 1, frame = 48, animfunc = "DoAnim" } );

    if ( cmn.IsEventDone( "use_gear3" ) ) then

      ObjSet( "anm_fridges3_on_frize", { frame = 106, animfunc = "DoAnim" } );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_card3",     use_card3_inv );
  cmn.AddSubscriber( "use_card3",     use_card3_beg, private.room_objname );
  cmn.AddSubscriber( "use_card3",     use_card3_end, private.room_objname );
  cmn.AddSubscriber( "use_card3_inv", use_card3_inv, private.room_objname );
  cmn.AddSubscriber( "use_card3_beg", use_card3_beg, private.room_objname );
  cmn.AddSubscriber( "use_card3_end", use_card3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amulethydra3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amulethydra3" ] =
  {
    type = "use",
    use_obj = "inv_amulethydra3",
    use_place = "obj_cardindex3_use_amulethydra3",
    room = private.room_objname,
    zz = "zz_cardindex3",
    zz_gate = "gzz_mortuary3_cardindex3"
  };
  --------------------------------------------------------------------------------------------
  local use_amulethydra3_inv = function ()

    int.InventoryItemRemove( "inv_amulethydra3" );

  end;
  local use_amulethydra3_beg = function ()

    ObjDelete( "obj_cardindex3_use_amulethydra3" );

  end;
  local use_amulethydra3_end = function ()

    ObjDelete( "gzz_mortuary3_cardindex3" );
    ObjSet( "gho_mortuary3_hocardindex3", { alp = 1, input = true, active = true } );

    ObjSet( "spr_mortuary3_cardindex_amulethydra", { alp = 1 } );
    
    ObjDelete( "obj_mortuary3_cardindex3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amulethydra3",     use_amulethydra3_inv );
  cmn.AddSubscriber( "use_amulethydra3",     use_amulethydra3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulethydra3",     use_amulethydra3_end, private.room_objname );
  cmn.AddSubscriber( "use_amulethydra3_inv", use_amulethydra3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amulethydra3_beg", use_amulethydra3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulethydra3_end", use_amulethydra3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spellabsorbent3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spellabsorbent3_2" ] =
  {
    type = "use",
    use_obj = "inv_spellabsorbent3",
    use_place = "obj_cardindex3_use_spellabsorbent3_2",
    room = private.room_objname,
    zz = "zz_cardindex3",
    zz_gate = "gzz_mortuary3_cardindex3"
  };
  --------------------------------------------------------------------------------------------
  local use_spellabsorbent3_2_inv = function ()

    int.InventoryItemRemove( "inv_spellabsorbent3" );

  end;
  local use_spellabsorbent3_2_beg = function ()

    ObjDelete( "obj_cardindex3_use_spellabsorbent3_2" );
    ObjDelete( "anm_cardindex3_spirit_click" );
    ObjDelete( "anm_cardindex3_spirit_static" );

  end;
  local use_spellabsorbent3_2_end = function ()

    ObjDelete( "anm_cardindex3_spellabsorbent" );
    ObjSet( "spr_cardindex3_spirit3", { alp = 1, input = true } );
    ObjSet( "gfx_cardindex3_spirit3", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spellabsorbent3_2",     use_spellabsorbent3_2_inv );
  cmn.AddSubscriber( "use_spellabsorbent3_2",     use_spellabsorbent3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_spellabsorbent3_2",     use_spellabsorbent3_2_end, private.room_objname );
  cmn.AddSubscriber( "use_spellabsorbent3_2_inv", use_spellabsorbent3_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_spellabsorbent3_2_beg", use_spellabsorbent3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_spellabsorbent3_2_end", use_spellabsorbent3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************  
function private.get_screensaver_2_23()

  int.AddScreensaver( "spr_stand3_screensaver_2_23" );

end;    
function private.get_screensaver_2_24()

  int.AddScreensaver( "spr_fridges3_screensaver_2_24" );

end; 
-----------------------------------------------------------------------
function private.get_scalpel3 ()

  cmn.SetEventDone( "get_scalpel3" );
  cmn.CallEventHandler( "get_scalpel3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_scalpel3" ) and 
     cmn.IsEventDone( "get_gear3_3" ) and 
     cmn.IsEventDone( "get_gear3_2" ) and 
     cmn.IsEventDone( "get_probe3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_spirit3 ()

  cmn.SetEventDone( "get_spirit3" );
  cmn.CallEventHandler( "get_spirit3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_gear3_3 ()

  cmn.SetEventDone( "get_gear3_3" );
  cmn.CallEventHandler( "get_gear3_3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_scalpel3" ) and 
     cmn.IsEventDone( "get_gear3_3" ) and 
     cmn.IsEventDone( "get_gear3_2" ) and 
     cmn.IsEventDone( "get_probe3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_probe3 ()

  cmn.SetEventDone( "get_probe3" );
  cmn.CallEventHandler( "get_probe3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_scalpel3" ) and 
     cmn.IsEventDone( "get_gear3_3" ) and 
     cmn.IsEventDone( "get_gear3_2" ) and 
     cmn.IsEventDone( "get_probe3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_lever3 ()

  cmn.SetEventDone( "get_lever3" );
  cmn.CallEventHandler( "get_lever3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amulethydra3_3 ()

  cmn.SetEventDone( "get_amulethydra3_3" );
  cmn.CallEventHandler( "get_amulethydra3_3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_gear3_2 ()

  cmn.SetEventDone( "get_gear3_2" );
  cmn.CallEventHandler( "get_gear3_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_scalpel3" ) and 
     cmn.IsEventDone( "get_gear3_3" ) and 
     cmn.IsEventDone( "get_gear3_2" ) and 
     cmn.IsEventDone( "get_probe3" ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_amuletlapwing3 ()

  local item = "inv_amuletlapwing3";

  if ( cmn.ApplyObj( item, "gzz_mortuary3_stand3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletlapwing3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand3_use_amuletlapwing3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletlapwing3" ) ) then

    cmn.CallEventHandler( "use_amuletlapwing3_inv" );
    cmn.CallEventHandler( "use_amuletlapwing3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletlapwing3" );
      cmn.CallEventHandler( "use_amuletlapwing3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_stand3_use_amuletlapwing", { alp = 1 } );
    ObjSet( "anm_stand3_click_box_door", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_bird_box" );
    AnimPlay( "anm_stand3_use_amuletlapwing", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletshamrock3 ()

  local item = "inv_amuletshamrock3";

  if ( cmn.ApplyObj( item, "gzz_mortuary3_stand3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletshamrock3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand3_use_amuletshamrock3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletshamrock3" ) ) then

    cmn.CallEventHandler( "use_amuletshamrock3_inv" );
    cmn.CallEventHandler( "use_amuletshamrock3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletshamrock3" );
      cmn.CallEventHandler( "use_amuletshamrock3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_stand3_click_door_medicine", { alp = 0 } );
    ObjSet( "anm_stand3_use_amuletshamrock", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_clover" );
    AnimPlay( "anm_stand3_use_amuletshamrock", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_lever3 ()

  local item = "inv_lever3";

  if ( cmn.ApplyObj( item, "gzz_mortuary3_stand3", false ) ) and
     ( not cmn.IsEventDone( "use_lever3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stand3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stand3_use_lever3", true ) ) and
         ( not cmn.IsEventDone( "use_lever3" ) ) then

    cmn.CallEventHandler( "use_lever3_inv" );
    cmn.CallEventHandler( "use_lever3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_lever3" );
      cmn.CallEventHandler( "use_lever3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_stand3_click_stash_door", { alp = 0 } );
    ObjSet( "anm_stand3_use_lever", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_incert_seal" );
    AnimPlay( "anm_stand3_use_lever", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_gear3 ()

  local item = "inv_gear3";

  if ( cmn.ApplyObj( item, "gzz_mortuary3_fridges3", false ) ) and
     ( not cmn.IsEventDone( "use_gear3" ) ) and
     ( cmn.IsEventDone( "get_gear3_1" ) ) and
     ( cmn.IsEventDone( "get_gear3_2" ) ) and
     ( cmn.IsEventDone( "get_gear3_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fridges3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fridges3_use_gear3", true ) ) and
         ( not cmn.IsEventDone( "use_gear3" ) ) and
         ( cmn.IsEventDone( "get_gear3_1" ) ) and
         ( cmn.IsEventDone( "get_gear3_2" ) ) and
         ( cmn.IsEventDone( "get_gear3_3" ) ) then

    cmn.CallEventHandler( "use_gear3_inv" );
    cmn.CallEventHandler( "use_gear3_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_gear3" );
        cmn.CallEventHandler( "use_gear3_end" );

      end;

      if ( cmn.IsEventDone( "use_card3" ) ) then

        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_fridges3_mech_up" );

        AnimPlay( "anm_fridges3_on_frize", "DoAnim",
        function ()

          cmn.CloseSubRoom( true );
          private.VidCarriage( func_end1 );

        end );

      else

        func_end1();

      end;

    end;

    int.Lock( true );

    ObjSet( "anm_fridges3_gear", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_fridges3_insert_mech" );
    AnimPlay( "anm_fridges3_gear", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_probe3 ()

  local item = "inv_probe3";

  if ( cmn.ApplyObj( item, "gzz_mortuary3_fridges3", false ) ) and
     ( not cmn.IsEventDone( "use_probe3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fridges3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fridges3_use_probe3", true ) ) and
         ( not cmn.IsEventDone( "use_probe3" ) ) then

    cmn.CallEventHandler( "use_probe3_inv" );
    cmn.CallEventHandler( "use_probe3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_probe3" );
      cmn.CallEventHandler( "use_probe3_end" );
      private.get_amulethydra3_3();

    end;

    int.Lock( true );

    ObjSet( "anm_fridges3_probe", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_fridges3_take_stuff" );
    AnimPlay( "anm_fridges3_probe", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_card3 ()

  local item = "inv_card3";

  if ( cmn.ApplyObj( item, "gzz_mortuary3_fridges3", false ) ) and
     ( not cmn.IsEventDone( "use_card3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fridges3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fridges3_use_card3", true ) ) and
         ( not cmn.IsEventDone( "use_card3" ) ) then

    cmn.CallEventHandler( "use_card3_inv" );
    cmn.CallEventHandler( "use_card3_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_card3" );
        cmn.CallEventHandler( "use_card3_end" );

      end;

      if ( cmn.IsEventDone( "use_gear3" ) ) then

        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_fridges3_mech_up" );

        AnimPlay( "anm_fridges3_on_frize", "DoAnim",
        function ()

          cmn.CloseSubRoom( true );
          private.VidCarriage( func_end1 );

        end );

      else

        func_end1();

      end;

    end;

    int.Lock( true );

    ObjSet( "anm_fridges3_card", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_fridges3_insert_card" );
    AnimPlay( "anm_fridges3_card", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amulethydra3 ()

  local item = "inv_amulethydra3";

  if ( cmn.ApplyObj( item, "gzz_mortuary3_cardindex3", false ) ) and
     ( not cmn.IsEventDone( "use_amulethydra3" ) ) and
     ( cmn.IsEventDone( "get_amulethydra3_1" ) ) and
     ( cmn.IsEventDone( "get_amulethydra3_2" ) ) and
     ( cmn.IsEventDone( "get_amulethydra3_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cardindex3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cardindex3_use_amulethydra3", true ) ) and
         ( not cmn.IsEventDone( "use_amulethydra3" ) ) and
         ( cmn.IsEventDone( "get_amulethydra3_1" ) ) and
         ( cmn.IsEventDone( "get_amulethydra3_2" ) ) and
         ( cmn.IsEventDone( "get_amulethydra3_3" ) ) then

    cmn.CallEventHandler( "use_amulethydra3_inv" );
    cmn.CallEventHandler( "use_amulethydra3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amulethydra3" );
      cmn.CallEventHandler( "use_amulethydra3_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_cardindex3_insert_stuff" );
    ObjAnimate( "spr_cardindex3_amulethydra3_1", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "spr_cardindex3_amulethydra3_2", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.5, 3, 0.0,
      0.8, 3, 1.0,
    } );

    ObjAnimate( "spr_cardindex3_amulethydra3_3", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      1.0, 3, 0.0,
      1.3, 3, 1.0,
    } );

    ObjAnimate( "spr_cardindex3_gates_1", "pos_x", 0, 0, func_end,
    {
      0.0, 3,  77,
      1.6, 3,  77,
      2.6, 3, 250,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_spellabsorbent3_2 ()

  local item = "inv_spellabsorbent3";

  if ( cmn.ApplyObj( item, "gzz_mortuary3_cardindex3", false ) ) and
     ( not cmn.IsEventDone( "use_spellabsorbent3_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cardindex3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cardindex3_use_spellabsorbent3_2", true ) ) and
         ( not cmn.IsEventDone( "use_spellabsorbent3_2" ) ) then

    cmn.CallEventHandler( "use_spellabsorbent3_2_inv" );
    cmn.CallEventHandler( "use_spellabsorbent3_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_spellabsorbent3_2" );
      cmn.CallEventHandler( "use_spellabsorbent3_2_end" );
      cmn.StopAudio( "sfx", "audio/level3/sfx/aud_zz_cardindex3_loop_env", 0.5 );

    end;

    int.Lock( true );

    ObjSet( "anm_cardindex3_spellabsorbent", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_cardindex3_use_magic" );
    AnimPlay( "anm_cardindex3_spellabsorbent", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_mortuary3 ()

  if not ( cmn.IsEventDone( "opn_mortuary3" ) ) then

    cmn.SetEventDone( "opn_mortuary3" );
    cmn.CallEventHandler( "opn_mortuary3" );

    int.Lock( true );

    AnimPlay( "anm_mortuary3_skull", "DoAnim",
    function ()

      int.Lock( false );
      interface.KeyTaskDone( true, "task_3_4" );

    end );

  end;

  cmn.StopAllEnv( "audio/level3/env/aud_rm_mortuary3_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_mortuary3_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_mortuary3();

end;
--*********************************************************************************************************************
function private.VidCarriage ( func_end_video )

  local func_end = function ( skip )

    func_end_video();
    cmn.GotoRoom( "rm_towerroof3" );
    
    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      cmn.StopAudio( "voc", "audio/level3/voc/aud_lvl3_vid_carriage_voc" );
      cmn.StopAudio( "mus", "audio/level3/mus/aud_vid_mortuary3_carriage_mus" );
    end;

    --cmn.PlayAudio( "env", "audio/level1/env/aud_rm_prison2_env", 1 );
    --cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_mortuary3_carriage", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  cmn.PlayAudio( "voc", "audio/level3/voc/aud_lvl3_vid_carriage_voc" );
  cmn.PlayAudio( "mus", "audio/level3/mus/aud_vid_mortuary3_carriage_mus", nil, nil, 44 );

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_scalpel3",                              { "use_lever3" } );
  int.AddedTaskMap( private.room_objname, "get_spirit3",                               { "use_spellabsorbent3_2" } );
  int.AddedTaskMap( private.room_objname, "get_gear3_3",                               { "use_amuletlapwing3" } );
  int.AddedTaskMap( private.room_objname, "get_probe3",                                { "use_amuletlapwing3" } );
  int.AddedTaskMap( private.room_objname, "get_lever3" );
  int.AddedTaskMap( private.room_objname, "get_amulethydra3_3",                        { "use_probe3" } );
  int.AddedTaskMap( private.room_objname, "get_gear3_2",                               { "use_amuletshamrock3" } );

  int.AddedTaskMap( private.room_objname, "use_amuletlapwing3",                        { "get_amuletlapwing3" } );
  int.AddedTaskMap( private.room_objname, "use_amuletshamrock3",                       { "get_amuletshamrock3" } );
  int.AddedTaskMap( private.room_objname, "use_lever3",                                { "get_lever3" } );
  int.AddedTaskMap( private.room_objname, "use_gear3",                                 { "get_gear3_1", "get_gear3_2", "get_gear3_3" } );
  int.AddedTaskMap( private.room_objname, "use_probe3",                                { "get_probe3" } );
  int.AddedTaskMap( private.room_objname, "use_card3",                                 { "win_hocardindex3" } );
  int.AddedTaskMap( private.room_objname, "use_amulethydra3",                          { "get_amulethydra3_1", "get_amulethydra3_2", "get_amulethydra3_3" } );
  int.AddedTaskMap( private.room_objname, "use_spellabsorbent3_2",                     { "get_spellabsorbent3" } );

  int.AddedTaskMap( private.room_objname, "win_hocardindex3",                          { "use_amulethydra3" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_fridges3" );
  subroom.Define( "zz_cardindex3" );
  -----------------------------------------------
  function zz_fridges3.Close ()

    cmn.NoteScaleEnd( { "spr_fridges3_note" }, true );

  end;
  -----------------------------------------------
  function zz_cardindex3.Open ()

    if not cmn.IsEventDone( "use_spellabsorbent3_2" ) then
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_cardindex3_loop_env", 1 );
    end;

  end;
  -----------------------------------------------
  function zz_cardindex3.Close ()

    if not cmn.IsEventDone( "use_spellabsorbent3_2" ) then
      cmn.StopAudio( "sfx", "audio/level3/sfx/aud_zz_cardindex3_loop_env", 0.5 );
    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_stand3_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1
  } );

end;
--*********************************************************************************************************************
function private.Fridges3amulethydraClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_fridges3_use_probe3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  AnimPlay( "anm_fridges3_amulethydra3_3_click", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_fridges3_snake" );

end;
--*********************************************************************************************************************
function private.Cardindex3BoxClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_cardindex3_use_amulethydra3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_cardindex3_cage" );
  ObjAnimate( "spr_cardindex3_gates_1", "pos_x", 0, 0, func_end,
  {
    0.0, 3, 77,
    0.2, 3, 80,
    0.4, 3, 77,
    0.6, 3, 80,
    0.8, 3, 77,
  } );

end;
--*********************************************************************************************************************
function private.Cardindex3SpiritClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_cardindex3_use_spellabsorbent3_2" );
    int.Lock( false );
    ObjSet( "anm_cardindex3_spirit_click", { alp = 0 } );
    
  end;
  
  int.Lock( true );

  ObjSet( "anm_cardindex3_spirit_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_cardindex3_magic_box" );
  AnimPlay( "anm_cardindex3_spirit_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Stand3AmuletlapwingClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_stand3_use_amuletlapwing3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_stand3_box_red" );
  AnimPlay( "anm_stand3_click_box_door", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Stand3AmuletshamrockClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_stand3_use_amuletshamrock3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_stand3_box_heal" );
  AnimPlay( "anm_stand3_click_door_medicine", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Stand3LeverClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_stand3_use_lever3" );
    int.Lock( false );
    
  end;
  
  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_stand3_hidden_cell_wall" );
  AnimPlay( "anm_stand3_click_stash_door", "DoAnim", func_end );

end;
--*********************************************************************************************************************