-- name=rm_neartower3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_neartower3";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_tunnelentrance3", "room_hub" );

  ObjMultiSet(
  {
    { "spr_tunnelentrance3_hexagram3_1", { event_mdown = private.get_hexagram3_1 } },
  } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_neartower3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_neartower3", update_game_mode_neartower3, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function opn_neartower3 () end;
  --------------------------------------------------------------------------------------------
  local opn_neartower3 = function ()

    if ( cmn.IsEventDone( "use_gear3" ) ) and
       ( cmn.IsEventDone( "use_card3" ) ) then
      
       ObjSet( "spr_neartower3_carriege", { alp = 1 } );      
      
    end;

  end;

  cmn.AddSubscriber( "opn_neartower3", opn_neartower3, private.room_objname );      
  
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_3 = function ()

    ObjDelete( "obj_neartower3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_3", get_morphobject_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hexagram3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hexagram3_1" ] =
  {
    type = "get",
    get_obj = "spr_tunnelentrance3_hexagram3_1",
    room = private.room_objname,
    zz = "zz_tunnelentrance3",
    zz_gate = "gzz_neartower3_tunnelentrance3"
  };
  --------------------------------------------------------------------------------------------
  local get_hexagram3_1_inv = function ()

    int.InventoryItemAdd( "inv_hexagram3", "spr_tunnelentrance3_hexagram3_1", "assets/levels/level3/rm_neartower3/zz_tunnelentrance3/inv/inv_hexagram3_1" );
    level3_inv.CheckHexagram3( 1 );

  end;
  local get_hexagram3_1_closezz = function ()

    ObjDelete( "gfx_tunnelentrance3_hexagram3_1" );

    --ObjDelete( "gzz_neartower3_tunnelentrance3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_hexagram3_1", get_hexagram3_1_inv );
  cmn.AddSubscriber( "get_hexagram3_1", get_hexagram3_1_closezz, private.room_objname );
--------------------------------------------------------------------------------------------
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_jimmy3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jimmy3_1" ] =
  {
    type = "use",
    use_obj = "inv_jimmy3",
    use_place = "obj_tunnelentrance3_use_jimmy3",
    room = private.room_objname,
    zz = "zz_tunnelentrance3",
    --zz_gate = "gzz_neartower3_tunnelentrance3",
    zz_gate = "gzz_neartower3_tunnelentrance3_clone"
  };
  --------------------------------------------------------------------------------------------
  local use_jimmy3_1_inv = function ()

    if cmn.IsEventDone( "use_jimmy3_2" ) and 
       cmn.IsEventDone( "use_jimmy3_3" ) then
      int.InventoryItemRemove( "inv_jimmy3" );
    end;

  end;
  local use_jimmy3_1_beg = function ()

    ObjDelete( "obj_tunnelentrance3_use_jimmy3" );

  end;
  local use_jimmy3_1_end = function ()

    ObjDelete( "obj_tunnelentrance3_cash_close" );
    ObjSet( "obj_tunnelentrance3_cash_open", { alp = 1, input = true } );
    ObjSet( "gfx_tunnelentrance3_hexagram3_1", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jimmy3_1",     use_jimmy3_1_inv );
  cmn.AddSubscriber( "use_jimmy3_1",     use_jimmy3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_1",     use_jimmy3_1_end, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_1_inv", use_jimmy3_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_1_beg", use_jimmy3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_1_end", use_jimmy3_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_burningtorch3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_burningtorch3" ] =
  {
    type = "use",
    use_obj = "inv_burningtorch3",
    use_place = "obj_tunnelentrance3_use_burningtorch3",
    room = private.room_objname,
    zz = "zz_tunnelentrance3",
    zz_gate = "gzz_neartower3_tunnelentrance3"
  };
  --------------------------------------------------------------------------------------------
  local use_burningtorch3_inv = function ()

    int.InventoryItemRemove( "inv_burningtorch3" );

  end;
  local use_burningtorch3_beg = function ()

    ObjDelete( "obj_tunnelentrance3_use_burningtorch3" );

  end;
  local use_burningtorch3_end = function ()

    ObjDelete( "gzz_neartower3_tunnelentrance3" );
    ObjSet( "grm_neartower3_abigailshouse3", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_neartower3_abigailshouse3_focus");
    end;
    ObjDelete( "spr_neartower3_stacy_shadow" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_burningtorch3",     use_burningtorch3_inv );
  cmn.AddSubscriber( "use_burningtorch3",     use_burningtorch3_beg, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch3",     use_burningtorch3_end, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch3_inv", use_burningtorch3_inv, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch3_beg", use_burningtorch3_beg, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch3_end", use_burningtorch3_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------------------------------
function private.get_hexagram3_1 ()

  cmn.SetEventDone( "get_hexagram3_1" );
  cmn.CallEventHandler( "get_hexagram3_1" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_jimmy3_1 ()

  local item = "inv_jimmy3";

  if ( cmn.ApplyObj( item, "gzz_neartower3_tunnelentrance3", false ) ) and
     ( not cmn.IsEventDone( "use_jimmy3_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tunnelentrance3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tunnelentrance3_use_jimmy3", true ) ) and
         ( not cmn.IsEventDone( "use_jimmy3_1" ) ) then

    cmn.CallEventHandler( "use_jimmy3_1_inv" );
    cmn.CallEventHandler( "use_jimmy3_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_jimmy3_1" );
      cmn.CallEventHandler( "use_jimmy3_1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_tunnelentrance3_wall", { alp = 0 } );
    ObjSet( "anm_tunnelentrance3_use_jimmy", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_tunnelentrance3_broke" );
    AnimPlay( "anm_tunnelentrance3_use_jimmy", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_burningtorch3 ()

  local item = "inv_burningtorch3";

  if ( cmn.ApplyObj( item, "gzz_neartower3_tunnelentrance3", false ) ) and
     ( not cmn.IsEventDone( "use_burningtorch3" ) ) and 
       cmn.IsEventDone( "use_jimmy3_1" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tunnelentrance3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_tunnelentrance3_use_burningtorch3", true ) ) and
         ( not cmn.IsEventDone( "use_burningtorch3" ) ) and 
           cmn.IsEventDone( "use_jimmy3_1" ) then

    cmn.CallEventHandler( "use_burningtorch3_inv" );
    cmn.CallEventHandler( "use_burningtorch3_beg" );

    local func_end = function ()

      cmn.CloseSubRoom( true );
      private.VidStacy();

    end;

    int.Lock( true );

    AnimPlay( "anm_tunnelentrance3_use_burningtorch", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_neartower3 ()

  if not ( cmn.IsEventDone( "opn_neartower3" ) ) then

    cmn.SetEventDone( "opn_neartower3" );
    cmn.CallEventHandler( "opn_neartower3" );

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_neartower2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_neartower2_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_neartower3();

end;
--*********************************************************************************************************************
function private.VidStacy()

  local func_end = function ( skip )

    cmn.SetEventDone( "use_burningtorch3" );
    cmn.CallEventHandler( "use_burningtorch3_end" );
    cmn.GotoRoom( "rm_abigailshouse3" );
    int.Lock( false );
    
    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      cmn.StopAudio( "voc", "audio/level3/voc/aud_lvl3_vid_stacy_voc" );
      cmn.StopAudio( "mus", "audio/level3/mus/aud_vid_neartower3_stacy_mus" );
    end;

    --cmn.PlayAudio( "env", "audio/level1/env/aud_rm_prison2_env", 1 );
    --cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_neartower3_stacy", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  cmn.PlayAudio( "voc", "audio/level3/voc/aud_lvl3_vid_stacy_voc" );
  cmn.PlayAudio( "mus", "audio/level3/mus/aud_vid_neartower3_stacy_mus", nil, nil, 23 );

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_hexagram3_1",                              { "use_jimmy3_1" } );
  int.AddedTaskMap( private.room_objname, "use_jimmy3_1" );
  int.AddedTaskMap( private.room_objname, "use_burningtorch3",                            { "get_burningtorch3", "use_jimmy3_1" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
--[[
  subroom.Define( "zz_picture" );  
  -------------------------------------------------
  function zz_picture.Open()
  end;
  -------------------------------------------------
  function zz_picture.PreClose()
  end;
  -------------------------------------------------
  function zz_picture.Skip ()
  end;
  -------------------------------------------------
  function zz_picture.Reset ()
  end;
  -------------------------------------------------
]]--
end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************