-- name=rm_park3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_park3";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_servicedoor3", "room_hub" );
  ObjAttach( "zz_fountain3",    "room_hub" );
  ObjAttach( "zz_highrelief3",  "room_hub" );

  ObjMultiSet(
  {
    { "spr_servicedoor3_abovedoorsign3",     { event_mdown = private.get_abovedoorsign3 } },
    { "spr_fountain3_amuletchimera3_1",      { event_mdown = private.get_amuletchimera3_1 } },
    { "spr_fountain3_statuehand3",           { event_mdown = private.get_statuehand3 } },
    { "spr_fountain3_statuehead3",           { event_mdown = private.get_statuehead3 } },
    { "spr_fountain3_amulethydra3_1",        { event_mdown = private.get_amulethydra3_1 } },
    { "spr_highrelief3_amulettree3",         { event_mdown = private.get_amulettree3 } },
    { "spr_highrelief3_gear3_1",             { event_mdown = private.get_gear3_1 } },
    { "spr_highrelief3_amuletshamrock3",     { event_mdown = private.get_amuletshamrock3 } },
    { "spr_highrelief3_amuletlion3_2",       { event_mdown = private.get_amuletchimera3_2 } },
    { "obj_highrelief3_use_mermaidstatue3",  { event_mdown = private.Highrelief3CapClick } },
    { "obj_highrelief3_use_statuehand3",     { event_mdown = function () private.Highrelief3HighreliefClick( "statuehand3" ) end; } },
    { "obj_highrelief3_use_statuehead3",     { event_mdown = function () private.Highrelief3HighreliefClick( "statuehead3" ) end; } },
    { "spr_park3_collect_3_1",               { event_mdown = private.get_collect_3_1 } },
    { "obj_fountain3_use_amuletsnake3",      { event_mdown = private.Fountain3DoorClick } },
    { "obj_fountain3_use_spirit3",           { event_mdown = private.Fountain3AmulethydraClick } },
    { "obj_fountain3_use_spellabsorbent3_1", { event_mdown = private.Fountain3MagicClick } },
    { "obj_fountain3_use_amuletsnake3",      { event_mdown = private.Fountain3DoorClick } },
    { "obj_servicedoor3_clk_key_area",       { event_mdown = function() private.Servicedoor3KeysZoomBeg() end } },
    { "spr_servicedoor3_zoom",               { event_mdown = function() private.Servicedoor3KeysZoomEnd() end } },
    { "spr_fountain3_screensaver_2_21",      { event_mdown = private.get_screensaver_2_21 } },      
    { "spr_highrelief3_screensaver_2_22",    { event_mdown = private.get_screensaver_2_22 } },          
  } );
  local get_screensaver_2_21 = function ()

    ObjDelete( "spr_fountain3_screensaver_2_21" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_21", get_screensaver_2_21, private.room_objname );  
  local get_screensaver_2_22 = function ()

    ObjDelete( "spr_highrelief3_screensaver_2_22" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_22", get_screensaver_2_22, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_park3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_park3", update_game_mode_park3, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function opn_park3 () end;
  --------------------------------------------------------------------------------------------
  local opn_park3 = function ()
    
    if (cmn.IsEventDone( "win_mgkeys3" )) then
      
      ObjSet( "grm_park3_mortuary3", { alp = 1, input = true, active = true } ); 
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_park3_mortuary3_focus");
      end;
      ObjSet( "spr_park3_servicedoor3_door", { alp = 1 } ); 
      ObjDelete( "spr_park3_servicedoor3_bunchofkeys" );    
      
    end;

  end;

  cmn.AddSubscriber( "opn_park3", opn_park3, private.room_objname );  
  
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_3_1 = function ()

    ObjDelete( "spr_park3_collect_3_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_3_1", get_collect_3_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_3 = function ()

    ObjDelete( "obj_park3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_3_3", get_morphobject_3_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spellabsorbent3 () end;
  --------------------------------------------------------------------------------------------
  local get_spellabsorbent3_inv = function ()

    int.InventoryItemAdd( "inv_spellabsorbent3", "spr_park3_spellabsorbent3" );

  end;
  local get_spellabsorbent3_closezz = function ()

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_spellabsorbent3", get_spellabsorbent3_inv );
  cmn.AddSubscriber( "get_spellabsorbent3", get_spellabsorbent3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_abovedoorsign3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_abovedoorsign3" ] =
  {
    type = "get",
    get_obj = "spr_servicedoor3_abovedoorsign3",
    room = private.room_objname,
    zz = "zz_servicedoor3",
    zz_gate = "gzz_park3_servicedoor3"
  };
  --------------------------------------------------------------------------------------------
  local get_abovedoorsign3_inv = function ()

    int.InventoryItemAdd( "inv_abovedoorsign3", "spr_servicedoor3_abovedoorsign3" );
    ObjSet( "inv_abovedoorsign3", { drag = false } );

    if ( not cmn.IsEventDone( "get_glasscutter3" ) ) then

      ObjSet( "inv_abovedoorsign3_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_abovedoorsign3_closezz = function ()

    ObjDelete( "gfx_servicedoor3_abovedoorsign3" );
    ObjDelete( "spr_park3_servicedoor3_abovedoorsign" );
    --ObjDelete( "gzz_park3_servicedoor3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_abovedoorsign3", get_abovedoorsign3_inv );
  cmn.AddSubscriber( "get_abovedoorsign3", get_abovedoorsign3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletchimera3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletchimera3_1" ] =
  {
    type = "get",
    get_obj = "spr_fountain3_amuletchimera3_1",
    room = private.room_objname,
    zz = "zz_fountain3",
    zz_gate = "gzz_park3_fountain3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletchimera3_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletchimera3", "spr_fountain3_amuletchimera3_1", "assets/levels/level3/rm_park3/zz_fountain3/inv/inv_amuletchimera3_1" );
    level3_inv.CheckAmuletchimera3( 1 );

  end;
  local get_amuletchimera3_1_closezz = function ()

    ObjDelete( "gfx_fountain3_amuletchimera3_1" );
    ObjDelete( "spr_fountain3_amuletchimera3_1_light" );

    ObjDelete( "spr_park3_fountain3_lion" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletchimera3_1", get_amuletchimera3_1_inv );
  cmn.AddSubscriber( "get_amuletchimera3_1", get_amuletchimera3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_statuehand3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_statuehand3" ] =
  {
    type = "get",
    get_obj = "spr_fountain3_statuehand3",
    room = private.room_objname,
    zz = "zz_fountain3",
    zz_gate = "gzz_park3_fountain3"
  };
  --------------------------------------------------------------------------------------------
  local get_statuehand3_inv = function ()

    int.InventoryItemAdd( "inv_statuehand3", "spr_fountain3_statuehand3" );

  end;
  local get_statuehand3_closezz = function ()

    ObjDelete( "gfx_fountain3_statuehand3" );
    ObjDelete( "spr_fountain3_statuehand3_shadow" );

    ObjDelete( "spr_park3_fountain3_statuehand" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_statuehand3", get_statuehand3_inv );
  cmn.AddSubscriber( "get_statuehand3", get_statuehand3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_statuehead3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_statuehead3" ] =
  {
    type = "get",
    get_obj = "spr_fountain3_statuehead3",
    room = private.room_objname,
    zz = "zz_fountain3",
    zz_gate = "gzz_park3_fountain3"
  };
  --------------------------------------------------------------------------------------------
  local get_statuehead3_inv = function ()

    int.InventoryItemAdd( "inv_statuehead3", "spr_fountain3_statuehead3" );

  end;
  local get_statuehead3_closezz = function ()

    ObjDelete( "gfx_fountain3_statuehead3" );
    ObjDelete( "spr_fountain3_statuehead3_shadow" );
    ObjDelete( "spr_fountain3_statuehead3_light" );

    ObjDelete( "spr_park3_fountain3_statuehead" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_statuehead3", get_statuehead3_inv );
  cmn.AddSubscriber( "get_statuehead3", get_statuehead3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulethydra3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulethydra3_1" ] =
  {
    type = "get",
    get_obj = "spr_fountain3_amulethydra3_1",
    room = private.room_objname,
    zz = "zz_fountain3",
    zz_gate = "gzz_park3_fountain3"
  };
  --------------------------------------------------------------------------------------------
  local get_amulethydra3_1_inv = function ()

    int.InventoryItemAdd( "inv_amulethydra3", "spr_fountain3_amulethydra3_1", "assets/levels/level3/rm_park3/zz_fountain3/inv/inv_amulethydra3_1" );
    level3_inv.CheckAmulethydra3();

  end;
  local get_amulethydra3_1_closezz = function ()

    ObjDelete( "anm_fountain3_amulethydra" );
    ObjDelete( "gzz_park3_fountain3" );

    ObjDelete( "spr_park3_fountain3_amulethydra" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amulethydra3_1", get_amulethydra3_1_inv );
  cmn.AddSubscriber( "get_amulethydra3_1", get_amulethydra3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amulettree3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amulettree3" ] =
  {
    type = "get",
    get_obj = "spr_highrelief3_amulettree3",
    room = private.room_objname,
    zz = "zz_highrelief3",
    zz_gate = "gzz_park3_highrelief3"
  };
  --------------------------------------------------------------------------------------------
  local get_amulettree3_inv = function ()

    int.InventoryItemAdd( "inv_amulettree3", "spr_highrelief3_amulettree3" );

  end;
  local get_amulettree3_closezz = function ()

    ObjDelete( "gfx_highrelief3_amulettree3" );
    ObjDelete( "spr_park3_highrelief3_amulettree" );

    if ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) and
       ( cmn.IsEventDone( "get_gear3_1" ) ) and
       ( cmn.IsEventDone( "get_amulettree3" ) ) and
       ( cmn.IsEventDone( "get_amuletshamrock3" ) ) then

      ObjDelete( "gzz_park3_highrelief3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amulettree3", get_amulettree3_inv );
  cmn.AddSubscriber( "get_amulettree3", get_amulettree3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gear3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gear3_1" ] =
  {
    type = "get",
    get_obj = "spr_highrelief3_gear3_1",
    room = private.room_objname,
    zz = "zz_highrelief3",
    zz_gate = "gzz_park3_highrelief3"
  };
  --------------------------------------------------------------------------------------------
  local get_gear3_1_inv = function ()

    int.InventoryItemAdd( "inv_gear3", "spr_highrelief3_gear3_1", "assets/levels/level3/rm_park3/zz_highrelief3/inv/inv_gear3_1" );
    level3_inv.CheckGear3();

  end;
  local get_gear3_1_closezz = function ()

    ObjDelete( "gfx_highrelief3_gear3_1" );
    ObjDelete( "spr_park3_highrelief3_gear" );

    if ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) and
       ( cmn.IsEventDone( "get_gear3_1" ) ) and
       ( cmn.IsEventDone( "get_amulettree3" ) ) and
       ( cmn.IsEventDone( "get_amuletshamrock3" ) ) then

      ObjDelete( "gzz_park3_highrelief3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gear3_1", get_gear3_1_inv );
  cmn.AddSubscriber( "get_gear3_1", get_gear3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletshamrock3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletshamrock3" ] =
  {
    type = "get",
    get_obj = "spr_highrelief3_amuletshamrock3",
    room = private.room_objname,
    zz = "zz_highrelief3",
    zz_gate = "gzz_park3_highrelief3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletshamrock3_inv = function ()

    int.InventoryItemAdd( "inv_amuletshamrock3", "spr_highrelief3_amuletshamrock3" );

  end;
  local get_amuletshamrock3_closezz = function ()

    ObjDelete( "gfx_highrelief3_amuletshamrock3" );
    ObjDelete( "spr_park3_highrelief3_amuletshamrock" );

    if ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) and
       ( cmn.IsEventDone( "get_gear3_1" ) ) and
       ( cmn.IsEventDone( "get_amulettree3" ) ) and
       ( cmn.IsEventDone( "get_amuletshamrock3" ) ) then

      ObjDelete( "gzz_park3_highrelief3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletshamrock3", get_amuletshamrock3_inv );
  cmn.AddSubscriber( "get_amuletshamrock3", get_amuletshamrock3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletchimera3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletchimera3_2" ] =
  {
    type = "get",
    get_obj = "spr_highrelief3_amuletlion3_2",
    room = private.room_objname,
    zz = "zz_highrelief3",
    zz_gate = "gzz_park3_highrelief3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletchimera3_2_inv = function ()

    int.InventoryItemAdd( "inv_amuletchimera3", "spr_highrelief3_amuletlion3_2", "assets/levels/level3/rm_park3/zz_fountain3/inv/inv_amuletchimera3_2" );
    level3_inv.CheckAmuletchimera3( 2 );

  end;
  local get_amuletchimera3_2_closezz = function ()

    ObjDelete( "gfx_highrelief3_amuletchimera3_2" );
    ObjDelete( "spr_park3_highrelief3_lion" );

    if ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) and
       ( cmn.IsEventDone( "get_gear3_1" ) ) and
       ( cmn.IsEventDone( "get_amulettree3" ) ) and
       ( cmn.IsEventDone( "get_amuletshamrock3" ) ) then

      ObjDelete( "gzz_park3_highrelief3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletchimera3_2", get_amuletchimera3_2_inv );
  cmn.AddSubscriber( "get_amuletchimera3_2", get_amuletchimera3_2_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_cane3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cane3" ] =
  {
    type = "use",
    use_obj = "inv_cane3",
    use_place = "obj_servicedoor3_use_cane3",
    room = private.room_objname,
    zz = "zz_servicedoor3",
    zz_gate = "gzz_park3_servicedoor3"
  };
  --------------------------------------------------------------------------------------------
  local use_cane3_inv = function ()

    int.InventoryItemRemove( "inv_cane3" );

  end;
  local use_cane3_beg = function ()

    ObjDelete( "obj_servicedoor3_use_cane3" );
    ObjDelete( "anm_servicedoor3_abovedoorsign_static" );

  end;
  local use_cane3_end = function ()

    ObjDelete( "anm_servicedoor3_cane" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cane3",     use_cane3_inv );
  cmn.AddSubscriber( "use_cane3",     use_cane3_beg, private.room_objname );
  cmn.AddSubscriber( "use_cane3",     use_cane3_end, private.room_objname );
  cmn.AddSubscriber( "use_cane3_inv", use_cane3_inv, private.room_objname );
  cmn.AddSubscriber( "use_cane3_beg", use_cane3_beg, private.room_objname );
  cmn.AddSubscriber( "use_cane3_end", use_cane3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bunchofkeys3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bunchofkeys3" ] =
  {
    type = "use",
    use_obj = "inv_bunchofkeys3",
    use_place = "obj_servicedoor3_use_bunchofkeys3",
    room = private.room_objname,
    zz = "zz_servicedoor3",
    zz_gate = "gzz_park3_servicedoor3"
  };
  --------------------------------------------------------------------------------------------
  local use_bunchofkeys3_inv = function ()

    int.InventoryItemRemove( "inv_bunchofkeys3" );

  end;
  local use_bunchofkeys3_beg = function ()

    ObjDelete( "obj_servicedoor3_use_bunchofkeys3" );

  end;
  local use_bunchofkeys3_end = function ()

    ObjDelete( "gzz_park3_servicedoor3" );
    ObjSet( "gmg_park3_mgkeys3", { alp = 1, input = true, active = true } );

    ObjSet( "spr_park3_servicedoor3_bunchofkeys", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bunchofkeys3",     use_bunchofkeys3_inv );
  cmn.AddSubscriber( "use_bunchofkeys3",     use_bunchofkeys3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bunchofkeys3",     use_bunchofkeys3_end, private.room_objname );
  cmn.AddSubscriber( "use_bunchofkeys3_inv", use_bunchofkeys3_inv, private.room_objname );
  cmn.AddSubscriber( "use_bunchofkeys3_beg", use_bunchofkeys3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bunchofkeys3_end", use_bunchofkeys3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spellabsorbent3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spellabsorbent3_1" ] =
  {
    type = "use",
    use_obj = "inv_spellabsorbent3",
    use_place = "obj_fountain3_use_spellabsorbent3_1",
    room = private.room_objname,
    zz = "zz_fountain3",
    zz_gate = "gzz_park3_fountain3"
  };
  --------------------------------------------------------------------------------------------
  local use_spellabsorbent3_1_inv = function ()

    --int.InventoryItemRemove( "inv_spellabsorbent3" );

  end;
  local use_spellabsorbent3_1_beg = function ()

    ObjDelete( "obj_fountain3_use_spellabsorbent3_1" );
    ObjDelete( "anm_fountain3_magic_click" );
    ObjDelete( "anm_fountain3_magic_static" );

  end;
  local use_spellabsorbent3_1_end = function ()

    ObjDelete( "anm_fountain3_spellabsorbent" );
    ObjSet( "spr_fountain3_statuehead3",      { input = true } );
    ObjSet( "gfx_fountain3_statuehead3",      { active = true } );
    ObjSet( "spr_fountain3_amuletchimera3_1", { input = true } );
    ObjSet( "gfx_fountain3_amuletchimera3_1", { active = true } );
    ObjDelete( "anm_park3_zz" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spellabsorbent3_1",     use_spellabsorbent3_1_inv );
  cmn.AddSubscriber( "use_spellabsorbent3_1",     use_spellabsorbent3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_spellabsorbent3_1",     use_spellabsorbent3_1_end, private.room_objname );
  cmn.AddSubscriber( "use_spellabsorbent3_1_inv", use_spellabsorbent3_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_spellabsorbent3_1_beg", use_spellabsorbent3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_spellabsorbent3_1_end", use_spellabsorbent3_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletsnake3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletsnake3" ] =
  {
    type = "use",
    use_obj = "inv_amuletsnake3",
    use_place = "obj_fountain3_use_amuletsnake3",
    room = private.room_objname,
    zz = "zz_fountain3",
    zz_gate = "gzz_park3_fountain3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletsnake3_inv = function ()

    int.InventoryItemRemove( "inv_amuletsnake3" );

  end;
  local use_amuletsnake3_beg = function ()

    ObjDelete( "obj_fountain3_use_amuletsnake3" );
    ObjDelete( "obj_fountain3_door" );

  end;
  local use_amuletsnake3_end = function ()

    ObjDelete( "anm_fountain3_cap_open" );
    ObjSet( "spr_fountain3_statuehand3", { input = true } );
    ObjSet( "gfx_fountain3_statuehand3", { active = true } );

    ObjSet( "spr_park3_fountain3_door", { pos_x = 305, pos_y = 0, ang = 0.28 } );
    ObjSet( "spr_park3_fountain3_amuletsnake", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletsnake3",     use_amuletsnake3_inv );
  cmn.AddSubscriber( "use_amuletsnake3",     use_amuletsnake3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletsnake3",     use_amuletsnake3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletsnake3_inv", use_amuletsnake3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletsnake3_beg", use_amuletsnake3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletsnake3_end", use_amuletsnake3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spirit3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spirit3" ] =
  {
    type = "use",
    use_obj = "inv_spirit3",
    use_place = "obj_fountain3_use_spirit3",
    room = private.room_objname,
    zz = "zz_fountain3",
    zz_gate = "gzz_park3_fountain3"
  };
  --------------------------------------------------------------------------------------------
  local use_spirit3_inv = function ()

    int.InventoryItemRemove( "inv_spirit3" );

  end;
  local use_spirit3_beg = function ()

    ObjDelete( "obj_fountain3_use_spirit3" );
    ObjDelete( "anm_fountain3_amulethydra_click" );

  end;
  local use_spirit3_end = function ()

    ObjDelete( "anm_fountain3_spirit" );
    ObjSet( "spr_fountain3_amulethydra3_1", { input = true } );
    ObjSet( "gfx_fountain3_amulethydra3_1", { active = true } );
    ObjSet( "anm_fountain3_amulethydra",    { alp = 1 } );

    ObjDelete( "spr_park3_fountain3_dirty" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spirit3",     use_spirit3_inv );
  cmn.AddSubscriber( "use_spirit3",     use_spirit3_beg, private.room_objname );
  cmn.AddSubscriber( "use_spirit3",     use_spirit3_end, private.room_objname );
  cmn.AddSubscriber( "use_spirit3_inv", use_spirit3_inv, private.room_objname );
  cmn.AddSubscriber( "use_spirit3_beg", use_spirit3_beg, private.room_objname );
  cmn.AddSubscriber( "use_spirit3_end", use_spirit3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mermaidstatue3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mermaidstatue3" ] =
  {
    type = "use",
    use_obj = "inv_mermaidstatue3",
    use_place = "obj_highrelief3_use_mermaidstatue3",
    room = private.room_objname,
    zz = "zz_highrelief3",
    zz_gate = "gzz_park3_highrelief3"
  };
  --------------------------------------------------------------------------------------------
  local use_mermaidstatue3_inv = function ()

    int.InventoryItemRemove( "inv_mermaidstatue3" );

  end;
  local use_mermaidstatue3_beg = function ()

    ObjDelete( "obj_highrelief3_use_mermaidstatue3" );

  end;
  local use_mermaidstatue3_end = function ()

    ObjSet( "anm_highrelief3_open_cap",       { frame = 62, animfunc = "DoAnim" } );
    ObjSet( "spr_highrelief3_amulettree3",    { input = true } );
    ObjSet( "gfx_highrelief3_amulettree3",    { active = true } );
    ObjDelete( "spr_park3_highrelief3_plate_over" );

    ObjSet( "spr_park3_highrelief3_open",    { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mermaidstatue3",     use_mermaidstatue3_inv );
  cmn.AddSubscriber( "use_mermaidstatue3",     use_mermaidstatue3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mermaidstatue3",     use_mermaidstatue3_end, private.room_objname );
  cmn.AddSubscriber( "use_mermaidstatue3_inv", use_mermaidstatue3_inv, private.room_objname );
  cmn.AddSubscriber( "use_mermaidstatue3_beg", use_mermaidstatue3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mermaidstatue3_end", use_mermaidstatue3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_statuehand3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_statuehand3" ] =
  {
    type = "use",
    use_obj = "inv_statuehand3",
    use_place = "obj_highrelief3_use_statuehand3",
    room = private.room_objname,
    zz = "zz_highrelief3",
    zz_gate = "gzz_park3_highrelief3"
  };
  --------------------------------------------------------------------------------------------
  local use_statuehand3_inv = function ()

    int.InventoryItemRemove( "inv_statuehand3" );

  end;
  local use_statuehand3_beg = function ()

    ObjDelete( "obj_highrelief3_use_statuehand3" );

  end;
  local use_statuehand3_end = function ()

    ObjSet( "anm_highrelief3_statuehand", { frame = 54, animfunc = "DoAnim" } );

    ObjDelete( "spr_park3_highrelief3_hand_slot" );

    if ( cmn.IsEventDone( "use_statuehead3" ) ) then

      ObjDelete( "obj_highrelief3_highrelief" );
      ObjSet( "anm_highrelief3_open_plate",    { alp = 1, frame = 54, animfunc = "DoAnim" } );
      ObjSet( "spr_highrelief3_amuletlion3_2", { input = true } );
      ObjSet( "gfx_highrelief3_amuletlion3_2", { active = true } );

      ObjSet( "spr_park3_highrelief3_plate", { pos_x = 728, pos_y = 155 } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statuehand3",     use_statuehand3_inv );
  cmn.AddSubscriber( "use_statuehand3",     use_statuehand3_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuehand3",     use_statuehand3_end, private.room_objname );
  cmn.AddSubscriber( "use_statuehand3_inv", use_statuehand3_inv, private.room_objname );
  cmn.AddSubscriber( "use_statuehand3_beg", use_statuehand3_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuehand3_end", use_statuehand3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_statuehead3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_statuehead3" ] =
  {
    type = "use",
    use_obj = "inv_statuehead3",
    use_place = "obj_highrelief3_use_statuehead3",
    room = private.room_objname,
    zz = "zz_highrelief3",
    zz_gate = "gzz_park3_highrelief3"
  };
  --------------------------------------------------------------------------------------------
  local use_statuehead3_inv = function ()

    int.InventoryItemRemove( "inv_statuehead3" );

  end;
  local use_statuehead3_beg = function ()

    ObjDelete( "obj_highrelief3_use_statuehead3" );

  end;
  local use_statuehead3_end = function ()

    ObjSet( "anm_highrelief3_statuehead", { frame = 54, animfunc = "DoAnim" } );
    ObjDelete( "spr_park3_highrelief3_head_slot" );

    if ( cmn.IsEventDone( "use_statuehand3" ) ) then

      ObjDelete( "obj_highrelief3_highrelief" );
      ObjSet( "anm_highrelief3_open_plate",    { alp = 1, frame = 54, animfunc = "DoAnim" } );
      ObjSet( "spr_highrelief3_amuletlion3_2", { input = true } );
      ObjSet( "gfx_highrelief3_amuletlion3_2", { active = true } );

      ObjSet( "spr_park3_highrelief3_plate", { pos_x = 728, pos_y = 155 } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statuehead3",     use_statuehead3_inv );
  cmn.AddSubscriber( "use_statuehead3",     use_statuehead3_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuehead3",     use_statuehead3_end, private.room_objname );
  cmn.AddSubscriber( "use_statuehead3_inv", use_statuehead3_inv, private.room_objname );
  cmn.AddSubscriber( "use_statuehead3_beg", use_statuehead3_beg, private.room_objname );
  cmn.AddSubscriber( "use_statuehead3_end", use_statuehead3_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_mgkeys3 () end;
  --------------------------------------------------------------------------------------------
  local win_mgkeys3 = function ()

    if ( cmn.IsEventDone( "win_mgkeys3" ) ) then

      ObjDelete( "gmg_park3_mgkeys3" );

    end;

  end;

  cmn.AddSubscriber( "win_mgkeys3", win_mgkeys3, private.room_objname );
  --------------------------------------------------------------------------------------
  -- function dlg_park3_richard3_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_park3_richard3_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_park3_richard3_1_end = function ()

    ObjDelete( "dlg_park3_richard3_1" );

  end;

  cmn.AddSubscriber( "dlg_park3_richard3_1",     dlg_park3_richard3_1_beg );
  cmn.AddSubscriber( "dlg_park3_richard3_1",     dlg_park3_richard3_1_end );
  cmn.AddSubscriber( "dlg_park3_richard3_1_beg", dlg_park3_richard3_1_beg );
  cmn.AddSubscriber( "dlg_park3_richard3_1_end", dlg_park3_richard3_1_end );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_2_21()

  int.AddScreensaver( "spr_fountain3_screensaver_2_21" );

end;    
function private.get_screensaver_2_22()

  int.AddScreensaver( "spr_highrelief3_screensaver_2_22" );

end; 
-----------------------------------------------------------------------
function private.get_collect_3_1 ()

  int.AddCollectibles( "spr_park3_collect_3_1" );

end;
-----------------------------------------------------------------------
function private.get_abovedoorsign3 ()

  ObjSet( "spr_servicedoor3_abovedoorsign3", { alp = 1 } );

  cmn.SetEventDone( "get_abovedoorsign3" );
  cmn.CallEventHandler( "get_abovedoorsign3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amuletchimera3_1 ()

  cmn.SetEventDone( "get_amuletchimera3_1" );
  cmn.CallEventHandler( "get_amuletchimera3_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_statuehand3 ()

  cmn.SetEventDone( "get_statuehand3" );
  cmn.CallEventHandler( "get_statuehand3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_statuehead3 ()

  cmn.SetEventDone( "get_statuehead3" );
  cmn.CallEventHandler( "get_statuehead3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amulethydra3_1 ()

  ObjSet( "spr_fountain3_amulethydra3_1", { alp = 1 } );

  cmn.SetEventDone( "get_amulethydra3_1" );
  cmn.CallEventHandler( "get_amulethydra3_1" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_amulettree3 ()

  cmn.SetEventDone( "get_amulettree3" );
  cmn.CallEventHandler( "get_amulettree3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) and
     ( cmn.IsEventDone( "get_gear3_1" ) ) and
     ( cmn.IsEventDone( "get_amulettree3" ) ) and
     ( cmn.IsEventDone( "get_amuletshamrock3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_gear3_1 ()

  cmn.SetEventDone( "get_gear3_1" );
  cmn.CallEventHandler( "get_gear3_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) and
     ( cmn.IsEventDone( "get_gear3_1" ) ) and
     ( cmn.IsEventDone( "get_amulettree3" ) ) and
     ( cmn.IsEventDone( "get_amuletshamrock3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amuletshamrock3 ()

  cmn.SetEventDone( "get_amuletshamrock3" );
  cmn.CallEventHandler( "get_amuletshamrock3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) and
     ( cmn.IsEventDone( "get_gear3_1" ) ) and
     ( cmn.IsEventDone( "get_amulettree3" ) ) and
     ( cmn.IsEventDone( "get_amuletshamrock3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amuletchimera3_2 ()

  cmn.SetEventDone( "get_amuletchimera3_2" );
  cmn.CallEventHandler( "get_amuletchimera3_2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_amuletchimera3_2" ) ) and
     ( cmn.IsEventDone( "get_gear3_1" ) ) and
     ( cmn.IsEventDone( "get_amulettree3" ) ) and
     ( cmn.IsEventDone( "get_amuletshamrock3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_cane3 ()

  local item = "inv_cane3";

  if ( cmn.ApplyObj( item, "gzz_park3_servicedoor3", false ) ) and
     ( not cmn.IsEventDone( "use_cane3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_servicedoor3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_servicedoor3_use_cane3", true ) ) and
         ( not cmn.IsEventDone( "use_cane3" ) ) and 
           ObjGet( "obj_servicedoor3_clk_key_area" ).input then

    cmn.CallEventHandler( "use_cane3_inv" );
    cmn.CallEventHandler( "use_cane3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_cane3" );
      cmn.CallEventHandler( "use_cane3_end" );
      private.get_abovedoorsign3();

    end;

    int.Lock( true );

    ObjSet( "anm_servicedoor3_cane", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_servicedoor3_take_green_cross" );
    AnimPlay( "anm_servicedoor3_cane", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_bunchofkeys3 ()

  local item = "inv_bunchofkeys3";

  if ( cmn.ApplyObj( item, "gzz_park3_servicedoor3", false ) ) and
     ( not cmn.IsEventDone( "use_bunchofkeys3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_servicedoor3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_servicedoor3_use_bunchofkeys3", true ) ) and
         ( not cmn.IsEventDone( "use_bunchofkeys3" ) ) then

    cmn.CallEventHandler( "use_bunchofkeys3_inv" );
    cmn.CallEventHandler( "use_bunchofkeys3_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_bunchofkeys3" );
        cmn.CallEventHandler( "use_bunchofkeys3_end" );
        cmn.CloseSubRoom();
        cmn.GotoRoom( "mg_mgkeys3" );

      end; 

      ObjSet( "anm_servicedoor3_bunchofkeys", { alp = 1 } );
      AnimPlay( "anm_servicedoor3_bunchofkeys", "DoAnim", func_end1 );

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_use_keys_mg_mgkeys3_begin" );

    end;

    int.Lock( true );

    if ObjGet( "obj_servicedoor3_clk_key_area" ).input then

      ObjAnimate( "spr_servicedoor3_zoom", "scale_xy", 0, 0, "", 
      { 
        0.0, 3, 0, 0,
        0.3, 3, 1, 1
      } );
      ObjAnimate( "spr_servicedoor3_zoom", "pos_xy", 0, 0, func_end, 
      { 
        0.0, 3, - 88, 26,
        0.3, 3, 0, 0,
        0.6, 3, 0, 0
      } );

    else

      func_end();

    end;

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_spellabsorbent3_1 ()

  local item = "inv_spellabsorbent3";

  if ( cmn.ApplyObj( item, "gzz_park3_fountain3", false ) ) and
     ( not cmn.IsEventDone( "use_spellabsorbent3_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fountain3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fountain3_use_spellabsorbent3_1", true ) ) and
         ( not cmn.IsEventDone( "use_spellabsorbent3_1" ) ) then

    cmn.CallEventHandler( "use_spellabsorbent3_1_inv" );
    cmn.CallEventHandler( "use_spellabsorbent3_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_spellabsorbent3_1" );
      cmn.CallEventHandler( "use_spellabsorbent3_1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_fountain3_spellabsorbent", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_fountain3_use_magic_amulet" );
    AnimPlay( "anm_fountain3_spellabsorbent", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletsnake3 ()

  local item = "inv_amuletsnake3";

  if ( cmn.ApplyObj( item, "gzz_park3_fountain3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletsnake3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fountain3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fountain3_use_amuletsnake3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletsnake3" ) ) then

    cmn.CallEventHandler( "use_amuletsnake3_inv" );
    cmn.CallEventHandler( "use_amuletsnake3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletsnake3" );
      cmn.CallEventHandler( "use_amuletsnake3_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_fountain3_insert_right_down" );
    ObjSet( "anm_fountain3_cap_open", { alp = 1 } );
    AnimPlay( "anm_fountain3_cap_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_spirit3 ()

  local item = "inv_spirit3";

  if ( cmn.ApplyObj( item, "gzz_park3_fountain3", false ) ) and
     ( not cmn.IsEventDone( "use_spirit3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fountain3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_fountain3_use_spirit3", true ) ) and
         ( not cmn.IsEventDone( "use_spirit3" ) ) then

    cmn.CallEventHandler( "use_spirit3_inv" );
    cmn.CallEventHandler( "use_spirit3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_spirit3" );
      cmn.CallEventHandler( "use_spirit3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_fountain3_spirit", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_drop_pipette" );
    AnimPlay( "anm_fountain3_spirit", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_mermaidstatue3 ()

  local item = "inv_mermaidstatue3";

  if ( cmn.ApplyObj( item, "gzz_park3_highrelief3", false ) ) and
     ( not cmn.IsEventDone( "use_mermaidstatue3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_highrelief3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_highrelief3_use_mermaidstatue3", true ) ) and
         ( not cmn.IsEventDone( "use_mermaidstatue3" ) ) then

    cmn.CallEventHandler( "use_mermaidstatue3_inv" );
    cmn.CallEventHandler( "use_mermaidstatue3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mermaidstatue3" );
      cmn.CallEventHandler( "use_mermaidstatue3_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_highrelief3_insert_fish" );
    AnimPlay( "anm_highrelief3_open_cap", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_statuehand3 ()

  local item = "inv_statuehand3";

  if ( cmn.ApplyObj( item, "gzz_park3_highrelief3", false ) ) and
     ( not cmn.IsEventDone( "use_statuehand3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_highrelief3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_highrelief3_use_statuehand3", true ) ) and
         ( not cmn.IsEventDone( "use_statuehand3" ) ) then

    cmn.CallEventHandler( "use_statuehand3_inv" );
    cmn.CallEventHandler( "use_statuehand3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_statuehand3" );
      cmn.CallEventHandler( "use_statuehand3_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_highrelief3_insert_stuff" );
    if ( cmn.IsEventDone( "use_statuehead3" ) ) then

      AnimPlay( "anm_highrelief3_statuehand", "DoAnim",
      function ()

        ObjSet( "obj_highrelief3_highrelief", { alp = 0 } );
        ObjSet( "anm_highrelief3_open_plate", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_highrelief3_opens" );
        AnimPlay( "anm_highrelief3_open_plate", "DoAnim", func_end );

      end );

    else

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_highrelief3_insert_stuff" );
      AnimPlay( "anm_highrelief3_statuehand", "DoAnim", func_end );

    end;

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_statuehead3 ()

  local item = "inv_statuehead3";

  if ( cmn.ApplyObj( item, "gzz_park3_highrelief3", false ) ) and
     ( not cmn.IsEventDone( "use_statuehead3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_highrelief3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_highrelief3_use_statuehead3", true ) ) and
         ( not cmn.IsEventDone( "use_statuehead3" ) ) then

    cmn.CallEventHandler( "use_statuehead3_inv" );
    cmn.CallEventHandler( "use_statuehead3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_statuehead3" );
      cmn.CallEventHandler( "use_statuehead3_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_highrelief3_insert_stuff" );
    if ( cmn.IsEventDone( "use_statuehand3" ) ) then

      AnimPlay( "anm_highrelief3_statuehead", "DoAnim",
      function ()

        ObjSet( "obj_highrelief3_highrelief", { alp = 0 } );
        ObjSet( "anm_highrelief3_open_plate", { alp = 1 } );

        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_highrelief3_opens" );
        AnimPlay( "anm_highrelief3_open_plate", "DoAnim", func_end );

      end );

    else

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_highrelief3_insert_stuff" );
      AnimPlay( "anm_highrelief3_statuehead", "DoAnim", func_end );

    end;

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.dlg_park3_richard3_1 ()

  local func_before_end = function ( func_end )

    ObjSet( "spr_park3_spellabsorbent3", { alp = 1 } );

    cmn.CallEventHandler( "get_spellabsorbent3" );
    cmn.GetObjectSfx();

    ObjSet( "anm_park3_richard3_1_richard_static_1",      { alp = 0 } );
    ObjSet( "anm_park3_richard3_1_richard_static_2",      { alp = 0 } );
    ObjSet( "anm_park3_richard3_1_richard_appearance",    { alp = 0 } );
    ObjSet( "anm_park3_richard3_1_richard_disappearance", { alp = 1 } );

    AnimStop( "anm_park3_richard3_1_richard_static_1" );
    AnimStop( "anm_park3_richard3_1_richard_static_2" );
    AnimStop( "anm_park3_richard3_1_richard_disappearance" );

    ObjAnimate( "anm_park3_richard3_1_richard_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.5, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );
    AnimPlay( "anm_park3_richard3_1_richard_disappearance", "DoAnim", function ()

      if ( func_end ) then

        func_end();

      end;

      cmn.SetEventDone( "get_spellabsorbent3" );
      cmn.SetEventDone( "dlg_park3_richard3_1" );
      int.InventoryItemAdd( "inv_richardskull3" );
      --cmn.ShowBbt( "bbt_park3_after_dlg_richard" );

    end );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_park3_richard3_1_richard_appearance" );
    ObjSet( "anm_park3_richard3_1_richard_appearance", { alp = 0 } );

    ObjSet( "anm_park3_richard3_1_richard_static_1", { alp = 1 } );
    AnimPlay( "anm_park3_richard3_1_richard_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "richard3_1", "park3", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_park3_richard3_1_beg" );
  ObjAttach( "dlg_park3_richard3_1", GetCurrentRoom() );  

  ObjSet( "anm_park3_richard3_1_richard_appearance", { alp = 1 } );
  AnimPlay( "anm_park3_richard3_1_richard_appearance", "DoAnim", func_anim_end );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_park3_richard3_1_richard_static_1", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    1.5, 3, 1.0,
  } );

  int.InventoryItemRemove( "inv_richardskull3" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "richard3_1" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_park3_richard3_1_richard_static_1" );
        AnimPlay( "anm_park3_richard3_1_richard_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_park3_richard3_1_richard_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_park3_richard3_1_richard_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    elseif ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_park3_richard3_1_richard_static_2" );
        AnimPlay( "anm_park3_richard3_1_richard_give", "DoAnim", "" );
        AnimPlay( "anm_park3_richard3_1_object_appearance", "DoAnim", "" );

        ObjAnimate( "spr_park3_spellabsorbent3", "alp", 0, 0, "",
        {
          0.0, 3, 0.0,
          1.0, 3, 1.0,
        } );

      end;

      ObjAnimate( "anm_park3_richard3_1_richard_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_park3_richard3_1_richard_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

      cmn.PlayAudio( "sfx", "audio/aud_richard_creates_thing" );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_park3 ()

  if not ( cmn.IsEventDone( "opn_park3" ) ) then

    cmn.SetEventDone( "opn_park3" );
    cmn.CallEventHandler( "opn_park3" );

  end;

  if not ( cmn.IsEventDone( "dlg_park3_richard3_1" ) ) then

    private.dlg_park3_richard3_1();

  end;

  cmn.StopAllEnv( "audio/level3/env/aud_rm_park3_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_park3_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_park3();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_spellabsorbent3",                              { "dlg_park3_richard3_1" } );
  int.AddedTaskMap( private.room_objname, "get_abovedoorsign3",                               { "use_cane3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletchimera3_1",                             { "use_spellabsorbent3_1" } );
  int.AddedTaskMap( private.room_objname, "get_statuehand3",                                  { "use_amuletsnake3" } );
  int.AddedTaskMap( private.room_objname, "get_statuehead3",                                  { "use_spellabsorbent3_1" } );
  int.AddedTaskMap( private.room_objname, "get_amulethydra3_1",                               { "use_spirit3" } );
  int.AddedTaskMap( private.room_objname, "get_amulettree3",                                  { "use_mermaidstatue3" } );
  int.AddedTaskMap( private.room_objname, "get_gear3_1" );
  int.AddedTaskMap( private.room_objname, "get_amuletshamrock3" );
  int.AddedTaskMap( private.room_objname, "get_amuletchimera3_2",                             { "use_statuehand3", "use_statuehead3" } );

  int.AddedTaskMap( private.room_objname, "use_cane3",                                        { "get_cane3" } );
  int.AddedTaskMap( private.room_objname, "use_bunchofkeys3",                                 { "get_bunchofkeys3" } );
  int.AddedTaskMap( private.room_objname, "use_spellabsorbent3_1",                            { "get_spellabsorbent3" } );
  int.AddedTaskMap( private.room_objname, "use_amuletsnake3",                                 { "get_amuletsnake3" } );
  int.AddedTaskMap( private.room_objname, "use_spirit3",                                      { "get_spirit3" } );
  int.AddedTaskMap( private.room_objname, "use_mermaidstatue3",                               { "get_mermaidstatue3" } );
  int.AddedTaskMap( private.room_objname, "use_statuehand3",                                  { "get_statuehand3" } );
  int.AddedTaskMap( private.room_objname, "use_statuehead3",                                  { "get_statuehead3" } );

  int.AddedTaskMap( private.room_objname, "win_mgkeys3",                                      { "use_bunchofkeys3" } );

  int.AddedTaskMap( private.room_objname, "dlg_park3_richard3_1" );

  int.AddedTaskMap( private.room_objname, "opn_mortuary3",                                    { "win_mgkeys3" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_servicedoor3" );  
  -------------------------------------------------
  function zz_servicedoor3.Close()

    if ( not ObjGet( "obj_servicedoor3_clk_key_area" ).input ) and  
       ( not cmn.IsEventDone( "use_bunchofkeys3" ) ) then

      ObjSet( "obj_servicedoor3_clk_key_area", { input = true } );
      ObjSet( "spr_servicedoor3_zoom", { scale_x = 0, scale_y = 0, pos_x = - 88, pos_y = 26 } );

    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_fountain3_amuletchimera3_1_light", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.4,
    5.0, 3, 1.0,
  } );

  ObjAnimate( "spr_fountain3_statuehead3_light", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.4,
    5.0, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.Highrelief3CapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_highrelief3_use_mermaidstatue3" );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_highrelief3_box" );
  ObjAnimate( "obj_highrelief3_mermaidstatue3", "pos_xy", 0, 0, func_end,
  {
    0.0, 3, 0,  0,
    0.2, 3, 3, -5,
    0.4, 3, 0,  0,
    0.6, 3, 3, -5,
    0.8, 3, 0 , 0,
  } );

end;
--*********************************************************************************************************************
function private.Fountain3DoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_fountain3_use_amuletsnake3" );
    int.Lock( false );

  end;

  int.Lock( true );

  --ObjAnimate( "anm_fountain3_cap_open", "pos_x", 0, 0, func_end,
  --{
  --  0.0, 3, 162,
  --  0.2, 3, 164,
  --  0.4, 3, 162,
  --  0.6, 3, 164,
  --  0.8, 3, 162,
  --} );

  func_end();

end;
--*********************************************************************************************************************
function private.Fountain3AmulethydraClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_fountain3_use_spirit3" );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_fountain3_stuff_right" );
  AnimPlay( "anm_fountain3_amulethydra_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Fountain3MagicClick ()

  local func_end = function ()

    ObjSet( "anm_fountain3_magic_click", { alp = 0 } );
    cmn.ShowBbt( "bbt_fountain3_use_spellabsorbent3_1" );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_fountain3_magic_statue" );

  ObjSet( "anm_fountain3_magic_click", { alp = 1 } );
  AnimPlay( "anm_fountain3_magic_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Fountain3DoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_fountain3_use_amuletsnake3" );
    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "spr_fountain3_door", "pos_xy", 0, 0, func_end,
  {
    0.0, 3, 160, 144,
    0.2, 3, 163, 146,
    0.4, 3, 160, 144,
    0.6, 3, 163, 146,
    0.8, 3, 160, 144,
  } );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_fountain3_hiddel_cell" );

end;
--*********************************************************************************************************************
function private.Highrelief3HighreliefClick ( item )

  local func_end = function ()

    cmn.ShowBbt( "bbt_highrelief3_use_"..item );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_highrelief3_stone" );
  ObjAnimate( "obj_highrelief3_highrelief", "pos_x", 0, 0, func_end,
  {
    0.0, 3,  0,
    0.2, 3, -3,
    0.4, 3,  0,
    0.6, 3, -3,
    0.8, 3,  0,
  } );

end;
--*********************************************************************************************************************
function private.Servicedoor3DoorClick ( item )

  local func_end = function ()

    cmn.ShowBbt( "bbt_highrelief3_use_"..item );
    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "obj_highrelief3_highrelief", "pos_x", 0, 0, func_end,
  {
    0.0, 3,  0,
    0.2, 3, -3,
    0.4, 3,  0,
    0.6, 3, -3,
    0.8, 3,  0,
  } );

end;
--*********************************************************************************************************************
function private.Servicedoor3KeysZoomBeg ()

  local func_end = function ()

    ObjSet( "obj_servicedoor3_clk_key_area", { input = false } );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjAnimate( "spr_servicedoor3_zoom", "scale_xy", 0, 0, "", 
  { 
    0.0, 3, 0, 0,
    0.3, 3, 1, 1
  } );
  ObjAnimate( "spr_servicedoor3_zoom", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, - 88, 26,
    0.3, 3, 0, 0,
  } );

end;
--*********************************************************************************************************************
function private.Servicedoor3KeysZoomEnd ()

  local func_end = function ()

    ObjSet( "obj_servicedoor3_clk_key_area", { input = true } );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjAnimate( "spr_servicedoor3_zoom", "scale_xy", 0, 0, "", 
  { 
    0.0, 3, 1, 1,
    0.3, 3, 0, 0
  } );
  ObjAnimate( "spr_servicedoor3_zoom", "pos_xy", 0, 0, func_end, 
  { 
    0.0, 3, 0, 0,
    0.3, 3, - 88, 26,
  } );

end;
--*********************************************************************************************************************