-- name=rm_secretroom3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_secretroom3";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_armchair3", "room_hub" );
  ObjAttach( "zz_box3",      "room_hub" );
  ObjAttach( "zz_irondoor3", "room_hub" );

  ObjMultiSet(
  {
    { "spr_armchair3_soldierfigurine3", { event_mdown = private.get_soldierfigurine3 } },
    { "spr_armchair3_crest3_1",         { event_mdown = private.get_crest3_1 } },
    { "spr_armchair3_toyboat3",         { event_mdown = private.get_toyboat3 } },
    { "obj_box3_crest3",                { event_mdown = private.get_crest3_2 } },
    { "spr_box3_opener3",               { event_mdown = private.get_opener3 } },    
    { "spr_irondoor3_amuletgriffin3_2", { event_mdown = private.get_amuletgriffin3_2 } },
    { "spr_secretroom3_collect_3_2",    { event_mdown = private.get_collect_3_2 } },
    { "obj_irondoor3_handle_clk",       { event_mdown = function() private.Irondoor3HandleClk() end } },
    { "obj_irondoor3_use_feather3",     { event_mdown = function() private.Irondoor3ScorpionClk() end } },
    { "obj_box3_use_roundnosepliers3_1",     { event_mdown = function() private.Box3CrestClk() end } },
    { "obj_box3_use_amuletgriffin3",         { event_mdown = function() private.Box3AmuletgriffinClk() end } },
    { "spr_armchair3_screensaver_2_19",     { event_mdown = private.get_screensaver_2_19 } },      
    { "spr_box3_screensaver_2_20",     { event_mdown = private.get_screensaver_2_20 } },          
  } );
  local get_screensaver_2_19 = function ()

    ObjDelete( "spr_armchair3_screensaver_2_19" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_19", get_screensaver_2_19, private.room_objname );  
  local get_screensaver_2_20 = function ()

    ObjDelete( "spr_box3_screensaver_2_20" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_20", get_screensaver_2_20, private.room_objname );     

  private.Irondoor3Init();
  private.InitMiniHO();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_secretroom3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_secretroom3", update_game_mode_secretroom3, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_3_2 = function ()

    ObjDelete( "spr_secretroom3_collect_3_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_3_2", get_collect_3_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_4 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_4 = function ()

    ObjDelete( "obj_secretroom3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_3_4", get_morphobject_3_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_opener3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_opener3" ] =
  {
    type = "get",
    get_obj = "spr_box3_ho_1",
    room = private.room_objname,
    zz = "zz_box3",
    zz_gate = "gzz_secretroom3_box3"
  };    
  --------------------------------------------------------------------------------------------
  local get_opener3_inv = function ()

    int.InventoryItemAdd( "inv_opener3", "spr_box3_win" );
    ObjDelete( "obj_box3_miniho" );

    if cmn.IsEventDone( "get_crest3_2" ) then

      ObjDelete( "gzz_secretroom3_box3" );

    end;

    ObjDelete( "spr_secretroom3_miniho" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_opener3", get_opener3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_soldierfigurine3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_soldierfigurine3" ] =
  {
    type = "get",
    get_obj = "spr_armchair3_soldierfigurine3",
    room = private.room_objname,
    zz = "zz_armchair3",
    zz_gate = "gzz_secretroom3_armchair3"
  };
  --------------------------------------------------------------------------------------------
  local get_soldierfigurine3_inv = function ()

    int.InventoryItemAdd( "inv_soldierfigurine3", "spr_armchair3_soldierfigurine3" );

  end;
  local get_soldierfigurine3_closezz = function ()

    ObjDelete( "gfx_armchair3_soldierfigurine3" );
    ObjDelete( "spr_secretroom3_soldierfigurine" );
    --ObjDelete( "gzz_secretroom3_armchair3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_soldierfigurine3", get_soldierfigurine3_inv );
  cmn.AddSubscriber( "get_soldierfigurine3", get_soldierfigurine3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crest3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crest3_1" ] =
  {
    type = "get",
    get_obj = "spr_armchair3_crest3_1",
    room = private.room_objname,
    zz = "zz_armchair3",
    zz_gate = "gzz_secretroom3_armchair3"
  };
  --------------------------------------------------------------------------------------------
  local get_crest3_1_inv = function ()

    int.InventoryItemAdd( "inv_crest3", "spr_armchair3_crest3_1", "assets/levels/level3/rm_secretroom3/zz_armchair3/inv/inv_crest3_1" );
    level3_inv.CheckCrest3( 1 );

  end;
  local get_crest3_1_closezz = function ()

    ObjDelete( "gfx_armchair3_crest3_1" );

    if cmn.IsEventDone( "get_toyboat3" ) then

      ObjDelete( "gzz_secretroom3_armchair3" );

    end;

    ObjDelete( "spr_secretroom3_armchair_crest" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crest3_1", get_crest3_1_inv );
  cmn.AddSubscriber( "get_crest3_1", get_crest3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toyboat3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toyboat3" ] =
  {
    type = "get",
    get_obj = "spr_armchair3_toyboat3",
    room = private.room_objname,
    zz = "zz_armchair3",
    zz_gate = "gzz_secretroom3_armchair3"
  };
  --------------------------------------------------------------------------------------------
  local get_toyboat3_inv = function ()

    int.InventoryItemAdd( "inv_toyboat3", "spr_armchair3_toyboat3" );

  end;
  local get_toyboat3_closezz = function ()

    ObjDelete( "gfx_armchair3_toyboat3" );

    if cmn.IsEventDone( "get_crest3_1" ) then

      ObjDelete( "gzz_secretroom3_armchair3" );

    end;

    ObjDelete( "spr_secretroom3_toyboat" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_toyboat3", get_toyboat3_inv );
  cmn.AddSubscriber( "get_toyboat3", get_toyboat3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crest3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crest3_2" ] =
  {
    type = "get",
    get_obj = "obj_box3_crest3",
    room = private.room_objname,
    zz = "zz_box3",
    zz_gate = "gzz_secretroom3_box3"
  };
  --------------------------------------------------------------------------------------------
  local get_crest3_2_inv = function ()

    int.InventoryItemAdd( "inv_crest3", "obj_box3_crest3", "assets/levels/level3/rm_secretroom3/zz_armchair3/inv/inv_crest3_2" );
    level3_inv.CheckCrest3( 2 );

  end;
  local get_crest3_2_closezz = function ()

    if cmn.IsEventDone( "get_opener3" ) then

      ObjDelete( "gzz_secretroom3_box3" );

    end;

    ObjDelete( "spr_secretroom3_box_crest" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crest3_2", get_crest3_2_inv );
  cmn.AddSubscriber( "get_crest3_2", get_crest3_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletgriffin3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletgriffin3_2" ] =
  {
    type = "get",
    get_obj = "spr_irondoor3_amuletgriffin3_2",
    room = private.room_objname,
    zz = "zz_irondoor3",
    zz_gate = "gzz_secretroom3_irondoor3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletgriffin3_2_inv = function ()

    int.InventoryItemAdd( "inv_amuletgriffin3", "spr_irondoor3_amuletgriffin3_2", "assets/levels/level3/rm_abigailshouse3/zz_windowsill3/inv/inv_amuletgriffin3_2" );
    level3_inv.CheckAmuletgriffin3( 2 );

  end;
  local get_amuletgriffin3_2_closezz = function ()

    ObjDelete( "gfx_irondoor3_amuletgriffin3_2" );
    ObjDelete( "spr_irondoor3_amuletgriffin_shadow" );
    ObjDelete( "spr_secretroom3_amuletgriffin" );
    --ObjDelete( "gzz_secretroom3_irondoor3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletgriffin3_2", get_amuletgriffin3_2_inv );
  cmn.AddSubscriber( "get_amuletgriffin3_2", get_amuletgriffin3_2_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_razor3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_razor3" ] =
  {
    type = "use",
    use_obj = "inv_razor3",
    use_place = "obj_armchair3_use_razor3",
    room = private.room_objname,
    zz = "zz_armchair3",
    zz_gate = "gzz_secretroom3_armchair3"
  };
  --------------------------------------------------------------------------------------------
  local use_razor3_inv = function ()

    int.InventoryItemRemove( "inv_razor3" );

  end;
  local use_razor3_beg = function ()

    ObjDelete( "obj_armchair3_use_razor3" );

  end;
  local use_razor3_end = function ()

    ObjSet( "obj_armchair3_armchair_open", { alp = 1, input = true } );
    ObjSet( "gfx_armchair3_crest3_1", { active = true } );
    ObjDelete( "anm_armchair3_use_razor" );

    ObjSet( "spr_secretroom3_open_armchair", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_razor3",     use_razor3_inv );
  cmn.AddSubscriber( "use_razor3",     use_razor3_beg, private.room_objname );
  cmn.AddSubscriber( "use_razor3",     use_razor3_end, private.room_objname );
  cmn.AddSubscriber( "use_razor3_inv", use_razor3_inv, private.room_objname );
  cmn.AddSubscriber( "use_razor3_beg", use_razor3_beg, private.room_objname );
  cmn.AddSubscriber( "use_razor3_end", use_razor3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_opener3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_opener3" ] =
  {
    type = "use",
    use_obj = "inv_opener3",
    use_place = "obj_armchair3_use_opener3",
    room = private.room_objname,
    zz = "zz_armchair3",
    zz_gate = "gzz_secretroom3_armchair3"
  };
  --------------------------------------------------------------------------------------------
  local use_opener3_inv = function ()

    int.InventoryItemRemove( "inv_opener3" );

  end;
  local use_opener3_beg = function ()

    ObjDelete( "obj_armchair3_use_opener3" );

  end;
  local use_opener3_end = function ()

    ObjSet( "obj_armchair3_open_box", { alp = 1, input = true } );
    ObjSet( "gfx_armchair3_toyboat3", { active = true } );
    ObjDelete( "anm_armchair3_use_opener" );

    ObjSet( "spr_secretroom3_armchair_open_box", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_opener3",     use_opener3_inv );
  cmn.AddSubscriber( "use_opener3",     use_opener3_beg, private.room_objname );
  cmn.AddSubscriber( "use_opener3",     use_opener3_end, private.room_objname );
  cmn.AddSubscriber( "use_opener3_inv", use_opener3_inv, private.room_objname );
  cmn.AddSubscriber( "use_opener3_beg", use_opener3_beg, private.room_objname );
  cmn.AddSubscriber( "use_opener3_end", use_opener3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletgriffin3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletgriffin3" ] =
  {
    type = "use",
    use_obj = "inv_amuletgriffin3",
    use_place = "obj_box3_use_amuletgriffin3",
    room = private.room_objname,
    zz = "zz_box3",
    zz_gate = "gzz_secretroom3_box3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletgriffin3_inv = function ()

    int.InventoryItemRemove( "inv_amuletgriffin3" );

  end;
  local use_amuletgriffin3_beg = function ()

    ObjDelete( "obj_box3_use_amuletgriffin3" );

  end;
  local use_amuletgriffin3_end = function ()

    ObjDelete( "obj_box3_box_close" );
    ObjSet( "obj_box3_box_open", { input = true } );
    ObjSet( "anm_box3_use_amuletgriffin", { alp = 1, frame = 999 } );
    ObjSet( "obj_secretroom3_open_box", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletgriffin3",     use_amuletgriffin3_inv );
  cmn.AddSubscriber( "use_amuletgriffin3",     use_amuletgriffin3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgriffin3",     use_amuletgriffin3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletgriffin3_inv", use_amuletgriffin3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletgriffin3_beg", use_amuletgriffin3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletgriffin3_end", use_amuletgriffin3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_roundnosepliers3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_roundnosepliers3_1" ] =
  {
    type = "use",
    use_obj = "inv_roundnosepliers3",
    use_place = "obj_box3_use_roundnosepliers3_1",
    room = private.room_objname,
    zz = "zz_box3",
    zz_gate = "gzz_secretroom3_box3"
  };
  --------------------------------------------------------------------------------------------
  local use_roundnosepliers3_1_inv = function ()

    if ( cmn.IsEventDone( "use_roundnosepliers3_2" ) ) then

      int.InventoryItemRemove( "inv_roundnosepliers3" );

    end;

  end;
  local use_roundnosepliers3_1_beg = function ()

    ObjDelete( "obj_box3_use_roundnosepliers3_1" );

  end;
  local use_roundnosepliers3_1_end = function ()

    ObjSet( "anm_box3_click_crest", { alp = 0 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_roundnosepliers3_1",     use_roundnosepliers3_1_inv );
  cmn.AddSubscriber( "use_roundnosepliers3_1",     use_roundnosepliers3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_roundnosepliers3_1",     use_roundnosepliers3_1_end, private.room_objname );
  cmn.AddSubscriber( "use_roundnosepliers3_1_inv", use_roundnosepliers3_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_roundnosepliers3_1_beg", use_roundnosepliers3_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_roundnosepliers3_1_end", use_roundnosepliers3_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_feather3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_feather3" ] =
  {
    type = "use",
    use_obj = "inv_feather3",
    use_place = "obj_irondoor3_use_feather3",
    room = private.room_objname,
    zz = "zz_irondoor3",
    zz_gate = "gzz_secretroom3_irondoor3"
  };
  --------------------------------------------------------------------------------------------
  local use_feather3_inv = function ()

    int.InventoryItemRemove( "inv_feather3" );

  end;
  local use_feather3_beg = function ()

    ObjDelete( "obj_irondoor3_use_feather3" );

  end;
  local use_feather3_end = function ()

    ObjDelete( "anm_irondoor3_scorpion_static" );
    ObjDelete( "anm_irondoor3_scorpion_click" );
    ObjDelete( "anm_irondoor3_use_spray" );

    ObjSet( "spr_irondoor3_amuletgriffin3_2", { input = true } );
    ObjSet( "gfx_irondoor3_amuletgriffin3_2", { active = true } );

    ObjDelete( "spr_secretroom3_scorpion" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_feather3",     use_feather3_inv );
  cmn.AddSubscriber( "use_feather3",     use_feather3_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather3",     use_feather3_end, private.room_objname );
  cmn.AddSubscriber( "use_feather3_inv", use_feather3_inv, private.room_objname );
  cmn.AddSubscriber( "use_feather3_beg", use_feather3_beg, private.room_objname );
  cmn.AddSubscriber( "use_feather3_end", use_feather3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toyboat3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toyboat3" ] =
  {
    type = "use",
    use_obj = "inv_toyboat3",
    use_place = "obj_irondoor3_use_toyboat3",
    room = private.room_objname,
    zz = "zz_irondoor3",
    zz_gate = "gzz_secretroom3_irondoor3"
  };
  --------------------------------------------------------------------------------------------
  local use_toyboat3_inv = function ()

    int.InventoryItemRemove( "inv_toyboat3" );

  end;
  local use_toyboat3_beg = function ()

    ObjDelete( "obj_irondoor3_use_toyboat3" );

  end;
  local use_toyboat3_end = function ()

    ObjSet( "obj_irondoor3_mmg", { pos_z = 50 } );
    ObjDelete( "obj_irondoor3_cap" );
    ObjSet( "obj_irondoor3_parts", { input = true } );

    for i = 1, 8 do

      local pos_x = private.start_coor[ i ][ 1 ];
      local pos_y = private.start_coor[ i ][ 2 ];

      ObjSet( "spr_irondoor3_"..i, { pos_x = pos_x, pos_y = pos_y } );

    end;

    ObjDelete( "spr_secretroom3_cap" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toyboat3",     use_toyboat3_inv );
  cmn.AddSubscriber( "use_toyboat3",     use_toyboat3_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyboat3",     use_toyboat3_end, private.room_objname );
  cmn.AddSubscriber( "use_toyboat3_inv", use_toyboat3_inv, private.room_objname );
  cmn.AddSubscriber( "use_toyboat3_beg", use_toyboat3_beg, private.room_objname );
  cmn.AddSubscriber( "use_toyboat3_end", use_toyboat3_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_irondoor3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_irondoor3" ] =
  {
    type = "click",
    clk_obj = "spr_irondoor3_1",
    room = private.room_objname,
    zz = "zz_irondoor3",
    zz_gate = "gzz_secretroom3_irondoor3"
  };
  --*********************************************************************************************************************
  local win_irondoor3_inv = function ()

    if ( cmn.IsEventDone( "win_irondoor3" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_irondoor3 = function ()

    if ( cmn.IsEventDone( "win_irondoor3" ) ) then
            
      ObjSet( "gho_secretroom3_hotreasury3", { alp = 1, input = true, active = true } );
      ObjDelete( "gzz_secretroom3_irondoor3" );

      ObjSet( "obj_secretroom3_irondoor_open", { alp = 1 } );
      ObjDelete( "obj_secretroom3_irondoor_close" );
      
    else 

      private.Irondoor3Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_irondoor3", win_irondoor3_inv );
  cmn.AddSubscriber( "win_irondoor3", win_irondoor3, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.get_screensaver_2_19()

  int.AddScreensaver( "spr_armchair3_screensaver_2_19" );

end;    
function private.get_screensaver_2_20()

  int.AddScreensaver( "spr_box3_screensaver_2_20" );

end;
-----------------------------------------------------------------------
function private.get_collect_3_2 ()

  int.AddCollectibles( "spr_secretroom3_collect_3_2" );

end;
-----------------------------------------------------------------------
function private.get_soldierfigurine3 ()

  cmn.SetEventDone( "get_soldierfigurine3" );
  cmn.CallEventHandler( "get_soldierfigurine3" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_crest3_1 ()

  cmn.SetEventDone( "get_crest3_1" );
  cmn.CallEventHandler( "get_crest3_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toyboat3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function public.get_opener3 ()

  if cmn.IsEventDone( "get_crest3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_toyboat3 ()

  cmn.SetEventDone( "get_toyboat3" );
  cmn.CallEventHandler( "get_toyboat3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_crest3_1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_crest3_2 ()

  cmn.SetEventDone( "get_crest3_2" );
  cmn.CallEventHandler( "get_crest3_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_opener3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amuletgriffin3_2 ()

  cmn.SetEventDone( "get_amuletgriffin3_2" );
  cmn.CallEventHandler( "get_amuletgriffin3_2" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_razor3 ()

  local item = "inv_razor3";

  if ( cmn.ApplyObj( item, "gzz_secretroom3_armchair3", false ) ) and
     ( not cmn.IsEventDone( "use_razor3" ) ) and 
       cmn.IsEventDone( "get_soldierfigurine3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armchair3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_armchair3_use_razor3", true ) ) and
         ( not cmn.IsEventDone( "use_razor3" ) ) and 
           cmn.IsEventDone( "get_soldierfigurine3" ) then

    cmn.CallEventHandler( "use_razor3_inv" );
    cmn.CallEventHandler( "use_razor3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_razor3" );
      cmn.CallEventHandler( "use_razor3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_armchair3_use_razor", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_armchair3_cut" );
    AnimPlay( "anm_armchair3_use_razor", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_opener3 ()

  local item = "inv_opener3";

  if ( cmn.ApplyObj( item, "gzz_secretroom3_armchair3", false ) ) and
     ( not cmn.IsEventDone( "use_opener3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armchair3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_armchair3_use_opener3", true ) ) and
         ( not cmn.IsEventDone( "use_opener3" ) ) then

    cmn.CallEventHandler( "use_opener3_inv" );
    cmn.CallEventHandler( "use_opener3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_opener3" );
      cmn.CallEventHandler( "use_opener3_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_armchair3_cut_box" );
    AnimPlay( "anm_armchair3_use_opener", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletgriffin3 ()

  local item = "inv_amuletgriffin3";

  if ( cmn.ApplyObj( item, "gzz_secretroom3_box3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletgriffin3" ) ) and 
       cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
       cmn.IsEventDone( "get_amuletgriffin3_2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_box3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_box3_use_amuletgriffin3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletgriffin3" ) ) and 
           cmn.IsEventDone( "get_amuletgriffin3_1" ) and 
           cmn.IsEventDone( "get_amuletgriffin3_2" ) then

    cmn.CallEventHandler( "use_amuletgriffin3_inv" );
    cmn.CallEventHandler( "use_amuletgriffin3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletgriffin3" );
      cmn.CallEventHandler( "use_amuletgriffin3_end" );
      int_button_mini_ho.Show( "get_opener3", "box3", 4, "spr_box3_opener_panel", private.mini_ho_array ); 

    end;

    int.Lock( true );

    ObjSet( "obj_box3_box_close", { alp = 0 } );
    ObjSet( "anm_box3_use_amuletgriffin", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_box3_insert_2_stuff" );
    AnimPlay( "anm_box3_use_amuletgriffin", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_roundnosepliers3_1 ()

  local item = "inv_roundnosepliers3";

  if ( cmn.ApplyObj( item, "gzz_secretroom3_box3", false ) ) and
     ( not cmn.IsEventDone( "use_roundnosepliers3_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_box3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_box3_use_roundnosepliers3_1", true ) ) and
         ( not cmn.IsEventDone( "use_roundnosepliers3_1" ) ) then

    cmn.CallEventHandler( "use_roundnosepliers3_1_inv" );
    cmn.CallEventHandler( "use_roundnosepliers3_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_roundnosepliers3_1" );
      cmn.CallEventHandler( "use_roundnosepliers3_1_end" );
      private.get_crest3_2();

    end;

    int.Lock( true );

    ObjSet( "anm_box3_click_crest", { alp = 0 } );
    ObjSet( "anm_box3_use_roundnosepliers", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_box3_take_stuff" );
    AnimPlay( "anm_box3_use_roundnosepliers", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_feather3 ()

  local item = "inv_feather3";

  if ( cmn.ApplyObj( item, "gzz_secretroom3_irondoor3", false ) ) and
     ( not cmn.IsEventDone( "use_feather3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_irondoor3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_irondoor3_use_feather3", true ) ) and
         ( not cmn.IsEventDone( "use_feather3" ) ) then

    cmn.CallEventHandler( "use_feather3_inv" );
    cmn.CallEventHandler( "use_feather3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_feather3" );
      cmn.CallEventHandler( "use_feather3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_irondoor3_scorpion_static", { alp = 0 } );
    ObjSet( "anm_irondoor3_use_spray", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_irondoor3_spray_scorpion" );
    cmn.StopAudio( "sfx", "audio/level3/sfx/aud_zz_irondoor3_scorpio_loop_env", 0.5 );
    AnimPlay( "anm_irondoor3_use_spray", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_toyboat3 ()

  local item = "inv_toyboat3";

  if ( cmn.ApplyObj( item, "gzz_secretroom3_irondoor3", false ) ) and
     ( not cmn.IsEventDone( "use_toyboat3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_irondoor3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_irondoor3_use_toyboat3", true ) ) and
         ( not cmn.IsEventDone( "use_toyboat3" ) ) then

    cmn.CallEventHandler( "use_toyboat3_inv" );
    cmn.CallEventHandler( "use_toyboat3_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_toyboat3" );
        cmn.CallEventHandler( "use_toyboat3_end" );
        private.Irondoor3Start();

      end;

      ObjSet( "obj_irondoor3_mmg", { pos_z = 50 } );

      for i = 1, 8 do

        local pos_x = private.start_coor[ i ][ 1 ];
        local pos_y = private.start_coor[ i ][ 2 ];

        ObjAnimate( "spr_irondoor3_"..i, "pos_xy", 0, 0, "",
        {
          0.0, 3, ObjGet( "spr_irondoor3_"..i ).pos_x, ObjGet( "spr_irondoor3_"..i ).pos_y,
          0.3, 3, pos_x, pos_y
        } );

      end;

      cmn.WaitAndRun( func_end1, 0.4 );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_irondoor3_insert_ship_mmg" );
    AnimPlay( "anm_irondoor3_use_toyboat", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_secretroom3 ()

  if not ( cmn.IsEventDone( "opn_secretroom3" ) ) then

    cmn.SetEventDone( "opn_secretroom3" );

  end;

  cmn.StopAllEnv( "audio/level3/env/aud_rm_secretroom3_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_secretroom3_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_secretroom3();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_opener3",                              { "use_amuletgriffin3" } );
  int.AddedTaskMap( private.room_objname, "get_soldierfigurine3" );
  int.AddedTaskMap( private.room_objname, "get_crest3_1",                             { "use_razor3" } );
  int.AddedTaskMap( private.room_objname, "get_toyboat3",                             { "use_opener3" } );
  int.AddedTaskMap( private.room_objname, "get_crest3_2",                             { "use_roundnosepliers3_1" } );
  int.AddedTaskMap( private.room_objname, "get_amuletgriffin3_2",                     { "use_feather3" } );

  int.AddedTaskMap( private.room_objname, "use_razor3",                               { "get_razor3", "get_soldierfigurine3" } );
  int.AddedTaskMap( private.room_objname, "use_opener3",                              { "get_opener3" } );
  int.AddedTaskMap( private.room_objname, "use_amuletgriffin3",                       { "get_amuletgriffin3_1", "get_amuletgriffin3_2" } );
  int.AddedTaskMap( private.room_objname, "use_roundnosepliers3_1",                   { "get_roundnosepliers3" } );
  int.AddedTaskMap( private.room_objname, "use_feather3",                             { "get_feather3" } );
  int.AddedTaskMap( private.room_objname, "use_toyboat3",                             { "get_toyboat3" } );

  int.AddedTaskMap( private.room_objname, "win_irondoor3",                            { "use_toyboat3" } );

  int.AddedTaskMap( private.room_objname, "win_hotreasury3",                          { "win_irondoor3" } );

end;
--*********************************************************************************************************************
function private.InitMiniHO ()
  
  private.mini_ho_array = { 
                            "spr_box3_ho_1", 
                            "spr_box3_ho_2", 
                            "spr_box3_ho_3", 
                            "spr_box3_ho_4", 
                          };

  for i = 1, #private.mini_ho_array do

    ObjSet( private.mini_ho_array[ i ], { 
                    event_mdown = function() 
                                    int_button_mini_ho.MiniHoTaskFind( "get_opener3", "box3", private.mini_ho_array[ i ], 4, "", nil, true );
                                  end,
                    event_menter = function () cmn.SetCursor( CURSOR_GET );  end,
                    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end  } );

  end;
      
end;  
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_irondoor3" );
  subroom.Define( "zz_box3" );
  -----------------------------------------------
  -------------------------------------------------
  function zz_irondoor3.Open()
    
    if ( cmn.IsEventStart( "win_irondoor3" ) and not cmn.IsEventDone( "win_irondoor3" ) ) then

      cmn.MiniGameShow( "irondoor3" );
      common_impl.PassingMgStart( "irondoor3" );

    end;

    if not cmn.IsEventDone( "use_feather3" ) then
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_irondoor3_scorpio_loop_env", 1 );
    end;

  end;
  -------------------------------------------------
  function zz_irondoor3.PreClose()
        
    if ( cmn.IsEventStart( "win_irondoor3" ) and not cmn.IsEventDone( "win_irondoor3" ) ) then

      cmn.MiniGameHide( "irondoor3" );
      common_impl.PassingMgStop( "irondoor3" );

    end;
    
  end;
  -------------------------------------------------
  function zz_irondoor3.Close()

    if not cmn.IsEventDone( "use_feather3" ) then
      cmn.StopAudio( "sfx", "audio/level3/sfx/aud_zz_irondoor3_scorpio_loop_env", 0.5 );
    end;

  end;
  -------------------------------------------------
  function zz_irondoor3.Skip ()

    if ( cmn.IsEventStart( "win_irondoor3" ) and not cmn.IsEventDone( "win_irondoor3" ) ) then
      private.Irondoor3Skip();
    end;

  end;
  -------------------------------------------------
  function zz_irondoor3.Reset ()

    if ( cmn.IsEventStart( "win_irondoor3" ) and not cmn.IsEventDone( "win_irondoor3" ) ) then
      private.Irondoor3Reset();
    end;

  end;
  -------------------------------------------------
  -------------------------------------------------
  function zz_box3.PreOpen ()

     if cmn.IsEventDone( "use_amuletgriffin3" ) and not
       cmn.IsEventDone( "get_opener3" ) then
       int_button_mini_ho.Show( "get_opener3", "box3", 4, "spr_box3_opener_panel", private.mini_ho_array ); 
     end;       
       
  end;  
  -------------------------------------------------
  function zz_box3.PreClose()

    if cmn.IsEventDone( "use_amuletgriffin3" ) and not
        cmn.IsEventDone( "get_opener3" ) then
      int_button_mini_ho.Hide(); 
    end;        
       
  end; 
 -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Irondoor3 *** () end;
--*********************************************************************************************************************
  function private.Irondoor3Start ()

    cmn.MiniGameShow( "irondoor3" );
    common_impl.PassingMgStart( "irondoor3" );
   
    ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz = {
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 }
                                                              };
  end;
  --*********************************************************************************************************************
  function private.Irondoor3Load ()

    for i = 1, 8 do

      if ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz[ i ][ 1 ] ~= 0 then

        local field_line = ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz[ i ][ 1 ];
        local field_column = ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz[ i ][ 2 ];

        local pos_x = private.part_coor[ i ][ 1 ][ 1 ] + ( ( field_column - 1 ) * private.part_coor[ i ][ 2 ][ 1 ] );
        local pos_y = private.part_coor[ i ][ 1 ][ 2 ] + ( ( field_line - 1 ) * private.part_coor[ i ][ 2 ][ 2 ] );

        ObjSet( "spr_irondoor3_"..i, { pos_x = pos_x, pos_y = pos_y } );

      end;

    end; 

  end;
  --*********************************************************************************************************************
  function private.Irondoor3Skip ()

    for i = 1, 8 do

      local field_line = private.win_field_poz[ i ][ 1 ];
      local field_column = private.win_field_poz[ i ][ 2 ];
      local pos_x = private.part_coor[ i ][ 1 ][ 1 ] + ( ( field_column - 1 ) * private.part_coor[ i ][ 2 ][ 1 ] );
      local pos_y = private.part_coor[ i ][ 1 ][ 2 ] + ( ( field_line - 1 ) * private.part_coor[ i ][ 2 ][ 2 ] );

      ObjSet( "spr_irondoor3_"..i, { pos_x = pos_x, pos_y = pos_y } );

    end;

    private.Irondoor3Win();

  end;
  --*********************************************************************************************************************
  function private.Irondoor3Reset ()

    ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz = {
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 },
                                                                { 0, 0 }
                                                               };

    for i = 1, 8 do

      local pos_x = private.start_coor[ i ][ 1 ];
      local pos_y = private.start_coor[ i ][ 2 ];

      ObjSet( "spr_irondoor3_"..i, { pos_x = pos_x, pos_y = pos_y } );

    end; 

  end;
  --*********************************************************************************************************************
  function private.Irondoor3Init ()

    for i = 1, 8 do

      ObjSet( "spr_irondoor3_"..i,
      {
        event_mdown  = function () private.Irondoor3Clk( i ) end,
        event_dragdrop  = function () private.Irondoor3Drop( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );

    end;

    private.part = {
                    {
                      { 1, 1 },
                      { 0, 1 }
                    },
                    {
                      { 1 },
                      { 1 }
                    },
                    {
                      { 1, 0 },
                      { 1, 1 },
                      { 1, 0 },
                    },
                    {
                      { 1, 1, 1 },
                    },
                    {
                      { 1, 1 },
                    },
                    {
                      { 1, 1, 0 },
                      { 0, 1, 1 }
                    },
                    {
                      { 0, 1, 1 },
                      { 1, 1, 0 }
                    },
                    {
                      { 0, 1 },
                      { 1, 1 }
                    },
                   };             

    private.start_coor = {
                          { 277, - 174 },
                          { 261, - 30 },
                          { 297, 152 },
                          { 89, 243 },
                          { - 101, 236 },
                          { - 290, 174 },
                          { - 310, 5 },
                          { -300, - 181 }
                        };

    private.part_coor = {
                          {
                            { - 115, - 123 },--начальные координаты в первой ячейке
                            { 74, 71 }--шаг по x и y
                          }, 
                          {
                            { - 153, - 122 },
                            { 74, 71 }
                          },
                          {
                            { - 115, - 86 },
                            { 74, 71 },
                          },
                          {
                            { - 77, - 157 },
                            { 75, 71 },
                          }, 
                          {
                            { - 113, - 158 },
                            { 74, 72 },
                          }, 
                          {
                            { - 80, - 123 },
                            { 74, 72 },
                          },
                          {
                            { - 79, - 122 },
                            { 74, 71 },
                          },
                          {
                            { - 114, - 122 },
                            { 74, 71 },
                          }   
                        };

    private.win_field_poz = {
                              { 1, 3 },
                              { 1, 5 },
                              { 2, 1 },
                              { 5, 1 },
                              { 5, 4 },
                              { 1, 1 },
                              { 3, 2 },
                              { 3, 4 }
                            };

  end;
  --*********************************************************************************************************************
  function private.Irondoor3Clk ( number )

    ObjSet( "spr_irondoor3_"..number, { pos_z = 100 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_zz_irondoor3_take" );

  end;
  --*********************************************************************************************************************
  function private.Irondoor3Drop ( number )

    ObjSet( "spr_irondoor3_"..number, { pos_z = number } );

    local field_poz_tmp = {
                            { 0, 0 },
                            { 0, 0 },
                            { 0, 0 },
                            { 0, 0 },
                            { 0, 0 },
                            { 0, 0 },
                            { 0, 0 },
                            { 0, 0 }
                          };
    for i = 1, 8 do
      for j = 1, 2 do
        field_poz_tmp[ i ][ j ] = ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz[ i ][ j ];
      end;
    end;

    field_poz_tmp[ number ][ 1 ] = 0;--записываем, что где была раньше деталь, там пусто
    field_poz_tmp[ number ][ 2 ] = 0;

    local scanning_tmp = {
                           { 0, 0, 0, 0, 0 },
                           { 0, 0, 0, 0, 0 },
                           { 0, 0, 0, 0, 0 },
                           { 0, 0, 0, 0, 0 },
                           { 0, 0, 0, 0, 0 }
                         };
    for i = 1, 8 do
      if field_poz_tmp[ i ][ 1 ] ~= 0 then--если деталь на поле
        for part_line = 1, #private.part[ i ] do--количество строк в массиве детали
          for part_column = 1, #private.part[ i ][ part_line ] do--количество столбцов в массиве детали
            if private.part[ i ][ part_line ][ part_column ] == 1 then
              scanning_tmp[ field_poz_tmp[ i ][ 1 ] + part_line - 1 ][ field_poz_tmp[ i ][ 2 ] + part_column - 1 ] = i;
            end; 
          end;
        end;
      end;
    end;

    for field_line = 1, 5 do--количество строк в массиве поля

      for field_column = 1, 5 do--количество столбцов в массиве поля

        if ( cmn.ApplyObj( "spr_irondoor3_"..number, "obj_irondoor3_cell_"..field_line.."_"..field_column, true ) ) then

          for part_line = 1, #private.part[ number ] do--количество строк в массиве детали

            for part_column = 1, #private.part[ number ][ part_line ] do--количество столбцов в массиве детали

              if ( field_line + part_line - 1 ) <= 5 and ( field_column + part_column - 1 ) <= 5 then

                if scanning_tmp[ field_line + part_line - 1 ][ field_column + part_column - 1 ] ~= 0 then

                  if private.part[ number ][ part_line ][ part_column ] == 1 then

                    return;--если ячейка занята, куда мы кладем деталь

                  end;

                end; 

                if private.part[ number ][ part_line ][ part_column ] == 1 then
                  scanning_tmp[ field_line + part_line - 1 ][ field_column + part_column - 1 ] = number;--записываем, что кладем деталь на поле
                end;
                
                if part_line == #private.part[ number ] and part_column == #private.part[ number ][ part_line ] then--если мы проверили, что туда можно положить деталь

                  local pos_x = private.part_coor[ number ][ 1 ][ 1 ] + ( ( field_column - 1 ) * private.part_coor[ number ][ 2 ][ 1 ] );
                  local pos_y = private.part_coor[ number ][ 1 ][ 2 ] + ( ( field_line - 1 ) * private.part_coor[ number ][ 2 ][ 2 ] );

                  ObjSet( "spr_irondoor3_"..number, { pos_x = pos_x, pos_y = pos_y } );

                  field_poz_tmp[ number ][ 1 ] = field_line;
                  field_poz_tmp[ number ][ 2 ] = field_column;

                  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_zz_irondoor3_put_field" );

                  -----------------------проверка на выигрыш----------------------

--                  for i = 1, 5 do 
--                    for j = 1, 5 do
--                      if scanning_tmp[ i ][ j ] == 0 then
--
--                        for i = 1, 8 do
--                          for j = 1, 2 do
--                            ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz[ i ][ j ] = field_poz_tmp[ i ][ j ];
--                          end;
--                        end;
--
--                        return;
--
--                      end;
--                    end;
--                  end;

                  --private.Irondoor3Win();
                  --return;

                 local win = true;

                 for i = 1, 8 do

                   if field_poz_tmp[ i ][ 1 ] ~= private.win_field_poz[ i ][ 1 ] or 
                      field_poz_tmp[ i ][ 2 ] ~= private.win_field_poz[ i ][ 2 ] then
                     win = false;
                   end;

                 end;
     
                 if win then
                   private.Irondoor3Win();
                 else
                   for i = 1, 8 do
                     for j = 1, 2 do
                       ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz[ i ][ j ] = field_poz_tmp[ i ][ j ];
                     end;
                   end;
                 end; 

                 return;
                 ----------------------------------------------------------------   

                end;
               
              else

                local pos_x = private.start_coor[ number ][ 1 ];
                local pos_y = private.start_coor[ number ][ 2 ];

                ObjSet( "spr_irondoor3_"..number, { pos_x = pos_x, pos_y = pos_y } );
                for i = 1, 8 do
                  for j = 1, 2 do
                    ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz[ i ][ j ] = field_poz_tmp[ i ][ j ];
                  end;
                end;

                return;--если деталь выходит за границы поля

              end;

            end;

          end;

        end;

      end;

    end;

    local pos_x = private.start_coor[ number ][ 1 ];
    local pos_y = private.start_coor[ number ][ 2 ];

    ObjSet( "spr_irondoor3_"..number, { pos_x = pos_x, pos_y = pos_y } );
    for i = 1, 8 do
      for j = 1, 2 do
        ng_global.progress[ "std" ][ "win_irondoor3" ].field_poz[ i ][ j ] = field_poz_tmp[ i ][ j ];
      end;
    end;

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_zz_irondoor3_pout_field" );

  end;
  --*********************************************************************************************************************
  function private.Irondoor3Win () 

    local func_end = function ()

      local func_end1 = function ()

        cmn.MiniGameHide( "irondoor3" );
        cmn.SetEventDone( "win_irondoor3" );
        cmn.CallEventHandler( "win_irondoor3" );
        common_impl.PassingMgWin( "irondoor3" );
        cmn.CloseSubRoom();

      end;

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_zz_irondoor3_win" );
      ObjAnimate( "obj_irondoor3_door1", "alp", 0, 0, "", 
      { 
        0.0, 0, 1,
        0.3, 0, 0,
      } );
      ObjAnimate( "obj_irondoor3_door2", "alp", 0, 0, func_end1, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );

    end;

    int.Lock( true );
    cmn.WaitAndRun( func_end );

  end;
--*********************************************************************************************************************
function private.Irondoor3HandleClk () 

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_irondoor3_left_handle" );
  ObjAnimate( "obj_irondoor3_handle_1", "ang", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, -0.1,
    0.4, 3, 0,
    0.6, 3, -0.1,
    0.8, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.Irondoor3ScorpionClk () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_irondoor3_use_feather3" );
    ObjSet( "anm_irondoor3_scorpion_static", { alp = 1 } );
    ObjSet( "anm_irondoor3_scorpion_click", { alp = 0 } );
    AnimPlay( "anm_irondoor3_scorpion_static", "DoAnim", "" );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "anm_irondoor3_scorpion_static", { alp = 0 } );
  AnimStop( "anm_irondoor3_scorpion_static" );
  ObjSet( "anm_irondoor3_scorpion_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_irondoor3_scorpion" );
  AnimPlay( "anm_irondoor3_scorpion_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Box3CrestClk () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_box3_use_roundnosepliers3_1" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_box3_stuff" );
  AnimPlay( "anm_box3_click_crest", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Box3AmuletgriffinClk () 

  local func_end = function ()

    cmn.ShowBbt( "bbt_box3_use_amuletgriffin3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_box3_chest" );
  AnimPlay( "anm_box3_cap_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************