-- name=rm_shore3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_shore3";

  private.InitSubroom();
  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_shore3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_shore3", update_game_mode_shore3, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_5 = function ()

    ObjDelete( "obj_shore3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_5", get_morphobject_2_5, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_shore3 ()

  if not ( cmn.IsEventDone( "opn_shore3" ) ) then

    cmn.SetEventDone( "opn_shore3" );

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_shore2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_shore2_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_shore3();

end;
--*********************************************************************************************************************
function public.Task ()

  --int.AddedTaskMap( private.room_objname, "", { "" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
--[[
  subroom.Define( "zz_picture" );  
  -------------------------------------------------
  function zz_picture.Open()
  end;
  -------------------------------------------------
  function zz_picture.PreClose()
  end;
  -------------------------------------------------
  function zz_picture.Skip ()
  end;
  -------------------------------------------------
  function zz_picture.Reset ()
  end;
  -------------------------------------------------
]]--
end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************