-- name=rm_tower3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_tower3";

  private.InitSubroom();
  private.InitAnimations();
  private.Labdoor3Init();

  ObjAttach( "zz_labdoor3", "room_hub" );
  ObjAttach( "zz_stuff3",   "room_hub" );
  ObjAttach( "zz_roaster3", "room_hub" );
  ObjAttach( "zz_armory3",  "room_hub" );
  ObjAttach( "zz_boxes3",   "room_hub" );

  ObjMultiSet(
  {
    { "spr_labdoor3_jimmy3",                  { event_mdown = private.get_jimmy3 } },    
    { "spr_armory3_disassembledgun3",         { event_mdown = private.get_disassembledgun3 } },
    { "spr_stuff3_blacksmithfigurine3_1",     { event_mdown = private.get_blacksmithfigurine3_1 } },
    { "spr_armory3_battery3",                 { event_mdown = private.get_battery3 } },
    { "spr_stuff3_hexagram3_2",               { event_mdown = private.get_hexagram3_2 } },
    { "spr_roaster3_amuletgorgon3",           { event_mdown = private.get_amuletgorgon3 } },
    { "spr_roaster3_burningtorch3",           { event_mdown = private.get_burningtorch3 } },
    { "spr_roaster3_bluecylinder3",           { event_mdown = private.get_bluecylinder3 } },
    { "spr_armory3_blacksmithfigurine3_3",    { event_mdown = private.get_blacksmithfigurine3_3 } },
    { "spr_armory3_bullet3",                  { event_mdown = private.get_bullet3 } },
    { "spr_boxes3_mallet3",                   { event_mdown = private.get_mallet3 } },
    { "spr_boxes3_blacksmithfigurine3_2",     { event_mdown = private.get_blacksmithfigurine3_2 } },
    { "spr_labdoor3_amuletomega3_1",          { event_mdown = private.get_amuletomega3_1 } },
    { "spr_labdoor3_switchhandle3",           { event_mdown = private.get_switchhandle3 } },        
    { "spr_boxes3_amuletmolecule3_1",         { event_mdown = private.get_amuletmolecule3_1 } },
    { "spr_boxes3_disassembledlamp3",         { event_mdown = private.get_disassembledlamp3 } },
    { "spr_boxes3_magnetizedhorseshoe3",      { event_mdown = private.get_magnetizedhorseshoe3 } },
    { "spr_tower3_facetedglass3",             { event_mdown = private.get_facetedglass3 } },
    { "obj_armory3_use_icarusfigurine3",      { event_mdown = private.Armory3Door1Click } },
    { "obj_armory3_use_soldierfigurine3",     { event_mdown = private.Armory3Door2Click } },
    { "obj_armory3_clk_switchhandle3",        { event_mdown = private.clk_switchhandle3 } },
    { "spr_armory3_amuletmolecule3_2",        { event_mdown = private.get_amuletmolecule3_2 } },    
    { "spr_tower3_collect_3_3",               { event_mdown = private.get_collect_3_3 } },
    { "obj_stuff3_use_chisel3",               { event_mdown = function() private.Stuff3EggClk() end } },
    { "obj_roaster3_use_propellentcharge3",   { event_mdown = function() private.Roaster3StoneClk() end } },
    { "spr_armory3_torch3",                   { event_mdown = private.get_torch3 } },
    { "obj_armory3_use_switchhandle3",        { event_mdown = private.Armory3Lattice2Click } },
    { "obj_labdoor3_use_blacksmithfigurine3", { event_mdown = private.Labdoor3BoxClick } },
    { "obj_labdoor3_use_amuletmolecule3",     { event_mdown = private.Labdoor3CapClick } },
    { "obj_labdoor3_use_amuletmolecule3_2",   { event_mdown = private.Labdoor3LockClick } },
    { "obj_boxes3_use_jimmy3",                { event_mdown = function() private.Boxes3Clk() end } },
    { "spr_stuff3_screensaver_2_13",     { event_mdown = private.get_screensaver_2_13 } },      
    { "spr_boxes3_screensaver_2_14",     { event_mdown = private.get_screensaver_2_14 } },          
  } );
  local get_screensaver_2_13 = function ()

    ObjDelete( "spr_stuff3_screensaver_2_13" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_13", get_screensaver_2_13, private.room_objname );  
  local get_screensaver_2_14 = function ()

    ObjDelete( "spr_boxes3_screensaver_2_14" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_14", get_screensaver_2_14, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_tower3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_tower3", update_game_mode_tower3, private.room_objname );  
  
  --------------------------------------------------------------------------------------------
  -- function opn_tower3 () end;
  --------------------------------------------------------------------------------------------
  local opn_tower3 = function ()

    ObjDelete( "anm_tower3_stacy_away_fromtower" ); 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_tower3", opn_tower3, private.room_objname );    
  --------------------------------------------------------------------------------------------  
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_3_3 = function ()

    ObjDelete( "spr_tower3_collect_3_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_3_3", get_collect_3_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_5 = function ()

    ObjDelete( "obj_tower3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_3_5", get_morphobject_3_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletrainbow3 () end;
  --------------------------------------------------------------------------------------------
  local get_amuletrainbow3_inv = function ()

    int.InventoryItemAdd( "inv_amuletrainbow3", "spr_tower3_amuletrainbow3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletrainbow3", get_amuletrainbow3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_jimmy3 () end;
  --------------------------------------------------------------------------------------------
  local get_jimmy3_inv = function ()

    int.InventoryItemAdd( "inv_jimmy3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_jimmy3", get_jimmy3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_richardskull3 () end;
  --------------------------------------------------------------------------------------------
  local get_richardskull3_inv = function ()

    int.InventoryItemAdd( "inv_richardskull3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_richardskull3", get_richardskull3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_blacksmithfigurine3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blacksmithfigurine3_1" ] =
  {
    type = "get",
    get_obj = "spr_stuff3_blacksmithfigurine3_1",
    room = private.room_objname,
    zz = "zz_stuff3",
    zz_gate = "gzz_tower3_stuff3"
  };
  --------------------------------------------------------------------------------------------
  local get_blacksmithfigurine3_1_inv = function ()

    int.InventoryItemAdd( "inv_blacksmithfigurine3", "spr_stuff3_blacksmithfigurine3_1", "assets/levels/level3/rm_tower3/zz_stuff3/inv/inv_blacksmithfigurine3_1" );
    level3_inv.CheckBlacksmithfigurine3();

  end;
  local get_blacksmithfigurine3_1_closezz = function ()

    ObjDelete( "gfx_stuff3_blacksmithfigurine3_1" );
    ObjDelete( "spr_tower3_stuff_blacksmithfigurine" );

    if cmn.IsEventDone( "get_hexagram3_2" ) then

      ObjDelete( "gzz_tower3_stuff3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_blacksmithfigurine3_1", get_blacksmithfigurine3_1_inv );
  cmn.AddSubscriber( "get_blacksmithfigurine3_1", get_blacksmithfigurine3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hexagram3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hexagram3_2" ] =
  {
    type = "get",
    get_obj = "spr_stuff3_hexagram3_2",
    room = private.room_objname,
    zz = "zz_stuff3",
    zz_gate = "gzz_tower3_stuff3"
  };
  --------------------------------------------------------------------------------------------
  local get_hexagram3_2_inv = function ()

    int.InventoryItemAdd( "inv_hexagram3", "spr_stuff3_hexagram3_2", "assets/levels/level3/rm_neartower3/zz_tunnelentrance3/inv/inv_hexagram3_2" );
    level3_inv.CheckHexagram3( 2 );

  end;
  local get_hexagram3_2_closezz = function ()

    ObjDelete( "gfx_stuff3_hexagram3_2" );
    ObjDelete( "spr_stuff3_light_hexagram_open" );
    ObjDelete( "spr_tower3_hexagram" );

    if cmn.IsEventDone( "get_blacksmithfigurine3_1" ) then

      ObjDelete( "gzz_tower3_stuff3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_hexagram3_2", get_hexagram3_2_inv );
  cmn.AddSubscriber( "get_hexagram3_2", get_hexagram3_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletgorgon3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletgorgon3" ] =
  {
    type = "get",
    get_obj = "spr_roaster3_amuletgorgon3",
    room = private.room_objname,
    zz = "zz_roaster3",
    zz_gate = "gzz_tower3_roaster3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletgorgon3_inv = function ()

    int.InventoryItemAdd( "inv_amuletgorgon3", "spr_roaster3_amuletgorgon3" );

  end;
  local get_amuletgorgon3_closezz = function ()

    ObjDelete( "gfx_roaster3_amuletgorgon3" );
    ObjDelete( "spr_tower3_amuletgorgon" );

    if ( cmn.IsEventDone( "get_bluecylinder3" ) ) and
       ( cmn.IsEventDone( "get_amuletgorgon3" ) ) then

      ObjDelete( "gzz_tower3_roaster3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletgorgon3", get_amuletgorgon3_inv );
  cmn.AddSubscriber( "get_amuletgorgon3", get_amuletgorgon3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_burningtorch3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_burningtorch3" ] =
  {
    type = "get",
    get_obj = "obj_roaster3_burningtorch3",
    room = private.room_objname,
    zz = "zz_roaster3",
    zz_gate = "gzz_tower3_roaster3"
  };
  --------------------------------------------------------------------------------------------
  local get_burningtorch3_inv = function ()

    int.InventoryItemAdd( "inv_burningtorch3", "obj_roaster3_burningtorch3" );

  end;
  local get_burningtorch3_closezz = function ()

    ObjDelete( "gfx_roaster3_burningtorch3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_burningtorch3", get_burningtorch3_inv );
  cmn.AddSubscriber( "get_burningtorch3", get_burningtorch3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletmolecule3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletmolecule3_2" ] =
  {
    type = "get",
    get_obj = "spr_armory3_amuletmolecule3_2",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletmolecule3_2_inv = function ()

    int.InventoryItemAdd( "inv_amuletmolecule3", "spr_armory3_amuletmolecule3_2", "assets/levels/level3/rm_tower3/zz_boxes3/inv/inv_amuletmolecule3_2" );
    level3_inv.CheckAmuletmolecule3( 2 );

  end;
  local get_amuletmolecule3_2_closezz = function ()

    ObjDelete( "gfx_armory3_amuletmolecule3_2" );
    ObjDelete( "spr_tower3_armory_amuletmolecule" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletmolecule3_2", get_amuletmolecule3_2_inv );
  cmn.AddSubscriber( "get_amuletmolecule3_2", get_amuletmolecule3_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bluecylinder3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bluecylinder3" ] =
  {
    type = "get",
    get_obj = "spr_roaster3_bluecylinder3",
    room = private.room_objname,
    zz = "zz_roaster3",
    zz_gate = "gzz_tower3_roaster3"
  };
  --------------------------------------------------------------------------------------------
  local get_bluecylinder3_inv = function ()

    int.InventoryItemAdd( "inv_bluecylinder3", "spr_roaster3_bluecylinder3" );

  end;
  local get_bluecylinder3_closezz = function ()

    ObjDelete( "gfx_roaster3_bluecylinder3" );
    ObjDelete( "spr_tower3_bluecylinder" );

    if ( cmn.IsEventDone( "get_bluecylinder3" ) ) and
       ( cmn.IsEventDone( "get_amuletgorgon3" ) ) then

      ObjDelete( "gzz_tower3_roaster3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bluecylinder3", get_bluecylinder3_inv );
  cmn.AddSubscriber( "get_bluecylinder3", get_bluecylinder3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_blacksmithfigurine3_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blacksmithfigurine3_3" ] =
  {
    type = "get",
    get_obj = "spr_armory3_blacksmithfigurine3_3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local get_blacksmithfigurine3_3_inv = function ()

    int.InventoryItemAdd( "inv_blacksmithfigurine3", "spr_armory3_blacksmithfigurine3_3", "assets/levels/level3/rm_tower3/zz_stuff3/inv/inv_blacksmithfigurine3_3" );
    level3_inv.CheckBlacksmithfigurine3();

  end;
  local get_blacksmithfigurine3_3_closezz = function ()

    ObjDelete( "gfx_armory3_blacksmithfigurine3_3" );
    ObjDelete( "spr_tower3_armory_blacksmithfigurine" );

    if ( cmn.IsEventDone( "get_torch3" ) ) and
       ( cmn.IsEventDone( "get_bullet3" ) ) and
       ( cmn.IsEventDone( "get_battery3" ) ) and
       ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
       ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

      ObjDelete( "gzz_tower3_armory3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_blacksmithfigurine3_3", get_blacksmithfigurine3_3_inv );
  cmn.AddSubscriber( "get_blacksmithfigurine3_3", get_blacksmithfigurine3_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_torch3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_torch3" ] =
  {
    type = "get",
    get_obj = "spr_armory3_torch3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local get_torch3_inv = function ()

    int.InventoryItemAdd( "inv_torch3", "spr_armory3_torch3" );

  end;
  local get_torch3_closezz = function ()

    ObjDelete( "gfx_armory3_torch3" );
    ObjDelete( "spr_tower3_torch" );

    if ( cmn.IsEventDone( "get_torch3" ) ) and
       ( cmn.IsEventDone( "get_bullet3" ) ) and
       ( cmn.IsEventDone( "get_battery3" ) ) and
       ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
       ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

      ObjDelete( "gzz_tower3_armory3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_torch3", get_torch3_inv );
  cmn.AddSubscriber( "get_torch3", get_torch3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bullet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bullet3" ] =
  {
    type = "get",
    get_obj = "spr_armory3_bullet3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local get_bullet3_inv = function ()

    int.InventoryItemAdd( "inv_bullet3", "spr_armory3_bullet3" );

    if ( cmn.IsEventDone( "clk_disassembledgun3" ) ) and
       ( cmn.IsEventDone( "use_gunpowder3" ) ) then

      ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_bullet3_closezz = function ()

    ObjDelete( "gfx_armory3_bullet3" );
    ObjDelete( "spr_tower3_bullet" );

    if ( cmn.IsEventDone( "get_torch3" ) ) and
       ( cmn.IsEventDone( "get_bullet3" ) ) and
       ( cmn.IsEventDone( "get_battery3" ) ) and
       ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
       ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

      ObjDelete( "gzz_tower3_armory3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bullet3", get_bullet3_inv );
  cmn.AddSubscriber( "get_bullet3", get_bullet3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mallet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mallet3" ] =
  {
    type = "get",
    get_obj = "spr_boxes3_mallet3",
    room = private.room_objname,
    zz = "zz_boxes3",
    zz_gate = "gzz_tower3_boxes3"
  };
  --------------------------------------------------------------------------------------------
  local get_mallet3_inv = function ()

    int.InventoryItemAdd( "inv_mallet3", "spr_boxes3_mallet3" );

  end;
  local get_mallet3_closezz = function ()

    ObjDelete( "gfx_boxes3_mallet3" );
    ObjDelete( "spr_tower3_boxes_mallet" );

    if cmn.IsEventDone( "get_disassembledlamp3" ) and 
       cmn.IsEventDone( "get_magnetizedhorseshoe3" ) and 
       cmn.IsEventDone( "get_amuletmolecule3_1" ) and 
       cmn.IsEventDone( "get_blacksmithfigurine3_2" ) then

      ObjDelete( "gzz_tower3_boxes3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mallet3", get_mallet3_inv );
  cmn.AddSubscriber( "get_mallet3", get_mallet3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_blacksmithfigurine3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blacksmithfigurine3_2" ] =
  {
    type = "get",
    get_obj = "spr_boxes3_blacksmithfigurine3_2",
    room = private.room_objname,
    zz = "zz_boxes3",
    zz_gate = "gzz_tower3_boxes3"
  };
  --------------------------------------------------------------------------------------------
  local get_blacksmithfigurine3_2_inv = function ()

    int.InventoryItemAdd( "inv_blacksmithfigurine3", "spr_boxes3_blacksmithfigurine3_2", "assets/levels/level3/rm_tower3/zz_stuff3/inv/inv_blacksmithfigurine3_2" );
    level3_inv.CheckBlacksmithfigurine3();

  end;
  local get_blacksmithfigurine3_2_closezz = function ()

    ObjDelete( "gfx_boxes3_blacksmithfigurine3_2" );
    ObjDelete( "spr_tower3_boxes_blacksmithfigurine" );

    if cmn.IsEventDone( "get_disassembledlamp3" ) and 
       cmn.IsEventDone( "get_magnetizedhorseshoe3" ) and 
       cmn.IsEventDone( "get_amuletmolecule3_1" ) and 
       cmn.IsEventDone( "get_mallet3" ) then

      ObjDelete( "gzz_tower3_boxes3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_blacksmithfigurine3_2", get_blacksmithfigurine3_2_inv );
  cmn.AddSubscriber( "get_blacksmithfigurine3_2", get_blacksmithfigurine3_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletomega3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletomega3_1" ] =
  {
    type = "get",
    get_obj = "spr_labdoor3_amuletomega3_1",
    room = private.room_objname,
    zz = "zz_labdoor3",
    zz_gate = "gzz_tower3_labdoor3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletomega3_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletomega3", "spr_labdoor3_amuletomega3_1", "assets/levels/level3/rm_tower3/zz_labdoor3/inv/inv_amuletomega3_1" );
    level3_inv.CheckAmuletomega3( 1 );

  end;
  local get_amuletomega3_1_closezz = function ()

    ObjDelete( "gfx_labdoor3_amuletomega3_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletomega3_1", get_amuletomega3_1_inv );
  cmn.AddSubscriber( "get_amuletomega3_1", get_amuletomega3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_switchhandle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_switchhandle3" ] =
  {
    type = "get",
    get_obj = "spr_labdoor3_switchhandle3",
    room = private.room_objname,
    zz = "zz_labdoor3",
    zz_gate = "gzz_tower3_labdoor3"
  };
  --------------------------------------------------------------------------------------------
  local get_switchhandle3_inv = function ()

    int.InventoryItemAdd( "inv_switchhandle3", "spr_labdoor3_switchhandle3" );

  end;
  local get_switchhandle3_closezz = function ()

    ObjDelete( "gfx_labdoor3_switchhandle3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_switchhandle3", get_switchhandle3_inv );
  cmn.AddSubscriber( "get_switchhandle3", get_switchhandle3_closezz, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_amuletmolecule3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletmolecule3_1" ] =
  {
    type = "get",
    get_obj = "spr_boxes3_amuletmolecule3_1",
    room = private.room_objname,
    zz = "zz_boxes3",
    zz_gate = "gzz_tower3_boxes3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletmolecule3_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletmolecule3", "spr_boxes3_amuletmolecule3_1", "assets/levels/level3/rm_tower3/zz_boxes3/inv/inv_amuletmolecule3_1" );
    level3_inv.CheckAmuletmolecule3( 1 );

  end;
  local get_amuletmolecule3_1_closezz = function ()

    ObjDelete( "gfx_boxes3_amuletmolecule3_1" );
    ObjDelete( "spr_tower3_boxes_amuletmolecule" );

    if cmn.IsEventDone( "get_disassembledlamp3" ) and 
       cmn.IsEventDone( "get_magnetizedhorseshoe3" ) and 
       cmn.IsEventDone( "get_mallet3" ) and 
       cmn.IsEventDone( "get_blacksmithfigurine3_2" ) then

      ObjDelete( "gzz_tower3_boxes3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletmolecule3_1", get_amuletmolecule3_1_inv );
  cmn.AddSubscriber( "get_amuletmolecule3_1", get_amuletmolecule3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_disassembledlamp3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_disassembledlamp3" ] =
  {
    type = "get",
    get_obj = "spr_boxes3_disassembledlamp3",
    room = private.room_objname,
    zz = "zz_boxes3",
    zz_gate = "gzz_tower3_boxes3"
  };
  --------------------------------------------------------------------------------------------
  local get_disassembledlamp3_inv = function ()

    int.InventoryItemAdd( "inv_disassembledlamp3", "spr_boxes3_disassembledlamp3" );
    ObjSet( "inv_disassembledlamp3", { drag = false } );

    if ( not cmn.IsEventDone( "get_gasoline3" ) ) then

      ObjSet( "inv_disassembledlamp3_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_disassembledlamp3_closezz = function ()

    ObjDelete( "gfx_boxes3_disassembledlamp3" );
    ObjDelete( "spr_boxes3_disassembledlamp_shadow" );

    ObjDelete( "spr_tower3_disassembledlamp" );

    if cmn.IsEventDone( "get_magnetizedhorseshoe3" ) and 
       cmn.IsEventDone( "get_amuletmolecule3_1" ) and 
       cmn.IsEventDone( "get_mallet3" ) and 
       cmn.IsEventDone( "get_blacksmithfigurine3_2" ) then

      ObjDelete( "gzz_tower3_boxes3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_disassembledlamp3", get_disassembledlamp3_inv );
  cmn.AddSubscriber( "get_disassembledlamp3", get_disassembledlamp3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_magnetizedhorseshoe3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnetizedhorseshoe3" ] =
  {
    type = "get",
    get_obj = "spr_boxes3_magnetizedhorseshoe3",
    room = private.room_objname,
    zz = "zz_boxes3",
    zz_gate = "gzz_tower3_boxes3"
  };
  --------------------------------------------------------------------------------------------
  local get_magnetizedhorseshoe3_inv = function ()

    int.InventoryItemAdd( "inv_magnetizedhorseshoe3", "spr_boxes3_magnetizedhorseshoe3" );
    ObjSet( "inv_magnetizedhorseshoe3", { drag = false } );

    if ( not cmn.IsEventDone( "get_lace3" ) ) then

      ObjSet( "inv_magnetizedhorseshoe3_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_magnetizedhorseshoe3_closezz = function ()

    ObjDelete( "gfx_boxes3_magnetizedhorseshoe3" );
    ObjDelete( "spr_boxes3_magnetizedhorseshoe_shadow" );
    ObjDelete( "spr_tower3_magnetizedhorseshoe" );

    if cmn.IsEventDone( "get_disassembledlamp3" ) and 
       cmn.IsEventDone( "get_amuletmolecule3_1" ) and 
       cmn.IsEventDone( "get_mallet3" ) and 
       cmn.IsEventDone( "get_blacksmithfigurine3_2" ) then

      ObjDelete( "gzz_tower3_boxes3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magnetizedhorseshoe3", get_magnetizedhorseshoe3_inv );
  cmn.AddSubscriber( "get_magnetizedhorseshoe3", get_magnetizedhorseshoe3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_facetedglass3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_facetedglass3" ] =
  {
    type = "get",
    get_obj = "spr_tower3_facetedglass3",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local get_facetedglass3_inv = function ()

    int.InventoryItemAdd( "inv_facetedglass3", "spr_tower3_facetedglass3" );

  end;
  local get_facetedglass3_closezz = function ()

    ObjDelete( "gfx_tower3_facetedglass3" );
    ObjDelete( "spr_tower3_facetedglass2_light" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_facetedglass3", get_facetedglass3_inv );
  cmn.AddSubscriber( "get_facetedglass3", get_facetedglass3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_battery3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_battery3" ] =
  {
    type = "get",
    get_obj = "spr_armory3_battery3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local get_battery3_inv = function ()

    int.InventoryItemAdd( "inv_battery3", "spr_armory3_battery3" );

  end;
  local get_battery3_closezz = function ()

    ObjDelete( "gfx_armory3_battery3" );
    ObjDelete( "spr_tower3_battery" );

    if ( cmn.IsEventDone( "get_torch3" ) ) and
       ( cmn.IsEventDone( "get_bullet3" ) ) and
       ( cmn.IsEventDone( "get_battery3" ) ) and
       ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
       ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

      ObjDelete( "gzz_tower3_armory3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_battery3", get_battery3_inv );
  cmn.AddSubscriber( "get_battery3", get_battery3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_disassembledgun3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_disassembledgun3" ] =
  {
    type = "get",
    get_obj = "spr_armory3_disassembledgun3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local get_disassembledgun3_inv = function ()

    int.InventoryItemAdd( "inv_disassembledgun3", "spr_armory3_disassembledgun3" );

    ObjSet( "inv_disassembledgun3", { drag = false } );

--    if ( not cmn.IsEventDone( "get_gunpowder3" ) ) or
--       ( not cmn.IsEventDone( "get_flintlock3" ) ) then
--
--      ObjSet( "inv_disassembledgun3_plus_focus2", { alp = 0 } );
--
--    end;

  end;
  local get_disassembledgun3_closezz = function ()

    ObjDelete( "spr_tower3_disassembledgun" );
    ObjDelete( "spr_armory3_disassembledgun3_shadow" );

    if ( cmn.IsEventDone( "get_torch3" ) ) and
       ( cmn.IsEventDone( "get_bullet3" ) ) and
       ( cmn.IsEventDone( "get_battery3" ) ) and
       ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
       ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

      ObjDelete( "gzz_tower3_armory3" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_disassembledgun3", get_disassembledgun3_inv );
  cmn.AddSubscriber( "get_disassembledgun3", get_disassembledgun3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_blacksmithfigurine3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_blacksmithfigurine3" ] =
  {
    type = "use",
    use_obj = "inv_blacksmithfigurine3",
    use_place = "obj_labdoor3_use_blacksmithfigurine3",
    room = private.room_objname,
    zz = "zz_labdoor3",
    zz_gate = "gzz_tower3_labdoor3"
  };
  --------------------------------------------------------------------------------------------
  local use_blacksmithfigurine3_inv = function ()

    int.InventoryItemRemove( "inv_blacksmithfigurine3" );

  end;
  local use_blacksmithfigurine3_beg = function ()

    ObjDelete( "obj_labdoor3_use_blacksmithfigurine3" );
    ObjDelete( "anm_labdoor3_box_cap_click" );

  end;
  local use_blacksmithfigurine3_end = function ()

    ObjSet( "anm_labdoor3_blacksmithfigurine", { alp = 1, frame = 94, animfunc = "DoAnim" } );
    ObjSet( "spr_labdoor3_amuletomega3_1", { input = true } );
    ObjSet( "gfx_labdoor3_amuletomega3_1", { active = true } );
    ObjSet( "spr_labdoor3_switchhandle3",  { input = true } );
    ObjSet( "gfx_labdoor3_switchhandle3",  { active = true } );

    ObjDelete( "spr_tower3_labdoor_box_closed" );
    ObjSet( "spr_tower3_labdoor_box_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_blacksmithfigurine3",     use_blacksmithfigurine3_inv );
  cmn.AddSubscriber( "use_blacksmithfigurine3",     use_blacksmithfigurine3_beg, private.room_objname );
  cmn.AddSubscriber( "use_blacksmithfigurine3",     use_blacksmithfigurine3_end, private.room_objname );
  cmn.AddSubscriber( "use_blacksmithfigurine3_inv", use_blacksmithfigurine3_inv, private.room_objname );
  cmn.AddSubscriber( "use_blacksmithfigurine3_beg", use_blacksmithfigurine3_beg, private.room_objname );
  cmn.AddSubscriber( "use_blacksmithfigurine3_end", use_blacksmithfigurine3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletmolecule3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletmolecule3" ] =
  {
    type = "use",
    use_obj = "inv_amuletmolecule3",
    use_place = "obj_labdoor3_use_amuletmolecule3",
    room = private.room_objname,
    zz = "zz_labdoor3",
    zz_gate = "gzz_tower3_labdoor3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletmolecule3_inv = function ()

    int.InventoryItemRemove( "inv_amuletmolecule3" );

  end;
  local use_amuletmolecule3_beg = function ()

    ObjDelete( "obj_labdoor3_use_amuletmolecule3" );
    ObjDelete( "obj_labdoor3_use_amuletmolecule3_2" );
    ObjDelete( "anm_labdoor3_cap_click" );

  end;
  local use_amuletmolecule3_end = function ()

    ObjSet( "obj_labdoor3_mmg", { alp = 1, scale_x = 1, scale_y = 1, pos_y = -55, input = true } );
    ObjSet( "anm_labdoor3_amuletmolecule", { alp = 1, frame = 98, animfunc = "DoAnim" } );

    ObjSet( "spr_tower3_labdoor_mmg", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletmolecule3",     use_amuletmolecule3_inv );
  cmn.AddSubscriber( "use_amuletmolecule3",     use_amuletmolecule3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletmolecule3",     use_amuletmolecule3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletmolecule3_inv", use_amuletmolecule3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletmolecule3_beg", use_amuletmolecule3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletmolecule3_end", use_amuletmolecule3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chisel3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel3" ] =
  {
    type = "use",
    use_obj = "inv_chisel3",
    use_place = "obj_stuff3_use_chisel3",
    room = private.room_objname,
    zz = "zz_stuff3",
    zz_gate = "gzz_tower3_stuff3"
  };
  --------------------------------------------------------------------------------------------
  local use_chisel3_inv = function ()

    int.InventoryItemRemove( "inv_chisel3" );

  end;
  local use_chisel3_beg = function ()

    ObjDelete( "obj_stuff3_use_chisel3" );

  end;
  local use_chisel3_end = function ()

    ObjSet( "anm_stuff3_use_chisel", { alp = 1, frame = 500 } );
    ObjDelete( "anm_stuff3_click_egg" );

    ObjSet( "obj_stuff3_use_mallet3", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel3",     use_chisel3_inv );
  cmn.AddSubscriber( "use_chisel3",     use_chisel3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel3",     use_chisel3_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel3_inv", use_chisel3_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel3_beg", use_chisel3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel3_end", use_chisel3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mallet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mallet3" ] =
  {
    type = "use",
    use_obj = "inv_mallet3",
    use_place = "obj_stuff3_use_mallet3",
    room = private.room_objname,
    zz = "zz_stuff3",
    zz_gate = "gzz_tower3_stuff3"
  };
  --------------------------------------------------------------------------------------------
  local use_mallet3_inv = function ()

    int.InventoryItemRemove( "inv_mallet3" );

  end;
  local use_mallet3_beg = function ()

    ObjDelete( "obj_stuff3_use_mallet3" );

  end;
  local use_mallet3_end = function ()

    ObjSet( "spr_stuff3_hexagram3_2", { alp = 1, input = true } );
    ObjSet( "gfx_stuff3_hexagram3_2", { active = true } );
    ObjSet( "spr_stuff3_egg", { alp = 1 } );
    ObjDelete( "anm_stuff3_use_mallet" );
    ObjDelete( "anm_stuff3_use_chisel" );

    ObjDelete( "spr_tower3_egg_close" );
    ObjSet( "spr_tower3_hexagram", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mallet3",     use_mallet3_inv );
  cmn.AddSubscriber( "use_mallet3",     use_mallet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mallet3",     use_mallet3_end, private.room_objname );
  cmn.AddSubscriber( "use_mallet3_inv", use_mallet3_inv, private.room_objname );
  cmn.AddSubscriber( "use_mallet3_beg", use_mallet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_mallet3_end", use_mallet3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_torch3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_torch3" ] =
  {
    type = "use",
    use_obj = "inv_torch3",
    use_place = "obj_roaster3_use_torch3",
    room = private.room_objname,
    zz = "zz_roaster3",
    zz_gate = "gzz_tower3_roaster3"
  };
  --------------------------------------------------------------------------------------------
  local use_torch3_inv = function ()

    int.InventoryItemRemove( "inv_torch3" );

  end;
  local use_torch3_beg = function ()

    ObjDelete( "obj_roaster3_use_torch3" );

  end;
  local use_torch3_end = function ()

    ObjDelete( "anm_roaster3_use_torch" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_torch3",     use_torch3_inv );
  cmn.AddSubscriber( "use_torch3",     use_torch3_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch3",     use_torch3_end, private.room_objname );
  cmn.AddSubscriber( "use_torch3_inv", use_torch3_inv, private.room_objname );
  cmn.AddSubscriber( "use_torch3_beg", use_torch3_beg, private.room_objname );
  cmn.AddSubscriber( "use_torch3_end", use_torch3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coals3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coals3" ] =
  {
    type = "use",
    use_obj = "inv_coals3",
    use_place = "obj_roaster3_use_coals3",
    room = private.room_objname,
    zz = "zz_roaster3",
    zz_gate = "gzz_tower3_roaster3"
  };
  --------------------------------------------------------------------------------------------
  local use_coals3_inv = function ()

    int.InventoryItemRemove( "inv_coals3" );

  end;
  local use_coals3_beg = function ()

    ObjDelete( "obj_roaster3_use_coals3" );

  end;
  local use_coals3_end = function ()

    ObjSet( "obj_roaster3_use_bellows3", { input = true } );

    ObjSet( "anm_roaster3_coal_fire", { alp = 1, playing = true } );
    ObjDelete( "anm_roaster3_use_coals" );

    ObjSet( "spr_tower3_coals",        { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coals3",     use_coals3_inv );
  cmn.AddSubscriber( "use_coals3",     use_coals3_beg, private.room_objname );
  cmn.AddSubscriber( "use_coals3",     use_coals3_end, private.room_objname );
  cmn.AddSubscriber( "use_coals3_inv", use_coals3_inv, private.room_objname );
  cmn.AddSubscriber( "use_coals3_beg", use_coals3_beg, private.room_objname );
  cmn.AddSubscriber( "use_coals3_end", use_coals3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bellows3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bellows3" ] =
  {
    type = "use",
    use_obj = "inv_bellows3",
    use_place = "obj_roaster3_use_bellows3",
    room = private.room_objname,
    zz = "zz_roaster3",
    zz_gate = "gzz_tower3_roaster3"
  };
  --------------------------------------------------------------------------------------------
  local use_bellows3_inv = function ()

    int.InventoryItemRemove( "inv_bellows3" );

  end;
  local use_bellows3_beg = function ()

    ObjDelete( "obj_roaster3_use_bellows3" );

  end;
  local use_bellows3_end = function ()

    ObjSet( "obj_roaster3_use_torch3", { input = true } );
    ObjDelete( "spr_tower3_coals" );
    ObjDelete( "spr_tower3_fire_light1" );

    ObjSet( "anm_tower3_roaster_fire", { alp = 1, playing = true } );
    ObjSet( "spr_tower3_fire_light2",  { active = true } );
    ObjDelete( "spr_tower3_rag" );
    ObjSet( "spr_tower3_rag_fire",     { alp = 1 } );

    ObjSet( "anm_roaster3_fire_static",{ alp = 1, playing = true } );
    ObjDelete( "anm_roaster3_coal_fire" );
    ObjDelete( "anm_roaster3_use_bellows" );

    ObjSet( "spr_roaster3_back_2",      { alp = 1 } );

    ObjSet( "spr_tower3_roaster_fire1", { alp = 1 } );
    ObjSet( "spr_tower3_fire_light1",   { alp = 1, active = true } );
    ObjSet( "spr_tower3_stones_fire",   { alp = 1 } );
    ObjSet( "spr_tower3_roaster_crack_fire", { alp = 1 } );
    ObjDelete( "spr_tower3_roaster_crack" );

    ObjSet( "spr_tower3_tree_2",        { alp = 1 } );
    ObjDelete( "spr_tower3_tree_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bellows3",     use_bellows3_inv );
  cmn.AddSubscriber( "use_bellows3",     use_bellows3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bellows3",     use_bellows3_end, private.room_objname );
  cmn.AddSubscriber( "use_bellows3_inv", use_bellows3_inv, private.room_objname );
  cmn.AddSubscriber( "use_bellows3_beg", use_bellows3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bellows3_end", use_bellows3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_propellentcharge3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_propellentcharge3" ] =
  {
    type = "use",
    use_obj = "inv_propellentcharge3",
    use_place = "obj_roaster3_use_propellentcharge3",
    room = private.room_objname,
    zz = "zz_roaster3",
    zz_gate = "gzz_tower3_roaster3"
  };
  --------------------------------------------------------------------------------------------
  local use_propellentcharge3_inv = function ()

    int.InventoryItemRemove( "inv_propellentcharge3" );

  end;
  local use_propellentcharge3_beg = function ()

    ObjDelete( "obj_roaster3_use_propellentcharge3" );

  end;
  local use_propellentcharge3_end = function ()

    ObjDelete( "obj_roaster3_niche_close" );
    ObjSet( "spr_roaster3_bluecylinder3",    { input = true } );
    ObjSet( "gfx_roaster3_bluecylinder3",    { active = true } );
    ObjSet( "spr_roaster3_amuletgorgon3", { input = true } );
    ObjSet( "gfx_roaster3_amuletgorgon3", { active = true } );

    ObjDelete( "spr_tower3_roaster_crack_fire" );
    ObjDelete( "anm_roaster3_use_bomb" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_propellentcharge3",     use_propellentcharge3_inv );
  cmn.AddSubscriber( "use_propellentcharge3",     use_propellentcharge3_beg, private.room_objname );
  cmn.AddSubscriber( "use_propellentcharge3",     use_propellentcharge3_end, private.room_objname );
  cmn.AddSubscriber( "use_propellentcharge3_inv", use_propellentcharge3_inv, private.room_objname );
  cmn.AddSubscriber( "use_propellentcharge3_beg", use_propellentcharge3_beg, private.room_objname );
  cmn.AddSubscriber( "use_propellentcharge3_end", use_propellentcharge3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_switchhandle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_switchhandle3" ] =
  {
    type = "use",
    use_obj = "inv_switchhandle3",
    use_place = "obj_armory3_use_switchhandle3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local use_switchhandle3_inv = function ()

    int.InventoryItemRemove( "inv_switchhandle3" );

  end;
  local use_switchhandle3_beg = function ()

    ObjDelete( "obj_armory3_use_switchhandle3" );

  end;
  local use_switchhandle3_end = function ()

    ObjSet( "anm_armory3_switchhandle",      { frame = 66, animfunc = "DoAnim" } );
    ObjSet( "obj_armory3_clk_switchhandle3", { input = true } );

    ObjSet( "spr_tower3_handle", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_switchhandle3",     use_switchhandle3_inv );
  cmn.AddSubscriber( "use_switchhandle3",     use_switchhandle3_beg, private.room_objname );
  cmn.AddSubscriber( "use_switchhandle3",     use_switchhandle3_end, private.room_objname );
  cmn.AddSubscriber( "use_switchhandle3_inv", use_switchhandle3_inv, private.room_objname );
  cmn.AddSubscriber( "use_switchhandle3_beg", use_switchhandle3_beg, private.room_objname );
  cmn.AddSubscriber( "use_switchhandle3_end", use_switchhandle3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_soldierfigurine3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_soldierfigurine3" ] =
  {
    type = "use",
    use_obj = "inv_soldierfigurine3",
    use_place = "obj_armory3_use_soldierfigurine3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local use_soldierfigurine3_inv = function ()

    int.InventoryItemRemove( "inv_soldierfigurine3" );

  end;
  local use_soldierfigurine3_beg = function ()

    ObjDelete( "obj_armory3_use_soldierfigurine3" );
    ObjDelete( "anm_armory3_door_2_click" );

  end;
  local use_soldierfigurine3_end = function ()

    ObjSet( "anm_armory3_door_2_open", { alp = 1, frame = 57, animfunc = "DoAnim" } );
    ObjSet( "spr_armory3_bullet3", { input = true } );
    ObjSet( "gfx_armory3_bullet3", { active = true } );

    ObjDelete( "spr_tower3_bullet_door_closed" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_soldierfigurine3",     use_soldierfigurine3_inv );
  cmn.AddSubscriber( "use_soldierfigurine3",     use_soldierfigurine3_beg, private.room_objname );
  cmn.AddSubscriber( "use_soldierfigurine3",     use_soldierfigurine3_end, private.room_objname );
  cmn.AddSubscriber( "use_soldierfigurine3_inv", use_soldierfigurine3_inv, private.room_objname );
  cmn.AddSubscriber( "use_soldierfigurine3_beg", use_soldierfigurine3_beg, private.room_objname );
  cmn.AddSubscriber( "use_soldierfigurine3_end", use_soldierfigurine3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_icarusfigurine3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_icarusfigurine3" ] =
  {
    type = "use",
    use_obj = "inv_icarusfigurine3",
    use_place = "obj_armory3_use_icarusfigurine3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local use_icarusfigurine3_inv = function ()

    int.InventoryItemRemove( "inv_icarusfigurine3" );

  end;
  local use_icarusfigurine3_beg = function ()

    ObjDelete( "obj_armory3_use_icarusfigurine3" );
    ObjDelete( "anm_armory3_door_1_click" );

  end;
  local use_icarusfigurine3_end = function ()

    ObjSet( "anm_armory3_door_1_open", { alp = 1, frame = 57, animfunc = "DoAnim" } );
    ObjSet( "spr_armory3_battery3",         { input = true } );
    ObjSet( "gfx_armory3_battery3",         { active = true } );
    ObjSet( "spr_armory3_disassembledgun3", { input = true } );
    ObjSet( "gfx_armory3_disassembledgun3", { active = true } );

    ObjSet( "spr_tower3_amuletangel_niche_open", { alp = 1 } );
    ObjDelete( "spr_tower3_armory_niche_closed" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_icarusfigurine3",     use_icarusfigurine3_inv );
  cmn.AddSubscriber( "use_icarusfigurine3",     use_icarusfigurine3_beg, private.room_objname );
  cmn.AddSubscriber( "use_icarusfigurine3",     use_icarusfigurine3_end, private.room_objname );
  cmn.AddSubscriber( "use_icarusfigurine3_inv", use_icarusfigurine3_inv, private.room_objname );
  cmn.AddSubscriber( "use_icarusfigurine3_beg", use_icarusfigurine3_beg, private.room_objname );
  cmn.AddSubscriber( "use_icarusfigurine3_end", use_icarusfigurine3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_jimmy3_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jimmy3_2" ] =
  {
    type = "use",
    use_obj = "inv_jimmy3",
    use_place = "obj_boxes3_use_jimmy3",
    room = private.room_objname,
    zz = "zz_boxes3",
    zz_gate = "gzz_tower3_boxes3"
  };
  --------------------------------------------------------------------------------------------
  local use_jimmy3_2_inv = function ()

    if cmn.IsEventDone( "use_jimmy3_1" ) and 
       cmn.IsEventDone( "use_jimmy3_3" ) then
      int.InventoryItemRemove( "inv_jimmy3" );
    end;

  end;
  local use_jimmy3_2_beg = function ()

    ObjDelete( "obj_boxes3_use_jimmy3" );

  end;
  local use_jimmy3_2_end = function ()

    ObjSet( "obj_boxes3_box_open", { input = true } );

    ObjSet( "gfx_boxes3_amuletmolecule3_1", { active = true } );
    ObjSet( "gfx_boxes3_mallet3", { active = true } );

    ObjDelete( "obj_boxes3_box_close" );


    ObjSet( "spr_tower3_cap_box2", { alp = 1 } );
    ObjDelete( "spr_tower3_cap_box" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jimmy3_2",     use_jimmy3_2_inv );
  cmn.AddSubscriber( "use_jimmy3_2",     use_jimmy3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_2",     use_jimmy3_2_end, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_2_inv", use_jimmy3_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_2_beg", use_jimmy3_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_jimmy3_2_end", use_jimmy3_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amulethypercube3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amulethypercube3" ] =
  {
    type = "use",
    use_obj = "inv_amulethypercube3",
    use_place = "obj_boxes3_use_amulethypercube3",
    room = private.room_objname,
    zz = "zz_boxes3",
    zz_gate = "gzz_tower3_boxes3"
  };
  --------------------------------------------------------------------------------------------
  local use_amulethypercube3_inv = function ()

    int.InventoryItemRemove( "inv_amulethypercube3" );

  end;
  local use_amulethypercube3_beg = function ()

    ObjDelete( "obj_boxes3_use_amulethypercube3" );

  end;
  local use_amulethypercube3_end = function ()

    ObjSet( "obj_boxes3_hypercube_open", { alp = 1, input = true } );
    ObjSet( "gfx_boxes3_disassembledlamp3", { active = true } );
    ObjSet( "gfx_boxes3_magnetizedhorseshoe3", { active = true } );
    ObjSet( "obj_boxes3_hypercube_1", { alp = 1 } );

    ObjSet( "spr_tower3_disassembledlamp", { alp = 1 } );
    ObjSet( "spr_tower3_disassembledlamp_slot", { alp = 1 } );
    ObjSet( "spr_tower3_hypercube", { alp = 1 } );
    ObjSet( "spr_tower3_magnetizedhorseshoe", { alp = 1 } );

    ObjDelete( "anm_boxes3_use_amulethypercube" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amulethypercube3",     use_amulethypercube3_inv );
  cmn.AddSubscriber( "use_amulethypercube3",     use_amulethypercube3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulethypercube3",     use_amulethypercube3_end, private.room_objname );
  cmn.AddSubscriber( "use_amulethypercube3_inv", use_amulethypercube3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amulethypercube3_beg", use_amulethypercube3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amulethypercube3_end", use_amulethypercube3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chargedgun3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chargedgun3" ] =
  {
    type = "use",
    use_obj = "inv_chargedgun3",
    use_place = "obj_tower3_use_chargedgun3",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local use_chargedgun3_inv = function ()

    int.InventoryItemRemove( "inv_chargedgun3" );

  end;
  local use_chargedgun3_beg = function ()

    ObjDelete( "obj_tower3_use_chargedgun3" );
    ObjDelete( "obj_tower3_chandelier1" );

  end;
  local use_chargedgun3_end = function ()

    ObjSet( "spr_tower3_facetedglass3", { alp = 1, input = true } );
    ObjSet( "gfx_tower3_facetedglass3", { active = true } );

    ObjSet( "obj_tower3_chandelier2", { alp = 1 } );
    ObjSet( "spr_tower3_facetedglass1_light", { active = true } );
    ObjDelete( "vid_tower3_gun" );
    ObjDelete( "vid_tower3_gun_light" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chargedgun3",     use_chargedgun3_inv );
  cmn.AddSubscriber( "use_chargedgun3",     use_chargedgun3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chargedgun3",     use_chargedgun3_end, private.room_objname );
  cmn.AddSubscriber( "use_chargedgun3_inv", use_chargedgun3_inv, private.room_objname );
  cmn.AddSubscriber( "use_chargedgun3_beg", use_chargedgun3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chargedgun3_end", use_chargedgun3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_switchhandle3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_switchhandle3" ] =
  {
    type = "click",
    clk_obj = "obj_armory3_clk_switchhandle3",
    room = private.room_objname,
    zz = "zz_armory3",
    zz_gate = "gzz_tower3_armory3"
  };
  --------------------------------------------------------------------------------------------
  local clk_switchhandle3_inv = function ()


  end;
  local clk_switchhandle3_beg = function ()

    ObjDelete( "obj_armory3_clk_switchhandle3" );
    ObjDelete( "anm_armory3_lattice_click" );
    ObjDelete( "anm_armory3_switchhandle" );

  end;
  local clk_switchhandle3_end = function ()

    ObjSet( "anm_armory3_lattice_open", { alp = 1, frame = 97, animfunc = "DoAnim" } );
    ObjSet( "anm_armory3_switchhandle_click", { alp = 1, frame = 66, animfunc = "DoAnim" } );

    ObjSet( "obj_armory3_use_soldierfigurine3", { input = true } );
    ObjSet( "obj_armory3_use_icarusfigurine3",  { input = true } );
    ObjSet( "spr_armory3_torch3",               { input = true } );
    ObjSet( "gfx_armory3_torch3",               { active = true } );
    ObjSet( "spr_armory3_amuletmolecule3_2",    { input = true } );
    ObjSet( "gfx_armory3_amuletmolecule3_2",    { active = true } );    

    ObjDelete( "spr_tower3_lattice_up" );
    ObjDelete( "spr_tower3_lattice_down" );
    ObjSet( "spr_tower3_lattice2_open", { alp = 1 } );
    ObjDelete( "spr_tower3_handle_groove" );
    ObjDelete( "spr_tower3_handle" );
    ObjSet( "spr_tower3_handle_down", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_switchhandle3",     clk_switchhandle3_inv );
  cmn.AddSubscriber( "clk_switchhandle3",     clk_switchhandle3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switchhandle3",     clk_switchhandle3_end, private.room_objname );
  cmn.AddSubscriber( "clk_switchhandle3_inv", clk_switchhandle3_inv, private.room_objname );
  cmn.AddSubscriber( "clk_switchhandle3_beg", clk_switchhandle3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switchhandle3_end", clk_switchhandle3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_tower3_emily3_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_tower3_emily3_1_beg = function ()

    ObjSet( "grm_tower3_towerroof3", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_tower3_towerroof3_focus");
    end;    
    ObjSet( "spr_tower3_towerroof_door_open", { alp = 1 } );
    ObjDelete( "anm_tower3_emily_loc_tower3" );
    ObjDelete( "obj_tower3_emily_bbt" );
    ObjDelete( "spr_tower3_towerroof_door_closed" );
    ObjDelete( "obj_tower3_towerroof_door" );        
    
  end;
  -----------------------------------------------
  local dlg_tower3_emily3_1_end = function ()

    ObjDelete( "dlg_tower3_emily3_1" );    

  end;

  cmn.AddSubscriber( "dlg_tower3_emily3_1",     dlg_tower3_emily3_1_beg );
  cmn.AddSubscriber( "dlg_tower3_emily3_1",     dlg_tower3_emily3_1_end );
  cmn.AddSubscriber( "dlg_tower3_emily3_1_beg", dlg_tower3_emily3_1_beg );
  cmn.AddSubscriber( "dlg_tower3_emily3_1_end", dlg_tower3_emily3_1_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_tower3_emily_stacy3_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_tower3_emily_stacy3_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_tower3_emily_stacy3_1_end = function ()

    ObjDelete( "dlg_tower3_emily_stacy3_1" );  
    ObjSet( "anm_tower3_emily_loc_tower3", { alp = 1, playing = true } );  
    ObjSet( "obj_tower3_emily_bbt", { input = true } );  

  end;

  cmn.AddSubscriber( "dlg_tower3_emily_stacy3_1",     dlg_tower3_emily_stacy3_1_beg );
  cmn.AddSubscriber( "dlg_tower3_emily_stacy3_1",     dlg_tower3_emily_stacy3_1_end );
  cmn.AddSubscriber( "dlg_tower3_emily_stacy3_1_beg", dlg_tower3_emily_stacy3_1_beg );
  cmn.AddSubscriber( "dlg_tower3_emily_stacy3_1_end", dlg_tower3_emily_stacy3_1_end );
  --------------------------------------------------------------------------------------------
  -- function win_labdoor3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_labdoor3" ] =
  {
    type = "click",
    clk_obj = "obj_labdoor3_mmg",
    room = private.room_objname,
    zz = "zz_labdoor3",
    zz_gate = "gzz_tower3_labdoor3"
  };
  --*********************************************************************************************************************
  local win_labdoor3_inv = function ()

    if ( cmn.IsEventDone( "win_labdoor3" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_labdoor3 = function ()

    if ( cmn.IsEventDone( "win_labdoor3" ) ) then

      ObjSet( "grm_tower3_lab3", { alp = 1, input = true, active = true } );  
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_tower3_lab3_focus");
      end;  
      ObjDelete( "gzz_tower3_labdoor3" );
      ObjDelete( "obj_labdoor3_mmg" );

      ObjSet( "spr_tower3_open_door", { alp = 1 } ); 
      ObjDelete( "spr_tower3_labdoor_mmg" );

    else 

      private.Labdoor3Load();

    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_labdoor3", win_labdoor3_inv );
  cmn.AddSubscriber( "win_labdoor3", win_labdoor3, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************  
function private.get_screensaver_2_13()

  int.AddScreensaver( "spr_stuff3_screensaver_2_13" );

end;    
function private.get_screensaver_2_14()

  int.AddScreensaver( "spr_boxes3_screensaver_2_14" );

end;
-----------------------------------------------------------------------
function private.get_collect_3_3 ()

  int.AddCollectibles( "spr_tower3_collect_3_3" );

end;
-----------------------------------------------------------------------
function private.get_blacksmithfigurine3_1 ()

  cmn.SetEventDone( "get_blacksmithfigurine3_1" );
  cmn.CallEventHandler( "get_blacksmithfigurine3_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_hexagram3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_hexagram3_2 ()

  cmn.SetEventDone( "get_hexagram3_2" );
  cmn.CallEventHandler( "get_hexagram3_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_blacksmithfigurine3_1" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amuletgorgon3 ()

  cmn.SetEventDone( "get_amuletgorgon3" );
  cmn.CallEventHandler( "get_amuletgorgon3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_bluecylinder3" ) ) and
     ( cmn.IsEventDone( "get_amuletgorgon3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_burningtorch3 ()

  cmn.SetEventDone( "get_burningtorch3" );
  cmn.CallEventHandler( "get_burningtorch3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amuletmolecule3_1 ()

  cmn.SetEventDone( "get_amuletmolecule3_1" );
  cmn.CallEventHandler( "get_amuletmolecule3_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_disassembledlamp3" ) and 
     cmn.IsEventDone( "get_magnetizedhorseshoe3" ) and 
     cmn.IsEventDone( "get_mallet3" ) and 
     cmn.IsEventDone( "get_blacksmithfigurine3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_bluecylinder3 ()

  cmn.SetEventDone( "get_bluecylinder3" );
  cmn.CallEventHandler( "get_bluecylinder3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_bluecylinder3" ) ) and
     ( cmn.IsEventDone( "get_amuletgorgon3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_blacksmithfigurine3_3 ()

  cmn.SetEventDone( "get_blacksmithfigurine3_3" );
  cmn.CallEventHandler( "get_blacksmithfigurine3_3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_torch3" ) ) and
     ( cmn.IsEventDone( "get_bullet3" ) ) and
     ( cmn.IsEventDone( "get_battery3" ) ) and
     ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
     ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_torch3 ()

  cmn.SetEventDone( "get_torch3" );
  cmn.CallEventHandler( "get_torch3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_torch3" ) ) and
     ( cmn.IsEventDone( "get_bullet3" ) ) and
     ( cmn.IsEventDone( "get_battery3" ) ) and
     ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
     ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_bullet3 ()

  cmn.SetEventDone( "get_bullet3" );
  cmn.CallEventHandler( "get_bullet3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_torch3" ) ) and
     ( cmn.IsEventDone( "get_bullet3" ) ) and
     ( cmn.IsEventDone( "get_battery3" ) ) and
     ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
     ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_mallet3 ()

  cmn.SetEventDone( "get_mallet3" );
  cmn.CallEventHandler( "get_mallet3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_disassembledlamp3" ) and 
     cmn.IsEventDone( "get_magnetizedhorseshoe3" ) and 
     cmn.IsEventDone( "get_amuletmolecule3_1" ) and 
     cmn.IsEventDone( "get_blacksmithfigurine3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_blacksmithfigurine3_2 ()

  cmn.SetEventDone( "get_blacksmithfigurine3_2" );
  cmn.CallEventHandler( "get_blacksmithfigurine3_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_disassembledlamp3" ) and 
     cmn.IsEventDone( "get_magnetizedhorseshoe3" ) and 
     cmn.IsEventDone( "get_amuletmolecule3_1" ) and 
     cmn.IsEventDone( "get_mallet3" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_amuletomega3_1 ()

  cmn.SetEventDone( "get_amuletomega3_1" );
  cmn.CallEventHandler( "get_amuletomega3_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_switchhandle3 ()

  cmn.SetEventDone( "get_switchhandle3" );
  cmn.CallEventHandler( "get_switchhandle3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amuletmolecule3_2 ()

  cmn.SetEventDone( "get_amuletmolecule3_2" );
  cmn.CallEventHandler( "get_amuletmolecule3_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_disassembledlamp3 ()

  cmn.SetEventDone( "get_disassembledlamp3" );
  cmn.CallEventHandler( "get_disassembledlamp3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_magnetizedhorseshoe3" ) and 
     cmn.IsEventDone( "get_amuletmolecule3_1" ) and 
     cmn.IsEventDone( "get_mallet3" ) and 
     cmn.IsEventDone( "get_blacksmithfigurine3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_magnetizedhorseshoe3 ()

  cmn.SetEventDone( "get_magnetizedhorseshoe3" );
  cmn.CallEventHandler( "get_magnetizedhorseshoe3" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_disassembledlamp3" ) and 
     cmn.IsEventDone( "get_amuletmolecule3_1" ) and 
     cmn.IsEventDone( "get_mallet3" ) and 
     cmn.IsEventDone( "get_blacksmithfigurine3_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_facetedglass3 ()

  cmn.SetEventDone( "get_facetedglass3" );
  cmn.CallEventHandler( "get_facetedglass3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_battery3 ()

  cmn.SetEventDone( "get_battery3" );
  cmn.CallEventHandler( "get_battery3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_torch3" ) ) and
     ( cmn.IsEventDone( "get_bullet3" ) ) and
     ( cmn.IsEventDone( "get_battery3" ) ) and
     ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
     ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_disassembledgun3 ()

  cmn.SetEventDone( "get_disassembledgun3" );
  cmn.CallEventHandler( "get_disassembledgun3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_torch3" ) ) and
     ( cmn.IsEventDone( "get_bullet3" ) ) and
     ( cmn.IsEventDone( "get_battery3" ) ) and
     ( cmn.IsEventDone( "get_disassembledgun3" ) ) and
     ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
function public.use_blacksmithfigurine3 ()

  local item = "inv_blacksmithfigurine3";

  if ( cmn.ApplyObj( item, "gzz_tower3_labdoor3", false ) ) and
     ( not cmn.IsEventDone( "use_blacksmithfigurine3" ) ) and
     ( cmn.IsEventDone( "get_blacksmithfigurine3_1" ) ) and
     ( cmn.IsEventDone( "get_blacksmithfigurine3_2" ) ) and
     ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_labdoor3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_labdoor3_use_blacksmithfigurine3", true ) ) and
         ( not cmn.IsEventDone( "use_blacksmithfigurine3" ) ) and
         ( cmn.IsEventDone( "get_blacksmithfigurine3_1" ) ) and
         ( cmn.IsEventDone( "get_blacksmithfigurine3_2" ) ) and
         ( cmn.IsEventDone( "get_blacksmithfigurine3_3" ) ) then

    cmn.CallEventHandler( "use_blacksmithfigurine3_inv" );
    cmn.CallEventHandler( "use_blacksmithfigurine3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_blacksmithfigurine3" );
      cmn.CallEventHandler( "use_blacksmithfigurine3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_labdoor3_blacksmithfigurine", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_labdoor3_insert_stuffs_right_down" );
    AnimPlay( "anm_labdoor3_blacksmithfigurine", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletmolecule3 ()

  local item = "inv_amuletmolecule3";

  if ( cmn.ApplyObj( item, "gzz_tower3_labdoor3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletmolecule3" ) ) and
     ( cmn.IsEventDone( "get_amuletmolecule3_1" ) ) and
     ( cmn.IsEventDone( "get_amuletmolecule3_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_labdoor3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_labdoor3_use_amuletmolecule3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletmolecule3" ) ) and
         ( cmn.IsEventDone( "get_amuletmolecule3_1" ) ) and
         ( cmn.IsEventDone( "get_amuletmolecule3_2" ) ) then

    cmn.CallEventHandler( "use_amuletmolecule3_inv" );
    cmn.CallEventHandler( "use_amuletmolecule3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletmolecule3" );
      cmn.CallEventHandler( "use_amuletmolecule3_end" );
      private.Labdoor3Start();

    end;

    int.Lock( true );

    ObjSet( "anm_labdoor3_amuletmolecule", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_formules" );
    AnimPlay( "anm_labdoor3_amuletmolecule", "DoAnim",
    function ()

      ObjAnimate( "obj_labdoor3_mmg", "pos_y", 0, 0, "",
      {
        0.0, 3, -140,
        0.5, 3, -55,
      } );

      ObjAnimate( "obj_labdoor3_mmg", "scale_xy", 0, 0, func_end,
      {
        0.0, 3, 0.0, 0.0,
        0.5, 3, 1.0, 1.0,
      } );

      ObjAnimate( "obj_labdoor3_mmg", "alp", 0, 0, "",
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_chisel3 ()

  local item = "inv_chisel3";

  if ( cmn.ApplyObj( item, "gzz_tower3_stuff3", false ) ) and
     ( not cmn.IsEventDone( "use_chisel3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stuff3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stuff3_use_chisel3", true ) ) and
         ( not cmn.IsEventDone( "use_chisel3" ) ) then

    cmn.CallEventHandler( "use_chisel3_inv" );
    cmn.CallEventHandler( "use_chisel3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_chisel3" );
      cmn.CallEventHandler( "use_chisel3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_stuff3_use_chisel", { alp = 1 } );
    ObjSet( "anm_stuff3_click_egg", { alp = 0 } );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_stuff3_insert_lamp" );
    AnimPlay( "anm_stuff3_use_chisel", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_mallet3 ()

  local item = "inv_mallet3";

  if ( cmn.ApplyObj( item, "gzz_tower3_stuff3", false ) ) and
     ( not cmn.IsEventDone( "use_mallet3" ) ) and 
       cmn.IsEventDone( "use_chisel3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stuff3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stuff3_use_mallet3", true ) ) and
         ( not cmn.IsEventDone( "use_mallet3" ) ) and 
           cmn.IsEventDone( "use_chisel3" ) then

    cmn.CallEventHandler( "use_mallet3_inv" );
    cmn.CallEventHandler( "use_mallet3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mallet3" );
      cmn.CallEventHandler( "use_mallet3_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_stuff3_use_mallet", { alp = 1 } );
    ObjSet( "anm_stuff3_use_chisel", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_stuff3_hit_hammer" );
    AnimPlay( "anm_stuff3_use_mallet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_torch3 ()

  local item = "inv_torch3";

  if ( cmn.ApplyObj( item, "gzz_tower3_roaster3", false ) ) and
     ( not cmn.IsEventDone( "use_torch3" ) ) and
     ( cmn.IsEventDone( "use_bellows3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roaster3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roaster3_use_torch3", true ) ) and
         ( not cmn.IsEventDone( "use_torch3" ) ) and
         ( cmn.IsEventDone( "use_bellows3" ) ) then

    cmn.CallEventHandler( "use_torch3_inv" );
    cmn.CallEventHandler( "use_torch3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_torch3" );
      cmn.CallEventHandler( "use_torch3_end" );
      private.get_burningtorch3();

    end;

    int.Lock( true );

    ObjSet( "anm_roaster3_use_torch", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_roaster3_fire_tourch" );
    AnimPlay( "anm_roaster3_use_torch", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_coals3 ()

  local item = "inv_coals3";

  if ( cmn.ApplyObj( item, "gzz_tower3_roaster3", false ) ) and
     ( not cmn.IsEventDone( "use_coals3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roaster3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roaster3_use_coals3", true ) ) and
         ( not cmn.IsEventDone( "use_coals3" ) ) then

    cmn.CallEventHandler( "use_coals3_inv" );
    cmn.CallEventHandler( "use_coals3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_coals3" );
      cmn.CallEventHandler( "use_coals3_end" );

    end;

    int.Lock( true );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_roaster3_put_coals" );
    AnimPlay( "anm_roaster3_use_coals", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_bellows3 ()

  local item = "inv_bellows3";

  if ( cmn.ApplyObj( item, "gzz_tower3_roaster3", false ) ) and
     ( not cmn.IsEventDone( "use_bellows3" ) ) and
     ( cmn.IsEventDone( "use_coals3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roaster3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roaster3_use_bellows3", true ) ) and
         ( not cmn.IsEventDone( "use_bellows3" ) ) and
         ( cmn.IsEventDone( "use_coals3" ) ) then

    cmn.CallEventHandler( "use_bellows3_inv" );
    cmn.CallEventHandler( "use_bellows3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_bellows3" );
      cmn.CallEventHandler( "use_bellows3_end" );
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_roaster3_loop_env", 1 );

    end;

    int.Lock( true );

    ObjSet( "anm_roaster3_coal_fire", { alp = 0 } );
    ObjSet( "anm_roaster3_use_bellows", { alp = 1 } );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_roaster3_press_coals" );
    AnimPlay( "anm_roaster3_use_bellows", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_propellentcharge3 ()

  local item = "inv_propellentcharge3";

  if ( cmn.ApplyObj( item, "gzz_tower3_roaster3", false ) ) and
     ( not cmn.IsEventDone( "use_propellentcharge3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_roaster3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_roaster3_use_propellentcharge3", true ) ) and
         ( not cmn.IsEventDone( "use_propellentcharge3" ) ) then

    cmn.CallEventHandler( "use_propellentcharge3_inv" );
    cmn.CallEventHandler( "use_propellentcharge3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_propellentcharge3" );
      cmn.CallEventHandler( "use_propellentcharge3_end" );

    end;

    int.Lock( true );

    ObjSet( "obj_roaster3_niche_close", { alp = 0 } );
    ObjSet( "anm_roaster3_use_bomb", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_dynamite_boom" );
    AnimPlay( "anm_roaster3_use_bomb", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_switchhandle3 ()

  local item = "inv_switchhandle3";

  if ( cmn.ApplyObj( item, "gzz_tower3_armory3", false ) ) and
     ( not cmn.IsEventDone( "use_switchhandle3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armory3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_armory3_use_switchhandle3", true ) ) and
         ( not cmn.IsEventDone( "use_switchhandle3" ) ) then

    cmn.CallEventHandler( "use_switchhandle3_inv" );
    cmn.CallEventHandler( "use_switchhandle3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_switchhandle3" );
      cmn.CallEventHandler( "use_switchhandle3_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_insert_arm_cell" );
    AnimPlay( "anm_armory3_switchhandle", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_soldierfigurine3 ()

  local item = "inv_soldierfigurine3";

  if ( cmn.ApplyObj( item, "gzz_tower3_armory3", false ) ) and
     ( not cmn.IsEventDone( "use_soldierfigurine3" ) ) and
     ( cmn.IsEventDone( "clk_switchhandle3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armory3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_armory3_use_soldierfigurine3", true ) ) and
         ( not cmn.IsEventDone( "use_soldierfigurine3" ) ) and
         ( cmn.IsEventDone( "clk_switchhandle3" ) ) then

    cmn.CallEventHandler( "use_soldierfigurine3_inv" );
    cmn.CallEventHandler( "use_soldierfigurine3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_soldierfigurine3" );
      cmn.CallEventHandler( "use_soldierfigurine3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_armory3_door_2_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_armory3_insert_down" );
    AnimPlay( "anm_armory3_door_2_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_icarusfigurine3 ()

  local item = "inv_icarusfigurine3";

  if ( cmn.ApplyObj( item, "gzz_tower3_armory3", false ) ) and
     ( not cmn.IsEventDone( "use_icarusfigurine3" ) ) and
     ( cmn.IsEventDone( "clk_switchhandle3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_armory3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_armory3_use_icarusfigurine3", true ) ) and
         ( not cmn.IsEventDone( "use_icarusfigurine3" ) ) and
         ( cmn.IsEventDone( "clk_switchhandle3" ) ) then

    cmn.CallEventHandler( "use_icarusfigurine3_inv" );
    cmn.CallEventHandler( "use_icarusfigurine3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_icarusfigurine3" );
      cmn.CallEventHandler( "use_icarusfigurine3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_armory3_door_1_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_armory3_insert_up" );
    AnimPlay( "anm_armory3_door_1_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_jimmy3_2 ()

  local item = "inv_jimmy3";

  if ( cmn.ApplyObj( item, "gzz_tower3_boxes3", false ) ) and
     ( not cmn.IsEventDone( "use_jimmy3_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes3", nil, { 512, 384 }, true );;

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes3_use_jimmy3", true ) ) and
         ( not cmn.IsEventDone( "use_jimmy3_2" ) ) then

    cmn.CallEventHandler( "use_jimmy3_2_inv" );
    cmn.CallEventHandler( "use_jimmy3_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_jimmy3_2" );
      cmn.CallEventHandler( "use_jimmy3_2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_boxes3_woodbox_click", { alp = 0 } );
    ObjSet( "anm_boxes3_use_jimmy", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_broke_zz_boxes3" );
    AnimPlay( "anm_boxes3_use_jimmy", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amulethypercube3 ()

  local item = "inv_amulethypercube3";

  if ( cmn.ApplyObj( item, "gzz_tower3_boxes3", false ) ) and
     ( not cmn.IsEventDone( "use_amulethypercube3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boxes3", nil, { 512, 384 }, true );;

    return true;

  elseif ( cmn.ApplyObj( item, "obj_boxes3_use_amulethypercube3", true ) ) and
         ( not cmn.IsEventDone( "use_amulethypercube3" ) ) then

    cmn.CallEventHandler( "use_amulethypercube3_inv" );
    cmn.CallEventHandler( "use_amulethypercube3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amulethypercube3" );
      cmn.CallEventHandler( "use_amulethypercube3_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_boxes3_use_amulethypercube", { croprect_init = true } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_boxes3_insert_cube" );
    AnimPlay( "anm_boxes3_use_amulethypercube", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_chargedgun3 ()

  local item = "inv_chargedgun3";

  if ( cmn.ApplyObj( item, "obj_tower3_use_chargedgun3", true ) ) and
     ( not cmn.IsEventDone( "use_chargedgun3" ) ) then

    cmn.CallEventHandler( "use_chargedgun3_inv" );
    cmn.CallEventHandler( "use_chargedgun3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_chargedgun3" );
      cmn.CallEventHandler( "use_chargedgun3_end" );

    end;

    int.Lock( true );

    ObjSet( "vid_tower3_gun",       { alp = 1 } );
    ObjSet( "vid_tower3_gun_light", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_loc_gun_shot" );
    VidPlay( "vid_tower3_gun", func_end );
    VidPlay( "vid_tower3_gun_light", "" );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.clk_switchhandle3 ()

  cmn.CallEventHandler( "clk_switchhandle3_inv" );
  cmn.CallEventHandler( "clk_switchhandle3_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_switchhandle3" );
    cmn.CallEventHandler( "clk_switchhandle3_end" );

  end;

  int.Lock( true );

  ObjSet( "anm_armory3_lattice_open", { alp = 1 } );
  ObjSet( "anm_armory3_switchhandle_click", { alp = 1 } );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_click_arm_open_gates" );

  AnimPlay( "anm_armory3_switchhandle_click", "DoAnim",
  function ()

    AnimPlay( "anm_armory3_lattice_open", "DoAnim", func_end );

  end );

end;
--*********************************************************************************************************************
function public.dlg_tower3_emily3_1 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_amuletrainbow3" );
    cmn.GetObjectSfx();

    ObjSet( "anm_tower3_emily3_1_emily_static_1", { alp = 0 } );
    ObjSet( "anm_tower3_emily3_1_emily_static_2", { alp = 0 } );

    AnimStop( "anm_tower3_emily3_1_emily_static_1" );
    AnimStop( "anm_tower3_emily3_1_emily_static_2" );

    ObjAnimate( "anm_tower3_emily3_1_emily_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );

    if ( func_end ) then

      func_end();

    end;

    cmn.SetEventDone( "get_amuletrainbow3" );
    cmn.SetEventDone( "dlg_tower3_emily3_1" );
    --cmn.ShowBbt( "bbt_tower3_after_dlg_emily" );

    interface.KeyTaskDone( true, "task_3_5" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_tower3_emily3_1_emily_static_1", "DoAnim", "" );

    common_impl.dialog_character_loc = "anm_towerroof3_emily";
    common_impl.DialogCharacterStart( "emily3_1", "tower3", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_tower3_emily3_1_beg" );
  ObjAttach( "dlg_tower3_emily3_1", GetCurrentRoom() );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_tower3_emily3_1_emily_static_1", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.dlg_tower3_emily_stacy3_1 ()

  local func_end = function ()

    cmn.SetEventDone( "beg_level3" );
    cmn.SetEventDone( "get_jimmy3" );
    cmn.SetEventDone( "get_richardskull3" );
    cmn.CallEventHandler( "get_jimmy3" );
    cmn.CallEventHandler( "get_richardskull3" );    
    cmn.SetEventDone( "dlg_tower3_emily_stacy3_1" );
    ObjSet( "anm_tower3_emily_loc_tower3", { alp = 1, playing = true } );
    ObjSet( "obj_tower3_emily_bbt", { input = true } ); 
    private.func_stacy_away();

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_tower3_emily_stacy3_1_emily_static", "DoAnim", "" );
    AnimPlay( "anm_tower3_emily_stacy3_1_stacy_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "emily_stacy3_1", "tower3", 3, nil, nil, true, func_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_tower3_emily_stacy3_1_beg" );
  ObjAttach( "dlg_tower3_emily_stacy3_1", GetCurrentRoom() );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_tower3_emily_stacy3_1_emily_static", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

  ObjAnimate( "anm_tower3_emily_stacy3_1_stacy_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "emily3_1" ) then

    if ( count_txt == 2 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_tower3_emily3_1_emily_static_1" );
        AnimPlay( "anm_tower3_emily3_1_emily_static_2", "DoAnim", "" );

      end;

      ObjAnimate( "anm_tower3_emily3_1_emily_static_1", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_tower3_emily3_1_emily_static_2", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    elseif ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_tower3_emily3_1_emily_static_2" );
        AnimPlay( "anm_tower3_emily3_1_emily_give", "DoAnim", "" );

      end;

      ObjAnimate( "anm_tower3_emily3_1_emily_static_2", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_tower3_emily3_1_emily_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.func_stacy_away ()

  local func_stacy_away_end = function ()
    
    int.Lock( false );
    cmn.SetEventDone( "opn_tower3" );
    --cmn.ShowBbt( "bbt_tower3_first_enter" );    

--    ObjAnimate( "rm_tower3", "scale_xy", 0, 0, "",
--    {
--      0.0, 3, 1.0, 1.0,
--      0.5, 3, 1.4, 1.4,
--      1.5, 3, 1.4, 1.4,
--      2.0, 3, 1.0, 1.0,
--    } );
--
--    ObjAnimate( "rm_tower3", "pos_x", 0, 0,
--    function ()
--
--
--
--    end,
--    {
--      0.0, 3,    0,
--      0.5, 3, -360,
--      1.5, 3, -360,
--      2.0, 3,    0,
--    } );

    interface.KeyTaskAdd( "task_3_1", true );

  end;

  int.Lock( true );

  ObjAnimate( "anm_tower3_stacy_away_fromtower", "alp", 0, 0,
  function ()

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_stasy_goes_other_loc_1" );
    AnimPlay( "anm_tower3_stacy_away_fromtower", "DoAnim", func_stacy_away_end );

  end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.opn_tower3 ()
  


  if ( not cmn.IsEventDone( "dlg_tower3_emily_stacy3_1" ) ) then

    private.dlg_tower3_emily_stacy3_1();

  end;

  if ( not cmn.IsEventDone( "opn_tower3" ) )  and 
           cmn.IsEventDone( "dlg_tower3_emily_stacy3_1" )  then

    cmn.SetEventDone( "opn_neartower3" );       
    cmn.SetEventDone( "opn_shore3" );       
    cmn.SetEventDone( "opn_workshop3" );           
    int.VisitMapRoom( "rm_neartower3" );
    int.VisitMapRoom( "rm_shore3" );
    int.VisitMapRoom( "rm_workshop3" );  
    int.VisitMapRoom( "rm_tower3" );             
             
    private.func_stacy_away();

  end;

  cmn.StopAllEnv( "audio/level3/env/aud_rm_tower3_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_tower3_env", 1 );

  if ( cmn.IsEventDone( "win_generator3" ) ) and
     not ( cmn.IsEventDone( "win_mgcrowd3" ) ) and
     not ( ng_global.progress[ ng_global.currentprogress ][ "opn_tower3" ].window ) then

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_rm_tower3_throw_stone_1" );
    AnimPlay( "anm_tower3_break_window", "DoAnim",
    function ()

      ng_global.progress[ ng_global.currentprogress ][ "opn_tower3" ].window = true;

      int.Lock( false );

      ObjSet( "anm_tower3_break_window",
      {
        res = "assets/levels/level3/rm_tower3/anims/anm_break_static",
        animfunc = "DoAnim",
        playing = true,
      } );

    end );

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  if ( cmn.IsEventDone( "use_gear3" ) ) and
     ( cmn.IsEventDone( "use_card3" ) ) then
  
    ObjSet( "spr_tower3_towerroof_door_open", { alp = 1 } );
    ObjDelete( "spr_tower3_towerroof_door_closed" );
  
  end;

  if ( ng_global.progress[ ng_global.currentprogress ][ "opn_tower3" ].window ) then

    ObjSet( "anm_tower3_break_window",
    {
      res = "assets/levels/level3/rm_tower3/anims/anm_break_static",
      animfunc = "DoAnim",
      playing = true,
    } );

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventDone( "opn_tower3" ) )  then

    cmn.SetEventDone( "opn_neartower3" );       
    cmn.SetEventDone( "opn_shore3" );       
    cmn.SetEventDone( "opn_workshop3" );           
    int.VisitMapRoom( "rm_neartower3" );
    int.VisitMapRoom( "rm_shore3" );
    int.VisitMapRoom( "rm_workshop3" );  
    int.VisitMapRoom( "rm_tower3" );             


  end;  
  
  private.opn_tower3();

end;
--*********************************************************************************************************************
function private.IntroLvl3( func_stacy_away )

  local func_end = function ( skip )

    cmn.SetEventDone( "beg_level3" );
    cmn.SetEventDone( "get_jimmy3" );
    cmn.SetEventDone( "get_richardskull3" );
    cmn.CallEventHandler( "get_jimmy3" );
    cmn.CallEventHandler( "get_richardskull3" );

    ObjSet( "rm_tower3", { color_r = 1, color_g = 1, color_b = 1 } );

    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_prison2_intro_voc" );
      --cmn.StopAudio( "mus", "audio/level1/mus/aud_rm_prison2_vid_mus" );
    end;

    --cmn.PlayAudio( "env", "audio/level1/env/aud_rm_prison2_env", 1 );
    --cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );

    func_stacy_away();

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_tower3_intro", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_prison2_intro_voc" );
  --cmn.PlayAudio( "mus", "audio/level1/mus/aud_rm_prison2_vid_mus", nil, nil, 34 );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_amuletrainbow3",                                     { "dlg_tower3_emily3_1" } );
  int.AddedTaskMap( private.room_objname, "get_blacksmithfigurine3_1",                              { "dlg_tower3_emily_stacy3_1" } );
  int.AddedTaskMap( private.room_objname, "get_hexagram3_2",                                        { "use_mallet3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletgorgon3",                                      { "use_propellentcharge3" } );
  int.AddedTaskMap( private.room_objname, "get_burningtorch3",                                      { "use_torch3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletmolecule3_2",                                  { "clk_switchhandle3" } );
  int.AddedTaskMap( private.room_objname, "get_bluecylinder3",                                      { "use_propellentcharge3" } );
  int.AddedTaskMap( private.room_objname, "get_blacksmithfigurine3_3" );
  int.AddedTaskMap( private.room_objname, "get_torch3",                                             { "clk_switchhandle3" } );
  int.AddedTaskMap( private.room_objname, "get_bullet3",                                            { "use_soldierfigurine3" } );
  int.AddedTaskMap( private.room_objname, "get_mallet3",                                            { "use_jimmy3_2" } );
  int.AddedTaskMap( private.room_objname, "get_blacksmithfigurine3_2" );
  int.AddedTaskMap( private.room_objname, "get_amuletomega3_1",                                     { "use_blacksmithfigurine3" } );
  int.AddedTaskMap( private.room_objname, "get_switchhandle3",                                      { "use_blacksmithfigurine3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletmolecule3_1",                                  { "use_jimmy3_2" } );
  int.AddedTaskMap( private.room_objname, "get_disassembledlamp3",                                  { "use_amulethypercube3" } );
  int.AddedTaskMap( private.room_objname, "get_magnetizedhorseshoe3",                               { "use_amulethypercube3" } );
  int.AddedTaskMap( private.room_objname, "get_facetedglass3",                                      { "use_chargedgun3" } );
  int.AddedTaskMap( private.room_objname, "get_battery3",                                           { "use_icarusfigurine3" } );
  int.AddedTaskMap( private.room_objname, "get_disassembledgun3",                                   { "use_icarusfigurine3" } );

  int.AddedTaskMap( private.room_objname, "use_blacksmithfigurine3",                                { "get_blacksmithfigurine3_1", "get_blacksmithfigurine3_2", "get_blacksmithfigurine3_3" } );
  int.AddedTaskMap( private.room_objname, "use_amuletmolecule3",                                    { "get_amuletmolecule3_1", "get_amuletmolecule3_2" } );
  int.AddedTaskMap( private.room_objname, "use_chisel3",                                            { "get_chisel3" } );
  int.AddedTaskMap( private.room_objname, "use_mallet3",                                            { "get_mallet3", "use_chisel3" } );
  int.AddedTaskMap( private.room_objname, "use_torch3",                                             { "get_torch3", "use_bellows3" } );
  int.AddedTaskMap( private.room_objname, "use_coals3",                                             { "get_coals3" } );
  int.AddedTaskMap( private.room_objname, "use_bellows3",                                           { "get_bellows3", "use_coals3" } );
  int.AddedTaskMap( private.room_objname, "use_propellentcharge3",                                  { "get_propellentcharge3" } );
  int.AddedTaskMap( private.room_objname, "use_switchhandle3",                                      { "get_switchhandle3" } );
  int.AddedTaskMap( private.room_objname, "use_soldierfigurine3",                                   { "get_soldierfigurine3", "clk_switchhandle3" } );
  int.AddedTaskMap( private.room_objname, "use_icarusfigurine3",                                    { "get_icarusfigurine3", "clk_switchhandle3" } );
  int.AddedTaskMap( private.room_objname, "use_amulethypercube3",                                   { "get_amulethypercube3" } );
  int.AddedTaskMap( private.room_objname, "use_chargedgun3",                                        { "get_chargedgun3" } );
  int.AddedTaskMap( private.room_objname, "use_jimmy3_2" );

  int.AddedTaskMap( private.room_objname, "clk_switchhandle3",                                      { "use_switchhandle3" } );

  int.AddedTaskMap( private.room_objname, "dlg_tower3_emily3_1",                                    { "use_card3" } );
  int.AddedTaskMap( private.room_objname, "dlg_tower3_emily_stacy3_1" );

  int.AddedTaskMap( private.room_objname, "win_labdoor3",                                           { "use_amuletmolecule3" } );

  int.AddedTaskMap( private.room_objname, "opn_lab3",                                               { "win_labdoor3" } );
  int.AddedTaskMap( private.room_objname, "opn_towerroof3",                                         { "get_amuletrainbow3" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_labdoor3" );
  subroom.Define( "zz_roaster3" );
  -------------------------------------------------
  function zz_roaster3.Open()

    if cmn.IsEventDone( "use_bellows3" ) then
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_roaster3_loop_env", 1 );
    end;

  end; 
  -------------------------------------------------
  function zz_roaster3.Close()

    if cmn.IsEventDone( "use_bellows3" ) then
      cmn.StopAudio( "sfx", "audio/level3/sfx/aud_zz_roaster3_loop_env", 0.5 );
    end;

  end; 
  -------------------------------------------------
  function zz_labdoor3.Open()
    
    if ( cmn.IsEventStart( "win_labdoor3" ) and not cmn.IsEventDone( "win_labdoor3" ) ) then

      cmn.MiniGameShow( "labdoor3" );
      common_impl.PassingMgStart( "labdoor3" );

    end;

  end;
  -------------------------------------------------
  function zz_labdoor3.PreClose()
        
    if ( cmn.IsEventStart( "win_labdoor3" ) and not cmn.IsEventDone( "win_labdoor3" ) ) then

      cmn.MiniGameHide( "labdoor3" );
      common_impl.PassingMgStop( "labdoor3" );

    end;
    
  end;
  -------------------------------------------------
  function zz_labdoor3.Skip ()

    if ( cmn.IsEventStart( "win_labdoor3" ) and not cmn.IsEventDone( "win_labdoor3" ) ) then

      private.Labdoor3Skip();

    end;

  end;
  -------------------------------------------------
  function zz_labdoor3.Reset ()

    if ( cmn.IsEventStart( "win_labdoor3" ) and not cmn.IsEventDone( "win_labdoor3" ) ) then

      private.Labdoor3Reset();

    end;

  end;
  -------------------------------------------------
  function zz_labdoor3.Close ()

    cmn.NoteScaleEnd( { "spr_labdoor3_note" }, true );

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_boxes3_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1,
  } );
  ObjAnimate( "obj_tower3_chandelier1", "ang", 1, 0, "", 
  { 
    0.0, 3, -0.03,
    2.0, 3, 0.03,
    4.0, 3, -0.03,
  } );
  ObjAnimate( "spr_tower3_facetedglass1_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1,
  } );
  ObjAnimate( "spr_tower3_facetedglass2_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1,
  } );
  ObjAnimate( "spr_tower3_fire_light1", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1,
  } );
  ObjAnimate( "spr_tower3_fire_light2", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.5, 0, 0.5,
    3.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.Armory3Door1Click ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_armory3_use_icarusfigurine3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_armory3_up" );
  AnimPlay( "anm_armory3_door_1_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Armory3Door2Click ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_armory3_use_soldierfigurine3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_armory3_down" );
  AnimPlay( "anm_armory3_door_2_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Armory3Lattice2Click ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_armory3_use_switchhandle3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_closed_gates_zz_armory3" );
  AnimPlay( "anm_armory3_lattice_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Stuff3EggClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_stuff3_use_chisel3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_stuff_like_lamp" );
  AnimPlay( "anm_stuff3_click_egg", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Boxes3Clk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_boxes3_use_jimmy3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_broken_zz_boxes3" );
  AnimPlay( "anm_boxes3_woodbox_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Roaster3StoneClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_roaster3_use_propellentcharge3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_stones_in_wall" );
  AnimPlay( "anm_roaster3_stone_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Labdoor3BoxClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_labdoor3_use_blacksmithfigurine3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_box_zz_labdoor3" );
  AnimPlay( "anm_labdoor3_box_cap_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Labdoor3CapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_labdoor3_use_amuletmolecule3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_lock_with_formules" );
  AnimPlay( "anm_labdoor3_cap_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Labdoor3LockClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_labdoor3_use_amuletmolecule3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_lock_zz_labdoor3" );
  AnimPlay( "anm_labdoor3_lock_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*** function *** MMG Labdoor *** () ***
--*********************************************************************************************************************
  function private.Labdoor3Start ()

    cmn.MiniGameShow( "labdoor3" );
    common_impl.PassingMgStart( "labdoor3" );

    ng_global.progress[ "std" ][ "win_labdoor3" ].field =
    {
      { 1, 6,11, 3,8, 1 },
      { 9, 5, 1,10,9, 5 },
      { 2,12, 4, 7,2,12 },
      { 8, 6,11, 3,8, 6 },
      { 1, 5, 1,10,9, 1 },
    };

  end;
--*********************************************************************************************************************
  function private.Labdoor3Init ()

    private.btn_count = 7;
    private.field_row = 5;
    private.field_col = 6;

    private.delta_x = 67;
    private.delta_y = 67;

    private.field_win = { 0,1,2,3,4,0 };
    private.field =
    {
      { 1, 6,11, 3,8, 1 },
      { 9, 5, 1,10,9, 5 },
      { 2,12, 4, 7,2,12 },
      { 8, 6,11, 3,8, 6 },
      { 1, 5, 1,10,9, 1 },
    };

    for b = 1, private.btn_count do

      ObjSet( "obj_labdoor3_mmg_button_"..b,
      {
        event_mdown    = function () private.Labdoor3ButtonClick( b ) end,
        event_menter   = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );

    end;

  end;
--*********************************************************************************************************************
  function private.Labdoor3Load ()

    for row = 1, private.field_row do

      for col = 1, private.field_col do

        local item = ng_global.progress[ "std" ][ "win_labdoor3" ].field[ row ][ col ];
        private.field[ row ][ col ] = item;

        ObjSet( "spr_labdoor3_item_"..row.."_"..col, { res = "assets/levels/level3/rm_tower3/zz_labdoor3/layers/mmg_part_"..item } );

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.Labdoor3ButtonClick ( idx )

    --cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_buttonmove_blue" );

    local sign = { 1,1,1,1,1,1,1 };

    local func_end = function ()

      int.Lock( false );

      if ( idx <= 3 ) then

        local row = idx + 1;

        private.field[ row ][ 6 ] = private.field[ row ][ 5 ];
        private.field[ row ][ 5 ] = private.field[ row ][ 4 ];
        private.field[ row ][ 4 ] = private.field[ row ][ 3 ];
        private.field[ row ][ 3 ] = private.field[ row ][ 2 ];
        private.field[ row ][ 2 ] = private.field[ row ][ 1 ];

      else

        local col = idx - 2;

        private.field[ 5 ][ col ] = private.field[ 4 ][ col ];
        private.field[ 4 ][ col ] = private.field[ 3 ][ col ];
        private.field[ 3 ][ col ] = private.field[ 2 ][ col ];
        private.field[ 2 ][ col ] = private.field[ 1 ][ col ];

      end;

      private.field[ 2 ][ 1 ] = private.field[ 2 ][ 5 ];
      private.field[ 3 ][ 1 ] = private.field[ 3 ][ 5 ];
      private.field[ 4 ][ 1 ] = private.field[ 4 ][ 5 ];
      private.field[ 5 ][ 1 ] = private.field[ 5 ][ 5 ];

      private.field[ 1 ][ 2 ] = private.field[ 4 ][ 2 ];
      private.field[ 1 ][ 3 ] = private.field[ 4 ][ 3 ];
      private.field[ 1 ][ 4 ] = private.field[ 4 ][ 4 ];
      private.field[ 1 ][ 5 ] = private.field[ 4 ][ 5 ];

      for row = 1, private.field_row do

        for col = 1, private.field_col do

          local item = private.field[ row ][ col ];

          ObjSet( "spr_labdoor3_item_"..row.."_"..col,
          {
            pos_x = ( col - 1 ) * private.delta_x,
            pos_y = ( row - 1 ) * private.delta_y,
            res = "assets/levels/level3/rm_tower3/zz_labdoor3/layers/mmg_part_"..item
          } );

        end;

      end;

      if ( private.Labdoor3IsWin() ) then

        private.Labdoor3WinAnim();

      end;

    end;

    int.Lock( true );

    if ( idx <= 3 ) then

      local row = idx + 1;
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_formules_click_horizontal" );
      for i = 1, private.field_col do

        local name = "spr_labdoor3_item_"..row.."_"..i;
        local pos_x_start = ObjGet( name ).pos_x;
        local pos_x_end   = pos_x_start + ( sign[ idx ] * private.delta_x );
        ObjAnimate( name, "pos_x", 0, 0, "", 
        {
          0.0, 3, pos_x_start,
          0.5, 3, pos_x_end,
        } );

      end;

    else
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_formules_click_vertical" );
      for i = 1, private.field_row do

        local col = idx - 2;

        local name = "spr_labdoor3_item_"..i.."_"..col;
        local pos_y_start = ObjGet( name ).pos_y;
        local pos_y_end   = pos_y_start + ( sign[ idx ] * private.delta_y );
        ObjAnimate( name, "pos_y", 0, 0, "", 
        {
          0.0, 3, pos_y_start,
          0.5, 3, pos_y_end,
        } );

      end;

    end;

    ObjAnimate( "spr_labdoor3_mmg_button_"..idx.."_light", "alp", 0, 0, "", 
    {
      0.0, 3, 0.0,
      0.2, 3, 1.0,
      0.3, 3, 1.0,
      0.5, 3, 0.0,
    } );

    ObjSet( "tmr_labdoor3_anim", 
    { 
      playing = 1, 
      time = 0.5,  
      endtrig = func_end;
    } );

  end;
--*********************************************************************************************************************
  function private.Labdoor3WinAnim()

    int.Lock( true );

    local func_end = function ()

      private.Labdoor3SaveProgress();
      private.Labdoor3Win();
      int.Lock( false );

    end;

    ObjAnimate( "obj_labdoor3_mmg", "scale_xy", 0, 0,
    function ()

      ObjSet( "obj_labdoor3_lock",      { alp = 0 } );
      ObjSet( "obj_labdoor3_cap",       { alp = 0 } );
      ObjSet( "obj_labdoor3_door",      { alp = 0 } );
      ObjSet( "anm_labdoor3_door_open", { alp = 1 } );
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_loc_zz_labdoor3_opens" );
      AnimPlay( "anm_labdoor3_door_open", "DoAnim", func_end );

    end,
    {
      0.0, 3, 1.0, 1.0,
      1.0, 3, 1.0, 1.0,
      1.6, 3, 0.0, 0.0,
    } );

    ObjAnimate( "obj_labdoor3_mmg", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      1.3, 3, 1.0,
      1.6, 3, 0.0,
    } );

    ObjAnimate( "obj_labdoor3_mmg", "pos_y", 0, 0, "",
    {
      0.0, 3, -55,
      1.0, 3, -55,
      1.6, 3, -140,
    } );

  end;
--*********************************************************************************************************************
  function private.Labdoor3SaveProgress ()

    for row = 1, private.field_row do

      for col = 1, private.field_col do

        ng_global.progress[ "std" ][ "win_labdoor3" ].field[ row ][ col ] = private.field[ row ][ col ];

      end;

    end;

  end;
--*********************************************************************************************************************
  function private.Labdoor3IsWin ()

    local row = 3;

    for col = 2, private.field_col - 1 do

      local item = private.field[ row ][ col ];

      if ( item ~= private.field_win[ col ] ) then

        private.Labdoor3SaveProgress();
        return false;

      end;

    end;

    return true;

  end;
--*********************************************************************************************************************
  function private.Labdoor3Win ()

    cmn.MiniGameHide( "labdoor3" );
    cmn.SetEventDone( "win_labdoor3" );
    cmn.CallEventHandler( "win_labdoor3" );
    common_impl.PassingMgWin( "labdoor3" );
    cmn.CloseSubRoom();

  end;
--*********************************************************************************************************************
  function private.Labdoor3Reset ()

    ng_global.progress[ "std" ][ "win_labdoor3" ].field =
    {
      { 1, 6,11, 3,8, 1 },
      { 9, 5, 1,10,9, 5 },
      { 2,12, 4, 7,2,12 },
      { 8, 6,11, 3,8, 6 },
      { 1, 5, 1,10,9, 1 },
    };

    private.field =
    {
      { 1, 6,11, 3,8, 1 },
      { 9, 5, 1,10,9, 5 },
      { 2,12, 4, 7,2,12 },
      { 8, 6,11, 3,8, 6 },
      { 1, 5, 1,10,9, 1 },
    };

    private.Labdoor3Load();

  end;
--*********************************************************************************************************************
  function private.Labdoor3Skip ()

    local field_win =
    {
      { 1, 6,11,12,8, 1 },
      { 9, 5, 7,10,9, 5 },
      { 4, 1, 2, 3,4, 1 },
      { 8, 6,11,12,8, 6 },
      { 1, 5, 7,10,9, 1 },
    };

    for row = 1, private.field_row do

      for col = 1, private.field_col do

        local item = field_win[ row ][ col ];

        ObjSet( "spr_labdoor3_item_"..row.."_"..col, { res = "assets/levels/level3/rm_tower3/zz_labdoor3/layers/mmg_part_"..item } );

      end;

    end;

    private.Labdoor3WinAnim();

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************