-- name=rm_towerroof3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_towerroof3";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_revitalizer3", "room_hub" );
  ObjAttach( "zz_lodgment3",    "room_hub" );
  ObjAttach( "zz_generator3",   "room_hub" );

  ObjMultiSet(
  {
    { "spr_revitalizer3_amuletangel3_1",  { event_mdown = private.get_amuletangel3_1 } },
    { "spr_lodgment3_gasoline3",          { event_mdown = private.get_gasoline3 } },
    { "spr_generator3_chargedskull3",     { event_mdown = private.get_chargedskull3 } },
    { "obj_lodgment3_use_amuletrainbow3", { event_mdown = private.Lodgment3CapClick } },
    { "obj_lodgment3_use_blowtorch3",     { event_mdown = private.Lodgment3DoorClick } },
    { "obj_generator3_lever_clk",         { event_mdown = function() private.clk_generator3_lever() end } },
    { "spr_revitalizer3_flintlock3",      { event_mdown = private.get_flintlock3 } },
    { "spr_revitalizer3_amuletaxes3",     { event_mdown = private.get_amuletaxes3 } },
    { "spr_revitalizer3_screensaver_2_17",     { event_mdown = private.get_screensaver_2_17 } },      
    { "spr_generator3_screensaver_2_18",     { event_mdown = private.get_screensaver_2_18 } }, 
    { "obj_revitalizer3_use_vitruvianamulet3",     { event_mdown = function() private.Revitalizer3VitruvianamuletCapClk() end } },          
  } );

  local get_screensaver_2_17 = function ()

    ObjDelete( "spr_revitalizer3_screensaver_2_17" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_17", get_screensaver_2_17, private.room_objname );  
  local get_screensaver_2_18 = function ()

    ObjDelete( "spr_generator3_screensaver_2_18" );

  end;
  cmn.AddSubscriber( "get_screensaver_2_18", get_screensaver_2_18, private.room_objname );  

  private.Revitalizer3Init();
  private.Generator3Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_towerroof3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_towerroof3", update_game_mode_towerroof3, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_vitruvianamulet3 () end;
  --------------------------------------------------------------------------------------------
  local get_vitruvianamulet3_inv = function ()

    int.InventoryItemAdd( "inv_vitruvianamulet3", "spr_towerroof3_vitruvianamulet3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_vitruvianamulet3", get_vitruvianamulet3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_3_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_3_6 = function ()

    ObjDelete( "obj_towerroof3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_3_6", get_morphobject_3_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletangel3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletangel3_1" ] =
  {
    type = "get",
    get_obj = "spr_revitalizer3_amuletangel3_1",
    room = private.room_objname,
    zz = "zz_revitalizer3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletangel3_1_inv = function ()

    int.InventoryItemAdd( "inv_amuletangel3", "spr_revitalizer3_amuletangel3_1", "assets/levels/level3/rm_towerroof3/zz_revitalizer3/inv/inv_amuletangel3_1" );
    level3_inv.CheckAmuletAngel3( 1 );

  end;
  local get_amuletangel3_1_closezz = function ()

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletangel3_1", get_amuletangel3_1_inv );
  cmn.AddSubscriber( "get_amuletangel3_1", get_amuletangel3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gasoline3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gasoline3" ] =
  {
    type = "get",
    get_obj = "spr_lodgment3_gasoline3",
    room = private.room_objname,
    zz = "zz_lodgment3",
    zz_gate = "gzz_towerroof3_lodgment3"
  };
  --------------------------------------------------------------------------------------------
  local get_gasoline3_inv = function ()

    int.InventoryItemAdd( "inv_gasoline3", "spr_lodgment3_gasoline3" );

    if ( cmn.IsEventDone( "get_disassembledlamp3" ) ) then

      ObjSet( "inv_disassembledlamp3_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_gasoline3_closezz = function ()

    ObjDelete( "gfx_lodgment3_gasoline3" );
    ObjDelete( "spr_towerroof3_lodgment_gasoline" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gasoline3", get_gasoline3_inv );
  cmn.AddSubscriber( "get_gasoline3", get_gasoline3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flintlock3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flintlock3" ] =
  {
    type = "get",
    get_obj = "spr_revitalizer3_flintlock3",
    room = private.room_objname,
    zz = "zz_revitalizer3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --------------------------------------------------------------------------------------------
  local get_flintlock3_inv = function ()

    int.InventoryItemAdd( "inv_flintlock3", "spr_revitalizer3_flintlock3" );

  end;
  local get_flintlock3_closezz = function ()

    ObjDelete( "spr_towerroof3_revitalizer_flintlock" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_flintlock3", get_flintlock3_inv );
  cmn.AddSubscriber( "get_flintlock3", get_flintlock3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_amuletaxes3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_amuletaxes3" ] =
  {
    type = "get",
    get_obj = "spr_revitalizer3_amuletaxes3",
    room = private.room_objname,
    zz = "zz_revitalizer3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --------------------------------------------------------------------------------------------
  local get_amuletaxes3_inv = function ()

    int.InventoryItemAdd( "inv_amuletaxes3", "spr_revitalizer3_amuletaxes3" );


  end;
  local get_amuletaxes3_closezz = function ()

    ObjDelete( "spr_towerroof3_revitalizer_amuletaxes" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amuletaxes3", get_amuletaxes3_inv );
  cmn.AddSubscriber( "get_amuletaxes3", get_amuletaxes3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_facetedglass3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_facetedglass3" ] =
  {
    type = "use",
    use_obj = "inv_facetedglass3",
    use_place = "obj_revitalizer3_use_facetedglass3",
    room = private.room_objname,
    zz = "zz_revitalizer3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --------------------------------------------------------------------------------------------
  local use_facetedglass3_inv = function ()

    int.InventoryItemRemove( "inv_facetedglass3" );

  end;
  local use_facetedglass3_beg = function ()

    ObjDelete( "obj_revitalizer3_use_facetedglass3" );

  end;
  local use_facetedglass3_end = function ()

    ObjSet( "anm_revitalizer3_use_essence", { alp = 1 } );
    ObjDelete( "anm_revitalizer3_crystal_start_pos" );
    ObjDelete( "anm_revitalizer3_use_facetedglass" );
    ObjDelete( "anm_revitalizer3_slot_facetedglass" );

    ObjSet( "spr_towerroof3_revitalizer_facetedglass_1", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_facetedglass3",     use_facetedglass3_inv );
  cmn.AddSubscriber( "use_facetedglass3",     use_facetedglass3_beg, private.room_objname );
  cmn.AddSubscriber( "use_facetedglass3",     use_facetedglass3_end, private.room_objname );
  cmn.AddSubscriber( "use_facetedglass3_inv", use_facetedglass3_inv, private.room_objname );
  cmn.AddSubscriber( "use_facetedglass3_beg", use_facetedglass3_beg, private.room_objname );
  cmn.AddSubscriber( "use_facetedglass3_end", use_facetedglass3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_vitruvianamulet3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_vitruvianamulet3" ] =
  {
    type = "use",
    use_obj = "inv_vitruvianamulet3",
    use_place = "obj_revitalizer3_use_vitruvianamulet3",
    room = private.room_objname,
    zz = "zz_revitalizer3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --------------------------------------------------------------------------------------------
  local use_vitruvianamulet3_inv = function ()

    int.InventoryItemRemove( "inv_vitruvianamulet3" );

  end;
  local use_vitruvianamulet3_beg = function ()

    ObjDelete( "obj_revitalizer3_use_vitruvianamulet3" );

  end;
  local use_vitruvianamulet3_end = function ()

    ObjSet( "anm_revitalizer3_use_vitruvianamulet", { frame = 500 } );
    ObjSet( "spr_revitalizer3_flintlock3",  { input = true } );
    ObjSet( "gfx_revitalizer3_flintlock3",  { active = true } );
    ObjSet( "spr_revitalizer3_amuletaxes3", { input = true } );
    ObjSet( "gfx_revitalizer3_amuletaxes3", { active = true } );

    ObjSet( "spr_towerroof3_revitalizer_door", { pos_x = 238, pos_y = 409 } );
    ObjSet( "spr_towerroof3_revitalizer_vitruvianamulet", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_vitruvianamulet3",     use_vitruvianamulet3_inv );
  cmn.AddSubscriber( "use_vitruvianamulet3",     use_vitruvianamulet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_vitruvianamulet3",     use_vitruvianamulet3_end, private.room_objname );
  cmn.AddSubscriber( "use_vitruvianamulet3_inv", use_vitruvianamulet3_inv, private.room_objname );
  cmn.AddSubscriber( "use_vitruvianamulet3_beg", use_vitruvianamulet3_beg, private.room_objname );
  cmn.AddSubscriber( "use_vitruvianamulet3_end", use_vitruvianamulet3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_essence3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_essence3" ] =
  {
    type = "use",
    use_obj = "inv_essence3",
    use_place = "obj_revitalizer3_use_essence3",
    room = private.room_objname,
    zz = "zz_revitalizer3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --------------------------------------------------------------------------------------------
  local use_essence3_inv = function ()

    int.InventoryItemRemove( "inv_essence3" );

  end;
  local use_essence3_beg = function ()

    ObjDelete( "obj_revitalizer3_use_essence3" );

  end;
  local use_essence3_end = function ()

    ObjDelete( "anm_revitalizer3_use_essence" );
    ObjSet( "obj_revitalizer3_mmg", { alp = 1 } );

    for i = 1, 4 do
      ObjSet( "anm_revitalizer3_crystal_ray_"..i, { alp = 1, playing = true } );
    end;

    if cmn.IsEventDone( "use_crystal3" ) then

      ObjSet( "obj_revitalizer3_mmg", { input = true } );
      ObjDelete( "anm_revitalizer3_back_mechanism_start" );
      ObjSet( "anm_revitalizer3_back_mechanism", { alp = 1, playing = true } );

    end;

    ObjSet( "spr_revitalizer3_crystals_light_over", { alp = 1 } );
    ObjSet( "spr_revitalizer3_crystal_central_over", { alp = 1 } );
    ObjSet( "spr_revitalizer3_tube", { alp = 1 } );
    ObjSet( "spr_revitalizer3_tube_over", { alp = 1 } );
    ObjSet( "spr_revitalizer3_over_trumbet_down", { alp = 1 } );

    ObjSet( "anm_revitalizer3_facetedglass_sparks", { alp = 1, playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_essence3",     use_essence3_inv );
  cmn.AddSubscriber( "use_essence3",     use_essence3_beg, private.room_objname );
  cmn.AddSubscriber( "use_essence3",     use_essence3_end, private.room_objname );
  cmn.AddSubscriber( "use_essence3_inv", use_essence3_inv, private.room_objname );
  cmn.AddSubscriber( "use_essence3_beg", use_essence3_beg, private.room_objname );
  cmn.AddSubscriber( "use_essence3_end", use_essence3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crystal3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crystal3" ] =
  {
    type = "use",
    use_obj = "inv_crystal3",
    use_place = "obj_revitalizer3_use_crystal3",
    room = private.room_objname,
    zz = "zz_revitalizer3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --------------------------------------------------------------------------------------------
  local use_crystal3_inv = function ()

    int.InventoryItemRemove( "inv_crystal3" );

  end;
  local use_crystal3_beg = function ()

    ObjDelete( "obj_revitalizer3_use_crystal3" );

  end;
  local use_crystal3_end = function ()

    if cmn.IsEventDone( "use_essence3" ) then

      ObjSet( "obj_revitalizer3_mmg", { input = true } );
      ObjDelete( "anm_revitalizer3_back_mechanism_start" );
      ObjSet( "anm_revitalizer3_back_mechanism", { alp = 1, playing = true } );

    end;

    ObjSet( "spr_revitalizer3_crystal", { alp = 1 } );
    ObjDelete( "anm_revitalizer3_slot_crystal" );

    ObjSet( "spr_towerroof3_revitalizer_crystal", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crystal3",     use_crystal3_inv );
  cmn.AddSubscriber( "use_crystal3",     use_crystal3_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystal3",     use_crystal3_end, private.room_objname );
  cmn.AddSubscriber( "use_crystal3_inv", use_crystal3_inv, private.room_objname );
  cmn.AddSubscriber( "use_crystal3_beg", use_crystal3_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystal3_end", use_crystal3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amuletrainbow3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amuletrainbow3" ] =
  {
    type = "use",
    use_obj = "inv_amuletrainbow3",
    use_place = "obj_lodgment3_use_amuletrainbow3",
    room = private.room_objname,
    zz = "zz_lodgment3",
    zz_gate = "gzz_towerroof3_lodgment3"
  };
  --------------------------------------------------------------------------------------------
  local use_amuletrainbow3_inv = function ()

    int.InventoryItemRemove( "inv_amuletrainbow3" );

  end;
  local use_amuletrainbow3_beg = function ()

    ObjDelete( "obj_lodgment3_use_amuletrainbow3" );
    ObjDelete( "anm_lodgment3_box_cap_click" );

  end;
  local use_amuletrainbow3_end = function ()

    ObjSet( "spr_lodgment3_gasoline3", { input = true } );
    ObjSet( "gfx_lodgment3_gasoline3", { active = true } );
    ObjSet( "anm_lodgment3_box_cap_open", { alp = 1, frame = 118, animfunc = "DoAnim" } );

    ObjSet( "spr_towerroof3_lodgment_cap", { pos_x = 506, pos_y = 618 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amuletrainbow3",     use_amuletrainbow3_inv );
  cmn.AddSubscriber( "use_amuletrainbow3",     use_amuletrainbow3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletrainbow3",     use_amuletrainbow3_end, private.room_objname );
  cmn.AddSubscriber( "use_amuletrainbow3_inv", use_amuletrainbow3_inv, private.room_objname );
  cmn.AddSubscriber( "use_amuletrainbow3_beg", use_amuletrainbow3_beg, private.room_objname );
  cmn.AddSubscriber( "use_amuletrainbow3_end", use_amuletrainbow3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_blowtorch3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_blowtorch3" ] =
  {
    type = "use",
    use_obj = "inv_blowtorch3",
    use_place = "obj_lodgment3_use_blowtorch3",
    room = private.room_objname,
    zz = "zz_lodgment3",
    zz_gate = "gzz_towerroof3_lodgment3"
  };
  --------------------------------------------------------------------------------------------
  local use_blowtorch3_inv = function ()

    int.InventoryItemRemove( "inv_blowtorch3" );

  end;
  local use_blowtorch3_beg = function ()

    ObjDelete( "obj_lodgment3_use_blowtorch3" );
    ObjDelete( "anm_lodgment3_safe_door_click" );

  end;
  local use_blowtorch3_end = function ()

    ObjDelete( "gzz_towerroof3_lodgment3" );
    ObjSet( "gho_towerroof3_horepair3", { alp = 1, input = true, active = true } );

    ObjSet( "spr_towerroof3_lodgment_door", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_blowtorch3",     use_blowtorch3_inv );
  cmn.AddSubscriber( "use_blowtorch3",     use_blowtorch3_beg, private.room_objname );
  cmn.AddSubscriber( "use_blowtorch3",     use_blowtorch3_end, private.room_objname );
  cmn.AddSubscriber( "use_blowtorch3_inv", use_blowtorch3_inv, private.room_objname );
  cmn.AddSubscriber( "use_blowtorch3_beg", use_blowtorch3_beg, private.room_objname );
  cmn.AddSubscriber( "use_blowtorch3_end", use_blowtorch3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fuses3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fuses3" ] =
  {
    type = "use",
    use_obj = "inv_fuses3",
    use_place = "obj_generator3_use_fuses3",
    room = private.room_objname,
    zz = "zz_generator3",
    zz_gate = "gzz_towerroof3_generator3"
  };
  --------------------------------------------------------------------------------------------
  local use_fuses3_inv = function ()

    int.InventoryItemRemove( "inv_fuses3" );

  end;
  local use_fuses3_beg = function ()

    ObjDelete( "obj_generator3_use_fuses3" );

  end;
  local use_fuses3_end = function ()

    ObjSet( "obj_generator3_levers", { input = true } );
    ObjSet( "spr_generator3_fuse1", { alp = 1 } );
    ObjSet( "spr_generator3_fuse2", { alp = 1 } );
    ObjSet( "obj_generator3_light_3", { alp = 1 } );
    ObjSet( "obj_generator3_light_4", { alp = 1 } );

    ObjSet( "spr_towerroof3_generator_fuses", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fuses3",     use_fuses3_inv );
  cmn.AddSubscriber( "use_fuses3",     use_fuses3_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuses3",     use_fuses3_end, private.room_objname );
  cmn.AddSubscriber( "use_fuses3_inv", use_fuses3_inv, private.room_objname );
  cmn.AddSubscriber( "use_fuses3_beg", use_fuses3_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuses3_end", use_fuses3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_battery3 () end;
  --------------------------------------------------------------------------------------------
  local use_battery3_end = function ()

    ObjSet( "anm_towerroof3_back_light", { alp = 1, playing = true } );
    ObjDelete( "anm_towerroof3_back_dark" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_battery3",     use_battery3_end, private.room_objname );
  cmn.AddSubscriber( "use_battery3_end", use_battery3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_revitalizer3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_revitalizer3" ] =
  {
    type = "click",
    clk_obj = "obj_revitalizer3_crystal_1",
    room = private.room_objname,
    zz = "zz_revitalizer3",
    zz_gate = "gzz_towerroof3_revitalizer3"
  };
  --*********************************************************************************************************************
  local win_revitalizer3_inv = function ()

    if ( cmn.IsEventDone( "win_revitalizer3" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_revitalizer3 = function ()

    if ( cmn.IsEventDone( "win_revitalizer3" ) ) then

      ObjSet( "gmg_towerroof3_mgfight3", { alp = 1, input = true, active = true } );
      ObjDelete( "gzz_towerroof3_revitalizer3" );


 
    else 

      private.Revitalizer3Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_revitalizer3", win_revitalizer3_inv );
  cmn.AddSubscriber( "win_revitalizer3", win_revitalizer3, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_generator3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_generator3" ] =
  {
    type = "click",
    clk_obj = "spr_generator3_lever1_up",
    room = private.room_objname,
    zz = "zz_generator3",
    zz_gate = "gzz_towerroof3_generator3"
  };
  --*********************************************************************************************************************
  local win_generator3_inv = function ()

    if ( cmn.IsEventDone( "win_generator3" ) ) then

    end;

  end;
  --*********************************************************************************************************************
  local win_generator3 = function ()

    if ( cmn.IsEventDone( "win_generator3" ) ) then

      ObjSet( "obj_generator3_levers", { input = false } );

      for i = 1, 6 do

        ObjSet( "spr_generator3_lever"..i, { alp = 0 } );
        ObjSet( "spr_generator3_lever"..i.."_up", { alp = 1 } );
        ObjSet( "spr_generator3_light_red"..i, { alp = 0 } );
        ObjSet( "spr_generator3_light_green"..i, { alp = 1 } );

      end;

      ObjSet( "obj_generator3_lever_clk", { input = true } );

      ObjSet( "spr_towerroof3_generator_lever_on", { alp = 1 } );
      ObjDelete( "spr_towerroof3_generator_lever_off" );
 
    else 

      private.Generator3Load();

    end;
    
  end;

  cmn.AddSubscriber( "win_generator3", win_generator3_inv );
  cmn.AddSubscriber( "win_generator3", win_generator3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_towerroof3_emily3_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_towerroof3_emily3_2_beg = function ()

  end;
  -----------------------------------------------
  local dlg_towerroof3_emily3_2_end = function ()

    ObjDelete( "dlg_towerroof3_emily3_2" );

  end;

  cmn.AddSubscriber( "dlg_towerroof3_emily3_2",     dlg_towerroof3_emily3_2_beg );
  cmn.AddSubscriber( "dlg_towerroof3_emily3_2",     dlg_towerroof3_emily3_2_end );
  cmn.AddSubscriber( "dlg_towerroof3_emily3_2_beg", dlg_towerroof3_emily3_2_beg );
  cmn.AddSubscriber( "dlg_towerroof3_emily3_2_end", dlg_towerroof3_emily3_2_end );


--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_generator3_lever () end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_generator3_lever" ] =
  {
    type = "click",
    clk_obj = "obj_generator3_lever_clk",
    room = private.room_objname,
    zz = "zz_generator3",
    zz_gate = "gzz_towerroof3_generator3"
  };
  -----------------------------------------------
  --------------------------------------------------------------------------------------------
  local clk_generator3_lever_inv = function ()


  end;
  local clk_generator3_lever_beg = function ()

    ObjDelete( "obj_generator3_lever_clk" );
    ObjSet( "spr_towerroof3_generator_lever", { ang = 0.75 } );
    ObjDelete( "spr_towerroof3_lamp_red_light" );
    ObjSet( "spr_towerroof3_lamp_green_light", { alp = 1, active = true } );

  end;
  local clk_generator3_lever_end = function ()

    ObjDelete( "gzz_towerroof3_generator3" );
    ObjDelete( "anm_towerroof3_lighting" );
    ObjSet( "anm_towerroof3_lighting_static", { alp = 1, playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_generator3_lever",     clk_generator3_lever_inv );
  cmn.AddSubscriber( "clk_generator3_lever",     clk_generator3_lever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_generator3_lever",     clk_generator3_lever_end, private.room_objname );
  cmn.AddSubscriber( "clk_generator3_lever_inv", clk_generator3_lever_inv, private.room_objname );
  cmn.AddSubscriber( "clk_generator3_lever_beg", clk_generator3_lever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_generator3_lever_end", clk_generator3_lever_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
end;
function private.get_screensaver_2_17()

  int.AddScreensaver( "spr_revitalizer3_screensaver_2_17" );

end;    
function private.get_screensaver_2_18()

  int.AddScreensaver( "spr_generator3_screensaver_2_18" );

end; 
-----------------------------------------------------------------------
function private.get_amuletangel3_1 ()

  cmn.SetEventDone( "get_amuletangel3_1" );
  cmn.CallEventHandler( "get_amuletangel3_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_gasoline3 ()

  cmn.SetEventDone( "get_gasoline3" );
  cmn.CallEventHandler( "get_gasoline3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_flintlock3 ()

  cmn.SetEventDone( "get_flintlock3" );
  cmn.CallEventHandler( "get_flintlock3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_amuletaxes3 ()

  cmn.SetEventDone( "get_amuletaxes3" );
  cmn.CallEventHandler( "get_amuletaxes3" );
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_facetedglass3 ()

  local item = "inv_facetedglass3";

  if ( cmn.ApplyObj( item, "gzz_towerroof3_revitalizer3", false ) ) and
     ( not cmn.IsEventDone( "use_facetedglass3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_revitalizer3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_revitalizer3_use_facetedglass3", true ) ) and
         ( not cmn.IsEventDone( "use_facetedglass3" ) ) then

    cmn.CallEventHandler( "use_facetedglass3_inv" );
    cmn.CallEventHandler( "use_facetedglass3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_facetedglass3" );
      cmn.CallEventHandler( "use_facetedglass3_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_revitalizer3_slot_facetedglass", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_revitalizer3_insert_crystal" );
    AnimPlay( "anm_revitalizer3_use_facetedglass", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_vitruvianamulet3 ()

  local item = "inv_vitruvianamulet3";

  if ( cmn.ApplyObj( item, "gzz_towerroof3_revitalizer3", false ) ) and
     ( not cmn.IsEventDone( "use_vitruvianamulet3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_revitalizer3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_revitalizer3_use_vitruvianamulet3", true ) ) and
         ( not cmn.IsEventDone( "use_vitruvianamulet3" ) ) then

    cmn.CallEventHandler( "use_vitruvianamulet3_inv" );
    cmn.CallEventHandler( "use_vitruvianamulet3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_vitruvianamulet3" );
      cmn.CallEventHandler( "use_vitruvianamulet3_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_revitalizer3_insert_2_hand_leg_man" );
    AnimPlay( "anm_revitalizer3_use_vitruvianamulet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_essence3 ()

  local item = "inv_essence3";

  if ( cmn.ApplyObj( item, "gzz_towerroof3_revitalizer3", false ) ) and
     ( not cmn.IsEventDone( "use_essence3" ) ) and 
       cmn.IsEventDone( "use_facetedglass3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_revitalizer3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_revitalizer3_use_essence3", true ) ) and
         ( not cmn.IsEventDone( "use_essence3" ) ) and 
           cmn.IsEventDone( "use_facetedglass3" ) then

    cmn.CallEventHandler( "use_essence3_inv" );
    cmn.CallEventHandler( "use_essence3_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_essence3" );
        cmn.CallEventHandler( "use_essence3_end" );

        if cmn.IsEventDone( "use_crystal3" ) then
          private.Revitalizer3Start();
        end;

      end;

      if cmn.IsEventDone( "use_crystal3" ) then

        ObjDelete( "anm_revitalizer3_use_essence" );
        ObjSet( "obj_revitalizer3_mmg", { alp = 1 } );

        for i = 1, 4 do
          ObjSet( "anm_revitalizer3_crystal_ray_"..i, { alp = 1, playing = true } );
        end;

        ObjSet( "spr_revitalizer3_crystals_light_over", { alp = 1 } );
        ObjSet( "spr_revitalizer3_crystal_central_over", { alp = 1 } );
        ObjSet( "spr_revitalizer3_tube", { alp = 1 } );
        ObjSet( "spr_revitalizer3_tube_over", { alp = 1 } );
        ObjSet( "spr_revitalizer3_over_trumbet_down", { alp = 1 } );

        ObjSet( "anm_revitalizer3_facetedglass_sparks", { alp = 1, playing = true } );
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_revitalizer3_mech_works" );
        AnimPlay( "anm_revitalizer3_back_mechanism_start", "DoAnim", func_end1 ); 

      else
        func_end1();
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_revitalizer3_fill_powder" );
    AnimPlay( "anm_revitalizer3_use_essence", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_crystal3 ()

  local item = "inv_crystal3";

  if ( cmn.ApplyObj( item, "gzz_towerroof3_revitalizer3", false ) ) and
     ( not cmn.IsEventDone( "use_crystal3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_revitalizer3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_revitalizer3_use_crystal3", true ) ) and
         ( not cmn.IsEventDone( "use_crystal3" ) ) then

    cmn.CallEventHandler( "use_crystal3_inv" );
    cmn.CallEventHandler( "use_crystal3_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_crystal3" );
        cmn.CallEventHandler( "use_crystal3_end" );

        if cmn.IsEventDone( "use_essence3" ) then
          private.Revitalizer3Start();
        end;

      end;

      if cmn.IsEventDone( "use_essence3" ) then
        cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_revitalizer3_mech_works" );
        AnimPlay( "anm_revitalizer3_back_mechanism_start", "DoAnim", func_end1 ); 
      else
        func_end1();
      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_revitalizer3_insert_middle_crystal" );
    ObjAnimate( "anm_revitalizer3_slot_crystal", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );
    ObjAnimate( "spr_revitalizer3_crystal", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amuletrainbow3 ()

  local item = "inv_amuletrainbow3";

  if ( cmn.ApplyObj( item, "gzz_towerroof3_lodgment3", false ) ) and
     ( not cmn.IsEventDone( "use_amuletrainbow3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lodgment3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_lodgment3_use_amuletrainbow3", true ) ) and
         ( not cmn.IsEventDone( "use_amuletrainbow3" ) ) then

    cmn.CallEventHandler( "use_amuletrainbow3_inv" );
    cmn.CallEventHandler( "use_amuletrainbow3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amuletrainbow3" );
      cmn.CallEventHandler( "use_amuletrainbow3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_lodgment3_box_cap_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_lodgment3_insert_in_box_down_right" );
    AnimPlay( "anm_lodgment3_box_cap_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_blowtorch3 ()

  local item = "inv_blowtorch3";

  if ( cmn.ApplyObj( item, "gzz_towerroof3_lodgment3", false ) ) and
     ( not cmn.IsEventDone( "use_blowtorch3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_lodgment3" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_lodgment3_use_blowtorch3", true ) ) and
         ( not cmn.IsEventDone( "use_blowtorch3" ) ) then

    cmn.CallEventHandler( "use_blowtorch3_inv" );
    cmn.CallEventHandler( "use_blowtorch3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_blowtorch3" );
      cmn.CallEventHandler( "use_blowtorch3_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );

    ObjSet( "anm_lodgment3_safe_door_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_lodgment3_burn_safe" );
    AnimPlay( "anm_lodgment3_safe_door_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_fuses3 ()

  local item = "inv_fuses3";

  if ( cmn.ApplyObj( item, "gzz_towerroof3_generator3", false ) ) and
     ( not cmn.IsEventDone( "use_fuses3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_generator3", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_generator3_use_fuses3", true ) ) and
         ( not cmn.IsEventDone( "use_fuses3" ) ) then

    cmn.CallEventHandler( "use_fuses3_inv" );
    cmn.CallEventHandler( "use_fuses3_beg" );

    local func_end = function ()

      cmn.SetEventDone( "use_fuses3" );
      cmn.CallEventHandler( "use_fuses3_end" );
      private.Generator3Start();
      int.Lock( false );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_zz_generator3_insert_2_stuffs" );
    ObjAnimate( "spr_generator3_fuse1", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    ObjAnimate( "spr_generator3_fuse2", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    ObjAnimate( "obj_generator3_light_3", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );
    ObjAnimate( "obj_generator3_light_4", "alp", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.clk_generator3_lever ()

  cmn.CallEventHandler( "clk_generator3_lever_inv" );
  cmn.CallEventHandler( "clk_generator3_lever_beg" );

  local func_end = function ()

    local func_end1 = function ()

      local func_end2 = function ()

        cmn.SetEventDone( "clk_generator3_lever" );
        cmn.CallEventHandler( "clk_generator3_lever_end" );
        private.VidCrowd();

      end;

      cmn.CloseSubRoom( true );
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_rm_towerroof3_mech_works" );
      AnimPlay( "anm_towerroof3_lighting", "DoAnim", func_end2 );

    end;

    ObjAnimate( "anm_generator3_red_light_lamp", "alp", 0, 0, function() ObjSet( "anm_generator3_green_light_lamp", { playing = true } ); end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );
    ObjAnimate( "anm_generator3_green_light_lamp", "alp", 0, 0, func_end1, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
      1.0, 0, 1,
    } );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_transistors_turn_lever" );
  AnimPlay( "anm_generator3_clk_lever", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.dlg_towerroof3_emily3_2 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_vitruvianamulet3" );
    cmn.GetObjectSfx();

    ObjSet( "anm_towerroof3_emily3_2_emily_static", { alp = 0 } );
    AnimStop( "anm_towerroof3_emily3_2_emily_static" );

    ObjAnimate( "anm_towerroof3_emily3_2_emily_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_rishard_diss" );

    if ( func_end ) then

      func_end();

    end;

    cmn.SetEventDone( "get_vitruvianamulet3" );
    cmn.SetEventDone( "dlg_towerroof3_emily3_2" );

    --cmn.ShowBbt( "bbt_towerroof3_after_dlg_emily" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_towerroof3_emily3_2_emily_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "anm_towerroof3_emily";
    common_impl.DialogCharacterStart( "emily3_2", "towerroof3", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_towerroof3_emily3_2_beg" );
  ObjAttach( "dlg_towerroof3_emily3_2", GetCurrentRoom() );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_richard_want_talk" );

  ObjAnimate( "anm_towerroof3_emily3_2_emily_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "emily3_2" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_towerroof3_emily3_2_emily_static" );
        AnimPlay( "anm_towerroof3_emily3_2_emily_give", "DoAnim", "" );

      end;

      ObjAnimate( "anm_towerroof3_emily3_2_emily_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_towerroof3_emily3_2_emily_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_towerroof3 ()

  if not ( cmn.IsEventDone( "opn_towerroof3" ) ) then

    cmn.SetEventDone( "opn_towerroof3" );

  end;

  cmn.StopAllEnv( "audio/level3/env/aud_rm_towerroof3_env", true );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_towerroof3_env", 1 );

  if cmn.IsEventDone( "clk_generator3_lever" ) and 
     not cmn.IsEventDone( "dlg_towerroof3_emily3_2" ) and 
     not ng_global.progress[ "std" ][ "opn_towerroof3" ].crowd then

    private.VidCrowd();

  end;

  if ng_global.progress[ "std" ][ "opn_towerroof3" ].crowd and
     not cmn.IsEventDone( "dlg_towerroof3_emily3_2" ) then

    private.dlg_towerroof3_emily3_2();
 
  end;
  
  if ( cmn.IsEventDone( "use_gear3" ) ) and
     ( cmn.IsEventDone( "use_card3" ) ) and
     not ( cmn.IsEventDone( "dlg_tower3_emily3_1" ) ) then

    int.Lock( true);
    rm_tower3.dlg_tower3_emily3_1();

  end;  

  if ( cmn.IsEventDone( "win_revitalizer3" ) ) and
     not ( ng_global.progress[ "std" ][ "opn_towerroof3" ].fight ) then

    private.VidFight();

  end;

  if ( cmn.IsEventDone( "win_horepair3" ) ) and
     not ( ng_global.progress[ "std" ][ "opn_towerroof3" ].task_3_5 ) then

    ng_global.progress[ "std" ][ "opn_towerroof3" ].task_3_5 = true;
    interface.KeyTaskDone( true, "task_3_6" );

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_towerroof3();

end;
--*********************************************************************************************************************
function private.VidCrowd ()

  local func_end = function ( skip )

    int.Lock( false );
    ng_global.progress[ "std" ][ "opn_towerroof3" ].crowd = 1;

    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      cmn.StopAudio( "voc", "audio/level3/voc/aud_lvl3_vid_towerroof3_crowd_voc" );
      cmn.StopAudio( "mus", "audio/level3/mus/aud_vid_towerroof3_crowd_mus" );
    end;

    cmn.PlayAudio( "env", "audio/level3/env/aud_rm_towerroof3_env", 1 );
    cmn.PlayAudio( "mus", "audio/aud_action_crowd_1", nil, nil, 94 );

    common_impl.InterfaceSetVisible( true );
    private.dlg_towerroof3_emily3_2();

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_towerroof3_crowd", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  common_impl.StopMusEnv( false );

  cmn.PlayAudio( "voc", "audio/level3/voc/aud_lvl3_vid_towerroof3_crowd_voc" );
  cmn.PlayAudio( "mus", "audio/level3/mus/aud_vid_towerroof3_crowd_mus", nil, nil, 20 );

end;
--*********************************************************************************************************************
function private.VidFight ()

  local func_end = function ( skip )

    int.Lock( false );
    ng_global.progress[ "std" ][ "opn_towerroof3" ].fight = true;

    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_prison2_intro_voc" );
      cmn.StopAudio( "mus", "audio/level3/mus/aud_vid_towerroof3_fight_mus" );
    end;

    cmn.PlayAudio( "env", "audio/level3/env/aud_rm_towerroof3_env", 1 );
    --cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );
    cmn.GotoRoom( "mg_mgfight3" );

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_towerroof3_fight", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_prison2_intro_voc" );
  cmn.PlayAudio( "mus", "audio/level3/mus/aud_vid_towerroof3_fight_mus" );

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_vitruvianamulet3",                              { "dlg_towerroof3_emily3_2" } );
  int.AddedTaskMap( private.room_objname, "get_amuletangel3_1" );
  int.AddedTaskMap( private.room_objname, "get_gasoline3",                                     { "use_amuletrainbow3" } );
  int.AddedTaskMap( private.room_objname, "get_flintlock3",                                    { "use_vitruvianamulet3" } );
  int.AddedTaskMap( private.room_objname, "get_amuletaxes3",                                   { "use_vitruvianamulet3" } );

  int.AddedTaskMap( private.room_objname, "use_facetedglass3",                                 { "get_facetedglass3" } );
  int.AddedTaskMap( private.room_objname, "use_vitruvianamulet3",                              { "get_vitruvianamulet3" } );
  int.AddedTaskMap( private.room_objname, "use_essence3",                                      { "win_hoalchemybox3", "use_facetedglass3" } );
  int.AddedTaskMap( private.room_objname, "use_crystal3",                                      { "get_crystal3" } );
  int.AddedTaskMap( private.room_objname, "use_amuletrainbow3",                                { "get_amuletrainbow3" } );
  int.AddedTaskMap( private.room_objname, "use_blowtorch3",                                    { "get_blowtorch3" } );
  int.AddedTaskMap( private.room_objname, "use_fuses3",                                        { "win_horepair3" } );

  int.AddedTaskMap( private.room_objname, "win_revitalizer3",                                  { "use_essence3", "use_crystal3" } );
  int.AddedTaskMap( private.room_objname, "win_generator3",                                    { "use_fuses3" } );
  int.AddedTaskMap( private.room_objname, "win_horepair3",                                     { "use_blowtorch3" } );
  int.AddedTaskMap( private.room_objname, "win_mgfight3",                                      { "win_revitalizer3" } );

  int.AddedTaskMap( private.room_objname, "dlg_towerroof3_emily3_2",                           { "clk_generator3_lever" } );

  int.AddedTaskMap( private.room_objname, "clk_generator3_lever",                              { "win_generator3" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_revitalizer3" );
  subroom.Define( "zz_generator3" );
  -------------------------------------------------
  function zz_revitalizer3.Open()
    
    if ( cmn.IsEventStart( "win_revitalizer3" ) and not cmn.IsEventDone( "win_revitalizer3" ) ) then

      cmn.MiniGameShow( "revitalizer3" );
      common_impl.PassingMgStart( "revitalizer3" );

    end;

  end;
  -------------------------------------------------
  function zz_revitalizer3.Close()

    cmn.NoteScaleEnd( { "spr_revitalizer3_note" }, true );

  end;
  -------------------------------------------------
  function zz_revitalizer3.PreClose()
        
    if ( cmn.IsEventStart( "win_revitalizer3" ) and not cmn.IsEventDone( "win_revitalizer3" ) ) then

      cmn.MiniGameHide( "revitalizer3" );
      common_impl.PassingMgStop( "revitalizer3" );

    end;
    
  end;
  -------------------------------------------------
  function zz_revitalizer3.Skip ()

    if ( cmn.IsEventStart( "win_revitalizer3" ) and not cmn.IsEventDone( "win_revitalizer3" ) ) then
      private.Revitalizer3Skip();
    end;

  end;
  -------------------------------------------------
  function zz_revitalizer3.Reset ()

    if ( cmn.IsEventStart( "win_revitalizer3" ) and not cmn.IsEventDone( "win_revitalizer3" ) ) then
      private.Revitalizer3Reset();
    end;

  end;
  -------------------------------------------------
  -------------------------------------------------
  function zz_generator3.Open()
    
    if ( cmn.IsEventStart( "win_generator3" ) and not cmn.IsEventDone( "win_generator3" ) ) then

      cmn.MiniGameShow( "generator3" );
      common_impl.PassingMgStart( "generator3" );

    end;

  end;
  -----------------------------------------------
  function zz_generator3.Close ()

    cmn.NoteScaleEnd( { "spr_generator3_note" }, true );

  end;
  -------------------------------------------------
  function zz_generator3.PreClose()
        
    if ( cmn.IsEventStart( "win_generator3" ) and not cmn.IsEventDone( "win_generator3" ) ) then

      cmn.MiniGameHide( "generator3" );
      common_impl.PassingMgStop( "generator3" );

    end;
    
  end;
  -------------------------------------------------
  function zz_generator3.Skip ()

    if ( cmn.IsEventStart( "win_generator3" ) and not cmn.IsEventDone( "win_generator3" ) ) then
      private.Generator3Skip();
    end;

  end;
  -------------------------------------------------
  function zz_generator3.Reset ()

    if ( cmn.IsEventStart( "win_generator3" ) and not cmn.IsEventDone( "win_generator3" ) ) then
      private.Generator3Reset();
    end;

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_generator3_light", "alp", 1, 0, "", 
  { 
    0.0, 3, 1,
    2.0, 3, 0.5,
    4.0, 3, 1,
  } );
  ObjAnimate( "obj_generator3_lights", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.4,
    2.0, 0, 1,
  } );
  ObjAnimate( "spr_towerroof3_lamp_green_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.4,
    2.0, 0, 1,
  } );
  ObjAnimate( "spr_towerroof3_lamp_red_light", "alp", 1, 0, "", 
  { 
    0.0, 0, 1,
    1.0, 0, 0.4,
    2.0, 0, 1,
  } );

end;
--*********************************************************************************************************************
function private.Lodgment3CapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_lodgment3_use_amuletrainbow3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_lodgment3_safe_left" );
  AnimPlay( "anm_lodgment3_box_cap_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Lodgment3DoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_lodgment3_use_blowtorch3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_zz_lodgment3_box_right" );
  AnimPlay( "anm_lodgment3_safe_door_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Revitalizer3VitruvianamuletCapClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_revitalizer3_use_vitruvianamulet3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_xx_rm_towerroof3_tab_man" );
  ObjAnimate( "anm_revitalizer3_use_vitruvianamulet", "pos_x", 0, 0, func_end, 
  { 
    0.0, 0, 0,
    0.3, 0, - 2,
    0.6, 0, 0,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Revitalizer3 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Revitalizer3Start ()

    cmn.MiniGameShow( "revitalizer3" );
    common_impl.PassingMgStart( "revitalizer3" );

    ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos = {};

    for i = 1, 4 do
      ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos[ i ] = private.primary_crystal_pos[ i ];
    end;
    
  end;
  --*********************************************************************************************************************
  function private.Revitalizer3Load ()

    for i = 1, 4 do

      local cur_pos = ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos[ i ];
      local cur_ang = private.pos_parameter[ i ][ cur_pos ][ 1 ];

      ObjSet( "obj_revitalizer3_crystal_"..i.."_turn", { ang = cur_ang } );

      if cur_pos == private.win_crystal_pos[ i ] then
        ObjSet( "obj_revitalizer3_crystal_"..i.."_crop", { croprect_init = false } );
      else
        ObjSet( "obj_revitalizer3_crystal_"..i.."_crop", {
                                                            croprect_init = true,
                                                            croprect_x = private.pos_parameter[ i ][ cur_pos ][ 2 ],
                                                            croprect_y = private.pos_parameter[ i ][ cur_pos ][ 3 ],
                                                            croprect_w = private.pos_parameter[ i ][ cur_pos ][ 4 ],
                                                            croprect_h = private.pos_parameter[ i ][ cur_pos ][ 5 ]
                                                          } );
      end; 

    end;

  end;
  --*********************************************************************************************************************
  function private.Revitalizer3Skip ()

    int.Lock( true ); 

    for i = 1, 4 do
      ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos[ i ] = private.win_crystal_pos[ i ];
    end;

    private.Revitalizer3Load();

    cmn.WaitAndRun( function() private.Revitalizer3Win() end );

  end;
  --*********************************************************************************************************************
  function private.Revitalizer3Reset ()

    for i = 1, 4 do
      ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos[ i ] = private.primary_crystal_pos[ i ];
    end;
    private.Revitalizer3Load();

  end;
  --*********************************************************************************************************************
  function private.Revitalizer3Init ()

    private.pos_parameter = {
                             {
                               { 0, - 270, - 200, 500, 140 },
                               { - 2.7, - 300, - 171, 500, 500 },
                               { - 4.39 }
                             },
                             {
                               { 0, - 270, - 234, 500, 500 },
                               { - 2.13, - 259, - 264, 500, 135 },
                               { - 4.47 }
                             },
                             {
                               { 0, 95, - 280, 500, 500 },
                               { - 1.54 },
                               { - 3.66, - 300, - 271, 500, 490 }
                             },
                             {
                               { 0, - 227, - 250, 500, 500 },
                               { - 2.31 },
                               { - 4.1, - 230, - 258, 130, 500 }
                             },
                            };

    for i = 1, 4 do
      
      ObjSet( "obj_revitalizer3_crystal_"..i,
      {
        event_mdown  = function () private.Revitalizer3CrystalClk( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );
        
    end;

    private.crystal_link = { 2, 4, 1, 3 };

    private.primary_crystal_pos = { 1, 1, 1, 1 };

    private.win_crystal_pos = { 3, 3, 2, 2 };

--    private.Revitalizer3TurnSet( 2 );
--    private.Revitalizer3TurnSet( private.crystal_link[ 2 ] );
--
--    private.Revitalizer3TurnSet( 3 );
--    private.Revitalizer3TurnSet( private.crystal_link[ 3 ] );
--
--    private.Revitalizer3TurnSet( 1 );
--    private.Revitalizer3TurnSet( private.crystal_link[ 1 ] );

  end;
  --*********************************************************************************************************************
  function private.Revitalizer3CrystalClk ( id )

    local rnd = math.random( 3 );
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_crystals_mechanism_klick_"..rnd );

    private.tmp = { 0, 0, 0, 0 };

    for i = 1, 4 do
      private.tmp[ i ] = ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos[ i ];
    end;

    local func_anim_end = function ()

      local win = true;
      for i = 1, 4 do
        if private.tmp[ i ] ~= private.win_crystal_pos[ i ] then
          win = false;
          break;
        end;
      end;

      if win then
        private.Revitalizer3Win(); 
      else
        for i = 1, 4 do
          ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos[ i ] = private.tmp[ i ];
        end;
        int.Lock( false );
      end; 

    end;

    int.Lock( true );
    private.Revitalizer3TurnAnim( id );
    private.Revitalizer3TurnAnim( private.crystal_link[ id ] );

    cmn.WaitAndRun( func_anim_end, 0.4 );

  end;
  --*********************************************************************************************************************
  function private.Revitalizer3TurnAnim ( id )

    local cur_pos = ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos[ id ];
    local new_pos = ng_global.progress[ "std" ][ "win_revitalizer3" ].crystal_pos[ id ] + 1;

    if new_pos == 4 then
      new_pos = 1;
    end;

    local cur_ang = private.pos_parameter[ id ][ cur_pos ][ 1 ];
    local new_ang = private.pos_parameter[ id ][ new_pos ][ 1 ];

    if new_pos == 1 then
      new_ang = new_ang - 6.28;
    end;

    local func_end = function ()

      ObjSet( "anm_revitalizer3_crystal_ray_"..id, { alp = 1, playing = true } );

      if new_pos == 1 then
        ObjSet( "obj_revitalizer3_crystal_"..id.."_turn", { ang = 0 } );
      end; 

      if new_pos ~= private.win_crystal_pos[ id ] then

        ObjSet( "obj_revitalizer3_crystal_"..id.."_crop", {
                                                            croprect_init = true,
                                                            croprect_x = private.pos_parameter[ id ][ new_pos ][ 2 ],
                                                            croprect_y = private.pos_parameter[ id ][ new_pos ][ 3 ],
                                                            croprect_w = private.pos_parameter[ id ][ new_pos ][ 4 ],
                                                            croprect_h = private.pos_parameter[ id ][ new_pos ][ 5 ]
                                                          } );
      end;

      private.tmp[ id ] = new_pos;

    end;

    ObjSet( "anm_revitalizer3_crystal_ray_"..id, { alp = 0, playing = false } );
    ObjSet( "obj_revitalizer3_crystal_"..id.."_crop", { croprect_init = false } );
    ObjAnimate( "obj_revitalizer3_crystal_"..id.."_turn", "ang", 0, 0, func_end, 
    { 
      0.0, 0, cur_ang,
      0.3, 0, new_ang,
    } );

  end;
  --*********************************************************************************************************************
  function private.Revitalizer3TurnSet ( id )

    local cur_pos = private.primary_crystal_pos[ id ];
    local new_pos = private.primary_crystal_pos[ id ] + 1;

    if new_pos == 4 then
      new_pos = 1;
    end;

    local cur_ang = private.pos_parameter[ id ][ cur_pos ][ 1 ];
    local new_ang = private.pos_parameter[ id ][ new_pos ][ 1 ];

    if new_pos == 1 then
      new_ang = new_ang + 6.28;
    end;

    if new_pos == 1 then
      ObjSet( "obj_revitalizer3_crystal_"..id.."_crop", { croprect_init = false } );
      ObjSet( "obj_revitalizer3_crystal_"..id.."_turn", { ang = 0 } );
    else
      ObjSet( "obj_revitalizer3_crystal_"..id.."_crop", {
                                                          croprect_init = true,
                                                          croprect_x = private.pos_parameter[ id ][ new_pos ][ 2 ],
                                                          croprect_y = private.pos_parameter[ id ][ new_pos ][ 3 ],
                                                          croprect_w = private.pos_parameter[ id ][ new_pos ][ 4 ],
                                                          croprect_h = private.pos_parameter[ id ][ new_pos ][ 5 ]
                                                        } );
    end; 

    ObjSet( "obj_revitalizer3_crystal_"..id.."_turn", { ang = new_ang } );

    private.primary_crystal_pos[ id ] = new_pos;

  end;
  --*********************************************************************************************************************
  function private.Revitalizer3Win () 

    local func_end = function ()

      cmn.MiniGameHide( "revitalizer3" );
      cmn.SetEventDone( "win_revitalizer3" );
      cmn.CallEventHandler( "win_revitalizer3" );
      common_impl.PassingMgWin( "revitalizer3" );
      cmn.CloseSubRoom();
      int.Lock( false );
      private.VidFight();

      interface.KeyTaskDone( false );

    end;

    ObjAnimate( "spr_revitalizer3_crystal", "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );
    ObjAnimate( "obj_revitalizer3_chargedcrystal", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );
          
  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG Generator3 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
  function private.Generator3Start ()

    cmn.MiniGameShow( "generator3" );
    common_impl.PassingMgStart( "generator3" );
    
    ng_global.progress[ "std" ][ "win_generator3" ].pos = { 0, 0, 1, 1, 0, 1 };
    
  end;
  --*********************************************************************************************************************
  function private.Generator3Load ()

    for i = 1, 6 do

      if ng_global.progress[ "std" ][ "win_generator3" ].pos[ i ] == 1 then

        ObjSet( "spr_generator3_lever"..i, { alp = 0, input = false } );
        ObjSet( "spr_generator3_lever"..i.."_up", { alp = 1, input = true } );
        ObjSet( "spr_generator3_light_red"..i, { alp = 0 } );
        ObjSet( "spr_generator3_light_green"..i, { alp = 1 } );

      else

        ObjSet( "spr_generator3_lever"..i, { alp = 1, input = true } );
        ObjSet( "spr_generator3_lever"..i.."_up", { alp = 0, input = false } );
        ObjSet( "spr_generator3_light_red"..i, { alp = 1 } );
        ObjSet( "spr_generator3_light_green"..i, { alp = 0 } );

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.Generator3Skip ()

    int.Lock( true );
    ng_global.progress[ "std" ][ "win_generator3" ].pos = { 1, 1, 1, 1, 1, 1 };
    private.Generator3Load();

    local func_end = function ()
      private.Generator3Win();
    end;
    cmn.WaitAndRun( func_end, 0.6 );

  end;
  --*********************************************************************************************************************
  function private.Generator3Reset ()

    ng_global.progress[ "std" ][ "win_generator3" ].pos = { 0, 0, 1, 1, 0, 1 };
    private.Generator3Load();

  end;
  --*********************************************************************************************************************
  function private.Generator3Init ()

    for i = 1, 6 do
      
      ObjSet( "spr_generator3_lever"..i.."_up",
      {
        event_mdown  = function () private.Generator3Clk( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );
        
    end;

    for i = 1, 6 do
      
      ObjSet( "spr_generator3_lever"..i,
      {
        event_mdown  = function () private.Generator3Clk( i ) end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      } );
        
    end;

    private.link = { 
                     { 2, 3 },
                     { 4 },
                     { 6 },
                     { 1, 5, 2 },
                     { 2 },
                     { 5 }
                   };

  end;
  --*********************************************************************************************************************
  function private.Generator3Clk ( id )

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_transistors_click" );

    private.tmp = { 0, 0, 0, 0, 0, 0 };

    for i = 1, 6 do
      private.tmp[ i ] = ng_global.progress[ "std" ][ "win_generator3" ].pos[ i ];
    end;

    private.Generator3Anim( id );

    for i = 1, #private.link[ id ] do
      private.Generator3Anim( private.link[ id ][ i ] );
    end;

    local func_end = function ()

      local win = true;

      for i = 1, 6 do
        if private.tmp[ i ] ~= 1 then
          win = false;
          break;
        end;
      end;

      if win then

        private.Generator3Win();

      else

        for i = 1, 6 do
          ng_global.progress[ "std" ][ "win_generator3" ].pos[ i ] = private.tmp[ i ];
        end;

        int.Lock( false );

      end;
      
    end;

    int.Lock( true );
    cmn.WaitAndRun( func_end, 0.4 );

  end;
  --*********************************************************************************************************************
  function private.Generator3Anim ( id )

    local name_app, name_dis, name_app_light, name_dis_light;
    local pos = private.tmp[ id ];

    if pos == 1 then
      name_app = "spr_generator3_lever"..id;
      name_dis = "spr_generator3_lever"..id.."_up";
      name_app_light = "spr_generator3_light_red"..id;
      name_dis_light = "spr_generator3_light_green"..id;
      pos = 0;
    else
      name_app = "spr_generator3_lever"..id.."_up";
      name_dis = "spr_generator3_lever"..id;
      name_app_light = "spr_generator3_light_green"..id;
      name_dis_light = "spr_generator3_light_red"..id;
      pos = 1;
    end; 

    local func_end = function ()

      private.tmp[ id ] = pos;
      ObjSet( name_app, { input = true } );
      ObjSet( name_dis, { input = false } );

    end;

    ObjAnimate( name_app, "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );
    ObjAnimate( name_dis, "alp", 0, 0, "", 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );
    ObjAnimate( name_app_light, "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      0.3, 0, 1,
    } );
    ObjAnimate( name_dis_light, "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1,
      0.3, 0, 0,
    } );

  end;
  --*********************************************************************************************************************
  function private.Generator3Win ()

    cmn.MiniGameHide( "generator3" );
    cmn.SetEventDone( "win_generator3" );
    cmn.CallEventHandler( "win_generator3" );
    common_impl.PassingMgWin( "generator3" ); 
    int.Lock( false );       

    interface.KeyTaskDone( true, "task_3_7" );

  end;        
--*********************************************************************************************************************