-- name=rm_workshop3
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_workshop3";

  ObjAttach( "zz_worktable3", "room_hub" );

  private.InitSubroom();
  private.InitAnimations();

  ObjMultiSet(
  {
    { "spr_workshop3_collect_2_3", { event_mdown = private.get_collect_2_3 } },
  } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_workshop3 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_workshop3", update_game_mode_workshop3, private.room_objname );  

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.InitMorphRandomState( 3 );

  end;

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_2_3 = function ()

    ObjDelete( "spr_workshop3_collect_2_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_2_3", get_collect_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_2_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_2_6 = function ()

    ObjDelete( "obj_workshop3_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_2_6", get_morphobject_2_6, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_workshop3 ()

  if not ( cmn.IsEventDone( "opn_workshop3" ) ) then

    cmn.SetEventDone( "opn_workshop3" );

  end;

  cmn.StopAllEnv( "audio/level2/env/aud_rm_workshop2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_rm_workshop2_env", 1 );

end;
-----------------------------------------------------------------------
function private.get_collect_2_3 ()

  int.AddCollectibles( "spr_workshop3_collect_2_3" );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_workshop3();

end;
--*********************************************************************************************************************
function public.Task ()

  --int.AddedTaskMap( private.room_objname, "", { "" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_worktable3" );
  -----------------------------------------------
  function zz_worktable3.Close ()

    cmn.NoteScaleEnd( { "spr_worktable3_note2" }, true );

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************