-- name=ho_hogargoyle
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hogargoyle" );
  game.relations[ "ho_hogargoyle" ].exitroom = "rm_pagantemple";
  private.room_objname = "ho_hogargoyle";
  private.task_name = "win_hogargoyle";  
  
  private.win_hogargoyle = {};    

  --------------------------------------------------------------------------------------------
  -- function opn_hogargoyle () end;
  --------------------------------------------------------------------------------------------
  local opn_hogargoyle = function ()

  end;

  cmn.AddSubscriber( "opn_hogargoyle", opn_hogargoyle, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "get",
    get_obj = "spr_hogargoyle_wolfamulet",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------------
  local win_hogargoyle_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_wolfamulet", "spr_hogargoyle_win" );
      ObjDelete( "gho_pagantemple_hogargoyle" );

    end;

  end;
  cmn.AddSubscriber( "win_hogargoyle", win_hogargoyle_func );
  --------------------------------------------------------------------------------------------------
  local start_hogargoyle_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

      common_impl.ProcessHoStart( "hogargoyle" );
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hogargoyle", start_hogargoyle_func, "ho_hogargoyle" );
  --------------------------------------------------------------------------------------------------
  private.win_hogargoyle.task = { "item_1", "item_2", "item_3", "item_4", 
               "item_5", "item_6", "item_7", "item_8", 
               "item_9", "item_10", "item_11", "item_12" };
  for i = 1, #private.win_hogargoyle.task do

    ObjSet( "spr_hogargoyle_"..private.win_hogargoyle.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hogargoyle.task[ i ] ); end } );

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hogargoyle" );

  end;

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_hogargoyle" ) ) then

      cmn.SetEventDone( "opn_hogargoyle" );
      cmn.CallEventHandler( "opn_hogargoyle" );
      cmn.ShowBbt( "bbt_hogargoyle_first_enter" );

  end;        

  local ho_tasks = {};
  
  for i = 1, #private.win_hogargoyle.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hogargoyle.task[ i ], 1, 0, { { "spr_hogargoyle_"..private.win_hogargoyle.task[ i ]  } } );
    
  end; 
  
  int.TaskPanelShow( ho_tasks );
  private.PanelShow();
  
  cmn.StopAllMus();
  cmn.StopAllEnv( "audio/level2/env/aud_ho_hogargoyle_env" );
  cmn.PlayAudio( "env", "audio/level2/env/aud_ho_hogargoyle_env", 1, 1 );
  --cmn.PlayAudio( "mus", "audio/aud_ho_game1_mus", 1, 1 );     

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.StopMusEnv( false );

  cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  --cmn.StopAudio( "mus", "audio/aud_ho_game1_mus", 0.5 );
  common_impl.PlayMusEnv();  

  cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  private.PanelHide();
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  if (name == "item_1") then
    ObjSet( "spr_hogargoyle_item_1", { res = "assets/levels/levelext/ho_hogargoyle/anims/item_1" } );
    ObjSet( "anm_hogargoyle_item_1", { alp = 0 } );
  elseif ( name == "item_2") then
    ObjSet( "spr_hogargoyle_item_2", { res = "assets/levels/levelext/ho_hogargoyle/anims/item_2" } ); 
    ObjSet( "anm_hogargoyle_item_2", { alp = 0 } );   
  end;  
  
  local postfix = "";
  if ( number ) then postfix = "_"..number; end;
  cmn.HoTaskFind( "spr_hogargoyle_"..name..postfix, name );
  common_impl.PassingHoCheck();  

end;
--*********************************************************************************************************************
function private.PanelShow ( )

  ObjSet( "int_inventory_impl", { input = false } );
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  
  ObjSet( "obj_int_taskpanel_task_1", { pos_x = 70 } );  
  ObjSet( "obj_int_taskpanel_task_2", { pos_x = 213 } );  
  ObjSet( "obj_int_taskpanel_task_3", { pos_x = 356 } );  
  ObjSet( "obj_int_taskpanel_task_4", { pos_x = 500 } );   
  ObjSet( "obj_int_taskpanel_task_5", { pos_x = 70 } );  
  ObjSet( "obj_int_taskpanel_task_6", { pos_x = 213 } );  
  ObjSet( "obj_int_taskpanel_task_7", { pos_x = 356 } );  
  ObjSet( "obj_int_taskpanel_task_8", { pos_x = 500 } );   
  ObjSet( "obj_int_taskpanel_task_9", { pos_x = 70 } );  
  ObjSet( "obj_int_taskpanel_task_10", { pos_x = 213 } );  
  ObjSet( "obj_int_taskpanel_task_11", { pos_x = 356 } );  
  ObjSet( "obj_int_taskpanel_task_12", { pos_x = 500 } );  

end;
--*********************************************************************************************************************
function private.PanelHide ( )  
  
  ObjSet( "int_inventory_impl", { input = true } );
  ObjSet( "obj_int_taskpanel", { alp = 1 } );  
  
  ObjSet( "obj_int_taskpanel_task_1", { pos_x = 40 } );  
  ObjSet( "obj_int_taskpanel_task_2", { pos_x = 220 } );  
  ObjSet( "obj_int_taskpanel_task_3", { pos_x = 385 } );  
  ObjSet( "obj_int_taskpanel_task_4", { pos_x = 550 } );   
  ObjSet( "obj_int_taskpanel_task_5", { pos_x = 40 } );  
  ObjSet( "obj_int_taskpanel_task_6", { pos_x = 220 } );  
  ObjSet( "obj_int_taskpanel_task_7", { pos_x = 385 } );  
  ObjSet( "obj_int_taskpanel_task_8", { pos_x = 550 } );   
  ObjSet( "obj_int_taskpanel_task_9", { pos_x = 40 } );  
  ObjSet( "obj_int_taskpanel_task_10", { pos_x = 220 } );  
  ObjSet( "obj_int_taskpanel_task_11", { pos_x = 385 } );  
  ObjSet( "obj_int_taskpanel_task_12", { pos_x = 550 } );     
  
end;   
--*********************************************************************************************************************
--*********************************************************************************************************************