-- name=ho_homagiccube
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_homagiccube" );
  game.relations[ "ho_homagiccube" ].exitroom = "rm_prison";
  private.room_objname = "ho_homagiccube";

  private.task_name = "win_homagiccube";  
  
  private.win_homagiccube = {};
  private.win_homagiccube.sound_counter = 0;  
  private.side = 1;
  private.last_side = 2;  
  private.check_panel_i = 1;
  private.check_panel_tmp = 1;    
  --------------------------------------------------------------------------------------------
  -- function opn_homagiccube () end;
  --------------------------------------------------------------------------------------------
  local opn_homagiccube = function ()

  end;

  cmn.AddSubscriber( "opn_homagiccube", opn_homagiccube, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    use_place = "gho_deploy_inv_magiccube_homagiccube",
    room = "int_deploy_inv",
    zz = "deploy_inv_magiccube",
    zz_gate = "inv_magiccube"      
  };
  --------------------------------------------------------------------------------------------------
  local win_homagiccube_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemRemove( "inv_magiccube" );      
      int.InventoryItemAdd( "inv_theseusfigurine", "spr_homagiccube_win" );
      ObjDelete( "gho_prison_homagiccube" );
      ObjDelete( "obj_homagiccube_panel" );         

    end;

  end;
  cmn.AddSubscriber( "win_homagiccube", win_homagiccube_func );
  --------------------------------------------------------------------------------------------------
  local start_homagiccube_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

      common_impl.ProcessHoStart( "homagiccube" );
      
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
        
        local task_name = ho_found[ i ][ "task" ];
               
        ObjDelete( "spr_homagiccube_side"..private.GetSideByName( task_name ).."_"..task_name );
        ObjDelete( "spr_homagiccube_side"..private.GetSideByName( task_name ).."_"..task_name.."_shadow" );        
        ObjDelete( "obj_homagiccube_use_"..task_name );
        ObjSet( "spr_homagiccube_done_side"..private.GetDoneSideByName( task_name ).."_"..task_name, { alp = 1 } );
        
      end;       

    end;

  end;
  cmn.AddSubscriber( "win_homagiccube", start_homagiccube_func, "ho_homagiccube" );
  --------------------------------------------------------------------------------------------------
  private.win_homagiccube.task = { "ball", "bench", "bridge", "bush", "clock", "gargoyle", 
                                    "lamp", "pavingstone", "plate", "redbush", "roof", "stairs" };
                  
  for i = 1, #private.win_homagiccube.task do

    local task_name = private.win_homagiccube.task[ i ];
    local obj_name = "spr_homagiccube_side"..private.GetSideByName(task_name).."_"..task_name;
    
    ObjSet( obj_name, { 
      event_mdown = function () private.FindItem( obj_name, i ); end, 
      input = false } );
      
    ObjSet( "obj_homagiccube_use_"..task_name, { 
      event_mdown = function () cmn.ShowBbt( "bbt_homagiccube_use"..task_name ); end, 
      event_menter = function () cmn.SetCursor( CURSOR_USE ); end, 
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,         
      } );      

  end;
    
    
    
  --ObjSet( "spr_hopast2_obj_"..i.."_"..j, { drag = true, event_dragdrop = function () private.DropPart( i, j ) end } );    
    
  ObjSet( "obj_homagiccube_button_changeside", {  
    event_mdown = function () private.ChangeSide( ) end,
    event_menter = function () private.ChangeSideEnter () end,
    event_mleave = function () private.ChangeSideLeave () end      
  } );      
  
end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()  

  cmn.InterfaceSetVisible( true );
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "homagiccube" );

  end;

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventDone( "opn_homagiccube" ) ) then

      cmn.SetEventDone( "opn_homagiccube" );
      cmn.CallEventHandler( "opn_homagiccube" );
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].exitroom = 
        game.relations[ "ho_homagiccube" ].exitroom;      
      
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].side = 1;
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].finded = { 0,0,0,0,0,0,0,0,0,0,0,0 };   
      
      cmn.ShowBbt( "bbt_homagiccube_first_enter" );

  end;        

  local ho_tasks = {};
  
  for i = 1, #private.win_homagiccube.task do

    local task_name = private.win_homagiccube.task[ i ];
    
    local get_sprite = "spr_homagiccube_side"..private.GetSideByName(task_name).."_"..task_name;
    local use_place = "obj_homagiccube_use_inv_"..task_name;
    local obj_hint = "obj_homagiccube_"..task_name.."_inv_hint";
    local button_change = "obj_homagiccube_use_btn_"..task_name;    
        
    interface.TaskPanelTaskAdd( ho_tasks, task_name, 1, 0, { { get_sprite  },{ obj_hint, use_place, button_change } } );
    
  end; 
  
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  private.SetSide( ng_global.progress[ ng_global.currentprogress ][ private.task_name ].side );  
  cmn.StopAllMus();
  
  game.relations[ "ho_homagiccube" ].exitroom = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].exitroom;
  
  ObjSet( "grm_homagiccube_prison", {  
      event_mdown = function () cmn.GotoRoom( game.relations[ "ho_homagiccube" ].exitroom ); end,
      event_menter = function() cmn.GateMouseEnter( CURSOR_DOWN, common.GetObjectName(game.relations[ "ho_homagiccube" ].exitroom), "grm_homagiccube_prison" ); end
  } );   

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.StopMusEnv( false );    

  cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

  cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );    
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_homagiccube_panel","ho_homagiccube" );
  
  for i = 1,#private.win_homagiccube.task do 

     local obj = "obj_"..i;
     ObjDelete( obj );

  end;    
   
  common_impl.PlayMusEnv();    
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.ChangeSideEnter()
  
  cmn.SetCursor( CURSOR_HAND );
  
  ObjSet( "spr_homagiccube_button_changeside_arrow_add_back", { alp = 1 } );
  ObjSet( "spr_homagiccube_button_changeside_arrow_add", { alp = 1 } );  
  
end;
--*********************************************************************************************************************
function private.ChangeSideLeave()
  
  cmn.SetCursor( CURSOR_DEFAULT );
  
  ObjSet( "spr_homagiccube_button_changeside_arrow_add_back", { alp = 0 } );
  ObjSet( "spr_homagiccube_button_changeside_arrow_add", { alp = 0 } );   
  
end;
--*********************************************************************************************************************
function private.ChangeSide()
  
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgcube_click" );
  
  local next_side = 1;
  
  if (private.side == 1) then
    
    next_side = 2;
    
  end;
  
  private.SetSide(next_side);
  
end;
--*********************************************************************************************************************
function private.SetSide( number )  
  
  for i = 1, #private.win_homagiccube.task do

    local task_name = private.win_homagiccube.task[ i ];
    
    ObjSet( "spr_homagiccube_side"..private.GetSideByName(task_name).."_"..task_name, { input = false } ); 
    
    ObjSet( "obj_homagiccube_use_inv_"..task_name, { input = false } );
    ObjSet( "obj_homagiccube_"..task_name.."_inv_hint", { input = false } );    
    ObjSet( "obj_homagiccube_use_btn_"..task_name, { input =false } );
    
  end;   
  
  private.last_side = 2;  
  
  if (1 == private.side) then
    
    private.last_side= 1;
    
  end;  
  
  ObjSet( "spr_homagiccube_side"..private.last_side, { alp = 0 } );    
  ObjSet( "obj_homagiccube_objects_done_side"..private.last_side, { alp = 0 } );   
  ObjSet( "obj_homagiccube_objects_side"..private.last_side, { alp = 0, input = false } );       
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].side = number;
  private.side = number;  

  ObjSet( "spr_homagiccube_side"..private.side, { alp = 1 } );
  ObjSet( "obj_homagiccube_objects_done_side"..private.side, { alp = 1 } );
  ObjSet( "obj_homagiccube_objects_side"..private.side, { alp = 1, input = true } );     
 
    
  for i = 1, #private.win_homagiccube.task do

    local task_name = private.win_homagiccube.task[ i ];
    
    if ( ObjGet( "obj_homagiccube_use_"..task_name ) ) then
    
      local relations = ObjGetRelations( "obj_homagiccube_use_"..task_name ); 
     
      if ( ObjGet( "spr_homagiccube_"..task_name.."_inv" ) ) then      
        
        if ( ObjGet( "spr_homagiccube_"..task_name.."_inv" ).input ) then         
          
          if (ObjGet( ObjGetRelations(relations.parent).parent ).input ) then     
        
            ObjSet( "obj_homagiccube_use_inv_"..task_name, { input = true } );
            ObjSet( "obj_homagiccube_"..task_name.."_inv_hint", { input = true } );    
      
          else 
      
            if ( ObjGet( "obj_homagiccube_use_btn_"..task_name ) ) then
        
              ObjSet( "obj_homagiccube_use_btn_"..task_name, { input = true } );
        
            end;      
            
          end;
          
        else         
          --DbgTrace( "1 spr_homagiccube_side"..private.GetSideByName(task_name).."_"..task_name );
          if ( not ObjGet( "spr_homagiccube_side"..private.GetSideByName(task_name).."_"..task_name ).input ) then
            --DbgTrace( ObjGetRelations( "2 spr_homagiccube_side"..private.GetSideByName(task_name).."_"..task_name ).parent );
            if not ( ObjGet( ObjGetRelations( "spr_homagiccube_side"..private.GetSideByName(task_name).."_"..task_name ).parent ).input ) then               

              if ( ObjGet( "obj_homagiccube_use_btn_"..task_name ) ) then

                ObjSet( "obj_homagiccube_use_btn_"..task_name, { input = true } );
          
              end;   
            
            end;  

          end;          
          
        end;
        
      end;      
      
    end;
    
  end;           
 
  --DbgTrace( "SetSide "..private.last_side.." -> "..private.side );  
  
  if (private.side == 1) then
    
    ObjSet( "obj_homagiccube_buttons", { scale_x = 1, scale_y = 1 } );
    
  else
    
    ObjSet( "obj_homagiccube_buttons", { scale_x = -1, scale_y = -1 } );    
    
  end;
  
  private.CheckPanel ( private.check_panel_i, private.check_panel_tmp );
  
end;
--*********************************************************************************************************************
function private.GetSide()
  
  return private.side; 
  
end;
--*********************************************************************************************************************
function private.GetSideByName( name )
  
  local side = 2;
  
  if ( name == "gargoyle" or
    name == "clock" or
    name == "bush" or
    name == "bench" or
    name == "redbush" ) then
    
    side = 1;
    
  end;
  
  return side;
  
end;
--*********************************************************************************************************************
function private.GetDoneSideByName( name )
  
  local side = 1;
  
  if ( name == "gargoyle" or
    name == "bush" or
    name == "bench" or
    name == "redbush" ) then
    
    side = 2;
    
  end;
  
  return side;
  
end;
--*********************************************************************************************************************
function private.Panel ()
  
  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_homagiccube_panel" , "spr_int_taskpanel" );
  
  if ( not ng_global.progress[ ng_global.currentprogress ]["win_homagiccube"].task_check ) then

    ng_global.progress[ng_global.currentprogress]["win_homagiccube"].task_check = { 0,0,0,0,0,0,0,0,0,0,0,0 };

  end;

  local posx = -175;

  ObjSet( "obj_homagiccube_panel", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 560, croprect_h = 400 } );

  for i = 1,#private.win_homagiccube.task do 

     local obj = "obj_"..i;
     local task_name = private.win_homagiccube.task[ i ];         

    if ( ng_global.progress[ng_global.currentprogress]["win_homagiccube"].task_check[i] == 0 ) and
      ( not ObjGet( obj ) ) then

      ObjCreate( obj, "obj" );
      ObjAttach( obj, "obj_homagiccube_panel" );
      ObjSet( obj, { pos_x = posx, pos_y = 24, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = false  } );
      
      local spr_lamp = "spr_homagiccube_"..task_name.."_inv2";
      ObjCreate( spr_lamp, "spr" );
      ObjSet( spr_lamp, { 
        res = "assets/levels/levelext/ho_homagiccube/layers/inv/"..task_name.."2", 
        scale_x = 1, 
        scale_y = 1,
        input = false;
      } );
      ObjAttach( spr_lamp, obj );
      
      local spr = "spr_homagiccube_"..task_name.."_inv";
      ObjCreate( spr, "spr" );
      ObjSet( spr, { 
      res = "assets/levels/levelext/ho_homagiccube/layers/inv/"..task_name, 
        alp = 0, 
        scale_x = 1, 
        scale_y = 1,
        input = false,
        inputrect_init = true,
        inputrect_x = -50,
        inputrect_y = -50,
        inputrect_w = 100,
        inputrect_h = 100,          
        drag = true,
        event_startdrag = function () private.GetItem( spr, i ); end,
        event_dragdrop = function () private.UseItem( spr, i ); end,           
      } );
      ObjAttach( spr, obj );
      
      local obj_hint = "obj_homagiccube_"..task_name.."_inv_hint";      
      ObjCreate( obj_hint, "obj" );
      ObjSet( obj, { input = false  } );  
      ObjAttach( obj_hint, obj );      

      posx = posx + 95;

    end;
      
    if (  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].finded[ i ] == 1 ) then

      --DbgTrace( "task_name = "..tostring( task_name ) );

      ObjDelete( "spr_homagiccube_side"..private.GetSideByName( task_name ).."_"..task_name );
      ObjDelete( "spr_homagiccube_side"..private.GetSideByName( task_name ).."_"..task_name.."_shadow" );        
      ObjDelete( "spr_homagiccube_"..task_name.."_inv2" );
      ObjSet( "spr_homagiccube_"..task_name.."_inv", { alp = 1, input = true } );

    end;          

  end;      
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( ) 
   
  local tmp = 0;    
    
  for i = 1,#private.win_homagiccube.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress[ng_global.currentprogress]["win_homagiccube"].task_check[i] == 0 ) then

        tmp = tmp + 1;       
       
        if ( tmp < 6 ) then
          
          ObjSet( obj, { input = 1 } );

          if ( ObjGet( obj ).alp == 0 ) then
          
            ObjAnimate( obj, "alp", 0, 0, "", 
            { 
              0,0,0, 
              0.3,0,1 
            });
            
          end;

          ObjSet( "spr_homagiccube_side"..private.GetSide().."_"..private.win_homagiccube.task[i], { alp = 1, input = true } );                             
          --DbgTrace( "private.CheckPanel ".."spr_homagiccube_side"..private.GetSide().."_"..private.win_homagiccube.task[i] );        
          
        end;

     end;

  end;    
   
end; 
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;
  local panel_sound = false;

      for i = tmp,#private.win_homagiccube.task do

          local obj_tmp = "obj_"..i;

          if obj_tmp ~= nil and ng_global.progress[ ng_global.currentprogress ][ "win_homagiccube" ].task_check[ i ] ~= 1 then

              if not panel_sound then
                --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_fakel_click" );
                panel_sound = true;
              end;

              ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_"..i ).pos_x-95
              });

              if ObjGet( "obj_"..i ).pos_x-95 == 205 then

                  ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;  
--*********************************************************************************************************************
function private.Check ( num )  

--   local tmp = 0;
--
--   for i = 1,#private.win_homagiccube.task do
--
--       local item = "obj_"..i;
--
--       if ( item and ng_global.progress[ ng_global.currentprogress ][ "win_homagiccube" ].task_check[ i ] ~= 1 ) then
--
--          tmp = tmp + 1;
--
--          if ( tmp < 6 ) then
--
--             ObjSet( "spr_homagiccube_"..private.win_homagiccube.task[ i ], { alp = 1, input = 1 } );
--
--          end;
--
--          num = num + 1;
--
--       end;
--
--   end;
--   
--   local func_end = function () int.Lock( false ) end;
--
--   ObjAnimate( "ho_homagiccube", "alp", 0, 0, func_end, 
--   { 
--    0,3,1, 
--    0.6,3,1
--   });

  private.SetSide( private.GetSide() );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, num )

  ng_global.progress[ ng_global.currentprogress ][ "win_homagiccube" ].task_check[ num ] = 1;  
  
  private.AnimInv ( num );
  
  cmn.HoTaskFind( "spr_homagiccube_"..name, name );
  
  common_impl.PassingHoCheck();
end;
--*********************************************************************************************************************
function private.FindItem ( name, number )

  cmn.GetObjectSfx();  
  
  local exactly_name = string.sub(name, 23);
  
  ObjDelete( name );  
  ObjDelete( name.."_shadow" );  
  ObjDelete( "spr_homagiccube_"..exactly_name.."_inv2" );
  ObjSet( "spr_homagiccube_"..exactly_name.."_inv", { alp = 1, input = true } );
  
  local relations = ObjGetRelations( "obj_homagiccube_use_"..exactly_name ); 

  if ( ObjGet( ObjGetRelations(relations.parent).parent ).input ) then     
  
    ObjSet( "obj_homagiccube_use_inv_"..exactly_name, { input = true } );
    ObjSet( "obj_homagiccube_"..exactly_name.."_inv_hint", { input = true } );
    
  else
    
    if ( ObjGet( "obj_homagiccube_use_btn_"..exactly_name ) ) then
    
      ObjSet( "obj_homagiccube_use_btn_"..exactly_name, { input = true } );
      
    end;
    
  end;  
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].finded[ number ] = 1;  

end;
--*********************************************************************************************************************
function private.GetItem ( name, num )

  local exactly_name = common.GetObjectPrefix( string.sub(name, 17) );
  
  ObjAttach( name, "int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.UseItem ( name, num )

  local exactly_name = common.GetObjectPrefix( string.sub(name, 17) ); 

  local relations = ObjGetRelations( "obj_homagiccube_use_"..exactly_name );  
  
  local item = "spr_homagiccube_"..private.win_homagiccube.task[num].."_inv";   
  
  local bool = true;
  
  SetCursor( CURSOR_DEFAULT );

  if ( ObjIntersect( item, "obj_homagiccube_use_"..exactly_name ) and
       ObjGet( ObjGetRelations(relations.parent).parent ).input ) then

      bool = false;
      int.Lock( true );

      local func_end = function ()

        private.UseItemEnd( exactly_name, num );

      end;          

      ObjDelete( item );  
      ObjDelete( "obj_"..num ); 
      ObjDelete( "obj_homagiccube_use_"..exactly_name ); 
      
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_hotable1_lock"..math.random( 4 ) );

      --DbgTrace( "private.UseItem show ".."spr_homagiccube_done_side"..private.GetDoneSideByName(exactly_name).."_"..exactly_name );            
      
      ObjAnimate( "spr_homagiccube_done_side"..private.GetDoneSideByName(exactly_name).."_"..exactly_name, "alp", 0, 0, func_end, 
      { 
        0.0,  0,  0,
        0.3,  0,  1
      } );

  end;

  if ( bool ) then

      ObjAttach( item, "obj_"..num );
      --ObjSet( item, { res = "assets/levels/level1/ho_hotable1/layers/amulet_"..num, pos_z = 0 } );
      --ObjSet( item.."_shadow", { alp = 1 } );      
      cmn.WrongApply();

  end;

end;
--*********************************************************************************************************************
function private.UseItemEnd( name, num1 )

  --ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols[ num1 ] = 1;
  --ng_global.progress[ ng_global.currentprogress ][ private.task_name ].symbols_slot[ num1 ] = 1;

  private.CompleteTask( name, num1 );

--  for i = 1,#private.win_hotable1.array_symbols[ num1 ] do
--
--    ObjSet( private.win_hotable1.array_symbols[ num1 ][ i ], { input = true } );        
--      
--  end;
    
    
  int.Lock( false ); 

  --ObjDelete( "obj_hotable1_symbol_"..num1 );
  --ObjDelete( "spr_hotable1_symbol_"..num1.."_overlap" );  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************