-- name=ho_hosafe
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hosafe" );
  
  game.relations[ "ho_hosafe" ].exitroom = "rm_alchemiststore";
  private.room_objname = "ho_hosafe";

  private.task_name = "win_hosafe";  
  
  private.InitAnimations();

  private.win_hosafe = {};
  private.win_hosafe.sound_counter = 0;  
  
  ObjSet( "spr_hosafe_key", { event_mdown = function () private.GetKey(); end } );

  --------------------------------------------------------------------------------------------
  -- function opn_hosafe () end;
  --------------------------------------------------------------------------------------------
  local opn_hosafe = function ()

  end;

  cmn.AddSubscriber( "opn_hosafe", opn_hosafe, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hosafe_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_gatekey", "spr_hosafe_win" );
      ObjDelete( "gho_alchemiststore_hosafe" );
      ObjSet( "spr_alchemiststore_safe_open_smallcap", { alp = 1 });
      ObjDelete( "obj_hosafe_panel" );    

    end;

  end;
  cmn.AddSubscriber( "win_hosafe", win_hosafe_func );
  --------------------------------------------------------------------------------------------------
  local start_hosafe_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

      common_impl.ProcessHoStart( "hosafe" );
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;
      
      if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count >= 12 ) then
            
          ObjDelete( "spr_hosafe_win_door" );
          ObjSet( "spr_hosafe_key", { alp = 1, input = true } );
          ObjSet( "txt_hosafe_task", { alp = 1 } );          

      end;        
      
    end;

  end;
  cmn.AddSubscriber( "win_hosafe", start_hosafe_func, "ho_hosafe" );
  --------------------------------------------------------------------------------------------------
  private.win_hosafe.task = { "obj_1", "obj_2", "obj_3", "obj_4", "obj_5", "obj_6", 
                                    "obj_7", "obj_8", "obj_9", "obj_10", "obj_11", "obj_12" };
                  
  for i = 1, #private.win_hosafe.task do

    ObjSet( "spr_hosafe_"..private.win_hosafe.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hosafe.task[ i ] ); end, input = false } );

  end;

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );  
  
  if ( not cmn.IsEventDone( "opn_hosafe" ) ) then

      cmn.SetEventDone( "opn_hosafe" );
      cmn.CallEventHandler( "opn_hosafe" );
      ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count = 0;  

  end;    
       
  local ho_tasks = {};
  
  for i = 1, #private.win_hosafe.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hosafe.task[ i ], 1, 0, { { "spr_hosafe_"..private.win_hosafe.task[ i ]  } } );
    
  end; 
  
  interface.TaskPanelTaskAdd( ho_tasks, "key", 1, 0, { { "spr_hosafe_key"  } } );
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hosafe" );

  end;  
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  cmn.StopAllMus();
  
end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  common_impl.StopMusEnv( false );  

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );    
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hosafe_panel","ho_hosafe" );
  
  for i = 1,#private.win_hosafe.task do 

     local obj = "obj_"..i;
     ObjDelete( obj );

  end;       
  
  common_impl.PlayMusEnv();  
  
end;

--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_click_whoosh" );
  cmn.HoTaskFind( "spr_hosafe_"..name, name );
  

  for i = 1,#private.win_hosafe.task do

      if ( private.win_hosafe.task[i] == name ) then 

          local object_name = "obj_"..i; 
          local collect_name  = "pfx_hosafe_collect_"..object_name.."_effect";
          ng_global.progress[ ng_global.currentprogress ][ "win_hosafe" ].task_check[ i ] = 1;
          ObjCreate( collect_name, "partsys" );

          if  ( cmn.IsEventDone( "win_hosafe" ) ) then

              --int.Lock( false );

          end;

          ObjSet( collect_name,
          {
            res    = "assets/interface/resources/effects_ho_hint",
            pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
            active = 1, visible = 1, input = 0
          } );

          ObjAttach( collect_name, "obj_hosafe_panel" );
          ObjSet( collect_name, { blendmode = 2, scale_x = 1, scale_y = 1 } );
          --PartSysSetMaskObj( collect_name, object_name );  
          local func_end = function () private.AnimInv( i ); end;
            
          private.win_hosafe.sound_counter = private.win_hosafe.sound_counter + 1;
      
          ObjAnimate( object_name, 8,0,0, func_end,
          { 
              0.0, 0, 1.0,
              0.5, 0, 0.0
          } );
--
      end;

  end;

  common_impl.PassingHoCheck();
  
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count = 
    ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count + 1;
    
  if (ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count >= 12 ) then
        
    local func_end = function ()

      int.Lock( false );
      ObjDelete( "spr_hosafe_win_door" );
      ObjSet( "spr_hosafe_key", { alp = 1, input = true } );
      ObjSet( "txt_hosafe_task", { alp = 1 } );
      cmn.ShowBbt( "bbt_hosafe_first_enter" );

    end;    
    
    ObjAnimate( "spr_hosafe_win_door", "alp", 0, 0, func_end, 
    {
      0.0, 0, 1,
      0.5, 0, 0
    } );
    
  end;

end;
--*********************************************************************************************************************
function private.Panel ()
  
  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hosafe_panel" , "spr_int_taskpanel" );
  
  if ( not ng_global.progress[ ng_global.currentprogress ]["win_hosafe"].task_check ) then

    ng_global.progress[ng_global.currentprogress]["win_hosafe"].task_check = { 0,0,0,0,0,0,0,0,0,0,0,0 };

  end;

  local posx = -175;
  local tmp = 0;

  ObjSet( "obj_hosafe_panel", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 560, croprect_h = 400 } );

  for i = 1,#private.win_hosafe.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress[ng_global.currentprogress]["win_hosafe"].task_check[i] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_hosafe_panel" );
        ObjSet( obj, { pos_x = posx, pos_y = 24, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_hosafe_"..private.win_hosafe.task[i].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/levelext/ho_hosafe/layers/inv/inv_"..private.win_hosafe.task[i], scale_x = 1, scale_y = 1 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

         posx = posx + 95;

        if ( tmp == 12 ) then

          ng_global.progress[ ng_global.currentprogress ][ "win_hosafe" ].set = 1;

        end;

     else

     end;

  end;
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      });

      ObjSet( "spr_hosafe_"..private.win_hosafe.task[i], { alp = 1, input = 1 } );

   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;
  local panel_sound = false;

      for i = tmp,#private.win_hosafe.task do

          local obj_tmp = "obj_"..i;

          if obj_tmp ~= nil and ng_global.progress[ ng_global.currentprogress ][ "win_hosafe" ].task_check[ i ] ~= 1 then

              if not panel_sound then
                --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_fakel_click" );
                panel_sound = true;
              end;

              ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_"..i ).pos_x-95
              });

              if ObjGet( "obj_"..i ).pos_x-95 == 205 then

                  ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

   local tmp = 0;

   for i = 1,#private.win_hosafe.task do

       local item = "obj_"..i;

       if ( item and ng_global.progress[ ng_global.currentprogress ][ "win_hosafe" ].task_check[ i ] ~= 1 ) then

          tmp = tmp + 1;

          if ( tmp < 6 ) then

             ObjSet( "spr_hosafe_"..private.win_hosafe.task[ i ], { alp = 1, input = 1 } );

          end;

          num = num + 1;

       end;

   end;
   
   local func_end = function () int.Lock( false ) end;

   ObjAnimate( "ho_hosafe", "alp", 0, 0, func_end, 
   { 
    0,3,1, 
    0.6,3,1
   });

end;
--*********************************************************************************************************************
function private.GetKey( )

  cmn.HoTaskFind( "spr_hosafe_key", "key" );    
  common_impl.PassingHoCheck();     
  
end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************