-- name=ho_hotable
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------

  room.Define( "ho_hotable" );
  
  game.relations[ "ho_hotable" ].exitroom = "rm_headphysicianoffice";
  private.room_objname = "ho_hotable";

  private.task_name = "win_hotable";  
  
  private.win_hotable = {};

  private.InitAnim();

  private.win_hotable.time = { 16, 16, 12, 12, 12, 12, 11, 11, 5, 6, 13, 6 };  
  private.win_hotable.norm_color = { 0.46, 0.66, 0.01 };
  private.win_hotable.dark_color = { 0.1, 0.1, 0.1 };  
  private.win_hotable.alp_low = 0;
  private.win_hotable.alp_high = 1;  
--, param0,param1,param2

  --------------------------------------------------------------------------------------------
  -- function opn_hotable () end;
  --------------------------------------------------------------------------------------------
  local opn_hotable = function ()

  end;

  cmn.AddSubscriber( "opn_hotable", opn_hotable, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hotable_func = function ()

    if ( cmn.IsEventDone( private.task_name ) ) then

      int.InventoryItemAdd( "inv_nameseal", "spr_hotable_win" );
      ObjDelete( "gho_headphysicianoffice_hotable" );
      ObjDelete( "obj_hotable_taskpanel" ); 
      ObjSet( "inv_magiccircle_plus_focus2", { alp = 1 } );   

      int.LockRoomMap("alchemiststore",1); 
      int.LockRoomMap("headphysicianoffice",1); 
      int.LockRoomMap("hospital",1); 
      int.LockRoomMap("morgue",1); 
      int.LockRoomMap("park",1); 
      int.LockRoomMap("sidesteet",1); 
      int.LockRoomMap("square",1);       

    end;

  end;
  cmn.AddSubscriber( "win_hotable", win_hotable_func );
  --------------------------------------------------------------------------------------------------
  local start_hotable_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then

      common_impl.ProcessHoStart( "hotable" );
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hotable", start_hotable_func, "ho_hotable" );
  --------------------------------------------------------------------------------------------------
  private.win_hotable.task = {  "item_1", "item_2", "item_3", "item_4", 
                                    "item_5", "item_6", "item_7", "item_8", 
                                    "item_9", "item_10", "item_11", "item_12" };                              
  
  for i = 1, #private.win_hotable.task do

    ObjSet( "spr_hotable_"..private.win_hotable.task[ i ], { input = false, event_mdown = function () private.CompleteTask( private.win_hotable.task[ i ], i ); end } );

  end;  
    
  if port.ios_lang() == "ja" then
    ObjSet("txt_hotable_taskpanel_1",{ fontsize = 16 });
    ObjSet("txt_hotable_taskpanel_0",{ fontsize = 16 });
  end;

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );  

  if ( not cmn.IsEventDone( "opn_hotable" ) ) then

    cmn.SetEventDone( "opn_hotable" );
    cmn.CallEventHandler( "opn_hotable" );
    
    ng_global.progress["ext"]["win_hotable"].number = 1;
    
  end;        

  private.TaskStart();  
  
  local ho_tasks = {};

  interface.TaskPanelTaskAdd( ho_tasks, "item_1", 1, 0, { { "spr_hotable_item_1" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_2", 1, 0, { { "spr_hotable_item_2" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_3", 1, 0, { { "spr_hotable_item_3" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_4", 1, 0, { { "spr_hotable_item_4" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_5", 1, 0, { { "spr_hotable_item_5" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_6", 1, 0, { { "spr_hotable_item_6" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_7", 1, 0, { { "spr_hotable_item_7" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_8", 1, 0, { { "spr_hotable_item_8" } } );  
  interface.TaskPanelTaskAdd( ho_tasks, "item_9", 1, 0, { { "spr_hotable_item_9" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_10", 1, 0, { { "spr_hotable_item_10" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_11", 1, 0, { { "spr_hotable_item_11" } } );
  interface.TaskPanelTaskAdd( ho_tasks, "item_12", 1, 0, { { "spr_hotable_item_12" } } );  
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hotable" );

  end;  
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  cmn.StopAllMus();
  common_impl.StopMusEnv( false );

  cmn.StopAllEnv( "audio/level4/env/aud_ho_hotable_env" );
  cmn.PlayAudio( "env", "audio/level4/env/aud_ho_hotable_env", 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.PassingHoStart();
  private.TimerStart();

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  cmn.StopAllVoc();  

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  ObjSet( "int_inventory_impl", { input = true } );
  
end;

--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, num )

  cmn.HoTaskFind( "spr_hotable_"..name, name );
  common_impl.PassingHoCheck();
  
  ng_global.progress["ext"]["win_hotable"].number = ng_global.progress["ext"]["win_hotable"].number + 1;  
  
  local func_end;
  
  if (  ng_global.progress["ext"]["win_hotable"].number == 3 or
        ng_global.progress["ext"]["win_hotable"].number == 5 or    
        ng_global.progress["ext"]["win_hotable"].number == 7 or          
        ng_global.progress["ext"]["win_hotable"].number == 9 or 
        ng_global.progress["ext"]["win_hotable"].number == 10 or 
        ng_global.progress["ext"]["win_hotable"].number == 11 or         
        ng_global.progress["ext"]["win_hotable"].number == 12 ) then   
    
    func_end = function() 
           
      private.Task(); 
      
    end;        

  else

    func_end = function() 
        
      int.Lock( false ); 
      
    end;       
    
  end;
  
  int.Lock( true ); 
  
  local panel_name = ""; 
  
  if ( ng_global.progress["ext"]["win_hotable"].number < 9 ) then   
    
    panel_name = "txt_hotable_taskpanel_"..(num % 2); 

  else

    panel_name = "txt_hotable_taskpanel_1";    
    
  end;  
  
  ObjSet( panel_name, { 
    param0 = private.win_hotable.dark_color[1],
    param1 = private.win_hotable.dark_color[2],
    param2 = private.win_hotable.dark_color[3] } );  
    
  cmn.WaitAndRun (func_end, 0,5);  
  
end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hotable_taskpanel" , "int_taskpanel_impl" );

end;
--*********************************************************************************************************************
function private.TaskStart()
  
  local number = ng_global.progress["ext"]["win_hotable"].number;
  
  if ( number < 9 and 
      (number % 2 == 0 ) ) then 
  
      number  = number - 1 ;
    
  end;  

  ObjSet( "txt_hotable_taskpanel_0", { alp = 0 } );
  
  if ( ObjGet( "spr_hotable_"..private.win_hotable.task[ number ] ) ) then
    
    ObjSet( "txt_hotable_taskpanel_1", { 
      text = "tsk_hotable_"..private.win_hotable.task[ number ], 
      param0 = private.win_hotable.norm_color[1],
      param1 = private.win_hotable.norm_color[2],
      param2 = private.win_hotable.norm_color[3] } );  
    
    ObjSet( "spr_hotable_"..private.win_hotable.task[ number ], { input = true } );     
    
  else
    
    ObjSet( "txt_hotable_taskpanel_1", { 
      alp = 1,
      text = "tsk_hotable_"..private.win_hotable.task[ number ], 
      param0 = private.win_hotable.dark_color[1],
      param1 = private.win_hotable.dark_color[2],
      param2 = private.win_hotable.dark_color[3] } );           
    
  end;      
 
  if (number<8) then
    
    if ( ObjGet( "spr_hotable_"..private.win_hotable.task[ number+1 ] ) ) then
      
      ObjSet( "txt_hotable_taskpanel_0", { 
        alp = 1,
        text = "tsk_hotable_"..private.win_hotable.task[ number ].."_1", 
        param0 = private.win_hotable.norm_color[1],
        param1 = private.win_hotable.norm_color[2],
        param2 = private.win_hotable.norm_color[3] } );      
      
      ObjSet( "spr_hotable_"..private.win_hotable.task[ number+1 ], { input = true } );       
      
    else
      
      ObjSet( "txt_hotable_taskpanel_0", { 
        alp = 1,
        text = "tsk_hotable_"..private.win_hotable.task[ number ].."_1", 
        param0 = private.win_hotable.dark_color[1],
        param1 = private.win_hotable.dark_color[2],
        param2 = private.win_hotable.dark_color[3] } );           
      
    end;           
    
  end;

end;
--*********************************************************************************************************************
function private.Task ()
  
  local func_end = function ()

    private.TaskStart();  

  end;

  local func_end2 = function ()

    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "txt_hotable_taskpanel_1", "alp", 0, 0, func_end2,
  { 
    0.0, 0, ObjGet( "txt_hotable_taskpanel_1" ).alp, 
    0.3, 0, private.win_hotable.alp_low,
    0.4, 0, private.win_hotable.alp_low,
    0.7, 0, ObjGet( "txt_hotable_taskpanel_1" ).alp

  } );
  if ( ng_global.progress["ext"]["win_hotable"].number < 8 ) then  
    
    ObjAnimate( "txt_hotable_taskpanel_0", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "txt_hotable_taskpanel_0" ).alp, 
      0.3, 0, private.win_hotable.alp_low,
      0.4, 0, private.win_hotable.alp_low,
      0.7, 0, ObjGet( "txt_hotable_taskpanel_0" ).alp

    } );  
    
  else
    
    ObjAnimate( "txt_hotable_taskpanel_0", "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "txt_hotable_taskpanel_0" ).alp, 
      0.3, 0, private.win_hotable.alp_low

    } );      
    
  end;

  ObjAnimate( "ho_hotable", "alp", 0, 0, func_end,
  { 
    0.0, 0, ObjGet( "ho_hotable" ).alp, 
    0.3, 0, ObjGet( "ho_hotable" ).alp
  } );

  private.TimerDone();
  private.TimerStart();

end;
--*********************************************************************************************************************
function private.TimerStart ()

  local number = ng_global.progress["ext"]["win_hotable"].number;
  
  if ( number < 9 and 
      (number % 2 == 0 ) ) then 
  
      number  = number - 1 ;
    
  end;    
  
  ObjSet( "tmr_hotable_voice", 
    { 
    playing = true, 
    time = private.win_hotable.time[ number ],
    endtrig = private.TimerDone
    } );

  ObjSet( "tmr_hotable_button", 
    { 
    playing = true, 
    time = private.win_hotable.time[ number ],
    endtrig = function()   cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_ho_hotable_stop" ); end
    } );

  cmn.StopAllVoc();
  cmn.PlayAudio( "voc", "audio/level4/voc/aud_hotable_"..number.."_voc", 0 ); 

  ObjSet( "obj_hotable_button", { input = false } );
  
  ObjSet( "anm_hotable_recorder", { alp = 0, active = false, frame = 0 } ); 
  ObjSet( "anm_hotable_recorder_start", { alp = 1, active = true, frame = 0 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_ho_hotable_play" );
  AnimPlay( "anm_hotable_recorder_start", "DoAnim", 
    function () 
      ObjSet( "anm_hotable_recorder_start", { alp = 0, active = false, frame = 0 } );      
      ObjSet( "anm_hotable_recorder", { alp = 1, active = true } );
     
    end );

end;
--*********************************************************************************************************************
function private.TimerDone ()

  local func_end = function ()

    private.TimerStart();

  end;

  cmn.StopAllVoc();

  ObjSet( "obj_hotable_button", { input = true, event_mdown = func_end } );
  ObjSet( "anm_hotable_recorder", { alp = 0, active = false } );
  ObjSet( "anm_hotable_recorder_start", { alp = 1, active = true, frame = 0 } );

end;
--*********************************************************************************************************************
function private.InitAnim ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************