-- name=mg_mgcrystals
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgcrystals";
  game.relations[ "mg_mgcrystals" ].exitroom = "rm_dungeon";

  private.Init();
  private.Update();
  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgcrystals = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgcrystals", update_game_mode_mgcrystals, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_mgcrystals () end;
  --------------------------------------------------------------------------------------------
  local opn_mgcrystals = function ()

  end;

  cmn.AddSubscriber( "opn_mgcrystals", opn_mgcrystals, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgcrystals () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgcrystals" ] =
  {
    type = "click",
    get_obj = "spr_mgcrystals_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgcrystals = function ()

    if ( cmn.IsEventDone( "win_mgcrystals" ) ) then

      --int.DeleteTaskMap( "rm_", "win_mgcrystals" );

      ObjDelete( "obj_mgcrystals_buttons" );
      ObjDelete( "tmr_mgcrystals_update" );

    elseif ( cmn.IsEventStart( "win_mgcrystals" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgcrystals", win_mgcrystals, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mgcrystals" ) ) then

    private.Start();

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if not ( cmn.IsEventDone( "opn_mgcrystals" ) ) then

    cmn.SetEventDone( "opn_mgcrystals" );
    cmn.CallEventHandler( "opn_mgcrystals" );
    --cmn.ShowBbt( "bbt_mgcrystals_first_enter" );

  end;

  if ( not cmn.IsEventDone( "win_mgcrystals" ) ) then

    cmn.MiniGameShow( "mgcrystals" );
    common_impl.PassingMgStart( "mgcrystals" );

  end;

  if ( private.is_first_enter ) then

    private.is_first_enter = false;
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_magic_hist", 0 );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_loop", 1 );

  cmn.StopAllMus();
  cmn.StopAllEnv( "audio/level4/env/aud_rm_dungeon_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_dungeon_env", 1, 1 );  

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "mgcrystals" );

  cmn.StopAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_loop" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ObjSet( "tmr_mgcrystals_update", { playing = false } );

  private.crystal_click = 1;
  private.is_click = false;
  private.crystals = { 0,0,0,0,0,0,0 };

  ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystals = { 0,0,0,0,0,0,0 };
  ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystal_click = 1;

  for c = 1, private.crystals_count do

    ObjSet( "spr_mgcrystals_crystal_"..c.."_line", { scale_x = 0 } );
    ObjSet( "obj_mgcrystals_button_"..c, { input = false } );

  end;

  ObjSet( "obj_mgcrystals_button_1", { input = true } );

  for f = 1, private.fire_count do

    ObjStopAnimate( "anm_mgcrystals_fire_"..f, "pos_xy" );
    ObjSet( "anm_mgcrystals_fire_"..f,
    {
      alp   = 1,
      pos_x = private.fire_pos[ f ][ 1 ][ 1 ],
      pos_y = private.fire_pos[ f ][ 1 ][ 2 ],
      scale_x = 0,
      scale_y = 0,
    } );

    private.CreateFire( f );

  end;

  ObjAttach( "spr_mgcrystals_crystal_light", "obj_mgcrystals_crystal_"..private.crystal_click );

  private.Update();

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_magic_hist", 0 );

end;
--*********************************************************************************************************************
function public.Skip ()

  ObjSet( "tmr_mgcrystals_update", { playing = false } );
  private.is_click = false;

--  for f = 1, private.fire_count do
--
--    ObjStopAnimate( "anm_mgcrystals_fire_"..f, "pos_xy" );
--
--  end;

  private.WinAnim();

end;
--*********************************************************************************************************************
function private.Init ()

  private.is_first_enter = true;
  private.crystals_count = 7;
  private.fire_count = 4;
  private.length = { 3.5,6,4,5.5,4,6,3.5 };
  private.crystal_click = 1;
  private.is_click = false;
  private.update_time = 0.01;
  private.delta_length = 0.03;
  private.crystals = { 0,0,0,0,0,0,0 };
  private.fire_pos =
  {
    { { 795,225 },{ 156,378 },{ 365,685 },{ 896,444 },{ 195,320 },{ 795,225 } },
    { { 115,555 },{ 865,375 },{ 300,200 },{ 610,155 },{ 468,672 },{ 115,555 } },
    { { 218,228 },{ 432,674 },{ 590,154 },{ 732,656 },{ 880,422 },{ 218,228 } },
    { { 916,560 },{ 124,608 },{ 860,386 },{ 368,175 },{ 335,675 },{ 916,560 } },
  };

  for c = 1, private.crystals_count do

    ObjSet( "obj_mgcrystals_button_"..c,
    {
      event_mdown  = function () private.CrystalClick( c ); end,
      event_mup    = function () private.CrystalUnClick( c ); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

    ObjSet( "spr_mgcrystals_crystal_"..c.."_line",
    {
      inputrect_init = true,
      inputrect_x = 0,
      inputrect_y = -10,
      inputrect_h = 20,
      inputrect_w = 40,
    } );

  end;

  for f = 1, private.fire_count do

    private.CreateFire( f );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystals = { 0,0,0,0,0,0,0 };
  ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystal_click = 1;

end;
--*********************************************************************************************************************
function private.Load ()

  private.crystal_click = ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystal_click;

  for c = 1, private.crystals_count do

    private.crystals[ c ] = ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystals[ c ];

    local length = private.crystals[ c ] * private.delta_length;

    ObjSet( "spr_mgcrystals_crystal_"..c.."_line", { scale_x = length } );

  end;

  ObjAttach( "spr_mgcrystals_crystal_light", "obj_mgcrystals_crystal_"..private.crystal_click );

  ObjSet( "obj_mgcrystals_button_1", { input = false } );
  ObjSet( "obj_mgcrystals_button_"..private.crystal_click, { input = true } );

end;
--*********************************************************************************************************************
function private.WinAnim ()

  int.Lock( true );

  local func_end = function ()

    private.Win();
    int.Lock( false );

  end;

  for c = 1, private.crystals_count do

    local scale_1 = ObjGet( "spr_mgcrystals_crystal_"..c.."_line" ).scale_x;
    local scale_2 = private.length[ c ];

    ObjAnimate( "spr_mgcrystals_crystal_"..c.."_line", "scale_x", 0, 0, func_end,
    {
      0.0, 3, scale_1,
      1.0, 3, scale_2,
      1.3, 3, scale_2,
    } );

    func_end = "";

  end;

end;
--*********************************************************************************************************************
function private.Win ()

  for f = 1, private.fire_count do

    ObjStopAnimate( "anm_mgcrystals_fire_"..f, "pos_xy" );

  end;

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgcrystals" );
  cmn.CallEventHandler( "win_mgcrystals" );
  common_impl.PassingMgWin( "mgcrystals" );
  cmn.GotoRoom( "rm_dungeon" );

end;
--*********************************************************************************************************************
function private.CrystalClick ( idx )

  private.is_click = true;
  private.crystal_click = idx;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_click_wait", 1 );

end;
--*********************************************************************************************************************
function private.CrystalUnClick ( idx )

  private.is_click = false;
  ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystals[ idx ] = private.crystals[ idx ];

  cmn.StopAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_click_wait" );

end;
--*********************************************************************************************************************
function private.Update ()

  ObjSet( "tmr_mgcrystals_update",
  {
    time = private.update_time,
    playing = true,
    endtrig = function ()

      private.Update();

    end,
  } );

  if ( private.is_click ) then

    private.crystals[ private.crystal_click ] = private.crystals[ private.crystal_click ] + 1;

    local length = private.crystals[ private.crystal_click ] * private.delta_length;

    if ( length < private.length[ private.crystal_click ] ) then

      ObjSet( "spr_mgcrystals_crystal_"..private.crystal_click.."_line", { scale_x = length } );

    else

      private.NextCrystal();

    end;

  end;

  for f = 1, private.fire_count do

    if ( private.IsCollision( f ) ) then

      private.DestroyLine( f );

    end;

  end;

end;
--*********************************************************************************************************************
function private.NextCrystal ()

  private.is_click = false;

  ObjSet( "obj_mgcrystals_button_"..private.crystal_click, { input = false } );

  private.crystal_click = private.crystal_click + 1;

  if ( private.crystal_click > private.crystals_count ) then

    private.WinAnim();

  else

    ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystals[ private.crystal_click - 1 ] = private.crystals[ private.crystal_click - 1 ];
    ng_global.progress[ private.currentprogress ][ "win_mgcrystals" ].crystal_click = private.crystal_click;

    ObjSet( "obj_mgcrystals_button_"..private.crystal_click, { input = true } );
    ObjAttach( "spr_mgcrystals_crystal_light", "obj_mgcrystals_crystal_"..private.crystal_click );

  end;

  cmn.StopAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_click_wait" );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_come", 0 );

end;
--*********************************************************************************************************************
function private.IsCollision ( idx )

  local is_collision = false;

  if ( ApplyObj( "obj_mgcrystals_fire_"..idx, "spr_mgcrystals_crystal_"..private.crystal_click.."_line" ) ) and
     ( private.crystals[ private.crystal_click ] > 0 ) then

    is_collision = true;

  end;

  return is_collision;

end;
--*********************************************************************************************************************
function private.DestroyLine ( idx )

  local func_end = function ()

    private.CreateFire( idx );

  end;

  private.is_click = false;
  ObjSet( "spr_mgcrystals_crystal_"..private.crystal_click.."_line", { scale_x = 0 } );
  private.crystals[ private.crystal_click ] = 0;

  ObjStopAnimate( "anm_mgcrystals_fire_"..idx, "pos_xy" );

  ObjAnimate( "anm_mgcrystals_fire_"..idx, "alp", 0, 0, "",
  {
    0.0, 3, 1.0,
    0.2, 3, 0.0,
  } );

  ObjAnimate( "anm_mgcrystals_fire_"..idx, "scale_xy", 0, 0, func_end,
  {
    0.0, 3, 1.0, 1.0,
    0.2, 3, 2.0, 2.0,
  } );

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgcrystals_magic_hist", 0 );

end;
--*********************************************************************************************************************
function private.CreateFire ( idx )

  local func_end = function ()

    local tme = { 0,0,0,0,0 };

    for p = 1, 5 do

      local pos_1 = private.fire_pos[ idx ][ p ];
      local pos_2 = private.fire_pos[ idx ][ p + 1 ];

      local cathetus_1 = math.abs( pos_1[ 1 ] - pos_2[ 1 ] );
      local cathetus_2 = math.abs( pos_1[ 2 ] - pos_2[ 2 ] );
      local hypotenuse = math.sqrt( math.pow( cathetus_1,2 ) + math.pow( cathetus_2,2 ) );

      tme[ p ] = hypotenuse * 0.01;

    end;

    for p = 2, 5 do

      tme[ p ] = tme[ p ] + tme[ p - 1 ];

    end;

    ObjAnimate( "anm_mgcrystals_fire_"..idx, "pos_xy", 1, 0, "",
    {
      0.0,      3, private.fire_pos[ idx ][ 1 ][ 1 ], private.fire_pos[ idx ][ 1 ][ 2 ],
      tme[ 1 ], 3, private.fire_pos[ idx ][ 2 ][ 1 ], private.fire_pos[ idx ][ 2 ][ 2 ],
      tme[ 2 ], 3, private.fire_pos[ idx ][ 3 ][ 1 ], private.fire_pos[ idx ][ 3 ][ 2 ],
      tme[ 3 ], 3, private.fire_pos[ idx ][ 4 ][ 1 ], private.fire_pos[ idx ][ 4 ][ 2 ],
      tme[ 4 ], 3, private.fire_pos[ idx ][ 5 ][ 1 ], private.fire_pos[ idx ][ 5 ][ 2 ],
      tme[ 5 ], 3, private.fire_pos[ idx ][ 6 ][ 1 ], private.fire_pos[ idx ][ 6 ][ 2 ],
    } );

    local t = 0.3;

  end;

  local sign = { 1,-1,1,1 };

  ObjSet( "anm_mgcrystals_fire_"..idx,
  {
    alp   = 1,
    pos_x = private.fire_pos[ idx ][ 1 ][ 1 ],
    pos_y = private.fire_pos[ idx ][ 1 ][ 2 ],
  } );

  ObjAnimate( "anm_mgcrystals_fire_"..idx, "scale_xy", 0, 0, func_end,
  {
    0.0, 3, 0.0, 0.0,
    1.0, 3, 1.0 * sign[ idx ], 1.0,
  } );

  local func_end_1 = function ()

    ObjDelete( "anm_mgcrystals_fire_start_"..idx );

  end;

  if ( ObjGet( "anm_mgcrystals_fire_start_"..idx ) ) then

    ObjDelete( "anm_mgcrystals_fire_start_"..idx );

  end;

  ObjCreate( "anm_mgcrystals_fire_start_"..idx, "anim" );
  ObjAttach( "anm_mgcrystals_fire_start_"..idx, "obj_mgcrystals_fire" );
  ObjSet( "anm_mgcrystals_fire_start_"..idx,
  {
    res = "assets/levels/levelext/mg_mgcrystals/anims/anm_fire_start",
    pos_x = private.fire_pos[ idx ][ 1 ][ 1 ],
    pos_y = private.fire_pos[ idx ][ 1 ][ 2 ],
    input = false,
    animfunc = "DoAnim",
  } );

  AnimPlay( "anm_mgcrystals_fire_start_"..idx, "DoAnim", func_end_1 );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  local tme = { 0.2,0.22,0.18,0.23,0.19,0.16,0.21 };

  for c = 1, private.crystals_count do

    ObjAnimate( "spr_mgcrystals_crystal_"..c.."_line", "scale_y", 1, 0, "",
    {
      0.0,        3, 1.0,
      tme[ c ],   3, 0.8,
      tme[ c ]*2, 3, 1.0,
    } );

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************