-- name=mg_mgdominoes
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgdominoes";
  game.relations[ "mg_mgdominoes" ].exitroom = "rm_hospital";

  private.Init();

  ObjSet( "spr_mgdominoes_butterflyfigurine", { event_mdown = private.get_butterflyfigurine } );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgdominoes = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgdominoes", update_game_mode_mgdominoes, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_mgdominoes () end;
  --------------------------------------------------------------------------------------------
  local opn_mgdominoes = function ()

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_mgdominoes", opn_mgdominoes, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgdominoes () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgdominoes" ] =
  {
    type = "click",
    get_obj = "spr_mgdominoes_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgdominoes = function ()

    if ( cmn.IsEventDone( "win_mgdominoes" ) ) then

      --int.DeleteTaskMap( "rm_hospital", "win_mgdominoes" );

      ObjSet( "obj_mgdominoes_hubs",  { input = false } );
      ObjSet( "obj_mgdominoes_field", { input = false } );

      ObjSet( "spr_mgdominoes_butterflyfigurine", { input = true } );
      ObjSet( "gfx_mgdominoes_butterflyfigurine", { active = true } );
      ObjDelete( "anm_mgdominoes_jaw_static" );
      ObjSet( "anm_mgdominoes_win", { alp = 1, frame = 31, animfunc = "DoAnim" } );

    end;

    if ( cmn.IsEventStart( "win_mgdominoes" ) ) then

      private.Load();

    end;

  end; 
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_mgdominoes", win_mgdominoes, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_butterflyfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_butterflyfigurine" ] =
  {
    type = "get",
    get_obj = "spr_mgdominoes_butterflyfigurine",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local get_butterflyfigurine_inv = function ()

    ObjSet( "spr_mgdominoes_butterflyfigurine", { alp = 1 } );
    int.InventoryItemAdd( "inv_butterflyfigurine", "spr_mgdominoes_butterflyfigurine" );

  end;
  local get_butterflyfigurine_closezz = function ()

    ObjDelete( "gfx_mgdominoes_butterflyfigurine" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_butterflyfigurine", get_butterflyfigurine_inv );
  cmn.AddSubscriber( "get_butterflyfigurine", get_butterflyfigurine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.get_butterflyfigurine ()

  cmn.SetEventDone( "get_butterflyfigurine" );
  cmn.CallEventHandler( "get_butterflyfigurine" );
  cmn.GetObjectSfx();
  cmn.GotoRoom( "rm_hospital" );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  --int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  if ( not cmn.IsEventStart( "win_mgdominoes" ) ) then

    private.Start();

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if not ( cmn.IsEventDone( "opn_mgdominoes" ) ) then

    cmn.SetEventDone( "opn_mgdominoes" );
    cmn.CallEventHandler( "opn_mgdominoes" );
    cmn.ShowBbt( "bbt_mgdominoes_first_enter" );

  end;

  if ( not cmn.IsEventDone( "win_mgdominoes" ) ) then

    cmn.MiniGameShow( "mgdominoes" );
    common_impl.PassingMgStart( "mgdominoes" );

  end;

  cmn.StopAllMus();
  common_impl.StopMusEnv( false );
  cmn.StopAllEnv( "audio/level4/env/aud_rm_hospital_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_hospital_env", 1, 1 );  

  cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "mgdominoes" );

  cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PlayMusEnv();
  
end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].field = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].items = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].value = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  private.field = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  private.items = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  private.value = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

  for c = 1, private.cells_count do

    ObjAttach( "spr_mgdominoes_item_"..c, "obj_mgdominoes_hub_"..c );
    ObjSet( "spr_mgdominoes_item_"..c, { pos_x = 0, pos_y = 0 } );

  end;

end;
--*********************************************************************************************************************
function public.Skip ()

  int.Lock( true );

  local win_items = { 4,0,3,0,5,11,0,2,9,0,0,10,0,6,8,0,12,0,1,7,0,0,0,0 };

  for c = 1, private.cells_count do

    if ( win_items[ c ] ~= 0 ) then

      ObjAnimate( "spr_mgdominoes_item_"..win_items[ c ], "scale_x", 0, 0,
      function ()

        ObjAttach( "spr_mgdominoes_item_"..win_items[ c ], "obj_mgdominoes_field_"..c );
        local pos = private.GetItemPosEnd( win_items[ c ], c );
        ObjSet( "spr_mgdominoes_item_"..win_items[ c ], { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );

      end,
      {
        0.0, 3, 1.0,
        0.3, 3, 1.0,
      } );

      ObjAnimate( "spr_mgdominoes_item_"..win_items[ c ], "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
        0.6, 3, 1.0,
      } );

    end;

  end;

  ObjSet( "tmr_mgdominoes_anims",
  {
    playing = 1,
    time = 0.6,
    endtrig = private.WinAnim;
  } );

  private.field = { 4,3,3,5,5,11,11,2,9,9,2,10,10,6,8,8,12,12,1,7,4,6,1,7 };
  private.items = { 4,0,3,0,5,11,0,2,9,0,0,10,0,6,8,0,12,0,1,7,0,0,0,0 };
  private.value = { 1,1,3,3,1,1,2,2,2,1,2,2,3,1,1,1,1,2,3,3,2,3,2,3 };

end;
--*********************************************************************************************************************
function private.Init ()

  private.items_count = 12;
  private.cells_count = 24;
  private.direction   = nil;
  private.directions  = { "right","down","down","right","down","down","down","right","right","right","right","down" };
  private.items_value = { { 3,2 },{ 2,2 },{ 3,1 },{ 1,2 },{ 1,3 },{ 1,3 },
                          { 3,3 },{ 1,1 },{ 2,1 },{ 2,3 },{ 1,2 },{ 1,2 } };
-- 1 - череп человека
-- 2 - череп животного
-- 3 - кости

  private.field = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  private.items = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  private.value = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

  private.links =
  {
    {                  [ "right" ] = 21 }, --[[  1 ]]
    {                  [ "right" ] =  1 }, --[[  2 ]]
    { [ "down" ] =  2                   }, --[[  3 ]]
    { [ "down" ] =  3                   }, --[[  4 ]]
    { [ "down" ] =  4                   }, --[[  5 ]]
    { [ "down" ] =  5, [ "right" ] =  7 }, --[[  6 ]]
    {                  [ "right" ] =  8 }, --[[  7 ]]
    { [ "down" ] = 11, [ "right" ] =  9 }, --[[  8 ]]
    {                  [ "right" ] = 10 }, --[[  9 ]]
    { [ "down" ] = 14                   }, --[[ 10 ]]
    { [ "down" ] = 12                   }, --[[ 11 ]]
    {                  [ "right" ] = 13 }, --[[ 12 ]]
    {                  [ "right" ] = 22 }, --[[ 13 ]]
    { [ "down" ] = 22, [ "right" ] = 15 }, --[[ 14 ]]
    {                  [ "right" ] = 16 }, --[[ 15 ]]
    { [ "down" ] = 17                   }, --[[ 16 ]]
    { [ "down" ] = 18                   }, --[[ 17 ]]
    { [ "down" ] = 23                   }, --[[ 18 ]]
    {                  [ "right" ] = 23 }, --[[ 19 ]]
    { [ "down" ] = 24, [ "right" ] = 19 }, --[[ 20 ]]
  };

  for i = 1, private.items_count do

    ObjSet( "spr_mgdominoes_item_"..i,
    {
      event_mdown    = function () private.ItemStartDrag( i ) end,
      event_menter   = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      event_drag     = function () private.ItemDrag() end,
      event_dragdrop = function () private.ItemDrop( i ) end,
      drag           = true,
      inputrect_init = false,
    } );

    ObjCreate( "obj_mgdominoes_item_"..i, "obj" );
    ObjAttach( "obj_mgdominoes_item_"..i, "spr_mgdominoes_item_"..i );

    ObjSet( "obj_mgdominoes_item_"..i,
    {
      input          = false,
      inputrect_init = true,
      inputrect_x    = -10,
      inputrect_y    = -10,
      inputrect_h    =  20,
      inputrect_w    =  20,
    } );

  end;

  for c = 1, private.cells_count do

    ObjSet( "obj_mgdominoes_cell_"..c,
    {
      inputrect_init = true,
      inputrect_x    = -15,
      inputrect_y    = -15,
      inputrect_h    =  30,
      inputrect_w    =  30,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].field = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].items = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].value = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

end;
--*********************************************************************************************************************
function private.Load ()

  for c = 1, private.cells_count do

    private.field[ c ] = ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].field[ c ];
    private.items[ c ] = ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].items[ c ];
    private.value[ c ] = ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].value[ c ];

    if ( private.items[ c ] ~= 0 ) then

      ObjAttach( "spr_mgdominoes_item_"..private.items[ c ], "obj_mgdominoes_field_"..c );
      local pos = private.GetItemPosEnd( private.items[ c ], c );
      ObjSet( "spr_mgdominoes_item_"..private.items[ c ], { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.WinAnim ()

  int.Lock( true );

  local func_end = function ()

    private.SaveProgress();
    private.Win();
    int.Lock( false );

  end;

  ObjSet( "anm_mgdominoes_jaw_static", { alp = 0 } );
  AnimStop( "anm_mgdominoes_jaw_static" );

  ObjSet( "anm_mgdominoes_win", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/mg_mgdominoes_win" );
  AnimPlay( "anm_mgdominoes_win", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgdominoes" );
  cmn.CallEventHandler( "win_mgdominoes" );
  common_impl.PassingMgWin( "mgdominoes" );

end;
--*********************************************************************************************************************
function private.ItemStartDrag ( idx )

  cmn.PlayAudio( "sfx", "audio/level4/sfx/mg_mgdominoes_take" );
  for c = 1, private.cells_count do

    if ( private.field[ c ] == idx ) then

      private.field[ c ] = 0;
      private.items[ c ] = 0;
      private.value[ c ] = 0;

    end;

  end;
  
  ObjSet( "spr_mgdominoes_item_"..idx, { pos_x = 0, pos_y = 0 });
  
    private.last_drawoff_y = ObjGet("spr_mgdominoes_item_"..idx).drawoff_y;
    private.last_pos_y = ObjGet("obj_mgdominoes_item_"..idx).pos_y;
    ObjSet( "spr_mgdominoes_item_"..idx, { drawoff_y = -50 } );
    ObjSet( "obj_mgdominoes_item_"..idx, { pos_y = - 50 });
    if idx == 2 or idx == 3 or idx == 5 or idx == 6 or idx == 7 or idx == 12 then
      ObjSet( "obj_mgdominoes_item_"..idx, { pos_y = - 50 - 38 });
    end;
  
  ObjAttach( "spr_mgdominoes_item_"..idx, "obj_mgdominoes_top" );

end;
--*********************************************************************************************************************
function private.GetItemPosEnd ( item, cell )

  local pos_x = 0;
  local pos_y = 0;

  if ( ( cell == 6 ) and ( private.directions[ item ] == "down" ) ) then

    pos_x = -7;
    pos_y = 5;

  end;

  if ( ( cell == 8 ) and ( private.directions[ item ] == "right" ) ) then

    pos_x = 5;
    pos_y = -5;

  end;

  if ( ( cell == 14 ) and ( private.directions[ item ] == "right" ) ) then

    pos_x = 5;
    pos_y = -6;

  end;

  if ( ( cell == 20 ) and ( private.directions[ item ] == "right" ) ) then

    pos_x = 6;
    pos_y = -4;

  end;
  
  return { pos_x, pos_y };

end;
--*********************************************************************************************************************
function private.ItemDrag ()

  cmn.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.ItemDrop ( idx )

  local direction = private.directions[ idx ];
  
  --cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgdominoes_insert_domino" );

  for c = 1, private.cells_count do

    if ( ApplyObj( "obj_mgdominoes_item_"..idx, "obj_mgdominoes_cell_"..c ) ) then

      if ( private.field[ c ] == 0 ) and
         ( private.field[ private.links[ c ][ direction ] ] ) and
         ( private.field[ private.links[ c ][ direction ] ] == 0 ) then

        ObjSet( "obj_mgdominoes_field_"..c, { pos_z = 2 } );
        ObjAttach( "spr_mgdominoes_item_"..idx, "obj_mgdominoes_field_"..c );

        local pos_1 = GetObjPosByObj( "spr_mgdominoes_item_"..idx, "obj_mgdominoes_field_"..c );
        local pos_2 = private.GetItemPosEnd( idx, c );
        int.Lock( true );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/mg_mgdominoes_put_right" );
          ObjSet( "spr_mgdominoes_item_"..idx, { drawoff_y = private.last_drawoff_y } );
          ObjSet( "obj_mgdominoes_item_"..idx, { pos_y = private.last_pos_y });
        
        ObjAnimate( "spr_mgdominoes_item_"..idx, "pos_xy", 0, 0,
        function ()
          int.Lock( false );

          private.field[ c ] = idx;
          private.field[ private.links[ c ][ direction ] ] = idx;
          private.items[ c ] = idx;
          private.value[ c ] = private.items_value[ idx ][ 1 ];
          private.value[ private.links[ c ][ direction ] ] = private.items_value[ idx ][ 2 ];

          if ( private.IsWin() ) then

            private.WinAnim();

          end;

          ObjSet( "obj_mgdominoes_field_"..c, { pos_z = 0 } );

        end,
        {
          0.0, 3, pos_1[ 1 ], pos_1[ 2 ],
          0.3, 3, pos_2[ 1 ], pos_2[ 2 ],
        } );

        return;

      end;

    end;

  end;

  int.Lock( true );

  local pos = GetObjPosByObj( "spr_mgdominoes_item_"..idx, "obj_mgdominoes_hub_"..idx );
  ObjSet( "obj_mgdominoes_hub_"..idx, { pos_z = 2 } );
  ObjSet( "spr_mgdominoes_item_"..idx, { drawoff_y = private.last_drawoff_y } );
  ObjSet( "obj_mgdominoes_item_"..idx, { pos_y = private.last_pos_y });
  cmn.PlayAudio( "sfx", "audio/level4/sfx/mg_mgdominoes_put_place" );
  ObjAnimate( "spr_mgdominoes_item_"..idx, "pos_xy", 0, 0,
  function ()

    private.SaveProgress();
    ObjSet( "obj_mgdominoes_hub_"..idx, { pos_z = 0 } );
    int.Lock( false );

  end,
  {
    0.0, 3, pos[ 1 ], pos[ 2 ],
    0.3, 3, 0, 0,
  } );

  ObjAttach( "spr_mgdominoes_item_"..idx, "obj_mgdominoes_hub_"..idx );
  cmn.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.IsWin ()

  local win_fields = { { 1,2 },{ 3,4 },{ 5,6 },{ 7,8 },{ 8,9 },{ 11,12 },{ 13,22 },{ 10,14 },{ 14,15 },{ 16,17 },{ 18,23 },{ 19,20 } };

  for c = 1, private.cells_count do

    if ( private.field[ c ] == 0 ) then

      private.SaveProgress();
      return false;

    end;

  end;

  for c = 1, #win_fields do

    if ( private.value[ win_fields[ c ][ 1 ] ] ~= private.value[ win_fields[ c ][ 2 ] ] ) then

      private.SaveProgress();
      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.SaveProgress ()

  for c = 1, private.cells_count do

    ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].field[ c ] = private.field[ c ];
    ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].items[ c ] = private.items[ c ];
    ng_global.progress[ private.currentprogress ][ "win_mgdominoes" ].value[ c ] = private.value[ c ];

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************