-- name=mg_mgwitch
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgwitch";
  game.relations[ "mg_mgwitch" ].exitroom = "rm_pagantemple";

  private.Init();
  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgwitch = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgwitch", update_game_mode_mgwitch, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_mgwitch () end;
  --------------------------------------------------------------------------------------------
  local opn_mgwitch = function ()

  end;

  cmn.AddSubscriber( "opn_mgwitch", opn_mgwitch, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgwitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mgwitch" ] =
  {
    type = "click",
    get_obj = "spr_mgwitch_back",
    room = private.room_objname,
  };
  -----------------------------------------------
  local win_mgwitch = function ()

    if ( cmn.IsEventDone( "win_mgwitch" ) ) then

      --int.DeleteTaskMap( "rm_pagantemple", "win_mgwitch" );

    elseif ( cmn.IsEventStart( "win_mgwitch" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgwitch", win_mgwitch, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  int.VisitMapRoom( game.relations[ private.room_objname ].exitroom );

  int.LockRoomMap( "prison",1 ); 
  int.LockRoomMap( "dungeon",1 ); 
  int.LockRoomMap( "pagantemple",1 ); 

  if ( not cmn.IsEventStart( "win_mgwitch" ) ) then

    private.FightStartConditions();
    private.Load();

  end;
  if ( cmn.IsEventDone( "win_mgwitch" ) ) then
    
    ObjSet( "mg_mgwitch", { color_r = 0, color_g = 0, color_b = 0 } );
    
  end;   

end;
--*********************************************************************************************************************
function public.Open ()

  if not ( cmn.IsEventDone( "opn_mgwitch" ) ) then

    cmn.SetEventDone( "opn_mgwitch" );
    cmn.CallEventHandler( "opn_mgwitch" );       

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgwitch_begin_mg" );

  end; 

  if ( not cmn.IsEventDone( "win_mgwitch" ) ) then

    cmn.MiniGameShow( "mgwitch" );
    common_impl.PassingMgStart( "mgwitch" );
      
    private.FightDrawScene();
    private.FightStartGame();    

  else
        
    local func_end = function ()
      
      cmn.GotoRoom( "rm_credits" );  
      
    end;    
    private.Outro( func_end );         
    
  end;
  
  common_impl.StopMusEnv( false );  
  cmn.PlayAudio( "mus", "audio/level1/mus/aud_action_fight_1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  cmn.MiniGameHide();
  common_impl.PassingMgStop( "mgwitch" );

  cmn.StopAudio( "mus", "audio/level1/mus/aud_action_fight_1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()
  
  common_impl.PlayMusEnv();    
  
end;
--*********************************************************************************************************************
function public.Reset ()

  private.FightReset();

end;
--*********************************************************************************************************************
function public.Skip ()

  private.FightSkip();

end;
--*********************************************************************************************************************
function private.Load ()

  --private.FightStartConditions(); 
  private.state = ng_global.progress[ private.currentprogress ][ "win_mgwitch" ].state;

  ObjSet( "anm_fight_guardian_static_1", { alp = 0, playing = false } );
  ObjSet( "anm_fight_guardian_static_"..( private.state.stage ), { alp = 1, playing = true } );

end;
--*********************************************************************************************************************
function private.Init ()

  --private.stage_win_num = { 5, 5, 5 };    -- количество шариков нужно выбить в стадиях
  private.stage_win_num = { 18, 20, 27 };   -- количество шариков нужно выбить в стадиях
  private.life_drawoff_x = -250;            -- смещение полоски жизней, когда ее полностью не видно
  private.fire_flag = false;                -- нахождение в процессе анимации выстрела
  private.fly_ball_flag = false;            -- нахождение в процессе полета выстреленного шара
  private.ball_waiting_flag = {};           -- нахождение в процессе ожидания предыдущих шаров (шары которые ждут)
  private.ball_insert_flag = 0;             -- нахождение в процессе вставки выстреленного шара (последний шар который убегает в перед)
  private.balls = {};                       -- динамически заполняемая таблица шаров ( номер, цвет, позиция, движение )
  private.fight_is_start = false;           -- для первого захода в локу
  private.insert_flag = false;              -- нахождение в процессе анимации вставки между шарами

  --точки которые проходят шарики, потом дополнительно разбиваются программно
  private.start_stage_points_1 =
  {
    { 163, 320 }, { 133, 301 }, { 124, 267 }, { 137, 235 }, { 167, 216 }, { 203, 209 },
    { 239, 212 }, { 271, 228 }, { 299, 250 }, { 328, 272 }, { 358, 291 }, { 389, 310 },
    { 423, 322 }, { 458, 330 }, { 495, 331 }, { 530, 324 }, { 563, 309 }, { 594, 291 },
    { 622, 269 }, { 644, 244 }, { 671, 220 }, { 701, 200 }, { 735, 189 }, { 771, 185 }, { 807, 186 },
    { 840, 198 }, { 867, 220 }, { 886, 250 }, { 896, 285 }, { 895, 322 }, { 890, 357 }, { 876, 387 }
  };

  private.start_stage_points_2 =
  {
    { 226, 251 }, { 246, 221 }, { 281, 210 }, { 316, 216 }, { 349, 232 }, { 375, 258 },
    { 401, 284 }, { 422, 314 }, { 444, 344 }, { 467, 373 }, { 490, 401 }, { 518, 426 },
    { 549, 445 }, { 584, 455 }, { 621, 457 }, { 656, 448 }, { 684, 425 }, { 708, 398 },
    { 729, 368 }, { 740, 334 }, { 751, 299 }, { 771, 270 }, { 801, 247 }, { 835, 242 }, { 871, 246 },
  };
  private.start_stage_points_3 =
 {
    { 178, 407 }, { 148, 393 }, { 131, 361 }, { 124, 326 }, { 129, 288 }, { 151, 261 },
    { 182, 245 }, { 219, 237 }, { 255, 243 }, { 290, 255 }, { 325, 270 }, { 356, 290 },
    { 386, 310 }, { 415, 332 }, { 446, 351 }, { 480, 364 }, { 516, 371 }, { 553, 374 },
    { 590, 372 }, { 625, 364 }, { 659, 348 }, { 685, 324 }, { 711, 299 }, { 741, 277 },
    { 771, 257 }, { 805, 241 }, { 841, 232 }, { 878, 234 }, { 913, 245 }, { 942, 266 },
    { 965, 296 }, { 975, 332 }, { 973, 368 }, { 952, 398 }, { 922, 420 }, { 889, 436 }, { 854, 446 },
  };

  private.stage_points_1 = {};  --точки маршрута движения шаров
  private.stage_points_2 = {};  --получаются программным разбитием начальных маршрутов start_stage_points_1 - 3
  private.stage_points_3 = {};

  private.fire_points = {}; --точки пути летящего шара
  private.distance_between_points = 1.5;--2;  --растояние между точками через которые проходят шары
                                              --не менять денамически!!! участвует только в начальном разбитии маршрута шаров

  private.time_between_points = 0.0166666675;--0.0333333351; --время за которое шар добирается от точки до точки

  private.FightSplitBallsPoints();

  private.balls_colors    = { "blue", "green", "yellow" };
  private.fire_ball_color = 1;
  private.balls_diameter  = 34;

  --private.fire_ball_speed_coefficient = 0.0007;
  private.fire_ball_speed_coefficient = 0.0;

  ObjSet( "obj_fight_back",
  {
    event_mdown    = function () private.FightFireNewBall() end,
    event_menter   = function () cmn.SetCursor( CURSOR_HAND ); private.FightArrowAnim(); end,
    event_mleave   = function () cmn.SetCursor( CURSOR_DEFAULT ); private.FightArrowStopAnim(); end,
  } );

end;
--*********************************************************************************************************************
function private.FightReset ( for_win, for_next_stage )

  if #private.balls == 0 then return; end;

  int.Lock( true );

  ObjSet( "tmr_fight_gametimer", { playing = false } );

  for i = 1, #private.balls, 1 do

    local ball_name = "spr_fight_ball_"..private.balls[ i ].id;
    local ball_params = ObjGet( ball_name );

    ObjAnimate( ball_name, "alp", 0, 0, function () ObjDelete( ball_name ); end, { 0, 0, ball_params.alp,   0.3, 0, 0 } );
    ObjAnimate( ball_name, "scale_xy", 0, 0, "", { 0, 0, ball_params.scale_x, ball_params.scale_y,    0.3, 0, 0, 0 } );

  end;

  private.balls = {};

  private.state.last_ball_id = 0;
  private.state.stage_del_ball_num = 0;

  private.ball_waiting_flag = {};
  private.ball_insert_flag = 0;

  if ( for_next_stage ) then

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgwitch_win_session" );

    local name_1 = "anm_fight_guardian_static_"..( private.state.stage - 1 );
    local name_2 = "anm_fight_guardian_static_"..( private.state.stage - 1 ).."_"..( private.state.stage );
    local name_3 = "anm_fight_guardian_static_"..( private.state.stage );

    ObjSet( name_1, { alp = 0 } );
    ObjSet( name_2, { alp = 1 } );

    AnimPlay( name_2, "DoAnim",
    function ()

      ObjAnimate( "spr_fight_life", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

      ObjSet( name_2, { alp = 0 } );
      ObjSet( name_3, { alp = 1 } );

      AnimPlay( name_3, "DoAnim", "" );

      int.Lock( false );
      private.FightStartGame();

    end );

    local life_func_after = function ()

      ObjSet( "spr_fight_life", { drawoff_x = 0 } );

    end;

    ObjAnimate( "spr_fight_life", "alp", 0, 0, life_func_after, { 0, 0, 1,    0.3, 0, 0 } );

  elseif ( for_win ) then

    ObjAnimate( "spr_fight_life", "drawoff_x", 0, 0, "",
    { 
      0.00, 0, ObjGet( "spr_fight_life" ).drawoff_x,
      0.12, 0, private.life_drawoff_x
    } );

    ObjSet( "tmr_fight_resetskip", { time = 0.35, endtrig = function () int.Lock( false ); private.Win(); end, playing = true } );

  else

    ObjSet( "tmr_fight_resetskip", { time = 0.35, endtrig = function () int.Lock( false ); private.FightStartGame(); end, playing = true } );

    local life_func_after = function ()

      ObjSet( "spr_fight_life", { drawoff_x = 0 } );
      ObjAnimate( "spr_fight_life", "alp", 0, 0, "", { 0, 0, 0,    0.3, 0, 1 } );

    end;

    ObjAnimate( "spr_fight_life", "alp", 0, 0, life_func_after, { 0, 0, 1,    0.3, 0, 0 } );

  end;

end;
--*********************************************************************************************************************
function private.FightSkip ()

  --private.state.stage = #private.stage_win_num + 1;
  private.FightReset( true );

end;
--*********************************************************************************************************************
function private.FightStartConditions ()

  ng_global.progress[ private.currentprogress ][ "win_mgwitch" ].state = {
    stage = 1,                       -- стадия игры (1-3)
    stage_del_ball_num = 0,          -- количество выбитых шариков на текущей стадии
    last_ball_id = 0,                -- номер последнего созданного шарика
    loaded_ball_color = 1            -- цвет шарика которым будем стрелять
  };

end;
--*********************************************************************************************************************
function private.FightDrawScene ()

  ObjSet( "tmr_fight_gametimer", { playing = false } );

  for i = 1, #private.balls, 1 do

    ObjDelete( "spr_fight_ball_"..private.balls[ i ].id );

  end;

  private.balls = {};

  private.state.last_ball_id = 0;
  private.state.stage_del_ball_num = 0;

  private.ball_waiting_flag = {};
  private.ball_insert_flag = 0;

  ObjSet( "spr_fight_amulet_ball", { 
    res = "assets/levels/levelext/mg_mgwitch/layers/balls_big/ball_"..private.balls_colors[ private.state.loaded_ball_color ],
  } );

  ObjAnimate( "spr_fight_amulet_ball", "scale_xy", 0, 0, "",
  {
    0.0, 3, 0.0, 0.0,
    0.3, 3, 1.0, 1.0,
  } );

  AnimPlay( "anm_fight_ball_create", "DoAnim", "" );

  ObjSet( "spr_fight_life", { drawoff_x = 0 } );

end;
--*********************************************************************************************************************
function private.FightCheckWin ()

  if ( private.state.stage_del_ball_num >= private.stage_win_num[ private.state.stage ] ) then

    --cmn.PlayAudio( "snd", "assets/levels/level3/mg_fight/audio/aud_hpless" );

    private.state.stage = private.state.stage + 1;

    if ( private.state.stage > #private.stage_win_num ) then

      private.state.stage = private.state.stage - 1;

      private.FightReset( true );

    else

      private.FightReset( false, true );

    end;

  end;

end;
--*********************************************************************************************************************
function private.WinEnd ()

  common_impl.PassingMgWin( "mgwitch" );
  cmn.MiniGameHide( "mgwitch" );
  cmn.SetEventDone( "win_mgwitch" );
  cmn.CallEventHandler( "win_mgwitch" );
  
  local func_end = function ()
    
    cmn.GotoRoom( "rm_credits" ); 
    
  end;  
  
  private.Outro( func_end );  

end;
--*********************************************************************************************************************
function private.Win ()

  --cmn.PlayAudio( "sfx", "audio/levelext/sfx/aud_da_ghost_die_skilet" );

  local func_end = function ()

    int.Lock( false );

    ObjSet( "obj_mgwitch_fight", { input = false, active = false } );
    private.WinEnd();

  end;

  int.Lock( true );

  ObjSet( "obj_fight_guardian_static", { alp = 0, active = false } );
  ObjSet( "anm_fight_guardian_win",    { alp = 1 } );

  AnimPlay( "anm_fight_guardian_win", "DoAnim", func_end );

  ObjAnimate( "obj_fight_life", "alp", 0, 0, "",
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

  ObjAnimate( "spr_fight_amulet", "alp", 0, 0, "",
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
function private.FightFireNewBall ()

  if private.fire_flag or private.fly_ball_flag or private.insert_flag then

    return;

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgwitch_shot" );

  private.fire_flag = true;

  local cursor_pos = GetZoomCursorPos();

  local ball_start_pos_x = 512;
  local ball_start_pos_y = 668;
  local ball_start_pos = { ball_start_pos_x, ball_start_pos_y };

  local ball_fly_border = { --границы полета шара ( левая, верхняя, правая )
    { { -172 - private.balls_diameter*2, 0 - private.balls_diameter*2 }, { -171 - private.balls_diameter*2, 768 + private.balls_diameter*2 } },
    { { -171 - private.balls_diameter*2, 0 - private.balls_diameter*2 }, { 1195 + private.balls_diameter*2,  -1 - private.balls_diameter*2 } },
    { { 1195 + private.balls_diameter*2, 0 - private.balls_diameter*2 }, { 1196 + private.balls_diameter*2, 768 + private.balls_diameter*2 } }
  };

  local ball_end_pos;
  local len;
  local new_len;

  local cycle_step_start = 1;
  local cycle_step_num   = 2;
  if ( cursor_pos[ 1 ] > ball_start_pos_x ) then  --стрельнули влево  сравниваем с левой  и верхней границе

    cycle_step_start = 2;                         --стрельнули вправо сравниваем с правой и верхней границе
    cycle_step_num   = 3;

  end;

  for i = cycle_step_start, cycle_step_num, 1 do

    ball_end_pos = private.FightFindLineIntersection( cursor_pos, ball_start_pos, ball_fly_border[i][1], ball_fly_border[i][2] );
    new_len = private.FightFindSegmentLength( ball_start_pos, ball_end_pos );

    if ( not len ) or ( new_len < len ) then

      len = new_len;
      private.fire_points.ball_start_pos = ball_start_pos;
      private.fire_points.ball_end_pos = ball_end_pos;
      private.fire_points.len = len;

    end;

  end;

  ObjSet( "spr_fight_amulet_ball", { scale_x = 0.0, scale_y = 0.0 } );

  private.FightFireNewBallBeg();

end;
--*********************************************************************************************************************
function private.FightFireNewBallBeg ()

  private.fire_flag = false;
  private.fly_ball_flag = true;

  private.fire_ball_color = private.state.loaded_ball_color;
  private.state.loaded_ball_color = math.random( 1, #private.balls_colors );

  local ball_color = private.fire_ball_color;
  local ball_name = "spr_fight_flying_ball";

  ObjCreate( ball_name, "spr" );
  ObjSet( ball_name, {
    res = "assets/levels/levelext/mg_mgwitch/layers/balls_big/ball_"..private.balls_colors[ ball_color ],
    pos_x = private.fire_points.ball_start_pos[1],
    pos_y = private.fire_points.ball_start_pos[2]
  } );
  ObjAttach( ball_name, "obj_fight_fireballshub" );

  local tme = private.fire_ball_speed_coefficient * private.fire_points.len + 1.5;
  ObjAnimate( ball_name, "pos_xy", 0, 0, private.FightFireNewBallEnd, { 
    0,   0, private.fire_points.ball_start_pos[1], private.fire_points.ball_start_pos[2],
    tme, 0, private.fire_points.ball_end_pos[1],   private.fire_points.ball_end_pos[2] 
  } );

  ObjAnimate( ball_name, "scale_xy", 0, 0, "", { 
    0,   0, 1.0, 1.0,
    tme/2, 0, 0.5, 0.5 
  } );

  ObjSet( "spr_fight_amulet_ball", { 
    res = "assets/levels/levelext/mg_mgwitch/layers/balls_big/ball_"..private.balls_colors[ private.state.loaded_ball_color ],
  } );

  ObjAnimate( "spr_fight_amulet_ball", "scale_xy", 0, 0, "",
  {
    0.0, 3, 0.0, 0.0,
    0.3, 3, 1.0, 1.0,
  } );

  AnimPlay( "anm_fight_ball_create", "DoAnim", "" );

end;
--*********************************************************************************************************************
function private.FightFireNewBallEnd ()

  private.fly_ball_flag = false;
  ObjStopAnimate( "spr_fight_flying_ball", "pos_xy" );
  ObjDelete( "spr_fight_flying_ball" );

end;
--*********************************************************************************************************************
function private.FightStartGame ()

  --if ( private.fight_is_start ) then

    --return;

  --end;

  --private.fight_is_start = true;

  private.FightCreateBall();

  ObjSet( "tmr_fight_gametimer", { time = private.time_between_points, endtrig = private.FightMoveBalls, playing = true } );

end;
--*********************************************************************************************************************
function private.FightCreateBall ( ball_color, pos_x, pos_y, pos, point )

  private.state.last_ball_id = private.state.last_ball_id + 1;

  ball_color = ball_color or math.random( 1, #private.balls_colors );

  local ball_num = private.state.last_ball_id;
  local ball_name = "spr_fight_ball_"..ball_num;
  local ball_pos_x = pos_x or private[ "stage_points_"..private.state.stage ][ 1 ][ 1 ];
  local ball_pos_y = pos_y or private[ "stage_points_"..private.state.stage ][ 1 ][ 2 ];
  local ball_alp_scale = 0;

  if ( pos ) then

    ball_alp_scale = 1;
    table.insert( private.balls, pos, { id = ball_num, color = ball_color, pos = point, move = true } );

  else

    ball_alp_scale = 0;
    table.insert( private.balls, { id = ball_num, color = ball_color, pos = 1, move = true } );

  end;

  ObjCreate( ball_name, "spr" );
  ObjSet( ball_name, {
    res = "assets/levels/levelext/mg_mgwitch/layers/balls/ball_"..private.balls_colors[ ball_color ],
    pos_x = ball_pos_x,
    pos_y = ball_pos_y,
    scale_x = ball_alp_scale,
    scale_y = ball_alp_scale,
    alp = ball_alp_scale
  } );
  ObjAttach( ball_name, "obj_fight_ballshub" );

  if ( not pos ) then

    ObjAnimate( ball_name, "alp",      0, 0, "", { 0, 0, 0,       0.3, 0, 1 } );
    ObjAnimate( ball_name, "scale_xy", 0, 0, "", { 0, 0, 0, 0,    0.3, 0, 1, 1 } );

  end;

end;
--*********************************************************************************************************************
function private.FightInsertBalls ( num, fire_ball_pos_x, fire_ball_pos_y )

  private.insert_flag = true;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgwitch_contakt" );

  local stage_points = private[ "stage_points_"..private.state.stage ];

  private.ball_insert_flag = num;

  private.FightFireNewBallEnd();

  private.FightCreateBall( 
    private.fire_ball_color, 
    fire_ball_pos_x, 
    fire_ball_pos_y, 
    num + 1,
    private.balls[ num ].pos
  );

  local last_stoping_ball = #private.balls;  --номер последнего останавливаемого шара
  local first_moving_ball = 1;  --номер первого смещаемого шара

  for i = #private.ball_waiting_flag, 1, -1  do
    if ( private.ball_waiting_flag[i] >= num ) then
      private.ball_waiting_flag[i] = private.ball_waiting_flag[i] + 1;
      last_stoping_ball = private.ball_waiting_flag[i];
    end;
  end;

  for i = 1, #private.ball_waiting_flag, 1  do
    if ( private.ball_waiting_flag[i] <= num ) then
      first_moving_ball = private.ball_waiting_flag[i] + 1;
    end;
  end;

  for i = num + 1, last_stoping_ball, 1 do
    private.balls[i].move = false;
  end;

  for i = first_moving_ball, num, 1 do
    private.balls[i].move = true;
  end;

  local fire_ball_end_pos_x = stage_points[ private.balls[num].pos ][1];
  local fire_ball_end_pos_y = stage_points[ private.balls[num].pos ][2];

  ObjAnimate( "spr_fight_ball_"..private.state.last_ball_id, "pos_xy", 0, 0,
  function ()

    private.insert_flag = false;

  end, 
  { 0,   0, fire_ball_pos_x,     fire_ball_pos_y,    
    0.2, 0, fire_ball_end_pos_x, fire_ball_end_pos_y
  } );

end;
--*********************************************************************************************************************
function private.FightInsertBallsEnd ()

  local ball_waiting_before_ball_insert = false;

  for i = 1, #private.ball_waiting_flag, 1 do
    if ( private.ball_waiting_flag[i] >= private.ball_insert_flag + 1 ) then
      ball_waiting_before_ball_insert = true;
      break;
    end;
  end;

  if ( not ball_waiting_before_ball_insert ) then

    for i = private.ball_insert_flag + 1, #private.balls, 1 do
      private.balls[i].move = true;
    end;

  else

    for i = 1, private.ball_insert_flag, 1 do
      private.balls[i].move = false;
    end;

  end;

  local check_ball_num = private.ball_insert_flag + 1;

  private.ball_insert_flag = 0;
  private.FightCheckSameBalls( check_ball_num, private.balls[ check_ball_num ].color );

end;
--*********************************************************************************************************************
function private.FightCheckSameBalls ( check_ball_num, check_color, need_launch_befor_delete_flag )

  check_color = check_color or private.fire_ball_color;

  local same_color_balls = {};  --сщитаем количество одинаковых шариков

  local left_search_border  = #private.balls; --границы поиска
  local right_search_border = 1;

  ----------------------определяем границы поиска

  if ( check_ball_num ~= #private.balls ) then

    for i = 1, #private.ball_waiting_flag, 1 do
      if ( private.ball_waiting_flag[i] >= check_ball_num ) then
        left_search_border = private.ball_waiting_flag[i];
        break;
      end;
    end;

  end;

  if ( check_ball_num ~= 1 ) then

    for i = #private.ball_waiting_flag, 1, -1 do
      if ( private.ball_waiting_flag[i] < check_ball_num ) then
        right_search_border = private.ball_waiting_flag[i] + 1;
        break;
      end;
    end;

  end;

  -------------------------сщитаем количество одинаковых шаров

  for k = check_ball_num, right_search_border, -1 do

    if ( check_color == private.balls[k].color ) then
      table.insert( same_color_balls, k );
    else
      break;
    end;

  end;

  for k = check_ball_num+1, left_search_border, 1 do

    if ( check_color == private.balls[k].color ) then
      table.insert( same_color_balls, k );
    else
      break;
    end;

  end;

  if ( #same_color_balls >= 3 ) then

    if ( private.ball_insert_flag ~= 0 ) then

      for i = 1, #same_color_balls, 1 do
        if ( same_color_balls[i] == private.ball_insert_flag + 1 ) then
          need_launch_befor_delete_flag = true;
          break;
        end;
      end;

    end;

    if ( need_launch_befor_delete_flag ) then

      for i = check_ball_num, #private.balls, 1 do
        private.balls[i].move = true;
      end;

    end;

    private.FightDeleteBalls( same_color_balls );

  end;

end;
--*********************************************************************************************************************
function private.FightDeleteBalls ( same_color_balls )

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgwitch_balls_diss" );

  local old_life_drawoff_x = math.floor( ( private.life_drawoff_x / private.stage_win_num[ private.state.stage ] ) * private.state.stage_del_ball_num );

  private.state.stage_del_ball_num = private.state.stage_del_ball_num + #same_color_balls;

  local new_life_drawoff_x = math.floor( ( private.life_drawoff_x / private.stage_win_num[ private.state.stage ] ) * private.state.stage_del_ball_num );

  ObjAnimate( "spr_fight_life", "drawoff_x", 0, 0, "",
  { 
    0.00, 0, old_life_drawoff_x,
    0.12, 0, new_life_drawoff_x
  } );

  -----------------

  local stage_points = private[ "stage_points_"..private.state.stage ];
  local first_stoping_ball = 1; --первый останавливаемый шар, после образования дырки

  table.sort( same_color_balls );

  local anm_pos;
  local anm_pos_x;
  local anm_pos_y;
  local anm_color;

  for d = 1, #same_color_balls, 1 do

    local delete_ball_name = "spr_fight_ball_"..private.balls[ same_color_balls[d] ].id;

    ObjAnimate( delete_ball_name, "alp", 0, 0, function () ObjDelete( delete_ball_name ); end, { 0, 0, 1,   0.3, 0, 0 } );
    ObjAnimate( delete_ball_name, "scale_xy", 0, 0, "", { 0, 0, 1, 1,    0.3, 0, 0, 0 } );

  end;

  for d = #same_color_balls, 1, -1 do

    table.remove( private.balls, same_color_balls[ d ] );

  end;

  local need_to_insert_end_ball = false; --флаг надобности завершить вставку шара после удаления

  -----------------проверка на процесс вставки
  if ( private.ball_insert_flag ~= 0 ) then

    local ball_insert_num = private.ball_insert_flag + 1;

    if  ( ball_insert_num >= same_color_balls[1] ) 
    and ( ball_insert_num <= same_color_balls[#same_color_balls] ) then

      first_stoping_ball = 1;
      private.ball_insert_flag = 0;

    elseif ( ball_insert_num < same_color_balls[1] ) then

      first_stoping_ball = ball_insert_num;

    elseif ( ball_insert_num > same_color_balls[ #same_color_balls ] ) then

      private.ball_insert_flag = private.ball_insert_flag - #same_color_balls;

      if ( private.ball_insert_flag > 0 ) then
      else
        need_to_insert_end_ball = true;
      end;

    end;

  end;

  local new_ball_waiting = same_color_balls[1] - 1;

  ------------------------ изменение флагов ожидания

  for i = #private.ball_waiting_flag, 1, -1  do
    if ( private.ball_waiting_flag[i] > same_color_balls[ #same_color_balls ] ) then

      private.ball_waiting_flag[i] = private.ball_waiting_flag[i] - #same_color_balls;

    elseif ( private.ball_waiting_flag[i] >= same_color_balls[1] ) 
    and ( private.ball_waiting_flag[i] <= same_color_balls[#same_color_balls] ) then

      table.remove( private.ball_waiting_flag, i );

    else

      if ( new_ball_waiting == private.ball_waiting_flag[i] ) then
        new_ball_waiting = 0;
      end;

      break;

    end;
  end;

  --------------------- добавление новых флагов ожидания

  if new_ball_waiting > 0 then

    table.insert( private.ball_waiting_flag, new_ball_waiting );
    table.sort( private.ball_waiting_flag );

    for i = first_stoping_ball, new_ball_waiting, 1 do --останавливаем шары, идущие перед оброзовавшейся дыркой
      private.balls[i].move = false;
    end;

  end;

  if ( need_to_insert_end_ball ) then

    private.FightInsertBallsEnd();

  end;

end;
--*********************************************************************************************************************
function private.FightMoveBalls ()

  local stage_points = private[ "stage_points_"..private.state.stage ];

  if ( private.balls[1].pos == #stage_points ) then

   local func_end = function ()

      ObjSet( "obj_fight_guardian_static", { alp = 1 } );
      ObjSet( "anm_fight_guardian_lose",   { alp = 0 } );

      AnimStop( "anm_fight_guardian_lose" );
      AnimPlay( "anm_fight_guardian_static_"..private.state.stage, "DoAnim", "" );

      private.FightReset();

    end;

    ObjSet( "obj_fight_guardian_static", { alp = 0 } );
    ObjSet( "anm_fight_guardian_lose",   { alp = 1 } );

    AnimStop( "anm_fight_guardian_static_"..private.state.stage );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mg_mgwitch_loose_session" );
    AnimPlay( "anm_fight_guardian_lose", "DoAnim", func_end );

    --private.FightReset();

    --*****************************************************************************************
    --*****************************************************************************************
    int.Lock( true );

    ObjSet( "tmr_fight_gametimer", { playing = false } );

    for i = 1, #private.balls, 1 do

      local ball_name = "spr_fight_ball_"..private.balls[ i ].id;
      local ball_params = ObjGet( ball_name );

      ObjAnimate( ball_name, "alp", 0, 0, "", { 0, 0, ball_params.alp,   0.3, 0, 0 } );
      ObjAnimate( ball_name, "scale_xy", 0, 0, "", { 0, 0, ball_params.scale_x, ball_params.scale_y,    0.3, 0, 0, 0 } );

    end;
    --*****************************************************************************************
    --*****************************************************************************************

    return;

  end;

  local ball_num;
  local ball_pos;
  local ball_new_pos_x;
  local ball_new_pos_y;

  local ball_old_pos_x;
  local ball_old_pos_y;

  -------------------------

  if ( #private.ball_waiting_flag > 0 ) then  --есть ожидающие шары

    for check_waiting_ball_num = #private.ball_waiting_flag, 1, -1 do

      local num_waiting_balls = private.ball_waiting_flag[ check_waiting_ball_num ]; --номер шара который стоит
      local num_move_balls = num_waiting_balls + 1; --номер шара после ждущего

      if ( num_move_balls <= #private.balls ) then  --проверка на существование шара

        local movebal_pos = private.balls[ num_move_balls ].pos;
        local waiting_ball_pos = private.balls[ num_waiting_balls ].pos;
        local distance_moveball_waiting_ball = private.FightFindSegmentLength( stage_points[ movebal_pos ], stage_points[ waiting_ball_pos ] );

        if ( distance_moveball_waiting_ball <= private.balls_diameter + private.distance_between_points ) then

          table.remove( private.ball_waiting_flag, check_waiting_ball_num );

          local num_first_launch_ball = 1; --первый запускаемый шар

          for i = #private.ball_waiting_flag, 1, -1 do    --ищем дыры спереди
            if ( private.ball_waiting_flag[i] < num_waiting_balls ) then
              num_first_launch_ball = private.ball_waiting_flag[ i ] + 1;
              break;
            end;
          end;


          local need_launch_befor_delete_flag = false;  --флаг надобности запустить остановленные шары перед удалением

          if ( private.ball_insert_flag ~= 0 )
          and ( private.ball_insert_flag + 1 >= num_first_launch_ball )
          and ( private.ball_insert_flag + 1 <= num_waiting_balls ) then

            for i = num_move_balls, #private.balls, 1 do
              private.balls[ i ].move = false;
            end;

            need_launch_befor_delete_flag = true;

          else

            for i = num_first_launch_ball, num_waiting_balls, 1 do
              private.balls[ i ].move = true;
            end;

          end;

          if ( private.balls[ num_move_balls ].color == private.balls[ num_waiting_balls ].color ) then
            private.FightCheckSameBalls( num_move_balls, private.balls[ num_move_balls ].color, need_launch_befor_delete_flag );
          end;

        end;

      end;

    end;

  end;

  -------------------------

  if ( private.ball_insert_flag ~= 0 ) then

    local insert_bal_pos = private.balls[ private.ball_insert_flag + 1 ].pos;
    local move_ball_pos  = private.balls[ private.ball_insert_flag ].pos;
    local distance_insert_ball_move_ball = private.FightFindSegmentLength( stage_points[ insert_bal_pos ], stage_points[ move_ball_pos ] );

    if ( distance_insert_ball_move_ball >= private.balls_diameter ) then --+ private.distance_between_points

      private.FightInsertBallsEnd();

    end;

  end;

  -------------------------

  for i = 1, #private.balls, 1 do  --двигаем эти шары

    if ( private.balls[ i ].move ) then

      ball_pos = private.balls[ i ].pos;
      ball_old_pos_x = stage_points[ ball_pos ][ 1 ];
      ball_old_pos_y = stage_points[ ball_pos ][ 2 ];

      private.balls[ i ].pos = private.balls[ i ].pos + 1;

      ball_num = private.balls[i].id;
      ball_pos = private.balls[i].pos;
      ball_new_pos_x = stage_points[ ball_pos ][ 1 ];
      ball_new_pos_y = stage_points[ ball_pos ][ 2 ];

      ObjAnimate( "spr_fight_ball_"..ball_num, "pos_xy", 0, 0, "", 
      { 0,                           0, ball_old_pos_x, ball_old_pos_y,
        private.time_between_points, 0, ball_new_pos_x, ball_new_pos_y
      } );

    end;

  end;

  -------------------------

  if ( private.fly_ball_flag ) then   --проверки на поподание выстреленного шара

    local fire_ball_name = "spr_fight_flying_ball";
    local fire_ball_pos_x = ObjGet( fire_ball_name ).pos_x;
    local fire_ball_pos_y = ObjGet( fire_ball_name ).pos_y;
    local fire_ball_pos = { fire_ball_pos_x, fire_ball_pos_y };
    local len;

    for i = 1, #private.balls, 1 do

      len = private.FightFindSegmentLength( fire_ball_pos, stage_points[ private.balls[ i ].pos ] );

      if ( len < private.balls_diameter ) then

        --cmn.PlayAudio( "snd", "assets/levels/level3/mg_fight/audio/aud_target" );

        private.FightInsertBalls( i, fire_ball_pos_x, fire_ball_pos_y );

        break;

      end;

    end;

  end;

  ----------------------------

  if ( #private.balls == 0) then  --создание новых шаров
    private.FightCreateBall();
  else

    local last_ball_pos = private.balls[ #private.balls ].pos;
    local distance_from_start_to_last_ball = private.FightFindSegmentLength( stage_points[1], stage_points[ last_ball_pos ] );

    if ( distance_from_start_to_last_ball >= private.balls_diameter ) then

    private.FightCreateBall();
    end;

  end;

  ----------------------------

  ObjSet( "tmr_fight_gametimer", { time = private.time_between_points, endtrig = private.FightMoveBalls, playing = true } );

  private.FightCheckWin();

end;
--*********************************************************************************************************************
function private.FightFindSegmentPoint ( point_a, point_b, delta )
  --нахождения координат точки на отрезке по заданному отношению
  --( {x1,y1}, {x2,y2}, num )

  local pos_x = ( point_a[1] + ( delta * point_b[1] ) ) / ( 1 + delta );
  local pos_y = ( point_a[2] + ( delta * point_b[2] ) ) / ( 1 + delta );

  return { pos_x, pos_y };

end;
--*********************************************************************************************************************
function private.FightFindSegmentLength ( point_a, point_b )
  --нахождение растояния от координаты А до Б ( {x1,y1}, {x2,y2} )

  local len = ( ( point_b[ 1 ] - point_a[ 1 ] )^2 + ( point_b[ 2 ] - point_a[ 2 ] )^2 )^0.5;
  return len;

end;
--*********************************************************************************************************************
function private.FightFindLineIntersection ( point_a1, point_b1, point_a2, point_b2 )
  --нахождения точки пересечения прямых
  --входные параметры - 2 точки каждой прямой {x,y}
  --ОСТОРОЖНО!!! упращенная формула, может быть деление на нуль, при чисто горизонтальных/вертикальных линиях

  local x1 = point_a1[ 1 ]; local y1 = point_a1[ 2 ];
  local x2 = point_b1[ 1 ]; local y2 = point_b1[ 2 ];

  local x3 = point_a2[ 1 ]; local y3 = point_a2[ 2 ];
  local x4 = point_b2[ 1 ]; local y4 = point_b2[ 2 ];

  local x = ( ((x1*y2-x2*y1)*(x4-x3)-(x3*y4-x4*y3)*(x2-x1))/((y1-y2)*(x4-x3)-(y3-y4)*(x2-x1)) );
  local y = ( ((y3-y4)*x-(x3*y4-x4*y3))/(x4-x3) );

  x = -x;

  return { x, y };

end;
--*********************************************************************************************************************
function private.FightSplitBallsPoints ()

  local start_points;
  local seg_len;
  local point_a;
  local point_b;
  local points_in_seg;
  local delta;
  local new_point;

  local seg_a_to_new;
  local seg_new_to_b;

  for stage = 1, #private.stage_win_num, 1 do

    start_points = private[ "start_stage_points_"..stage ];
    point_a = start_points[ 1 ];

    table.insert( private[ "stage_points_"..stage ], point_a );

    for i = 1, #start_points - 1, 1 do

      point_b = start_points[i+1];
      seg_len = private.FightFindSegmentLength( point_a, point_b );
      points_in_seg = math.floor( seg_len / private.distance_between_points );

      for j = 1, points_in_seg, 1 do

        seg_a_to_new = private.distance_between_points * j;
        seg_new_to_b = seg_len - ( private.distance_between_points * j );

        if     ( seg_a_to_new == 0 ) then --попали на начальную точку
          new_point = point_a;
        elseif ( seg_new_to_b == 0 ) then --попали на канечную точку
          new_point = point_b;
        else
          delta = seg_a_to_new / seg_new_to_b;
          new_point = private.FightFindSegmentPoint( point_a, point_b, delta );
        end;

        table.insert( private[ "stage_points_"..stage ], new_point );

      end;

      point_a = new_point;

    end;

  end;

end;
--*********************************************************************************************************************
function private.FightArrowAnim ()

  local params = ObjGet( "spr_fight_amulet" );
  local x1 = params.pos_x;
  local y1 = params.pos_y;

  local cursor_pos = GetZoomCursorPos();
  local x2 = cursor_pos[ 1 ];
  local y2 = cursor_pos[ 2 ];

  local ang = private.FightArrowAng( x1,y1,x2,y2 ) - 1.57;

  ObjSet( "spr_fight_amulet_arrow", { ang = ang } );
  ObjSet( "tmr_fight_arrow",
  {
    playing = 1,
    time = 0.01,
    endtrig = function ()

      private.FightArrowAnim();

    end
  } );

end;
--*********************************************************************************************************************
function private.FightArrowStopAnim ()

  ObjSet( "tmr_fight_arrow", { playing = 0 } );

end;
--*********************************************************************************************************************
function private.FightArrowAng( x1,y1,x2,y2 )

  local len = ( (x1-x2)^2 +(y1-y2)^2 )^0.5
  y1 = -y1; --переворот для игровой системы координат
  y2 = -y2; --переворот для игровой системы координат

  if ( len == 0 ) then return 0,0 end; --исключение

  local k = ( y1 - y2 ) / len;
  local a = math.abs( math.asin( k ) );

  if ( x2 >= x1 and y2 <= y1 ) then

    a = math.pi*2 - a;
    return a,len;

  elseif ( x2 >= x1 and y2 >= y1 ) then

    return a,len;

  elseif ( x2 <= x1 and y2 <= y1 ) then

    a = math.pi + a;
    return a,len;

  elseif ( x2 <= x1 and y2 >= y1 ) then

    a = math.pi - a;
    return a,len;

  end;

end
--*********************************************************************************************************************
function private.Outro ( end_func )

  cmn.StopAllMus();
  cmn.StopAllEnv();

  local func_end = function ( skip )

    int.Lock( false );
    
    if ( skip ) then

      cmn.StopAudio( "mus", "audio/level4/mus/aud_mgwitch_outro" );
      --cmn.StopAudio( "voc", "audio/level4/voc/aud_mgfight3_outro_voc" );

    end;

    common_impl.InterfaceSetVisible( true );
    end_func();

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_mgwitch_outro", func_end );  

  cmn.PlayAudio( "mus", "audio/level4/mus/aud_mgwitch_outro" );
  --cmn.PlayAudio( "voc", "audio/level4/voc/aud_mgfight3_outro_voc" );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_mgwitch_light", "alp", 1, 0, "",
  {
    0.0, 3, 0.3,
    3.0, 3, 1.0,
    6.0, 3, 0.3,
  } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************