-- name=levelext
--*********************************************************************************************************************
function public.Start ( param )

  int.WidgetAdd( InterfaceWidget_Pause, 1800 );
  int.WidgetAdd( InterfaceWidget_BtnMenu, 12 );
  int.WidgetAdd( InterfaceWidget_BtnHint, 9 );
  int.WidgetAdd( InterfaceWidget_BtnSkip, 9 );
  int.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  int.WidgetAdd( InterfaceWidget_BtnReset, 9 );
  int.WidgetAdd( InterfaceWidget_Inventory, 21 );
  int.WidgetAdd( InterfaceWidget_TaskPanel, 22 );
  int.WidgetAdd( InterfaceWidget_ItemPanel, 22 );
  int.WidgetAdd( InterfaceWidget_Effects, 24 );
  int.WidgetAdd( InterfaceWidget_BtnMap, 11 );
  int.WidgetAdd( InterfaceWidget_DialogHo );
  int.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );
  int.WidgetAdd( InterfaceWidget_Popup, 31 );
  int.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  int.WidgetAdd( InterfaceWidget_Dialog, 22 );
  int.WidgetAdd( InterfaceWidget_DialogVideo, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogStory, 1491 );
  int.WidgetAdd( InterfaceWidget_DialogCharacter, 1491 );
  int.WidgetAdd( InterfaceWidget_StrategyGuide );
  int.WidgetAdd( InterfaceWidget_Window );
  int.WidgetAdd( InterfaceWidget_Tutorial, 25 );
  int.WidgetAdd( InterfaceWidget_Map, 24 );

  int.ButtonLockAdd();
  int.PanelNotificationAdd();
  int.DeployInvAdd( 9 );
  int.DialogHintAdd( 10 );

  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );
  int.InitMiniho( 18 );
  --int.InitLoupe( 20 );

  --
  private.Init();
  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init();
  --

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.WidgetAdd( InterfaceWidget_BtnGuide, 8 );
    interface.AchievementsAdd( 10 );
    int.MorphingAdd( 10 );
    int.CollectiblesAdd( 20 );
    int.Collectibles2Add( 22 );
    int.ScreensaverAdd( 11 ); 

  end;

  common.LevelLoad( "levelext", "ext", "rm_square", param, private.menu_moduls );

  private.TutorialSetParams();
  interface.KeyUpdate();

  local collectibles = 
  {
     "get_collect_4_1"
    ,"get_collect_4_2"
    ,"get_collect_4_3"
  };
  local collect_morph = 
  {
     "get_morphobject_4_1"
    ,"get_morphobject_4_2"
    ,"get_morphobject_4_3"
    ,"get_morphobject_4_4"
    ,"get_morphobject_4_5"
    ,"get_morphobject_4_6"
    ,"get_morphobject_4_7"
    ,"get_morphobject_4_8"
    ,"get_morphobject_4_9"
    ,"get_morphobject_4_10"
  };   

  local screen_s = 
  {
     "screensaver_4_1"
    ,"screensaver_4_2"
    ,"screensaver_4_3"
    ,"screensaver_4_4"
    ,"screensaver_4_5"
    ,"screensaver_4_6"
    ,"screensaver_4_7"
    ,"screensaver_4_8"
    ,"screensaver_4_9"
    ,"screensaver_4_10"
    ,"screensaver_4_11" 
    ,"screensaver_4_12"    
    ,"screensaver_4_13"
    ,"screensaver_4_14"
    ,"screensaver_4_15"
    ,"screensaver_4_16"   
  };     
  
  if ( not IsCollectorsEdition() and not IsSurveyEdition() ) then

    ObjSet( "btn_map_button_diary", { pos_x = 10 } );
    ObjSet( "btn_map_button_collectibles", { visible = 0, active = 0, input = 0  } );
    ObjSet( "btn_map_button_achievements", { visible = 0, active = 0, input = 0  } );        

    for i = 1, #collectibles do

      cmn.SetEventDone( collectibles[ i ] );
      cmn.CallEventHandler( collectibles[ i ] );

    end;
    for i = 1, #collect_morph do

      cmn.SetEventDone( collect_morph[ i ] );
      cmn.CallEventHandler( collect_morph[ i ] );

    end;
    for i = 1, #screen_s do

      cmn.SetEventDone( "get_"..screen_s[ i ] );
      cmn.CallEventHandler( "get_"..screen_s[ i ] );

    end;     

  else

    for i = 1, #collectibles do

      if ( ng_global.collect[ collectibles[ i ] ] ~= nil ) then

        if ( ng_global.collect[ collectibles[ i ] ].done == 1 ) then

          cmn.SetEventDone( "get_"..collectibles[ i ] );
          cmn.CallEventHandler( "get_"..collectibles[ i ] );

        end;

      end;

    end;
    for i = 1, #collect_morph do

      if ( ng_global.morphings[ collect_morph[ i ] ] ~= nil ) then
          if ( ng_global.morphings[ collect_morph[ i ] ].done == 1 ) then

            cmn.SetEventDone( collect_morph[ i ] );
            cmn.CallEventHandler( collect_morph[ i ] );

          end;
      end;

    end;         
    for i = 1, #screen_s do

      if ( ng_global.screensaver[ screen_s[ i ] ] ~= nil ) then
          if ( ng_global.screensaver[ screen_s[ i ] ].done == 1 ) then

            cmn.SetEventDone( "get_"..screen_s[ i ] );
            cmn.CallEventHandler( "get_"..screen_s[ i ] );

          end;
      end;

    end;      

  end;

end;
--*********************************************************************************************************************
function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_alchemiststore"
    ,"rm_pagantemple"
    ,"rm_dungeon"
    ,"rm_hospital"
    ,"rm_headphysicianoffice"
    ,"rm_prison"
    ,"rm_sidesteet"
    ,"rm_park"
    ,"rm_morgue"
    ,"rm_square"
    ,"mg_mgwitch"
    ,"ho_hosafe"
    ,"mg_mgdominoes"
    ,"mg_mgcrystals"
    ,"ho_hogargoyle"
    ,"ho_hotable"
    ,"ho_homagiccube"
  };

  game.progress_names =
  {
   "beg_levelext"
  ,"dlg_square_emily4_0"
  ,"get_leprechaunamulet_1"
  ,"get_alchemistryamulet"
  ,"get_firepoker"
  ,"get_sphynxamulet_1"
  ,"use_firepoker_1"
  ,"get_flaskofwater"
  ,"get_pincers"
  ,"use_flaskofwater"
  ,"use_pincers"
  ,"get_knightamulet"
  ,"use_knightamulet"
  ,"get_stiletto"
  ,"use_stiletto_1"
  ,"get_sigmaamulet"
  ,"use_sigmaamulet"
  ,"get_storekey"
  ,"use_storekey"

  ,"opn_alchemiststore"
  --,"dlg_alchemiststore_emily4_1"
  ,"get_jupiteremblem"
  ,"get_mop"
  ,"get_coin"
  ,"use_alchemistryamulet"
  ,"get_toydial"
  ,"use_jupiteremblem"
  ,"get_crazydoctor_1"
  ,"use_coin"
  ,"get_awl"
  ,"get_leprechaunamulet_2"
  ,"use_awl"
  ,"get_sphynxamulet_2"
  ,"use_mop"
  ,"get_fairyfigurine"
  ,"use_fairyfigurine"
  ,"get_toymouse"
  ,"use_toymouse"
  ,"win_toydial"
  ,"get_leprechaunamulet_3"
  ,"use_leprechaunamulet"
  ,"get_packofseeds"
  ,"get_thermalmatches"
  ,"use_packofseeds"
  ,"get_sphynxamulet_3"
  ,"use_sphynxamulet"
  ,"win_hosafe"--  ,"get_gatekey"
  ,"use_gatekey"
  
  ,"opn_park"  
  ,"get_container"
  ,"use_firepoker_2"
  ,"get_coatlamulet_1"
  ,"use_stiletto_2"
  ,"get_jaw"
  ,"get_tridentamulet_1"
  ,"get_staroflife_1"
  ,"use_thermalmatches"
  ,"get_crazydoctor_2"
  ,"use_stiletto_3"
  ,"get_tridentamulet_2"
  ,"use_crazydoctor"
  ,"get_salamanderamulet"
  ,"use_salamanderamulet"
  ,"get_fireaxe"
  ,"use_fireaxe"
  ,"get_tridentamulet_3"
  ,"get_deeramulet"
  ,"use_firepoker_3"
  ,"use_tridentamulet"
  ,"get_extendingladder"
  ,"use_extendingladder"
  
  ,"opn_hospital"  
  ,"get_clamp"
  ,"use_stiletto_4"
  ,"get_safedisk"
  ,"get_nutwrench"
  ,"use_clamp"
  ,"get_staroflife_2"
  ,"use_nutwrench"
  ,"get_handle"
  ,"use_handle"
  ,"get_lockerkey"
  ,"get_grimsickleramulet"
  ,"use_grimsickleramulet"
  ,"get_butterflyfigurine"
  ,"use_lockerkey"
  ,"get_purifyingsphere"
  ,"use_purifyingsphere"
  
  ,"opn_headphysicianoffice"  
  ,"get_safehandle"
  ,"get_staroflife_3"
  ,"get_antimagicpowder"
  ,"get_split"
  ,"use_butterflyfigurine"
  ,"get_dummyarm"
  ,"use_split"
  ,"get_staroflife_4"
  ,"use_staroflife"
  ,"get_magicheart"
  ,"use_deeramulet"
  ,"get_horn_1"
  ,"use_antimagicpowder"
  ,"get_lilyamulet"
  ,"use_lilyamulet"
  ,"get_emptysyringe"
  ,"use_emptysyringe"
  ,"get_syringewithoil"
  ,"use_syringewithoil"
  ,"get_coatlamulet_2"
  ,"use_coatlamulet"
  ,"get_horn_2"
  ,"use_horn"
  ,"use_safedisk"
  ,"use_safehandle"
  ,"win_stash"
  ,"clk_safelever"
  ,"get_eyeofhorusamulet"
  ,"use_eyeofhorusamulet"
  ,"get_magiceye"
  ,"use_magiceye"
  ,"use_magicheart"
  ,"use_dummyarm"
  ,"use_jaw"
  ,"get_harpamulet"
  ,"use_harpamulet"
  ,"get_tonearm"
  ,"clk_tonearm"
  ,"use_tonearm"
  ,"win_hotable"  --,"get_nameseal"

  ,"opn_dungeon"
  ,"dlg_dungeon_emily4_4"
  ,"get_chisel"
  ,"get_atlantesamulet_1"
  ,"get_runedice_1"
  ,"use_chisel_1"
  ,"get_hellhoundamulet"
  ,"use_hellhoundamulet"
  ,"get_magiccube"
  ,"use_chisel_2"
  ,"get_shachihokoamulet"
  ,"use_shachihokoamulet"
  ,"get_crystalsofpurity"
  ,"use_crystalsofpurity"
  ,"win_mgcrystals"
  ,"dlg_dungeon_emily4_2"
  
  ,"opn_prison"
  ,"get_splinter"
  ,"get_minotauramulet_1"
  ,"get_atlantesamulet_2"
  ,"get_stoneofsouls_1"
  ,"use_splinter"
  ,"get_infamulet"
  ,"dlg_prison_nicholas_1"
  ,"get_magiccircle"
  ,"get_atlantesamulet_3"
  ,"use_atlantesamulet"
  ,"clk_magiccube"
  
  ,"win_homagiccube"--,"get_theseusfigurine"
  ,"use_theseusfigurine"
  ,"get_magicshield"
  ,"use_magicshield"
  
  ,"opn_pagantemple"  
  --,"dlg_pagantemple_emily4_3"
  ,"get_demonamulet"
  ,"get_stoneofsouls_2"
  ,"get_stoneofsouls_3"
  ,"get_ritualsickle"
  ,"use_infamulet"
  ,"get_satyrfigurine_1"  
  ,"get_minotauramulet_2"
  ,"use_ritualsickle_1"
  ,"get_krakenamulet"
  ,"use_krakenamulet"
  ,"get_brokenstatuette"
  ,"use_minotauramulet"
  ,"get_wings"
  ,"get_crystalofelements_1"
  ,"use_wings"
  ,"get_creepystatue"    
  ,"use_ritualsickle_2"
  ,"get_crystalofelements_2"
  ,"use_demonamulet"
  ,"get_crystalofelements_3"
  ,"get_runedice_2"
  ,"use_ritualsickle"
  ,"get_stoneofsouls_4"
  ,"get_gargoylefigurine"
  ,"use_gargoylefigurine"
  ,"get_bonekey"
  ,"use_bonekey"
  ,"win_cage"
  ,"dlg_prison_nicholas_2"
  ,"get_amphisamulet"
  ,"use_amphisamulet"
  ,"get_gargoylehead"
  ,"use_gargoylehead"
  ,"win_hogargoyle"--  ,"get_wolfamulet"
  ,"use_wolfamulet"
  ,"get_stoneofsouls_5"
  ,"get_satyrfigurine_2"
  ,"use_satyrfigurine"
  ,"get_runedice_3"
  ,"use_runedice"
  ,"use_creepystatue"
  ,"dlg_pagantemple_demon4_1"
  ,"get_stoneofsouls_6"
  ,"see_altar_slots"
  ,"use_stoneofsouls"
  ,"get_crystalofelements_4"
  ,"use_nameseal"
  ,"use_crystalofelements"
  ,"get_circleofelements"
  ,"use_circleofelements"
  ,"dlg_pagantemple_witch4_1"

  ,"opn_square"
  ,"opn_sidesteet"

  ,"opn_morgue"
  ,"opn_mgwitch"
  ,"opn_hosafe"
  ,"opn_mgdominoes"
  ,"opn_mgcrystals"
  ,"opn_hogargoyle"
  ,"opn_hotable"
  ,"opn_homagiccube"

  ,"win_mgdominoes"
  ,"win_mgwitch"

  ,"get_collect_4_1"
  ,"get_collect_4_2"
  ,"get_collect_4_3"

  ,"get_morphobject_4_1"
  ,"get_morphobject_4_2"
  ,"get_morphobject_4_3"
  ,"get_morphobject_4_4"
  ,"get_morphobject_4_5"
  ,"get_morphobject_4_6"
  ,"get_morphobject_4_7"
  ,"get_morphobject_4_8"
  ,"get_morphobject_4_9"
  ,"get_morphobject_4_10"
  
  ,"get_screensaver_4_1"
  ,"get_screensaver_4_2"
  ,"get_screensaver_4_3"
  ,"get_screensaver_4_4"
  ,"get_screensaver_4_5"
  ,"get_screensaver_4_6"
  ,"get_screensaver_4_7"
  ,"get_screensaver_4_8"
  ,"get_screensaver_4_9"
  ,"get_screensaver_4_10"
  ,"get_screensaver_4_11" 
  ,"get_screensaver_4_12"  
  ,"get_screensaver_4_13"
  ,"get_screensaver_4_14"
  ,"get_screensaver_4_15"
  ,"get_screensaver_4_16"  
  };

  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {

      "rm_collectibles",
      "rm_achievements",
    };

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TutorialSetParams()

  if not ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ] then

    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ] = {};
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].start = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state = {};
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.no = 0;
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.currentpage = "tutorial_start";
    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].func = function() end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );

    end;

    ng_global.progress[ ng_global.currentprogress ][ "see_tutorial" ].state.pages = {

      [ "tutorial_start" ]  = { shown = 0, noskip = true,  posx = 512, posy = 384, input = true,  arrows = {} },       -- Показать туториал?

      [ "tutorial_page_1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 840, pos_y = 500, ang = 3.14 }
                                                                            } },                                        -- Открытие ЗЗ
      [ "tutorial_page_2" ]  = { shown = 0, noskip = false, posx = 512, posy = 170, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "spr_bushes1_ladybag1" }
                                                                            } },                                        -- Подбор предмета
      [ "tutorial_page_3" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "spr_int_inventory" }
                                                                              --{ pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_ladybag" }
                                                                            } },                                        -- Инвентарь, cложный инвентарный
      [ "tutorial_page_4" ]  = { shown = 0, noskip = false, posx = 512, posy = 150, input = false, arrows = {
                                                                              --{ pos_x = 0, pos_y = -80, ang = -3.14, target = "hub_int_inventory_ladybag" }
                                                                            } },                                        -- Сложный инвентарный
      [ "tutorial_page_5" ]  = { shown = 0, noskip = false, posx = 512, posy = 150, input = false, arrows = {
                                                                              { pos_x = 20, pos_y = -80, ang = 3.14, target = "gzz_greywitchgates1_van1" },
                                                                              { pos_x = -80, pos_y = 30, ang = -1.57, target = "gzz_greywitchgates1_gates1" }
                                                                            } },                                        -- Подбор предметов
      [ "tutorial_page_6" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_ladybag1" },
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_bagamulet1" },
                                                                            } },                                        -- применение предмета
      [ "tutorial_page_6_1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_bagamulet1" },
                                                                            } },                                        -- применение предмета                                                                            
      [ "tutorial_page_7" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 60, pos_y = 0, ang = 1.57, target = "gho_greywitchgates1_hovan1" },
                                                                            } },                                        -- переход в ХО
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 400, posy = 200, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = 80, ang = 0.00, target = "grm_greywitchgates1_ruinedsquare1" }
                                                                            } },                                        -- Переход в локацию
      [ "tutorial_ho1" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО с войсами
      [ "tutorial_ho2" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО обычное
      [ "tutorial_ho3" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО с силуэтами
      [ "tutorial_ho4" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              } },                                      -- ХО парами
      [ "tutorial_minigame" ]  = { shown = 0, noskip = false, posx = 512, posy = 330, input = false, arrows = { 
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_info" },
                                                                              { pos_x = 120, pos_y = 0,   ang =  1.57,  target = "obj_int_button_reset" },
                                                                              { pos_x = 100, pos_y = -50, ang = -4,     target = "int_button_skip_impl" }
                                                                            } },                                        -- Кнопка Инфо в МГ
      [ "tutorial_map_1" ] = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = -60, pos_y = -100, ang = 3.925, target = "int_button_map_impl" }
                                                                            } },                                        -- Карта
      [ "tutorial_map_2" ] = { shown = 0, noskip = false, posx = 600, posy = 200, input = false, arrows = {
                                                                              { pos_x = 300, pos_y = 320, ang = 2.355 }
                                                                            } },                                        -- Переход в локацию по карте
      [ "tutorial_achievements" ] = { shown = 0, noskip = false, posx = 512, posy = 280, input = false, arrows = {
                                                                              --{ pos_x = 80, pos_y = 60, ang = 0, target = "obj_int_achievements" },
                                                                            } },                                        -- Ачивки
      [ "tutorial_collectibles" ] = { shown = 0, noskip = false, posx = 512, posy = 280, input = false, arrows = {
                                                                              --{ pos_x = 80, pos_y = 60, ang = 0, target = "obj_int_collectibles" },
                                                                            } },                                        -- Коллектиблз
      [ "tutorial_loupe" ] = { shown = 0, noskip = true,  posx = 512, posy = 250, input = false, arrows = {
                                                                              { pos_x = 0, pos_y = -80, ang = 3.14, target = "inv_mentalmagnifier1" },
                                                                            } },                                      -- Поиск линзой
      [ "tutorial_hint" ]  = { shown = 0, noskip = false, posx = 512, posy = 250, input = false, arrows = { 
                                                                              { pos_x = 100, pos_y = -50, ang = -4, target = "obj_int_button_hint" },
                                                                            } },                                      -- Хинт
      --[ "tutorial_page_20" ] = { shown = 0, noskip = true,  posx = 512, posy = 280, input = false, arrows = {
      --                                                                        { pos_x = 0, pos_y = -80, ang = 3.14, target = "obj_int_button_ability" }
      --                                                                        } },                                    -- Абилка

    };

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************