-- name=levelext_inv
--*********************************************************************************************************************
function public.Init ()

  int.CreateDeployPlus( "ext" );

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_levelext_inv_deploy = function ()

    local visible_sparkle_ho = true;

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then

      visible_sparkle_ho = false;

    end;

    common_impl.TurnChildGfx( { "levelext_inv_deploy" } , "levelext_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_levelext_inv_deploy", update_game_mode_levelext_inv_deploy, nil );

  private.init_toydial();
  private.InitMMG();
  private.init_container();
  private.init_magiccube();
  private.init_brokenstatuette();
  private.init_magiccircle();
  
  --port.  fix
  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** toydial *** () end;
--*********************************************************************************************************************
  function private.init_toydial()

    ObjSet( "spr_deploy_inv_toydial_leprechaunamulet", { event_mdown = private.get_leprechaunamulet_3 } );
    ObjSet( "inv_toydial", { event_mdown = function() private.show_toydial() end; });
    --------------------------------------------------------------------------------------------
    -- function get_leprechaunamulet_3 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_leprechaunamulet_3" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_toydial_leprechaunamulet",
      room = "int_deploy_inv",
      zz = "deploy_inv_toydial",
      zz_gate = "inv_toydial"
    };
    --------------------------------------------------------------------------------------------
    local get_leprechaunamulet_3_inv = function ()
    
      int.InventoryItemAdd( "inv_leprechaunamulet", "spr_deploy_inv_toydial_leprechaunamulet", "assets/levels/levelext/rm_square/zz_victormemorial/inv/inv_leprechaunamulet_3" );
      int.InventoryItemRemove( "inv_toydial" );
      levelext_inv.CheckLeprechaunamulet();
    
      ObjDelete( "gfx_deploy_inv_toydial_leprechaunamulet" );
      ObjDelete( "spr_inv_toydial_leprechaunamulet_3" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_leprechaunamulet_3", get_leprechaunamulet_3_inv );
    --------------------------------------------------------------------------------------------
    -- function use_toymouse () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_toymouse" ] =
    {
      type = "use",
      use_obj = "inv_toymouse",
      use_place = "obj_deploy_inv_toydial_use_toymouse",
      room = "int_deploy_inv",
      zz = "deploy_inv_toydial",
      zz_gate = "inv_toydial"
    };
    --------------------------------------------------------------------------------------------
    local use_toymouse_inv = function ()
    
      int.InventoryItemRemove( "inv_toymouse" );
      ObjSet( "spr_inv_toydial_toymouse", { alp = 1 } );

    end;
    local use_toymouse_beg = function ()
    
      ObjDelete( "obj_deploy_inv_toydial_use_toymouse" );
    
    end;
    local use_toymouse_end = function ()
    
      --ObjSet( "spr_deploy_inv_toydial_leprechaunamulet", { alp = 1, input = true } );
      --ObjSet( "gfx_deploy_inv_toydial_leprechaunamulet", { active = true } );
      ObjSet( "spr_deploy_inv_toydial_mouse", { alp = 1});
      --ObjSet( "obj_deploy_inv_shelf", { pos_x = 0 });
      if not cmn.IsEventDone( "win_toydial") then
        
        ObjSet( "obj_deploy_inv_toydial_mmg", { input = true });
        
      end;  
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_toymouse",     use_toymouse_beg, "inv_toydial" );
    cmn.AddSubscriber( "use_toymouse",     use_toymouse_inv );
    cmn.AddSubscriber( "use_toymouse",     use_toymouse_end, "inv_toydial" );
    cmn.AddSubscriber( "use_toymouse_inv", use_toymouse_inv, "inv_toydial" );
    cmn.AddSubscriber( "use_toymouse_beg", use_toymouse_beg, "inv_toydial" );
    cmn.AddSubscriber( "use_toymouse_end", use_toymouse_end, "inv_toydial" );
    --------------------------------------------------------------------------------------------


  end;
  --*********************************************************************************************************************
  function public.use_toymouse ()

    local item = "inv_toymouse";

    if ( cmn.ShowByInv( item, "inv_toydial" ) ) and
       ( not cmn.IsEventDone( "use_toymouse" ) ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_toydial" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_toydial_use_toymouse", "deploy_inv_toydial" ) ) and
           ( not cmn.IsEventDone( "use_toymouse" ) ) then

      cmn.CallEventHandler( "use_toymouse_inv" );
      cmn.CallEventHandler( "use_toymouse_beg", "inv_toydial" );

      local func_after = function ()
      
      -- local func_end = function ()

          int.Lock( false );
          cmn.SetEventDone( "use_toymouse" );
          cmn.CallEventHandler( "use_toymouse_end", "inv_toydial" );
          private.start_mmg();

          --end;
        
        --ObjAnimate( "obj_deploy_inv_shelf", "pos_x", 0, 0, func_end,
        --{
        --  0.0, 3, 143,
        --  0.5, 3, 0
        --} );
        
      end;  
      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_insert_mouse" );
      ObjAnimate( "spr_deploy_inv_toydial_mouse", "alp", 0, 0, func_after,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0
      } );
      
      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function private.show_toydial()

   if cmn.IsEventStart( "win_toydial" ) and not cmn.IsEventDone( "win_toydial" ) then

      private.start_mmg();
      
    end;
    
    common_impl.ShowDeployInv("inv_toydial");
    
  end;
  --------------------------------------------------------------------------------------------
  function private.get_leprechaunamulet_3 ()

    cmn.SetEventDone( "get_leprechaunamulet_3" );
    cmn.CallEventHandler( "get_leprechaunamulet_3" );
    int.DeployInvHide();

  end;
--*********************************************************************************************************************
-- function *** MMG *** () end;
--*********************************************************************************************************************  
  function private.InitMMG()
   
    -------------------------------------------------------------------------------------------
    -- function win_toydial () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "win_toydial" ] = {
      type = "click",
      --get_obj = "spr_toolbox_screwdriver",
      room = "int_deploy_inv",
      zz = "deploy_inv_toydial",
      zz_gate = "inv_toydial"
    };
    
    local win_toydial_end = function ()

     if cmn.IsEventDone("win_toydial") then
       
      ObjSet( "spr_deploy_inv_toydial_leprechaunamulet", { alp = 1, input = true } );
      ObjSet( "gfx_deploy_inv_toydial_leprechaunamulet", { active = true } );
      ObjSet( "obj_deploy_inv_shelf", { alp = 1 });
      ObjSet( "spr_deploy_inv_toydial_mouse_cheeze", { pos_x = 5, pos_y = 189}); 
      ObjSet( "obj_deploy_inv_toydial_mmg", { input = false });
      ObjSet( "obj_inv_toydial_win", { alp = 1 } );
      ObjDelete( "spr_inv_toydial_toymouse" );
      ObjDelete( "anm_deploy_inv_shelf_open" );

     else 
      
      ObjSet( "spr_deploy_inv_toydial_mouse", { pos_x = ng_global.progress[ "ext" ][ "win_toydial" ].state[1][1],
                                               pos_y = ng_global.progress[ "ext" ][ "win_toydial" ].state[1][2] } );
      ObjSet( "obj_deploy_inv_toydial_mmg_round", { ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[2] } );
      ObjSet( "obj_deploy_inv_toydial_mmg_round", { ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[2] } );
      ObjSet( "obj_deploy_inv_toydial_corner_2", { ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[5] } );
      ObjSet( "obj_deploy_inv_toydial_corner_1", { ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[4] } );
      ObjSet( "obj_deploy_inv_toydial_mouse_turn", { ang  = ng_global.progress[ "ext" ][ "win_toydial" ].state[6]})
      private.check_corner_input();
      
     end; 

    end;
    
  --  local win_toolbox_loc = function ()
  --
  --  if ( cmn.IsEventDone( "win_toolbox" ) ) then
  --    
  --    
  --    
  --  end;
  -------------------------------------------------------------------------------------------- 
  cmn.AddSubscriber( "win_toydial", win_toydial_end );
  cmn.AddSubscriber( "win_toydial", win_toydial_end, "deploy_inv_toydial" );
  cmn.AddSubscriber( "win_toydial_end", win_toydial_end, "deploy_inv_toydial" );
  --------------------------------------------------------------------------------------------  
  private.cheeze_pos = { 99, -193 }; 
  private.new_ang_corner = { 0, 0 };
  ObjSet( "obj_deploy_inv_mmg_clk_1", { event_mdown = function() private.anim_rotate_left() end,
                                        event_menter= function() cmn.SetCursor( CURSOR_HAND ); end,
                                        event_mleave = function() cmn.SetCursor( CURSOR_DEFAULT ); end;
    });
  ObjSet( "obj_deploy_inv_mmg_clk_2", { event_mdown = function() private.anim_rotate_right() end,
                                        event_menter= function() cmn.SetCursor( CURSOR_HAND ); end,
                                        event_mleave = function() cmn.SetCursor( CURSOR_DEFAULT ); end;
   });
  ObjSet( "obj_deploy_inv_toydial_corner_2_clk", { event_mdown = function() private.clk_corner(2) end});
  ObjSet( "obj_deploy_inv_toydial_corner_1_clk", { event_mdown = function() private.clk_corner(1) end});
  
  end;
  -------------------------------------------------------------------------------------------
  function private.anim_ang_set()

    if ng_global.progress[ "ext" ][ "win_toydial" ].state[2] > 6.1 or ng_global.progress[ "ext" ][ "win_toydial" ].state[2] < -6 then

      ng_global.progress[ "ext" ][ "win_toydial" ].state[2] = 0
      -- ObjSet( "obj_deploy_inv_toydial_mmg_round", { ang = 0 } );
      ObjSet( "spr_deploy_inv_toydial_back", { ang = 0 } );
      
    end;

    private.anim = false;

  end;
  ------------------------------------------------------------------------------------
  function private.anim_ang_set_private( ang )

    local mas_ang = { -7, -6.14, -4.71,-3.14, -1.57, 0, 1.57, 3.14, 4.71, 6.14, 7 };
    for i = 1,#mas_ang do

      if mas_ang[i] > private.new_ang then

        if ( mas_ang[i-1] + mas_ang[i] ) / 2 > private.new_ang then

          return ( mas_ang[i-1] );

        else

          return( mas_ang[i] );

        end;

      end;

    end;

  end;
  ------------------------------------------------------------------------------------
  function private.save_coord( x, y )

    private.check_corner_input();
    -- common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_toydial_ball_end", 0, "", 0 );
    -- common_impl.StopAudio( "sfx", "common/audio/levelext/aud_mg_toydial_ball_move" );
    if ng_global.progress[ "ext" ][ "win_toydial" ].state[3] == 1 then

        if not ( ObjGet( "spr_deploy_inv_toydial_mouse_cheeze" ).pos_x == 0 and ObjGet( "spr_deploy_inv_toydial_mouse_cheeze" ).pos_x == 0 ) then
          cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_mouse_cheese_take_cheese" );
        end;

        ObjAttach( "spr_deploy_inv_toydial_mouse_cheeze", "spr_deploy_inv_toydial_mouse");
        ObjSet( "spr_deploy_inv_toydial_mouse_cheeze", { pos_x = 0, pos_y = 0}); 
        
    end;    
    if not private.winflag then

      ObjSet( "obj_deploy_inv_toydial_mouse", { pos_x = 0, pos_y = 0 } );    
      ng_global.progress[ "ext" ][ "win_toydial" ].state[1][1] = ObjGet( "spr_deploy_inv_toydial_mouse" ).pos_x;
      ng_global.progress[ "ext" ][ "win_toydial" ].state[1][2] = ObjGet( "spr_deploy_inv_toydial_mouse" ).pos_y;
      ng_global.progress[ "ext" ][ "win_toydial" ].state[2] = private.new_ang;
      ng_global.progress[ "ext" ][ "win_toydial" ].state[6] = ObjGet( "obj_deploy_inv_toydial_mouse_turn").ang;
      private.anim_ang_set();
      int.Lock( false );

    else

      private.Win();

    end;

  end;
  --------------------------------------------------------------------------------------
  function private.clk_corner(number)
    
    private.new_ang_corner[number] = ng_global.progress[ "ext" ][ "win_toydial" ].state[number+3] - 1.57;
    local func_after = function()
    
      int.Lock( false );
      private.check_corner_input();
      ng_global.progress[ "ext" ][ "win_toydial" ].state[number+3] = private.new_ang_corner[number];
      if  ng_global.progress[ "ext" ][ "win_toydial" ].state[number+3] < -6 then

        --private.new_ang_corner[number] = 0
        ng_global.progress[ "ext" ][ "win_toydial" ].state[number+3] = 0;
      
      end;
      -- ObjSet( "obj_deploy_inv_toydial_mmg_round", { ang = 0 } );
      --ObjSet( "obj_deploy_inv_toydial_corner_"..number, { ang = private.new_ang_corner[number] } );
      --ng_global.progress[ "ext" ][ "win_toydial" ].state[number+3] = private.new_ang_corner[number];
      
    end;
    
    int.Lock( true );
    --cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_mouse_cheese_click" );
    ObjAnimate("obj_deploy_inv_toydial_corner_"..number, "ang", 0, 0, func_after,
    {
      0, 0, ng_global.progress[ "ext" ][ "win_toydial" ].state[number+3], 
      0.3, 3, private.new_ang_corner[number] 
    });
    
    
  end;  
  --------------------------------------------------------------------------------------
  function private.check_corner_input()
    
    --for i = 1, #private.new_ang_corner  do
      
    if ( int.ObjIntersectCheck( "spr_deploy_inv_toydial_mouse_1", "obj_deploy_inv_toydial_corner_1_input", "deploy_inv_toydial" ) )
     
      then
      
      ObjSet( "obj_deploy_inv_toydial_corner_1_clk", { input = false })
      
    else   
      
      ObjSet( "obj_deploy_inv_toydial_corner_1_clk", { input = true });
      
    end
    
    if ( int.ObjIntersectCheck( "spr_deploy_inv_toydial_mouse_1", "obj_deploy_inv_toydial_corner_2_input", "deploy_inv_toydial" ) )
      
      then
      
      ObjSet( "obj_deploy_inv_toydial_corner_2_clk", { input = false })
      
    else   
      
      ObjSet( "obj_deploy_inv_toydial_corner_2_clk", { input = true });
      
    end
    
  end;  
  --------------------------------------------------------------------------------------
  function private.anim_rotate_right()

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_mouse_cheese_click" );
    --common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_toydial_ball_rotate", 0, "", 0 );
    private.pos_x = ng_global.progress[ "ext" ][ "win_toydial" ].state[1][1];
    private.pos_y = ng_global.progress[ "ext" ][ "win_toydial" ].state[1][2];
    private.new_ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[2] - 1.57;
    private.lenght = { 0, 0 };

    local func_after = function()

      if math.ceil( private.new_ang ) == 0 or math.ceil( private.new_ang ) == 1 or math.ceil( math.abs( private.new_ang ) ) == 7 then --0, -6.14

      
        private.moveball( 0, 1 );

      elseif math.ceil( private.new_ang ) == - 1 or math.ceil( private.new_ang ) == 5 then -- -1.57, 4.71

      
        private.moveball( 1, 0 );

      elseif math.ceil( private.new_ang ) == - 3 or math.ceil( private.new_ang ) == 4 then -- -3.14, 3.14

        
        private.moveball( 0, -1 );

      elseif math.ceil( private.new_ang ) == - 4 or math.ceil( private.new_ang ) == 2 then -- -4.71, 1.57

       
        private.moveball( -1, 0 );

      end;

    end;

    int.Lock( true );
    --DbgTrace( "новый угол"..private.new_ang);
    ObjAnimate("obj_deploy_inv_toydial_mmg_round", "ang", 0, 0, func_after,
    {
      0, 0, ng_global.progress[ "ext" ][ "win_toydial" ].state[2], 
      0.3, 3, private.new_ang
    });
    if private.pos_x ~= - 145 and private.pos_y ~= -184 then
      
      ObjAnimate("obj_deploy_inv_toydial_mouse_turn", "ang", 0, 0, "",
      {
        0, 0, ObjGet("obj_deploy_inv_toydial_mouse_turn").ang, 
        0.3, 3, ObjGet("obj_deploy_inv_toydial_mouse_turn").ang + 1.57;
      });
    
    end;
    ObjAnimate("spr_deploy_inv_mmg_button_2", "alp", 0, 0, "",
    {
      0.0, 0, 0, 
      0.2, 3, 1,
      0.4, 3, 0,
    });

  end;
  -------------------------------------------------------------------------------------------------
  function private.anim_rotate_left()

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_mouse_cheese_click" );
    --common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_toydial_ball_rotate", 0, "", 0 );
    private.pos_x = ng_global.progress[ "ext" ][ "win_toydial" ].state[1][1];
    private.pos_y = ng_global.progress[ "ext" ][ "win_toydial" ].state[1][2];
    private.new_ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[2] + 1.57;
    private.lenght = { 0, 0 };

    local func_after = function()

      if math.ceil( private.new_ang ) == 0 or math.ceil( private.new_ang ) == 1 or math.ceil( math.abs( private.new_ang ) ) == 7 then --0, -6.14

        private.moveball( 0, 1 );

      elseif math.ceil( private.new_ang ) == - 1 or math.ceil( private.new_ang ) == 5 then -- -1.57, 4.71

        private.moveball( 1, 0 );

      elseif math.ceil( private.new_ang ) == - 3 or math.ceil( private.new_ang ) == 4 then -- -3.14, 3.14

        private.moveball( 0, -1 );

      elseif math.ceil( private.new_ang ) == - 4 or math.ceil( private.new_ang ) == 2 then -- -4.71, 1.57

        private.moveball( -1, 0 );

      end;

    end;

    int.Lock( true );
    --DbgTrace( "новый угол"..private.new_ang);
    ObjAnimate("obj_deploy_inv_toydial_mmg_round", "ang", 0, 0, func_after,
    {
      0, 0, ng_global.progress[ "ext" ][ "win_toydial" ].state[2], 
      0.3, 3, private.new_ang
    });
    if private.pos_x ~= -145 and private.pos_y ~= -184 then
      
      ObjAnimate("obj_deploy_inv_toydial_mouse_turn", "ang", 0, 0, "",
      {
        0, 0, ObjGet("obj_deploy_inv_toydial_mouse_turn").ang, 
        0.3, 3, ObjGet("obj_deploy_inv_toydial_mouse_turn").ang - 1.57;
      });
    
    end;
    ObjAnimate("spr_deploy_inv_mmg_button_1", "alp", 0, 0, "",
    {
      0.0, 0, 0, 
      0.2, 3, 1,
      0.4, 3, 0
    });

  end;
  ---------------------------------------------------------------------------------
  function private.count_length( x1,y1 )

    
    for i = 1, 13 do
    
      if ( int.ObjIntersectCheck( "obj_deploy_inv_toydial_mouse", "obj_deploy_inv_toydial_barrier_"..i, "deploy_inv_toydial" ) ) then
         --if cmn.ApplyObj( "obj_deploy_inv_toydial_mouse", "obj_deploy_inv_toydial_barrier_"..i, false ) then

         
          
           private.lenght[1] = private.lenght[1] - x1*5;
           private.lenght[2] = private.lenght[2] - y1*5;
          --private.lenght[1] = private.lenght[1] - x1*2;
          --private.lenght[2] = private.lenght[2] - y1*2;
          
        return;
        
      end;
--
    end;
--   for i = 1, 5 do
--    
--     if ( int.ObjIntersectCheck( "obj_deploy_inv_toydial_mouse", "obj_deploy_inv_toydial_polukrug_"..i, "deploy_inv_toydial" ) ) then
--         --if cmn.ApplyObj( "obj_deploy_inv_toydial_mouse", "obj_deploy_inv_toydial_barrier_"..i, false ) then
--
--         --DbgTrace( "пересексись"..i);
--        private.lenght[1] = private.lenght[1] - x1*2;
--        private.lenght[2] = private.lenght[2] - y1*2;
--        return;
--        
--      end;
--
--    end;
    
    if ( int.ObjIntersectCheck( "obj_deploy_inv_toydial_mouse", "obj_deploy_inv_toydial_hole", "deploy_inv_toydial" ) ) and
      ng_global.progress[ "ext" ][ "win_toydial" ].state[3] == 1 then
    --if cmn.ApplyObj( "obj_deploy_inv_toydial_mouse", "obj_deploy_inv_toydial_hole" ) then
    --DbgTrace( "ugol"..private.new_ang);
      if private.new_ang == 0 or private.new_ang > 6 or private.new_ang < -6 or (private.new_ang < 0.5 and private.new_ang> -0.5) then
        --private.anim_ang_set();
        private.lenght[1] = private.lenght[1] - x1*5;
        private.lenght[2] = private.lenght[2] - y1*5;
        private.winflag = true;
        return;
      end;
    end;
   
    if ( int.ObjIntersectCheck( "obj_deploy_inv_toydial_mouse", "obj_deploy_inv_toydial_cheeze", "deploy_inv_toydial" ) ) 
      and private.cheeze == false
      
      then    
      
      --if cmn.ApplyObj( "obj_deploy_inv_toydial_mouse", "obj_deploy_inv_toydial_cheeze" ) then
        
        private.lenght[1] = private.lenght[1] - x1*5;
        private.lenght[2] = private.lenght[2] - y1*5;
        --private.winflag = true;
        --ObjSet("spr_deploy_inv_toydial_mouse_cheeze", { alp = 0 });
        --ObjAttach( "spr_deploy_inv_toydial_mouse_cheeze", "obj_deploy_inv_toydial_mouse");
        --ObjSet( "spr_deploy_inv_toydial_mouse_cheeze", { pos_x = 0, pos_y = 0});
        private.cheeze = true;
        ng_global.progress[ "ext" ][ "win_toydial" ].state[3] = 1;
        --return;

    end;

      if private.pos_x + private.lenght[1] < -179 or private.pos_x + private.lenght[1] > 184
        or private.pos_y + private.lenght[2] < -240 or private.pos_y + private.lenght[2] > 144 then  -- симметрия не для нас
        
          private.lenght[1] = private.lenght[1] - x1*5;
          private.lenght[2] = private.lenght[2] - y1*5;
          return;
      --if private.pos_x >-220  and private.pos_x < 220 and private.pos_y > -80 and private.pos_y < 70 then
      --
      --  if private.pos_x + private.lenght[1] < -210 or private.pos_x + private.lenght[1] > 210
      --    or private.pos_y + private.lenght[2] < -240 or private.pos_y + private.lenght[2] > 210 then  -- симметрия не для нас
      --  
      --    private.lenght[1] = private.lenght[1] - x1*2;
      --    private.lenght[2] = private.lenght[2] - y1*2;
      --  return;
      --  
      --end
      --  
      --else
      --  
      --  DbgTrace( "zahod po else");
      --  if private.pos_x + private.lenght[1] < -136 or private.pos_x + private.lenght[1] > 141
      --    or private.pos_y + private.lenght[2] < -221 or private.pos_y + private.lenght[2] > 210 then  -- симметрия не для нас
      --  
      --    private.lenght[1] = private.lenght[1] - x1*2;
      --    private.lenght[2] = private.lenght[2] - y1*2;
      --  return;
      --  
      --end;  
        

     end;
    private.lenght[1] = private.lenght[1] + x1;
    private.lenght[2] = private.lenght[2] + y1;
    ObjSet( "obj_deploy_inv_toydial_mouse", { pos_x = private.lenght[1], pos_y = private.lenght[2] } ); 
    --ObjSet( "spr_deploy_inv_toydial_mouse", { pos_x = private.lenght[1], pos_y = private.lenght[2] } ); 
    private.count_length( x1,y1 )

  end;
  ------------------------------------------------------------------------------------------------------------
  function private.moveball( x, y )
    
    private.count_length( x,y )
    local tme = ( math.abs( private.lenght[1] ) + math.abs( private.lenght[2] ) ) / 200
    --common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_toydial_ball_move", 1, "", 0 );
    --DbgTrace( "smechenie po x"..private.lenght[1]);
    --DbgTrace( "smechenie po y"..private.lenght[2]);
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_mouse_cheese_move", 1 );
    ObjAnimate("spr_deploy_inv_toydial_mouse", "pos_xy", 0, 0, function() cmn.StopAudio( "sfx", "audio/level4/sfx/aud_inv_mouse_cheese_move", 0.5 ); cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_mouse_cheese_fringe" ); private.save_coord( x, y ) end,
    { 
      0, 0, private.pos_x, private.pos_y,
      tme, 3, private.pos_x + private.lenght[1], private.pos_y + private.lenght[2]
    });

  end;
  ----------------------------------------------------------------------------------------------------------
  function private.Win()

    local func_after = function()

      local func_after_2 = function()

        int.Lock( false );
        ng_global.progress[ "ext" ][ "win_toydial" ].state[2] = 1;
        cmn.MiniGameHide( "toydial");
        cmn.SetEventDone( "win_toydial" );
        cmn.CallEventHandler( "win_toydial" );
        common_impl.PassingMgWin( "toydial" );
       
      end;

      --ObjSet( "anm_toydial_door_3", { alp = 1 } );
      --AnimPlay( "anm_toydial_door_3", "DoAnim", func_after_2 );
      --common_impl.PlayAudio( "sfx", "common/audio/levelext/aud_mg_toydial_flower_rotate", 0, "", 0 );
      ObjAttach( "spr_deploy_inv_toydial_mouse_cheeze", "obj_deploy_inv_toydial_mmg_round_1");
      ObjSet( "spr_deploy_inv_toydial_mouse_cheeze", { pos_x = 5, pos_y = 189});
      ObjSet( "anm_deploy_inv_shelf_open", { alp = 1 } );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_mouse_cheese_open_cell" );
      AnimPlay( "anm_deploy_inv_shelf_open", "DoAnim", func_after_2 );

    end;

    int.Lock( true );

    --ObjAnimate( "spr_deploy_inv_toydial_mouse", "pos_x", 0, 0, func_after, { 0,   0, ObjGet( "spr_deploy_inv_toydial_mouse" ).pos_x,
    --                                                                       0.6, 0, 90 } );
    --ObjAnimate( "obj_toydial_mg_2_open", "alp", 0, 0, func_after, { 0,   0, 0,
    --                                                                      0.6, 0, 0,
    --                                                                      1,   0, 1 } );
  --func_after();
  --ObjAttach( "spr_deploy_inv_toydial_mouse_cheeze", "obj_deploy_inv_toydial_mmg_round_1");
  --ObjSet( "spr_deploy_inv_toydial_mouse_cheeze", { pos_x = 5, pos_y = 189}); 
  ObjAnimate( "spr_deploy_inv_toydial_mouse", "pos_y", 0, 0, func_after,
  {
        0.0, 3, ObjGet( "spr_deploy_inv_toydial_mouse").pos_y,
        0.2, 3, 110
  
  })

  end;
  ----------------------------------------------------------------------------------------
  function private.start_mmg()
    
    if not cmn.IsEventStart( "win_toydial" ) then
      
      --ng_global.progress[ "ext" ][ "win_toydial" ].state = { { -138, 29 }, 0, 0, 0, 0 };
      ng_global.progress[ "ext" ][ "win_toydial" ].state = { { -145, -184 }, 0, 0, 0, 0, -1.57 };
    
    end;
    if  ng_global.progress[ "ext" ][ "win_toydial" ].state[3] == 0 then
      
      private.cheeze = false;
    
    else  
      
      private.cheeze = true;
      ObjAttach( "spr_deploy_inv_toydial_mouse_cheeze", "spr_deploy_inv_toydial_mouse");
      ObjSet( "spr_deploy_inv_toydial_mouse_cheeze", { pos_x = 0, pos_y = 0});
      
    end;
    
    if not cmn.IsEventDone( "win_toydial" ) then
      
      cmn.MiniGameShow( 'toydial' );
      common_impl.PassingMgStart( 'toydial' );
    
    end;
    
  end;
  --*********************************************************************************************************************  
  function public.Reset()
    
    --private.InitMMG();
    --
    --ng_global.progress["std"]["win_toolbox"].toolbox = private.toolbox;
    --
    --private.draw();
    --
    --ng_global.progress[ "ext" ][ "win_toydial" ].state = { { -138, 29 }, 0, 0, 0, 0 };
    ng_global.progress[ "ext" ][ "win_toydial" ].state = { { -145, -184 }, 0, 0, 0, 0, -1.57 };
    ObjSet( "spr_deploy_inv_toydial_mouse", { pos_x = ng_global.progress[ "ext" ][ "win_toydial" ].state[1][1], 
                                              pos_y = ng_global.progress[ "ext" ][ "win_toydial" ].state[1][2]});
    ObjSet( "obj_deploy_inv_toydial_mouse_turn", { ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[6]});
    ObjSet( "obj_deploy_inv_toydial_corner_1_input", { input = false });
    ObjSet( "obj_deploy_inv_toydial_mmg_round", { ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[2]});
    ObjAttach( "spr_deploy_inv_toydial_mouse_cheeze", "obj_deploy_inv_toydial_mmg_round_1");
    private.cheeze = false;
    ObjSet( "spr_deploy_inv_toydial_mouse_cheeze", { pos_x = private.cheeze_pos[1] , pos_y = private.cheeze_pos[2]});
    for i = 1, 2  do
      
      private.new_ang_corner[i] = 0;
      ObjSet( "obj_deploy_inv_toydial_corner_"..i, { ang = ng_global.progress[ "ext" ][ "win_toydial" ].state[i + 3]});
      ObjSet( "obj_deploy_inv_toydial_corner_"..i.."_clk", { input = true } );
      
      
    end;
    

  end;
  --*********************************************************************************************************************
  function public.Skip()

    private.Win();
    
    ObjSet( "spr_deploy_inv_toydial_mouse_cheeze", { pos_x = 4, pos_y = 283 });
    ObjSet( "spr_deploy_inv_toydial_mouse", { pos_x = ObjGet("obj_deploy_inv_toydial_hole").pos_x, pos_y = ObjGet("obj_deploy_inv_toydial_hole").pos_y});

  end;
--*********************************************************************************************************************
-- function *** container *** () end;
--*********************************************************************************************************************
  function private.init_container ()

    ObjSet( "spr_deploy_inv_container_jaw", { event_mdown = private.get_jaw } );
    ObjSet( "obj_deploy_inv_container_use_stiletto", { event_mdown = private.ContainerClick } );
    --------------------------------------------------------------------------------------------
    -- function get_jaw () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_jaw" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_container_jaw",
      room = "int_deploy_inv",
      zz = "deploy_inv_container",
      zz_gate = "inv_container"
    };
    --------------------------------------------------------------------------------------------
    local get_jaw_inv = function ()
    
      int.InventoryItemAdd( "inv_jaw", "spr_deploy_inv_container_jaw" );
      int.InventoryItemRemove( "inv_container" );
    
      ObjDelete( "anm_deploy_inv_container_jaw" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_jaw", get_jaw_inv );
    --------------------------------------------------------------------------------------------
    -- function use_stiletto_2 () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_stiletto_2" ] =
    {
      type = "use",
      use_obj = "inv_stiletto",
      use_place = "obj_deploy_inv_container_use_stiletto",
      room = "int_deploy_inv",
      zz = "deploy_inv_container",
      zz_gate = "inv_container"
    };
    --------------------------------------------------------------------------------------------
    local use_stiletto_2_inv = function ()

      if cmn.IsEventDone( "use_stiletto_1" ) and 
         cmn.IsEventDone( "use_stiletto_3" ) and 
         cmn.IsEventDone( "use_stiletto_4" ) then

        int.InventoryItemRemove( "inv_stiletto" );

      end;

      ObjSet( "inv_container", { res = "assets/levels/levelext/common_inventory4/inv_container/inv/inv_container_open" } );

    end;
    local use_stiletto_2_beg = function ()
    
      ObjDelete( "obj_deploy_inv_container_use_stiletto" );
      ObjDelete( "anm_deploy_inv_container_click" );

    end;
    local use_stiletto_2_end = function ()
    
      ObjDelete( "anm_deploy_inv_container_open" );
      ObjSet( "obj_deploy_inv_container_open", { alp = 1 } );
      ObjSet( "spr_deploy_inv_container_jaw",  { input = true } );
      ObjSet( "gfx_deploy_inv_container_jaw",  { active = true } );
      
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_stiletto_2",     use_stiletto_2_beg, "inv_container" );
    cmn.AddSubscriber( "use_stiletto_2",     use_stiletto_2_inv );
    cmn.AddSubscriber( "use_stiletto_2",     use_stiletto_2_end, "inv_container" );
    cmn.AddSubscriber( "use_stiletto_2_inv", use_stiletto_2_inv, "inv_container" );
    cmn.AddSubscriber( "use_stiletto_2_beg", use_stiletto_2_beg, "inv_container" );
    cmn.AddSubscriber( "use_stiletto_2_end", use_stiletto_2_end, "inv_container" );

  end;
  --*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  function public.use_stiletto_2 ()

    local item = "inv_stiletto";

    if ( cmn.ShowByInv( item, "inv_container" ) ) and
       ( not cmn.IsEventDone( "use_stiletto_2" ) ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_container" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_container_use_stiletto", "deploy_inv_container" ) ) and
           ( not cmn.IsEventDone( "use_stiletto_2" ) ) then

      cmn.CallEventHandler( "use_stiletto_2_inv" );
      cmn.CallEventHandler( "use_stiletto_2_beg", "inv_container" );

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_stiletto_2" );
        cmn.CallEventHandler( "use_stiletto_2_end", "inv_container" );

      end;

      int.Lock( true );

      ObjSet( "anm_deploy_inv_container_open", { alp = 1 } );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_cut_rope_box" );
      AnimPlay( "anm_deploy_inv_container_open", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function private.get_jaw ()

    ObjSet( "spr_deploy_inv_container_jaw", { alp = 1 } );
    cmn.SetEventDone( "get_jaw" );
    cmn.CallEventHandler( "get_jaw" );
    int.DeployInvHide();

  end;
  --------------------------------------------------------------------------------------------
  function private.ContainerClick ()

    local func_end = function ()

      int.Lock( false );
      cmn.ShowBbt( "bbt_deploy_inv_container_use_stiletto" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_inv_box_rope_seal" );
    AnimPlay( "anm_deploy_inv_container_click", "DoAnim", func_end );

  end;
--------------------------------------------------------------------------------------------
-- function *** magiccube *** () end;
--*********************************************************************************************************************
  function private.init_magiccube ()

    ObjSet( "gho_deploy_inv_magiccube_homagiccube", { event_mdown = private.ToMagiccubeHO } );  
    ObjSet( "obj_deploy_inv_magiccube_clk",         { event_mdown = private.clk_magiccube } );  
    
    --------------------------------------------------------------------------------------------
    -- function use_atlantesamulet () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_atlantesamulet" ] =
    {
      type = "use",
      use_obj = "inv_atlantesamulet",
      use_place = "obj_deploy_inv_magiccube_use_atlantesamulet",
      room = "int_deploy_inv",
      zz = "deploy_inv_magiccube",
      zz_gate = "inv_magiccube"
    };
    --------------------------------------------------------------------------------------------
    local use_atlantesamulet_inv = function ()
    
      int.InventoryItemRemove( "inv_atlantesamulet" );
      ObjSet( "inv_magiccube_atlantesamulet", { alp = 1 } );

    end;
    local use_atlantesamulet_beg = function ()
    
      ObjDelete( "obj_deploy_inv_magiccube_use_atlantesamulet" );
    
    end;
    local use_atlantesamulet_end = function ()
    
      ObjDelete( "anm_deploy_inv_magiccube_use_atlantesamulet" );
      ObjSet( "anm_deploy_inv_magiccube_loop", { alp = 1, playing = true } );
      ObjSet( "obj_deploy_inv_magiccube_clk", { input = true } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_atlantesamulet",     use_atlantesamulet_beg, "inv_magiccube" );
    cmn.AddSubscriber( "use_atlantesamulet",     use_atlantesamulet_inv );
    cmn.AddSubscriber( "use_atlantesamulet",     use_atlantesamulet_end, "inv_magiccube" );
    cmn.AddSubscriber( "use_atlantesamulet_inv", use_atlantesamulet_inv, "inv_magiccube" );
    cmn.AddSubscriber( "use_atlantesamulet_beg", use_atlantesamulet_beg, "inv_magiccube" );
    cmn.AddSubscriber( "use_atlantesamulet_end", use_atlantesamulet_end, "inv_magiccube" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    -- function clk_magiccube () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_magiccube" ] =
    {
      type = "click",
      clk_obj = "obj_deploy_inv_magiccube_clk",
      room = "int_deploy_inv",
      zz = "deploy_inv_magiccube",
      zz_gate = "inv_magiccube"
    };
    --------------------------------------------------------------------------------------------
    local clk_magiccube_inv = function ()
    
    end;
    local clk_magiccube_beg = function ()

      ObjDelete( "obj_deploy_inv_magiccube_clk" );

    end;
    local clk_magiccube_end = function ()

      ObjDelete( "inv_magiccube_atlantesamulet" );
      ObjSet( "inv_magiccube", {
                                 event_mdown = function() cmn.GotoRoom( 'ho_homagiccube' ); end, 
                                 res = "assets/levels/levelext/common_inventory4/inv_magiccube/inv/inv_magiccube_ho"
                               } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_magiccube", clk_magiccube_beg, "inv_magiccube" );
    cmn.AddSubscriber( "clk_magiccube", clk_magiccube_inv );
    cmn.AddSubscriber( "clk_magiccube", clk_magiccube_end, "inv_magiccube" );
    cmn.AddSubscriber( "clk_magiccube_inv", clk_magiccube_inv, "inv_magiccube" );
    cmn.AddSubscriber( "clk_magiccube_beg", clk_magiccube_beg, "inv_magiccube" );
    cmn.AddSubscriber( "clk_magiccube_end", clk_magiccube_end, "inv_magiccube" );
  --------------------------------------------------------------------------------------------

  end;
  --------------------------------------------------------------------------------------------
  function public.use_atlantesamulet ()

    local item = "inv_atlantesamulet";

    if ( cmn.ShowByInv( item, "inv_magiccube" ) ) and
       ( not cmn.IsEventDone( "use_atlantesamulet" ) ) and 
         cmn.IsEventDone( "get_atlantesamulet_1" ) and 
         cmn.IsEventDone( "get_atlantesamulet_2" ) and 
         cmn.IsEventDone( "get_atlantesamulet_3" ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_magiccube" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_magiccube_use_atlantesamulet", "deploy_inv_magiccube" ) ) and
           ( not cmn.IsEventDone( "use_atlantesamulet" ) ) and 
             cmn.IsEventDone( "get_atlantesamulet_1" ) and 
             cmn.IsEventDone( "get_atlantesamulet_2" ) and 
             cmn.IsEventDone( "get_atlantesamulet_3" ) then

      cmn.CallEventHandler( "use_atlantesamulet_inv" );
      cmn.CallEventHandler( "use_atlantesamulet_beg", "inv_magiccube" );

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_atlantesamulet" );
        cmn.CallEventHandler( "use_atlantesamulet_end", "inv_magiccube" );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_4_stuffs_cube_loop", 1, 0.5 );

      end;

      int.Lock( true );
      ObjSet( "anm_deploy_inv_magiccube_use_atlantesamulet", { croprect_init = false } );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_insert_4_stuffs_cube" );
      AnimPlay( "anm_deploy_inv_magiccube_use_atlantesamulet", "DoAnim", func_end ); 

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function private.clk_magiccube ()

    if ( not cmn.IsEventDone( "clk_magiccube" ) ) then

      cmn.CallEventHandler( "clk_magiccube_inv" );
      cmn.CallEventHandler( "clk_magiccube_beg", "inv_magiccube" );

    end;

    local func_end = function ()

      if ( not cmn.IsEventDone( "clk_magiccube" ) ) then

        cmn.SetEventDone( "clk_magiccube" );
        cmn.CallEventHandler( "clk_magiccube_end", "inv_magiccube" );
        game.relations[ "ho_homagiccube" ].exitroom = GetCurrentRoom();
        int.DeployInvHide();
        cmn.GotoRoom( 'ho_homagiccube' );

      end;

    end;

    ObjSet( "anm_deploy_inv_magiccube_loop", { alp = 0 } );
    ObjSet( "anm_deploy_inv_magiccube_open_ho", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_4_stuffs_cube_click" );
    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_inv_4_stuffs_cube_loop" );
    AnimPlay( "anm_deploy_inv_magiccube_open_ho", "DoAnim", func_end ); 

  end;
  --------------------------------------------------------------------------------------------
  function private.ToMagiccubeHO ()

    game.relations[ "ho_homagiccube" ].exitroom = GetCurrentRoom();
    int.DeployInvHide();
    cmn.GotoRoom( 'ho_homagiccube' );

  end;  
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** brokenstatuette *** () end;
--*********************************************************************************************************************
  --*********************************************************************************************************************
  function private.init_brokenstatuette ()

    ObjSet( "obj_deploy_inv_brokenstatuette_get_creepystatue", { event_mdown = private.get_creepystatue } );
    --------------------------------------------------------------------------------------------
    -- function get_creepystatue () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_creepystatue" ] =
    {
      type = "get",
      get_obj = "obj_deploy_inv_brokenstatuette_get_creepystatue",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenstatuette",
      zz_gate = "inv_brokenstatuette"
    };
    --------------------------------------------------------------------------------------------
    local get_creepystatue_inv = function ()
    
      int.InventoryItemAdd( "inv_creepystatue", "obj_deploy_inv_brokenstatuette" );
      int.InventoryItemRemove( "inv_brokenstatuette" );
    
      ObjDelete( "gfx_deploy_inv_brokenstatuette_creepystatue" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_creepystatue", get_creepystatue_inv );
    --------------------------------------------------------------------------------------------
    -- function use_wings () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_wings" ] =
    {
      type = "use",
      use_obj = "inv_wings",
      use_place = "obj_deploy_inv_brokenstatuette_use_wings",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenstatuette",
      zz_gate = "inv_brokenstatuette"
    };
    --------------------------------------------------------------------------------------------
    local use_wings_inv = function ()
    
      int.InventoryItemRemove( "inv_wings" );
      ObjSet( "inv_brokenstatuette", { res = "assets/levels/levelext/common_inventory4/inv_brokenstatuette/inv/inv_creepystatue" } );

    end;
    local use_wings_beg = function ()
    
      ObjDelete( "obj_deploy_inv_brokenstatuette_use_wings" );
    
    end;
    local use_wings_end = function ()
   
      ObjSet( "anm_deploy_inv_brokenstatuette_use_wings", { alp = 1, frame = 500 } );

      ObjSet( "obj_deploy_inv_brokenstatuette_get_creepystatue", { input = true } );
      ObjSet( "gfx_deploy_inv_brokenstatuette_creepystatue", { active = true } );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_wings",     use_wings_beg, "inv_brokenstatuette" );
    cmn.AddSubscriber( "use_wings",     use_wings_inv );
    cmn.AddSubscriber( "use_wings",     use_wings_end, "inv_brokenstatuette" );
    cmn.AddSubscriber( "use_wings_inv", use_wings_inv, "inv_brokenstatuette" );
    cmn.AddSubscriber( "use_wings_beg", use_wings_beg, "inv_brokenstatuette" );
    cmn.AddSubscriber( "use_wings_end", use_wings_end, "inv_brokenstatuette" );
    --------------------------------------------------------------------------------------------


  end;
  --------------------------------------------------------------------------------------------
  function public.use_wings ()

    local item = "inv_wings";

    if ( cmn.ShowByInv( item, "inv_brokenstatuette" ) ) and
       ( not cmn.IsEventDone( "use_wings" ) ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_brokenstatuette" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_brokenstatuette_use_wings", "deploy_inv_brokenstatuette" ) ) and
           ( not cmn.IsEventDone( "use_wings" ) ) then

      cmn.CallEventHandler( "use_wings_inv" );
      cmn.CallEventHandler( "use_wings_beg", "inv_brokenstatuette" );

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_wings" );
        cmn.CallEventHandler( "use_wings_end", "inv_brokenstatuette" );

      end;

      int.Lock( true );

      ObjSet( "anm_deploy_inv_brokenstatuette_use_wings", { alp = 1 } );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_glue_wings" );
      AnimPlay( "anm_deploy_inv_brokenstatuette_use_wings", "DoAnim", func_end ); 

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function private.get_creepystatue ()

    cmn.SetEventDone( "get_creepystatue" );
    cmn.CallEventHandler( "get_creepystatue" );
    int.DeployInvHide();

  end;
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** magiccircle *** () end;
--*********************************************************************************************************************
  function private.init_magiccircle ()

    ObjSet( "spr_deploy_inv_magiccircle_circleofelements", { event_mdown = private.get_circleofelements } );
    --------------------------------------------------------------------------------------------
    -- function get_circleofelements () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "get_circleofelements" ] =
    {
      type = "get",
      get_obj = "spr_deploy_inv_magiccircle_circleofelements",
      room = "int_deploy_inv",
      zz = "deploy_inv_magiccircle",
      zz_gate = "inv_magiccircle"
    };
    --------------------------------------------------------------------------------------------
    local get_circleofelements_inv = function ()
    
      int.InventoryItemAdd( "inv_circleofelements", "spr_deploy_inv_magiccircle_circleofelements" );
      int.InventoryItemRemove( "inv_magiccircle" );
    
      ObjDelete( "gfx_deploy_magiccircle_circleofelements" );
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_circleofelements", get_circleofelements_inv );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    -- function use_crystalofelements () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_crystalofelements" ] =
    {
      type = "use",
      use_obj = "inv_crystalofelements",
      use_place = "obj_deploy_inv_magiccircle_use_crystalofelements",
      room = "int_deploy_inv",
      zz = "deploy_inv_magiccircle",
      zz_gate = "inv_magiccircle"
    };
    --------------------------------------------------------------------------------------------
    local use_crystalofelements_inv = function ()
    
      int.InventoryItemRemove( "inv_crystalofelements" );
      ObjSet( "spr_inv_magiccircle_crystalofelements", { alp = 1 } );

      if not cmn.IsEventDone( "win_hotable" ) then

        ObjSet( "inv_magiccircle_plus_focus2", { alp = 0 } );

      end;
    
    end;
    local use_crystalofelements_beg = function ()
    
      ObjDelete( "obj_deploy_inv_magiccircle_use_crystalofelements" );
    
    end;
    local use_crystalofelements_end = function ()
    
      ObjSet( "anm_deploy_inv_magiccircle_crystalofelements", { pos_z = 0, alp = 1, frame = 182, animfunc = "DoAnim" } );
      if cmn.IsEventDone( "use_nameseal" ) then

        ObjSet( "spr_deploy_inv_magiccircle_circleofelements", { alp = 1, input = true } );
        ObjSet( "gfx_deploy_inv_magiccircle_circleofelements", { active = true } );
        ObjSet( "anm_deploy_inv_magiccircle_circleofelements", { alp = 1, playing = true } );

      end;
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_crystalofelements",     use_crystalofelements_beg, "inv_magiccircle" );
    cmn.AddSubscriber( "use_crystalofelements",     use_crystalofelements_inv );
    cmn.AddSubscriber( "use_crystalofelements",     use_crystalofelements_end, "inv_magiccircle" );
    cmn.AddSubscriber( "use_crystalofelements_inv", use_crystalofelements_inv, "inv_magiccircle" );
    cmn.AddSubscriber( "use_crystalofelements_beg", use_crystalofelements_beg, "inv_magiccircle" );
    cmn.AddSubscriber( "use_crystalofelements_end", use_crystalofelements_end, "inv_magiccircle" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
    -- function use_nameseal () end;
    --------------------------------------------------------------------------------------------
    common_impl.hint[ "use_nameseal" ] =
    {
      type = "use",
      use_obj = "inv_nameseal",
      use_place = "obj_deploy_inv_magiccircle_use_nameseal",
      room = "int_deploy_inv",
      zz = "deploy_inv_magiccircle",
      zz_gate = "inv_magiccircle"
    };
    --------------------------------------------------------------------------------------------
    local use_nameseal_inv = function ()
    
      int.InventoryItemRemove( "inv_nameseal" );
      ObjSet( "spr_inv_magiccircle_nameseal", { alp = 1 } );

      if not ( cmn.IsEventDone( "get_crystalofelements_1" ) and 
               cmn.IsEventDone( "get_crystalofelements_2" ) and 
               cmn.IsEventDone( "get_crystalofelements_3" ) and 
               cmn.IsEventDone( "get_crystalofelements_4" ) ) then

        ObjSet( "inv_magiccircle_plus_focus2", { alp = 0 } );
      
      end;
    
    end;
    local use_nameseal_beg = function ()
    
      ObjDelete( "obj_deploy_inv_magiccircle_use_nameseal" );
    
    end;
    local use_nameseal_end = function ()
    
      ObjSet( "anm_deploy_inv_magiccircle_nameseal", { pos_z = 0, alp = 1, frame = 83, animfunc = "DoAnim" } );
      if cmn.IsEventDone( "use_crystalofelements" ) then

        ObjSet( "spr_deploy_inv_magiccircle_circleofelements", { alp = 1, input = true } );
        ObjSet( "gfx_deploy_inv_magiccircle_circleofelements", { active = true } );
        ObjSet( "anm_deploy_inv_magiccircle_circleofelements", { alp = 1, playing = true } );

      end;
    
    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_nameseal",     use_nameseal_beg, "inv_magiccircle" );
    cmn.AddSubscriber( "use_nameseal",     use_nameseal_inv );
    cmn.AddSubscriber( "use_nameseal",     use_nameseal_end, "inv_magiccircle" );
    cmn.AddSubscriber( "use_nameseal_inv", use_nameseal_inv, "inv_magiccircle" );
    cmn.AddSubscriber( "use_nameseal_beg", use_nameseal_beg, "inv_magiccircle" );
    cmn.AddSubscriber( "use_nameseal_end", use_nameseal_end, "inv_magiccircle" );
    --------------------------------------------------------------------------------------------

  end;
  --------------------------------------------------------------------------------------------
  function public.use_crystalofelements ()

    local item = "inv_crystalofelements";

    if ( cmn.ShowByInv( item, "inv_magiccircle" ) ) and
       ( not cmn.IsEventDone( "use_crystalofelements" ) ) and 
         cmn.IsEventDone( "get_crystalofelements_1" ) and 
         cmn.IsEventDone( "get_crystalofelements_2" ) and 
         cmn.IsEventDone( "get_crystalofelements_3" ) and 
         cmn.IsEventDone( "get_crystalofelements_4" ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_magiccircle" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_magiccircle_use_crystalofelements", "deploy_inv_magiccircle" ) ) and
           ( not cmn.IsEventDone( "use_crystalofelements" ) ) and 
             cmn.IsEventDone( "get_crystalofelements_1" ) and 
             cmn.IsEventDone( "get_crystalofelements_2" ) and 
             cmn.IsEventDone( "get_crystalofelements_3" ) and 
             cmn.IsEventDone( "get_crystalofelements_4" ) then

      cmn.CallEventHandler( "use_crystalofelements_inv" );
      cmn.CallEventHandler( "use_crystalofelements_beg", "inv_magiccircle" );

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_crystalofelements" );
        cmn.CallEventHandler( "use_crystalofelements_end", "inv_magiccircle" );

      end;

      int.Lock( true );

      ObjSet( "anm_deploy_inv_magiccircle_crystalofelements", { alp = 1 } );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_insert_4_stuffs" );
      AnimPlay( "anm_deploy_inv_magiccircle_crystalofelements", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function public.use_nameseal ()

    local item = "inv_nameseal";

    if ( cmn.ShowByInv( item, "inv_magiccircle" ) ) and
       ( not cmn.IsEventDone( "use_nameseal" ) ) then

      --interface.ObjDoNotDrop( item );
      cmn.ShowDeployInv( "inv_magiccircle" );

      return true;

    elseif ( int.ObjIntersectCheck( item, "obj_deploy_inv_magiccircle_use_nameseal", "deploy_inv_magiccircle" ) ) and
           ( not cmn.IsEventDone( "use_nameseal" ) ) then

      cmn.CallEventHandler( "use_nameseal_inv" );
      cmn.CallEventHandler( "use_nameseal_beg", "inv_magiccircle" );

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_nameseal" );
        cmn.CallEventHandler( "use_nameseal_end", "inv_magiccircle" );

      end;

      int.Lock( true );

      ObjSet( "anm_deploy_inv_magiccircle_nameseal", { alp = 1 } );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_inv_insert_1_stuff_middle" );
      AnimPlay( "anm_deploy_inv_magiccircle_nameseal", "DoAnim", func_end );

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------------------------------------------
  function private.get_circleofelements ()

    cmn.SetEventDone( "get_circleofelements" );
    cmn.CallEventHandler( "get_circleofelements" );
    int.DeployInvHide();

  end;
  --*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** CHECK FUNCTIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.CheckAtlantesamulet ()

    local count = 0;

    for i = 1, 3 do

      if ( cmn.IsEventDone( "get_atlantesamulet_"..i ) ) then

        count = count + 1;
        ObjSet( "spr_inv_atlantesamulet_"..i, { alp = 1 } );

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_atlantesamulet_count" );

    else

      ObjSet( "txt_inv_atlantesamulet_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckCrazydoctor ( id )

    if ( cmn.IsEventDone( "get_crazydoctor_1" ) ) and
       ( cmn.IsEventDone( "get_crazydoctor_2" ) ) then

      ObjSet( "inv_crazydoctor", { res = "assets/levels/levelext/rm_sidesteet/zz_ossuary/inv/inv_crazydoctor_all" } );
      ObjDelete( "txt_inv_crazydoctor_count" );

    else 

      ObjSet( "inv_crazydoctor", { res = "assets/levels/levelext/rm_sidesteet/zz_ossuary/inv/inv_crazydoctor_"..id } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckLeprechaunamulet ()

    local count = 0;

    for i = 1, 3 do

      if ( cmn.IsEventDone( "get_leprechaunamulet_"..i ) ) then

        count = count + 1;
        ObjSet( "spr_inv_leprechaunamulet_"..i, { alp = 1 } );

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_leprechaunamulet_count" );

    else

      ObjSet( "txt_inv_leprechaunamulet_count", { text = count.."/3" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckMinotauramulet ( id )

    ObjSet( "inv_minotauramulet", { res = "assets/levels/levelext/rm_prison/zz_runecontainers/inv/inv_minotauramulet_"..id } );

    if ( cmn.IsEventDone( "get_minotauramulet_1" ) ) and
       ( cmn.IsEventDone( "get_minotauramulet_2" ) ) then

      ObjDelete( "txt_inv_minotauramulet_count" );
      ObjSet( "inv_minotauramulet", { res = "assets/levels/levelext/rm_prison/zz_runecontainers/inv/inv_minotauramulet_all" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckSatyrfigurine ()

    if ( cmn.IsEventDone( "get_satyrfigurine_1" ) ) and
       ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) then

      ObjDelete( "txt_inv_satyrfigurine_count" );
      ObjSet( "inv_satyrfigurine", { res = "assets/levels/levelext/rm_dungeon/zz_load/inv/inv_satyrfigurine_2" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckCrystalofelements ()

    local count = 0;

    for i = 1, 4 do

      if ( cmn.IsEventDone( "get_crystalofelements_"..i ) ) then

        count = count + 1;
        ObjSet( "spr_inv_crystalofelements_"..i, { alp = 1 } );

      end;

    end;

    if ( count == 4 ) then

      ObjDelete( "txt_inv_crystalofelements_count" );

    else

      ObjSet( "txt_inv_crystalofelements_count", { text = count.."/4" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckStaroflife ()

    local count = 0;

    for i = 1, 4 do

      if ( cmn.IsEventDone( "get_staroflife_"..i ) ) then

        count = count + 1;
        ObjSet( "spr_inv_staroflife_"..i, { alp = 1 } );

      end;

    end;

    if ( count == 4 ) then

      ObjDelete( "txt_inv_staroflife_count" );

    else

      ObjSet( "txt_inv_staroflife_count", { text = count.."/4" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckTridentamulet ()

    local count = 0;

    for i = 1, 3 do

      if ( cmn.IsEventDone( "get_tridentamulet_"..i ) ) then

        count = count + 1;

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_tridentamulet_count" );

    else

      ObjSet( "txt_inv_tridentamulet_count", { text = count.."/3" } );

    end;

    ObjSet( "inv_tridentamulet", { res = "assets/levels/levelext/rm_park/zz_pump/inv/inv_tridentamulet_"..count } );

  end;
--*********************************************************************************************************************
  function public.CheckHorn ( id )

    ObjSet( "inv_horn", { res = "assets/levels/levelext/rm_headphysicianoffice/zz_table/inv/inv_horn_"..id } );

    if ( cmn.IsEventDone( "get_horn_1" ) ) and
       ( cmn.IsEventDone( "get_horn_2" ) ) then

      ObjDelete( "txt_inv_horn_count" );
      ObjSet( "inv_horn", { res = "assets/levels/levelext/rm_headphysicianoffice/zz_table/inv/inv_horn_all" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckSphynxamulet ( id )

    local count = 0;

    for i = 1, 3 do

      if ( cmn.IsEventDone( "get_sphynxamulet_"..i ) ) then

        count = count + 1;

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_sphynxamulet_count" );

    else

      ObjSet( "txt_inv_sphynxamulet_count", { text = count.."/3" } );

    end;

    ObjSet( "spr_inv_sphynxamulet_"..id, { alp = 1 } );

  end;
--*********************************************************************************************************************
  function public.CheckStoneofsouls ()

    local count = 0;

    for i = 1, 6 do

      if ( cmn.IsEventDone( "get_stoneofsouls_"..i ) ) then

        count = count + 1;
        ObjSet( "spr_inv_stoneofsouls_"..i, { alp = 1 } );

      end;

    end;

    if ( count == 6 ) then

      ObjDelete( "txt_inv_stoneofsouls_count" );

    else

      ObjSet( "txt_inv_stoneofsouls_count", { text = count.."/6" } );

    end;

  end;
--*********************************************************************************************************************
  function public.CheckRunedice ( id )

    local count = 0;

    for i = 1, 3 do

      if ( cmn.IsEventDone( "get_runedice_"..i ) ) then

        count = count + 1;

      end;

    end;

    if ( count == 3 ) then

      ObjDelete( "txt_inv_runedice_count" );

    else

      ObjSet( "txt_inv_runedice_count", { text = count.."/3" } );
     
    end;

    ObjSet( "spr_inv_runedice_"..id, { alp = 1 } );

  end;
--*********************************************************************************************************************
  function public.CheckCoatlamulet ( id )

    if ( cmn.IsEventDone( "get_coatlamulet_1" ) ) and
       ( cmn.IsEventDone( "get_coatlamulet_2" ) ) then

      ObjSet( "inv_coatlamulet", { res = "assets/levels/levelext/rm_park/zz_hospitalproperty/inv/inv_coatlamulet_all" } );
      ObjDelete( "txt_inv_coatlamulet_count" );

    else 

      ObjSet( "inv_coatlamulet", { res = "assets/levels/levelext/rm_park/zz_hospitalproperty/inv/inv_coatlamulet_"..id } );

    end;

  end;
--*********************************************************************************************************************