-- name=rm_alchemiststore
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_alchemiststore";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_ceilingcabinet", "room_hub" );
  ObjAttach( "zz_counter",        "room_hub" );
  ObjAttach( "zz_safe",           "room_hub" );

  ObjMultiSet(
  {
    { "spr_alchemiststore_jupiteremblem",  { event_mdown = private.get_jupiteremblem } },    
    { "spr_ceilingcabinet_fairyfigurine",  { event_mdown = private.get_fairyfigurine } },
    { "spr_ceilingcabinet_packofseeds",    { event_mdown = private.get_packofseeds } },
    { "spr_ceilingcabinet_thermalmatches", { event_mdown = private.get_thermalmatches } },
    { "spr_counter_coin",                  { event_mdown = private.get_coin } },
    { "spr_counter_toydial",               { event_mdown = private.get_toydial } },
    { "spr_safe_awl",                      { event_mdown = private.get_awl } },
    { "spr_safe_mop",                      { event_mdown = private.get_mop } },
    { "spr_safe_leprechaunamulet_2",       { event_mdown = private.get_leprechaunamulet_2 } },
    { "obj_ceilingcabinet_use_leprechaunamulet", { event_mdown = private.CeilingcabinetDoorsClick } },
    { "spr_alchemiststore_collect_4_1",          { event_mdown = private.get_collect_4_1 } },
    { "spr_counter_screensaver_4_2",             { event_mdown = private.get_screensaver_4_2 } },
    { "obj_safe_use_sphynxamulet",               { event_mdown = private.SafeDoorClick } },
    { "obj_counter_use_alchemistryamulet",       { event_mdown = function() private.CounterBoxClk() end } },          
  } );

  local get_screensaver_4_2 = function ()

    ObjDelete( "spr_counter_screensaver_4_2" );
    ObjDelete( "spr_alchemiststore_counter_collect");
    
  end;
  cmn.AddSubscriber( "get_screensaver_4_2", get_screensaver_4_2, private.room_objname );  


  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_alchemiststore = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_alchemiststore", update_game_mode_alchemiststore, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_4_1 = function ()

    ObjDelete( "spr_alchemiststore_collect_4_1" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_4_1", get_collect_4_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_1 = function ()

    ObjDelete( "obj_alchemiststore_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_1", get_morphobject_4_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_jupiteremblem () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "get_jupiteremblem" ] =
  {
    type = "get",
    get_obj = "spr_alchemiststore_jupiteremblem",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local get_jupiteremblem_inv = function ()

    int.InventoryItemAdd( "inv_jupiteremblem", "spr_alchemiststore_jupiteremblem" );

  end;
  local get_jupiteremblem_closezz = function ()

    ObjDelete( "gfx_alchemiststore_jupiteremblem" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_jupiteremblem", get_jupiteremblem_inv );
  cmn.AddSubscriber( "get_jupiteremblem", get_jupiteremblem_closezz, private.room_objname );    
  --------------------------------------------------------------------------------------------
  -- function get_fairyfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fairyfigurine" ] =
  {
    type = "get",
    get_obj = "spr_ceilingcabinet_fairyfigurine",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_alchemiststore_ceilingcabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_fairyfigurine_inv = function ()

    int.InventoryItemAdd( "inv_fairyfigurine", "spr_ceilingcabinet_fairyfigurine" );

  end;
  local get_fairyfigurine_closezz = function ()

    ObjDelete( "gfx_ceilingcabinet_fairyfigurine" );
    ObjDelete( "spr_alchemiststore_ceilingcabinet_item");

    if ( cmn.IsEventDone( "get_fairyfigurine" ) ) and
       ( cmn.IsEventDone( "get_packofseeds" ) ) and
       ( cmn.IsEventDone( "get_thermalmatches" ) ) then

      ObjDelete( "gzz_alchemiststore_ceilingcabinet" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_fairyfigurine", get_fairyfigurine_inv );
  cmn.AddSubscriber( "get_fairyfigurine", get_fairyfigurine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_packofseeds () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_packofseeds" ] =
  {
    type = "get",
    get_obj = "spr_ceilingcabinet_packofseeds",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_alchemiststore_ceilingcabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_packofseeds_inv = function ()

    int.InventoryItemAdd( "inv_packofseeds", "spr_ceilingcabinet_packofseeds" );

  end;
  local get_packofseeds_closezz = function ()

    ObjDelete( "gfx_ceilingcabinet_packofseeds" );
    ObjDelete( "spr_alchemiststore_ceilingcabinet_seed");

    if ( cmn.IsEventDone( "get_fairyfigurine" ) ) and
       ( cmn.IsEventDone( "get_packofseeds" ) ) and
       ( cmn.IsEventDone( "get_thermalmatches" ) ) then

      ObjDelete( "gzz_alchemiststore_ceilingcabinet" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_packofseeds", get_packofseeds_inv );
  cmn.AddSubscriber( "get_packofseeds", get_packofseeds_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_thermalmatches () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_thermalmatches" ] =
  {
    type = "get",
    get_obj = "spr_ceilingcabinet_thermalmatches",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_alchemiststore_ceilingcabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_thermalmatches_inv = function ()

    int.InventoryItemAdd( "inv_thermalmatches", "spr_ceilingcabinet_thermalmatches" );

  end;
  local get_thermalmatches_closezz = function ()

    ObjDelete( "gfx_ceilingcabinet_thermalmatches" );
    ObjDelete( "spr_alchemiststore_ceilingcabinet_matches");
    
    if ( cmn.IsEventDone( "get_fairyfigurine" ) ) and
       ( cmn.IsEventDone( "get_packofseeds" ) ) and
       ( cmn.IsEventDone( "get_thermalmatches" ) ) then

      ObjDelete( "gzz_alchemiststore_ceilingcabinet" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_thermalmatches", get_thermalmatches_inv );
  cmn.AddSubscriber( "get_thermalmatches", get_thermalmatches_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin" ] =
  {
    type = "get",
    get_obj = "spr_counter_coin",
    room = private.room_objname,
    zz = "zz_counter",
    zz_gate = "gzz_alchemiststore_counter"
  };
  --------------------------------------------------------------------------------------------
  local get_coin_inv = function ()

    int.InventoryItemAdd( "inv_coin", "spr_counter_coin" );

  end;
  local get_coin_closezz = function ()

    ObjDelete( "gfx_counter_coin" );
    ObjDelete( "spr_alchemiststore_counter_coin");

    if cmn.IsEventDone( "get_toydial" ) and 
       cmn.IsEventDone( "get_syringewithoil" ) then

      ObjDelete( "gzz_alchemiststore_counter" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_coin", get_coin_inv );
  cmn.AddSubscriber( "get_coin", get_coin_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toydial () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toydial" ] =
  {
    type = "get",
    get_obj = "spr_counter_toydial",
    room = private.room_objname,
    zz = "zz_counter",
    zz_gate = "gzz_alchemiststore_counter"
  };
  --------------------------------------------------------------------------------------------
  local get_toydial_inv = function ()

    int.InventoryItemAdd( "inv_toydial", "spr_counter_toydial" );
    ObjSet( "inv_toydial", { drag = false } );

    if not cmn.IsEventDone( "get_toymouse" ) then
      ObjSet( "inv_toydial_plus_focus2", { alp = 0 } );
    end;

  end;
  local get_toydial_closezz = function ()

    ObjDelete( "gfx_counter_toydial" );
    ObjDelete( "spr_alchemiststore_counter_box" );

    if cmn.IsEventDone( "get_coin" ) and 
       cmn.IsEventDone( "get_syringewithoil" ) then

      ObjDelete( "gzz_alchemiststore_counter" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_toydial", get_toydial_inv );
  cmn.AddSubscriber( "get_toydial", get_toydial_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_syringewithoil () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_syringewithoil" ] =
  {
    type = "get",
    get_obj = "obj_counter_syringewithoil",
    room = private.room_objname,
    zz = "zz_counter",
    zz_gate = "gzz_alchemiststore_counter"
  };
  --------------------------------------------------------------------------------------------
  local get_syringewithoil_inv = function ()

    int.InventoryItemAdd( "inv_syringewithoil", "obj_counter_syringewithoil" );

  end;
  local get_syringewithoil_closezz = function ()

    if cmn.IsEventDone( "get_coin" ) and 
       cmn.IsEventDone( "get_toydial" ) then

      ObjDelete( "gzz_alchemiststore_counter" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_syringewithoil", get_syringewithoil_inv );
  cmn.AddSubscriber( "get_syringewithoil", get_syringewithoil_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_awl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_awl" ] =
  {
    type = "get",
    get_obj = "spr_safe_awl",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_alchemiststore_safe"
  };
  --------------------------------------------------------------------------------------------
  local get_awl_inv = function ()

    int.InventoryItemAdd( "inv_awl", "spr_safe_awl" );

  end;
  local get_awl_closezz = function ()

    ObjDelete( "gfx_safe_awl" );
    ObjDelete( "spr_alchemiststore_safe_awl" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_awl", get_awl_inv );
  cmn.AddSubscriber( "get_awl", get_awl_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mop () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mop" ] =
  {
    type = "get",
    get_obj = "spr_safe_mop",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_alchemiststore_safe"
  };
  --------------------------------------------------------------------------------------------
  local get_mop_inv = function ()

    int.InventoryItemAdd( "inv_mop", "spr_safe_mop" );

  end;
  local get_mop_closezz = function ()

    ObjDelete( "gfx_safe_mop" );
    ObjDelete( "spr_alchemiststore_safe_mop" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_mop", get_mop_inv );
  cmn.AddSubscriber( "get_mop", get_mop_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_leprechaunamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_leprechaunamulet_2" ] =
  {
    type = "get",
    get_obj = "spr_safe_leprechaunamulet_2",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_alchemiststore_safe"
  };
  --------------------------------------------------------------------------------------------
  local get_leprechaunamulet_2_inv = function ()

    int.InventoryItemAdd( "inv_leprechaunamulet", "spr_safe_leprechaunamulet_2", "assets/levels/levelext/rm_square/zz_victormemorial/inv/inv_leprechaunamulet_2" );
    levelext_inv.CheckLeprechaunamulet();

  end;
  local get_leprechaunamulet_2_closezz = function ()

    ObjDelete( "gfx_safe_leprechaunamulet_2" );
    ObjDelete( "spr_alchemiststore_safe_amulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_leprechaunamulet_2", get_leprechaunamulet_2_inv );
  cmn.AddSubscriber( "get_leprechaunamulet_2", get_leprechaunamulet_2_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_leprechaunamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_leprechaunamulet" ] =
  {
    type = "use",
    use_obj = "inv_leprechaunamulet",
    use_place = "obj_ceilingcabinet_use_leprechaunamulet",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_alchemiststore_ceilingcabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_leprechaunamulet_inv = function ()

    int.InventoryItemRemove( "inv_leprechaunamulet" );

  end;
  local use_leprechaunamulet_beg = function ()

    ObjDelete( "obj_ceilingcabinet_use_leprechaunamulet" );
    ObjDelete( "anm_ceilingcabinet_doors_click" );

  end;
  local use_leprechaunamulet_end = function ()

    ObjDelete( "spr_alchemiststore_ceilingcabinet_close");
    ObjSet( "obj_alchemiststore_ceilingcabinet_open", { alp = 1 });
    ObjSet( "spr_ceilingcabinet_packofseeds",    { input = true } );
    ObjSet( "gfx_ceilingcabinet_packofseeds",    { active = true } );
    ObjSet( "spr_ceilingcabinet_thermalmatches", { input = true } );
    ObjSet( "gfx_ceilingcabinet_thermalmatches", { active = true } );
    ObjSet( "anm_ceilingcabinet_doors_open",     { alp = 1, frame = 85, animfunc = "DoAnim" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_leprechaunamulet",     use_leprechaunamulet_inv );
  cmn.AddSubscriber( "use_leprechaunamulet",     use_leprechaunamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_leprechaunamulet",     use_leprechaunamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_leprechaunamulet_inv", use_leprechaunamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_leprechaunamulet_beg", use_leprechaunamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_leprechaunamulet_end", use_leprechaunamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mop () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mop" ] =
  {
    type = "use",
    use_obj = "inv_mop",
    use_place = "obj_ceilingcabinet_use_mop",
    room = private.room_objname,
    zz = "zz_ceilingcabinet",
    zz_gate = "gzz_alchemiststore_ceilingcabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_mop_inv = function ()

    int.InventoryItemRemove( "inv_mop" );

  end;
  local use_mop_beg = function ()

    ObjDelete( "obj_ceilingcabinet_use_mop" );

  end;
  local use_mop_end = function ()

    ObjDelete( "anm_ceilingcabinet_mop" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mop",     use_mop_inv );
  cmn.AddSubscriber( "use_mop",     use_mop_beg, private.room_objname );
  cmn.AddSubscriber( "use_mop",     use_mop_end, private.room_objname );
  cmn.AddSubscriber( "use_mop_inv", use_mop_inv, private.room_objname );
  cmn.AddSubscriber( "use_mop_beg", use_mop_beg, private.room_objname );
  cmn.AddSubscriber( "use_mop_end", use_mop_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_alchemistryamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_alchemistryamulet" ] =
  {
    type = "use",
    use_obj = "inv_alchemistryamulet",
    use_place = "obj_counter_use_alchemistryamulet",
    room = private.room_objname,
    zz = "zz_counter",
    zz_gate = "gzz_alchemiststore_counter"
  };
  --------------------------------------------------------------------------------------------
  local use_alchemistryamulet_inv = function ()

    int.InventoryItemRemove( "inv_alchemistryamulet" );

  end;
  local use_alchemistryamulet_beg = function ()

    ObjDelete( "obj_counter_use_alchemistryamulet" );

  end;
  local use_alchemistryamulet_end = function ()

    ObjDelete( "obj_counter_box_close" );
    ObjSet( "spr_alchemiststore_counter_open", { alp = 1 });
    ObjSet( "obj_counter_box_open", { alp = 1, input = true } );
    ObjSet( "gfx_counter_toydial", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_alchemistryamulet",     use_alchemistryamulet_inv );
  cmn.AddSubscriber( "use_alchemistryamulet",     use_alchemistryamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_alchemistryamulet",     use_alchemistryamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_alchemistryamulet_inv", use_alchemistryamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_alchemistryamulet_beg", use_alchemistryamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_alchemistryamulet_end", use_alchemistryamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emptysyringe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emptysyringe" ] =
  {
    type = "use",
    use_obj = "inv_emptysyringe",
    use_place = "obj_counter_use_emptysyringe",
    room = private.room_objname,
    zz = "zz_counter",
    zz_gate = "gzz_alchemiststore_counter"
  };
  --------------------------------------------------------------------------------------------
  local use_emptysyringe_inv = function ()

    int.InventoryItemRemove( "inv_emptysyringe" );

  end;
  local use_emptysyringe_beg = function ()

    ObjDelete( "obj_counter_use_emptysyringe" );

  end;
  local use_emptysyringe_end = function ()

    ObjSet( "spr_counter_syringewithoil", { alp = 1, input = true } );
    ObjSet( "gfx_counter_syringewithoil", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emptysyringe",     use_emptysyringe_inv );
  cmn.AddSubscriber( "use_emptysyringe",     use_emptysyringe_beg, private.room_objname );
  cmn.AddSubscriber( "use_emptysyringe",     use_emptysyringe_end, private.room_objname );
  cmn.AddSubscriber( "use_emptysyringe_inv", use_emptysyringe_inv, private.room_objname );
  cmn.AddSubscriber( "use_emptysyringe_beg", use_emptysyringe_beg, private.room_objname );
  cmn.AddSubscriber( "use_emptysyringe_end", use_emptysyringe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sphynxamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sphynxamulet" ] =
  {
    type = "use",
    use_obj = "inv_sphynxamulet",
    use_place = "obj_safe_use_sphynxamulet",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_alchemiststore_safe"
  };
  --------------------------------------------------------------------------------------------
  local use_sphynxamulet_inv = function ()

    int.InventoryItemRemove( "inv_sphynxamulet" );

  end;
  local use_sphynxamulet_beg = function ()

    ObjDelete( "obj_safe_use_sphynxamulet" );
    ObjDelete( "anm_safe_door_click" );

  end;
  local use_sphynxamulet_end = function ()

    ObjDelete( "gzz_alchemiststore_safe" );
    ObjDelete( "spr_alchemiststore_safe_locks");
    ObjSet( "spr_alchemiststore_safe_open", { alp = 1 });
    ObjSet( "gho_alchemiststore_hosafe", { alp = 1, input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sphynxamulet",     use_sphynxamulet_inv );
  cmn.AddSubscriber( "use_sphynxamulet",     use_sphynxamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_sphynxamulet",     use_sphynxamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_sphynxamulet_inv", use_sphynxamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_sphynxamulet_beg", use_sphynxamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_sphynxamulet_end", use_sphynxamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coin" ] =
  {
    type = "use",
    use_obj = "inv_coin",
    use_place = "obj_safe_use_coin",
    room = private.room_objname,
    zz = "zz_safe",
    zz_gate = "gzz_alchemiststore_safe"
  };
  --------------------------------------------------------------------------------------------
  local use_coin_inv = function ()

    int.InventoryItemRemove( "inv_coin" );

  end;
  local use_coin_beg = function ()

    ObjDelete( "obj_safe_use_coin" );

  end;
  local use_coin_end = function ()

    ObjDelete( "spr_alchemiststore_safe_capclose");
    ObjSet( "obj_safe_box_open", { alp = 1, input = true } );
    ObjSet( "gfx_safe_leprechaunamulet_2", { active = true } );
    ObjSet( "gfx_safe_awl", { active = true } );

    ObjDelete( "obj_safe_box_close" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin",     use_coin_inv );
  cmn.AddSubscriber( "use_coin",     use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin",     use_coin_end, private.room_objname );
  cmn.AddSubscriber( "use_coin_inv", use_coin_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin_beg", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_end", use_coin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function dlg_alchemiststore_emily4_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_alchemiststore_emily4_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_alchemiststore_emily4_1_end = function ()

    ObjDelete( "dlg_alchemiststore_emily4_1" );

  end;

  cmn.AddSubscriber( "alchemiststore_emily4_1",     alchemiststore_emily4_1_beg );
  cmn.AddSubscriber( "alchemiststore_emily4_1",     alchemiststore_emily4_1_end );
  cmn.AddSubscriber( "alchemiststore_emily4_1_beg", alchemiststore_emily4_1_beg );
  cmn.AddSubscriber( "alchemiststore_emily4_1_end", alchemiststore_emily4_1_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_2()

  int.AddScreensaver( "spr_counter_screensaver_4_2" );

end;  
-----------------------------------------------------------------------
function private.get_collect_4_1 ()

  int.AddCollectibles( "spr_alchemiststore_collect_4_1" );

end;
-----------------------------------------------------------------------
function private.get_jupiteremblem ()

  cmn.SetEventDone( "get_jupiteremblem" );
  cmn.CallEventHandler( "get_jupiteremblem" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_fairyfigurine ()

  ObjSet( "spr_ceilingcabinet_fairyfigurine", { alp = 1 } );

  cmn.SetEventDone( "get_fairyfigurine" );
  cmn.CallEventHandler( "get_fairyfigurine" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_fairyfigurine" ) ) and
     ( cmn.IsEventDone( "get_packofseeds" ) ) and
     ( cmn.IsEventDone( "get_thermalmatches" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_packofseeds ()

  cmn.SetEventDone( "get_packofseeds" );
  cmn.CallEventHandler( "get_packofseeds" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_fairyfigurine" ) ) and
     ( cmn.IsEventDone( "get_packofseeds" ) ) and
     ( cmn.IsEventDone( "get_thermalmatches" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_thermalmatches ()

  cmn.SetEventDone( "get_thermalmatches" );
  cmn.CallEventHandler( "get_thermalmatches" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_fairyfigurine" ) ) and
     ( cmn.IsEventDone( "get_packofseeds" ) ) and
     ( cmn.IsEventDone( "get_thermalmatches" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_coin ()

  cmn.SetEventDone( "get_coin" );
  cmn.CallEventHandler( "get_coin" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toydial" ) and 
     cmn.IsEventDone( "get_syringewithoil" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_toydial ()

  cmn.SetEventDone( "get_toydial" );
  cmn.CallEventHandler( "get_toydial" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_coin" ) and 
     cmn.IsEventDone( "get_syringewithoil" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_syringewithoil ()

  cmn.SetEventDone( "get_syringewithoil" );
  cmn.CallEventHandler( "get_syringewithoil" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_coin" ) and 
     cmn.IsEventDone( "get_toydial" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_awl ()

  cmn.SetEventDone( "get_awl" );
  cmn.CallEventHandler( "get_awl" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_mop ()

  cmn.SetEventDone( "get_mop" );
  cmn.CallEventHandler( "get_mop" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_leprechaunamulet_2 ()

  cmn.SetEventDone( "get_leprechaunamulet_2" );
  cmn.CallEventHandler( "get_leprechaunamulet_2" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_leprechaunamulet ()

  local item = "inv_leprechaunamulet";

  if ( cmn.ApplyObj( item, "gzz_alchemiststore_ceilingcabinet", false ) ) and
     ( cmn.IsEventDone( "get_leprechaunamulet_1" ) ) and
     ( cmn.IsEventDone( "get_leprechaunamulet_2" ) ) and
     ( cmn.IsEventDone( "get_leprechaunamulet_3" ) ) and
     ( not cmn.IsEventDone( "use_leprechaunamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ceilingcabinet", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ceilingcabinet_use_leprechaunamulet", true ) ) and
         ( cmn.IsEventDone( "get_leprechaunamulet_1" ) ) and
         ( cmn.IsEventDone( "get_leprechaunamulet_2" ) ) and
         ( cmn.IsEventDone( "get_leprechaunamulet_3" ) ) and
         ( not cmn.IsEventDone( "use_leprechaunamulet" ) ) then

    cmn.CallEventHandler( "use_leprechaunamulet_inv" );
    cmn.CallEventHandler( "use_leprechaunamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_leprechaunamulet" );
      cmn.CallEventHandler( "use_leprechaunamulet_end" );

      interface.KeyTaskDone( true, "task_4_2" );

    end;

    int.Lock( true );

    ObjSet( "anm_ceilingcabinet_doors_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cellingcabinet _insert_color_open" );
    AnimPlay( "anm_ceilingcabinet_doors_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_mop ()

  local item = "inv_mop";

  if ( cmn.ApplyObj( item, "gzz_alchemiststore_ceilingcabinet", false ) ) and
     ( not cmn.IsEventDone( "use_mop" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ceilingcabinet", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ceilingcabinet_use_mop", true ) ) and
         ( not cmn.IsEventDone( "use_mop" ) ) then

    cmn.CallEventHandler( "use_mop_inv" );
    cmn.CallEventHandler( "use_mop_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_mop" );
      cmn.CallEventHandler( "use_mop_end" );
      private.get_fairyfigurine();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cellingcabinet_take_stuff_upper" );
    AnimPlay( "anm_ceilingcabinet_mop", "DoAnim", func_end );
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_alchemistryamulet ()

  local item = "inv_alchemistryamulet";

  if ( cmn.ApplyObj( item, "gzz_alchemiststore_counter", false ) ) and
     ( not cmn.IsEventDone( "use_alchemistryamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_counter" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_counter_use_alchemistryamulet", true ) ) and
         ( not cmn.IsEventDone( "use_alchemistryamulet" ) ) then

    cmn.CallEventHandler( "use_alchemistryamulet_inv" );
    cmn.CallEventHandler( "use_alchemistryamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_alchemistryamulet" );
      cmn.CallEventHandler( "use_alchemistryamulet_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_counter_click_door", { alp = 0 } );
    ObjSet( "anm_counter_use_alchemistryamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_counter_insert_box_trangle" );
    AnimPlay( "anm_counter_use_alchemistryamulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_emptysyringe ()

  local item = "inv_emptysyringe";

  if ( cmn.ApplyObj( item, "gzz_alchemiststore_counter", false ) ) and
     ( not cmn.IsEventDone( "use_emptysyringe" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_counter" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_counter_use_emptysyringe", true ) ) and
         ( not cmn.IsEventDone( "use_emptysyringe" ) ) then

    cmn.CallEventHandler( "use_emptysyringe_inv" );
    cmn.CallEventHandler( "use_emptysyringe_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_emptysyringe" );
      cmn.CallEventHandler( "use_emptysyringe_end" );
      private.get_syringewithoil();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_counter_fill_syringe" );
    AnimPlay( "anm_counter_use_emptysyringe", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_sphynxamulet ()

  local item = "inv_sphynxamulet";

  if ( cmn.ApplyObj( item, "gzz_alchemiststore_safe", false ) ) and
     ( not cmn.IsEventDone( "use_sphynxamulet" ) ) and 
       cmn.IsEventDone( "get_sphynxamulet_1" ) and 
       cmn.IsEventDone( "get_sphynxamulet_2" ) and 
       cmn.IsEventDone( "get_sphynxamulet_3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_safe" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_safe_use_sphynxamulet", true ) ) and
         ( not cmn.IsEventDone( "use_sphynxamulet" ) ) and 
           cmn.IsEventDone( "get_sphynxamulet_1" ) and 
           cmn.IsEventDone( "get_sphynxamulet_2" ) and 
           cmn.IsEventDone( "get_sphynxamulet_3" ) then

    cmn.CallEventHandler( "use_sphynxamulet_inv" );
    cmn.CallEventHandler( "use_sphynxamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_sphynxamulet" );
      cmn.CallEventHandler( "use_sphynxamulet_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );

    ObjSet( "anm_safe_sphynxamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_safe_insert_figure_opens" );
    AnimPlay( "anm_safe_sphynxamulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_coin ()

  local item = "inv_coin";

  if ( cmn.ApplyObj( item, "gzz_alchemiststore_safe", false ) ) and
     ( not cmn.IsEventDone( "use_coin" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_safe" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_safe_use_coin", true ) ) and
         ( not cmn.IsEventDone( "use_coin" ) ) then

    cmn.CallEventHandler( "use_coin_inv" );
    cmn.CallEventHandler( "use_coin_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_coin" );
      cmn.CallEventHandler( "use_coin_end" );

    end;

    local func_anim_end = function ()

      ObjAnimate( "obj_safe_box_open", "alp", 0, 0, "",
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );
      ObjAnimate( "obj_safe_box_close", "alp", 0, 0, func_end,
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_safe_unscrew_hidden_cell" );
    VidPlay( "vid_safe_coin", func_anim_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.dlg_alchemiststore_emily4_1 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_jupiteremblem" );
    cmn.GetObjectSfx();

    ObjSet( "anm_alchemiststore_emily4_1_emily_static", { alp = 0 } );
    AnimStop( "anm_alchemiststore_emily4_1_emily_static" );

    ObjAnimate( "anm_alchemiststore_emily4_1_emily_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    if ( func_end ) then

      func_end();

    end;

    cmn.SetEventDone( "get_jupiteremblem" );
    cmn.SetEventDone( "dlg_alchemiststore_emily4_1" );
    cmn.ShowBbt( "bbt_alchemiststore_dlg_emily4_1" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_alchemiststore_emily4_1_emily_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "emily4_1", "alchemiststore", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_alchemiststore_emily4_1_beg" );
  ObjAttach( "dlg_alchemiststore_emily4_1", GetCurrentRoom() );  

  ObjAnimate( "anm_alchemiststore_emily4_1_emily_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "emily4_1" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_alchemiststore_emily4_1_emily_static" );
        AnimPlay( "anm_alchemiststore_emily4_1_emily_give", "DoAnim", "" );

      end;

      ObjAnimate( "anm_alchemiststore_emily4_1_emily_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_alchemiststore_emily4_1_emily_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_alchemiststore ()

  if not ( cmn.IsEventDone( "opn_alchemiststore" ) ) then

    cmn.SetEventDone( "opn_alchemiststore" );

  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_alchemiststore_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_alchemiststore_env", 1 );

--  if ( not cmn.IsEventDone( "dlg_alchemiststore_emily4_1" ) ) then
--
--    private.dlg_alchemiststore_emily4_1();
--
--  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_alchemiststore();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_jupiteremblem" );
  int.AddedTaskMap( private.room_objname, "get_fairyfigurine",                                               { "use_mop" } );
  int.AddedTaskMap( private.room_objname, "get_packofseeds",                                                 { "use_leprechaunamulet" } );
  int.AddedTaskMap( private.room_objname, "get_thermalmatches",                                              { "use_leprechaunamulet" } );
  int.AddedTaskMap( private.room_objname, "get_coin" );
  int.AddedTaskMap( private.room_objname, "get_toydial",                                                     { "use_alchemistryamulet" } );
  int.AddedTaskMap( private.room_objname, "get_syringewithoil",                                              { "use_emptysyringe" } );
  int.AddedTaskMap( private.room_objname, "get_awl",                                                         { "use_coin" } );
  int.AddedTaskMap( private.room_objname, "get_mop" );
  int.AddedTaskMap( private.room_objname, "get_leprechaunamulet_2",                                          { "use_coin" } );

  int.AddedTaskMap( private.room_objname, "use_leprechaunamulet",                                            { "get_leprechaunamulet_1", "get_leprechaunamulet_2", "get_leprechaunamulet_3" } );
  int.AddedTaskMap( private.room_objname, "use_mop",                                                         { "get_mop" } );
  int.AddedTaskMap( private.room_objname, "use_alchemistryamulet",                                           { "get_alchemistryamulet" } );
  int.AddedTaskMap( private.room_objname, "use_emptysyringe",                                                { "get_emptysyringe" } );
  int.AddedTaskMap( private.room_objname, "use_sphynxamulet",                                                { "get_sphynxamulet_1", "get_sphynxamulet_2", "get_sphynxamulet_3" } );
  int.AddedTaskMap( private.room_objname, "use_coin",                                                        { "get_coin" } );

  int.AddedTaskMap( private.room_objname, "win_hosafe",                                                      { "use_sphynxamulet" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_counter" );  
  -------------------------------------------------
  function zz_counter.Close()
    
    cmn.NoteScaleEnd( { "spr_counter_note" }, true );

  end;
  -------------------------------------------------  
  subroom.Define( "zz_safe" );  
  -------------------------------------------------
  function zz_safe.Close()

    cmn.NoteScaleEnd( { "spr_safe_note" }, true );

  end;  
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
function private.CeilingcabinetDoorsClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_ceilingcabinet_use_leprechaunamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_cellingcabinet_camod" );
  AnimPlay( "anm_ceilingcabinet_doors_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.SafeDoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_safe_use_sphynxamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_safe_safe" );
  AnimPlay( "anm_safe_door_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.CounterBoxClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_counter_use_alchemistryamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_counter_box_table" );
  AnimPlay( "anm_counter_click_door", "DoAnim", func_end );

end;
--*********************************************************************************************************************