-- name=rm_dungeon
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_dungeon";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_ritualstone", "room_hub" );
  ObjAttach( "zz_load",        "room_hub" );
  ObjAttach( "zz_extract",     "room_hub" );

  ObjMultiSet(
  {
    { "spr_ritualstone_shachihokoamulet", { event_mdown = private.get_shachihokoamulet } },
    { "spr_ritualstone_atlantesamulet_1", { event_mdown = private.get_atlantesamulet_1 } },
    { "spr_load_chisel",                  { event_mdown = private.get_chisel } },
    { "spr_load_magiccube",               { event_mdown = private.get_magiccube } },
    { "spr_load_crystalsofpurity",        { event_mdown = private.get_crystalsofpurity } },
    { "spr_load_crystalofelements_2",     { event_mdown = private.get_crystalofelements_2 } },
    { "spr_extract_magicshield",          { event_mdown = private.get_magicshield } },
    { "spr_extract_runedice_1",           { event_mdown = private.get_runedice_1 } },
    { "spr_extract_stoneofsouls_4",       { event_mdown = private.get_stoneofsouls_4 } },
    { "spr_extract_gargoylefigurine",     { event_mdown = private.get_gargoylefigurine } },
    { "obj_load_use_hellhoundamulet",     { event_mdown = private.clk_load_box_xx } },
    { "obj_load_use_shachihokoamulet",    { event_mdown = private.clk_load_chest_xx } },
    { "spr_load_screensaver_4_13",        { event_mdown = private.get_screensaver_4_13 } },          
    { "spr_extract_screensaver_4_14",     { event_mdown = private.get_screensaver_4_14 } },  
    { "obj_ritualstone_use_chisel_2",     { event_mdown = private.RitualstoneClick } },  
    { "obj_dungeon_use_magicshield",      { event_mdown = function() private.DungeonMagicshieldSlotClk() end } }, 
    { "obj_extract_use_theseusfigurine",  { event_mdown = function() private.ExtractChestClk() end } }, 
    { "obj_extract_use_ritualsickle",     { event_mdown = function() private.ExtracthBushesClk() end } },  
    { "obj_load_use_shachihokoamulet",    { event_mdown = function() private.LoadChestClk() end } },
    { "obj_load_use_hellhoundamulet",     { event_mdown = function() private.LoadBoxClk() end } },
    { "obj_load_use_ritualsickle",        { event_mdown = function() private.LoadBagClk() end } },             
  } );

  local get_screensaver_4_13 = function ()

    ObjDelete( "spr_load_screensaver_4_13" );
    ObjDelete( "spr_dungeon_load_puzzle" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_13", get_screensaver_4_13, private.room_objname );  
  local get_screensaver_4_14 = function ()

    ObjDelete( "spr_extract_screensaver_4_14" );
    ObjDelete( "spr_dungeon_extract_puzzle" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_14", get_screensaver_4_14, private.room_objname );  
 
  private.InitMiniHO();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_dungeon = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_dungeon", update_game_mode_dungeon, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_2 = function ()

    ObjDelete( "obj_dungeon_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_2", get_morphobject_4_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_splinter() end;
  --------------------------------------------------------------------------------------------
  local get_splinter_inv = function ()

    int.InventoryItemAdd( "inv_splinter", "spr_dungeon_splinter" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_splinter", get_splinter_inv );
  --------------------------------------------------------------------------------------------
  -- function get_shachihokoamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shachihokoamulet" ] =
  {
    type = "get",
    get_obj = "spr_ritualstone_shachihokoamulet",
    room = private.room_objname,
    zz = "zz_ritualstone",
    zz_gate = "gzz_dungeon_ritualstone"
  };
  --------------------------------------------------------------------------------------------
  local get_shachihokoamulet_inv = function ()

    int.InventoryItemAdd( "inv_shachihokoamulet", "spr_ritualstone_shachihokoamulet" );

  end;
  local get_shachihokoamulet_closezz = function ()

    ObjDelete( "anm_ritualstone_chisel" );
    ObjDelete( "spr_dungeon_ritualstone_shachihokoamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_shachihokoamulet", get_shachihokoamulet_inv );
  cmn.AddSubscriber( "get_shachihokoamulet", get_shachihokoamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_atlantesamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_atlantesamulet_1" ] =
  {
    type = "get",
    get_obj = "spr_ritualstone_atlantesamulet_1",
    room = private.room_objname,
    zz = "zz_ritualstone",
    zz_gate = "gzz_dungeon_ritualstone"
  };
  --------------------------------------------------------------------------------------------
  local get_atlantesamulet_1_inv = function ()

    int.InventoryItemAdd( "inv_atlantesamulet", "spr_ritualstone_atlantesamulet_1", "assets/levels/levelext/rm_dungeon/zz_ritualstone/inv/inv_atlantesamulet_1" );
    levelext_inv.CheckAtlantesamulet();

    if cmn.IsEventDone( "get_atlantesamulet_2" ) and 
       cmn.IsEventDone( "get_atlantesamulet_3" ) and 
       cmn.IsEventDone( "get_magiccube" ) then

      ObjSet( "inv_magiccube_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_atlantesamulet_1_closezz = function ()

    ObjDelete( "gfx_ritualstone_atlantesamulet_1" );
    ObjDelete( "spr_dungeon_ritualstone_atlantesamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_atlantesamulet_1", get_atlantesamulet_1_inv );
  cmn.AddSubscriber( "get_atlantesamulet_1", get_atlantesamulet_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chisel" ] =
  {
    type = "get",
    get_obj = "spr_load_chisel",
    room = private.room_objname,
    zz = "zz_load",
    zz_gate = "gzz_dungeon_load"
  };
  --------------------------------------------------------------------------------------------
  local get_chisel_inv = function ()

    int.InventoryItemAdd( "inv_chisel", "spr_load_chisel" );

  end;
  local get_chisel_closezz = function ()

    ObjDelete( "gfx_load_chisel" );

    ObjDelete( "spr_dungeon_load_chisel" );
    --ObjDelete( "gzz_dungeon_load" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_chisel", get_chisel_inv );
  cmn.AddSubscriber( "get_chisel", get_chisel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magiccube () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magiccube" ] =
  {
    type = "get",
    get_obj = "spr_load_magiccube",
    room = private.room_objname,
    zz = "zz_load",
    zz_gate = "gzz_dungeon_load"
  };
  --------------------------------------------------------------------------------------------
  local get_magiccube_inv = function ()

    int.InventoryItemAdd( "inv_magiccube", "spr_load_magiccube" );
    ObjSet( "inv_magiccube", { drag = false } );

    if not ( cmn.IsEventDone( "get_atlantesamulet_1" ) and 
             cmn.IsEventDone( "get_atlantesamulet_2" ) and 
             cmn.IsEventDone( "get_atlantesamulet_3" ) ) then

      ObjSet( "inv_magiccube_plus_focus2", { alp = 0 } );

    end;

  end;
  local get_magiccube_closezz = function ()

    ObjDelete( "gfx_load_magiccube" );

    ObjDelete( "spr_dungeon_load_magiccube" );
    --ObjDelete( "gzz_dungeon_load" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magiccube", get_magiccube_inv );
  cmn.AddSubscriber( "get_magiccube", get_magiccube_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalsofpurity () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crystalsofpurity" ] =
  {
    type = "get",
    get_obj = "spr_load_crystalsofpurity",
    room = private.room_objname,
    zz = "zz_load",
    zz_gate = "gzz_dungeon_load"
  };
  --------------------------------------------------------------------------------------------
  local get_crystalsofpurity_inv = function ()

    int.InventoryItemAdd( "inv_crystalsofpurity", "spr_load_win" );

  end;
  local get_crystalsofpurity_closezz = function ()

    ObjDelete( "gfx_load_crystalsofpurity" );
    ObjDelete( "obj_load_miniho" );

    ObjDelete( "spr_dungeon_load_mini_ho" );
    --ObjDelete( "gzz_dungeon_load" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystalsofpurity", get_crystalsofpurity_inv );
  cmn.AddSubscriber( "get_crystalsofpurity", get_crystalsofpurity_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalofelements_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crystalofelements_2" ] =
  {
    type = "get",
    get_obj = "spr_load_crystalofelements_2",
    room = private.room_objname,
    zz = "zz_load",
    zz_gate = "gzz_dungeon_load"
  };
  --------------------------------------------------------------------------------------------
  local get_crystalofelements_2_inv = function ()

    int.InventoryItemAdd( "inv_crystalofelements", "spr_load_crystalofelements_2", "assets/levels/levelext/rm_pagantemple/zz_gargoyles/inv/inv_crystalofelements_2" );
    levelext_inv.CheckCrystalofelements();

    if cmn.IsEventDone( "get_crystalofelements_1" ) and 
       cmn.IsEventDone( "get_crystalofelements_3" ) and 
       cmn.IsEventDone( "get_crystalofelements_4" ) then

      ObjSet( "inv_magiccircle_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_crystalofelements_2_closezz = function ()

    ObjDelete( "gfx_load_crystalofelements_2" );
    ObjDelete( "gzz_dungeon_load" );

    ObjDelete( "spr_dungeon_load_crystalofelements" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystalofelements_2", get_crystalofelements_2_inv );
  cmn.AddSubscriber( "get_crystalofelements_2", get_crystalofelements_2_closezz, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_magicshield () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magicshield" ] =
  {
    type = "get",
    get_obj = "spr_extract_magicshield",
    room = private.room_objname,
    zz = "zz_extract",
    zz_gate = "gzz_dungeon_extract"
  };
  --------------------------------------------------------------------------------------------
  local get_magicshield_inv = function ()

    int.InventoryItemAdd( "inv_magicshield", "spr_extract_magicshield" );

  end;
  local get_magicshield_closezz = function ()

    ObjDelete( "gfx_extract_magicshield" );

    if cmn.IsEventDone( "get_hellhoundamulet" ) and 
       cmn.IsEventDone( "get_runedice_1" ) and 
       cmn.IsEventDone( "get_stoneofsouls_4" ) and 
       cmn.IsEventDone( "get_gargoylefigurine" ) then

      ObjDelete( "gzz_dungeon_extract" );

    end;

    ObjDelete( "spr_dungeon_extract_magicshield" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicshield", get_magicshield_inv );
  cmn.AddSubscriber( "get_magicshield", get_magicshield_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hellhoundamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hellhoundamulet" ] =
  {
    type = "get",
    get_obj = "obj_extract_hellhoundamulet",
    room = private.room_objname,
    zz = "zz_extract",
    zz_gate = "gzz_dungeon_extract"
  };
  --------------------------------------------------------------------------------------------
  local get_hellhoundamulet_inv = function ()

    int.InventoryItemAdd( "inv_hellhoundamulet", "obj_extract_hellhoundamulet" );

  end;
  local get_hellhoundamulet_closezz = function ()

    ObjDelete( "spr_extract_hellhoundamulet_shadow" );
    ObjDelete( "gfx_extract_hellhoundamulet" );

    if cmn.IsEventDone( "get_magicshield" ) and 
       cmn.IsEventDone( "get_runedice_1" ) and 
       cmn.IsEventDone( "get_stoneofsouls_4" ) and 
       cmn.IsEventDone( "get_gargoylefigurine" ) then

      ObjDelete( "gzz_dungeon_extract" );

    end;

    ObjDelete( "spr_dungeon_hellhoundamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_hellhoundamulet", get_hellhoundamulet_inv );
  cmn.AddSubscriber( "get_hellhoundamulet", get_hellhoundamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_runedice_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_runedice_1" ] =
  {
    type = "get",
    get_obj = "spr_extract_runedice_1",
    room = private.room_objname,
    zz = "zz_extract",
    zz_gate = "gzz_dungeon_extract"
  };
  --------------------------------------------------------------------------------------------
  local get_runedice_1_inv = function ()

    int.InventoryItemAdd( "inv_runedice", "spr_extract_runedice_1", "assets/levels/levelext/rm_dungeon/zz_extract/inv/inv_runedice_1" );
    levelext_inv.CheckRunedice( 1 );

  end;
  local get_runedice_1_closezz = function ()

    ObjDelete( "gfx_extract_runedice_1" );

    if cmn.IsEventDone( "get_magicshield" ) and 
       cmn.IsEventDone( "get_hellhoundamulet" ) and 
       cmn.IsEventDone( "get_stoneofsouls_4" ) and 
       cmn.IsEventDone( "get_gargoylefigurine" ) then

      ObjDelete( "gzz_dungeon_extract" );

    end;

    ObjDelete( "spr_dungeon_extract_runedice" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_runedice_1", get_runedice_1_inv );
  cmn.AddSubscriber( "get_runedice_1", get_runedice_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stoneofsouls_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stoneofsouls_4" ] =
  {
    type = "get",
    get_obj = "spr_extract_stoneofsouls_4",
    room = private.room_objname,
    zz = "zz_extract",
    zz_gate = "gzz_dungeon_extract"
  };
  --------------------------------------------------------------------------------------------
  local get_stoneofsouls_4_inv = function ()

    int.InventoryItemAdd( "inv_stoneofsouls", "spr_extract_stoneofsouls_4", "assets/levels/levelext/rm_prison/zz_throneoftorture/inv/inv_stoneofsouls_4" );
    levelext_inv.CheckStoneofsouls();

  end;
  local get_stoneofsouls_4_closezz = function ()

    ObjDelete( "gfx_extract_stoneofsouls_4" );

    if cmn.IsEventDone( "get_magicshield" ) and 
       cmn.IsEventDone( "get_hellhoundamulet" ) and 
       cmn.IsEventDone( "get_runedice_1" ) and 
       cmn.IsEventDone( "get_gargoylefigurine" ) then

      ObjDelete( "gzz_dungeon_extract" );

    end;

    ObjDelete( "spr_dungeon_extract_stoneofsouls" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stoneofsouls_4", get_stoneofsouls_4_inv );
  cmn.AddSubscriber( "get_stoneofsouls_4", get_stoneofsouls_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gargoylefigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gargoylefigurine" ] =
  {
    type = "get",
    get_obj = "spr_extract_gargoylefigurine",
    room = private.room_objname,
    zz = "zz_extract",
    zz_gate = "gzz_dungeon_extract"
  };
  --------------------------------------------------------------------------------------------
  local get_gargoylefigurine_inv = function ()

    int.InventoryItemAdd( "inv_gargoylefigurine", "spr_extract_gargoylefigurine" );

  end;
  local get_gargoylefigurine_closezz = function ()

    ObjDelete( "gfx_extract_gargoylefigurine" );

    if cmn.IsEventDone( "get_magicshield" ) and 
       cmn.IsEventDone( "get_hellhoundamulet" ) and 
       cmn.IsEventDone( "get_runedice_1" ) and 
       cmn.IsEventDone( "get_stoneofsouls_4" ) then

      ObjDelete( "gzz_dungeon_extract" );

    end;

    ObjDelete( "spr_dungeon_extract_gargoylefigurine" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gargoylefigurine", get_gargoylefigurine_inv );
  cmn.AddSubscriber( "get_gargoylefigurine", get_gargoylefigurine_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_chisel_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel_2" ] =
  {
    type = "use",
    use_obj = "inv_chisel",
    use_place = "obj_ritualstone_use_chisel_2",
    room = private.room_objname,
    zz = "zz_ritualstone",
    zz_gate = "gzz_dungeon_ritualstone"
  };
  --------------------------------------------------------------------------------------------
  local use_chisel_2_inv = function ()

    if ( cmn.IsEventDone( "use_chisel_1" ) ) then

      int.InventoryItemRemove( "inv_chisel" );

    end;

  end;
  local use_chisel_2_beg = function ()

    ObjDelete( "obj_ritualstone_use_chisel_2" );
    ObjDelete( "anm_ritualstone_click" );

  end;
  local use_chisel_2_end = function ()

    ObjSet( "anm_ritualstone_chisel", { alp = 1, frame = 131, animfunc = "DoAnim" } );
    ObjSet( "spr_ritualstone_shachihokoamulet", { input = true } );
    ObjSet( "gfx_ritualstone_shachihokoamulet", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel_2",     use_chisel_2_inv );
  cmn.AddSubscriber( "use_chisel_2",     use_chisel_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2",     use_chisel_2_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2_inv", use_chisel_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2_beg", use_chisel_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2_end", use_chisel_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crystalsofpurity () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crystalsofpurity" ] =
  {
    type = "use",
    use_obj = "inv_crystalsofpurity",
    use_place = "obj_ritualstone_use_crystalsofpurity",
    room = private.room_objname,
    zz = "zz_ritualstone",
    zz_gate = "gzz_dungeon_ritualstone"
  };
  --------------------------------------------------------------------------------------------
  local use_crystalsofpurity_inv = function ()

    int.InventoryItemRemove( "inv_crystalsofpurity" );

  end;
  local use_crystalsofpurity_beg = function ()

    ObjDelete( "obj_ritualstone_use_crystalsofpurity" );

  end;
  local use_crystalsofpurity_end = function ()

    ObjDelete( "gzz_dungeon_ritualstone" );
    ObjSet( "grm_dungeon_prison", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_dungeon_prison_focus");
    end;
    ObjSet( "gmg_dungeon_mgcrystals", { alp = 1, input = true, active = true } );

    ObjDelete( "anm_dungeon_prison_open_start" );
    ObjSet( "anm_dungeon_prison_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crystalsofpurity",     use_crystalsofpurity_inv );
  cmn.AddSubscriber( "use_crystalsofpurity",     use_crystalsofpurity_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalsofpurity",     use_crystalsofpurity_end, private.room_objname );
  cmn.AddSubscriber( "use_crystalsofpurity_inv", use_crystalsofpurity_inv, private.room_objname );
  cmn.AddSubscriber( "use_crystalsofpurity_beg", use_crystalsofpurity_beg, private.room_objname );
  cmn.AddSubscriber( "use_crystalsofpurity_end", use_crystalsofpurity_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hellhoundamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hellhoundamulet" ] =
  {
    type = "use",
    use_obj = "inv_hellhoundamulet",
    use_place = "obj_load_use_hellhoundamulet",
    room = private.room_objname,
    zz = "zz_load",
    zz_gate = "gzz_dungeon_load"
  };
  --------------------------------------------------------------------------------------------
  local use_hellhoundamulet_inv = function ()

    int.InventoryItemRemove( "inv_hellhoundamulet" );

  end;
  local use_hellhoundamulet_beg = function ()

    ObjDelete( "obj_load_use_hellhoundamulet" );

  end;
  local use_hellhoundamulet_end = function ()
  
    ObjSet( "spr_load_magiccube", { input = true } );
    ObjSet( "gfx_load_magiccube", { active = true } );
    ObjDelete( "obj_load_box_close");

    ObjSet( "obj_dungeon_load_open_box", { alp = 1 } );
    ObjDelete( "spr_dungeon_cap" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hellhoundamulet",     use_hellhoundamulet_inv );
  cmn.AddSubscriber( "use_hellhoundamulet",     use_hellhoundamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_hellhoundamulet",     use_hellhoundamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_hellhoundamulet_inv", use_hellhoundamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_hellhoundamulet_beg", use_hellhoundamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_hellhoundamulet_end", use_hellhoundamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shachihokoamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shachihokoamulet" ] =
  {
    type = "use",
    use_obj = "inv_shachihokoamulet",
    use_place = "obj_load_use_shachihokoamulet",
    room = private.room_objname,
    zz = "zz_load",
    zz_gate = "gzz_dungeon_load"
  };
  --------------------------------------------------------------------------------------------
  local use_shachihokoamulet_inv = function ()

    int.InventoryItemRemove( "inv_shachihokoamulet" );

  end;
  local use_shachihokoamulet_beg = function ()

    ObjDelete( "obj_load_use_shachihokoamulet" );

  end;
  local use_shachihokoamulet_end = function ()

    ObjDelete( "anm_load_click_chest" );
    ObjSet( "obj_load_open_chest", { input = true } );
    ObjSet( "anm_load_use_shachihokoamulet", { alp = 1, frame = 500 } );

    ObjDelete( "spr_dungeon_load_close_cover" );
    ObjSet( "obj_dungeon_load_open_chest", { alp = 1});

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shachihokoamulet",     use_shachihokoamulet_inv );
  cmn.AddSubscriber( "use_shachihokoamulet",     use_shachihokoamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_shachihokoamulet",     use_shachihokoamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_shachihokoamulet_inv", use_shachihokoamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_shachihokoamulet_beg", use_shachihokoamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_shachihokoamulet_end", use_shachihokoamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ritualsickle_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ritualsickle_2" ] =
  {
    type = "use",
    use_obj = "inv_ritualsickle",
    use_place = "obj_load_use_ritualsickle",
    room = private.room_objname,
    zz = "zz_load",
    zz_gate = "gzz_dungeon_load"
  };
  --------------------------------------------------------------------------------------------
  local use_ritualsickle_2_inv = function ()

    if ( cmn.IsEventDone( "use_ritualsickle_1" ) and 
         cmn.IsEventDone( "use_ritualsickle" )) then
     
     int.InventoryItemRemove( "inv_ritualsickle" );
      
    end;

  end;
  local use_ritualsickle_2_beg = function ()

    ObjDelete( "obj_load_use_ritualsickle" );

  end;
  local use_ritualsickle_2_end = function ()
    
    ObjSet( "obj_load_sack_open", { alp = 1 });
    ObjSet( "spr_load_crystalofelements_2", { input = true });
    ObjSet( "gfx_load_crystalofelements_2", { active = true });

    ObjDelete( "anm_load_use_ritualsickle" );
    ObjDelete( "anm_load_click" );

    ObjSet( "obj_dungeon_load_open_sack", { alp = 1 });


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ritualsickle_2",     use_ritualsickle_2_inv );
  cmn.AddSubscriber( "use_ritualsickle_2",     use_ritualsickle_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_2",     use_ritualsickle_2_end, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_2_inv", use_ritualsickle_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_2_beg", use_ritualsickle_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_2_end", use_ritualsickle_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chisel_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel_1" ] =
  {
    type = "use",
    use_obj = "inv_chisel",
    use_place = "obj_extract_use_chisel_1",
    room = private.room_objname,
    zz = "zz_extract",
    zz_gate = "gzz_dungeon_extract"
  };
  --------------------------------------------------------------------------------------------
  local use_chisel_1_inv = function ()

    if ( cmn.IsEventDone( "use_chisel_2" ) ) then

      int.InventoryItemRemove( "inv_chisel" );

    end;

  end;
  local use_chisel_1_beg = function ()

    ObjDelete( "obj_extract_use_chisel_1" );

  end;
  local use_chisel_1_end = function ()

    --ObjSet( "anm_extract_use_chisel", { frame = 500, alp = 1 } );
    ObjDelete( "anm_extract_click_chest" );
    ObjDelete( "anm_extract_use_chisel" );

    ObjSet( "anm_extract_click_box_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel_1",     use_chisel_1_inv );
  cmn.AddSubscriber( "use_chisel_1",     use_chisel_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_1",     use_chisel_1_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_1_inv", use_chisel_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_1_beg", use_chisel_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_1_end", use_chisel_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ritualsickle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ritualsickle" ] =
  {
    type = "use",
    use_obj = "inv_ritualsickle",
    use_place = "obj_extract_use_ritualsickle",
    room = private.room_objname,
    zz = "zz_extract",
    zz_gate = "gzz_dungeon_extract"
  };
  --------------------------------------------------------------------------------------------
  local use_ritualsickle_inv = function ()

    if ( cmn.IsEventDone( "use_ritualsickle_1" ) and 
         cmn.IsEventDone( "use_ritualsickle_2" )) then
     
     int.InventoryItemRemove( "inv_ritualsickle" );
      
    end;
   
  end;
  local use_ritualsickle_beg = function ()

    ObjDelete( "obj_extract_use_ritualsickle" );

  end;
  local use_ritualsickle_end = function ()

    ObjDelete( "obj_extract_opening_close" );
    ObjSet( "obj_extract_opening_open", { alp = 1, input = true } );
    ObjSet( "gfx_extract_stoneofsouls_4", { active = true } );
    ObjSet( "gfx_extract_gargoylefigurine", { active = true } );

    ObjDelete( "spr_dungeon_extract_bush" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ritualsickle",     use_ritualsickle_inv );
  cmn.AddSubscriber( "use_ritualsickle",     use_ritualsickle_beg, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle",     use_ritualsickle_end, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_inv", use_ritualsickle_inv, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_beg", use_ritualsickle_beg, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_end", use_ritualsickle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_theseusfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_theseusfigurine" ] =
  {
    type = "use",
    use_obj = "inv_theseusfigurine",
    use_place = "obj_extract_use_theseusfigurine",
    room = private.room_objname,
    zz = "zz_extract",
    zz_gate = "gzz_dungeon_extract"
  };
  --------------------------------------------------------------------------------------------
  local use_theseusfigurine_inv = function ()

    int.InventoryItemRemove( "inv_theseusfigurine" );

  end;
  local use_theseusfigurine_beg = function ()

    ObjDelete( "obj_extract_use_theseusfigurine" );

  end;
  local use_theseusfigurine_end = function ()

    ObjSet( "anm_extract_use_theseusfigurine", { frame = 500 } );
    ObjSet( "obj_extract_chest_open", { alp = 1, input = true } );
    ObjDelete( "obj_extract_chest_close" );
    ObjSet( "gfx_extract_magicshield", { active = true } );

    ObjSet( "spr_extract_light2", { alp = 1 } );
    ObjDelete( "spr_extract_light1" );

    ObjDelete( "spr_dungeon_extract_close_cover" );
    ObjSet( "obj_dungeon_extract_open_chest", { alp = 1 } );
    ObjSet( "spr_dungeon_extract_theseusfigurine", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_theseusfigurine",     use_theseusfigurine_inv );
  cmn.AddSubscriber( "use_theseusfigurine",     use_theseusfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_theseusfigurine",     use_theseusfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_theseusfigurine_inv", use_theseusfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_theseusfigurine_beg", use_theseusfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_theseusfigurine_end", use_theseusfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magicshield () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magicshield" ] =
  {
    type = "use",
    use_obj = "inv_magicshield",
    use_place = "obj_dungeon_use_magicshield",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------
  local use_magicshield_inv = function ()

    int.InventoryItemRemove( "inv_magicshield" );

  end;
  local use_magicshield_beg = function ()

    ObjDelete( "obj_dungeon_use_magicshield" );

  end;
  local use_magicshield_end = function ()

    ObjSet( "grm_dungeon_pagantemple", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_dungeon_pagantemple_focus");
    end;
    
    ObjDelete( "anm_dungeon_magicshield_slot_clk" );
    ObjSet( "spr_dungeon_pagantemple_gates_over", { alp = 1 } );
    ObjSet( "spr_dungeon_shield", { alp = 1 } );
    ObjDelete( "anm_dungeon_magic_rays" );
    ObjDelete( "anm_dungeon_use_shield" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magicshield",     use_magicshield_inv );
  cmn.AddSubscriber( "use_magicshield",     use_magicshield_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicshield",     use_magicshield_end, private.room_objname );
  cmn.AddSubscriber( "use_magicshield_inv", use_magicshield_inv, private.room_objname );
  cmn.AddSubscriber( "use_magicshield_beg", use_magicshield_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicshield_end", use_magicshield_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function win_mgcrystals () end;
  --------------------------------------------------------------------------------------------
  local win_mgcrystals = function ()

    if ( cmn.IsEventDone( "win_mgcrystals" ) ) then

      ObjDelete( "gmg_dungeon_mgcrystals" );
      ObjSet( "grm_dungeon_prison", { alp = 1, input = true, active = true } );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_dungeon_prison_focus");
      end;
    end;

  end;

  cmn.AddSubscriber( "win_mgcrystals", win_mgcrystals, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_dungeon_emily4_4 () end;
  --------------------------------------------------------------------------------------------
  local dlg_dungeon_emily4_4_beg = function ()

  end;
  -----------------------------------------------
  local dlg_dungeon_emily4_4_end = function ()

    ObjDelete( "dlg_dungeon_emily4_4" );
    ObjSet( "anm_dungeon_emily", { alp = 1, playing = true } );
    ObjSet( "obj_dungeon_emily", { input = true } );

  end;

  cmn.AddSubscriber( "dlg_dungeon_emily4_4",     dlg_dungeon_emily4_4_beg );
  cmn.AddSubscriber( "dlg_dungeon_emily4_4",     dlg_dungeon_emily4_4_end );
  cmn.AddSubscriber( "dlg_dungeon_emily4_4_beg", dlg_dungeon_emily4_4_beg );
  cmn.AddSubscriber( "dlg_dungeon_emily4_4_end", dlg_dungeon_emily4_4_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_dungeon_emily4_2 () end;
  --------------------------------------------------------------------------------------------
  local dlg_dungeon_emily4_2_beg = function ()

  end;
  -----------------------------------------------
  local dlg_dungeon_emily4_2_end = function ()

    ObjDelete( "dlg_dungeon_emily4_2" );

  end;

  cmn.AddSubscriber( "dlg_dungeon_emily4_2",     dlg_dungeon_emily4_2_beg );
  cmn.AddSubscriber( "dlg_dungeon_emily4_2",     dlg_dungeon_emily4_2_end );
  cmn.AddSubscriber( "dlg_dungeon_emily4_2_beg", dlg_dungeon_emily4_2_beg );
  cmn.AddSubscriber( "dlg_dungeon_emily4_2_end", dlg_dungeon_emily4_2_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_13()

  int.AddScreensaver( "spr_load_screensaver_4_13" );

end;    
------------------------------------------------------------------------------------------
function private.get_screensaver_4_14()

  int.AddScreensaver( "spr_extract_screensaver_4_14" );

end; 
-----------------------------------------------------------------------
function private.get_shachihokoamulet ()

  ObjSet( "spr_ritualstone_shachihokoamulet", { alp = 1 } );
  cmn.SetEventDone( "get_shachihokoamulet" );
  cmn.CallEventHandler( "get_shachihokoamulet" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_atlantesamulet_1 ()

  cmn.SetEventDone( "get_atlantesamulet_1" );
  cmn.CallEventHandler( "get_atlantesamulet_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_chisel ()

  cmn.SetEventDone( "get_chisel" );
  cmn.CallEventHandler( "get_chisel" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_magiccube ()

  cmn.SetEventDone( "get_magiccube" );
  cmn.CallEventHandler( "get_magiccube" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_crystalsofpurity ()

  cmn.SetEventDone( "get_crystalsofpurity" );
  cmn.CallEventHandler( "get_crystalsofpurity" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_crystalofelements_2 ()

  cmn.SetEventDone( "get_crystalofelements_2" );
  cmn.CallEventHandler( "get_crystalofelements_2" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

  if ( cmn.IsEventDone( "get_crystalofelements_1" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_2" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_4" ) ) then

    interface.KeyTaskDone( true, "task_4_8" );

  end;

end;
-----------------------------------------------------------------------
function private.get_magicshield ()

  cmn.SetEventDone( "get_magicshield" );
  cmn.CallEventHandler( "get_magicshield" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_hellhoundamulet" ) and 
     cmn.IsEventDone( "get_runedice_1" ) and 
     cmn.IsEventDone( "get_stoneofsouls_4" ) and 
     cmn.IsEventDone( "get_gargoylefigurine" )then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_hellhoundamulet ()

  cmn.SetEventDone( "get_hellhoundamulet" );
  cmn.CallEventHandler( "get_hellhoundamulet" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_magicshield" ) and 
     cmn.IsEventDone( "get_runedice_1" ) and 
     cmn.IsEventDone( "get_stoneofsouls_4" ) and
     cmn.IsEventDone( "get_gargoylefigurine" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_runedice_1 ()

  cmn.SetEventDone( "get_runedice_1" );
  cmn.CallEventHandler( "get_runedice_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_magicshield" ) and 
     cmn.IsEventDone( "get_hellhoundamulet" ) and 
     cmn.IsEventDone( "get_stoneofsouls_4" ) and 
     cmn.IsEventDone( "get_gargoylefigurine" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_stoneofsouls_4 ()

  cmn.SetEventDone( "get_stoneofsouls_4" );
  cmn.CallEventHandler( "get_stoneofsouls_4" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_magicshield" ) and 
     cmn.IsEventDone( "get_hellhoundamulet" ) and 
     cmn.IsEventDone( "get_runedice_1" ) and 
     cmn.IsEventDone( "get_gargoylefigurine" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_gargoylefigurine ()

  cmn.SetEventDone( "get_gargoylefigurine" );
  cmn.CallEventHandler( "get_gargoylefigurine" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_magicshield" ) and 
     cmn.IsEventDone( "get_hellhoundamulet" ) and 
     cmn.IsEventDone( "get_runedice_1" ) and 
     cmn.IsEventDone( "get_stoneofsouls_4" ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_chisel_2 ()

  local item = "inv_chisel";

  if ( cmn.ApplyObj( item, "gzz_dungeon_ritualstone", false ) ) and
     ( not cmn.IsEventDone( "use_chisel_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualstone", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualstone_use_chisel_2", true ) ) and
         ( not cmn.IsEventDone( "use_chisel_2" ) ) then

    cmn.CallEventHandler( "use_chisel_2_inv" );
    cmn.CallEventHandler( "use_chisel_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_chisel_2" );
      cmn.CallEventHandler( "use_chisel_2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_ritualstone_chisel", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_ritualstone_unscrew_stuff_shisel" );
    AnimPlay( "anm_ritualstone_chisel", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_crystalsofpurity ()

  local item = "inv_crystalsofpurity";

  if ( cmn.ApplyObj( item, "gzz_dungeon_ritualstone", false ) ) and
     ( not cmn.IsEventDone( "use_crystalsofpurity" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ritualstone", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ritualstone_use_crystalsofpurity", true ) ) and
         ( not cmn.IsEventDone( "use_crystalsofpurity" ) ) then

    cmn.CallEventHandler( "use_crystalsofpurity_inv" );
    cmn.CallEventHandler( "use_crystalsofpurity_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_crystalsofpurity" );
      cmn.CallEventHandler( "use_crystalsofpurity_end" );
      cmn.CloseSubRoom();
      cmn.GotoRoom( "mg_mgcrystals" );

    end;

    int.Lock( true );

    ObjSet( "anm_ritualstone_crystalsofpurity", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_ritualstone_insert_stones_red" );
    AnimPlay( "anm_ritualstone_crystalsofpurity", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_hellhoundamulet ()

  local item = "inv_hellhoundamulet";

  if ( cmn.ApplyObj( item, "gzz_dungeon_load", false ) ) and
     ( not cmn.IsEventDone( "use_hellhoundamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_load", nil, { 512, 384 }, true )

    return true;

  elseif ( cmn.ApplyObj( item, "obj_load_use_hellhoundamulet", true ) ) and
         ( not cmn.IsEventDone( "use_hellhoundamulet" ) ) then

    cmn.CallEventHandler( "use_hellhoundamulet_inv" );
    cmn.CallEventHandler( "use_hellhoundamulet_beg" );

    local func_after = function ()
    
      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_hellhoundamulet" );
        cmn.CallEventHandler( "use_hellhoundamulet_end" );

      end;
      
      ObjAnimate( "obj_load_box_close", "alp", 0, 0, func_end,
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0
        
      } );
    end;  
    
    int.Lock( true );
    ObjSet( "anm_load_click_box", { alp = 0 } );
    ObjSet( "anm_load_use_hellhoundamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_load_insert_stuff_down_right_box" );
    AnimPlay( "anm_load_use_hellhoundamulet", "DoAnim", func_after ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_shachihokoamulet()

  local item = "inv_shachihokoamulet";

  if ( cmn.ApplyObj( item, "gzz_dungeon_load", false ) ) and
     ( not cmn.IsEventDone( "use_shachihokoamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_load", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_load_use_shachihokoamulet", true ) ) and
         ( not cmn.IsEventDone( "use_shachihokoamulet" ) ) then

    cmn.CallEventHandler( "use_shachihokoamulet_inv" );
    cmn.CallEventHandler( "use_shachihokoamulet_beg" );

    local func_after = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_shachihokoamulet" );
      cmn.CallEventHandler( "use_shachihokoamulet_end" );
      int_button_mini_ho.Show( "get_crystalsofpurity", "load", 4, "spr_load_emptysmoker_panel", private.mini_ho_array ); 
     
    end;  

    int.Lock( true );

    ObjSet( "anm_load_use_shachihokoamulet", { alp = 1 } );
    ObjSet( "anm_load_click_chest", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_load_insert_big_box_fish" );
    AnimPlay( "anm_load_use_shachihokoamulet", "DoAnim", func_after ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_ritualsickle_2 ()

  local item = "inv_ritualsickle";

  if ( cmn.ApplyObj( item, "gzz_dungeon_load", false ) ) and
    ( not cmn.IsEventDone( "use_ritualsickle_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_load", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_load_use_ritualsickle", true ) ) and
    ( not cmn.IsEventDone( "use_ritualsickle_2" ) ) then

    cmn.CallEventHandler( "use_ritualsickle_2_inv" );
    cmn.CallEventHandler( "use_ritualsickle_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_ritualsickle_2" );
      cmn.CallEventHandler( "use_ritualsickle_2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_load_click", { alp = 0 } );
    ObjSet( "anm_load_use_ritualsickle", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_load_cut_poach" );
    AnimPlay( "anm_load_use_ritualsickle", "DoAnim", func_end ); 
    
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_chisel_1 ()

  local item = "inv_chisel";

  if ( cmn.ApplyObj( item, "gzz_dungeon_extract", false ) ) and
     ( not cmn.IsEventDone( "use_chisel_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_extract", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_extract_use_chisel_1", true ) ) and
         ( not cmn.IsEventDone( "use_chisel_1" ) ) then

    cmn.CallEventHandler( "use_chisel_1_inv" );
    cmn.CallEventHandler( "use_chisel_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_chisel_1" );
      cmn.CallEventHandler( "use_chisel_1_end" );
      private.get_hellhoundamulet();

    end;

    int.Lock( true );

    ObjSet( "anm_extract_click_chest", { alp = 0 } );
    ObjSet( "anm_extract_use_chisel", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_extract_unscrew_stuff_chisel" );
    AnimPlay( "anm_extract_use_chisel", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_ritualsickle ()

  local item = "inv_ritualsickle";

  if ( cmn.ApplyObj( item, "gzz_dungeon_extract", false ) ) and
     ( not cmn.IsEventDone( "use_ritualsickle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_extract", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_extract_use_ritualsickle", true ) ) and
         ( not cmn.IsEventDone( "use_ritualsickle" ) ) then

    cmn.CallEventHandler( "use_ritualsickle_inv" );
    cmn.CallEventHandler( "use_ritualsickle_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_ritualsickle" );
      cmn.CallEventHandler( "use_ritualsickle_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_extract_click_bushes", { alp = 0 } );
    ObjSet( "anm_extract_use_ritualsickle", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_extract_cut_leaves" );
    AnimPlay( "anm_extract_use_ritualsickle", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_theseusfigurine ()

  local item = "inv_theseusfigurine";

  if ( cmn.ApplyObj( item, "gzz_dungeon_extract", false ) ) and
     ( not cmn.IsEventDone( "use_theseusfigurine" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_extract", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_extract_use_theseusfigurine", true ) ) and
         ( not cmn.IsEventDone( "use_theseusfigurine" ) ) then

    cmn.CallEventHandler( "use_theseusfigurine_inv" );
    cmn.CallEventHandler( "use_theseusfigurine_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_theseusfigurine" );
        cmn.CallEventHandler( "use_theseusfigurine_end" );

      end;

      ObjAnimate( "obj_extract_chest_open", "alp", 0, 0, "",
      {
        0.0, 3, 0.0,
        0.3, 3, 0.0,
        0.6, 3, 1.0,
      } );
      ObjAnimate( "obj_extract_chest_close", "alp", 0, 0, func_end1,
      {
        0.0, 3, 1.0,
        0.3, 3, 1.0,
        0.6, 3, 0.0,
      } );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_extract_insert_figure_warrior" );
    AnimPlay( "anm_extract_use_theseusfigurine", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_magicshield ()

  local item = "inv_magicshield";

  if ( cmn.ApplyObj( item, "obj_dungeon_use_magicshield", true ) ) and
         ( not cmn.IsEventDone( "use_magicshield" ) ) then

    cmn.CallEventHandler( "use_magicshield_inv" );
    cmn.CallEventHandler( "use_magicshield_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_magicshield" );
      cmn.CallEventHandler( "use_magicshield_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_dungeon_magicshield_slot_clk", { alp = 0 } );
    ObjSet( "anm_dungeon_magic_rays", { alp = 0 } );
    ObjSet( "anm_dungeon_use_shield", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_loc_dungeon_use_shield_open" );
    AnimPlay( "anm_dungeon_use_shield", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.clk_load_box_xx()
  
 local func_end = function ()

    int.Lock( false );
    
 end;
  
 int.Lock( true );
 cmn.ShowBbt( "bbt_load_use_hellhoundamulet" );
 ObjAnimate( "spr_load_box_close", "pos_x", 0, 0, func_end,
 {
      0.0, 3, 144,
      0.3, 3, 145,
      0.6, 3, 144
      
  } );
 
end;  
--------------------------------------------------------------------------------
function private.clk_load_chest_xx()
  
 local func_end = function ()

    int.Lock( false );
    
 end;
  
 int.Lock( true );
 cmn.ShowBbt( "bbt_load_use_shachihokoamulet" );
 ObjAnimate( "spr_load_chest_close", "pos_xy", 0, 0, func_end,
 {
   0.0, 3, 16,-110,
   0.3, 3, 15,-111,
   0.6, 3, 16,-110
      
  } );
 
end;
--*********************************************************************************************************************
function private.dlg_dungeon_emily4_2 ()

  local func_before_end = function ( func_end )

    cmn.CallEventHandler( "get_splinter" );
    cmn.GetObjectSfx();

    ObjSet( "anm_dungeon_emily4_2_emily_static", { alp = 0 } );
    AnimStop( "anm_dungeon_emily4_2_emily_static" );

    ObjAnimate( "anm_dungeon_emily4_2_emily_give", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    if ( func_end ) then

      func_end();

    end;

    ObjSet( "spr_dungeon_splinter", { alp = 1 } );
    ObjSet( "anm_dungeon_emily4_2_emily_splinter", { alp = 0 } );

    cmn.SetEventDone( "get_splinter" );
    cmn.SetEventDone( "dlg_dungeon_emily4_2" );
    cmn.ShowBbt( "bbt_dungeon_dlg_emily4_2" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_dungeon_emily4_2_emily_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "anm_dungeon_emily";
    common_impl.DialogCharacterStart( "emily4_2", "dungeon", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_dungeon_emily4_2_beg" );
  ObjAttach( "dlg_dungeon_emily4_2", GetCurrentRoom() );  

  ObjAnimate( "anm_dungeon_emily4_2_emily_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.dlg_dungeon_emily4_4 ()

  local func_end = function ()

    cmn.SetEventDone( "dlg_dungeon_emily4_4" );
    cmn.CallEventHandler( "dlg_dungeon_emily4_4" );

    interface.KeyTaskDone( true, "task_4_4" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_dungeon_emily4_4_emily_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "anm_dungeon_emily";
    common_impl.DialogCharacterStart( "emily4_4", "dungeon", 3, nil, nil, true, func_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_dungeon_emily4_4_beg" );
  ObjAttach( "dlg_dungeon_emily4_4", GetCurrentRoom() );  

  ObjAnimate( "anm_dungeon_emily4_4_emily_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "emily4_2" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_dungeon_emily4_2_emily_static" );
        AnimPlay( "anm_dungeon_emily4_2_emily_give", "DoAnim", "" );

      end;

      AnimPlay( "anm_dungeon_emily4_2_emily_splinter", "DoAnim", "" );

      ObjAnimate( "anm_dungeon_emily4_2_emily_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_dungeon_emily4_2_emily_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.opn_dungeon ()

  if not ( cmn.IsEventDone( "opn_dungeon" ) ) then

    cmn.SetEventDone( "opn_dungeon" );

  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_dungeon_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_dungeon_env", 1 );

  if ( cmn.IsEventDone( "win_hotable" ) ) and
     ( not cmn.IsEventDone( "dlg_dungeon_emily4_4" ) ) then

    private.dlg_dungeon_emily4_4();

  end;

  if ( cmn.IsEventDone( "win_mgcrystals" ) ) and
     ( not cmn.IsEventDone( "dlg_dungeon_emily4_2" ) ) then

    private.dlg_dungeon_emily4_2();

  end;

  if cmn.IsEventDone( "win_mgcrystals" ) then

    if not ng_global.progress["ext"]["opn_dungeon"].opn_prison then

      local func_end = function ()

        ng_global.progress["ext"]["opn_dungeon"].opn_prison = 1;
        int.Lock( false );

      end;

      int.Lock( true );
      AnimPlay( "anm_dungeon_prison_open", "DoAnim", func_end );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if cmn.IsEventDone( "win_mgcrystals" ) then

    if ng_global.progress["ext"]["opn_dungeon"].opn_prison then

      ObjSet( "anm_dungeon_prison_open", { frame = 500 } );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_dungeon();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_splinter",                                               { "dlg_dungeon_emily4_2" } );
  int.AddedTaskMap( private.room_objname, "get_shachihokoamulet",                                       { "use_chisel_2" } );
  int.AddedTaskMap( private.room_objname, "get_atlantesamulet_1" );
  int.AddedTaskMap( private.room_objname, "get_chisel" );
  int.AddedTaskMap( private.room_objname, "get_magiccube",                                              { "use_hellhoundamulet" } );
  int.AddedTaskMap( private.room_objname, "get_crystalsofpurity",                                       { "use_shachihokoamulet" } );
  int.AddedTaskMap( private.room_objname, "get_crystalofelements_2",                                    { "use_ritualsickle_2" } );
  int.AddedTaskMap( private.room_objname, "get_magicshield",                                            { "use_theseusfigurine" } );
  int.AddedTaskMap( private.room_objname, "get_hellhoundamulet",                                        { "use_chisel_1" } );
  int.AddedTaskMap( private.room_objname, "get_runedice_1" );
  int.AddedTaskMap( private.room_objname, "get_stoneofsouls_4",                                         { "use_ritualsickle" } );
  int.AddedTaskMap( private.room_objname, "get_gargoylefigurine",                                       { "use_ritualsickle" } );

  int.AddedTaskMap( private.room_objname, "use_chisel_2",                                               { "get_chisel" } );
  int.AddedTaskMap( private.room_objname, "use_crystalsofpurity",                                       { "get_crystalsofpurity" } );
  int.AddedTaskMap( private.room_objname, "use_hellhoundamulet",                                        { "get_hellhoundamulet" } );
  int.AddedTaskMap( private.room_objname, "use_shachihokoamulet",                                       { "get_shachihokoamulet" } );
  int.AddedTaskMap( private.room_objname, "use_ritualsickle_2",                                         { "get_ritualsickle" } );
  int.AddedTaskMap( private.room_objname, "use_chisel_1",                                               { "get_chisel" } );
  int.AddedTaskMap( private.room_objname, "use_ritualsickle",                                           { "get_ritualsickle" } );
  int.AddedTaskMap( private.room_objname, "use_theseusfigurine",                                        { "win_homagiccube" } );
  int.AddedTaskMap( private.room_objname, "use_magicshield",                                            { "get_magicshield" } );

  int.AddedTaskMap( private.room_objname, "win_mgcrystals",                                             { "use_crystalsofpurity" } );

  int.AddedTaskMap( private.room_objname, "opn_prison",                                                 { "dlg_dungeon_emily4_2" } );
  int.AddedTaskMap( private.room_objname, "opn_pagantemple",                                            { "use_magicshield" } );

  int.AddedTaskMap( private.room_objname, "dlg_dungeon_emily4_4" );
  int.AddedTaskMap( private.room_objname, "dlg_dungeon_emily4_2",                                       { "win_mgcrystals" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_load" );  
  -------------------------------------------------
  function zz_load.PreOpen()
    
   if cmn.IsEventDone( "use_shachihokoamulet" ) and not
      cmn.IsEventDone( "get_crystalsofpurity" ) then
      
      int_button_mini_ho.Show( "get_crystalsofpurity", "load", 4, "spr_load_emptysmoker_panel", private.mini_ho_array ); 
      
   end; 
    
  end;
  -------------------------------------------------
  function zz_load.PreClose()
    
    if cmn.IsEventDone( "use_shachihokoamulet" ) and not
       cmn.IsEventDone( "get_crystalsofpurity" ) then
       
      int_button_mini_ho.Hide(); 
      
    end;  
    
  end;
  
end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "obj_extract_lights", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.4,
    5.0, 3, 1.0,
  } );
  ObjAnimate( "spr_extract_soulstone_light_1", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.4,
    5.0, 3, 1.0,
  } );
  ObjAnimate( "spr_extract_soulstone_light_2", "alp", 1, 0, "",
  {
    0.0, 3, 0.0,
    2.4, 3, 1.0,
    4.8, 3, 0.0,
  } );

end;
--*********************************************************************************************************************
function private.InitMiniHO ()
  
  private.mini_ho_array = { 
                            "spr_load_ho_1", 
                            "spr_load_ho_2", 
                            "spr_load_ho_3", 
                            "spr_load_ho_4" 
                           
                          };

  for i = 1, #private.mini_ho_array do

    ObjSet( private.mini_ho_array[ i ], { 
                    event_mdown = function() 
                    int_button_mini_ho.MiniHoTaskFind( "get_crystalsofpurity", "load", private.mini_ho_array[ i ], 4, "" );
                                  end,
                    event_menter = function () cmn.SetCursor( CURSOR_GET );  end,
                    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end  } );

  end;
      
end;
--*********************************************************************************************************************
function private.DungeonMagicshieldSlotClk ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_dungeon_use_magicshield" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_loc_big_cell_for_big_stuff" );
  AnimPlay( "anm_dungeon_magicshield_slot_clk", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.ExtractChestClk ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_extract_use_theseusfigurine" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_extract_box" );
  if not cmn.IsEventDone( "get_hellhoundamulet" ) then

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_ritualstone_stick_stuff" );
    AnimPlay( "anm_extract_click_chest", "DoAnim", func_end ); 

  else

    AnimPlay( "anm_extract_click_box_2", "DoAnim", func_end );

  end;

end;
--*********************************************************************************************************************
function private.ExtracthBushesClk ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_extract_use_ritualsickle" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_extract_leaves" );
  AnimPlay( "anm_extract_click_bushes", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.RitualstoneClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_ritualstone_use_chisel_2" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_ritualstone_stick_stuff" );
  AnimPlay( "anm_ritualstone_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.LoadChestClk ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_load_use_shachihokoamulet" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_load_box_wood" );
  AnimPlay( "anm_load_click_chest", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.LoadBoxClk ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_load_use_hellhoundamulet" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_load_box_right" );
  AnimPlay( "anm_load_click_box", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.LoadBagClk ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_load_use_ritualsickle" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_load_pouch" );
  AnimPlay( "anm_load_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************