-- name=rm_headphysicianoffice
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_headphysicianoffice";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_stuffedanimal", "room_hub" );
  ObjAttach( "zz_table",         "room_hub" );
  ObjAttach( "zz_cabinet",       "room_hub" );
  ObjAttach( "zz_dummy",         "room_hub" );
  ObjAttach( "zz_stash",         "room_hub" );

  ObjMultiSet(
  {
    { "spr_stuffedanimal_antimagicpowder", { event_mdown = private.get_antimagicpowder } },
    { "spr_stuffedanimal_staroflife_4",    { event_mdown = private.get_staroflife_4 } },
    { "obj_stuffedanimal_use_horn",        { event_mdown = function() private.AnimalHornClk() end } },
    { "obj_stuffedanimal_use_split",       { event_mdown = function() private.AnimalStarClk() end } },    
    { "spr_table_staroflife_3",            { event_mdown = private.get_staroflife_3 } },
    { "spr_table_horn_1",                  { event_mdown = private.get_horn_1 } },
    { "spr_cabinet_split",                 { event_mdown = private.get_split } },
    { "spr_cabinet_dummyarm",              { event_mdown = private.get_dummyarm } },
    { "spr_cabinet_coatlamulet_2",         { event_mdown = private.get_coatlamulet_2 } },
    { "spr_dummy_horn_2",                  { event_mdown = private.get_horn_2 } },
    { "spr_dummy_safehandle",              { event_mdown = private.get_safehandle } },
    { "spr_dummy_harpamulet",              { event_mdown = private.get_harpamulet } },
    { "spr_stash_eyeofhorusamulet",        { event_mdown = private.get_eyeofhorusamulet } },
    { "spr_stash_tonearm",                 { event_mdown = private.get_tonearm } },
    { "obj_stash_lever_click",             { event_mdown = private.clk_safelever } },
    { "obj_stash_use_harpamulet",          { event_mdown = private.clk_safedoor_xx } },
    { "obj_table_use_deeramulet",          { event_mdown = private.TableCapClick } },
    { "obj_cabinet_use_butterflyfigurine", { event_mdown = private.CabinetCapClick } },
    { "obj_cabinet_use_syringewithoil",    { event_mdown = private.CabinetDoorClick } },
    { "obj_dummy_use_magiceye",            { event_mdown = function() private.DummyEyeClk() end } },
    { "obj_dummy_use_dummyarm",            { event_mdown = function() private.DummyHandClk() end } },
    { "obj_dummy_use_magicheart",          { event_mdown = function() private.DummyHeartClk() end } },
    { "obj_dummy_use_jaw",                 { event_mdown = function() private.DummyJawClk() end } },
    { "obj_dummy_use_coatlamulet",         { event_mdown = function() private.DummyBagClk() end } },
    { "spr_cabinet_screensaver_4_12",      { event_mdown = private.get_screensaver_4_12 } },
    { "obj_table_clk_tonearm",             { event_mdown = private.clk_tonearm } },
    { "obj_stash_use_harpamulet",          { event_mdown = private.StashDoorClick } },
    { "obj_stash_use_safedisk",            { event_mdown = function() private.StashSafeClick( "safedisk" ) end } },
    { "obj_stash_use_safehandle",          { event_mdown = function() private.StashSafeClick( "safehandle" ) end } },
  } );
  local get_screensaver_4_12 = function ()

    ObjDelete( "spr_cabinet_screensaver_4_12" );
    ObjDelete( "spr_headphysicianoffice_cabinet_puzzle" );
 
  end;
  cmn.AddSubscriber( "get_screensaver_4_12", get_screensaver_4_12, private.room_objname );  

  private.stash_init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_headphysicianoffice = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_headphysicianoffice", update_game_mode_headphysicianoffice, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_3 = function ()

    ObjDelete( "obj_headphysicianoffice_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_3", get_morphobject_4_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_antimagicpowder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_antimagicpowder" ] =
  {
    type = "get",
    get_obj = "spr_stuffedanimal_antimagicpowder",
    room = private.room_objname,
    zz = "zz_stuffedanimal",
    zz_gate = "gzz_headphysicianoffice_stuffedanimal"
  };
  --------------------------------------------------------------------------------------------
  local get_antimagicpowder_inv = function ()

    int.InventoryItemAdd( "inv_antimagicpowder", "spr_stuffedanimal_antimagicpowder" );

  end;
  local get_antimagicpowder_closezz = function ()

    ObjDelete( "gfx_stuffedanimal_antimagicpowder" );
    ObjDelete( "spr_headphysicianoffice_stuffedanimal_antimagicpowder" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_antimagicpowder", get_antimagicpowder_inv );
  cmn.AddSubscriber( "get_antimagicpowder", get_antimagicpowder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_staroflife_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_staroflife_4" ] =
  {
    type = "get",
    get_obj = "spr_stuffedanimal_staroflife_4",
    room = private.room_objname,
    zz = "zz_stuffedanimal",
    zz_gate = "gzz_headphysicianoffice_stuffedanimal"
  };
  --------------------------------------------------------------------------------------------
  local get_staroflife_4_inv = function ()

    int.InventoryItemAdd( "inv_staroflife", "spr_stuffedanimal_staroflife_4", "assets/levels/levelext/rm_morgue/zz_debris/inv/inv_staroflife_4" );
    levelext_inv.CheckStaroflife();

  end;
  local get_staroflife_4_closezz = function ()

    ObjDelete( "gfx_stuffedanimal_staroflife_4" );
    ObjDelete( "spr_headphysicianoffice_stuffedanimal_staroflife" );
    ObjSet( "spr_headphysicianoffice_stuffedanimal_jaw", { alp = 1 } );

    if ( cmn.IsEventDone( "use_horn" ) ) then

      ObjDelete( "gzz_headphysicianoffice_stuffedanimal" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_staroflife_4", get_staroflife_4_inv );
  cmn.AddSubscriber( "get_staroflife_4", get_staroflife_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_staroflife_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_staroflife_3" ] =
  {
    type = "get",
    get_obj = "spr_table_staroflife_3",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_headphysicianoffice_table"
  };
  --------------------------------------------------------------------------------------------
  local get_staroflife_3_inv = function ()

    int.InventoryItemAdd( "inv_staroflife", "spr_table_staroflife_3", "assets/levels/levelext/rm_morgue/zz_debris/inv/inv_staroflife_3" );
    levelext_inv.CheckStaroflife();

  end;
  local get_staroflife_3_closezz = function ()

    ObjDelete( "gfx_table_staroflife_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_staroflife_3", get_staroflife_3_inv );
  cmn.AddSubscriber( "get_staroflife_3", get_staroflife_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_horn_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_horn_1" ] =
  {
    type = "get",
    get_obj = "spr_table_horn_1",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_headphysicianoffice_table"
  };
  --------------------------------------------------------------------------------------------
  local get_horn_1_inv = function ()

    int.InventoryItemAdd( "inv_horn", "spr_table_horn_1", "assets/levels/levelext/rm_headphysicianoffice/zz_table/inv/inv_horn_1" );
    levelext_inv.CheckHorn( 1 );

  end;
  local get_horn_1_closezz = function ()

    ObjDelete( "gfx_table_horn_1" );
    
    ObjDelete( "spr_headphysicianoffice_table_horn_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_horn_1", get_horn_1_inv );
  cmn.AddSubscriber( "get_horn_1", get_horn_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_split () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_split" ] =
  {
    type = "get",
    get_obj = "spr_cabinet_split",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_headphysicianoffice_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_split_inv = function ()

    int.InventoryItemAdd( "inv_split", "spr_cabinet_split" );

  end;
  local get_split_closezz = function ()

    ObjDelete( "gfx_cabinet_split" );

    if ( cmn.IsEventDone( "get_split" ) ) and
       ( cmn.IsEventDone( "get_dummyarm" ) ) and
       ( cmn.IsEventDone( "get_coatlamulet_2" ) ) then

      ObjDelete( "gzz_headphysicianoffice_cabinet" );

    end;

    ObjDelete( "spr_headphysicianoffice_cabinet_split" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_split", get_split_inv );
  cmn.AddSubscriber( "get_split", get_split_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_dummyarm () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dummyarm" ] =
  {
    type = "get",
    get_obj = "spr_cabinet_dummyarm",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_headphysicianoffice_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_dummyarm_inv = function ()

    int.InventoryItemAdd( "inv_dummyarm", "spr_cabinet_dummyarm" );

  end;
  local get_dummyarm_closezz = function ()

    ObjDelete( "gfx_cabinet_dummyarm" );

    if ( cmn.IsEventDone( "get_split" ) ) and
       ( cmn.IsEventDone( "get_dummyarm" ) ) and
       ( cmn.IsEventDone( "get_coatlamulet_2" ) ) then

      ObjDelete( "gzz_headphysicianoffice_cabinet" );

    end;

    ObjDelete( "spr_headphysicianoffice_cabinet_dummyarm" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_dummyarm", get_dummyarm_inv );
  cmn.AddSubscriber( "get_dummyarm", get_dummyarm_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coatlamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coatlamulet_2" ] =
  {
    type = "get",
    get_obj = "spr_cabinet_coatlamulet_2",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_headphysicianoffice_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local get_coatlamulet_2_inv = function ()

    int.InventoryItemAdd( "inv_coatlamulet", "spr_cabinet_coatlamulet_2", "assets/levels/levelext/rm_park/zz_hospitalproperty/inv/inv_coatlamulet_2" );
    levelext_inv.CheckCoatlamulet( 2 );

  end;
  local get_coatlamulet_2_closezz = function ()

    ObjDelete( "gfx_cabinet_coatlamulet_2" );

    if ( cmn.IsEventDone( "get_split" ) ) and
       ( cmn.IsEventDone( "get_dummyarm" ) ) and
       ( cmn.IsEventDone( "get_coatlamulet_2" ) ) then

      ObjDelete( "gzz_headphysicianoffice_cabinet" );

    end;

    ObjDelete( "spr_headphysicianoffice_cabinet_coatlamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_coatlamulet_2", get_coatlamulet_2_inv );
  cmn.AddSubscriber( "get_coatlamulet_2", get_coatlamulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_horn_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_horn_2" ] =
  {
    type = "get",
    get_obj = "spr_dummy_horn_2",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_headphysicianoffice_dummy"
  };
  --------------------------------------------------------------------------------------------
  local get_horn_2_inv = function ()

    int.InventoryItemAdd( "inv_horn", "spr_dummy_horn_2", "assets/levels/levelext/rm_headphysicianoffice/zz_table/inv/inv_horn_2" );
    levelext_inv.CheckHorn( 2 );

  end;
  local get_horn_2_closezz = function ()

    ObjDelete( "gfx_dummy_horn_2" );

    if ( cmn.IsEventDone( "get_horn_2" ) ) and
       ( cmn.IsEventDone( "get_safehandle" ) ) and
       ( cmn.IsEventDone( "get_harpamulet" ) ) then

      ObjDelete( "gzz_headphysicianoffice_dummy" );

    end;

    ObjDelete( "spr_headphysicianoffice_dummy_horn" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_horn_2", get_horn_2_inv );
  cmn.AddSubscriber( "get_horn_2", get_horn_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_safehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_safehandle" ] =
  {
    type = "get",
    get_obj = "spr_dummy_safehandle",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_headphysicianoffice_dummy"
  };
  --------------------------------------------------------------------------------------------
  local get_safehandle_inv = function ()

    int.InventoryItemAdd( "inv_safehandle", "spr_dummy_safehandle" );

  end;
  local get_safehandle_closezz = function ()

    ObjDelete( "gfx_dummy_safehandle" );

    if ( cmn.IsEventDone( "get_horn_2" ) ) and
       ( cmn.IsEventDone( "get_safehandle" ) ) and
       ( cmn.IsEventDone( "get_harpamulet" ) ) then

      ObjDelete( "gzz_headphysicianoffice_dummy" );

    end;

    ObjDelete( "anm_dummy_revival" );
    ObjSet( "anm_dummy_use_eye", { alp = 1 } );
    ObjSet( "anm_dummy_give_amulet", { alp = 1 } );
    ObjSet( "anm_dummy_eye_right", { alp = 1, playing = true } );

    ObjSet( "obj_dummy_use_magiceye", { input = true } );
    ObjSet( "obj_dummy_use_magicheart", { input = true } );
    ObjSet( "obj_dummy_use_dummyarm", { input = true } );
    ObjSet( "obj_dummy_use_jaw", { input = true } );

    ObjDelete( "spr_headphysicianoffice_dummy_safehandle" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_safehandle", get_safehandle_inv );
  cmn.AddSubscriber( "get_safehandle", get_safehandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_harpamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_harpamulet" ] =
  {
    type = "get",
    get_obj = "spr_dummy_harpamulet",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_headphysicianoffice_dummy"
  };
  --------------------------------------------------------------------------------------------
  local get_harpamulet_inv = function ()

    int.InventoryItemAdd( "inv_harpamulet", "spr_dummy_harpamulet" );

  end;
  local get_harpamulet_closezz = function ()

    ObjDelete( "gfx_dummy_harpamulet" );

    if ( cmn.IsEventDone( "get_horn_2" ) ) and
       ( cmn.IsEventDone( "get_safehandle" ) ) and
       ( cmn.IsEventDone( "get_harpamulet" ) ) then

      ObjDelete( "gzz_headphysicianoffice_dummy" );

    end;

    ObjDelete( "spr_headphysicianoffice_dummy_harpamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_harpamulet", get_harpamulet_inv );
  cmn.AddSubscriber( "get_harpamulet", get_harpamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_eyeofhorusamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_eyeofhorusamulet" ] =
  {
    type = "get",
    get_obj = "spr_stash_eyeofhorusamulet",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_headphysicianoffice_stash"
  };
  --------------------------------------------------------------------------------------------
  local get_eyeofhorusamulet_inv = function ()

    int.InventoryItemAdd( "inv_eyeofhorusamulet", "spr_stash_eyeofhorusamulet" );

  end;
  local get_eyeofhorusamulet_closezz = function ()

    ObjDelete( "gfx_stash_eyeofhorusamulet" );

    ObjDelete( "spr_headphysicianoffice_stash_eyeofhorusamulet" );
    --ObjDelete( "gzz_headphysicianoffice_stash" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_eyeofhorusamulet", get_eyeofhorusamulet_inv );
  cmn.AddSubscriber( "get_eyeofhorusamulet", get_eyeofhorusamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tonearm () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tonearm" ] =
  {
    type = "get",
    get_obj = "spr_stash_tonearm",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_headphysicianoffice_stash"
  };
  --------------------------------------------------------------------------------------------
  local get_tonearm_inv = function ()

    int.InventoryItemAdd( "inv_tonearm", "spr_stash_tonearm" );

  end;
  local get_tonearm_closezz = function ()

    ObjDelete( "gfx_stash_tonearm" );
    ObjDelete( "gzz_headphysicianoffice_stash" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_tonearm", get_tonearm_inv );
  cmn.AddSubscriber( "get_tonearm", get_tonearm_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_split () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_split" ] =
  {
    type = "use",
    use_obj = "inv_split",
    use_place = "obj_stuffedanimal_use_split",
    room = private.room_objname,
    zz = "zz_stuffedanimal",
    zz_gate = "gzz_headphysicianoffice_stuffedanimal"
  };
  --------------------------------------------------------------------------------------------
  local use_split_inv = function ()

    int.InventoryItemRemove( "inv_split" );

  end;
  local use_split_beg = function ()

    ObjDelete( "obj_stuffedanimal_use_split" );
    ObjDelete( "anm_stuffedanimal_star_click" );

  end;
  local use_split_end = function ()

    ObjSet( "spr_stuffedanimal_split", { alp = 1 } );
    ObjSet( "spr_stuffedanimal_jaw", { alp = 1, pos_x = -160, pos_y = 82 } );
    ObjSet( "spr_stuffedanimal_staroflife_4", { alp = 1, pos_x = -178, pos_y = 95, input = true } );
    ObjSet( "gfx_stuffedanimal_staroflife_4", { active = true } );
    ObjDelete( "anm_stuffedanimal_use_key" );
    
    ObjSet( "spr_headphysicianoffice_stuffedanimal_split", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_split",     use_split_inv );
  cmn.AddSubscriber( "use_split",     use_split_beg, private.room_objname );
  cmn.AddSubscriber( "use_split",     use_split_end, private.room_objname );
  cmn.AddSubscriber( "use_split_inv", use_split_inv, private.room_objname );
  cmn.AddSubscriber( "use_split_beg", use_split_beg, private.room_objname );
  cmn.AddSubscriber( "use_split_end", use_split_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_horn () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_horn" ] =
  {
    type = "use",
    use_obj = "inv_horn",
    use_place = "obj_stuffedanimal_use_horn",
    room = private.room_objname,
    zz = "zz_stuffedanimal",
    zz_gate = "gzz_headphysicianoffice_stuffedanimal"
  };
  --------------------------------------------------------------------------------------------
  local use_horn_inv = function ()

    int.InventoryItemRemove( "inv_horn" );

  end;
  local use_horn_beg = function ()

    ObjDelete( "obj_stuffedanimal_use_horn" );
    ObjDelete( "anm_stuffedanimal_horn_click" );

  end;
  local use_horn_end = function ()

    if ( cmn.IsEventDone( "get_staroflife_4" ) ) then

      ObjDelete( "gzz_headphysicianoffice_stuffedanimal" );

    end;

    ObjSet( "gzz_headphysicianoffice_stash", { alp = 1, input = true, active = true } );

    ObjSet( "spr_headphysicianoffice_stuffedanimal_horn", { alp = 1 } );
    ObjDelete( "anm_headphysicianoffice_open_door" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_horn",     use_horn_inv );
  cmn.AddSubscriber( "use_horn",     use_horn_beg, private.room_objname );
  cmn.AddSubscriber( "use_horn",     use_horn_end, private.room_objname );
  cmn.AddSubscriber( "use_horn_inv", use_horn_inv, private.room_objname );
  cmn.AddSubscriber( "use_horn_beg", use_horn_beg, private.room_objname );
  cmn.AddSubscriber( "use_horn_end", use_horn_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_deeramulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_deeramulet" ] =
  {
    type = "use",
    use_obj = "inv_deeramulet",
    use_place = "obj_table_use_deeramulet",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_headphysicianoffice_table"
  };
  --------------------------------------------------------------------------------------------
  local use_deeramulet_inv = function ()

    int.InventoryItemRemove( "inv_deeramulet" );

  end;
  local use_deeramulet_beg = function ()

    ObjDelete( "obj_table_use_deeramulet" );
    ObjDelete( "anm_table_box_click" );

  end;
  local use_deeramulet_end = function ()

    ObjSet( "anm_table_box_open", { alp = 1, frame = 67, animfunc = "DoAnim" } );
    ObjSet( "spr_table_horn_1", { alp = 1, input = true } );
    ObjSet( "gfx_table_horn_1", { active = true } );
    ObjSet( "spr_table_horn_1_over", { alp = 1 } );
    ObjDelete( "spr_headphysicianoffice_table_box_cap_close" );
    ObjSet( "spr_headphysicianoffice_table_box_cap_open", { alp = 1 } );    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_deeramulet",     use_deeramulet_inv );
  cmn.AddSubscriber( "use_deeramulet",     use_deeramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_deeramulet",     use_deeramulet_end, private.room_objname );
  cmn.AddSubscriber( "use_deeramulet_inv", use_deeramulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_deeramulet_beg", use_deeramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_deeramulet_end", use_deeramulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tonearm () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tonearm" ] =
  {
    type = "use",
    use_obj = "inv_tonearm",
    use_place = "obj_table_use_tonearm",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_headphysicianoffice_table"
  };
  --------------------------------------------------------------------------------------------
  local use_tonearm_inv = function ()

    int.InventoryItemRemove( "inv_tonearm" );

  end;
  local use_tonearm_beg = function ()

    ObjDelete( "obj_table_use_tonearm" );

  end;
  local use_tonearm_end = function ()

    ObjDelete( "gzz_headphysicianoffice_table" );
    ObjSet( "gho_headphysicianoffice_hotable", { alp = 1, input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tonearm",     use_tonearm_inv );
  cmn.AddSubscriber( "use_tonearm",     use_tonearm_beg, private.room_objname );
  cmn.AddSubscriber( "use_tonearm",     use_tonearm_end, private.room_objname );
  cmn.AddSubscriber( "use_tonearm_inv", use_tonearm_inv, private.room_objname );
  cmn.AddSubscriber( "use_tonearm_beg", use_tonearm_beg, private.room_objname );
  cmn.AddSubscriber( "use_tonearm_end", use_tonearm_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_syringewithoil () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_syringewithoil" ] =
  {
    type = "use",
    use_obj = "inv_syringewithoil",
    use_place = "obj_cabinet_use_syringewithoil",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_headphysicianoffice_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_syringewithoil_inv = function ()

    int.InventoryItemRemove( "inv_syringewithoil" );

  end;
  local use_syringewithoil_beg = function ()

    ObjDelete( "obj_cabinet_use_syringewithoil" );
    ObjDelete( "anm_cabinet_door_click" );

  end;
  local use_syringewithoil_end = function ()

    ObjSet( "anm_cabinet_syringewithoil", { alp = 1, frame = 122, animfunc = "DoAnim" } );
    ObjSet( "spr_cabinet_coatlamulet_2", { input = true } );
    ObjSet( "gfx_cabinet_coatlamulet_2", { active = true } );

    ObjSet( "obj_headphysicianoffice_cabinet_1",     { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_syringewithoil",     use_syringewithoil_inv );
  cmn.AddSubscriber( "use_syringewithoil",     use_syringewithoil_beg, private.room_objname );
  cmn.AddSubscriber( "use_syringewithoil",     use_syringewithoil_end, private.room_objname );
  cmn.AddSubscriber( "use_syringewithoil_inv", use_syringewithoil_inv, private.room_objname );
  cmn.AddSubscriber( "use_syringewithoil_beg", use_syringewithoil_beg, private.room_objname );
  cmn.AddSubscriber( "use_syringewithoil_end", use_syringewithoil_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_butterflyfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_butterflyfigurine" ] =
  {
    type = "use",
    use_obj = "inv_butterflyfigurine",
    use_place = "obj_cabinet_use_butterflyfigurine",
    room = private.room_objname,
    zz = "zz_cabinet",
    zz_gate = "gzz_headphysicianoffice_cabinet"
  };
  --------------------------------------------------------------------------------------------
  local use_butterflyfigurine_inv = function ()

    int.InventoryItemRemove( "inv_butterflyfigurine" );

  end;
  local use_butterflyfigurine_beg = function ()

    ObjDelete( "obj_cabinet_use_butterflyfigurine" );
    ObjDelete( "anm_cabinet_box_click" );

  end;
  local use_butterflyfigurine_end = function ()

    ObjDelete( "anm_cabinet_butterflyfigurine" );
    ObjSet( "spr_cabinet_butterflyfigurine_shadow", { alp = 1 } );
    ObjSet( "spr_cabinet_butterflyfigurine", { alp = 1 } );
    ObjSet( "spr_cabinet_cap_open", { alp = 1 } );
    ObjSet( "spr_cabinet_dummyarm", { alp = 1, input = true } );
    ObjSet( "gfx_cabinet_dummyarm", { active = true } );

    ObjSet( "spr_headphysicianoffice_cabinet_butterflyfigurine", { alp = 1 } );
    ObjSet( "spr_headphysicianoffice_cabinet_box_open", { alp = 1 } );
    ObjSet( "spr_headphysicianoffice_cabinet_dummyarm", { alp = 1 } );
    ObjDelete( "spr_headphysicianoffice_cabinet_box_close" );

    ObjDelete( "spr_cabinet_cap_close" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_butterflyfigurine",     use_butterflyfigurine_inv );
  cmn.AddSubscriber( "use_butterflyfigurine",     use_butterflyfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_butterflyfigurine",     use_butterflyfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_butterflyfigurine_inv", use_butterflyfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_butterflyfigurine_beg", use_butterflyfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_butterflyfigurine_end", use_butterflyfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magiceye () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magiceye" ] =
  {
    type = "use",
    use_obj = "inv_magiceye",
    use_place = "obj_dummy_use_magiceye",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_headphysicianoffice_dummy"
  };
  --------------------------------------------------------------------------------------------
  local use_magiceye_inv = function ()

    int.InventoryItemRemove( "inv_magiceye" );

  end;
  local use_magiceye_beg = function ()

    ObjDelete( "obj_dummy_use_magiceye" );

  end;
  local use_magiceye_end = function ()

    if ( cmn.IsEventDone( "use_magiceye" ) ) and
       ( cmn.IsEventDone( "use_magicheart" ) ) and
       ( cmn.IsEventDone( "use_dummyarm" ) ) and
       ( cmn.IsEventDone( "use_jaw" ) ) then

      ObjSet( "spr_dummy_harpamulet", { alp = 1, input = true } );
      ObjSet( "gfx_dummy_harpamulet", { active = true } );
      ObjDelete( "anm_dummy_use_eye" );
      ObjSet( "anm_dummy_give_amulet_end", { alp = 1 } );

      ObjDelete( "spr_headphysicianoffice_dummy_hand_1" );
      ObjSet( "spr_headphysicianoffice_dummy_hand_2", { alp = 1 } );

    end;

    ObjSet( "anm_dummy_eye_static", { alp = 1, playing = true } );
    ObjDelete( "anm_dummy_use_eye" );

    ObjSet( "spr_headphysicianoffice_dummy_magiceye", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magiceye",     use_magiceye_inv );
  cmn.AddSubscriber( "use_magiceye",     use_magiceye_beg, private.room_objname );
  cmn.AddSubscriber( "use_magiceye",     use_magiceye_end, private.room_objname );
  cmn.AddSubscriber( "use_magiceye_inv", use_magiceye_inv, private.room_objname );
  cmn.AddSubscriber( "use_magiceye_beg", use_magiceye_beg, private.room_objname );
  cmn.AddSubscriber( "use_magiceye_end", use_magiceye_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_coatlamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coatlamulet" ] =
  {
    type = "use",
    use_obj = "inv_coatlamulet",
    use_place = "obj_dummy_use_coatlamulet",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_headphysicianoffice_dummy"
  };
  --------------------------------------------------------------------------------------------
  local use_coatlamulet_inv = function ()

    int.InventoryItemRemove( "inv_coatlamulet" );

  end;
  local use_coatlamulet_beg = function ()

    ObjDelete( "obj_dummy_use_coatlamulet" );

  end;
  local use_coatlamulet_end = function ()

    ObjSet( "obj_dummy_bag_open", { alp = 1, input = true } );
    ObjDelete( "obj_dummy_bag_close" );
    ObjSet( "gfx_dummy_horn_2", { active = true } );

    ObjDelete( "spr_headphysicianoffice_dummy_close_bag" );
    ObjSet( "spr_headphysicianoffice_dummy_horn", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coatlamulet",     use_coatlamulet_inv );
  cmn.AddSubscriber( "use_coatlamulet",     use_coatlamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_coatlamulet",     use_coatlamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_coatlamulet_inv", use_coatlamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_coatlamulet_beg", use_coatlamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_coatlamulet_end", use_coatlamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magicheart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magicheart" ] =
  {
    type = "use",
    use_obj = "inv_magicheart",
    use_place = "obj_dummy_use_magicheart",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_headphysicianoffice_dummy"
  };
  --------------------------------------------------------------------------------------------
  local use_magicheart_inv = function ()

    int.InventoryItemRemove( "inv_magicheart" );

  end;
  local use_magicheart_beg = function ()

    ObjDelete( "obj_dummy_use_magicheart" );

  end;
  local use_magicheart_end = function ()

    if ( cmn.IsEventDone( "use_magiceye" ) ) and
       ( cmn.IsEventDone( "use_magicheart" ) ) and
       ( cmn.IsEventDone( "use_dummyarm" ) ) and
       ( cmn.IsEventDone( "use_jaw" ) ) then

      ObjSet( "spr_dummy_harpamulet", { alp = 1, input = true } );
      ObjSet( "gfx_dummy_harpamulet", { active = true } );
      ObjDelete( "anm_dummy_use_eye" );
      ObjSet( "anm_dummy_give_amulet_end", { alp = 1 } );

      ObjDelete( "spr_headphysicianoffice_dummy_hand_1" );
      ObjSet( "spr_headphysicianoffice_dummy_hand_2", { alp = 1 } );

    end;

    ObjSet( "anm_dummy_heart_static", { alp = 1, playing = true } );
    ObjDelete( "anm_dummy_use_heart" );

    ObjSet( "spr_headphysicianoffice_dummy_magicheart", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magicheart",     use_magicheart_inv );
  cmn.AddSubscriber( "use_magicheart",     use_magicheart_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicheart",     use_magicheart_end, private.room_objname );
  cmn.AddSubscriber( "use_magicheart_inv", use_magicheart_inv, private.room_objname );
  cmn.AddSubscriber( "use_magicheart_beg", use_magicheart_beg, private.room_objname );
  cmn.AddSubscriber( "use_magicheart_end", use_magicheart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_dummyarm () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_dummyarm" ] =
  {
    type = "use",
    use_obj = "inv_dummyarm",
    use_place = "obj_dummy_use_dummyarm",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_headphysicianoffice_dummy"
  };
  --------------------------------------------------------------------------------------------
  local use_dummyarm_inv = function ()

    int.InventoryItemRemove( "inv_dummyarm" );

  end;
  local use_dummyarm_beg = function ()

    ObjDelete( "obj_dummy_use_dummyarm" );

  end;
  local use_dummyarm_end = function ()

    if ( cmn.IsEventDone( "use_magiceye" ) ) and
       ( cmn.IsEventDone( "use_magicheart" ) ) and
       ( cmn.IsEventDone( "use_dummyarm" ) ) and
       ( cmn.IsEventDone( "use_jaw" ) ) then

      ObjSet( "spr_dummy_harpamulet", { alp = 1, input = true } );
      ObjSet( "gfx_dummy_harpamulet", { active = true } );
      ObjDelete( "anm_dummy_use_eye" );
      ObjSet( "anm_dummy_give_amulet_end", { alp = 1 } );

      ObjDelete( "spr_headphysicianoffice_dummy_hand_1" );
      ObjSet( "spr_headphysicianoffice_dummy_hand_2", { alp = 1 } );

    end;

    ObjSet( "spr_headphysicianoffice_dummy_dummyarm", { alp = 1 } );

    ObjSet( "anm_dummy_use_hand_end", { alp = 1 } );
    ObjDelete( "anm_dummy_use_hand" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_dummyarm",     use_dummyarm_inv );
  cmn.AddSubscriber( "use_dummyarm",     use_dummyarm_beg, private.room_objname );
  cmn.AddSubscriber( "use_dummyarm",     use_dummyarm_end, private.room_objname );
  cmn.AddSubscriber( "use_dummyarm_inv", use_dummyarm_inv, private.room_objname );
  cmn.AddSubscriber( "use_dummyarm_beg", use_dummyarm_beg, private.room_objname );
  cmn.AddSubscriber( "use_dummyarm_end", use_dummyarm_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_jaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jaw" ] =
  {
    type = "use",
    use_obj = "inv_jaw",
    use_place = "obj_dummy_use_jaw",
    room = private.room_objname,
    zz = "zz_dummy",
    zz_gate = "gzz_headphysicianoffice_dummy"
  };
  --------------------------------------------------------------------------------------------
  local use_jaw_inv = function ()

    int.InventoryItemRemove( "inv_jaw" );

  end;
  local use_jaw_beg = function ()

    ObjDelete( "obj_dummy_use_jaw" );

  end;
  local use_jaw_end = function ()

    if ( cmn.IsEventDone( "use_magiceye" ) ) and
       ( cmn.IsEventDone( "use_magicheart" ) ) and
       ( cmn.IsEventDone( "use_dummyarm" ) ) and
       ( cmn.IsEventDone( "use_jaw" ) ) then

      ObjSet( "spr_dummy_harpamulet", { alp = 1, input = true } );
      ObjSet( "gfx_dummy_harpamulet", { active = true } );
      ObjDelete( "anm_dummy_use_eye" );
      ObjSet( "anm_dummy_give_amulet_end", { alp = 1 } );

      ObjDelete( "spr_headphysicianoffice_dummy_hand_1" );
      ObjSet( "spr_headphysicianoffice_dummy_hand_2", { alp = 1 } );

    end;

    ObjSet( "anm_dummy_use_jaw", { alp = 1, frame = 500 } );

    ObjSet( "spr_headphysicianoffice_dummy_jaw", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jaw",     use_jaw_inv );
  cmn.AddSubscriber( "use_jaw",     use_jaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_jaw",     use_jaw_end, private.room_objname );
  cmn.AddSubscriber( "use_jaw_inv", use_jaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_jaw_beg", use_jaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_jaw_end", use_jaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_safedisk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_safedisk" ] =
  {
    type = "use",
    use_obj = "inv_safedisk",
    use_place = "obj_stash_use_safedisk",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_headphysicianoffice_stash"
  };
  --------------------------------------------------------------------------------------------
  local use_safedisk_inv = function ()

    int.InventoryItemRemove( "inv_safedisk" );

  end;
  local use_safedisk_beg = function ()

    ObjDelete( "obj_stash_use_safedisk" );
    ObjSet( "obj_stash_handle", { alp = 1 } );

  end;
  local use_safedisk_end = function ()
  
    ObjSet( "anm_stash_handle", { alp = 1, frame = 55, animfunc = "DoAnim" } );
    
    if cmn.IsEventDone( "use_safehandle") then
      
      ObjSet( "obj_stash_disk", { input = true } );
     
    end; 

    ObjSet( "spr_headphysicianoffice_stash_safedisk", { alp = 1 } );   

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_safedisk",     use_safedisk_inv );
  cmn.AddSubscriber( "use_safedisk",     use_safedisk_beg, private.room_objname );
  cmn.AddSubscriber( "use_safedisk",     use_safedisk_end, private.room_objname );
  cmn.AddSubscriber( "use_safedisk_inv", use_safedisk_inv, private.room_objname );
  cmn.AddSubscriber( "use_safedisk_beg", use_safedisk_beg, private.room_objname );
  cmn.AddSubscriber( "use_safedisk_end", use_safedisk_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_safehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_safehandle" ] =
  {
    type = "use",
    use_obj = "inv_safehandle",
    use_place = "obj_stash_use_safehandle",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_headphysicianoffice_stash"
  };
  --------------------------------------------------------------------------------------------
  local use_safehandle_inv = function ()

    int.InventoryItemRemove( "inv_safehandle" );

  end;
  local use_safehandle_beg = function ()
  
   ObjDelete( "obj_stash_use_safehandle" );

  end;
  local use_safehandle_end = function ()
    
   ObjSet( "anm_stash_lever", { alp = 1, frame = 49, animfunc = "DoAnim" } );
   ObjSet( "spr_headphysicianoffice_stash_safehandle", { alp = 1 } );

   if cmn.IsEventDone( "use_safedisk") then
     
     ObjSet( "obj_stash_disk", { input = true });
     
   end;  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_safehandle",     use_safehandle_inv );
  cmn.AddSubscriber( "use_safehandle",     use_safehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_safehandle",     use_safehandle_end, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_inv", use_safehandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_beg", use_safehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_safehandle_end", use_safehandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_harpamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_harpamulet" ] =
  {
    type = "use",
    use_obj = "inv_harpamulet",
    use_place = "obj_stash_use_harpamulet",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_headphysicianoffice_stash"
  };
  --------------------------------------------------------------------------------------------
  local use_harpamulet_inv = function ()

    int.InventoryItemRemove( "inv_harpamulet" );

  end;

  local use_harpamulet_beg = function ()

    ObjDelete( "obj_stash_use_harpamulet" );
    ObjDelete( "anm_stash_seconddoor_click" );

  end;
  local use_harpamulet_end = function ()
  
    ObjSet( "spr_stash_tonearm", { input = true });
    ObjSet( "gfx_stash_tonearm", { active = true });
    ObjSet( "anm_stash_seconddoor_open", { alp = 1, frame = 67, animfunc = "DoAnim" } );

    ObjDelete( "obj_headphysicianoffice_stash_close_2");
    ObjSet( "obj_headphysicianoffice_stash_open_2",  { alp = 1 });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_harpamulet",     use_harpamulet_inv );
  cmn.AddSubscriber( "use_harpamulet",     use_harpamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_harpamulet",     use_harpamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_harpamulet_inv", use_harpamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_harpamulet_beg", use_harpamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_harpamulet_end", use_harpamulet_end, private.room_objname );
 
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function clk_safelever () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_safelever" ] =
  {
    type = "click",
    clk_obj = "obj_stash_lever_click",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_headphysicianoffice_stash"
  };
  -----------------------------------------------
  local clk_safelever_inv = function ()

  end;
  local clk_safelever_beg = function ()

    ObjDelete( "obj_stash_lever_click" );
    ObjDelete( "obj_stash_firstdoor_mmg" );

  end;
  local clk_safelever_end = function ()

    ObjSet( "anm_stash_firstdoor_open", { alp = 1, frame = 266, animfunc = "DoAnim" } );
    ObjSet( "spr_stash_eyeofhorusamulet", { input = true });
    ObjSet( "gfx_stash_eyeofhorusamulet", { active = true });
    ObjSet( "obj_stash_use_harpamulet",   { input = true });

    ObjDelete( "obj_headphysicianoffice_stash_close_1" );
    ObjSet( "obj_headphysicianoffice_stash_open_1", { alp = 1 } );
  
  end;
 
  -----------------------------------------------
  cmn.AddSubscriber( "clk_safelever",     clk_safelever_inv );
  cmn.AddSubscriber( "clk_safelever",     clk_safelever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safelever",     clk_safelever_end, private.room_objname );
  cmn.AddSubscriber( "clk_safelever_inv", clk_safelever_inv, private.room_objname );
  cmn.AddSubscriber( "clk_safelever_beg", clk_safelever_beg, private.room_objname );
  cmn.AddSubscriber( "clk_safelever_end", clk_safelever_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_tonearm () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tonearm" ] =
  {
    type = "click",
    clk_obj = "obj_table_clk_tonearm",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_headphysicianoffice_table"
  };
  -----------------------------------------------
  local clk_tonearm_inv = function ()

  end;
  local clk_tonearm_beg = function ()

    ObjDelete( "obj_table_clk_tonearm" );
    
  end;
  local clk_tonearm_end = function ()

    ObjSet( "obj_table_use_tonearm", { input = true });
    ObjDelete( "anm_table_tonearm_old" );
  
  end;
  -----------------------------------------------
  cmn.AddSubscriber( "clk_tonearm",     clk_tonearm_inv );
  cmn.AddSubscriber( "clk_tonearm",     clk_tonearm_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tonearm",     clk_tonearm_end, private.room_objname );
  cmn.AddSubscriber( "clk_tonearm_inv", clk_tonearm_inv, private.room_objname );
  cmn.AddSubscriber( "clk_tonearm_beg", clk_tonearm_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tonearm_end", clk_tonearm_end, private.room_objname );
  --------------------------------------------------------------------------------------
  --function win_stash () end;
  ------------------------------------------------------------------------------------------
  common_impl.hint[ "win_stash" ] =
  {
    type = "click",
    clk_obj = "spr_stash_handle",
    room = private.room_objname,
    zz = "zz_stash",
    zz_gate = "gzz_headphysicianoffice_stash"
  };
  --*********************************************************************************************************************
  local win_stash_inv = function ()

  end;
  --*********************************************************************************************************************
  local win_stash = function ()

    if ( cmn.IsEventDone( "win_stash" ) ) then

       for i = 1, 5  do
          
         ObjSet( "txt_stash_numeral_"..i, { text = tostring(private.stash_win[i]) } );
         ObjSet( "spr_stash_light_"..i.."_right", { alp = 1 } );  
          
       end;
       ObjSet( "obj_stash_lever_click", { input = true });
       ObjSet( "obj_stash_disk", { input = false });
       ObjSet( "spr_stash_handle", { ang = -5.55 } );

    else

       private.stash_load();

    end;
    
  end;
  -----------------------------------------------------------------------
  cmn.AddSubscriber( "win_stash", win_stash_inv );
  cmn.AddSubscriber( "win_stash", win_stash, private.room_objname );
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_12()

  int.AddScreensaver( "spr_cabinet_screensaver_4_12" );

end;  
-----------------------------------------------------------------------
function private.get_antimagicpowder ()

  cmn.SetEventDone( "get_antimagicpowder" );
  cmn.CallEventHandler( "get_antimagicpowder" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_staroflife_4 ()

  cmn.SetEventDone( "get_staroflife_4" );
  cmn.CallEventHandler( "get_staroflife_4" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "use_horn" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_staroflife_3 ()

  cmn.SetEventDone( "get_staroflife_3" );
  cmn.CallEventHandler( "get_staroflife_3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_horn_1 ()

  cmn.SetEventDone( "get_horn_1" );
  cmn.CallEventHandler( "get_horn_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_split ()

  cmn.SetEventDone( "get_split" );
  cmn.CallEventHandler( "get_split" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_split" ) ) and
     ( cmn.IsEventDone( "get_dummyarm" ) ) and
     ( cmn.IsEventDone( "get_coatlamulet_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_dummyarm ()

  cmn.SetEventDone( "get_dummyarm" );
  cmn.CallEventHandler( "get_dummyarm" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_split" ) ) and
     ( cmn.IsEventDone( "get_dummyarm" ) ) and
     ( cmn.IsEventDone( "get_coatlamulet_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_coatlamulet_2 ()

  cmn.SetEventDone( "get_coatlamulet_2" );
  cmn.CallEventHandler( "get_coatlamulet_2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_split" ) ) and
     ( cmn.IsEventDone( "get_dummyarm" ) ) and
     ( cmn.IsEventDone( "get_coatlamulet_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_horn_2 ()

  cmn.SetEventDone( "get_horn_2" );
  cmn.CallEventHandler( "get_horn_2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_horn_2" ) ) and
     ( cmn.IsEventDone( "get_safehandle" ) ) and
     ( cmn.IsEventDone( "get_harpamulet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_safehandle ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_headphysicianoffice_dummy" );

    cmn.CallEventHandler( "get_safehandle" );
    cmn.GetObjectSfx();
    cmn.SetEventDone( "get_safehandle" );

    if ( cmn.IsEventDone( "get_horn_2" ) ) and
       ( cmn.IsEventDone( "get_safehandle" ) ) and
       ( cmn.IsEventDone( "get_harpamulet" ) ) then

      cmn.CloseSubRoom();

    end;

    ObjSet( "anm_dummy_show_jaw", { alp = 0 } );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_click_dummy_shows_all" );
  AnimPlay( "anm_dummy_revival", "DoAnim", function ()

    ObjSet( "anm_dummy_revival", { alp = 0 } );
    ObjSet( "anm_dummy_show_eye", { alp = 1 } );
    AnimPlay( "anm_dummy_show_eye", "DoAnim", function () 

      ObjSet( "anm_dummy_show_eye", { alp = 0 } );
      ObjSet( "anm_dummy_use_eye", { alp = 1 } );
      ObjSet( "anm_dummy_show_hand", { alp = 1 } );
      AnimPlay( "anm_dummy_show_hand", "DoAnim", function () 

        ObjSet( "anm_dummy_show_hand", { alp = 0 } );
        ObjSet( "anm_dummy_show_heart", { alp = 1 } );
        AnimPlay( "anm_dummy_show_heart", "DoAnim", function () 

          ObjSet( "anm_dummy_show_heart", { alp = 0 } );
          ObjSet( "anm_dummy_show_jaw", { alp = 1 } );
          AnimPlay( "anm_dummy_show_jaw", "DoAnim", func_end );

        end ); 

      end ); 

    end );

  end ); 

end;
-----------------------------------------------------------------------
function private.get_harpamulet ()

  cmn.SetEventDone( "get_harpamulet" );
  cmn.CallEventHandler( "get_harpamulet" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_horn_2" ) ) and
     ( cmn.IsEventDone( "get_safehandle" ) ) and
     ( cmn.IsEventDone( "get_harpamulet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_eyeofhorusamulet ()

  cmn.SetEventDone( "get_eyeofhorusamulet" );
  cmn.CallEventHandler( "get_eyeofhorusamulet" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_tonearm ()

  cmn.SetEventDone( "get_tonearm" );
  cmn.CallEventHandler( "get_tonearm" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_split ()

  local item = "inv_split";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_stuffedanimal", false ) ) and
     ( not cmn.IsEventDone( "use_split" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stuffedanimal", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stuffedanimal_use_split", true ) ) and
         ( not cmn.IsEventDone( "use_split" ) ) then

    cmn.CallEventHandler( "use_split_inv" );
    cmn.CallEventHandler( "use_split_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_split" );
      cmn.CallEventHandler( "use_split_end" );
      --private.get_staroflife_4();

    end;

    int.Lock( true );

    --ObjSet( "spr_stuffedanimal_split", { alp = 1 } );
    
    --ObjAnimate( "spr_stuffedanimal_jaw", "pos_y", 0, 0, "", 
    --{
    --  0.0, 0, 58,
    --  0.3, 0, 78,
    --} );
    --ObjAnimate( "spr_stuffedanimal_staroflife_4", "pos_y", 0, 0, func_end, 
    --{
    --  0.0, 0, 78,
    --  0.3, 0, 98,
    --} );  
    ObjSet( "anm_stuffedanimal_use_key", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_stuffedanimal_insert_key_deer" );
    AnimPlay( "anm_stuffedanimal_use_key", "DoAnim", func_end );  
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_horn ()

  local item = "inv_horn";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_stuffedanimal", false ) ) and
     ( cmn.IsEventDone( "get_horn_1" ) ) and
     ( cmn.IsEventDone( "get_horn_2" ) ) and
     ( not cmn.IsEventDone( "use_horn" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stuffedanimal", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stuffedanimal_use_horn", true ) ) and
         ( cmn.IsEventDone( "get_horn_1" ) ) and
         ( cmn.IsEventDone( "get_horn_2" ) ) and
         ( not cmn.IsEventDone( "use_horn" ) ) then

    cmn.CallEventHandler( "use_horn_inv" );
    cmn.CallEventHandler( "use_horn_beg" );

    local func_end = function ()

      cmn.CloseSubRoom( true );
      private.is_use_horn = true;

    end;

    int.Lock( true );

    ObjSet( "anm_stuffedanimal_use_horn", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_stuffedanimal_insert_horns" );
    AnimPlay( "anm_stuffedanimal_use_horn", "DoAnim", func_end );
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_deeramulet ()

  local item = "inv_deeramulet";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_table", false ) ) and
     ( not cmn.IsEventDone( "use_deeramulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_table", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_table_use_deeramulet", true ) ) and
         ( not cmn.IsEventDone( "use_deeramulet" ) ) then

    cmn.CallEventHandler( "use_deeramulet_inv" );
    cmn.CallEventHandler( "use_deeramulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_deeramulet" );
      cmn.CallEventHandler( "use_deeramulet_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_table_insert_stuff_deer" );
    ObjSet( "anm_table_box_open", { alp = 1 } );
    AnimPlay( "anm_table_box_open", "DoAnim", func_end );

    ObjAnimate( "spr_table_horn_1", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.8, 3, 0.0,
      1.0, 3, 1.0,
    } );

    ObjAnimate( "spr_table_horn_1_over", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.8, 3, 0.0,
      0.8, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_tonearm ()

  local item = "inv_tonearm";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_table", false ) ) and
     ( cmn.IsEventDone( "clk_tonearm" ) ) and
     ( not cmn.IsEventDone( "use_tonearm" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_table", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_table_use_tonearm", true ) ) and
         ( cmn.IsEventDone( "clk_tonearm" ) ) and
         ( not cmn.IsEventDone( "use_tonearm" ) ) then

    cmn.CallEventHandler( "use_tonearm_inv" );
    cmn.CallEventHandler( "use_tonearm_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_tonearm" );
      cmn.CallEventHandler( "use_tonearm_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_table_insert_gramophone" );
    ObjSet( "anm_table_tonearm_new", { alp = 1 } );
    AnimPlay( "anm_table_tonearm_new", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_syringewithoil ()

  local item = "inv_syringewithoil";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_cabinet", false ) ) and
     ( not cmn.IsEventDone( "use_syringewithoil" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cabinet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_syringewithoil", true ) ) and
         ( not cmn.IsEventDone( "use_syringewithoil" ) ) then

    cmn.CallEventHandler( "use_syringewithoil_inv" );
    cmn.CallEventHandler( "use_syringewithoil_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_syringewithoil" );
      cmn.CallEventHandler( "use_syringewithoil_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cabinet_fill_syringe" );
    ObjSet( "anm_cabinet_syringewithoil", { alp = 1 } );
    AnimPlay( "anm_cabinet_syringewithoil", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_butterflyfigurine ()

  local item = "inv_butterflyfigurine";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_cabinet", false ) ) and
     ( not cmn.IsEventDone( "use_butterflyfigurine" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cabinet" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cabinet_use_butterflyfigurine", true ) ) and
         ( not cmn.IsEventDone( "use_butterflyfigurine" ) ) then

    cmn.CallEventHandler( "use_butterflyfigurine_inv" );
    cmn.CallEventHandler( "use_butterflyfigurine_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_butterflyfigurine" );
      cmn.CallEventHandler( "use_butterflyfigurine_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_cabinet_butterflyfigurine", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cabinet_insert_butterfly" );
    AnimPlay( "anm_cabinet_butterflyfigurine", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_magiceye ()

  local item = "inv_magiceye";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_dummy", false ) ) and
     ( not cmn.IsEventDone( "use_magiceye" ) ) and 
       cmn.IsEventDone( "get_safehandle" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dummy", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dummy_use_magiceye", true ) ) and
         ( not cmn.IsEventDone( "use_magiceye" ) ) and 
           cmn.IsEventDone( "get_safehandle" ) then

    cmn.CallEventHandler( "use_magiceye_inv" );
    cmn.CallEventHandler( "use_magiceye_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_magiceye" );
        cmn.CallEventHandler( "use_magiceye_end" );

      end;

      if ( cmn.IsEventDone( "use_magicheart" ) ) and
         ( cmn.IsEventDone( "use_dummyarm" ) ) and
         ( cmn.IsEventDone( "use_jaw" ) ) then

        private.use_magiceye_magicheart_dummyarm_jaw_end( func_end1 );

      else

        func_end1();

      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_insert_eye" );
    AnimPlay( "anm_dummy_use_eye", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.use_magiceye_magicheart_dummyarm_jaw_end ( func_end )

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_takes_stugg" );
  AnimPlay( "anm_dummy_give_amulet", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function public.use_coatlamulet ()

  local item = "inv_coatlamulet";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_dummy", false ) ) and
     ( not cmn.IsEventDone( "use_coatlamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dummy", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dummy_use_coatlamulet", true ) ) and
         ( not cmn.IsEventDone( "use_coatlamulet" ) ) then

    cmn.CallEventHandler( "use_coatlamulet_inv" );
    cmn.CallEventHandler( "use_coatlamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_coatlamulet" );
      cmn.CallEventHandler( "use_coatlamulet_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_dummy_bag_click", { alp = 0 } );
    ObjSet( "anm_dummy_use_coatlamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_insert_jeton_jacket" );
    AnimPlay( "anm_dummy_use_coatlamulet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_magicheart ()

  local item = "inv_magicheart";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_dummy", false ) ) and
     ( not cmn.IsEventDone( "use_magicheart" ) ) and 
       cmn.IsEventDone( "get_safehandle" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dummy", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dummy_use_magicheart", true ) ) and
         ( not cmn.IsEventDone( "use_magicheart" ) ) and 
           cmn.IsEventDone( "get_safehandle" ) then

    cmn.CallEventHandler( "use_magicheart_inv" );
    cmn.CallEventHandler( "use_magicheart_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_magicheart" );
        cmn.CallEventHandler( "use_magicheart_end" );

      end;

      if ( cmn.IsEventDone( "use_magiceye" ) ) and
         ( cmn.IsEventDone( "use_dummyarm" ) ) and
         ( cmn.IsEventDone( "use_jaw" ) ) then

        private.use_magiceye_magicheart_dummyarm_jaw_end( func_end1 );

      else

        func_end1();

      end;

    end;

    int.Lock( true );

    ObjSet( "anm_dummy_use_heart", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_insert_heart" );
    AnimPlay( "anm_dummy_use_heart", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_dummyarm ()

  local item = "inv_dummyarm";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_dummy", false ) ) and
     ( not cmn.IsEventDone( "use_dummyarm" ) ) and 
       cmn.IsEventDone( "get_safehandle" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dummy", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dummy_use_dummyarm", true ) ) and
         ( not cmn.IsEventDone( "use_dummyarm" ) ) and 
           cmn.IsEventDone( "get_safehandle" ) then

    cmn.CallEventHandler( "use_dummyarm_inv" );
    cmn.CallEventHandler( "use_dummyarm_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_dummyarm" );
        cmn.CallEventHandler( "use_dummyarm_end" );

      end;

      if ( cmn.IsEventDone( "use_magicheart" ) ) and
         ( cmn.IsEventDone( "use_magiceye" ) ) and
         ( cmn.IsEventDone( "use_jaw" ) ) then

        private.use_magiceye_magicheart_dummyarm_jaw_end( func_end1 );

      else

        func_end1();

      end;

    end;

    int.Lock( true );

    ObjSet( "anm_dummy_use_hand", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_insert_hand" );
    AnimPlay( "anm_dummy_use_hand", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_jaw ()

  local item = "inv_jaw";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_dummy", false ) ) and
     ( not cmn.IsEventDone( "use_jaw" ) ) and 
       cmn.IsEventDone( "get_safehandle" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dummy", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_dummy_use_jaw", true ) ) and
         ( not cmn.IsEventDone( "use_jaw" ) ) and 
           cmn.IsEventDone( "get_safehandle" ) then

    cmn.CallEventHandler( "use_jaw_inv" );
    cmn.CallEventHandler( "use_jaw_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_jaw" );
        cmn.CallEventHandler( "use_jaw_end" );

      end;

      if ( cmn.IsEventDone( "use_magicheart" ) ) and
         ( cmn.IsEventDone( "use_dummyarm" ) ) and
         ( cmn.IsEventDone( "use_magiceye" ) ) then

        private.use_magiceye_magicheart_dummyarm_jaw_end( func_end1 );

      else

        func_end1();

      end;


    end;

    int.Lock( true );

    ObjSet( "anm_dummy_use_jaw", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_insert_moth" );
    AnimPlay( "anm_dummy_use_jaw", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_safedisk()

  local item = "inv_safedisk";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_stash", false ) ) and
     ( cmn.IsEventDone( "use_horn" ) ) and
     ( not cmn.IsEventDone( "use_safedisk" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stash",nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stash_use_safedisk", true ) ) and
         ( not cmn.IsEventDone( "use_safedisk" ) ) then

    cmn.CallEventHandler( "use_safedisk_inv" );
    cmn.CallEventHandler( "use_safedisk_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_safedisk" );
      cmn.CallEventHandler( "use_safedisk_end" );
      if cmn.IsEventDone( "use_safehandle") then
        
        private.stash_start_init();
        
      end; 

    end;

    int.Lock( true );

    ObjSet( "anm_stash_handle", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_stash_insert_right" );
    AnimPlay( "anm_stash_handle", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_safehandle()

  local item = "inv_safehandle";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_stash", false ) ) and
     ( cmn.IsEventDone( "use_horn" ) ) and
     ( not cmn.IsEventDone( "use_safehandle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stash",nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stash_use_safehandle", true ) ) and
         ( not cmn.IsEventDone( "use_safehandle" ) ) then

    cmn.CallEventHandler( "use_safehandle_inv" );
    cmn.CallEventHandler( "use_safehandle_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_safehandle" );
      cmn.CallEventHandler( "use_safehandle_end" );
      if cmn.IsEventDone( "use_safedisk") then
        
        private.stash_start_init();
        
      end;  

    end;

    int.Lock( true );

    ObjSet( "anm_stash_lever", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_stash_insert_handle" );
    AnimPlay( "anm_stash_lever", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_harpamulet()

  local item = "inv_harpamulet";

  if ( cmn.ApplyObj( item, "gzz_headphysicianoffice_stash", false ) ) and
     ( cmn.IsEventDone( "use_horn" ) ) and
     ( not cmn.IsEventDone( "use_harpamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_stash",nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_stash_use_harpamulet", true ) and cmn.IsEventDone( "win_stash")) and
         ( not cmn.IsEventDone( "use_harpamulet" ) ) then

    cmn.CallEventHandler( "use_harpamulet_inv" );
    cmn.CallEventHandler( "use_harpamulet_beg" );

    local func_end = function ()
    
      int.Lock( false );
      cmn.SetEventDone( "use_harpamulet" );
      cmn.CallEventHandler( "use_harpamulet_end" );
        
    end;  
      
    int.Lock( true );
    ObjSet( "anm_stash_seconddoor_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_stash_insert_hidden_cell_stuff" );
    AnimPlay( "anm_stash_seconddoor_open", "DoAnim", func_end );

   return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.clk_safelever()

  cmn.CallEventHandler( "clk_safelever_inv" );
  cmn.CallEventHandler( "clk_safelever_beg" );

  local func_end = function ()
  
    int.Lock( false );
    cmn.SetEventDone( "clk_safelever" );
    cmn.CallEventHandler( "clk_safelever_end" );

  end;

  int.Lock( true );

  ObjSet( "anm_stash_firstdoor_open", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mmg_zz_stash_click_handle" );
  AnimPlay( "anm_stash_firstdoor_open", "DoAnim", func_end );

end;
--************************************************
function private.clk_safedoor_xx() 
  
  local func_after = function ()

    cmn.ShowBbt( "bbt_stash_use_harpamulet" );
    int.Lock( false );
  
  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_stash_xx_hidden_cell" );
  ObjAnimate( "spr_stash_secondoor_close", "scale_xy", 0, 0, func_after,
  {
      0.0, 1, 1,1,
      0.3, 1, 1.01, 1.01,
      0.6, 1, 1,1
  } );
  
end; 
--------------------------------------------------------------------------------------------
function private.clk_tonearm ()

  cmn.CallEventHandler( "clk_tonearm_inv" );
  cmn.CallEventHandler( "clk_tonearm_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "clk_tonearm" );
    cmn.CallEventHandler( "clk_tonearm_end" );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_table_off_gramophone" );
  AnimPlay( "anm_table_tonearm_old", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_headphysicianoffice ()

  if not ( cmn.IsEventDone( "opn_headphysicianoffice" ) ) then

    cmn.SetEventDone( "opn_headphysicianoffice" );

  end;
  
  if ( cmn.IsEventDone( "use_purifyingsphere" ) and 
    not ng_global.progress[ ng_global.currentprogress ][ "opn_headphysicianoffice" ].cultist ) then

    local func_end = function ()

      cmn.ShowBbt( "bbt_headphysicianoffice_cultist" );
      ng_global.progress[ ng_global.currentprogress ][ "opn_headphysicianoffice" ].cultist = true;
      ObjDelete( "anm_headphysicianoffice_cultist" );
      int.Lock( false );

    end;

    int.Lock( true );
    ObjSet( "anm_headphysicianoffice_cultist", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_loc_people_dissapears_window" );
    AnimPlay( "anm_headphysicianoffice_cultist", "DoAnim", func_end );
    --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_assault_win" );

  elseif ng_global.progress[ ng_global.currentprogress ][ "opn_headphysicianoffice" ].cultist then

    ObjDelete( "anm_headphysicianoffice_cultist" );

  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_headphysicanoffice_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_headphysicanoffice_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--************************************************************************************************
function public.PreOpen ()

  if ( cmn.IsEventDone( "use_purifyingsphere" ) and 
    not ng_global.progress[ ng_global.currentprogress ][ "opn_headphysicianoffice" ].cultist ) then

    ObjSet( "anm_headphysicianoffice_cultist", { alp = 1 } );
    
  end;

  if ( cmn.IsEventDone( "win_hotable" ) and 
       not ng_global.progress[ ng_global.currentprogress ][ "opn_headphysicianoffice" ].stealing ) then

    private.VidStealing();
    
  end;

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_headphysicianoffice();

end;
--*********************************************************************************************************************
function private.VidStealing ()

  local func_end = function ( skip )

    cmn.GotoRoom( "rm_dungeon" );
    
    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_prison2_intro_voc" );
      cmn.StopAudio( "mus", "audio/level4/mus/aud_vid_headphysicianoffice3_stealing_mus" );
    end;

    --cmn.PlayAudio( "env", "audio/level1/env/aud_rm_prison2_env", 1 );
    --cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );
    ng_global.progress[ ng_global.currentprogress ][ "opn_headphysicianoffice" ].stealing = 1;

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_headphysicianoffice3_stealing", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_prison2_intro_voc" );
  cmn.PlayAudio( "mus", "audio/level4/mus/aud_vid_headphysicianoffice3_stealing_mus" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_antimagicpowder" );
  int.AddedTaskMap( private.room_objname, "get_staroflife_4",                                         { "use_split" } );
  int.AddedTaskMap( private.room_objname, "get_staroflife_3" );
  int.AddedTaskMap( private.room_objname, "get_horn_1",                                               { "use_deeramulet" } );
  int.AddedTaskMap( private.room_objname, "get_split" );
  int.AddedTaskMap( private.room_objname, "get_dummyarm",                                             { "use_butterflyfigurine" } );
  int.AddedTaskMap( private.room_objname, "get_coatlamulet_2",                                        { "use_syringewithoil" } );
  int.AddedTaskMap( private.room_objname, "get_horn_2",                                               { "use_coatlamulet" } );
  int.AddedTaskMap( private.room_objname, "get_safehandle" );
  int.AddedTaskMap( private.room_objname, "get_harpamulet",                                           { "use_jaw", "use_magiceye", "use_dummyarm", "use_magicheart" } );
  int.AddedTaskMap( private.room_objname, "get_eyeofhorusamulet",                                     { "clk_safelever" } );
  int.AddedTaskMap( private.room_objname, "get_tonearm",                                              { "use_harpamulet" } );

  int.AddedTaskMap( private.room_objname, "use_split",                                                { "get_split" } );
  int.AddedTaskMap( private.room_objname, "use_horn",                                                 { "get_horn_1", "get_horn_2" } );
  int.AddedTaskMap( private.room_objname, "use_deeramulet",                                           { "get_deeramulet" } );
  int.AddedTaskMap( private.room_objname, "use_tonearm",                                              { "clk_tonearm", "get_tonearm" } );
  int.AddedTaskMap( private.room_objname, "use_syringewithoil",                                       { "get_syringewithoil" } );
  int.AddedTaskMap( private.room_objname, "use_butterflyfigurine",                                    { "get_butterflyfigurine" } );
  int.AddedTaskMap( private.room_objname, "use_magiceye",                                             { "get_magiceye", "get_safehandle" } );
  int.AddedTaskMap( private.room_objname, "use_coatlamulet",                                          { "get_coatlamulet_1", "get_coatlamulet_2" } );
  int.AddedTaskMap( private.room_objname, "use_magicheart",                                           { "get_magicheart", "get_safehandle" } );
  int.AddedTaskMap( private.room_objname, "use_dummyarm",                                             { "get_dummyarm", "get_safehandle" } );
  int.AddedTaskMap( private.room_objname, "use_jaw",                                                  { "get_jaw", "get_safehandle" } );
  int.AddedTaskMap( private.room_objname, "use_safedisk",                                             { "get_safedisk", "use_horn" } );
  int.AddedTaskMap( private.room_objname, "use_safehandle",                                           { "get_safehandle", "use_horn" } );
  int.AddedTaskMap( private.room_objname, "use_harpamulet",                                           { "get_harpamulet", "win_stash" } );

  int.AddedTaskMap( private.room_objname, "clk_safelever",                                            { "win_stash" } );
  int.AddedTaskMap( private.room_objname, "clk_tonearm" );

  int.AddedTaskMap( private.room_objname, "win_stash",                                                { "use_safehandle", "use_safedisk" } );
  int.AddedTaskMap( private.room_objname, "win_hotable",                                              { "use_tonearm" } );

  int.AddedTaskMap( private.room_objname, "opn_dungeon",                                              { "win_hotable" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_stash" ); 
  
  -------------------------------------------------
  function zz_stash.Open()
    
    if ( cmn.IsEventStart( "win_stash" ) and not cmn.IsEventDone( "win_stash" ) ) then
      
      cmn.MiniGameShow( "stash" );
      common_impl.PassingMgStart( "stash" );

    end;
    
  end;
  -------------------------------------------------
  function zz_stash.PreClose()
    
    if ( cmn.IsEventStart( "win_stash" ) and not cmn.IsEventDone( "win_stash" ) ) then

      cmn.MiniGameHide( "stash" );
      common_impl.PassingMgStop( "stash" );

    end;
    
  end;
  -------------------------------------------------
  function zz_stash.Skip()
    
    if ( cmn.IsEventStart( "win_stash" ) and not cmn.IsEventDone( "win_stash" ) ) then
      
      private.stash_skip();
      
    end;
    
  end;
  -------------------------------------------------
  function zz_stash.Reset()
    
    if ( cmn.IsEventStart( "win_stash" ) and not cmn.IsEventDone( "win_stash" ) ) then
      
      private.stash_reset();
      
    end;
    
  end;
  -------------------------------------------------
  subroom.Define( "zz_stuffedanimal" ); 
  -------------------------------------------------
  function zz_stuffedanimal.Close()
    
    if ( private.is_use_horn ) then

      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_horn" );
        cmn.CallEventHandler( "use_horn_end" );
        cmn.ShowBbt( "bbt_headphysicianoffice_stash" );

      end;

      local func_anim_end = function ()

        ObjAnimate( "rm_headphysicianoffice", "scale_xy", 0, 0, func_end,
        {
          0.0, 3, 1.2, 1.2,
          0.3, 3, 1.2, 1.2,
          0.8, 3, 1.0, 1.0,
        } );

        ObjAnimate( "rm_headphysicianoffice", "pos_xy", 0, 0, "",
        {
          0.0, 3, 34, -154,
          0.3, 3, 34, -154,
          0.8, 3, 0, 0,
        } );

      end;

      private.is_use_horn = false;
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_loc_hidden_cell_safe_opens" );
      ObjAnimate( "rm_headphysicianoffice", "scale_xy", 0, 0,
      function()

        AnimPlay( "anm_headphysicianoffice_open_door", "DoAnim", func_anim_end );

      end,
      {
        0.0, 3, 1.0, 1.0,
        0.5, 3, 1.2, 1.2,
      } );

      ObjAnimate( "rm_headphysicianoffice", "pos_xy", 0, 0, "",
      {
        0.0, 3, 0, 0,
        0.5, 3, 34, -154,
      } );

    end;
    
  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
function private.TableCapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_table_use_deeramulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_table_stuff_gramophone" );
  AnimPlay( "anm_table_box_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.CabinetCapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_cabinet_use_butterflyfigurine" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_cabinet_box_cabinet" );
  AnimPlay( "anm_cabinet_box_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.CabinetDoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_cabinet_use_syringewithoil" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_cabinet_cabinet" );
  AnimPlay( "anm_cabinet_door_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.StashSafeClick ( item )

  local func_end = function ()

    cmn.ShowBbt( "bbt_stash_use_"..item );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_stash_safe" );
  AnimPlay( "anm_stash_firstdoor_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.StashDoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_stash_use_harpamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_stash_xx_hidden_cell" );
  AnimPlay( "anm_stash_seconddoor_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG STASH *** () end;
--*********************************************************************************************************************
  function private.stash_start_init()

    cmn.MiniGameShow( "stash" );
    common_impl.PassingMgStart( "stash" );
    ng_global.progress[ "ext" ][ "win_stash" ].array = { -1, -1, -1, -1, -1 };
    ng_global.progress[ "ext" ][ "win_stash" ].ang_index = 0;

  end;
--------------------------------------------------------------------------------------
  function private.stash_init()
    
    for i = 0, 9  do
      
      ObjSet( "obj_stash_disk_num_"..i, 
      {
         event_mdown = function () private.stash_disk_clk(i)  end,
         event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
         event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end,
      
      } );
      
    end
    
    private.stash_win = { 1, 3, 5, 7, 9 };
    private.stash_start = { -1, -1, -1, -1, -1 };
    private.stash_current = { -1, -1, -1, -1, -1 };
    private.stash_ang = { 0, -0.7, -1.36, -1.96, -2.58, -3.17, -3.75, -4.32, -4.96, -5.55 }
    
    
  end;  
--------------------------------------------------------------------------------------
  function private.stash_disk_clk(num)

    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mmg_zz_stash_click" );
    local start_ang, finish_ang;
    
    start_ang = ObjGet("spr_stash_handle").ang;
    finish_ang = private.stash_ang[num + 1];
    
    local func_after = function ()
    
      int.Lock( false );
      private.stash_checklight( num );
      
    end;  
    
    int.Lock( true );
    if start_ang ~= finish_ang then
      
      ObjAnimate( "spr_stash_handle", "ang", 0, 0, func_after,
      {
          0.0, 1, start_ang,
          0.3, 1, finish_ang
          
      } );
      
    else  
      
      func_after();
      
    end;  
    
  end;  
--------------------------------------------------------------------------------------
  function private.stash_checklight( num )
    
    local cur_num = 0;
    
    for i = 1, 5  do
      
      if private.stash_current[i] == -1 then 
        
        cur_num = i;
        break;
        
      end;  
      
    end;
    
    
    if private.stash_win[cur_num] == num then

      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mmg_zz_stash_green" );
      ObjSet( "txt_stash_numeral_"..cur_num , { text = tostring(num) });
      ObjSet( "spr_stash_light_"..cur_num.."_right", { alp = 1 });
      
    else 

     cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mmg_zz_stash_red" );
     ObjSet( "txt_stash_numeral_"..cur_num , { text = tostring(num) });
     ObjSet( "spr_stash_light_"..cur_num.."_wrong", { alp = 1 }); 
      
    end;  
   
   
    if cur_num ~= 5 then
      
      private.stash_current[cur_num] = num;
      ng_global.progress[ "ext" ][ "win_stash" ].array[cur_num]= private.stash_current[cur_num];
      ng_global.progress[ "ext" ][ "win_stash" ].ang_index = num;
    
    else  
    
      private.stash_current[cur_num] = num;
      private.check_win();
      
    end; 
   
  end;  
--------------------------------------------------------------------------------------
  function private.check_win()
    
    local result = true;
    
    for i = 1, 5  do
      
      if private.stash_win[i] ~= private.stash_current[i] then
        
        result = false;
        break;
        
      end;  
      
    end;
    
    if result then 
      
      private.win_stash() 
      
    else 

      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mmg_zz_stash_drop" );
      private.stash_reset();
   
    end;
    
  end; 
--------------------------------------------------------------------------------------
  function private.stash_load()
    
    for i = 1, 5 do
      
      private.stash_current[i] = ng_global.progress[ "ext" ][ "win_stash" ].array[i];
      
      if  private.stash_current[i] ~= -1 then
        
        ObjSet( "txt_stash_numeral_"..i , { text = tostring(private.stash_current[i]) });
        
        if private.stash_win[i] == private.stash_current[i] then
          
           ObjSet( "spr_stash_light_"..i.."_right", { alp = 1 });
           
        else 
         
           ObjSet( "spr_stash_light_"..i.."_wrong", { alp = 1 });
          
        end;
        
      end;  
      
    end;
    
    ObjSet( "spr_stash_handle", { ang = private.stash_ang[ng_global.progress[ "ext" ][ "win_stash" ].ang_index + 1] } );
    --private.stash_checklight( ng_global.progress[ "ext" ][ "win_stash" ].ang_index);
    
  end;  
--------------------------------------------------------------------------------------
  function private.stash_skip()
    
    local func_after = function ()
    
      private.win_stash();
      
    end;
    ObjSet( "spr_stash_handle", { ang = 0 } );
    for i = 1, 5  do
      
     ObjSet( "txt_stash_numeral_"..i, { text = tostring(private.stash_win[i]) } );
     ObjSet( "spr_stash_light_"..i.."_right", { alp = 1 } );  
      
    end;
    func_after();
    
  end;  
-------------------------------------------------------------------------------------
  function private.win_stash()
    
    cmn.MiniGameHide( "stash" );
    common_impl.PassingMgWin( "stash" );
    cmn.SetEventDone( "win_stash" );
    cmn.CallEventHandler( "win_stash" );
    
  end;
------------------------------------------------------------------------------------
  function private.stash_reset()

    ng_global.progress[ "ext" ][ "win_stash" ].array = { -1, -1, -1, -1, -1 };
    ng_global.progress[ "ext" ][ "win_stash" ].ang_index = 0;

    local func_after = function ()
    
     -- ObjSet( "spr_stash_handle", { ang = 0 } );
     --
      int.Lock( false );
      for i = 1, 5 do
        
        ObjSet( "txt_stash_numeral_"..i, { text = " " } );
        ObjSet( "spr_stash_light_"..i.."_wrong", { alp = 0 } );
        ObjSet( "spr_stash_light_"..i.."_right", { alp = 0 } );
        
      end;
      private.stash_init();
      
      
    end;   
      
    for i = 1, 5  do
      
      ObjAnimate( "spr_stash_light_"..i.."_wrong", "ang", 0, 0, "",
      {
          0.0, 1, ObjGet("spr_stash_light_"..i.."_wrong").alp,
          0.3, 1, 0
          
      } );
      ObjAnimate( "spr_stash_light_"..i.."_right", "ang", 0, 0, "",
      {
          0.0, 1, ObjGet("spr_stash_light_"..i.."_right").alp,
          0.3, 1, 0
          
      } );
      
    end
    
    int.Lock( true );
    ObjAnimate( "spr_stash_handle", "ang", 0, 0, func_after,
    {
        0.0, 1, ObjGet("spr_stash_handle").ang,
        0.3, 1, 0
        
    } );
      
  end;
--*********************************************************************************************************************
function private.DummyEyeClk ()

  local func_end = function ()

    ObjSet( "anm_dummy_give_amulet", { alp = 1 } );
    ObjSet( "anm_dummy_use_eye", { alp = 1 } );
    ObjSet( "anm_dummy_show_eye", { alp = 0 } );
    cmn.ShowBbt( "bbt_dummy_use_magiceye" );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "anm_dummy_give_amulet", { alp = 0 } );
  ObjSet( "anm_dummy_use_eye", { alp = 0 } );
  ObjSet( "anm_dummy_show_eye", { alp = 1 } );
  AnimPlay( "anm_dummy_show_eye", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.DummyHandClk ()

  local func_end = function ()

    ObjSet( "anm_dummy_give_amulet", { alp = 1 } );
    ObjSet( "anm_dummy_show_hand", { alp = 0 } );
    cmn.ShowBbt( "bbt_dummy_use_dummyarm" );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "anm_dummy_give_amulet", { alp = 0 } );
  ObjSet( "anm_dummy_show_hand", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_click_hand_miss" );
  AnimPlay( "anm_dummy_show_hand", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.DummyHeartClk ()

  local func_end = function ()

    ObjSet( "anm_dummy_give_amulet", { alp = 1 } );
    ObjSet( "anm_dummy_show_heart", { alp = 0 } );
    cmn.ShowBbt( "bbt_dummy_use_magicheart" );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "anm_dummy_give_amulet", { alp = 0 } );
  ObjSet( "anm_dummy_show_heart", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_click_heart" );
  AnimPlay( "anm_dummy_show_heart", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.DummyJawClk ()

  local func_end = function ()

    ObjSet( "anm_dummy_give_amulet", { alp = 1 } );
    ObjSet( "anm_dummy_show_jaw", { alp = 0 } );
    cmn.ShowBbt( "bbt_dummy_use_jaw" );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "anm_dummy_give_amulet", { alp = 0 } );
  ObjSet( "anm_dummy_show_jaw", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_dummy_click_mouth" );
  AnimPlay( "anm_dummy_show_jaw", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.DummyBagClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_dummy_use_coatlamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_dummy_jacket" );
  AnimPlay( "anm_dummy_bag_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.AnimalHornClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_stuffedanimal_use_horn" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_stuffedanimal_deer_horns" );
  AnimPlay( "anm_stuffedanimal_horn_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.AnimalStarClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_stuffedanimal_use_split" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_stuffedanimal_stuff_deer" );
  AnimPlay( "anm_stuffedanimal_star_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************