-- name=rm_hospital
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_hospital";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_receptiondesk", "room_hub" );
  ObjAttach( "zz_plunderedlocker", "room_hub" );
  ObjAttach( "zz_firstaidkit", "room_hub" );

  ObjMultiSet(
  {
    { "spr_receptiondesk_lockerkey",         { event_mdown = private.get_lockerkey } },
    { "spr_receptiondesk_safedisk",          { event_mdown = private.get_safedisk } },
    --{ "spr_plunderedlocker_purifyingsphere", { event_mdown = private.get_purifyingsphere } },
    { "spr_plunderedlocker_nutwrench",       { event_mdown = private.get_nutwrench } },
    { "spr_plunderedlocker_staroflife_2",    { event_mdown = private.get_staroflife_2 } },
    { "spr_firstaidkit_emptysyringe",        { event_mdown = private.get_emptysyringe } },
    { "spr_firstaidkit_clamp",               { event_mdown = private.get_clamp } },
    { "obj_plunderedlocker_use_lockerkey",   { event_mdown = private.PlunderedlockerDoorClick } },
    { "obj_receptiondesk_use_handle",        { event_mdown = private.ReceptiondeskNicheClick } },
    { "obj_receptiondesk_use_grimsickleramulet",  { event_mdown = private.ReceptiondeskNicheClick2 } },
    { "obj_firstaidkit_use_lilyamulet",      { event_mdown = private.FirstaidkitCapClick } },
    { "spr_hospital_collect_4_2",            { event_mdown = private.get_collect_4_2 } },
    { "spr_firstaidkit_screensaver_4_10",     { event_mdown = private.get_screensaver_4_10 } },          
    { "spr_plunderedlocker_screensaver_4_11",     { event_mdown = private.get_screensaver_4_11 } },  
    { "obj_hospital_use_purifyingsphere",         { event_mdown = function() private.HospitalMagicClk() end } }           
  } );

  local get_screensaver_4_10 = function ()

    ObjDelete( "spr_firstaidkit_screensaver_4_10" );
    ObjDelete( "spr_hospital_firstaidkit_puzzle" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_10", get_screensaver_4_10, private.room_objname );  
  local get_screensaver_4_11 = function ()

    ObjDelete( "spr_plunderedlocker_screensaver_4_11" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_11", get_screensaver_4_11, private.room_objname );  

  private.InitMiniHO();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hospital = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_hospital", update_game_mode_hospital, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function opn_hospital () end;
  --------------------------------------------------------------------------------------------
  local opn_hospital = function ()

    ObjDelete( "anm_hospital_damned" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_hospital", opn_hospital, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_4_2 = function ()

    ObjDelete( "spr_hospital_collect_4_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_4_2", get_collect_4_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_4 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_4 = function ()

    ObjDelete( "obj_hospital_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_4", get_morphobject_4_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_butterflyfigurine () end;
  --------------------------------------------------------------------------------------------
  local get_butterflyfigurine_closezz = function ()

    ObjDelete( "gmg_hospital_mgdominoes" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_butterflyfigurine", get_butterflyfigurine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lockerkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lockerkey" ] =
  {
    type = "get",
    get_obj = "spr_receptiondesk_lockerkey",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_hospital_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local get_lockerkey_inv = function ()

    int.InventoryItemAdd( "inv_lockerkey", "spr_receptiondesk_lockerkey" );

  end;
  local get_lockerkey_closezz = function ()

    ObjDelete( "gfx_receptiondesk_lockerkey" );
    ObjSet( "obj_receptiondesk_use_grimsickleramulet", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lockerkey", get_lockerkey_inv );
  cmn.AddSubscriber( "get_lockerkey", get_lockerkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_safedisk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_safedisk" ] =
  {
    type = "get",
    get_obj = "spr_receptiondesk_safedisk",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_hospital_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local get_safedisk_inv = function ()

    int.InventoryItemAdd( "inv_safedisk", "spr_receptiondesk_safedisk" );

  end;
  local get_safedisk_closezz = function ()

    ObjDelete( "gfx_receptiondesk_safedisk" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_safedisk", get_safedisk_inv );
  cmn.AddSubscriber( "get_safedisk", get_safedisk_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_purifyingsphere () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_purifyingsphere" ] =
  {
    type = "get",
    get_obj = "spr_plunderedlocker_purifyingsphere",
    room = private.room_objname,
    zz = "zz_plunderedlocker",
    zz_gate = "gzz_hospital_plunderedlocker"
  };
  --------------------------------------------------------------------------------------------
  local get_purifyingsphere_inv = function ()

    int.InventoryItemAdd( "inv_purifyingsphere", "spr_plunderedlocker_win" );

  end;
  local get_purifyingsphere_closezz = function ()

    ObjDelete( "gfx_plunderedlocker_purifyingsphere" );

    if ( cmn.IsEventDone( "get_staroflife_2" ) ) then

      ObjDelete( "gzz_hospital_plunderedlocker" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_purifyingsphere", get_purifyingsphere_inv );
  cmn.AddSubscriber( "get_purifyingsphere", get_purifyingsphere_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nutwrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nutwrench" ] =
  {
    type = "get",
    get_obj = "spr_plunderedlocker_nutwrench",
    room = private.room_objname,
    zz = "zz_plunderedlocker",
    zz_gate = "gzz_hospital_plunderedlocker"
  };
  --------------------------------------------------------------------------------------------
  local get_nutwrench_inv = function ()

    int.InventoryItemAdd( "inv_nutwrench", "spr_plunderedlocker_nutwrench" );

  end;
  local get_nutwrench_closezz = function ()

    ObjDelete( "gfx_plunderedlocker_nutwrench" );
    ObjDelete( "spr_hospital_plunderedlocker_nutwrench" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_nutwrench", get_nutwrench_inv );
  cmn.AddSubscriber( "get_nutwrench", get_nutwrench_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_staroflife_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_staroflife_2" ] =
  {
    type = "get",
    get_obj = "spr_plunderedlocker_staroflife_2",
    room = private.room_objname,
    zz = "zz_plunderedlocker",
    zz_gate = "gzz_hospital_plunderedlocker"
  };
  --------------------------------------------------------------------------------------------
  local get_staroflife_2_inv = function ()

    int.InventoryItemAdd( "inv_staroflife", "spr_plunderedlocker_staroflife_2", "assets/levels/levelext/rm_morgue/zz_debris/inv/inv_staroflife_2" );
    levelext_inv.CheckStaroflife();

  end;
  local get_staroflife_2_closezz = function ()

    ObjDelete( "gfx_plunderedlocker_staroflife_2" );

    if ( cmn.IsEventDone( "get_purifyingsphere" ) ) then

      ObjDelete( "gzz_hospital_plunderedlocker" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_staroflife_2", get_staroflife_2_inv );
  cmn.AddSubscriber( "get_staroflife_2", get_staroflife_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emptysyringe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emptysyringe" ] =
  {
    type = "get",
    get_obj = "spr_firstaidkit_emptysyringe",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_hospital_firstaidkit"
  };
  --------------------------------------------------------------------------------------------
  local get_emptysyringe_inv = function ()

    int.InventoryItemAdd( "inv_emptysyringe", "spr_firstaidkit_emptysyringe" );

  end;
  local get_emptysyringe_closezz = function ()

    ObjDelete( "gfx_firstaidkit_emptysyringe" );
    ObjDelete( "gzz_hospital_firstaidkit" );

    ObjDelete( "spr_hospital_firstaidkit_emptysyringe" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_emptysyringe", get_emptysyringe_inv );
  cmn.AddSubscriber( "get_emptysyringe", get_emptysyringe_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clamp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clamp" ] =
  {
    type = "get",
    get_obj = "spr_firstaidkit_clamp",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_hospital_firstaidkit"
  };
  --------------------------------------------------------------------------------------------
  local get_clamp_inv = function ()

    int.InventoryItemAdd( "inv_clamp", "spr_firstaidkit_clamp" );

  end;
  local get_clamp_closezz = function ()

    ObjSet( "anm_firstaidkit_cap_click", { res = "assets/levels/levelext/rm_hospital/zz_firstaidkit/anims/anm_click1", animfunc = "DoAnim" } );
    ObjDelete( "gfx_firstaidkit_clamp" );
    ObjDelete( "spr_hospital_firstaidkit_clamp" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_clamp", get_clamp_inv );
  cmn.AddSubscriber( "get_clamp", get_clamp_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_stiletto_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stiletto_4" ] =
  {
    type = "use",
    use_obj = "inv_stiletto",
    use_place = "obj_receptiondesk_use_stiletto_4",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_hospital_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local use_stiletto_4_inv = function ()

    int.InventoryItemRemove( "inv_stiletto" );

  end;
  local use_stiletto_4_beg = function ()

    ObjDelete( "obj_receptiondesk_use_stiletto_4" );

  end;
  local use_stiletto_4_end = function ()

    ObjSet( "anm_receptiondesk_stiletto", { alp = 1, frame = 109, animfunc = "DoAnim" } );
    ObjSet( "obj_receptiondesk_box_open", { alp = 1 } );
    ObjSet( "spr_receptiondesk_safedisk", { input = true } );
    ObjSet( "gfx_receptiondesk_safedisk", { active = true } );

    ObjSet( "spr_hospital_receptiondesk_open_box",    { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stiletto_4",     use_stiletto_4_inv );
  cmn.AddSubscriber( "use_stiletto_4",     use_stiletto_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_4",     use_stiletto_4_end, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_4_inv", use_stiletto_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_4_beg", use_stiletto_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_4_end", use_stiletto_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_handle" ] =
  {
    type = "use",
    use_obj = "inv_handle",
    use_place = "obj_receptiondesk_use_handle",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_hospital_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local use_handle_inv = function ()

    int.InventoryItemRemove( "inv_handle" );

  end;
  local use_handle_beg = function ()

    ObjDelete( "obj_receptiondesk_use_handle" );
    ObjDelete( "anm_receptiondesk_niche_cover_click" );

  end;
  local use_handle_end = function ()

    ObjDelete( "anm_receptiondesk_niche_handle" );
    ObjSet( "spr_receptiondesk_lockerkey", { input = true } );
    ObjSet( "gfx_receptiondesk_lockerkey", { active = true } );
    ObjSet( "spr_hospital_receptiondesk_handle_1", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handle",     use_handle_inv );
  cmn.AddSubscriber( "use_handle",     use_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle",     use_handle_end, private.room_objname );
  cmn.AddSubscriber( "use_handle_inv", use_handle_inv, private.room_objname );
  cmn.AddSubscriber( "use_handle_beg", use_handle_beg, private.room_objname );
  cmn.AddSubscriber( "use_handle_end", use_handle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_grimsickleramulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_grimsickleramulet" ] =
  {
    type = "use",
    use_obj = "inv_grimsickleramulet",
    use_place = "obj_receptiondesk_use_grimsickleramulet",
    room = private.room_objname,
    zz = "zz_receptiondesk",
    zz_gate = "gzz_hospital_receptiondesk"
  };
  --------------------------------------------------------------------------------------------
  local use_grimsickleramulet_inv = function ()

    int.InventoryItemRemove( "inv_grimsickleramulet" );

  end;
  local use_grimsickleramulet_beg = function ()

    ObjDelete( "obj_receptiondesk_use_grimsickleramulet" );
    ObjDelete( "anm_receptiondesk_niche_click" );

  end;
  local use_grimsickleramulet_end = function ()

    ObjDelete( "gzz_hospital_receptiondesk" );
    ObjSet( "gmg_hospital_mgdominoes", { alp = 1, input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_grimsickleramulet",     use_grimsickleramulet_inv );
  cmn.AddSubscriber( "use_grimsickleramulet",     use_grimsickleramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_grimsickleramulet",     use_grimsickleramulet_end, private.room_objname );
  cmn.AddSubscriber( "use_grimsickleramulet_inv", use_grimsickleramulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_grimsickleramulet_beg", use_grimsickleramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_grimsickleramulet_end", use_grimsickleramulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clamp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clamp" ] =
  {
    type = "use",
    use_obj = "inv_clamp",
    use_place = "obj_plunderedlocker_use_clamp",
    room = private.room_objname,
    zz = "zz_plunderedlocker",
    zz_gate = "gzz_hospital_plunderedlocker"
  };
  --------------------------------------------------------------------------------------------
  local use_clamp_inv = function ()

    int.InventoryItemRemove( "inv_clamp" );

  end;
  local use_clamp_beg = function ()

    ObjDelete( "obj_plunderedlocker_use_clamp" );

  end;
  local use_clamp_end = function ()

    ObjDelete( "anm_plunderedlocker_clamp" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clamp",     use_clamp_inv );
  cmn.AddSubscriber( "use_clamp",     use_clamp_beg, private.room_objname );
  cmn.AddSubscriber( "use_clamp",     use_clamp_end, private.room_objname );
  cmn.AddSubscriber( "use_clamp_inv", use_clamp_inv, private.room_objname );
  cmn.AddSubscriber( "use_clamp_beg", use_clamp_beg, private.room_objname );
  cmn.AddSubscriber( "use_clamp_end", use_clamp_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockerkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockerkey" ] =
  {
    type = "use",
    use_obj = "inv_lockerkey",
    use_place = "obj_plunderedlocker_use_lockerkey",
    room = private.room_objname,
    zz = "zz_plunderedlocker",
    zz_gate = "gzz_hospital_plunderedlocker"
  };
  --------------------------------------------------------------------------------------------
  local use_lockerkey_inv = function ()

    int.InventoryItemRemove( "inv_lockerkey" );

  end;
  local use_lockerkey_beg = function ()

    ObjDelete( "obj_plunderedlocker_use_lockerkey" );

  end;
  local use_lockerkey_end = function ()

    ObjSet( "anm_plunderedlocker_door", { alp = 1, frame = 79, animfunc = "DoAnim" } );
    --ObjSet( "spr_plunderedlocker_purifyingsphere", { input = true } );
    --ObjSet( "gfx_plunderedlocker_purifyingsphere", { active = true } );
    ObjSet( "obj_plunderedlocker_miniho", { input = true } );

    ObjDelete( "spr_hospital_plunderedlocker_close_door" );
    ObjSet( "spr_hospital_plunderedlocker_open_door", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockerkey",     use_lockerkey_inv );
  cmn.AddSubscriber( "use_lockerkey",     use_lockerkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockerkey",     use_lockerkey_end, private.room_objname );
  cmn.AddSubscriber( "use_lockerkey_inv", use_lockerkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockerkey_beg", use_lockerkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockerkey_end", use_lockerkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lilyamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lilyamulet" ] =
  {
    type = "use",
    use_obj = "inv_lilyamulet",
    use_place = "obj_firstaidkit_use_lilyamulet",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_hospital_firstaidkit"
  };
  --------------------------------------------------------------------------------------------
  local use_lilyamulet_inv = function ()

    int.InventoryItemRemove( "inv_lilyamulet" );

  end;
  local use_lilyamulet_beg = function ()

    ObjDelete( "obj_firstaidkit_use_lilyamulet" );
    ObjDelete( "anm_firstaidkit_cap_click" );

  end;
  local use_lilyamulet_end = function ()

    ObjSet( "anm_firstaidkit_lilyamulet", { alp = 1, frame = 65, animfunc = "DoAnim" } );
    ObjSet( "spr_firstaidkit_emptysyringe", { input = true } );
    ObjSet( "gfx_firstaidkit_emptysyringe", { active = true } );

    ObjDelete( "spr_hospital_firstaidkit_closed" );
    ObjSet( "spr_hospital_firstaidkit_open",     { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lilyamulet",     use_lilyamulet_inv );
  cmn.AddSubscriber( "use_lilyamulet",     use_lilyamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_lilyamulet",     use_lilyamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_lilyamulet_inv", use_lilyamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_lilyamulet_beg", use_lilyamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_lilyamulet_end", use_lilyamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_purifyingsphere () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_purifyingsphere" ] =
  {
    type = "use",
    use_obj = "inv_purifyingsphere",
    use_place = "obj_hospital_use_purifyingsphere",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local use_purifyingsphere_inv = function ()

    int.InventoryItemRemove( "inv_purifyingsphere" );

  end;
  local use_purifyingsphere_beg = function ()

    ObjDelete( "obj_hospital_use_purifyingsphere" );

  end;
  local use_purifyingsphere_end = function ()

    ObjSet( "grm_hospital_headphysicianoffice", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_hospital_headphysicianoffice_focus");
    end;
    
    ObjDelete( "obj_hospital_az" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_purifyingsphere",     use_purifyingsphere_inv );
  cmn.AddSubscriber( "use_purifyingsphere",     use_purifyingsphere_beg, private.room_objname );
  cmn.AddSubscriber( "use_purifyingsphere",     use_purifyingsphere_end, private.room_objname );
  cmn.AddSubscriber( "use_purifyingsphere_inv", use_purifyingsphere_inv, private.room_objname );
  cmn.AddSubscriber( "use_purifyingsphere_beg", use_purifyingsphere_beg, private.room_objname );
  cmn.AddSubscriber( "use_purifyingsphere_end", use_purifyingsphere_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_10()

  int.AddScreensaver( "spr_firstaidkit_screensaver_4_10" );

end;   
------------------------------------------------------------------------------------------
function private.get_screensaver_4_11()

  int.AddScreensaver( "spr_plunderedlocker_screensaver_4_11" );

end; 
-----------------------------------------------------------------------
function private.get_collect_4_2 ()

  int.AddCollectibles( "spr_hospital_collect_4_2" );

end;
-----------------------------------------------------------------------
function private.get_lockerkey ()

  cmn.SetEventDone( "get_lockerkey" );
  cmn.CallEventHandler( "get_lockerkey" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_safedisk ()

  cmn.SetEventDone( "get_safedisk" );
  cmn.CallEventHandler( "get_safedisk" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function public.get_purifyingsphere ()

  cmn.SetEventDone( "get_purifyingsphere" );
  --cmn.CallEventHandler( "get_purifyingsphere" );
  --cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_staroflife_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_nutwrench ()

  cmn.SetEventDone( "get_nutwrench" );
  cmn.CallEventHandler( "get_nutwrench" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_staroflife_2 ()

  ObjSet( "spr_plunderedlocker_staroflife_2", { alp = 1 } );

  cmn.SetEventDone( "get_staroflife_2" );
  cmn.CallEventHandler( "get_staroflife_2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_purifyingsphere" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_emptysyringe ()

  cmn.SetEventDone( "get_emptysyringe" );
  cmn.CallEventHandler( "get_emptysyringe" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_clamp ()

  ObjSet( "spr_firstaidkit_clamp", { alp = 1 } );

  cmn.SetEventDone( "get_clamp" );
  cmn.CallEventHandler( "get_clamp" );
  cmn.GetObjectSfx();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_stiletto_4 ()

  local item = "inv_stiletto";

  if ( cmn.ApplyObj( item, "gzz_hospital_receptiondesk", false ) ) and
     ( not cmn.IsEventDone( "use_stiletto_4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_receptiondesk", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_receptiondesk_use_stiletto_4", true ) ) and
         ( not cmn.IsEventDone( "use_stiletto_4" ) ) then

    cmn.CallEventHandler( "use_stiletto_4_inv" );
    cmn.CallEventHandler( "use_stiletto_4_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_stiletto_4" );
      cmn.CallEventHandler( "use_stiletto_4_end" );

    end;

    int.Lock( true );

    ObjAnimate( "anm_receptiondesk_stiletto", "alp", 0, 0,
    function ()
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_receptiondesk_cut_cardboard" );
      AnimPlay( "anm_receptiondesk_stiletto", "DoAnim", func_end );

    end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    ObjAnimate( "obj_receptiondesk_box_open", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      1.6, 3, 0.0,
      1.7, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_handle ()

  local item = "inv_handle";

  if ( cmn.ApplyObj( item, "gzz_hospital_receptiondesk", false ) ) and
     ( not cmn.IsEventDone( "use_handle" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_receptiondesk", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_receptiondesk_use_handle", true ) ) and
         ( not cmn.IsEventDone( "use_handle" ) ) then

    cmn.CallEventHandler( "use_handle_inv" );
    cmn.CallEventHandler( "use_handle_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_handle" );
      cmn.CallEventHandler( "use_handle_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_receptiondesk_niche_handle", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_receptiondesk_insert_handle" );
    AnimPlay( "anm_receptiondesk_niche_handle", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_grimsickleramulet ()

  local item = "inv_grimsickleramulet";

  if ( cmn.ApplyObj( item, "gzz_hospital_receptiondesk", false ) ) and
     ( cmn.IsEventDone( "get_lockerkey" ) ) and
     ( not cmn.IsEventDone( "use_grimsickleramulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_receptiondesk", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_receptiondesk_use_grimsickleramulet", true ) ) and
         ( cmn.IsEventDone( "get_lockerkey" ) ) and
         ( not cmn.IsEventDone( "use_grimsickleramulet" ) ) then

    cmn.CallEventHandler( "use_grimsickleramulet_inv" );
    cmn.CallEventHandler( "use_grimsickleramulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_grimsickleramulet" );
      cmn.CallEventHandler( "use_grimsickleramulet_end" );
      cmn.CloseSubRoom();
      cmn.GotoRoom( "mg_mgdominoes" );

    end;

    int.Lock( true );

    ObjSet( "anm_receptiondesk_niche_grimsickleramulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_receptiondesk_insert_stuff_hidden_cell_down" );
    AnimPlay( "anm_receptiondesk_niche_grimsickleramulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_clamp ()

  local item = "inv_clamp";

  if ( cmn.ApplyObj( item, "gzz_hospital_plunderedlocker", false ) ) and
     ( not cmn.IsEventDone( "use_clamp" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_plunderedlocker", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_plunderedlocker_use_clamp", true ) ) and
         ( not cmn.IsEventDone( "use_clamp" ) ) then

    cmn.CallEventHandler( "use_clamp_inv" );
    cmn.CallEventHandler( "use_clamp_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_clamp" );
      cmn.CallEventHandler( "use_clamp_end" );
      private.get_staroflife_2();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_plunderedlocker_take_stuff_slime" );
    AnimPlay( "anm_plunderedlocker_clamp", "DoAnim", func_end );
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_lockerkey ()

  local item = "inv_lockerkey";

  if ( cmn.ApplyObj( item, "gzz_hospital_plunderedlocker", false ) ) and
     ( not cmn.IsEventDone( "use_lockerkey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_plunderedlocker", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_plunderedlocker_use_lockerkey", true ) ) and
         ( not cmn.IsEventDone( "use_lockerkey" ) ) then

    cmn.CallEventHandler( "use_lockerkey_inv" );
    cmn.CallEventHandler( "use_lockerkey_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_lockerkey" );
      cmn.CallEventHandler( "use_lockerkey_end" );
      int_button_mini_ho.Show( "get_purifyingsphere", "plunderedlocker", 4, "spr_plunderedlocker_purifyingsphere_panel", private.mini_ho_array ); 

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_plunderedlocker_insert_key_door" );
    AnimPlay( "anm_plunderedlocker_door", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_lilyamulet ()

  local item = "inv_lilyamulet";

  if ( cmn.ApplyObj( item, "gzz_hospital_firstaidkit", false ) ) and
     ( not cmn.IsEventDone( "use_lilyamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_firstaidkit", nil, { 512, 384 }, true, { -150,80 } );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_firstaidkit_use_lilyamulet", true ) ) and
         ( not cmn.IsEventDone( "use_lilyamulet" ) ) then

    cmn.CallEventHandler( "use_lilyamulet_inv" );
    cmn.CallEventHandler( "use_lilyamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_lilyamulet" );
      cmn.CallEventHandler( "use_lilyamulet_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_firstaidkit_lilyamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_firstaidkit_insert_stuff_table" );
    AnimPlay( "anm_firstaidkit_lilyamulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_purifyingsphere ()

  local item = "inv_purifyingsphere";

  if ( cmn.ApplyObj( item, "obj_hospital_use_purifyingsphere", true ) ) and
         ( not cmn.IsEventDone( "use_purifyingsphere" ) ) then

    cmn.CallEventHandler( "use_purifyingsphere_inv" );
    cmn.CallEventHandler( "use_purifyingsphere_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_purifyingsphere" );
      cmn.CallEventHandler( "use_purifyingsphere_end" );

    end;

    int.Lock( true );

    local func_end_tmr = function ()
      ObjSet( "anm_hospital_az_static", { alp = 0 } );
    end;

    cmn.WaitAndRun( func_end_tmr, 1.95 );

    ObjSet( "anm_hospital_use_purifyingsphere", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_loc_use_magic_stuff_portal_diss" );
    AnimPlay( "anm_hospital_use_purifyingsphere", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.opn_hospital ()

  if not ( cmn.IsEventDone( "opn_hospital" ) ) then
    
    private.HospitalDamnedAnim();    

  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_hospital_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_hospital_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_hospital();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_lockerkey",                                         { "use_handle" } );
  int.AddedTaskMap( private.room_objname, "get_safedisk",                                          { "use_stiletto_4" } );
  int.AddedTaskMap( private.room_objname, "get_purifyingsphere",                                   { "use_lockerkey" } );
  int.AddedTaskMap( private.room_objname, "get_nutwrench" );
  int.AddedTaskMap( private.room_objname, "get_staroflife_2",                                      { "use_clamp" } );
  int.AddedTaskMap( private.room_objname, "get_emptysyringe",                                      { "use_lilyamulet" } );
  int.AddedTaskMap( private.room_objname, "get_clamp" );
  int.AddedTaskMap( private.room_objname, "get_butterflyfigurine",                                 { "win_mgdominoes" } );

  int.AddedTaskMap( private.room_objname, "use_stiletto_4",                                        { "get_stiletto" } );
  int.AddedTaskMap( private.room_objname, "use_handle",                                            { "get_handle" } );
  int.AddedTaskMap( private.room_objname, "use_grimsickleramulet",                                 { "get_grimsickleramulet", "get_lockerkey" } );
  int.AddedTaskMap( private.room_objname, "use_clamp",                                             { "get_clamp" } );
  int.AddedTaskMap( private.room_objname, "use_lockerkey",                                         { "get_lockerkey" } );
  int.AddedTaskMap( private.room_objname, "use_lilyamulet",                                        { "get_lilyamulet" } );
  int.AddedTaskMap( private.room_objname, "use_purifyingsphere",                                   { "get_purifyingsphere" } );

  int.AddedTaskMap( private.room_objname, "win_mgdominoes",                                        { "use_grimsickleramulet" } );

  int.AddedTaskMap( private.room_objname, "opn_headphysicianoffice",                               { "use_purifyingsphere" } );


end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_plunderedlocker" );  
  -------------------------------------------------
  function zz_plunderedlocker.PreOpen()
    
   if cmn.IsEventDone( "use_lockerkey" ) and not
      cmn.IsEventDone( "get_purifyingsphere" ) then
      
      int_button_mini_ho.Show( "get_purifyingsphere", "plunderedlocker", 4, "spr_plunderedlocker_purifyingsphere_panel", private.mini_ho_array ); 
      
   end; 
    
  end;
  -------------------------------------------------
  function zz_plunderedlocker.PreClose()
    
    if cmn.IsEventDone( "use_lockerkey" ) and not
       cmn.IsEventDone( "get_purifyingsphere" ) then
       
      int_button_mini_ho.Hide(); 
      
    end;  
    
  end;

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
function private.PlunderedlockerDoorClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_plunderedlocker_use_lockerkey" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_plunderedlocker_door" );
  ObjAnimate( "anm_plunderedlocker_door", "pos_x", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, 2,
    0.4, 3, 0,
    0.6, 3, 2,
    0.7, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.ReceptiondeskNicheClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_receptiondesk_use_handle" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_receptiondesk_closed_cell_table" );
  AnimPlay( "anm_receptiondesk_niche_cover_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.ReceptiondeskNicheClick2 ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_receptiondesk_use_grimsickleramulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_receptiondesk_hidden_cell_down" );
  AnimPlay( "anm_receptiondesk_niche_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.FirstaidkitCapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_firstaidkit_use_lilyamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_firstaidkit_box" );
  AnimPlay( "anm_firstaidkit_cap_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.InitMiniHO ()
  
  private.mini_ho_array = { 
                            "spr_plunderedlocker_ho_1", 
                            "spr_plunderedlocker_ho_2", 
                            "spr_plunderedlocker_ho_3", 
                            "spr_plunderedlocker_ho_4", 
                          };

  for i = 1, #private.mini_ho_array do

    ObjSet( private.mini_ho_array[ i ], { 
                    event_mdown = function() 
                    int_button_mini_ho.MiniHoTaskFind( "get_purifyingsphere", "plunderedlocker", private.mini_ho_array[ i ], 4, "" );
                                  end,
                    event_menter = function () cmn.SetCursor( CURSOR_GET );  end,
                    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end  } );

  end;
      
end;
--*********************************************************************************************************************
function private.HospitalMagicClk ()

  local func_end = function ()

    ObjSet( "anm_hospital_az_click", { alp = 0 } );
    cmn.ShowBbt( "bbt_hospital_use_purifyingsphere" );
    int.Lock( false );

  end;

  int.Lock( true );
  ObjSet( "anm_hospital_az_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_loc_portal" );
  AnimPlay( "anm_hospital_az_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.HospitalDamnedAnim ()
  
  local mas_widgets = {

     InterfaceWidget_BtnHint
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_BtnMap
    ,InterfaceWidget_BtnGuide    
  };
  
  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[i], false, true, 0.3 ); 

  end;

  cmn.StopAllMus();
  common_impl.StopMusEnv( false );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_loc_anim_man_skull", 0, 0 );
  cmn.PlayAudio( "voc", "audio/level4/voc/aud_lvl4_vid_cursed_voc", 0, 0 );


  ObjSet( "obj_hospital_gates", { visible = false } );
  interface.DialogVideoShow( "", 1, function() private.HospitalDamnedAnim_End( "skip" ); end, 0 );
  AnimPlay( "anm_hospital_damned", "DoAnim", private.HospitalDamnedAnim_End );

  local func_subtitle = function ()

    interface.DialogVideoSubtitleShow( "sub_hospital_damned_1" );  

  end;

  local func_subtitle_end = function ()

    interface.DialogVideoSubtitleHide();  

  end;

  cmn.WaitAndRun( func_subtitle, 5.9 );
  cmn.WaitAndRun( func_subtitle_end, 17.5 );
  
end;
--*********************************************************************************************************************
function private.HospitalDamnedAnim_End ( skip ) 
 
  local mas_widgets = {

     InterfaceWidget_BtnHint
    ,InterfaceWidget_Inventory
    ,InterfaceWidget_BtnMap
    ,InterfaceWidget_BtnGuide    
  };
  
  for i = 1, #mas_widgets do

    interface.WidgetSetVisible( mas_widgets[i], true, true, 0.3 ); 

  end;
  
  interface.DialogVideoHide();
  --interface.DialogVideoSubtitleHide();
  ObjSet( "obj_hospital_gates", { visible = true } );
  
  cmn.SetEventDone( "opn_hospital" );
  cmn.CallEventHandler( "opn_hospital" );
  interface.KeyTaskDone( true, "task_4_3" );
  common_impl.PlayMusEnv();
  int.Lock( false );
  
  if skip then

    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_loc_anim_man_skull", 0.2 );
    cmn.StopAudio( "voc", "audio/level4/voc/aud_lvl4_vid_cursed_voc", 0.2 );
    
  end; 

  --cmn.PlayMusEnv( "common/audio/aud_danger2_mus" );  
  
end; 
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************