-- name=rm_morgue
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_morgue";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_breach", "room_hub" );
  ObjAttach( "zz_char",   "room_hub" );
  ObjAttach( "zz_debris", "room_hub" );

  ObjMultiSet(
  {
    { "spr_breach_tridentamulet_2", { event_mdown = private.get_tridentamulet_2 } },
    { "spr_char_extendingladder",   { event_mdown = private.get_extendingladder } },
    { "spr_char_grimsickleramulet", { event_mdown = private.get_grimsickleramulet } },
    { "spr_debris_crazydoctor_2",   { event_mdown = private.get_crazydoctor_2 } },
    { "spr_debris_staroflife_1",    { event_mdown = private.get_staroflife_1 } },
    { "spr_debris_tridentamulet_3", { event_mdown = private.get_tridentamulet_3 } },
    { "spr_debris_deeramulet",      { event_mdown = private.get_deeramulet } },
    { "obj_char_use_tridentamulet", { event_mdown = private.CharCapClick } },
    { "obj_char_use_firepoker_3",   { event_mdown = private.CharCoalsClick } },
    { "spr_char_screensaver_4_8",   { event_mdown = private.get_screensaver_4_8 } },          
    { "spr_debris_screensaver_4_9", { event_mdown = private.get_screensaver_4_9 } },              
    { "obj_breach_use_stiletto_3",  { event_mdown = private.BreachWireClick } },              
    { "obj_debris_use_thermalmatches", { event_mdown = private.DebrisWaxClick } },              
    { "obj_debris_use_fireaxe",        { event_mdown = private.DebrisBoardClick } },              
  } );
  local get_screensaver_4_8 = function ()

    ObjDelete( "spr_char_screensaver_4_8" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_8", get_screensaver_4_8, private.room_objname );
  local get_screensaver_4_9 = function ()

    ObjDelete( "spr_debris_screensaver_4_9" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_9", get_screensaver_4_9, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_morgue = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_morgue", update_game_mode_morgue, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_5 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_5 = function ()

    ObjDelete( "obj_morgue_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_5", get_morphobject_4_5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tridentamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tridentamulet_2" ] =
  {
    type = "get",
    get_obj = "spr_breach_tridentamulet_2",
    room = private.room_objname,
    zz = "zz_breach",
    zz_gate = "gzz_morgue_breach"
  };
  --------------------------------------------------------------------------------------------
  local get_tridentamulet_2_inv = function ()

    int.InventoryItemAdd( "inv_tridentamulet", "spr_breach_tridentamulet_2", "assets/levels/levelext/rm_park/zz_pump/inv/inv_tridentamulet_1" );
    levelext_inv.CheckTridentamulet();

  end;
  local get_tridentamulet_2_closezz = function ()

    ObjDelete( "gfx_breach_tridentamulet_2" );
    ObjDelete( "spr_morgue_breach_amulet");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_tridentamulet_2", get_tridentamulet_2_inv );
  cmn.AddSubscriber( "get_tridentamulet_2", get_tridentamulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_extendingladder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_extendingladder" ] =
  {
    type = "get",
    get_obj = "spr_char_extendingladder",
    room = private.room_objname,
    zz = "zz_char",
    zz_gate = "gzz_morgue_char"
  };
  --------------------------------------------------------------------------------------------
  local get_extendingladder_inv = function ()

    int.InventoryItemAdd( "inv_extendingladder", "spr_char_extendingladder" );

  end;
  local get_extendingladder_closezz = function ()

    ObjDelete( "gfx_char_extendingladder" );
    ObjDelete( "spr_morgue_char_open_ladder");
    if ( cmn.IsEventDone( "get_grimsickleramulet" ) ) then

      ObjDelete( "gzz_morgue_char" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_extendingladder", get_extendingladder_inv );
  cmn.AddSubscriber( "get_extendingladder", get_extendingladder_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_grimsickleramulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_grimsickleramulet" ] =
  {
    type = "get",
    get_obj = "spr_char_grimsickleramulet",
    room = private.room_objname,
    zz = "zz_char",
    zz_gate = "gzz_morgue_char"
  };
  --------------------------------------------------------------------------------------------
  local get_grimsickleramulet_inv = function ()

    int.InventoryItemAdd( "inv_grimsickleramulet", "spr_char_grimsickleramulet" );

  end;
  local get_grimsickleramulet_closezz = function ()

    ObjDelete( "gfx_char_grimsickleramulet" );
    ObjDelete( "spr_morgue_char_amulet");

    if ( cmn.IsEventDone( "get_extendingladder" ) ) then

      ObjDelete( "gzz_morgue_char" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_grimsickleramulet", get_grimsickleramulet_inv );
  cmn.AddSubscriber( "get_grimsickleramulet", get_grimsickleramulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crazydoctor_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crazydoctor_2" ] =
  {
    type = "get",
    get_obj = "spr_debris_crazydoctor_2",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_morgue_debris"
  };
  --------------------------------------------------------------------------------------------
  local get_crazydoctor_2_inv = function ()

    int.InventoryItemAdd( "inv_crazydoctor", "spr_debris_crazydoctor_2", "assets/levels/levelext/rm_sidesteet/zz_ossuary/inv/inv_crazydoctor_2" );
    levelext_inv.CheckCrazydoctor( 2 );

  end;
  local get_crazydoctor_2_closezz = function ()

    ObjDelete( "gfx_debris_crazydoctor_2" );
    ObjDelete( "spr_morgue_debris_statuette");
    
    if ( cmn.IsEventDone( "get_crazydoctor_2" ) ) and
       ( cmn.IsEventDone( "get_staroflife_1" ) ) and
       ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
       ( cmn.IsEventDone( "get_deeramulet" ) ) then

       ObjDelete( "gzz_morgue_debris" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crazydoctor_2", get_crazydoctor_2_inv );
  cmn.AddSubscriber( "get_crazydoctor_2", get_crazydoctor_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_staroflife_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_staroflife_1" ] =
  {
    type = "get",
    get_obj = "spr_debris_staroflife_1",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_morgue_debris"
  };
  --------------------------------------------------------------------------------------------
  local get_staroflife_1_inv = function ()

    int.InventoryItemAdd( "inv_staroflife", "spr_debris_staroflife_1", "assets/levels/levelext/rm_morgue/zz_debris/inv/inv_staroflife_1" );
    levelext_inv.CheckStaroflife();

  end;
  local get_staroflife_1_closezz = function ()

    ObjDelete( "gfx_debris_staroflife_1" );
    ObjDelete( "spr_morgue_debris_star");

    if ( cmn.IsEventDone( "get_crazydoctor_2" ) ) and
       ( cmn.IsEventDone( "get_staroflife_1" ) ) and
       ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
       ( cmn.IsEventDone( "get_deeramulet" ) ) then

       ObjDelete( "gzz_morgue_debris" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_staroflife_1", get_staroflife_1_inv );
  cmn.AddSubscriber( "get_staroflife_1", get_staroflife_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tridentamulet_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tridentamulet_3" ] =
  {
    type = "get",
    get_obj = "spr_debris_tridentamulet_3",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_morgue_debris"
  };
  --------------------------------------------------------------------------------------------
  local get_tridentamulet_3_inv = function ()

    int.InventoryItemAdd( "inv_tridentamulet", "spr_debris_tridentamulet_3", "assets/levels/levelext/rm_park/zz_pump/inv/inv_tridentamulet_1" );
    levelext_inv.CheckTridentamulet();

  end;
  local get_tridentamulet_3_closezz = function ()

    ObjDelete( "gfx_debris_tridentamulet_3" );
    ObjDelete( "spr_morgue_debris_symbol");

    if ( cmn.IsEventDone( "get_crazydoctor_2" ) ) and
       ( cmn.IsEventDone( "get_staroflife_1" ) ) and
       ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
       ( cmn.IsEventDone( "get_deeramulet" ) ) then

       ObjDelete( "gzz_morgue_debris" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_tridentamulet_3", get_tridentamulet_3_inv );
  cmn.AddSubscriber( "get_tridentamulet_3", get_tridentamulet_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_deeramulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_deeramulet" ] =
  {
    type = "get",
    get_obj = "spr_debris_deeramulet",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_morgue_debris"
  };
  --------------------------------------------------------------------------------------------
  local get_deeramulet_inv = function ()

    int.InventoryItemAdd( "inv_deeramulet", "spr_debris_deeramulet" );

  end;
  local get_deeramulet_closezz = function ()

    ObjDelete( "gfx_debris_deeramulet" );
    ObjDelete( "spr_morgue_debris_deer");

    if ( cmn.IsEventDone( "get_crazydoctor_2" ) ) and
       ( cmn.IsEventDone( "get_staroflife_1" ) ) and
       ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
       ( cmn.IsEventDone( "get_deeramulet" ) ) then

       ObjDelete( "gzz_morgue_debris" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_deeramulet", get_deeramulet_inv );
  cmn.AddSubscriber( "get_deeramulet", get_deeramulet_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_stiletto_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stiletto_3" ] =
  {
    type = "use",
    use_obj = "inv_stiletto",
    use_place = "obj_breach_use_stiletto_3",
    room = private.room_objname,
    zz = "zz_breach",
    zz_gate = "gzz_morgue_breach"
  };
  --------------------------------------------------------------------------------------------
  local use_stiletto_3_inv = function ()

    --int.InventoryItemRemove( "inv_stiletto" );

  end;
  local use_stiletto_3_beg = function ()

    ObjDelete( "obj_breach_use_stiletto_3" );
    ObjDelete( "anm_breach_wire_click" );

  end;
  local use_stiletto_3_end = function ()

    ObjDelete( "spr_breach_part_wire" );
    ObjSet( "spr_breach_tridentamulet_2", { input = true } );
    ObjSet( "gfx_breach_tridentamulet_2", { active = true } );
    ObjDelete( "anm_breach_stiletto" );
    ObjSet( "anm_breach_wire_static", { res = "assets/levels/levelext/rm_morgue/zz_breach/anims/anm_wire_1", animfunc = "DoAnim", playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stiletto_3",     use_stiletto_3_inv );
  cmn.AddSubscriber( "use_stiletto_3",     use_stiletto_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_3",     use_stiletto_3_end, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_3_inv", use_stiletto_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_3_beg", use_stiletto_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_3_end", use_stiletto_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_extendingladder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_extendingladder" ] =
  {
    type = "use",
    use_obj = "inv_extendingladder",
    use_place = "obj_breach_use_extendingladder",
    room = private.room_objname,
    zz = "zz_breach",
    zz_gate = "gzz_morgue_breach"
  };
  --------------------------------------------------------------------------------------------
  local use_extendingladder_inv = function ()

    int.InventoryItemRemove( "inv_extendingladder" );

  end;
  local use_extendingladder_beg = function ()

    ObjDelete( "obj_breach_use_extendingladder" );

  end;
  local use_extendingladder_end = function ()

    ObjDelete( "gzz_morgue_breach" );
    ObjSet( "grm_morgue_hospital", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_morgue_hospital_focus");
    end;
    
    ObjSet( "spr_morgue_breach_ladder_shadow", { alp = 1 } );
    ObjSet( "spr_morgue_breach_ladder", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_extendingladder",     use_extendingladder_inv );
  cmn.AddSubscriber( "use_extendingladder",     use_extendingladder_beg, private.room_objname );
  cmn.AddSubscriber( "use_extendingladder",     use_extendingladder_end, private.room_objname );
  cmn.AddSubscriber( "use_extendingladder_inv", use_extendingladder_inv, private.room_objname );
  cmn.AddSubscriber( "use_extendingladder_beg", use_extendingladder_beg, private.room_objname );
  cmn.AddSubscriber( "use_extendingladder_end", use_extendingladder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_firepoker_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_firepoker_3" ] =
  {
    type = "use",
    use_obj = "inv_firepoker",
    use_place = "obj_char_use_firepoker_3",
    room = private.room_objname,
    zz = "zz_char",
    zz_gate = "gzz_morgue_char"
  };
  --------------------------------------------------------------------------------------------
  local use_firepoker_3_inv = function ()

    if ( cmn.IsEventDone( "use_firepoker_1" ) ) and
       ( cmn.IsEventDone( "use_firepoker_2" ) ) then

      int.InventoryItemRemove( "inv_firepoker" );

    end;

  end;
  local use_firepoker_3_beg = function ()

    ObjDelete( "obj_char_use_firepoker_3" );
    ObjDelete( "anm_char_coals_click" );

  end;
  local use_firepoker_3_end = function ()

    ObjDelete( "spr_morgue_char_trash");
    ObjDelete( "anm_char_firepoker" );
    ObjSet( "spr_char_grimsickleramulet", { alp = 1, input = true } );
    ObjSet( "spr_char_screensaver_4_8",   { input = true } );
    ObjSet( "gfx_char_grimsickleramulet", { active = true } );
    ObjSet( "obj_char_use_tridentamulet", { input = true } );
    ObjSet( "anm_char_cap_open",          { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_firepoker_3",     use_firepoker_3_inv );
  cmn.AddSubscriber( "use_firepoker_3",     use_firepoker_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_3",     use_firepoker_3_end, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_3_inv", use_firepoker_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_3_beg", use_firepoker_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_3_end", use_firepoker_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tridentamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tridentamulet" ] =
  {
    type = "use",
    use_obj = "inv_tridentamulet",
    use_place = "obj_char_use_tridentamulet",
    room = private.room_objname,
    zz = "zz_char",
    zz_gate = "gzz_morgue_char"
  };
  --------------------------------------------------------------------------------------------
  local use_tridentamulet_inv = function ()

    int.InventoryItemRemove( "inv_tridentamulet" );

  end;
  local use_tridentamulet_beg = function ()

    ObjDelete( "obj_char_use_tridentamulet" );

  end;
  local use_tridentamulet_end = function ()

    ObjSet( "spr_morgue_char_open", { alp = 1 });
    ObjSet( "spr_char_extendingladder", { input = true } );
    ObjSet( "gfx_char_extendingladder", { active = true } );
    ObjSet( "anm_char_cap_open", { alp = 1, frame = 106, animfunc = "DoAnim" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tridentamulet",     use_tridentamulet_inv );
  cmn.AddSubscriber( "use_tridentamulet",     use_tridentamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_tridentamulet",     use_tridentamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_tridentamulet_inv", use_tridentamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_tridentamulet_beg", use_tridentamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_tridentamulet_end", use_tridentamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_thermalmatches () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_thermalmatches" ] =
  {
    type = "use",
    use_obj = "inv_thermalmatches",
    use_place = "obj_debris_use_thermalmatches",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_morgue_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_thermalmatches_inv = function ()

    int.InventoryItemRemove( "inv_thermalmatches" );

  end;
  local use_thermalmatches_beg = function ()

    ObjDelete( "obj_debris_use_thermalmatches" );
    ObjDelete( "anm_debris_wax_click" );

  end;
  local use_thermalmatches_end = function ()

    ObjDelete( "anm_debris_thermalmatches" );
    ObjDelete( "spr_morgue_debris_wax");
    ObjSet( "spr_debris_crazydoctor_2", { input = true } );
    ObjSet( "gfx_debris_crazydoctor_2", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_thermalmatches",     use_thermalmatches_inv );
  cmn.AddSubscriber( "use_thermalmatches",     use_thermalmatches_beg, private.room_objname );
  cmn.AddSubscriber( "use_thermalmatches",     use_thermalmatches_end, private.room_objname );
  cmn.AddSubscriber( "use_thermalmatches_inv", use_thermalmatches_inv, private.room_objname );
  cmn.AddSubscriber( "use_thermalmatches_beg", use_thermalmatches_beg, private.room_objname );
  cmn.AddSubscriber( "use_thermalmatches_end", use_thermalmatches_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fireaxe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fireaxe" ] =
  {
    type = "use",
    use_obj = "inv_fireaxe",
    use_place = "obj_debris_use_fireaxe",
    room = private.room_objname,
    zz = "zz_debris",
    zz_gate = "gzz_morgue_debris"
  };
  --------------------------------------------------------------------------------------------
  local use_fireaxe_inv = function ()

    int.InventoryItemRemove( "inv_fireaxe" );

  end;
  local use_fireaxe_beg = function ()

    ObjDelete( "obj_debris_use_fireaxe" );
    ObjDelete( "anm_debris_board_click" );

  end;
  local use_fireaxe_end = function ()

    ObjDelete( "anm_debris_fireaxe" );
    ObjDelete( "spr_morgue_debris_wood_2");
    ObjSet( "spr_morgue_debris_wood_3",   { alp = 1 } );
    ObjSet( "spr_debris_deeramulet",      { input = true } );
    ObjSet( "gfx_debris_deeramulet",      { active = true } );
    ObjSet( "spr_debris_tridentamulet_3", { input = true } );
    ObjSet( "gfx_debris_tridentamulet_3", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fireaxe",     use_fireaxe_inv );
  cmn.AddSubscriber( "use_fireaxe",     use_fireaxe_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireaxe",     use_fireaxe_end, private.room_objname );
  cmn.AddSubscriber( "use_fireaxe_inv", use_fireaxe_inv, private.room_objname );
  cmn.AddSubscriber( "use_fireaxe_beg", use_fireaxe_beg, private.room_objname );
  cmn.AddSubscriber( "use_fireaxe_end", use_fireaxe_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_8()

  int.AddScreensaver( "spr_char_screensaver_4_8" );

end;    
------------------------------------------------------------------------------------------
function private.get_screensaver_4_9()

  int.AddScreensaver( "spr_debris_screensaver_4_9" );

end;  
-----------------------------------------------------------------------
function private.get_tridentamulet_2 ()

  cmn.SetEventDone( "get_tridentamulet_2" );
  cmn.CallEventHandler( "get_tridentamulet_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_extendingladder ()

  cmn.SetEventDone( "get_extendingladder" );
  cmn.CallEventHandler( "get_extendingladder" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_grimsickleramulet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_grimsickleramulet ()

  cmn.SetEventDone( "get_grimsickleramulet" );
  cmn.CallEventHandler( "get_grimsickleramulet" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_extendingladder" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_crazydoctor_2 ()

  cmn.SetEventDone( "get_crazydoctor_2" );
  cmn.CallEventHandler( "get_crazydoctor_2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_crazydoctor_2" ) ) and
     ( cmn.IsEventDone( "get_staroflife_1" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
     ( cmn.IsEventDone( "get_deeramulet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_staroflife_1 ()

  cmn.SetEventDone( "get_staroflife_1" );
  cmn.CallEventHandler( "get_staroflife_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_crazydoctor_2" ) ) and
     ( cmn.IsEventDone( "get_staroflife_1" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
     ( cmn.IsEventDone( "get_deeramulet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_tridentamulet_3 ()

  cmn.SetEventDone( "get_tridentamulet_3" );
  cmn.CallEventHandler( "get_tridentamulet_3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_crazydoctor_2" ) ) and
     ( cmn.IsEventDone( "get_staroflife_1" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
     ( cmn.IsEventDone( "get_deeramulet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_deeramulet ()

  cmn.SetEventDone( "get_deeramulet" );
  cmn.CallEventHandler( "get_deeramulet" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_crazydoctor_2" ) ) and
     ( cmn.IsEventDone( "get_staroflife_1" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
     ( cmn.IsEventDone( "get_deeramulet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_stiletto_3 ()

  local item = "inv_stiletto";

  if ( cmn.ApplyObj( item, "gzz_morgue_breach", false ) ) and
     ( not cmn.IsEventDone( "use_stiletto_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_breach" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_breach_use_stiletto_3", true ) ) and
         ( not cmn.IsEventDone( "use_stiletto_3" ) ) then

    cmn.CallEventHandler( "use_stiletto_3_inv" );
    cmn.CallEventHandler( "use_stiletto_3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_stiletto_3" );
      cmn.CallEventHandler( "use_stiletto_3_end" );
      private.get_tridentamulet_2();

      ObjSet( "anm_breach_wire_static", { alp = 1 } );

    end;

    int.Lock( true );

    ObjSet( "anm_breach_wire_static", { alp = 0 } );
    AnimStop( "anm_breach_wire_static" );

    ObjSet( "anm_breach_stiletto", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_breach_cut_wires" );
    AnimPlay( "anm_breach_stiletto", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_extendingladder ()

  local item = "inv_extendingladder";

  if ( cmn.ApplyObj( item, "gzz_morgue_breach", false ) ) and
     ( not cmn.IsEventDone( "use_extendingladder" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_breach" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_breach_use_extendingladder", true ) ) and
         ( not cmn.IsEventDone( "use_extendingladder" ) ) then

    cmn.CallEventHandler( "use_extendingladder_inv" );
    cmn.CallEventHandler( "use_extendingladder_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_extendingladder" );
      cmn.CallEventHandler( "use_extendingladder_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );

    ObjSet( "anm_breach_extendingladder", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_breach_take_stairway" );
    AnimPlay( "anm_breach_extendingladder", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_firepoker_3 ()

  local item = "inv_firepoker";

  if ( cmn.ApplyObj( item, "gzz_morgue_char", false ) ) and
     ( not cmn.IsEventDone( "use_firepoker_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_char", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_char_use_firepoker_3", true ) ) and
         ( not cmn.IsEventDone( "use_firepoker_3" ) ) then

    cmn.CallEventHandler( "use_firepoker_3_inv" );
    cmn.CallEventHandler( "use_firepoker_3_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_firepoker_3" );
      cmn.CallEventHandler( "use_firepoker_3_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_char_firepoker", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_char_cut_debris" );
    AnimPlay( "anm_char_firepoker", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_tridentamulet ()

  local item = "inv_tridentamulet";

  if ( cmn.ApplyObj( item, "gzz_morgue_char", false ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_1" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_2" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
     ( cmn.IsEventDone( "use_firepoker_3" ) ) and
     ( not cmn.IsEventDone( "use_tridentamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_char", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_char_use_tridentamulet", true ) ) and
         ( cmn.IsEventDone( "get_tridentamulet_1" ) ) and
         ( cmn.IsEventDone( "get_tridentamulet_2" ) ) and
         ( cmn.IsEventDone( "get_tridentamulet_3" ) ) and
         ( cmn.IsEventDone( "use_firepoker_3" ) ) and
         ( not cmn.IsEventDone( "use_tridentamulet" ) ) then

    cmn.CallEventHandler( "use_tridentamulet_inv" );
    cmn.CallEventHandler( "use_tridentamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_tridentamulet" );
      cmn.CallEventHandler( "use_tridentamulet_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_char_insert_3_figures_opens" );
    AnimPlay( "anm_char_cap_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_thermalmatches ()

  local item = "inv_thermalmatches";

  if ( cmn.ApplyObj( item, "gzz_morgue_debris", false ) ) and
     ( not cmn.IsEventDone( "use_thermalmatches" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_debris" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_debris_use_thermalmatches", true ) ) and
         ( not cmn.IsEventDone( "use_thermalmatches" ) ) then

    cmn.CallEventHandler( "use_thermalmatches_inv" );
    cmn.CallEventHandler( "use_thermalmatches_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_thermalmatches" );
      cmn.CallEventHandler( "use_thermalmatches_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_debris_thermalmatches", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_debris_match_fire" );
    AnimPlay( "anm_debris_thermalmatches", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_fireaxe ()

  local item = "inv_fireaxe";

  if ( cmn.ApplyObj( item, "gzz_morgue_debris", false ) ) and
     ( not cmn.IsEventDone( "use_fireaxe" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_debris" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_debris_use_fireaxe", true ) ) and
         ( not cmn.IsEventDone( "use_fireaxe" ) ) then

    cmn.CallEventHandler( "use_fireaxe_inv" );
    cmn.CallEventHandler( "use_fireaxe_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_fireaxe" );
      cmn.CallEventHandler( "use_fireaxe_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_debris_fireaxe", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_debris_cut_axe" );
    AnimPlay( "anm_debris_fireaxe", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_morgue ()

  if not ( cmn.IsEventDone( "opn_morgue" ) ) then

    cmn.SetEventDone( "opn_morgue" );
    cmn.ShowBbt( "bbt_morgue_first_enter" );

  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_morgue_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_morgue_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_morgue();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_tridentamulet_2",                                         { "use_stiletto_3" } );
  int.AddedTaskMap( private.room_objname, "get_extendingladder",                                         { "use_tridentamulet" } );
  int.AddedTaskMap( private.room_objname, "get_grimsickleramulet",                                       { "use_firepoker_3" } );
  int.AddedTaskMap( private.room_objname, "get_crazydoctor_2",                                           { "use_thermalmatches" } );
  int.AddedTaskMap( private.room_objname, "get_staroflife_1",                                            { "use_stiletto_2" } );
  int.AddedTaskMap( private.room_objname, "get_tridentamulet_3",                                         { "use_fireaxe" } );
  int.AddedTaskMap( private.room_objname, "get_deeramulet",                                              { "use_fireaxe" } );

  int.AddedTaskMap( private.room_objname, "use_stiletto_3",                                              { "get_stiletto" } );
  int.AddedTaskMap( private.room_objname, "use_extendingladder",                                         { "get_extendingladder" } );
  int.AddedTaskMap( private.room_objname, "use_firepoker_3",                                             { "get_firepoker" } );
  int.AddedTaskMap( private.room_objname, "use_tridentamulet",                                           { "get_tridentamulet_1", "get_tridentamulet_2", "get_tridentamulet_3", "use_firepoker_3" } );
  int.AddedTaskMap( private.room_objname, "use_thermalmatches",                                          { "get_thermalmatches" } );
  int.AddedTaskMap( private.room_objname, "use_fireaxe",                                                 { "get_fireaxe" } );

  int.AddedTaskMap( private.room_objname, "opn_hospital",                                                { "use_extendingladder" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
--[[
  subroom.Define( "zz_picture" );  
  -------------------------------------------------
  function zz_picture.Open()
  end;
  -------------------------------------------------
  function zz_picture.PreClose()
  end;
  -------------------------------------------------
  function zz_picture.Skip ()
  end;
  -------------------------------------------------
  function zz_picture.Reset ()
  end;
  -------------------------------------------------
]]--
end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
function private.CharCapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_char_use_tridentamulet" );
    int.Lock( false );

  end;

  int.Lock( true );

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_char_clean_chest" );
  ObjAnimate( "anm_char_cap_open", "pos_y", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, 2,
    0.4, 3, 0,
    0.6, 3, 2,
    0.7, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.CharCoalsClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_char_use_firepoker_3" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_char_debris" );
  AnimPlay( "anm_char_coals_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.DebrisWaxClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_debris_use_thermalmatches" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_debris_slime" );
  AnimPlay( "anm_debris_wax_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.DebrisBoardClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_debris_use_fireaxe" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_debris_piece_of_wood" );
  AnimPlay( "anm_debris_board_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.BreachWireClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_breach_use_stiletto_3" );
    int.Lock( false );

    ObjSet( "anm_breach_wire_click", { alp = 0 } );
    AnimStop( "anm_breach_wire_click" );

    ObjSet( "anm_breach_wire_static", { alp = 1 } );
    AnimPlay( "anm_breach_wire_static", "DoAnim", "" );

  end;

  int.Lock( true );

  ObjSet( "anm_breach_wire_static", { alp = 0 } );
  AnimStop( "anm_breach_wire_static" );

  ObjSet( "anm_breach_wire_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_breach_wires" );
  AnimPlay( "anm_breach_wire_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************