-- name=rm_pagantemple
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_pagantemple";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_altar",     "room_hub" );
  ObjAttach( "zz_idol",      "room_hub" );
  ObjAttach( "zz_gargoyles", "room_hub" );
  ObjAttach( "zz_library",   "room_hub" );

  ObjMultiSet(
  {
    { "spr_altar_ritualsickle",            { event_mdown = private.get_ritualsickle } },
    { "spr_altar_gargoylehead",            { event_mdown = private.get_gargoylehead } },
    { "spr_altar_runedice_2",              { event_mdown = private.get_runedice_2 } },
    { "spr_altar_crystalofelements_4",     { event_mdown = private.get_crystalofelements_4 } },
    { "spr_idol_satyrfigurine_2",          { event_mdown = private.get_satyrfigurine_2 } },
    { "spr_idol_minotauramulet_2",         { event_mdown = private.get_minotauramulet_2 } },
    { "spr_idol_krakenamulet",             { event_mdown = private.get_krakenamulet } },
    { "spr_idol_stoneofsouls_5",           { event_mdown = private.get_stoneofsouls_5 } },
    { "spr_gargoyles_stoneofsouls_3",      { event_mdown = private.get_stoneofsouls_3 } },
    { "spr_gargoyles_wings",               { event_mdown = private.get_wings } },
    { "spr_gargoyles_crystalofelements_1", { event_mdown = private.get_crystalofelements_1 } },
    { "spr_library_stoneofsouls_2",        { event_mdown = private.get_stoneofsouls_2 } },
    { "spr_library_brokenstatuette",       { event_mdown = private.get_brokenstatuette } },
    { "obj_gargoyles_use_minotauramulet",  { event_mdown = private.GargoylesDoorsClick } },
    { "spr_altar_satyrfigurine_1",         { event_mdown = private.get_satyrfigurine_1 } },    
    { "spr_library_screensaver_4_16",      { event_mdown = private.get_screensaver_4_16 } },  
    { "obj_pagantemple_demonamulet_get",   { event_mdown = private.get_demonamulet } },          
    { "obj_gargoyles_use_gargoylehead",    { event_mdown = private.GargoylesHeadClick } }, 
    { "obj_idol_use_ritualsickle_1",       { event_mdown = private.IdolKrakenamuletClick } }, 
    { "obj_idol_use_wolfamulet",           { event_mdown = private.IdolCapClick } }, 
    { "obj_library_use_krakenamulet",      { event_mdown = function() private.LibraryBoxClick() end } }, 
    { "obj_altar_use_infamulet",           { event_mdown = function() private.AltarBoxClick() end } },         
  } );

  local get_screensaver_4_16 = function ()

    ObjDelete( "spr_library_screensaver_4_16" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_16", get_screensaver_4_16, private.room_objname );  

  private.InitMiniHO();
  private.book_sound = 0;
  private.demon_sound = 0;
  private.demon_sound_zz = 0;

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_pagantemple = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_pagantemple", update_game_mode_pagantemple, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_6 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_6 = function ()

    ObjDelete( "obj_pagantemple_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_6", get_morphobject_4_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_demonamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_demonamulet" ] =
  {
    type = "get",
    get_obj = "obj_pagantemple_demonamulet_get",
    room = private.room_objname,
  };
  --------------------------------------------------------------------------------------------
  local get_demonamulet_inv = function ()

    int.InventoryItemAdd( "inv_demonamulet", "obj_pagantemple_demonamulet_get" );

  end;
  --------------------------------------------------------------------------------------------
  local get_demonamulet_closezz = function ()

    ObjDelete( "obj_pagantemple_demonamulet" );

  end;
  ------------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_demonamulet", get_demonamulet_inv );
  cmn.AddSubscriber( "get_demonamulet", get_demonamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ritualsickle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ritualsickle" ] =
  {
    type = "get",
    get_obj = "spr_altar_ritualsickle",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local get_ritualsickle_inv = function ()

    int.InventoryItemAdd( "inv_ritualsickle", "spr_altar_ritualsickle" );

  end;
  local get_ritualsickle_closezz = function ()

    ObjDelete( "gfx_altar_ritualsickle" );
    ObjDelete( "obj_altar_ritualsickle" );

    ObjDelete( "spr_pagantemple_altar_ritualsickle" );
    --ObjDelete( "gzz_pagantemple_altar" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_ritualsickle", get_ritualsickle_inv );
  cmn.AddSubscriber( "get_ritualsickle", get_ritualsickle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gargoylehead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gargoylehead" ] =
  {
    type = "get",
    get_obj = "spr_altar_gargoylehead",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local get_gargoylehead_inv = function ()

    int.InventoryItemAdd( "inv_gargoylehead", "spr_altar_gargoylehead" );

  end;
  local get_gargoylehead_closezz = function ()

    ObjDelete( "gfx_altar_gargoylehead" );

    ObjDelete( "spr_pagantemple_altar_gargoylehead" );
    ObjDelete( "spr_altar_gargoylehead_over" );
    --ObjDelete( "gzz_pagantemple_altar" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_gargoylehead", get_gargoylehead_inv );
  cmn.AddSubscriber( "get_gargoylehead", get_gargoylehead_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalofelements_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crystalofelements_4" ] =
  {
    type = "get",
    get_obj = "spr_altar_crystalofelements_4",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local get_crystalofelements_4_inv = function ()

    int.InventoryItemAdd( "inv_crystalofelements", "spr_altar_crystalofelements_4", "assets/levels/levelext/rm_pagantemple/zz_gargoyles/inv/inv_crystalofelements_4" );
    levelext_inv.CheckCrystalofelements();

    if cmn.IsEventDone( "get_crystalofelements_1" ) and 
       cmn.IsEventDone( "get_crystalofelements_2" ) and 
       cmn.IsEventDone( "get_crystalofelements_3" ) then

      ObjSet( "inv_magiccircle_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_crystalofelements_4_closezz = function ()

    ObjDelete( "gzz_pagantemple_altar" );
    ObjDelete( "anm_altar_demon_element_static" );

    ObjDelete( "spr_pagantemple_gargoyles_crystalofelements" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystalofelements_4", get_crystalofelements_4_inv );
  cmn.AddSubscriber( "get_crystalofelements_4", get_crystalofelements_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_satyrfigurine_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_satyrfigurine_2" ] =
  {
    type = "get",
    get_obj = "spr_idol_satyrfigurine_2",
    room = private.room_objname,
    zz = "zz_idol",
    zz_gate = "gzz_pagantemple_idol"
  };
  --------------------------------------------------------------------------------------------
  local get_satyrfigurine_2_inv = function ()

    int.InventoryItemAdd( "inv_satyrfigurine", "spr_idol_satyrfigurine_2", "assets/levels/levelext/rm_dungeon/zz_load/inv/inv_satyrfigurine_1" );
    levelext_inv.CheckSatyrfigurine();

  end;
  local get_satyrfigurine_2_closezz = function ()

    ObjDelete( "gfx_idol_satyrfigurine_2" );
    ObjDelete( "spr_pagantemple_idol_satyrfigurine" );

    if ( cmn.IsEventDone( "get_stoneofsouls_5" ) ) and
       ( cmn.IsEventDone( "get_minotauramulet_2" ) ) and
       ( cmn.IsEventDone( "get_krakenamulet" ) ) then

      ObjDelete( "anm_idol_ritualsickle" );
      ObjDelete( "anm_idol_explosion" );
      ObjSet( "anm_idol_idol", { alp = 1, playing = true } );
      ObjSet( "obj_idol_use_circleofelements", { input = true } );
      ObjDelete( "anm_idol_web" );
      ObjDelete( "spr_pagantemple_idol_head" );
      ObjSet( "anm_pagantemple_idol", { alp = 1, playing = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_satyrfigurine_2", get_satyrfigurine_2_inv );
  cmn.AddSubscriber( "get_satyrfigurine_2", get_satyrfigurine_2_closezz, private.room_objname );
  cmn.AddSubscriber( "get_satyrfigurine_2_inv",     get_satyrfigurine_2_inv );
  cmn.AddSubscriber( "get_satyrfigurine_2_closezz", get_satyrfigurine_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_minotauramulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_minotauramulet_2" ] =
  {
    type = "get",
    get_obj = "spr_idol_minotauramulet_2",
    room = private.room_objname,
    zz = "zz_idol",
    zz_gate = "gzz_pagantemple_idol"
  };
  --------------------------------------------------------------------------------------------
  local get_minotauramulet_2_inv = function ()

    int.InventoryItemAdd( "inv_minotauramulet", "spr_idol_minotauramulet_2", "assets/levels/levelext/rm_prison/zz_runecontainers/inv/inv_minotauramulet_2" );
    levelext_inv.CheckMinotauramulet( 2 );

  end;
  local get_minotauramulet_2_closezz = function ()

    ObjDelete( "gfx_idol_minotauramulet_2" );
    ObjDelete( "spr_idol_minotauramulet_2_over" );
    ObjDelete( "spr_pagantemple_idol_minotauramulet" );

    if ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) and
       ( cmn.IsEventDone( "get_krakenamulet" ) ) and
       ( cmn.IsEventDone( "get_stoneofsouls_5" ) ) then

      ObjDelete( "anm_idol_ritualsickle" );
      ObjDelete( "anm_idol_explosion" );
      ObjSet( "anm_idol_idol", { alp = 1, playing = true } );
      ObjSet( "obj_idol_use_circleofelements", { input = true } );
      ObjDelete( "anm_idol_web" );
      ObjDelete( "spr_pagantemple_idol_head" );
      ObjSet( "anm_pagantemple_idol", { alp = 1, playing = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_minotauramulet_2", get_minotauramulet_2_inv );
  cmn.AddSubscriber( "get_minotauramulet_2", get_minotauramulet_2_closezz, private.room_objname );
  cmn.AddSubscriber( "get_minotauramulet_2_inv",     get_minotauramulet_2_inv );
  cmn.AddSubscriber( "get_minotauramulet_2_closezz", get_minotauramulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_krakenamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_krakenamulet" ] =
  {
    type = "get",
    get_obj = "spr_idol_krakenamulet",
    room = private.room_objname,
    zz = "zz_idol",
    zz_gate = "gzz_pagantemple_idol"
  };
  --------------------------------------------------------------------------------------------
  local get_krakenamulet_inv = function ()

    int.InventoryItemAdd( "inv_krakenamulet", "spr_idol_krakenamulet" );

  end;
  local get_krakenamulet_closezz = function ()

    ObjDelete( "gfx_idol_krakenamulet" );
    ObjDelete( "spr_pagantemple_idol_krakenamulet" );

    if ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) and
       ( cmn.IsEventDone( "get_minotauramulet_2" ) ) and
       ( cmn.IsEventDone( "get_stoneofsouls_5" ) ) then

      ObjDelete( "anm_idol_ritualsickle" );
      ObjDelete( "anm_idol_explosion" );
      ObjSet( "anm_idol_idol", { alp = 1, playing = true } );
      ObjSet( "obj_idol_use_circleofelements", { input = true } );
      ObjDelete( "anm_idol_web" );
      ObjDelete( "spr_pagantemple_idol_head" );
      ObjSet( "anm_pagantemple_idol", { alp = 1, playing = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_krakenamulet", get_krakenamulet_inv );
  cmn.AddSubscriber( "get_krakenamulet", get_krakenamulet_closezz, private.room_objname );
  cmn.AddSubscriber( "get_krakenamulet_inv",     get_krakenamulet_inv );
  cmn.AddSubscriber( "get_krakenamulet_closezz", get_krakenamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stoneofsouls_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stoneofsouls_5" ] =
  {
    type = "get",
    get_obj = "spr_idol_stoneofsouls_5",
    room = private.room_objname,
    zz = "zz_idol",
    zz_gate = "gzz_pagantemple_idol"
  };
  --------------------------------------------------------------------------------------------
  local get_stoneofsouls_5_inv = function ()

    int.InventoryItemAdd( "inv_stoneofsouls", "spr_idol_stoneofsouls_5", "assets/levels/levelext/rm_prison/zz_throneoftorture/inv/inv_stoneofsouls_5" );
    levelext_inv.CheckStoneofsouls();

  end;
  local get_stoneofsouls_5_closezz = function ()

    ObjDelete( "gfx_idol_stoneofsouls_5" );
    ObjDelete( "spr_idol_stoneofsouls_5_light" );
    ObjDelete( "spr_pagantemple_idol_stoneofsouls" );

    if ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) and
       ( cmn.IsEventDone( "get_minotauramulet_2" ) ) and
       ( cmn.IsEventDone( "get_krakenamulet" ) ) then

      ObjDelete( "anm_idol_ritualsickle" );
      ObjDelete( "anm_idol_explosion" );
      ObjSet( "anm_idol_idol", { alp = 1, playing = true } );
      ObjSet( "obj_idol_use_circleofelements", { input = true } );
      ObjDelete( "anm_idol_web" );
      ObjDelete( "spr_pagantemple_idol_head" );
      ObjSet( "anm_pagantemple_idol", { alp = 1, playing = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stoneofsouls_5", get_stoneofsouls_5_inv );
  cmn.AddSubscriber( "get_stoneofsouls_5", get_stoneofsouls_5_closezz, private.room_objname );
  cmn.AddSubscriber( "get_stoneofsouls_5_inv",     get_stoneofsouls_5_inv );
  cmn.AddSubscriber( "get_stoneofsouls_5_closezz", get_stoneofsouls_5_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stoneofsouls_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stoneofsouls_3" ] =
  {
    type = "get",
    get_obj = "spr_gargoyles_stoneofsouls_3",
    room = private.room_objname,
    zz = "zz_gargoyles",
    zz_gate = "gzz_pagantemple_gargoyles"
  };
  --------------------------------------------------------------------------------------------
  local get_stoneofsouls_3_inv = function ()

    int.InventoryItemAdd( "inv_stoneofsouls", "spr_gargoyles_stoneofsouls_3", "assets/levels/levelext/rm_prison/zz_throneoftorture/inv/inv_stoneofsouls_3" );
    levelext_inv.CheckStoneofsouls();

  end;
  local get_stoneofsouls_3_closezz = function ()

    ObjDelete( "gfx_gargoyles_stoneofsouls_3" );
    ObjDelete( "spr_gargoyles_stoneofsouls_3_light_1" );
    ObjDelete( "spr_gargoyles_stoneofsouls_3_over" );
    ObjDelete( "spr_pagantemple_gargoyles_stoneofsouls" );

    if ( cmn.IsEventDone( "get_stoneofsouls_3" ) ) and
       ( cmn.IsEventDone( "get_wings" ) ) and
       ( cmn.IsEventDone( "get_crystalofelements_1" ) ) and
       ( cmn.IsEventDone( "use_gargoylehead" ) ) then

      ObjDelete( "gzz_pagantemple_gargoyles" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stoneofsouls_3", get_stoneofsouls_3_inv );
  cmn.AddSubscriber( "get_stoneofsouls_3", get_stoneofsouls_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wings () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wings" ] =
  {
    type = "get",
    get_obj = "spr_gargoyles_wings",
    room = private.room_objname,
    zz = "zz_gargoyles",
    zz_gate = "gzz_pagantemple_gargoyles"
  };
  --------------------------------------------------------------------------------------------
  local get_wings_inv = function ()

    int.InventoryItemAdd( "inv_wings", "spr_gargoyles_wings" );

    if cmn.IsEventDone( "get_brokenstatuette" ) then
      ObjSet( "inv_brokenstatuette_plus_focus2", { alp = 1 } );
    end;

  end;
  local get_wings_closezz = function ()

    ObjDelete( "gfx_gargoyles_wings" );
    ObjDelete( "spr_pagantemple_gargoyles_wings" );

    if ( cmn.IsEventDone( "get_stoneofsouls_3" ) ) and
       ( cmn.IsEventDone( "get_wings" ) ) and
       ( cmn.IsEventDone( "get_crystalofelements_1" ) ) and
       ( cmn.IsEventDone( "use_gargoylehead" ) ) then

      ObjDelete( "gzz_pagantemple_gargoyles" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_wings", get_wings_inv );
  cmn.AddSubscriber( "get_wings", get_wings_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalofelements_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crystalofelements_1" ] =
  {
    type = "get",
    get_obj = "spr_gargoyles_crystalofelements_1",
    room = private.room_objname,
    zz = "zz_gargoyles",
    zz_gate = "gzz_pagantemple_gargoyles"
  };
  --------------------------------------------------------------------------------------------
  local get_crystalofelements_1_inv = function ()

    int.InventoryItemAdd( "inv_crystalofelements", "spr_gargoyles_crystalofelements_1", "assets/levels/levelext/rm_pagantemple/zz_gargoyles/inv/inv_crystalofelements_1" );
    levelext_inv.CheckCrystalofelements();

    if cmn.IsEventDone( "get_crystalofelements_2" ) and 
       cmn.IsEventDone( "get_crystalofelements_3" ) and 
       cmn.IsEventDone( "get_crystalofelements_4" ) then

      ObjSet( "inv_magiccircle_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_crystalofelements_1_closezz = function ()

    ObjDelete( "gfx_gargoyles_crystalofelements_1" );
    ObjDelete( "spr_pagantemple_gargoyles_crystalofelements" );

    if ( cmn.IsEventDone( "get_stoneofsouls_3" ) ) and
       ( cmn.IsEventDone( "get_wings" ) ) and
       ( cmn.IsEventDone( "get_crystalofelements_1" ) ) and
       ( cmn.IsEventDone( "use_gargoylehead" ) ) then

      ObjDelete( "gzz_pagantemple_gargoyles" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystalofelements_1", get_crystalofelements_1_inv );
  cmn.AddSubscriber( "get_crystalofelements_1", get_crystalofelements_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bonekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bonekey" ] =
  {
    type = "get",
    get_obj = "spr_library_ho1",
    room = private.room_objname,
    zz = "zz_library",
    zz_gate = "gzz_pagantemple_library"
  };
  --------------------------------------------------------------------------------------------
  local get_bonekey_inv = function ()

    int.InventoryItemAdd( "inv_bonekey", "spr_library_win" );

  end;
  local get_bonekey_closezz = function ()

    ObjDelete( "obj_library_miniho" );

    if ( cmn.IsEventDone( "get_brokenstatuette" ) ) then

      ObjDelete( "gzz_pagantemple_library" );

    end;

    ObjDelete( "spr_pagantemple_library_ho" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_bonekey", get_bonekey_inv );
  cmn.AddSubscriber( "get_bonekey", get_bonekey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stoneofsouls_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stoneofsouls_2" ] =
  {
    type = "get",
    get_obj = "spr_library_stoneofsouls_2",
    room = private.room_objname,
    zz = "zz_library",
    zz_gate = "gzz_pagantemple_library"
  };
  --------------------------------------------------------------------------------------------
  local get_stoneofsouls_2_inv = function ()

    int.InventoryItemAdd( "inv_stoneofsouls", "spr_library_stoneofsouls_2", "assets/levels/levelext/rm_prison/zz_throneoftorture/inv/inv_stoneofsouls_2" );
    levelext_inv.CheckStoneofsouls();

  end;
  local get_stoneofsouls_2_closezz = function ()

    ObjDelete( "gfx_library_stoneofsouls_2" );
    ObjDelete( "spr_library_stoneofsouls_light_1" );
    ObjDelete( "spr_library_stoneofsouls_light_2" );
    --ObjDelete( "gzz_pagantemple_library" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stoneofsouls_2", get_stoneofsouls_2_inv );
  cmn.AddSubscriber( "get_stoneofsouls_2", get_stoneofsouls_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenstatuette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenstatuette" ] =
  {
    type = "get",
    get_obj = "spr_library_brokenstatuette",
    room = private.room_objname,
    zz = "zz_library",
    zz_gate = "gzz_pagantemple_library"
  };
  --------------------------------------------------------------------------------------------
  local get_brokenstatuette_inv = function ()

    int.InventoryItemAdd( "inv_brokenstatuette", "spr_library_brokenstatuette" );
    ObjSet( "inv_brokenstatuette", { drag = false } );

    if not cmn.IsEventDone( "get_wings" ) then
      ObjSet( "inv_brokenstatuette_plus_focus2", { alp = 0 } );
    end;

  end;
  local get_brokenstatuette_closezz = function ()

    ObjDelete( "gfx_library_brokenstatuette" );

    if ( cmn.IsEventDone( "get_bonekey" ) ) then

      ObjDelete( "gzz_pagantemple_library" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_brokenstatuette", get_brokenstatuette_inv );
  cmn.AddSubscriber( "get_brokenstatuette", get_brokenstatuette_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_satyrfigurine_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_satyrfigurine_1" ] =
  {
    type = "get",
    get_obj = "spr_altar_satyrfigurine_1",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local get_satyrfigurine_1_inv = function ()

    int.InventoryItemAdd( "inv_satyrfigurine", "spr_altar_satyrfigurine_1", "assets/levels/levelext/rm_dungeon/zz_load/inv/inv_satyrfigurine_1" );
    levelext_inv.CheckSatyrfigurine();

  end;
  local get_satyrfigurine_1_closezz = function ()

    ObjDelete( "gfx_altar_satyrfigurine_1" );
    --ObjDelete( "gzz_dungeon_load" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_satyrfigurine_1", get_satyrfigurine_1_inv );
  cmn.AddSubscriber( "get_satyrfigurine_1", get_satyrfigurine_1_closezz, private.room_objname );  
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_runedice () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_runedice" ] =
  {
    type = "use",
    use_obj = "inv_runedice",
    use_place = "obj_altar_use_runedice",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local use_runedice_inv = function ()

    int.InventoryItemRemove( "inv_runedice" );

  end;
  local use_runedice_beg = function ()

    ObjDelete( "obj_altar_use_runedice" );

  end;
  local use_runedice_end = function ()

    ObjSet( "obj_altar_runedices", { alp = 1 } );
    ObjSet( "anm_altar_use_runedice", { frame = 500 } );

    if cmn.IsEventDone( "use_creepystatue" ) then

      ObjSet( "obj_altar_use_stoneofsouls", { input = true } );
      ObjSet( "anm_altar_demon_static",     { alp = 1 } );
      ObjDelete( "anm_altar_demon_appear" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_runedice",     use_runedice_inv );
  cmn.AddSubscriber( "use_runedice",     use_runedice_beg, private.room_objname );
  cmn.AddSubscriber( "use_runedice",     use_runedice_end, private.room_objname );
  cmn.AddSubscriber( "use_runedice_inv", use_runedice_inv, private.room_objname );
  cmn.AddSubscriber( "use_runedice_beg", use_runedice_beg, private.room_objname );
  cmn.AddSubscriber( "use_runedice_end", use_runedice_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stoneofsouls () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stoneofsouls" ] =
  {
    type = "use",
    use_obj = "inv_stoneofsouls",
    use_place = "obj_altar_use_stoneofsouls",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local use_stoneofsouls_inv = function ()

    int.InventoryItemRemove( "inv_stoneofsouls" );

  end;
  local use_stoneofsouls_beg = function ()

    ObjDelete( "obj_altar_use_stoneofsouls" );
    ObjDelete( "anm_altar_demon_static" );
    ObjDelete( "anm_altar_demon_slots_static" );

  end;
  local use_stoneofsouls_end = function ()

    ObjDelete( "anm_altar_demon_disappear" );
    ObjDelete( "anm_altar_demon_craft" );
    ObjSet( "anm_altar_demon_element_static", { alp = 1, playing = true } );
    ObjSet( "spr_altar_crystalofelements_4", { input = true } );
    ObjSet( "gfx_altar_crystalofelements_4", { active = true } );

    ObjDelete( "obj_pagantemple_daemon" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stoneofsouls",     use_stoneofsouls_inv );
  cmn.AddSubscriber( "use_stoneofsouls",     use_stoneofsouls_beg, private.room_objname );
  cmn.AddSubscriber( "use_stoneofsouls",     use_stoneofsouls_end, private.room_objname );
  cmn.AddSubscriber( "use_stoneofsouls_inv", use_stoneofsouls_inv, private.room_objname );
  cmn.AddSubscriber( "use_stoneofsouls_beg", use_stoneofsouls_beg, private.room_objname );
  cmn.AddSubscriber( "use_stoneofsouls_end", use_stoneofsouls_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_infamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_infamulet" ] =
  {
    type = "use",
    use_obj = "inv_infamulet",
    use_place = "obj_altar_use_infamulet",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local use_infamulet_inv = function ()

    int.InventoryItemRemove( "inv_infamulet" );

  end;
  local use_infamulet_beg = function ()

    ObjDelete( "obj_altar_use_infamulet" );

  end;
  local use_infamulet_end = function ()

    ObjDelete( "obj_altar_infamulet_box_close" );
    ObjSet( "obj_altar_infamulet_box_open", { input = true } );
    ObjSet( "gfx_altar_satyrfigurine_1", { active = true } );
    ObjSet( "anm_altar_use_infamulet", { alp = 1, frame = 500 } );

    ObjDelete( "spr_pagantemple_altar_casket_cap_closed" );
    ObjSet( "spr_pagantemple_altar_casket_cap_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_infamulet",     use_infamulet_inv );
  cmn.AddSubscriber( "use_infamulet",     use_infamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_infamulet",     use_infamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_infamulet_inv", use_infamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_infamulet_beg", use_infamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_infamulet_end", use_infamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_amphisamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_amphisamulet" ] =
  {
    type = "use",
    use_obj = "inv_amphisamulet",
    use_place = "obj_altar_use_amphisamulet",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local use_amphisamulet_inv = function ()

    int.InventoryItemRemove( "inv_amphisamulet" );

  end;
  local use_amphisamulet_beg = function ()

    ObjDelete( "obj_altar_use_amphisamulet" );

  end;
  local use_amphisamulet_end = function ()

    ObjDelete( "obj_altar_amphisamulet_box_close" );
    ObjSet( "obj_altar_amphisamulet_box_open", { input = true } );
    ObjSet( "gfx_altar_gargoylehead", { active = true } );

    ObjDelete( "spr_pagantemple_altar_amphisamulet_cap_closed" );
    ObjSet( "spr_pagantemple_altar_amphisamulet_cap_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_amphisamulet",     use_amphisamulet_inv );
  cmn.AddSubscriber( "use_amphisamulet",     use_amphisamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_amphisamulet",     use_amphisamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_amphisamulet_inv", use_amphisamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_amphisamulet_beg", use_amphisamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_amphisamulet_end", use_amphisamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_creepystatue () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_creepystatue" ] =
  {
    type = "use",
    use_obj = "inv_creepystatue",
    use_place = "obj_altar_use_creepystatue",
    room = private.room_objname,
    zz = "zz_altar",
    zz_gate = "gzz_pagantemple_altar"
  };
  --------------------------------------------------------------------------------------------
  local use_creepystatue_inv = function ()

    int.InventoryItemRemove( "inv_creepystatue" );

  end;
  local use_creepystatue_beg = function ()

    ObjDelete( "obj_altar_use_creepystatue" );

  end;
  local use_creepystatue_end = function ()

    if cmn.IsEventDone( "use_runedice" ) then

      ObjSet( "obj_altar_use_stoneofsouls", { input = true } );
      ObjSet( "anm_altar_demon_static",     { alp = 1 } );
      ObjDelete( "anm_altar_demon_appear" );

    end;

    ObjSet( "anm_altar_use_creepystatue", { frame = 500 } );
    ObjSet( "spr_altar_light1", { alp = 1 } );
    ObjDelete( "spr_altar_light2" );

    ObjSet( "spr_pagantemple_altar_creepystatue", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_creepystatue",     use_creepystatue_inv );
  cmn.AddSubscriber( "use_creepystatue",     use_creepystatue_beg, private.room_objname );
  cmn.AddSubscriber( "use_creepystatue",     use_creepystatue_end, private.room_objname );
  cmn.AddSubscriber( "use_creepystatue_inv", use_creepystatue_inv, private.room_objname );
  cmn.AddSubscriber( "use_creepystatue_beg", use_creepystatue_beg, private.room_objname );
  cmn.AddSubscriber( "use_creepystatue_end", use_creepystatue_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ritualsickle_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ritualsickle_1" ] =
  {
    type = "use",
    use_obj = "inv_ritualsickle",
    use_place = "obj_idol_use_ritualsickle_1",
    room = private.room_objname,
    zz = "zz_idol",
    zz_gate = "gzz_pagantemple_idol"
  };
  --------------------------------------------------------------------------------------------
  local use_ritualsickle_1_inv = function ()

    --int.InventoryItemRemove( "inv_ritualsickle" );

  end;
  local use_ritualsickle_1_beg = function ()

    ObjDelete( "obj_idol_use_ritualsickle_1" );
    ObjDelete( "anm_idol_krakenamulet_click" );

  end;
  local use_ritualsickle_1_end = function ()

    ObjSet( "anm_idol_ritualsickle", { alp = 1, frame = 100, animfunc = "DoAnim" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ritualsickle_1",     use_ritualsickle_1_inv );
  cmn.AddSubscriber( "use_ritualsickle_1",     use_ritualsickle_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_1",     use_ritualsickle_1_end, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_1_inv", use_ritualsickle_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_1_beg", use_ritualsickle_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_ritualsickle_1_end", use_ritualsickle_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wolfamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wolfamulet" ] =
  {
    type = "use",
    use_obj = "inv_wolfamulet",
    use_place = "obj_idol_use_wolfamulet",
    room = private.room_objname,
    zz = "zz_idol",
    zz_gate = "gzz_pagantemple_idol"
  };
  --------------------------------------------------------------------------------------------
  local use_wolfamulet_inv = function ()

    int.InventoryItemRemove( "inv_wolfamulet" );

  end;
  local use_wolfamulet_beg = function ()

    ObjDelete( "obj_idol_use_wolfamulet" );
    ObjDelete( "anm_idol_cap_click" );

  end;
  local use_wolfamulet_end = function ()

    ObjSet( "anm_idol_wolfamulet", { alp = 1, frame = 71, animfunc = "DoAnim" } );
    ObjSet( "spr_idol_satyrfigurine_2", { input = true } );
    ObjSet( "gfx_idol_satyrfigurine_2", { active = true } );
    ObjSet( "spr_idol_stoneofsouls_5",  { input = true } );
    ObjSet( "gfx_idol_stoneofsouls_5",  { active = true } );

    ObjDelete( "spr_pagantemple_idol_wolfamulet_cap_closed" );
    ObjSet( "spr_pagantemple_idol_wolfamulet_cap_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wolfamulet",     use_wolfamulet_inv );
  cmn.AddSubscriber( "use_wolfamulet",     use_wolfamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_wolfamulet",     use_wolfamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_wolfamulet_inv", use_wolfamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_wolfamulet_beg", use_wolfamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_wolfamulet_end", use_wolfamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_circleofelements () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_circleofelements" ] =
  {
    type = "use",
    use_obj = "inv_circleofelements",
    use_place = "obj_idol_use_circleofelements",
    room = private.room_objname,
    zz = "zz_idol",
    zz_gate = "gzz_pagantemple_idol"
  };
  --------------------------------------------------------------------------------------------
  local use_circleofelements_inv = function ()

    int.InventoryItemRemove( "inv_circleofelements" );

  end;
  local use_circleofelements_beg = function ()

    ObjDelete( "obj_idol_use_circleofelements" );

  end;
  local use_circleofelements_end = function ()

    ObjDelete( "gzz_pagantemple_idol" );
    ObjDelete( "anm_pagantemple_idol" );
    ObjSet( "obj_pagantemple_portal", { alp = 1, active = true } );    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_circleofelements",     use_circleofelements_inv );
  cmn.AddSubscriber( "use_circleofelements",     use_circleofelements_beg, private.room_objname );
  cmn.AddSubscriber( "use_circleofelements",     use_circleofelements_end, private.room_objname );
  cmn.AddSubscriber( "use_circleofelements_inv", use_circleofelements_inv, private.room_objname );
  cmn.AddSubscriber( "use_circleofelements_beg", use_circleofelements_beg, private.room_objname );
  cmn.AddSubscriber( "use_circleofelements_end", use_circleofelements_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_minotauramulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_minotauramulet" ] =
  {
    type = "use",
    use_obj = "inv_minotauramulet",
    use_place = "obj_gargoyles_use_minotauramulet",
    room = private.room_objname,
    zz = "zz_gargoyles",
    zz_gate = "gzz_pagantemple_gargoyles"
  };
  --------------------------------------------------------------------------------------------
  local use_minotauramulet_inv = function ()

    int.InventoryItemRemove( "inv_minotauramulet" );

  end;
  local use_minotauramulet_beg = function ()

    ObjDelete( "obj_gargoyles_use_minotauramulet" );
    ObjDelete( "anm_gargoyles_door_click" );

  end;
  local use_minotauramulet_end = function ()

    ObjSet( "spr_gargoyles_wings", { input = true } );
    ObjSet( "gfx_gargoyles_wings", { active = true } );
    ObjSet( "spr_gargoyles_crystalofelements_1", { input = true } );
    ObjSet( "gfx_gargoyles_crystalofelements_1", { active = true } );

    ObjDelete( "spr_pagantemple_gargoyles_minotauramulet_cap_close" );
    ObjSet( "spr_pagantemple_gargoyles_cache_cap_open", { alp = 1 } );
    ObjDelete( "anm_gargoyles_open_door" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_minotauramulet",     use_minotauramulet_inv );
  cmn.AddSubscriber( "use_minotauramulet",     use_minotauramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_minotauramulet",     use_minotauramulet_end, private.room_objname );
  cmn.AddSubscriber( "use_minotauramulet_inv", use_minotauramulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_minotauramulet_beg", use_minotauramulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_minotauramulet_end", use_minotauramulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gargoylehead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gargoylehead" ] =
  {
    type = "use",
    use_obj = "inv_gargoylehead",
    use_place = "obj_gargoyles_use_gargoylehead",
    room = private.room_objname,
    zz = "zz_gargoyles",
    zz_gate = "gzz_pagantemple_gargoyles"
  };
  --------------------------------------------------------------------------------------------
  local use_gargoylehead_inv = function ()

    int.InventoryItemRemove( "inv_gargoylehead" );

  end;
  local use_gargoylehead_beg = function ()

    ObjDelete( "obj_gargoyles_use_gargoylehead" );
    ObjSet( "spr_pagantemple_gargoyles_gargoylehead", { alp = 1 } );

  end;
  local use_gargoylehead_end = function ()

    ObjSet( "anm_gargoyles_gargoylehead", { alp = 1, frame = 72, animfunc = "DoAnim" } );

    if ( cmn.IsEventDone( "get_stoneofsouls_3" ) ) and
       ( cmn.IsEventDone( "get_wings" ) ) and
       ( cmn.IsEventDone( "get_crystalofelements_1" ) ) and
       ( cmn.IsEventDone( "use_gargoylehead" ) ) then

      ObjDelete( "gzz_pagantemple_gargoyles" );

    end;

    ObjSet( "gho_pagantemple_hogargoyle", { alp = 1, input = true, active = true } );
    ObjSet( "anm_pagantemple_open_ho", { frame = 500 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gargoylehead",     use_gargoylehead_inv );
  cmn.AddSubscriber( "use_gargoylehead",     use_gargoylehead_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoylehead",     use_gargoylehead_end, private.room_objname );
  cmn.AddSubscriber( "use_gargoylehead_inv", use_gargoylehead_inv, private.room_objname );
  cmn.AddSubscriber( "use_gargoylehead_beg", use_gargoylehead_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoylehead_end", use_gargoylehead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gargoylefigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gargoylefigurine" ] =
  {
    type = "use",
    use_obj = "inv_gargoylefigurine",
    use_place = "obj_library_use_gargoylefigurine",
    room = private.room_objname,
    zz = "zz_library",
    zz_gate = "gzz_pagantemple_library"
  };
  --------------------------------------------------------------------------------------------
  local use_gargoylefigurine_inv = function ()

    int.InventoryItemRemove( "inv_gargoylefigurine" );

  end;
  local use_gargoylefigurine_beg = function ()

    ObjDelete( "obj_library_use_gargoylefigurine" );

  end;
  local use_gargoylefigurine_end = function ()

    ObjDelete( "anm_library_book_with_chain" );
    ObjDelete( "anm_library_use_gargoylefigurine" );
    ObjSet( "anm_library_book", { alp = 1 } );
    ObjSet( "obj_library_rolls", { input = true } );

    ObjDelete( "spr_pagantemple_library_chain_closed" );
    ObjSet( "spr_pagantemple_library_chain_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gargoylefigurine",     use_gargoylefigurine_inv );
  cmn.AddSubscriber( "use_gargoylefigurine",     use_gargoylefigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoylefigurine",     use_gargoylefigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_gargoylefigurine_inv", use_gargoylefigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_gargoylefigurine_beg", use_gargoylefigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_gargoylefigurine_end", use_gargoylefigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_krakenamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_krakenamulet" ] =
  {
    type = "use",
    use_obj = "inv_krakenamulet",
    use_place = "obj_library_use_krakenamulet",
    room = private.room_objname,
    zz = "zz_library",
    zz_gate = "gzz_pagantemple_library"
  };
  --------------------------------------------------------------------------------------------
  local use_krakenamulet_inv = function ()

    int.InventoryItemRemove( "inv_krakenamulet" );

  end;
  local use_krakenamulet_beg = function ()

    ObjDelete( "obj_library_use_krakenamulet" );

  end;
  local use_krakenamulet_end = function ()

    ObjSet( "spr_library_krakenamulet_shadow", { alp = 1 } );
    ObjSet( "spr_library_krakenamulet", { alp = 1 } );
    ObjSet( "anm_library_use_krakenamulet", { alp = 1, frame = 500 } );
    ObjSet( "obj_library_box_open", { input = true } );
    ObjSet( "gfx_library_brokenstatuette", { active = true } );
    ObjDelete( "obj_library_box_close" );

    ObjSet( "spr_pagantemple_library_open_casket", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_krakenamulet",     use_krakenamulet_inv );
  cmn.AddSubscriber( "use_krakenamulet",     use_krakenamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_krakenamulet",     use_krakenamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_krakenamulet_inv", use_krakenamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_krakenamulet_beg", use_krakenamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_krakenamulet_end", use_krakenamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_altar_slots () end;
  --------------------------------------------------------------------------------------------
  local see_altar_slots_inv = function ()

  end;
  local see_altar_slots_beg = function ()

  end;
  local see_altar_slots_end = function ()

    ObjDelete( "anm_altar_demon_slots_appear" );
    ObjSet( "anm_altar_demon_slots_static", { alp = 1, playing = true } );

    ObjSet( "anm_pagantemple_daemon_slots", { playing = true, alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "see_altar_slots",     see_altar_slots_inv );
  cmn.AddSubscriber( "see_altar_slots",     see_altar_slots_beg, private.room_objname );
  cmn.AddSubscriber( "see_altar_slots",     see_altar_slots_end, private.room_objname );
  cmn.AddSubscriber( "see_altar_slots_inv", see_altar_slots_inv, private.room_objname );
  cmn.AddSubscriber( "see_altar_slots_beg", see_altar_slots_beg, private.room_objname );
  cmn.AddSubscriber( "see_altar_slots_end", see_altar_slots_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function dlg_square_emily4_3 () end;
  --------------------------------------------------------------------------------------------
  local dlg_pagantemple_emily4_3_beg = function ()

  end;
  -----------------------------------------------
  local dlg_pagantemple_emily4_3_end = function ()

    ObjDelete( "dlg_pagantemple_emily4_3" );

  end;

  cmn.AddSubscriber( "dlg_pagantemple_emily4_3",     dlg_pagantemple_emily4_3_beg );
  cmn.AddSubscriber( "dlg_pagantemple_emily4_3",     dlg_pagantemple_emily4_3_end );
  cmn.AddSubscriber( "dlg_pagantemple_emily4_3_beg", dlg_pagantemple_emily4_3_beg );
  cmn.AddSubscriber( "dlg_pagantemple_emily4_3_end", dlg_pagantemple_emily4_3_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_square_demon4_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_pagantemple_demon4_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_pagantemple_demon4_1_end = function ()

    ObjDelete( "dlg_pagantemple_demon4_1" );

    ObjSet( "obj_pagantemple_daemon", { alp = 1 } );

  end;

  cmn.AddSubscriber( "dlg_pagantemple_demon4_1",     dlg_pagantemple_demon4_1_beg );
  cmn.AddSubscriber( "dlg_pagantemple_demon4_1",     dlg_pagantemple_demon4_1_end );
  cmn.AddSubscriber( "dlg_pagantemple_demon4_1_beg", dlg_pagantemple_demon4_1_beg );
  cmn.AddSubscriber( "dlg_pagantemple_demon4_1_end", dlg_pagantemple_demon4_1_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_square_witch4_1 () end;
  --------------------------------------------------------------------------------------------
  local dlg_pagantemple_witch4_1_beg = function ()

  end;
  -----------------------------------------------
  local dlg_pagantemple_witch4_1_end = function ()

    ObjDelete( "dlg_pagantemple_witch4_1" );

  end;

  cmn.AddSubscriber( "dlg_pagantemple_witch4_1",     dlg_pagantemple_witch4_1_beg );
  cmn.AddSubscriber( "dlg_pagantemple_witch4_1",     dlg_pagantemple_witch4_1_end );
  cmn.AddSubscriber( "dlg_pagantemple_witch4_1_beg", dlg_pagantemple_witch4_1_beg );
  cmn.AddSubscriber( "dlg_pagantemple_witch4_1_end", dlg_pagantemple_witch4_1_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------------------------------
function private.get_demonamulet ()

  cmn.SetEventDone( "get_demonamulet" );
  cmn.CallEventHandler( "get_demonamulet" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_screensaver_4_16()

  int.AddScreensaver( "spr_library_screensaver_4_16" );

end;  
-----------------------------------------------------------------------
function private.get_ritualsickle ()

  cmn.SetEventDone( "get_ritualsickle" );
  cmn.CallEventHandler( "get_ritualsickle" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_gargoylehead ()

  cmn.SetEventDone( "get_gargoylehead" );
  cmn.CallEventHandler( "get_gargoylehead" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_runedice_2 ()

  cmn.SetEventDone( "get_runedice_2" );
  cmn.CallEventHandler( "get_runedice_2" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_crystalofelements_4 ()

  ObjSet( "spr_altar_crystalofelements_4", { alp = 1 } );

  cmn.SetEventDone( "get_crystalofelements_4" );
  cmn.CallEventHandler( "get_crystalofelements_4" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

  if ( cmn.IsEventDone( "get_crystalofelements_1" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_2" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_4" ) ) then

    interface.KeyTaskDone( true, "task_4_8" );

  end;

end;
-----------------------------------------------------------------------
function private.get_satyrfigurine_2 ()

  ObjSet( "gfx_idol_satyrfigurine_2", { alp = 0 } );
  cmn.CallEventHandler( "get_satyrfigurine_2_inv" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "get_satyrfigurine_2" );
    cmn.CallEventHandler( "get_satyrfigurine_2_closezz" );
    cmn.GetObjectSfx();
    levelext_inv.CheckSatyrfigurine();

  end;

  if ( cmn.IsEventDone( "get_stoneofsouls_5" ) ) and
     ( cmn.IsEventDone( "get_minotauramulet_2" ) ) and
     ( cmn.IsEventDone( "get_krakenamulet" ) ) then

    int.Lock( true );

    ObjSet( "anm_idol_ritualsickle", { alp = 0 } );
    ObjSet( "anm_idol_explosion",    { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_idol_idol_appears" );
    AnimPlay( "anm_idol_explosion", "DoAnim", func_end );

    ObjAnimate( "anm_idol_web", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.1, 3, 1.0,
      0.3, 3, 0.0,
    } );

  else

    func_end();

  end;

end;
-----------------------------------------------------------------------
function private.get_minotauramulet_2 ()

  ObjSet( "gfx_idol_minotauramulet_2", { alp = 0 } );
  ObjSet( "spr_idol_minotauramulet_2_over", { alp = 0 } );
  cmn.CallEventHandler( "get_minotauramulet_2_inv" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "get_minotauramulet_2" );
    cmn.CallEventHandler( "get_minotauramulet_2_closezz" );
    cmn.GetObjectSfx();
    levelext_inv.CheckMinotauramulet( 2 );

  end;

  if ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) and
     ( cmn.IsEventDone( "get_krakenamulet" ) ) and
     ( cmn.IsEventDone( "get_stoneofsouls_5" ) ) then

    int.Lock( true );

    ObjSet( "anm_idol_ritualsickle", { alp = 0 } );
    ObjSet( "anm_idol_explosion",    { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_idol_idol_appears" );
    AnimPlay( "anm_idol_explosion", "DoAnim", func_end );

    ObjAnimate( "anm_idol_web", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.1, 3, 1.0,
      0.3, 3, 0.0,
    } );

  else

    func_end();

  end;

end;
-----------------------------------------------------------------------
function private.get_krakenamulet ()

  ObjSet( "gfx_idol_krakenamulet", { alp = 0 } );
  ObjSet( "spr_idol_krakenamulet", { alp = 1 } );
  cmn.CallEventHandler( "get_krakenamulet_inv" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "get_krakenamulet" );
    cmn.CallEventHandler( "get_krakenamulet_closezz" );
    cmn.GetObjectSfx();

  end;

  if ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) and
     ( cmn.IsEventDone( "get_minotauramulet_2" ) ) and
     ( cmn.IsEventDone( "get_stoneofsouls_5" ) ) then

    int.Lock( true );

    ObjSet( "anm_idol_ritualsickle", { alp = 0 } );
    ObjSet( "anm_idol_explosion",    { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_idol_idol_appears" );
    AnimPlay( "anm_idol_explosion", "DoAnim", func_end );

    ObjAnimate( "anm_idol_web", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.1, 3, 1.0,
      0.3, 3, 0.0,
    } );

  else

    func_end();

  end;

end;

-----------------------------------------------------------------------
function private.get_stoneofsouls_5 ()

  ObjSet( "gfx_idol_stoneofsouls_5", { alp = 0 } );
  cmn.CallEventHandler( "get_stoneofsouls_5_inv" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "get_stoneofsouls_5" );
    cmn.CallEventHandler( "get_stoneofsouls_5_closezz" );
    cmn.GetObjectSfx();
    levelext_inv.CheckStoneofsouls();

  end;

  if ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) and
     ( cmn.IsEventDone( "get_minotauramulet_2" ) ) and
     ( cmn.IsEventDone( "get_krakenamulet" ) ) then

    int.Lock( true );

    ObjSet( "anm_idol_ritualsickle", { alp = 0 } );
    ObjSet( "anm_idol_explosion",    { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_idol_idol_appears" );
    AnimPlay( "anm_idol_explosion", "DoAnim", func_end );

    ObjAnimate( "anm_idol_web", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.1, 3, 1.0,
      0.3, 3, 0.0,
    } );

  else

    func_end();

  end;

end;
-----------------------------------------------------------------------
function private.get_stoneofsouls_3 ()

  cmn.SetEventDone( "get_stoneofsouls_3" );
  cmn.CallEventHandler( "get_stoneofsouls_3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_stoneofsouls_3" ) ) and
     ( cmn.IsEventDone( "get_wings" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_wings ()

  cmn.SetEventDone( "get_wings" );
  cmn.CallEventHandler( "get_wings" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_stoneofsouls_3" ) ) and
     ( cmn.IsEventDone( "get_wings" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_crystalofelements_1 ()

  cmn.SetEventDone( "get_crystalofelements_1" );
  cmn.CallEventHandler( "get_crystalofelements_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_crystalofelements_1" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_2" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_4" ) ) then

    interface.KeyTaskDone( true, "task_4_8" );

  end;

  if ( cmn.IsEventDone( "get_stoneofsouls_3" ) ) and
     ( cmn.IsEventDone( "get_wings" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function public.get_bonekey ()

  if ( cmn.IsEventDone( "get_brokenstatuette" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_stoneofsouls_2 ()

  cmn.SetEventDone( "get_stoneofsouls_2" );
  cmn.CallEventHandler( "get_stoneofsouls_2" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_brokenstatuette ()

  cmn.SetEventDone( "get_brokenstatuette" );
  cmn.CallEventHandler( "get_brokenstatuette" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_bonekey" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_satyrfigurine_1 ()

  cmn.SetEventDone( "get_satyrfigurine_1" );
  cmn.CallEventHandler( "get_satyrfigurine_1" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_runedice ()

  local item = "inv_runedice";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_altar", false ) ) and
     ( not cmn.IsEventDone( "use_runedice" ) ) and 
       cmn.IsEventDone( "get_runedice_1" ) and 
       cmn.IsEventDone( "get_runedice_2" ) and 
       cmn.IsEventDone( "get_runedice_3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar_use_runedice", true ) ) and
         ( not cmn.IsEventDone( "use_runedice" ) ) and 
           cmn.IsEventDone( "get_runedice_1" ) and 
           cmn.IsEventDone( "get_runedice_2" ) and 
           cmn.IsEventDone( "get_runedice_3" ) then

    cmn.CallEventHandler( "use_runedice_inv" );
    cmn.CallEventHandler( "use_runedice_beg" );

    local func_end = function ()

      if cmn.IsEventDone( "use_creepystatue" ) then
        
        ObjSet( "anm_altar_demon_appear", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_altar_summon" );
        AnimPlay( "anm_altar_demon_appear", "DoAnim",
        function ()

          int.Lock( false );
          cmn.SetEventDone( "use_runedice" );
          cmn.CallEventHandler( "use_runedice_end" );

          cmn.CloseSubRoom();
          private.dlg_pagantemple_demon4_1();

        end );

      else

        int.Lock( false );
        cmn.SetEventDone( "use_runedice" );
        cmn.CallEventHandler( "use_runedice_end" );

      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_altar_insert_3_stuffs_cells" );
    AnimPlay( "anm_altar_use_runedice", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_stoneofsouls ()

  local item = "inv_stoneofsouls";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_altar", false ) ) and
     ( not cmn.IsEventDone( "use_stoneofsouls" ) ) and 
       cmn.IsEventDone( "get_stoneofsouls_1" ) and 
       cmn.IsEventDone( "get_stoneofsouls_2" ) and 
       cmn.IsEventDone( "get_stoneofsouls_3" ) and  
       cmn.IsEventDone( "get_stoneofsouls_4" ) and 
       cmn.IsEventDone( "get_stoneofsouls_5" ) and 
       cmn.IsEventDone( "get_stoneofsouls_6" ) and 
       cmn.IsEventDone( "dlg_pagantemple_demon4_1" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar_use_stoneofsouls", true ) ) and
         ( cmn.IsEventDone( "see_altar_slots" ) ) and 
         ( not cmn.IsEventDone( "use_stoneofsouls" ) ) and 
           cmn.IsEventDone( "get_stoneofsouls_1" ) and 
           cmn.IsEventDone( "get_stoneofsouls_2" ) and 
           cmn.IsEventDone( "get_stoneofsouls_3" ) and 
           cmn.IsEventDone( "get_stoneofsouls_4" ) and 
           cmn.IsEventDone( "get_stoneofsouls_5" ) and 
           cmn.IsEventDone( "get_stoneofsouls_6" ) and 
           cmn.IsEventDone( "dlg_pagantemple_demon4_1" ) then

    cmn.CallEventHandler( "use_stoneofsouls_inv" );
    cmn.CallEventHandler( "use_stoneofsouls_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_stoneofsouls" );
      cmn.CallEventHandler( "use_stoneofsouls_end" );

    end;

    int.Lock( true );
    AnimStop( "anm_altar_demon_static" );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_altar_use_5_balls_devilkin" );
    ObjSet( "anm_altar_demon_craft", { alp = 1 } );
    AnimPlay( "anm_altar_demon_craft", "DoAnim",
    function ()

      ObjSet( "anm_altar_demon_element_static", { alp = 1, playing = true } );
      ObjSet( "anm_altar_demon_craft", { alp = 0 } );
      ObjSet( "anm_altar_demon_disappear", { alp = 1 } );
      AnimPlay( "anm_altar_demon_disappear", "DoAnim", func_end );

    end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_infamulet ()

  local item = "inv_infamulet";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_altar", false ) ) and
     ( not cmn.IsEventDone( "use_infamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar_use_infamulet", true ) ) and
         ( not cmn.IsEventDone( "use_infamulet" ) ) then

    cmn.CallEventHandler( "use_infamulet_inv" );
    cmn.CallEventHandler( "use_infamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_infamulet" );
      cmn.CallEventHandler( "use_infamulet_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_altar_infamulet_cap_click", { alp = 0 } );
    ObjSet( "anm_altar_use_infamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_altar_insert_figure_8" );
    AnimPlay( "anm_altar_use_infamulet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_amphisamulet ()

  local item = "inv_amphisamulet";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_altar", false ) ) and
     ( not cmn.IsEventDone( "use_amphisamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar_use_amphisamulet", true ) ) and
         ( not cmn.IsEventDone( "use_amphisamulet" ) ) then

    cmn.CallEventHandler( "use_amphisamulet_inv" );
    cmn.CallEventHandler( "use_amphisamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_amphisamulet" );
      cmn.CallEventHandler( "use_amphisamulet_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_altar_use_amphisamulet", { croprect_init = false } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_altar_insert_hidden_cell_opens" );
    AnimPlay( "anm_altar_use_amphisamulet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_creepystatue ()

  local item = "inv_creepystatue";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_altar", false ) ) and
     ( not cmn.IsEventDone( "use_creepystatue" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_altar", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_altar_use_creepystatue", true ) ) and
         ( not cmn.IsEventDone( "use_creepystatue" ) ) then

    cmn.CallEventHandler( "use_creepystatue_inv" );
    cmn.CallEventHandler( "use_creepystatue_beg" );

    local func_end = function ()

      if cmn.IsEventDone( "use_runedice" ) then
        
        ObjSet( "anm_altar_demon_appear", {        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_altar_summon" ); alp = 1 } );

        AnimPlay( "anm_altar_demon_appear", "DoAnim",
        function ()

          int.Lock( false );
          cmn.SetEventDone( "use_creepystatue" );
          cmn.CallEventHandler( "use_creepystatue_end" );

          cmn.CloseSubRoom();
          private.dlg_pagantemple_demon4_1();

        end );

      else

        int.Lock( false );
        cmn.SetEventDone( "use_creepystatue" );
        cmn.CallEventHandler( "use_creepystatue_end" );

      end;

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_altar_insert_figure_idol" );
    AnimPlay( "anm_altar_use_creepystatue", "DoAnim", func_end );

    ObjAnimate( "spr_altar_light2", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );
    ObjAnimate( "spr_altar_light1", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_ritualsickle_1 ()

  local item = "inv_ritualsickle";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_idol", false ) ) and
     ( not cmn.IsEventDone( "use_ritualsickle_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_idol", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_idol_use_ritualsickle_1", true ) ) and
         ( not cmn.IsEventDone( "use_ritualsickle_1" ) ) then

    cmn.CallEventHandler( "use_ritualsickle_1_inv" );
    cmn.CallEventHandler( "use_ritualsickle_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_ritualsickle_1" );
      cmn.CallEventHandler( "use_ritualsickle_1_end" );
      private.get_krakenamulet();

    end;

    int.Lock( true );

    ObjSet( "anm_idol_ritualsickle", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_idol_cut_rope_statue" );
    AnimPlay( "anm_idol_ritualsickle", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_wolfamulet ()

  local item = "inv_wolfamulet";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_idol", false ) ) and
     ( not cmn.IsEventDone( "use_wolfamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_idol", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_idol_use_wolfamulet", true ) ) and
         ( not cmn.IsEventDone( "use_wolfamulet" ) ) then

    cmn.CallEventHandler( "use_wolfamulet_inv" );
    cmn.CallEventHandler( "use_wolfamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_wolfamulet" );
      cmn.CallEventHandler( "use_wolfamulet_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_idol_wolfamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_idol_insert_idol_figure" );
    AnimPlay( "anm_idol_wolfamulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_circleofelements ()

  local item = "inv_circleofelements";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_idol", false ) ) and
     ( not cmn.IsEventDone( "use_circleofelements" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_idol", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_idol_use_circleofelements", true ) ) and
         ( not cmn.IsEventDone( "use_circleofelements" ) ) then

    cmn.CallEventHandler( "use_circleofelements_inv" );
    cmn.CallEventHandler( "use_circleofelements_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_circleofelements" );
        cmn.CallEventHandler( "use_circleofelements_end" );

        private.dlg_pagantemple_witch4_1();

      end;

      cmn.CloseSubRoom();
      private.VidFunnel( func_end1 );

      interface.KeyTaskDone( false );

    end;

    int.Lock( true );

    func_end();

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_minotauramulet ()

  local item = "inv_minotauramulet";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_gargoyles", false ) ) and
     ( cmn.IsEventDone( "get_minotauramulet_1" ) ) and
     ( cmn.IsEventDone( "get_minotauramulet_2" ) ) and
     ( not cmn.IsEventDone( "use_minotauramulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gargoyles" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gargoyles_use_minotauramulet", true ) ) and
         ( cmn.IsEventDone( "get_minotauramulet_1" ) ) and
         ( cmn.IsEventDone( "get_minotauramulet_2" ) ) and
         ( not cmn.IsEventDone( "use_minotauramulet" ) ) then

    cmn.CallEventHandler( "use_minotauramulet_inv" );
    cmn.CallEventHandler( "use_minotauramulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_minotauramulet" );
      cmn.CallEventHandler( "use_minotauramulet_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_gargoyles_open_door", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_gargoyles_insert_bull" );
    AnimPlay( "anm_gargoyles_open_door", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_gargoylehead ()

  local item = "inv_gargoylehead";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_gargoyles", false ) ) and
     ( not cmn.IsEventDone( "use_gargoylehead" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gargoyles" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gargoyles_use_gargoylehead", true ) ) and
         ( not cmn.IsEventDone( "use_gargoylehead" ) ) then

    cmn.CallEventHandler( "use_gargoylehead_inv" );
    cmn.CallEventHandler( "use_gargoylehead_beg" );

    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_gargoylehead" );
        cmn.CallEventHandler( "use_gargoylehead_end" );

      end;

      cmn.CloseSubRoom( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_loc_shield_goes" );
      AnimPlay( "anm_pagantemple_open_ho", "DoAnim", func_end1 ); 

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_gargoyles_insert_head" );
    AnimPlay( "anm_gargoyles_gargoylehead", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_gargoylefigurine ()

  local item = "inv_gargoylefigurine";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_library", false ) ) and
     ( not cmn.IsEventDone( "use_gargoylefigurine" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_library", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_library_use_gargoylefigurine", true ) ) and
         ( not cmn.IsEventDone( "use_gargoylefigurine" ) ) then

    cmn.CallEventHandler( "use_gargoylefigurine_inv" );
    cmn.CallEventHandler( "use_gargoylefigurine_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_gargoylefigurine" );
      cmn.CallEventHandler( "use_gargoylefigurine_end" );
      ng_global.progress[ ng_global.currentprogress ][ "opn_pagantemple" ].book = { 0, 0, 0, 0, 0, 0 };
      int_button_mini_ho.Show( "get_bonekey", "library", 7, "spr_library_bonekey_panel", private.mini_ho_array );

    end;

    int.Lock( true );

    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_zz_library_random_book_monster_"..private.book_sound, 0.2 );
    AnimStop( "anm_library_book_with_chain" );
    ObjSet( "anm_library_book_with_chain", { alp = 0 } );

    private.LibraryBookAnim();

    ObjSet( "anm_library_book", { alp = 1 } );
    ObjSet( "anm_library_use_gargoylefigurine", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_library_open_losk_monster" );
    AnimPlay( "anm_library_use_gargoylefigurine", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.LibraryBookAnim ()

  private.book_sound = math.random( 3 );

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_library_random_book_monster_release_"..private.book_sound );
  AnimPlay( "anm_library_book", "DoAnim", function () private.LibraryBookAnim() end );

end;
--------------------------------------------------------------------------------------------
function public.use_krakenamulet ()

  local item = "inv_krakenamulet";

  if ( cmn.ApplyObj( item, "gzz_pagantemple_library", false ) ) and
     ( not cmn.IsEventDone( "use_krakenamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_library", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_library_use_krakenamulet", true ) ) and
         ( not cmn.IsEventDone( "use_krakenamulet" ) ) then

    cmn.CallEventHandler( "use_krakenamulet_inv" );
    cmn.CallEventHandler( "use_krakenamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_krakenamulet" );
      cmn.CallEventHandler( "use_krakenamulet_end" );

    end;

    int.Lock( true );

    --ObjAnimate( "spr_library_krakenamulet", "alp", 0, 0, "",
    --{
    --  0.0, 3, 0.0,
    --  0.3, 3, 1.0,
    --} );
    --ObjAnimate( "spr_library_krakenamulet_shadow", "alp", 0, 0, "",
    --{
    --  0.0, 3, 0.0,
    --  0.3, 3, 1.0,
    --} );
    --ObjAnimate( "obj_library_box_close", "alp", 0, 0, "",
    --{
    --  0.0, 3, 1.0,
    --  0.6, 3, 1.0,
    --  0.9, 3, 0.0
    --} );
    --ObjAnimate( "obj_library_box_open", "alp", 0, 0, func_end,
    --{
    --  0.0, 3, 0.0,
    --  0.6, 3, 0.0,
    --  0.9, 3, 1.0
    --} );

    ObjSet( "anm_library_click_cap", { alp = 0 } );
    ObjSet( "anm_library_use_krakenamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_library_insert_figure_monster" );
    AnimPlay( "anm_library_use_krakenamulet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function private.see_altar_slots ()

  cmn.CallEventHandler( "see_altar_slots_inv" );
  cmn.CallEventHandler( "see_altar_slots_beg" );

  local func_end = function ()

    int.Lock( false );
    cmn.SetEventDone( "see_altar_slots" );
    cmn.CallEventHandler( "see_altar_slots_end" );

  end;

  int.Lock( true );

  ObjSet( "anm_altar_demon_slots_appear", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_altar_circles_appears" );
  AnimPlay( "anm_altar_demon_slots_appear", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--function private.dlg_pagantemple_emily4_3 ()
--
--  local func_before_end = function ( func_end )
--
--    cmn.CallEventHandler( "get_demonamulet" );
--    cmn.GetObjectSfx();
--
--    ObjSet( "anm_pagantemple_emily4_3_emily_static", { alp = 0 } );
--    AnimStop( "anm_pagantemple_emily4_3_emily_static" );
--
--    ObjAnimate( "anm_pagantemple_emily4_3_emily_give", "alp", 0, 0, "",
--    {
--      0.0, 3, 1.0,
--      0.3, 3, 0.0,
--    } );
--
--    if ( func_end ) then
--
--      func_end();
--
--    end;
--
--    cmn.SetEventDone( "get_demonamulet" );
--    cmn.SetEventDone( "dlg_pagantemple_emily4_3" );
--    cmn.ShowBbt( "bbt_pagantemple_dlg_emily4_3" );
--
--  end;
--
--  local func_anim_end = function ()
--
--    int.Lock( false );
--
--    AnimPlay( "anm_pagantemple_emily4_3_emily_static", "DoAnim", "" );
--
--    common_impl.dialog_character_loc = "";
--    common_impl.DialogCharacterStart( "emily4_3", "pagantemple", 3, nil, nil, true, nil, func_before_end );
--
--  end;
--
--  int.Lock( true );
--
--  cmn.CallEventHandler( "dlg_pagantemple_emily4_3_beg" );
--  ObjAttach( "dlg_pagantemple_emily4_3", GetCurrentRoom() );  
--
--  ObjAnimate( "anm_pagantemple_emily4_3_emily_static", "alp", 0, 0, func_anim_end,
--  {
--    0.0, 3, 0.0,
--    0.3, 3, 1.0,
--  } );
--
--end;
--*********************************************************************************************************************
function private.dlg_pagantemple_demon4_1 ()

  local func_end = function ()

    cmn.CallEventHandler( "dlg_pagantemple_demon4_1_end" );
    cmn.SetEventDone( "dlg_pagantemple_demon4_1" );

    interface.KeyTaskDone( true, "task_4_7" );
    private.PagantempleDemonAnim();

  end;

  local func_anim_end = function ()

    int.Lock( false );

    private.DialogDemonAnim();

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "demon4_1", "pagantemple", 2, nil, nil, true, func_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_pagantemple_demon4_1_beg" );
  ObjAttach( "dlg_pagantemple_demon4_1", GetCurrentRoom() );  

  ObjAnimate( "anm_pagantemple_demon4_1_demon_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.DialogDemonAnim ()

  local rnd = math.random( 3 );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_dialoge_anim_cycle_wings_"..rnd );
  AnimPlay( "anm_pagantemple_demon4_1_demon_static", "DoAnim", function() cmn.StopAudio( "sfx", "audio/level4/sfx/aud_dialoge_anim_cycle_wings_"..rnd ); private.DialogDemonAnim() end );

end;
--*********************************************************************************************************************
function private.PagantempleDemonAnim ()

  private.demon_sound = math.random( 3 );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_loc_anim_cycle_wings_"..private.demon_sound );
  AnimPlay( "anm_pagantemple_daemon_static", "DoAnim", function() cmn.StopAudio( "sfx", "audio/level4/sfx/aud_loc_anim_cycle_wings_"..private.demon_sound ); private.PagantempleDemonAnim() end );

end;
--*********************************************************************************************************************
function private.dlg_pagantemple_witch4_1 ()

  local func_end = function ()

    cmn.SetEventDone( "dlg_pagantemple_witch4_1" );
    cmn.GotoRoom( "mg_mgwitch" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_pagantemple_witch4_1_witch_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "witch4_1", "pagantemple", 3, nil, nil, true, func_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_pagantemple_witch4_1_beg" );
  ObjAttach( "dlg_pagantemple_witch4_1", GetCurrentRoom() );  

  ObjAnimate( "anm_pagantemple_witch4_1_witch_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "emily4_3" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_pagantemple_emily4_3_emily_static" );
        AnimPlay( "anm_pagantemple_emily4_3_emily_give", "DoAnim", "" );

      end;

      ObjAnimate( "anm_pagantemple_emily4_3_emily_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_pagantemple_emily4_3_emily_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_pagantemple ()

  if not ( cmn.IsEventDone( "opn_pagantemple" ) ) then

    cmn.SetEventDone( "opn_pagantemple" );

  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_pagantemple_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_pagantemple_env", 1 );

  if ( cmn.IsEventDone( "dlg_pagantemple_demon4_1" ) ) and 
       not cmn.IsEventDone( "use_stoneofsouls" ) then

    ObjSet( "anm_pagantemple_daemon_static", { frame = 0 } );
    private.PagantempleDemonAnim();

  end;

  if ( cmn.IsEventDone( "use_creepystatue" ) ) and
     ( cmn.IsEventDone( "use_runedice" ) ) and
     ( not cmn.IsEventDone( "dlg_pagantemple_demon4_1" ) ) then

    private.dlg_pagantemple_demon4_1();

  end;

  if ( cmn.IsEventDone( "use_circleofelements" ) ) and
     ( not cmn.IsEventDone( "dlg_pagantemple_witch4_1" ) ) then

    private.dlg_pagantemple_witch4_1();

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function private.VidFunnel ( func_end )

  local func_end = function ( skip )
    
    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      --cmn.StopAudio( "voc", "audio/level1/voc/aud_prison2_intro_voc" );
      cmn.StopAudio( "mus", "audio/level4/mus/aud_vid_pagantemple_funnel_mus" );
    end;

    --cmn.PlayAudio( "env", "audio/level1/env/aud_rm_prison2_env", 1 );
    --cmn.PlayAudio( "mus", "audio/main_theme_personalising_extra_lite_mus", nil, nil, 14 );

    common_impl.InterfaceSetVisible( true );

    func_end();

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_pagantemple_funnel", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  --cmn.PlayAudio( "voc", "audio/level1/voc/aud_prison2_intro_voc" );

  cmn.PlayAudio( "mus", "audio/level4/mus/aud_vid_pagantemple_funnel_mus", nil, nil, 12 );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open ()

  private.opn_pagantemple();

end;
--*********************************************************************************************************************
function public.Close ()

  if ( cmn.IsEventDone( "dlg_pagantemple_demon4_1" ) ) and 
       not cmn.IsEventDone( "use_stoneofsouls" ) then

    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_loc_anim_cycle_wings_"..private.demon_sound );
    AnimStop( "anm_pagantemple_daemon_static" );

  end;

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_demonamulet" );
  int.AddedTaskMap( private.room_objname, "get_ritualsickle" );
  int.AddedTaskMap( private.room_objname, "get_gargoylehead",                                        { "use_amphisamulet" } );
  int.AddedTaskMap( private.room_objname, "get_crystalofelements_4",                                 { "use_stoneofsouls" } );
  int.AddedTaskMap( private.room_objname, "get_satyrfigurine_2",                                     { "use_wolfamulet" } );
  int.AddedTaskMap( private.room_objname, "get_minotauramulet_2" );
  int.AddedTaskMap( private.room_objname, "get_krakenamulet",                                        { "use_ritualsickle_1" } );
  int.AddedTaskMap( private.room_objname, "get_stoneofsouls_5",                                      { "use_wolfamulet" } );
  int.AddedTaskMap( private.room_objname, "get_stoneofsouls_3" );
  int.AddedTaskMap( private.room_objname, "get_wings",                                               { "use_minotauramulet" } );
  int.AddedTaskMap( private.room_objname, "get_crystalofelements_1",                                 { "use_minotauramulet" } );
  int.AddedTaskMap( private.room_objname, "get_bonekey",                                             { "use_gargoylefigurine" } );
  int.AddedTaskMap( private.room_objname, "get_stoneofsouls_2" );
  int.AddedTaskMap( private.room_objname, "get_brokenstatuette",                                     { "use_krakenamulet" } );
  int.AddedTaskMap( private.room_objname, "get_satyrfigurine_1",                                     { "use_infamulet" } );

  int.AddedTaskMap( private.room_objname, "use_runedice",                                            { "get_runedice_1", "get_runedice_2", "get_runedice_3" } );
  int.AddedTaskMap( private.room_objname, "use_stoneofsouls",                                        { "see_altar_slots", "get_stoneofsouls_1", "get_stoneofsouls_2", "get_stoneofsouls_3", "get_stoneofsouls_4", "get_stoneofsouls_5", "get_stoneofsouls_6", "dlg_pagantemple_demon4_1" } );
  int.AddedTaskMap( private.room_objname, "use_infamulet",                                           { "get_infamulet" } );
  int.AddedTaskMap( private.room_objname, "use_amphisamulet",                                        { "get_amphisamulet" } );
  int.AddedTaskMap( private.room_objname, "use_creepystatue",                                        { "get_creepystatue" } );
  int.AddedTaskMap( private.room_objname, "use_ritualsickle_1",                                      { "get_ritualsickle" } );
  int.AddedTaskMap( private.room_objname, "use_wolfamulet",                                          { "win_hogargoyle" } );
  int.AddedTaskMap( private.room_objname, "use_circleofelements",                                    { "get_circleofelements" } );
  int.AddedTaskMap( private.room_objname, "use_minotauramulet",                                      { "get_minotauramulet_1", "get_minotauramulet_2" } );
  int.AddedTaskMap( private.room_objname, "use_gargoylehead",                                        { "get_gargoylehead" } );
  int.AddedTaskMap( private.room_objname, "use_gargoylefigurine",                                    { "get_gargoylefigurine" } );
  int.AddedTaskMap( private.room_objname, "use_krakenamulet",                                        { "get_krakenamulet" } );

  int.AddedTaskMap( private.room_objname, "see_altar_slots",                                         { "dlg_pagantemple_demon4_1" } );

  int.AddedTaskMap( private.room_objname, "dlg_pagantemple_witch4_1",                                { "use_circleofelements" } );
  int.AddedTaskMap( private.room_objname, "dlg_pagantemple_demon4_1",                                { "use_creepystatue", "use_runedice" } );

  int.AddedTaskMap( private.room_objname, "win_hogargoyle",                                          { "use_gargoylehead" } );
  int.AddedTaskMap( private.room_objname, "win_mgwitch",                                             { "dlg_pagantemple_witch4_1" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_library" );
  -------------------------------------------------
  function zz_library.PreOpen ()

    if cmn.IsEventDone( "use_gargoylefigurine" ) and not
       cmn.IsEventDone( "get_bonekey" ) then

      int_button_mini_ho.Show( "get_bonekey", "library", 7, "spr_library_bonekey_panel", private.mini_ho_array ); 

      local count = 0;

      for i = 1, 6 do 
        if ng_global.progress[ ng_global.currentprogress ][ "opn_pagantemple" ].book[ i ] == 1 then
          count = count + 1;
          if i == 1 or 
             i == 5 or
             i == 6 then
            ObjDelete( "spr_library_ho"..i.."_shadow" );
          end;
        end;
      end;

      if count == 6 then
        ObjSet( "obj_library_book_open", { alp = 1, input = true } );
        ObjSet( "anm_library_book_fly", { playing = true } );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_monster_book_loop", 1 );
        ObjDelete( "obj_library_book_close" );
      end;

    end;   
    
    private.LibraryStartBookAnim();
   
  end; 
  -------------------------------------------------
  function zz_library.Open() 

  end;
  -------------------------------------------------
  function zz_library.PreClose()

    if cmn.IsEventDone( "use_gargoylefigurine" ) and not
       cmn.IsEventDone( "get_bonekey" ) then
      int_button_mini_ho.Hide(); 
    end;  

  
   
  end; 
  -------------------------------------------------
  function zz_library.Close()

    cmn.NoteScaleEnd( { "spr_library_note" }, true );
    private.LibraryStopBookAnim(); 
    if cmn.IsEventDone( "use_gargoylefigurine" ) then    
       
      cmn.StopAudio( "sfx", "audio/level4/sfx/aud_monster_book_loop" );
      
    end;

  end; 
  -------------------------------------------------
  subroom.Define( "zz_altar" );
  -------------------------------------------------
  function zz_altar.PreOpen ()

    if ( cmn.IsEventDone( "dlg_pagantemple_demon4_1" ) ) and 
         not cmn.IsEventDone( "use_stoneofsouls" ) then
      private.AltarStartDemonAnim();
      cmn.StopAudio( "sfx", "audio/level4/sfx/aud_loc_anim_cycle_wings_"..private.demon_sound );
      AnimStop( "anm_pagantemple_daemon_static" );
    end;

  end; 
  -------------------------------------------------
  function zz_altar.Open ()

    if ( cmn.IsEventDone( "dlg_pagantemple_demon4_1" ) ) and
       ( not cmn.IsEventDone( "see_altar_slots" ) ) then

      private.see_altar_slots();

    end;

  end;  
  -------------------------------------------------
  function zz_altar.Close ()

    if ( cmn.IsEventDone( "dlg_pagantemple_demon4_1" ) ) and 
         not cmn.IsEventDone( "use_stoneofsouls" ) then

      private.AltarStopDemonAnim();
      ObjSet( "anm_pagantemple_daemon_static", { frame = 0 } );
      private.PagantempleDemonAnim();

    end

  end; 
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "obj_altar_lights", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.4,
    5.0, 3, 1.0,
  } );

  ObjAnimate( "spr_library_light", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.4,
    5.0, 3, 1.0,
  } );

  ObjAnimate( "spr_gargoyles_stoneofsouls_3_light_1", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.4,
    5.0, 3, 1.0,
  } );

  ObjAnimate( "spr_library_stoneofsouls_light_1", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.0,
    5.0, 3, 1.0,
  } );

  ObjAnimate( "spr_library_stoneofsouls_light_2", "alp", 1, 0, "",
  {
    0.0, 3, 0.0,
    2.6, 3, 1.0,
    5.2, 3, 0.0,
  } );

  ObjAnimate( "spr_idol_stoneofsouls_5_light", "alp", 1, 0, "",
  {
    0.0, 3, 0.3,
    2.6, 3, 1.0,
    5.2, 3, 0.3,
  } );

end;
--*********************************************************************************************************************
function private.LibraryStartBookAnim ()

  private.book_sound = math.random( 3 );

  if cmn.IsEventDone( "use_gargoylefigurine" ) then
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_library_random_book_monster_release_"..private.book_sound );
    AnimPlay( "anm_library_book", "DoAnim", function () cmn.StopAudio( "sfx", "audio/level4/sfx/aud_zz_library_random_book_monster_release_"..private.book_sound ); private.LibraryStartBookAnim() end );
  else
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_library_random_book_monster_"..private.book_sound );
    AnimPlay( "anm_library_book_with_chain", "DoAnim", function () cmn.StopAudio( "sfx", "audio/level4/sfx/aud_zz_library_random_book_monster_"..private.book_sound ); private.LibraryStartBookAnim() end );
  end;

end;
--*********************************************************************************************************************
function private.LibraryStopBookAnim ()

  if cmn.IsEventDone( "use_gargoylefigurine" ) then
    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_zz_library_random_book_monster_release_"..private.book_sound, 0.2 );
    AnimStop( "anm_library_book" );
    ObjSet( "anm_library_book", { frame = 0 } );
  else
    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_zz_library_random_book_monster_"..private.book_sound, 0.2 );
    AnimStop( "anm_library_book_with_chain" );
    ObjSet( "anm_library_book_with_chain", { frame = 0 } );
  end;

end;
--*********************************************************************************************************************
function private.AltarStartDemonAnim ()

  private.demon_sound_zz = math.random( 3 );

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_anim_cycle_wings_"..private.demon_sound_zz );
  AnimPlay( "anm_altar_demon_static", "DoAnim", function () cmn.StopAudio( "sfx", "audio/level4/sfx/aud_zz_anim_cycle_wings_"..private.demon_sound_zz ); private.AltarStartDemonAnim() end );

end;
--*********************************************************************************************************************
function private.AltarStopDemonAnim ()

  cmn.StopAudio( "sfx", "audio/level4/sfx/aud_zz_anim_cycle_wings_"..private.demon_sound_zz );
  AnimStop( "anm_altar_demon_static" );
  ObjSet( "anm_altar_demon_static", { frame = 0 } );

end;
--*********************************************************************************************************************
function private.GargoylesDoorsClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_gargoyles_use_minotauramulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_gargoyles_hidden_cell" );
  AnimPlay( "anm_gargoyles_door_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.GargoylesHeadClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_gargoyles_use_gargoylehead" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_gargoyles_stone_circle" );
  AnimPlay( "anm_gargoyles_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.LibraryBoxClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_library_use_krakenamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_library_box_left_book_monster" );
  AnimPlay( "anm_library_click_cap", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.IdolKrakenamuletClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_idol_use_ritualsickle_1" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_idol_stuff_statue" );
  AnimPlay( "anm_idol_krakenamulet_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.IdolCapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_idol_use_wolfamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_idol_hidden_cell_down" );
  AnimPlay( "anm_idol_cap_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.AltarBoxClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_altar_use_infamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_altar_box_down_left" );
  AnimPlay( "anm_altar_infamulet_cap_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.InitMiniHO ()
  
  private.mini_ho_array = { 
                            "spr_library_ho1", 
                            "spr_library_ho2", 
                            "spr_library_ho3", 
                            "spr_library_ho4", 
                            "spr_library_ho5", 
                            "spr_library_ho6", 
                            "obj_library_bonekey", 
                          };

  for i = 1, 6 do

    ObjSet( private.mini_ho_array[ i ], { 
                                          event_mdown = function() private.MiniHOClkRoll( i ); end,
                                          event_dragdrop = function() private.MiniHODrop( i ); end,
                                          event_menter = function () cmn.SetCursor( CURSOR_GET ); end,
                                          event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end 
                                        } );
  end;

  ObjSet( private.mini_ho_array[ 7 ], { 
                                        event_mdown = function() private.MiniHOClkBook( 7 ); end,
                                        event_menter = function () cmn.SetCursor( CURSOR_GET ); end,
                                        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end 
                                      } );
      
end;
--*********************************************************************************************************************
function private.MiniHODrop ( id )

  if ( cmn.ApplyObj( "obj_library_ho"..id, "obj_library_use_rolls", true ) ) then

    local count = 0;

    for i = 1, 6 do 
      if ng_global.progress[ ng_global.currentprogress ][ "opn_pagantemple" ].book[ i ] == 1 then
        count = count + 1;
      end;
    end;

    if count ~= 6 then

      if count == 5 then

        local func_end = function ()
          int.Lock( false );
          ObjSet( "obj_library_book_open", { input = true } );
          ng_global.progress[ ng_global.currentprogress ][ "opn_pagantemple" ].book[ id ] = 1;
          int_button_mini_ho.MiniHoTaskFind( "get_bonekey", "library", private.mini_ho_array[ id ], 7, "" );
        end;

        int.Lock( true );
        ObjAnimate( "obj_library_book_open", "alp", 0, 0, func_end, 
        { 
          0.0, 0, 0,
          0.3, 0, 1,
        } );

      else

        ng_global.progress[ ng_global.currentprogress ][ "opn_pagantemple" ].book[ id ] = 1;  
        int_button_mini_ho.MiniHoTaskFind( "get_bonekey", "library", private.mini_ho_array[ id ], 7, "" );

      end;
      
    end;

  else

    ObjAttach( "spr_library_ho"..id, "obj_library_rolls");
    if id == 1 or 
       id == 5 or
       id == 6 then
      ObjSet( "spr_library_ho"..id.."_shadow", { alp = 1 } );
    end;

  end;

end;
--*********************************************************************************************************************
function private.MiniHOClkRoll ( id )

  if id == 1 or 
     id == 5 or
     id == 6 then
    ObjSet( "spr_library_ho"..id.."_shadow", { alp = 0 } );
  end; 
  
  local count = 0;  
  
  for i = 1, 6 do 
    if ng_global.progress[ ng_global.currentprogress ][ "opn_pagantemple" ].book[ i ] == 1 then
      count = count + 1;
    end;
  end;  
  
  if count ~= 6 then

    if count == 5 then
      
      local func_end = function ()
        int.Lock( false );
        ObjSet( "obj_library_book_open", { input = true } );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_monster_book_loop", 1 );
        ObjSet( "anm_library_book_fly", { playing = true } );
        ng_global.progress[ ng_global.currentprogress ][ "opn_pagantemple" ].book[ id ] = 1;
        int_button_mini_ho.MiniHoTaskFind( "get_bonekey", "library", private.mini_ho_array[ id ], 7, "" );
        ObjDelete( "obj_library_book_close" );

      end;

      int.Lock( true );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_monster_book_open" );
      ObjAnimate( "obj_library_book_close", "alp", 0, 0, "", 
      { 
        0.0, 0, 1,
        0.3, 0, 0,
      } );
      ObjAnimate( "obj_library_book_open", "alp", 0, 0, func_end, 
      { 
        0.0, 0, 0,
        0.3, 0, 1,
      } );
      
    else

      ng_global.progress[ ng_global.currentprogress ][ "opn_pagantemple" ].book[ id ] = 1;  
      int_button_mini_ho.MiniHoTaskFind( "get_bonekey", "library", private.mini_ho_array[ id ], 7, "" );

      local func_end = function ()
        ObjSet( "anm_library_book", { alp = 1 } );
        ObjSet( "anm_library_book_eat", { alp = 0 } );
        AnimPlay( "anm_library_book", "DoAnim", "" );
        int.Lock( false );
      end;

      int.Lock( true );
      ObjSet( "anm_library_book", { alp = 0 } );
      ObjSet( "anm_library_book_eat", { alp = 1 } );
      AnimStop( "anm_library_book" );

      local rnd = math.random( 3 );
      cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_library_feet_monster_"..rnd );
      AnimPlay( "anm_library_book_eat", "DoAnim", func_end );

    end;   

  end;  

end;
--*********************************************************************************************************************
function private.MiniHOClkBook ( id )

  int_button_mini_ho.MiniHoTaskFind( "get_bonekey", "library", private.mini_ho_array[ id ], 7, "" );
    cmn.StopAudio( "sfx", "audio/level4/sfx/aud_monster_book_loop", 1 );

end;
--*********************************************************************************************************************