-- name=rm_park
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_park";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_hospitalproperty", "room_hub" );
  ObjAttach( "zz_pump",             "room_hub" );

  ObjMultiSet(
  {
    { "spr_hospitalproperty_container",     { event_mdown = private.get_container } },
    { "spr_hospitalproperty_coatlamulet_1", { event_mdown = private.get_coatlamulet_1 } },
    { "spr_hospitalproperty_magicheart",    { event_mdown = private.get_magicheart } },
    { "spr_pump_tridentamulet_1",           { event_mdown = private.get_tridentamulet_1 } },
    { "spr_pump_fireaxe",                   { event_mdown = private.get_fireaxe } },
    { "spr_pump_handle",                    { event_mdown = private.get_handle } },
    { "spr_pump_magiceye",                  { event_mdown = private.get_magiceye } },
    { "obj_pump_use_salamanderamulet",      { event_mdown = private.PumpCapClick } },
    { "spr_pump_screensaver_4_6",             { event_mdown = private.get_screensaver_4_6 } },          
    { "spr_hospitalproperty_screensaver_4_7", { event_mdown = private.get_screensaver_4_7 } },              
    { "obj_hospitalproperty_use_staroflife",  { event_mdown = private.HospitalpropertyBoxClick } },       
    { "obj_hospitalproperty_use_firepoker_2", { event_mdown = private.HospitalpropertyCupboardClick } },       
    { "obj_pump_use_eyeofhorusamulet",        { event_mdown = private.PumpContainerClick } },       
  } );
  local get_screensaver_4_6 = function ()

    ObjDelete( "spr_pump_screensaver_4_6" );
    ObjDelete( "spr_park_pump_puzzle" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_6", get_screensaver_4_6, private.room_objname );  
  local get_screensaver_4_7 = function ()

    ObjDelete( "spr_hospitalproperty_screensaver_4_7" );
    ObjDelete( "spr_park_hospitalproperty_puzzle" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_7", get_screensaver_4_7, private.room_objname );  
 
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_park = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_park", update_game_mode_park, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_7 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_7 = function ()

    ObjDelete( "obj_park_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_7", get_morphobject_4_7, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_container () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_container" ] =
  {
    type = "get",
    get_obj = "spr_hospitalproperty_container",
    room = private.room_objname,
    zz = "zz_hospitalproperty",
    zz_gate = "gzz_park_hospitalproperty"
  };
  --------------------------------------------------------------------------------------------
  local get_container_inv = function ()

    int.InventoryItemAdd( "inv_container", "spr_hospitalproperty_container" );
    ObjSet( "inv_container", { drag = false } );

    if not cmn.IsEventDone( "get_stiletto" ) then
      ObjSet( "inv_container_plus_focus2", { alp = 0 } );
    end;

  end;
  local get_container_closezz = function ()

    ObjDelete( "gfx_hospitalproperty_container" );
    ObjDelete( "spr_park_hospitalproperty_container" );

    if ( cmn.IsEventDone( "get_container" ) ) and
       ( cmn.IsEventDone( "get_coatlamulet_1" ) ) and
       ( cmn.IsEventDone( "get_magicheart" ) ) then

      ObjDelete( "gzz_park_hospitalproperty" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_container", get_container_inv );
  cmn.AddSubscriber( "get_container", get_container_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coatlamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coatlamulet_1" ] =
  {
    type = "get",
    get_obj = "spr_hospitalproperty_coatlamulet_1",
    room = private.room_objname,
    zz = "zz_hospitalproperty",
    zz_gate = "gzz_park_hospitalproperty"
  };
  --------------------------------------------------------------------------------------------
  local get_coatlamulet_1_inv = function ()

    int.InventoryItemAdd( "inv_coatlamulet", "spr_hospitalproperty_coatlamulet_1", "assets/levels/levelext/rm_park/zz_hospitalproperty/inv/inv_coatlamulet_1" );
    levelext_inv.CheckCoatlamulet( 1 );

  end;
  local get_coatlamulet_1_closezz = function ()

    ObjDelete( "gfx_hospitalproperty_coatlamulet_1" );
    ObjDelete( "spr_park_hospitalproperty_coatlamulet" );

    if ( cmn.IsEventDone( "get_container" ) ) and
       ( cmn.IsEventDone( "get_coatlamulet_1" ) ) and
       ( cmn.IsEventDone( "get_magicheart" ) ) then

      ObjDelete( "gzz_park_hospitalproperty" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_coatlamulet_1", get_coatlamulet_1_inv );
  cmn.AddSubscriber( "get_coatlamulet_1", get_coatlamulet_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magicheart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magicheart" ] =
  {
    type = "get",
    get_obj = "spr_hospitalproperty_magicheart",
    room = private.room_objname,
    zz = "zz_hospitalproperty",
    zz_gate = "gzz_park_hospitalproperty"
  };
  --------------------------------------------------------------------------------------------
  local get_magicheart_inv = function ()

    int.InventoryItemAdd( "inv_magicheart", "spr_hospitalproperty_magicheart" );

  end;
  local get_magicheart_closezz = function ()

    ObjDelete( "gfx_hospitalproperty_magicheart" );
    ObjDelete( "spr_park_magicheart" );

    if ( cmn.IsEventDone( "get_container" ) ) and
       ( cmn.IsEventDone( "get_coatlamulet_1" ) ) and
       ( cmn.IsEventDone( "get_magicheart" ) ) then

      ObjDelete( "gzz_park_hospitalproperty" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magicheart", get_magicheart_inv );
  cmn.AddSubscriber( "get_magicheart", get_magicheart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tridentamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tridentamulet_1" ] =
  {
    type = "get",
    get_obj = "spr_pump_tridentamulet_1",
    room = private.room_objname,
    zz = "zz_pump",
    zz_gate = "gzz_park_pump"
  };
  --------------------------------------------------------------------------------------------
  local get_tridentamulet_1_inv = function ()

    int.InventoryItemAdd( "inv_tridentamulet", "spr_pump_tridentamulet_1", "assets/levels/levelext/rm_park/zz_pump/inv/inv_tridentamulet_1" );
    levelext_inv.CheckTridentamulet();

  end;
  local get_tridentamulet_1_closezz = function ()

    ObjDelete( "gfx_pump_tridentamulet_1" );

    ObjDelete( "spr_park_pump_tridentamulet" );
    --ObjDelete( "gzz_park_pump" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_tridentamulet_1", get_tridentamulet_1_inv );
  cmn.AddSubscriber( "get_tridentamulet_1", get_tridentamulet_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fireaxe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fireaxe" ] =
  {
    type = "get",
    get_obj = "spr_pump_fireaxe",
    room = private.room_objname,
    zz = "zz_pump",
    zz_gate = "gzz_park_pump"
  };
  --------------------------------------------------------------------------------------------
  local get_fireaxe_inv = function ()

    int.InventoryItemAdd( "inv_fireaxe", "spr_pump_fireaxe" );

  end;
  local get_fireaxe_closezz = function ()

    ObjDelete( "gfx_pump_fireaxe" );

    ObjDelete( "spr_park_fireaxe" );

    if ( cmn.IsEventDone( "get_fireaxe" ) ) and
       ( cmn.IsEventDone( "get_handle" ) ) and
       ( cmn.IsEventDone( "get_magiceye" ) ) then

      ObjDelete( "gzz_park_pump" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_fireaxe", get_fireaxe_inv );
  cmn.AddSubscriber( "get_fireaxe", get_fireaxe_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle" ] =
  {
    type = "get",
    get_obj = "spr_pump_handle",
    room = private.room_objname,
    zz = "zz_pump",
    zz_gate = "gzz_park_pump"
  };
  --------------------------------------------------------------------------------------------
  local get_handle_inv = function ()

    int.InventoryItemAdd( "inv_handle", "spr_pump_handle" );

  end;
  local get_handle_closezz = function ()

    ObjDelete( "gfx_pump_handle" );

    ObjDelete( "spr_park_pump_handle" );

    if ( cmn.IsEventDone( "get_fireaxe" ) ) and
       ( cmn.IsEventDone( "get_handle" ) ) and
       ( cmn.IsEventDone( "get_magiceye" ) ) then

      ObjDelete( "gzz_park_pump" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_handle", get_handle_inv );
  cmn.AddSubscriber( "get_handle", get_handle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magiceye () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magiceye" ] =
  {
    type = "get",
    get_obj = "spr_pump_magiceye",
    room = private.room_objname,
    zz = "zz_pump",
    zz_gate = "gzz_park_pump"
  };
  --------------------------------------------------------------------------------------------
  local get_magiceye_inv = function ()

    int.InventoryItemAdd( "inv_magiceye", "spr_pump_magiceye" );

  end;
  local get_magiceye_closezz = function ()

    ObjDelete( "gfx_pump_magiceye" );

    ObjDelete( "spr_park_magiceye" );

    if ( cmn.IsEventDone( "get_fireaxe" ) ) and
       ( cmn.IsEventDone( "get_handle" ) ) and
       ( cmn.IsEventDone( "get_magiceye" ) ) then

      ObjDelete( "gzz_park_pump" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magiceye", get_magiceye_inv );
  cmn.AddSubscriber( "get_magiceye", get_magiceye_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_firepoker_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_firepoker_2" ] =
  {
    type = "use",
    use_obj = "inv_firepoker",
    use_place = "obj_hospitalproperty_use_firepoker_2",
    room = private.room_objname,
    zz = "zz_hospitalproperty",
    zz_gate = "gzz_park_hospitalproperty"
  };
  --------------------------------------------------------------------------------------------
  local use_firepoker_2_inv = function ()

    if ( cmn.IsEventDone( "use_firepoker_1" ) ) and
       ( cmn.IsEventDone( "use_firepoker_3" ) ) then

      int.InventoryItemRemove( "inv_firepoker" );

    end;

  end;
  local use_firepoker_2_beg = function ()

    ObjDelete( "obj_hospitalproperty_use_firepoker_2" );
    ObjDelete( "anm_hospitalproperty_cupboard_click" );

  end;
  local use_firepoker_2_end = function ()

    ObjSet( "anm_hospitalproperty_cupboard_open", { alp = 1, frame = 121, animfunc = "DoAnim" } );
    ObjSet( "spr_hospitalproperty_coatlamulet_1", { input = true } );
    ObjSet( "gfx_hospitalproperty_coatlamulet_1", { active = true } );

    ObjSet( "spr_park_cupboard_open", { alp = 1 } );
    ObjDelete( "spr_park_hospitalproperty_lock" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_firepoker_2",     use_firepoker_2_inv );
  cmn.AddSubscriber( "use_firepoker_2",     use_firepoker_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_2",     use_firepoker_2_end, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_2_inv", use_firepoker_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_2_beg", use_firepoker_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_2_end", use_firepoker_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_staroflife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_staroflife" ] =
  {
    type = "use",
    use_obj = "inv_staroflife",
    use_place = "obj_hospitalproperty_use_staroflife",
    room = private.room_objname,
    zz = "zz_hospitalproperty",
    zz_gate = "gzz_park_hospitalproperty"
  };
  --------------------------------------------------------------------------------------------
  local use_staroflife_inv = function ()

    int.InventoryItemRemove( "inv_staroflife" );

  end;
  local use_staroflife_beg = function ()

    ObjDelete( "obj_hospitalproperty_use_staroflife" );
    ObjDelete( "anm_hospitalproperty_box_click" );

  end;
  local use_staroflife_end = function ()

    ObjSet( "anm_hospitalproperty_staroflife", { alp = 1, frame = 149, animfunc = "DoAnim" } );
    ObjSet( "spr_hospitalproperty_magicheart", { input = true } );
    ObjSet( "gfx_hospitalproperty_magicheart", { active = true } );
    ObjSet( "spr_park_hospitalproperty_box_open",   { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_staroflife",     use_staroflife_inv );
  cmn.AddSubscriber( "use_staroflife",     use_staroflife_beg, private.room_objname );
  cmn.AddSubscriber( "use_staroflife",     use_staroflife_end, private.room_objname );
  cmn.AddSubscriber( "use_staroflife_inv", use_staroflife_inv, private.room_objname );
  cmn.AddSubscriber( "use_staroflife_beg", use_staroflife_beg, private.room_objname );
  cmn.AddSubscriber( "use_staroflife_end", use_staroflife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_salamanderamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_salamanderamulet" ] =
  {
    type = "use",
    use_obj = "inv_salamanderamulet",
    use_place = "obj_pump_use_salamanderamulet",
    room = private.room_objname,
    zz = "zz_pump",
    zz_gate = "gzz_park_pump"
  };
  --------------------------------------------------------------------------------------------
  local use_salamanderamulet_inv = function ()

    int.InventoryItemRemove( "inv_salamanderamulet" );

  end;
  local use_salamanderamulet_beg = function ()

    ObjDelete( "obj_pump_use_salamanderamulet" );

  end;
  local use_salamanderamulet_end = function ()

    ObjDelete( "anm_pump_salamanderamulet" );
    ObjSet( "spr_pump_fireaxe", { input = true } );
    ObjSet( "gfx_pump_fireaxe", { active = true } );

    ObjDelete( "spr_park_pump_cap" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_salamanderamulet",     use_salamanderamulet_inv );
  cmn.AddSubscriber( "use_salamanderamulet",     use_salamanderamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_salamanderamulet",     use_salamanderamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_salamanderamulet_inv", use_salamanderamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_salamanderamulet_beg", use_salamanderamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_salamanderamulet_end", use_salamanderamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nutwrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nutwrench" ] =
  {
    type = "use",
    use_obj = "inv_nutwrench",
    use_place = "obj_pump_use_nutwrench",
    room = private.room_objname,
    zz = "zz_pump",
    zz_gate = "gzz_park_pump"
  };
  --------------------------------------------------------------------------------------------
  local use_nutwrench_inv = function ()

    int.InventoryItemRemove( "inv_nutwrench" );

  end;
  local use_nutwrench_beg = function ()

    ObjDelete( "obj_pump_use_nutwrench" );

  end;
  local use_nutwrench_end = function ()

    ObjDelete( "vid_pump_nutwhench" );
    ObjSet( "spr_pump_handle", { input = true } );
    ObjSet( "gfx_pump_handle", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nutwrench",     use_nutwrench_inv );
  cmn.AddSubscriber( "use_nutwrench",     use_nutwrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_nutwrench",     use_nutwrench_end, private.room_objname );
  cmn.AddSubscriber( "use_nutwrench_inv", use_nutwrench_inv, private.room_objname );
  cmn.AddSubscriber( "use_nutwrench_beg", use_nutwrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_nutwrench_end", use_nutwrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_eyeofhorusamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_eyeofhorusamulet" ] =
  {
    type = "use",
    use_obj = "inv_eyeofhorusamulet",
    use_place = "obj_pump_use_eyeofhorusamulet",
    room = private.room_objname,
    zz = "zz_pump",
    zz_gate = "gzz_park_pump"
  };
  --------------------------------------------------------------------------------------------
  local use_eyeofhorusamulet_inv = function ()

    int.InventoryItemRemove( "inv_eyeofhorusamulet" );

  end;
  local use_eyeofhorusamulet_beg = function ()

    ObjDelete( "obj_pump_use_eyeofhorusamulet" );
    ObjDelete( "anm_pump_container_click" );

  end;
  local use_eyeofhorusamulet_end = function ()

    ObjSet( "spr_pump_magiceye", { alp = 1, input = true } );
    ObjSet( "gfx_pump_magiceye", { active = true } );
    ObjSet( "anm_pump_eyeofhorusamulet", { alp = 1, frame = 68, animfunc = "DoAnim" } );
    ObjSet( "spr_pump_slot", { alp = 1 } );

    ObjSet( "spr_park_pump_container_open", { alp = 1 } );
    ObjDelete( "spr_park_pump_container_close" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_eyeofhorusamulet",     use_eyeofhorusamulet_inv );
  cmn.AddSubscriber( "use_eyeofhorusamulet",     use_eyeofhorusamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_eyeofhorusamulet",     use_eyeofhorusamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_eyeofhorusamulet_inv", use_eyeofhorusamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_eyeofhorusamulet_beg", use_eyeofhorusamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_eyeofhorusamulet_end", use_eyeofhorusamulet_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_6()

  int.AddScreensaver( "spr_pump_screensaver_4_6" );

end;    
------------------------------------------------------------------------------------------
function private.get_screensaver_4_7()

  int.AddScreensaver( "spr_hospitalproperty_screensaver_4_7" );

end; 
-----------------------------------------------------------------------
function private.get_container ()

  cmn.SetEventDone( "get_container" );
  cmn.CallEventHandler( "get_container" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_container" ) ) and
     ( cmn.IsEventDone( "get_coatlamulet_1" ) ) and
     ( cmn.IsEventDone( "get_magicheart" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_coatlamulet_1 ()

  cmn.SetEventDone( "get_coatlamulet_1" );
  cmn.CallEventHandler( "get_coatlamulet_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_container" ) ) and
     ( cmn.IsEventDone( "get_coatlamulet_1" ) ) and
     ( cmn.IsEventDone( "get_magicheart" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_magicheart ()

  cmn.SetEventDone( "get_magicheart" );
  cmn.CallEventHandler( "get_magicheart" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_container" ) ) and
     ( cmn.IsEventDone( "get_coatlamulet_1" ) ) and
     ( cmn.IsEventDone( "get_magicheart" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_tridentamulet_1 ()

  cmn.SetEventDone( "get_tridentamulet_1" );
  cmn.CallEventHandler( "get_tridentamulet_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_fireaxe" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_1" ) ) and
     ( cmn.IsEventDone( "get_handle" ) ) and
     ( cmn.IsEventDone( "get_magiceye" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_fireaxe ()

  cmn.SetEventDone( "get_fireaxe" );
  cmn.CallEventHandler( "get_fireaxe" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_fireaxe" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_1" ) ) and
     ( cmn.IsEventDone( "get_handle" ) ) and
     ( cmn.IsEventDone( "get_magiceye" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_handle ()

  cmn.SetEventDone( "get_handle" );
  cmn.CallEventHandler( "get_handle" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_fireaxe" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_1" ) ) and
     ( cmn.IsEventDone( "get_handle" ) ) and
     ( cmn.IsEventDone( "get_magiceye" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_magiceye ()

  cmn.SetEventDone( "get_magiceye" );
  cmn.CallEventHandler( "get_magiceye" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_fireaxe" ) ) and
     ( cmn.IsEventDone( "get_tridentamulet_1" ) ) and
     ( cmn.IsEventDone( "get_handle" ) ) and
     ( cmn.IsEventDone( "get_magiceye" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_firepoker_2 ()

  local item = "inv_firepoker";

  if ( cmn.ApplyObj( item, "gzz_park_hospitalproperty", false ) ) and
     ( not cmn.IsEventDone( "use_firepoker_2" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hospitalproperty", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hospitalproperty_use_firepoker_2", true ) ) and
         ( not cmn.IsEventDone( "use_firepoker_2" ) ) then

    cmn.CallEventHandler( "use_firepoker_2_inv" );
    cmn.CallEventHandler( "use_firepoker_2_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_firepoker_2" );
      cmn.CallEventHandler( "use_firepoker_2_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_hospitalproperty_cupboard_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_hospitalproperty_hit_scrap_lock" );
    AnimPlay( "anm_hospitalproperty_cupboard_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_staroflife ()

  local item = "inv_staroflife";

  if ( cmn.ApplyObj( item, "gzz_park_hospitalproperty", false ) ) and
     ( cmn.IsEventDone( "get_staroflife_1" ) ) and
     ( cmn.IsEventDone( "get_staroflife_2" ) ) and
     ( cmn.IsEventDone( "get_staroflife_3" ) ) and
     ( cmn.IsEventDone( "get_staroflife_4" ) ) and
     ( not cmn.IsEventDone( "use_staroflife" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hospitalproperty", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_hospitalproperty_use_staroflife", true ) ) and
         ( cmn.IsEventDone( "get_staroflife_1" ) ) and
         ( cmn.IsEventDone( "get_staroflife_2" ) ) and
         ( cmn.IsEventDone( "get_staroflife_3" ) ) and
         ( cmn.IsEventDone( "get_staroflife_4" ) ) and
         ( not cmn.IsEventDone( "use_staroflife" ) ) then

    cmn.CallEventHandler( "use_staroflife_inv" );
    cmn.CallEventHandler( "use_staroflife_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_staroflife" );
      cmn.CallEventHandler( "use_staroflife_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_hospitalproperty_staroflife", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_hospitalproperty_insert_4_stuffs" );
    AnimPlay( "anm_hospitalproperty_staroflife", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_salamanderamulet ()

  local item = "inv_salamanderamulet";

  if ( cmn.ApplyObj( item, "gzz_park_pump", false ) ) and
     ( not cmn.IsEventDone( "use_salamanderamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pump", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pump_use_salamanderamulet", true ) ) and
         ( not cmn.IsEventDone( "use_salamanderamulet" ) ) then

    cmn.CallEventHandler( "use_salamanderamulet_inv" );
    cmn.CallEventHandler( "use_salamanderamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_salamanderamulet" );
      cmn.CallEventHandler( "use_salamanderamulet_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_pump_insert_lizard" );
    AnimPlay( "anm_pump_salamanderamulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_nutwrench ()

  local item = "inv_nutwrench";

  if ( cmn.ApplyObj( item, "gzz_park_pump", false ) ) and
     ( not cmn.IsEventDone( "use_nutwrench" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pump", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pump_use_nutwrench", true ) ) and
         ( not cmn.IsEventDone( "use_nutwrench" ) ) then

    cmn.CallEventHandler( "use_nutwrench_inv" );
    cmn.CallEventHandler( "use_nutwrench_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_nutwrench" );
      cmn.CallEventHandler( "use_nutwrench_end" );
      private.get_handle();

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_pump_take_handle_pump" );
    VidPlay( "vid_pump_nutwhench", func_end );

    ObjAnimate( "spr_pump_handle_spot", "alp", 0, 0, "",
    {
      0.0, 3, ObjGet( "spr_pump_handle_spot" ).alp,
      0.3, 3, 0.0,
    } );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_eyeofhorusamulet ()

  local item = "inv_eyeofhorusamulet";

  if ( cmn.ApplyObj( item, "gzz_park_pump", false ) ) and
     ( not cmn.IsEventDone( "use_eyeofhorusamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pump", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_pump_use_eyeofhorusamulet", true ) ) and
         ( not cmn.IsEventDone( "use_eyeofhorusamulet" ) ) then

    cmn.CallEventHandler( "use_eyeofhorusamulet_inv" );
    cmn.CallEventHandler( "use_eyeofhorusamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_eyeofhorusamulet" );
      cmn.CallEventHandler( "use_eyeofhorusamulet_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_pump_eyeofhorusamulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_pump_insert_figure_eye" );
    AnimPlay( "anm_pump_eyeofhorusamulet", "DoAnim", func_end );

    ObjAnimate( "spr_pump_magiceye", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.8, 3, 0.0,
      1.0, 3, 1.0,
    } );

    ObjAnimate( "spr_pump_slot", "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.8, 3, 0.0,
      0.8, 3, 1.0,
    } );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_park ()

  if not ( cmn.IsEventDone( "opn_park" ) ) then

    cmn.SetEventDone( "opn_park" );
    cmn.ShowBbt( "bbt_park_first_enter" );

  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_park_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_park_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_park();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_container" );
  int.AddedTaskMap( private.room_objname, "get_coatlamulet_1",                             { "use_firepoker_2" } );
  int.AddedTaskMap( private.room_objname, "get_magicheart",                                { "use_staroflife" } );
  int.AddedTaskMap( private.room_objname, "get_tridentamulet_1" );
  int.AddedTaskMap( private.room_objname, "get_fireaxe",                                   { "use_salamanderamulet" } );
  int.AddedTaskMap( private.room_objname, "get_handle",                                    { "use_nutwrench" } );
  int.AddedTaskMap( private.room_objname, "get_magiceye",                                  { "use_eyeofhorusamulet" } );

  int.AddedTaskMap( private.room_objname, "use_firepoker_2",                               { "get_firepoker" } );
  int.AddedTaskMap( private.room_objname, "use_staroflife",                                { "get_staroflife_1", "get_staroflife_2", "get_staroflife_3", "get_staroflife_4" } );
  int.AddedTaskMap( private.room_objname, "use_salamanderamulet",                          { "get_salamanderamulet" } );
  int.AddedTaskMap( private.room_objname, "use_nutwrench",                                 { "get_nutwrench" } );
  int.AddedTaskMap( private.room_objname, "use_eyeofhorusamulet",                          { "get_eyeofhorusamulet" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
--[[
  subroom.Define( "zz_picture" );  
  -------------------------------------------------
  function zz_picture.Open()
  end;
  -------------------------------------------------
  function zz_picture.PreClose()
  end;
  -------------------------------------------------
  function zz_picture.Skip ()
  end;
  -------------------------------------------------
  function zz_picture.Reset ()
  end;
  -------------------------------------------------
]]--
end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_pump_handle_spot", "alp", 1, 0, "",
  {
    0.0, 3, 0.3,
    2.0, 3, 1.0,
    4.0, 3, 0.3,
  } );

end;
--*********************************************************************************************************************
function private.PumpCapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_pump_use_salamanderamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_pump_big_box_left" );
  ObjAnimate( "obj_pump_box_close", "pos_y", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, 2,
    0.4, 3, 0,
    0.6, 3, 2,
    0.7, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.PumpContainerClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_pump_use_eyeofhorusamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_pump_box_behind_pump" );
  AnimPlay( "anm_pump_container_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.HospitalpropertyBoxClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_hospitalproperty_use_staroflife" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_hospitalproperty_box_up_right" );
  AnimPlay( "anm_hospitalproperty_box_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.HospitalpropertyCupboardClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_hospitalproperty_use_firepoker_2" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_hospitalproperty_box_left_down" );
  AnimPlay( "anm_hospitalproperty_cupboard_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************