-- name=rm_prison
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_prison";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_throneoftorture", "room_hub" );
  ObjAttach( "zz_runecontainers",  "room_hub" );
  ObjAttach( "zz_cage",            "room_hub" );

  ObjMultiSet(
  {
    { "spr_throneoftorture_atlantesamulet_2",    { event_mdown = private.get_atlantesamulet_2 } },
    { "spr_throneoftorture_stoneofsouls_1",      { event_mdown = private.get_stoneofsouls_1 } },
    { "spr_throneoftorture_crystalofelements_3", { event_mdown = private.get_crystalofelements_3 } },
    { "spr_throneoftorture_runedice_2",          { event_mdown = private.get_runedice_2 } },
    { "spr_runecontainers_minotauramulet_1",     { event_mdown = private.get_minotauramulet_1 } },
    { "spr_runecontainers_runedice_3",           { event_mdown = private.get_runedice_3 } },
    { "spr_cage_infamulet",                      { event_mdown = private.get_infamulet } },
    { "spr_cage_stoneofsouls_6",                 { event_mdown = private.get_stoneofsouls_6 } },
    { "obj_runecontainers_use_satyrfigurine",    { event_mdown = private.RunecontainersCapClick } },
    { "obj_throneoftorture_use_demonamulet",     { event_mdown = private.Smallchest_xx } },
    { "obj_cage_mmg_clk",                        { event_mdown = private.open_mmg } },
    { "obj_cage_mmg_close",                      { event_mdown = private.close_mmg } },
    { "spr_prison_collect_4_3",                  { event_mdown = private.get_collect_4_3 } },
    { "spr_runecontainers_screensaver_4_15",     { event_mdown = private.get_screensaver_4_15 } },
    { "obj_cage_use_bonekey",                    { event_mdown = function() private.CageClick() end; } }, 
    { "obj_throneoftorture_use_demonamulet",     { event_mdown = function() private.ThroneoftortureClick() end; } }, 
    { "obj_cage_use_splinter",                   { event_mdown = function() private.CageDarkClk() end; } },          
  } );

  local get_screensaver_4_15 = function ()

    ObjDelete( "spr_runecontainers_screensaver_4_15" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_15", get_screensaver_4_15, private.room_objname );  

  private.cage_init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_prison = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_prison", update_game_mode_prison, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_collect_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_4_3 = function ()

    ObjDelete( "spr_prison_collect_4_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_collect_4_3", get_collect_4_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_8 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_8 = function ()

    ObjDelete( "obj_prison_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_8", get_morphobject_4_8, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_atlantesamulet_3 () end;
  --------------------------------------------------------------------------------------------
  local get_atlantesamulet_3_inv = function ()

    int.InventoryItemAdd( "inv_atlantesamulet", "spr_prison3_atlantesamulet_3", "assets/levels/levelext/rm_dungeon/zz_ritualstone/inv/inv_atlantesamulet_3" );
    levelext_inv.CheckAtlantesamulet();

    if cmn.IsEventDone( "get_atlantesamulet_1" ) and 
       cmn.IsEventDone( "get_atlantesamulet_2" ) and 
       cmn.IsEventDone( "get_magiccube" ) then

      ObjSet( "inv_magiccube_plus_focus2", { alp = 1 } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_atlantesamulet_3", get_atlantesamulet_3_inv );
  --------------------------------------------------------------------------------------------
  -- function get_magiccircle () end;
  --------------------------------------------------------------------------------------------
  local get_magiccircle_inv = function ()

    int.InventoryItemAdd( "inv_magiccircle", "spr_prison3_magiccircle" );
    ObjSet( "inv_magiccircle", { drag = false } );

    if not ( ( cmn.IsEventDone( "get_crystalofelements_1" ) and 
               cmn.IsEventDone( "get_crystalofelements_2" ) and 
               cmn.IsEventDone( "get_crystalofelements_3" ) and 
               cmn.IsEventDone( "get_crystalofelements_4" ) ) or 
               cmn.IsEventDone( "win_hotable" ) ) then

      ObjSet( "inv_magiccircle_plus_focus2", { alp = 0 } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_magiccircle", get_magiccircle_inv );
  --------------------------------------------------------------------------------------------
  -- function get_amphisamulet () end;
  --------------------------------------------------------------------------------------------
  local get_amphisamulet_inv = function ()

    int.InventoryItemAdd( "inv_amphisamulet", "spr_prison3_amphisamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_amphisamulet", get_amphisamulet_inv );
  --------------------------------------------------------------------------------------------
  -- function get_atlantesamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_atlantesamulet_2" ] =
  {
    type = "get",
    get_obj = "spr_throneoftorture_atlantesamulet_2",
    room = private.room_objname,
    zz = "zz_throneoftorture",
    zz_gate = "gzz_prison_throneoftorture"
  };
  --------------------------------------------------------------------------------------------
  local get_atlantesamulet_2_inv = function ()

    int.InventoryItemAdd( "inv_atlantesamulet", "spr_throneoftorture_atlantesamulet_2", "assets/levels/levelext/rm_dungeon/zz_ritualstone/inv/inv_atlantesamulet_2" );
    levelext_inv.CheckAtlantesamulet();

    if cmn.IsEventDone( "get_atlantesamulet_1" ) and 
       cmn.IsEventDone( "get_atlantesamulet_3" ) and 
       cmn.IsEventDone( "get_magiccube" ) then

      ObjSet( "inv_magiccube_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_atlantesamulet_2_closezz = function ()

    ObjDelete( "gfx_throneoftorture_atlantesamulet_2" );
    ObjDelete( "spr_throneoftorture_atlantesamulet_2_add" );

    if ( cmn.IsEventDone( "get_atlantesamulet_2" ) ) and 
       ( cmn.IsEventDone( "get_stoneofsouls_1" ) ) and 
       ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and 
       ( cmn.IsEventDone( "get_runedice_2" ) ) then

      ObjDelete( "gzz_prison_throneoftorture" );

    end;

    ObjDelete( "spr_prison_throneoftorture_atlantesamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_atlantesamulet_2", get_atlantesamulet_2_inv );
  cmn.AddSubscriber( "get_atlantesamulet_2", get_atlantesamulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stoneofsouls_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stoneofsouls_1" ] =
  {
    type = "get",
    get_obj = "spr_throneoftorture_stoneofsouls_1",
    room = private.room_objname,
    zz = "zz_throneoftorture",
    zz_gate = "gzz_prison_throneoftorture"
  };
  --------------------------------------------------------------------------------------------
  local get_stoneofsouls_1_inv = function ()

    int.InventoryItemAdd( "inv_stoneofsouls", "spr_throneoftorture_stoneofsouls_1", "assets/levels/levelext/rm_prison/zz_throneoftorture/inv/inv_stoneofsouls_1" );
    levelext_inv.CheckStoneofsouls();

  end;
  local get_stoneofsouls_1_closezz = function ()

    ObjDelete( "gfx_throneoftorture_stoneofsouls_1" );
    ObjDelete( "spr_throneoftorture_stoneofsouls_1_light_1" );
    ObjDelete( "spr_throneoftorture_stoneofsouls_1_light_2" );

    if ( cmn.IsEventDone( "get_atlantesamulet_2" ) ) and 
       ( cmn.IsEventDone( "get_stoneofsouls_1" ) ) and 
       ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and 
       ( cmn.IsEventDone( "get_runedice_2" ) ) then

      ObjDelete( "gzz_prison_throneoftorture" );

    end;

    ObjDelete( "spr_prison_throneoftorture_stoneofsouls" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stoneofsouls_1", get_stoneofsouls_1_inv );
  cmn.AddSubscriber( "get_stoneofsouls_1", get_stoneofsouls_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crystalofelements_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crystalofelements_3" ] =
  {
    type = "get",
    get_obj = "spr_throneoftorture_crystalofelements_3",
    room = private.room_objname,
    zz = "zz_throneoftorture",
    zz_gate = "gzz_prison_throneoftorture"
  };
  --------------------------------------------------------------------------------------------
  local get_crystalofelements_3_inv = function ()

    int.InventoryItemAdd( "inv_crystalofelements", "spr_throneoftorture_crystalofelements_3", "assets/levels/levelext/rm_pagantemple/zz_gargoyles/inv/inv_crystalofelements_3" );
    levelext_inv.CheckCrystalofelements();

    if cmn.IsEventDone( "get_crystalofelements_1" ) and 
       cmn.IsEventDone( "get_crystalofelements_2" ) and 
       cmn.IsEventDone( "get_crystalofelements_4" ) then

      ObjSet( "inv_magiccircle_plus_focus2", { alp = 1 } );

    end;

  end;
  local get_crystalofelements_3_closezz = function ()

    ObjDelete( "gfx_throneoftorture_crystalofelements_3" );

    if ( cmn.IsEventDone( "get_atlantesamulet_2" ) ) and 
       ( cmn.IsEventDone( "get_stoneofsouls_1" ) ) and 
       ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and 
       ( cmn.IsEventDone( "get_runedice_2" ) ) then

      ObjDelete( "gzz_prison_throneoftorture" );

    end;

    ObjDelete( "spr_prison_throneoftorture_crystalofelements" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crystalofelements_3", get_crystalofelements_3_inv );
  cmn.AddSubscriber( "get_crystalofelements_3", get_crystalofelements_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_runedice_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_runedice_2" ] =
  {
    type = "get",
    get_obj = "spr_throneoftorture_runedice_2",
    room = private.room_objname,
    zz = "zz_throneoftorture",
    zz_gate = "gzz_prison_throneoftorture"
  };
  --------------------------------------------------------------------------------------------
  local get_runedice_2_inv = function ()

    int.InventoryItemAdd( "inv_runedice", "spr_throneoftorture_runedice_2", "assets/levels/levelext/rm_dungeon/zz_extract/inv/inv_runedice_2" );
    levelext_inv.CheckRunedice( 2 );

  end;
  local get_runedice_2_closezz = function ()

    ObjDelete( "gfx_throneoftorture_runedice_2" );

    if ( cmn.IsEventDone( "get_atlantesamulet_2" ) ) and 
       ( cmn.IsEventDone( "get_stoneofsouls_1" ) ) and 
       ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and 
       ( cmn.IsEventDone( "get_runedice_2" ) ) then

      ObjDelete( "gzz_prison_throneoftorture" );

    end;

    ObjDelete( "spr_prison_throneoftorture_runedice" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_runedice_2", get_runedice_2_inv );
  cmn.AddSubscriber( "get_runedice_2", get_runedice_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_minotauramulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_minotauramulet_1" ] =
  {
    type = "get",
    get_obj = "spr_runecontainers_minotauramulet_1",
    room = private.room_objname,
    zz = "zz_runecontainers",
    zz_gate = "gzz_prison_runecontainers"
  };
  --------------------------------------------------------------------------------------------
  local get_minotauramulet_1_inv = function ()

    int.InventoryItemAdd( "inv_minotauramulet", "spr_runecontainers_minotauramulet_1", "assets/levels/levelext/rm_prison/zz_runecontainers/inv/inv_minotauramulet_1" );
    levelext_inv.CheckMinotauramulet( 1 );

  end;
  local get_minotauramulet_1_closezz = function ()

    ObjDelete( "gfx_runecontainers_minotauramulet_1" );

    ObjDelete( "spr_prison_runecontainers_minotauramulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_minotauramulet_1", get_minotauramulet_1_inv );
  cmn.AddSubscriber( "get_minotauramulet_1", get_minotauramulet_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_runedice_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_runedice_3" ] =
  {
    type = "get",
    get_obj = "spr_runecontainers_runedice_3",
    room = private.room_objname,
    zz = "zz_runecontainers",
    zz_gate = "gzz_prison_runecontainers"
  };
  --------------------------------------------------------------------------------------------
  local get_runedice_3_inv = function ()

    int.InventoryItemAdd( "inv_runedice", "spr_runecontainers_runedice_3", "assets/levels/levelext/rm_dungeon/zz_extract/inv/inv_runedice_3" );
    levelext_inv.CheckRunedice( 3 );

  end;
  local get_runedice_3_closezz = function ()

    ObjDelete( "gfx_runecontainers_runedice_3" );
    ObjDelete( "gzz_prison_runecontainers" );

    ObjDelete( "spr_prison_runecontainers_runedice" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_runedice_3", get_runedice_3_inv );
  cmn.AddSubscriber( "get_runedice_3", get_runedice_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_infamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_infamulet" ] =
  {
    type = "get",
    get_obj = "spr_cage_infamulet",
    room = private.room_objname,
    zz = "zz_cage",
    zz_gate = "gzz_prison_cage"
  };
  --------------------------------------------------------------------------------------------
  local get_infamulet_inv = function ()

    int.InventoryItemAdd( "inv_infamulet", "spr_cage_infamulet" );

  end;
  local get_infamulet_closezz = function ()

    ObjDelete( "gfx_cage_infamulet" );

    ObjDelete( "spr_prison_cage_infamulet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_infamulet", get_infamulet_inv );
  cmn.AddSubscriber( "get_infamulet", get_infamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stoneofsouls_6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stoneofsouls_6" ] =
  {
    type = "get",
    get_obj = "spr_cage_stoneofsouls_6",
    room = private.room_objname,
    zz = "zz_cage",
    zz_gate = "gzz_prison_cage"
  };
  --------------------------------------------------------------------------------------------
  local get_stoneofsouls_6_inv = function ()

    int.InventoryItemAdd( "inv_stoneofsouls", "spr_cage_stoneofsouls_6", "assets/levels/levelext/rm_prison/zz_throneoftorture/inv/inv_stoneofsouls_6" );
    levelext_inv.CheckStoneofsouls();

  end;
  local get_stoneofsouls_6_closezz = function ()

    ObjDelete( "gfx_cage_stoneofsouls_6" );
    ObjDelete( "spr_prison_cage_stoneofsouls" );
    ObjDelete( "spr_cage_stoneofsouls_6_light_2" );

    if ( cmn.IsEventDone( "win_cage" ) ) then

      ObjDelete( "gzz_prison_cage" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stoneofsouls_6", get_stoneofsouls_6_inv );
  cmn.AddSubscriber( "get_stoneofsouls_6", get_stoneofsouls_6_closezz, private.room_objname );
 --*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_demonamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_demonamulet" ] =
  {
    type = "use",
    use_obj = "inv_demonamulet",
    use_place = "obj_throneoftorture_use_demonamulet",
    room = private.room_objname,
    zz = "zz_throneoftorture",
    zz_gate = "gzz_prison_throneoftorture"
  };
  --------------------------------------------------------------------------------------------
  local use_demonamulet_inv = function ()

    int.InventoryItemRemove( "inv_demonamulet" );

  end;
  local use_demonamulet_beg = function ()

    ObjDelete( "obj_throneoftorture_use_demonamulet" );

  end;
  local use_demonamulet_end = function ()

    ObjSet( "spr_throneoftorture_runedice_2", { input = true, active = true } );
    ObjSet( "gfx_throneoftorture_runedice_2", { active = true } );
    ObjSet( "spr_throneoftorture_crystalofelements_3", { input = true, active = true } );
    ObjSet( "gfx_throneoftorture_crystalofelements_3", { active = true } );
    ObjSet( "obj_throneoftorture_smallchest_open", { alp = 1 });
    ObjSet( "spr_throneoftorture_smallchest_amulet", { alp = 1 });
    ObjDelete( "spr_throneoftorture_smallchest_close");

    ObjDelete( "anm_throneoftorture_use_amulet");
    ObjDelete( "anm_throneoftorture_click");

    ObjSet( "spr_prison_throneoftorture_open_cap", { alp = 1 } );
    ObjSet( "spr_prison_throneoftorture_demonamulet", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_demonamulet",     use_demonamulet_inv );
  cmn.AddSubscriber( "use_demonamulet",     use_demonamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_demonamulet",     use_demonamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_demonamulet_inv", use_demonamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_demonamulet_beg", use_demonamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_demonamulet_end", use_demonamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_satyrfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_satyrfigurine" ] =
  {
    type = "use",
    use_obj = "inv_satyrfigurine",
    use_place = "obj_runecontainers_use_satyrfigurine",
    room = private.room_objname,
    zz = "zz_runecontainers",
    zz_gate = "gzz_prison_runecontainers"
  };
  --------------------------------------------------------------------------------------------
  local use_satyrfigurine_inv = function ()

    int.InventoryItemRemove( "inv_satyrfigurine" );

  end;
  local use_satyrfigurine_beg = function ()

    ObjDelete( "obj_runecontainers_use_satyrfigurine" );
    ObjDelete( "anm_runecontainers_cap_click" );

  end;
  local use_satyrfigurine_end = function ()

    ObjSet( "anm_runecontainers_satyrfigurine", { alp = 1, frame = 51, animfunc = "DoAnim", pos_z = 2 } );
    ObjSet( "spr_runecontainers_runedice_3", { input = true } );
    ObjSet( "gfx_runecontainers_runedice_3", { active = true } );

    ObjSet( "spr_prison_runecontainers_cap_open", { alp = 1 });
    ObjDelete( "spr_prison_runecontainers_cap_close");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_satyrfigurine",     use_satyrfigurine_inv );
  cmn.AddSubscriber( "use_satyrfigurine",     use_satyrfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_satyrfigurine",     use_satyrfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_satyrfigurine_inv", use_satyrfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_satyrfigurine_beg", use_satyrfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_satyrfigurine_end", use_satyrfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_splinter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_splinter" ] =
  {
    type = "use",
    use_obj = "inv_splinter",
    use_place = "obj_cage_use_splinter",
    room = private.room_objname,
    zz = "zz_cage",
    zz_gate = "gzz_prison_cage"
  };
  --------------------------------------------------------------------------------------------
  local use_splinter_inv = function ()

    int.InventoryItemRemove( "inv_splinter" );

  end;
  local use_splinter_beg = function ()

    ObjDelete( "obj_cage_use_splinter" );

  end;
  local use_splinter_end = function ()

    ObjDelete( "obj_cage_splinter");
    ObjDelete( "anm_cage_click_dark");
    ObjDelete( "spr_cage_stoneofsouls_over_dark");
    ObjMultiSet(
    {
      { "spr_cage_infamulet", { alp = 1, active = true, input = true } },
      { "obj_cage_use_bonekey", { active = true, input = true } },
      { "obj_cage_light_on", { alp = 1 } },
      { "spr_cage_stoneofsouls_over_light", { alp = 1 } },
      { "spr_cage_stoneofsouls_6_light_2", { alp = 1 } },
      --{ "obj_cage_lantern_fire", { alp = 1 } },
      { "gfx_cage_infamulet", { active = true } }, 
      --{ "spr_prison_cage_lamp_light", { alp = 1, active = true } },
      { "spr_prison_cage_infamulet", { alp = 1 } },
      { "spr_cage_stoneofsouls_6", { input = true } },
      { "gfx_cage_stoneofsouls_6", { active = true, alp = 1 } },
    });

    ObjDelete( "anm_cage_lamp_static_dark");
    ObjDelete( "anm_cage_lamp_on");
    ObjSet( "anm_cage_lamp_static_light", { alp = 1, playing = true } );
    ObjSet( "anm_prison_lamp", { res = "assets/levels/levelext/rm_prison/anims/anm_lamp_add", animfunc = "DoAnim", playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_splinter",     use_splinter_inv );
  cmn.AddSubscriber( "use_splinter",     use_splinter_beg, private.room_objname );
  cmn.AddSubscriber( "use_splinter",     use_splinter_end, private.room_objname );
  cmn.AddSubscriber( "use_splinter_inv", use_splinter_inv, private.room_objname );
  cmn.AddSubscriber( "use_splinter_beg", use_splinter_beg, private.room_objname );
  cmn.AddSubscriber( "use_splinter_end", use_splinter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bonekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bonekey" ] =
  {
    type = "use",
    use_obj = "inv_bonekey",
    use_place = "obj_cage_use_bonekey",
    room = private.room_objname,
    zz = "zz_cage",
    zz_gate = "gzz_prison_cage"
  };
  --------------------------------------------------------------------------------------------
  local use_bonekey_inv = function ()

    int.InventoryItemRemove( "inv_bonekey" );

  end;
  local use_bonekey_beg = function ()

    ObjDelete( "obj_cage_use_bonekey" );

  end;
  local use_bonekey_end = function ()

    ObjSet( "obj_cage_mmg_clk", { input =  true });
    --ObjDelete( "spr_cage_door_close");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bonekey",     use_bonekey_inv );
  cmn.AddSubscriber( "use_bonekey",     use_bonekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_bonekey",     use_bonekey_end, private.room_objname );
  cmn.AddSubscriber( "use_bonekey_inv", use_bonekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_bonekey_beg", use_bonekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_bonekey_end", use_bonekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_cage() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_cage" ] = {
    type = "win",
    use_place = "obj_cage_mmg_clk",
    room = private.room_objname,
    zz = "zz_cage",
    zz_gate = "gzz_prison_cage"
   };
   local win_cage_inv = function ()

   end;
   local win_cage_beg = function ()

    --if ( cmn.IsEventDone( "win_controlunit" ) ) then
    --  
    --  ObjDelete("obj_controlunit_mmg");
    --  
    --else 
    --  
    --  private.draw_path();
    --  private.check_light(ng_global.progress[ "std" ][ "win_controlunit" ].last_clk);
    --  ObjSet( "obj_controlunit_mmg_chip", { pos_x = private.mmg_coord[ng_global.progress[ "std" ][ "win_controlunit" ].last_clk][1], pos_y = private.mmg_coord[ng_global.progress[ "std" ][ "win_controlunit" ].last_clk][2] })
    --  
    --end;
    

  end;
  
  local win_cage_end= function ()
  
    if ( cmn.IsEventDone( "win_cage" ) ) then
      
      ObjDelete( "obj_cage_mmg");
      ObjDelete( "obj_cage_mmg_clk");
      ObjDelete( "spr_cage_door_close");
      ObjDelete( "anm_cage_nik_static1");
      ObjDelete( "anm_cage_nik_static2");
      ObjDelete( "anm_cage_nik_static1_front");

      ObjDelete( "spr_prison_cage_nikolas" );
      ObjDelete( "spr_prison_cage_nikolas_hands" );
      ObjDelete( "spr_prison_cage_lattice_close" );
      ObjDelete( "anm_cage_cage_click" );
      ObjDelete( "anm_cage_cage_open" );
      ObjDelete( "spr_cage_nik_shad" );

      ObjSet( "spr_prison_cage_lattice_open", { alp = 1 } );

      if ( cmn.IsEventDone( "get_stoneofsouls_6" ) ) then

        ObjDelete( "gzz_prison_cage" );

      end;

    else
     
     for i = 1, #private.cage_current do
    
      private.cage_current[i] = ng_global.progress[ "ext" ][ "win_cage" ].array[i];
      ObjSet( "spr_cage_mmg_disk_"..i, { ang = private.cage_ang[ private.cage_current[i] ]});
      
     end;
    
      
    end;
  
  end;
   -------------------------------------------------------------------------------------------- 
  cmn.AddSubscriber( "win_cage",     win_cage_inv );
  cmn.AddSubscriber( "win_cage",     win_cage_beg, private.room_objname );
  cmn.AddSubscriber( "win_cage",     win_cage_end, private.room_objname );
  cmn.AddSubscriber( "win_cage_inv", win_cage_inv, private.room_objname );
  cmn.AddSubscriber( "win_cage_beg", win_cage_beg, private.room_objname );
  cmn.AddSubscriber( "win_cage_end", win_cage_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_prison_nicholas_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_prison_nicholas_1" ] =
  {
    type = "click",
    clk_obj = "dlg_prison_nicholas_1",
    room = private.room_objname,
  };
  local dlg_prison_nicholas_1_inv = function ()

  end;
  local dlg_prison_nicholas_1_beg = function ()
  
  end;
  local dlg_prison_nicholas_1_end = function ()

    ObjDelete( "dlg_prison_nicholas_1" );
    ObjSet( "anm_cage_nik_static1", { alp = 1, playing = true } );
    ObjSet( "anm_cage_nik_static1_front", { alp = 1, playing = true } );
    ObjSet( "spr_prison_cage_nikolas", { alp = 1 } );
    ObjSet( "spr_prison_cage_nikolas_hands", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_prison_nicholas_1",     dlg_prison_nicholas_1_beg );
  cmn.AddSubscriber( "dlg_prison_nicholas_1",     dlg_prison_nicholas_1_inv );
  cmn.AddSubscriber( "dlg_prison_nicholas_1_inv", dlg_prison_nicholas_1_inv );
  cmn.AddSubscriber( "dlg_prison_nicholas_1",     dlg_prison_nicholas_1_end );
  cmn.AddSubscriber( "dlg_prison_nicholas_1_beg", dlg_prison_nicholas_1_beg );
  cmn.AddSubscriber( "dlg_prison_nicholas_1_end", dlg_prison_nicholas_1_end );
  --------------------------------------------------------------------------------------------
  -- function dlg_prison_nicholas_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_prison_nicholas_2" ] =
  {
    type = "click",
    clk_obj = "dlg_prison_nicholas_2",
    room = private.room_objname,
  };
  local dlg_prison_nicholas_2_inv = function ()

  end;
  local dlg_prison_nicholas_2_beg = function ()
  
  end;
  local dlg_prison_nicholas_2_end = function ()

    ObjDelete( "dlg_prison_nicholas_2" );
    ObjSet( "anm_prison_nicholas", { alp = 1, playing = true } );
    ObjSet( "obj_prison_nicholas", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_prison_nicholas_2",     dlg_prison_nicholas_2_beg );
  cmn.AddSubscriber( "dlg_prison_nicholas_2",     dlg_prison_nicholas_2_inv );
  cmn.AddSubscriber( "dlg_prison_nicholas_2_inv", dlg_prison_nicholas_2_inv );
  cmn.AddSubscriber( "dlg_prison_nicholas_2",     dlg_prison_nicholas_2_end );
  cmn.AddSubscriber( "dlg_prison_nicholas_2_beg", dlg_prison_nicholas_2_beg );
  cmn.AddSubscriber( "dlg_prison_nicholas_2_end", dlg_prison_nicholas_2_end );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_15()

  int.AddScreensaver( "spr_runecontainers_screensaver_4_15" );

end;  
-----------------------------------------------------------------------
function private.get_collect_4_3 ()

  int.AddCollectibles( "spr_prison_collect_4_3" );

end;
-----------------------------------------------------------------------
function private.get_atlantesamulet_2 ()

  cmn.SetEventDone( "get_atlantesamulet_2" );
  cmn.CallEventHandler( "get_atlantesamulet_2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_atlantesamulet_2" ) ) and 
     ( cmn.IsEventDone( "get_stoneofsouls_1" ) ) and 
     ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and 
     ( cmn.IsEventDone( "get_runedice_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
------------------------------------------------------
function private.get_atlantesamulet_3 ()

  cmn.SetEventDone( "get_atlantesamulet_3" );
  cmn.CallEventHandler( "get_atlantesamulet_3" );
  cmn.GetObjectSfx();
  --cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_stoneofsouls_1 ()

  cmn.SetEventDone( "get_stoneofsouls_1" );
  cmn.CallEventHandler( "get_stoneofsouls_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_atlantesamulet_2" ) ) and 
     ( cmn.IsEventDone( "get_stoneofsouls_1" ) ) and 
     ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and 
     ( cmn.IsEventDone( "get_runedice_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_crystalofelements_3 ()

  cmn.SetEventDone( "get_crystalofelements_3" );
  cmn.CallEventHandler( "get_crystalofelements_3" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_atlantesamulet_2" ) ) and 
     ( cmn.IsEventDone( "get_stoneofsouls_1" ) ) and 
     ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and 
     ( cmn.IsEventDone( "get_runedice_2" ) ) then

    cmn.CloseSubRoom();

  end;

  if ( cmn.IsEventDone( "get_crystalofelements_1" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_2" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and
     ( cmn.IsEventDone( "get_crystalofelements_4" ) ) then

    interface.KeyTaskDone( true, "task_4_8" );

  end;

end;
-----------------------------------------------------------------------
function private.get_runedice_2 ()

  cmn.SetEventDone( "get_runedice_2" );
  cmn.CallEventHandler( "get_runedice_2" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_atlantesamulet_2" ) ) and 
     ( cmn.IsEventDone( "get_stoneofsouls_1" ) ) and 
     ( cmn.IsEventDone( "get_crystalofelements_3" ) ) and 
     ( cmn.IsEventDone( "get_runedice_2" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_minotauramulet_1 ()

  cmn.SetEventDone( "get_minotauramulet_1" );
  cmn.CallEventHandler( "get_minotauramulet_1" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_runedice_3 ()

  cmn.SetEventDone( "get_runedice_3" );
  cmn.CallEventHandler( "get_runedice_3" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_infamulet ()

  cmn.SetEventDone( "get_infamulet" );
  cmn.CallEventHandler( "get_infamulet" );
  cmn.GetObjectSfx();
  cmn.CloseSubRoom();

end;
-----------------------------------------------------------------------
function private.get_stoneofsouls_6 ()

  cmn.SetEventDone( "get_stoneofsouls_6" );
  cmn.CallEventHandler( "get_stoneofsouls_6" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "win_cage" ) ) then

    cmn.CloseSubRoom();

  end;

end;
----------------------------------------------------------------------------
function private.get_amphisamulet ()

  cmn.SetEventDone( "get_amphisamulet" );
  cmn.CallEventHandler( "get_amphisamulet" );
  cmn.GetObjectSfx();
  
end;
----------------------------------------------------------------------------
function private.get_magiccircle ()

  cmn.SetEventDone( "get_magiccircle" );
  cmn.CallEventHandler( "get_magiccircle" );
  cmn.GetObjectSfx();
  
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_demonamulet ()

  local item = "inv_demonamulet";

  if ( cmn.ApplyObj( item, "gzz_prison_throneoftorture", false ) ) and
     ( not cmn.IsEventDone( "use_demonamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_throneoftorture", nil, { 512, 384 } , true)

    return true;

  elseif ( cmn.ApplyObj( item, "obj_throneoftorture_use_demonamulet", true ) ) and
         ( not cmn.IsEventDone( "use_demonamulet" ) ) then

    cmn.CallEventHandler( "use_demonamulet_inv" );
    cmn.CallEventHandler( "use_demonamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_demonamulet" );
      cmn.CallEventHandler( "use_demonamulet_end" );

    end;
      
    int.Lock( true );
    ObjSet( "anm_throneoftorture_click", { alp = 0 } );
    ObjSet( "anm_throneoftorture_use_amulet", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_throneoftorture_insert_box_stuff" );
    AnimPlay( "anm_throneoftorture_use_amulet", "DoAnim", func_end ); 

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_satyrfigurine ()

  local item = "inv_satyrfigurine";

  if ( cmn.ApplyObj( item, "gzz_prison_runecontainers", false ) ) and
     ( cmn.IsEventDone( "get_satyrfigurine_1" ) ) and
     ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) and
     ( not cmn.IsEventDone( "use_satyrfigurine" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_runecontainers" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_runecontainers_use_satyrfigurine", true ) ) and
         ( cmn.IsEventDone( "get_satyrfigurine_1" ) ) and
         ( cmn.IsEventDone( "get_satyrfigurine_2" ) ) and
         ( not cmn.IsEventDone( "use_satyrfigurine" ) ) then

    cmn.CallEventHandler( "use_satyrfigurine_inv" );
    cmn.CallEventHandler( "use_satyrfigurine_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_satyrfigurine" );
      cmn.CallEventHandler( "use_satyrfigurine_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_runecontainers_satyrfigurine", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_runecontainers_insert_2_figures" );
    AnimPlay( "anm_runecontainers_satyrfigurine", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_splinter ()

  local item = "inv_splinter";

  if ( cmn.ApplyObj( item, "gzz_prison_cage", false ) ) and
     ( not cmn.IsEventDone( "use_splinter" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cage" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cage_use_splinter", true ) ) and
         ( not cmn.IsEventDone( "use_splinter" ) ) then

    cmn.CallEventHandler( "use_splinter_inv" );
    cmn.CallEventHandler( "use_splinter_beg" );

    local func_after = function ()
    
      local func_end = function ()

        int.Lock( false );
        cmn.SetEventDone( "use_splinter" );
        cmn.CallEventHandler( "use_splinter_end" );

      end;
      
      --ObjAnimate( "obj_cage_lantern_fire", "alp", 0, 0, func_end,
      --{
      --  0.0, 3, 0.0,
      --  0.6, 3, 1.0
      --} );
      --
      --ObjAnimate( "obj_cage_light_on", "alp", 0, 0, "",
      --{
      --  0.0, 3, 0.0,
      --  0.3, 3, 1.0
      --} );
      --ObjAnimate( "spr_cage_stoneofsouls_over_light", "alp", 0, 0, "",
      --{
      --  0.0, 3, 0.0,
      --  0.3, 3, 1.0
      --} );
      --ObjAnimate( "spr_cage_stoneofsouls_6_light_2", "alp", 0, 0, "",
      --{
      --  0.0, 3, 0.0,
      --  0.3, 3, 1.0
      --} );
      --ObjAnimate( "spr_cage_infamulet", "alp", 0, 0, "",
      --{
      --  0.0, 3, 0.0,
      --  0.3, 3, 1.0
      --} );

      func_end();
      
    end;  

    int.Lock( true );
    --ObjAnimate( "obj_cage_splinter", "alp", 0, 0, func_after,
    --{
    --  0.0, 3, 0.0,
    --  0.3, 3, 1.0,
    --  0.9, 3, 1.0,
    --  1.2, 3, 0.0
    --} );
    --ObjAnimate( "obj_cage_splinter", "pos_xy", 0, 0, "",
    --{
    --  0.0, 3, 121, -114,
    --  0.3, 3, 121, -114,
    --  0.9, 3, 349, -74
    --} );

    ObjSet( "anm_cage_lamp_static_dark", { alp = 0 } );
    ObjSet( "anm_cage_lamp_on", { alp = 1 } );
    --ObjSet( "anm_cage_click_dark", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cage_use_match_cage" );
    AnimPlay( "anm_cage_lamp_on", "DoAnim", func_after ); 
   
    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_bonekey ()

  local item = "inv_bonekey";

  if ( cmn.ApplyObj( item, "gzz_prison_cage", false ) ) and
     ( not cmn.IsEventDone( "use_bonekey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cage" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cage_use_bonekey", true ) ) and
         ( not cmn.IsEventDone( "use_bonekey" ) ) then

    cmn.CallEventHandler( "use_bonekey_inv" );
    cmn.CallEventHandler( "use_bonekey_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_bonekey" );
      cmn.CallEventHandler( "use_bonekey_end" );
      --cmn.CloseSubRoom();

      private.open_mmg();

    end;

    --int.Lock( true );
    --ObjAnimate( "spr_cage_door_close", "pos_x", 0, 0, func_end,
    --{
    --    0.0, 3, -92,
    --    0.3, 3, -150,
    --    0.6, 3, -300
    --} );
    func_end();
    
    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.dlg_prison_nicholas_1 ()

  local func_before_end = function ( func_end )

    ObjSet( "anm_prison_nicholas_1_nicholas_static", { alp = 0 } );
    ObjSet( "anm_prison_nicholas_1_nicholas_coming", { alp = 0 } );
    ObjSet( "anm_prison_nicholas_1_nicholas_give",   { alp = 1 } );

    AnimStop( "anm_prison_nicholas_1_nicholas_static" );
    AnimStop( "anm_prison_nicholas_1_nicholas_coming" );
    AnimPlay( "anm_prison_nicholas_1_nicholas_give", "DoAnim", "" );

    if ( func_end ) then

      func_end();

    end;

    private.get_atlantesamulet_3();
    private.get_magiccircle();

    cmn.SetEventDone( "dlg_prison_nicholas_1" );
    cmn.ShowBbt( "bbt_prison_dlg_nicholas_1" );

    interface.KeyTaskDone( true, "task_4_5" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimStop( "anm_prison_nicholas_1_nicholas_coming" );
    ObjSet( "anm_prison_nicholas_1_nicholas_coming", { alp = 0 } );

    ObjSet( "anm_prison_nicholas_1_nicholas_static", { alp = 1 } );
    AnimPlay( "anm_prison_nicholas_1_nicholas_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "nicholas_1", "prison", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_prison_nicholas_1_inv");
  cmn.CallEventHandler( "dlg_prison_nicholas_1_beg" );
  ObjAttach( "dlg_prison_nicholas_1", GetCurrentRoom() );  

  ObjAnimate( "anm_prison_nicholas_1_nicholas_coming", "alp", 0, 0,
  function ()

    AnimPlay( "anm_prison_nicholas_1_nicholas_coming", "DoAnim", func_anim_end );

  end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.dlg_prison_nicholas_2 ()

  local func_before_end = function ( func_end )

    ObjSet( "anm_prison_nicholas_2_nicholas_static", { alp = 0 } );
    ObjSet( "anm_prison_nicholas_2_nicholas_give",   { alp = 1 } );

    AnimStop( "anm_prison_nicholas_2_nicholas_static" );
    AnimPlay( "anm_prison_nicholas_2_nicholas_give", "DoAnim", "" );

    if ( func_end ) then

      func_end();

    end;

    private.get_amphisamulet();

    cmn.SetEventDone( "dlg_prison_nicholas_2" );
    cmn.ShowBbt( "bbt_prison_dlg_nicholas_2" );

    interface.KeyTaskDone( true, "task_4_6" );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_prison_nicholas_2_nicholas_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "anm_prison_nicholas";
    common_impl.DialogCharacterStart( "nicholas_2", "prison", 3, nil, nil, true, nil, func_before_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_prison_nicholas_2_inv");
  cmn.CallEventHandler( "dlg_prison_nicholas_2_beg" );
  ObjAttach( "dlg_prison_nicholas_2", GetCurrentRoom() );  

  ObjAnimate( "anm_prison_nicholas_2_nicholas_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if ( dlg_name == "nicholas_1" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        ObjSet( "anm_prison_nicholas_1_nicholas_static", { alp = 0 } );
        AnimStop( "anm_prison_nicholas_1_nicholas_static" );
        AnimPlay( "anm_prison_nicholas_1_nicholas_give", "DoAnim", "" );

      end;

      ObjAnimate( "anm_prison_nicholas_1_nicholas_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  elseif ( dlg_name == "nicholas_2" ) then

    if ( count_txt == 3 ) then

      int.Lock( true );

      local func_end = function ()

        int.Lock( false );

        AnimStop( "anm_prison_nicholas_2_nicholas_static" );
        AnimPlay( "anm_prison_nicholas_2_nicholas_give", "DoAnim", "" );

      end;

      ObjAnimate( "anm_prison_nicholas_2_nicholas_static", "alp", 0, 0, "",
      {
        0.0, 3, 1.0,
        0.3, 3, 0.0,
      } );

      ObjAnimate( "anm_prison_nicholas_2_nicholas_give", "alp", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        0.3, 3, 1.0,
      } );

    end;

  end;

end;  
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_prison ()

  if not ( cmn.IsEventDone( "opn_prison" ) ) then

    cmn.SetEventDone( "opn_prison" );
    
  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_prison_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_prison_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_prison();

end;
--*********************************************************************************************************************
function public.PreOpen()

  if cmn.IsEventDone( "get_infamulet") and not cmn.IsEventDone( "dlg_prison_nicholas_1") then
      
        ObjSet( "tmr_prison_dlg_nicholas",
        {
          playing = 1,
          time = 0.02,
          endtrig = function() private.dlg_prison_nicholas_1(); end;
        } );
      
  end;
  ---------------------------------------------------------------------------    
  if cmn.IsEventDone( "win_cage") and not cmn.IsEventDone( "dlg_prison_nicholas_2") then
      
        ObjSet( "tmr_prison_dlg_nicholas",
        {
          playing = 1,
          time = 0.02,
          endtrig = function() private.dlg_prison_nicholas_2(); end;
        } );
      
  end;    
      

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_atlantesamulet_3",                                 { "dlg_prison_nicholas_1" } );
  int.AddedTaskMap( private.room_objname, "get_magiccircle",                                      { "dlg_prison_nicholas_1" } );
  int.AddedTaskMap( private.room_objname, "get_amphisamulet",                                     { "dlg_prison_nicholas_2" } );
  int.AddedTaskMap( private.room_objname, "get_atlantesamulet_2" );
  int.AddedTaskMap( private.room_objname, "get_stoneofsouls_1" );
  int.AddedTaskMap( private.room_objname, "get_crystalofelements_3",                              { "use_demonamulet" } );
  int.AddedTaskMap( private.room_objname, "get_runedice_2",                                       { "use_demonamulet" } );
  int.AddedTaskMap( private.room_objname, "get_minotauramulet_1" );
  int.AddedTaskMap( private.room_objname, "get_runedice_3",                                       { "use_satyrfigurine" } );
  int.AddedTaskMap( private.room_objname, "get_infamulet",                                        { "use_splinter" } );
  int.AddedTaskMap( private.room_objname, "get_stoneofsouls_6",                                   { "use_splinter" } );

  int.AddedTaskMap( private.room_objname, "use_demonamulet",                                      { "get_demonamulet" } );
  int.AddedTaskMap( private.room_objname, "use_satyrfigurine",                                    { "get_satyrfigurine_1", "get_satyrfigurine_2" } );
  int.AddedTaskMap( private.room_objname, "use_splinter",                                         { "get_splinter" } );
  int.AddedTaskMap( private.room_objname, "use_bonekey",                                          { "get_bonekey", "use_splinter" } );
  int.AddedTaskMap( private.room_objname, "win_cage",                                             { "use_bonekey" } );

  int.AddedTaskMap( private.room_objname, "dlg_prison_nicholas_1",                                { "get_infamulet" } );
  int.AddedTaskMap( private.room_objname, "dlg_prison_nicholas_2",                                { "win_cage" } );

  int.AddedTaskMap( private.room_objname, "win_homagiccube",                                      { "use_atlantesamulet" } );

end;
--*********************************************************************************************************************

function private.InitSubroom ()

  subroom.Define( "zz_cage" ); 
  -----------------------------------------------------------------------------------------------
  function zz_cage.PreOpen() 
    
    if ( cmn.IsEventDone( "use_bonekey" ) and not cmn.IsEventDone( "win_cage" ) ) then

   
      ObjSet( "obj_cage_mmg_clk", { input = true } );
      ObjSet( "obj_cage_mmg", { alp = 0, input = false } );
      
    end; 
    
  end;  
  -----------------------------------------------
  function zz_cage.Open()
  end;
  -----------------------------------------------
  function zz_cage.PreClose()
    
    if cmn.IsEventDone( "get_infamulet") and not cmn.IsEventDone( "dlg_prison_nicholas_1") then
      
        ObjSet( "tmr_prison_dlg_nicholas",
        {
          playing = 1,
          time = 0.02,
          endtrig = function() private.dlg_prison_nicholas_1(); end;
        } );
        
    end;
    ---------------------------------------------------------------------------------  
    if cmn.IsEventDone( "win_cage") and not cmn.IsEventDone( "dlg_prison_nicholas_2") then
      
        ObjSet( "tmr_prison_dlg_nicholas",
        {
          playing = 1,
          time = 0.02,
          endtrig = function() private.dlg_prison_nicholas_2(); end;
        } );
      
    end; 
    ---------------------------------------------------------------------- 
    if ( cmn.IsEventDone( "use_bonekey" ) and not cmn.IsEventDone( "win_cage" )
      and ObjGet( "obj_cage_mmg" ) and  ObjGet( "obj_cage_mmg" ).input ) then

      cmn.MiniGameHide( "cage" );
      common_impl.PassingMgStop( "cage" );
      
    end;  
    
  end;
  -----------------------------------------------------------------------
  function zz_cage.Close()
    
     if ( ObjGet( "obj_cage_mmg" ) ) and ( ObjGet( "obj_cage_mmg" ).input ) then

       ObjSet( "obj_cage_mmg", { input = false, alp = 0 } );

    end;
    
  end;  
  -----------------------------------------------
  function zz_cage.Skip ()
    
    if ( cmn.IsEventStart( "win_cage" ) and not cmn.IsEventDone( "win_cage" ) ) then
      
      private.cage_skip();
      
    end;
    
  end;
  -----------------------------------------------
  function zz_cage.Reset ()
    
    if ( cmn.IsEventStart( "win_cage" ) and not cmn.IsEventDone( "win_cage" ) ) then
      
      private.cage_reset();
      
    end;
    
  end;
  -----------------------------------------------
  subroom.Define( "zz_throneoftorture" );  
  -------------------------------------------------
  function zz_throneoftorture.Close()
    
    cmn.NoteScaleEnd( { "spr_throneoftorture_note" }, true );

  end;
  
end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_throneoftorture_atlantesamulet_2_add", "alp", 1, 0, "", 
  {
     0.0, 0, 1.0,
     2.5, 3, 0.5,
     5.0, 3, 1.0
  } );

  ObjAnimate( "spr_throneoftorture_stoneofsouls_1_light_1", "alp", 1, 0, "", 
  {
     0.0, 0, 1.0,
     2.5, 3, 0.5,
     5.0, 3, 1.0
  } );

  ObjAnimate( "spr_throneoftorture_stoneofsouls_1_light_2", "alp", 1, 0, "", 
  {
     0.0, 0, 1.0,
     2.5, 3, 0.5,
     5.0, 3, 1.0
  } );

end;
--*********************************************************************************************************************
function private.RunecontainersCapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_runecontainers_use_satyrfigurine" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_runecontainers_box" );
  AnimPlay( "anm_runecontainers_cap_click", "DoAnim", func_end );

end;
-----------------------------------------------------------------------------------
function private.Smallchest_xx ()
  
  local func_end = function ()

    cmn.ShowBbt( "bbt_throneoftorture_use_demonamulet" );
    int.Lock( false );

  end;

  int.Lock( true );

  ObjAnimate( "spr_throneoftorture_smallchest_close", "pos_y", 0, 0, func_end,
  {
    0.0, 3, -94,
    0.2, 3, -93,
    0.4, 3, -94,
    0.6, 3, -93,
    0.7, 3, -94
  } );
  
end;  
--*********************************************************************************************************************
function private.CageClick ()

  local func_end = function ()

    if cmn.IsEventDone( "get_infamulet" ) then

      ObjSet( "anm_cage_nik_static1", { alp = 1 } );
      ObjSet( "anm_cage_nik_static1_front", { alp = 1 } );
      AnimPlay( "anm_cage_nik_static1", "DoAnim", "" ); 
      AnimPlay( "anm_cage_nik_static1_front", "DoAnim", "" ); 
      ObjSet( "anm_cage_nik_static2", { alp = 0, frame = 0 } );

    end;

    int.Lock( false );
    cmn.ShowBbt( "bbt_cage_use_bonekey" );

  end;

  int.Lock( true );

  if cmn.IsEventDone( "get_infamulet" ) then

    ObjSet( "anm_cage_nik_static1", { alp = 0 } );
    ObjSet( "anm_cage_nik_static1_front", { alp = 0 } );
    AnimStop( "anm_cage_nik_static1" ); 
    AnimStop( "anm_cage_nik_static1_front" ); 
    ObjSet( "anm_cage_nik_static2", { alp = 1, playing = true } );

  end;

  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_cage_cage" );
  AnimPlay( "anm_cage_cage_click", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.CageDarkClk ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_cage_use_splinter" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_cage_cage" );
  AnimPlay( "anm_cage_click_dark", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.ThroneoftortureClick ()

  local func_end = function ()

    int.Lock( false );
    cmn.ShowBbt( "bbt_throneoftorture_use_demonamulet" );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_throneoftorture_box_left" );
  AnimPlay( "anm_throneoftorture_click", "DoAnim", func_end ); 

end;
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG CAGE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------------------------------------
  function private.open_mmg()
    
    local func_end = function ()

      local func_end1 = function ()

        int.Lock( false );
        ObjSet( "obj_cage_mmg", { input = true } );
        ObjSet( "obj_cage_mmg_clk", { input = false } );
        ObjSet( "obj_cage_mmg_close", { input = true } );
        if not cmn.IsEventStart( "win_cage") then
          
           ng_global.progress[ "ext" ][ "win_cage" ].array = { 2, 2, 3 };
          
        end;
        cmn.MiniGameShow( "cage" );
        common_impl.PassingMgStart( "cage" );

      end; 

      if not ng_global.progress[ "ext" ][ "win_cage" ].array then

        ObjSet( "anm_cage_key_loose", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cage_use_key_cage" );
        AnimPlay( "anm_cage_key_loose", "DoAnim", func_end1 ); 

      else

        func_end1();

      end;

    end;
    
    int.Lock( true );
    ObjAnimate( "obj_cage_mmg", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 0,
      0.4, 3, 1
    } );

  end;
-----------------------------------------------------------------------------------------------------------------------
  function private.close_mmg()

    local func_end = function ()

      int.Lock( false );
      ObjSet( "obj_cage_mmg", { input = false } );
      ObjSet( "obj_cage_mmg_clk", { input = true } );
      ObjSet( "obj_cage_mmg_close", { input = false } );
      
      cmn.MiniGameHide( "cage"  );
      common_impl.PassingMgStop( "cage" )

    end;  
    int.Lock( true );
    ObjAnimate( "obj_cage_mmg", "alp", 0, 0, func_end, 
    { 
      0.0, 3, 1,
      0.4, 3, 0
    } );  
    
  end;
-------------------------------------------------------------------------------------
  function private.cage_start_init()

    cmn.MiniGameShow( "cage" );
    common_impl.PassingMgStart( "cage" );
    ng_global.progress[ "ext" ][ "win_cage" ].array = { 2, 2, 3 };
  --  ng_global.progress[ "ext" ][ "win_stash" ].ang_index = 0;
  --
  end;
--------------------------------------------------------------------------------------
  function private.cage_init()
    
    for i = 1, 3  do
      
      ObjSet( "spr_cage_button_push_"..i.."_clockwise", 
      {
         event_mdown = function () private.cage_clk_arrow( i, "clockwise")  end,
         event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
         event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end,
      
      } );
      
      ObjSet( "spr_cage_button_push_"..i.."_counterclockwise", 
      {
         event_mdown = function () private.cage_clk_arrow( i, "counterclockwise")  end,
         event_menter = function () cmn.SetCursor( CURSOR_HAND );  end,
         event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end,
      
      } );
      
    end
    
    --private.stash_win = { 1, 3, 5, 7, 9 };
    private.cage_ang = { 0, 2.09, 4.18 };
    --private.cage_current = { 1, 1, 1 };
    private.cage_current = { 2, 2, 3 };
    private.cage_start = { 2, 2, 3 };
    --private.stash_ang = { 0, -0.7, -1.36, -1.96, -2.58, -3.17, -3.75, -4.32, -4.96, -5.55 }
    
    
  end; 
-------------------------------------------------------------------------------------
  function private.cage_clk_arrow( num, direct )  

    local rnd = math.random( 3 );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mmg_key_cage_click_"..rnd );

    local start_ang, finish_ang,  start, finish;
    
    if direct == "clockwise" then
      
      
      start_ang = private.cage_current[num];
      finish_ang = private.cage_current[num] - 1;
      start = private.cage_ang[start_ang];
      finish = private.cage_ang[finish_ang];
      if finish_ang < 1 then 
        
        finish_ang = 3;
        finish = private.cage_ang[finish_ang]; 
        start = 6.28; 
        ObjSet( "spr_cage_mmg_disk_"..num, { ang = 6.28 });
        
      end;
      
      
    else 
      
     
      start_ang = private.cage_current[num];
      finish_ang = private.cage_current[num] + 1;
      start = private.cage_ang[start_ang];
      finish = private.cage_ang[finish_ang];
      if finish_ang > 3 then 
        
        finish_ang = 1; 
        finish = private.cage_ang[finish_ang];
        finish = 6.28;
       
      end;
      
     
    end;  
    
    local func_after = function ()

      local func_end = function ()
      
        int.Lock( false );
        if ObjGet( "spr_cage_mmg_disk_"..num).ang > 6 then ObjSet( "spr_cage_mmg_disk_"..num, { ang = 0 }) end ;
        private.cage_current[num] = finish_ang;
        if private.cage_check_win() then
        
          private.win_cage();
          
        else  
          
          ng_global.progress[ "ext" ][ "win_cage" ].array[num] = private.cage_current[num];
          
        end;  
          

      end;

    ObjAnimate( "spr_cage_mmg_disk_"..num, "ang", 0, 0, func_end, 
    { 
      0.0, 0, start,
      0.4, 0, finish
    } );
    
    end;
    int.Lock( true );
    ObjAnimate( "spr_cage_button_push_"..num.."_"..direct, "alp", 0, 0, func_after, 
    { 
      0.0, 3,    1,    
      0.2, 3,  0.5, 
      0.4, 3,    1  
    } );
    
    
  end; 
--************************************************************************************ 
  function private.cage_check_win()
    
    result = true;
    
    for i = 1, #private.cage_current do
      
      if private.cage_current[i] ~= 1 then
        
        result = false;
        break;
        
      end;  
      
    end
    
    return result;
    
  end; 
--******************************************************************************** 
  function private.win_cage()
    
    local func_after = function ()

      local func_after1 = function ()  

        local func_after2 = function ()  

          int.Lock( false ); 
          cmn.MiniGameHide( "cage" );
          common_impl.PassingMgWin( "cage" );
          cmn.SetEventDone( "win_cage" );
          cmn.CallEventHandler( "win_cage" );
          cmn.CloseSubRoom();

        end;

        ObjSet( "anm_cage_nik_static2", { alp = 1, playing = true } );
        ObjSet( "anm_cage_nik_static1", { alp = 0 } );
        ObjSet( "anm_cage_nik_static1_front", { alp = 0 } );
        ObjSet( "anm_cage_cage_click", { alp = 0 } );
        ObjSet( "spr_cage_nik_shad", { alp = 0 } );
        ObjSet( "anm_cage_cage_open", { alp = 1 } );
        cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cage_open_cage" );
        AnimPlay( "anm_cage_cage_open", "DoAnim", func_after2 ); 

      end;

      ObjAnimate( "obj_cage_mmg", "alp", 0, 0, func_after1, 
      { 
        0.0, 3,  1,    
        0.3, 3,  0 
        
      } );
      
    end;
    
    int.Lock( true );

--    ObjAnimate( "spr_cage_door_close", "pos_x", 0, 0, func_after,
--    {
--          0.0, 3, -92,
--          0.3, 3, -150,
--          0.6, 3, -300,
--          0.9, 3, -350
--    } );
--
--    ObjAnimate( "spr_cage_man_hands", "alp", 0, 0, "",
--    {
--      0.0, 3, 1.0,
--      0.3, 3, 0.0,
--    } );
--

    ObjSet( "anm_cage_key_loose", { alp = 0 } );
    ObjSet( "anm_cage_key_win", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_mmg_key_cage_insert" );
    AnimPlay( "anm_cage_key_win", "DoAnim", func_after ); 

  end;
--**************************************************************************************
  function private.cage_skip()
    
    private.win_cage();
    
  end; 
--***************************************************************************************
  function private.cage_reset()
    
    for i = 1, #private.cage_current do
      
      ng_global.progress[ "ext" ][ "win_cage" ].array[i] = private.cage_start[i];
      private.cage_current[i] = private.cage_start[i];
      ObjSet( "spr_cage_mmg_disk_"..i, { ang = private.cage_ang[ private.cage_current[i] ]});
      
    end;
    
  end;  
--*********************************************************************************************************************