-- name=rm_sidesteet
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_sidesteet";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_gate",    "room_hub" );
  ObjAttach( "zz_cart",    "room_hub" );
  ObjAttach( "zz_ossuary", "room_hub" );

  ObjMultiSet(
  {
    { "spr_gate_sphynxamulet_3",   { event_mdown = private.get_sphynxamulet_3 } },
    { "spr_cart_sphynxamulet_1",   { event_mdown = private.get_sphynxamulet_1 } },
    { "spr_cart_toymouse",         { event_mdown = private.get_toymouse } },
    { "spr_cart_salamanderamulet", { event_mdown = private.get_salamanderamulet } },
    { "spr_ossuary_crazydoctor_1", { event_mdown = private.get_crazydoctor_1 } },
    { "spr_ossuary_lilyamulet",    { event_mdown = private.get_lilyamulet } },
    { "obj_gate_use_gatekey",      { event_mdown = private.GateDoorsClick } },
    { "spr_cart_screensaver_4_3",    { event_mdown = private.get_screensaver_4_3 } },  
    { "spr_ossuary_screensaver_4_4", { event_mdown = private.get_screensaver_4_4 } },  
    { "obj_gate_use_packofseeds",    { event_mdown = private.GateCrowClick } },  
    { "obj_ossuary_use_jupiteremblem", { event_mdown = private.OssuaryBoxClick } },  
    { "spr_sidesteet_note_big",      { event_mdown = function() private.BigNoteClk() end } }, 
    { "obj_cart_use_crazydoctor",    { event_mdown = function() private.CartBoxClk() end } },
    { "obj_cart_use_fairyfigurine",    { event_mdown = function() private.CartCasketClk() end } }                 
  } );

  local get_screensaver_4_3 = function ()

    ObjDelete( "spr_cart_screensaver_4_3" );
    ObjDelete( "spr_sidesteet_cart_puzzle" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_3", get_screensaver_4_3, private.room_objname );
  local get_screensaver_4_4 = function ()

    ObjDelete( "spr_ossuary_screensaver_4_4" );
    ObjDelete( "spr_sidesteet_ossuary_puzzle" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_4", get_screensaver_4_4, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_sidesteet = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_sidesteet", update_game_mode_sidesteet, private.room_objname );  

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_9 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_9 = function ()

    ObjDelete( "obj_sidesteet_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_9", get_morphobject_4_9, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sphynxamulet_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sphynxamulet_3" ] =
  {
    type = "get",
    get_obj = "spr_gate_sphynxamulet_3",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_sidesteet_gate"
  };
  --------------------------------------------------------------------------------------------
  local get_sphynxamulet_3_inv = function ()

    int.InventoryItemAdd( "inv_sphynxamulet", "spr_gate_sphynxamulet_3", "assets/levels/levelext/rm_sidesteet/zz_cart/inv/inv_sphynxamulet_3" );
    levelext_inv.CheckSphynxamulet( 3 );

  end;
  local get_sphynxamulet_3_closezz = function ()

    ObjDelete( "gfx_gate_sphynxamulet_3" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sphynxamulet_3", get_sphynxamulet_3_inv );
  cmn.AddSubscriber( "get_sphynxamulet_3", get_sphynxamulet_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sphynxamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sphynxamulet_1" ] =
  {
    type = "get",
    get_obj = "spr_cart_sphynxamulet_1",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_sidesteet_cart"
  };
  --------------------------------------------------------------------------------------------
  local get_sphynxamulet_1_inv = function ()

    int.InventoryItemAdd( "inv_sphynxamulet", "spr_cart_sphynxamulet_1", "assets/levels/levelext/rm_sidesteet/zz_cart/inv/inv_sphynxamulet_1" );
    levelext_inv.CheckSphynxamulet( 1 );

  end;
  local get_sphynxamulet_1_closezz = function ()

    ObjDelete( "gfx_cart_sphynxamulet_1" );

    ObjDelete( "spr_sidesteet_cart_sphynxamulet" );

    if cmn.IsEventDone( "get_toymouse" ) and 
       cmn.IsEventDone( "get_salamanderamulet" ) then
      ObjDelete( "gzz_sidesteet_cart" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sphynxamulet_1", get_sphynxamulet_1_inv );
  cmn.AddSubscriber( "get_sphynxamulet_1", get_sphynxamulet_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_toymouse () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_toymouse" ] =
  {
    type = "get",
    get_obj = "spr_cart_toymouse",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_sidesteet_cart"
  };
  --------------------------------------------------------------------------------------------
  local get_toymouse_inv = function ()

    int.InventoryItemAdd( "inv_toymouse", "spr_cart_toymouse" );

    if cmn.IsEventDone( "get_toydial" ) then
      ObjSet( "inv_toydial_plus_focus2", { alp = 1 } );
    end;

  end;
  local get_toymouse_closezz = function ()

    ObjDelete( "gfx_cart_toymouse" );

    ObjDelete( "spr_sidesteet_cart_toymouse" );

    if cmn.IsEventDone( "get_sphynxamulet_1" ) and 
       cmn.IsEventDone( "get_salamanderamulet" ) then
      ObjDelete( "gzz_sidesteet_cart" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_toymouse", get_toymouse_inv );
  cmn.AddSubscriber( "get_toymouse", get_toymouse_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_salamanderamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_salamanderamulet" ] =
  {
    type = "get",
    get_obj = "spr_cart_salamanderamulet",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_sidesteet_cart"
  };
  --------------------------------------------------------------------------------------------
  local get_salamanderamulet_inv = function ()

    int.InventoryItemAdd( "inv_salamanderamulet", "spr_cart_salamanderamulet" );

  end;
  local get_salamanderamulet_closezz = function ()

    ObjDelete( "gfx_cart_salamanderamulet" );

    ObjDelete( "spr_sidesteet_cart_salamanderamulet" );

    if cmn.IsEventDone( "get_sphynxamulet_1" ) and 
       cmn.IsEventDone( "get_toymouse" ) then
      ObjDelete( "gzz_sidesteet_cart" );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_salamanderamulet", get_salamanderamulet_inv );
  cmn.AddSubscriber( "get_salamanderamulet", get_salamanderamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crazydoctor_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crazydoctor_1" ] =
  {
    type = "get",
    get_obj = "spr_ossuary_crazydoctor_1",
    room = private.room_objname,
    zz = "zz_ossuary",
    zz_gate = "gzz_sidesteet_ossuary"
  };
  --------------------------------------------------------------------------------------------
  local get_crazydoctor_1_inv = function ()

    int.InventoryItemAdd( "inv_crazydoctor", "spr_ossuary_crazydoctor_1", "assets/levels/levelext/rm_sidesteet/zz_ossuary/inv/inv_crazydoctor_1" );
    levelext_inv.CheckCrazydoctor( 1 );

  end;
  local get_crazydoctor_1_closezz = function ()

    ObjDelete( "gfx_ossuary_crazydoctor_1" );

    ObjDelete( "spr_sidesteet_ossuary_crazydoctor" );

    if ( cmn.IsEventDone( "get_lilyamulet" ) ) then

      ObjDelete( "gzz_sidesteet_ossuary" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_crazydoctor_1", get_crazydoctor_1_inv );
  cmn.AddSubscriber( "get_crazydoctor_1", get_crazydoctor_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lilyamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lilyamulet" ] =
  {
    type = "get",
    get_obj = "spr_ossuary_lilyamulet",
    room = private.room_objname,
    zz = "zz_ossuary",
    zz_gate = "gzz_sidesteet_ossuary"
  };
  --------------------------------------------------------------------------------------------
  local get_lilyamulet_inv = function ()

    int.InventoryItemAdd( "inv_lilyamulet", "spr_ossuary_lilyamulet" );

  end;
  local get_lilyamulet_closezz = function ()

    ObjDelete( "gfx_ossuary_lilyamulet" );

    ObjDelete( "spr_sidesteet_ossuary_lilyamulet" );

    if ( cmn.IsEventDone( "get_crazydoctor_1" ) ) then

      ObjDelete( "gzz_sidesteet_ossuary" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lilyamulet", get_lilyamulet_inv );
  cmn.AddSubscriber( "get_lilyamulet", get_lilyamulet_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_packofseeds () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_packofseeds" ] =
  {
    type = "use",
    use_obj = "inv_packofseeds",
    use_place = "obj_gate_use_packofseeds",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_sidesteet_gate"
  };
  --------------------------------------------------------------------------------------------
  local use_packofseeds_inv = function ()

    int.InventoryItemRemove( "inv_packofseeds" );

  end;
  local use_packofseeds_beg = function ()

    ObjDelete( "obj_gate_use_packofseeds" );
    ObjDelete( "anm_gate_crow_click" );
    ObjDelete( "anm_gate_crow_static" );

  end;
  local use_packofseeds_end = function ()

    ObjDelete( "anm_gate_packofseeds" );
    ObjSet( "spr_gate_sphynxamulet_3", { input = true } );
    ObjSet( "gfx_gate_sphynxamulet_3", { active = true } );
    ObjSet( "spr_gate_seeds", { alp = 1 } );
    ObjDelete( "spr_sidesteet_gate_raven" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_packofseeds",     use_packofseeds_inv );
  cmn.AddSubscriber( "use_packofseeds",     use_packofseeds_beg, private.room_objname );
  cmn.AddSubscriber( "use_packofseeds",     use_packofseeds_end, private.room_objname );
  cmn.AddSubscriber( "use_packofseeds_inv", use_packofseeds_inv, private.room_objname );
  cmn.AddSubscriber( "use_packofseeds_beg", use_packofseeds_beg, private.room_objname );
  cmn.AddSubscriber( "use_packofseeds_end", use_packofseeds_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gatekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gatekey" ] =
  {
    type = "use",
    use_obj = "inv_gatekey",
    use_place = "obj_gate_use_gatekey",
    room = private.room_objname,
    zz = "zz_gate",
    zz_gate = "gzz_sidesteet_gate"
  };
  --------------------------------------------------------------------------------------------
  local use_gatekey_inv = function ()

    int.InventoryItemRemove( "inv_gatekey" );

  end;
  local use_gatekey_beg = function ()

    ObjDelete( "obj_gate_use_gatekey" );
    ObjDelete( "anm_gate_gate_click" );

  end;
  local use_gatekey_end = function ()

    ObjDelete( "gzz_sidesteet_gate" );
    ObjSet( "grm_sidesteet_park", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_sidesteet_park_focus");
    end;
    
    ObjDelete( "spr_sidesteet_gate_closed" );
    ObjSet( "spr_sidesteet_gate_open", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gatekey",     use_gatekey_inv );
  cmn.AddSubscriber( "use_gatekey",     use_gatekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_gatekey",     use_gatekey_end, private.room_objname );
  cmn.AddSubscriber( "use_gatekey_inv", use_gatekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_gatekey_beg", use_gatekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_gatekey_end", use_gatekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fairyfigurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fairyfigurine" ] =
  {
    type = "use",
    use_obj = "inv_fairyfigurine",
    use_place = "obj_cart_use_fairyfigurine",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_sidesteet_cart"
  };
  --------------------------------------------------------------------------------------------
  local use_fairyfigurine_inv = function ()

    int.InventoryItemRemove( "inv_fairyfigurine" );

  end;
  local use_fairyfigurine_beg = function ()

    ObjDelete( "obj_cart_use_fairyfigurine" );

  end;
  local use_fairyfigurine_end = function ()

    ObjSet( "obj_cart_casket_open", { input = true } );
    ObjSet( "anm_cart_use_fairyfigurine", { frame = 500 } );

    ObjSet( "gfx_cart_toymouse", { active = true } );

    ObjSet( "spr_sidesteet_cart_casket_open", { alp = 1 } );
    ObjDelete( "spr_sidesteet_cart_casket_close" );
    ObjDelete( "anm_cart_click_casket" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fairyfigurine",     use_fairyfigurine_inv );
  cmn.AddSubscriber( "use_fairyfigurine",     use_fairyfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_fairyfigurine",     use_fairyfigurine_end, private.room_objname );
  cmn.AddSubscriber( "use_fairyfigurine_inv", use_fairyfigurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_fairyfigurine_beg", use_fairyfigurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_fairyfigurine_end", use_fairyfigurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crazydoctor () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crazydoctor" ] =
  {
    type = "use",
    use_obj = "inv_crazydoctor",
    use_place = "obj_cart_use_crazydoctor",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_sidesteet_cart"
  };
  --------------------------------------------------------------------------------------------
  local use_crazydoctor_inv = function ()

    int.InventoryItemRemove( "inv_crazydoctor" );

  end;
  local use_crazydoctor_beg = function ()

    ObjDelete( "obj_cart_use_crazydoctor" );

  end;
  local use_crazydoctor_end = function ()

    ObjSet( "anm_cart_use_crazydoctor", { alp = 1, frame = 500 } );
    ObjSet( "obj_cart_box_open", { input = true } );
    ObjDelete( "obj_cart_box_close" );

    ObjSet( "gfx_cart_salamanderamulet", { active = true } );

    ObjSet( "obj_sidesteet_cart_box", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crazydoctor",     use_crazydoctor_inv );
  cmn.AddSubscriber( "use_crazydoctor",     use_crazydoctor_beg, private.room_objname );
  cmn.AddSubscriber( "use_crazydoctor",     use_crazydoctor_end, private.room_objname );
  cmn.AddSubscriber( "use_crazydoctor_inv", use_crazydoctor_inv, private.room_objname );
  cmn.AddSubscriber( "use_crazydoctor_beg", use_crazydoctor_beg, private.room_objname );
  cmn.AddSubscriber( "use_crazydoctor_end", use_crazydoctor_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_jupiteremblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jupiteremblem" ] =
  {
    type = "use",
    use_obj = "inv_jupiteremblem",
    use_place = "obj_ossuary_use_jupiteremblem",
    room = private.room_objname,
    zz = "zz_ossuary",
    zz_gate = "gzz_sidesteet_ossuary"
  };
  --------------------------------------------------------------------------------------------
  local use_jupiteremblem_inv = function ()

    int.InventoryItemRemove( "inv_jupiteremblem" );

  end;
  local use_jupiteremblem_beg = function ()

    ObjDelete( "obj_ossuary_use_jupiteremblem" );
    ObjDelete( "spr_ossuary_box_cap_close" );

  end;
  local use_jupiteremblem_end = function ()

    ObjSet( "anm_ossuary_jupiteremblem", { alp = 1, frame = 53, animfunc = "DoAnim" } );
    ObjSet( "spr_ossuary_crazydoctor_1", { input = true } );
    ObjSet( "gfx_ossuary_crazydoctor_1", { active = true } );

    ObjDelete( "spr_sidesteet_ossuary_close_box" );
    ObjSet( "spr_sidesteet_ossuary_crazydoctor",      { alp = 1 } );
    ObjSet( "spr_sidesteet_ossuary_open_box",      { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jupiteremblem",     use_jupiteremblem_inv );
  cmn.AddSubscriber( "use_jupiteremblem",     use_jupiteremblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_jupiteremblem",     use_jupiteremblem_end, private.room_objname );
  cmn.AddSubscriber( "use_jupiteremblem_inv", use_jupiteremblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_jupiteremblem_beg", use_jupiteremblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_jupiteremblem_end", use_jupiteremblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_antimagicpowder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_antimagicpowder" ] =
  {
    type = "use",
    use_obj = "inv_antimagicpowder",
    use_place = "obj_ossuary_use_antimagicpowder",
    room = private.room_objname,
    zz = "zz_ossuary",
    zz_gate = "gzz_sidesteet_ossuary"
  };
  --------------------------------------------------------------------------------------------
  local use_antimagicpowder_inv = function ()

    int.InventoryItemRemove( "inv_antimagicpowder" );

  end;
  local use_antimagicpowder_beg = function ()

    ObjDelete( "obj_ossuary_use_antimagicpowder" );

  end;
  local use_antimagicpowder_end = function ()

    ObjDelete( "anm_ossuary_blue_fire" );
    ObjDelete( "anm_ossuary_antimagicpowder" );
    ObjSet( "spr_ossuary_lilyamulet", { input = true } );
    ObjSet( "gfx_ossuary_lilyamulet", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_antimagicpowder",     use_antimagicpowder_inv );
  cmn.AddSubscriber( "use_antimagicpowder",     use_antimagicpowder_beg, private.room_objname );
  cmn.AddSubscriber( "use_antimagicpowder",     use_antimagicpowder_end, private.room_objname );
  cmn.AddSubscriber( "use_antimagicpowder_inv", use_antimagicpowder_inv, private.room_objname );
  cmn.AddSubscriber( "use_antimagicpowder_beg", use_antimagicpowder_beg, private.room_objname );
  cmn.AddSubscriber( "use_antimagicpowder_end", use_antimagicpowder_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_3()

  int.AddScreensaver( "spr_cart_screensaver_4_3" );

end;    
------------------------------------------------------------------------------------------
function private.get_screensaver_4_4()

  int.AddScreensaver( "spr_ossuary_screensaver_4_4" );

end;  
-----------------------------------------------------------------------
function private.get_sphynxamulet_3 ()

  cmn.SetEventDone( "get_sphynxamulet_3" );
  cmn.CallEventHandler( "get_sphynxamulet_3" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_sphynxamulet_1 ()

  cmn.SetEventDone( "get_sphynxamulet_1" );
  cmn.CallEventHandler( "get_sphynxamulet_1" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_toymouse" ) and 
     cmn.IsEventDone( "get_salamanderamulet" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_toymouse ()

  cmn.SetEventDone( "get_toymouse" );
  cmn.CallEventHandler( "get_toymouse" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_sphynxamulet_1" ) and 
     cmn.IsEventDone( "get_salamanderamulet" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_salamanderamulet ()

  cmn.SetEventDone( "get_salamanderamulet" );
  cmn.CallEventHandler( "get_salamanderamulet" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_sphynxamulet_1" ) and 
     cmn.IsEventDone( "get_toymouse" ) then
    cmn.CloseSubRoom();
  end;

end;
-----------------------------------------------------------------------
function private.get_crazydoctor_1 ()

  cmn.SetEventDone( "get_crazydoctor_1" );
  cmn.CallEventHandler( "get_crazydoctor_1" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_lilyamulet" ) ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_lilyamulet ()

  cmn.SetEventDone( "get_lilyamulet" );
  cmn.CallEventHandler( "get_lilyamulet" );
  cmn.GetObjectSfx();

  if ( cmn.IsEventDone( "get_crazydoctor_1" ) ) then

    cmn.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_packofseeds ()

  local item = "inv_packofseeds";

  if ( cmn.ApplyObj( item, "gzz_sidesteet_gate", false ) ) and
     ( not cmn.IsEventDone( "use_packofseeds" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gate", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gate_use_packofseeds", true ) ) and
         ( not cmn.IsEventDone( "use_packofseeds" ) ) then

    cmn.CallEventHandler( "use_packofseeds_inv" );
    cmn.CallEventHandler( "use_packofseeds_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_packofseeds" );
      cmn.CallEventHandler( "use_packofseeds_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_gate_packofseeds", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_gate_seeds_crow" );
    AnimPlay( "anm_gate_packofseeds", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_gatekey ()

  local item = "inv_gatekey";

  if ( cmn.ApplyObj( item, "gzz_sidesteet_gate", false ) ) and
     ( not cmn.IsEventDone( "use_gatekey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gate", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_gate_use_gatekey", true ) ) and
         ( not cmn.IsEventDone( "use_gatekey" ) ) then

    cmn.CallEventHandler( "use_gatekey_inv" );
    cmn.CallEventHandler( "use_gatekey_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_gatekey" );
      cmn.CallEventHandler( "use_gatekey_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );

    ObjSet( "anm_gate_gatekey", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_gate_open_gates_key" );
    AnimPlay( "anm_gate_gatekey", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_fairyfigurine ()

  local item = "inv_fairyfigurine";

  if ( cmn.ApplyObj( item, "gzz_sidesteet_cart", false ) ) and
     ( not cmn.IsEventDone( "use_fairyfigurine" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cart_use_fairyfigurine", true ) ) and
         ( not cmn.IsEventDone( "use_fairyfigurine" ) ) then

    cmn.CallEventHandler( "use_fairyfigurine_inv" );
    cmn.CallEventHandler( "use_fairyfigurine_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_fairyfigurine" );
      cmn.CallEventHandler( "use_fairyfigurine_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_cart_click_casket", { alp = 0 } );
    ObjSet( "anm_cart_use_fairyfigurine", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cart_insert_figure_down_cell_opens" );
    AnimPlay( "anm_cart_use_fairyfigurine", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_crazydoctor ()

  local item = "inv_crazydoctor";

  if ( cmn.ApplyObj( item, "gzz_sidesteet_cart", false ) ) and
     ( not cmn.IsEventDone( "use_crazydoctor" ) ) and 
       cmn.IsEventDone( "get_crazydoctor_1" ) and 
       cmn.IsEventDone( "get_crazydoctor_2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_cart_use_crazydoctor", true ) ) and
         ( not cmn.IsEventDone( "use_crazydoctor" ) ) and 
           cmn.IsEventDone( "get_crazydoctor_1" ) and 
           cmn.IsEventDone( "get_crazydoctor_2" ) then

    cmn.CallEventHandler( "use_crazydoctor_inv" );
    cmn.CallEventHandler( "use_crazydoctor_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_crazydoctor" );
      cmn.CallEventHandler( "use_crazydoctor_end" );

    end;

    int.Lock( true );

    ObjSet( "obj_cart_box_close", { alp = 0 } );
    ObjSet( "anm_cart_use_crazydoctor", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_cart_insert_figures_dortors" );
    AnimPlay( "anm_cart_use_crazydoctor", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_jupiteremblem ()

  local item = "inv_jupiteremblem";

  if ( cmn.ApplyObj( item, "gzz_sidesteet_ossuary", false ) ) and
     ( not cmn.IsEventDone( "use_jupiteremblem" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ossuary", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ossuary_use_jupiteremblem", true ) ) and
         ( not cmn.IsEventDone( "use_jupiteremblem" ) ) then

    cmn.CallEventHandler( "use_jupiteremblem_inv" );
    cmn.CallEventHandler( "use_jupiteremblem_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_jupiteremblem" );
      cmn.CallEventHandler( "use_jupiteremblem_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_ossuary_jupiteremblem", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_ossuary_insert_21" );
    AnimPlay( "anm_ossuary_jupiteremblem", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_antimagicpowder ()

  local item = "inv_antimagicpowder";

  if ( cmn.ApplyObj( item, "gzz_sidesteet_ossuary", false ) ) and
     ( not cmn.IsEventDone( "use_antimagicpowder" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ossuary", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_ossuary_use_antimagicpowder", true ) ) and
         ( not cmn.IsEventDone( "use_antimagicpowder" ) ) then

    cmn.CallEventHandler( "use_antimagicpowder_inv" );
    cmn.CallEventHandler( "use_antimagicpowder_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_antimagicpowder" );
      cmn.CallEventHandler( "use_antimagicpowder_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_ossuary_fill_powder_skull" );
    ObjSet( "anm_ossuary_antimagicpowder", { alp = 1 } );
    AnimPlay( "anm_ossuary_antimagicpowder", "DoAnim", func_end );
    ObjAnimate( "anm_ossuary_blue_fire", "alp", 0, 0, "",
    {
      0.0, 3, 1.0,
      0.4, 3, 1.0,
      1.0, 3, 0.0,
    } );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.opn_sidesteet ()

  if not ( cmn.IsEventDone( "opn_sidesteet" ) ) then

    cmn.SetEventDone( "opn_sidesteet" );
    cmn.ShowBbt( "bbt_sidesteet_first_enter" );

  end;

  cmn.StopAllEnv( "audio/level4/env/aud_rm_sidestreet_env", true );
  cmn.PlayAudio( "env", "audio/level4/env/aud_rm_sidestreet_env", 1 );

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_sidesteet();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_sphynxamulet_3",                                             { "use_packofseeds" } );
  int.AddedTaskMap( private.room_objname, "get_sphynxamulet_1" );
  int.AddedTaskMap( private.room_objname, "get_toymouse",                                                   { "use_fairyfigurine" } );
  int.AddedTaskMap( private.room_objname, "get_salamanderamulet",                                           { "use_crazydoctor" } );
  int.AddedTaskMap( private.room_objname, "get_crazydoctor_1",                                              { "use_jupiteremblem" } );
  int.AddedTaskMap( private.room_objname, "get_lilyamulet",                                                 { "use_antimagicpowder" } );

  int.AddedTaskMap( private.room_objname, "use_packofseeds",                                                { "get_packofseeds" } );
  int.AddedTaskMap( private.room_objname, "use_gatekey",                                                    { "win_hosafe" } );
  int.AddedTaskMap( private.room_objname, "use_fairyfigurine",                                              { "get_fairyfigurine" } );
  int.AddedTaskMap( private.room_objname, "use_crazydoctor",                                                { "get_crazydoctor_1", "get_crazydoctor_2" } );
  int.AddedTaskMap( private.room_objname, "use_jupiteremblem",                                              { "get_jupiteremblem" } );
  int.AddedTaskMap( private.room_objname, "use_antimagicpowder",                                            { "get_antimagicpowder" } );

  int.AddedTaskMap( private.room_objname, "opn_park",                                                       { "use_gatekey" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()
--[[
  subroom.Define( "zz_picture" );  
  -------------------------------------------------
  function zz_picture.Open()
  end;
  -------------------------------------------------
  function zz_picture.PreClose()
  end;
  -------------------------------------------------
  function zz_picture.Skip ()
  end;
  -------------------------------------------------
  function zz_picture.Reset ()
  end;
  -------------------------------------------------
]]--
end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_cart_light", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.5, 3, 0.4,
    5.0, 3, 1.0,
  } );
  ObjAnimate( "spr_sidesteet_ossuary_fire", "alp", 1, 0, "",
  {
    0.0, 3, 1.0,
    2.0, 3, 0.5,
    4.0, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.GateDoorsClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_gate_use_gatekey" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_gate_crow" );
  AnimPlay( "anm_gate_gate_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.GateCrowClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_gate_use_packofseeds" );
    int.Lock( false );

    ObjSet( "anm_gate_crow_click", { alp = 0 } );
    ObjSet( "anm_gate_crow_static", { alp = 1 } );

    AnimStop( "anm_gate_crow_click" );
    AnimPlay( "anm_gate_crow_static", "DoAnim", "" );

  end;

  int.Lock( true );

  ObjSet( "anm_gate_crow_static", { alp = 0 } );
  ObjSet( "anm_gate_crow_click", { alp = 1 } );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_gate_gates" );
  AnimStop( "anm_gate_crow_static" );
  AnimPlay( "anm_gate_crow_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.BigNoteClk ()

  --if not ng_global.progress["ext"]["opn_square"].note then
  --  cmn.ShowBbt( "bbt_square_note" );
  --  ng_global.progress["ext"]["opn_square"].note = 1;
  --end;

  cmn.NoteScale( { "spr_sidesteet_note" } );

end;
--*********************************************************************************************************************
function private.CartBoxClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_cart_use_crazydoctor" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_cart_box_up_left" );
  AnimPlay( "anm_cart_clk_box", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.CartCasketClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_cart_use_fairyfigurine" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_cart_thing_below" );
  AnimPlay( "anm_cart_click_casket", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.OssuaryBoxClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_ossuary_use_jupiteremblem" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_ossuary_21" );
  ObjAnimate( "spr_ossuary_box_cap_close", "pos_y", 0, 0, func_end,
  {
    0.0, 3, -209,
    0.2, 3, -211,
    0.4, 3, -209,
    0.6, 3, -211,
    0.8, 3, -209,
  } );

end;
--*********************************************************************************************************************