-- name=rm_square
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "rm_square";

  private.InitSubroom();
  private.InitAnimations();

  ObjAttach( "zz_storedoor",      "room_hub" );
  ObjAttach( "zz_vendingbooth",   "room_hub" );
  ObjAttach( "zz_victormemorial", "room_hub" );

  ObjMultiSet(
  {
    { "spr_storedoor_sigmaamulet",             { event_mdown = private.get_sigmaamulet } },
    { "spr_storedoor_firepoker",               { event_mdown = private.get_firepoker } },
    { "spr_vendingbooth_stiletto",             { event_mdown = private.get_stiletto } },
    { "spr_vendingbooth_sphynxamulet_2",       { event_mdown = private.get_sphynxamulet_2 } },
    { "spr_victormemorial_knightamulet",       { event_mdown = private.get_knightamulet } },
    { "spr_victormemorial_leprechaunamulet_1", { event_mdown = private.get_leprechaunamulet_1 } },
    { "spr_victormemorial_alchemistryamulet",  { event_mdown = private.get_alchemistryamulet } },
    { "spr_victormemorial_storekey",           { event_mdown = private.get_storekey } },
    { "obj_storedoor_use_storekey",            { event_mdown = private.StoredoorDoorsClick } },
    { "spr_vendingbooth_flaskofwater",         { event_mdown = private.get_flaskofwater } },
    { "spr_vendingbooth_pincers",              { event_mdown = private.get_pincers } },
    { "obj_victormemorial_use_sigmaamulet",    { event_mdown = private.VictormemorialCapClick } },
    { "obj_storedoor_use_stiletto_1",          { event_mdown = private.StoredoorStoneClick } },
    { "obj_victormemorial_use_pincers",        { event_mdown = function() private.VictormemorialKnightamuletClick( "pincers" ) end } },
    { "obj_victormemorial_use_flaskofwater",   { event_mdown = function() private.VictormemorialKnightamuletClick( "flaskofwater" ) end } },
    { "obj_vendingbooth_use_awl",              { event_mdown = function() private.VendingboothSmallChestClk() end } },
    { "obj_vendingbooth_use_firepoker",        { event_mdown = function() private.VendingboothBoxClk() end } },
    { "obj_vendingbooth_use_knightamulet",     { event_mdown = function() private.VendingboothChestClk() end } },
    { "spr_vendingbooth_screensaver_4_1",      { event_mdown = private.get_screensaver_4_1 } },          
    { "spr_victormemorial_screensaver_4_5",    { event_mdown = private.get_screensaver_4_5 } }, 
    { "spr_square_note_big",                   { event_mdown = function() private.SquareBigNoteClk() end } },             
  } );

  local get_screensaver_4_1 = function ()

    ObjDelete( "spr_vendingbooth_screensaver_4_1" );

  end;
  cmn.AddSubscriber( "get_screensaver_4_1", get_screensaver_4_1, private.room_objname );  
  local get_screensaver_4_5 = function ()

    ObjDelete( "spr_victormemorial_screensaver_4_5" );
    ObjDelete( "spr_square_victormemorial_collect");

  end;
  cmn.AddSubscriber( "get_screensaver_4_5", get_screensaver_4_5, private.room_objname );  


  private.InitMiniHO();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_square = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    --search all gates
    local room_name = string.sub( private.room_objname, 4, #private.room_objname );
    local gates = ObjGetRelations( "obj_"..room_name.."_gates" );

    for i = 1, #gates.childs do      
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );          
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

    --get all zz
    local mas_parent_gfx = 
    {
      private.room_objname
    };

    local cut_length = 5 + #room_name;

    for i = 1, #gates.childs do
      local name = gates.childs[ i ]
      if ( common.GetObjectPrefix( name ) == "gzz" ) then
        table.insert( mas_parent_gfx, "zz"..string.sub( name, cut_length ) );
      end;
    end;

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;

  cmn.AddSubscriber( "update_game_mode_square", update_game_mode_square, private.room_objname );  

--*********************************************************************************************************************

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    int.InitMorphRandomState( 4 );

  end;

--*********************************************************************************************************************
-- PROGRESS GET
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function get_morphobject_4_10 () end;
  --------------------------------------------------------------------------------------------
  local get_morphobject_4_10 = function ()

    ObjDelete( "obj_square_morphobject" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_morphobject_4_10", get_morphobject_4_10, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sigmaamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sigmaamulet" ] =
  {
    type = "get",
    get_obj = "spr_storedoor_sigmaamulet",
    room = private.room_objname,
    zz = "zz_storedoor",
    zz_gate = "gzz_square_storedoor"
  };
  --------------------------------------------------------------------------------------------
  local get_sigmaamulet_inv = function ()

    int.InventoryItemAdd( "inv_sigmaamulet", "spr_storedoor_sigmaamulet" );

  end;
  local get_sigmaamulet_closezz = function ()

    ObjDelete( "gfx_storedoor_sigmaamulet" );
    ObjDelete( "spr_square_storedoor_amul");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sigmaamulet", get_sigmaamulet_inv );
  cmn.AddSubscriber( "get_sigmaamulet", get_sigmaamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_firepoker () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_firepoker" ] =
  {
    type = "get",
    get_obj = "spr_storedoor_firepoker",
    room = private.room_objname,
    zz = "zz_storedoor",
    zz_gate = "gzz_square_storedoor"
  };
  --------------------------------------------------------------------------------------------
  local get_firepoker_inv = function ()

    int.InventoryItemAdd( "inv_firepoker", "spr_storedoor_firepoker" );

  end;
  local get_firepoker_closezz = function ()

    ObjDelete( "gfx_storedoor_firepoker" );
    ObjDelete( "spr_square_storedoor_firepoker");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_firepoker", get_firepoker_inv );
  cmn.AddSubscriber( "get_firepoker", get_firepoker_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stiletto () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stiletto" ] =
  {
    type = "get",
    get_obj = "spr_vendingbooth_ho_1",
    room = private.room_objname,
    zz = "zz_vendingbooth",
    zz_gate = "gzz_square_vendingbooth"
  };
  --------------------------------------------------------------------------------------------
  local get_stiletto_inv = function ()

    int.InventoryItemAdd( "inv_stiletto", "spr_vendingbooth_win" );

    if cmn.IsEventDone( "get_container" ) then
      ObjSet( "inv_container_plus_focus2", { alp = 1 } );
    end;

  end;
  local get_stiletto_closezz = function ()

    ObjDelete( "obj_vendingbooth_miniho" );
    ObjDelete( "obj_square_vendingbooth_miniho");
    ObjDelete( "gfx_vendingbooth_stiletto" );

    if cmn.IsEventDone( "get_pincers" ) and 
       cmn.IsEventDone( "get_flaskofwater" ) and 
       cmn.IsEventDone( "get_sphynxamulet_2" ) then

      ObjDelete( "gzz_square_vendingbooth" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_stiletto", get_stiletto_inv );
  cmn.AddSubscriber( "get_stiletto", get_stiletto_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flaskofwater () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flaskofwater" ] =
  {
    type = "get",
    get_obj = "spr_vendingbooth_flaskofwater",
    room = private.room_objname,
    zz = "zz_vendingbooth",
    zz_gate = "gzz_square_vendingbooth"
  };
  --------------------------------------------------------------------------------------------
  local get_flaskofwater_inv = function ()

    int.InventoryItemAdd( "inv_flaskofwater", "spr_vendingbooth_flaskofwater" );

  end;
  local get_flaskofwater_closezz = function ()

    ObjDelete( "gfx_vendingbooth_flaskofwater" );
    ObjDelete( "spr_square_vendingbooth_flask");

    if cmn.IsEventDone( "get_pincers" ) and 
       cmn.IsEventDone( "get_stiletto" ) and 
       cmn.IsEventDone( "get_sphynxamulet_2" ) then

      ObjDelete( "gzz_square_vendingbooth" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_flaskofwater", get_flaskofwater_inv );
  cmn.AddSubscriber( "get_flaskofwater", get_flaskofwater_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pincers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pincers" ] =
  {
    type = "get",
    get_obj = "spr_vendingbooth_pincers",
    room = private.room_objname,
    zz = "zz_vendingbooth",
    zz_gate = "gzz_square_vendingbooth"
  };
  --------------------------------------------------------------------------------------------
  local get_pincers_inv = function ()

    int.InventoryItemAdd( "inv_pincers", "spr_vendingbooth_pincers" );

    if cmn.IsEventDone( "get_container" ) then
      ObjSet( "inv_container_plus_focus2", { alp = 1 } );
    end;

  end;
  local get_pincers_closezz = function ()

    ObjDelete( "gfx_vendingbooth_pincers" );
    ObjDelete( "spr_square_vendingbooth_scissors");

    if cmn.IsEventDone( "get_flaskofwater" ) and 
       cmn.IsEventDone( "get_stiletto" ) and 
       cmn.IsEventDone( "get_sphynxamulet_2" ) then

      ObjDelete( "gzz_square_vendingbooth" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_pincers", get_pincers_inv );
  cmn.AddSubscriber( "get_pincers", get_pincers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_sphynxamulet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_sphynxamulet_2" ] =
  {
    type = "get",
    get_obj = "spr_vendingbooth_sphynxamulet_2",
    room = private.room_objname,
    zz = "zz_vendingbooth",
    zz_gate = "gzz_square_vendingbooth"
  };
  --------------------------------------------------------------------------------------------
  local get_sphynxamulet_2_inv = function ()

    int.InventoryItemAdd( "inv_sphynxamulet", "spr_vendingbooth_sphynxamulet_2", "assets/levels/levelext/rm_sidesteet/zz_cart/inv/inv_sphynxamulet_2" );
    levelext_inv.CheckSphynxamulet( 2 );

  end;
  local get_sphynxamulet_2_closezz = function ()

    ObjDelete( "gfx_vendingbooth_sphynxamulet_2" );
    ObjDelete( "spr_square_vendingbooth_box_2_amulet");

    if cmn.IsEventDone( "get_flaskofwater" ) and 
       cmn.IsEventDone( "get_stiletto" ) and 
       cmn.IsEventDone( "get_pincers" ) then

      ObjDelete( "gzz_square_vendingbooth" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_sphynxamulet_2", get_sphynxamulet_2_inv );
  cmn.AddSubscriber( "get_sphynxamulet_2", get_sphynxamulet_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knightamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_knightamulet" ] =
  {
    type = "get",
    get_obj = "spr_victormemorial_knightamulet",
    room = private.room_objname,
    zz = "zz_victormemorial",
    zz_gate = "gzz_square_victormemorial"
  };
  --------------------------------------------------------------------------------------------
  local get_knightamulet_inv = function ()

    int.InventoryItemAdd( "inv_knightamulet", "spr_victormemorial_knightamulet" );

  end;
  local get_knightamulet_closezz = function ()

    ObjDelete( "gfx_victormemorial_knightamulet" );
    ObjDelete( "spr_square_victormemorial_knighthead");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_knightamulet", get_knightamulet_inv );
  cmn.AddSubscriber( "get_knightamulet", get_knightamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_leprechaunamulet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_leprechaunamulet_1" ] =
  {
    type = "get",
    get_obj = "spr_victormemorial_leprechaunamulet_1",
    room = private.room_objname,
    zz = "zz_victormemorial",
    zz_gate = "gzz_square_victormemorial"
  };
  --------------------------------------------------------------------------------------------
  local get_leprechaunamulet_1_inv = function ()

    int.InventoryItemAdd( "inv_leprechaunamulet", "spr_victormemorial_leprechaunamulet_1", "assets/levels/levelext/rm_square/zz_victormemorial/inv/inv_leprechaunamulet_1" );
    levelext_inv.CheckLeprechaunamulet();

  end;
  local get_leprechaunamulet_1_closezz = function ()

    ObjDelete( "gfx_victormemorial_leprechaunamulet_1" );
    ObjDelete( "spr_square_victormemorial_gnumme");
    
    if cmn.IsEventDone( "get_leprechaunamulet_1" ) and 
       cmn.IsEventDone( "get_alchemistryamulet" ) and 
       cmn.IsEventDone( "get_storekey" ) then

       ObjDelete( "gzz_square_victormemorial" );

    end;     

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_leprechaunamulet_1", get_leprechaunamulet_1_inv );
  cmn.AddSubscriber( "get_leprechaunamulet_1", get_leprechaunamulet_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_alchemistryamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_alchemistryamulet" ] =
  {
    type = "get",
    get_obj = "spr_victormemorial_alchemistryamulet",
    room = private.room_objname,
    zz = "zz_victormemorial",
    zz_gate = "gzz_square_victormemorial"
  };
  --------------------------------------------------------------------------------------------
  local get_alchemistryamulet_inv = function ()

    int.InventoryItemAdd( "inv_alchemistryamulet", "spr_victormemorial_alchemistryamulet" );

  end;
  local get_alchemistryamulet_closezz = function ()

    ObjDelete( "gfx_victormemorial_alchemistryamulet" );
    
    if cmn.IsEventDone( "get_leprechaunamulet_1" ) and 
       cmn.IsEventDone( "get_alchemistryamulet" ) and 
       cmn.IsEventDone( "get_storekey" ) then

       ObjDelete( "gzz_square_victormemorial" );

    end;     

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_alchemistryamulet", get_alchemistryamulet_inv );
  cmn.AddSubscriber( "get_alchemistryamulet", get_alchemistryamulet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_storekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_storekey" ] =
  {
    type = "get",
    get_obj = "spr_victormemorial_storekey",
    room = private.room_objname,
    zz = "zz_victormemorial",
    zz_gate = "gzz_square_victormemorial"
  };
  --------------------------------------------------------------------------------------------
  local get_storekey_inv = function ()

    int.InventoryItemAdd( "inv_storekey", "spr_victormemorial_storekey" );

  end;
  local get_storekey_closezz = function ()

    ObjDelete( "gfx_victormemorial_storekey" );
    
    if cmn.IsEventDone( "get_leprechaunamulet_1" ) and 
       cmn.IsEventDone( "get_alchemistryamulet" ) and 
       cmn.IsEventDone( "get_storekey" ) then

       ObjDelete( "gzz_square_victormemorial" );

    end;     

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_storekey", get_storekey_inv );
  cmn.AddSubscriber( "get_storekey", get_storekey_closezz, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS USE
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function use_stiletto_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stiletto_1" ] =
  {
    type = "use",
    use_obj = "inv_stiletto",
    use_place = "obj_storedoor_use_stiletto_1",
    room = private.room_objname,
    zz = "zz_storedoor",
    zz_gate = "gzz_square_storedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_stiletto_1_inv = function ()

    if cmn.IsEventDone( "use_stiletto_2" ) and 
       cmn.IsEventDone( "use_stiletto_3" ) and 
       cmn.IsEventDone( "use_stiletto_4" ) then

      int.InventoryItemRemove( "inv_stiletto" );

    end;

  end;
  local use_stiletto_1_beg = function ()

    ObjDelete( "obj_storedoor_use_stiletto_1" );
    ObjDelete( "anm_storedoor_stone_click" );

  end;
  local use_stiletto_1_end = function ()

    ObjDelete( "anm_storedoor_stiletto" );
    ObjDelete( "spr_square_storedoor_stone");
    ObjSet( "spr_storedoor_sigmaamulet", { input = true } );
    ObjSet( "gfx_storedoor_sigmaamulet", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stiletto_1",     use_stiletto_1_inv );
  cmn.AddSubscriber( "use_stiletto_1",     use_stiletto_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_1",     use_stiletto_1_end, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_1_inv", use_stiletto_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_1_beg", use_stiletto_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_stiletto_1_end", use_stiletto_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_storekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_storekey" ] =
  {
    type = "use",
    use_obj = "inv_storekey",
    use_place = "obj_storedoor_use_storekey",
    room = private.room_objname,
    zz = "zz_storedoor",
    zz_gate = "gzz_square_storedoor"
  };
  --------------------------------------------------------------------------------------------
  local use_storekey_inv = function ()

    int.InventoryItemRemove( "inv_storekey" );

  end;
  local use_storekey_beg = function ()

    ObjDelete( "obj_storedoor_use_storekey" );
    ObjDelete( "anm_storedoor_door_click" );

  end;
  local use_storekey_end = function ()

    ObjDelete( "gzz_square_storedoor" );
    ObjSet( "spr_square_storedoor_open", { alp = 1 });
    ObjSet( "grm_square_alchemiststore", { alp = 1, input = true, active = true } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_square_alchemiststore_focus");
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_storekey",     use_storekey_inv );
  cmn.AddSubscriber( "use_storekey",     use_storekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_storekey",     use_storekey_end, private.room_objname );
  cmn.AddSubscriber( "use_storekey_inv", use_storekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_storekey_beg", use_storekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_storekey_end", use_storekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knightamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knightamulet" ] =
  {
    type = "use",
    use_obj = "inv_knightamulet",
    use_place = "obj_vendingbooth_use_knightamulet",
    room = private.room_objname,
    zz = "zz_vendingbooth",
    zz_gate = "gzz_square_vendingbooth"
  };
  --------------------------------------------------------------------------------------------
  local use_knightamulet_inv = function ()

    int.InventoryItemRemove( "inv_knightamulet" );

  end;
  local use_knightamulet_beg = function ()

    ObjDelete( "obj_vendingbooth_use_knightamulet" );

  end;
  local use_knightamulet_end = function ()

    ObjSet( "obj_vendingbooth_chest_open", { input = true } );
    ObjSet( "spr_vendingbooth_chest_open_cap", { alp = 1 } );
    ObjDelete( "obj_vendingbooth_chest_close" );
    ObjSet( "obj_square_vendingbooth_miniho", { alp = 1 });
    ObjDelete( "spr_square_vendingbooth_closebox_1");
    ObjSet( "spr_square_vendingbooth_openbox", { alp = 1 });

    ObjSet( "anm_vendingbooth_use_knightamulet", { alp = 1, frame = 500 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knightamulet",     use_knightamulet_inv );
  cmn.AddSubscriber( "use_knightamulet",     use_knightamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_knightamulet",     use_knightamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_knightamulet_inv", use_knightamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_knightamulet_beg", use_knightamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_knightamulet_end", use_knightamulet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_awl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_awl" ] =
  {
    type = "use",
    use_obj = "inv_awl",
    use_place = "obj_vendingbooth_use_awl",
    room = private.room_objname,
    zz = "zz_vendingbooth",
    zz_gate = "gzz_square_vendingbooth"
  };
  --------------------------------------------------------------------------------------------
  local use_awl_inv = function ()

    int.InventoryItemRemove( "inv_awl" );

  end;
  local use_awl_beg = function ()

    ObjDelete( "obj_vendingbooth_use_awl" );

  end;
  local use_awl_end = function ()

    ObjSet( "obj_vendingbooth_small_chest_open", { input = true } );
    ObjSet( "anm_vendingbooth_use_awl", { alp = 1, frame = 500 } );
    ObjSet( "gfx_vendingbooth_sphynxamulet_2", { active = true } );
    ObjDelete( "obj_vendingbooth_small_chest_close" );
    ObjDelete( "spr_square_vendingbooth_closebox_2");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_awl",     use_awl_inv );
  cmn.AddSubscriber( "use_awl",     use_awl_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl",     use_awl_end, private.room_objname );
  cmn.AddSubscriber( "use_awl_inv", use_awl_inv, private.room_objname );
  cmn.AddSubscriber( "use_awl_beg", use_awl_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl_end", use_awl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_firepoker_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_firepoker_1" ] =
  {
    type = "use",
    use_obj = "inv_firepoker",
    use_place = "obj_vendingbooth_use_firepoker",
    room = private.room_objname,
    zz = "zz_vendingbooth",
    zz_gate = "gzz_square_vendingbooth"
  };
  --------------------------------------------------------------------------------------------
  local use_firepoker_1_inv = function ()

    if ( cmn.IsEventDone( "use_firepoker_2" ) ) and
       ( cmn.IsEventDone( "use_firepoker_3" ) ) then

      int.InventoryItemRemove( "inv_firepoker" );

    end;

  end;
  local use_firepoker_1_beg = function ()

    ObjDelete( "obj_vendingbooth_use_firepoker" );

  end;
  local use_firepoker_1_end = function ()

    ObjSet( "obj_vendingbooth_box_open", { input = true } );
    ObjSet( "gfx_vendingbooth_flaskofwater", { active = true } );
    ObjSet( "gfx_vendingbooth_pincers", { active = true } );
    ObjDelete( "obj_vendingbooth_box_close" );
    ObjDelete( "anm_vendingbooth_use_firepoker" );
    ObjDelete( "spr_square_vendingbooth_closechest");
    ObjSet( "obj_square_vendingbooth_chest", { alp = 1 });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_firepoker_1",     use_firepoker_1_inv );
  cmn.AddSubscriber( "use_firepoker_1",     use_firepoker_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_1",     use_firepoker_1_end, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_1_inv", use_firepoker_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_1_beg", use_firepoker_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_firepoker_1_end", use_firepoker_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_flaskofwater () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_flaskofwater" ] =
  {
    type = "use",
    use_obj = "inv_flaskofwater",
    use_place = "obj_victormemorial_use_flaskofwater",
    room = private.room_objname,
    zz = "zz_victormemorial",
    zz_gate = "gzz_square_victormemorial"
  };
  --------------------------------------------------------------------------------------------
  local use_flaskofwater_inv = function ()

    int.InventoryItemRemove( "inv_flaskofwater" );

  end;
  local use_flaskofwater_beg = function ()

    ObjDelete( "obj_victormemorial_use_flaskofwater" );

  end;
  local use_flaskofwater_end = function ()

    ObjDelete( "anm_victormemorial_flaskofwater" );
    ObjDelete( "spr_square_victormemorial_mud");
    ObjSet( "obj_victormemorial_use_pincers", { input = true } );
    ObjSet( "anm_victormemorial_knightamulet_click",
    {
      alp = 1,
      res = "assets/levels/levelext/rm_square/zz_victormemorial/anims/anm_knightamulet_click_2",
      animfunc = "DoAnim",
    } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_flaskofwater",     use_flaskofwater_inv );
  cmn.AddSubscriber( "use_flaskofwater",     use_flaskofwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_flaskofwater",     use_flaskofwater_end, private.room_objname );
  cmn.AddSubscriber( "use_flaskofwater_inv", use_flaskofwater_inv, private.room_objname );
  cmn.AddSubscriber( "use_flaskofwater_beg", use_flaskofwater_beg, private.room_objname );
  cmn.AddSubscriber( "use_flaskofwater_end", use_flaskofwater_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pincers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pincers" ] =
  {
    type = "use",
    use_obj = "inv_pincers",
    use_place = "obj_victormemorial_use_pincers",
    room = private.room_objname,
    zz = "zz_victormemorial",
    zz_gate = "gzz_square_victormemorial"
  };
  --------------------------------------------------------------------------------------------
  local use_pincers_inv = function ()

    int.InventoryItemRemove( "inv_pincers" );

  end;
  local use_pincers_beg = function ()

    ObjDelete( "obj_victormemorial_use_pincers" );
    ObjDelete( "anm_victormemorial_knightamulet_click" );

  end;
  local use_pincers_end = function ()

    ObjSet( "spr_victormemorial_knightamulet", { input = true } );
    ObjSet( "gfx_victormemorial_knightamulet", { active = true } );
    ObjSet( "anm_victormemorial_pincers", { alp = 1, frame = 125, animfunc = "DoAnim" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pincers",     use_pincers_inv );
  cmn.AddSubscriber( "use_pincers",     use_pincers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pincers",     use_pincers_end, private.room_objname );
  cmn.AddSubscriber( "use_pincers_inv", use_pincers_inv, private.room_objname );
  cmn.AddSubscriber( "use_pincers_beg", use_pincers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pincers_end", use_pincers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_sigmaamulet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_sigmaamulet" ] =
  {
    type = "use",
    use_obj = "inv_sigmaamulet",
    use_place = "obj_victormemorial_use_sigmaamulet",
    room = private.room_objname,
    zz = "zz_victormemorial",
    zz_gate = "gzz_square_victormemorial"
  };
  --------------------------------------------------------------------------------------------
  local use_sigmaamulet_inv = function ()

    int.InventoryItemRemove( "inv_sigmaamulet" );

  end;
  local use_sigmaamulet_beg = function ()

    ObjDelete( "obj_victormemorial_use_sigmaamulet" );

  end;
  local use_sigmaamulet_end = function ()

    ObjSet( "spr_victormemorial_storekey",    { input = true } );
    ObjSet( "gfx_victormemorial_storekey",    { active = true } );
    ObjSet( "spr_square_victormemorial_open", { alp = 1 });
    ObjSet( "spr_square_victormemorial_key",  { alp = 1 });
    ObjSet( "anm_victormemorial_sigmaamulet", { alp = 1, frame = 61, animfunc = "DoAnim" } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_sigmaamulet",     use_sigmaamulet_inv );
  cmn.AddSubscriber( "use_sigmaamulet",     use_sigmaamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_sigmaamulet",     use_sigmaamulet_end, private.room_objname );
  cmn.AddSubscriber( "use_sigmaamulet_inv", use_sigmaamulet_inv, private.room_objname );
  cmn.AddSubscriber( "use_sigmaamulet_beg", use_sigmaamulet_beg, private.room_objname );
  cmn.AddSubscriber( "use_sigmaamulet_end", use_sigmaamulet_end, private.room_objname );
--*********************************************************************************************************************
-- PROGRESS CLICK
--*********************************************************************************************************************
  --------------------------------------------------------------------------------------------
  -- function dlg_square_emily4_0 () end;
  --------------------------------------------------------------------------------------------
  local dlg_square_emily4_0_beg = function ()

  end;
  -----------------------------------------------
  local dlg_square_emily4_0_end = function ()

    ObjDelete( "dlg_square_emily4_0" );
    ObjSet( "anm_square_girl_static", { alp = 1 });

  end;

  cmn.AddSubscriber( "dlg_square_emily4_0",     dlg_square_emily4_0_beg );
  cmn.AddSubscriber( "dlg_square_emily4_0",     dlg_square_emily4_0_end );
  cmn.AddSubscriber( "dlg_square_emily4_0_beg", dlg_square_emily4_0_beg );
  cmn.AddSubscriber( "dlg_square_emily4_0_end", dlg_square_emily4_0_end );
  --------------------------------------------------------------------------------------------
  -- function win_hosafe () end;
  --------------------------------------------------------------------------------------------
  local win_hosafe = function ()

    ObjDelete( "obj_square_emily_bbt" );
    ObjDelete( "obj_square_girl");
    ObjSet( "spr_square_note", { alp = 1, input = true });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_hosafe", win_hosafe, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.get_screensaver_4_1()

  int.AddScreensaver( "spr_vendingbooth_screensaver_4_1" );

end;   
------------------------------------------------------------------------------------------
function private.get_screensaver_4_5()

  int.AddScreensaver( "spr_victormemorial_screensaver_4_5" );

end; 
-----------------------------------------------------------------------
function private.get_sigmaamulet ()

  cmn.SetEventDone( "get_sigmaamulet" );
  cmn.CallEventHandler( "get_sigmaamulet" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_firepoker ()

  cmn.SetEventDone( "get_firepoker" );
  cmn.CallEventHandler( "get_firepoker" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_flaskofwater ()

  cmn.SetEventDone( "get_flaskofwater" );
  cmn.CallEventHandler( "get_flaskofwater" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_pincers" ) and 
     cmn.IsEventDone( "get_stiletto" ) and 
     cmn.IsEventDone( "get_sphynxamulet_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_pincers ()

  cmn.SetEventDone( "get_pincers" );
  cmn.CallEventHandler( "get_pincers" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_flaskofwater" ) and 
     cmn.IsEventDone( "get_stiletto" ) and 
     cmn.IsEventDone( "get_sphynxamulet_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function public.get_stiletto ()

  if cmn.IsEventDone( "get_flaskofwater" ) and 
     cmn.IsEventDone( "get_pincers" ) and 
     cmn.IsEventDone( "get_sphynxamulet_2" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_sphynxamulet_2 ()

  cmn.SetEventDone( "get_sphynxamulet_2" );
  cmn.CallEventHandler( "get_sphynxamulet_2" );
  cmn.GetObjectSfx();

  if cmn.IsEventDone( "get_flaskofwater" ) and 
     cmn.IsEventDone( "get_pincers" ) and 
     cmn.IsEventDone( "get_stiletto" ) then

    cmn.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------
function private.get_knightamulet ()

  ObjSet( "spr_victormemorial_knightamulet", { alp = 1 } );
  cmn.SetEventDone( "get_knightamulet" );
  cmn.CallEventHandler( "get_knightamulet" );
  cmn.GetObjectSfx();

end;
-----------------------------------------------------------------------
function private.get_leprechaunamulet_1 ()

  cmn.SetEventDone( "get_leprechaunamulet_1" );
  cmn.CallEventHandler( "get_leprechaunamulet_1" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_leprechaunamulet_1" ) and 
     cmn.IsEventDone( "get_alchemistryamulet" ) and 
     cmn.IsEventDone( "get_storekey" ) then

    cmn.CloseSubRoom();

  end;  

end;
-----------------------------------------------------------------------
function private.get_alchemistryamulet ()

  cmn.SetEventDone( "get_alchemistryamulet" );
  cmn.CallEventHandler( "get_alchemistryamulet" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_leprechaunamulet_1" ) and 
     cmn.IsEventDone( "get_alchemistryamulet" ) and 
     cmn.IsEventDone( "get_storekey" ) then

    cmn.CloseSubRoom();

  end;   

end;
-----------------------------------------------------------------------
function private.get_storekey ()

  cmn.SetEventDone( "get_storekey" );
  cmn.CallEventHandler( "get_storekey" );
  cmn.GetObjectSfx();
  
  if cmn.IsEventDone( "get_leprechaunamulet_1" ) and 
     cmn.IsEventDone( "get_alchemistryamulet" ) and 
     cmn.IsEventDone( "get_storekey" ) then

    cmn.CloseSubRoom();

  end;   

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_stiletto_1 ()

  local item = "inv_stiletto";

  if ( cmn.ApplyObj( item, "gzz_square_storedoor", false ) ) and
     ( not cmn.IsEventDone( "use_stiletto_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storedoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_storedoor_use_stiletto_1", true ) ) and
         ( not cmn.IsEventDone( "use_stiletto_1" ) ) then

    cmn.CallEventHandler( "use_stiletto_1_inv" );
    cmn.CallEventHandler( "use_stiletto_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_stiletto_1" );
      cmn.CallEventHandler( "use_stiletto_1_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_storedoor_stiletto", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_storedoor_take_knife_dirt" );
    AnimPlay( "anm_storedoor_stiletto", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_storekey ()

  local item = "inv_storekey";

  if ( cmn.ApplyObj( item, "gzz_square_storedoor", false ) ) and
     ( not cmn.IsEventDone( "use_storekey" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storedoor" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_storedoor_use_storekey", true ) ) and
         ( not cmn.IsEventDone( "use_storekey" ) ) then

    cmn.CallEventHandler( "use_storekey_inv" );
    cmn.CallEventHandler( "use_storekey_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_storekey" );
      cmn.CallEventHandler( "use_storekey_end" );
      cmn.CloseSubRoom();

    end;

    int.Lock( true );

    ObjSet( "anm_storedoor_door_open", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_storedoor_insert_key" );
    AnimPlay( "anm_storedoor_door_open", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_knightamulet ()

  local item = "inv_knightamulet";

  if ( cmn.ApplyObj( item, "gzz_square_vendingbooth", false ) ) and
     ( not cmn.IsEventDone( "use_knightamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vendingbooth", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_vendingbooth_use_knightamulet", true ) ) and
         ( not cmn.IsEventDone( "use_knightamulet" ) ) then

    cmn.CallEventHandler( "use_knightamulet_inv" );
    cmn.CallEventHandler( "use_knightamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_knightamulet" );
      cmn.CallEventHandler( "use_knightamulet_end" );
      int_button_mini_ho.Show( "get_stiletto", "vendingbooth", 4, "spr_vendingbooth_stiletto_panel", private.mini_ho_array );

    end;

    int.Lock( true );

    ObjSet( "anm_vendingbooth_use_knightamulet", { alp = 1 } );
    ObjSet( "anm_vendingbooth_chest_clk", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_vendingbooth_insert_helm_open" );
    AnimPlay( "anm_vendingbooth_use_knightamulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_awl ()

  local item = "inv_awl";

  if ( cmn.ApplyObj( item, "gzz_square_vendingbooth", false ) ) and
     ( not cmn.IsEventDone( "use_awl" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vendingbooth", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_vendingbooth_use_awl", true ) ) and
         ( not cmn.IsEventDone( "use_awl" ) ) then

    cmn.CallEventHandler( "use_awl_inv" );
    cmn.CallEventHandler( "use_awl_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_awl" );
      cmn.CallEventHandler( "use_awl_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_vendingbooth_use_awl", { alp = 1 } );
    ObjSet( "obj_vendingbooth_small_chest_close", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_vendingbooth_break_down_box_lockpick" );
    AnimPlay( "anm_vendingbooth_use_awl", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_firepoker_1 ()

  local item = "inv_firepoker";

  if ( cmn.ApplyObj( item, "gzz_square_vendingbooth", false ) ) and
     ( not cmn.IsEventDone( "use_firepoker_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_vendingbooth", nil, { 512, 384 }, true );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_vendingbooth_use_firepoker", true ) ) and
         ( not cmn.IsEventDone( "use_firepoker_1" ) ) then

    cmn.CallEventHandler( "use_firepoker_1_inv" );
    cmn.CallEventHandler( "use_firepoker_1_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_firepoker_1" );
      cmn.CallEventHandler( "use_firepoker_1_end" );

    end;

    int.Lock( true );
    ObjSet( "anm_vendingbooth_use_firepoker", { alp = 1 } );
    ObjSet( "obj_vendingbooth_box_close", { alp = 0 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_vendingbooth_unscrew_nails" );
    AnimPlay( "anm_vendingbooth_use_firepoker", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_flaskofwater ()

  local item = "inv_flaskofwater";

  if ( cmn.ApplyObj( item, "gzz_square_victormemorial", false ) ) and
     ( not cmn.IsEventDone( "use_flaskofwater" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_victormemorial" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_victormemorial_use_flaskofwater", true ) ) and
         ( not cmn.IsEventDone( "use_flaskofwater" ) ) then

    cmn.CallEventHandler( "use_flaskofwater_inv" );
    cmn.CallEventHandler( "use_flaskofwater_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_flaskofwater" );
      cmn.CallEventHandler( "use_flaskofwater_end" );

    end;

    int.Lock( true );

    ObjSet( "anm_victormemorial_knightamulet_click", { alp = 0 } );
    ObjSet( "anm_victormemorial_flaskofwater", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_victormemorial_fill_liquid" );
    AnimPlay( "anm_victormemorial_flaskofwater", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_pincers ()

  local item = "inv_pincers";

  if ( cmn.ApplyObj( item, "gzz_square_victormemorial", false ) ) and
     ( cmn.IsEventDone( "use_flaskofwater" ) )and
     ( not cmn.IsEventDone( "use_pincers" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_victormemorial" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_victormemorial_use_pincers", true ) ) and
         ( cmn.IsEventDone( "use_flaskofwater" ) )and
         ( not cmn.IsEventDone( "use_pincers" ) ) then

    cmn.CallEventHandler( "use_pincers_inv" );
    cmn.CallEventHandler( "use_pincers_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_pincers" );
      cmn.CallEventHandler( "use_pincers_end" );
      private.get_knightamulet();

    end;

    int.Lock( true );

    ObjSet( "anm_victormemorial_pincers", { alp = 1 } );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_victormemorial_take_stuff_forceps" );
    AnimPlay( "anm_victormemorial_pincers", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--------------------------------------------------------------------------------------------
function public.use_sigmaamulet ()

  local item = "inv_sigmaamulet";

  if ( cmn.ApplyObj( item, "gzz_square_victormemorial", false ) ) and
     ( not cmn.IsEventDone( "use_sigmaamulet" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_victormemorial" );

    return true;

  elseif ( cmn.ApplyObj( item, "obj_victormemorial_use_sigmaamulet", true ) ) and
         ( not cmn.IsEventDone( "use_sigmaamulet" ) ) then

    cmn.CallEventHandler( "use_sigmaamulet_inv" );
    cmn.CallEventHandler( "use_sigmaamulet_beg" );

    local func_end = function ()

      int.Lock( false );
      cmn.SetEventDone( "use_sigmaamulet" );
      cmn.CallEventHandler( "use_sigmaamulet_end" );

    end;

    int.Lock( true );
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_zz_victormemorial_insert_cell_viktor" );
    AnimPlay( "anm_victormemorial_sigmaamulet", "DoAnim", func_end );

    return true;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.dlg_square_emily4_0 ()

  local func_end = function ()

    cmn.SetEventDone( "dlg_square_emily4_0" );
    cmn.CallEventHandler( "dlg_square_emily4_0_end");
    cmn.ShowBbt( "bbt_square_dlg_emily4_0" );

    interface.KeyTaskAdd( "task_4_1", true );

  end;

  local func_anim_end = function ()

    int.Lock( false );

    AnimPlay( "anm_square_emily4_0_emily_static", "DoAnim", "" );

    common_impl.dialog_character_loc = "";
    common_impl.DialogCharacterStart( "emily4_0", "square", 3, nil, nil, true, func_end );

  end;

  int.Lock( true );

  cmn.CallEventHandler( "dlg_square_emily4_0_beg" );
  ObjAttach( "dlg_square_emily4_0", GetCurrentRoom() );  

  ObjAnimate( "anm_square_emily4_0_emily_static", "alp", 0, 0, func_anim_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

end;
--*********************************************************************************************************************
function private.IntroLvl4( func_end )

  local func_end = function ( skip )

    ObjSet( "rm_square", { color_r = 1, color_g = 1, color_b = 1 } );

    int.Lock( false );
    
    if ( skip ) then
      --cmn.StopAudio( "sfx", "audio/level1/sfx/aud_prison2_intro" );
      cmn.StopAudio( "voc", "audio/level4/voc/aud_lvl4_intro_voc" );
      cmn.StopAudio( "mus", "audio/level4/mus/aud_intro_4_lvl_mus" );
    end;

    cmn.PlayAudio( "env", "audio/level4/env/aud_rm_square_env", 1 );

    common_impl.InterfaceSetVisible( true );

    func_end();

  end;

  int.Lock( true );

  common_impl.PlayDialogVideo( "vid_square_intro", func_end );  

  --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_nearcastle_intro" );
  cmn.PlayAudio( "voc", "audio/level4/voc/aud_lvl4_intro_voc" );
  cmn.PlayAudio( "mus", "audio/level4/mus/aud_intro_4_lvl_mus", nil, nil, 41 );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventDone( "opn_square" ) ) then

    common_impl.InterfaceSetVisible( false );
    ObjSet( "rm_square", { color_r = 0, color_g = 0, color_b = 0 } );    

  end;
  
end;  
--*********************************************************************************************************************
function private.opn_square ()

  if not ( cmn.IsEventDone( "opn_square" ) ) then

    local func_end = function ()
      cmn.SetEventDone( "opn_square" );
      private.dlg_square_emily4_0();
    end;

    private.IntroLvl4( func_end );

  else

    if ( not cmn.IsEventDone( "dlg_square_emily4_0" ) ) then

      private.dlg_square_emily4_0();

    end;

    cmn.StopAllEnv( "audio/level4/env/aud_rm_square_env", true );
    cmn.PlayAudio( "env", "audio/level4/env/aud_rm_square_env", 1 );

    if cmn.IsEventDone( "win_hosafe" ) and 
       not ng_global.progress["ext"]["opn_square"].bbt_hosafe then

      cmn.ShowBbt( "bbt_square_after_hosafe" );
      ng_global.progress["ext"]["opn_square"].bbt_hosafe = 1;

    end;

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_square();

end;
--*********************************************************************************************************************
function public.Task ()

  int.AddedTaskMap( private.room_objname, "get_sigmaamulet",                                                       { "use_stiletto_1" } );
  int.AddedTaskMap( private.room_objname, "get_firepoker" );
  int.AddedTaskMap( private.room_objname, "get_stiletto",                                                          { "use_knightamulet" } );
  int.AddedTaskMap( private.room_objname, "get_flaskofwater",                                                      { "use_firepoker_1" } );
  int.AddedTaskMap( private.room_objname, "get_pincers",                                                           { "use_firepoker_1" } );
  int.AddedTaskMap( private.room_objname, "get_sphynxamulet_2",                                                    { "use_awl" } );
  int.AddedTaskMap( private.room_objname, "get_knightamulet",                                                      { "use_pincers" } );
  int.AddedTaskMap( private.room_objname, "get_leprechaunamulet_1",                                                { "dlg_square_emily4_0" } );
  int.AddedTaskMap( private.room_objname, "get_alchemistryamulet",                                                 { "dlg_square_emily4_0" } );
  int.AddedTaskMap( private.room_objname, "get_storekey",                                                          { "use_sigmaamulet" } );

  int.AddedTaskMap( private.room_objname, "use_stiletto_1",                                                        { "get_stiletto" } );
  int.AddedTaskMap( private.room_objname, "use_storekey",                                                          { "get_storekey" } );
  int.AddedTaskMap( private.room_objname, "use_knightamulet",                                                      { "get_knightamulet" } );
  int.AddedTaskMap( private.room_objname, "use_awl",                                                               { "get_awl" } );
  int.AddedTaskMap( private.room_objname, "use_firepoker_1",                                                       { "get_firepoker" } );
  int.AddedTaskMap( private.room_objname, "use_flaskofwater",                                                      { "get_flaskofwater" } );
  int.AddedTaskMap( private.room_objname, "use_pincers",                                                           { "get_pincers", "use_flaskofwater" } );
  int.AddedTaskMap( private.room_objname, "use_sigmaamulet",                                                       { "get_sigmaamulet" } );

  int.AddedTaskMap( private.room_objname, "dlg_square_emily4_0" );

  int.AddedTaskMap( private.room_objname, "opn_alchemiststore",                                                    { "use_storekey" } );

end;
--*********************************************************************************************************************
function private.InitSubroom ()

  subroom.Define( "zz_vendingbooth" );
  -------------------------------------------------
  function zz_vendingbooth.PreOpen ()

    if cmn.IsEventDone( "use_knightamulet" ) and not
      cmn.IsEventDone( "get_stiletto" ) then
      int_button_mini_ho.Show( "get_stiletto", "vendingbooth", 4, "spr_vendingbooth_stiletto_panel", private.mini_ho_array ); 
    end;       
       
  end;  
  -------------------------------------------------
  function zz_vendingbooth.PreClose()

    if cmn.IsEventDone( "use_knightamulet" ) and not
       cmn.IsEventDone( "get_stiletto" ) then
      int_button_mini_ho.Hide(); 
    end;        
       
  end; 
  -------------------------------------------------
  subroom.Define( "zz_storedoor" );
  -----------------------------------------------
  function zz_storedoor.Close ()

    cmn.NoteScaleEnd( { "spr_storedoor_note" }, true );

  end;
  -------------------------------------------------

end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
function private.InitMiniHO ()
  
  private.mini_ho_array = { 
                            "spr_vendingbooth_ho_1", 
                            "spr_vendingbooth_ho_2", 
                            "spr_vendingbooth_ho_3", 
                            "spr_vendingbooth_ho_4" 
                          };

  for i = 1, #private.mini_ho_array do

    ObjSet( private.mini_ho_array[ i ], { 
                    event_mdown = function() 
                                    int_button_mini_ho.MiniHoTaskFind( "get_stiletto", "vendingbooth", private.mini_ho_array[ i ], 4, "", nil, true );
                                  end,
                    event_menter = function () cmn.SetCursor( CURSOR_GET );  end,
                    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT );  end  } );


  end;
      
end;
--*********************************************************************************************************************
function private.StoredoorDoorsClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_storedoor_use_storekey" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_storedoor_door" );
  AnimPlay( "anm_storedoor_door_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.StoredoorStoneClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_storedoor_use_stiletto_1" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_storedoor_dirt" );
  AnimPlay( "anm_storedoor_stone_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.VictormemorialCapClick ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_victormemorial_use_sigmaamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_victormemorial_victor_cell" );
  ObjAnimate( "obj_victormemorial_niche_close", "pos_y", 0, 0, func_end,
  {
    0.0, 3, 0,
    0.2, 3, 2,
    0.4, 3, 0,
    0.6, 3, 2,
    0.7, 3, 0,
  } );

end;
--*********************************************************************************************************************
function private.VictormemorialKnightamuletClick ( item )

  local func_end = function ()

    cmn.ShowBbt( "bbt_victormemorial_use_"..item );
    int.Lock( false );

  end;

  int.Lock( true );
  if cmn.IsEventDone( "use_flaskofwater" ) then
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_victormemorial_stuff_liquid" );
  else
    cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_victormemorial_stuff_squeak" );
  end;

  AnimPlay( "anm_victormemorial_knightamulet_click", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.VendingboothSmallChestClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_vendingbooth_use_awl" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_vendingbooth_stuff_down" );
  AnimPlay( "anm_vendingbooth_small_chest_clk", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.VendingboothBoxClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_vendingbooth_use_firepoker" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_vendingbooth_stuff_left" );
  AnimPlay( "anm_vendingbooth_box_clk", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.VendingboothChestClk ()

  local func_end = function ()

    cmn.ShowBbt( "bbt_vendingbooth_use_knightamulet" );
    int.Lock( false );

  end;

  int.Lock( true );
  cmn.PlayAudio( "sfx", "audio/level4/sfx/aud_xx_zz_vendingbooth_stuff_right" );
  AnimPlay( "anm_vendingbooth_chest_clk", "DoAnim", func_end ); 

end;
--*********************************************************************************************************************
function private.SquareBigNoteClk ()

  if not ng_global.progress["ext"]["opn_square"].note then
    cmn.ShowBbt( "bbt_square_note" );
    ng_global.progress["ext"]["opn_square"].note = 1;
  end;

  cmn.NoteScale( { "spr_square_note" } );

end;
--*********************************************************************************************************************