-- name=ho_hoalchemybox3_rpl
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  
  room.Define( "ho_hoalchemybox3_rpl" );
  game.relations[ "ho_hoalchemybox3_rpl" ].exitroom = "rm_replayroom";
  private.room_objname = "ho_hoalchemybox3_rpl";

  private.task_name = "win_hoalchemybox3_rpl";  
  private.win_hoalchemybox3_rpl = {};
  
  private.COLLECT_ANIM_TIME = 0.8;
  private.COLLECT_VISIBLE_TIME = 4.0;
  private.REPLACE_VISIBLE_TIME = 2.0;    
  
  --------------------------------------------------------------------------------------------
  -- function opn_hoalchemybox3_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_hoalchemybox3_rpl = function ()

  end;

  cmn.AddSubscriber( "opn_hoalchemybox3_rpl", opn_hoalchemybox3_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hoalchemybox3_rpl_func = function ()

  end;
  cmn.AddSubscriber( "win_hoalchemybox3_rpl", win_hoalchemybox3_rpl_func );
  --------------------------------------------------------------------------------------------------
  local start_hoalchemybox3_rpl_func = function ()

    if ( cmn.IsEventStart( private.task_name ) ) then
    
      local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

      for i = 1, #ho_found, 1 do
    
        ObjDelete( ho_found[ i ][ "object" ] );
    
      end;
      
      if (ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].set == 10 ) then
                  
          ObjSet( "obj_hoalchemybox3_rpl_win", { alp = 1, input = true } );
          ObjSet( "spr_hoalchemybox3_rpl_win_bottle", { input = true } );        
        
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hoalchemybox3_rpl", start_hoalchemybox3_rpl_func );
  --------------------------------------------------------------------------------------------------
  private.win_hoalchemybox3_rpl.task = { "item_1", "item_2", "item_3", "item_4", "item_5", "item_6", "item_7", "item_8", "item_9", "item_10" };

  for i = 1, #private.win_hoalchemybox3_rpl.task do

    ObjSet( "spr_hoalchemybox3_rpl_"..private.win_hoalchemybox3_rpl.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hoalchemybox3_rpl.task[ i ] ); end, input = false } );

  end; 
    
  ObjSet( "spr_hoalchemybox3_rpl_win_bottle", { event_mdown = function () private.GetBottle(); end } );        

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.ResetHO ()

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].start = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].done = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].set = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].task_check = { 0,0,0,0,0,0,0,0,0,0 };  

end;
--*********************************************************************************************************************
function public.Open ()

  cmn.PlayAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, true );   
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hoalchemybox3_rpl" );

  end;

  if ( not cmn.IsEventDone( "opn_hoalchemybox3_rpl" ) ) then

      cmn.SetEventDone( "opn_hoalchemybox3_rpl" );
      cmn.CallEventHandler( "opn_hoalchemybox3_rpl" );
      
      ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].set = 0;

  end;        

  local ho_tasks = {};
  
  for i = 1, #private.win_hoalchemybox3_rpl.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hoalchemybox3_rpl.task[ i ], 1, 0, { { "spr_hoalchemybox3_rpl_"..private.win_hoalchemybox3_rpl.task[ i ]  } } );
    
  end; 

  interface.TaskPanelTaskAdd( ho_tasks, "bottle", 1, 0, { { "spr_hoalchemybox3_rpl_win_bottle"  } } );
  
  for i=1, #private.win_hoalchemybox3_rpl.task do  

    local rand = math.random( 1, 2 );
    
    if rand == 1 then
    
      private.MorphItemMorphing( private.win_hoalchemybox3_rpl.task[ i ] );
      
    else
      
      private.MorphItemActive( private.win_hoalchemybox3_rpl.task[ i ] );
      
    end;
    
  end;  
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();
  
  private.ClearTasks();

  cmn.StopAllMus();

  cmn.StopAllEnv( "audio/level3/env/aud_rm_lab3_env" );
  cmn.PlayAudio( "env", "audio/level3/env/aud_rm_lab3_env", 1, 1 );  

end;
--*********************************************************************************************************************
function public.Close ()

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );    
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hoalchemybox3_rpl_panel","ho_hoalchemybox3_rpl" );
  
end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();

  cmn.StopAudio( "mus", "audio/level1/mus/aud_ho_game1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )
  
  if (ObjGet("spr_hoalchemybox3_rpl_"..name).alp > 0.8) then
  
    cmn.HoTaskFind( "spr_hoalchemybox3_rpl_"..name, name );
    
    for i = 1,#private.win_hoalchemybox3_rpl.task do

        if ( private.win_hoalchemybox3_rpl.task[i] == name ) then 

            local object_name = "obj_"..i; 
            --DbgTrace( object_name );
            local collect_name  = "pfx_hoalchemybox3_rpl_collect_"..object_name.."_effect";
            ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].task_check[ i ] = 1;
            ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].set = ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].set + 1;
            ObjCreate( collect_name, "partsys" );

            if  ( cmn.IsEventDone( "win_hoalchemybox3_rpl" ) ) then

                --int.Lock( false );

            end;

            ObjSet( collect_name,{
              res    = "assets/interface/resources/effects_ho_hint",
              pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
              active = 1, visible = 1, input = 0
            } );

            ObjAttach( collect_name, "obj_hoalchemybox3_rpl_panel" );
            ObjSet( collect_name, { blendmode = 2, scale_x = 0.8, scale_y = 0.8 } );

            local func_end = function () private.AnimInv( i ); end;
              
            int.Lock( true );            
              
            ObjAnimate( object_name, 8,0,0, func_end,{ 
                0.0, 0, 1.0,
                0.5, 0, 0.0
            } );
              
        end;

    end;  
    int.Lock( true );            
        
    if ( ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].set == 10 ) then

      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_ho_hoalchemybox3_win" );
      ObjSet( "obj_hoalchemybox3_rpl_win", { alp = 1, input = true } );
      ObjSet( "spr_hoalchemybox3_rpl_win_bottle", { input = true } );
      --cmn.CallEventHandler( "win_hoalchemybox3_rpl" );

    end;    
  
  end;

end;
--*********************************************************************************************************************
function private.ClearTasks ()

  local ho_found = ng_global.progress[ ng_global.currentprogress ][ private.task_name ].found;

  for i = 1, #ho_found, 1 do
      ObjDelete( ho_found[ i ][ "object" ] );
      ObjDelete( ho_found[ i ][ "object" ].."_morph" );
  end;

end;
--*********************************************************************************************************************
function private.Panel ()

  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hoalchemybox3_rpl_panel" , "spr_int_taskpanel" );
  
  if ( not ng_global.progress[ ng_global.currentprogress ]["win_hoalchemybox3_rpl"].task_check ) then

    ng_global.progress[ng_global.currentprogress]["win_hoalchemybox3_rpl"].task_check = { 0,0,0,0,0,0,0,0,0,0 };

  end;

  local posx = -175;
  local tmp = 0;

  ObjSet( "obj_hoalchemybox3_rpl_panel", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 560, croprect_h = 400 } );

  for i = 1,#private.win_hoalchemybox3_rpl.task do 

     local obj = "obj_"..i;

     if ( ng_global.progress[ng_global.currentprogress]["win_hoalchemybox3_rpl"].task_check[i] == 0 ) and
        ( not ObjGet( obj ) ) then

        ObjCreate( obj, "obj" );
        ObjAttach( obj, "obj_hoalchemybox3_rpl_panel" );
        ObjSet( obj, { pos_x = posx, pos_y = 24, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
        local spr = "spr_hoalchemybox3_rpl_"..private.win_hoalchemybox3_rpl.task[i].."_inv";
        ObjCreate( spr, "spr" );
        ObjSet( spr, { res = "assets/levels/level3/ho_hoalchemybox3/layers/inv/"..private.win_hoalchemybox3_rpl.task[i].."_inv", scale_x = 0.8, scale_y = 0.8 } );
        ObjAttach( spr, obj );
        tmp = tmp + 1;
        if ( tmp < 6 ) then

           private.CheckPanel( i, tmp );
          
        end;

         posx = posx + 95;

--         if ( tmp == 0 ) then
--
--          ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].set = true;
--          ObjSet( "obj_hoalchemybox3_rpl_win", { alp = 1, input = true } );
--          ObjSet( "spr_hoalchemybox3_rpl_win_bottle", { input = true } );
--
--        end;

     else

     end;

  end;

end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      });

      ObjSet( "spr_hoalchemybox3_rpl_"..private.win_hoalchemybox3_rpl.task[i], { alp = 1, input = 1 } );

   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;
  local panel_sound = false;

      for i = tmp,#private.win_hoalchemybox3_rpl.task do

          local obj_tmp = "obj_"..i;

          if obj_tmp ~= nil and ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].task_check[ i ] ~= 1 then

              if not panel_sound then
                --cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_ho_fakel_click" );
                panel_sound = true;
              end;

              ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_"..i ).pos_x-95
              });

              if ObjGet( "obj_"..i ).pos_x-95 == 205 then

                  ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

   local tmp = 0;

   for i = 1,#private.win_hoalchemybox3_rpl.task do

       local item = "obj_"..i;

       if ( item and ng_global.progress[ ng_global.currentprogress ][ "win_hoalchemybox3_rpl" ].task_check[ i ] ~= 1 ) then

          tmp = tmp + 1;

          if ( tmp < 6 ) then

             ObjSet( "spr_hoalchemybox3_rpl_"..private.win_hoalchemybox3_rpl.task[ i ], { alp = 1, input = 1 } );

          end;

          num = num + 1;

       end;

   end;
   
   local func_end = function () int.Lock( false ) end;

   ObjAnimate( "ho_hoalchemybox3_rpl", "alp", 0, 0, func_end, 
   { 
    0,3,1, 
    0.6,3,1
   });

end;
--*********************************************************************************************************************
function private.MorphItemMorphing ( name )
 
  local collect_item = "spr_hoalchemybox3_rpl_"..name;
  local replace_item = "spr_hoalchemybox3_rpl_"..name.."_morph"; 
  local random_time = math.random( 0, 2 );

  --ObjSet( collect_item, { input = false } ); 

  ObjAnimate( collect_item, "alp", 0, 0, function() private.MorphItemActive( name ) end, { 
    0, 0, 1,
    random_time + private.COLLECT_ANIM_TIME, 0, 0,
    random_time + private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 0, 0,
    random_time + 2*private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 3, 1 } );

  ObjAnimate( replace_item, "alp", 0, 0, "", { 
    0, 0, 0,
    random_time + private.COLLECT_ANIM_TIME, 0, 1,
    random_time + private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 0, 1,
    random_time + 2*private.COLLECT_ANIM_TIME + private.REPLACE_VISIBLE_TIME, 3, 0 } );
 
end;
--*********************************************************************************************************************
function private.MorphItemActive ( name )
  
   local collect_item = "spr_hoalchemybox3_rpl_"..name;
   local replace_item = "spr_hoalchemybox3_rpl_"..name.."_morph"; 
  
   --ObjSet( collect_item, { input = true } ); 

   ObjAnimate( collect_item, "alp", 0, 0, function() private.MorphItemMorphing( name ) end, { 
    0, 3, 1, 
    private.COLLECT_VISIBLE_TIME, 3, 1 } );

  ObjAnimate( replace_item, "alp", 0, 0, "", { 
    0, 3, 0, 
    private.COLLECT_VISIBLE_TIME, 3, 0 } );

end;
--*********************************************************************************************************************
function private.GetBottle( )

  cmn.HoTaskFind( "spr_hoalchemybox3_rpl_win_bottle", "bottle" );     
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************