-- name=ho_hocupboard2_rpl
--*********************************************************************************************************************
function public.Init ()

  --------------------------------------------------------------------------------------------------
  room.Define( "ho_hocupboard2_rpl" );
  game.relations[ "ho_hocupboard2_rpl" ].exitroom = "rm_replayroom";
  private.room_objname = "ho_hocupboard2_rpl";
  private.task_name = "win_hocupboard2_rpl";  

  private.InitAnimations();

  private.win_hocupboard2_rpl = {};
  private.win_hocupboard2_rpl.sound_counter = 0;
  
  --------------------------------------------------------------------------------------------
  -- function opn_hocupboard2_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_hocupboard2_rpl = function ()

  end;

  cmn.AddSubscriber( "opn_hocupboard2_rpl", opn_hocupboard2_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------------    
  common_impl.hint[ private.task_name ] =
  {
    type = "win",
    win_ho = "",
    room = private.room_objname
  };
  --------------------------------------------------------------------------------------------------
  local win_hocupboard2_rpl_func = function ()


  end;
  cmn.AddSubscriber( "win_hocupboard2_rpl", win_hocupboard2_rpl_func );
  --------------------------------------------------------------------------------------------------
  local start_hocupboard2_rpl_func = function ()

    if ( cmn.IsEventStart( "win_hocupboard2_rpl" ) ) then

        local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].found;

        for i = 1, #ho_found, 1 do
          
            private.win_hocupboard2_rpl.sound_counter = private.win_hocupboard2_rpl.sound_counter + 1;
            ObjDelete( ho_found[ i ][ "object" ] );

        end;

    end;

  end;
  cmn.AddSubscriber( "win_hocupboard2_rpl", start_hocupboard2_rpl_func );
  --------------------------------------------------------------------------------------------------
  private.win_hocupboard2_rpl.task = { "item_1", "item_2", "item_3", "item_4", "item_5", "item_6", 
                                    "item_7", "item_8", "item_9", "item_10" };

  for i = 1, #private.win_hocupboard2_rpl.task do

    ObjSet( "spr_hocupboard2_rpl_"..private.win_hocupboard2_rpl.task[ i ], { event_mdown = function () private.CompleteTask( private.win_hocupboard2_rpl.task[ i ], i ); end, input = false } );

  end;

end;

--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.ResetHO ()

  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].start = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].done = 0;
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].stage = 1;      
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].all = { { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1, 1, 1} };      
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].count = 10;     
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].shadow = 0; 
  ng_global.progress[ ng_global.currentprogress ][ private.task_name ].task_check = { 0,0,0,0,0,0,0,0,0,0 };  
  DbgTrace( "ResetHO" );
  
end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.InterfaceSetVisible( true );
  interface.WidgetSetVisible( InterfaceWidget_BtnHint, true );     
  
  if ( not cmn.IsEventStart( private.task_name ) ) then

      cmn.InitHo( "hocupboard2_rpl" );

  end;

  if ( not cmn.IsEventDone( "opn_hocupboard2_rpl" ) ) then

      cmn.SetEventDone( "opn_hocupboard2_rpl" );
      cmn.CallEventHandler( "opn_hocupboard2_rpl" );
      
      ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].stage = 1;      
      ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].all = { { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 1, 1, 1, 1} };      
      ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].count = 10;     
      ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].shadow = 0;        

  end;        

  local ho_tasks = {};
  
  for i = 1, #private.win_hocupboard2_rpl.task do

    interface.TaskPanelTaskAdd( ho_tasks, private.win_hocupboard2_rpl.task[ i ], 1, 0, { { "spr_hocupboard2_rpl_"..private.win_hocupboard2_rpl.task[ i ]  } } );
    
  end;  
  
  interface.TaskPanelTaskAdd( ho_tasks, "vessel",    1, 0, { { "spr_hocupboard2_rpl_open_vessel" } } );  
  
  for i = 1, #ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].all[ 1 ] do
    
    if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].all[ 1 ][ i ] == 0 ) then
      
      ObjSet( "spr_hocupboard2_rpl_plate_"..i, { alp = 1 } );
      
    end;
    
  end;    
  
  int.TaskPanelShow( ho_tasks );
  private.Panel();  
  
  ObjSet( "txt_hocupboard2_rpl_task",  { text = "tsk_hocupboard2_task_"..ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].stage } );    
  ObjSet( "txt_hocupboard2_rpl_count", { text = ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].count } ); 
     
  private.ChangeTask();
  
  cmn.StopAllMus();
  cmn.StopAllEnv( "audio/level2/env/aud_ho_hocupboard2_env", true );
  cmn.PlayAudio( "env", "audio/level2/env/aud_ho_hocupboard2_env", 1, 1 );

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.StopMusEnv( false );

end;
--*********************************************************************************************************************
function public.PreClose ()

  int.TaskPanelHide();
  common_impl.PlayMusEnv();

end;
--*********************************************************************************************************************
function public.Close ()

  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  ObjSet( "txt_int_taskpanel", { alp = 1 } );    
  ObjSet( "int_inventory_impl", { input = true } );
  ObjAttach( "obj_hocupboard2_rpl_panel","ho_hocupboard2_rpl" );
  
end;
--*********************************************************************************************************************
function public.HoComplete ()

  int.Lock( true );

end;
--*********************************************************************************************************************
function private.CompleteTask ( name, number )

  int.Lock( true );

  ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].all[ 1 ][ number ] = 0;
  ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].shadow = ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].shadow + 1;  
  ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].count = ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].count - 1;  
  
  cmn.HoTaskFind( "spr_hocupboard2_rpl_"..name, name );
  for i = 1,#private.win_hocupboard2_rpl.task do

      if ( private.win_hocupboard2_rpl.task[i] == name ) then 

          local object_name = "obj_"..i; 
          local collect_name  = "pfx_hocupboard2_rpl_collect_"..object_name.."_effect";
          ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].task_check[ i ] = 1;
          ObjCreate( collect_name, "partsys" );

          if  ( cmn.IsEventDone( "win_hocupboard2_rpl" ) ) then

              --int.Lock( false );

          end;

          ObjSet( collect_name,
          {
            res    = "assets/interface/resources/effects_ho_hint",
            pos_x  = ObjGet( object_name ).pos_x, pos_y = ObjGet( object_name ).pos_y,
            active = 1, visible = 1, input = 0
          } );

          ObjAttach( collect_name, "obj_hocupboard2_rpl_panel" );
          ObjSet( collect_name, { blendmode = 2, scale_x = 0.8, scale_y = 0.8 } );
          --PartSysSetMaskObj( collect_name, object_name );  
          local func_end = function () private.AnimInv( i ); private.CompleteTask_2( name, number ); end;
            
          private.win_hocupboard2_rpl.sound_counter = private.win_hocupboard2_rpl.sound_counter + 1;
      
          ObjAnimate( object_name, 8,0,0, func_end,
          { 
              0.0, 0, 1.0,
              0.5, 0, 0.0
          } );                       
--
      end;

  end;

end;
--*********************************************************************************************************************
function private.CompleteTask_2 ( name, number )

  int.Lock( true );
  
  local func_end = function ()

    private.ChangeTask();  
  
  end;
  
  private.FlyPFX( name );  

  ObjAnimate( "spr_hocupboard2_rpl_plate_"..number, "alp", 0, 0, "", 
  { 
    0.0, 0, 0,      
    0.7, 0, 0,        
    0.1, 0, 1
  });
  --waitandrun
  ObjAnimate( "obj_hocupboard2_rpl_anims", "alp", 0, 0, func_end, 
  { 
    0.0, 0, 1,      
    1.0, 0, 1
  })  


end;
--********************************************************************************************************************* 
function private.ChangeTask () 
  
   local stage = ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].stage;

   if ( stage == 1 ) then
   
     local count = ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].count;
       
     if ( count == 0 ) then

        ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].stage = 3;
        ObjSet( "txt_hocupboard2_rpl_num", { alp = 0} );
        local func_end = function ()

          private.CheckTask();

        end;

        ObjAnimate( "txt_hocupboard2_rpl_task", "alp", 0, 0, func_end, 
        { 
          0,   0, 0, 
          0.3, 0, 0, 
        });        
        
     else 
      
      int.Lock( false );
     
     end;
    
   else
    
    int.Lock( false );
     
   end;  
    
end;
--********************************************************************************************************************* 
function private.CheckTask () 

   local stage = ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].stage;
   
   ObjSet( "txt_hocupboard2_rpl_task",  { text = "tsk_hocupboard2_task_"..stage } );
   
   int.Lock( false );

   if ( stage == 3 ) then
      
      local func_end = function ()      
      
       ObjSet( "txt_hocupboard2_rpl_task", { pos_x = 5 } );
       ObjSet( "txt_hocupboard2_rpl_num",  { alp = 0 } );
       ObjSet( "spr_hocupboard2_rpl_open_vessel", { event_mdown = private.GetStone, alp = 1, input = true } );
       ObjSet( "gfx_hocupboard2_rpl_open_vessel", { active = true } ); 
       ObjSet( "anm_hocupboard2_rpl_door_opn_end", { alp = 1 } );       
       ObjSet( "anm_hocupboard2_rpl_door_opn", { alp = 0 } );       
       ObjSet( "obj_hocupboard2_rpl_plate_cover", { alp = 0 } );       
       ObjSet( "obj_hocupboard2_rpl_plate", { input = false } );       

      end;

      ObjAnimate( "txt_hocupboard2_rpl_task", "alp", 0, 0, "", 
      { 
        0,   0, 0, 
        0.3, 0, 1, 
      })
      ObjSet( "anm_hocupboard2_rpl_door_opn", { alp = 1 } );
      ObjSet( "obj_hocupboard2_rpl_plate_cover", { alp = 0 } );
      cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ho_cupboard2_open" );
      AnimPlay( "anm_hocupboard2_rpl_door_opn", "DoAnim", func_end );

   end;
   
end;
--*********************************************************************************************************************
function private.FlyPFX ( name )

    local anm_fly_name = "anm_fly_"..name;

    local collect_pos = GetObjPosByObj( "spr_hocupboard2_rpl_"..name, "obj_hocupboard2_rpl_plate" );  

    local collect_drawoff_x = ObjGet( "spr_hocupboard2_rpl_"..name ).drawoff_x;
    local collect_drawoff_y = ObjGet( "spr_hocupboard2_rpl_"..name ).drawoff_y;

    ObjCreate( anm_fly_name, "anim" );

    ObjSet( anm_fly_name,
    {
      res = "assets/levels/level2/ho_hocupboard2/anims/anm_red_stone",
      pos_x = collect_drawoff_x, pos_y = collect_drawoff_y,
      input = false
    } );
    
    AnimPlay( anm_fly_name, "DoAnim", "" );
    ObjAttach( anm_fly_name, "obj_hocupboard2_rpl_plate" );

    cmn.WaitAndRun( function() cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_ho_cupboard2_insert" ) end, 0.7 );

    ObjSet( anm_fly_name, { pos_z = 50 } );

    ObjAnimate( anm_fly_name, "pos_xy", 0, 0, "", 
    { 
      0.0,  0,  collect_pos[ 1 ], collect_pos[ 2 ],
      0.8,  0,  0, 0 
    } );
    ObjAnimate( anm_fly_name, "alp", 0, 0, function () ObjDelete(anm_fly_name); end, 
    { 
      0.0,  1, 1,
      1.0,  0, 0
    } );

end;
--*********************************************************************************************************************
function private.Panel ()
  
  ObjSet( "obj_int_taskpanel", { alp = 0 } );
  ObjSet( "txt_int_taskpanel", { alp = 0 } );
  ObjSet( "int_inventory_impl", { input = false } );
  ObjAttach( "obj_hocupboard2_rpl_panel" , "spr_int_taskpanel" );
  
  
  --1 STAGE
  if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].stage == 1 ) then
  
    if ( not ng_global.progress[ ng_global.currentprogress ]["win_hocupboard2_rpl"].task_check ) then

      ng_global.progress[ng_global.currentprogress]["win_hocupboard2_rpl"].task_check = { 0,0,0,0,0,0,0,0,0,0 };

    end;

    local posx = -175;
    local tmp = 0;

    ObjSet( "obj_hocupboard2_rpl_panel", { croprect_init = true, croprect_x = -308, croprect_y = -200, croprect_w = 560, croprect_h = 400 } );

    for i = 1,#private.win_hocupboard2_rpl.task do 

       local obj = "obj_"..i;

       if ( ng_global.progress[ng_global.currentprogress]["win_hocupboard2_rpl"].task_check[i] == 0 ) and
          ( not ObjGet( obj ) ) then

          ObjCreate( obj, "obj" );
          ObjAttach( obj, "obj_hocupboard2_rpl_panel" );
          ObjSet( obj, { pos_x = posx, pos_y = 24, inputrect_init = true, inputrect_x = -45, inputrect_y = -45, inputrect_w = 90, inputrect_h = 90, alp = 1, input = 0  } );
          local spr = "spr_hocupboard2_rpl_"..private.win_hocupboard2_rpl.task[i].."_inv";
          ObjCreate( spr, "spr" );
          ObjSet( spr, { res = "assets/levels/level2/ho_hocupboard2/layers/inv/inv_"..private.win_hocupboard2_rpl.task[i], scale_x = 0.8, scale_y = 0.8 } );
          ObjAttach( spr, obj );
          tmp = tmp + 1;
          if ( tmp < 6 ) then

             private.CheckPanel( i, tmp );
            
          end;

           posx = posx + 95;

           if ( tmp == 10 ) then

            ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].set = 1;

          end;

       else

       end;

    end;     
  
  elseif ( ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].stage == 3 ) then       
      
      ObjSet( "txt_hocupboard2_rpl_task", { alp = 1, pos_x = 5 } );
    ObjSet( "txt_hocupboard2_rpl_num",  { alp = 0 } );
    ObjSet( "spr_hocupboard2_rpl_open_vessel", { event_mdown = private.GetStone, alp = 1, input = true } );
    ObjSet( "gfx_hocupboard2_rpl_open_stone", { active = true } );
    ObjSet( "anm_hocupboard2_rpl_door_opn_end", { alp = 1 } );   
    ObjSet( "anm_hocupboard2_rpl_door_opn", { alp = 0 } );        
      ObjSet( "obj_hocupboard2_rpl_plate_cover", { alp = 0 } );    
    ObjSet( "obj_hocupboard2_rpl_plate", { input = false } );
    
  end;      
      
   
end;
--********************************************************************************************************************* 
function private.CheckPanel ( i, tmp ) 

   local obj = "obj_"..i;

   if ( tmp < 6 ) then

      ObjSet( obj, { input = 1 } );

      ObjAnimate( obj, "alp", 0, 0, "", 
      { 
        0,0,0, 
        0.3,0,1 
      });

      ObjSet( "spr_hocupboard2_rpl_"..private.win_hocupboard2_rpl.task[i], { alp = 1, input = 1 } );

   end;
   
end;
--*********************************************************************************************************************
function private.AnimInv ( num )

  local item = "obj_"..num;
  local tmp = num + 1;
  local panel_sound = false;

      for i = tmp,#private.win_hocupboard2_rpl.task do

          local obj_tmp = "obj_"..i;

          if obj_tmp ~= nil and ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].task_check[ i ] ~= 1 then

              if not panel_sound then
                panel_sound = true;
              end;

              ObjAnimate( "obj_"..i, "pos_x", 0, 0, "", 
              { 
                0,3,ObjGet( "obj_"..i ).pos_x, 
                0.6,3,ObjGet( "obj_"..i ).pos_x-95
              });

              if ObjGet( "obj_"..i ).pos_x-95 == 205 then

                  ObjAnimate( "obj_"..i, "scale_xy", 0, 0, "", 
                  { 
                    0.0,0,0.2,0.2, 
                    0.7,0,1,1
                  });

               end;

          end;

      end;

  private.Check( num );

end;
--*********************************************************************************************************************
function private.Check ( num )  

  local tmp = 0;

  for i = 1,#private.win_hocupboard2_rpl.task do

     local item = "obj_"..i;

     if ( item and ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].task_check[ i ] ~= 1 ) then

        tmp = tmp + 1;

        if ( tmp < 6 ) then

           ObjSet( "spr_hocupboard2_rpl_"..private.win_hocupboard2_rpl.task[ i ], { alp = 1, input = 1 } );

        end;

        num = num + 1;

     end;

  end;
   
    if ( ng_global.progress[ ng_global.currentprogress ][ "win_hocupboard2_rpl" ].shadow < 10 ) then     
      
    local func_end = function () int.Lock( false ) end;

    ObjAnimate( "ho_hocupboard2_rpl", "alp", 0, 0, func_end, 
    { 
    0,3,1, 
    0.6,3,1
    });
  
  else

    int.Lock( false );   

  end;

end;
--*********************************************************************************************************************
function private.GetStone ()

  local func_end = function ()

    int.Lock( false );

  end;

  int.Lock( true );
  MsgSend( Event_DialogHo_Show, {} );
  ObjAnimate( "spr_hocupboard2_rpl_open_vessel", "alp", 0, 0, func_end, 
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );
  
end;
--*********************************************************************************************************************
function private.InitAnimations ()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************