-- name=mg_mgassault1_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgassault1_rpl";
  game.relations[ "mg_mgassault1_rpl" ].exitroom = "rm_replayroom";

  private.Init();
  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgassault1_rpl = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgassault1_rpl", update_game_mode_mgassault1_rpl, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mgassault1_rpl () end;
  --------------------------------------------------------------------------------------------
  local win_mgassault1_rpl = function ()

    if ( cmn.IsEventStart( "win_mgassault1_rpl" ) ) and not ( cmn.IsEventDone( "win_mgassault1_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgassault1_rpl", win_mgassault1_rpl );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  if ( cmn.IsEventDone( "win_mgassault1_rpl" ) ) then

    public.Reset();

    ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].start = 0;
    ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].done = 0;

  end;

  --private.InventoryUpdate( "hide" );

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventDone( "opn_mgassault1_rpl" ) ) then

    cmn.SetEventDone( "opn_mgassault1_rpl" );

  end;

  if ( not cmn.IsEventStart( "win_mgassault1_rpl" ) ) then    

    private.Start();

  elseif ( cmn.IsEventStart( "win_mgassault1_rpl" ) ) then

    cmn.MiniGameShow( "mgassault1_rpl" );

  end;

  if ( not private.is_start_fight ) and
     ( not cmn.IsEventDone( "win_mgassault1_rpl" ) ) then

    private.is_start_fight = true;
    private.SymbolsInit();

  end;

  --common_impl.StopMusEnv( false );
  --cmn.PlayAudio( "mus", "audio/level1/mus/aud_action_fight_1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_mgassault1_rpl" ) ) and ( not cmn.IsEventDone( "win_mgassault1_rpl" ) ) then

    cmn.MiniGameHide();

  end;

  --cmn.StopAudio( "mus", "audio/level1/mus/aud_action_fight_1_mus", 0.5 );

end;
--*********************************************************************************************************************
function public.Close ()

  --private.InventoryUpdate( "show" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].stage  = "protect";
  ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].attack = 0;

  private.stage = "protect";
  private.symbols = {};
  private.attack = 0;
  private.position = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  private.is_start_fight = false;

  ObjSet( "tmr_mgassault1_rpl_counter",        { playing = false } );
  ObjSet( "tmr_mgassault1_rpl_counter_update", { playing = false } );
  ObjSet( "spr_mgassault1_rpl_counter_stripe", { croprect_y = 0 } );
  ObjSet( "anm_mgassault1_rpl_counter",        { frame = 0, playing = false, animfunc = "DoAnim" } );

  for s = 1, private.symbols_count do

    ObjSet( "spr_mgassault1_rpl_inventory_symbol_"..s, { alp = 0 } );

  end;

  private.SymbolsInit();

end;
--*********************************************************************************************************************
function public.Skip ()

  private.WinAnim();

end;
--*********************************************************************************************************************
function private.Init ()

  private.symbols_count = 18;
  private.tme = 15;
  private.stack = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18 };
  private.stage = "attack";
  --private.stage = "protect";  
  private.symbols = {};
  private.position = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  private.attack = 0;
  private.is_start_fight = false;

  for s = 1, private.symbols_count do

    ObjSet( "obj_mgassault1_rpl_symbol_"..s,
    {
      input        = true,
      event_mdown  = function () private.SymbolClick( s ); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].stage  = "protect";
  ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].attack = 0;
  cmn.MiniGameShow( "mgassault1_rpl" );

end;
--*********************************************************************************************************************
function private.Load ()

  private.stage  = ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].stage;
  private.attack = ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].attack;

  ObjSet( "spr_mgassault1_rpl_counter_logo", { res = "assets/levels/level1/mg_mgassault1/layers/counter_"..private.stage } );

end;
--*********************************************************************************************************************
function private.WinAnim()

  int.Lock( true );

  local func_end = function ()

    private.Win();
    int.Lock( false );

  end;

  func_end();

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgassault1_rpl" );
  cmn.CallEventHandler( "win_mgassault1_rpl" );
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.SymbolsInit ()

  local stack = {};
  private.symbols = {};
  private.position = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
  private.is_start_fight = true;

  for s = 1, private.symbols_count do

    table.insert( stack, private.stack[ s ] );

  end;

  for s = 1, 3 do

    local idx = math.random( #stack );
    table.insert( private.symbols, stack[ idx ] );
    private.position[ stack[ idx ] ] = s;
    table.remove( stack, idx );

    ObjSet( "spr_mgassault1_rpl_counter_light_"..s, { alp = 0 } );

  end;

  private.SymbolsShow();

  ObjSet( "spr_mgassault1_rpl_counter_logo", { res = "assets/levels/level1/mg_mgassault1/layers/counter_"..private.stage } );

end;
--*********************************************************************************************************************
function private.SymbolsShow ()

  int.Lock( true );

  for s = 1, 3 do

    ObjSet( "spr_mgassault1_rpl_inventory_symbol_"..s, { res = "assets/levels/level1/mg_mgassault1/layers/symbols/int_symbol_"..private.symbols[ s ] } );

  end;

  local func_end = function ()

    int.Lock( false );

    ObjSet( "tmr_mgassault1_rpl_counter",
    {
      playing = true,
      time = private.tme,
      endtrig = function ()

        private.SymbolsHide();
        private.EnemyAttack();

      end,
    } );

    private.CounterUpdate();

  end;

  ObjAnimate( "spr_mgassault1_rpl_inventory_symbol_1", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

  ObjAnimate( "spr_mgassault1_rpl_inventory_symbol_2", "alp", 0, 0, "",
  {
    0.0, 3, 0.0,
    0.5, 3, 0.0,
    0.8, 3, 1.0,
  } );

  ObjAnimate( "spr_mgassault1_rpl_inventory_symbol_3", "alp", 0, 0, func_end,
  {
    0.0, 3, 0.0,
    1.0, 3, 0.0,
    1.3, 3, 1.0,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_assault_suluets_appears" );

end;
--*********************************************************************************************************************
function private.SymbolsHide ()

  for s = 1, 3 do

    ObjAnimate( "spr_mgassault1_rpl_inventory_symbol_"..s, "alp", 0, 0, "",
    {
      0.0, 3, ObjGet( "spr_mgassault1_rpl_inventory_symbol_"..s ).alp,
      0.3, 3, 0.0,
    } );

  end;

end;
--*********************************************************************************************************************
function private.SymbolClick ( idx )

  local func_end = function ()

    int.Lock( false );

    if ( #private.symbols == 0 ) then

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_assault_all_siluets" );

      if ( private.stage == "protect" ) then

        private.HeroProtect();

      else

        private.HeroAttack();

      end;

    end;

    ObjSet( "spr_mgassault1_rpl_inventory_symbol_"..private.position[ idx ], { alp = 0, scale_x = 1.0, scale_y = 1.0 } );

  end;

  if ( private.IsRightSymbol( idx ) ) then

    if ( #private.symbols == 0 ) then

      ObjSet( "anm_mgassault1_rpl_counter",        { playing = false } );
      ObjSet( "tmr_mgassault1_rpl_counter",        { playing = false } );
      ObjSet( "tmr_mgassault1_rpl_counter_update", { playing = false } );

    end;

    int.Lock( true );

    ObjAnimate( "spr_mgassault1_rpl_inventory_symbol_"..private.position[ idx ], "scale_xy", 0, 0, func_end,
    {
      0.0, 3, 1.0, 1.0,
      0.3, 3, 1.1, 1.1,
      0.6, 3, 0.0, 0.0,
    } );

    local light = 3 - #private.symbols;

    ObjSet( "spr_mgassault1_rpl_counter_light_"..light, { res = "assets/levels/level1/mg_mgassault1/layers/counter_light_green" } );
    ObjAnimate( "spr_mgassault1_rpl_counter_light_"..light, "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    private.ShowFX( idx, private.position[ idx ] );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_assault_right" );

  else

    ObjSet( "anm_mgassault1_rpl_counter",        { playing = false } );
    ObjSet( "tmr_mgassault1_rpl_counter",        { playing = false } );
    ObjSet( "tmr_mgassault1_rpl_counter_update", { playing = false } );

    local light = 3 - #private.symbols + 1;

    ObjSet( "spr_mgassault1_rpl_counter_light_"..light, { res = "assets/levels/level1/mg_mgassault1/layers/counter_light_red" } );
    ObjAnimate( "spr_mgassault1_rpl_counter_light_"..light, "alp", 0, 0, "",
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    private.SymbolsHide();
    private.EnemyAttack();

  end;

end;
--*********************************************************************************************************************
function private.IsRightSymbol ( idx )

  for s = 1, #private.symbols do

    if ( idx == private.symbols[ s ] ) then

      table.remove( private.symbols, s );
      return true;

    end;

  end;

  return false;

end;
--*********************************************************************************************************************
function private.EnemyAttack ()

  AnimStop( "anm_mgassault1_rpl_counter" );
  ObjSet( "tmr_mgassault1_rpl_counter",        { playing = false } );
  ObjSet( "tmr_mgassault1_rpl_counter_update", { playing = false } );

  local func_end = function ()

    int.Lock( false );

    private.stage = "protect";
    ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].stage  = "protect";
    private.SymbolsInit();

    ObjSet( "anm_mgassault1_rpl_enemy_attack", { alp = 0 } );
    ObjSet( "anm_mgassault1_rpl_enemy_static", { alp = 1 } );

    AnimStop( "anm_mgassault1_rpl_enemy_attack" );
    AnimPlay( "anm_mgassault1_rpl_enemy_static", "DoAnim", "" );

    ObjSet( "anm_mgassault1_rpl_user_get_damage", { alp = 0 } );
    ObjSet( "anm_mgassault1_rpl_user_static", { alp = 1 } );

    AnimStop( "anm_mgassault1_rpl_user_get_damage" );
    AnimPlay( "anm_mgassault1_rpl_user_static", "DoAnim", "" );

    ObjAttach( "obj_mgassault1_rpl_symbol_9", "anm_mgassault1_rpl_enemy_static" );
    ObjAttach( "obj_mgassault1_rpl_symbol_10", "anm_mgassault1_rpl_enemy_static" );

  end;

  int.Lock( true );

  ObjSet( "anm_mgassault1_rpl_enemy_static", { alp = 0 } );
  ObjSet( "anm_mgassault1_rpl_enemy_attack", { alp = 1 } );

  AnimStop( "anm_mgassault1_rpl_enemy_static" );
  AnimPlay( "anm_mgassault1_rpl_enemy_attack", "DoAnim", func_end );

  ObjSet( "anm_mgassault1_rpl_user_static", { alp = 0 } );
  ObjSet( "anm_mgassault1_rpl_user_get_damage", { alp = 1 } );

  AnimStop( "anm_mgassault1_rpl_user_static" );
  AnimPlay( "anm_mgassault1_rpl_user_get_damage", "DoAnim", "" );

  ObjAttach( "obj_mgassault1_rpl_symbol_9", "anm_mgassault1_rpl_enemy_attack" );
  ObjAttach( "obj_mgassault1_rpl_symbol_10", "anm_mgassault1_rpl_enemy_attack" );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_assault_click_wrong" );

end;
--*********************************************************************************************************************
function private.HeroAttack ()

  AnimStop( "anm_mgassault1_rpl_counter" );
  ObjSet( "tmr_mgassault1_rpl_counter",        { playing = false } );
  ObjSet( "tmr_mgassault1_rpl_counter_update", { playing = false } );

  local func_end = function ()

    int.Lock( false );

    private.attack = private.attack + 1;

    if ( private.attack == 2 ) then
    --if ( private.attack == 3 ) then      

      private.WinAnim();

    else

      private.stage = "protect";
      private.SymbolsInit();

      ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].stage  = "protect";
      ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].attack = private.attack;

    end;

    ObjSet( "anm_mgassault1_rpl_user_attack", { alp = 0 } );
    ObjSet( "anm_mgassault1_rpl_user_static", { alp = 1 } );

    AnimStop( "anm_mgassault1_rpl_user_attack" );
    AnimPlay( "anm_mgassault1_rpl_user_static", "DoAnim", "" );

    ObjSet( "anm_mgassault1_rpl_enemy_get_damage", { alp = 0 } );
    ObjSet( "anm_mgassault1_rpl_enemy_static", { alp = 1 } );

    AnimStop( "anm_mgassault1_rpl_enemy_get_damage" );
    AnimPlay( "anm_mgassault1_rpl_enemy_static", "DoAnim", "" );

    ObjAttach( "obj_mgassault1_rpl_symbol_9", "anm_mgassault1_rpl_enemy_static" );
    ObjAttach( "obj_mgassault1_rpl_symbol_10", "anm_mgassault1_rpl_enemy_static" );

  end;

  int.Lock( true );

  ObjSet( "anm_mgassault1_rpl_user_static", { alp = 0 } );
  ObjSet( "anm_mgassault1_rpl_user_attack", { alp = 1 } );

  AnimStop( "anm_mgassault1_rpl_user_static" );
  AnimPlay( "anm_mgassault1_rpl_user_attack", "DoAnim", func_end );

  ObjSet( "anm_mgassault1_rpl_enemy_static", { alp = 0 } );
  ObjSet( "anm_mgassault1_rpl_enemy_get_damage", { alp = 1 } );

  AnimStop( "anm_mgassault1_rpl_enemy_static" );
  AnimPlay( "anm_mgassault1_rpl_enemy_get_damage", "DoAnim", "" );

  ObjAttach( "obj_mgassault1_rpl_symbol_9", "anm_mgassault1_rpl_enemy_get_damage" );
  ObjAttach( "obj_mgassault1_rpl_symbol_10", "anm_mgassault1_rpl_enemy_get_damage" );

end;
--*********************************************************************************************************************
function private.HeroProtect ()

  AnimStop( "anm_mgassault1_rpl_counter" );
  ObjSet( "tmr_mgassault1_rpl_counter",        { playing = false } );
  ObjSet( "tmr_mgassault1_rpl_counter_update", { playing = false } );

  local func_end = function ()

    int.Lock( false );

    private.stage = "attack";
    private.SymbolsInit();

    ng_global.progress[ private.currentprogress ][ "win_mgassault1_rpl" ].stage = "attack";

    ObjSet( "anm_mgassault1_rpl_enemy_attack", { alp = 0 } );
    ObjSet( "anm_mgassault1_rpl_enemy_static", { alp = 1 } );

    AnimStop( "anm_mgassault1_rpl_enemy_attack" );
    AnimPlay( "anm_mgassault1_rpl_enemy_static", "DoAnim", "" );

    ObjSet( "anm_mgassault1_rpl_user_protect", { alp = 0 } );
    ObjSet( "anm_mgassault1_rpl_user_static", { alp = 1 } );

    AnimStop( "anm_mgassault1_rpl_user_protect" );
    AnimPlay( "anm_mgassault1_rpl_user_static", "DoAnim", "" );

    ObjAttach( "obj_mgassault1_rpl_symbol_9", "anm_mgassault1_rpl_enemy_static" );
    ObjAttach( "obj_mgassault1_rpl_symbol_10", "anm_mgassault1_rpl_enemy_static" );

  end;

  int.Lock( true );

  ObjSet( "anm_mgassault1_rpl_enemy_static", { alp = 0 } );
  ObjSet( "anm_mgassault1_rpl_enemy_attack", { alp = 1 } );

  AnimStop( "anm_mgassault1_rpl_enemy_static" );
  AnimPlay( "anm_mgassault1_rpl_enemy_attack", "DoAnim", func_end );

  ObjSet( "anm_mgassault1_rpl_user_static", { alp = 0 } );
  ObjSet( "anm_mgassault1_rpl_user_protect", { alp = 1 } );

  AnimStop( "anm_mgassault1_rpl_user_static" );
  AnimPlay( "anm_mgassault1_rpl_user_protect", "DoAnim", "" );

  ObjAttach( "obj_mgassault1_rpl_symbol_9", "anm_mgassault1_rpl_enemy_attack" );
  ObjAttach( "obj_mgassault1_rpl_symbol_10", "anm_mgassault1_rpl_enemy_attack" );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_assault_click_wrong" );

end;
--*********************************************************************************************************************
function private.CounterUpdate ()

  --[[
  local tme = ObjGet( "tmr_mgassault1_rpl_counter" ).time;

  if ( tme < 0.00001 ) then

    return;

  end;

  local crop = 115 - ( 115 * tme ) / private.tme;
  ObjSet( "spr_mgassault1_rpl_counter_stripe", { croprect_y = crop } );

  ObjSet( "tmr_mgassault1_rpl_counter_update",
  {
    playing = true,
    time = 0.1,
    endtrig = function ()

      private.CounterUpdate();

    end,
  } );
  ]]

  ObjSet( "anm_mgassault1_rpl_counter", { frame = 0, animfunc = "DoAnim" } );
  AnimPlay( "anm_mgassault1_rpl_counter", "DoAnim", "" );

end;
--*********************************************************************************************************************
function private.InventoryUpdate ( event )

  if ( event == "show" ) then

    ObjSet( "int_inventory", { input = true, active = true, visible = true } );

  else

    ObjSet( "int_inventory", { input = false, active = false, visible = false } );

  end;

end;
--*********************************************************************************************************************
function private.ShowFX ( symbol, idx )

  local name = "anm_mgassault1_rpl_symbol_fx_"..idx;
  local end_xy = { { 400,722 }, { 512,722 }, { 624,722 } };
  local start_xy =
  {
    {  51,135 }, {  28,286 }, { 196, 67 }, { 157,234 }, { 141,360 }, { 152,577 },
    { 359,107 }, { 289,207 }, { 390,348 }, { 554,481 }, { 624, 90 }, { 698, 90 },
    { 652,216 }, { 755,251 }, { 880,250 }, { 769,405 }, { 887,455 }, { 825,541 },
  };

  ObjSet( name, { alp = 1, playing = true } );

  ObjAnimate( name, "pos_xy", 0, 0,
  function ()

    ObjSet( name, { alp = 0, playing = false } );

  end,
  {
    0.0, 3, start_xy[ symbol ][ 1 ], start_xy[ symbol ][ 2 ],
    0.5, 3, end_xy[ idx ][ 1 ],      end_xy[ idx ][ 2 ],
  } );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  for s = 1, private.symbols_count do

    local tme = math.random( 10, 25 ) / 10;

    ObjAnimate( "spr_mgassault1_rpl_symbol_"..s.."_light", "alp", 1, 0, "",
    {
      0.0,       3, 0.0,
      tme,       3, 0.6,
      tme + tme, 3, 0.0,
    } );

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************