-- name=mg_mgcreatingacid2_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgcreatingacid2_rpl";
  game.relations[ "mg_mgcreatingacid2_rpl" ].exitroom = "rm_replayroom";

  private.Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgcreatingacid2_rpl = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgcreatingacid2_rpl", update_game_mode_mgcreatingacid2_rpl, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mgcreatingacid2_rpl () end;
  --------------------------------------------------------------------------------------------
  local win_mgcreatingacid2_rpl = function ()

    if ( cmn.IsEventStart( "win_mgcreatingacid2_rpl" ) ) and not ( cmn.IsEventDone( "win_mgcreatingacid2_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgcreatingacid2_rpl", win_mgcreatingacid2_rpl );

  --------------------------------------------------------------------------------------------
  -- function opn_mgcreatingacid2_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_mgcreatingacid2_rpl = function ()


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "opn_mgcreatingacid2_rpl", opn_mgcreatingacid2_rpl, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  if ( cmn.IsEventDone( "win_mgcreatingacid2_rpl" ) ) then

    public.Reset();

    ng_global.progress[ private.currentprogress ][ "win_mgcreatingacid2_rpl" ].start = 0;
    ng_global.progress[ private.currentprogress ][ "win_mgcreatingacid2_rpl" ].done = 0;

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventDone( "opn_mgcreatingacid2_rpl" ) ) then

    cmn.SetEventDone( "opn_mgcreatingacid2_rpl" );
    cmn.CallEventHandler( "opn_mgcreatingacid2_rpl" );

  end;

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_loop_bubles", 1 );

  if ( not cmn.IsEventStart( "win_mgcreatingacid2_rpl" ) ) then    

    private.Start();

  elseif ( cmn.IsEventStart( "win_mgcreatingacid2_rpl" ) ) then

    cmn.MiniGameShow( "mgcreatingacid2_rpl" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_mgcreatingacid2_rpl" ) ) and ( not cmn.IsEventDone( "win_mgcreatingacid2_rpl" ) ) then

    cmn.MiniGameHide();

  end;

  cmn.StopAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_loop_bubles" );

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ ng_global.currentprogress ][ "win_mgcreatingacid2_rpl" ].angs = { 3,-4 };

  private.Load();

  ObjSet( "anm_mgcreatingacid2_rpl_acid", { alp = 0, frame = 0, animfunc = "DoAnim" } );

end;
--*********************************************************************************************************************
function public.Skip ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    private.WinAnim();

  end;

  for c = 1, private.count do

    local ang_1 = ( private.angs[ c ] ) * private.delta;
    local ang_2 = 0;

    ObjAnimate( "spr_mgcreatingacid2_rpl_arrow_"..c, "ang", 0, 0, func_end,
    {
      0.0, 3, ang_1,
      1.5, 3, ang_2,
    } );

    func_end = "";

  end;

end;
--*********************************************************************************************************************
function private.Init ()

  private.count = 2;
  private.delta = 0.523;
  private.angs  = { 3,-4 };
  private.array_pos = { { 2,-1 }, { -1,1 } };

  for c = 1, private.count do

    ObjSet( "obj_mgcreatingacid2_rpl_button_"..c,
    {
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      event_mdown  = function () private.ButtonClick( c ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgcreatingacid2_rpl" ].angs = { 3,-4 };
  cmn.MiniGameShow( "mgcreatingacid2_rpl" );

end;
--*********************************************************************************************************************
function private.Load ()

  for c = 1, private.count do

    private.angs[ c ] = ng_global.progress[ ng_global.currentprogress ][ "win_mgcreatingacid2_rpl" ].angs[ c ];

    local ang = private.angs[ c ] * private.delta;

    ObjSet( "spr_mgcreatingacid2_rpl_arrow_"..c, { ang = ang } );

  end;

end;
--*********************************************************************************************************************
function private.WinAnim()

  local func_end = function ()

    ng_global.progress[ ng_global.currentprogress ][ "win_mgcreatingacid2_rpl" ].angs = { 0,0 };
    int.Lock( false );
    private.Win();

  end;

  int.Lock( true );

  ObjSet( "anm_mgcreatingacid2_rpl_acid", { alp = 1 } );
  AnimPlay( "anm_mgcreatingacid2_rpl_acid", "DoAnim", func_end );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_win" );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgcreatingacid2_rpl" );
  cmn.CallEventHandler( "win_mgcreatingacid2_rpl" );
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.IsWin ()

  for c = 1, private.count do

    if ( private.angs[ c ] ~= 0 ) then

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.ButtonClick ( idx )

  local func_end = function ()

    int.Lock( false );

    for c = 1, private.count do

      private.angs[ c ] = private.angs[ c ] + private.array_pos[ idx ][ c ];

      if ( private.angs[ c ] >= 13.9 ) then

        private.angs[ c ] = 2;

      elseif ( private.angs[ c ] >= 12.9 ) then

        private.angs[ c ] = 1;

      elseif ( private.angs[ c ] >= 11.9 ) then

        private.angs[ c ] = 0;

      elseif ( private.angs[ c ] <= -13.9 ) then

        private.angs[ c ] = -2;

      elseif ( private.angs[ c ] <= -12.9 ) then

        private.angs[ c ] = -1;

      elseif ( private.angs[ c ] <= -11.9 ) then

        private.angs[ c ] = 0;

      end;

      ObjSet( "spr_mgcreatingacid2_rpl_arrow_"..c, { ang = private.angs[ c ] * private.delta } );

    end;

    if ( private.IsWin() ) then

      private.WinAnim();

    else

      private.SaveProgress();

    end;

  end;

  int.Lock( true );

  for c = 1, private.count do

    local ang_1 = ( private.angs[ c ] ) * private.delta;
    local ang_2 = ( private.angs[ c ] + private.array_pos[ idx ][ c ] ) * private.delta;

    ObjAnimate( "spr_mgcreatingacid2_rpl_arrow_"..c, "ang", 0, 0, func_end,
    {
      0.0, 3, ang_1,
      0.5, 3, ang_2,
    } );

    func_end = "";

  end;

  AnimPlay( "anm_mgcreatingacid2_rpl_button_"..idx.."_click", "DoAnim", "" );

  if ( idx == 1 ) then

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_click_right" );

  else

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgcreatingacid2_click_left" );

  end;

end;
--*********************************************************************************************************************
function private.SaveProgress ()

  for c = 1, private.count do

    ng_global.progress[ ng_global.currentprogress ][ "win_mgcreatingacid2_rpl" ].angs[ c ] = private.angs[ c ];

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************