-- name=mg_mgdescent2_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgdescent2_rpl";
  game.relations[ "mg_mgdescent2_rpl" ].exitroom = "rm_replayroom";

  private.Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgdescent2_rpl = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgdescent2_rpl", update_game_mode_mgdescent2_rpl, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mgdescent2_rpl () end;
  --------------------------------------------------------------------------------------------
  local win_mgdescent2_rpl = function ()

    if ( cmn.IsEventStart( "win_mgdescent2_rpl" ) ) and not ( cmn.IsEventDone( "win_mgdescent2_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgdescent2_rpl", win_mgdescent2_rpl );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  if ( cmn.IsEventDone( "win_mgdescent2_rpl" ) ) then

    public.Reset();

    ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].start = 0;
    ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].done = 0;

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventStart( "win_mgdescent2_rpl" ) ) then    

    private.Start();

  elseif ( cmn.IsEventStart( "win_mgdescent2_rpl" ) ) then

    cmn.MiniGameShow( "mgdescent2_rpl" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_mgdescent2_rpl" ) ) and ( not cmn.IsEventDone( "win_mgdescent2_rpl" ) ) then

    cmn.MiniGameHide();

  end;

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].game = 3;
  ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item = nil;
  ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].items =
  {
    { false,false,false,false,false },
    { false,false,false,false },
    { false,false,false },
  };

  private.game = 3;
  private.current_item = nil;
  private.items =
  {
    { false,false,false,false,false },
    { false,false,false,false },
    { false,false,false },
  };

  for g = 1, 3 do

    for s = 1, private.items_count[ g ] do

      ObjSet( "obj_mgdescent2_rpl_items_"..g.."_symbol_"..s.."_1", { alp = 1, input = true } );
      ObjSet( "obj_mgdescent2_rpl_items_"..g.."_symbol_"..s.."_2", { alp = 1, input = true } );
      ObjSet( "spr_mgdescent2_rpl_items_"..g.."_light_"..s.."_1",  { alp = 0 } );
      ObjSet( "spr_mgdescent2_rpl_items_"..g.."_light_"..s.."_2",  { alp = 0 } );
      ObjSet( "anm_mgdescent2_rpl_back_"..g.."_static",            { alp = 0 } );
      AnimStop( "anm_mgdescent2_rpl_back_"..g.."_static" );

    end;

  end;

  ObjSet( "obj_mgdescent2_rpl_back", { pos_y = 1536 } );
  ObjSet( "anm_mgdescent2_rpl_back_3_static", { alp = 1 } );
  AnimPlay( "anm_mgdescent2_rpl_back_3_static", "DoAnim", "" );

end;
--*********************************************************************************************************************
function public.Skip ()

  private.WinAnim();

end;
--*********************************************************************************************************************
function private.Init ()

  private.game = 3;
  private.items_count = { 5,4,3 };
  private.current_item = nil;
  private.items =
  {
    { false,false,false,false,false },
    { false,false,false,false },
    { false,false,false },
  };

  for g = 1, 3 do

    for s = 1, private.items_count[ g ] do

      ObjSet( "obj_mgdescent2_rpl_items_"..g.."_symbol_"..s.."_1",
      {
        event_mdown  = function () private.ItemClick( s, 1 ); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
        inputrect_init = true,
        inputrect_x = -80,
        inputrect_y = -40,
        inputrect_w = 160,
        inputrect_h =  80,
      } );

      ObjSet( "obj_mgdescent2_rpl_items_"..g.."_symbol_"..s.."_2",
      {
        event_mdown  = function () private.ItemClick( s, 2 ); end,
        event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
        event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
        inputrect_init = true,
        inputrect_x = -80,
        inputrect_y = -40,
        inputrect_w = 160,
        inputrect_h =  80,
      } );

    end;

  end;

  ObjSet( "obj_mgdescent2_rpl_items_2_symbol_5_1",
  {
    event_mdown  = function () private.ItemClick( 5, 1 ); end,
    event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
  } );

  ObjSet( "obj_mgdescent2_rpl_items_2_symbol_6_1",
  {
    event_mdown  = function () private.ItemClick( 6, 1 ); end,
    event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
  } );

  ObjSet( "obj_mgdescent2_rpl_items_2_symbol_7_1",
  {
    event_mdown  = function () private.ItemClick( 7, 1 ); end,
    event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
  } );

  ObjSet( "obj_mgdescent2_rpl_items_3_symbol_4_1",
  {
    event_mdown  = function () private.ItemClick( 4, 1 ); end,
    event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
  } );

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].game = 3;
  ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item = nil;
  ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].items =
  {
    { false,false,false,false,false },
    { false,false,false,false },
    { false,false,false },
  };

  cmn.MiniGameShow( "mgdescent2_rpl" );

end;
--*********************************************************************************************************************
function private.Load ()

  private.game = ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].game;

  if ( ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item ) then

    private.current_item = {};
    private.current_item[ 1 ] = ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item[ 1 ];
    private.current_item[ 2 ] = ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item[ 2 ];

  end;

  ObjSet( "obj_mgdescent2_rpl_back", { pos_y = 768 * ( private.game - 1 ) } );

  if ( private.current_item ) then

    ObjSet( "spr_mgdescent2_rpl_items_"..private.game.."_light_"..private.current_item[ 1 ].."_"..private.current_item[ 2 ], { alp = 1 } );

  end;

  for g = 1, 3 do

    for s = 1, private.items_count[ g ] do

      private.items[ g ][ s ] = ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].items[ g ][ s ];

      if ( private.items[ g ][ s ] ) then

        ObjSet( "obj_mgdescent2_rpl_items_"..g.."_symbol_"..s.."_1", { alp = 0, input = false } );
        ObjSet( "obj_mgdescent2_rpl_items_"..g.."_symbol_"..s.."_2", { alp = 0, input = false } );

      end;

    end;

  end;

  ObjSet( "anm_mgdescent2_rpl_back_3_static", { alp = 0 } );
  AnimStop( "anm_mgdescent2_rpl_back_3_static" );

  ObjSet( "anm_mgdescent2_rpl_back_"..private.game.."_static", { alp = 1 } );
  AnimPlay( "anm_mgdescent2_rpl_back_"..private.game.."_static", "DoAnim", "" );

end;
--*********************************************************************************************************************
function private.WinAnim( idx )

  int.Lock( true );

  local func_end = function ()

    if ( idx ) then

      ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].items[ private.game ][ idx ] = true;
      ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item = nil;

    end;

    private.Win();
    int.Lock( false );

  end;

  func_end();

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgdescent2_rpl" );
  cmn.CallEventHandler( "win_mgdescent2_rpl" );
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.NextGame ( idx )

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    ObjSet( "obj_mgdescent2_rpl_back", { alp = 1, pos_y = 768 * ( private.game - 2 ) } );
    ObjSet( "anm_mgdescent2_rpl_move_"..private.game, { alp = 0 } );

    ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].items[ private.game ][ idx ] = true;
    private.game = private.game - 1;
    ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].game = private.game;
    ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item = nil;

    ObjSet( "anm_mgdescent2_rpl_back_"..private.game.."_static", { alp = 1 } );
    AnimPlay( "anm_mgdescent2_rpl_back_"..private.game.."_static", "DoAnim", "" );

  end;

  ObjSet( "obj_mgdescent2_rpl_back", { alp = 0 } );
  ObjSet( "anm_mgdescent2_rpl_back_"..private.game.."_static", { alp = 0 } );
  ObjSet( "anm_mgdescent2_rpl_move_"..private.game, { alp = 1 } );

  AnimStop( "anm_mgdescent2_rpl_back_"..private.game.."_static" );
  AnimPlay( "anm_mgdescent2_rpl_move_"..private.game, "DoAnim", func_end );

  cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgdescent2_down_"..private.game );

  --ObjAnimate( "obj_mgdescent2_rpl_back", "pos_y", 0, 0, func_end,
  --{
  --  0.0, 3, 768 * ( private.game - 1 ),
  --  2.0, 3, 768 * ( private.game - 2 ),
  --} );

end;
--*********************************************************************************************************************
function private.IsAllClick ()

  for s = 1, private.items_count[ private.game ] do

    if ( not private.items[ private.game ][ s ] ) then

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
function private.ItemClick ( idx_1, idx_2 )

  int.Lock( true );

  if ( not private.current_item ) then

    ObjAnimate( "spr_mgdescent2_rpl_items_"..private.game.."_light_"..idx_1.."_"..idx_2, "alp", 0, 0,
    function ()

      int.Lock( false );
      private.current_item = { idx_1, idx_2 };
      ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item = { idx_1, idx_2 };

    end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgdescent2_click" );

  elseif ( private.current_item[ 1 ] == idx_1 ) and ( private.current_item[ 2 ] == idx_2 ) then

    ObjAnimate( "spr_mgdescent2_rpl_items_"..private.game.."_light_"..idx_1.."_"..idx_2, "alp", 0, 0,
    function ()

      int.Lock( false );
      private.current_item = nil;
      ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item = nil;

    end,
    {
      0.0, 3, 1.0,
      0.3, 3, 0.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgdescent2_unclick" );

  else

    cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgdescent2_click" );

    --[[ if ( private.current_item[ 1 ] == idx_1 ) then

      cmn.PlayAudio( "sfx", "audio/level2/sfx/"..math.random( 1,3 ) );

    else

      cmn.PlayAudio( "sfx", "audio/level2/sfx/" );

    end; ]]

    ObjAnimate( "spr_mgdescent2_rpl_items_"..private.game.."_light_"..idx_1.."_"..idx_2, "alp", 0, 0,
    function ()

      if ( private.current_item[ 1 ] == idx_1 ) then

        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgdescent2_right" );

        ObjSet( "obj_mgdescent2_rpl_items_"..private.game.."_symbol_"..idx_1.."_"..idx_2, { input = false } );
        ObjSet( "obj_mgdescent2_rpl_items_"..private.game.."_symbol_"..private.current_item[ 1 ].."_"..private.current_item[ 2 ], { input = false } );

        ObjAnimate( "obj_mgdescent2_rpl_items_"..private.game.."_symbol_"..idx_1.."_"..idx_2, "alp", 0, 0,
        function ()

          int.Lock( false );
          private.items[ private.game ][ idx_1 ] = true;
          private.current_item = nil;

          if ( private.IsAllClick() ) then

            if ( private.game == 1 ) then

              private.WinAnim( idx_1 );

            else

              private.NextGame( idx_1 );

            end;

          else

            ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].items[ private.game ][ idx_1 ] = true;
            ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item = nil;

          end;

        end,
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
          1.0, 3, 0.0,
        } );

        ObjAnimate( "obj_mgdescent2_rpl_items_"..private.game.."_symbol_"..private.current_item[ 1 ].."_"..private.current_item[ 2 ], "alp", 0, 0, "",
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
        } );

        local name_1 = "anm_mgdescent2_rpl_items_"..private.game.."_symbol_"..private.current_item[ 1 ].."_1";
        local name_2 = "anm_mgdescent2_rpl_items_"..private.game.."_symbol_"..private.current_item[ 1 ].."_2";

        local params_1 = ObjGet( "obj_mgdescent2_rpl_items_"..private.game.."_symbol_"..private.current_item[ 1 ].."_1" );
        local params_2 = ObjGet( "obj_mgdescent2_rpl_items_"..private.game.."_symbol_"..private.current_item[ 1 ].."_2" );

        ObjCreate( name_1, "anim" );
        ObjCreate( name_2, "anim" );

        ObjAttach( name_1, "obj_mgdescent2_rpl_items_"..private.game );
        ObjAttach( name_2, "obj_mgdescent2_rpl_items_"..private.game );

        ObjSet( name_1,
        {
          res = "assets/levels/level2/mg_mgdescent2/anims/anm_brick_break",
          animfunc = "DoAnim",
          pos_x = params_1.pos_x,
          pos_y = params_1.pos_y,
        } );

        ObjSet( name_2,
        {
          res = "assets/levels/level2/mg_mgdescent2/anims/anm_brick_break",
          animfunc = "DoAnim",
          pos_x = params_2.pos_x,
          pos_y = params_2.pos_y,
        } );

        AnimPlay( name_1, "DoAnim", "" );
        AnimPlay( name_2, "DoAnim",
        function ()

          ObjDelete( name_1 );
          ObjDelete( name_2 );

        end );

      else

        cmn.PlayAudio( "sfx", "audio/level2/sfx/aud_mg_mgdescent2_wrong" );

        ObjAnimate( "spr_mgdescent2_rpl_items_"..private.game.."_light_"..idx_1.."_"..idx_2, "alp", 0, 0,
        function ()

          int.Lock( false );
          ObjSet( "obj_mgdescent2_rpl_items_"..private.game.."_symbol_"..private.current_item[ 1 ].."_"..private.current_item[ 2 ], { input = true } );
          private.current_item = nil;
          ng_global.progress[ private.currentprogress ][ "win_mgdescent2_rpl" ].current_item = nil;

        end,
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
        } );

        ObjAnimate( "spr_mgdescent2_rpl_items_"..private.game.."_light_"..private.current_item[ 1 ].."_"..private.current_item[ 2 ], "alp", 0, 0, "",
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
        } );

      end;

    end,
    {
      0.0, 3, 0.0,
      0.3, 3, 1.0,
    } );

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************