-- name=mg_mgdocument1_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgdocument1_rpl";
  game.relations[ "mg_mgdocument1_rpl" ].exitroom = "rm_replayroom";

  private.Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgdocument1_rpl = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgdocument1_rpl", update_game_mode_mgdocument1_rpl, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mgdocument1_rpl () end;
  --------------------------------------------------------------------------------------------
  local win_mgdocument1_rpl = function ()

    if ( cmn.IsEventStart( "win_mgdocument1_rpl" ) ) and not ( cmn.IsEventDone( "win_mgdocument1_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgdocument1_rpl", win_mgdocument1_rpl );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  if ( cmn.IsEventDone( "win_mgdocument1_rpl" ) ) then

    public.Reset();

    ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].start = 0;
    ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].done = 0;

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventStart( "win_mgdocument1_rpl" ) ) then    

    private.Start();

  elseif ( cmn.IsEventStart( "win_mgdocument1_rpl" ) ) then

    cmn.MiniGameShow( "mgdocument1_rpl" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_mgdocument1_rpl" ) ) and ( not cmn.IsEventDone( "win_mgdocument1_rpl" ) ) then

    cmn.MiniGameHide();

  end;

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].text = { 2,2,2,3,4 };
  ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].lamp = { 2,2,2,3,4 };
  ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].button = nil;

  private.text = { 2,2,2,3,4 };
  private.lamp = { 2,2,2,3,4 };

  if ( private.button ) then

    ObjSet( "spr_mgdocument1_rpl_button_"..private.button, { pos_y = 0 } );
    private.button = nil;

  end;

  private.SetTextSettings();
  private.LampLight( private.lamp, true );

  ObjSet( "obj_mgdocument1_rpl_arrows", { input = false } );

  ObjSet( "obj_mgdocument1_rpl_fakedocument1", { alp = 1 } );
  ObjSet( "anm_mgdocument1_rpl_test",          { alp = 1, frame = 0, animfunc = "DoAnim" } );
  ObjSet( "anm_mgdocument1_rpl_win",           { alp = 0, frame = 0, animfunc = "DoAnim" } );

end;
--*********************************************************************************************************************
function public.Skip ()

  private.text = { 1,1,2,2,1 };
  private.lamp = { 1,1,2,2,1 };
  private.SetTextSettings();

  private.WinAnim();

end;
--*********************************************************************************************************************
function private.Init ()

  private.buttons_count = 5;
  private.arrows_count  = 2;
  private.text = { 2,2,2,3,4 };
  private.lamp = { 2,2,2,3,4 };
  private.button = nil;
  private.settings =
  {
    { true, false }, -- italic
    { false, true }, -- capital
    { true, false }, -- bold
    { 30,27,24,21,18 }, -- size
    { { 134, 43,  5 },
      {  81,134,  5 },
      {   5,120,134 },
      { 120,  5,134 },
      {   5,  8,134 } },-- color
  };

  for s = 1, private.buttons_count do

    ObjSet( "spr_mgdocument1_rpl_button_"..s,
    {
      input = true,
      event_mdown  = function () private.ButtonClick( s ); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

  for s = 1, private.arrows_count do

    ObjSet( "obj_mgdocument1_rpl_arrows_"..s,
    {
      input = true,
      event_mdown  = function () private.ArrowClick( s ); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

  ObjSet( "obj_mgdocument1_rpl_button_assay",
  {
    input = true,
    event_mdown  = function () private.Assay(); end,
    event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
    event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
  } );

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].text = { 2,2,2,3,4 };
  ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].lamp = { 2,2,2,3,4 };
  ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].button = nil;
  cmn.MiniGameShow( "mgdocument1_rpl" );

end;
--*********************************************************************************************************************
function private.Load ()

  private.button = ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].button;

  for s = 1, private.buttons_count do

    private.text[ s ] = ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].text[ s ];
    private.lamp[ s ] = ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].lamp[ s ];

  end;

  private.SetTextSettings();

  if ( private.button ) then

    ObjSet( "spr_mgdocument1_rpl_button_"..private.button, { pos_y = 5 } );
    ObjSet( "obj_mgdocument1_rpl_arrows", { input = true } );

  end;

  private.LampLight( private.lamp, true );

end;
--*********************************************************************************************************************
function private.WinAnim()

  int.Lock( true );

  local func_end = function ()

    ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].text = { 1,1,2,2,1 };
    ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].lamp = { 1,1,2,2,1 };

    private.Win();
    int.Lock( false );

  end;

  ObjSet( "anm_mgdocument1_rpl_test",          { alp = 0 } );
  ObjSet( "obj_mgdocument1_rpl_fakedocument1", { alp = 0 } );
  ObjSet( "anm_mgdocument1_rpl_win",           { alp = 1 } );

  AnimPlay( "anm_mgdocument1_rpl_win", "DoAnim", func_end );
  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgdocument1_win" );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgdocument1_rpl" );
  cmn.CallEventHandler( "win_mgdocument1_rpl" );
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.ButtonClick ( idx )

  local tme = 0.3;

  local func_end = function ()

    int.Lock( false );

    if ( not private.button ) or ( private.button ~= idx ) then

      private.button = idx;
      ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].button = idx;
      ObjSet( "obj_mgdocument1_rpl_arrows", { input = true } );

    else

      private.button = nil;
      ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].button = nil;
      ObjSet( "obj_mgdocument1_rpl_arrows", { input = false } );

    end;

  end;

  int.Lock( true );

  if ( not private.button ) then

    ObjAnimate( "spr_mgdocument1_rpl_button_"..idx, "pos_y", 0, 0, func_end,
    {
      0.0, 3, 0.0,
      tme, 3, 5.0,
    } );

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgdocument1_click_button" );

  else

    if ( private.button == idx ) then

      ObjAnimate( "spr_mgdocument1_rpl_button_"..idx, "pos_y", 0, 0, func_end,
      {
        0.0, 3, 5.0,
        tme, 3, 0.0,
      } );

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgdocument1_unclick_button" );

    else

      ObjAnimate( "spr_mgdocument1_rpl_button_"..idx, "pos_y", 0, 0, func_end,
      {
        0.0, 3, 0.0,
        tme, 3, 5.0,
      } );

      ObjAnimate( "spr_mgdocument1_rpl_button_"..private.button, "pos_y", 0, 0, "",
      {
        0.0, 3, 5.0,
        tme, 3, 0.0,
      } );

      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgdocument1_click_button" );
      cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgdocument1_unclick_button" );

    end;

  end;

end;
--*********************************************************************************************************************
function private.ArrowClick ( idx )

  local property_1 = private.text[ private.button ];
  local property_2 = private.text[ private.button ];

  if ( idx == 2 ) then

    property_2 = property_1 + 1;

    if ( property_2 > #private.settings[ private.button ] ) then

      property_2 = 1;

    end;

  else

    property_2 = property_1 - 1;

    if ( property_2 <= 0 ) then

      property_2 = #private.settings[ private.button ];

    end;

  end;

  private.text[ private.button ] = property_2;
  ng_global.progress[ private.currentprogress ][ "win_mgdocument1_rpl" ].text[ private.button ] = property_2;

  private.SetTextSettings();

  ObjAnimate( "spr_mgdocument1_rpl_arrow_"..idx.."_light", "alp", 0, 0, "",
  {
    0.0, 3, 1.0,
    0.2, 3, 1.0,
    0.2, 3, 0.0,
  } );

  cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgdocument1_click_arrow" );

end;
--*********************************************************************************************************************
function private.SetTextSettings ()

  local font = "assets/fonts/times";
  local is_bold = private.settings[ 3 ][ private.text[ 3 ] ];
  local is_italic = private.settings[ 1 ][ private.text[ 1 ] ];

  if ( is_italic ) then

    font = "assets/fonts/times";

  end;

  local is_capital = private.settings[ 2 ][ private.text[ 2 ] ];

  if ( is_capital ) then

    ObjSet( "txt_mgdocument1_rpl_fakedocument1", { res = font, text = "str_mgdocument1_fakedocument1_2" } );

  else

    ObjSet( "txt_mgdocument1_rpl_fakedocument1", { res = font, text = "str_mgdocument1_fakedocument1_1" } );

  end;

  ObjSet( "txt_mgdocument1_rpl_fakedocument1", { display_outline = false } );

  local color = private.settings[ 5 ][ private.text[ 5 ] ];

  ObjSet( "txt_mgdocument1_rpl_fakedocument1",
  {
    fontcolor_r = 1 / 256 * color[ 1 ],
    fontcolor_g = 1 / 256 * color[ 2 ],
    fontcolor_b = 1 / 256 * color[ 3 ],
  } );

  if ( is_bold ) then

    ObjSet( "txt_mgdocument1_rpl_fakedocument1",
    {
      display_outline = true,
      outline_color_r = 1 / 256 * color[ 1 ],
      outline_color_g = 1 / 256 * color[ 2 ],
      outline_color_b = 1 / 256 * color[ 3 ],
    } );

  end;

  local size = private.settings[ 4 ][ private.text[ 4 ] ];

  ObjSet( "txt_mgdocument1_rpl_fakedocument1", { fontsize = size } );

end;
--*********************************************************************************************************************
function private.Assay ()

  private.LampLight( private.lamp, false );

  local func_end = function ()

    private.LampLight( private.text, true );

  end;

  if ( private.IsWin() ) then

    private.WinAnim();

  else

    cmn.PlayAudio( "sfx", "audio/level1/sfx/aud_mg_mgdocument1_click_test_wrong" );
    AnimPlay( "anm_mgdocument1_rpl_test", "DoAnim", func_end );

  end;

end;
--*********************************************************************************************************************
function private.LampLight ( array, is_show )

  local text_win = { 1,1,2,2,1 };

  for s = 1, private.buttons_count do

    ObjSet( "spr_mgdocument1_rpl_lamp_"..s, { alp = 0 } );

    if ( is_show ) and ( array[ s ] == text_win[ s ] ) then

      ObjSet( "spr_mgdocument1_rpl_lamp_"..s, { alp = 1 } );

    end;

    private.lamp[ s ] = array[ s ];
    ng_global.progress[ ng_global.currentprogress ][ "win_mgdocument1_rpl" ].lamp[ s ] = array[ s ];

  end;

end;
--*********************************************************************************************************************
function private.IsWin ()

  local text_win = { 1,1,2,2,1 };

  for s = 1, private.buttons_count do

    if ( private.text[ s ] ~= text_win[ s ] ) then

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************