-- name=mg_mgfight3_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgfight3_rpl";
  game.relations[ "mg_mgfight3_rpl" ].exitroom = "rm_replayroom";

  private.Init();
  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgfight3_rpl = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;

  cmn.AddSubscriber( "update_game_mode_mgfight3_rpl", update_game_mode_mgfight3_rpl, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_mgfight3_rpl () end;
  --------------------------------------------------------------------------------------------
  local win_mgfight3_rpl = function ()

    if ( cmn.IsEventStart( "win_mgfight3_rpl" ) ) and not ( cmn.IsEventDone( "win_mgfight3_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgfight3_rpl", win_mgfight3_rpl );

end;
--*********************************************************************************************************************
function public.PreOpen () 

  if ( cmn.IsEventDone( "win_mgfight3_rpl" ) ) then

    public.Reset();

    ng_global.progress[ private.currentprogress ][ "win_mgfight3_rpl" ].start = 0;
    ng_global.progress[ private.currentprogress ][ "win_mgfight3_rpl" ].done = 0;

  end;

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.Open ()

  if ( not cmn.IsEventStart( "win_mgfight3_rpl" ) ) then    

    private.Start();

  elseif ( cmn.IsEventStart( "win_mgfight3_rpl" ) ) then

    cmn.MiniGameShow( "mgfight3_rpl" );

  end;

  if ( not private.is_start ) and
     ( not cmn.IsEventDone( "win_mgfight3_rpl" ) ) then

    private.is_start = true;
    private.SymbolsInit();

  end;

  --cmn.StopAllMus();
  --cmn.StopAllEnv();
  --common_impl.StopMusEnv( false );

  --cmn.PlayAudio( "mus", "audio/level1/mus/aud_action_fight_1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_mgfight3_rpl" ) ) and ( not cmn.IsEventDone( "win_mgfight3_rpl" ) ) then

    cmn.MiniGameHide();

  end;
--
--  cmn.StopAudio( "mus", "audio/level1/mus/aud_action_fight_1_mus", 1, 0.5 );

end;
--*********************************************************************************************************************
function public.Reset ()

  ng_global.progress[ ng_global.currentprogress ][ "win_mgfight3_rpl" ].hero_health  = 6;
  ng_global.progress[ ng_global.currentprogress ][ "win_mgfight3_rpl" ].enemy_health = 6;

  private.is_start = false;
  private.enemy_health = 6;
  private.hero_health  = 6;
  private.current_symbol = nil;
  private.symbols = { { 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },
                      { 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false }, };
  private.pairs_found = 0;

  ObjSet( "tmr_mgfight3_rpl_search",  { playing = false } );
  ObjSet( "obj_mgfight3_rpl_symbols", { alp = 0, input = false } );

  ObjSet( "spr_mgfight3_rpl_health_enemy", { pos_x = 0 } );
  ObjSet( "spr_mgfight3_rpl_health_hero",  { pos_x = 0 } );

  ObjSet( "anm_mgfight3_rpl_counter",        { playing = false } );
  ObjSet( "anm_mgfight3_rpl_hero_attack",    { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_hero_damage",    { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_enemy_attack",   { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_enemy_damage",   { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_symbols_attack", { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );

  ObjSet( "anm_mgfight3_rpl_hero_static",    { alp = 1, frame = 0, animfunc = "DoAnim", playing = true } );
  ObjSet( "anm_mgfight3_rpl_enemy_static",   { alp = 1, frame = 0, animfunc = "DoAnim", playing = true } );
  ObjSet( "anm_mgfight3_rpl_symbols_static", { alp = 1, frame = 0, animfunc = "DoAnim", playing = true } );

  private.SymbolsInit();

--  cmn.StopAudio( "sfx", "audio/level3/sfx/aud_mg_mgfight3_loop_beatles" );

end;
--*********************************************************************************************************************
function public.Skip ()

  ObjSet( "tmr_mgfight3_rpl_search", { playing = false } );

  int.Lock( true );

  local func_end = function ()

    private.WinAnim();

  end;

  ObjAnimate( "obj_mgfight3_rpl_symbols", "alp", 0, 0, func_end,
  {
    0.0, 3, ObjGet( "obj_mgfight3_rpl_symbols" ).alp,
    0.5, 3, 0.0,
  } );

  ObjSet( "anm_mgfight3_rpl_counter",        { playing = false } );
  ObjSet( "anm_mgfight3_rpl_hero_attack",    { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_hero_damage",    { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_enemy_attack",   { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_symbols_static", { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_symbols_attack", { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );
  ObjSet( "anm_mgfight3_rpl_enemy_damage",   { alp = 0, frame = 0, animfunc = "DoAnim", playing = false } );

  ObjSet( "anm_mgfight3_rpl_hero_static",   { alp = 1, frame = 0, animfunc = "DoAnim", playing = true } );
  ObjSet( "anm_mgfight3_rpl_enemy_static",  { alp = 1, frame = 0, animfunc = "DoAnim", playing = true } );

end;
--*********************************************************************************************************************
function private.Init ()

  private.stack = { 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18 };
  private.symbols_count = 18;
  private.enemy_health = 6;
  private.hero_health  = 6;
  private.current_symbol = nil;
  private.search_tme = 14;
  private.is_start = false;
  private.symbols = { { 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },
                      { 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false }, };
  private.pairs_found = 0;

  for s = 1, private.symbols_count do

    ObjSet( "obj_mgfight3_rpl_symbol_"..s,
    {
      input        = true,
      event_mdown  = function () private.SymbolClick( s ); end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ ng_global.currentprogress ][ "win_mgfight3_rpl" ].hero_health  = 6;
  ng_global.progress[ ng_global.currentprogress ][ "win_mgfight3_rpl" ].enemy_health = 6;
  cmn.MiniGameShow( "mgfight3_rpl" );

end;
--*********************************************************************************************************************
function private.Load ()

  private.enemy_health = ng_global.progress[ ng_global.currentprogress ][ "win_mgfight3_rpl" ].enemy_health;
  private.hero_health  = ng_global.progress[ ng_global.currentprogress ][ "win_mgfight3_rpl" ].hero_health;

  ObjSet( "spr_mgfight3_rpl_health_enemy", { pos_x = -1 * ( 6 - private.enemy_health ) * ( 264 / 6 ) } );
  ObjSet( "spr_mgfight3_rpl_health_hero",  { pos_x = ( 6 - private.hero_health ) * ( 264 / 6 ) } );

end;
--*********************************************************************************************************************
function private.WinAnim()

  int.Lock( true );

  local func_end = function ()

    private.Win();
    int.Lock( false );

  end;

  func_end();

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgfight3_rpl" );
  cmn.CallEventHandler( "win_mgfight3_rpl" );
  cmn.GotoRoom( "rm_replayroom" );  

end;
--*********************************************************************************************************************
function private.SymbolsInit ()

  private.is_start = true;
  private.SymbolsSetDefault();

  local stack = {};
  local position = {};
  private.current_symbol = nil;
  private.symbols = { { 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },
                      { 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false },{ 0,false }, };
  private.pairs_found = 0;

  for c = 1, 3 do

    ObjSet( "spr_mgfight3_rpl_counter_light_"..c, { alp = 0 } );

  end;

  for s = 1, #private.stack do

    table.insert( stack, private.stack[ s ] );
    table.insert( position, private.stack[ s ] );

  end;

  for s = 1, private.symbols_count / 2 do

    local smb = math.random( #stack );

    local pos_1 = math.random( #position );
    private.symbols[ position[ pos_1 ] ][ 1 ] = stack[ smb ];

    ObjSet( "spr_mgfight3_rpl_symbol_"..position[ pos_1 ],           { res = "assets/levels/level3/mg_mgfight3/layers/symbols/symbol"..stack[ smb ] } );
    ObjSet( "spr_mgfight3_rpl_symbol_"..position[ pos_1 ].."_light", { res = "assets/levels/level3/mg_mgfight3/layers/symbols/symbol"..stack[ smb ].."_light", alp = 0 } );

    table.remove( position, pos_1 );

    local pos_2 = math.random( #position );
    private.symbols[ position[ pos_2 ] ][ 1 ] = stack[ smb ];

    ObjSet( "spr_mgfight3_rpl_symbol_"..position[ pos_2 ],           { res = "assets/levels/level3/mg_mgfight3/layers/symbols/symbol"..stack[ smb ] } );
    ObjSet( "spr_mgfight3_rpl_symbol_"..position[ pos_2 ].."_light", { res = "assets/levels/level3/mg_mgfight3/layers/symbols/symbol"..stack[ smb ].."_light", alp = 0 } );

    table.remove( position, pos_2 );
    table.remove( stack, smb );

  end;

  private.SymbolsShow();

  private.DbgTrace(
    private.symbols[ 1 ][ 1 ]..", "..private.symbols[ 2 ][ 1 ]..", "..private.symbols[ 3 ][ 1 ]..", "..
    private.symbols[ 4 ][ 1 ]..", "..private.symbols[ 5 ][ 1 ]..", "..private.symbols[ 6 ][ 1 ]..", "..
    private.symbols[ 7 ][ 1 ]..", "..private.symbols[ 8 ][ 1 ]..", "..private.symbols[ 9 ][ 1 ]..", "..
    private.symbols[ 10 ][ 1 ]..", "..private.symbols[ 11 ][ 1 ]..", "..private.symbols[ 12 ][ 1 ]..", "..
    private.symbols[ 13 ][ 1 ]..", "..private.symbols[ 14 ][ 1 ]..", "..private.symbols[ 15 ][ 1 ]..", "..
    private.symbols[ 16 ][ 1 ]..", "..private.symbols[ 17 ][ 1 ]..", "..private.symbols[ 18 ][ 1 ] );

end;
--*********************************************************************************************************************
function private.SymbolsShow ()

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );
    ObjSet( "obj_mgfight3_rpl_symbols", { input = true } );

  end;

  ObjAnimate( "obj_mgfight3_rpl_symbols", "alp", 0, 0, func_end,
  {
    0.0, 3, 0.0,
    0.5, 3, 0.7,
  } );

  ObjSet( "anm_mgfight3_rpl_symbols_static", { alp = 1, frame = 0, animfunc = "DoAnim" } );
  AnimPlay( "anm_mgfight3_rpl_symbols_static", "DoAnim", "" );

  ObjSet( "tmr_mgfight3_rpl_search",
  {
    playing = true,
    time = private.search_tme,
    endtrig = function ()

      local func_end = function ()

        int.Lock( false );

        private.SymbolsHide( false );

        ObjSet( "anm_mgfight3_rpl_enemy_attack",   { alp = 0, frame = 0, animfunc = "DoAnim" } );
        ObjSet( "anm_mgfight3_rpl_symbols_attack", { alp = 0, frame = 0, animfunc = "DoAnim" } );
        ObjSet( "anm_mgfight3_rpl_hero_damage",    { alp = 0, frame = 0, animfunc = "DoAnim" } );
        ObjSet( "anm_mgfight3_rpl_enemy_static",   { alp = 1, frame = 0, animfunc = "DoAnim" } );
        ObjSet( "anm_mgfight3_rpl_hero_static",    { alp = 1, frame = 0, animfunc = "DoAnim" } );

        AnimStop( "anm_mgfight3_rpl_enemy_attack" );
        AnimStop( "anm_mgfight3_rpl_symbols_attack" );
        AnimPlay( "anm_mgfight3_rpl_enemy_static", "DoAnim", "" );

        AnimStop( "anm_mgfight3_rpl_hero_damage" );
        AnimPlay( "anm_mgfight3_rpl_hero_static", "DoAnim", "" );

      end;

      int.Lock( true );

      ObjSet( "anm_mgfight3_rpl_counter", { playing = false } );
      ObjSet( "anm_mgfight3_rpl_enemy_static",   { alp = 0, frame = 0, animfunc = "DoAnim" } );
      ObjSet( "anm_mgfight3_rpl_symbols_static", { alp = 0, frame = 0, animfunc = "DoAnim" } );
      ObjSet( "anm_mgfight3_rpl_enemy_attack",   { alp = 1, frame = 0, animfunc = "DoAnim" } );
      ObjSet( "anm_mgfight3_rpl_symbols_attack", { alp = 1, frame = 0, animfunc = "DoAnim" } );
      ObjSet( "anm_mgfight3_rpl_hero_static",    { alp = 0, frame = 0, animfunc = "DoAnim" } );
      ObjSet( "anm_mgfight3_rpl_hero_damage",    { alp = 1, frame = 0, animfunc = "DoAnim" } );

      AnimStop( "anm_mgfight3_rpl_enemy_static" );
      AnimStop( "anm_mgfight3_rpl_symbols_static" );
      AnimPlay( "anm_mgfight3_rpl_enemy_attack", "DoAnim", func_end );
      AnimPlay( "anm_mgfight3_rpl_symbols_attack", "DoAnim", "" );

      AnimStop( "anm_mgfight3_rpl_hero_static" );
      AnimPlay( "anm_mgfight3_rpl_hero_damage", "DoAnim", "" );
      
      cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfught3_shot_us" );

    end,
  } );

  private.CounterUpdate();

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfught3_appears" );

end;
--*********************************************************************************************************************
function private.SymbolsHide ( is_win )

  int.Lock( true );

  local func_end = function ()

    int.Lock( false );

    ObjSet( "obj_mgfight3_rpl_symbols", { input = false } );

    if ( is_win ) then

      private.EnemyHeal( -1 );

    else

      private.HeroHeal( -1, true );

    end;

  end;

  ObjSet( "tmr_mgfight3_rpl_search", { playing = false } );

  ObjAnimate( "obj_mgfight3_rpl_symbols", "alp", 0, 0, func_end,
  {
    0.0, 3, 0.7,
    0.5, 3, 0.0,
  } );

  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfught3_diss" );

end;
--*********************************************************************************************************************
function private.SymbolClick ( idx )

  local symbol = private.symbols[ idx ][ 1 ];

  private.DbgTrace( "Символ = "..tostring( symbol ) );

  int.Lock( true );

  local func_end = function ()

    private.symbols[ idx ][ 2 ] = true;

    int.Lock( false );

    ObjSet( "obj_mgfight3_rpl_symbol_"..idx, { input = false } );

    if ( not private.current_symbol ) then

      private.DbgTrace( "Первый клик" );

      private.current_symbol = symbol;
      return;

    end;

    if ( symbol ~= private.current_symbol ) then

      private.DbgTrace( "Символы не совпадают" );
      private.SymbolsSetDefault( symbol );

      return;

    else

      private.pairs_found = private.pairs_found + 1;
      private.current_symbol = nil;

      ObjSet( "spr_mgfight3_rpl_counter_light_"..private.pairs_found, { alp = 1 } );

       cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfught3_right" );
       
      if ( private.pairs_found == 3 ) then

        private.DbgTrace( "Нашли три пары символов" );

        local func_end = function ()

          int.Lock( false );

          ObjSet( "anm_mgfight3_rpl_enemy_damage",    { alp = 0, frame = 0, animfunc = "DoAnim" } );
          ObjSet( "anm_mgfight3_rpl_enemy_static",    { alp = 1, frame = 0, animfunc = "DoAnim" } );
          ObjSet( "anm_mgfight3_rpl_symbols_static",  { alp = 1, frame = 0, animfunc = "DoAnim" } );
          ObjSet( "anm_mgfight3_rpl_hero_attack",     { alp = 0, frame = 0, animfunc = "DoAnim" } );
          ObjSet( "anm_mgfight3_rpl_hero_static",     { alp = 1, frame = 0, animfunc = "DoAnim" } );

          AnimStop( "anm_mgfight3_rpl_enemy_damage" );
          AnimPlay( "anm_mgfight3_rpl_enemy_static", "DoAnim", "" );
          AnimPlay( "anm_mgfight3_rpl_symbols_static", "DoAnim", "" );

          AnimStop( "anm_mgfight3_rpl_hero_attack" );
          AnimPlay( "anm_mgfight3_rpl_hero_static", "DoAnim", "" );

          private.SymbolsHide( true );

        end;

        int.Lock( true );

        ObjSet( "tmr_mgfight3_rpl_search",  { playing = false } );
        ObjSet( "anm_mgfight3_rpl_counter", { playing = false } );

        ObjSet( "anm_mgfight3_rpl_enemy_static",    { alp = 0, frame = 0, animfunc = "DoAnim" } );
        ObjSet( "anm_mgfight3_rpl_symbols_static",  { alp = 0, frame = 0, animfunc = "DoAnim" } );
        ObjSet( "anm_mgfight3_rpl_enemy_damage",    { alp = 1, frame = 0, animfunc = "DoAnim" } );
        ObjSet( "anm_mgfight3_rpl_hero_static",     { alp = 0, frame = 0, animfunc = "DoAnim" } );
        ObjSet( "anm_mgfight3_rpl_hero_attack",     { alp = 1, frame = 0, animfunc = "DoAnim" } );

        AnimStop( "anm_mgfight3_rpl_enemy_static" );
        AnimStop( "anm_mgfight3_rpl_symbols_static" );
        AnimPlay( "anm_mgfight3_rpl_enemy_damage", "DoAnim", "" );

        AnimStop( "anm_mgfight3_rpl_hero_static" );
        AnimPlay( "anm_mgfight3_rpl_hero_attack", "DoAnim", func_end );

         cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfught3_right" );

      end;

    end;

  end;

  if ( private.current_symbol ) and
     ( symbol ~= private.current_symbol ) then

    ObjSet( "spr_mgfight3_rpl_symbol_"..idx.."_light", { blendmode = 0 } );
    --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfight3_wrong_click_obgect" );

  else

    ObjSet( "spr_mgfight3_rpl_symbol_"..idx.."_light", { blendmode = 2 } );
    --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfight3_click_obgect_"..math.random( 1,3 ) );

  end;

  ObjAnimate( "spr_mgfight3_rpl_symbol_"..idx.."_light", "alp", 0, 0, func_end,
  {
    0.0, 3, 0.0,
    0.3, 3, 1.0,
  } );

   cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfught3_click" );
end;
--*********************************************************************************************************************
function private.SymbolsSetDefault ( symbol )

  private.DbgTrace( "Сброс кликов" );

  if ( symbol ) then

    int.Lock( true );

    local func_end = function ()

      int.Lock( false );
      private.current_symbol = nil;

    end;

    for s = 1, private.symbols_count do

      if ( symbol == private.symbols[ s ][ 1 ] ) and ( private.symbols[ s ][ 2 ] ) then

        ObjAnimate( "spr_mgfight3_rpl_symbol_"..s.."_light", "alp", 0, 0,
        function ()

          ObjSet( "obj_mgfight3_rpl_symbol_"..s, { input = true } );
          private.symbols[ s ][ 2 ] = false;

        end,
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
        } );

      end;

      if ( private.current_symbol == private.symbols[ s ][ 1 ] ) and ( private.symbols[ s ][ 2 ] ) then

        ObjAnimate( "spr_mgfight3_rpl_symbol_"..s.."_light", "alp", 0, 0,
        function ()

          ObjSet( "obj_mgfight3_rpl_symbol_"..s, { input = true } );
          private.symbols[ s ][ 2 ] = false;

        end,
        {
          0.0, 3, 1.0,
          0.3, 3, 0.0,
        } );

      end;

    end;

    ObjSet( "tmr_mgfight3_rpl_anims",
    {
      playing = true,
      time = 0.3,
      endtrig = func_end,
    } );

  else

    for s = 1, private.symbols_count do

      ObjSet( "spr_mgfight3_rpl_symbol_"..s.."_light", { alp = 0 } );
      ObjSet( "obj_mgfight3_rpl_symbol_"..s, { input = true } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.HeroHeal ( delta_health, is_show )

  local func_end = function ()

    ng_global.progress[ ng_global.currentprogress ][ "win_mgfight3_rpl" ].hero_health = private.hero_health;

    if ( private.hero_health == 0 ) then

      public.Reset();

    else

      if ( is_show ) then

        private.SymbolsInit();

      end;

    end;

  end;

  int.Lock( true );

  local pos_x1 = ( 6 - private.hero_health ) * ( 264 / 6 );
  local pos_x2 = ( 7 - private.hero_health ) * ( 264 / 6 );

  ObjAnimate( "spr_mgfight3_rpl_health_hero", "pos_x", 0, 0, func_end,
  {
    0.0, 3, pos_x1,
    0.3, 3, pos_x2,
  } );

  --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfight3_life_dissaperas" );

  private.hero_health = private.hero_health + delta_health;

end;
--*********************************************************************************************************************
function private.EnemyHeal ( delta_health )

  local func_end = function ()

    if ( private.enemy_health == 0 ) then

      private.WinAnim();

    else

      ng_global.progress[ ng_global.currentprogress ][ "win_mgfight3_rpl" ].enemy_health = private.enemy_health;

      private.SymbolsInit();

    end;

  end;

  int.Lock( true );

  ObjAnimate( "spr_mgfight3_rpl_health_enemy_"..( 7 - private.enemy_health ), "alp", 0, 0, func_end,
  {
    0.0, 3, 1.0,
    0.3, 3, 0.0,
  } );

  local pos_x1 = -1 * ( 6 - private.enemy_health ) * ( 264 / 6 );
  local pos_x2 = -1 * ( 7 - private.enemy_health ) * ( 264 / 6 );

  ObjAnimate( "spr_mgfight3_rpl_health_enemy", "pos_x", 0, 0, func_end,
  {
    0.0, 3, pos_x1,
    0.3, 3, pos_x2,
  } );

  private.enemy_health = private.enemy_health + delta_health;

  --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgfight3_life_dissapears_monster" );

end;
--*********************************************************************************************************************
function private.CounterUpdate ()

  ObjSet( "anm_mgfight3_rpl_counter", { frame = 0, animfunc = "DoAnim" } );
  AnimPlay( "anm_mgfight3_rpl_counter", "DoAnim", "" );

end;
--*********************************************************************************************************************
function private.DbgTrace( txt )

  --DbgTrace( txt );

end;
--*********************************************************************************************************************
function private.InitAnimations ()

  local fight_pos = { 99,296,356,114,310,207,53,175,412,56,491,78,261,309,56,520,417,178 };

  for s = 1, private.symbols_count do

    local way = 1;
    local value = math.random( 1, 100 );
    local tme   = math.random( 10, 25 ) / 10;

    if ( value > 50 ) then

      way = -1;

    end;

    ObjAnimate( "obj_mgfight3_rpl_symbol_"..s, "pos_y", 1, 0, "",
    {
      0.0,       3, fight_pos[ s ],
      tme,       3, fight_pos[ s ] + 3 * way,
      tme + tme, 3, fight_pos[ s ],
    } );

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************