-- name=mg_mgkeys3_rpl
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_mgkeys3_rpl";
  game.relations[ "mg_mgkeys3_rpl" ].exitroom = "rm_replayroom";

  private.Init();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mgkeys3_rpl = function ()

    local table_multiset = {};

    local visible_sparkle_area = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
      visible_sparkle_area = false;
    end;

    local visible_sparkle_ho = true;
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 
    {
      private.room_objname
    };
    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_mgkeys3_rpl", update_game_mode_mgkeys3_rpl, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function opn_mgkeys3_rpl () end;
  --------------------------------------------------------------------------------------------
  local opn_mgkeys3_rpl = function ()

  end;

  cmn.AddSubscriber( "opn_mgkeys3_rpl", opn_mgkeys3_rpl, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_mgkeys3_rpl () end;
  --------------------------------------------------------------------------------------------
  local win_mgkeys3_rpl = function ()

    if ( cmn.IsEventStart( "win_mgkeys3_rpl" ) ) and not ( cmn.IsEventDone( "win_mgkeys3_rpl" ) ) then

      private.Load();

    end;

  end;

  cmn.AddSubscriber( "win_mgkeys3_rpl", win_mgkeys3_rpl );

end;
--*********************************************************************************************************************
function public.Load () 

  private.currentprogress = ng_global.currentprogress;

end;
--*********************************************************************************************************************
function public.PreOpen () 

  if ( cmn.IsEventDone( "win_mgkeys3_rpl" ) ) then

    public.Reset();

    ng_global.progress[ private.currentprogress ][ "win_mgkeys3_rpl" ].start = 0;
    ng_global.progress[ private.currentprogress ][ "win_mgkeys3_rpl" ].done = 0;

  end;

end;
--*********************************************************************************************************************
function public.Open ()

  if not ( cmn.IsEventDone( "opn_mgkeys3_rpl" ) ) then

    cmn.SetEventDone( "opn_mgkeys3_rpl" );
    cmn.CallEventHandler( "opn_mgkeys3_rpl" );

  end;

  if ( not cmn.IsEventStart( "win_mgkeys3_rpl" ) ) then    

    private.Start();

  elseif ( cmn.IsEventStart( "win_mgkeys3_rpl" ) ) then

    cmn.MiniGameShow( "mgkeys3_rpl" );

  end;

end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_mgkeys3_rpl" ) ) and ( not cmn.IsEventDone( "win_mgkeys3_rpl" ) ) then

    cmn.MiniGameHide();

  end;

end;
--*********************************************************************************************************************
function public.Reset ()

  if ( private.lock_prev ~= 0 ) then

    ObjSet( "spr_mgkeys3_rpl_key_"..private.lock_prev.."_light", { alp = 0 } );
    private.lock_prev = 0;

  end;

  private.SetInput();

  ng_global.progress[ private.currentprogress ][ "win_mgkeys3_rpl" ].lock = { 5,8,1,12,10,4,6,2,3,11,9,7 };
  private.Load();

  ObjSet( "obj_mgkeys3_rpl_keys_1", { pos_y = 0 } );
  ObjSet( "obj_mgkeys3_rpl_keys_2", { pos_y = 0 } );

  for c = 1, private.lock_count / 2 do

    ObjAttach( "obj_mgkeys3_rpl_key_"..c, "obj_mgkeys3_rpl_keys_2" );

  end;

end;
--*********************************************************************************************************************
function public.Skip ()

  int.Lock( true );

  for c = 1, private.lock_count do

    local lock_pos = private.GetPos( c );

    ObjAnimate( "obj_mgkeys3_rpl_key_"..c, "pos_xy", 0, 0, "",
    {
      0.0, 3, private.lock_pos[ lock_pos ][ 1 ], private.lock_pos[ lock_pos ][ 2 ],
      0.5, 3, private.lock_win_pos[ c ][ 1 ],    private.lock_win_pos[ c ][ 2 ],
    } );

    ObjAnimate( "obj_mgkeys3_rpl_key_"..c, "ang", 0, 0, "",
    {
      0.0, 3, ObjGet( "obj_mgkeys3_rpl_key_"..c ).ang,
      0.5, 3, 0.0,
    } );

  end;

  cmn.WaitAndRun( private.WinAnim, 1.0 );

end;
--*********************************************************************************************************************
function private.Init ()

  private.lock_count   = 12;
  private.lock_items   = { 5,8,1,12,10,4,6,2,3,11,9,7 };
  private.lock_win     = { 1,2,3,4,5,6,7,8,9,10,11,12 };
  private.lock_pos     = { { 202,228 }, { 327,228 }, { 450,227 }, { 574,227 },
                           { 699,225 }, { 822,227 }, { 203,507 }, { 326,506 },
                           { 449,504 }, { 575,507 }, { 701,507 }, { 824,504 } };
  private.lock_win_pos = { { 202,228 }, { 327,228 }, { 450,227 }, { 574,227 },
                           { 699,225 }, { 822,227 }, { 203,507 }, { 326,506 },
                           { 449,504 }, { 575,507 }, { 701,507 }, { 824,504 } };
  private.lock_links   = { { 1,2,7 }, { 1,2,3,8 }, { 2,3,4,9 }, { 3,4,5,10 }, { 4,5,6,11 }, { 5,6,12 },
                           { 1,7,8 }, { 2,7,8,9 }, { 3,8,9,10 }, { 4,9,10,11 }, { 5,10,11,12 }, { 6,11,12 } };
  private.lock_prev    = 0;

  for c = 1, private.lock_count do

    ObjSet( "obj_mgkeys3_rpl_key_"..c,
    {
      input        = true,
      event_mdown  = function () private.Click( c ) end,
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      inputrect_init = true,
      inputrect_x = -60,
      inputrect_y = -50,
      inputrect_w = 120,
      inputrect_h = 100,
    } );

  end;

end;
--*********************************************************************************************************************
function private.Start ()

  ng_global.progress[ private.currentprogress ][ "win_mgkeys3_rpl" ].lock = { 5,8,1,12,10,4,6,2,3,11,9,7 };
  cmn.MiniGameShow( "mgkeys3_rpl" );

end;
--*********************************************************************************************************************
function private.Load ()

  for c = 1, private.lock_count do

    private.lock_items[ c ] = ng_global.progress[ private.currentprogress ][ "win_mgkeys3_rpl" ].lock[ c ];

    ObjSet( "obj_mgkeys3_rpl_key_"..private.lock_items[ c ],
    { 
      pos_x = private.lock_pos[ c ][ 1 ],
      pos_y = private.lock_pos[ c ][ 2 ],
    } );

    local lock_pos = private.GetPos( private.lock_items[ c ] );

    if ( ( private.lock_items[ c ] < 7 ) and ( lock_pos < 7 ) ) or
       ( ( private.lock_items[ c ] > 6 ) and ( lock_pos > 6 ) ) then

      ObjSet( "obj_mgkeys3_rpl_key_"..private.lock_items[ c ], { ang = 0 } );

    else

      ObjSet( "obj_mgkeys3_rpl_key_"..private.lock_items[ c ], { ang = 3.14 } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.WinAnim()

  int.Lock( true );

  local func_end = function ()

    ng_global.progress[ private.currentprogress ][ "win_mgkeys3_rpl" ].lock = { 1,2,3,4,5,6,7,8,9,10,11,12 };
    private.Win();
    int.Lock( false );

  end;

  for c = 1, private.lock_count / 2 do

    ObjAttach( "obj_mgkeys3_rpl_key_"..c, "obj_mgkeys3_rpl_keys_1" );

  end;

  
  cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgkeys3_win" );
  ObjAnimate( "obj_mgkeys3_rpl_keys_1", "pos_y", 0, 0, func_end,
  {
    0.0, 3,  0,
    1.0, 3, 50,
    1.5, 3, 50,
  } );

  ObjAnimate( "obj_mgkeys3_rpl_keys_2", "pos_y", 0, 0, "",
  {
    0.0, 3,   0,
    1.0, 3, -50,
  } );

end;
--*********************************************************************************************************************
function private.Win ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_mgkeys3_rpl" );
  cmn.CallEventHandler( "win_mgkeys3_rpl" );
  cmn.GotoRoom( "rm_replayroom" );

end;
--*********************************************************************************************************************
function private.GetPos ( idx )

  for c = 1, private.lock_count do

    if ( idx == private.lock_items[ c ] ) then

      return c;

    end;

  end;

end;
--*********************************************************************************************************************
function private.SetInput ( idx )

  if ( idx ) then

    for c = 1, private.lock_count do

      ObjSet( "obj_mgkeys3_rpl_key_"..c, { input = false } );

    end;

    local lock_pos = private.GetPos( idx );

    for c = 1, #private.lock_links[ lock_pos ] do

      local lock = private.lock_items[ private.lock_links[ lock_pos ][ c ] ];

      ObjSet( "obj_mgkeys3_rpl_key_"..lock, { input = true } );

    end;

  else

    for c = 1, private.lock_count do

      ObjSet( "obj_mgkeys3_rpl_key_"..c, { input = true } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.Click ( idx )

  int.Lock( true );    

  local func_end = function ()

    int.Lock( false );      

    ObjSet( "obj_mgkeys3_rpl_key_"..idx,               { pos_z = 5 } );
    ObjSet( "obj_mgkeys3_rpl_key_"..private.lock_prev, { pos_z = 5 } );

    private.lock_items[ private.lock_pos_1 ] = private.lock_prev;
    private.lock_items[ private.lock_pos_2 ] = idx;

    private.lock_prev = 0;

    if ( private.IsWin() ) then

      private.WinAnim();

    end;

    private.SetInput();

  end;

  if ( private.lock_prev == 0 ) then

    private.lock_prev = idx;
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgkeys3_click" );
    ObjAnimate( "spr_mgkeys3_rpl_key_"..idx.."_light", "alp", 0, 0,
    function ()

      int.Lock( false );
      private.SetInput( idx );

    end, 
    {
      0.0, 0, 0.0,
      0.2, 0, 1.0,
    } );

  elseif ( private.lock_prev == idx ) then

    private.lock_prev = 0;
    
    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgkeys3_unclick" );
    ObjAnimate( "spr_mgkeys3_rpl_key_"..idx.."_light", "alp", 0, 0,
    function ()

      int.Lock( false );
      private.SetInput();

    end, 
    {
      0.0, 0, 1.0,
      0.2, 0, 0.0,
    } );

  else

    --local rnd = math.random( 3 );
    --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_keys_change_metal_pieces_"..rnd );

    ObjAnimate( "spr_mgkeys3_rpl_key_"..idx.."_light", "alp", 0, 0, "", 
    {
      0.0, 0, 0.0,
      0.2, 0, 1.0,
      0.4, 0, 0.0,
    } );

    ObjAnimate( "spr_mgkeys3_rpl_key_"..private.lock_prev.."_light", "alp", 0, 0, "", 
    {
      0.0, 0, 1.0,
      0.2, 0, 1.0,
      0.4, 0, 0.0,
    } );

    ObjSet( "obj_mgkeys3_rpl_key_"..idx,               { pos_z = 8 } );
    ObjSet( "obj_mgkeys3_rpl_key_"..private.lock_prev, { pos_z = 8 } );

    private.lock_pos_1 = private.GetPos( idx );
    private.lock_pos_2 = private.GetPos( private.lock_prev );

    cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mg_mgkeys3_change_objects" );
    ObjAnimate( "obj_mgkeys3_rpl_key_"..idx, "pos_xy", 0, 0, func_end, 
    {
      0.0, 0, private.lock_pos[ private.lock_pos_1 ][ 1 ], private.lock_pos[ private.lock_pos_1 ][ 2 ],
      0.2, 0, private.lock_pos[ private.lock_pos_1 ][ 1 ], private.lock_pos[ private.lock_pos_1 ][ 2 ],
      0.6, 0, private.lock_pos[ private.lock_pos_2 ][ 1 ], private.lock_pos[ private.lock_pos_2 ][ 2 ],
    } );

    ObjAnimate( "obj_mgkeys3_rpl_key_"..private.lock_prev, "pos_xy", 0, 0, "", 
    {
      0.0, 0, private.lock_pos[ private.lock_pos_2 ][ 1 ], private.lock_pos[ private.lock_pos_2 ][ 2 ],
      0.2, 0, private.lock_pos[ private.lock_pos_2 ][ 1 ], private.lock_pos[ private.lock_pos_2 ][ 2 ],
      0.6, 0, private.lock_pos[ private.lock_pos_1 ][ 1 ], private.lock_pos[ private.lock_pos_1 ][ 2 ],
    } );

    if ( math.abs( private.lock_pos_1 - private.lock_pos_2 ) > 1 ) then

      local ang_1_start = 3.14;
      local ang_1_end   = 0.00;
      local ang_2_start = 3.14;
      local ang_2_end   = 0.00;

      if ( ( idx < 7 ) and ( private.lock_pos_1 < 7 ) ) or
         ( ( idx > 6 ) and ( private.lock_pos_1 > 6 ) ) then

        ang_1_start = 0.00;
        ang_1_end = 3.14;

      end;

      if ( ( private.lock_prev < 7 ) and ( private.lock_pos_2 < 7 ) ) or
         ( ( private.lock_prev > 6 ) and ( private.lock_pos_2 > 6 ) ) then

        ang_2_start = 0.00;
        ang_2_end = 3.14;

      end;

      ObjAnimate( "obj_mgkeys3_rpl_key_"..idx, "ang", 0, 0, "", 
      {
        0.0, 0, ang_1_start,
        0.2, 0, ang_1_start,
        0.6, 0, ang_1_end,
      } );

      ObjAnimate( "obj_mgkeys3_rpl_key_"..private.lock_prev, "ang", 0, 0, "", 
      {
        0.0, 0, ang_2_start,
        0.2, 0, ang_2_start,
        0.6, 0, ang_2_end,
      } );

    end;

  end;

  --local rnd = math.random( 3 );
  --cmn.PlayAudio( "sfx", "audio/level3/sfx/aud_mmg_keys_ckick_"..rnd );

end;
--*********************************************************************************************************************
function private.IsWin ()
  
  for c = 1, private.lock_count do

    local lock = private.lock_items[ c ];

    if ( lock ~= private.lock_win[ c ] ) then

      for k = 1, private.lock_count do

        ng_global.progress[ private.currentprogress ][ "win_mgkeys3_rpl" ].lock[ k ] = private.lock_items[ k ];

      end;

      return false;

    end;

  end;

  return true;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************