-- name=rm_replayroom
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_replayroom";

  private.mgs = {
    {  1, "/mg/mgassault1",       "mg_mgassault1_rpl" },    -- num, path to screen, module
    {  2, "/mg/mgtime1",          "mg_mgtime1_rpl" },
    {  3, "/mg/mgdocument1",      "mg_mgdocument1_rpl" },
    {  4, "/mg/mgdescent2",       "mg_mgdescent2_rpl" },
    {  5, "/mg/mgcatacomb2",      "mg_mgcatacomb2_rpl" },
    {  6, "/mg/mgcreatingacid2",  "mg_mgcreatingacid2_rpl" },
    {  7, "/mg/mglock2",          "mg_mglock2_rpl" },
    {  8, "/mg/mgkeys3",          "mg_mgkeys3_rpl" },
    {  9, "/mg/mgcrowd3",         "mg_mgcrowd3_rpl" },
    { 10, "/mg/mgfight3",         "mg_mgfight3_rpl" },
    { 11, "/mg/mg_mgcrystals",    "mg_mgcrystals_rpl" },
    { 12, "/mg/mg_mgdominoes",    "mg_mgdominoes_rpl" },
    { 13, "/mg/mg_mgwitch",       "mg_mgwitch_rpl" },
  };
  private.hos = {
    {  1, "/ho/hovan1",           "ho_hovan1_rpl" },        -- num, path to screen, module
    {  2, "/ho/hotable1",         "ho_hotable1_rpl" },
    {  3, "/ho/howardrobe1",      "ho_howardrobe1_rpl" },
    {  4, "/ho/hosafe1",          "ho_hosafe1_rpl" },
    {  5, "/ho/hoskeleton2",      "ho_hoskeleton2_rpl" },
    {  6, "/ho/hosecretsection2", "ho_hosecretsection2_rpl" },
    {  7, "/ho/hocupboard2",      "ho_hocupboard2_rpl" },
    {  8, "/ho/hopast2",          "ho_hopast2_rpl" },
    {  9, "/ho/hotreasury3",      "ho_hotreasury3_rpl" },
    { 10, "/ho/hocardindex3",     "ho_hocardindex3_rpl" },
    { 11, "/ho/horepair3",        "ho_horepair3_rpl" },
    { 12, "/ho/hoalchemybox3",    "ho_hoalchemybox3_rpl" },
    --{ 13, "/ho/ho_hosafe",        "ho_ho_hosafe_rpl" },
    --{ 14, "/ho/ho_hotable",       "ho_ho_hotable_rpl" },
    --{ 15, "/ho/ho_hogargoyle",    "ho_ho_hogargoyle_rpl" },
    --{ 16, "/ho/ho_homagiccube",   "ho_ho_homagiccube_rpl" },
  };

  private.mg_num = 1;
  private.ho_num = 1;
  private.cur_scr = "mg";

  ObjMultiSet(
  {
    { "obj_replayroom_button_play", {
      event_menter = function () private.BtnEnter( "play" ); end,
      event_mleave = function () private.BtnLeave( "play" ); end,
      event_mdown =  function () private.OpenTask(); end,
    } },
    { "obj_replayroom_button_screen", {
      event_menter = function () cmn.SetCursor( CURSOR_HAND ); end,
      event_mleave = function () cmn.SetCursor( CURSOR_DEFAULT ); end,
      event_mdown =  function () private.OpenTask(); end,
    } },
    { "obj_replayroom_button_prev", {
      event_menter = function () private.BtnEnter( "prev" ); end,
      event_mleave = function () private.BtnLeave( "prev" ); end,
      event_mdown =  function () private.ChangeNum( -1 ); end,
    } },
    { "obj_replayroom_button_next", {
      event_menter = function () private.BtnEnter( "next" ); end,
      event_mleave = function () private.BtnLeave( "next" ); end,
      event_mdown =  function () private.ChangeNum( 1 ); end,
    } },
    { "obj_replayroom_button_mgs", {
      event_menter = function () private.BtnEnter( "mgs" ); end,
      event_mleave = function () private.BtnLeave( "mgs" ); end,
      event_mdown =  function () private.SwitchType( "mg" ); end,
    } },
    { "obj_replayroom_button_hos", {
      event_menter = function () private.BtnEnter( "hos" ); end,
      event_mleave = function () private.BtnLeave( "hos" ); end,
      event_mdown =  function () private.SwitchType( "ho" ); end,
    } },
    { "obj_replayroom_button_exit", {
      event_menter = function () private.BtnEnter( "exit" ); end,
      event_mleave = function () private.BtnLeave( "exit" ); end,
      event_mdown =  function () public.ExitRoom(); end,
    } },
    { "spr_replayroom_screen_mg", {
      res = "assets/levels/levelrpl/rm_replayroom/layers"..private.mgs[ private.mg_num ][ 2 ]
    } },
    { "spr_replayroom_screen_ho", {
    res = "assets/levels/levelrpl/rm_replayroom/layers"..private.hos[ private.ho_num ][ 2 ]
    } },
  } );

  private.Anims();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_replayroom = function ()

  local table_multiset = {};
  local visible_sparkle_area = true;
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then
    visible_sparkle_ho = false;
  end;
  local gates =
  {
    --"gzz_",
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_replayroom", update_game_mode_replayroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_replayroom = function ()

  local effects_table = 
  {
    --"obj_replayroom_anim" 
  };

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_replayroom", update_performance_mode_replayroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_replayroom () end;
  --------------------------------------------------------------------------------------------
  local opn_replayroom = function ()

    if cmn.IsEventDone( "opn_replayroom" ) then

      private.Load();

    end;

  end;
  cmn.AddSubscriber( "opn_replayroom", opn_replayroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function beg_levelrpl () end;
  --------------------------------------------------------------------------------------------
  local beg_levelrpl = function ()

  end;
  cmn.AddSubscriber( "beg_levelrpl", beg_levelrpl, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open()

  cmn.StopAllMus();
  cmn.StopAllEnv();
  cmn.PlayAudio( "mus", "audio/aud_location_theme_mus", 1 );

end;
--*********************************************************************************************************************
function public.PreOpen()

  interface.WidgetSetInput( InterfaceWidget_BtnHint, false );

  if ( not cmn.IsEventDone( "opn_replayroom" ) ) then

    ng_global.progress[ "rpl" ][ "opn_replayroom" ].mg_num = 1;
    ng_global.progress[ "rpl" ][ "opn_replayroom" ].ho_num = 1;
    ng_global.progress[ "rpl" ][ "opn_replayroom" ].cur_scr = "mg";

    cmn.SetEventDone( "opn_replayroom" );

  end;

  levelrpl.InventoryDisable();  

end;
--*********************************************************************************************************************
function public.Close()


end;
--*********************************************************************************************************************
function public.PreClose()

  levelrpl.InventoryDisable("close");

  --cmn.StopAudio( "mus", "common/audio/aud_adventure1_mus", 1 );
  

end;
--*********************************************************************************************************************
function private.Load ()

  private.mg_num  = ng_global.progress[ "rpl" ][ "opn_replayroom" ].mg_num;
  private.ho_num  = ng_global.progress[ "rpl" ][ "opn_replayroom" ].ho_num;
  private.cur_scr = ng_global.progress[ "rpl" ][ "opn_replayroom" ].cur_scr;

  ObjSet( "spr_replayroom_screen_mg", { res = "assets/levels/levelrpl/rm_replayroom/layers"..private.mgs[ private.mg_num ][ 2 ] } );
  ObjSet( "spr_replayroom_screen_ho", { res = "assets/levels/levelrpl/rm_replayroom/layers"..private.hos[ private.ho_num ][ 2 ] } );

  if ( private.cur_scr == "mg" ) then

    ObjSet( "txt_replayroom_counter",    { text = private.mg_num.."/"..tostring( #private.mgs ) } );
    ObjSet( "spr_replayroom_screen_mg",  { alp = 1 } );
    ObjSet( "spr_replayroom_screen_ho",  { alp = 0 } );

  elseif ( private.cur_scr == "ho" ) then

    ObjSet( "txt_replayroom_counter",    { text = private.ho_num.."/"..tostring( #private.hos ) } );
    ObjSet( "spr_replayroom_screen_mg",  { alp = 0 } );
    ObjSet( "spr_replayroom_screen_ho",  { alp = 1 } );

  end;

end;
--*********************************************************************************************************************
function private.OpenTask()

  int.Lock( false );
  common_impl.StopMusEnv();
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  
  common_impl.PlayMusEnv();
  
  if ( private.cur_scr == "mg" ) then

    cmn.GotoRoom( private.mgs[ private.mg_num ][ 3 ], 1, true );
    interface.WidgetSetVisible( InterfaceWidget_BtnGuide, true );  
    interface.WidgetSetInput( InterfaceWidget_BtnGuide, true ); 

  elseif ( private.cur_scr == "ho" ) then 

    if ( cmn.IsEventDone( "win_"..string.sub( private.hos[ private.ho_num ][ 3 ], 4 ) ) ) then

      _G[ private.hos[ private.ho_num ][ 3 ] ].ResetHO();
      ObjDelete( private.hos[ private.ho_num ][ 3 ] );
      ModLoad( string.format( "assets/levels/levelrpl/%s/mod_%s", private.hos[ private.ho_num ][ 3 ], string.sub( private.hos[ private.ho_num ][ 3 ], 4 ) ) );
      _G[ private.hos[ private.ho_num ][ 3 ] ].Init();
      _G[ private.hos[ private.ho_num ][ 3 ] ].Load();

    end;

    cmn.GotoRoom( private.hos[ private.ho_num ][ 3 ], 1, true ); 

  end;

end;
--*********************************************************************************************************************
function public.ExitRoom()
  common_impl.StopMusEnv();
  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  SaveProfiles();
  SaveSettings();

  SetCursor( CURSOR_DEFAULT );

  --ng_global.is_rpl = true;

  ObjSet( "int_inventory", { input = true } );

  common.LevelSwitch( "menu", "game" );

end;
--******************************************************************************************
function private.Anims ()

end;
--******************************************************************************************
function private.BtnEnter ( btn )
  
  cmn.SetCursor( CURSOR_HAND );
  ObjAnimate( "spr_replayroom_button_"..btn.."_focus", "alp", 0, 0, "", 
  {
    0.0,0,ObjGet( "spr_replayroom_button_"..btn.."_focus" ).alp,
    0.2,0,1
  } );
  
end;
--******************************************************************************************
function private.BtnLeave ( btn )

  cmn.SetCursor( CURSOR_DEFAULT );
  ObjAnimate( "spr_replayroom_button_"..btn.."_focus", "alp", 0, 0, "", 
  {
    0.0,0,ObjGet( "spr_replayroom_button_"..btn.."_focus" ).alp,
    0.2,0,0
  } );

end;
--******************************************************************************************
function private.SwitchType ( tpe )

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  if ( tpe ~= private.cur_scr ) then

    int.Lock( true );

    if ( private.cur_scr == "mg" ) then

      ObjAnimate( "txt_replayroom_counter", "alp", 0, 0,
      function ()

        ObjSet( "txt_replayroom_counter", { text = private.ho_num.."/"..tostring( #private.hos ) } );

      end,
      {
        0.00, 3, 1.0,
        0.25, 3, 1.0,
      } );

      ObjAnimate( "spr_replayroom_screen_ho", "alp", 0, 0,
      function ()

        int.Lock( false );

      end,
      {
        0.0,3,0.0,
        0.3,3,1.0,
      } );

      ObjAnimate( "spr_replayroom_screen_mg", "alp", 0, 0, "",
      {
        0.0,3,1.0,
        0.3,3,0.0,
      } );

      private.cur_scr = "ho";

    elseif ( private.cur_scr == "ho" ) then

      ObjAnimate( "txt_replayroom_counter", "alp", 0, 0,
      function ()

        ObjSet( "txt_replayroom_counter", { text = private.mg_num.."/"..tostring( #private.mgs ) } );

      end,
      {
        0.00, 3, 1.0,
        0.25, 3, 1.0,
      } );

      ObjAnimate( "spr_replayroom_screen_ho", "alp", 0, 0,
      function ()

        int.Lock( false );

      end,
      {
        0.0,3,1.0,
        0.3,3,0.0,
      } );

      ObjAnimate( "spr_replayroom_screen_mg", "alp", 0, 0, "",
      {
        0.0,3,0.0,
        0.3,3,1.0,
      } );

      private.cur_scr = "mg";

    end;

    ng_global.progress[ "rpl" ][ "opn_replayroom" ].cur_scr = private.cur_scr;

  end;

end; 
--******************************************************************************************
function private.ChangeNum ( val )

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );
  
  if ( private.cur_scr == "mg" ) then

    if ( private.mg_num == #private.mgs ) and ( val == 1 ) then
      private.mg_num = 1;
    elseif ( private.mg_num == 1 ) and ( val == -1 ) then
      private.mg_num = #private.mgs;
    else
      private.mg_num = private.mg_num + val;
    end;

    ObjSet( "spr_replayroom_screen_mg", { res = "assets/levels/levelrpl/rm_replayroom/layers"..private.mgs[ private.mg_num ][ 2 ] } );
    ObjSet( "txt_replayroom_counter", { text = private.mg_num.."/"..tostring( #private.mgs ) } );

    ng_global.progress[ "rpl" ][ "opn_replayroom" ].mg_num = private.mg_num;

  elseif ( private.cur_scr == "ho" ) then
    
    if ( private.ho_num == #private.hos ) and ( val == 1 ) then
      private.ho_num = 1;
    elseif ( private.ho_num == 1 ) and ( val == -1 ) then
      private.ho_num = #private.hos;
    else
      private.ho_num = private.ho_num + val;
    end;

    ObjSet( "spr_replayroom_screen_ho", { res = "assets/levels/levelrpl/rm_replayroom/layers"..private.hos[ private.ho_num ][ 2 ] } );
    ObjSet( "txt_replayroom_counter", { text = private.ho_num.."/"..tostring( #private.hos ) } );

    ng_global.progress[ "rpl" ][ "opn_replayroom" ].ho_num = private.ho_num;

  end;

end;
--******************************************************************************************