-- name=levelscr

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );
  interface.WidgetAdd( InterfaceWidget_BtnMenu, 20 );
  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.ButtonLockAdd();
  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog, 26 );
  interface.WidgetAdd( InterfaceWidget_Window );
  interface.WidgetAdd( InterfaceWidget_Tutorial, 30 );
  int.DialogHintAdd( 10 );
  interface.IntTaskpanelScrAdd( 5 );
  interface.IntMorphScrAdd( 5 );
  interface.IntTimerScrAdd( 5 );
  interface.IntDialogScrAdd( 21 );
  
  interface.AchievementsAdd( 18 );

  cmn.SecretroomInit();
  private.Init(); 

  common.LevelLoad( "levelscr", "scr", "rm_neartower_scr", param, private.menu_moduls );
  cmn.MorphingSecretLoad();
  private.TutorialSetParams();

  int_timer_scr.SetTimer();
  int_taskpanel_scr.UpdateAchievpanel();

  ng_global.secret.game = false;

end;
    
function private.Init ()

  game = {};
  game.room_names =  {
     "rm_lab_scr"
    ,"rm_neartower_scr"
    ,"rm_tower_scr"
    ,"rm_towerroof_scr"
  };

   game.progress_names_room =
  {
     { "opn_lab_scr" }
    ,{ "opn_neartower_scr" }
    ,{ "opn_tower_scr" }
    ,{ "opn_towerroof_scr" }

    ,{ "get_device_scr" }
    ,{ "get_mask_scr" }
    ,{ "get_book_scr" }
    ,{ "get_statuette_scr" }
    ,{ "get_bottle_scr" }
    ,{ "get_skull_scr" }
    
  };

  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      
      "rm_achievements"
    }

    for i = 1, #menu_moduls_ce do

      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );

    end;

  end;



end;
-------------------------------------------------
function private.TutorialSetParams ()

  if not ng_global.progress[ "scr" ][ "see_tutorial_scr" ] then

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ] = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].done  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].start = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state = {};
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.no  = 0;
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].func = function()
      --
    end;

    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );      

    end;

    ng_global.progress[ "scr" ][ "see_tutorial_scr" ].state.pages = {

      [ "tutorial_page_1_scr" ] = { shown = 0, noskip = true, posx = 512, posy = 200, input = true, arrows = { } }, -- о начале сикретрума

      [ "tutorial_page_2_scr" ] = { shown = 0, noskip = false, posx = 550, posy = 380, input = true, arrows = {
                                                                                    { pos_x = 220, pos_y = 50, ang =  1.3, target = "obj_int_morph_scr" }
                                                                                  } } , -- что искать и сколько искать
      [ "tutorial_page_3_scr" ] = { shown = 0, noskip = false, posx = 500, posy = 450, input = true, arrows = {
                                                                                    { pos_x = 800, pos_y = 570, ang =  -2.1, target = "int_timer_scr" }
                                                                                  } } , -- показать на таймер
      [ "tutorial_page_4_scr" ] = { shown = 0, noskip = false, posx = 512, posy = 384, input = true, arrows = {
                                                                                    { pos_x = 350, pos_y = 550, ang =  2.9 },
                                                                                    { pos_x = 650, pos_y = 550, ang =  -2.9 }
                                                                                  } } , -- показать на панель ачивок и прогресса
      [ "tutorial_page_5_scr" ] = { shown = 0, noskip = false, posx = 550, posy = 380, input = true, arrows = {
                                                                                    { pos_x = 220, pos_y = 50, ang =  1.3, target = "obj_int_morph_scr" }
                                                                                  } } , -- показать, что становится серым когда взяли все предметы в этой локи
      [ "tutorial_page_6_scr" ] = { shown = 0, noskip = false, posx = 512, posy = 384, input = true, arrows = {
                                                                                    { pos_x = 512, pos_y = 550, ang =  3.14 }
                                                                                  } } , -- показать на прогресс бар после первого этапа сикретрума

    };

  end;

end;