-- name=rm_collectibles
--******************************************************************************************
function public.Init()

  private.collectibles = {};
  private.collectibles.current_big = { 0, 0 };
  private.collectibles.animtime = 0.4;

  private.collectibles.TMP_POS = {};
  private.collectibles.TMP_POS.X = 0;
  private.collectibles.TMP_POS.Y = 0;
  private.collectibles.POPUP_ANIM_FLY = 0.4;

  local table_multiset = {};

  for i = 1, 4 do

    for j = 1, 4 do

      --private.MorphAnimation( i, j );

      table.insert( table_multiset, { "obj_collectibles_collect_"..i.."_"..j, 
         {
           event_mdown  = function() private.MouseDownSmall( i, j ); end ,
           event_menter = function() private.MouseEnter( CURSOR_LOUPE, i, j ); end ,
           event_mleave = function() private.MouseLeave( CURSOR_DEFAULT, i, j ) end,
           event_menter = function() private.PopupShow( i, j ); end ,
           event_mleave = function() private.PopupHide() end             
         } 
      } );

    end;

  end;  

  table.insert( table_multiset, { "obj_collectibles_btn_exit",
    { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "collectibles_btn_exit" ) end, 
      event_mleave = function() private.BtnMouseLeave( "collectibles_btn_exit" ) end;
    } 
  } );

  table.insert( table_multiset, { "obj_collectibles_btn_exit_2",
    { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "collectibles_btn_exit_2" ) end, 
      event_mleave = function() private.BtnMouseLeave( "collectibles_btn_exit_2" ) end;
    } 
  } );
  
  ObjMultiSet( table_multiset );

  if ( ng_global[ "collect" ] == nil ) then

     ng_global[ "collect" ] = {};

  end;

end;
--******************************************************************************************
--******************************************************************************************
function public.PreOpen ()

  common_impl.InterfaceSetVisible( false );  

--  local current_room = common.GetCurrentRoom();
--  if ( current_room ) then
--
--    int.Lock( false );--разблокировка для карты EE
--
--  end;
  
  private.Update();

end;
--******************************************************************************************
function public.Open ()

  cmn.StopAllMus();
  cmn.StopAllEnv();
  
  cmn.StopAllEnv( "audio/level1/env/aud_collectibles_env", true );
  cmn.PlayAudio( "env", "audio/level1/env/aud_collectibles_env", 1 );       
  int.Lock(false);
end;
--******************************************************************************************
--******************************************************************************************
function public.Close ()

  common_impl.InterfaceSetVisible( true ); 
 
  if cmn.IsFromMap then

    cmn.IsFromMap = false;
    ObjSet( "int_map", { input = true, visible = true, alp = 1 });

  end;      

  cmn.GotoRoom( ng_global.achievements.previous_room, 0, true );

end;
--******************************************************************************************
--******************************************************************************************
function private.Update ()

  local prg   = ng_global.currentprogress;
  local level = ng_global.progress[ prg ].common.chapter;
  local lvl   = string.sub(level,6);

  if ( lvl == "ext" or lvl == "scr" ) then

    lvl = 4

  end;
  
  for i = 1, 4 do

      for j = 1, 4 do

          local name_collect = "collect_"..i.."_"..j;
          
     --ng_global[ "collect" ][ name_collect ] = {};
     --ng_global[ "collect" ][ name_collect ].done = 1;
     
              if ( ng_global[ "collect" ][ name_collect ] ~= nil ) then

                  if ( ng_global[ "collect" ][ name_collect ].done == 1 ) then

                    ObjSet( "obj_collectibles_collect_"..i.."_"..j, { alp = 1, active = true, input = true } );

                  else 

                    ObjSet( "obj_collectibles_collect_"..i.."_"..j, { alp = 0, active = false, input = false  } );

                  end;

              end;

      end;

  end;

end;
--******************************************************************************************
function private.BtnMouseEnter ( type_cursor, name )

  if type_cursor then
    
    SetCursor( type_cursor );
    
  else 
    
    SetCursor( CURSOR_DEFAULT );
    
  end;
  
  if GetPerformanceMode() == 0 then

    name = "pfx_"..name.."_focus";

  else

    name = "spr_"..name.."_focus";

  end;

  local alp = ObjGet( name ).alp;

  ObjAnimate( name, "alp", 0, 0, "", { 0, 0, alp, ( private.collectibles.animtime * ( 1 - alp ) ), 0, 1 } );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
--******************************************************************************************
function private.BtnMouseLeave ( name )

  SetCursor( CURSOR_DEFAULT );

  if GetPerformanceMode() == 0 then

    name = "pfx_"..name.."_focus";

  else

    name = "spr_"..name.."_focus";

  end;

  local alp = ObjGet( name ).alp;

  ObjAnimate( name, "alp", 0, 0, "", { 0, 1, alp, ( private.collectibles.animtime * alp ), 1, 0 } );
  cmn.PlayAudio( "sfx", "audio/aud_menter" );

end;
--******************************************************************************************
function private.MouseEnter ( type_cursor, i, j )

  if type_cursor then
    
    SetCursor( type_cursor );
    
  else 
    
    SetCursor( CURSOR_DEFAULT );
    
  end;

  local tme = private.collectibles.POPUP_ANIM_FLY;
  
  --private.MouseDownSmall( i, j );

  if ( type_cursor ~= CURSOR_DOWN ) then

     cmn.PlayAudio( "sfx", "audio/aud_menter" );
  
  end;

end;
--******************************************************************************************
function private.MouseLeave ( type_cursor, i, j )

  SetCursor( CURSOR_DEFAULT );

  local tme = private.collectibles.POPUP_ANIM_FLY;

end;
--******************************************************************************************
--port.
function public.Hide()
  private.BtnCloseMouseDown(); --  public. or private.
end;
--******************************************************************************************
function private.BtnCloseMouseDown ()

  cmn.PlayAudio("sfx", "audio/aud_click_menu_closedoor");

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  

  if ( private.collectibles.current_big[ 1 ] == 0 ) then

      cmn.GotoRoom( ng_global.achievements.previous_room, nil, true );

  else 

      local idx1 = private.collectibles.current_big[ 1 ];
      local idx2 = private.collectibles.current_big[ 2 ];

      private.MouseDownPopup ( idx1, idx2 );

  end;

end;
--******************************************************************************************
function private.MouseDownSmall ( i, j )

  --cmn.ShowBbt( "str_collect_"..i.."_"..j.."_say" );
  
  local func_end = function ()
  
    --ObjSet( "rm_collectibles", { input = true } );
    ObjSet( "obj_collectibles_collect_"..i.."_"..j, { input = true } );
   
  end;

  ObjSet( "obj_collectibles_collect_"..i.."_"..j, { input = false } );
  AnimPlay( "anm_collectibles_collect_"..i.."_"..j, "DoAnim", func_end  );

end;
--******************************************************************************************
function private.MouseDownPopup ( i, j )

end;
--******************************************************************************************
function private.MorphAnimation ( idx1, idx2 )

  local tme = math.random( 5,10 );

  ObjAnimate( "spr_collectibles_collect_"..idx1.."_"..idx2.."a", "alp", 1, 0, "",
  {
    0.0,                   3, 0.0,
    tme,                   3, 0.0,
    tme + 2.0,             3, 1.0,
    tme + 2.0 + tme,       3, 1.0,
    tme + 2.0 + tme + 2.0, 3, 0.0,
  } );

end;
--******************************************************************************************
--******************************************************************************************
--function --**POPUP**-- () end;
--******************************************************************************************

function private.PopupShow( idx1, idx2 )

  cmn.SetCursor( CURSOR_LOUPE );
  
  --local title = "str_collect_"..idx1.."_"..idx2.."_name";
  --local description = "str_collect_"..idx1.."_"..idx2.."_say";
  private.WindowShow( idx1, idx2 );  

end;
--------------------------------------------------------------------------------------------
function private.PopupHide() 

  private.WindowHide();  
  cmn.SetCursor( CURSOR_DEFAULT );

end;
--******************************************************************************************
--function --**Dialog**-- () end;
--******************************************************************************************
function private.WindowShow( idx1, idx2 )

  local dialog_text_title = "str_collect_"..idx1.."_"..idx2.."_name";
  local dialog_text = "str_collect_"..idx1.."_"..idx2.."_say";
  local obj_collect = "obj_collectibles_collect_"..idx1.."_"..idx2;

  local game_cursor = ObjGet( obj_collect );
  dialog_pos_x = game_cursor.pos_x;
  dialog_pos_y = game_cursor.pos_y + 150;

  ObjSet( "txt_collectibles_window_title", { text = dialog_text_title } );
  ObjSet( "txt_collectibles_window", { text = dialog_text } );

  private.GRID_CORNER_W =  58;
  private.GRID_CORNER_H =  58;
  private.GRID_MID_W    =   4;
  private.GRID_MID_H    =   4;

  private.GRID_BORDER_W = 100;
  private.GRID_BORDER_H = 100;

  private.MIN_W = 370;
  private.MAX_W = 500;
  private.MIN_H = 150;
  private.MAX_H = 500;

  private.WindowShow_ANIM_TIME = 0.3;

  local off_x = private.GRID_BORDER_W;
  local off_y = private.GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_collectibles_window" ).draw_width + off_x;

  if ( dialog_w < private.MIN_W ) then

    dialog_w = private.MIN_W;

  elseif ( dialog_w > private.MAX_W ) then

    dialog_w = private.MAX_W;

  end;

  local dialog_h = ObjGet( "txt_collectibles_window" ).draw_height + off_y;

  if ( dialog_h < private.MIN_H ) then

    dialog_h = private.MIN_H;

  elseif ( dialog_h > private.MAX_H ) then
  
    dialog_h = private.MAX_H;

  end;

  local offset = 50;
  if ( dialog_pos_x < 171 ) then

    dialog_pos_x = 171 ;
  
  elseif ( dialog_pos_x > GetAppWidth() - 171 ) then

    dialog_pos_x = GetAppWidth() - 171;

  end;
  
  local grid_corner_w = private.GRID_CORNER_W;
  local grid_corner_h = private.GRID_CORNER_H;

  local grid_mid_w = private.GRID_MID_W;
  local grid_mid_h = private.GRID_MID_H;

  interface.FrameGridSet( "collectibles_window",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  ObjSet( "obj_collectibles_window",
  {
    active = true, visible = true,
    pos_x = dialog_pos_x, pos_y = dialog_pos_y
  } );

  local event_id = "show";
  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_collectibles_window", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

  local pos_x = - dialog_w / 2 + 19;
  local pos_y = dialog_h / 2 - 42;

  ObjSet( "txt_collectibles_window_title", { pos_y = - pos_y } );
  ObjSet( "txt_collectibles_window",       { pos_y = pos_y / 4 } );

end;
--******************************************************************************************
--function private.WindowShow( dialog_text_title, dialog_text )
--
--  local game_cursor = GetZoomCursorPos();
--  dialog_pos_x = game_cursor[ 1 ];
--  dialog_pos_y = game_cursor[ 2 ];
--
--  ObjSet( "txt_collectibles_window_title", { text = dialog_text_title } );
--  ObjSet( "txt_collectibles_window", { text = dialog_text } );
--
--  private.GRID_CORNER_W =  58;
--  private.GRID_CORNER_H =  58;
--  private.GRID_MID_W    =   4;
--  private.GRID_MID_H    =   4;
--
--  private.GRID_BORDER_W = 100;
--  private.GRID_BORDER_H = 100;
--
--  private.MIN_W = 370;
--  private.MAX_W = 500;
--  private.MIN_H = 150;
--  private.MAX_H = 500;
--
--  private.WindowShow_ANIM_TIME = 0.3;
--
--  local off_x = private.GRID_BORDER_W;
--  local off_y = private.GRID_BORDER_H;
--
--  local dialog_w = ObjGet( "txt_collectibles_window" ).draw_width + off_x;
--
--  if ( dialog_w < private.MIN_W ) then
--
--    dialog_w = private.MIN_W;
--
--  elseif ( dialog_w > private.MAX_W ) then
--
--    dialog_w = private.MAX_W;
--
--  end;
--
--  local dialog_h = ObjGet( "txt_collectibles_window" ).draw_height + off_y;
--
--  if ( dialog_h < private.MIN_H ) then
--
--    dialog_h = private.MIN_H;
--
--  elseif ( dialog_h > private.MAX_H ) then
--  
--    dialog_h = private.MAX_H;
--
--  end;
--
--  local offset = 50;
--  if ( dialog_pos_x < 171 ) then
--
--    dialog_pos_x = 171 ;
--  
--  elseif ( dialog_pos_x > GetAppWidth() - 171 ) then
--
--    dialog_pos_x = GetAppWidth() - 171;
--
--  end;
--  
--  dialog_pos_y = dialog_pos_y - dialog_h/2;
--  if ( dialog_pos_y - dialog_h < 0 ) then
--
--    dialog_pos_y = dialog_h / 2;
--
--  end;
--
--  local grid_corner_w = private.GRID_CORNER_W;
--  local grid_corner_h = private.GRID_CORNER_H;
--
--  local grid_mid_w = private.GRID_MID_W;
--  local grid_mid_h = private.GRID_MID_H;
--
--  interface.FrameGridSet( "collectibles_window",
--  {
--    grid_w   = dialog_w,
--    grid_h   = dialog_h,
--    corner_w = grid_corner_w,
--    corner_h = grid_corner_h,
--    mid_w    = grid_mid_w,
--    mid_h    = grid_mid_h
--  } );
--
--  ObjSet( "obj_collectibles_window",
--  {
--    active = true, visible = true,
--    pos_x = dialog_pos_x, pos_y = dialog_pos_y
--  } );
--
--  local event_id = "show";
--  
--  local trg = function () private.EventAnimEnd( event_id ); end;
--  local tme = private.WindowShow_ANIM_TIME;
--
--  ObjAnimate( "obj_collectibles_window", "alp", 0, 0, trg,
--  {
--    0.0, 2, 0,
--    tme, 2, 1
--  } );
--
--  local pos_x = - dialog_w / 2 + 19;
--  local pos_y = dialog_h / 2 - 42;
--
--  ObjSet( "txt_collectibles_window_title", { pos_y = - pos_y } );
--  ObjSet( "txt_collectibles_window",       { pos_y = pos_y / 4 } );
--
--end;
--******************************************************************************************
function private.WindowHide( )
  
  ObjSet( "obj_collectibles_window", { input = false } );

  local event_id = "hide";  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_collectibles_window", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
  
  ObjSet( "obj_collectibles_window", { active = true, visible = true } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  ObjSet( "obj_collectibles_window", { active = false, visible = false } );

------------------------------------------------------------------------------------
  end;

end;
--*****************************************************************************************