-- name=rm_menu
--******************************************************************************************
function public.Init ()

  ObjSet( "menu_but_play", 
  {
    event_mdown = private.PlayDown
  } );

  private.anim_obj = {
    {"obj_menu_1",    0, 0, 0, 1},    
    {"obj_menu_2",    0, 0, 0, 1},  
    {"obj_menu_3",    0, 0, 2, -1},  
    {"obj_menu_4",    0, 0, 2, -1},  
    {"obj_menu_5",    0, 0, 2, -1},  
    {"obj_menu_6",    0, 0, 3, 1},  
    {"obj_menu_7",    0, 0, 3, 1},  
    {"obj_menu_8",    0, 0, -4, 1},  
    {"obj_menu_9",    0, 0, -4, 1},  
    {"obj_menu_10",   0, 0, -4, 1},    
    {"obj_menu_11",   0, 0, -4, 1},    
    {"obj_menu_12",   0, 0, -2, 1},  
    {"obj_menu_13",   0, 0, -4, 1},  
    {"obj_menu_14",   0, 0, -9, 1},   
    {"obj_menu_15",   0, 0, -9, 1},   
    {"obj_menu_16",   0, 0, -9, 1},  
  }

  private.x = -0.5;
  private.y =  0;

  private.BackAnim();

  ObjSet("menu_but_options", { event_mdown = private.OptionsDown });
  ObjSet("menu_but_credits", { event_mdown = private.CreditsDown } );
  ObjSet("menu_but_profile", { event_mdown = private.ProfileDown } );
  ObjSet("menu_but_moregames", { event_mdown = private.MoreGamesDown } );
  ObjSet("menu_but_forum", { event_mdown = private.ForumDown } );
  ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
  ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
  ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
  ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
  ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
  ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
  ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown });
  ObjSet("spr_menu_but_back_button", { event_mdown = function() public.closeGearSubMenu(); end });
  ObjSet("menu_but_gear", { event_mdown = function() public.openGearSubMenu(); end });
  ObjSet("menu_but_extra", { event_mdown = private.ExtraDown } );
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  
  if GetPlatform() == "android" then
    ObjSet("menu_but_forum",{ alp = 0, input = false, visible = false });  
    ObjSet("menu_but_credits",{ pos_x = 512 });  
  end;
  
end;

--******************************************************************************************
function private.ButMouseEnter(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1.1, scale_y = 1.1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1.1, scale_y = 1.1 }); 
  end;
end;
--******************************************************************************************
function private.ButMouseLeave(par)
  if par == "close_gear" then
    ObjSet( "spr_menu_but_back_button",{ scale_x = 1, scale_y = 1 });
  else
    ObjSet( "menu_but_"..par,{ scale_x = 1, scale_y = 1 }); 
  end;
end;
--******************************************************************************************
local wait_gear;
public.sub_menu_active = false;
--******************************************************************************************
function public.closeGearSubMenu()
  common.button_click_sound();
  private.ButMouseEnter("close_gear");
  port.TapDownTimer(0.5,
    function() 
    public.sub_menu_active = false;
    ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
    private.ButMouseLeave("close_gear");
    end
  );
end;
--******************************************************************************************
function public.openGearSubMenu()
  common.button_click_sound();
  private.ButMouseEnter("gear");
  port.TapDownTimer(0.5,
    function() 
      public.sub_menu_active = true;
      ObjSet("menu_port_hub_sub_menu", { active = true, visible = true, input = true, alp = true });
      private.ButMouseLeave("gear");
    end
  );
  
end;
--******************************************************************************************
function public.gearOverAngle()
  
  local current_ang = ObjGet("spr_menu_but_gear").ang;
  
  if (wait_gear) then
    
    ObjSet( "tmr_gear", { time = 0.5, playing = 1, endtrig = function() wait_gear = false; public.gearOverAngle(); end  } );
  else
    wait_gear = true;
    local end_ang = current_ang + ((360/8)*3.14)/180;
    ObjAnimate( "spr_menu_but_gear", "ang", 0, 0, function() public.gearOverAngle(); end , {0,0,current_ang, 1,0,end_ang} ); 
  end;
  
  
end;
--******************************************************************************************
function public.PreOpen ()
    
  ObjSet( "menu_buttons_ce", { active = false, visible = false, input = false } );

  if ( IsCollectorsEdition() and not IsSurveyEdition() ) then

    ObjSet( "menu_buttons_ce", { active = true, visible = true, input = true } );

  end;

  if ( IsSurveyEdition()  ) then

    ObjSet( "menu_button_strguide", { active = false, visible = false, input = false } );

  end;

  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();
  
  common_impl.StopMusEnv( false );
  cmn.StopAllMus( "audio/aud_maintheme_mus", true );
  cmn.PlayAudio(  "mus", "audio/aud_maintheme_mus", 1 );
  cmn.StopAllEnv( "audio/aud_menu_env", true );
  cmn.PlayAudio( "env", "audio/aud_menu_env", 1 );  
  
  
  ObjSet( "menu_buttons", { alp = 0, input = false } );
  ObjSet( "spr_menu_logo", { alp = 0, input = false } ); 
  ObjSet( "menu_buttons", { alp = 1, input = true } );
  ObjSet( "spr_menu_logo", { alp = 1 } );        
  
  ObjSet("menu_port_hub_sub_menu", { active = false, visible = false, input = false, alp = false });
  wait_gear = false;
  public.gearOverAngle();  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      iOS_LogEvents(2);
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if tostring(GetPlatform()) == "android" then  
      DbgTrace("SetPerformanceMode(1)");
      SetPerformanceMode(1);
    elseif tostring(GetPlatform()) == "ios" then
      ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 0.5, playing = 1 });
    end;
      
    

    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;
end;
--******************************************************************************************
function public.Open ()

  int.Lock( false );

  if ( IsCollectorsEdition() ) then

    if ( ng_global.progress[ "std" ].common.gamewin == true ) and
       ( ng_global.progress[ "std" ].common.gamestart == false ) and
         ( not ng_global.bonusunlock ) then

      common.DialogWindowShow( "common", "bonusunlock", false );
      ng_global.bonusunlock = true;

      SaveProfiles();

    elseif ( ng_global.progress[ "ext" ].common.gamewin == true ) and
       ( ng_global.progress[ "ext" ].common.gamestart == false ) and
         ( not ng_global.secretunlock ) then

      common.DialogWindowShow( "common", "secretunlock", false );
      ng_global.secretunlock = true;

      SaveProfiles();

    end;

  end;  
  
  

end;
--***ios fix***************************************************************************************
function public.PreClose()
  ObjStopAnimate( "spr_menu_but_gear", "ang");
  ObjSet( "tmr_gear", { playing = 0 }); 
end;
--******************************************************************************************
function private.PerformanceWarning()
  iOS_PerformanceWarning();
end;
--******************************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--******************************************************************************************
function public.Save50OffButton()
  ObjSet("tmr_menu_save50", { playing = 0 });
  ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
end;
--******************************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-------------------------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
--******************************************************************************************
function public.UnlockOffButton()
  local room_name = GetCurrentRoom();
  if room_name ~= nil and room_name == "rm_menu" then
    ObjSet("tmr_menu_unlock", { playing = 0 });
    ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0 });
  end;
end;
--******************************************************************************************
function public.SetProfileText ( name )
  
--  local obj = "txt_menu_button_profile";
--  local profile_name = "";
--
--  if  ( name ~= "ng_noprofiles" )
--  and ( name ~= "ng_error" )
--  then
--
--    profile_name = name;
--
--  end;
--
--  ObjSet( obj, { text = profile_name } );
--
end;
--******************************************************************************************
function private.PlayDown ()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu_opendoor" );

   private.ButMouseEnter("play");
  port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave("play");
      common.MenuPlay();
      end
    ); 

end;
--******************************************************************************************
function private.OptionsDown ()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu_opendoor" );

  common.MenuOptions();

end;
--******************************************************************************************
function private.QuitDown ()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu" );

  common.MenuQuit();  

end;
--******************************************************************************************
function private.ExtraDown ()
  private.ButMouseEnter("extra");
   port.TapDownTimer(0.5,
    function()
      private.ButMouseLeave("extra");
      if port.isPortable() == 1 then
        if iOS_IsBought() == 1 then
          common.MenuExtra();
        else
          common.MenuUnlock();
        end;
      else
        common.MenuExtra();
      end;
    end
    ); 

  cmn.PlayAudio( "sfx", "audio/aud_click_menu_opendoor" );
  
end;
--******************************************************************************************
function private.StrGuideDown ()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu_opennotebook" );

  if IsCollectorsEdition() then

    --common_impl.ButtonGuide_Click();
    interface.StrategyGuideShow();

  else

    local guide_url = GetGuideUrl();
    OpenBrowser( guide_url );

  end;

end;
--******************************************************************************************
function private.ProfileDown ()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu_opendoor" );

  common.MenuProfile();

end;
--*****************************************************************************************
function private.MoreGamesDown ()

  cmn.PlayAudio( "sfx", "audio/aud_click_menu_opendoor" );
  iOS_MoreGamesPressed();
  --common.MenuMoreGames();

end;

--*************************************ios*****************************************************
function private.Save50Down()
  common.button_click_sound();
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  common.button_click_sound();
  private.ButMouseEnter("unlock");
  port.TapDownTimer(0.5,
    function()
      common.MenuUnlock();
      private.ButMouseLeave("unlock");
    end
   );
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
  common.button_click_sound();
  common.MenuSneakPeak();
end;
--*************************************ios*****************************************************
function private.ForumDown()
  common.button_click_sound();
  iOS_LaunchForum();
end;
--******************************************************************************************
function private.ButtonMouseEnter ( button_name )

  cmn.PlayAudio( "sfx", "audio/aud_guidance_"..math.random( 8 ) );

  cmn.SetCursor( CURSOR_HAND );

  local obj = "spr_menu_button_"..button_name;

  local alp = ObjGet( obj.."_light" ).alp;

  ObjAnimate( obj.."_light", "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 1 } );

  if ( GetPerformanceMode() == 0 ) then

    local pfx = "pfx_menu_button_"..button_name;
    local p_alp = ObjGet( pfx.."_light" ).alp;
    ObjSet(pfx.."_light", {active = true});
    ObjAnimate( pfx.."_light", "alp", 0, 0, "", { 0, 0, p_alp, ( common_impl.animtime * p_alp ), 0, 1 } );

  end;

  if ( button_name == "profile" ) then

    return;

  end;

  ObjSet( obj, { scale_x = 1, scale_y = 1 } );

end;
--******************************************************************************************
function private.ButtonMouseLeave ( button_name )

  cmn.SetCursor( CURSOR_DEFAULT );

  local obj = "spr_menu_button_"..button_name;

  local alp = ObjGet( obj.."_light" ).alp;

  ObjAnimate( obj.."_light", "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  if ( GetPerformanceMode() == 0 ) then

    local pfx = "pfx_menu_button_"..button_name;
    local p_alp = ObjGet( pfx.."_light" ).alp;    
    ObjAnimate( pfx.."_light", "alp", 0, 0, function () ObjSet(pfx.."_light", {active = false}); end, { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  end;

  if ( button_name == "profile" ) then

    return;

  end;

  ObjSet( obj, { scale_x = 0.9, scale_y = 0.9 } );

end;
--******************************************************************************************
function public.ButtonSetPos ()

  local offwidth = 0.5 * ( GetAppWidth() - 1024 );

  --ObjSet( "menu_objects_left",  { pos_x = ( 512 - offwidth ) } );
  --ObjSet( "menu_objects_right", { pos_x = ( 512 + offwidth ) } );

end;
--*****************************************************************************************
function private.BackAnim ()

  local func_end = function () private.BackAnim(); end;
  ObjSet( "tmr_menu_anim", { endtrig = func_end, time = 1/20, playing = 1 } );

  --local res = common.AnimForCur( private.anim_obj, private.x, private.y );
  local res = common.AnimForCur( private.anim_obj, private.x, 0 );

  private.x = res[1];
  private.y = res[2];
   

end;
--*****************************************************************************************
function private.Anims()

end;
--*****************************************************************************************
